/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(899), /*)*//*default:*//*Label 152*/ GIMT_Encode4(415110),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3394),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36389),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50617),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(52446),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(52528), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(52610),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(60356),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(72135), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(79327), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(86851), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(96795),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(97286),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(97777),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(98045),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(98195),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(98686), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(98719),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(107529),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(108579), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(111548), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(125074),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(126425),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(127417),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(128409),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(129901), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(131393),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(132385),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(133377),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(134369),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(135361),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(136353),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(137345), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(138050),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(138755), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(139460), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 35*/ GIMT_Encode4(139511),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 36*/ GIMT_Encode4(249247), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 37*/ GIMT_Encode4(260763),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 38*/ GIMT_Encode4(261053),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 39*/ GIMT_Encode4(262490),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 40*/ GIMT_Encode4(262610), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 41*/ GIMT_Encode4(262851),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 42*/ GIMT_Encode4(264749),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 43*/ GIMT_Encode4(266403),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 44*/ GIMT_Encode4(269182),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 45*/ GIMT_Encode4(269962),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 46*/ GIMT_Encode4(270355), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 47*/ GIMT_Encode4(271131),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 48*/ GIMT_Encode4(271261), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 49*/ GIMT_Encode4(271754), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(279531), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(280576),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(281060),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(281544),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(281974),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(282404),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(282834), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(283264),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(285062),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(285800),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(289896), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(306169), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(306785),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(310292),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(310540),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(310728),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(311705),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(312682),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(316990),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 69*/ GIMT_Encode4(320676),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 70*/ GIMT_Encode4(320996),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(321316), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 72*/ GIMT_Encode4(322173),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 73*/ GIMT_Encode4(322455),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 74*/ GIMT_Encode4(322833),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 75*/ GIMT_Encode4(323211),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 76*/ GIMT_Encode4(323561),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 77*/ GIMT_Encode4(323911),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 78*/ GIMT_Encode4(324614), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 79*/ GIMT_Encode4(325317),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 80*/ GIMT_Encode4(325721),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 81*/ GIMT_Encode4(326125),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 82*/ GIMT_Encode4(326529),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 83*/ GIMT_Encode4(326933),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 84*/ GIMT_Encode4(327748),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 85*/ GIMT_Encode4(327914),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 86*/ GIMT_Encode4(328013), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 87*/ GIMT_Encode4(328029),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 88*/ GIMT_Encode4(333401),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 89*/ GIMT_Encode4(361885), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 90*/ GIMT_Encode4(364803), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 91*/ GIMT_Encode4(367123), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 92*/ GIMT_Encode4(367275), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 93*/ GIMT_Encode4(367949),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 94*/ GIMT_Encode4(368109),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(368423),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 96*/ GIMT_Encode4(368577), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 97*/ GIMT_Encode4(369068),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 98*/ GIMT_Encode4(369368),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 99*/ GIMT_Encode4(369859),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 100*/ GIMT_Encode4(370350), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 101*/ GIMT_Encode4(370841),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 102*/ GIMT_Encode4(371967),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 103*/ GIMT_Encode4(372583),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 104*/ GIMT_Encode4(376305), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(376921),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 106*/ GIMT_Encode4(392528), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 107*/ GIMT_Encode4(392828),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 108*/ GIMT_Encode4(392842),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 109*/ GIMT_Encode4(392863), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 110*/ GIMT_Encode4(392888), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 111*/ GIMT_Encode4(393198),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 112*/ GIMT_Encode4(393369),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 113*/ GIMT_Encode4(393540),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 114*/ GIMT_Encode4(393711),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 115*/ GIMT_Encode4(393882), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 116*/ GIMT_Encode4(395011),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 117*/ GIMT_Encode4(395214),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 118*/ GIMT_Encode4(395417),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 119*/ GIMT_Encode4(395620), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3262 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 120*/ GIMT_Encode4(395823), GIMT_Encode4(0),
     /*   3270 */ /*AArch64::G_BSP*//*Label 121*/ GIMT_Encode4(395963),
     /*   3274 */ /*AArch64::G_DUP*//*Label 122*/ GIMT_Encode4(396503),
     /*   3278 */ /*AArch64::G_DUPLANE16*//*Label 123*/ GIMT_Encode4(398326),
     /*   3282 */ /*AArch64::G_DUPLANE32*//*Label 124*/ GIMT_Encode4(398581),
     /*   3286 */ /*AArch64::G_DUPLANE64*//*Label 125*/ GIMT_Encode4(398836),
     /*   3290 */ /*AArch64::G_DUPLANE8*//*Label 126*/ GIMT_Encode4(398982),
     /*   3294 */ /*AArch64::G_EXT*//*Label 127*/ GIMT_Encode4(399161),
     /*   3298 */ /*AArch64::G_FCMEQ*//*Label 128*/ GIMT_Encode4(400811),
     /*   3302 */ /*AArch64::G_FCMGE*//*Label 129*/ GIMT_Encode4(401370),
     /*   3306 */ /*AArch64::G_FCMGT*//*Label 130*/ GIMT_Encode4(402462),
     /*   3310 */ /*AArch64::G_REV16*//*Label 131*/ GIMT_Encode4(403554),
     /*   3314 */ /*AArch64::G_REV32*//*Label 132*/ GIMT_Encode4(403708),
     /*   3318 */ /*AArch64::G_REV64*//*Label 133*/ GIMT_Encode4(403884),
     /*   3322 */ /*AArch64::G_SADDLP*//*Label 134*/ GIMT_Encode4(404158),
     /*   3326 */ /*AArch64::G_SADDLV*//*Label 135*/ GIMT_Encode4(404364),
     /*   3330 */ /*AArch64::G_SDOT*//*Label 136*/ GIMT_Encode4(404763),
     /*   3334 */ /*AArch64::G_SITOF*//*Label 137*/ GIMT_Encode4(405133),
     /*   3338 */ /*AArch64::G_SMULL*//*Label 138*/ GIMT_Encode4(405250),
     /*   3342 */ /*AArch64::G_TRN1*//*Label 139*/ GIMT_Encode4(406483),
     /*   3346 */ /*AArch64::G_TRN2*//*Label 140*/ GIMT_Encode4(407263),
     /*   3350 */ /*AArch64::G_UADDLP*//*Label 141*/ GIMT_Encode4(408043),
     /*   3354 */ /*AArch64::G_UADDLV*//*Label 142*/ GIMT_Encode4(408249),
     /*   3358 */ /*AArch64::G_UDOT*//*Label 143*/ GIMT_Encode4(409116),
     /*   3362 */ /*AArch64::G_UITOF*//*Label 144*/ GIMT_Encode4(409486),
     /*   3366 */ /*AArch64::G_UMULL*//*Label 145*/ GIMT_Encode4(409603),
     /*   3370 */ /*AArch64::G_UZP1*//*Label 146*/ GIMT_Encode4(410836),
     /*   3374 */ /*AArch64::G_UZP2*//*Label 147*/ GIMT_Encode4(411616),
     /*   3378 */ /*AArch64::G_VASHR*//*Label 148*/ GIMT_Encode4(412396),
     /*   3382 */ /*AArch64::G_VLSHR*//*Label 149*/ GIMT_Encode4(413094),
     /*   3386 */ /*AArch64::G_ZIP1*//*Label 150*/ GIMT_Encode4(413550),
     /*   3390 */ /*AArch64::G_ZIP2*//*Label 151*/ GIMT_Encode4(414330),
     /*   3394 */ // Label 0: @3394
     /*   3394 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 166*/ GIMT_Encode4(36388),
     /*   3405 */ /*GILLT_s32*//*Label 153*/ GIMT_Encode4(3493),
     /*   3409 */ /*GILLT_s64*//*Label 154*/ GIMT_Encode4(6272), GIMT_Encode4(0),
     /*   3417 */ /*GILLT_v2s32*//*Label 155*/ GIMT_Encode4(11600),
     /*   3421 */ /*GILLT_v2s64*//*Label 156*/ GIMT_Encode4(15208),
     /*   3425 */ /*GILLT_v4s16*//*Label 157*/ GIMT_Encode4(21110),
     /*   3429 */ /*GILLT_v4s32*//*Label 158*/ GIMT_Encode4(24608),
     /*   3433 */ /*GILLT_v8s8*//*Label 159*/ GIMT_Encode4(30786),
     /*   3437 */ /*GILLT_v8s16*//*Label 160*/ GIMT_Encode4(31636),
     /*   3441 */ /*GILLT_v16s8*//*Label 161*/ GIMT_Encode4(35214), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3461 */ /*GILLT_nxv2s64*//*Label 162*/ GIMT_Encode4(35938), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3473 */ /*GILLT_nxv4s32*//*Label 163*/ GIMT_Encode4(36310), GIMT_Encode4(0),
     /*   3481 */ /*GILLT_nxv8s16*//*Label 164*/ GIMT_Encode4(36336), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv16s8*//*Label 165*/ GIMT_Encode4(36362),
     /*   3493 */ // Label 153: @3493
     /*   3493 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(6271),
     /*   3498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3504 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(3537), // Rule ID 13183 //
     /*   3509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3524 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3535 */     GIR_RootConstrainSelectedInstOperands,
     /*   3536 */     // GIR_Coverage, 13183,
     /*   3536 */     GIR_EraseRootFromParent_Done,
     /*   3537 */   // Label 168: @3537
     /*   3537 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(3689), // Rule ID 13610 //
     /*   3542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3569 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3572 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3577 */     // MIs[2] pattern
     /*   3577 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3580 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3591 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3591 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3594 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3598 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3605 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3608 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3612 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3617 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3620 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3624 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3654 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3661 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3671 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3688 */     // GIR_Coverage, 13610,
     /*   3688 */     GIR_EraseRootFromParent_Done,
     /*   3689 */   // Label 169: @3689
     /*   3689 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3841), // Rule ID 15464 //
     /*   3694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3721 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3724 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3729 */     // MIs[2] pattern
     /*   3729 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3732 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3743 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3743 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3746 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3750 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3757 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3760 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3764 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3769 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3772 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3776 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3779 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3806 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3813 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3823 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3840 */     // GIR_Coverage, 15464,
     /*   3840 */     GIR_EraseRootFromParent_Done,
     /*   3841 */   // Label 170: @3841
     /*   3841 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3993), // Rule ID 15476 //
     /*   3846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3873 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3876 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3881 */     // MIs[2] pattern
     /*   3881 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3884 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3895 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3895 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3898 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3902 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3909 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3912 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3916 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3921 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3928 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3931 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3936 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3992 */     // GIR_Coverage, 15476,
     /*   3992 */     GIR_EraseRootFromParent_Done,
     /*   3993 */   // Label 171: @3993
     /*   3993 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4145), // Rule ID 15488 //
     /*   3998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4025 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4028 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4033 */     // MIs[2] pattern
     /*   4033 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4036 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4047 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4047 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4050 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4054 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4073 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4076 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4080 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4083 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4127 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4144 */     // GIR_Coverage, 15488,
     /*   4144 */     GIR_EraseRootFromParent_Done,
     /*   4145 */   // Label 172: @4145
     /*   4145 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4178), // Rule ID 91 //
     /*   4150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4165 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4176 */     GIR_RootConstrainSelectedInstOperands,
     /*   4177 */     // GIR_Coverage, 91,
     /*   4177 */     GIR_EraseRootFromParent_Done,
     /*   4178 */   // Label 173: @4178
     /*   4178 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4330), // Rule ID 2656 //
     /*   4183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4214 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4217 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4222 */     // MIs[2] pattern
     /*   4222 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4225 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4232 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4232 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4235 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4239 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4258 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4261 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4265 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4302 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4312 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4329 */     // GIR_Coverage, 2656,
     /*   4329 */     GIR_EraseRootFromParent_Done,
     /*   4330 */   // Label 174: @4330
     /*   4330 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4482), // Rule ID 9921 //
     /*   4335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4366 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4369 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4374 */     // MIs[2] pattern
     /*   4374 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4377 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4384 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4384 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4387 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4391 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4410 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4413 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4417 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4447 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4481 */     // GIR_Coverage, 9921,
     /*   4481 */     GIR_EraseRootFromParent_Done,
     /*   4482 */   // Label 175: @4482
     /*   4482 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4634), // Rule ID 9933 //
     /*   4487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4518 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4521 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4526 */     // MIs[2] pattern
     /*   4526 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4529 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4536 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4536 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4539 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4543 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4550 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4553 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4557 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4562 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4565 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4569 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4572 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4599 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4606 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4616 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4633 */     // GIR_Coverage, 9933,
     /*   4633 */     GIR_EraseRootFromParent_Done,
     /*   4634 */   // Label 176: @4634
     /*   4634 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4786), // Rule ID 9945 //
     /*   4639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4670 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4673 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4678 */     // MIs[2] pattern
     /*   4678 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4681 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4688 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4714 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4721 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4758 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4768 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4785 */     // GIR_Coverage, 9945,
     /*   4785 */     GIR_EraseRootFromParent_Done,
     /*   4786 */   // Label 177: @4786
     /*   4786 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4943), // Rule ID 15507 //
     /*   4791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4818 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4821 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4826 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4837 */     // MIs[2] pred
     /*   4837 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4848 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4848 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4851 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4855 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4862 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4865 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4869 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4874 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4881 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4889 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4942 */     // GIR_Coverage, 15507,
     /*   4942 */     GIR_EraseRootFromParent_Done,
     /*   4943 */   // Label 178: @4943
     /*   4943 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(5100), // Rule ID 15508 //
     /*   4948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4975 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4978 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   4987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4994 */     // MIs[2] pred
     /*   4994 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5005 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5005 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5008 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5012 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5031 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5038 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5072 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5082 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5099 */     // GIR_Coverage, 15508,
     /*   5099 */     GIR_EraseRootFromParent_Done,
     /*   5100 */   // Label 179: @5100
     /*   5100 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(5257), // Rule ID 15509 //
     /*   5105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5132 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5135 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5144 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5151 */     // MIs[2] pred
     /*   5151 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5162 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5195 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5239 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5256 */     // GIR_Coverage, 15509,
     /*   5256 */     GIR_EraseRootFromParent_Done,
     /*   5257 */   // Label 180: @5257
     /*   5257 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5414), // Rule ID 15510 //
     /*   5262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5289 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5292 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5301 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5308 */     // MIs[2] pred
     /*   5308 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5319 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5319 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5322 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5326 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5333 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5336 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5340 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5345 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5348 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5352 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5396 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5413 */     // GIR_Coverage, 15510,
     /*   5413 */     GIR_EraseRootFromParent_Done,
     /*   5414 */   // Label 181: @5414
     /*   5414 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5571), // Rule ID 10037 //
     /*   5419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5450 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5453 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5462 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5469 */     // MIs[2] pred
     /*   5469 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5476 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5476 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5479 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5483 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5502 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5505 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5509 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5512 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5517 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5522 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5539 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5570 */     // GIR_Coverage, 10037,
     /*   5570 */     GIR_EraseRootFromParent_Done,
     /*   5571 */   // Label 182: @5571
     /*   5571 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5728), // Rule ID 10038 //
     /*   5576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5607 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5610 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5626 */     // MIs[2] pred
     /*   5626 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5633 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5633 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5636 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5640 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5647 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5650 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5654 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5659 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5662 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5666 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5674 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5679 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5710 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5727 */     // GIR_Coverage, 10038,
     /*   5727 */     GIR_EraseRootFromParent_Done,
     /*   5728 */   // Label 183: @5728
     /*   5728 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5885), // Rule ID 10039 //
     /*   5733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5764 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5767 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5783 */     // MIs[2] pred
     /*   5783 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5790 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5790 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5793 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5797 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5816 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5823 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5857 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5867 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5884 */     // GIR_Coverage, 10039,
     /*   5884 */     GIR_EraseRootFromParent_Done,
     /*   5885 */   // Label 184: @5885
     /*   5885 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(6042), // Rule ID 10040 //
     /*   5890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5921 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5924 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5933 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5940 */     // MIs[2] pred
     /*   5940 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5947 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5947 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5950 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5954 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5973 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5976 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5980 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5983 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5988 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6024 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6041 */     // GIR_Coverage, 10040,
     /*   6041 */     GIR_EraseRootFromParent_Done,
     /*   6042 */   // Label 185: @6042
     /*   6042 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(6075), // Rule ID 13187 //
     /*   6047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6062 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6069 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6073 */     GIR_RootConstrainSelectedInstOperands,
     /*   6074 */     // GIR_Coverage, 13187,
     /*   6074 */     GIR_EraseRootFromParent_Done,
     /*   6075 */   // Label 186: @6075
     /*   6075 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6111), // Rule ID 13750 //
     /*   6080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6095 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6109 */     GIR_RootConstrainSelectedInstOperands,
     /*   6110 */     // GIR_Coverage, 13750,
     /*   6110 */     GIR_EraseRootFromParent_Done,
     /*   6111 */   // Label 187: @6111
     /*   6111 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6144), // Rule ID 97 //
     /*   6116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6131 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6142 */     GIR_RootConstrainSelectedInstOperands,
     /*   6143 */     // GIR_Coverage, 97,
     /*   6143 */     GIR_EraseRootFromParent_Done,
     /*   6144 */   // Label 188: @6144
     /*   6144 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6180), // Rule ID 3921 //
     /*   6149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6164 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6178 */     GIR_RootConstrainSelectedInstOperands,
     /*   6179 */     // GIR_Coverage, 3921,
     /*   6179 */     GIR_EraseRootFromParent_Done,
     /*   6180 */   // Label 189: @6180
     /*   6180 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6213), // Rule ID 13185 //
     /*   6185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6200 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6211 */     GIR_RootConstrainSelectedInstOperands,
     /*   6212 */     // GIR_Coverage, 13185,
     /*   6212 */     GIR_EraseRootFromParent_Done,
     /*   6213 */   // Label 190: @6213
     /*   6213 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6246), // Rule ID 95 //
     /*   6218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6233 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6244 */     GIR_RootConstrainSelectedInstOperands,
     /*   6245 */     // GIR_Coverage, 95,
     /*   6245 */     GIR_EraseRootFromParent_Done,
     /*   6246 */   // Label 191: @6246
     /*   6246 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6270), // Rule ID 93 //
     /*   6251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6263 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6268 */     GIR_RootConstrainSelectedInstOperands,
     /*   6269 */     // GIR_Coverage, 93,
     /*   6269 */     GIR_Done,
     /*   6270 */   // Label 192: @6270
     /*   6270 */   GIM_Reject,
     /*   6271 */ // Label 167: @6271
     /*   6271 */ GIM_Reject,
     /*   6272 */ // Label 154: @6272
     /*   6272 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(11599),
     /*   6277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6283 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6419), // Rule ID 5377 //
     /*   6288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6321 */     // MIs[1] Operand 2
     /*   6321 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6348 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6352 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6356 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6361 */     // MIs[3] Operand 2
     /*   6361 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6372 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6374 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6390 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6401 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6418 */     // GIR_Coverage, 5377,
     /*   6418 */     GIR_EraseRootFromParent_Done,
     /*   6419 */   // Label 194: @6419
     /*   6419 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(6555), // Rule ID 5376 //
     /*   6424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6457 */     // MIs[1] Operand 2
     /*   6457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6484 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6488 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6492 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6497 */     // MIs[3] Operand 2
     /*   6497 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6508 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6510 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6537 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6554 */     // GIR_Coverage, 5376,
     /*   6554 */     GIR_EraseRootFromParent_Done,
     /*   6555 */   // Label 195: @6555
     /*   6555 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6691), // Rule ID 5386 //
     /*   6560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6593 */     // MIs[1] Operand 2
     /*   6593 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6612 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6624 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6628 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6633 */     // MIs[3] Operand 2
     /*   6633 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6646 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6673 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6690 */     // GIR_Coverage, 5386,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 196: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6827), // Rule ID 5375 //
     /*   6696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6729 */     // MIs[1] Operand 2
     /*   6729 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6748 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6756 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6760 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6764 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6769 */     // MIs[3] Operand 2
     /*   6769 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6782 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6809 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6826 */     // GIR_Coverage, 5375,
     /*   6826 */     GIR_EraseRootFromParent_Done,
     /*   6827 */   // Label 197: @6827
     /*   6827 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6963), // Rule ID 5374 //
     /*   6832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6865 */     // MIs[1] Operand 2
     /*   6865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6892 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6896 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6900 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6905 */     // MIs[3] Operand 2
     /*   6905 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6916 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6918 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6945 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6962 */     // GIR_Coverage, 5374,
     /*   6962 */     GIR_EraseRootFromParent_Done,
     /*   6963 */   // Label 198: @6963
     /*   6963 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(7031), // Rule ID 6905 //
     /*   6968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6993 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   6997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7009 */     // MIs[2] Rn
     /*   7009 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7020 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7029 */     GIR_RootConstrainSelectedInstOperands,
     /*   7030 */     // GIR_Coverage, 6905,
     /*   7030 */     GIR_EraseRootFromParent_Done,
     /*   7031 */   // Label 199: @7031
     /*   7031 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(7099), // Rule ID 13908 //
     /*   7036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7061 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7077 */     // MIs[2] Rn
     /*   7077 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7082 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7088 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7097 */     GIR_RootConstrainSelectedInstOperands,
     /*   7098 */     // GIR_Coverage, 13908,
     /*   7098 */     GIR_EraseRootFromParent_Done,
     /*   7099 */   // Label 200: @7099
     /*   7099 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7132), // Rule ID 13184 //
     /*   7104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7119 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7130 */     GIR_RootConstrainSelectedInstOperands,
     /*   7131 */     // GIR_Coverage, 13184,
     /*   7131 */     GIR_EraseRootFromParent_Done,
     /*   7132 */   // Label 201: @7132
     /*   7132 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7265), // Rule ID 3973 //
     /*   7137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7174 */     // MIs[2] Operand 2
     /*   7174 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7193 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7197 */     // MIs[3] Operand 1
     /*   7197 */     // No operand predicates
     /*   7197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7203 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7215 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7263 */     GIR_RootConstrainSelectedInstOperands,
     /*   7264 */     // GIR_Coverage, 3973,
     /*   7264 */     GIR_EraseRootFromParent_Done,
     /*   7265 */   // Label 202: @7265
     /*   7265 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7360), // Rule ID 3971 //
     /*   7270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7315 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7319 */     // MIs[3] Operand 1
     /*   7319 */     // No operand predicates
     /*   7319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7325 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7337 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7358 */     GIR_RootConstrainSelectedInstOperands,
     /*   7359 */     // GIR_Coverage, 3971,
     /*   7359 */     GIR_EraseRootFromParent_Done,
     /*   7360 */   // Label 203: @7360
     /*   7360 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7455), // Rule ID 3972 //
     /*   7365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7410 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7414 */     // MIs[3] Operand 1
     /*   7414 */     // No operand predicates
     /*   7414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7418 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7420 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7432 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7453 */     GIR_RootConstrainSelectedInstOperands,
     /*   7454 */     // GIR_Coverage, 3972,
     /*   7454 */     GIR_EraseRootFromParent_Done,
     /*   7455 */   // Label 204: @7455
     /*   7455 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7488), // Rule ID 92 //
     /*   7460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7475 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7486 */     GIR_RootConstrainSelectedInstOperands,
     /*   7487 */     // GIR_Coverage, 92,
     /*   7487 */     GIR_EraseRootFromParent_Done,
     /*   7488 */   // Label 205: @7488
     /*   7488 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7621), // Rule ID 13760 //
     /*   7493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7534 */     // MIs[2] Operand 2
     /*   7534 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7553 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7557 */     // MIs[3] Operand 1
     /*   7557 */     // No operand predicates
     /*   7557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7559 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7571 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7590 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7619 */     GIR_RootConstrainSelectedInstOperands,
     /*   7620 */     // GIR_Coverage, 13760,
     /*   7620 */     GIR_EraseRootFromParent_Done,
     /*   7621 */   // Label 206: @7621
     /*   7621 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7716), // Rule ID 13758 //
     /*   7626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7675 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7679 */     // MIs[3] Operand 1
     /*   7679 */     // No operand predicates
     /*   7679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7681 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7693 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7714 */     GIR_RootConstrainSelectedInstOperands,
     /*   7715 */     // GIR_Coverage, 13758,
     /*   7715 */     GIR_EraseRootFromParent_Done,
     /*   7716 */   // Label 207: @7716
     /*   7716 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7811), // Rule ID 13759 //
     /*   7721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7770 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7774 */     // MIs[3] Operand 1
     /*   7774 */     // No operand predicates
     /*   7774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7776 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7788 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7809 */     GIR_RootConstrainSelectedInstOperands,
     /*   7810 */     // GIR_Coverage, 13759,
     /*   7810 */     GIR_EraseRootFromParent_Done,
     /*   7811 */   // Label 208: @7811
     /*   7811 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7893), // Rule ID 13195 //
     /*   7816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7865 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7876 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7891 */     GIR_RootConstrainSelectedInstOperands,
     /*   7892 */     // GIR_Coverage, 13195,
     /*   7892 */     GIR_EraseRootFromParent_Done,
     /*   7893 */   // Label 209: @7893
     /*   7893 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7975), // Rule ID 13196 //
     /*   7898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7947 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7958 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7973 */     GIR_RootConstrainSelectedInstOperands,
     /*   7974 */     // GIR_Coverage, 13196,
     /*   7974 */     GIR_EraseRootFromParent_Done,
     /*   7975 */   // Label 210: @7975
     /*   7975 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(8057), // Rule ID 123 //
     /*   7980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8033 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8040 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8055 */     GIR_RootConstrainSelectedInstOperands,
     /*   8056 */     // GIR_Coverage, 123,
     /*   8056 */     GIR_EraseRootFromParent_Done,
     /*   8057 */   // Label 211: @8057
     /*   8057 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(8139), // Rule ID 125 //
     /*   8062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8111 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8115 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8122 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8137 */     GIR_RootConstrainSelectedInstOperands,
     /*   8138 */     // GIR_Coverage, 125,
     /*   8138 */     GIR_EraseRootFromParent_Done,
     /*   8139 */   // Label 212: @8139
     /*   8139 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8197), // Rule ID 13605 //
     /*   8144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8159 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8162 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8167 */     // MIs[1] pattern
     /*   8167 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8170 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8181 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8195 */     GIR_RootConstrainSelectedInstOperands,
     /*   8196 */     // GIR_Coverage, 13605,
     /*   8196 */     GIR_EraseRootFromParent_Done,
     /*   8197 */   // Label 213: @8197
     /*   8197 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8255), // Rule ID 15459 //
     /*   8202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8217 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8220 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8225 */     // MIs[1] pattern
     /*   8225 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8228 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8239 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8253 */     GIR_RootConstrainSelectedInstOperands,
     /*   8254 */     // GIR_Coverage, 15459,
     /*   8254 */     GIR_EraseRootFromParent_Done,
     /*   8255 */   // Label 214: @8255
     /*   8255 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8313), // Rule ID 15471 //
     /*   8260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8275 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8278 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8283 */     // MIs[1] pattern
     /*   8283 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8286 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8297 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8311 */     GIR_RootConstrainSelectedInstOperands,
     /*   8312 */     // GIR_Coverage, 15471,
     /*   8312 */     GIR_EraseRootFromParent_Done,
     /*   8313 */   // Label 215: @8313
     /*   8313 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8371), // Rule ID 15483 //
     /*   8318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8333 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8336 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8341 */     // MIs[1] pattern
     /*   8341 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8344 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8355 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8369 */     GIR_RootConstrainSelectedInstOperands,
     /*   8370 */     // GIR_Coverage, 15483,
     /*   8370 */     GIR_EraseRootFromParent_Done,
     /*   8371 */   // Label 216: @8371
     /*   8371 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8429), // Rule ID 2653 //
     /*   8376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8395 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8398 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8403 */     // MIs[1] pattern
     /*   8403 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8406 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8413 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8427 */     GIR_RootConstrainSelectedInstOperands,
     /*   8428 */     // GIR_Coverage, 2653,
     /*   8428 */     GIR_EraseRootFromParent_Done,
     /*   8429 */   // Label 217: @8429
     /*   8429 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8487), // Rule ID 9918 //
     /*   8434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8453 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8456 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8461 */     // MIs[1] pattern
     /*   8461 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8464 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8471 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8485 */     GIR_RootConstrainSelectedInstOperands,
     /*   8486 */     // GIR_Coverage, 9918,
     /*   8486 */     GIR_EraseRootFromParent_Done,
     /*   8487 */   // Label 218: @8487
     /*   8487 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8545), // Rule ID 9930 //
     /*   8492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8511 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8514 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8519 */     // MIs[1] pattern
     /*   8519 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8522 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8529 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8543 */     GIR_RootConstrainSelectedInstOperands,
     /*   8544 */     // GIR_Coverage, 9930,
     /*   8544 */     GIR_EraseRootFromParent_Done,
     /*   8545 */   // Label 219: @8545
     /*   8545 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8603), // Rule ID 9942 //
     /*   8550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8569 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8572 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8577 */     // MIs[1] pattern
     /*   8577 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8580 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8587 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8601 */     GIR_RootConstrainSelectedInstOperands,
     /*   8602 */     // GIR_Coverage, 9942,
     /*   8602 */     GIR_EraseRootFromParent_Done,
     /*   8603 */   // Label 220: @8603
     /*   8603 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8766), // Rule ID 13880 //
     /*   8608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8650 */     // MIs[1] Operand 2
     /*   8650 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8667 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8667 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8670 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8674 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8693 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8696 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8700 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8713 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8730 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8748 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8765 */     // GIR_Coverage, 13880,
     /*   8765 */     GIR_EraseRootFromParent_Done,
     /*   8766 */   // Label 221: @8766
     /*   8766 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8929), // Rule ID 13877 //
     /*   8771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8813 */     // MIs[1] Operand 2
     /*   8813 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8830 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8830 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8833 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8837 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8856 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8863 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8866 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8871 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8911 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8928 */     // GIR_Coverage, 13877,
     /*   8928 */     GIR_EraseRootFromParent_Done,
     /*   8929 */   // Label 222: @8929
     /*   8929 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(9079), // Rule ID 13886 //
     /*   8934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8967 */     // MIs[1] Operand 2
     /*   8967 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8984 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8984 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8987 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8991 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9010 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9017 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9030 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9078 */     // GIR_Coverage, 13886,
     /*   9078 */     GIR_EraseRootFromParent_Done,
     /*   9079 */   // Label 223: @9079
     /*   9079 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(9229), // Rule ID 13889 //
     /*   9084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9117 */     // MIs[1] Operand 2
     /*   9117 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9134 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9134 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9137 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9141 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9148 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9151 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9155 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9160 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9167 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9170 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9175 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9180 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9197 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9211 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9228 */     // GIR_Coverage, 13889,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 224: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(9379), // Rule ID 13885 //
     /*   9234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9267 */     // MIs[1] Operand 2
     /*   9267 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9284 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9284 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9287 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9291 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9310 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9313 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9317 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9378 */     // GIR_Coverage, 13885,
     /*   9378 */     GIR_EraseRootFromParent_Done,
     /*   9379 */   // Label 225: @9379
     /*   9379 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9542), // Rule ID 5359 //
     /*   9384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9430 */     // MIs[1] Operand 2
     /*   9430 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9443 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9443 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9446 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9450 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9457 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9460 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9464 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9469 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9472 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9476 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9479 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9506 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9509 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9524 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9541 */     // GIR_Coverage, 5359,
     /*   9541 */     GIR_EraseRootFromParent_Done,
     /*   9542 */   // Label 226: @9542
     /*   9542 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9705), // Rule ID 5356 //
     /*   9547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9593 */     // MIs[1] Operand 2
     /*   9593 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9606 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9606 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9609 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9613 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9632 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9639 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9704 */     // GIR_Coverage, 5356,
     /*   9704 */     GIR_EraseRootFromParent_Done,
     /*   9705 */   // Label 227: @9705
     /*   9705 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9855), // Rule ID 5383 //
     /*   9710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9747 */     // MIs[1] Operand 2
     /*   9747 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9760 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9760 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9763 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9767 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9786 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9789 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9793 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9796 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9801 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9823 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9826 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9837 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9854 */     // GIR_Coverage, 5383,
     /*   9854 */     GIR_EraseRootFromParent_Done,
     /*   9855 */   // Label 228: @9855
     /*   9855 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(10005), // Rule ID 5389 //
     /*   9860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9897 */     // MIs[1] Operand 2
     /*   9897 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9910 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9936 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9987 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10004 */     // GIR_Coverage, 5389,
     /*  10004 */     GIR_EraseRootFromParent_Done,
     /*  10005 */   // Label 229: @10005
     /*  10005 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(10155), // Rule ID 5382 //
     /*  10010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10047 */     // MIs[1] Operand 2
     /*  10047 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10060 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10060 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10063 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10067 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10086 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10093 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10101 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10106 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10137 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10154 */     // GIR_Coverage, 5382,
     /*  10154 */     GIR_EraseRootFromParent_Done,
     /*  10155 */   // Label 230: @10155
     /*  10155 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(10188), // Rule ID 13188 //
     /*  10160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10175 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10186 */     GIR_RootConstrainSelectedInstOperands,
     /*  10187 */     // GIR_Coverage, 13188,
     /*  10187 */     GIR_EraseRootFromParent_Done,
     /*  10188 */   // Label 231: @10188
     /*  10188 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(10224), // Rule ID 13751 //
     /*  10193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10208 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10222 */     GIR_RootConstrainSelectedInstOperands,
     /*  10223 */     // GIR_Coverage, 13751,
     /*  10223 */     GIR_EraseRootFromParent_Done,
     /*  10224 */   // Label 232: @10224
     /*  10224 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10257), // Rule ID 98 //
     /*  10229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10244 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10255 */     GIR_RootConstrainSelectedInstOperands,
     /*  10256 */     // GIR_Coverage, 98,
     /*  10256 */     GIR_EraseRootFromParent_Done,
     /*  10257 */   // Label 233: @10257
     /*  10257 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10293), // Rule ID 3922 //
     /*  10262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10277 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 3922,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 234: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10326), // Rule ID 13186 //
     /*  10298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10313 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10324 */     GIR_RootConstrainSelectedInstOperands,
     /*  10325 */     // GIR_Coverage, 13186,
     /*  10325 */     GIR_EraseRootFromParent_Done,
     /*  10326 */   // Label 235: @10326
     /*  10326 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10389), // Rule ID 15499 //
     /*  10331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10346 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10349 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10358 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10365 */     // MIs[1] pred
     /*  10365 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10376 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10387 */     GIR_RootConstrainSelectedInstOperands,
     /*  10388 */     // GIR_Coverage, 15499,
     /*  10388 */     GIR_EraseRootFromParent_Done,
     /*  10389 */   // Label 236: @10389
     /*  10389 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10452), // Rule ID 15500 //
     /*  10394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10409 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10412 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10428 */     // MIs[1] pred
     /*  10428 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10439 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10450 */     GIR_RootConstrainSelectedInstOperands,
     /*  10451 */     // GIR_Coverage, 15500,
     /*  10451 */     GIR_EraseRootFromParent_Done,
     /*  10452 */   // Label 237: @10452
     /*  10452 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10515), // Rule ID 15501 //
     /*  10457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10472 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10475 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10491 */     // MIs[1] pred
     /*  10491 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10502 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10513 */     GIR_RootConstrainSelectedInstOperands,
     /*  10514 */     // GIR_Coverage, 15501,
     /*  10514 */     GIR_EraseRootFromParent_Done,
     /*  10515 */   // Label 238: @10515
     /*  10515 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10578), // Rule ID 15502 //
     /*  10520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10535 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10538 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10554 */     // MIs[1] pred
     /*  10554 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10565 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10576 */     GIR_RootConstrainSelectedInstOperands,
     /*  10577 */     // GIR_Coverage, 15502,
     /*  10577 */     GIR_EraseRootFromParent_Done,
     /*  10578 */   // Label 239: @10578
     /*  10578 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10611), // Rule ID 96 //
     /*  10583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10598 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10609 */     GIR_RootConstrainSelectedInstOperands,
     /*  10610 */     // GIR_Coverage, 96,
     /*  10610 */     GIR_EraseRootFromParent_Done,
     /*  10611 */   // Label 240: @10611
     /*  10611 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10674), // Rule ID 10029 //
     /*  10616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10635 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10638 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10654 */     // MIs[1] pred
     /*  10654 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10661 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10672 */     GIR_RootConstrainSelectedInstOperands,
     /*  10673 */     // GIR_Coverage, 10029,
     /*  10673 */     GIR_EraseRootFromParent_Done,
     /*  10674 */   // Label 241: @10674
     /*  10674 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10737), // Rule ID 10030 //
     /*  10679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10698 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10701 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10710 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10717 */     // MIs[1] pred
     /*  10717 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10724 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10735 */     GIR_RootConstrainSelectedInstOperands,
     /*  10736 */     // GIR_Coverage, 10030,
     /*  10736 */     GIR_EraseRootFromParent_Done,
     /*  10737 */   // Label 242: @10737
     /*  10737 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10800), // Rule ID 10031 //
     /*  10742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10761 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10764 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10773 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10780 */     // MIs[1] pred
     /*  10780 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10787 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10798 */     GIR_RootConstrainSelectedInstOperands,
     /*  10799 */     // GIR_Coverage, 10031,
     /*  10799 */     GIR_EraseRootFromParent_Done,
     /*  10800 */   // Label 243: @10800
     /*  10800 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10863), // Rule ID 10032 //
     /*  10805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10824 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10827 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10843 */     // MIs[1] pred
     /*  10843 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10850 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10861 */     GIR_RootConstrainSelectedInstOperands,
     /*  10862 */     // GIR_Coverage, 10032,
     /*  10862 */     GIR_EraseRootFromParent_Done,
     /*  10863 */   // Label 244: @10863
     /*  10863 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10919), // Rule ID 13294 //
     /*  10868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10883 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10886 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10906 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10917 */     GIR_RootConstrainSelectedInstOperands,
     /*  10918 */     // GIR_Coverage, 13294,
     /*  10918 */     GIR_EraseRootFromParent_Done,
     /*  10919 */   // Label 245: @10919
     /*  10919 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10975), // Rule ID 13306 //
     /*  10924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10939 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10942 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10962 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10973 */     GIR_RootConstrainSelectedInstOperands,
     /*  10974 */     // GIR_Coverage, 13306,
     /*  10974 */     GIR_EraseRootFromParent_Done,
     /*  10975 */   // Label 246: @10975
     /*  10975 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11042), // Rule ID 13512 //
     /*  10980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  10995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11004 */     // MIs[1] imm
     /*  11004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11012 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11016 */     // MIs[2] Operand 1
     /*  11016 */     // No operand predicates
     /*  11016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11026 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11040 */     GIR_RootConstrainSelectedInstOperands,
     /*  11041 */     // GIR_Coverage, 13512,
     /*  11041 */     GIR_EraseRootFromParent_Done,
     /*  11042 */   // Label 247: @11042
     /*  11042 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11109), // Rule ID 13515 //
     /*  11047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11071 */     // MIs[1] imm
     /*  11071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11083 */     // MIs[2] Operand 1
     /*  11083 */     // No operand predicates
     /*  11083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11087 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11093 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11107 */     GIR_RootConstrainSelectedInstOperands,
     /*  11108 */     // GIR_Coverage, 13515,
     /*  11108 */     GIR_EraseRootFromParent_Done,
     /*  11109 */   // Label 248: @11109
     /*  11109 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11165), // Rule ID 997 //
     /*  11114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11133 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11136 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11152 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11163 */     GIR_RootConstrainSelectedInstOperands,
     /*  11164 */     // GIR_Coverage, 997,
     /*  11164 */     GIR_EraseRootFromParent_Done,
     /*  11165 */   // Label 249: @11165
     /*  11165 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11221), // Rule ID 1058 //
     /*  11170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11189 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11192 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11208 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11219 */     GIR_RootConstrainSelectedInstOperands,
     /*  11220 */     // GIR_Coverage, 1058,
     /*  11220 */     GIR_EraseRootFromParent_Done,
     /*  11221 */   // Label 250: @11221
     /*  11221 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11288), // Rule ID 2121 //
     /*  11226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11254 */     // MIs[1] imm
     /*  11254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11262 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11266 */     // MIs[2] Operand 1
     /*  11266 */     // No operand predicates
     /*  11266 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11272 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11286 */     GIR_RootConstrainSelectedInstOperands,
     /*  11287 */     // GIR_Coverage, 2121,
     /*  11287 */     GIR_EraseRootFromParent_Done,
     /*  11288 */   // Label 251: @11288
     /*  11288 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11355), // Rule ID 2130 //
     /*  11293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11321 */     // MIs[1] imm
     /*  11321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11329 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11333 */     // MIs[2] Operand 1
     /*  11333 */     // No operand predicates
     /*  11333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11339 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 2130,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 252: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11403), // Rule ID 13293 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11390 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11401 */     GIR_RootConstrainSelectedInstOperands,
     /*  11402 */     // GIR_Coverage, 13293,
     /*  11402 */     GIR_EraseRootFromParent_Done,
     /*  11403 */   // Label 253: @11403
     /*  11403 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11451), // Rule ID 13305 //
     /*  11408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11438 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11449 */     GIR_RootConstrainSelectedInstOperands,
     /*  11450 */     // GIR_Coverage, 13305,
     /*  11450 */     GIR_EraseRootFromParent_Done,
     /*  11451 */   // Label 254: @11451
     /*  11451 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11499), // Rule ID 996 //
     /*  11456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11486 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11497 */     GIR_RootConstrainSelectedInstOperands,
     /*  11498 */     // GIR_Coverage, 996,
     /*  11498 */     GIR_EraseRootFromParent_Done,
     /*  11499 */   // Label 255: @11499
     /*  11499 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11547), // Rule ID 1057 //
     /*  11504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11534 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11545 */     GIR_RootConstrainSelectedInstOperands,
     /*  11546 */     // GIR_Coverage, 1057,
     /*  11546 */     GIR_EraseRootFromParent_Done,
     /*  11547 */   // Label 256: @11547
     /*  11547 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11571), // Rule ID 94 //
     /*  11552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11564 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11569 */     GIR_RootConstrainSelectedInstOperands,
     /*  11570 */     // GIR_Coverage, 94,
     /*  11570 */     GIR_Done,
     /*  11571 */   // Label 257: @11571
     /*  11571 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11598), // Rule ID 1607 //
     /*  11576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11591 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11596 */     GIR_RootConstrainSelectedInstOperands,
     /*  11597 */     // GIR_Coverage, 1607,
     /*  11597 */     GIR_Done,
     /*  11598 */   // Label 258: @11598
     /*  11598 */   GIM_Reject,
     /*  11599 */ // Label 193: @11599
     /*  11599 */ GIM_Reject,
     /*  11600 */ // Label 155: @11600
     /*  11600 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(15207),
     /*  11605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11611 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11799), // Rule ID 6926 //
     /*  11616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11653 */     // MIs[2] Operand 2
     /*  11653 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11672 */     // MIs[3] Rn
     /*  11672 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11677 */     // MIs[3] Operand 2
     /*  11677 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11688 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11692 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11696 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11700 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11704 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11708 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11712 */     // MIs[5] Rn
     /*  11712 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11717 */     // MIs[5] Operand 2
     /*  11717 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11728 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11732 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11736 */     // MIs[6] Rn
     /*  11736 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11741 */     // MIs[6] Operand 2
     /*  11741 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11752 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11754 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11781 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11798 */     // GIR_Coverage, 6926,
     /*  11798 */     GIR_EraseRootFromParent_Done,
     /*  11799 */   // Label 260: @11799
     /*  11799 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11987), // Rule ID 13919 //
     /*  11804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11841 */     // MIs[2] Operand 2
     /*  11841 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11860 */     // MIs[3] Rn
     /*  11860 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11865 */     // MIs[3] Operand 2
     /*  11865 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11876 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11880 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11884 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11888 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11896 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11900 */     // MIs[5] Rn
     /*  11900 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11905 */     // MIs[5] Operand 2
     /*  11905 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11916 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11920 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11924 */     // MIs[6] Rn
     /*  11924 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11929 */     // MIs[6] Operand 2
     /*  11929 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11940 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11942 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11969 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11986 */     // GIR_Coverage, 13919,
     /*  11986 */     GIR_EraseRootFromParent_Done,
     /*  11987 */   // Label 261: @11987
     /*  11987 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12123), // Rule ID 5373 //
     /*  11992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12025 */     // MIs[1] Operand 2
     /*  12025 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12048 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12052 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12056 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12060 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12065 */     // MIs[3] Operand 2
     /*  12065 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12076 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12078 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12105 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12122 */     // GIR_Coverage, 5373,
     /*  12122 */     GIR_EraseRootFromParent_Done,
     /*  12123 */   // Label 262: @12123
     /*  12123 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12259), // Rule ID 5372 //
     /*  12128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12161 */     // MIs[1] Operand 2
     /*  12161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12184 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12188 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12192 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12196 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12201 */     // MIs[3] Operand 2
     /*  12201 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12212 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12214 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12241 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12258 */     // GIR_Coverage, 5372,
     /*  12258 */     GIR_EraseRootFromParent_Done,
     /*  12259 */   // Label 263: @12259
     /*  12259 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12395), // Rule ID 5385 //
     /*  12264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12297 */     // MIs[1] Operand 2
     /*  12297 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12328 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12332 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12337 */     // MIs[3] Operand 2
     /*  12337 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12348 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12350 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12394 */     // GIR_Coverage, 5385,
     /*  12394 */     GIR_EraseRootFromParent_Done,
     /*  12395 */   // Label 264: @12395
     /*  12395 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12531), // Rule ID 5371 //
     /*  12400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12433 */     // MIs[1] Operand 2
     /*  12433 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12464 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12468 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12473 */     // MIs[3] Operand 2
     /*  12473 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12484 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12486 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12530 */     // GIR_Coverage, 5371,
     /*  12530 */     GIR_EraseRootFromParent_Done,
     /*  12531 */   // Label 265: @12531
     /*  12531 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12667), // Rule ID 5370 //
     /*  12536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12569 */     // MIs[1] Operand 2
     /*  12569 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12596 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12600 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12604 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12609 */     // MIs[3] Operand 2
     /*  12609 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12622 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12666 */     // GIR_Coverage, 5370,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 266: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12830), // Rule ID 13879 //
     /*  12672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12714 */     // MIs[1] Operand 2
     /*  12714 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12731 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12731 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12734 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12738 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12745 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12748 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12752 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12757 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12760 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12764 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12772 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12777 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12794 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12812 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12829 */     // GIR_Coverage, 13879,
     /*  12829 */     GIR_EraseRootFromParent_Done,
     /*  12830 */   // Label 267: @12830
     /*  12830 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12993), // Rule ID 13876 //
     /*  12835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12877 */     // MIs[1] Operand 2
     /*  12877 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12894 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12894 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12897 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12901 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12908 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12911 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12915 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12920 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12923 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12927 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12930 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12957 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12992 */     // GIR_Coverage, 13876,
     /*  12992 */     GIR_EraseRootFromParent_Done,
     /*  12993 */   // Label 268: @12993
     /*  12993 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(13143), // Rule ID 13884 //
     /*  12998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13031 */     // MIs[1] Operand 2
     /*  13031 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13048 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13051 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13055 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13074 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13077 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13081 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13084 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13125 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13142 */     // GIR_Coverage, 13884,
     /*  13142 */     GIR_EraseRootFromParent_Done,
     /*  13143 */   // Label 269: @13143
     /*  13143 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(13293), // Rule ID 13888 //
     /*  13148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13181 */     // MIs[1] Operand 2
     /*  13181 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13198 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13198 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13201 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13205 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13212 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13215 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13219 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13224 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13227 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13231 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13234 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13239 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13244 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13261 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13275 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13292 */     // GIR_Coverage, 13888,
     /*  13292 */     GIR_EraseRootFromParent_Done,
     /*  13293 */   // Label 270: @13293
     /*  13293 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(13443), // Rule ID 13883 //
     /*  13298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13331 */     // MIs[1] Operand 2
     /*  13331 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13348 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13348 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13351 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13355 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13374 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13377 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13381 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13425 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13442 */     // GIR_Coverage, 13883,
     /*  13442 */     GIR_EraseRootFromParent_Done,
     /*  13443 */   // Label 271: @13443
     /*  13443 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13606), // Rule ID 5358 //
     /*  13448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13494 */     // MIs[1] Operand 2
     /*  13494 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13507 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13507 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13510 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13514 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13533 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13536 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13540 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13543 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13548 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13553 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13588 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13605 */     // GIR_Coverage, 5358,
     /*  13605 */     GIR_EraseRootFromParent_Done,
     /*  13606 */   // Label 272: @13606
     /*  13606 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13769), // Rule ID 5355 //
     /*  13611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13657 */     // MIs[1] Operand 2
     /*  13657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13670 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13696 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13703 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13751 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13768 */     // GIR_Coverage, 5355,
     /*  13768 */     GIR_EraseRootFromParent_Done,
     /*  13769 */   // Label 273: @13769
     /*  13769 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13919), // Rule ID 5381 //
     /*  13774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13811 */     // MIs[1] Operand 2
     /*  13811 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13824 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13838 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13841 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13845 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13850 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13853 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13857 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13901 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13918 */     // GIR_Coverage, 5381,
     /*  13918 */     GIR_EraseRootFromParent_Done,
     /*  13919 */   // Label 274: @13919
     /*  13919 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(14069), // Rule ID 5388 //
     /*  13924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13961 */     // MIs[1] Operand 2
     /*  13961 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13974 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13974 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13977 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13981 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13988 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13991 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13995 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14000 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14007 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14051 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14068 */     // GIR_Coverage, 5388,
     /*  14068 */     GIR_EraseRootFromParent_Done,
     /*  14069 */   // Label 275: @14069
     /*  14069 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(14219), // Rule ID 5380 //
     /*  14074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14111 */     // MIs[1] Operand 2
     /*  14111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14124 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14124 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14127 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14131 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14150 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14153 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14157 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14170 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14187 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14218 */     // GIR_Coverage, 5380,
     /*  14218 */     GIR_EraseRootFromParent_Done,
     /*  14219 */   // Label 276: @14219
     /*  14219 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(14288), // Rule ID 13328 //
     /*  14224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14239 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14242 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14251 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14271 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14286 */     GIR_RootConstrainSelectedInstOperands,
     /*  14287 */     // GIR_Coverage, 13328,
     /*  14287 */     GIR_EraseRootFromParent_Done,
     /*  14288 */   // Label 277: @14288
     /*  14288 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(14357), // Rule ID 13340 //
     /*  14293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14308 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14311 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14320 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14340 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14355 */     GIR_RootConstrainSelectedInstOperands,
     /*  14356 */     // GIR_Coverage, 13340,
     /*  14356 */     GIR_EraseRootFromParent_Done,
     /*  14357 */   // Label 278: @14357
     /*  14357 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14413), // Rule ID 13290 //
     /*  14362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14377 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14380 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14400 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14411 */     GIR_RootConstrainSelectedInstOperands,
     /*  14412 */     // GIR_Coverage, 13290,
     /*  14412 */     GIR_EraseRootFromParent_Done,
     /*  14413 */   // Label 279: @14413
     /*  14413 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14469), // Rule ID 13302 //
     /*  14418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14433 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14436 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14456 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14467 */     GIR_RootConstrainSelectedInstOperands,
     /*  14468 */     // GIR_Coverage, 13302,
     /*  14468 */     GIR_EraseRootFromParent_Done,
     /*  14469 */   // Label 280: @14469
     /*  14469 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14536), // Rule ID 13532 //
     /*  14474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14498 */     // MIs[1] imm
     /*  14498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14506 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14510 */     // MIs[2] Operand 1
     /*  14510 */     // No operand predicates
     /*  14510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14514 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14520 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14534 */     GIR_RootConstrainSelectedInstOperands,
     /*  14535 */     // GIR_Coverage, 13532,
     /*  14535 */     GIR_EraseRootFromParent_Done,
     /*  14536 */   // Label 281: @14536
     /*  14536 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14603), // Rule ID 13553 //
     /*  14541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14565 */     // MIs[1] imm
     /*  14565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14573 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14577 */     // MIs[2] Operand 1
     /*  14577 */     // No operand predicates
     /*  14577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14581 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14587 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14601 */     GIR_RootConstrainSelectedInstOperands,
     /*  14602 */     // GIR_Coverage, 13553,
     /*  14602 */     GIR_EraseRootFromParent_Done,
     /*  14603 */   // Label 282: @14603
     /*  14603 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14672), // Rule ID 1365 //
     /*  14608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14627 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14630 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14639 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14655 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14670 */     GIR_RootConstrainSelectedInstOperands,
     /*  14671 */     // GIR_Coverage, 1365,
     /*  14671 */     GIR_EraseRootFromParent_Done,
     /*  14672 */   // Label 283: @14672
     /*  14672 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14741), // Rule ID 1488 //
     /*  14677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14708 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14724 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14739 */     GIR_RootConstrainSelectedInstOperands,
     /*  14740 */     // GIR_Coverage, 1488,
     /*  14740 */     GIR_EraseRootFromParent_Done,
     /*  14741 */   // Label 284: @14741
     /*  14741 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14797), // Rule ID 993 //
     /*  14746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14765 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14768 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14784 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14795 */     GIR_RootConstrainSelectedInstOperands,
     /*  14796 */     // GIR_Coverage, 993,
     /*  14796 */     GIR_EraseRootFromParent_Done,
     /*  14797 */   // Label 285: @14797
     /*  14797 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14853), // Rule ID 1054 //
     /*  14802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14821 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14824 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14840 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14851 */     GIR_RootConstrainSelectedInstOperands,
     /*  14852 */     // GIR_Coverage, 1054,
     /*  14852 */     GIR_EraseRootFromParent_Done,
     /*  14853 */   // Label 286: @14853
     /*  14853 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14920), // Rule ID 2238 //
     /*  14858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14886 */     // MIs[1] imm
     /*  14886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14894 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14898 */     // MIs[2] Operand 1
     /*  14898 */     // No operand predicates
     /*  14898 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14904 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14918 */     GIR_RootConstrainSelectedInstOperands,
     /*  14919 */     // GIR_Coverage, 2238,
     /*  14919 */     GIR_EraseRootFromParent_Done,
     /*  14920 */   // Label 287: @14920
     /*  14920 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14987), // Rule ID 2297 //
     /*  14925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14953 */     // MIs[1] imm
     /*  14953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14965 */     // MIs[2] Operand 1
     /*  14965 */     // No operand predicates
     /*  14965 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14971 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14985 */     GIR_RootConstrainSelectedInstOperands,
     /*  14986 */     // GIR_Coverage, 2297,
     /*  14986 */     GIR_EraseRootFromParent_Done,
     /*  14987 */   // Label 288: @14987
     /*  14987 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(15035), // Rule ID 13289 //
     /*  14992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15022 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15033 */     GIR_RootConstrainSelectedInstOperands,
     /*  15034 */     // GIR_Coverage, 13289,
     /*  15034 */     GIR_EraseRootFromParent_Done,
     /*  15035 */   // Label 289: @15035
     /*  15035 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15083), // Rule ID 13301 //
     /*  15040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15070 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15081 */     GIR_RootConstrainSelectedInstOperands,
     /*  15082 */     // GIR_Coverage, 13301,
     /*  15082 */     GIR_EraseRootFromParent_Done,
     /*  15083 */   // Label 290: @15083
     /*  15083 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15131), // Rule ID 992 //
     /*  15088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15118 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15129 */     GIR_RootConstrainSelectedInstOperands,
     /*  15130 */     // GIR_Coverage, 992,
     /*  15130 */     GIR_EraseRootFromParent_Done,
     /*  15131 */   // Label 291: @15131
     /*  15131 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15179), // Rule ID 1053 //
     /*  15136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15166 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15177 */     GIR_RootConstrainSelectedInstOperands,
     /*  15178 */     // GIR_Coverage, 1053,
     /*  15178 */     GIR_EraseRootFromParent_Done,
     /*  15179 */   // Label 292: @15179
     /*  15179 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15206), // Rule ID 1104 //
     /*  15184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15199 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15204 */     GIR_RootConstrainSelectedInstOperands,
     /*  15205 */     // GIR_Coverage, 1104,
     /*  15205 */     GIR_Done,
     /*  15206 */   // Label 293: @15206
     /*  15206 */   GIM_Reject,
     /*  15207 */ // Label 259: @15207
     /*  15207 */ GIM_Reject,
     /*  15208 */ // Label 156: @15208
     /*  15208 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(21109),
     /*  15213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15219 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15337), // Rule ID 13467 //
     /*  15224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15267 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15271 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15275 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15284 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15288 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15292 */     // MIs[4] Operand 1
     /*  15292 */     // No operand predicates
     /*  15292 */     // MIs[2] Operand 2
     /*  15292 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15307 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15316 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15335 */     GIR_RootConstrainSelectedInstOperands,
     /*  15336 */     // GIR_Coverage, 13467,
     /*  15336 */     GIR_EraseRootFromParent_Done,
     /*  15337 */   // Label 295: @15337
     /*  15337 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15455), // Rule ID 13468 //
     /*  15342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15385 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15389 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15393 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15398 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15402 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15406 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15410 */     // MIs[4] Operand 1
     /*  15410 */     // No operand predicates
     /*  15410 */     // MIs[2] Operand 2
     /*  15410 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15425 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15434 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 13468,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 296: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15573), // Rule ID 13497 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15503 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15507 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15511 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15516 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15520 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15524 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15528 */     // MIs[4] Operand 1
     /*  15528 */     // No operand predicates
     /*  15528 */     // MIs[2] Operand 2
     /*  15528 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15543 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15552 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15571 */     GIR_RootConstrainSelectedInstOperands,
     /*  15572 */     // GIR_Coverage, 13497,
     /*  15572 */     GIR_EraseRootFromParent_Done,
     /*  15573 */   // Label 297: @15573
     /*  15573 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15691), // Rule ID 13498 //
     /*  15578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15621 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15625 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15629 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15634 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15638 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15642 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15646 */     // MIs[4] Operand 1
     /*  15646 */     // No operand predicates
     /*  15646 */     // MIs[2] Operand 2
     /*  15646 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15661 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15670 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15689 */     GIR_RootConstrainSelectedInstOperands,
     /*  15690 */     // GIR_Coverage, 13498,
     /*  15690 */     GIR_EraseRootFromParent_Done,
     /*  15691 */   // Label 298: @15691
     /*  15691 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15809), // Rule ID 2042 //
     /*  15696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15743 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15747 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15751 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15756 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15760 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15764 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15768 */     // MIs[4] Operand 1
     /*  15768 */     // No operand predicates
     /*  15768 */     // MIs[2] Operand 2
     /*  15768 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15779 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15788 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15807 */     GIR_RootConstrainSelectedInstOperands,
     /*  15808 */     // GIR_Coverage, 2042,
     /*  15808 */     GIR_EraseRootFromParent_Done,
     /*  15809 */   // Label 299: @15809
     /*  15809 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15927), // Rule ID 13466 //
     /*  15814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15865 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15882 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15886 */     // MIs[4] Operand 1
     /*  15886 */     // No operand predicates
     /*  15886 */     // MIs[2] Operand 2
     /*  15886 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15897 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15899 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15906 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15925 */     GIR_RootConstrainSelectedInstOperands,
     /*  15926 */     // GIR_Coverage, 13466,
     /*  15926 */     GIR_EraseRootFromParent_Done,
     /*  15927 */   // Label 300: @15927
     /*  15927 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(16045), // Rule ID 2094 //
     /*  15932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15979 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15983 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15987 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16000 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16004 */     // MIs[4] Operand 1
     /*  16004 */     // No operand predicates
     /*  16004 */     // MIs[2] Operand 2
     /*  16004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16015 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16024 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16043 */     GIR_RootConstrainSelectedInstOperands,
     /*  16044 */     // GIR_Coverage, 2094,
     /*  16044 */     GIR_EraseRootFromParent_Done,
     /*  16045 */   // Label 301: @16045
     /*  16045 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(16163), // Rule ID 13496 //
     /*  16050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16097 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16101 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16105 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16110 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16114 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16118 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16122 */     // MIs[4] Operand 1
     /*  16122 */     // No operand predicates
     /*  16122 */     // MIs[2] Operand 2
     /*  16122 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16133 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16142 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16161 */     GIR_RootConstrainSelectedInstOperands,
     /*  16162 */     // GIR_Coverage, 13496,
     /*  16162 */     GIR_EraseRootFromParent_Done,
     /*  16163 */   // Label 302: @16163
     /*  16163 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(16250), // Rule ID 13372 //
     /*  16168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16195 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16198 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16207 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16231 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16248 */     GIR_RootConstrainSelectedInstOperands,
     /*  16249 */     // GIR_Coverage, 13372,
     /*  16249 */     GIR_EraseRootFromParent_Done,
     /*  16250 */   // Label 303: @16250
     /*  16250 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16337), // Rule ID 13396 //
     /*  16255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16282 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16285 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16294 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16318 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16335 */     GIR_RootConstrainSelectedInstOperands,
     /*  16336 */     // GIR_Coverage, 13396,
     /*  16336 */     GIR_EraseRootFromParent_Done,
     /*  16337 */   // Label 304: @16337
     /*  16337 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16424), // Rule ID 1699 //
     /*  16342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16373 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16376 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16385 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16405 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16422 */     GIR_RootConstrainSelectedInstOperands,
     /*  16423 */     // GIR_Coverage, 1699,
     /*  16423 */     GIR_EraseRootFromParent_Done,
     /*  16424 */   // Label 305: @16424
     /*  16424 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16511), // Rule ID 1777 //
     /*  16429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16460 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16463 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16472 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16492 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16509 */     GIR_RootConstrainSelectedInstOperands,
     /*  16510 */     // GIR_Coverage, 1777,
     /*  16510 */     GIR_EraseRootFromParent_Done,
     /*  16511 */   // Label 306: @16511
     /*  16511 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16626), // Rule ID 13462 //
     /*  16516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16559 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16563 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16567 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16572 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16576 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16580 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16584 */     // MIs[4] Operand 1
     /*  16584 */     // No operand predicates
     /*  16584 */     // MIs[2] Operand 2
     /*  16584 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16606 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16624 */     GIR_RootConstrainSelectedInstOperands,
     /*  16625 */     // GIR_Coverage, 13462,
     /*  16625 */     GIR_EraseRootFromParent_Done,
     /*  16626 */   // Label 307: @16626
     /*  16626 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16741), // Rule ID 13461 //
     /*  16631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16679 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16683 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16687 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16696 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16700 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16704 */     // MIs[4] Operand 1
     /*  16704 */     // No operand predicates
     /*  16704 */     // MIs[2] Operand 2
     /*  16704 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16719 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16721 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16739 */     GIR_RootConstrainSelectedInstOperands,
     /*  16740 */     // GIR_Coverage, 13461,
     /*  16740 */     GIR_EraseRootFromParent_Done,
     /*  16741 */   // Label 308: @16741
     /*  16741 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16856), // Rule ID 13492 //
     /*  16746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16789 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16793 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16797 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16806 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16810 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16814 */     // MIs[4] Operand 1
     /*  16814 */     // No operand predicates
     /*  16814 */     // MIs[2] Operand 2
     /*  16814 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16836 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16854 */     GIR_RootConstrainSelectedInstOperands,
     /*  16855 */     // GIR_Coverage, 13492,
     /*  16855 */     GIR_EraseRootFromParent_Done,
     /*  16856 */   // Label 309: @16856
     /*  16856 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16971), // Rule ID 13491 //
     /*  16861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16909 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16913 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16917 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16930 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16934 */     // MIs[4] Operand 1
     /*  16934 */     // No operand predicates
     /*  16934 */     // MIs[2] Operand 2
     /*  16934 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16949 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16951 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16969 */     GIR_RootConstrainSelectedInstOperands,
     /*  16970 */     // GIR_Coverage, 13491,
     /*  16970 */     GIR_EraseRootFromParent_Done,
     /*  16971 */   // Label 310: @16971
     /*  16971 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(17040), // Rule ID 1801 //
     /*  16976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  16991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17023 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17038 */     GIR_RootConstrainSelectedInstOperands,
     /*  17039 */     // GIR_Coverage, 1801,
     /*  17039 */     GIR_EraseRootFromParent_Done,
     /*  17040 */   // Label 311: @17040
     /*  17040 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(17109), // Rule ID 1800 //
     /*  17045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17092 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17107 */     GIR_RootConstrainSelectedInstOperands,
     /*  17108 */     // GIR_Coverage, 1800,
     /*  17108 */     GIR_EraseRootFromParent_Done,
     /*  17109 */   // Label 312: @17109
     /*  17109 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17178), // Rule ID 1717 //
     /*  17114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17147 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17161 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17176 */     GIR_RootConstrainSelectedInstOperands,
     /*  17177 */     // GIR_Coverage, 1717,
     /*  17177 */     GIR_EraseRootFromParent_Done,
     /*  17178 */   // Label 313: @17178
     /*  17178 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17247), // Rule ID 1799 //
     /*  17183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17230 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17245 */     GIR_RootConstrainSelectedInstOperands,
     /*  17246 */     // GIR_Coverage, 1799,
     /*  17246 */     GIR_EraseRootFromParent_Done,
     /*  17247 */   // Label 314: @17247
     /*  17247 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17316), // Rule ID 1798 //
     /*  17252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17299 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17314 */     GIR_RootConstrainSelectedInstOperands,
     /*  17315 */     // GIR_Coverage, 1798,
     /*  17315 */     GIR_EraseRootFromParent_Done,
     /*  17316 */   // Label 315: @17316
     /*  17316 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17431), // Rule ID 13460 //
     /*  17321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17376 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17381 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17385 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17389 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17393 */     // MIs[4] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     // MIs[2] Operand 2
     /*  17393 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17409 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17411 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17429 */     GIR_RootConstrainSelectedInstOperands,
     /*  17430 */     // GIR_Coverage, 13460,
     /*  17430 */     GIR_EraseRootFromParent_Done,
     /*  17431 */   // Label 316: @17431
     /*  17431 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17546), // Rule ID 2040 //
     /*  17436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17488 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17492 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17496 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17501 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17505 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17509 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17513 */     // MIs[4] Operand 1
     /*  17513 */     // No operand predicates
     /*  17513 */     // MIs[2] Operand 2
     /*  17513 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17526 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17544 */     GIR_RootConstrainSelectedInstOperands,
     /*  17545 */     // GIR_Coverage, 2040,
     /*  17545 */     GIR_EraseRootFromParent_Done,
     /*  17546 */   // Label 317: @17546
     /*  17546 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17661), // Rule ID 13490 //
     /*  17551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17602 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17606 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17619 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17623 */     // MIs[4] Operand 1
     /*  17623 */     // No operand predicates
     /*  17623 */     // MIs[2] Operand 2
     /*  17623 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17639 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17641 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17659 */     GIR_RootConstrainSelectedInstOperands,
     /*  17660 */     // GIR_Coverage, 13490,
     /*  17660 */     GIR_EraseRootFromParent_Done,
     /*  17661 */   // Label 318: @17661
     /*  17661 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17776), // Rule ID 2092 //
     /*  17666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17718 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17722 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17726 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17739 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17743 */     // MIs[4] Operand 1
     /*  17743 */     // No operand predicates
     /*  17743 */     // MIs[2] Operand 2
     /*  17743 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17754 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17756 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17774 */     GIR_RootConstrainSelectedInstOperands,
     /*  17775 */     // GIR_Coverage, 2092,
     /*  17775 */     GIR_EraseRootFromParent_Done,
     /*  17776 */   // Label 319: @17776
     /*  17776 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17843), // Rule ID 13384 //
     /*  17781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17824 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17841 */     GIR_RootConstrainSelectedInstOperands,
     /*  17842 */     // GIR_Coverage, 13384,
     /*  17842 */     GIR_EraseRootFromParent_Done,
     /*  17843 */   // Label 320: @17843
     /*  17843 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17910), // Rule ID 13414 //
     /*  17848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17891 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17908 */     GIR_RootConstrainSelectedInstOperands,
     /*  17909 */     // GIR_Coverage, 13414,
     /*  17909 */     GIR_EraseRootFromParent_Done,
     /*  17910 */   // Label 321: @17910
     /*  17910 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17977), // Rule ID 1729 //
     /*  17915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17944 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17958 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17975 */     GIR_RootConstrainSelectedInstOperands,
     /*  17976 */     // GIR_Coverage, 1729,
     /*  17976 */     GIR_EraseRootFromParent_Done,
     /*  17977 */   // Label 322: @17977
     /*  17977 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(18044), // Rule ID 1819 //
     /*  17982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18011 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18025 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18042 */     GIR_RootConstrainSelectedInstOperands,
     /*  18043 */     // GIR_Coverage, 1819,
     /*  18043 */     GIR_EraseRootFromParent_Done,
     /*  18044 */   // Label 323: @18044
     /*  18044 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(18125), // Rule ID 13370 //
     /*  18049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18076 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18079 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18088 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18108 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18123 */     GIR_RootConstrainSelectedInstOperands,
     /*  18124 */     // GIR_Coverage, 13370,
     /*  18124 */     GIR_EraseRootFromParent_Done,
     /*  18125 */   // Label 324: @18125
     /*  18125 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18206), // Rule ID 13394 //
     /*  18130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18157 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18160 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18169 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18189 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18204 */     GIR_RootConstrainSelectedInstOperands,
     /*  18205 */     // GIR_Coverage, 13394,
     /*  18205 */     GIR_EraseRootFromParent_Done,
     /*  18206 */   // Label 325: @18206
     /*  18206 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18287), // Rule ID 1697 //
     /*  18211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18242 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18245 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18254 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18270 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18285 */     GIR_RootConstrainSelectedInstOperands,
     /*  18286 */     // GIR_Coverage, 1697,
     /*  18286 */     GIR_EraseRootFromParent_Done,
     /*  18287 */   // Label 326: @18287
     /*  18287 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18368), // Rule ID 1775 //
     /*  18292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18323 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18326 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18335 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18351 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18366 */     GIR_RootConstrainSelectedInstOperands,
     /*  18367 */     // GIR_Coverage, 1775,
     /*  18367 */     GIR_EraseRootFromParent_Done,
     /*  18368 */   // Label 327: @18368
     /*  18368 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18460), // Rule ID 13465 //
     /*  18373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18429 */     // MIs[3] Operand 1
     /*  18429 */     // No operand predicates
     /*  18429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18440 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18458 */     GIR_RootConstrainSelectedInstOperands,
     /*  18459 */     // GIR_Coverage, 13465,
     /*  18459 */     GIR_EraseRootFromParent_Done,
     /*  18460 */   // Label 328: @18460
     /*  18460 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18552), // Rule ID 13464 //
     /*  18465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18526 */     // MIs[3] Operand 1
     /*  18526 */     // No operand predicates
     /*  18526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18532 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18550 */     GIR_RootConstrainSelectedInstOperands,
     /*  18551 */     // GIR_Coverage, 13464,
     /*  18551 */     GIR_EraseRootFromParent_Done,
     /*  18552 */   // Label 329: @18552
     /*  18552 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18644), // Rule ID 13495 //
     /*  18557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18613 */     // MIs[3] Operand 1
     /*  18613 */     // No operand predicates
     /*  18613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18622 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18624 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18642 */     GIR_RootConstrainSelectedInstOperands,
     /*  18643 */     // GIR_Coverage, 13495,
     /*  18643 */     GIR_EraseRootFromParent_Done,
     /*  18644 */   // Label 330: @18644
     /*  18644 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18736), // Rule ID 13494 //
     /*  18649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18710 */     // MIs[3] Operand 1
     /*  18710 */     // No operand predicates
     /*  18710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18716 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18734 */     GIR_RootConstrainSelectedInstOperands,
     /*  18735 */     // GIR_Coverage, 13494,
     /*  18735 */     GIR_EraseRootFromParent_Done,
     /*  18736 */   // Label 331: @18736
     /*  18736 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18828), // Rule ID 13463 //
     /*  18741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18797 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18801 */     // MIs[3] Operand 1
     /*  18801 */     // No operand predicates
     /*  18801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18808 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18826 */     GIR_RootConstrainSelectedInstOperands,
     /*  18827 */     // GIR_Coverage, 13463,
     /*  18827 */     GIR_EraseRootFromParent_Done,
     /*  18828 */   // Label 332: @18828
     /*  18828 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18920), // Rule ID 2041 //
     /*  18833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18894 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18898 */     // MIs[3] Operand 1
     /*  18898 */     // No operand predicates
     /*  18898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18900 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18918 */     GIR_RootConstrainSelectedInstOperands,
     /*  18919 */     // GIR_Coverage, 2041,
     /*  18919 */     GIR_EraseRootFromParent_Done,
     /*  18920 */   // Label 333: @18920
     /*  18920 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(19012), // Rule ID 13493 //
     /*  18925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18981 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18985 */     // MIs[3] Operand 1
     /*  18985 */     // No operand predicates
     /*  18985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18992 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19010 */     GIR_RootConstrainSelectedInstOperands,
     /*  19011 */     // GIR_Coverage, 13493,
     /*  19011 */     GIR_EraseRootFromParent_Done,
     /*  19012 */   // Label 334: @19012
     /*  19012 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(19104), // Rule ID 2093 //
     /*  19017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19078 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19082 */     // MIs[3] Operand 1
     /*  19082 */     // No operand predicates
     /*  19082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19102 */     GIR_RootConstrainSelectedInstOperands,
     /*  19103 */     // GIR_Coverage, 2093,
     /*  19103 */     GIR_EraseRootFromParent_Done,
     /*  19104 */   // Label 335: @19104
     /*  19104 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19155), // Rule ID 13408 //
     /*  19109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19141 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19153 */     GIR_RootConstrainSelectedInstOperands,
     /*  19154 */     // GIR_Coverage, 13408,
     /*  19154 */     GIR_EraseRootFromParent_Done,
     /*  19155 */   // Label 336: @19155
     /*  19155 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19206), // Rule ID 13378 //
     /*  19160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19192 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19204 */     GIR_RootConstrainSelectedInstOperands,
     /*  19205 */     // GIR_Coverage, 13378,
     /*  19205 */     GIR_EraseRootFromParent_Done,
     /*  19206 */   // Label 337: @19206
     /*  19206 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19257), // Rule ID 13407 //
     /*  19211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19243 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19255 */     GIR_RootConstrainSelectedInstOperands,
     /*  19256 */     // GIR_Coverage, 13407,
     /*  19256 */     GIR_EraseRootFromParent_Done,
     /*  19257 */   // Label 338: @19257
     /*  19257 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19308), // Rule ID 1813 //
     /*  19262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19294 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19306 */     GIR_RootConstrainSelectedInstOperands,
     /*  19307 */     // GIR_Coverage, 1813,
     /*  19307 */     GIR_EraseRootFromParent_Done,
     /*  19308 */   // Label 339: @19308
     /*  19308 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19359), // Rule ID 1723 //
     /*  19313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19345 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19357 */     GIR_RootConstrainSelectedInstOperands,
     /*  19358 */     // GIR_Coverage, 1723,
     /*  19358 */     GIR_EraseRootFromParent_Done,
     /*  19359 */   // Label 340: @19359
     /*  19359 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19410), // Rule ID 1812 //
     /*  19364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19396 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19408 */     GIR_RootConstrainSelectedInstOperands,
     /*  19409 */     // GIR_Coverage, 1812,
     /*  19409 */     GIR_EraseRootFromParent_Done,
     /*  19410 */   // Label 341: @19410
     /*  19410 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19466), // Rule ID 13296 //
     /*  19415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19430 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19433 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19453 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19464 */     GIR_RootConstrainSelectedInstOperands,
     /*  19465 */     // GIR_Coverage, 13296,
     /*  19465 */     GIR_EraseRootFromParent_Done,
     /*  19466 */   // Label 342: @19466
     /*  19466 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19522), // Rule ID 13308 //
     /*  19471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19486 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19489 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19509 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19520 */     GIR_RootConstrainSelectedInstOperands,
     /*  19521 */     // GIR_Coverage, 13308,
     /*  19521 */     GIR_EraseRootFromParent_Done,
     /*  19522 */   // Label 343: @19522
     /*  19522 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19589), // Rule ID 13536 //
     /*  19527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19551 */     // MIs[1] imm
     /*  19551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19559 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19563 */     // MIs[2] Operand 1
     /*  19563 */     // No operand predicates
     /*  19563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19573 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19587 */     GIR_RootConstrainSelectedInstOperands,
     /*  19588 */     // GIR_Coverage, 13536,
     /*  19588 */     GIR_EraseRootFromParent_Done,
     /*  19589 */   // Label 344: @19589
     /*  19589 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19656), // Rule ID 13557 //
     /*  19594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19618 */     // MIs[1] imm
     /*  19618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19626 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19630 */     // MIs[2] Operand 1
     /*  19630 */     // No operand predicates
     /*  19630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19634 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19640 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19654 */     GIR_RootConstrainSelectedInstOperands,
     /*  19655 */     // GIR_Coverage, 13557,
     /*  19655 */     GIR_EraseRootFromParent_Done,
     /*  19656 */   // Label 345: @19656
     /*  19656 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19712), // Rule ID 999 //
     /*  19661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19680 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19683 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19699 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19710 */     GIR_RootConstrainSelectedInstOperands,
     /*  19711 */     // GIR_Coverage, 999,
     /*  19711 */     GIR_EraseRootFromParent_Done,
     /*  19712 */   // Label 346: @19712
     /*  19712 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19768), // Rule ID 1060 //
     /*  19717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19736 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19739 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19755 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19766 */     GIR_RootConstrainSelectedInstOperands,
     /*  19767 */     // GIR_Coverage, 1060,
     /*  19767 */     GIR_EraseRootFromParent_Done,
     /*  19768 */   // Label 347: @19768
     /*  19768 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19835), // Rule ID 2242 //
     /*  19773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19801 */     // MIs[1] imm
     /*  19801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19813 */     // MIs[2] Operand 1
     /*  19813 */     // No operand predicates
     /*  19813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19819 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19833 */     GIR_RootConstrainSelectedInstOperands,
     /*  19834 */     // GIR_Coverage, 2242,
     /*  19834 */     GIR_EraseRootFromParent_Done,
     /*  19835 */   // Label 348: @19835
     /*  19835 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19902), // Rule ID 2301 //
     /*  19840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19868 */     // MIs[1] imm
     /*  19868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19876 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19880 */     // MIs[2] Operand 1
     /*  19880 */     // No operand predicates
     /*  19880 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19886 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19900 */     GIR_RootConstrainSelectedInstOperands,
     /*  19901 */     // GIR_Coverage, 2301,
     /*  19901 */     GIR_EraseRootFromParent_Done,
     /*  19902 */   // Label 349: @19902
     /*  19902 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19972), // Rule ID 6922 //
     /*  19907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19945 */     // MIs[2] Rn
     /*  19945 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19950 */     // MIs[2] Rm
     /*  19950 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19957 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19970 */     GIR_RootConstrainSelectedInstOperands,
     /*  19971 */     // GIR_Coverage, 6922,
     /*  19971 */     GIR_EraseRootFromParent_Done,
     /*  19972 */   // Label 350: @19972
     /*  19972 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(20042), // Rule ID 13915 //
     /*  19977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20015 */     // MIs[2] Rn
     /*  20015 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20020 */     // MIs[2] Rm
     /*  20020 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20027 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20040 */     GIR_RootConstrainSelectedInstOperands,
     /*  20041 */     // GIR_Coverage, 13915,
     /*  20041 */     GIR_EraseRootFromParent_Done,
     /*  20042 */   // Label 351: @20042
     /*  20042 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(20105), // Rule ID 1797 //
     /*  20047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20090 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20103 */     GIR_RootConstrainSelectedInstOperands,
     /*  20104 */     // GIR_Coverage, 1797,
     /*  20104 */     GIR_EraseRootFromParent_Done,
     /*  20105 */   // Label 352: @20105
     /*  20105 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20168), // Rule ID 1796 //
     /*  20110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20153 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20166 */     GIR_RootConstrainSelectedInstOperands,
     /*  20167 */     // GIR_Coverage, 1796,
     /*  20167 */     GIR_EraseRootFromParent_Done,
     /*  20168 */   // Label 353: @20168
     /*  20168 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20231), // Rule ID 1716 //
     /*  20173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20216 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20229 */     GIR_RootConstrainSelectedInstOperands,
     /*  20230 */     // GIR_Coverage, 1716,
     /*  20230 */     GIR_EraseRootFromParent_Done,
     /*  20231 */   // Label 354: @20231
     /*  20231 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20294), // Rule ID 1795 //
     /*  20236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20279 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20292 */     GIR_RootConstrainSelectedInstOperands,
     /*  20293 */     // GIR_Coverage, 1795,
     /*  20293 */     GIR_EraseRootFromParent_Done,
     /*  20294 */   // Label 355: @20294
     /*  20294 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20357), // Rule ID 1794 //
     /*  20299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20342 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20355 */     GIR_RootConstrainSelectedInstOperands,
     /*  20356 */     // GIR_Coverage, 1794,
     /*  20356 */     GIR_EraseRootFromParent_Done,
     /*  20357 */   // Label 356: @20357
     /*  20357 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20418), // Rule ID 13383 //
     /*  20362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20401 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20416 */     GIR_RootConstrainSelectedInstOperands,
     /*  20417 */     // GIR_Coverage, 13383,
     /*  20417 */     GIR_EraseRootFromParent_Done,
     /*  20418 */   // Label 357: @20418
     /*  20418 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20479), // Rule ID 13413 //
     /*  20423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20462 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20477 */     GIR_RootConstrainSelectedInstOperands,
     /*  20478 */     // GIR_Coverage, 13413,
     /*  20478 */     GIR_EraseRootFromParent_Done,
     /*  20479 */   // Label 358: @20479
     /*  20479 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20527), // Rule ID 13406 //
     /*  20484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20514 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20525 */     GIR_RootConstrainSelectedInstOperands,
     /*  20526 */     // GIR_Coverage, 13406,
     /*  20526 */     GIR_EraseRootFromParent_Done,
     /*  20527 */   // Label 359: @20527
     /*  20527 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20575), // Rule ID 13295 //
     /*  20532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20562 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20573 */     GIR_RootConstrainSelectedInstOperands,
     /*  20574 */     // GIR_Coverage, 13295,
     /*  20574 */     GIR_EraseRootFromParent_Done,
     /*  20575 */   // Label 360: @20575
     /*  20575 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20623), // Rule ID 13377 //
     /*  20580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20610 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20621 */     GIR_RootConstrainSelectedInstOperands,
     /*  20622 */     // GIR_Coverage, 13377,
     /*  20622 */     GIR_EraseRootFromParent_Done,
     /*  20623 */   // Label 361: @20623
     /*  20623 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20671), // Rule ID 13307 //
     /*  20628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20658 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20669 */     GIR_RootConstrainSelectedInstOperands,
     /*  20670 */     // GIR_Coverage, 13307,
     /*  20670 */     GIR_EraseRootFromParent_Done,
     /*  20671 */   // Label 362: @20671
     /*  20671 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20719), // Rule ID 13405 //
     /*  20676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20706 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20717 */     GIR_RootConstrainSelectedInstOperands,
     /*  20718 */     // GIR_Coverage, 13405,
     /*  20718 */     GIR_EraseRootFromParent_Done,
     /*  20719 */   // Label 363: @20719
     /*  20719 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20780), // Rule ID 1728 //
     /*  20724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20763 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20778 */     GIR_RootConstrainSelectedInstOperands,
     /*  20779 */     // GIR_Coverage, 1728,
     /*  20779 */     GIR_EraseRootFromParent_Done,
     /*  20780 */   // Label 364: @20780
     /*  20780 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20841), // Rule ID 1818 //
     /*  20785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20824 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20839 */     GIR_RootConstrainSelectedInstOperands,
     /*  20840 */     // GIR_Coverage, 1818,
     /*  20840 */     GIR_EraseRootFromParent_Done,
     /*  20841 */   // Label 365: @20841
     /*  20841 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20889), // Rule ID 1811 //
     /*  20846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20876 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20887 */     GIR_RootConstrainSelectedInstOperands,
     /*  20888 */     // GIR_Coverage, 1811,
     /*  20888 */     GIR_EraseRootFromParent_Done,
     /*  20889 */   // Label 366: @20889
     /*  20889 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20937), // Rule ID 998 //
     /*  20894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20924 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20935 */     GIR_RootConstrainSelectedInstOperands,
     /*  20936 */     // GIR_Coverage, 998,
     /*  20936 */     GIR_EraseRootFromParent_Done,
     /*  20937 */   // Label 367: @20937
     /*  20937 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20985), // Rule ID 1722 //
     /*  20942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20972 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20983 */     GIR_RootConstrainSelectedInstOperands,
     /*  20984 */     // GIR_Coverage, 1722,
     /*  20984 */     GIR_EraseRootFromParent_Done,
     /*  20985 */   // Label 368: @20985
     /*  20985 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(21033), // Rule ID 1059 //
     /*  20990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21020 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21031 */     GIR_RootConstrainSelectedInstOperands,
     /*  21032 */     // GIR_Coverage, 1059,
     /*  21032 */     GIR_EraseRootFromParent_Done,
     /*  21033 */   // Label 369: @21033
     /*  21033 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21081), // Rule ID 1810 //
     /*  21038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21068 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21079 */     GIR_RootConstrainSelectedInstOperands,
     /*  21080 */     // GIR_Coverage, 1810,
     /*  21080 */     GIR_EraseRootFromParent_Done,
     /*  21081 */   // Label 370: @21081
     /*  21081 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21108), // Rule ID 1106 //
     /*  21086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21101 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21106 */     GIR_RootConstrainSelectedInstOperands,
     /*  21107 */     // GIR_Coverage, 1106,
     /*  21107 */     GIR_Done,
     /*  21108 */   // Label 371: @21108
     /*  21108 */   GIM_Reject,
     /*  21109 */ // Label 294: @21109
     /*  21109 */ GIM_Reject,
     /*  21110 */ // Label 157: @21110
     /*  21110 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(24607),
     /*  21115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21121 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21257), // Rule ID 5369 //
     /*  21126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21159 */     // MIs[1] Operand 2
     /*  21159 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21182 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21186 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21190 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21194 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21199 */     // MIs[3] Operand 2
     /*  21199 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21210 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21212 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21239 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21256 */     // GIR_Coverage, 5369,
     /*  21256 */     GIR_EraseRootFromParent_Done,
     /*  21257 */   // Label 373: @21257
     /*  21257 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21393), // Rule ID 5368 //
     /*  21262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21295 */     // MIs[1] Operand 2
     /*  21295 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21322 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21326 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21330 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21335 */     // MIs[3] Operand 2
     /*  21335 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21346 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21348 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21375 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21392 */     // GIR_Coverage, 5368,
     /*  21392 */     GIR_EraseRootFromParent_Done,
     /*  21393 */   // Label 374: @21393
     /*  21393 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21529), // Rule ID 5384 //
     /*  21398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21431 */     // MIs[1] Operand 2
     /*  21431 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21450 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21458 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21462 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21466 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21471 */     // MIs[3] Operand 2
     /*  21471 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21482 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21484 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21511 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21528 */     // GIR_Coverage, 5384,
     /*  21528 */     GIR_EraseRootFromParent_Done,
     /*  21529 */   // Label 375: @21529
     /*  21529 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21665), // Rule ID 5367 //
     /*  21534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21567 */     // MIs[1] Operand 2
     /*  21567 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21586 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21590 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21594 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21598 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21602 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21607 */     // MIs[3] Operand 2
     /*  21607 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21618 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21620 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21647 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21664 */     // GIR_Coverage, 5367,
     /*  21664 */     GIR_EraseRootFromParent_Done,
     /*  21665 */   // Label 376: @21665
     /*  21665 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21801), // Rule ID 5366 //
     /*  21670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21703 */     // MIs[1] Operand 2
     /*  21703 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21722 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21726 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21730 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21734 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21738 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21743 */     // MIs[3] Operand 2
     /*  21743 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21754 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21756 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21783 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21800 */     // GIR_Coverage, 5366,
     /*  21800 */     GIR_EraseRootFromParent_Done,
     /*  21801 */   // Label 377: @21801
     /*  21801 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21934), // Rule ID 13920 //
     /*  21806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21851 */     // MIs[1] Operand 2
     /*  21851 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21870 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21874 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21878 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21882 */     // MIs[5] Rn
     /*  21882 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21887 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21889 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21916 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21933 */     // GIR_Coverage, 13920,
     /*  21933 */     GIR_EraseRootFromParent_Done,
     /*  21934 */   // Label 378: @21934
     /*  21934 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(22067), // Rule ID 6927 //
     /*  21939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  21992 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21996 */     // MIs[4] Rn
     /*  21996 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22001 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22005 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22009 */     // MIs[3] Operand 2
     /*  22009 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22020 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22022 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22066 */     // GIR_Coverage, 6927,
     /*  22066 */     GIR_EraseRootFromParent_Done,
     /*  22067 */   // Label 379: @22067
     /*  22067 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(22230), // Rule ID 13878 //
     /*  22072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22114 */     // MIs[1] Operand 2
     /*  22114 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22131 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22131 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22134 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22138 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22145 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22148 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22152 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22157 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22160 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22164 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22167 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22172 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22177 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22194 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22212 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22229 */     // GIR_Coverage, 13878,
     /*  22229 */     GIR_EraseRootFromParent_Done,
     /*  22230 */   // Label 380: @22230
     /*  22230 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22393), // Rule ID 13875 //
     /*  22235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22277 */     // MIs[1] Operand 2
     /*  22277 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22294 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22294 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22297 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22301 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22308 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22311 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22315 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22320 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22327 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22357 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22375 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22392 */     // GIR_Coverage, 13875,
     /*  22392 */     GIR_EraseRootFromParent_Done,
     /*  22393 */   // Label 381: @22393
     /*  22393 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22543), // Rule ID 13882 //
     /*  22398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22431 */     // MIs[1] Operand 2
     /*  22431 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22448 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22448 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22451 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22455 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22462 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22465 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22469 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22474 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22477 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22481 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22511 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22525 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22542 */     // GIR_Coverage, 13882,
     /*  22542 */     GIR_EraseRootFromParent_Done,
     /*  22543 */   // Label 382: @22543
     /*  22543 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22693), // Rule ID 13887 //
     /*  22548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22581 */     // MIs[1] Operand 2
     /*  22581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22598 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22598 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22601 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22605 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22612 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22624 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22627 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22631 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22661 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22675 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22692 */     // GIR_Coverage, 13887,
     /*  22692 */     GIR_EraseRootFromParent_Done,
     /*  22693 */   // Label 383: @22693
     /*  22693 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22843), // Rule ID 13881 //
     /*  22698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22731 */     // MIs[1] Operand 2
     /*  22731 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22748 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22748 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22751 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22755 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22774 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22777 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22781 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22811 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22842 */     // GIR_Coverage, 13881,
     /*  22842 */     GIR_EraseRootFromParent_Done,
     /*  22843 */   // Label 384: @22843
     /*  22843 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(23006), // Rule ID 5357 //
     /*  22848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22894 */     // MIs[1] Operand 2
     /*  22894 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22907 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22907 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22910 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22914 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22933 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22940 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22988 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23005 */     // GIR_Coverage, 5357,
     /*  23005 */     GIR_EraseRootFromParent_Done,
     /*  23006 */   // Label 385: @23006
     /*  23006 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(23169), // Rule ID 5354 //
     /*  23011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23057 */     // MIs[1] Operand 2
     /*  23057 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23070 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23070 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23073 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23077 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23084 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23087 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23091 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23096 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23103 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23106 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23111 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23116 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23151 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23168 */     // GIR_Coverage, 5354,
     /*  23168 */     GIR_EraseRootFromParent_Done,
     /*  23169 */   // Label 386: @23169
     /*  23169 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(23319), // Rule ID 5379 //
     /*  23174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23211 */     // MIs[1] Operand 2
     /*  23211 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23224 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23224 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23227 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23231 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23250 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23253 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23257 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23265 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23301 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23318 */     // GIR_Coverage, 5379,
     /*  23318 */     GIR_EraseRootFromParent_Done,
     /*  23319 */   // Label 387: @23319
     /*  23319 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(23469), // Rule ID 5387 //
     /*  23324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23361 */     // MIs[1] Operand 2
     /*  23361 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23374 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23374 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23377 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23381 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23400 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23407 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23415 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23451 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23468 */     // GIR_Coverage, 5387,
     /*  23468 */     GIR_EraseRootFromParent_Done,
     /*  23469 */   // Label 388: @23469
     /*  23469 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23619), // Rule ID 5378 //
     /*  23474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23511 */     // MIs[1] Operand 2
     /*  23511 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23524 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23524 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23527 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23531 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23550 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23553 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23557 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23618 */     // GIR_Coverage, 5378,
     /*  23618 */     GIR_EraseRootFromParent_Done,
     /*  23619 */   // Label 389: @23619
     /*  23619 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23688), // Rule ID 13324 //
     /*  23624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23639 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23642 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23651 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23671 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23686 */     GIR_RootConstrainSelectedInstOperands,
     /*  23687 */     // GIR_Coverage, 13324,
     /*  23687 */     GIR_EraseRootFromParent_Done,
     /*  23688 */   // Label 390: @23688
     /*  23688 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23757), // Rule ID 13336 //
     /*  23693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23708 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23711 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23740 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23755 */     GIR_RootConstrainSelectedInstOperands,
     /*  23756 */     // GIR_Coverage, 13336,
     /*  23756 */     GIR_EraseRootFromParent_Done,
     /*  23757 */   // Label 391: @23757
     /*  23757 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23813), // Rule ID 13286 //
     /*  23762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23777 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23780 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23800 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23811 */     GIR_RootConstrainSelectedInstOperands,
     /*  23812 */     // GIR_Coverage, 13286,
     /*  23812 */     GIR_EraseRootFromParent_Done,
     /*  23813 */   // Label 392: @23813
     /*  23813 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23869), // Rule ID 13298 //
     /*  23818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23833 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23836 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23856 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23867 */     GIR_RootConstrainSelectedInstOperands,
     /*  23868 */     // GIR_Coverage, 13298,
     /*  23868 */     GIR_EraseRootFromParent_Done,
     /*  23869 */   // Label 393: @23869
     /*  23869 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23936), // Rule ID 13528 //
     /*  23874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23898 */     // MIs[1] imm
     /*  23898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23910 */     // MIs[2] Operand 1
     /*  23910 */     // No operand predicates
     /*  23910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23920 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23934 */     GIR_RootConstrainSelectedInstOperands,
     /*  23935 */     // GIR_Coverage, 13528,
     /*  23935 */     GIR_EraseRootFromParent_Done,
     /*  23936 */   // Label 394: @23936
     /*  23936 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(24003), // Rule ID 13549 //
     /*  23941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23965 */     // MIs[1] imm
     /*  23965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23973 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23977 */     // MIs[2] Operand 1
     /*  23977 */     // No operand predicates
     /*  23977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23987 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  23990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24001 */     GIR_RootConstrainSelectedInstOperands,
     /*  24002 */     // GIR_Coverage, 13549,
     /*  24002 */     GIR_EraseRootFromParent_Done,
     /*  24003 */   // Label 395: @24003
     /*  24003 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(24072), // Rule ID 1361 //
     /*  24008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24027 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24030 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24055 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24070 */     GIR_RootConstrainSelectedInstOperands,
     /*  24071 */     // GIR_Coverage, 1361,
     /*  24071 */     GIR_EraseRootFromParent_Done,
     /*  24072 */   // Label 396: @24072
     /*  24072 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24141), // Rule ID 1484 //
     /*  24077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24108 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24124 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24139 */     GIR_RootConstrainSelectedInstOperands,
     /*  24140 */     // GIR_Coverage, 1484,
     /*  24140 */     GIR_EraseRootFromParent_Done,
     /*  24141 */   // Label 397: @24141
     /*  24141 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24197), // Rule ID 989 //
     /*  24146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24165 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24168 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24184 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24195 */     GIR_RootConstrainSelectedInstOperands,
     /*  24196 */     // GIR_Coverage, 989,
     /*  24196 */     GIR_EraseRootFromParent_Done,
     /*  24197 */   // Label 398: @24197
     /*  24197 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24253), // Rule ID 1050 //
     /*  24202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24221 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24224 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24240 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24251 */     GIR_RootConstrainSelectedInstOperands,
     /*  24252 */     // GIR_Coverage, 1050,
     /*  24252 */     GIR_EraseRootFromParent_Done,
     /*  24253 */   // Label 399: @24253
     /*  24253 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24320), // Rule ID 2234 //
     /*  24258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24286 */     // MIs[1] imm
     /*  24286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24294 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24298 */     // MIs[2] Operand 1
     /*  24298 */     // No operand predicates
     /*  24298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24304 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24318 */     GIR_RootConstrainSelectedInstOperands,
     /*  24319 */     // GIR_Coverage, 2234,
     /*  24319 */     GIR_EraseRootFromParent_Done,
     /*  24320 */   // Label 400: @24320
     /*  24320 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24387), // Rule ID 2293 //
     /*  24325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24353 */     // MIs[1] imm
     /*  24353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24365 */     // MIs[2] Operand 1
     /*  24365 */     // No operand predicates
     /*  24365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24371 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24385 */     GIR_RootConstrainSelectedInstOperands,
     /*  24386 */     // GIR_Coverage, 2293,
     /*  24386 */     GIR_EraseRootFromParent_Done,
     /*  24387 */   // Label 401: @24387
     /*  24387 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24435), // Rule ID 13285 //
     /*  24392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24422 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24433 */     GIR_RootConstrainSelectedInstOperands,
     /*  24434 */     // GIR_Coverage, 13285,
     /*  24434 */     GIR_EraseRootFromParent_Done,
     /*  24435 */   // Label 402: @24435
     /*  24435 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24483), // Rule ID 13297 //
     /*  24440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24470 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 13297,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 403: @24483
     /*  24483 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24531), // Rule ID 988 //
     /*  24488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24518 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24529 */     GIR_RootConstrainSelectedInstOperands,
     /*  24530 */     // GIR_Coverage, 988,
     /*  24530 */     GIR_EraseRootFromParent_Done,
     /*  24531 */   // Label 404: @24531
     /*  24531 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24579), // Rule ID 1049 //
     /*  24536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24566 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24577 */     GIR_RootConstrainSelectedInstOperands,
     /*  24578 */     // GIR_Coverage, 1049,
     /*  24578 */     GIR_EraseRootFromParent_Done,
     /*  24579 */   // Label 405: @24579
     /*  24579 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24606), // Rule ID 1102 //
     /*  24584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24599 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24604 */     GIR_RootConstrainSelectedInstOperands,
     /*  24605 */     // GIR_Coverage, 1102,
     /*  24605 */     GIR_Done,
     /*  24606 */   // Label 406: @24606
     /*  24606 */   GIM_Reject,
     /*  24607 */ // Label 372: @24607
     /*  24607 */ GIM_Reject,
     /*  24608 */ // Label 158: @24608
     /*  24608 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(30785),
     /*  24613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24619 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24737), // Rule ID 13458 //
     /*  24624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24671 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24675 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24680 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24684 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24688 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24692 */     // MIs[4] Operand 1
     /*  24692 */     // No operand predicates
     /*  24692 */     // MIs[2] Operand 2
     /*  24692 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24707 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24716 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24735 */     GIR_RootConstrainSelectedInstOperands,
     /*  24736 */     // GIR_Coverage, 13458,
     /*  24736 */     GIR_EraseRootFromParent_Done,
     /*  24737 */   // Label 408: @24737
     /*  24737 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24855), // Rule ID 13459 //
     /*  24742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24785 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24793 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24802 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24806 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24810 */     // MIs[4] Operand 1
     /*  24810 */     // No operand predicates
     /*  24810 */     // MIs[2] Operand 2
     /*  24810 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24834 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24853 */     GIR_RootConstrainSelectedInstOperands,
     /*  24854 */     // GIR_Coverage, 13459,
     /*  24854 */     GIR_EraseRootFromParent_Done,
     /*  24855 */   // Label 409: @24855
     /*  24855 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24973), // Rule ID 13488 //
     /*  24860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24907 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24911 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24924 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24928 */     // MIs[4] Operand 1
     /*  24928 */     // No operand predicates
     /*  24928 */     // MIs[2] Operand 2
     /*  24928 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24943 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24945 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24952 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24971 */     GIR_RootConstrainSelectedInstOperands,
     /*  24972 */     // GIR_Coverage, 13488,
     /*  24972 */     GIR_EraseRootFromParent_Done,
     /*  24973 */   // Label 410: @24973
     /*  24973 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25091), // Rule ID 13489 //
     /*  24978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25029 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25034 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25038 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25042 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25046 */     // MIs[4] Operand 1
     /*  25046 */     // No operand predicates
     /*  25046 */     // MIs[2] Operand 2
     /*  25046 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25070 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25089 */     GIR_RootConstrainSelectedInstOperands,
     /*  25090 */     // GIR_Coverage, 13489,
     /*  25090 */     GIR_EraseRootFromParent_Done,
     /*  25091 */   // Label 411: @25091
     /*  25091 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(25209), // Rule ID 2039 //
     /*  25096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25151 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25156 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25160 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25164 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25168 */     // MIs[4] Operand 1
     /*  25168 */     // No operand predicates
     /*  25168 */     // MIs[2] Operand 2
     /*  25168 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25179 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25188 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25207 */     GIR_RootConstrainSelectedInstOperands,
     /*  25208 */     // GIR_Coverage, 2039,
     /*  25208 */     GIR_EraseRootFromParent_Done,
     /*  25209 */   // Label 412: @25209
     /*  25209 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25327), // Rule ID 13457 //
     /*  25214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25265 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25274 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25278 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25282 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25286 */     // MIs[4] Operand 1
     /*  25286 */     // No operand predicates
     /*  25286 */     // MIs[2] Operand 2
     /*  25286 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25297 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25306 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 13457,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 413: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25445), // Rule ID 2091 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25379 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25383 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25387 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25392 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25396 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25400 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25404 */     // MIs[4] Operand 1
     /*  25404 */     // No operand predicates
     /*  25404 */     // MIs[2] Operand 2
     /*  25404 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25415 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25424 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25443 */     GIR_RootConstrainSelectedInstOperands,
     /*  25444 */     // GIR_Coverage, 2091,
     /*  25444 */     GIR_EraseRootFromParent_Done,
     /*  25445 */   // Label 414: @25445
     /*  25445 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25563), // Rule ID 13487 //
     /*  25450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25497 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25501 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25505 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25510 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25514 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25518 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25522 */     // MIs[4] Operand 1
     /*  25522 */     // No operand predicates
     /*  25522 */     // MIs[2] Operand 2
     /*  25522 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25533 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25542 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25561 */     GIR_RootConstrainSelectedInstOperands,
     /*  25562 */     // GIR_Coverage, 13487,
     /*  25562 */     GIR_EraseRootFromParent_Done,
     /*  25563 */   // Label 415: @25563
     /*  25563 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25650), // Rule ID 13368 //
     /*  25568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25595 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25598 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25607 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25624 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25631 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25648 */     GIR_RootConstrainSelectedInstOperands,
     /*  25649 */     // GIR_Coverage, 13368,
     /*  25649 */     GIR_EraseRootFromParent_Done,
     /*  25650 */   // Label 416: @25650
     /*  25650 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25737), // Rule ID 13392 //
     /*  25655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25682 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25685 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25694 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25711 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25718 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25735 */     GIR_RootConstrainSelectedInstOperands,
     /*  25736 */     // GIR_Coverage, 13392,
     /*  25736 */     GIR_EraseRootFromParent_Done,
     /*  25737 */   // Label 417: @25737
     /*  25737 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25824), // Rule ID 1695 //
     /*  25742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25773 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25776 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25785 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25805 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25822 */     GIR_RootConstrainSelectedInstOperands,
     /*  25823 */     // GIR_Coverage, 1695,
     /*  25823 */     GIR_EraseRootFromParent_Done,
     /*  25824 */   // Label 418: @25824
     /*  25824 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25911), // Rule ID 1773 //
     /*  25829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25860 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25863 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25872 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25878 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25892 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25909 */     GIR_RootConstrainSelectedInstOperands,
     /*  25910 */     // GIR_Coverage, 1773,
     /*  25910 */     GIR_EraseRootFromParent_Done,
     /*  25911 */   // Label 419: @25911
     /*  25911 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(26026), // Rule ID 13453 //
     /*  25916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25963 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25967 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25980 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25984 */     // MIs[4] Operand 1
     /*  25984 */     // No operand predicates
     /*  25984 */     // MIs[2] Operand 2
     /*  25984 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26004 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26006 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26024 */     GIR_RootConstrainSelectedInstOperands,
     /*  26025 */     // GIR_Coverage, 13453,
     /*  26025 */     GIR_EraseRootFromParent_Done,
     /*  26026 */   // Label 420: @26026
     /*  26026 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(26141), // Rule ID 13452 //
     /*  26031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26079 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26083 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26087 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26096 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26100 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26104 */     // MIs[4] Operand 1
     /*  26104 */     // No operand predicates
     /*  26104 */     // MIs[2] Operand 2
     /*  26104 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26119 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26121 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26139 */     GIR_RootConstrainSelectedInstOperands,
     /*  26140 */     // GIR_Coverage, 13452,
     /*  26140 */     GIR_EraseRootFromParent_Done,
     /*  26141 */   // Label 421: @26141
     /*  26141 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26256), // Rule ID 13483 //
     /*  26146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26189 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26193 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26197 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26206 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26210 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26214 */     // MIs[4] Operand 1
     /*  26214 */     // No operand predicates
     /*  26214 */     // MIs[2] Operand 2
     /*  26214 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26234 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26236 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26254 */     GIR_RootConstrainSelectedInstOperands,
     /*  26255 */     // GIR_Coverage, 13483,
     /*  26255 */     GIR_EraseRootFromParent_Done,
     /*  26256 */   // Label 422: @26256
     /*  26256 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26371), // Rule ID 13482 //
     /*  26261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26309 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26317 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26330 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26334 */     // MIs[4] Operand 1
     /*  26334 */     // No operand predicates
     /*  26334 */     // MIs[2] Operand 2
     /*  26334 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26349 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26351 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26369 */     GIR_RootConstrainSelectedInstOperands,
     /*  26370 */     // GIR_Coverage, 13482,
     /*  26370 */     GIR_EraseRootFromParent_Done,
     /*  26371 */   // Label 423: @26371
     /*  26371 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26440), // Rule ID 1793 //
     /*  26376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26423 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26438 */     GIR_RootConstrainSelectedInstOperands,
     /*  26439 */     // GIR_Coverage, 1793,
     /*  26439 */     GIR_EraseRootFromParent_Done,
     /*  26440 */   // Label 424: @26440
     /*  26440 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26509), // Rule ID 1792 //
     /*  26445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26492 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26507 */     GIR_RootConstrainSelectedInstOperands,
     /*  26508 */     // GIR_Coverage, 1792,
     /*  26508 */     GIR_EraseRootFromParent_Done,
     /*  26509 */   // Label 425: @26509
     /*  26509 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26578), // Rule ID 1715 //
     /*  26514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26561 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26576 */     GIR_RootConstrainSelectedInstOperands,
     /*  26577 */     // GIR_Coverage, 1715,
     /*  26577 */     GIR_EraseRootFromParent_Done,
     /*  26578 */   // Label 426: @26578
     /*  26578 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26647), // Rule ID 1791 //
     /*  26583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26623 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26630 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26645 */     GIR_RootConstrainSelectedInstOperands,
     /*  26646 */     // GIR_Coverage, 1791,
     /*  26646 */     GIR_EraseRootFromParent_Done,
     /*  26647 */   // Label 427: @26647
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26716), // Rule ID 1790 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26699 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26714 */     GIR_RootConstrainSelectedInstOperands,
     /*  26715 */     // GIR_Coverage, 1790,
     /*  26715 */     GIR_EraseRootFromParent_Done,
     /*  26716 */   // Label 428: @26716
     /*  26716 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26831), // Rule ID 13451 //
     /*  26721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26768 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26772 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26776 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26781 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26785 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26789 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26793 */     // MIs[4] Operand 1
     /*  26793 */     // No operand predicates
     /*  26793 */     // MIs[2] Operand 2
     /*  26793 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26811 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26829 */     GIR_RootConstrainSelectedInstOperands,
     /*  26830 */     // GIR_Coverage, 13451,
     /*  26830 */     GIR_EraseRootFromParent_Done,
     /*  26831 */   // Label 429: @26831
     /*  26831 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26946), // Rule ID 2037 //
     /*  26836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26901 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26905 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26909 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26913 */     // MIs[4] Operand 1
     /*  26913 */     // No operand predicates
     /*  26913 */     // MIs[2] Operand 2
     /*  26913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26924 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26926 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26944 */     GIR_RootConstrainSelectedInstOperands,
     /*  26945 */     // GIR_Coverage, 2037,
     /*  26945 */     GIR_EraseRootFromParent_Done,
     /*  26946 */   // Label 430: @26946
     /*  26946 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(27061), // Rule ID 13481 //
     /*  26951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27006 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27015 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27019 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27023 */     // MIs[4] Operand 1
     /*  27023 */     // No operand predicates
     /*  27023 */     // MIs[2] Operand 2
     /*  27023 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27039 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27041 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27059 */     GIR_RootConstrainSelectedInstOperands,
     /*  27060 */     // GIR_Coverage, 13481,
     /*  27060 */     GIR_EraseRootFromParent_Done,
     /*  27061 */   // Label 431: @27061
     /*  27061 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(27176), // Rule ID 2089 //
     /*  27066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27118 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27122 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27126 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27139 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27143 */     // MIs[4] Operand 1
     /*  27143 */     // No operand predicates
     /*  27143 */     // MIs[2] Operand 2
     /*  27143 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27156 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27174 */     GIR_RootConstrainSelectedInstOperands,
     /*  27175 */     // GIR_Coverage, 2089,
     /*  27175 */     GIR_EraseRootFromParent_Done,
     /*  27176 */   // Label 432: @27176
     /*  27176 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27243), // Rule ID 13382 //
     /*  27181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27224 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27241 */     GIR_RootConstrainSelectedInstOperands,
     /*  27242 */     // GIR_Coverage, 13382,
     /*  27242 */     GIR_EraseRootFromParent_Done,
     /*  27243 */   // Label 433: @27243
     /*  27243 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27310), // Rule ID 13412 //
     /*  27248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27291 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27308 */     GIR_RootConstrainSelectedInstOperands,
     /*  27309 */     // GIR_Coverage, 13412,
     /*  27309 */     GIR_EraseRootFromParent_Done,
     /*  27310 */   // Label 434: @27310
     /*  27310 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27377), // Rule ID 1727 //
     /*  27315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27344 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27358 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27375 */     GIR_RootConstrainSelectedInstOperands,
     /*  27376 */     // GIR_Coverage, 1727,
     /*  27376 */     GIR_EraseRootFromParent_Done,
     /*  27377 */   // Label 435: @27377
     /*  27377 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27444), // Rule ID 1817 //
     /*  27382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27425 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27442 */     GIR_RootConstrainSelectedInstOperands,
     /*  27443 */     // GIR_Coverage, 1817,
     /*  27443 */     GIR_EraseRootFromParent_Done,
     /*  27444 */   // Label 436: @27444
     /*  27444 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27525), // Rule ID 13366 //
     /*  27449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27476 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27479 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27488 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27508 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27523 */     GIR_RootConstrainSelectedInstOperands,
     /*  27524 */     // GIR_Coverage, 13366,
     /*  27524 */     GIR_EraseRootFromParent_Done,
     /*  27525 */   // Label 437: @27525
     /*  27525 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27606), // Rule ID 13390 //
     /*  27530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27557 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27560 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27569 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27589 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27604 */     GIR_RootConstrainSelectedInstOperands,
     /*  27605 */     // GIR_Coverage, 13390,
     /*  27605 */     GIR_EraseRootFromParent_Done,
     /*  27606 */   // Label 438: @27606
     /*  27606 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27687), // Rule ID 1693 //
     /*  27611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27642 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27645 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27654 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27670 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27685 */     GIR_RootConstrainSelectedInstOperands,
     /*  27686 */     // GIR_Coverage, 1693,
     /*  27686 */     GIR_EraseRootFromParent_Done,
     /*  27687 */   // Label 439: @27687
     /*  27687 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27768), // Rule ID 1771 //
     /*  27692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27723 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27726 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27735 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27751 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27766 */     GIR_RootConstrainSelectedInstOperands,
     /*  27767 */     // GIR_Coverage, 1771,
     /*  27767 */     GIR_EraseRootFromParent_Done,
     /*  27768 */   // Label 440: @27768
     /*  27768 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27860), // Rule ID 13456 //
     /*  27773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27829 */     // MIs[3] Operand 1
     /*  27829 */     // No operand predicates
     /*  27829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27840 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27858 */     GIR_RootConstrainSelectedInstOperands,
     /*  27859 */     // GIR_Coverage, 13456,
     /*  27859 */     GIR_EraseRootFromParent_Done,
     /*  27860 */   // Label 441: @27860
     /*  27860 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27952), // Rule ID 13455 //
     /*  27865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27926 */     // MIs[3] Operand 1
     /*  27926 */     // No operand predicates
     /*  27926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27932 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27950 */     GIR_RootConstrainSelectedInstOperands,
     /*  27951 */     // GIR_Coverage, 13455,
     /*  27951 */     GIR_EraseRootFromParent_Done,
     /*  27952 */   // Label 442: @27952
     /*  27952 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(28044), // Rule ID 13486 //
     /*  27957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28013 */     // MIs[3] Operand 1
     /*  28013 */     // No operand predicates
     /*  28013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28024 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28042 */     GIR_RootConstrainSelectedInstOperands,
     /*  28043 */     // GIR_Coverage, 13486,
     /*  28043 */     GIR_EraseRootFromParent_Done,
     /*  28044 */   // Label 443: @28044
     /*  28044 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(28136), // Rule ID 13485 //
     /*  28049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28110 */     // MIs[3] Operand 1
     /*  28110 */     // No operand predicates
     /*  28110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28116 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28134 */     GIR_RootConstrainSelectedInstOperands,
     /*  28135 */     // GIR_Coverage, 13485,
     /*  28135 */     GIR_EraseRootFromParent_Done,
     /*  28136 */   // Label 444: @28136
     /*  28136 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28228), // Rule ID 13454 //
     /*  28141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28197 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28201 */     // MIs[3] Operand 1
     /*  28201 */     // No operand predicates
     /*  28201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28208 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28226 */     GIR_RootConstrainSelectedInstOperands,
     /*  28227 */     // GIR_Coverage, 13454,
     /*  28227 */     GIR_EraseRootFromParent_Done,
     /*  28228 */   // Label 445: @28228
     /*  28228 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28320), // Rule ID 2038 //
     /*  28233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28294 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28298 */     // MIs[3] Operand 1
     /*  28298 */     // No operand predicates
     /*  28298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28300 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28318 */     GIR_RootConstrainSelectedInstOperands,
     /*  28319 */     // GIR_Coverage, 2038,
     /*  28319 */     GIR_EraseRootFromParent_Done,
     /*  28320 */   // Label 446: @28320
     /*  28320 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28412), // Rule ID 13484 //
     /*  28325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28381 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28385 */     // MIs[3] Operand 1
     /*  28385 */     // No operand predicates
     /*  28385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28392 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28410 */     GIR_RootConstrainSelectedInstOperands,
     /*  28411 */     // GIR_Coverage, 13484,
     /*  28411 */     GIR_EraseRootFromParent_Done,
     /*  28412 */   // Label 447: @28412
     /*  28412 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28504), // Rule ID 2090 //
     /*  28417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28478 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28482 */     // MIs[3] Operand 1
     /*  28482 */     // No operand predicates
     /*  28482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28484 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28502 */     GIR_RootConstrainSelectedInstOperands,
     /*  28503 */     // GIR_Coverage, 2090,
     /*  28503 */     GIR_EraseRootFromParent_Done,
     /*  28504 */   // Label 448: @28504
     /*  28504 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28555), // Rule ID 13404 //
     /*  28509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28541 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28553 */     GIR_RootConstrainSelectedInstOperands,
     /*  28554 */     // GIR_Coverage, 13404,
     /*  28554 */     GIR_EraseRootFromParent_Done,
     /*  28555 */   // Label 449: @28555
     /*  28555 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28606), // Rule ID 13376 //
     /*  28560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28592 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28604 */     GIR_RootConstrainSelectedInstOperands,
     /*  28605 */     // GIR_Coverage, 13376,
     /*  28605 */     GIR_EraseRootFromParent_Done,
     /*  28606 */   // Label 450: @28606
     /*  28606 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28657), // Rule ID 13403 //
     /*  28611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28643 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28655 */     GIR_RootConstrainSelectedInstOperands,
     /*  28656 */     // GIR_Coverage, 13403,
     /*  28656 */     GIR_EraseRootFromParent_Done,
     /*  28657 */   // Label 451: @28657
     /*  28657 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28708), // Rule ID 1809 //
     /*  28662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28694 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28706 */     GIR_RootConstrainSelectedInstOperands,
     /*  28707 */     // GIR_Coverage, 1809,
     /*  28707 */     GIR_EraseRootFromParent_Done,
     /*  28708 */   // Label 452: @28708
     /*  28708 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28759), // Rule ID 1721 //
     /*  28713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28738 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28745 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28757 */     GIR_RootConstrainSelectedInstOperands,
     /*  28758 */     // GIR_Coverage, 1721,
     /*  28758 */     GIR_EraseRootFromParent_Done,
     /*  28759 */   // Label 453: @28759
     /*  28759 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28810), // Rule ID 1808 //
     /*  28764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28789 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28796 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28808 */     GIR_RootConstrainSelectedInstOperands,
     /*  28809 */     // GIR_Coverage, 1808,
     /*  28809 */     GIR_EraseRootFromParent_Done,
     /*  28810 */   // Label 454: @28810
     /*  28810 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28879), // Rule ID 13330 //
     /*  28815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28830 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28833 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28842 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28862 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28877 */     GIR_RootConstrainSelectedInstOperands,
     /*  28878 */     // GIR_Coverage, 13330,
     /*  28878 */     GIR_EraseRootFromParent_Done,
     /*  28879 */   // Label 455: @28879
     /*  28879 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28948), // Rule ID 13342 //
     /*  28884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28911 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28931 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28946 */     GIR_RootConstrainSelectedInstOperands,
     /*  28947 */     // GIR_Coverage, 13342,
     /*  28947 */     GIR_EraseRootFromParent_Done,
     /*  28948 */   // Label 456: @28948
     /*  28948 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(29004), // Rule ID 13292 //
     /*  28953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28968 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28971 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28991 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29002 */     GIR_RootConstrainSelectedInstOperands,
     /*  29003 */     // GIR_Coverage, 13292,
     /*  29003 */     GIR_EraseRootFromParent_Done,
     /*  29004 */   // Label 457: @29004
     /*  29004 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(29060), // Rule ID 13304 //
     /*  29009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29024 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29027 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29047 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29058 */     GIR_RootConstrainSelectedInstOperands,
     /*  29059 */     // GIR_Coverage, 13304,
     /*  29059 */     GIR_EraseRootFromParent_Done,
     /*  29060 */   // Label 458: @29060
     /*  29060 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29127), // Rule ID 13534 //
     /*  29065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29089 */     // MIs[1] imm
     /*  29089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29097 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29101 */     // MIs[2] Operand 1
     /*  29101 */     // No operand predicates
     /*  29101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29111 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29125 */     GIR_RootConstrainSelectedInstOperands,
     /*  29126 */     // GIR_Coverage, 13534,
     /*  29126 */     GIR_EraseRootFromParent_Done,
     /*  29127 */   // Label 459: @29127
     /*  29127 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29194), // Rule ID 13555 //
     /*  29132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29156 */     // MIs[1] imm
     /*  29156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29164 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29168 */     // MIs[2] Operand 1
     /*  29168 */     // No operand predicates
     /*  29168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29172 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29178 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29192 */     GIR_RootConstrainSelectedInstOperands,
     /*  29193 */     // GIR_Coverage, 13555,
     /*  29193 */     GIR_EraseRootFromParent_Done,
     /*  29194 */   // Label 460: @29194
     /*  29194 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29263), // Rule ID 1367 //
     /*  29199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29218 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29221 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29246 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29261 */     GIR_RootConstrainSelectedInstOperands,
     /*  29262 */     // GIR_Coverage, 1367,
     /*  29262 */     GIR_EraseRootFromParent_Done,
     /*  29263 */   // Label 461: @29263
     /*  29263 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29332), // Rule ID 1490 //
     /*  29268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29287 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29290 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29315 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29330 */     GIR_RootConstrainSelectedInstOperands,
     /*  29331 */     // GIR_Coverage, 1490,
     /*  29331 */     GIR_EraseRootFromParent_Done,
     /*  29332 */   // Label 462: @29332
     /*  29332 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29388), // Rule ID 995 //
     /*  29337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29356 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29359 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29375 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29386 */     GIR_RootConstrainSelectedInstOperands,
     /*  29387 */     // GIR_Coverage, 995,
     /*  29387 */     GIR_EraseRootFromParent_Done,
     /*  29388 */   // Label 463: @29388
     /*  29388 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29444), // Rule ID 1056 //
     /*  29393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29431 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29442 */     GIR_RootConstrainSelectedInstOperands,
     /*  29443 */     // GIR_Coverage, 1056,
     /*  29443 */     GIR_EraseRootFromParent_Done,
     /*  29444 */   // Label 464: @29444
     /*  29444 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29511), // Rule ID 2240 //
     /*  29449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29477 */     // MIs[1] imm
     /*  29477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29489 */     // MIs[2] Operand 1
     /*  29489 */     // No operand predicates
     /*  29489 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29495 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29509 */     GIR_RootConstrainSelectedInstOperands,
     /*  29510 */     // GIR_Coverage, 2240,
     /*  29510 */     GIR_EraseRootFromParent_Done,
     /*  29511 */   // Label 465: @29511
     /*  29511 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29578), // Rule ID 2299 //
     /*  29516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29544 */     // MIs[1] imm
     /*  29544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29556 */     // MIs[2] Operand 1
     /*  29556 */     // No operand predicates
     /*  29556 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29562 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29576 */     GIR_RootConstrainSelectedInstOperands,
     /*  29577 */     // GIR_Coverage, 2299,
     /*  29577 */     GIR_EraseRootFromParent_Done,
     /*  29578 */   // Label 466: @29578
     /*  29578 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29648), // Rule ID 6923 //
     /*  29583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29621 */     // MIs[2] Rn
     /*  29621 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29626 */     // MIs[2] Rm
     /*  29626 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29633 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29646 */     GIR_RootConstrainSelectedInstOperands,
     /*  29647 */     // GIR_Coverage, 6923,
     /*  29647 */     GIR_EraseRootFromParent_Done,
     /*  29648 */   // Label 467: @29648
     /*  29648 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29718), // Rule ID 13916 //
     /*  29653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29691 */     // MIs[2] Rn
     /*  29691 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29696 */     // MIs[2] Rm
     /*  29696 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29703 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29716 */     GIR_RootConstrainSelectedInstOperands,
     /*  29717 */     // GIR_Coverage, 13916,
     /*  29717 */     GIR_EraseRootFromParent_Done,
     /*  29718 */   // Label 468: @29718
     /*  29718 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29781), // Rule ID 1789 //
     /*  29723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29766 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29779 */     GIR_RootConstrainSelectedInstOperands,
     /*  29780 */     // GIR_Coverage, 1789,
     /*  29780 */     GIR_EraseRootFromParent_Done,
     /*  29781 */   // Label 469: @29781
     /*  29781 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29844), // Rule ID 1788 //
     /*  29786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29829 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29842 */     GIR_RootConstrainSelectedInstOperands,
     /*  29843 */     // GIR_Coverage, 1788,
     /*  29843 */     GIR_EraseRootFromParent_Done,
     /*  29844 */   // Label 470: @29844
     /*  29844 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29907), // Rule ID 1714 //
     /*  29849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29892 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29905 */     GIR_RootConstrainSelectedInstOperands,
     /*  29906 */     // GIR_Coverage, 1714,
     /*  29906 */     GIR_EraseRootFromParent_Done,
     /*  29907 */   // Label 471: @29907
     /*  29907 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29970), // Rule ID 1787 //
     /*  29912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29955 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29968 */     GIR_RootConstrainSelectedInstOperands,
     /*  29969 */     // GIR_Coverage, 1787,
     /*  29969 */     GIR_EraseRootFromParent_Done,
     /*  29970 */   // Label 472: @29970
     /*  29970 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(30033), // Rule ID 1786 //
     /*  29975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30018 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30031 */     GIR_RootConstrainSelectedInstOperands,
     /*  30032 */     // GIR_Coverage, 1786,
     /*  30032 */     GIR_EraseRootFromParent_Done,
     /*  30033 */   // Label 473: @30033
     /*  30033 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(30094), // Rule ID 13381 //
     /*  30038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30077 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30092 */     GIR_RootConstrainSelectedInstOperands,
     /*  30093 */     // GIR_Coverage, 13381,
     /*  30093 */     GIR_EraseRootFromParent_Done,
     /*  30094 */   // Label 474: @30094
     /*  30094 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30155), // Rule ID 13411 //
     /*  30099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30138 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30153 */     GIR_RootConstrainSelectedInstOperands,
     /*  30154 */     // GIR_Coverage, 13411,
     /*  30154 */     GIR_EraseRootFromParent_Done,
     /*  30155 */   // Label 475: @30155
     /*  30155 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30203), // Rule ID 13402 //
     /*  30160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30190 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30201 */     GIR_RootConstrainSelectedInstOperands,
     /*  30202 */     // GIR_Coverage, 13402,
     /*  30202 */     GIR_EraseRootFromParent_Done,
     /*  30203 */   // Label 476: @30203
     /*  30203 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30251), // Rule ID 13291 //
     /*  30208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30238 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30249 */     GIR_RootConstrainSelectedInstOperands,
     /*  30250 */     // GIR_Coverage, 13291,
     /*  30250 */     GIR_EraseRootFromParent_Done,
     /*  30251 */   // Label 477: @30251
     /*  30251 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30299), // Rule ID 13375 //
     /*  30256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30286 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30297 */     GIR_RootConstrainSelectedInstOperands,
     /*  30298 */     // GIR_Coverage, 13375,
     /*  30298 */     GIR_EraseRootFromParent_Done,
     /*  30299 */   // Label 478: @30299
     /*  30299 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30347), // Rule ID 13303 //
     /*  30304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30334 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30345 */     GIR_RootConstrainSelectedInstOperands,
     /*  30346 */     // GIR_Coverage, 13303,
     /*  30346 */     GIR_EraseRootFromParent_Done,
     /*  30347 */   // Label 479: @30347
     /*  30347 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30395), // Rule ID 13401 //
     /*  30352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30382 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30393 */     GIR_RootConstrainSelectedInstOperands,
     /*  30394 */     // GIR_Coverage, 13401,
     /*  30394 */     GIR_EraseRootFromParent_Done,
     /*  30395 */   // Label 480: @30395
     /*  30395 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30456), // Rule ID 1726 //
     /*  30400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30439 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30454 */     GIR_RootConstrainSelectedInstOperands,
     /*  30455 */     // GIR_Coverage, 1726,
     /*  30455 */     GIR_EraseRootFromParent_Done,
     /*  30456 */   // Label 481: @30456
     /*  30456 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30517), // Rule ID 1816 //
     /*  30461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30500 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30515 */     GIR_RootConstrainSelectedInstOperands,
     /*  30516 */     // GIR_Coverage, 1816,
     /*  30516 */     GIR_EraseRootFromParent_Done,
     /*  30517 */   // Label 482: @30517
     /*  30517 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30565), // Rule ID 1807 //
     /*  30522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30552 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30563 */     GIR_RootConstrainSelectedInstOperands,
     /*  30564 */     // GIR_Coverage, 1807,
     /*  30564 */     GIR_EraseRootFromParent_Done,
     /*  30565 */   // Label 483: @30565
     /*  30565 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30613), // Rule ID 994 //
     /*  30570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30600 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30611 */     GIR_RootConstrainSelectedInstOperands,
     /*  30612 */     // GIR_Coverage, 994,
     /*  30612 */     GIR_EraseRootFromParent_Done,
     /*  30613 */   // Label 484: @30613
     /*  30613 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30661), // Rule ID 1720 //
     /*  30618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30648 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30659 */     GIR_RootConstrainSelectedInstOperands,
     /*  30660 */     // GIR_Coverage, 1720,
     /*  30660 */     GIR_EraseRootFromParent_Done,
     /*  30661 */   // Label 485: @30661
     /*  30661 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30709), // Rule ID 1055 //
     /*  30666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30696 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30707 */     GIR_RootConstrainSelectedInstOperands,
     /*  30708 */     // GIR_Coverage, 1055,
     /*  30708 */     GIR_EraseRootFromParent_Done,
     /*  30709 */   // Label 486: @30709
     /*  30709 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30757), // Rule ID 1806 //
     /*  30714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30744 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30755 */     GIR_RootConstrainSelectedInstOperands,
     /*  30756 */     // GIR_Coverage, 1806,
     /*  30756 */     GIR_EraseRootFromParent_Done,
     /*  30757 */   // Label 487: @30757
     /*  30757 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30784), // Rule ID 1105 //
     /*  30762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30777 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30782 */     GIR_RootConstrainSelectedInstOperands,
     /*  30783 */     // GIR_Coverage, 1105,
     /*  30783 */     GIR_Done,
     /*  30784 */   // Label 488: @30784
     /*  30784 */   GIM_Reject,
     /*  30785 */ // Label 407: @30785
     /*  30785 */ GIM_Reject,
     /*  30786 */ // Label 159: @30786
     /*  30786 */ GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(31635),
     /*  30791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30797 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30930), // Rule ID 13921 //
     /*  30802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30847 */     // MIs[1] Operand 2
     /*  30847 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30858 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30862 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30866 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30870 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30874 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30878 */     // MIs[5] Rn
     /*  30878 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30883 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30885 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30929 */     // GIR_Coverage, 13921,
     /*  30929 */     GIR_EraseRootFromParent_Done,
     /*  30930 */   // Label 490: @30930
     /*  30930 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31063), // Rule ID 6928 //
     /*  30935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30976 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30980 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  30984 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  30988 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30992 */     // MIs[4] Rn
     /*  30992 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30997 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31001 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31005 */     // MIs[3] Operand 2
     /*  31005 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31016 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31018 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31045 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31062 */     // GIR_Coverage, 6928,
     /*  31062 */     GIR_EraseRootFromParent_Done,
     /*  31063 */   // Label 491: @31063
     /*  31063 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(31132), // Rule ID 13320 //
     /*  31068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31083 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31086 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31095 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31115 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31130 */     GIR_RootConstrainSelectedInstOperands,
     /*  31131 */     // GIR_Coverage, 13320,
     /*  31131 */     GIR_EraseRootFromParent_Done,
     /*  31132 */   // Label 492: @31132
     /*  31132 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31201), // Rule ID 13332 //
     /*  31137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31152 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31155 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31184 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31199 */     GIR_RootConstrainSelectedInstOperands,
     /*  31200 */     // GIR_Coverage, 13332,
     /*  31200 */     GIR_EraseRootFromParent_Done,
     /*  31201 */   // Label 493: @31201
     /*  31201 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31268), // Rule ID 13524 //
     /*  31206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31230 */     // MIs[1] imm
     /*  31230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31238 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31242 */     // MIs[2] Operand 1
     /*  31242 */     // No operand predicates
     /*  31242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31252 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31266 */     GIR_RootConstrainSelectedInstOperands,
     /*  31267 */     // GIR_Coverage, 13524,
     /*  31267 */     GIR_EraseRootFromParent_Done,
     /*  31268 */   // Label 494: @31268
     /*  31268 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31335), // Rule ID 13545 //
     /*  31273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31297 */     // MIs[1] imm
     /*  31297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31305 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31309 */     // MIs[2] Operand 1
     /*  31309 */     // No operand predicates
     /*  31309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31319 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31333 */     GIR_RootConstrainSelectedInstOperands,
     /*  31334 */     // GIR_Coverage, 13545,
     /*  31334 */     GIR_EraseRootFromParent_Done,
     /*  31335 */   // Label 495: @31335
     /*  31335 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31404), // Rule ID 1357 //
     /*  31340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31359 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31362 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31371 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31387 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31402 */     GIR_RootConstrainSelectedInstOperands,
     /*  31403 */     // GIR_Coverage, 1357,
     /*  31403 */     GIR_EraseRootFromParent_Done,
     /*  31404 */   // Label 496: @31404
     /*  31404 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31473), // Rule ID 1480 //
     /*  31409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31456 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31471 */     GIR_RootConstrainSelectedInstOperands,
     /*  31472 */     // GIR_Coverage, 1480,
     /*  31472 */     GIR_EraseRootFromParent_Done,
     /*  31473 */   // Label 497: @31473
     /*  31473 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31540), // Rule ID 2230 //
     /*  31478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31506 */     // MIs[1] imm
     /*  31506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31518 */     // MIs[2] Operand 1
     /*  31518 */     // No operand predicates
     /*  31518 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31524 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31538 */     GIR_RootConstrainSelectedInstOperands,
     /*  31539 */     // GIR_Coverage, 2230,
     /*  31539 */     GIR_EraseRootFromParent_Done,
     /*  31540 */   // Label 498: @31540
     /*  31540 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31607), // Rule ID 2289 //
     /*  31545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31573 */     // MIs[1] imm
     /*  31573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31585 */     // MIs[2] Operand 1
     /*  31585 */     // No operand predicates
     /*  31585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31591 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31605 */     GIR_RootConstrainSelectedInstOperands,
     /*  31606 */     // GIR_Coverage, 2289,
     /*  31606 */     GIR_EraseRootFromParent_Done,
     /*  31607 */   // Label 499: @31607
     /*  31607 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31634), // Rule ID 1100 //
     /*  31612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31627 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31632 */     GIR_RootConstrainSelectedInstOperands,
     /*  31633 */     // GIR_Coverage, 1100,
     /*  31633 */     GIR_Done,
     /*  31634 */   // Label 500: @31634
     /*  31634 */   GIM_Reject,
     /*  31635 */ // Label 489: @31635
     /*  31635 */ GIM_Reject,
     /*  31636 */ // Label 160: @31636
     /*  31636 */ GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(35213),
     /*  31641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31647 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31734), // Rule ID 13364 //
     /*  31652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31679 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31682 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31691 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31715 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31732 */     GIR_RootConstrainSelectedInstOperands,
     /*  31733 */     // GIR_Coverage, 13364,
     /*  31733 */     GIR_EraseRootFromParent_Done,
     /*  31734 */   // Label 502: @31734
     /*  31734 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31821), // Rule ID 13388 //
     /*  31739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31766 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31769 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31778 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31802 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31819 */     GIR_RootConstrainSelectedInstOperands,
     /*  31820 */     // GIR_Coverage, 13388,
     /*  31820 */     GIR_EraseRootFromParent_Done,
     /*  31821 */   // Label 503: @31821
     /*  31821 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31908), // Rule ID 1691 //
     /*  31826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31857 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31860 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31869 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31889 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31906 */     GIR_RootConstrainSelectedInstOperands,
     /*  31907 */     // GIR_Coverage, 1691,
     /*  31907 */     GIR_EraseRootFromParent_Done,
     /*  31908 */   // Label 504: @31908
     /*  31908 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31995), // Rule ID 1769 //
     /*  31913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31944 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31947 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31956 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31969 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31976 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31993 */     GIR_RootConstrainSelectedInstOperands,
     /*  31994 */     // GIR_Coverage, 1769,
     /*  31994 */     GIR_EraseRootFromParent_Done,
     /*  31995 */   // Label 505: @31995
     /*  31995 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(32064), // Rule ID 1785 //
     /*  32000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32047 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32062 */     GIR_RootConstrainSelectedInstOperands,
     /*  32063 */     // GIR_Coverage, 1785,
     /*  32063 */     GIR_EraseRootFromParent_Done,
     /*  32064 */   // Label 506: @32064
     /*  32064 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32133), // Rule ID 1784 //
     /*  32069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32109 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32116 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32131 */     GIR_RootConstrainSelectedInstOperands,
     /*  32132 */     // GIR_Coverage, 1784,
     /*  32132 */     GIR_EraseRootFromParent_Done,
     /*  32133 */   // Label 507: @32133
     /*  32133 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32202), // Rule ID 1713 //
     /*  32138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32171 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32178 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32185 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32200 */     GIR_RootConstrainSelectedInstOperands,
     /*  32201 */     // GIR_Coverage, 1713,
     /*  32201 */     GIR_EraseRootFromParent_Done,
     /*  32202 */   // Label 508: @32202
     /*  32202 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32271), // Rule ID 1783 //
     /*  32207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32254 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32269 */     GIR_RootConstrainSelectedInstOperands,
     /*  32270 */     // GIR_Coverage, 1783,
     /*  32270 */     GIR_EraseRootFromParent_Done,
     /*  32271 */   // Label 509: @32271
     /*  32271 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32340), // Rule ID 1782 //
     /*  32276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32316 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32323 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32338 */     GIR_RootConstrainSelectedInstOperands,
     /*  32339 */     // GIR_Coverage, 1782,
     /*  32339 */     GIR_EraseRootFromParent_Done,
     /*  32340 */   // Label 510: @32340
     /*  32340 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32407), // Rule ID 13380 //
     /*  32345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32381 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32388 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32405 */     GIR_RootConstrainSelectedInstOperands,
     /*  32406 */     // GIR_Coverage, 13380,
     /*  32406 */     GIR_EraseRootFromParent_Done,
     /*  32407 */   // Label 511: @32407
     /*  32407 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32474), // Rule ID 13410 //
     /*  32412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32448 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32455 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32472 */     GIR_RootConstrainSelectedInstOperands,
     /*  32473 */     // GIR_Coverage, 13410,
     /*  32473 */     GIR_EraseRootFromParent_Done,
     /*  32474 */   // Label 512: @32474
     /*  32474 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32541), // Rule ID 1725 //
     /*  32479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32522 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32539 */     GIR_RootConstrainSelectedInstOperands,
     /*  32540 */     // GIR_Coverage, 1725,
     /*  32540 */     GIR_EraseRootFromParent_Done,
     /*  32541 */   // Label 513: @32541
     /*  32541 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32608), // Rule ID 1815 //
     /*  32546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32589 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32606 */     GIR_RootConstrainSelectedInstOperands,
     /*  32607 */     // GIR_Coverage, 1815,
     /*  32607 */     GIR_EraseRootFromParent_Done,
     /*  32608 */   // Label 514: @32608
     /*  32608 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32689), // Rule ID 13362 //
     /*  32613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32640 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32643 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32652 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32672 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32687 */     GIR_RootConstrainSelectedInstOperands,
     /*  32688 */     // GIR_Coverage, 13362,
     /*  32688 */     GIR_EraseRootFromParent_Done,
     /*  32689 */   // Label 515: @32689
     /*  32689 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32770), // Rule ID 13386 //
     /*  32694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32721 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32724 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32733 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32753 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32768 */     GIR_RootConstrainSelectedInstOperands,
     /*  32769 */     // GIR_Coverage, 13386,
     /*  32769 */     GIR_EraseRootFromParent_Done,
     /*  32770 */   // Label 516: @32770
     /*  32770 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32851), // Rule ID 1689 //
     /*  32775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32806 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32809 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32818 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32834 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32849 */     GIR_RootConstrainSelectedInstOperands,
     /*  32850 */     // GIR_Coverage, 1689,
     /*  32850 */     GIR_EraseRootFromParent_Done,
     /*  32851 */   // Label 517: @32851
     /*  32851 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32932), // Rule ID 1767 //
     /*  32856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32887 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32890 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32895 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32899 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32915 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32930 */     GIR_RootConstrainSelectedInstOperands,
     /*  32931 */     // GIR_Coverage, 1767,
     /*  32931 */     GIR_EraseRootFromParent_Done,
     /*  32932 */   // Label 518: @32932
     /*  32932 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32983), // Rule ID 13400 //
     /*  32937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32969 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32981 */     GIR_RootConstrainSelectedInstOperands,
     /*  32982 */     // GIR_Coverage, 13400,
     /*  32982 */     GIR_EraseRootFromParent_Done,
     /*  32983 */   // Label 519: @32983
     /*  32983 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(33034), // Rule ID 13374 //
     /*  32988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33020 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33032 */     GIR_RootConstrainSelectedInstOperands,
     /*  33033 */     // GIR_Coverage, 13374,
     /*  33033 */     GIR_EraseRootFromParent_Done,
     /*  33034 */   // Label 520: @33034
     /*  33034 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(33085), // Rule ID 13399 //
     /*  33039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33071 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33083 */     GIR_RootConstrainSelectedInstOperands,
     /*  33084 */     // GIR_Coverage, 13399,
     /*  33084 */     GIR_EraseRootFromParent_Done,
     /*  33085 */   // Label 521: @33085
     /*  33085 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33136), // Rule ID 1805 //
     /*  33090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33122 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33134 */     GIR_RootConstrainSelectedInstOperands,
     /*  33135 */     // GIR_Coverage, 1805,
     /*  33135 */     GIR_EraseRootFromParent_Done,
     /*  33136 */   // Label 522: @33136
     /*  33136 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33187), // Rule ID 1719 //
     /*  33141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33173 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33185 */     GIR_RootConstrainSelectedInstOperands,
     /*  33186 */     // GIR_Coverage, 1719,
     /*  33186 */     GIR_EraseRootFromParent_Done,
     /*  33187 */   // Label 523: @33187
     /*  33187 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33238), // Rule ID 1804 //
     /*  33192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33224 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33236 */     GIR_RootConstrainSelectedInstOperands,
     /*  33237 */     // GIR_Coverage, 1804,
     /*  33237 */     GIR_EraseRootFromParent_Done,
     /*  33238 */   // Label 524: @33238
     /*  33238 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33307), // Rule ID 13326 //
     /*  33243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33258 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33261 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33270 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33290 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33305 */     GIR_RootConstrainSelectedInstOperands,
     /*  33306 */     // GIR_Coverage, 13326,
     /*  33306 */     GIR_EraseRootFromParent_Done,
     /*  33307 */   // Label 525: @33307
     /*  33307 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33376), // Rule ID 13338 //
     /*  33312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33327 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33330 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33359 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33374 */     GIR_RootConstrainSelectedInstOperands,
     /*  33375 */     // GIR_Coverage, 13338,
     /*  33375 */     GIR_EraseRootFromParent_Done,
     /*  33376 */   // Label 526: @33376
     /*  33376 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33432), // Rule ID 13288 //
     /*  33381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33396 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33399 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33419 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33430 */     GIR_RootConstrainSelectedInstOperands,
     /*  33431 */     // GIR_Coverage, 13288,
     /*  33431 */     GIR_EraseRootFromParent_Done,
     /*  33432 */   // Label 527: @33432
     /*  33432 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33488), // Rule ID 13300 //
     /*  33437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33475 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33486 */     GIR_RootConstrainSelectedInstOperands,
     /*  33487 */     // GIR_Coverage, 13300,
     /*  33487 */     GIR_EraseRootFromParent_Done,
     /*  33488 */   // Label 528: @33488
     /*  33488 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33555), // Rule ID 13530 //
     /*  33493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33517 */     // MIs[1] imm
     /*  33517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33529 */     // MIs[2] Operand 1
     /*  33529 */     // No operand predicates
     /*  33529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33539 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33553 */     GIR_RootConstrainSelectedInstOperands,
     /*  33554 */     // GIR_Coverage, 13530,
     /*  33554 */     GIR_EraseRootFromParent_Done,
     /*  33555 */   // Label 529: @33555
     /*  33555 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33622), // Rule ID 13551 //
     /*  33560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33584 */     // MIs[1] imm
     /*  33584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33596 */     // MIs[2] Operand 1
     /*  33596 */     // No operand predicates
     /*  33596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33606 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33620 */     GIR_RootConstrainSelectedInstOperands,
     /*  33621 */     // GIR_Coverage, 13551,
     /*  33621 */     GIR_EraseRootFromParent_Done,
     /*  33622 */   // Label 530: @33622
     /*  33622 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33691), // Rule ID 1363 //
     /*  33627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33646 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33649 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33658 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33674 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33689 */     GIR_RootConstrainSelectedInstOperands,
     /*  33690 */     // GIR_Coverage, 1363,
     /*  33690 */     GIR_EraseRootFromParent_Done,
     /*  33691 */   // Label 531: @33691
     /*  33691 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33760), // Rule ID 1486 //
     /*  33696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33715 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33718 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33727 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33743 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33758 */     GIR_RootConstrainSelectedInstOperands,
     /*  33759 */     // GIR_Coverage, 1486,
     /*  33759 */     GIR_EraseRootFromParent_Done,
     /*  33760 */   // Label 532: @33760
     /*  33760 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33816), // Rule ID 991 //
     /*  33765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33784 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33787 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33803 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33814 */     GIR_RootConstrainSelectedInstOperands,
     /*  33815 */     // GIR_Coverage, 991,
     /*  33815 */     GIR_EraseRootFromParent_Done,
     /*  33816 */   // Label 533: @33816
     /*  33816 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33872), // Rule ID 1052 //
     /*  33821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33840 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33843 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33859 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33870 */     GIR_RootConstrainSelectedInstOperands,
     /*  33871 */     // GIR_Coverage, 1052,
     /*  33871 */     GIR_EraseRootFromParent_Done,
     /*  33872 */   // Label 534: @33872
     /*  33872 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33939), // Rule ID 2236 //
     /*  33877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33905 */     // MIs[1] imm
     /*  33905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33913 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33917 */     // MIs[2] Operand 1
     /*  33917 */     // No operand predicates
     /*  33917 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33923 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33937 */     GIR_RootConstrainSelectedInstOperands,
     /*  33938 */     // GIR_Coverage, 2236,
     /*  33938 */     GIR_EraseRootFromParent_Done,
     /*  33939 */   // Label 535: @33939
     /*  33939 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(34006), // Rule ID 2295 //
     /*  33944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33972 */     // MIs[1] imm
     /*  33972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33980 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33984 */     // MIs[2] Operand 1
     /*  33984 */     // No operand predicates
     /*  33984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33990 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34004 */     GIR_RootConstrainSelectedInstOperands,
     /*  34005 */     // GIR_Coverage, 2295,
     /*  34005 */     GIR_EraseRootFromParent_Done,
     /*  34006 */   // Label 536: @34006
     /*  34006 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(34076), // Rule ID 6924 //
     /*  34011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34049 */     // MIs[2] Rn
     /*  34049 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34054 */     // MIs[2] Rm
     /*  34054 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34061 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34074 */     GIR_RootConstrainSelectedInstOperands,
     /*  34075 */     // GIR_Coverage, 6924,
     /*  34075 */     GIR_EraseRootFromParent_Done,
     /*  34076 */   // Label 537: @34076
     /*  34076 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34146), // Rule ID 13917 //
     /*  34081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34119 */     // MIs[2] Rn
     /*  34119 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34124 */     // MIs[2] Rm
     /*  34124 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34131 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34144 */     GIR_RootConstrainSelectedInstOperands,
     /*  34145 */     // GIR_Coverage, 13917,
     /*  34145 */     GIR_EraseRootFromParent_Done,
     /*  34146 */   // Label 538: @34146
     /*  34146 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34209), // Rule ID 1781 //
     /*  34151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34194 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34207 */     GIR_RootConstrainSelectedInstOperands,
     /*  34208 */     // GIR_Coverage, 1781,
     /*  34208 */     GIR_EraseRootFromParent_Done,
     /*  34209 */   // Label 539: @34209
     /*  34209 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34272), // Rule ID 1780 //
     /*  34214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34257 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34270 */     GIR_RootConstrainSelectedInstOperands,
     /*  34271 */     // GIR_Coverage, 1780,
     /*  34271 */     GIR_EraseRootFromParent_Done,
     /*  34272 */   // Label 540: @34272
     /*  34272 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34335), // Rule ID 1712 //
     /*  34277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34320 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34333 */     GIR_RootConstrainSelectedInstOperands,
     /*  34334 */     // GIR_Coverage, 1712,
     /*  34334 */     GIR_EraseRootFromParent_Done,
     /*  34335 */   // Label 541: @34335
     /*  34335 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34398), // Rule ID 1779 //
     /*  34340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34383 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34396 */     GIR_RootConstrainSelectedInstOperands,
     /*  34397 */     // GIR_Coverage, 1779,
     /*  34397 */     GIR_EraseRootFromParent_Done,
     /*  34398 */   // Label 542: @34398
     /*  34398 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34461), // Rule ID 1778 //
     /*  34403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34446 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34459 */     GIR_RootConstrainSelectedInstOperands,
     /*  34460 */     // GIR_Coverage, 1778,
     /*  34460 */     GIR_EraseRootFromParent_Done,
     /*  34461 */   // Label 543: @34461
     /*  34461 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34522), // Rule ID 13379 //
     /*  34466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34505 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34520 */     GIR_RootConstrainSelectedInstOperands,
     /*  34521 */     // GIR_Coverage, 13379,
     /*  34521 */     GIR_EraseRootFromParent_Done,
     /*  34522 */   // Label 544: @34522
     /*  34522 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34583), // Rule ID 13409 //
     /*  34527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34566 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34581 */     GIR_RootConstrainSelectedInstOperands,
     /*  34582 */     // GIR_Coverage, 13409,
     /*  34582 */     GIR_EraseRootFromParent_Done,
     /*  34583 */   // Label 545: @34583
     /*  34583 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34631), // Rule ID 13398 //
     /*  34588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34618 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34629 */     GIR_RootConstrainSelectedInstOperands,
     /*  34630 */     // GIR_Coverage, 13398,
     /*  34630 */     GIR_EraseRootFromParent_Done,
     /*  34631 */   // Label 546: @34631
     /*  34631 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34679), // Rule ID 13287 //
     /*  34636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34666 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34677 */     GIR_RootConstrainSelectedInstOperands,
     /*  34678 */     // GIR_Coverage, 13287,
     /*  34678 */     GIR_EraseRootFromParent_Done,
     /*  34679 */   // Label 547: @34679
     /*  34679 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34727), // Rule ID 13373 //
     /*  34684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34714 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34725 */     GIR_RootConstrainSelectedInstOperands,
     /*  34726 */     // GIR_Coverage, 13373,
     /*  34726 */     GIR_EraseRootFromParent_Done,
     /*  34727 */   // Label 548: @34727
     /*  34727 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34775), // Rule ID 13299 //
     /*  34732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34762 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34773 */     GIR_RootConstrainSelectedInstOperands,
     /*  34774 */     // GIR_Coverage, 13299,
     /*  34774 */     GIR_EraseRootFromParent_Done,
     /*  34775 */   // Label 549: @34775
     /*  34775 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34823), // Rule ID 13397 //
     /*  34780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34810 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34821 */     GIR_RootConstrainSelectedInstOperands,
     /*  34822 */     // GIR_Coverage, 13397,
     /*  34822 */     GIR_EraseRootFromParent_Done,
     /*  34823 */   // Label 550: @34823
     /*  34823 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34884), // Rule ID 1724 //
     /*  34828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34867 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34882 */     GIR_RootConstrainSelectedInstOperands,
     /*  34883 */     // GIR_Coverage, 1724,
     /*  34883 */     GIR_EraseRootFromParent_Done,
     /*  34884 */   // Label 551: @34884
     /*  34884 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34945), // Rule ID 1814 //
     /*  34889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34928 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34943 */     GIR_RootConstrainSelectedInstOperands,
     /*  34944 */     // GIR_Coverage, 1814,
     /*  34944 */     GIR_EraseRootFromParent_Done,
     /*  34945 */   // Label 552: @34945
     /*  34945 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34993), // Rule ID 1803 //
     /*  34950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34980 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  34987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34991 */     GIR_RootConstrainSelectedInstOperands,
     /*  34992 */     // GIR_Coverage, 1803,
     /*  34992 */     GIR_EraseRootFromParent_Done,
     /*  34993 */   // Label 553: @34993
     /*  34993 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(35041), // Rule ID 990 //
     /*  34998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35028 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35039 */     GIR_RootConstrainSelectedInstOperands,
     /*  35040 */     // GIR_Coverage, 990,
     /*  35040 */     GIR_EraseRootFromParent_Done,
     /*  35041 */   // Label 554: @35041
     /*  35041 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35089), // Rule ID 1718 //
     /*  35046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35076 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35087 */     GIR_RootConstrainSelectedInstOperands,
     /*  35088 */     // GIR_Coverage, 1718,
     /*  35088 */     GIR_EraseRootFromParent_Done,
     /*  35089 */   // Label 555: @35089
     /*  35089 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35137), // Rule ID 1051 //
     /*  35094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35124 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35135 */     GIR_RootConstrainSelectedInstOperands,
     /*  35136 */     // GIR_Coverage, 1051,
     /*  35136 */     GIR_EraseRootFromParent_Done,
     /*  35137 */   // Label 556: @35137
     /*  35137 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35185), // Rule ID 1802 //
     /*  35142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35172 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35183 */     GIR_RootConstrainSelectedInstOperands,
     /*  35184 */     // GIR_Coverage, 1802,
     /*  35184 */     GIR_EraseRootFromParent_Done,
     /*  35185 */   // Label 557: @35185
     /*  35185 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35212), // Rule ID 1103 //
     /*  35190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35205 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35210 */     GIR_RootConstrainSelectedInstOperands,
     /*  35211 */     // GIR_Coverage, 1103,
     /*  35211 */     GIR_Done,
     /*  35212 */   // Label 558: @35212
     /*  35212 */   GIM_Reject,
     /*  35213 */ // Label 501: @35213
     /*  35213 */ GIM_Reject,
     /*  35214 */ // Label 161: @35214
     /*  35214 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35937),
     /*  35219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35225 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35294), // Rule ID 13322 //
     /*  35230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35245 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35248 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35257 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35277 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35292 */     GIR_RootConstrainSelectedInstOperands,
     /*  35293 */     // GIR_Coverage, 13322,
     /*  35293 */     GIR_EraseRootFromParent_Done,
     /*  35294 */   // Label 560: @35294
     /*  35294 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35363), // Rule ID 13334 //
     /*  35299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35314 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35317 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35326 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35346 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35361 */     GIR_RootConstrainSelectedInstOperands,
     /*  35362 */     // GIR_Coverage, 13334,
     /*  35362 */     GIR_EraseRootFromParent_Done,
     /*  35363 */   // Label 561: @35363
     /*  35363 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35430), // Rule ID 13526 //
     /*  35368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35392 */     // MIs[1] imm
     /*  35392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35404 */     // MIs[2] Operand 1
     /*  35404 */     // No operand predicates
     /*  35404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35414 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35428 */     GIR_RootConstrainSelectedInstOperands,
     /*  35429 */     // GIR_Coverage, 13526,
     /*  35429 */     GIR_EraseRootFromParent_Done,
     /*  35430 */   // Label 562: @35430
     /*  35430 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35497), // Rule ID 13547 //
     /*  35435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35459 */     // MIs[1] imm
     /*  35459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35471 */     // MIs[2] Operand 1
     /*  35471 */     // No operand predicates
     /*  35471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35481 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35495 */     GIR_RootConstrainSelectedInstOperands,
     /*  35496 */     // GIR_Coverage, 13547,
     /*  35496 */     GIR_EraseRootFromParent_Done,
     /*  35497 */   // Label 563: @35497
     /*  35497 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35566), // Rule ID 1359 //
     /*  35502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35521 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35524 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35533 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35549 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35564 */     GIR_RootConstrainSelectedInstOperands,
     /*  35565 */     // GIR_Coverage, 1359,
     /*  35565 */     GIR_EraseRootFromParent_Done,
     /*  35566 */   // Label 564: @35566
     /*  35566 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35635), // Rule ID 1482 //
     /*  35571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35590 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35593 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35602 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35618 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35633 */     GIR_RootConstrainSelectedInstOperands,
     /*  35634 */     // GIR_Coverage, 1482,
     /*  35634 */     GIR_EraseRootFromParent_Done,
     /*  35635 */   // Label 565: @35635
     /*  35635 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35702), // Rule ID 2232 //
     /*  35640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35668 */     // MIs[1] imm
     /*  35668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35680 */     // MIs[2] Operand 1
     /*  35680 */     // No operand predicates
     /*  35680 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35686 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35700 */     GIR_RootConstrainSelectedInstOperands,
     /*  35701 */     // GIR_Coverage, 2232,
     /*  35701 */     GIR_EraseRootFromParent_Done,
     /*  35702 */   // Label 566: @35702
     /*  35702 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35769), // Rule ID 2291 //
     /*  35707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35735 */     // MIs[1] imm
     /*  35735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35747 */     // MIs[2] Operand 1
     /*  35747 */     // No operand predicates
     /*  35747 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35753 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35767 */     GIR_RootConstrainSelectedInstOperands,
     /*  35768 */     // GIR_Coverage, 2291,
     /*  35768 */     GIR_EraseRootFromParent_Done,
     /*  35769 */   // Label 567: @35769
     /*  35769 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35839), // Rule ID 6925 //
     /*  35774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35812 */     // MIs[2] Rn
     /*  35812 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35817 */     // MIs[2] Rm
     /*  35817 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35824 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35837 */     GIR_RootConstrainSelectedInstOperands,
     /*  35838 */     // GIR_Coverage, 6925,
     /*  35838 */     GIR_EraseRootFromParent_Done,
     /*  35839 */   // Label 568: @35839
     /*  35839 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35909), // Rule ID 13918 //
     /*  35844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35882 */     // MIs[2] Rn
     /*  35882 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35887 */     // MIs[2] Rm
     /*  35887 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35894 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35907 */     GIR_RootConstrainSelectedInstOperands,
     /*  35908 */     // GIR_Coverage, 13918,
     /*  35908 */     GIR_EraseRootFromParent_Done,
     /*  35909 */   // Label 569: @35909
     /*  35909 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35936), // Rule ID 1101 //
     /*  35914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35929 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35934 */     GIR_RootConstrainSelectedInstOperands,
     /*  35935 */     // GIR_Coverage, 1101,
     /*  35935 */     GIR_Done,
     /*  35936 */   // Label 570: @35936
     /*  35936 */   GIM_Reject,
     /*  35937 */ // Label 559: @35937
     /*  35937 */ GIM_Reject,
     /*  35938 */ // Label 162: @35938
     /*  35938 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(36309),
     /*  35943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35953 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(36015), // Rule ID 15102 //
     /*  35958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  35985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  35989 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36002 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36013 */     GIR_RootConstrainSelectedInstOperands,
     /*  36014 */     // GIR_Coverage, 15102,
     /*  36014 */     GIR_EraseRootFromParent_Done,
     /*  36015 */   // Label 572: @36015
     /*  36015 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36077), // Rule ID 15101 //
     /*  36020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36051 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36064 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36075 */     GIR_RootConstrainSelectedInstOperands,
     /*  36076 */     // GIR_Coverage, 15101,
     /*  36076 */     GIR_EraseRootFromParent_Done,
     /*  36077 */   // Label 573: @36077
     /*  36077 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36139), // Rule ID 15100 //
     /*  36082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36113 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36126 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36137 */     GIR_RootConstrainSelectedInstOperands,
     /*  36138 */     // GIR_Coverage, 15100,
     /*  36138 */     GIR_EraseRootFromParent_Done,
     /*  36139 */   // Label 574: @36139
     /*  36139 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36201), // Rule ID 8868 //
     /*  36144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36175 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36188 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36199 */     GIR_RootConstrainSelectedInstOperands,
     /*  36200 */     // GIR_Coverage, 8868,
     /*  36200 */     GIR_EraseRootFromParent_Done,
     /*  36201 */   // Label 575: @36201
     /*  36201 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36247), // Rule ID 15103 //
     /*  36206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36221 */     // MIs[1] Operand 2
     /*  36221 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36234 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36245 */     GIR_RootConstrainSelectedInstOperands,
     /*  36246 */     // GIR_Coverage, 15103,
     /*  36246 */     GIR_EraseRootFromParent_Done,
     /*  36247 */   // Label 576: @36247
     /*  36247 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36293), // Rule ID 8869 //
     /*  36252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36267 */     // MIs[1] Operand 2
     /*  36267 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36280 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36291 */     GIR_RootConstrainSelectedInstOperands,
     /*  36292 */     // GIR_Coverage, 8869,
     /*  36292 */     GIR_EraseRootFromParent_Done,
     /*  36293 */   // Label 577: @36293
     /*  36293 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36308), // Rule ID 2780 //
     /*  36298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36301 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36306 */     GIR_RootConstrainSelectedInstOperands,
     /*  36307 */     // GIR_Coverage, 2780,
     /*  36307 */     GIR_Done,
     /*  36308 */   // Label 578: @36308
     /*  36308 */   GIM_Reject,
     /*  36309 */ // Label 571: @36309
     /*  36309 */ GIM_Reject,
     /*  36310 */ // Label 163: @36310
     /*  36310 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36335), // Rule ID 2779 //
     /*  36315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36328 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36333 */   GIR_RootConstrainSelectedInstOperands,
     /*  36334 */   // GIR_Coverage, 2779,
     /*  36334 */   GIR_Done,
     /*  36335 */ // Label 579: @36335
     /*  36335 */ GIM_Reject,
     /*  36336 */ // Label 164: @36336
     /*  36336 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36361), // Rule ID 2778 //
     /*  36341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36354 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36359 */   GIR_RootConstrainSelectedInstOperands,
     /*  36360 */   // GIR_Coverage, 2778,
     /*  36360 */   GIR_Done,
     /*  36361 */ // Label 580: @36361
     /*  36361 */ GIM_Reject,
     /*  36362 */ // Label 165: @36362
     /*  36362 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36387), // Rule ID 2777 //
     /*  36367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36380 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36385 */   GIR_RootConstrainSelectedInstOperands,
     /*  36386 */   // GIR_Coverage, 2777,
     /*  36386 */   GIR_Done,
     /*  36387 */ // Label 581: @36387
     /*  36387 */ GIM_Reject,
     /*  36388 */ // Label 166: @36388
     /*  36388 */ GIM_Reject,
     /*  36389 */ // Label 1: @36389
     /*  36389 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 595*/ GIMT_Encode4(50616),
     /*  36400 */ /*GILLT_s32*//*Label 582*/ GIMT_Encode4(36488),
     /*  36404 */ /*GILLT_s64*//*Label 583*/ GIMT_Encode4(37970), GIMT_Encode4(0),
     /*  36412 */ /*GILLT_v2s32*//*Label 584*/ GIMT_Encode4(41252),
     /*  36416 */ /*GILLT_v2s64*//*Label 585*/ GIMT_Encode4(42743),
     /*  36420 */ /*GILLT_v4s16*//*Label 586*/ GIMT_Encode4(45203),
     /*  36424 */ /*GILLT_v4s32*//*Label 587*/ GIMT_Encode4(46694),
     /*  36428 */ /*GILLT_v8s8*//*Label 588*/ GIMT_Encode4(49154),
     /*  36432 */ /*GILLT_v8s16*//*Label 589*/ GIMT_Encode4(49229),
     /*  36436 */ /*GILLT_v16s8*//*Label 590*/ GIMT_Encode4(50437), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36456 */ /*GILLT_nxv2s64*//*Label 591*/ GIMT_Encode4(50512), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36468 */ /*GILLT_nxv4s32*//*Label 592*/ GIMT_Encode4(50538), GIMT_Encode4(0),
     /*  36476 */ /*GILLT_nxv8s16*//*Label 593*/ GIMT_Encode4(50564), GIMT_Encode4(0),
     /*  36484 */ /*GILLT_nxv16s8*//*Label 594*/ GIMT_Encode4(50590),
     /*  36488 */ // Label 582: @36488
     /*  36488 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(37969),
     /*  36493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36499 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(36651), // Rule ID 9915 //
     /*  36504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36535 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36538 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36543 */     // MIs[2] pattern
     /*  36543 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36546 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36553 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36579 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36582 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36586 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36616 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36650 */     // GIR_Coverage, 9915,
     /*  36650 */     GIR_EraseRootFromParent_Done,
     /*  36651 */   // Label 597: @36651
     /*  36651 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(36803), // Rule ID 9927 //
     /*  36656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36687 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36690 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36695 */     // MIs[2] pattern
     /*  36695 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36698 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36705 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36705 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36708 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36712 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36719 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36722 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36726 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36731 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36734 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36738 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36741 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36746 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36768 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36802 */     // GIR_Coverage, 9927,
     /*  36802 */     GIR_EraseRootFromParent_Done,
     /*  36803 */   // Label 598: @36803
     /*  36803 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36955), // Rule ID 9939 //
     /*  36808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36839 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36842 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36847 */     // MIs[2] pattern
     /*  36847 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36850 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36857 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36857 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36860 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36864 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36883 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36886 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36890 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36923 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36937 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36954 */     // GIR_Coverage, 9939,
     /*  36954 */     GIR_EraseRootFromParent_Done,
     /*  36955 */   // Label 599: @36955
     /*  36955 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(37107), // Rule ID 9951 //
     /*  36960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  36999 */     // MIs[2] pattern
     /*  36999 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37002 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37009 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37009 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37012 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37016 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37035 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37038 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37042 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37045 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37050 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37055 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37072 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37089 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37106 */     // GIR_Coverage, 9951,
     /*  37106 */     GIR_EraseRootFromParent_Done,
     /*  37107 */   // Label 600: @37107
     /*  37107 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(37169), // Rule ID 3953 //
     /*  37112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37148 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37167 */     GIR_RootConstrainSelectedInstOperands,
     /*  37168 */     // GIR_Coverage, 3953,
     /*  37168 */     GIR_EraseRootFromParent_Done,
     /*  37169 */   // Label 601: @37169
     /*  37169 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(37326), // Rule ID 10053 //
     /*  37174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37205 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37208 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37224 */     // MIs[2] pred
     /*  37224 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37231 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37231 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37234 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37238 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37257 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37260 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37264 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37272 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37298 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37308 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37325 */     // GIR_Coverage, 10053,
     /*  37325 */     GIR_EraseRootFromParent_Done,
     /*  37326 */   // Label 602: @37326
     /*  37326 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(37483), // Rule ID 10054 //
     /*  37331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37362 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37365 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37381 */     // MIs[2] pred
     /*  37381 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37388 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37414 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37421 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37451 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37482 */     // GIR_Coverage, 10054,
     /*  37482 */     GIR_EraseRootFromParent_Done,
     /*  37483 */   // Label 603: @37483
     /*  37483 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(37640), // Rule ID 10055 //
     /*  37488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37519 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37522 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37531 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37538 */     // MIs[2] pred
     /*  37538 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37545 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37571 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37612 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37622 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37639 */     // GIR_Coverage, 10055,
     /*  37639 */     GIR_EraseRootFromParent_Done,
     /*  37640 */   // Label 604: @37640
     /*  37640 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37797), // Rule ID 10056 //
     /*  37645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37676 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37679 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37688 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37695 */     // MIs[2] pred
     /*  37695 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37702 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37702 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37705 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37709 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37716 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37719 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37723 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37728 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37731 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37735 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37738 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37743 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37748 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37769 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37779 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37796 */     // GIR_Coverage, 10056,
     /*  37796 */     GIR_EraseRootFromParent_Done,
     /*  37797 */   // Label 605: @37797
     /*  37797 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37833), // Rule ID 3918 //
     /*  37802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37817 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37822 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37831 */     GIR_RootConstrainSelectedInstOperands,
     /*  37832 */     // GIR_Coverage, 3918,
     /*  37832 */     GIR_EraseRootFromParent_Done,
     /*  37833 */   // Label 606: @37833
     /*  37833 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37866), // Rule ID 3923 //
     /*  37838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37853 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37860 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37864 */     GIR_RootConstrainSelectedInstOperands,
     /*  37865 */     // GIR_Coverage, 3923,
     /*  37865 */     GIR_EraseRootFromParent_Done,
     /*  37866 */   // Label 607: @37866
     /*  37866 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37902), // Rule ID 3912 //
     /*  37871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37886 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37900 */     GIR_RootConstrainSelectedInstOperands,
     /*  37901 */     // GIR_Coverage, 3912,
     /*  37901 */     GIR_EraseRootFromParent_Done,
     /*  37902 */   // Label 608: @37902
     /*  37902 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37938), // Rule ID 3916 //
     /*  37907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37922 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37936 */     GIR_RootConstrainSelectedInstOperands,
     /*  37937 */     // GIR_Coverage, 3916,
     /*  37937 */     GIR_EraseRootFromParent_Done,
     /*  37938 */   // Label 609: @37938
     /*  37938 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37968), // Rule ID 3914 //
     /*  37943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37955 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37960 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37966 */     GIR_RootConstrainSelectedInstOperands,
     /*  37967 */     // GIR_Coverage, 3914,
     /*  37967 */     GIR_Done,
     /*  37968 */   // Label 610: @37968
     /*  37968 */   GIM_Reject,
     /*  37969 */ // Label 596: @37969
     /*  37969 */ GIM_Reject,
     /*  37970 */ // Label 583: @37970
     /*  37970 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(41251),
     /*  37975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37981 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(38117), // Rule ID 5401 //
     /*  37986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38019 */     // MIs[1] Operand 2
     /*  38019 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38046 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38050 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38054 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38059 */     // MIs[3] Operand 2
     /*  38059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38070 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38072 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38099 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38116 */     // GIR_Coverage, 5401,
     /*  38116 */     GIR_EraseRootFromParent_Done,
     /*  38117 */   // Label 612: @38117
     /*  38117 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(38253), // Rule ID 5400 //
     /*  38122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38155 */     // MIs[1] Operand 2
     /*  38155 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38178 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38182 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38186 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38190 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38195 */     // MIs[3] Operand 2
     /*  38195 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38206 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38208 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38235 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38252 */     // GIR_Coverage, 5400,
     /*  38252 */     GIR_EraseRootFromParent_Done,
     /*  38253 */   // Label 613: @38253
     /*  38253 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38389), // Rule ID 5410 //
     /*  38258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38291 */     // MIs[1] Operand 2
     /*  38291 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38310 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38314 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38318 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38322 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38326 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38331 */     // MIs[3] Operand 2
     /*  38331 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38342 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38344 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38371 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38388 */     // GIR_Coverage, 5410,
     /*  38388 */     GIR_EraseRootFromParent_Done,
     /*  38389 */   // Label 614: @38389
     /*  38389 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38525), // Rule ID 5399 //
     /*  38394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38427 */     // MIs[1] Operand 2
     /*  38427 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38450 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38454 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38458 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38462 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38467 */     // MIs[3] Operand 2
     /*  38467 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38480 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38496 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38507 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38524 */     // GIR_Coverage, 5399,
     /*  38524 */     GIR_EraseRootFromParent_Done,
     /*  38525 */   // Label 615: @38525
     /*  38525 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38661), // Rule ID 5398 //
     /*  38530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38563 */     // MIs[1] Operand 2
     /*  38563 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38590 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38594 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38598 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38603 */     // MIs[3] Operand 2
     /*  38603 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38616 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38643 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38660 */     // GIR_Coverage, 5398,
     /*  38660 */     GIR_EraseRootFromParent_Done,
     /*  38661 */   // Label 616: @38661
     /*  38661 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38798), // Rule ID 3970 //
     /*  38666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38707 */     // MIs[2] Operand 2
     /*  38707 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38726 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38730 */     // MIs[3] Operand 1
     /*  38730 */     // No operand predicates
     /*  38730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38732 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38744 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38763 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38796 */     GIR_RootConstrainSelectedInstOperands,
     /*  38797 */     // GIR_Coverage, 3970,
     /*  38797 */     GIR_EraseRootFromParent_Done,
     /*  38798 */   // Label 617: @38798
     /*  38798 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38897), // Rule ID 3968 //
     /*  38803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38852 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38856 */     // MIs[3] Operand 1
     /*  38856 */     // No operand predicates
     /*  38856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38858 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38870 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38895 */     GIR_RootConstrainSelectedInstOperands,
     /*  38896 */     // GIR_Coverage, 3968,
     /*  38896 */     GIR_EraseRootFromParent_Done,
     /*  38897 */   // Label 618: @38897
     /*  38897 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38996), // Rule ID 3969 //
     /*  38902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38951 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38955 */     // MIs[3] Operand 1
     /*  38955 */     // No operand predicates
     /*  38955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38957 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38969 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38994 */     GIR_RootConstrainSelectedInstOperands,
     /*  38995 */     // GIR_Coverage, 3969,
     /*  38995 */     GIR_EraseRootFromParent_Done,
     /*  38996 */   // Label 619: @38996
     /*  38996 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(39082), // Rule ID 3963 //
     /*  39001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39061 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39080 */     GIR_RootConstrainSelectedInstOperands,
     /*  39081 */     // GIR_Coverage, 3963,
     /*  39081 */     GIR_EraseRootFromParent_Done,
     /*  39082 */   // Label 620: @39082
     /*  39082 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(39168), // Rule ID 3964 //
     /*  39087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39140 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39145 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39147 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39166 */     GIR_RootConstrainSelectedInstOperands,
     /*  39167 */     // GIR_Coverage, 3964,
     /*  39167 */     GIR_EraseRootFromParent_Done,
     /*  39168 */   // Label 621: @39168
     /*  39168 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39301), // Rule ID 3976 //
     /*  39173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39214 */     // MIs[2] Operand 2
     /*  39214 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39225 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39229 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39233 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39237 */     // MIs[3] Operand 1
     /*  39237 */     // No operand predicates
     /*  39237 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39239 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39251 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39270 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39299 */     GIR_RootConstrainSelectedInstOperands,
     /*  39300 */     // GIR_Coverage, 3976,
     /*  39300 */     GIR_EraseRootFromParent_Done,
     /*  39301 */   // Label 622: @39301
     /*  39301 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39396), // Rule ID 3974 //
     /*  39306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39355 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39359 */     // MIs[3] Operand 1
     /*  39359 */     // No operand predicates
     /*  39359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39361 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39373 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39394 */     GIR_RootConstrainSelectedInstOperands,
     /*  39395 */     // GIR_Coverage, 3974,
     /*  39395 */     GIR_EraseRootFromParent_Done,
     /*  39396 */   // Label 623: @39396
     /*  39396 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39491), // Rule ID 3975 //
     /*  39401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39450 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39454 */     // MIs[3] Operand 1
     /*  39454 */     // No operand predicates
     /*  39454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39456 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39468 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39489 */     GIR_RootConstrainSelectedInstOperands,
     /*  39490 */     // GIR_Coverage, 3975,
     /*  39490 */     GIR_EraseRootFromParent_Done,
     /*  39491 */   // Label 624: @39491
     /*  39491 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39573), // Rule ID 124 //
     /*  39496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39545 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39549 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39556 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39571 */     GIR_RootConstrainSelectedInstOperands,
     /*  39572 */     // GIR_Coverage, 124,
     /*  39572 */     GIR_EraseRootFromParent_Done,
     /*  39573 */   // Label 625: @39573
     /*  39573 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39655), // Rule ID 126 //
     /*  39578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39627 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39631 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39638 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39653 */     GIR_RootConstrainSelectedInstOperands,
     /*  39654 */     // GIR_Coverage, 126,
     /*  39654 */     GIR_EraseRootFromParent_Done,
     /*  39655 */   // Label 626: @39655
     /*  39655 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39717), // Rule ID 3954 //
     /*  39660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39696 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39715 */     GIR_RootConstrainSelectedInstOperands,
     /*  39716 */     // GIR_Coverage, 3954,
     /*  39716 */     GIR_EraseRootFromParent_Done,
     /*  39717 */   // Label 627: @39717
     /*  39717 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39775), // Rule ID 9912 //
     /*  39722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39741 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39744 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39749 */     // MIs[1] pattern
     /*  39749 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39752 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39759 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39773 */     GIR_RootConstrainSelectedInstOperands,
     /*  39774 */     // GIR_Coverage, 9912,
     /*  39774 */     GIR_EraseRootFromParent_Done,
     /*  39775 */   // Label 628: @39775
     /*  39775 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39833), // Rule ID 9924 //
     /*  39780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39799 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39802 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39807 */     // MIs[1] pattern
     /*  39807 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39810 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39817 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39831 */     GIR_RootConstrainSelectedInstOperands,
     /*  39832 */     // GIR_Coverage, 9924,
     /*  39832 */     GIR_EraseRootFromParent_Done,
     /*  39833 */   // Label 629: @39833
     /*  39833 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39891), // Rule ID 9936 //
     /*  39838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39857 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39860 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39865 */     // MIs[1] pattern
     /*  39865 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39868 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39875 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39889 */     GIR_RootConstrainSelectedInstOperands,
     /*  39890 */     // GIR_Coverage, 9936,
     /*  39890 */     GIR_EraseRootFromParent_Done,
     /*  39891 */   // Label 630: @39891
     /*  39891 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39949), // Rule ID 9948 //
     /*  39896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39923 */     // MIs[1] pattern
     /*  39923 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39926 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39933 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39947 */     GIR_RootConstrainSelectedInstOperands,
     /*  39948 */     // GIR_Coverage, 9948,
     /*  39948 */     GIR_EraseRootFromParent_Done,
     /*  39949 */   // Label 631: @39949
     /*  39949 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(40112), // Rule ID 5365 //
     /*  39954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40000 */     // MIs[1] Operand 2
     /*  40000 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40013 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40013 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40016 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40020 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40039 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40042 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40046 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40076 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40094 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40111 */     // GIR_Coverage, 5365,
     /*  40111 */     GIR_EraseRootFromParent_Done,
     /*  40112 */   // Label 632: @40112
     /*  40112 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(40275), // Rule ID 5362 //
     /*  40117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40163 */     // MIs[1] Operand 2
     /*  40163 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40176 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40176 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40179 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40183 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40190 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40193 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40197 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40202 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40205 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40209 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40222 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40239 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40274 */     // GIR_Coverage, 5362,
     /*  40274 */     GIR_EraseRootFromParent_Done,
     /*  40275 */   // Label 633: @40275
     /*  40275 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40425), // Rule ID 5407 //
     /*  40280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40317 */     // MIs[1] Operand 2
     /*  40317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40330 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40356 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40363 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40407 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40424 */     // GIR_Coverage, 5407,
     /*  40424 */     GIR_EraseRootFromParent_Done,
     /*  40425 */   // Label 634: @40425
     /*  40425 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40575), // Rule ID 5413 //
     /*  40430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40467 */     // MIs[1] Operand 2
     /*  40467 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40480 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40480 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40483 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40487 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40506 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40509 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40513 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40557 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40574 */     // GIR_Coverage, 5413,
     /*  40574 */     GIR_EraseRootFromParent_Done,
     /*  40575 */   // Label 635: @40575
     /*  40575 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40725), // Rule ID 5406 //
     /*  40580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40617 */     // MIs[1] Operand 2
     /*  40617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40630 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40656 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40663 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40671 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40676 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40693 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40707 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40724 */     // GIR_Coverage, 5406,
     /*  40724 */     GIR_EraseRootFromParent_Done,
     /*  40725 */   // Label 636: @40725
     /*  40725 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40761), // Rule ID 3919 //
     /*  40730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40745 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40750 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40752 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40759 */     GIR_RootConstrainSelectedInstOperands,
     /*  40760 */     // GIR_Coverage, 3919,
     /*  40760 */     GIR_EraseRootFromParent_Done,
     /*  40761 */   // Label 637: @40761
     /*  40761 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40794), // Rule ID 3924 //
     /*  40766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40781 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40788 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40792 */     GIR_RootConstrainSelectedInstOperands,
     /*  40793 */     // GIR_Coverage, 3924,
     /*  40793 */     GIR_EraseRootFromParent_Done,
     /*  40794 */   // Label 638: @40794
     /*  40794 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40830), // Rule ID 3913 //
     /*  40799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40814 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40828 */     GIR_RootConstrainSelectedInstOperands,
     /*  40829 */     // GIR_Coverage, 3913,
     /*  40829 */     GIR_EraseRootFromParent_Done,
     /*  40830 */   // Label 639: @40830
     /*  40830 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40866), // Rule ID 3917 //
     /*  40835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40850 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40857 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40864 */     GIR_RootConstrainSelectedInstOperands,
     /*  40865 */     // GIR_Coverage, 3917,
     /*  40865 */     GIR_EraseRootFromParent_Done,
     /*  40866 */   // Label 640: @40866
     /*  40866 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40929), // Rule ID 10045 //
     /*  40871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40890 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40893 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40909 */     // MIs[1] pred
     /*  40909 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40916 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40927 */     GIR_RootConstrainSelectedInstOperands,
     /*  40928 */     // GIR_Coverage, 10045,
     /*  40928 */     GIR_EraseRootFromParent_Done,
     /*  40929 */   // Label 641: @40929
     /*  40929 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40992), // Rule ID 10046 //
     /*  40934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40953 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40956 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40965 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40972 */     // MIs[1] pred
     /*  40972 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40979 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40990 */     GIR_RootConstrainSelectedInstOperands,
     /*  40991 */     // GIR_Coverage, 10046,
     /*  40991 */     GIR_EraseRootFromParent_Done,
     /*  40992 */   // Label 642: @40992
     /*  40992 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(41055), // Rule ID 10047 //
     /*  40997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41016 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41019 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41035 */     // MIs[1] pred
     /*  41035 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41042 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41053 */     GIR_RootConstrainSelectedInstOperands,
     /*  41054 */     // GIR_Coverage, 10047,
     /*  41054 */     GIR_EraseRootFromParent_Done,
     /*  41055 */   // Label 643: @41055
     /*  41055 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41118), // Rule ID 10048 //
     /*  41060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41079 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41082 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41098 */     // MIs[1] pred
     /*  41098 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41105 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41116 */     GIR_RootConstrainSelectedInstOperands,
     /*  41117 */     // GIR_Coverage, 10048,
     /*  41117 */     GIR_EraseRootFromParent_Done,
     /*  41118 */   // Label 644: @41118
     /*  41118 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41157), // Rule ID 1655 //
     /*  41123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41134 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41140 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41148 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41155 */     GIR_RootConstrainSelectedInstOperands,
     /*  41156 */     // GIR_Coverage, 1655,
     /*  41156 */     GIR_EraseRootFromParent_Done,
     /*  41157 */   // Label 645: @41157
     /*  41157 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41193), // Rule ID 5248 //
     /*  41162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41170 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41176 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41184 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41191 */     GIR_RootConstrainSelectedInstOperands,
     /*  41192 */     // GIR_Coverage, 5248,
     /*  41192 */     GIR_EraseRootFromParent_Done,
     /*  41193 */   // Label 646: @41193
     /*  41193 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41220), // Rule ID 1644 //
     /*  41198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41213 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41218 */     GIR_RootConstrainSelectedInstOperands,
     /*  41219 */     // GIR_Coverage, 1644,
     /*  41219 */     GIR_Done,
     /*  41220 */   // Label 647: @41220
     /*  41220 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41250), // Rule ID 3915 //
     /*  41225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41237 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41242 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41248 */     GIR_RootConstrainSelectedInstOperands,
     /*  41249 */     // GIR_Coverage, 3915,
     /*  41249 */     GIR_Done,
     /*  41250 */   // Label 648: @41250
     /*  41250 */   GIM_Reject,
     /*  41251 */ // Label 611: @41251
     /*  41251 */ GIM_Reject,
     /*  41252 */ // Label 584: @41252
     /*  41252 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(42742),
     /*  41257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41267 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41399), // Rule ID 5397 //
     /*  41272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41301 */     // MIs[1] Operand 2
     /*  41301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41324 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41328 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41332 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41336 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41341 */     // MIs[3] Operand 2
     /*  41341 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41352 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41354 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41398 */     // GIR_Coverage, 5397,
     /*  41398 */     GIR_EraseRootFromParent_Done,
     /*  41399 */   // Label 650: @41399
     /*  41399 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41531), // Rule ID 5396 //
     /*  41404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41433 */     // MIs[1] Operand 2
     /*  41433 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41464 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41468 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41473 */     // MIs[3] Operand 2
     /*  41473 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41484 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41486 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41530 */     // GIR_Coverage, 5396,
     /*  41530 */     GIR_EraseRootFromParent_Done,
     /*  41531 */   // Label 651: @41531
     /*  41531 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41663), // Rule ID 5409 //
     /*  41536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41565 */     // MIs[1] Operand 2
     /*  41565 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41596 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41600 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41605 */     // MIs[3] Operand 2
     /*  41605 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41616 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41618 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41645 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41662 */     // GIR_Coverage, 5409,
     /*  41662 */     GIR_EraseRootFromParent_Done,
     /*  41663 */   // Label 652: @41663
     /*  41663 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41795), // Rule ID 5395 //
     /*  41668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41697 */     // MIs[1] Operand 2
     /*  41697 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41728 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41732 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41737 */     // MIs[3] Operand 2
     /*  41737 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41750 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41777 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41794 */     // GIR_Coverage, 5395,
     /*  41794 */     GIR_EraseRootFromParent_Done,
     /*  41795 */   // Label 653: @41795
     /*  41795 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41927), // Rule ID 5394 //
     /*  41800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41829 */     // MIs[1] Operand 2
     /*  41829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41860 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41864 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41869 */     // MIs[3] Operand 2
     /*  41869 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41882 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41926 */     // GIR_Coverage, 5394,
     /*  41926 */     GIR_EraseRootFromParent_Done,
     /*  41927 */   // Label 654: @41927
     /*  41927 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(42086), // Rule ID 5364 //
     /*  41932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41974 */     // MIs[1] Operand 2
     /*  41974 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41987 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41987 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  41990 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41994 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42013 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42016 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42020 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42028 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42033 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42050 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42068 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42085 */     // GIR_Coverage, 5364,
     /*  42085 */     GIR_EraseRootFromParent_Done,
     /*  42086 */   // Label 655: @42086
     /*  42086 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(42245), // Rule ID 5361 //
     /*  42091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42133 */     // MIs[1] Operand 2
     /*  42133 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42146 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42146 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42149 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42153 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42160 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42163 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42167 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42172 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42179 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42182 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42187 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42192 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42209 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42244 */     // GIR_Coverage, 5361,
     /*  42244 */     GIR_EraseRootFromParent_Done,
     /*  42245 */   // Label 656: @42245
     /*  42245 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42391), // Rule ID 5405 //
     /*  42250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42283 */     // MIs[1] Operand 2
     /*  42283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42296 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42296 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42299 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42303 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42322 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42325 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42329 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42332 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42337 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42359 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42373 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42390 */     // GIR_Coverage, 5405,
     /*  42390 */     GIR_EraseRootFromParent_Done,
     /*  42391 */   // Label 657: @42391
     /*  42391 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42537), // Rule ID 5412 //
     /*  42396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42429 */     // MIs[1] Operand 2
     /*  42429 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42442 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42442 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42445 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42449 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42456 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42459 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42463 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42468 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42471 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42475 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42478 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42483 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42505 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42519 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42536 */     // GIR_Coverage, 5412,
     /*  42536 */     GIR_EraseRootFromParent_Done,
     /*  42537 */   // Label 658: @42537
     /*  42537 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42683), // Rule ID 5404 //
     /*  42542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42575 */     // MIs[1] Operand 2
     /*  42575 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42588 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42588 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42591 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42595 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42602 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42605 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42609 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42614 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42617 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42621 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42624 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42682 */     // GIR_Coverage, 5404,
     /*  42682 */     GIR_EraseRootFromParent_Done,
     /*  42683 */   // Label 659: @42683
     /*  42683 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42718), // Rule ID 969 //
     /*  42688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42695 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42701 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42709 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42716 */     GIR_RootConstrainSelectedInstOperands,
     /*  42717 */     // GIR_Coverage, 969,
     /*  42717 */     GIR_EraseRootFromParent_Done,
     /*  42718 */   // Label 660: @42718
     /*  42718 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42741), // Rule ID 1476 //
     /*  42723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42734 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42739 */     GIR_RootConstrainSelectedInstOperands,
     /*  42740 */     // GIR_Coverage, 1476,
     /*  42740 */     GIR_Done,
     /*  42741 */   // Label 661: @42741
     /*  42741 */   GIM_Reject,
     /*  42742 */ // Label 649: @42742
     /*  42742 */ GIM_Reject,
     /*  42743 */ // Label 585: @42743
     /*  42743 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(45202),
     /*  42748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42758 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42872), // Rule ID 2048 //
     /*  42763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42810 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42814 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42827 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42831 */     // MIs[4] Operand 1
     /*  42831 */     // No operand predicates
     /*  42831 */     // MIs[2] Operand 2
     /*  42831 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42842 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42851 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42870 */     GIR_RootConstrainSelectedInstOperands,
     /*  42871 */     // GIR_Coverage, 2048,
     /*  42871 */     GIR_EraseRootFromParent_Done,
     /*  42872 */   // Label 663: @42872
     /*  42872 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(42986), // Rule ID 13474 //
     /*  42877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42928 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42933 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42937 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42941 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42945 */     // MIs[4] Operand 1
     /*  42945 */     // No operand predicates
     /*  42945 */     // MIs[2] Operand 2
     /*  42945 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42956 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42965 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42984 */     GIR_RootConstrainSelectedInstOperands,
     /*  42985 */     // GIR_Coverage, 13474,
     /*  42985 */     GIR_EraseRootFromParent_Done,
     /*  42986 */   // Label 664: @42986
     /*  42986 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(43100), // Rule ID 2100 //
     /*  42991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43038 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43042 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43047 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43051 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43055 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43059 */     // MIs[4] Operand 1
     /*  43059 */     // No operand predicates
     /*  43059 */     // MIs[2] Operand 2
     /*  43059 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43070 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43079 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43098 */     GIR_RootConstrainSelectedInstOperands,
     /*  43099 */     // GIR_Coverage, 2100,
     /*  43099 */     GIR_EraseRootFromParent_Done,
     /*  43100 */   // Label 665: @43100
     /*  43100 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(43214), // Rule ID 13504 //
     /*  43105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43161 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43165 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43169 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43173 */     // MIs[4] Operand 1
     /*  43173 */     // No operand predicates
     /*  43173 */     // MIs[2] Operand 2
     /*  43173 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43184 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43212 */     GIR_RootConstrainSelectedInstOperands,
     /*  43213 */     // GIR_Coverage, 13504,
     /*  43213 */     GIR_EraseRootFromParent_Done,
     /*  43214 */   // Label 666: @43214
     /*  43214 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43279), // Rule ID 1855 //
     /*  43219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43255 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43262 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43277 */     GIR_RootConstrainSelectedInstOperands,
     /*  43278 */     // GIR_Coverage, 1855,
     /*  43278 */     GIR_EraseRootFromParent_Done,
     /*  43279 */   // Label 667: @43279
     /*  43279 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43344), // Rule ID 1854 //
     /*  43284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43327 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43342 */     GIR_RootConstrainSelectedInstOperands,
     /*  43343 */     // GIR_Coverage, 1854,
     /*  43343 */     GIR_EraseRootFromParent_Done,
     /*  43344 */   // Label 668: @43344
     /*  43344 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43409), // Rule ID 1759 //
     /*  43349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43392 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43407 */     GIR_RootConstrainSelectedInstOperands,
     /*  43408 */     // GIR_Coverage, 1759,
     /*  43408 */     GIR_EraseRootFromParent_Done,
     /*  43409 */   // Label 669: @43409
     /*  43409 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43474), // Rule ID 1853 //
     /*  43414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43457 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43472 */     GIR_RootConstrainSelectedInstOperands,
     /*  43473 */     // GIR_Coverage, 1853,
     /*  43473 */     GIR_EraseRootFromParent_Done,
     /*  43474 */   // Label 670: @43474
     /*  43474 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43539), // Rule ID 1852 //
     /*  43479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43522 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43537 */     GIR_RootConstrainSelectedInstOperands,
     /*  43538 */     // GIR_Coverage, 1852,
     /*  43538 */     GIR_EraseRootFromParent_Done,
     /*  43539 */   // Label 671: @43539
     /*  43539 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43650), // Rule ID 13472 //
     /*  43544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43608 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43612 */     // MIs[4] Operand 1
     /*  43612 */     // No operand predicates
     /*  43612 */     // MIs[2] Operand 2
     /*  43612 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43628 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43630 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43648 */     GIR_RootConstrainSelectedInstOperands,
     /*  43649 */     // GIR_Coverage, 13472,
     /*  43649 */     GIR_EraseRootFromParent_Done,
     /*  43650 */   // Label 672: @43650
     /*  43650 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43761), // Rule ID 2046 //
     /*  43655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43703 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43707 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43720 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43724 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43728 */     // MIs[4] Operand 1
     /*  43728 */     // No operand predicates
     /*  43728 */     // MIs[2] Operand 2
     /*  43728 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43741 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43759 */     GIR_RootConstrainSelectedInstOperands,
     /*  43760 */     // GIR_Coverage, 2046,
     /*  43760 */     GIR_EraseRootFromParent_Done,
     /*  43761 */   // Label 673: @43761
     /*  43761 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43872), // Rule ID 13502 //
     /*  43766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43809 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43813 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43817 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43826 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43830 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43834 */     // MIs[4] Operand 1
     /*  43834 */     // No operand predicates
     /*  43834 */     // MIs[2] Operand 2
     /*  43834 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43852 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43870 */     GIR_RootConstrainSelectedInstOperands,
     /*  43871 */     // GIR_Coverage, 13502,
     /*  43871 */     GIR_EraseRootFromParent_Done,
     /*  43872 */   // Label 674: @43872
     /*  43872 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43983), // Rule ID 2098 //
     /*  43877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43950 */     // MIs[4] Operand 1
     /*  43950 */     // No operand predicates
     /*  43950 */     // MIs[2] Operand 2
     /*  43950 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43961 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43963 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43981 */     GIR_RootConstrainSelectedInstOperands,
     /*  43982 */     // GIR_Coverage, 2098,
     /*  43982 */     GIR_EraseRootFromParent_Done,
     /*  43983 */   // Label 675: @43983
     /*  43983 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(44046), // Rule ID 1735 //
     /*  43988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44027 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44044 */     GIR_RootConstrainSelectedInstOperands,
     /*  44045 */     // GIR_Coverage, 1735,
     /*  44045 */     GIR_EraseRootFromParent_Done,
     /*  44046 */   // Label 676: @44046
     /*  44046 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(44109), // Rule ID 1825 //
     /*  44051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44083 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44090 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44107 */     GIR_RootConstrainSelectedInstOperands,
     /*  44108 */     // GIR_Coverage, 1825,
     /*  44108 */     GIR_EraseRootFromParent_Done,
     /*  44109 */   // Label 677: @44109
     /*  44109 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44197), // Rule ID 13473 //
     /*  44114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44166 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44170 */     // MIs[3] Operand 1
     /*  44170 */     // No operand predicates
     /*  44170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44177 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44195 */     GIR_RootConstrainSelectedInstOperands,
     /*  44196 */     // GIR_Coverage, 13473,
     /*  44196 */     GIR_EraseRootFromParent_Done,
     /*  44197 */   // Label 678: @44197
     /*  44197 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44285), // Rule ID 2047 //
     /*  44202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44259 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44263 */     // MIs[3] Operand 1
     /*  44263 */     // No operand predicates
     /*  44263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44265 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44283 */     GIR_RootConstrainSelectedInstOperands,
     /*  44284 */     // GIR_Coverage, 2047,
     /*  44284 */     GIR_EraseRootFromParent_Done,
     /*  44285 */   // Label 679: @44285
     /*  44285 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44373), // Rule ID 13503 //
     /*  44290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44342 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44346 */     // MIs[3] Operand 1
     /*  44346 */     // No operand predicates
     /*  44346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44353 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44371 */     GIR_RootConstrainSelectedInstOperands,
     /*  44372 */     // GIR_Coverage, 13503,
     /*  44372 */     GIR_EraseRootFromParent_Done,
     /*  44373 */   // Label 680: @44373
     /*  44373 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44461), // Rule ID 2099 //
     /*  44378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44435 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44439 */     // MIs[3] Operand 1
     /*  44439 */     // No operand predicates
     /*  44439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44441 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44459 */     GIR_RootConstrainSelectedInstOperands,
     /*  44460 */     // GIR_Coverage, 2099,
     /*  44460 */     GIR_EraseRootFromParent_Done,
     /*  44461 */   // Label 681: @44461
     /*  44461 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44508), // Rule ID 1867 //
     /*  44466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44494 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44506 */     GIR_RootConstrainSelectedInstOperands,
     /*  44507 */     // GIR_Coverage, 1867,
     /*  44507 */     GIR_EraseRootFromParent_Done,
     /*  44508 */   // Label 682: @44508
     /*  44508 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44555), // Rule ID 1765 //
     /*  44513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44541 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44553 */     GIR_RootConstrainSelectedInstOperands,
     /*  44554 */     // GIR_Coverage, 1765,
     /*  44554 */     GIR_EraseRootFromParent_Done,
     /*  44555 */   // Label 683: @44555
     /*  44555 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44602), // Rule ID 1866 //
     /*  44560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44588 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44600 */     GIR_RootConstrainSelectedInstOperands,
     /*  44601 */     // GIR_Coverage, 1866,
     /*  44601 */     GIR_EraseRootFromParent_Done,
     /*  44602 */   // Label 684: @44602
     /*  44602 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44661), // Rule ID 1851 //
     /*  44607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44646 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44659 */     GIR_RootConstrainSelectedInstOperands,
     /*  44660 */     // GIR_Coverage, 1851,
     /*  44660 */     GIR_EraseRootFromParent_Done,
     /*  44661 */   // Label 685: @44661
     /*  44661 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44720), // Rule ID 1850 //
     /*  44666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44705 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44718 */     GIR_RootConstrainSelectedInstOperands,
     /*  44719 */     // GIR_Coverage, 1850,
     /*  44719 */     GIR_EraseRootFromParent_Done,
     /*  44720 */   // Label 686: @44720
     /*  44720 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44779), // Rule ID 1758 //
     /*  44725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44764 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44777 */     GIR_RootConstrainSelectedInstOperands,
     /*  44778 */     // GIR_Coverage, 1758,
     /*  44778 */     GIR_EraseRootFromParent_Done,
     /*  44779 */   // Label 687: @44779
     /*  44779 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44838), // Rule ID 1849 //
     /*  44784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44823 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44836 */     GIR_RootConstrainSelectedInstOperands,
     /*  44837 */     // GIR_Coverage, 1849,
     /*  44837 */     GIR_EraseRootFromParent_Done,
     /*  44838 */   // Label 688: @44838
     /*  44838 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44897), // Rule ID 1848 //
     /*  44843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44882 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44895 */     GIR_RootConstrainSelectedInstOperands,
     /*  44896 */     // GIR_Coverage, 1848,
     /*  44896 */     GIR_EraseRootFromParent_Done,
     /*  44897 */   // Label 689: @44897
     /*  44897 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44932), // Rule ID 971 //
     /*  44902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44909 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44915 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44923 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44930 */     GIR_RootConstrainSelectedInstOperands,
     /*  44931 */     // GIR_Coverage, 971,
     /*  44931 */     GIR_EraseRootFromParent_Done,
     /*  44932 */   // Label 690: @44932
     /*  44932 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44989), // Rule ID 1734 //
     /*  44937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44972 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  44987 */     GIR_RootConstrainSelectedInstOperands,
     /*  44988 */     // GIR_Coverage, 1734,
     /*  44988 */     GIR_EraseRootFromParent_Done,
     /*  44989 */   // Label 691: @44989
     /*  44989 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(45046), // Rule ID 1824 //
     /*  44994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45029 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45044 */     GIR_RootConstrainSelectedInstOperands,
     /*  45045 */     // GIR_Coverage, 1824,
     /*  45045 */     GIR_EraseRootFromParent_Done,
     /*  45046 */   // Label 692: @45046
     /*  45046 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45090), // Rule ID 1865 //
     /*  45051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45077 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45088 */     GIR_RootConstrainSelectedInstOperands,
     /*  45089 */     // GIR_Coverage, 1865,
     /*  45089 */     GIR_EraseRootFromParent_Done,
     /*  45090 */   // Label 693: @45090
     /*  45090 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45134), // Rule ID 1764 //
     /*  45095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45121 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45132 */     GIR_RootConstrainSelectedInstOperands,
     /*  45133 */     // GIR_Coverage, 1764,
     /*  45133 */     GIR_EraseRootFromParent_Done,
     /*  45134 */   // Label 694: @45134
     /*  45134 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45178), // Rule ID 1864 //
     /*  45139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45165 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45176 */     GIR_RootConstrainSelectedInstOperands,
     /*  45177 */     // GIR_Coverage, 1864,
     /*  45177 */     GIR_EraseRootFromParent_Done,
     /*  45178 */   // Label 695: @45178
     /*  45178 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45201), // Rule ID 1478 //
     /*  45183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45194 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45199 */     GIR_RootConstrainSelectedInstOperands,
     /*  45200 */     // GIR_Coverage, 1478,
     /*  45200 */     GIR_Done,
     /*  45201 */   // Label 696: @45201
     /*  45201 */   GIM_Reject,
     /*  45202 */ // Label 662: @45202
     /*  45202 */ GIM_Reject,
     /*  45203 */ // Label 586: @45203
     /*  45203 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(46693),
     /*  45208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45218 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45350), // Rule ID 5393 //
     /*  45223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45252 */     // MIs[1] Operand 2
     /*  45252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45271 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45275 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45279 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45283 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45287 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45292 */     // MIs[3] Operand 2
     /*  45292 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45305 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45332 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45349 */     // GIR_Coverage, 5393,
     /*  45349 */     GIR_EraseRootFromParent_Done,
     /*  45350 */   // Label 698: @45350
     /*  45350 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45482), // Rule ID 5392 //
     /*  45355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45384 */     // MIs[1] Operand 2
     /*  45384 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45403 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45415 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45419 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45424 */     // MIs[3] Operand 2
     /*  45424 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45437 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45449 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45481 */     // GIR_Coverage, 5392,
     /*  45481 */     GIR_EraseRootFromParent_Done,
     /*  45482 */   // Label 699: @45482
     /*  45482 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45614), // Rule ID 5408 //
     /*  45487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45516 */     // MIs[1] Operand 2
     /*  45516 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45535 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45539 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45543 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45547 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45551 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45556 */     // MIs[3] Operand 2
     /*  45556 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45567 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45569 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45581 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45585 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45596 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45613 */     // GIR_Coverage, 5408,
     /*  45613 */     GIR_EraseRootFromParent_Done,
     /*  45614 */   // Label 700: @45614
     /*  45614 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45746), // Rule ID 5391 //
     /*  45619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45648 */     // MIs[1] Operand 2
     /*  45648 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45671 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45675 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45679 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45683 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45688 */     // MIs[3] Operand 2
     /*  45688 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45701 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45745 */     // GIR_Coverage, 5391,
     /*  45745 */     GIR_EraseRootFromParent_Done,
     /*  45746 */   // Label 701: @45746
     /*  45746 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45878), // Rule ID 5390 //
     /*  45751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45780 */     // MIs[1] Operand 2
     /*  45780 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45799 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45811 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45815 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45820 */     // MIs[3] Operand 2
     /*  45820 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45833 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45877 */     // GIR_Coverage, 5390,
     /*  45877 */     GIR_EraseRootFromParent_Done,
     /*  45878 */   // Label 702: @45878
     /*  45878 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(46037), // Rule ID 5363 //
     /*  45883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45925 */     // MIs[1] Operand 2
     /*  45925 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45938 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45938 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45941 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45945 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45964 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45971 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  45996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46001 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46004 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46019 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46036 */     // GIR_Coverage, 5363,
     /*  46036 */     GIR_EraseRootFromParent_Done,
     /*  46037 */   // Label 703: @46037
     /*  46037 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(46196), // Rule ID 5360 //
     /*  46042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46084 */     // MIs[1] Operand 2
     /*  46084 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46097 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46097 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46100 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46104 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46123 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46130 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46138 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46160 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46178 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46195 */     // GIR_Coverage, 5360,
     /*  46195 */     GIR_EraseRootFromParent_Done,
     /*  46196 */   // Label 704: @46196
     /*  46196 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46342), // Rule ID 5403 //
     /*  46201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46234 */     // MIs[1] Operand 2
     /*  46234 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46247 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46313 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46324 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46341 */     // GIR_Coverage, 5403,
     /*  46341 */     GIR_EraseRootFromParent_Done,
     /*  46342 */   // Label 705: @46342
     /*  46342 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46488), // Rule ID 5411 //
     /*  46347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46380 */     // MIs[1] Operand 2
     /*  46380 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46393 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46393 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46396 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46400 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46407 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46410 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46414 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46419 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46426 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46456 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46470 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46487 */     // GIR_Coverage, 5411,
     /*  46487 */     GIR_EraseRootFromParent_Done,
     /*  46488 */   // Label 706: @46488
     /*  46488 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46634), // Rule ID 5402 //
     /*  46493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46526 */     // MIs[1] Operand 2
     /*  46526 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46539 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46539 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46542 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46546 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46565 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46568 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46572 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46575 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46580 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46602 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46616 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46633 */     // GIR_Coverage, 5402,
     /*  46633 */     GIR_EraseRootFromParent_Done,
     /*  46634 */   // Label 707: @46634
     /*  46634 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46669), // Rule ID 967 //
     /*  46639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46646 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46652 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46660 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46667 */     GIR_RootConstrainSelectedInstOperands,
     /*  46668 */     // GIR_Coverage, 967,
     /*  46668 */     GIR_EraseRootFromParent_Done,
     /*  46669 */   // Label 708: @46669
     /*  46669 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46692), // Rule ID 1474 //
     /*  46674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46685 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46690 */     GIR_RootConstrainSelectedInstOperands,
     /*  46691 */     // GIR_Coverage, 1474,
     /*  46691 */     GIR_Done,
     /*  46692 */   // Label 709: @46692
     /*  46692 */   GIM_Reject,
     /*  46693 */ // Label 697: @46693
     /*  46693 */ GIM_Reject,
     /*  46694 */ // Label 587: @46694
     /*  46694 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(49153),
     /*  46699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46709 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46823), // Rule ID 2045 //
     /*  46714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46757 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46761 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46765 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46770 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46774 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46778 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46782 */     // MIs[4] Operand 1
     /*  46782 */     // No operand predicates
     /*  46782 */     // MIs[2] Operand 2
     /*  46782 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46793 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46795 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46802 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46821 */     GIR_RootConstrainSelectedInstOperands,
     /*  46822 */     // GIR_Coverage, 2045,
     /*  46822 */     GIR_EraseRootFromParent_Done,
     /*  46823 */   // Label 711: @46823
     /*  46823 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(46937), // Rule ID 13471 //
     /*  46828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46871 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46875 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46879 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46884 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46888 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46892 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46896 */     // MIs[4] Operand 1
     /*  46896 */     // No operand predicates
     /*  46896 */     // MIs[2] Operand 2
     /*  46896 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46907 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46916 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46935 */     GIR_RootConstrainSelectedInstOperands,
     /*  46936 */     // GIR_Coverage, 13471,
     /*  46936 */     GIR_EraseRootFromParent_Done,
     /*  46937 */   // Label 712: @46937
     /*  46937 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(47051), // Rule ID 2097 //
     /*  46942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46989 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47006 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47010 */     // MIs[4] Operand 1
     /*  47010 */     // No operand predicates
     /*  47010 */     // MIs[2] Operand 2
     /*  47010 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47021 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47030 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47049 */     GIR_RootConstrainSelectedInstOperands,
     /*  47050 */     // GIR_Coverage, 2097,
     /*  47050 */     GIR_EraseRootFromParent_Done,
     /*  47051 */   // Label 713: @47051
     /*  47051 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(47165), // Rule ID 13501 //
     /*  47056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47120 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47124 */     // MIs[4] Operand 1
     /*  47124 */     // No operand predicates
     /*  47124 */     // MIs[2] Operand 2
     /*  47124 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47163 */     GIR_RootConstrainSelectedInstOperands,
     /*  47164 */     // GIR_Coverage, 13501,
     /*  47164 */     GIR_EraseRootFromParent_Done,
     /*  47165 */   // Label 714: @47165
     /*  47165 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(47230), // Rule ID 1847 //
     /*  47170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47213 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47228 */     GIR_RootConstrainSelectedInstOperands,
     /*  47229 */     // GIR_Coverage, 1847,
     /*  47229 */     GIR_EraseRootFromParent_Done,
     /*  47230 */   // Label 715: @47230
     /*  47230 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47295), // Rule ID 1846 //
     /*  47235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47278 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47293 */     GIR_RootConstrainSelectedInstOperands,
     /*  47294 */     // GIR_Coverage, 1846,
     /*  47294 */     GIR_EraseRootFromParent_Done,
     /*  47295 */   // Label 716: @47295
     /*  47295 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47360), // Rule ID 1757 //
     /*  47300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47343 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47358 */     GIR_RootConstrainSelectedInstOperands,
     /*  47359 */     // GIR_Coverage, 1757,
     /*  47359 */     GIR_EraseRootFromParent_Done,
     /*  47360 */   // Label 717: @47360
     /*  47360 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47425), // Rule ID 1845 //
     /*  47365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47408 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47423 */     GIR_RootConstrainSelectedInstOperands,
     /*  47424 */     // GIR_Coverage, 1845,
     /*  47424 */     GIR_EraseRootFromParent_Done,
     /*  47425 */   // Label 718: @47425
     /*  47425 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47490), // Rule ID 1844 //
     /*  47430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47473 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47488 */     GIR_RootConstrainSelectedInstOperands,
     /*  47489 */     // GIR_Coverage, 1844,
     /*  47489 */     GIR_EraseRootFromParent_Done,
     /*  47490 */   // Label 719: @47490
     /*  47490 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47601), // Rule ID 13469 //
     /*  47495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47542 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47546 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47551 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47555 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47559 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47563 */     // MIs[4] Operand 1
     /*  47563 */     // No operand predicates
     /*  47563 */     // MIs[2] Operand 2
     /*  47563 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47581 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47599 */     GIR_RootConstrainSelectedInstOperands,
     /*  47600 */     // GIR_Coverage, 13469,
     /*  47600 */     GIR_EraseRootFromParent_Done,
     /*  47601 */   // Label 720: @47601
     /*  47601 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47712), // Rule ID 2043 //
     /*  47606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47658 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47662 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47667 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47671 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47675 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47679 */     // MIs[4] Operand 1
     /*  47679 */     // No operand predicates
     /*  47679 */     // MIs[2] Operand 2
     /*  47679 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47690 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47692 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47710 */     GIR_RootConstrainSelectedInstOperands,
     /*  47711 */     // GIR_Coverage, 2043,
     /*  47711 */     GIR_EraseRootFromParent_Done,
     /*  47712 */   // Label 721: @47712
     /*  47712 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47823), // Rule ID 13499 //
     /*  47717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47781 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47785 */     // MIs[4] Operand 1
     /*  47785 */     // No operand predicates
     /*  47785 */     // MIs[2] Operand 2
     /*  47785 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47801 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47803 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47821 */     GIR_RootConstrainSelectedInstOperands,
     /*  47822 */     // GIR_Coverage, 13499,
     /*  47822 */     GIR_EraseRootFromParent_Done,
     /*  47823 */   // Label 722: @47823
     /*  47823 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47934), // Rule ID 2095 //
     /*  47828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47884 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47897 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47901 */     // MIs[4] Operand 1
     /*  47901 */     // No operand predicates
     /*  47901 */     // MIs[2] Operand 2
     /*  47901 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47912 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47914 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47932 */     GIR_RootConstrainSelectedInstOperands,
     /*  47933 */     // GIR_Coverage, 2095,
     /*  47933 */     GIR_EraseRootFromParent_Done,
     /*  47934 */   // Label 723: @47934
     /*  47934 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47997), // Rule ID 1733 //
     /*  47939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47964 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47978 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47995 */     GIR_RootConstrainSelectedInstOperands,
     /*  47996 */     // GIR_Coverage, 1733,
     /*  47996 */     GIR_EraseRootFromParent_Done,
     /*  47997 */   // Label 724: @47997
     /*  47997 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(48060), // Rule ID 1823 //
     /*  48002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48041 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48058 */     GIR_RootConstrainSelectedInstOperands,
     /*  48059 */     // GIR_Coverage, 1823,
     /*  48059 */     GIR_EraseRootFromParent_Done,
     /*  48060 */   // Label 725: @48060
     /*  48060 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48148), // Rule ID 13470 //
     /*  48065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48117 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48121 */     // MIs[3] Operand 1
     /*  48121 */     // No operand predicates
     /*  48121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48128 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48146 */     GIR_RootConstrainSelectedInstOperands,
     /*  48147 */     // GIR_Coverage, 13470,
     /*  48147 */     GIR_EraseRootFromParent_Done,
     /*  48148 */   // Label 726: @48148
     /*  48148 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48236), // Rule ID 2044 //
     /*  48153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48210 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48214 */     // MIs[3] Operand 1
     /*  48214 */     // No operand predicates
     /*  48214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48216 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48234 */     GIR_RootConstrainSelectedInstOperands,
     /*  48235 */     // GIR_Coverage, 2044,
     /*  48235 */     GIR_EraseRootFromParent_Done,
     /*  48236 */   // Label 727: @48236
     /*  48236 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48324), // Rule ID 13500 //
     /*  48241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48297 */     // MIs[3] Operand 1
     /*  48297 */     // No operand predicates
     /*  48297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48304 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48322 */     GIR_RootConstrainSelectedInstOperands,
     /*  48323 */     // GIR_Coverage, 13500,
     /*  48323 */     GIR_EraseRootFromParent_Done,
     /*  48324 */   // Label 728: @48324
     /*  48324 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48412), // Rule ID 2096 //
     /*  48329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48386 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48390 */     // MIs[3] Operand 1
     /*  48390 */     // No operand predicates
     /*  48390 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48392 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48410 */     GIR_RootConstrainSelectedInstOperands,
     /*  48411 */     // GIR_Coverage, 2096,
     /*  48411 */     GIR_EraseRootFromParent_Done,
     /*  48412 */   // Label 729: @48412
     /*  48412 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48459), // Rule ID 1863 //
     /*  48417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48445 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48457 */     GIR_RootConstrainSelectedInstOperands,
     /*  48458 */     // GIR_Coverage, 1863,
     /*  48458 */     GIR_EraseRootFromParent_Done,
     /*  48459 */   // Label 730: @48459
     /*  48459 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48506), // Rule ID 1763 //
     /*  48464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48492 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48504 */     GIR_RootConstrainSelectedInstOperands,
     /*  48505 */     // GIR_Coverage, 1763,
     /*  48505 */     GIR_EraseRootFromParent_Done,
     /*  48506 */   // Label 731: @48506
     /*  48506 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48553), // Rule ID 1862 //
     /*  48511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48539 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48551 */     GIR_RootConstrainSelectedInstOperands,
     /*  48552 */     // GIR_Coverage, 1862,
     /*  48552 */     GIR_EraseRootFromParent_Done,
     /*  48553 */   // Label 732: @48553
     /*  48553 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48612), // Rule ID 1843 //
     /*  48558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48597 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48610 */     GIR_RootConstrainSelectedInstOperands,
     /*  48611 */     // GIR_Coverage, 1843,
     /*  48611 */     GIR_EraseRootFromParent_Done,
     /*  48612 */   // Label 733: @48612
     /*  48612 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48671), // Rule ID 1842 //
     /*  48617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48656 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48669 */     GIR_RootConstrainSelectedInstOperands,
     /*  48670 */     // GIR_Coverage, 1842,
     /*  48670 */     GIR_EraseRootFromParent_Done,
     /*  48671 */   // Label 734: @48671
     /*  48671 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48730), // Rule ID 1756 //
     /*  48676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48715 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48728 */     GIR_RootConstrainSelectedInstOperands,
     /*  48729 */     // GIR_Coverage, 1756,
     /*  48729 */     GIR_EraseRootFromParent_Done,
     /*  48730 */   // Label 735: @48730
     /*  48730 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48789), // Rule ID 1841 //
     /*  48735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48774 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48787 */     GIR_RootConstrainSelectedInstOperands,
     /*  48788 */     // GIR_Coverage, 1841,
     /*  48788 */     GIR_EraseRootFromParent_Done,
     /*  48789 */   // Label 736: @48789
     /*  48789 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48848), // Rule ID 1840 //
     /*  48794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48833 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48846 */     GIR_RootConstrainSelectedInstOperands,
     /*  48847 */     // GIR_Coverage, 1840,
     /*  48847 */     GIR_EraseRootFromParent_Done,
     /*  48848 */   // Label 737: @48848
     /*  48848 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48883), // Rule ID 970 //
     /*  48853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48860 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48866 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48874 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48881 */     GIR_RootConstrainSelectedInstOperands,
     /*  48882 */     // GIR_Coverage, 970,
     /*  48882 */     GIR_EraseRootFromParent_Done,
     /*  48883 */   // Label 738: @48883
     /*  48883 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48940), // Rule ID 1732 //
     /*  48888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48923 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48938 */     GIR_RootConstrainSelectedInstOperands,
     /*  48939 */     // GIR_Coverage, 1732,
     /*  48939 */     GIR_EraseRootFromParent_Done,
     /*  48940 */   // Label 739: @48940
     /*  48940 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48997), // Rule ID 1822 //
     /*  48945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48980 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48995 */     GIR_RootConstrainSelectedInstOperands,
     /*  48996 */     // GIR_Coverage, 1822,
     /*  48996 */     GIR_EraseRootFromParent_Done,
     /*  48997 */   // Label 740: @48997
     /*  48997 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(49041), // Rule ID 1861 //
     /*  49002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49028 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49039 */     GIR_RootConstrainSelectedInstOperands,
     /*  49040 */     // GIR_Coverage, 1861,
     /*  49040 */     GIR_EraseRootFromParent_Done,
     /*  49041 */   // Label 741: @49041
     /*  49041 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49085), // Rule ID 1762 //
     /*  49046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49072 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49083 */     GIR_RootConstrainSelectedInstOperands,
     /*  49084 */     // GIR_Coverage, 1762,
     /*  49084 */     GIR_EraseRootFromParent_Done,
     /*  49085 */   // Label 742: @49085
     /*  49085 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49129), // Rule ID 1860 //
     /*  49090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49116 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49127 */     GIR_RootConstrainSelectedInstOperands,
     /*  49128 */     // GIR_Coverage, 1860,
     /*  49128 */     GIR_EraseRootFromParent_Done,
     /*  49129 */   // Label 743: @49129
     /*  49129 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49152), // Rule ID 1477 //
     /*  49134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49145 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49150 */     GIR_RootConstrainSelectedInstOperands,
     /*  49151 */     // GIR_Coverage, 1477,
     /*  49151 */     GIR_Done,
     /*  49152 */   // Label 744: @49152
     /*  49152 */   GIM_Reject,
     /*  49153 */ // Label 710: @49153
     /*  49153 */ GIM_Reject,
     /*  49154 */ // Label 588: @49154
     /*  49154 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49228),
     /*  49159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49169 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49204), // Rule ID 965 //
     /*  49174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49181 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49187 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49195 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49202 */     GIR_RootConstrainSelectedInstOperands,
     /*  49203 */     // GIR_Coverage, 965,
     /*  49203 */     GIR_EraseRootFromParent_Done,
     /*  49204 */   // Label 746: @49204
     /*  49204 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49227), // Rule ID 1472 //
     /*  49209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49220 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49225 */     GIR_RootConstrainSelectedInstOperands,
     /*  49226 */     // GIR_Coverage, 1472,
     /*  49226 */     GIR_Done,
     /*  49227 */   // Label 747: @49227
     /*  49227 */   GIM_Reject,
     /*  49228 */ // Label 745: @49228
     /*  49228 */ GIM_Reject,
     /*  49229 */ // Label 589: @49229
     /*  49229 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(50436),
     /*  49234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49244 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49309), // Rule ID 1839 //
     /*  49249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49292 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49307 */     GIR_RootConstrainSelectedInstOperands,
     /*  49308 */     // GIR_Coverage, 1839,
     /*  49308 */     GIR_EraseRootFromParent_Done,
     /*  49309 */   // Label 749: @49309
     /*  49309 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(49374), // Rule ID 1838 //
     /*  49314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49357 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49372 */     GIR_RootConstrainSelectedInstOperands,
     /*  49373 */     // GIR_Coverage, 1838,
     /*  49373 */     GIR_EraseRootFromParent_Done,
     /*  49374 */   // Label 750: @49374
     /*  49374 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49439), // Rule ID 1755 //
     /*  49379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49415 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49422 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49437 */     GIR_RootConstrainSelectedInstOperands,
     /*  49438 */     // GIR_Coverage, 1755,
     /*  49438 */     GIR_EraseRootFromParent_Done,
     /*  49439 */   // Label 751: @49439
     /*  49439 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49504), // Rule ID 1837 //
     /*  49444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49487 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49502 */     GIR_RootConstrainSelectedInstOperands,
     /*  49503 */     // GIR_Coverage, 1837,
     /*  49503 */     GIR_EraseRootFromParent_Done,
     /*  49504 */   // Label 752: @49504
     /*  49504 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49569), // Rule ID 1836 //
     /*  49509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49552 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49567 */     GIR_RootConstrainSelectedInstOperands,
     /*  49568 */     // GIR_Coverage, 1836,
     /*  49568 */     GIR_EraseRootFromParent_Done,
     /*  49569 */   // Label 753: @49569
     /*  49569 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49632), // Rule ID 1731 //
     /*  49574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49613 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49630 */     GIR_RootConstrainSelectedInstOperands,
     /*  49631 */     // GIR_Coverage, 1731,
     /*  49631 */     GIR_EraseRootFromParent_Done,
     /*  49632 */   // Label 754: @49632
     /*  49632 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49695), // Rule ID 1821 //
     /*  49637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49662 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49676 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49693 */     GIR_RootConstrainSelectedInstOperands,
     /*  49694 */     // GIR_Coverage, 1821,
     /*  49694 */     GIR_EraseRootFromParent_Done,
     /*  49695 */   // Label 755: @49695
     /*  49695 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49742), // Rule ID 1859 //
     /*  49700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49728 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49740 */     GIR_RootConstrainSelectedInstOperands,
     /*  49741 */     // GIR_Coverage, 1859,
     /*  49741 */     GIR_EraseRootFromParent_Done,
     /*  49742 */   // Label 756: @49742
     /*  49742 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49789), // Rule ID 1761 //
     /*  49747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49775 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49787 */     GIR_RootConstrainSelectedInstOperands,
     /*  49788 */     // GIR_Coverage, 1761,
     /*  49788 */     GIR_EraseRootFromParent_Done,
     /*  49789 */   // Label 757: @49789
     /*  49789 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49836), // Rule ID 1858 //
     /*  49794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49822 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49834 */     GIR_RootConstrainSelectedInstOperands,
     /*  49835 */     // GIR_Coverage, 1858,
     /*  49835 */     GIR_EraseRootFromParent_Done,
     /*  49836 */   // Label 758: @49836
     /*  49836 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49895), // Rule ID 1835 //
     /*  49841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49880 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49893 */     GIR_RootConstrainSelectedInstOperands,
     /*  49894 */     // GIR_Coverage, 1835,
     /*  49894 */     GIR_EraseRootFromParent_Done,
     /*  49895 */   // Label 759: @49895
     /*  49895 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49954), // Rule ID 1834 //
     /*  49900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49939 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49952 */     GIR_RootConstrainSelectedInstOperands,
     /*  49953 */     // GIR_Coverage, 1834,
     /*  49953 */     GIR_EraseRootFromParent_Done,
     /*  49954 */   // Label 760: @49954
     /*  49954 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(50013), // Rule ID 1754 //
     /*  49959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49998 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50011 */     GIR_RootConstrainSelectedInstOperands,
     /*  50012 */     // GIR_Coverage, 1754,
     /*  50012 */     GIR_EraseRootFromParent_Done,
     /*  50013 */   // Label 761: @50013
     /*  50013 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(50072), // Rule ID 1833 //
     /*  50018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50057 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50070 */     GIR_RootConstrainSelectedInstOperands,
     /*  50071 */     // GIR_Coverage, 1833,
     /*  50071 */     GIR_EraseRootFromParent_Done,
     /*  50072 */   // Label 762: @50072
     /*  50072 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50131), // Rule ID 1832 //
     /*  50077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50116 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50129 */     GIR_RootConstrainSelectedInstOperands,
     /*  50130 */     // GIR_Coverage, 1832,
     /*  50130 */     GIR_EraseRootFromParent_Done,
     /*  50131 */   // Label 763: @50131
     /*  50131 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50166), // Rule ID 968 //
     /*  50136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50143 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50149 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50157 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50164 */     GIR_RootConstrainSelectedInstOperands,
     /*  50165 */     // GIR_Coverage, 968,
     /*  50165 */     GIR_EraseRootFromParent_Done,
     /*  50166 */   // Label 764: @50166
     /*  50166 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50223), // Rule ID 1730 //
     /*  50171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50206 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50221 */     GIR_RootConstrainSelectedInstOperands,
     /*  50222 */     // GIR_Coverage, 1730,
     /*  50222 */     GIR_EraseRootFromParent_Done,
     /*  50223 */   // Label 765: @50223
     /*  50223 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50280), // Rule ID 1820 //
     /*  50228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50263 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50278 */     GIR_RootConstrainSelectedInstOperands,
     /*  50279 */     // GIR_Coverage, 1820,
     /*  50279 */     GIR_EraseRootFromParent_Done,
     /*  50280 */   // Label 766: @50280
     /*  50280 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50324), // Rule ID 1857 //
     /*  50285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50311 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50322 */     GIR_RootConstrainSelectedInstOperands,
     /*  50323 */     // GIR_Coverage, 1857,
     /*  50323 */     GIR_EraseRootFromParent_Done,
     /*  50324 */   // Label 767: @50324
     /*  50324 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50368), // Rule ID 1760 //
     /*  50329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50355 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50366 */     GIR_RootConstrainSelectedInstOperands,
     /*  50367 */     // GIR_Coverage, 1760,
     /*  50367 */     GIR_EraseRootFromParent_Done,
     /*  50368 */   // Label 768: @50368
     /*  50368 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50412), // Rule ID 1856 //
     /*  50373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50399 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50410 */     GIR_RootConstrainSelectedInstOperands,
     /*  50411 */     // GIR_Coverage, 1856,
     /*  50411 */     GIR_EraseRootFromParent_Done,
     /*  50412 */   // Label 769: @50412
     /*  50412 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50435), // Rule ID 1475 //
     /*  50417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50428 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50433 */     GIR_RootConstrainSelectedInstOperands,
     /*  50434 */     // GIR_Coverage, 1475,
     /*  50434 */     GIR_Done,
     /*  50435 */   // Label 770: @50435
     /*  50435 */   GIM_Reject,
     /*  50436 */ // Label 748: @50436
     /*  50436 */ GIM_Reject,
     /*  50437 */ // Label 590: @50437
     /*  50437 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50511),
     /*  50442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50452 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50487), // Rule ID 966 //
     /*  50457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50478 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50485 */     GIR_RootConstrainSelectedInstOperands,
     /*  50486 */     // GIR_Coverage, 966,
     /*  50486 */     GIR_EraseRootFromParent_Done,
     /*  50487 */   // Label 772: @50487
     /*  50487 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50510), // Rule ID 1473 //
     /*  50492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50503 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50508 */     GIR_RootConstrainSelectedInstOperands,
     /*  50509 */     // GIR_Coverage, 1473,
     /*  50509 */     GIR_Done,
     /*  50510 */   // Label 773: @50510
     /*  50510 */   GIM_Reject,
     /*  50511 */ // Label 771: @50511
     /*  50511 */ GIM_Reject,
     /*  50512 */ // Label 591: @50512
     /*  50512 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50537), // Rule ID 7415 //
     /*  50517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50530 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50535 */   GIR_RootConstrainSelectedInstOperands,
     /*  50536 */   // GIR_Coverage, 7415,
     /*  50536 */   GIR_Done,
     /*  50537 */ // Label 774: @50537
     /*  50537 */ GIM_Reject,
     /*  50538 */ // Label 592: @50538
     /*  50538 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50563), // Rule ID 7414 //
     /*  50543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50556 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50561 */   GIR_RootConstrainSelectedInstOperands,
     /*  50562 */   // GIR_Coverage, 7414,
     /*  50562 */   GIR_Done,
     /*  50563 */ // Label 775: @50563
     /*  50563 */ GIM_Reject,
     /*  50564 */ // Label 593: @50564
     /*  50564 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50589), // Rule ID 7413 //
     /*  50569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50582 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50587 */   GIR_RootConstrainSelectedInstOperands,
     /*  50588 */   // GIR_Coverage, 7413,
     /*  50588 */   GIR_Done,
     /*  50589 */ // Label 776: @50589
     /*  50589 */ GIM_Reject,
     /*  50590 */ // Label 594: @50590
     /*  50590 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50615), // Rule ID 7412 //
     /*  50595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50608 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50613 */   GIR_RootConstrainSelectedInstOperands,
     /*  50614 */   // GIR_Coverage, 7412,
     /*  50614 */   GIR_Done,
     /*  50615 */ // Label 777: @50615
     /*  50615 */ GIM_Reject,
     /*  50616 */ // Label 595: @50616
     /*  50616 */ GIM_Reject,
     /*  50617 */ // Label 2: @50617
     /*  50617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 786*/ GIMT_Encode4(52445),
     /*  50628 */ /*GILLT_s32*//*Label 778*/ GIMT_Encode4(50668),
     /*  50632 */ /*GILLT_s64*//*Label 779*/ GIMT_Encode4(50825), GIMT_Encode4(0),
     /*  50640 */ /*GILLT_v2s32*//*Label 780*/ GIMT_Encode4(51369), GIMT_Encode4(0),
     /*  50648 */ /*GILLT_v4s16*//*Label 781*/ GIMT_Encode4(51707),
     /*  50652 */ /*GILLT_v4s32*//*Label 782*/ GIMT_Encode4(52045),
     /*  50656 */ /*GILLT_v8s8*//*Label 783*/ GIMT_Encode4(52211),
     /*  50660 */ /*GILLT_v8s16*//*Label 784*/ GIMT_Encode4(52245),
     /*  50664 */ /*GILLT_v16s8*//*Label 785*/ GIMT_Encode4(52411),
     /*  50668 */ // Label 778: @50668
     /*  50668 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(50824),
     /*  50673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50683 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(50738), // Rule ID 3955 //
     /*  50688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50704 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50719 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50736 */     GIR_RootConstrainSelectedInstOperands,
     /*  50737 */     // GIR_Coverage, 3955,
     /*  50737 */     GIR_EraseRootFromParent_Done,
     /*  50738 */   // Label 788: @50738
     /*  50738 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(50793), // Rule ID 13754 //
     /*  50743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50774 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50791 */     GIR_RootConstrainSelectedInstOperands,
     /*  50792 */     // GIR_Coverage, 13754,
     /*  50792 */     GIR_EraseRootFromParent_Done,
     /*  50793 */   // Label 789: @50793
     /*  50793 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(50823), // Rule ID 3951 //
     /*  50798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50806 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50821 */     GIR_RootConstrainSelectedInstOperands,
     /*  50822 */     // GIR_Coverage, 3951,
     /*  50822 */     GIR_EraseRootFromParent_Done,
     /*  50823 */   // Label 790: @50823
     /*  50823 */   GIM_Reject,
     /*  50824 */ // Label 787: @50824
     /*  50824 */ GIM_Reject,
     /*  50825 */ // Label 779: @50825
     /*  50825 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(51368),
     /*  50830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50840 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50895), // Rule ID 3956 //
     /*  50845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50861 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50876 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  50876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  50879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50893 */     GIR_RootConstrainSelectedInstOperands,
     /*  50894 */     // GIR_Coverage, 3956,
     /*  50894 */     GIR_EraseRootFromParent_Done,
     /*  50895 */   // Label 792: @50895
     /*  50895 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(50950), // Rule ID 13755 //
     /*  50900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50920 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50931 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  50931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  50934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50948 */     GIR_RootConstrainSelectedInstOperands,
     /*  50949 */     // GIR_Coverage, 13755,
     /*  50949 */     GIR_EraseRootFromParent_Done,
     /*  50950 */   // Label 793: @50950
     /*  50950 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(51063), // Rule ID 3967 //
     /*  50955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  50963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50972 */     // MIs[1] Operand 2
     /*  50972 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  50983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  50995 */     // MIs[2] Operand 1
     /*  50995 */     // No operand predicates
     /*  50995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50997 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  50997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51009 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51028 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51061 */     GIR_RootConstrainSelectedInstOperands,
     /*  51062 */     // GIR_Coverage, 3967,
     /*  51062 */     GIR_EraseRootFromParent_Done,
     /*  51063 */   // Label 794: @51063
     /*  51063 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(51138), // Rule ID 3965 //
     /*  51068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51093 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51097 */     // MIs[2] Operand 1
     /*  51097 */     // No operand predicates
     /*  51097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51099 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51111 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51136 */     GIR_RootConstrainSelectedInstOperands,
     /*  51137 */     // GIR_Coverage, 3965,
     /*  51137 */     GIR_EraseRootFromParent_Done,
     /*  51138 */   // Label 795: @51138
     /*  51138 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51213), // Rule ID 3966 //
     /*  51143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51168 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51172 */     // MIs[2] Operand 1
     /*  51172 */     // No operand predicates
     /*  51172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51174 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51186 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51211 */     GIR_RootConstrainSelectedInstOperands,
     /*  51212 */     // GIR_Coverage, 3966,
     /*  51212 */     GIR_EraseRootFromParent_Done,
     /*  51213 */   // Label 796: @51213
     /*  51213 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(51275), // Rule ID 3959 //
     /*  51218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51254 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51273 */     GIR_RootConstrainSelectedInstOperands,
     /*  51274 */     // GIR_Coverage, 3959,
     /*  51274 */     GIR_EraseRootFromParent_Done,
     /*  51275 */   // Label 797: @51275
     /*  51275 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51337), // Rule ID 3962 //
     /*  51280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51316 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51335 */     GIR_RootConstrainSelectedInstOperands,
     /*  51336 */     // GIR_Coverage, 3962,
     /*  51336 */     GIR_EraseRootFromParent_Done,
     /*  51337 */   // Label 798: @51337
     /*  51337 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51367), // Rule ID 3952 //
     /*  51342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51350 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  51353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51365 */     GIR_RootConstrainSelectedInstOperands,
     /*  51366 */     // GIR_Coverage, 3952,
     /*  51366 */     GIR_EraseRootFromParent_Done,
     /*  51367 */   // Label 799: @51367
     /*  51367 */   GIM_Reject,
     /*  51368 */ // Label 791: @51368
     /*  51368 */ GIM_Reject,
     /*  51369 */ // Label 780: @51369
     /*  51369 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51706),
     /*  51374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  51377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51384 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51470), // Rule ID 13448 //
     /*  51389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51433 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51437 */     // MIs[3] Operand 1
     /*  51437 */     // No operand predicates
     /*  51437 */     // MIs[1] Operand 2
     /*  51437 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51454 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51468 */     GIR_RootConstrainSelectedInstOperands,
     /*  51469 */     // GIR_Coverage, 13448,
     /*  51469 */     GIR_EraseRootFromParent_Done,
     /*  51470 */   // Label 801: @51470
     /*  51470 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51556), // Rule ID 2034 //
     /*  51475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51523 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51527 */     // MIs[3] Operand 1
     /*  51527 */     // No operand predicates
     /*  51527 */     // MIs[1] Operand 2
     /*  51527 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51540 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51554 */     GIR_RootConstrainSelectedInstOperands,
     /*  51555 */     // GIR_Coverage, 2034,
     /*  51555 */     GIR_EraseRootFromParent_Done,
     /*  51556 */   // Label 802: @51556
     /*  51556 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51619), // Rule ID 13449 //
     /*  51561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51593 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51597 */     // MIs[2] Operand 1
     /*  51597 */     // No operand predicates
     /*  51597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51603 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51617 */     GIR_RootConstrainSelectedInstOperands,
     /*  51618 */     // GIR_Coverage, 13449,
     /*  51618 */     GIR_EraseRootFromParent_Done,
     /*  51619 */   // Label 803: @51619
     /*  51619 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51682), // Rule ID 2035 //
     /*  51624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51664 */     // MIs[2] Operand 1
     /*  51664 */     // No operand predicates
     /*  51664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51666 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51680 */     GIR_RootConstrainSelectedInstOperands,
     /*  51681 */     // GIR_Coverage, 2035,
     /*  51681 */     GIR_EraseRootFromParent_Done,
     /*  51682 */   // Label 804: @51682
     /*  51682 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51705), // Rule ID 1352 //
     /*  51687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51698 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  51698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  51703 */     GIR_RootConstrainSelectedInstOperands,
     /*  51704 */     // GIR_Coverage, 1352,
     /*  51704 */     GIR_Done,
     /*  51705 */   // Label 805: @51705
     /*  51705 */   GIM_Reject,
     /*  51706 */ // Label 800: @51706
     /*  51706 */ GIM_Reject,
     /*  51707 */ // Label 781: @51707
     /*  51707 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52044),
     /*  51712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  51715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51722 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(51808), // Rule ID 13445 //
     /*  51727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51771 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51775 */     // MIs[3] Operand 1
     /*  51775 */     // No operand predicates
     /*  51775 */     // MIs[1] Operand 2
     /*  51775 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51792 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51806 */     GIR_RootConstrainSelectedInstOperands,
     /*  51807 */     // GIR_Coverage, 13445,
     /*  51807 */     GIR_EraseRootFromParent_Done,
     /*  51808 */   // Label 807: @51808
     /*  51808 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(51894), // Rule ID 2031 //
     /*  51813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51861 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51865 */     // MIs[3] Operand 1
     /*  51865 */     // No operand predicates
     /*  51865 */     // MIs[1] Operand 2
     /*  51865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51878 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51892 */     GIR_RootConstrainSelectedInstOperands,
     /*  51893 */     // GIR_Coverage, 2031,
     /*  51893 */     GIR_EraseRootFromParent_Done,
     /*  51894 */   // Label 808: @51894
     /*  51894 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(51957), // Rule ID 13446 //
     /*  51899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51931 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51935 */     // MIs[2] Operand 1
     /*  51935 */     // No operand predicates
     /*  51935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51941 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51955 */     GIR_RootConstrainSelectedInstOperands,
     /*  51956 */     // GIR_Coverage, 13446,
     /*  51956 */     GIR_EraseRootFromParent_Done,
     /*  51957 */   // Label 809: @51957
     /*  51957 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52020), // Rule ID 2032 //
     /*  51962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51998 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52002 */     // MIs[2] Operand 1
     /*  52002 */     // No operand predicates
     /*  52002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52004 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52018 */     GIR_RootConstrainSelectedInstOperands,
     /*  52019 */     // GIR_Coverage, 2032,
     /*  52019 */     GIR_EraseRootFromParent_Done,
     /*  52020 */   // Label 810: @52020
     /*  52020 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52043), // Rule ID 1350 //
     /*  52025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52036 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52041 */     GIR_RootConstrainSelectedInstOperands,
     /*  52042 */     // GIR_Coverage, 1350,
     /*  52042 */     GIR_Done,
     /*  52043 */   // Label 811: @52043
     /*  52043 */   GIM_Reject,
     /*  52044 */ // Label 806: @52044
     /*  52044 */ GIM_Reject,
     /*  52045 */ // Label 782: @52045
     /*  52045 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52210),
     /*  52050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52060 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52123), // Rule ID 13450 //
     /*  52065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52097 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52101 */     // MIs[2] Operand 1
     /*  52101 */     // No operand predicates
     /*  52101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52107 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52121 */     GIR_RootConstrainSelectedInstOperands,
     /*  52122 */     // GIR_Coverage, 13450,
     /*  52122 */     GIR_EraseRootFromParent_Done,
     /*  52123 */   // Label 813: @52123
     /*  52123 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52186), // Rule ID 2036 //
     /*  52128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52164 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52168 */     // MIs[2] Operand 1
     /*  52168 */     // No operand predicates
     /*  52168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52170 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52184 */     GIR_RootConstrainSelectedInstOperands,
     /*  52185 */     // GIR_Coverage, 2036,
     /*  52185 */     GIR_EraseRootFromParent_Done,
     /*  52186 */   // Label 814: @52186
     /*  52186 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52209), // Rule ID 1353 //
     /*  52191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52202 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52207 */     GIR_RootConstrainSelectedInstOperands,
     /*  52208 */     // GIR_Coverage, 1353,
     /*  52208 */     GIR_Done,
     /*  52209 */   // Label 815: @52209
     /*  52209 */   GIM_Reject,
     /*  52210 */ // Label 812: @52210
     /*  52210 */ GIM_Reject,
     /*  52211 */ // Label 783: @52211
     /*  52211 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52244), // Rule ID 1348 //
     /*  52216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52237 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52242 */   GIR_RootConstrainSelectedInstOperands,
     /*  52243 */   // GIR_Coverage, 1348,
     /*  52243 */   GIR_Done,
     /*  52244 */ // Label 816: @52244
     /*  52244 */ GIM_Reject,
     /*  52245 */ // Label 784: @52245
     /*  52245 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52410),
     /*  52250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52260 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52323), // Rule ID 13447 //
     /*  52265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52301 */     // MIs[2] Operand 1
     /*  52301 */     // No operand predicates
     /*  52301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52307 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52321 */     GIR_RootConstrainSelectedInstOperands,
     /*  52322 */     // GIR_Coverage, 13447,
     /*  52322 */     GIR_EraseRootFromParent_Done,
     /*  52323 */   // Label 818: @52323
     /*  52323 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52386), // Rule ID 2033 //
     /*  52328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52364 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52368 */     // MIs[2] Operand 1
     /*  52368 */     // No operand predicates
     /*  52368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52370 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52384 */     GIR_RootConstrainSelectedInstOperands,
     /*  52385 */     // GIR_Coverage, 2033,
     /*  52385 */     GIR_EraseRootFromParent_Done,
     /*  52386 */   // Label 819: @52386
     /*  52386 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52409), // Rule ID 1351 //
     /*  52391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52402 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  52402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  52407 */     GIR_RootConstrainSelectedInstOperands,
     /*  52408 */     // GIR_Coverage, 1351,
     /*  52408 */     GIR_Done,
     /*  52409 */   // Label 820: @52409
     /*  52409 */   GIM_Reject,
     /*  52410 */ // Label 817: @52410
     /*  52410 */ GIM_Reject,
     /*  52411 */ // Label 785: @52411
     /*  52411 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52444), // Rule ID 1349 //
     /*  52416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52437 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  52437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  52442 */   GIR_RootConstrainSelectedInstOperands,
     /*  52443 */   // GIR_Coverage, 1349,
     /*  52443 */   GIR_Done,
     /*  52444 */ // Label 821: @52444
     /*  52444 */ GIM_Reject,
     /*  52445 */ // Label 786: @52445
     /*  52445 */ GIM_Reject,
     /*  52446 */ // Label 3: @52446
     /*  52446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 824*/ GIMT_Encode4(52527),
     /*  52457 */ /*GILLT_s32*//*Label 822*/ GIMT_Encode4(52465),
     /*  52461 */ /*GILLT_s64*//*Label 823*/ GIMT_Encode4(52496),
     /*  52465 */ // Label 822: @52465
     /*  52465 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(52495), // Rule ID 117 //
     /*  52470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52488 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  52493 */   GIR_RootConstrainSelectedInstOperands,
     /*  52494 */   // GIR_Coverage, 117,
     /*  52494 */   GIR_Done,
     /*  52495 */ // Label 825: @52495
     /*  52495 */ GIM_Reject,
     /*  52496 */ // Label 823: @52496
     /*  52496 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(52526), // Rule ID 118 //
     /*  52501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52519 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  52524 */   GIR_RootConstrainSelectedInstOperands,
     /*  52525 */   // GIR_Coverage, 118,
     /*  52525 */   GIR_Done,
     /*  52526 */ // Label 826: @52526
     /*  52526 */ GIM_Reject,
     /*  52527 */ // Label 824: @52527
     /*  52527 */ GIM_Reject,
     /*  52528 */ // Label 4: @52528
     /*  52528 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 829*/ GIMT_Encode4(52609),
     /*  52539 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(52547),
     /*  52543 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(52578),
     /*  52547 */ // Label 827: @52547
     /*  52547 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(52577), // Rule ID 115 //
     /*  52552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52570 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  52575 */   GIR_RootConstrainSelectedInstOperands,
     /*  52576 */   // GIR_Coverage, 115,
     /*  52576 */   GIR_Done,
     /*  52577 */ // Label 830: @52577
     /*  52577 */ GIM_Reject,
     /*  52578 */ // Label 828: @52578
     /*  52578 */ GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(52608), // Rule ID 116 //
     /*  52583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52601 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  52606 */   GIR_RootConstrainSelectedInstOperands,
     /*  52607 */   // GIR_Coverage, 116,
     /*  52607 */   GIR_Done,
     /*  52608 */ // Label 831: @52608
     /*  52608 */ GIM_Reject,
     /*  52609 */ // Label 829: @52609
     /*  52609 */ GIM_Reject,
     /*  52610 */ // Label 5: @52610
     /*  52610 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 850*/ GIMT_Encode4(60355),
     /*  52621 */ /*GILLT_s32*//*Label 832*/ GIMT_Encode4(52709),
     /*  52625 */ /*GILLT_s64*//*Label 833*/ GIMT_Encode4(53207), GIMT_Encode4(0),
     /*  52633 */ /*GILLT_v2s32*//*Label 834*/ GIMT_Encode4(54642),
     /*  52637 */ /*GILLT_v2s64*//*Label 835*/ GIMT_Encode4(54802),
     /*  52641 */ /*GILLT_v4s16*//*Label 836*/ GIMT_Encode4(54962),
     /*  52645 */ /*GILLT_v4s32*//*Label 837*/ GIMT_Encode4(55122),
     /*  52649 */ /*GILLT_v8s8*//*Label 838*/ GIMT_Encode4(55282),
     /*  52653 */ /*GILLT_v8s16*//*Label 839*/ GIMT_Encode4(55442),
     /*  52657 */ /*GILLT_v16s8*//*Label 840*/ GIMT_Encode4(55602),
     /*  52661 */ /*GILLT_nxv1s1*//*Label 841*/ GIMT_Encode4(55762),
     /*  52665 */ /*GILLT_nxv2s1*//*Label 842*/ GIMT_Encode4(56303), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52677 */ /*GILLT_nxv2s64*//*Label 843*/ GIMT_Encode4(56844),
     /*  52681 */ /*GILLT_nxv4s1*//*Label 844*/ GIMT_Encode4(57316), GIMT_Encode4(0),
     /*  52689 */ /*GILLT_nxv4s32*//*Label 845*/ GIMT_Encode4(57857),
     /*  52693 */ /*GILLT_nxv8s1*//*Label 846*/ GIMT_Encode4(58329),
     /*  52697 */ /*GILLT_nxv8s16*//*Label 847*/ GIMT_Encode4(58870),
     /*  52701 */ /*GILLT_nxv16s1*//*Label 848*/ GIMT_Encode4(59342),
     /*  52705 */ /*GILLT_nxv16s8*//*Label 849*/ GIMT_Encode4(59883),
     /*  52709 */ // Label 832: @52709
     /*  52709 */ GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(53206),
     /*  52714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52720 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(52775), // Rule ID 13207 //
     /*  52725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52745 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  52762 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  52762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  52765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  52773 */     GIR_RootConstrainSelectedInstOperands,
     /*  52774 */     // GIR_Coverage, 13207,
     /*  52774 */     GIR_EraseRootFromParent_Done,
     /*  52775 */   // Label 852: @52775
     /*  52775 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(52830), // Rule ID 162 //
     /*  52780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  52817 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  52817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  52820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  52828 */     GIR_RootConstrainSelectedInstOperands,
     /*  52829 */     // GIR_Coverage, 162,
     /*  52829 */     GIR_EraseRootFromParent_Done,
     /*  52830 */   // Label 853: @52830
     /*  52830 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(52899), // Rule ID 5660 //
     /*  52835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  52847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  52872 */     // MIs[2] Operand 1
     /*  52872 */     // No operand predicates
     /*  52872 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  52883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52885 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  52885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  52888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52897 */     GIR_RootConstrainSelectedInstOperands,
     /*  52898 */     // GIR_Coverage, 5660,
     /*  52898 */     GIR_EraseRootFromParent_Done,
     /*  52899 */   // Label 854: @52899
     /*  52899 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(52968), // Rule ID 5661 //
     /*  52904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  52916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52941 */     // MIs[2] Operand 1
     /*  52941 */     // No operand predicates
     /*  52941 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  52952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52954 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  52954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  52957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52966 */     GIR_RootConstrainSelectedInstOperands,
     /*  52967 */     // GIR_Coverage, 5661,
     /*  52967 */     GIR_EraseRootFromParent_Done,
     /*  52968 */   // Label 855: @52968
     /*  52968 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53021), // Rule ID 13205 //
     /*  52973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52998 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53008 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53019 */     GIR_RootConstrainSelectedInstOperands,
     /*  53020 */     // GIR_Coverage, 13205,
     /*  53020 */     GIR_EraseRootFromParent_Done,
     /*  53021 */   // Label 856: @53021
     /*  53021 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53074), // Rule ID 160 //
     /*  53026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53055 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53061 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53072 */     GIR_RootConstrainSelectedInstOperands,
     /*  53073 */     // GIR_Coverage, 160,
     /*  53073 */     GIR_EraseRootFromParent_Done,
     /*  53074 */   // Label 857: @53074
     /*  53074 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53115), // Rule ID 142 //
     /*  53079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53095 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53099 */     // MIs[1] Operand 1
     /*  53099 */     // No operand predicates
     /*  53099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53101 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53108 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53113 */     GIR_RootConstrainSelectedInstOperands,
     /*  53114 */     // GIR_Coverage, 142,
     /*  53114 */     GIR_EraseRootFromParent_Done,
     /*  53115 */   // Label 858: @53115
     /*  53115 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53148), // Rule ID 13203 //
     /*  53120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53135 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53146 */     GIR_RootConstrainSelectedInstOperands,
     /*  53147 */     // GIR_Coverage, 13203,
     /*  53147 */     GIR_EraseRootFromParent_Done,
     /*  53148 */   // Label 859: @53148
     /*  53148 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53181), // Rule ID 158 //
     /*  53153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53168 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53179 */     GIR_RootConstrainSelectedInstOperands,
     /*  53180 */     // GIR_Coverage, 158,
     /*  53180 */     GIR_EraseRootFromParent_Done,
     /*  53181 */   // Label 860: @53181
     /*  53181 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53205), // Rule ID 156 //
     /*  53186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53198 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53203 */     GIR_RootConstrainSelectedInstOperands,
     /*  53204 */     // GIR_Coverage, 156,
     /*  53204 */     GIR_Done,
     /*  53205 */   // Label 861: @53205
     /*  53205 */   GIM_Reject,
     /*  53206 */ // Label 851: @53206
     /*  53206 */ GIM_Reject,
     /*  53207 */ // Label 833: @53207
     /*  53207 */ GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(54641),
     /*  53212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53218 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53273), // Rule ID 13208 //
     /*  53223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53260 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53271 */     GIR_RootConstrainSelectedInstOperands,
     /*  53272 */     // GIR_Coverage, 13208,
     /*  53272 */     GIR_EraseRootFromParent_Done,
     /*  53273 */   // Label 863: @53273
     /*  53273 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53328), // Rule ID 163 //
     /*  53278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53302 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53315 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53326 */     GIR_RootConstrainSelectedInstOperands,
     /*  53327 */     // GIR_Coverage, 163,
     /*  53327 */     GIR_EraseRootFromParent_Done,
     /*  53328 */   // Label 864: @53328
     /*  53328 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53441), // Rule ID 5662 //
     /*  53333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53378 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53382 */     // MIs[3] Operand 1
     /*  53382 */     // No operand predicates
     /*  53382 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53393 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53395 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  53395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53440 */     // GIR_Coverage, 5662,
     /*  53440 */     GIR_EraseRootFromParent_Done,
     /*  53441 */   // Label 865: @53441
     /*  53441 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53554), // Rule ID 5663 //
     /*  53446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53491 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53495 */     // MIs[3] Operand 1
     /*  53495 */     // No operand predicates
     /*  53495 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53508 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  53508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53520 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53553 */     // GIR_Coverage, 5663,
     /*  53553 */     GIR_EraseRootFromParent_Done,
     /*  53554 */   // Label 866: @53554
     /*  53554 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53653), // Rule ID 7094 //
     /*  53559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53571 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53574 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53579 */     // MIs[1] addr
     /*  53579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53588 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  53592 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53605 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  53612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53621 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53652 */     // GIR_Coverage, 7094,
     /*  53652 */     GIR_EraseRootFromParent_Done,
     /*  53653 */   // Label 867: @53653
     /*  53653 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53752), // Rule ID 7095 //
     /*  53658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53670 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53673 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53678 */     // MIs[1] addr
     /*  53678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53687 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  53691 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53704 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  53711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53720 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53751 */     // GIR_Coverage, 7095,
     /*  53751 */     GIR_EraseRootFromParent_Done,
     /*  53752 */   // Label 868: @53752
     /*  53752 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53851), // Rule ID 7096 //
     /*  53757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53769 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53772 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53777 */     // MIs[1] addr
     /*  53777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53786 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  53790 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  53801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53803 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  53810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53819 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53850 */     // GIR_Coverage, 7096,
     /*  53850 */     GIR_EraseRootFromParent_Done,
     /*  53851 */   // Label 869: @53851
     /*  53851 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(53950), // Rule ID 7101 //
     /*  53856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53868 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53871 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  53876 */     // MIs[1] addr
     /*  53876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53885 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  53889 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53902 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  53909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53918 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53949 */     // GIR_Coverage, 7101,
     /*  53949 */     GIR_EraseRootFromParent_Done,
     /*  53950 */   // Label 870: @53950
     /*  53950 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54049), // Rule ID 7102 //
     /*  53955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53967 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53970 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  53975 */     // MIs[1] addr
     /*  53975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53984 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  53988 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54001 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54017 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54048 */     // GIR_Coverage, 7102,
     /*  54048 */     GIR_EraseRootFromParent_Done,
     /*  54049 */   // Label 871: @54049
     /*  54049 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54148), // Rule ID 7103 //
     /*  54054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54066 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54069 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54074 */     // MIs[1] addr
     /*  54074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54083 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54087 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54100 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54147 */     // GIR_Coverage, 7103,
     /*  54147 */     GIR_EraseRootFromParent_Done,
     /*  54148 */   // Label 872: @54148
     /*  54148 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54201), // Rule ID 13206 //
     /*  54153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54178 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54188 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54199 */     GIR_RootConstrainSelectedInstOperands,
     /*  54200 */     // GIR_Coverage, 13206,
     /*  54200 */     GIR_EraseRootFromParent_Done,
     /*  54201 */   // Label 873: @54201
     /*  54201 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54254), // Rule ID 161 //
     /*  54206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54235 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54241 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54252 */     GIR_RootConstrainSelectedInstOperands,
     /*  54253 */     // GIR_Coverage, 161,
     /*  54253 */     GIR_EraseRootFromParent_Done,
     /*  54254 */   // Label 874: @54254
     /*  54254 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54354), // Rule ID 4004 //
     /*  54259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54267 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54278 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54290 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  54296 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54301 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  54313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54318 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54353 */     // GIR_Coverage, 4004,
     /*  54353 */     GIR_EraseRootFromParent_Done,
     /*  54354 */   // Label 875: @54354
     /*  54354 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54395), // Rule ID 143 //
     /*  54359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54375 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  54379 */     // MIs[1] Operand 1
     /*  54379 */     // No operand predicates
     /*  54379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54381 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  54381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  54384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54388 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  54393 */     GIR_RootConstrainSelectedInstOperands,
     /*  54394 */     // GIR_Coverage, 143,
     /*  54394 */     GIR_EraseRootFromParent_Done,
     /*  54395 */   // Label 876: @54395
     /*  54395 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54428), // Rule ID 13204 //
     /*  54400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54415 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54426 */     GIR_RootConstrainSelectedInstOperands,
     /*  54427 */     // GIR_Coverage, 13204,
     /*  54427 */     GIR_EraseRootFromParent_Done,
     /*  54428 */   // Label 877: @54428
     /*  54428 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54461), // Rule ID 159 //
     /*  54433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54448 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54459 */     GIR_RootConstrainSelectedInstOperands,
     /*  54460 */     // GIR_Coverage, 159,
     /*  54460 */     GIR_EraseRootFromParent_Done,
     /*  54461 */   // Label 878: @54461
     /*  54461 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54525), // Rule ID 13862 //
     /*  54466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54498 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54512 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54517 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54523 */     GIR_RootConstrainSelectedInstOperands,
     /*  54524 */     // GIR_Coverage, 13862,
     /*  54524 */     GIR_EraseRootFromParent_Done,
     /*  54525 */   // Label 879: @54525
     /*  54525 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54589), // Rule ID 5044 //
     /*  54530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54566 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54576 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54581 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54587 */     GIR_RootConstrainSelectedInstOperands,
     /*  54588 */     // GIR_Coverage, 5044,
     /*  54588 */     GIR_EraseRootFromParent_Done,
     /*  54589 */   // Label 880: @54589
     /*  54589 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54613), // Rule ID 157 //
     /*  54594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54606 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  54611 */     GIR_RootConstrainSelectedInstOperands,
     /*  54612 */     // GIR_Coverage, 157,
     /*  54612 */     GIR_Done,
     /*  54613 */   // Label 881: @54613
     /*  54613 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54640), // Rule ID 2484 //
     /*  54618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54633 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  54638 */     GIR_RootConstrainSelectedInstOperands,
     /*  54639 */     // GIR_Coverage, 2484,
     /*  54639 */     GIR_Done,
     /*  54640 */   // Label 882: @54640
     /*  54640 */   GIM_Reject,
     /*  54641 */ // Label 862: @54641
     /*  54641 */ GIM_Reject,
     /*  54642 */ // Label 834: @54642
     /*  54642 */ GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(54801),
     /*  54647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54657 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(54717), // Rule ID 13861 //
     /*  54662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54690 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54704 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54709 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54715 */     GIR_RootConstrainSelectedInstOperands,
     /*  54716 */     // GIR_Coverage, 13861,
     /*  54716 */     GIR_EraseRootFromParent_Done,
     /*  54717 */   // Label 884: @54717
     /*  54717 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(54777), // Rule ID 5043 //
     /*  54722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54754 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54764 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54769 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54775 */     GIR_RootConstrainSelectedInstOperands,
     /*  54776 */     // GIR_Coverage, 5043,
     /*  54776 */     GIR_EraseRootFromParent_Done,
     /*  54777 */   // Label 885: @54777
     /*  54777 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(54800), // Rule ID 2483 //
     /*  54782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54793 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  54798 */     GIR_RootConstrainSelectedInstOperands,
     /*  54799 */     // GIR_Coverage, 2483,
     /*  54799 */     GIR_Done,
     /*  54800 */   // Label 886: @54800
     /*  54800 */   GIM_Reject,
     /*  54801 */ // Label 883: @54801
     /*  54801 */ GIM_Reject,
     /*  54802 */ // Label 835: @54802
     /*  54802 */ GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(54961),
     /*  54807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54817 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(54877), // Rule ID 13865 //
     /*  54822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54850 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54856 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54864 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  54867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54869 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54875 */     GIR_RootConstrainSelectedInstOperands,
     /*  54876 */     // GIR_Coverage, 13865,
     /*  54876 */     GIR_EraseRootFromParent_Done,
     /*  54877 */   // Label 888: @54877
     /*  54877 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(54937), // Rule ID 5047 //
     /*  54882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54914 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54924 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  54927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54929 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54935 */     GIR_RootConstrainSelectedInstOperands,
     /*  54936 */     // GIR_Coverage, 5047,
     /*  54936 */     GIR_EraseRootFromParent_Done,
     /*  54937 */   // Label 889: @54937
     /*  54937 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(54960), // Rule ID 2487 //
     /*  54942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54953 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  54958 */     GIR_RootConstrainSelectedInstOperands,
     /*  54959 */     // GIR_Coverage, 2487,
     /*  54959 */     GIR_Done,
     /*  54960 */   // Label 890: @54960
     /*  54960 */   GIM_Reject,
     /*  54961 */ // Label 887: @54961
     /*  54961 */ GIM_Reject,
     /*  54962 */ // Label 836: @54962
     /*  54962 */ GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55121),
     /*  54967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  54970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54977 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55037), // Rule ID 13860 //
     /*  54982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  54997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55010 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55016 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55024 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55029 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55035 */     GIR_RootConstrainSelectedInstOperands,
     /*  55036 */     // GIR_Coverage, 13860,
     /*  55036 */     GIR_EraseRootFromParent_Done,
     /*  55037 */   // Label 892: @55037
     /*  55037 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(55097), // Rule ID 5042 //
     /*  55042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55074 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55080 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55084 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55089 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55095 */     GIR_RootConstrainSelectedInstOperands,
     /*  55096 */     // GIR_Coverage, 5042,
     /*  55096 */     GIR_EraseRootFromParent_Done,
     /*  55097 */   // Label 893: @55097
     /*  55097 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55120), // Rule ID 2482 //
     /*  55102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55113 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55118 */     GIR_RootConstrainSelectedInstOperands,
     /*  55119 */     // GIR_Coverage, 2482,
     /*  55119 */     GIR_Done,
     /*  55120 */   // Label 894: @55120
     /*  55120 */   GIM_Reject,
     /*  55121 */ // Label 891: @55121
     /*  55121 */ GIM_Reject,
     /*  55122 */ // Label 837: @55122
     /*  55122 */ GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55281),
     /*  55127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55137 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55197), // Rule ID 13864 //
     /*  55142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55170 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55184 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55189 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55195 */     GIR_RootConstrainSelectedInstOperands,
     /*  55196 */     // GIR_Coverage, 13864,
     /*  55196 */     GIR_EraseRootFromParent_Done,
     /*  55197 */   // Label 896: @55197
     /*  55197 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55257), // Rule ID 5046 //
     /*  55202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55234 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55240 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55244 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55249 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55255 */     GIR_RootConstrainSelectedInstOperands,
     /*  55256 */     // GIR_Coverage, 5046,
     /*  55256 */     GIR_EraseRootFromParent_Done,
     /*  55257 */   // Label 897: @55257
     /*  55257 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55280), // Rule ID 2486 //
     /*  55262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55273 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55278 */     GIR_RootConstrainSelectedInstOperands,
     /*  55279 */     // GIR_Coverage, 2486,
     /*  55279 */     GIR_Done,
     /*  55280 */   // Label 898: @55280
     /*  55280 */   GIM_Reject,
     /*  55281 */ // Label 895: @55281
     /*  55281 */ GIM_Reject,
     /*  55282 */ // Label 838: @55282
     /*  55282 */ GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55441),
     /*  55287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55297 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55357), // Rule ID 13343 //
     /*  55302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55330 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55344 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55355 */     GIR_RootConstrainSelectedInstOperands,
     /*  55356 */     // GIR_Coverage, 13343,
     /*  55356 */     GIR_EraseRootFromParent_Done,
     /*  55357 */   // Label 900: @55357
     /*  55357 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55417), // Rule ID 1597 //
     /*  55362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55394 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55404 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55415 */     GIR_RootConstrainSelectedInstOperands,
     /*  55416 */     // GIR_Coverage, 1597,
     /*  55416 */     GIR_EraseRootFromParent_Done,
     /*  55417 */   // Label 901: @55417
     /*  55417 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55440), // Rule ID 1595 //
     /*  55422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55433 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55438 */     GIR_RootConstrainSelectedInstOperands,
     /*  55439 */     // GIR_Coverage, 1595,
     /*  55439 */     GIR_Done,
     /*  55440 */   // Label 902: @55440
     /*  55440 */   GIM_Reject,
     /*  55441 */ // Label 899: @55441
     /*  55441 */ GIM_Reject,
     /*  55442 */ // Label 839: @55442
     /*  55442 */ GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55601),
     /*  55447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55457 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55517), // Rule ID 13863 //
     /*  55462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55490 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55496 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55504 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55509 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55515 */     GIR_RootConstrainSelectedInstOperands,
     /*  55516 */     // GIR_Coverage, 13863,
     /*  55516 */     GIR_EraseRootFromParent_Done,
     /*  55517 */   // Label 904: @55517
     /*  55517 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55577), // Rule ID 5045 //
     /*  55522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55554 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55564 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55569 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55575 */     GIR_RootConstrainSelectedInstOperands,
     /*  55576 */     // GIR_Coverage, 5045,
     /*  55576 */     GIR_EraseRootFromParent_Done,
     /*  55577 */   // Label 905: @55577
     /*  55577 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55600), // Rule ID 2485 //
     /*  55582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55593 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55598 */     GIR_RootConstrainSelectedInstOperands,
     /*  55599 */     // GIR_Coverage, 2485,
     /*  55599 */     GIR_Done,
     /*  55600 */   // Label 906: @55600
     /*  55600 */   GIM_Reject,
     /*  55601 */ // Label 903: @55601
     /*  55601 */ GIM_Reject,
     /*  55602 */ // Label 840: @55602
     /*  55602 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(55761),
     /*  55607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55617 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(55677), // Rule ID 13344 //
     /*  55622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55650 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55656 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55664 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55675 */     GIR_RootConstrainSelectedInstOperands,
     /*  55676 */     // GIR_Coverage, 13344,
     /*  55676 */     GIR_EraseRootFromParent_Done,
     /*  55677 */   // Label 908: @55677
     /*  55677 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(55737), // Rule ID 1598 //
     /*  55682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55714 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55724 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55735 */     GIR_RootConstrainSelectedInstOperands,
     /*  55736 */     // GIR_Coverage, 1598,
     /*  55736 */     GIR_EraseRootFromParent_Done,
     /*  55737 */   // Label 909: @55737
     /*  55737 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(55760), // Rule ID 1596 //
     /*  55742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55753 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55758 */     GIR_RootConstrainSelectedInstOperands,
     /*  55759 */     // GIR_Coverage, 1596,
     /*  55759 */     GIR_Done,
     /*  55760 */   // Label 910: @55760
     /*  55760 */   GIM_Reject,
     /*  55761 */ // Label 907: @55761
     /*  55761 */ GIM_Reject,
     /*  55762 */ // Label 841: @55762
     /*  55762 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(56302),
     /*  55767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  55777 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(55834), // Rule ID 15057 //
     /*  55782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55813 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55819 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55832 */     GIR_RootConstrainSelectedInstOperands,
     /*  55833 */     // GIR_Coverage, 15057,
     /*  55833 */     GIR_EraseRootFromParent_Done,
     /*  55834 */   // Label 912: @55834
     /*  55834 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(55891), // Rule ID 15060 //
     /*  55839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55870 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55876 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55889 */     GIR_RootConstrainSelectedInstOperands,
     /*  55890 */     // GIR_Coverage, 15060,
     /*  55890 */     GIR_EraseRootFromParent_Done,
     /*  55891 */   // Label 913: @55891
     /*  55891 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(55948), // Rule ID 15056 //
     /*  55896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55927 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55933 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55946 */     GIR_RootConstrainSelectedInstOperands,
     /*  55947 */     // GIR_Coverage, 15056,
     /*  55947 */     GIR_EraseRootFromParent_Done,
     /*  55948 */   // Label 914: @55948
     /*  55948 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(56005), // Rule ID 15059 //
     /*  55953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55984 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55990 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56003 */     GIR_RootConstrainSelectedInstOperands,
     /*  56004 */     // GIR_Coverage, 15059,
     /*  56004 */     GIR_EraseRootFromParent_Done,
     /*  56005 */   // Label 915: @56005
     /*  56005 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56062), // Rule ID 15055 //
     /*  56010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56041 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56047 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56060 */     GIR_RootConstrainSelectedInstOperands,
     /*  56061 */     // GIR_Coverage, 15055,
     /*  56061 */     GIR_EraseRootFromParent_Done,
     /*  56062 */   // Label 916: @56062
     /*  56062 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(56119), // Rule ID 15058 //
     /*  56067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56104 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56117 */     GIR_RootConstrainSelectedInstOperands,
     /*  56118 */     // GIR_Coverage, 15058,
     /*  56118 */     GIR_EraseRootFromParent_Done,
     /*  56119 */   // Label 917: @56119
     /*  56119 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(56176), // Rule ID 8407 //
     /*  56124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56155 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56161 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56174 */     GIR_RootConstrainSelectedInstOperands,
     /*  56175 */     // GIR_Coverage, 8407,
     /*  56175 */     GIR_EraseRootFromParent_Done,
     /*  56176 */   // Label 918: @56176
     /*  56176 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(56233), // Rule ID 8408 //
     /*  56181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56212 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56218 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56231 */     GIR_RootConstrainSelectedInstOperands,
     /*  56232 */     // GIR_Coverage, 8408,
     /*  56232 */     GIR_EraseRootFromParent_Done,
     /*  56233 */   // Label 919: @56233
     /*  56233 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56280), // Rule ID 10671 //
     /*  56238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56249 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56261 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56278 */     GIR_RootConstrainSelectedInstOperands,
     /*  56279 */     // GIR_Coverage, 10671,
     /*  56279 */     GIR_EraseRootFromParent_Done,
     /*  56280 */   // Label 920: @56280
     /*  56280 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56301), // Rule ID 2753 //
     /*  56285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56288 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56299 */     GIR_RootConstrainSelectedInstOperands,
     /*  56300 */     // GIR_Coverage, 2753,
     /*  56300 */     GIR_EraseRootFromParent_Done,
     /*  56301 */   // Label 921: @56301
     /*  56301 */   GIM_Reject,
     /*  56302 */ // Label 911: @56302
     /*  56302 */ GIM_Reject,
     /*  56303 */ // Label 842: @56303
     /*  56303 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56843),
     /*  56308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56318 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56375), // Rule ID 15048 //
     /*  56323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56354 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56360 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56373 */     GIR_RootConstrainSelectedInstOperands,
     /*  56374 */     // GIR_Coverage, 15048,
     /*  56374 */     GIR_EraseRootFromParent_Done,
     /*  56375 */   // Label 923: @56375
     /*  56375 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56432), // Rule ID 15051 //
     /*  56380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56411 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56417 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56430 */     GIR_RootConstrainSelectedInstOperands,
     /*  56431 */     // GIR_Coverage, 15051,
     /*  56431 */     GIR_EraseRootFromParent_Done,
     /*  56432 */   // Label 924: @56432
     /*  56432 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56489), // Rule ID 15047 //
     /*  56437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56468 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56474 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56487 */     GIR_RootConstrainSelectedInstOperands,
     /*  56488 */     // GIR_Coverage, 15047,
     /*  56488 */     GIR_EraseRootFromParent_Done,
     /*  56489 */   // Label 925: @56489
     /*  56489 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56546), // Rule ID 15050 //
     /*  56494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56525 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56531 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56544 */     GIR_RootConstrainSelectedInstOperands,
     /*  56545 */     // GIR_Coverage, 15050,
     /*  56545 */     GIR_EraseRootFromParent_Done,
     /*  56546 */   // Label 926: @56546
     /*  56546 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56603), // Rule ID 15046 //
     /*  56551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56582 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56588 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56601 */     GIR_RootConstrainSelectedInstOperands,
     /*  56602 */     // GIR_Coverage, 15046,
     /*  56602 */     GIR_EraseRootFromParent_Done,
     /*  56603 */   // Label 927: @56603
     /*  56603 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56660), // Rule ID 15049 //
     /*  56608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56639 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56645 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56658 */     GIR_RootConstrainSelectedInstOperands,
     /*  56659 */     // GIR_Coverage, 15049,
     /*  56659 */     GIR_EraseRootFromParent_Done,
     /*  56660 */   // Label 928: @56660
     /*  56660 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(56717), // Rule ID 8403 //
     /*  56665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56696 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56702 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56715 */     GIR_RootConstrainSelectedInstOperands,
     /*  56716 */     // GIR_Coverage, 8403,
     /*  56716 */     GIR_EraseRootFromParent_Done,
     /*  56717 */   // Label 929: @56717
     /*  56717 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(56774), // Rule ID 8404 //
     /*  56722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56753 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56759 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56772 */     GIR_RootConstrainSelectedInstOperands,
     /*  56773 */     // GIR_Coverage, 8404,
     /*  56773 */     GIR_EraseRootFromParent_Done,
     /*  56774 */   // Label 930: @56774
     /*  56774 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(56821), // Rule ID 10670 //
     /*  56779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56790 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  56790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56802 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56819 */     GIR_RootConstrainSelectedInstOperands,
     /*  56820 */     // GIR_Coverage, 10670,
     /*  56820 */     GIR_EraseRootFromParent_Done,
     /*  56821 */   // Label 931: @56821
     /*  56821 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(56842), // Rule ID 2752 //
     /*  56826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56829 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56840 */     GIR_RootConstrainSelectedInstOperands,
     /*  56841 */     // GIR_Coverage, 2752,
     /*  56841 */     GIR_EraseRootFromParent_Done,
     /*  56842 */   // Label 932: @56842
     /*  56842 */   GIM_Reject,
     /*  56843 */ // Label 922: @56843
     /*  56843 */ GIM_Reject,
     /*  56844 */ // Label 843: @56844
     /*  56844 */ GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57315),
     /*  56849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  56859 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(56914), // Rule ID 14988 //
     /*  56864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56895 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56901 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  56901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56912 */     GIR_RootConstrainSelectedInstOperands,
     /*  56913 */     // GIR_Coverage, 14988,
     /*  56913 */     GIR_EraseRootFromParent_Done,
     /*  56914 */   // Label 934: @56914
     /*  56914 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(56969), // Rule ID 14991 //
     /*  56919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56950 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56956 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  56956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56967 */     GIR_RootConstrainSelectedInstOperands,
     /*  56968 */     // GIR_Coverage, 14991,
     /*  56968 */     GIR_EraseRootFromParent_Done,
     /*  56969 */   // Label 935: @56969
     /*  56969 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57024), // Rule ID 14987 //
     /*  56974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57005 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57011 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57022 */     GIR_RootConstrainSelectedInstOperands,
     /*  57023 */     // GIR_Coverage, 14987,
     /*  57023 */     GIR_EraseRootFromParent_Done,
     /*  57024 */   // Label 936: @57024
     /*  57024 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57079), // Rule ID 14990 //
     /*  57029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57060 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57066 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57077 */     GIR_RootConstrainSelectedInstOperands,
     /*  57078 */     // GIR_Coverage, 14990,
     /*  57078 */     GIR_EraseRootFromParent_Done,
     /*  57079 */   // Label 937: @57079
     /*  57079 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57134), // Rule ID 14986 //
     /*  57084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57115 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57121 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57132 */     GIR_RootConstrainSelectedInstOperands,
     /*  57133 */     // GIR_Coverage, 14986,
     /*  57133 */     GIR_EraseRootFromParent_Done,
     /*  57134 */   // Label 938: @57134
     /*  57134 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57189), // Rule ID 14989 //
     /*  57139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57170 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57176 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57187 */     GIR_RootConstrainSelectedInstOperands,
     /*  57188 */     // GIR_Coverage, 14989,
     /*  57188 */     GIR_EraseRootFromParent_Done,
     /*  57189 */   // Label 939: @57189
     /*  57189 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57244), // Rule ID 7452 //
     /*  57194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57225 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57231 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57242 */     GIR_RootConstrainSelectedInstOperands,
     /*  57243 */     // GIR_Coverage, 7452,
     /*  57243 */     GIR_EraseRootFromParent_Done,
     /*  57244 */   // Label 940: @57244
     /*  57244 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(57299), // Rule ID 7453 //
     /*  57249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57280 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57286 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57297 */     GIR_RootConstrainSelectedInstOperands,
     /*  57298 */     // GIR_Coverage, 7453,
     /*  57298 */     GIR_EraseRootFromParent_Done,
     /*  57299 */   // Label 941: @57299
     /*  57299 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57314), // Rule ID 3146 //
     /*  57304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57307 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57312 */     GIR_RootConstrainSelectedInstOperands,
     /*  57313 */     // GIR_Coverage, 3146,
     /*  57313 */     GIR_Done,
     /*  57314 */   // Label 942: @57314
     /*  57314 */   GIM_Reject,
     /*  57315 */ // Label 933: @57315
     /*  57315 */ GIM_Reject,
     /*  57316 */ // Label 844: @57316
     /*  57316 */ GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57856),
     /*  57321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57331 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57388), // Rule ID 15039 //
     /*  57336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57367 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57373 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57386 */     GIR_RootConstrainSelectedInstOperands,
     /*  57387 */     // GIR_Coverage, 15039,
     /*  57387 */     GIR_EraseRootFromParent_Done,
     /*  57388 */   // Label 944: @57388
     /*  57388 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57445), // Rule ID 15042 //
     /*  57393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57424 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57430 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57443 */     GIR_RootConstrainSelectedInstOperands,
     /*  57444 */     // GIR_Coverage, 15042,
     /*  57444 */     GIR_EraseRootFromParent_Done,
     /*  57445 */   // Label 945: @57445
     /*  57445 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57502), // Rule ID 15038 //
     /*  57450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57481 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57487 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57500 */     GIR_RootConstrainSelectedInstOperands,
     /*  57501 */     // GIR_Coverage, 15038,
     /*  57501 */     GIR_EraseRootFromParent_Done,
     /*  57502 */   // Label 946: @57502
     /*  57502 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57559), // Rule ID 15041 //
     /*  57507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57538 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57544 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57557 */     GIR_RootConstrainSelectedInstOperands,
     /*  57558 */     // GIR_Coverage, 15041,
     /*  57558 */     GIR_EraseRootFromParent_Done,
     /*  57559 */   // Label 947: @57559
     /*  57559 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57616), // Rule ID 15037 //
     /*  57564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57595 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57601 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57614 */     GIR_RootConstrainSelectedInstOperands,
     /*  57615 */     // GIR_Coverage, 15037,
     /*  57615 */     GIR_EraseRootFromParent_Done,
     /*  57616 */   // Label 948: @57616
     /*  57616 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(57673), // Rule ID 15040 //
     /*  57621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57652 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57658 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57671 */     GIR_RootConstrainSelectedInstOperands,
     /*  57672 */     // GIR_Coverage, 15040,
     /*  57672 */     GIR_EraseRootFromParent_Done,
     /*  57673 */   // Label 949: @57673
     /*  57673 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(57730), // Rule ID 8399 //
     /*  57678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57709 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57715 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57728 */     GIR_RootConstrainSelectedInstOperands,
     /*  57729 */     // GIR_Coverage, 8399,
     /*  57729 */     GIR_EraseRootFromParent_Done,
     /*  57730 */   // Label 950: @57730
     /*  57730 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(57787), // Rule ID 8400 //
     /*  57735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57766 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57772 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57785 */     GIR_RootConstrainSelectedInstOperands,
     /*  57786 */     // GIR_Coverage, 8400,
     /*  57786 */     GIR_EraseRootFromParent_Done,
     /*  57787 */   // Label 951: @57787
     /*  57787 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(57834), // Rule ID 10669 //
     /*  57792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57803 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  57803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  57810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57815 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57832 */     GIR_RootConstrainSelectedInstOperands,
     /*  57833 */     // GIR_Coverage, 10669,
     /*  57833 */     GIR_EraseRootFromParent_Done,
     /*  57834 */   // Label 952: @57834
     /*  57834 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(57855), // Rule ID 2751 //
     /*  57839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57842 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57853 */     GIR_RootConstrainSelectedInstOperands,
     /*  57854 */     // GIR_Coverage, 2751,
     /*  57854 */     GIR_EraseRootFromParent_Done,
     /*  57855 */   // Label 953: @57855
     /*  57855 */   GIM_Reject,
     /*  57856 */ // Label 943: @57856
     /*  57856 */ GIM_Reject,
     /*  57857 */ // Label 845: @57857
     /*  57857 */ GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58328),
     /*  57862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57872 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(57927), // Rule ID 14979 //
     /*  57877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57908 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57914 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  57914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57925 */     GIR_RootConstrainSelectedInstOperands,
     /*  57926 */     // GIR_Coverage, 14979,
     /*  57926 */     GIR_EraseRootFromParent_Done,
     /*  57927 */   // Label 955: @57927
     /*  57927 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(57982), // Rule ID 14982 //
     /*  57932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57963 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57969 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  57969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57980 */     GIR_RootConstrainSelectedInstOperands,
     /*  57981 */     // GIR_Coverage, 14982,
     /*  57981 */     GIR_EraseRootFromParent_Done,
     /*  57982 */   // Label 956: @57982
     /*  57982 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58037), // Rule ID 14978 //
     /*  57987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58018 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58024 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58035 */     GIR_RootConstrainSelectedInstOperands,
     /*  58036 */     // GIR_Coverage, 14978,
     /*  58036 */     GIR_EraseRootFromParent_Done,
     /*  58037 */   // Label 957: @58037
     /*  58037 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58092), // Rule ID 14981 //
     /*  58042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58073 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58079 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58090 */     GIR_RootConstrainSelectedInstOperands,
     /*  58091 */     // GIR_Coverage, 14981,
     /*  58091 */     GIR_EraseRootFromParent_Done,
     /*  58092 */   // Label 958: @58092
     /*  58092 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58147), // Rule ID 14977 //
     /*  58097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58128 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58134 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58145 */     GIR_RootConstrainSelectedInstOperands,
     /*  58146 */     // GIR_Coverage, 14977,
     /*  58146 */     GIR_EraseRootFromParent_Done,
     /*  58147 */   // Label 959: @58147
     /*  58147 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58202), // Rule ID 14980 //
     /*  58152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58183 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58189 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58200 */     GIR_RootConstrainSelectedInstOperands,
     /*  58201 */     // GIR_Coverage, 14980,
     /*  58201 */     GIR_EraseRootFromParent_Done,
     /*  58202 */   // Label 960: @58202
     /*  58202 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58257), // Rule ID 7448 //
     /*  58207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58238 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58244 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58255 */     GIR_RootConstrainSelectedInstOperands,
     /*  58256 */     // GIR_Coverage, 7448,
     /*  58256 */     GIR_EraseRootFromParent_Done,
     /*  58257 */   // Label 961: @58257
     /*  58257 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(58312), // Rule ID 7449 //
     /*  58262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58293 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58299 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58310 */     GIR_RootConstrainSelectedInstOperands,
     /*  58311 */     // GIR_Coverage, 7449,
     /*  58311 */     GIR_EraseRootFromParent_Done,
     /*  58312 */   // Label 962: @58312
     /*  58312 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58327), // Rule ID 3145 //
     /*  58317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58320 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58325 */     GIR_RootConstrainSelectedInstOperands,
     /*  58326 */     // GIR_Coverage, 3145,
     /*  58326 */     GIR_Done,
     /*  58327 */   // Label 963: @58327
     /*  58327 */   GIM_Reject,
     /*  58328 */ // Label 954: @58328
     /*  58328 */ GIM_Reject,
     /*  58329 */ // Label 846: @58329
     /*  58329 */ GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58869),
     /*  58334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58344 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58401), // Rule ID 15030 //
     /*  58349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58380 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58386 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58399 */     GIR_RootConstrainSelectedInstOperands,
     /*  58400 */     // GIR_Coverage, 15030,
     /*  58400 */     GIR_EraseRootFromParent_Done,
     /*  58401 */   // Label 965: @58401
     /*  58401 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58458), // Rule ID 15033 //
     /*  58406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58437 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58443 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58456 */     GIR_RootConstrainSelectedInstOperands,
     /*  58457 */     // GIR_Coverage, 15033,
     /*  58457 */     GIR_EraseRootFromParent_Done,
     /*  58458 */   // Label 966: @58458
     /*  58458 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58515), // Rule ID 15029 //
     /*  58463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58500 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58513 */     GIR_RootConstrainSelectedInstOperands,
     /*  58514 */     // GIR_Coverage, 15029,
     /*  58514 */     GIR_EraseRootFromParent_Done,
     /*  58515 */   // Label 967: @58515
     /*  58515 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58572), // Rule ID 15032 //
     /*  58520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58551 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58557 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58570 */     GIR_RootConstrainSelectedInstOperands,
     /*  58571 */     // GIR_Coverage, 15032,
     /*  58571 */     GIR_EraseRootFromParent_Done,
     /*  58572 */   // Label 968: @58572
     /*  58572 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58629), // Rule ID 15028 //
     /*  58577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58614 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58627 */     GIR_RootConstrainSelectedInstOperands,
     /*  58628 */     // GIR_Coverage, 15028,
     /*  58628 */     GIR_EraseRootFromParent_Done,
     /*  58629 */   // Label 969: @58629
     /*  58629 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(58686), // Rule ID 15031 //
     /*  58634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58665 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58671 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58684 */     GIR_RootConstrainSelectedInstOperands,
     /*  58685 */     // GIR_Coverage, 15031,
     /*  58685 */     GIR_EraseRootFromParent_Done,
     /*  58686 */   // Label 970: @58686
     /*  58686 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(58743), // Rule ID 8395 //
     /*  58691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58722 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58728 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58741 */     GIR_RootConstrainSelectedInstOperands,
     /*  58742 */     // GIR_Coverage, 8395,
     /*  58742 */     GIR_EraseRootFromParent_Done,
     /*  58743 */   // Label 971: @58743
     /*  58743 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(58800), // Rule ID 8396 //
     /*  58748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58779 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58785 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58798 */     GIR_RootConstrainSelectedInstOperands,
     /*  58799 */     // GIR_Coverage, 8396,
     /*  58799 */     GIR_EraseRootFromParent_Done,
     /*  58800 */   // Label 972: @58800
     /*  58800 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(58847), // Rule ID 10668 //
     /*  58805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58816 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  58816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  58823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58845 */     GIR_RootConstrainSelectedInstOperands,
     /*  58846 */     // GIR_Coverage, 10668,
     /*  58846 */     GIR_EraseRootFromParent_Done,
     /*  58847 */   // Label 973: @58847
     /*  58847 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(58868), // Rule ID 2750 //
     /*  58852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58855 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58866 */     GIR_RootConstrainSelectedInstOperands,
     /*  58867 */     // GIR_Coverage, 2750,
     /*  58867 */     GIR_EraseRootFromParent_Done,
     /*  58868 */   // Label 974: @58868
     /*  58868 */   GIM_Reject,
     /*  58869 */ // Label 964: @58869
     /*  58869 */ GIM_Reject,
     /*  58870 */ // Label 847: @58870
     /*  58870 */ GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59341),
     /*  58875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58885 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(58940), // Rule ID 14970 //
     /*  58890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58921 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58927 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  58927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58938 */     GIR_RootConstrainSelectedInstOperands,
     /*  58939 */     // GIR_Coverage, 14970,
     /*  58939 */     GIR_EraseRootFromParent_Done,
     /*  58940 */   // Label 976: @58940
     /*  58940 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(58995), // Rule ID 14973 //
     /*  58945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58976 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58982 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  58982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58993 */     GIR_RootConstrainSelectedInstOperands,
     /*  58994 */     // GIR_Coverage, 14973,
     /*  58994 */     GIR_EraseRootFromParent_Done,
     /*  58995 */   // Label 977: @58995
     /*  58995 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59050), // Rule ID 14969 //
     /*  59000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59031 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59037 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59048 */     GIR_RootConstrainSelectedInstOperands,
     /*  59049 */     // GIR_Coverage, 14969,
     /*  59049 */     GIR_EraseRootFromParent_Done,
     /*  59050 */   // Label 978: @59050
     /*  59050 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59105), // Rule ID 14972 //
     /*  59055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59086 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59092 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59103 */     GIR_RootConstrainSelectedInstOperands,
     /*  59104 */     // GIR_Coverage, 14972,
     /*  59104 */     GIR_EraseRootFromParent_Done,
     /*  59105 */   // Label 979: @59105
     /*  59105 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59160), // Rule ID 14968 //
     /*  59110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59141 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59147 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59158 */     GIR_RootConstrainSelectedInstOperands,
     /*  59159 */     // GIR_Coverage, 14968,
     /*  59159 */     GIR_EraseRootFromParent_Done,
     /*  59160 */   // Label 980: @59160
     /*  59160 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59215), // Rule ID 14971 //
     /*  59165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59196 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59202 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59213 */     GIR_RootConstrainSelectedInstOperands,
     /*  59214 */     // GIR_Coverage, 14971,
     /*  59214 */     GIR_EraseRootFromParent_Done,
     /*  59215 */   // Label 981: @59215
     /*  59215 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59270), // Rule ID 7444 //
     /*  59220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59251 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59257 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59268 */     GIR_RootConstrainSelectedInstOperands,
     /*  59269 */     // GIR_Coverage, 7444,
     /*  59269 */     GIR_EraseRootFromParent_Done,
     /*  59270 */   // Label 982: @59270
     /*  59270 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(59325), // Rule ID 7445 //
     /*  59275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59306 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59312 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59323 */     GIR_RootConstrainSelectedInstOperands,
     /*  59324 */     // GIR_Coverage, 7445,
     /*  59324 */     GIR_EraseRootFromParent_Done,
     /*  59325 */   // Label 983: @59325
     /*  59325 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59340), // Rule ID 3144 //
     /*  59330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59333 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59338 */     GIR_RootConstrainSelectedInstOperands,
     /*  59339 */     // GIR_Coverage, 3144,
     /*  59339 */     GIR_Done,
     /*  59340 */   // Label 984: @59340
     /*  59340 */   GIM_Reject,
     /*  59341 */ // Label 975: @59341
     /*  59341 */ GIM_Reject,
     /*  59342 */ // Label 848: @59342
     /*  59342 */ GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59882),
     /*  59347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59357 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59414), // Rule ID 15021 //
     /*  59362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59393 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59399 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59412 */     GIR_RootConstrainSelectedInstOperands,
     /*  59413 */     // GIR_Coverage, 15021,
     /*  59413 */     GIR_EraseRootFromParent_Done,
     /*  59414 */   // Label 986: @59414
     /*  59414 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59471), // Rule ID 15024 //
     /*  59419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59450 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59456 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59469 */     GIR_RootConstrainSelectedInstOperands,
     /*  59470 */     // GIR_Coverage, 15024,
     /*  59470 */     GIR_EraseRootFromParent_Done,
     /*  59471 */   // Label 987: @59471
     /*  59471 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59528), // Rule ID 15020 //
     /*  59476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59507 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59513 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59526 */     GIR_RootConstrainSelectedInstOperands,
     /*  59527 */     // GIR_Coverage, 15020,
     /*  59527 */     GIR_EraseRootFromParent_Done,
     /*  59528 */   // Label 988: @59528
     /*  59528 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59585), // Rule ID 15023 //
     /*  59533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59564 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59570 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59583 */     GIR_RootConstrainSelectedInstOperands,
     /*  59584 */     // GIR_Coverage, 15023,
     /*  59584 */     GIR_EraseRootFromParent_Done,
     /*  59585 */   // Label 989: @59585
     /*  59585 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59642), // Rule ID 15019 //
     /*  59590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59627 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59640 */     GIR_RootConstrainSelectedInstOperands,
     /*  59641 */     // GIR_Coverage, 15019,
     /*  59641 */     GIR_EraseRootFromParent_Done,
     /*  59642 */   // Label 990: @59642
     /*  59642 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(59699), // Rule ID 15022 //
     /*  59647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59678 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59684 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59697 */     GIR_RootConstrainSelectedInstOperands,
     /*  59698 */     // GIR_Coverage, 15022,
     /*  59698 */     GIR_EraseRootFromParent_Done,
     /*  59699 */   // Label 991: @59699
     /*  59699 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(59756), // Rule ID 8391 //
     /*  59704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59735 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59741 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59754 */     GIR_RootConstrainSelectedInstOperands,
     /*  59755 */     // GIR_Coverage, 8391,
     /*  59755 */     GIR_EraseRootFromParent_Done,
     /*  59756 */   // Label 992: @59756
     /*  59756 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(59813), // Rule ID 8392 //
     /*  59761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59798 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59811 */     GIR_RootConstrainSelectedInstOperands,
     /*  59812 */     // GIR_Coverage, 8392,
     /*  59812 */     GIR_EraseRootFromParent_Done,
     /*  59813 */   // Label 993: @59813
     /*  59813 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(59860), // Rule ID 10667 //
     /*  59818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59829 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  59829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  59836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59858 */     GIR_RootConstrainSelectedInstOperands,
     /*  59859 */     // GIR_Coverage, 10667,
     /*  59859 */     GIR_EraseRootFromParent_Done,
     /*  59860 */   // Label 994: @59860
     /*  59860 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(59881), // Rule ID 2749 //
     /*  59865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59868 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59879 */     GIR_RootConstrainSelectedInstOperands,
     /*  59880 */     // GIR_Coverage, 2749,
     /*  59880 */     GIR_EraseRootFromParent_Done,
     /*  59881 */   // Label 995: @59881
     /*  59881 */   GIM_Reject,
     /*  59882 */ // Label 985: @59882
     /*  59882 */ GIM_Reject,
     /*  59883 */ // Label 849: @59883
     /*  59883 */ GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60354),
     /*  59888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59898 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(59953), // Rule ID 14961 //
     /*  59903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59934 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59940 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  59940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59951 */     GIR_RootConstrainSelectedInstOperands,
     /*  59952 */     // GIR_Coverage, 14961,
     /*  59952 */     GIR_EraseRootFromParent_Done,
     /*  59953 */   // Label 997: @59953
     /*  59953 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(60008), // Rule ID 14964 //
     /*  59958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59989 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59995 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  59995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60006 */     GIR_RootConstrainSelectedInstOperands,
     /*  60007 */     // GIR_Coverage, 14964,
     /*  60007 */     GIR_EraseRootFromParent_Done,
     /*  60008 */   // Label 998: @60008
     /*  60008 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(60063), // Rule ID 14960 //
     /*  60013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60044 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60050 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60061 */     GIR_RootConstrainSelectedInstOperands,
     /*  60062 */     // GIR_Coverage, 14960,
     /*  60062 */     GIR_EraseRootFromParent_Done,
     /*  60063 */   // Label 999: @60063
     /*  60063 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(60118), // Rule ID 14963 //
     /*  60068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60099 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60105 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60116 */     GIR_RootConstrainSelectedInstOperands,
     /*  60117 */     // GIR_Coverage, 14963,
     /*  60117 */     GIR_EraseRootFromParent_Done,
     /*  60118 */   // Label 1000: @60118
     /*  60118 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60173), // Rule ID 14959 //
     /*  60123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60154 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60160 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60171 */     GIR_RootConstrainSelectedInstOperands,
     /*  60172 */     // GIR_Coverage, 14959,
     /*  60172 */     GIR_EraseRootFromParent_Done,
     /*  60173 */   // Label 1001: @60173
     /*  60173 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60228), // Rule ID 14962 //
     /*  60178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60209 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60215 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60226 */     GIR_RootConstrainSelectedInstOperands,
     /*  60227 */     // GIR_Coverage, 14962,
     /*  60227 */     GIR_EraseRootFromParent_Done,
     /*  60228 */   // Label 1002: @60228
     /*  60228 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60283), // Rule ID 7440 //
     /*  60233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60264 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60270 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60281 */     GIR_RootConstrainSelectedInstOperands,
     /*  60282 */     // GIR_Coverage, 7440,
     /*  60282 */     GIR_EraseRootFromParent_Done,
     /*  60283 */   // Label 1003: @60283
     /*  60283 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(60338), // Rule ID 7441 //
     /*  60288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60319 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60325 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60336 */     GIR_RootConstrainSelectedInstOperands,
     /*  60337 */     // GIR_Coverage, 7441,
     /*  60337 */     GIR_EraseRootFromParent_Done,
     /*  60338 */   // Label 1004: @60338
     /*  60338 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60353), // Rule ID 3143 //
     /*  60343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60346 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60351 */     GIR_RootConstrainSelectedInstOperands,
     /*  60352 */     // GIR_Coverage, 3143,
     /*  60352 */     GIR_Done,
     /*  60353 */   // Label 1005: @60353
     /*  60353 */   GIM_Reject,
     /*  60354 */ // Label 996: @60354
     /*  60354 */ GIM_Reject,
     /*  60355 */ // Label 850: @60355
     /*  60355 */ GIM_Reject,
     /*  60356 */ // Label 6: @60356
     /*  60356 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1024*/ GIMT_Encode4(72134),
     /*  60367 */ /*GILLT_s32*//*Label 1006*/ GIMT_Encode4(60455),
     /*  60371 */ /*GILLT_s64*//*Label 1007*/ GIMT_Encode4(60815), GIMT_Encode4(0),
     /*  60379 */ /*GILLT_v2s32*//*Label 1008*/ GIMT_Encode4(62714),
     /*  60383 */ /*GILLT_v2s64*//*Label 1009*/ GIMT_Encode4(64022),
     /*  60387 */ /*GILLT_v4s16*//*Label 1010*/ GIMT_Encode4(65330),
     /*  60391 */ /*GILLT_v4s32*//*Label 1011*/ GIMT_Encode4(66638),
     /*  60395 */ /*GILLT_v8s8*//*Label 1012*/ GIMT_Encode4(67946),
     /*  60399 */ /*GILLT_v8s16*//*Label 1013*/ GIMT_Encode4(69254),
     /*  60403 */ /*GILLT_v16s8*//*Label 1014*/ GIMT_Encode4(70562),
     /*  60407 */ /*GILLT_nxv1s1*//*Label 1015*/ GIMT_Encode4(71870),
     /*  60411 */ /*GILLT_nxv2s1*//*Label 1016*/ GIMT_Encode4(71902), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  60423 */ /*GILLT_nxv2s64*//*Label 1017*/ GIMT_Encode4(71934),
     /*  60427 */ /*GILLT_nxv4s1*//*Label 1018*/ GIMT_Encode4(71960), GIMT_Encode4(0),
     /*  60435 */ /*GILLT_nxv4s32*//*Label 1019*/ GIMT_Encode4(71992),
     /*  60439 */ /*GILLT_nxv8s1*//*Label 1020*/ GIMT_Encode4(72018),
     /*  60443 */ /*GILLT_nxv8s16*//*Label 1021*/ GIMT_Encode4(72050),
     /*  60447 */ /*GILLT_nxv16s1*//*Label 1022*/ GIMT_Encode4(72076),
     /*  60451 */ /*GILLT_nxv16s8*//*Label 1023*/ GIMT_Encode4(72108),
     /*  60455 */ // Label 1006: @60455
     /*  60455 */ GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(60814),
     /*  60460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60466 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(60521), // Rule ID 13227 //
     /*  60471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60508 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60519 */     GIR_RootConstrainSelectedInstOperands,
     /*  60520 */     // GIR_Coverage, 13227,
     /*  60520 */     GIR_EraseRootFromParent_Done,
     /*  60521 */   // Label 1026: @60521
     /*  60521 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(60576), // Rule ID 174 //
     /*  60526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60550 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60556 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60563 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60574 */     GIR_RootConstrainSelectedInstOperands,
     /*  60575 */     // GIR_Coverage, 174,
     /*  60575 */     GIR_EraseRootFromParent_Done,
     /*  60576 */   // Label 1027: @60576
     /*  60576 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(60617), // Rule ID 146 //
     /*  60581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  60585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60597 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  60601 */     // MIs[1] Operand 1
     /*  60601 */     // No operand predicates
     /*  60601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60603 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  60603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  60606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60610 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  60615 */     GIR_RootConstrainSelectedInstOperands,
     /*  60616 */     // GIR_Coverage, 146,
     /*  60616 */     GIR_EraseRootFromParent_Done,
     /*  60617 */   // Label 1028: @60617
     /*  60617 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(60650), // Rule ID 13229 //
     /*  60622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60637 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60648 */     GIR_RootConstrainSelectedInstOperands,
     /*  60649 */     // GIR_Coverage, 13229,
     /*  60649 */     GIR_EraseRootFromParent_Done,
     /*  60650 */   // Label 1029: @60650
     /*  60650 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(60683), // Rule ID 178 //
     /*  60655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60670 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60681 */     GIR_RootConstrainSelectedInstOperands,
     /*  60682 */     // GIR_Coverage, 178,
     /*  60682 */     GIR_EraseRootFromParent_Done,
     /*  60683 */   // Label 1030: @60683
     /*  60683 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(60736), // Rule ID 13225 //
     /*  60688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60713 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60723 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  60726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60734 */     GIR_RootConstrainSelectedInstOperands,
     /*  60735 */     // GIR_Coverage, 13225,
     /*  60735 */     GIR_EraseRootFromParent_Done,
     /*  60736 */   // Label 1031: @60736
     /*  60736 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(60789), // Rule ID 172 //
     /*  60741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60770 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60776 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  60779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60787 */     GIR_RootConstrainSelectedInstOperands,
     /*  60788 */     // GIR_Coverage, 172,
     /*  60788 */     GIR_EraseRootFromParent_Done,
     /*  60789 */   // Label 1032: @60789
     /*  60789 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(60813), // Rule ID 176 //
     /*  60794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60806 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  60811 */     GIR_RootConstrainSelectedInstOperands,
     /*  60812 */     // GIR_Coverage, 176,
     /*  60812 */     GIR_Done,
     /*  60813 */   // Label 1033: @60813
     /*  60813 */   GIM_Reject,
     /*  60814 */ // Label 1025: @60814
     /*  60814 */ GIM_Reject,
     /*  60815 */ // Label 1007: @60815
     /*  60815 */ GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(62713),
     /*  60820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  60823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60826 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(60948), // Rule ID 4017 //
     /*  60831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  60859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  60867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60872 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  60876 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  60887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  60891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  60899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  60903 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  60907 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  60911 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  60915 */     // MIs[4] Rn
     /*  60915 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60920 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  60924 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  60935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60937 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  60937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  60940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  60946 */     GIR_RootConstrainSelectedInstOperands,
     /*  60947 */     // GIR_Coverage, 4017,
     /*  60947 */     GIR_EraseRootFromParent_Done,
     /*  60948 */   // Label 1035: @60948
     /*  60948 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61070), // Rule ID 13777 //
     /*  60953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  60981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  60989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60994 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  60998 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61021 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61033 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61037 */     // MIs[4] Rn
     /*  61037 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61042 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61046 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61057 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61059 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61068 */     GIR_RootConstrainSelectedInstOperands,
     /*  61069 */     // GIR_Coverage, 13777,
     /*  61069 */     GIR_EraseRootFromParent_Done,
     /*  61070 */   // Label 1036: @61070
     /*  61070 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61125), // Rule ID 13228 //
     /*  61075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61095 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61112 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61123 */     GIR_RootConstrainSelectedInstOperands,
     /*  61124 */     // GIR_Coverage, 13228,
     /*  61124 */     GIR_EraseRootFromParent_Done,
     /*  61125 */   // Label 1037: @61125
     /*  61125 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61180), // Rule ID 175 //
     /*  61130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61154 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61167 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61178 */     GIR_RootConstrainSelectedInstOperands,
     /*  61179 */     // GIR_Coverage, 175,
     /*  61179 */     GIR_EraseRootFromParent_Done,
     /*  61180 */   // Label 1038: @61180
     /*  61180 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(61289), // Rule ID 13577 //
     /*  61185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61233 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61246 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61250 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61254 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61258 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61263 */     // MIs[4] LHS
     /*  61263 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61268 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61270 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61287 */     GIR_RootConstrainSelectedInstOperands,
     /*  61288 */     // GIR_Coverage, 13577,
     /*  61288 */     GIR_EraseRootFromParent_Done,
     /*  61289 */   // Label 1039: @61289
     /*  61289 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(61398), // Rule ID 13576 //
     /*  61294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61342 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61348 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61355 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61359 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61363 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61367 */     // MIs[4] LHS
     /*  61367 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61377 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61379 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61396 */     GIR_RootConstrainSelectedInstOperands,
     /*  61397 */     // GIR_Coverage, 13576,
     /*  61397 */     GIR_EraseRootFromParent_Done,
     /*  61398 */   // Label 1040: @61398
     /*  61398 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61507), // Rule ID 13579 //
     /*  61403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61456 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61468 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61472 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61476 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61481 */     // MIs[4] LHS
     /*  61481 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61488 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61505 */     GIR_RootConstrainSelectedInstOperands,
     /*  61506 */     // GIR_Coverage, 13579,
     /*  61506 */     GIR_EraseRootFromParent_Done,
     /*  61507 */   // Label 1041: @61507
     /*  61507 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(61616), // Rule ID 13578 //
     /*  61512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61565 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61577 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61581 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61585 */     // MIs[4] LHS
     /*  61585 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61590 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61595 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61597 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61614 */     GIR_RootConstrainSelectedInstOperands,
     /*  61615 */     // GIR_Coverage, 13578,
     /*  61615 */     GIR_EraseRootFromParent_Done,
     /*  61616 */   // Label 1042: @61616
     /*  61616 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61725), // Rule ID 2471 //
     /*  61621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61678 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61682 */     // MIs[3] LHS
     /*  61682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61691 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61706 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61723 */     GIR_RootConstrainSelectedInstOperands,
     /*  61724 */     // GIR_Coverage, 2471,
     /*  61724 */     GIR_EraseRootFromParent_Done,
     /*  61725 */   // Label 1043: @61725
     /*  61725 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61834), // Rule ID 13574 //
     /*  61730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61787 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61791 */     // MIs[3] LHS
     /*  61791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61800 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61806 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61815 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61832 */     GIR_RootConstrainSelectedInstOperands,
     /*  61833 */     // GIR_Coverage, 13574,
     /*  61833 */     GIR_EraseRootFromParent_Done,
     /*  61834 */   // Label 1044: @61834
     /*  61834 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61943), // Rule ID 13573 //
     /*  61839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61901 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61905 */     // MIs[3] LHS
     /*  61905 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61910 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61914 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61922 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61924 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61941 */     GIR_RootConstrainSelectedInstOperands,
     /*  61942 */     // GIR_Coverage, 13573,
     /*  61942 */     GIR_EraseRootFromParent_Done,
     /*  61943 */   // Label 1045: @61943
     /*  61943 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(62052), // Rule ID 13575 //
     /*  61948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62010 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62014 */     // MIs[3] LHS
     /*  62014 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62019 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62023 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62031 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62033 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62050 */     GIR_RootConstrainSelectedInstOperands,
     /*  62051 */     // GIR_Coverage, 13575,
     /*  62051 */     GIR_EraseRootFromParent_Done,
     /*  62052 */   // Label 1046: @62052
     /*  62052 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(62093), // Rule ID 147 //
     /*  62057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62073 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62077 */     // MIs[1] Operand 1
     /*  62077 */     // No operand predicates
     /*  62077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62079 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62086 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62091 */     GIR_RootConstrainSelectedInstOperands,
     /*  62092 */     // GIR_Coverage, 147,
     /*  62092 */     GIR_EraseRootFromParent_Done,
     /*  62093 */   // Label 1047: @62093
     /*  62093 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62126), // Rule ID 13230 //
     /*  62098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62113 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62124 */     GIR_RootConstrainSelectedInstOperands,
     /*  62125 */     // GIR_Coverage, 13230,
     /*  62125 */     GIR_EraseRootFromParent_Done,
     /*  62126 */   // Label 1048: @62126
     /*  62126 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62159), // Rule ID 179 //
     /*  62131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62146 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62153 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62157 */     GIR_RootConstrainSelectedInstOperands,
     /*  62158 */     // GIR_Coverage, 179,
     /*  62158 */     GIR_EraseRootFromParent_Done,
     /*  62159 */   // Label 1049: @62159
     /*  62159 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62226), // Rule ID 13513 //
     /*  62164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62188 */     // MIs[1] imm
     /*  62188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62196 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62200 */     // MIs[2] Operand 1
     /*  62200 */     // No operand predicates
     /*  62200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62204 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62210 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62224 */     GIR_RootConstrainSelectedInstOperands,
     /*  62225 */     // GIR_Coverage, 13513,
     /*  62225 */     GIR_EraseRootFromParent_Done,
     /*  62226 */   // Label 1050: @62226
     /*  62226 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62293), // Rule ID 13516 //
     /*  62231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62255 */     // MIs[1] imm
     /*  62255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62263 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62267 */     // MIs[2] Operand 1
     /*  62267 */     // No operand predicates
     /*  62267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62277 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62291 */     GIR_RootConstrainSelectedInstOperands,
     /*  62292 */     // GIR_Coverage, 13516,
     /*  62292 */     GIR_EraseRootFromParent_Done,
     /*  62293 */   // Label 1051: @62293
     /*  62293 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62346), // Rule ID 13226 //
     /*  62298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62323 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62333 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  62336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62344 */     GIR_RootConstrainSelectedInstOperands,
     /*  62345 */     // GIR_Coverage, 13226,
     /*  62345 */     GIR_EraseRootFromParent_Done,
     /*  62346 */   // Label 1052: @62346
     /*  62346 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62413), // Rule ID 2122 //
     /*  62351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62379 */     // MIs[1] imm
     /*  62379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62391 */     // MIs[2] Operand 1
     /*  62391 */     // No operand predicates
     /*  62391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62397 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62411 */     GIR_RootConstrainSelectedInstOperands,
     /*  62412 */     // GIR_Coverage, 2122,
     /*  62412 */     GIR_EraseRootFromParent_Done,
     /*  62413 */   // Label 1053: @62413
     /*  62413 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62480), // Rule ID 2131 //
     /*  62418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62446 */     // MIs[1] imm
     /*  62446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62458 */     // MIs[2] Operand 1
     /*  62458 */     // No operand predicates
     /*  62458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62464 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62478 */     GIR_RootConstrainSelectedInstOperands,
     /*  62479 */     // GIR_Coverage, 2131,
     /*  62479 */     GIR_EraseRootFromParent_Done,
     /*  62480 */   // Label 1054: @62480
     /*  62480 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62533), // Rule ID 173 //
     /*  62485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62514 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62520 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  62523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62531 */     GIR_RootConstrainSelectedInstOperands,
     /*  62532 */     // GIR_Coverage, 173,
     /*  62532 */     GIR_EraseRootFromParent_Done,
     /*  62533 */   // Label 1055: @62533
     /*  62533 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62597), // Rule ID 13868 //
     /*  62538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62570 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62576 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62584 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  62587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62589 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  62591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62595 */     GIR_RootConstrainSelectedInstOperands,
     /*  62596 */     // GIR_Coverage, 13868,
     /*  62596 */     GIR_EraseRootFromParent_Done,
     /*  62597 */   // Label 1056: @62597
     /*  62597 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62661), // Rule ID 5056 //
     /*  62602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62638 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62644 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62648 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  62651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62653 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  62655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62659 */     GIR_RootConstrainSelectedInstOperands,
     /*  62660 */     // GIR_Coverage, 5056,
     /*  62660 */     GIR_EraseRootFromParent_Done,
     /*  62661 */   // Label 1057: @62661
     /*  62661 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62685), // Rule ID 177 //
     /*  62666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62678 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  62683 */     GIR_RootConstrainSelectedInstOperands,
     /*  62684 */     // GIR_Coverage, 177,
     /*  62684 */     GIR_Done,
     /*  62685 */   // Label 1058: @62685
     /*  62685 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(62712), // Rule ID 5062 //
     /*  62690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62705 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  62710 */     GIR_RootConstrainSelectedInstOperands,
     /*  62711 */     // GIR_Coverage, 5062,
     /*  62711 */     GIR_Done,
     /*  62712 */   // Label 1059: @62712
     /*  62712 */   GIM_Reject,
     /*  62713 */ // Label 1034: @62713
     /*  62713 */ GIM_Reject,
     /*  62714 */ // Label 1008: @62714
     /*  62714 */ GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(64021),
     /*  62719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62725 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(62834), // Rule ID 13570 //
     /*  62730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62778 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62803 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62808 */     // MIs[4] LHS
     /*  62808 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62815 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  62815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62832 */     GIR_RootConstrainSelectedInstOperands,
     /*  62833 */     // GIR_Coverage, 13570,
     /*  62833 */     GIR_EraseRootFromParent_Done,
     /*  62834 */   // Label 1061: @62834
     /*  62834 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62943), // Rule ID 13569 //
     /*  62839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62887 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62904 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62908 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62912 */     // MIs[4] LHS
     /*  62912 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62917 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62922 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62924 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  62924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62941 */     GIR_RootConstrainSelectedInstOperands,
     /*  62942 */     // GIR_Coverage, 13569,
     /*  62942 */     GIR_EraseRootFromParent_Done,
     /*  62943 */   // Label 1062: @62943
     /*  62943 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63052), // Rule ID 13572 //
     /*  62948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63001 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63007 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63013 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63017 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63021 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63026 */     // MIs[4] LHS
     /*  63026 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63031 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63033 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63050 */     GIR_RootConstrainSelectedInstOperands,
     /*  63051 */     // GIR_Coverage, 13572,
     /*  63051 */     GIR_EraseRootFromParent_Done,
     /*  63052 */   // Label 1063: @63052
     /*  63052 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63161), // Rule ID 13571 //
     /*  63057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63110 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63122 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63126 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63130 */     // MIs[4] LHS
     /*  63130 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63135 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63142 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63159 */     GIR_RootConstrainSelectedInstOperands,
     /*  63160 */     // GIR_Coverage, 13571,
     /*  63160 */     GIR_EraseRootFromParent_Done,
     /*  63161 */   // Label 1064: @63161
     /*  63161 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63270), // Rule ID 2470 //
     /*  63166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63223 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63227 */     // MIs[3] LHS
     /*  63227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63236 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63249 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63251 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63268 */     GIR_RootConstrainSelectedInstOperands,
     /*  63269 */     // GIR_Coverage, 2470,
     /*  63269 */     GIR_EraseRootFromParent_Done,
     /*  63270 */   // Label 1065: @63270
     /*  63270 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63379), // Rule ID 13567 //
     /*  63275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63332 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63336 */     // MIs[3] LHS
     /*  63336 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63341 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63345 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63351 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63358 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63360 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63377 */     GIR_RootConstrainSelectedInstOperands,
     /*  63378 */     // GIR_Coverage, 13567,
     /*  63378 */     GIR_EraseRootFromParent_Done,
     /*  63379 */   // Label 1066: @63379
     /*  63379 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63488), // Rule ID 13566 //
     /*  63384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63446 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63450 */     // MIs[3] LHS
     /*  63450 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63459 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63467 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63469 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63486 */     GIR_RootConstrainSelectedInstOperands,
     /*  63487 */     // GIR_Coverage, 13566,
     /*  63487 */     GIR_EraseRootFromParent_Done,
     /*  63488 */   // Label 1067: @63488
     /*  63488 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(63597), // Rule ID 13568 //
     /*  63493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63555 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63559 */     // MIs[3] LHS
     /*  63559 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63564 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63568 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63574 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63578 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63595 */     GIR_RootConstrainSelectedInstOperands,
     /*  63596 */     // GIR_Coverage, 13568,
     /*  63596 */     GIR_EraseRootFromParent_Done,
     /*  63597 */   // Label 1068: @63597
     /*  63597 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63664), // Rule ID 13533 //
     /*  63602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63626 */     // MIs[1] imm
     /*  63626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63634 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63638 */     // MIs[2] Operand 1
     /*  63638 */     // No operand predicates
     /*  63638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63648 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  63651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63662 */     GIR_RootConstrainSelectedInstOperands,
     /*  63663 */     // GIR_Coverage, 13533,
     /*  63663 */     GIR_EraseRootFromParent_Done,
     /*  63664 */   // Label 1069: @63664
     /*  63664 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63731), // Rule ID 13554 //
     /*  63669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63693 */     // MIs[1] imm
     /*  63693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63701 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63705 */     // MIs[2] Operand 1
     /*  63705 */     // No operand predicates
     /*  63705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63709 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63715 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  63718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63729 */     GIR_RootConstrainSelectedInstOperands,
     /*  63730 */     // GIR_Coverage, 13554,
     /*  63730 */     GIR_EraseRootFromParent_Done,
     /*  63731 */   // Label 1070: @63731
     /*  63731 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63798), // Rule ID 2239 //
     /*  63736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63764 */     // MIs[1] imm
     /*  63764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63772 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63776 */     // MIs[2] Operand 1
     /*  63776 */     // No operand predicates
     /*  63776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63782 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  63785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63796 */     GIR_RootConstrainSelectedInstOperands,
     /*  63797 */     // GIR_Coverage, 2239,
     /*  63797 */     GIR_EraseRootFromParent_Done,
     /*  63798 */   // Label 1071: @63798
     /*  63798 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63865), // Rule ID 2298 //
     /*  63803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63831 */     // MIs[1] imm
     /*  63831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63839 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63843 */     // MIs[2] Operand 1
     /*  63843 */     // No operand predicates
     /*  63843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63849 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  63852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63863 */     GIR_RootConstrainSelectedInstOperands,
     /*  63864 */     // GIR_Coverage, 2298,
     /*  63864 */     GIR_EraseRootFromParent_Done,
     /*  63865 */   // Label 1072: @63865
     /*  63865 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63929), // Rule ID 13867 //
     /*  63870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63902 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63916 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  63916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63921 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63927 */     GIR_RootConstrainSelectedInstOperands,
     /*  63928 */     // GIR_Coverage, 13867,
     /*  63928 */     GIR_EraseRootFromParent_Done,
     /*  63929 */   // Label 1073: @63929
     /*  63929 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(63993), // Rule ID 5055 //
     /*  63934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63970 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63980 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  63980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63985 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63991 */     GIR_RootConstrainSelectedInstOperands,
     /*  63992 */     // GIR_Coverage, 5055,
     /*  63992 */     GIR_EraseRootFromParent_Done,
     /*  63993 */   // Label 1074: @63993
     /*  63993 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64020), // Rule ID 5061 //
     /*  63998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64013 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64018 */     GIR_RootConstrainSelectedInstOperands,
     /*  64019 */     // GIR_Coverage, 5061,
     /*  64019 */     GIR_Done,
     /*  64020 */   // Label 1075: @64020
     /*  64020 */   GIM_Reject,
     /*  64021 */ // Label 1060: @64021
     /*  64021 */ GIM_Reject,
     /*  64022 */ // Label 1009: @64022
     /*  64022 */ GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(65329),
     /*  64027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64033 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64142), // Rule ID 13598 //
     /*  64038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64086 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64092 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64099 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64103 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64107 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64111 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64116 */     // MIs[4] LHS
     /*  64116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64121 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64123 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64140 */     GIR_RootConstrainSelectedInstOperands,
     /*  64141 */     // GIR_Coverage, 13598,
     /*  64141 */     GIR_EraseRootFromParent_Done,
     /*  64142 */   // Label 1077: @64142
     /*  64142 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64251), // Rule ID 13597 //
     /*  64147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64195 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64212 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64216 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64220 */     // MIs[4] LHS
     /*  64220 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64225 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64230 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64232 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64249 */     GIR_RootConstrainSelectedInstOperands,
     /*  64250 */     // GIR_Coverage, 13597,
     /*  64250 */     GIR_EraseRootFromParent_Done,
     /*  64251 */   // Label 1078: @64251
     /*  64251 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64360), // Rule ID 13600 //
     /*  64256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64309 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64317 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64321 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64325 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64329 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64334 */     // MIs[4] LHS
     /*  64334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64339 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64341 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64358 */     GIR_RootConstrainSelectedInstOperands,
     /*  64359 */     // GIR_Coverage, 13600,
     /*  64359 */     GIR_EraseRootFromParent_Done,
     /*  64360 */   // Label 1079: @64360
     /*  64360 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64469), // Rule ID 13599 //
     /*  64365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64418 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64426 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64430 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64434 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64438 */     // MIs[4] LHS
     /*  64438 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64443 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64448 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64450 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64467 */     GIR_RootConstrainSelectedInstOperands,
     /*  64468 */     // GIR_Coverage, 13599,
     /*  64468 */     GIR_EraseRootFromParent_Done,
     /*  64469 */   // Label 1080: @64469
     /*  64469 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64578), // Rule ID 2474 //
     /*  64474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64531 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64535 */     // MIs[3] LHS
     /*  64535 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64540 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64544 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64557 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64559 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64576 */     GIR_RootConstrainSelectedInstOperands,
     /*  64577 */     // GIR_Coverage, 2474,
     /*  64577 */     GIR_EraseRootFromParent_Done,
     /*  64578 */   // Label 1081: @64578
     /*  64578 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64687), // Rule ID 13595 //
     /*  64583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64644 */     // MIs[3] LHS
     /*  64644 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64649 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64653 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64659 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64666 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64668 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64685 */     GIR_RootConstrainSelectedInstOperands,
     /*  64686 */     // GIR_Coverage, 13595,
     /*  64686 */     GIR_EraseRootFromParent_Done,
     /*  64687 */   // Label 1082: @64687
     /*  64687 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64796), // Rule ID 13594 //
     /*  64692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64754 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64758 */     // MIs[3] LHS
     /*  64758 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64763 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64767 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64773 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64775 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64777 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64794 */     GIR_RootConstrainSelectedInstOperands,
     /*  64795 */     // GIR_Coverage, 13594,
     /*  64795 */     GIR_EraseRootFromParent_Done,
     /*  64796 */   // Label 1083: @64796
     /*  64796 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(64905), // Rule ID 13596 //
     /*  64801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64863 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64867 */     // MIs[3] LHS
     /*  64867 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64876 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64882 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64886 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64903 */     GIR_RootConstrainSelectedInstOperands,
     /*  64904 */     // GIR_Coverage, 13596,
     /*  64904 */     GIR_EraseRootFromParent_Done,
     /*  64905 */   // Label 1084: @64905
     /*  64905 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64972), // Rule ID 13537 //
     /*  64910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64934 */     // MIs[1] imm
     /*  64934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64942 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64946 */     // MIs[2] Operand 1
     /*  64946 */     // No operand predicates
     /*  64946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64950 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64956 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  64959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64970 */     GIR_RootConstrainSelectedInstOperands,
     /*  64971 */     // GIR_Coverage, 13537,
     /*  64971 */     GIR_EraseRootFromParent_Done,
     /*  64972 */   // Label 1085: @64972
     /*  64972 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(65039), // Rule ID 13558 //
     /*  64977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65001 */     // MIs[1] imm
     /*  65001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65009 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65013 */     // MIs[2] Operand 1
     /*  65013 */     // No operand predicates
     /*  65013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65017 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65023 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65037 */     GIR_RootConstrainSelectedInstOperands,
     /*  65038 */     // GIR_Coverage, 13558,
     /*  65038 */     GIR_EraseRootFromParent_Done,
     /*  65039 */   // Label 1086: @65039
     /*  65039 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65106), // Rule ID 2243 //
     /*  65044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65072 */     // MIs[1] imm
     /*  65072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65080 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65084 */     // MIs[2] Operand 1
     /*  65084 */     // No operand predicates
     /*  65084 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65090 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65104 */     GIR_RootConstrainSelectedInstOperands,
     /*  65105 */     // GIR_Coverage, 2243,
     /*  65105 */     GIR_EraseRootFromParent_Done,
     /*  65106 */   // Label 1087: @65106
     /*  65106 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65173), // Rule ID 2302 //
     /*  65111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65139 */     // MIs[1] imm
     /*  65139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65147 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65151 */     // MIs[2] Operand 1
     /*  65151 */     // No operand predicates
     /*  65151 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65157 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65171 */     GIR_RootConstrainSelectedInstOperands,
     /*  65172 */     // GIR_Coverage, 2302,
     /*  65172 */     GIR_EraseRootFromParent_Done,
     /*  65173 */   // Label 1088: @65173
     /*  65173 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65237), // Rule ID 13871 //
     /*  65178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65210 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65216 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65224 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65229 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65235 */     GIR_RootConstrainSelectedInstOperands,
     /*  65236 */     // GIR_Coverage, 13871,
     /*  65236 */     GIR_EraseRootFromParent_Done,
     /*  65237 */   // Label 1089: @65237
     /*  65237 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65301), // Rule ID 5059 //
     /*  65242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65278 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65288 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65293 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65299 */     GIR_RootConstrainSelectedInstOperands,
     /*  65300 */     // GIR_Coverage, 5059,
     /*  65300 */     GIR_EraseRootFromParent_Done,
     /*  65301 */   // Label 1090: @65301
     /*  65301 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65328), // Rule ID 5065 //
     /*  65306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65321 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65326 */     GIR_RootConstrainSelectedInstOperands,
     /*  65327 */     // GIR_Coverage, 5065,
     /*  65327 */     GIR_Done,
     /*  65328 */   // Label 1091: @65328
     /*  65328 */   GIM_Reject,
     /*  65329 */ // Label 1076: @65329
     /*  65329 */ GIM_Reject,
     /*  65330 */ // Label 1010: @65330
     /*  65330 */ GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(66637),
     /*  65335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65341 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65450), // Rule ID 13563 //
     /*  65346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65394 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65415 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65419 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65424 */     // MIs[4] LHS
     /*  65424 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65429 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65431 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65448 */     GIR_RootConstrainSelectedInstOperands,
     /*  65449 */     // GIR_Coverage, 13563,
     /*  65449 */     GIR_EraseRootFromParent_Done,
     /*  65450 */   // Label 1093: @65450
     /*  65450 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65559), // Rule ID 13562 //
     /*  65455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65503 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65516 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65520 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65524 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65528 */     // MIs[4] LHS
     /*  65528 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65533 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65538 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65540 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65557 */     GIR_RootConstrainSelectedInstOperands,
     /*  65558 */     // GIR_Coverage, 13562,
     /*  65558 */     GIR_EraseRootFromParent_Done,
     /*  65559 */   // Label 1094: @65559
     /*  65559 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65668), // Rule ID 13565 //
     /*  65564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65617 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65623 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65625 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65629 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65633 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65637 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65642 */     // MIs[4] LHS
     /*  65642 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65647 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65649 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65666 */     GIR_RootConstrainSelectedInstOperands,
     /*  65667 */     // GIR_Coverage, 13565,
     /*  65667 */     GIR_EraseRootFromParent_Done,
     /*  65668 */   // Label 1095: @65668
     /*  65668 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65777), // Rule ID 13564 //
     /*  65673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65726 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65734 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65738 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65742 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65746 */     // MIs[4] LHS
     /*  65746 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65751 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65756 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65758 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65775 */     GIR_RootConstrainSelectedInstOperands,
     /*  65776 */     // GIR_Coverage, 13564,
     /*  65776 */     GIR_EraseRootFromParent_Done,
     /*  65777 */   // Label 1096: @65777
     /*  65777 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65886), // Rule ID 2469 //
     /*  65782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65839 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65843 */     // MIs[3] LHS
     /*  65843 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65852 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65858 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65865 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65867 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65884 */     GIR_RootConstrainSelectedInstOperands,
     /*  65885 */     // GIR_Coverage, 2469,
     /*  65885 */     GIR_EraseRootFromParent_Done,
     /*  65886 */   // Label 1097: @65886
     /*  65886 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(65995), // Rule ID 13560 //
     /*  65891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65948 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65952 */     // MIs[3] LHS
     /*  65952 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65957 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65961 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65976 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65993 */     GIR_RootConstrainSelectedInstOperands,
     /*  65994 */     // GIR_Coverage, 13560,
     /*  65994 */     GIR_EraseRootFromParent_Done,
     /*  65995 */   // Label 1098: @65995
     /*  65995 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66104), // Rule ID 13559 //
     /*  66000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66066 */     // MIs[3] LHS
     /*  66066 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66075 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66083 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66085 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66102 */     GIR_RootConstrainSelectedInstOperands,
     /*  66103 */     // GIR_Coverage, 13559,
     /*  66103 */     GIR_EraseRootFromParent_Done,
     /*  66104 */   // Label 1099: @66104
     /*  66104 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(66213), // Rule ID 13561 //
     /*  66109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66171 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66175 */     // MIs[3] LHS
     /*  66175 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66184 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66190 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66192 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66194 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66211 */     GIR_RootConstrainSelectedInstOperands,
     /*  66212 */     // GIR_Coverage, 13561,
     /*  66212 */     GIR_EraseRootFromParent_Done,
     /*  66213 */   // Label 1100: @66213
     /*  66213 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66280), // Rule ID 13529 //
     /*  66218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66242 */     // MIs[1] imm
     /*  66242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66254 */     // MIs[2] Operand 1
     /*  66254 */     // No operand predicates
     /*  66254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66264 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66278 */     GIR_RootConstrainSelectedInstOperands,
     /*  66279 */     // GIR_Coverage, 13529,
     /*  66279 */     GIR_EraseRootFromParent_Done,
     /*  66280 */   // Label 1101: @66280
     /*  66280 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66347), // Rule ID 13550 //
     /*  66285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66309 */     // MIs[1] imm
     /*  66309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66321 */     // MIs[2] Operand 1
     /*  66321 */     // No operand predicates
     /*  66321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66331 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66345 */     GIR_RootConstrainSelectedInstOperands,
     /*  66346 */     // GIR_Coverage, 13550,
     /*  66346 */     GIR_EraseRootFromParent_Done,
     /*  66347 */   // Label 1102: @66347
     /*  66347 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66414), // Rule ID 2235 //
     /*  66352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66380 */     // MIs[1] imm
     /*  66380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66392 */     // MIs[2] Operand 1
     /*  66392 */     // No operand predicates
     /*  66392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66398 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66412 */     GIR_RootConstrainSelectedInstOperands,
     /*  66413 */     // GIR_Coverage, 2235,
     /*  66413 */     GIR_EraseRootFromParent_Done,
     /*  66414 */   // Label 1103: @66414
     /*  66414 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66481), // Rule ID 2294 //
     /*  66419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66447 */     // MIs[1] imm
     /*  66447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66455 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66459 */     // MIs[2] Operand 1
     /*  66459 */     // No operand predicates
     /*  66459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66465 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66479 */     GIR_RootConstrainSelectedInstOperands,
     /*  66480 */     // GIR_Coverage, 2294,
     /*  66480 */     GIR_EraseRootFromParent_Done,
     /*  66481 */   // Label 1104: @66481
     /*  66481 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66545), // Rule ID 13866 //
     /*  66486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66518 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66524 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66532 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66537 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  66539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66543 */     GIR_RootConstrainSelectedInstOperands,
     /*  66544 */     // GIR_Coverage, 13866,
     /*  66544 */     GIR_EraseRootFromParent_Done,
     /*  66545 */   // Label 1105: @66545
     /*  66545 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66609), // Rule ID 5054 //
     /*  66550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66586 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66592 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66596 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66601 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66607 */     GIR_RootConstrainSelectedInstOperands,
     /*  66608 */     // GIR_Coverage, 5054,
     /*  66608 */     GIR_EraseRootFromParent_Done,
     /*  66609 */   // Label 1106: @66609
     /*  66609 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66636), // Rule ID 5060 //
     /*  66614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66629 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66634 */     GIR_RootConstrainSelectedInstOperands,
     /*  66635 */     // GIR_Coverage, 5060,
     /*  66635 */     GIR_Done,
     /*  66636 */   // Label 1107: @66636
     /*  66636 */   GIM_Reject,
     /*  66637 */ // Label 1092: @66637
     /*  66637 */ GIM_Reject,
     /*  66638 */ // Label 1011: @66638
     /*  66638 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(67945),
     /*  66643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66649 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66758), // Rule ID 13591 //
     /*  66654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66702 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66715 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66719 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66723 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66727 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66732 */     // MIs[4] LHS
     /*  66732 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66737 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66739 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66756 */     GIR_RootConstrainSelectedInstOperands,
     /*  66757 */     // GIR_Coverage, 13591,
     /*  66757 */     GIR_EraseRootFromParent_Done,
     /*  66758 */   // Label 1109: @66758
     /*  66758 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66867), // Rule ID 13590 //
     /*  66763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66811 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66824 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66828 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66832 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66836 */     // MIs[4] LHS
     /*  66836 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66841 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66848 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66865 */     GIR_RootConstrainSelectedInstOperands,
     /*  66866 */     // GIR_Coverage, 13590,
     /*  66866 */     GIR_EraseRootFromParent_Done,
     /*  66867 */   // Label 1110: @66867
     /*  66867 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(66976), // Rule ID 13593 //
     /*  66872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66925 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66931 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66933 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66937 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66941 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66945 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66950 */     // MIs[4] LHS
     /*  66950 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66955 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66957 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66974 */     GIR_RootConstrainSelectedInstOperands,
     /*  66975 */     // GIR_Coverage, 13593,
     /*  66975 */     GIR_EraseRootFromParent_Done,
     /*  66976 */   // Label 1111: @66976
     /*  66976 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67085), // Rule ID 13592 //
     /*  66981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67034 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67046 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67050 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67054 */     // MIs[4] LHS
     /*  67054 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67059 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67066 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67083 */     GIR_RootConstrainSelectedInstOperands,
     /*  67084 */     // GIR_Coverage, 13592,
     /*  67084 */     GIR_EraseRootFromParent_Done,
     /*  67085 */   // Label 1112: @67085
     /*  67085 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67194), // Rule ID 2473 //
     /*  67090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67151 */     // MIs[3] LHS
     /*  67151 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67156 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67160 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67166 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67173 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67175 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67192 */     GIR_RootConstrainSelectedInstOperands,
     /*  67193 */     // GIR_Coverage, 2473,
     /*  67193 */     GIR_EraseRootFromParent_Done,
     /*  67194 */   // Label 1113: @67194
     /*  67194 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67303), // Rule ID 13588 //
     /*  67199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67244 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67256 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67260 */     // MIs[3] LHS
     /*  67260 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67265 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67269 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67275 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67282 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67284 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67301 */     GIR_RootConstrainSelectedInstOperands,
     /*  67302 */     // GIR_Coverage, 13588,
     /*  67302 */     GIR_EraseRootFromParent_Done,
     /*  67303 */   // Label 1114: @67303
     /*  67303 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67412), // Rule ID 13587 //
     /*  67308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67370 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67374 */     // MIs[3] LHS
     /*  67374 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67379 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67383 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67391 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67393 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67410 */     GIR_RootConstrainSelectedInstOperands,
     /*  67411 */     // GIR_Coverage, 13587,
     /*  67411 */     GIR_EraseRootFromParent_Done,
     /*  67412 */   // Label 1115: @67412
     /*  67412 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(67521), // Rule ID 13589 //
     /*  67417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67483 */     // MIs[3] LHS
     /*  67483 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67492 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67498 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67502 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67519 */     GIR_RootConstrainSelectedInstOperands,
     /*  67520 */     // GIR_Coverage, 13589,
     /*  67520 */     GIR_EraseRootFromParent_Done,
     /*  67521 */   // Label 1116: @67521
     /*  67521 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67588), // Rule ID 13535 //
     /*  67526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67550 */     // MIs[1] imm
     /*  67550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67558 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67562 */     // MIs[2] Operand 1
     /*  67562 */     // No operand predicates
     /*  67562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67572 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  67575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67586 */     GIR_RootConstrainSelectedInstOperands,
     /*  67587 */     // GIR_Coverage, 13535,
     /*  67587 */     GIR_EraseRootFromParent_Done,
     /*  67588 */   // Label 1117: @67588
     /*  67588 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67655), // Rule ID 13556 //
     /*  67593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67617 */     // MIs[1] imm
     /*  67617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67629 */     // MIs[2] Operand 1
     /*  67629 */     // No operand predicates
     /*  67629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67639 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  67642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67653 */     GIR_RootConstrainSelectedInstOperands,
     /*  67654 */     // GIR_Coverage, 13556,
     /*  67654 */     GIR_EraseRootFromParent_Done,
     /*  67655 */   // Label 1118: @67655
     /*  67655 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67722), // Rule ID 2241 //
     /*  67660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67688 */     // MIs[1] imm
     /*  67688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67696 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67700 */     // MIs[2] Operand 1
     /*  67700 */     // No operand predicates
     /*  67700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67706 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  67709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67720 */     GIR_RootConstrainSelectedInstOperands,
     /*  67721 */     // GIR_Coverage, 2241,
     /*  67721 */     GIR_EraseRootFromParent_Done,
     /*  67722 */   // Label 1119: @67722
     /*  67722 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67789), // Rule ID 2300 //
     /*  67727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67755 */     // MIs[1] imm
     /*  67755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67767 */     // MIs[2] Operand 1
     /*  67767 */     // No operand predicates
     /*  67767 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67773 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  67776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67787 */     GIR_RootConstrainSelectedInstOperands,
     /*  67788 */     // GIR_Coverage, 2300,
     /*  67788 */     GIR_EraseRootFromParent_Done,
     /*  67789 */   // Label 1120: @67789
     /*  67789 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67853), // Rule ID 13870 //
     /*  67794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67826 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67840 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67845 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67851 */     GIR_RootConstrainSelectedInstOperands,
     /*  67852 */     // GIR_Coverage, 13870,
     /*  67852 */     GIR_EraseRootFromParent_Done,
     /*  67853 */   // Label 1121: @67853
     /*  67853 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(67917), // Rule ID 5058 //
     /*  67858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67894 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67900 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67904 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67909 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67915 */     GIR_RootConstrainSelectedInstOperands,
     /*  67916 */     // GIR_Coverage, 5058,
     /*  67916 */     GIR_EraseRootFromParent_Done,
     /*  67917 */   // Label 1122: @67917
     /*  67917 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(67944), // Rule ID 5064 //
     /*  67922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67937 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  67942 */     GIR_RootConstrainSelectedInstOperands,
     /*  67943 */     // GIR_Coverage, 5064,
     /*  67943 */     GIR_Done,
     /*  67944 */   // Label 1123: @67944
     /*  67944 */   GIM_Reject,
     /*  67945 */ // Label 1108: @67945
     /*  67945 */ GIM_Reject,
     /*  67946 */ // Label 1012: @67946
     /*  67946 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(69253),
     /*  67951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  67957 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68066), // Rule ID 13351 //
     /*  67962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  67985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67997 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68010 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68016 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68023 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68027 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68031 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68035 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68040 */     // MIs[4] Rd
     /*  68040 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68045 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68047 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68064 */     GIR_RootConstrainSelectedInstOperands,
     /*  68065 */     // GIR_Coverage, 13351,
     /*  68065 */     GIR_EraseRootFromParent_Done,
     /*  68066 */   // Label 1125: @68066
     /*  68066 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68175), // Rule ID 13350 //
     /*  68071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68119 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68125 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68136 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68140 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68144 */     // MIs[4] Rd
     /*  68144 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68149 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68156 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68173 */     GIR_RootConstrainSelectedInstOperands,
     /*  68174 */     // GIR_Coverage, 13350,
     /*  68174 */     GIR_EraseRootFromParent_Done,
     /*  68175 */   // Label 1126: @68175
     /*  68175 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68284), // Rule ID 13353 //
     /*  68180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68233 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68241 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68245 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68249 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68253 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68258 */     // MIs[4] Rd
     /*  68258 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68263 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68265 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68282 */     GIR_RootConstrainSelectedInstOperands,
     /*  68283 */     // GIR_Coverage, 13353,
     /*  68283 */     GIR_EraseRootFromParent_Done,
     /*  68284 */   // Label 1127: @68284
     /*  68284 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68393), // Rule ID 13352 //
     /*  68289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68342 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68348 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68350 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68354 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68358 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68362 */     // MIs[4] Rd
     /*  68362 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68367 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68372 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68374 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68391 */     GIR_RootConstrainSelectedInstOperands,
     /*  68392 */     // GIR_Coverage, 13352,
     /*  68392 */     GIR_EraseRootFromParent_Done,
     /*  68393 */   // Label 1128: @68393
     /*  68393 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68502), // Rule ID 1605 //
     /*  68398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68455 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68459 */     // MIs[3] Rd
     /*  68459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68468 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68474 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68481 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68483 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68500 */     GIR_RootConstrainSelectedInstOperands,
     /*  68501 */     // GIR_Coverage, 1605,
     /*  68501 */     GIR_EraseRootFromParent_Done,
     /*  68502 */   // Label 1129: @68502
     /*  68502 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68611), // Rule ID 13348 //
     /*  68507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68564 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68568 */     // MIs[3] Rd
     /*  68568 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68577 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68583 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68590 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68592 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68609 */     GIR_RootConstrainSelectedInstOperands,
     /*  68610 */     // GIR_Coverage, 13348,
     /*  68610 */     GIR_EraseRootFromParent_Done,
     /*  68611 */   // Label 1130: @68611
     /*  68611 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68720), // Rule ID 13347 //
     /*  68616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68678 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68682 */     // MIs[3] Rd
     /*  68682 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68691 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68701 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68718 */     GIR_RootConstrainSelectedInstOperands,
     /*  68719 */     // GIR_Coverage, 13347,
     /*  68719 */     GIR_EraseRootFromParent_Done,
     /*  68720 */   // Label 1131: @68720
     /*  68720 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(68829), // Rule ID 13349 //
     /*  68725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68787 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68791 */     // MIs[3] Rd
     /*  68791 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68800 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68806 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68808 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68810 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68827 */     GIR_RootConstrainSelectedInstOperands,
     /*  68828 */     // GIR_Coverage, 13349,
     /*  68828 */     GIR_EraseRootFromParent_Done,
     /*  68829 */   // Label 1132: @68829
     /*  68829 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68896), // Rule ID 13525 //
     /*  68834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68858 */     // MIs[1] imm
     /*  68858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  68870 */     // MIs[2] Operand 1
     /*  68870 */     // No operand predicates
     /*  68870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68880 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  68883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68894 */     GIR_RootConstrainSelectedInstOperands,
     /*  68895 */     // GIR_Coverage, 13525,
     /*  68895 */     GIR_EraseRootFromParent_Done,
     /*  68896 */   // Label 1133: @68896
     /*  68896 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68963), // Rule ID 13546 //
     /*  68901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68925 */     // MIs[1] imm
     /*  68925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  68937 */     // MIs[2] Operand 1
     /*  68937 */     // No operand predicates
     /*  68937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68947 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  68950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68961 */     GIR_RootConstrainSelectedInstOperands,
     /*  68962 */     // GIR_Coverage, 13546,
     /*  68962 */     GIR_EraseRootFromParent_Done,
     /*  68963 */   // Label 1134: @68963
     /*  68963 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(69030), // Rule ID 2231 //
     /*  68968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68996 */     // MIs[1] imm
     /*  68996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69004 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69008 */     // MIs[2] Operand 1
     /*  69008 */     // No operand predicates
     /*  69008 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69014 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69028 */     GIR_RootConstrainSelectedInstOperands,
     /*  69029 */     // GIR_Coverage, 2231,
     /*  69029 */     GIR_EraseRootFromParent_Done,
     /*  69030 */   // Label 1135: @69030
     /*  69030 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69097), // Rule ID 2290 //
     /*  69035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69063 */     // MIs[1] imm
     /*  69063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69071 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69075 */     // MIs[2] Operand 1
     /*  69075 */     // No operand predicates
     /*  69075 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69081 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69095 */     GIR_RootConstrainSelectedInstOperands,
     /*  69096 */     // GIR_Coverage, 2290,
     /*  69096 */     GIR_EraseRootFromParent_Done,
     /*  69097 */   // Label 1136: @69097
     /*  69097 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69161), // Rule ID 13345 //
     /*  69102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69134 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69148 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69159 */     GIR_RootConstrainSelectedInstOperands,
     /*  69160 */     // GIR_Coverage, 13345,
     /*  69160 */     GIR_EraseRootFromParent_Done,
     /*  69161 */   // Label 1137: @69161
     /*  69161 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69225), // Rule ID 1601 //
     /*  69166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69202 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69208 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69212 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69223 */     GIR_RootConstrainSelectedInstOperands,
     /*  69224 */     // GIR_Coverage, 1601,
     /*  69224 */     GIR_EraseRootFromParent_Done,
     /*  69225 */   // Label 1138: @69225
     /*  69225 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69252), // Rule ID 1603 //
     /*  69230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69245 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69250 */     GIR_RootConstrainSelectedInstOperands,
     /*  69251 */     // GIR_Coverage, 1603,
     /*  69251 */     GIR_Done,
     /*  69252 */   // Label 1139: @69252
     /*  69252 */   GIM_Reject,
     /*  69253 */ // Label 1124: @69253
     /*  69253 */ GIM_Reject,
     /*  69254 */ // Label 1013: @69254
     /*  69254 */ GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(70561),
     /*  69259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69265 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69374), // Rule ID 13584 //
     /*  69270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69305 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69318 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69331 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69335 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69339 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69343 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69348 */     // MIs[4] LHS
     /*  69348 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69353 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69355 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69372 */     GIR_RootConstrainSelectedInstOperands,
     /*  69373 */     // GIR_Coverage, 13584,
     /*  69373 */     GIR_EraseRootFromParent_Done,
     /*  69374 */   // Label 1141: @69374
     /*  69374 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69483), // Rule ID 13583 //
     /*  69379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69427 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69448 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69452 */     // MIs[4] LHS
     /*  69452 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69457 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69464 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69481 */     GIR_RootConstrainSelectedInstOperands,
     /*  69482 */     // GIR_Coverage, 13583,
     /*  69482 */     GIR_EraseRootFromParent_Done,
     /*  69483 */   // Label 1142: @69483
     /*  69483 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69592), // Rule ID 13586 //
     /*  69488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69541 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69547 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69549 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69553 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69557 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69561 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69566 */     // MIs[4] LHS
     /*  69566 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69571 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69573 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69590 */     GIR_RootConstrainSelectedInstOperands,
     /*  69591 */     // GIR_Coverage, 13586,
     /*  69591 */     GIR_EraseRootFromParent_Done,
     /*  69592 */   // Label 1143: @69592
     /*  69592 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69701), // Rule ID 13585 //
     /*  69597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69650 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69656 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69662 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69666 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69670 */     // MIs[4] LHS
     /*  69670 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69675 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69680 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69682 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69699 */     GIR_RootConstrainSelectedInstOperands,
     /*  69700 */     // GIR_Coverage, 13585,
     /*  69700 */     GIR_EraseRootFromParent_Done,
     /*  69701 */   // Label 1144: @69701
     /*  69701 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69810), // Rule ID 2472 //
     /*  69706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69767 */     // MIs[3] LHS
     /*  69767 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69776 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69782 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69789 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69791 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69808 */     GIR_RootConstrainSelectedInstOperands,
     /*  69809 */     // GIR_Coverage, 2472,
     /*  69809 */     GIR_EraseRootFromParent_Done,
     /*  69810 */   // Label 1145: @69810
     /*  69810 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69919), // Rule ID 13581 //
     /*  69815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69872 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69876 */     // MIs[3] LHS
     /*  69876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69881 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69885 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69891 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69898 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69900 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69917 */     GIR_RootConstrainSelectedInstOperands,
     /*  69918 */     // GIR_Coverage, 13581,
     /*  69918 */     GIR_EraseRootFromParent_Done,
     /*  69919 */   // Label 1146: @69919
     /*  69919 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(70028), // Rule ID 13580 //
     /*  69924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69986 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69990 */     // MIs[3] LHS
     /*  69990 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69995 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69999 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70007 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70009 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70026 */     GIR_RootConstrainSelectedInstOperands,
     /*  70027 */     // GIR_Coverage, 13580,
     /*  70027 */     GIR_EraseRootFromParent_Done,
     /*  70028 */   // Label 1147: @70028
     /*  70028 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(70137), // Rule ID 13582 //
     /*  70033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70095 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70099 */     // MIs[3] LHS
     /*  70099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70108 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70114 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70116 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70118 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70135 */     GIR_RootConstrainSelectedInstOperands,
     /*  70136 */     // GIR_Coverage, 13582,
     /*  70136 */     GIR_EraseRootFromParent_Done,
     /*  70137 */   // Label 1148: @70137
     /*  70137 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70204), // Rule ID 13531 //
     /*  70142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70166 */     // MIs[1] imm
     /*  70166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70174 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70178 */     // MIs[2] Operand 1
     /*  70178 */     // No operand predicates
     /*  70178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70182 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70188 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70202 */     GIR_RootConstrainSelectedInstOperands,
     /*  70203 */     // GIR_Coverage, 13531,
     /*  70203 */     GIR_EraseRootFromParent_Done,
     /*  70204 */   // Label 1149: @70204
     /*  70204 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70271), // Rule ID 13552 //
     /*  70209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70233 */     // MIs[1] imm
     /*  70233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70245 */     // MIs[2] Operand 1
     /*  70245 */     // No operand predicates
     /*  70245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70255 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70269 */     GIR_RootConstrainSelectedInstOperands,
     /*  70270 */     // GIR_Coverage, 13552,
     /*  70270 */     GIR_EraseRootFromParent_Done,
     /*  70271 */   // Label 1150: @70271
     /*  70271 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70338), // Rule ID 2237 //
     /*  70276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70304 */     // MIs[1] imm
     /*  70304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70312 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70316 */     // MIs[2] Operand 1
     /*  70316 */     // No operand predicates
     /*  70316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70322 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70336 */     GIR_RootConstrainSelectedInstOperands,
     /*  70337 */     // GIR_Coverage, 2237,
     /*  70337 */     GIR_EraseRootFromParent_Done,
     /*  70338 */   // Label 1151: @70338
     /*  70338 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70405), // Rule ID 2296 //
     /*  70343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70371 */     // MIs[1] imm
     /*  70371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70383 */     // MIs[2] Operand 1
     /*  70383 */     // No operand predicates
     /*  70383 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70389 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70403 */     GIR_RootConstrainSelectedInstOperands,
     /*  70404 */     // GIR_Coverage, 2296,
     /*  70404 */     GIR_EraseRootFromParent_Done,
     /*  70405 */   // Label 1152: @70405
     /*  70405 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70469), // Rule ID 13869 //
     /*  70410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70442 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70456 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70461 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70467 */     GIR_RootConstrainSelectedInstOperands,
     /*  70468 */     // GIR_Coverage, 13869,
     /*  70468 */     GIR_EraseRootFromParent_Done,
     /*  70469 */   // Label 1153: @70469
     /*  70469 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70533), // Rule ID 5057 //
     /*  70474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70510 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70516 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70520 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70525 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  70527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70531 */     GIR_RootConstrainSelectedInstOperands,
     /*  70532 */     // GIR_Coverage, 5057,
     /*  70532 */     GIR_EraseRootFromParent_Done,
     /*  70533 */   // Label 1154: @70533
     /*  70533 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70560), // Rule ID 5063 //
     /*  70538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70553 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  70558 */     GIR_RootConstrainSelectedInstOperands,
     /*  70559 */     // GIR_Coverage, 5063,
     /*  70559 */     GIR_Done,
     /*  70560 */   // Label 1155: @70560
     /*  70560 */   GIM_Reject,
     /*  70561 */ // Label 1140: @70561
     /*  70561 */ GIM_Reject,
     /*  70562 */ // Label 1014: @70562
     /*  70562 */ GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71869),
     /*  70567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70573 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70682), // Rule ID 13358 //
     /*  70578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70613 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70626 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70632 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70647 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70651 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70656 */     // MIs[4] Rd
     /*  70656 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70661 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70663 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70680 */     GIR_RootConstrainSelectedInstOperands,
     /*  70681 */     // GIR_Coverage, 13358,
     /*  70681 */     GIR_EraseRootFromParent_Done,
     /*  70682 */   // Label 1157: @70682
     /*  70682 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70791), // Rule ID 13357 //
     /*  70687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70735 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70741 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70748 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70752 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70756 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70760 */     // MIs[4] Rd
     /*  70760 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70765 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70772 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70789 */     GIR_RootConstrainSelectedInstOperands,
     /*  70790 */     // GIR_Coverage, 13357,
     /*  70790 */     GIR_EraseRootFromParent_Done,
     /*  70791 */   // Label 1158: @70791
     /*  70791 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(70900), // Rule ID 13360 //
     /*  70796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70849 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70857 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70861 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70865 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70869 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70874 */     // MIs[4] Rd
     /*  70874 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70879 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70881 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70898 */     GIR_RootConstrainSelectedInstOperands,
     /*  70899 */     // GIR_Coverage, 13360,
     /*  70899 */     GIR_EraseRootFromParent_Done,
     /*  70900 */   // Label 1159: @70900
     /*  70900 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71009), // Rule ID 13359 //
     /*  70905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70958 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70964 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70978 */     // MIs[4] Rd
     /*  70978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70983 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70988 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70990 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71007 */     GIR_RootConstrainSelectedInstOperands,
     /*  71008 */     // GIR_Coverage, 13359,
     /*  71008 */     GIR_EraseRootFromParent_Done,
     /*  71009 */   // Label 1160: @71009
     /*  71009 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71118), // Rule ID 1606 //
     /*  71014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71075 */     // MIs[3] Rd
     /*  71075 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71084 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71090 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71097 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71099 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71116 */     GIR_RootConstrainSelectedInstOperands,
     /*  71117 */     // GIR_Coverage, 1606,
     /*  71117 */     GIR_EraseRootFromParent_Done,
     /*  71118 */   // Label 1161: @71118
     /*  71118 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71227), // Rule ID 13355 //
     /*  71123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71180 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71184 */     // MIs[3] Rd
     /*  71184 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71193 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71206 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71208 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71225 */     GIR_RootConstrainSelectedInstOperands,
     /*  71226 */     // GIR_Coverage, 13355,
     /*  71226 */     GIR_EraseRootFromParent_Done,
     /*  71227 */   // Label 1162: @71227
     /*  71227 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71336), // Rule ID 13354 //
     /*  71232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71298 */     // MIs[3] Rd
     /*  71298 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71303 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71307 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71315 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71317 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71334 */     GIR_RootConstrainSelectedInstOperands,
     /*  71335 */     // GIR_Coverage, 13354,
     /*  71335 */     GIR_EraseRootFromParent_Done,
     /*  71336 */   // Label 1163: @71336
     /*  71336 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(71445), // Rule ID 13356 //
     /*  71341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71407 */     // MIs[3] Rd
     /*  71407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71416 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71422 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71424 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71426 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71443 */     GIR_RootConstrainSelectedInstOperands,
     /*  71444 */     // GIR_Coverage, 13356,
     /*  71444 */     GIR_EraseRootFromParent_Done,
     /*  71445 */   // Label 1164: @71445
     /*  71445 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71512), // Rule ID 13527 //
     /*  71450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71474 */     // MIs[1] imm
     /*  71474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71482 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71486 */     // MIs[2] Operand 1
     /*  71486 */     // No operand predicates
     /*  71486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71490 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71496 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  71499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71510 */     GIR_RootConstrainSelectedInstOperands,
     /*  71511 */     // GIR_Coverage, 13527,
     /*  71511 */     GIR_EraseRootFromParent_Done,
     /*  71512 */   // Label 1165: @71512
     /*  71512 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71579), // Rule ID 13548 //
     /*  71517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71541 */     // MIs[1] imm
     /*  71541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71549 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71553 */     // MIs[2] Operand 1
     /*  71553 */     // No operand predicates
     /*  71553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71557 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71563 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  71566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71577 */     GIR_RootConstrainSelectedInstOperands,
     /*  71578 */     // GIR_Coverage, 13548,
     /*  71578 */     GIR_EraseRootFromParent_Done,
     /*  71579 */   // Label 1166: @71579
     /*  71579 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71646), // Rule ID 2233 //
     /*  71584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71612 */     // MIs[1] imm
     /*  71612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71620 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71624 */     // MIs[2] Operand 1
     /*  71624 */     // No operand predicates
     /*  71624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71630 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  71633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71644 */     GIR_RootConstrainSelectedInstOperands,
     /*  71645 */     // GIR_Coverage, 2233,
     /*  71645 */     GIR_EraseRootFromParent_Done,
     /*  71646 */   // Label 1167: @71646
     /*  71646 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71713), // Rule ID 2292 //
     /*  71651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71679 */     // MIs[1] imm
     /*  71679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71687 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71691 */     // MIs[2] Operand 1
     /*  71691 */     // No operand predicates
     /*  71691 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71697 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  71700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71711 */     GIR_RootConstrainSelectedInstOperands,
     /*  71712 */     // GIR_Coverage, 2292,
     /*  71712 */     GIR_EraseRootFromParent_Done,
     /*  71713 */   // Label 1168: @71713
     /*  71713 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71777), // Rule ID 13346 //
     /*  71718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71750 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71764 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71775 */     GIR_RootConstrainSelectedInstOperands,
     /*  71776 */     // GIR_Coverage, 13346,
     /*  71776 */     GIR_EraseRootFromParent_Done,
     /*  71777 */   // Label 1169: @71777
     /*  71777 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71841), // Rule ID 1602 //
     /*  71782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71818 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71828 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71839 */     GIR_RootConstrainSelectedInstOperands,
     /*  71840 */     // GIR_Coverage, 1602,
     /*  71840 */     GIR_EraseRootFromParent_Done,
     /*  71841 */   // Label 1170: @71841
     /*  71841 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(71868), // Rule ID 1604 //
     /*  71846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71861 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71866 */     GIR_RootConstrainSelectedInstOperands,
     /*  71867 */     // GIR_Coverage, 1604,
     /*  71867 */     GIR_Done,
     /*  71868 */   // Label 1171: @71868
     /*  71868 */   GIM_Reject,
     /*  71869 */ // Label 1156: @71869
     /*  71869 */ GIM_Reject,
     /*  71870 */ // Label 1015: @71870
     /*  71870 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(71901), // Rule ID 8430 //
     /*  71875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  71881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  71884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71888 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  71888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71893 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71895 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71897 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71899 */   GIR_RootConstrainSelectedInstOperands,
     /*  71900 */   // GIR_Coverage, 8430,
     /*  71900 */   GIR_EraseRootFromParent_Done,
     /*  71901 */ // Label 1172: @71901
     /*  71901 */ GIM_Reject,
     /*  71902 */ // Label 1016: @71902
     /*  71902 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(71933), // Rule ID 8429 //
     /*  71907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  71913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  71916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71920 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  71920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71925 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71927 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71929 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71931 */   GIR_RootConstrainSelectedInstOperands,
     /*  71932 */   // GIR_Coverage, 8429,
     /*  71932 */   GIR_EraseRootFromParent_Done,
     /*  71933 */ // Label 1173: @71933
     /*  71933 */ GIM_Reject,
     /*  71934 */ // Label 1017: @71934
     /*  71934 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(71959), // Rule ID 7435 //
     /*  71939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  71945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  71948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  71952 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  71952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  71957 */   GIR_RootConstrainSelectedInstOperands,
     /*  71958 */   // GIR_Coverage, 7435,
     /*  71958 */   GIR_Done,
     /*  71959 */ // Label 1174: @71959
     /*  71959 */ GIM_Reject,
     /*  71960 */ // Label 1018: @71960
     /*  71960 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(71991), // Rule ID 8428 //
     /*  71965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  71971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  71974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71978 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  71978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71983 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71985 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71987 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71989 */   GIR_RootConstrainSelectedInstOperands,
     /*  71990 */   // GIR_Coverage, 8428,
     /*  71990 */   GIR_EraseRootFromParent_Done,
     /*  71991 */ // Label 1175: @71991
     /*  71991 */ GIM_Reject,
     /*  71992 */ // Label 1019: @71992
     /*  71992 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72017), // Rule ID 7434 //
     /*  71997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  72003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  72006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72010 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  72010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72015 */   GIR_RootConstrainSelectedInstOperands,
     /*  72016 */   // GIR_Coverage, 7434,
     /*  72016 */   GIR_Done,
     /*  72017 */ // Label 1176: @72017
     /*  72017 */ GIM_Reject,
     /*  72018 */ // Label 1020: @72018
     /*  72018 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72049), // Rule ID 8427 //
     /*  72023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  72029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  72032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72036 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  72036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72041 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72043 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72045 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72047 */   GIR_RootConstrainSelectedInstOperands,
     /*  72048 */   // GIR_Coverage, 8427,
     /*  72048 */   GIR_EraseRootFromParent_Done,
     /*  72049 */ // Label 1177: @72049
     /*  72049 */ GIM_Reject,
     /*  72050 */ // Label 1021: @72050
     /*  72050 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72075), // Rule ID 7433 //
     /*  72055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  72061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  72064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72068 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  72068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72073 */   GIR_RootConstrainSelectedInstOperands,
     /*  72074 */   // GIR_Coverage, 7433,
     /*  72074 */   GIR_Done,
     /*  72075 */ // Label 1178: @72075
     /*  72075 */ GIM_Reject,
     /*  72076 */ // Label 1022: @72076
     /*  72076 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72107), // Rule ID 8426 //
     /*  72081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  72087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  72090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72094 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  72094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72099 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72101 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72103 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72105 */   GIR_RootConstrainSelectedInstOperands,
     /*  72106 */   // GIR_Coverage, 8426,
     /*  72106 */   GIR_EraseRootFromParent_Done,
     /*  72107 */ // Label 1179: @72107
     /*  72107 */ GIM_Reject,
     /*  72108 */ // Label 1023: @72108
     /*  72108 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72133), // Rule ID 7432 //
     /*  72113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  72119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  72122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72126 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  72126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72131 */   GIR_RootConstrainSelectedInstOperands,
     /*  72132 */   // GIR_Coverage, 7432,
     /*  72132 */   GIR_Done,
     /*  72133 */ // Label 1180: @72133
     /*  72133 */ GIM_Reject,
     /*  72134 */ // Label 1024: @72134
     /*  72134 */ GIM_Reject,
     /*  72135 */ // Label 7: @72135
     /*  72135 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1199*/ GIMT_Encode4(79326),
     /*  72146 */ /*GILLT_s32*//*Label 1181*/ GIMT_Encode4(72234),
     /*  72150 */ /*GILLT_s64*//*Label 1182*/ GIMT_Encode4(72914), GIMT_Encode4(0),
     /*  72158 */ /*GILLT_v2s32*//*Label 1183*/ GIMT_Encode4(73757),
     /*  72162 */ /*GILLT_v2s64*//*Label 1184*/ GIMT_Encode4(73992),
     /*  72166 */ /*GILLT_v4s16*//*Label 1185*/ GIMT_Encode4(74681),
     /*  72170 */ /*GILLT_v4s32*//*Label 1186*/ GIMT_Encode4(74916),
     /*  72174 */ /*GILLT_v8s8*//*Label 1187*/ GIMT_Encode4(75605),
     /*  72178 */ /*GILLT_v8s16*//*Label 1188*/ GIMT_Encode4(75843),
     /*  72182 */ /*GILLT_v16s8*//*Label 1189*/ GIMT_Encode4(76532),
     /*  72186 */ /*GILLT_nxv1s1*//*Label 1190*/ GIMT_Encode4(77224),
     /*  72190 */ /*GILLT_nxv2s1*//*Label 1191*/ GIMT_Encode4(77274), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72202 */ /*GILLT_nxv2s64*//*Label 1192*/ GIMT_Encode4(77324),
     /*  72206 */ /*GILLT_nxv4s1*//*Label 1193*/ GIMT_Encode4(77787), GIMT_Encode4(0),
     /*  72214 */ /*GILLT_nxv4s32*//*Label 1194*/ GIMT_Encode4(77837),
     /*  72218 */ /*GILLT_nxv8s1*//*Label 1195*/ GIMT_Encode4(78300),
     /*  72222 */ /*GILLT_nxv8s16*//*Label 1196*/ GIMT_Encode4(78350),
     /*  72226 */ /*GILLT_nxv16s1*//*Label 1197*/ GIMT_Encode4(78813),
     /*  72230 */ /*GILLT_nxv16s8*//*Label 1198*/ GIMT_Encode4(78863),
     /*  72234 */ // Label 1181: @72234
     /*  72234 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(72913),
     /*  72239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72245 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(72303), // Rule ID 13216 //
     /*  72250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72275 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72288 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72301 */     GIR_RootConstrainSelectedInstOperands,
     /*  72302 */     // GIR_Coverage, 13216,
     /*  72302 */     GIR_EraseRootFromParent_Done,
     /*  72303 */   // Label 1201: @72303
     /*  72303 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(72358), // Rule ID 13215 //
     /*  72308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72328 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72345 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72356 */     GIR_RootConstrainSelectedInstOperands,
     /*  72357 */     // GIR_Coverage, 13215,
     /*  72357 */     GIR_EraseRootFromParent_Done,
     /*  72358 */   // Label 1202: @72358
     /*  72358 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(72416), // Rule ID 13213 //
     /*  72363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72401 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72414 */     GIR_RootConstrainSelectedInstOperands,
     /*  72415 */     // GIR_Coverage, 13213,
     /*  72415 */     GIR_EraseRootFromParent_Done,
     /*  72416 */   // Label 1203: @72416
     /*  72416 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(72474), // Rule ID 166 //
     /*  72421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72459 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72472 */     GIR_RootConstrainSelectedInstOperands,
     /*  72473 */     // GIR_Coverage, 166,
     /*  72473 */     GIR_EraseRootFromParent_Done,
     /*  72474 */   // Label 1204: @72474
     /*  72474 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(72532), // Rule ID 13214 //
     /*  72479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72517 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72530 */     GIR_RootConstrainSelectedInstOperands,
     /*  72531 */     // GIR_Coverage, 13214,
     /*  72531 */     GIR_EraseRootFromParent_Done,
     /*  72532 */   // Label 1205: @72532
     /*  72532 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(72587), // Rule ID 13217 //
     /*  72537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72561 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72574 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72585 */     GIR_RootConstrainSelectedInstOperands,
     /*  72586 */     // GIR_Coverage, 13217,
     /*  72586 */     GIR_EraseRootFromParent_Done,
     /*  72587 */   // Label 1206: @72587
     /*  72587 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(72628), // Rule ID 144 //
     /*  72592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  72596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72608 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  72612 */     // MIs[1] Operand 1
     /*  72612 */     // No operand predicates
     /*  72612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72614 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  72614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  72617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72621 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  72626 */     GIR_RootConstrainSelectedInstOperands,
     /*  72627 */     // GIR_Coverage, 144,
     /*  72627 */     GIR_EraseRootFromParent_Done,
     /*  72628 */   // Label 1207: @72628
     /*  72628 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(72661), // Rule ID 13223 //
     /*  72633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72648 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  72651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72659 */     GIR_RootConstrainSelectedInstOperands,
     /*  72660 */     // GIR_Coverage, 13223,
     /*  72660 */     GIR_EraseRootFromParent_Done,
     /*  72661 */   // Label 1208: @72661
     /*  72661 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(72694), // Rule ID 170 //
     /*  72666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72681 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  72684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72692 */     GIR_RootConstrainSelectedInstOperands,
     /*  72693 */     // GIR_Coverage, 170,
     /*  72693 */     GIR_EraseRootFromParent_Done,
     /*  72694 */   // Label 1209: @72694
     /*  72694 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(72747), // Rule ID 13209 //
     /*  72699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72724 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72734 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  72745 */     GIR_RootConstrainSelectedInstOperands,
     /*  72746 */     // GIR_Coverage, 13209,
     /*  72746 */     GIR_EraseRootFromParent_Done,
     /*  72747 */   // Label 1210: @72747
     /*  72747 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(72803), // Rule ID 164 //
     /*  72752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72788 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72801 */     GIR_RootConstrainSelectedInstOperands,
     /*  72802 */     // GIR_Coverage, 164,
     /*  72802 */     GIR_EraseRootFromParent_Done,
     /*  72803 */   // Label 1211: @72803
     /*  72803 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(72856), // Rule ID 13210 //
     /*  72808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72837 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72843 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  72854 */     GIR_RootConstrainSelectedInstOperands,
     /*  72855 */     // GIR_Coverage, 13210,
     /*  72855 */     GIR_EraseRootFromParent_Done,
     /*  72856 */   // Label 1212: @72856
     /*  72856 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(72888), // Rule ID 4002 //
     /*  72861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72873 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  72873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  72876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  72886 */     GIR_RootConstrainSelectedInstOperands,
     /*  72887 */     // GIR_Coverage, 4002,
     /*  72887 */     GIR_EraseRootFromParent_Done,
     /*  72888 */   // Label 1213: @72888
     /*  72888 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(72912), // Rule ID 168 //
     /*  72893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72905 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  72910 */     GIR_RootConstrainSelectedInstOperands,
     /*  72911 */     // GIR_Coverage, 168,
     /*  72911 */     GIR_Done,
     /*  72912 */   // Label 1214: @72912
     /*  72912 */   GIM_Reject,
     /*  72913 */ // Label 1200: @72913
     /*  72913 */ GIM_Reject,
     /*  72914 */ // Label 1182: @72914
     /*  72914 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(73756),
     /*  72919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  72922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72925 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(72983), // Rule ID 13221 //
     /*  72930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  72946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  72950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72955 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  72968 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  72968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  72971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72981 */     GIR_RootConstrainSelectedInstOperands,
     /*  72982 */     // GIR_Coverage, 13221,
     /*  72982 */     GIR_EraseRootFromParent_Done,
     /*  72983 */   // Label 1216: @72983
     /*  72983 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(73038), // Rule ID 13220 //
     /*  72988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73025 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73036 */     GIR_RootConstrainSelectedInstOperands,
     /*  73037 */     // GIR_Coverage, 13220,
     /*  73037 */     GIR_EraseRootFromParent_Done,
     /*  73038 */   // Label 1217: @73038
     /*  73038 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(73096), // Rule ID 13218 //
     /*  73043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73081 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73094 */     GIR_RootConstrainSelectedInstOperands,
     /*  73095 */     // GIR_Coverage, 13218,
     /*  73095 */     GIR_EraseRootFromParent_Done,
     /*  73096 */   // Label 1218: @73096
     /*  73096 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(73154), // Rule ID 167 //
     /*  73101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73132 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73139 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73152 */     GIR_RootConstrainSelectedInstOperands,
     /*  73153 */     // GIR_Coverage, 167,
     /*  73153 */     GIR_EraseRootFromParent_Done,
     /*  73154 */   // Label 1219: @73154
     /*  73154 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(73212), // Rule ID 13219 //
     /*  73159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73184 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73197 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73206 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73210 */     GIR_RootConstrainSelectedInstOperands,
     /*  73211 */     // GIR_Coverage, 13219,
     /*  73211 */     GIR_EraseRootFromParent_Done,
     /*  73212 */   // Label 1220: @73212
     /*  73212 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(73267), // Rule ID 13222 //
     /*  73217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73241 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73254 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73261 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73265 */     GIR_RootConstrainSelectedInstOperands,
     /*  73266 */     // GIR_Coverage, 13222,
     /*  73266 */     GIR_EraseRootFromParent_Done,
     /*  73267 */   // Label 1221: @73267
     /*  73267 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(73367), // Rule ID 1613 //
     /*  73272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  73295 */     // MIs[1] Operand 1
     /*  73295 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  73312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  73316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  73330 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73336 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  73338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73342 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73348 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73350 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73352 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  73352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  73355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  73361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73365 */     GIR_RootConstrainSelectedInstOperands,
     /*  73366 */     // GIR_Coverage, 1613,
     /*  73366 */     GIR_EraseRootFromParent_Done,
     /*  73367 */   // Label 1222: @73367
     /*  73367 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(73408), // Rule ID 145 //
     /*  73372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  73376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73388 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  73392 */     // MIs[1] Operand 1
     /*  73392 */     // No operand predicates
     /*  73392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73394 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  73394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  73397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73401 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  73406 */     GIR_RootConstrainSelectedInstOperands,
     /*  73407 */     // GIR_Coverage, 145,
     /*  73407 */     GIR_EraseRootFromParent_Done,
     /*  73408 */   // Label 1223: @73408
     /*  73408 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(73441), // Rule ID 13224 //
     /*  73413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73428 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73435 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73439 */     GIR_RootConstrainSelectedInstOperands,
     /*  73440 */     // GIR_Coverage, 13224,
     /*  73440 */     GIR_EraseRootFromParent_Done,
     /*  73441 */   // Label 1224: @73441
     /*  73441 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(73474), // Rule ID 171 //
     /*  73446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73461 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73472 */     GIR_RootConstrainSelectedInstOperands,
     /*  73473 */     // GIR_Coverage, 171,
     /*  73473 */     GIR_EraseRootFromParent_Done,
     /*  73474 */   // Label 1225: @73474
     /*  73474 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(73527), // Rule ID 13211 //
     /*  73479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73514 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73525 */     GIR_RootConstrainSelectedInstOperands,
     /*  73526 */     // GIR_Coverage, 13211,
     /*  73526 */     GIR_EraseRootFromParent_Done,
     /*  73527 */   // Label 1226: @73527
     /*  73527 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(73583), // Rule ID 165 //
     /*  73532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73568 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73581 */     GIR_RootConstrainSelectedInstOperands,
     /*  73582 */     // GIR_Coverage, 165,
     /*  73582 */     GIR_EraseRootFromParent_Done,
     /*  73583 */   // Label 1227: @73583
     /*  73583 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(73636), // Rule ID 13212 //
     /*  73588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73617 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73623 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  73634 */     GIR_RootConstrainSelectedInstOperands,
     /*  73635 */     // GIR_Coverage, 13212,
     /*  73635 */     GIR_EraseRootFromParent_Done,
     /*  73636 */   // Label 1228: @73636
     /*  73636 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(73668), // Rule ID 4003 //
     /*  73641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73653 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  73653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  73656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  73666 */     GIR_RootConstrainSelectedInstOperands,
     /*  73667 */     // GIR_Coverage, 4003,
     /*  73667 */     GIR_EraseRootFromParent_Done,
     /*  73668 */   // Label 1229: @73668
     /*  73668 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(73704), // Rule ID 4951 //
     /*  73673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73685 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73691 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73695 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  73695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  73698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73702 */     GIR_RootConstrainSelectedInstOperands,
     /*  73703 */     // GIR_Coverage, 4951,
     /*  73703 */     GIR_EraseRootFromParent_Done,
     /*  73704 */   // Label 1230: @73704
     /*  73704 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(73728), // Rule ID 169 //
     /*  73709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73721 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  73726 */     GIR_RootConstrainSelectedInstOperands,
     /*  73727 */     // GIR_Coverage, 169,
     /*  73727 */     GIR_Done,
     /*  73728 */   // Label 1231: @73728
     /*  73728 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(73755), // Rule ID 5050 //
     /*  73733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73748 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  73748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  73753 */     GIR_RootConstrainSelectedInstOperands,
     /*  73754 */     // GIR_Coverage, 5050,
     /*  73754 */     GIR_Done,
     /*  73755 */   // Label 1232: @73755
     /*  73755 */   GIM_Reject,
     /*  73756 */ // Label 1215: @73756
     /*  73756 */ GIM_Reject,
     /*  73757 */ // Label 1183: @73757
     /*  73757 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(73991),
     /*  73762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  73765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73772 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(73868), // Rule ID 1160 //
     /*  73777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73792 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  73796 */     // MIs[1] Operand 1
     /*  73796 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  73813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  73831 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73837 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  73839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73843 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73851 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73853 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  73853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  73856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  73862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73866 */     GIR_RootConstrainSelectedInstOperands,
     /*  73867 */     // GIR_Coverage, 1160,
     /*  73867 */     GIR_EraseRootFromParent_Done,
     /*  73868 */   // Label 1234: @73868
     /*  73868 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(73935), // Rule ID 4998 //
     /*  73873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73885 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  73889 */     // MIs[1] Operand 1
     /*  73889 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  73898 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73904 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  73906 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  73910 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73920 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  73920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  73923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73933 */     GIR_RootConstrainSelectedInstOperands,
     /*  73934 */     // GIR_Coverage, 4998,
     /*  73934 */     GIR_EraseRootFromParent_Done,
     /*  73935 */   // Label 1235: @73935
     /*  73935 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(73967), // Rule ID 4949 //
     /*  73940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73948 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73954 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73958 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  73958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  73961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73965 */     GIR_RootConstrainSelectedInstOperands,
     /*  73966 */     // GIR_Coverage, 4949,
     /*  73966 */     GIR_EraseRootFromParent_Done,
     /*  73967 */   // Label 1236: @73967
     /*  73967 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(73990), // Rule ID 5049 //
     /*  73972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73983 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  73983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  73988 */     GIR_RootConstrainSelectedInstOperands,
     /*  73989 */     // GIR_Coverage, 5049,
     /*  73989 */     GIR_Done,
     /*  73990 */   // Label 1237: @73990
     /*  73990 */   GIM_Reject,
     /*  73991 */ // Label 1233: @73991
     /*  73991 */ GIM_Reject,
     /*  73992 */ // Label 1184: @73992
     /*  73992 */ GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(74680),
     /*  73997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74007 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(74103), // Rule ID 1162 //
     /*  74012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74031 */     // MIs[1] Operand 1
     /*  74031 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74066 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74072 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74078 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74084 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74088 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  74088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74101 */     GIR_RootConstrainSelectedInstOperands,
     /*  74102 */     // GIR_Coverage, 1162,
     /*  74102 */     GIR_EraseRootFromParent_Done,
     /*  74103 */   // Label 1239: @74103
     /*  74103 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(74170), // Rule ID 5000 //
     /*  74108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74120 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74124 */     // MIs[1] Operand 1
     /*  74124 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74133 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74139 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74145 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74151 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74155 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  74155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74168 */     GIR_RootConstrainSelectedInstOperands,
     /*  74169 */     // GIR_Coverage, 5000,
     /*  74169 */     GIR_EraseRootFromParent_Done,
     /*  74170 */   // Label 1240: @74170
     /*  74170 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(74255), // Rule ID 13746 //
     /*  74175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74219 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74225 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74238 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74253 */     GIR_RootConstrainSelectedInstOperands,
     /*  74254 */     // GIR_Coverage, 13746,
     /*  74254 */     GIR_EraseRootFromParent_Done,
     /*  74255 */   // Label 1241: @74255
     /*  74255 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(74340), // Rule ID 13745 //
     /*  74260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74309 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74323 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74338 */     GIR_RootConstrainSelectedInstOperands,
     /*  74339 */     // GIR_Coverage, 13745,
     /*  74339 */     GIR_EraseRootFromParent_Done,
     /*  74340 */   // Label 1242: @74340
     /*  74340 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(74425), // Rule ID 13744 //
     /*  74345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74393 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74399 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74408 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74423 */     GIR_RootConstrainSelectedInstOperands,
     /*  74424 */     // GIR_Coverage, 13744,
     /*  74424 */     GIR_EraseRootFromParent_Done,
     /*  74425 */   // Label 1243: @74425
     /*  74425 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(74510), // Rule ID 3830 //
     /*  74430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74483 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74489 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74493 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74508 */     GIR_RootConstrainSelectedInstOperands,
     /*  74509 */     // GIR_Coverage, 3830,
     /*  74509 */     GIR_EraseRootFromParent_Done,
     /*  74510 */   // Label 1244: @74510
     /*  74510 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(74542), // Rule ID 4952 //
     /*  74515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74529 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74533 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  74533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  74536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74540 */     GIR_RootConstrainSelectedInstOperands,
     /*  74541 */     // GIR_Coverage, 4952,
     /*  74541 */     GIR_EraseRootFromParent_Done,
     /*  74542 */   // Label 1245: @74542
     /*  74542 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(74599), // Rule ID 3826 //
     /*  74547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74582 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  74585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  74591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  74597 */     GIR_RootConstrainSelectedInstOperands,
     /*  74598 */     // GIR_Coverage, 3826,
     /*  74598 */     GIR_EraseRootFromParent_Done,
     /*  74599 */   // Label 1246: @74599
     /*  74599 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(74656), // Rule ID 13734 //
     /*  74604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74639 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  74642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  74648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  74654 */     GIR_RootConstrainSelectedInstOperands,
     /*  74655 */     // GIR_Coverage, 13734,
     /*  74655 */     GIR_EraseRootFromParent_Done,
     /*  74656 */   // Label 1247: @74656
     /*  74656 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(74679), // Rule ID 5053 //
     /*  74661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74672 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  74672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  74677 */     GIR_RootConstrainSelectedInstOperands,
     /*  74678 */     // GIR_Coverage, 5053,
     /*  74678 */     GIR_Done,
     /*  74679 */   // Label 1248: @74679
     /*  74679 */   GIM_Reject,
     /*  74680 */ // Label 1238: @74680
     /*  74680 */ GIM_Reject,
     /*  74681 */ // Label 1185: @74681
     /*  74681 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(74915),
     /*  74686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  74689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74696 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(74792), // Rule ID 1158 //
     /*  74701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74716 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  74720 */     // MIs[1] Operand 1
     /*  74720 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  74737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74755 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74761 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74763 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74767 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74773 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74775 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74777 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  74777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  74780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74790 */     GIR_RootConstrainSelectedInstOperands,
     /*  74791 */     // GIR_Coverage, 1158,
     /*  74791 */     GIR_EraseRootFromParent_Done,
     /*  74792 */   // Label 1250: @74792
     /*  74792 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(74859), // Rule ID 4996 //
     /*  74797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74809 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  74813 */     // MIs[1] Operand 1
     /*  74813 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74822 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74828 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74834 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74840 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74844 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  74844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  74847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74857 */     GIR_RootConstrainSelectedInstOperands,
     /*  74858 */     // GIR_Coverage, 4996,
     /*  74858 */     GIR_EraseRootFromParent_Done,
     /*  74859 */   // Label 1251: @74859
     /*  74859 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(74891), // Rule ID 4947 //
     /*  74864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74872 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74878 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74882 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  74882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74889 */     GIR_RootConstrainSelectedInstOperands,
     /*  74890 */     // GIR_Coverage, 4947,
     /*  74890 */     GIR_EraseRootFromParent_Done,
     /*  74891 */   // Label 1252: @74891
     /*  74891 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(74914), // Rule ID 5048 //
     /*  74896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74907 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  74907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74912 */     GIR_RootConstrainSelectedInstOperands,
     /*  74913 */     // GIR_Coverage, 5048,
     /*  74913 */     GIR_Done,
     /*  74914 */   // Label 1253: @74914
     /*  74914 */   GIM_Reject,
     /*  74915 */ // Label 1249: @74915
     /*  74915 */ GIM_Reject,
     /*  74916 */ // Label 1186: @74916
     /*  74916 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(75604),
     /*  74921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74931 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(75027), // Rule ID 1161 //
     /*  74936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74951 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74955 */     // MIs[1] Operand 1
     /*  74955 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74990 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74996 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75002 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75010 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75012 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  75012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75025 */     GIR_RootConstrainSelectedInstOperands,
     /*  75026 */     // GIR_Coverage, 1161,
     /*  75026 */     GIR_EraseRootFromParent_Done,
     /*  75027 */   // Label 1255: @75027
     /*  75027 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(75094), // Rule ID 4999 //
     /*  75032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75044 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75048 */     // MIs[1] Operand 1
     /*  75048 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75057 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75063 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75069 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75075 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75079 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  75079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75092 */     GIR_RootConstrainSelectedInstOperands,
     /*  75093 */     // GIR_Coverage, 4999,
     /*  75093 */     GIR_EraseRootFromParent_Done,
     /*  75094 */   // Label 1256: @75094
     /*  75094 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(75179), // Rule ID 13743 //
     /*  75099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75143 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75162 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75177 */     GIR_RootConstrainSelectedInstOperands,
     /*  75178 */     // GIR_Coverage, 13743,
     /*  75178 */     GIR_EraseRootFromParent_Done,
     /*  75179 */   // Label 1257: @75179
     /*  75179 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(75264), // Rule ID 13742 //
     /*  75184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75233 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75247 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75262 */     GIR_RootConstrainSelectedInstOperands,
     /*  75263 */     // GIR_Coverage, 13742,
     /*  75263 */     GIR_EraseRootFromParent_Done,
     /*  75264 */   // Label 1258: @75264
     /*  75264 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(75349), // Rule ID 13741 //
     /*  75269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75317 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75332 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75347 */     GIR_RootConstrainSelectedInstOperands,
     /*  75348 */     // GIR_Coverage, 13741,
     /*  75348 */     GIR_EraseRootFromParent_Done,
     /*  75349 */   // Label 1259: @75349
     /*  75349 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(75434), // Rule ID 3829 //
     /*  75354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75407 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75413 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75415 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75417 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75432 */     GIR_RootConstrainSelectedInstOperands,
     /*  75433 */     // GIR_Coverage, 3829,
     /*  75433 */     GIR_EraseRootFromParent_Done,
     /*  75434 */   // Label 1260: @75434
     /*  75434 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(75466), // Rule ID 4950 //
     /*  75439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75447 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75457 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  75457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75464 */     GIR_RootConstrainSelectedInstOperands,
     /*  75465 */     // GIR_Coverage, 4950,
     /*  75465 */     GIR_EraseRootFromParent_Done,
     /*  75466 */   // Label 1261: @75466
     /*  75466 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(75523), // Rule ID 3825 //
     /*  75471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75506 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75521 */     GIR_RootConstrainSelectedInstOperands,
     /*  75522 */     // GIR_Coverage, 3825,
     /*  75522 */     GIR_EraseRootFromParent_Done,
     /*  75523 */   // Label 1262: @75523
     /*  75523 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75580), // Rule ID 13733 //
     /*  75528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75563 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75578 */     GIR_RootConstrainSelectedInstOperands,
     /*  75579 */     // GIR_Coverage, 13733,
     /*  75579 */     GIR_EraseRootFromParent_Done,
     /*  75580 */   // Label 1263: @75580
     /*  75580 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75603), // Rule ID 5052 //
     /*  75585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75596 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  75596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75601 */     GIR_RootConstrainSelectedInstOperands,
     /*  75602 */     // GIR_Coverage, 5052,
     /*  75602 */     GIR_Done,
     /*  75603 */   // Label 1264: @75603
     /*  75603 */   GIM_Reject,
     /*  75604 */ // Label 1254: @75604
     /*  75604 */ GIM_Reject,
     /*  75605 */ // Label 1187: @75605
     /*  75605 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(75842),
     /*  75610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  75613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75620 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(75716), // Rule ID 1156 //
     /*  75625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75640 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  75644 */     // MIs[1] Operand 1
     /*  75644 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  75661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75679 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75685 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75691 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75701 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  75701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  75704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75714 */     GIR_RootConstrainSelectedInstOperands,
     /*  75715 */     // GIR_Coverage, 1156,
     /*  75715 */     GIR_EraseRootFromParent_Done,
     /*  75716 */   // Label 1266: @75716
     /*  75716 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(75783), // Rule ID 4994 //
     /*  75721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75733 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  75737 */     // MIs[1] Operand 1
     /*  75737 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75746 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75752 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75758 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75768 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  75768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  75771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75781 */     GIR_RootConstrainSelectedInstOperands,
     /*  75782 */     // GIR_Coverage, 4994,
     /*  75782 */     GIR_EraseRootFromParent_Done,
     /*  75783 */   // Label 1267: @75783
     /*  75783 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(75818), // Rule ID 972 //
     /*  75788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75809 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  75809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  75812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75816 */     GIR_RootConstrainSelectedInstOperands,
     /*  75817 */     // GIR_Coverage, 972,
     /*  75817 */     GIR_EraseRootFromParent_Done,
     /*  75818 */   // Label 1268: @75818
     /*  75818 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(75841), // Rule ID 1599 //
     /*  75823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75834 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  75834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  75839 */     GIR_RootConstrainSelectedInstOperands,
     /*  75840 */     // GIR_Coverage, 1599,
     /*  75840 */     GIR_Done,
     /*  75841 */   // Label 1269: @75841
     /*  75841 */   GIM_Reject,
     /*  75842 */ // Label 1265: @75842
     /*  75842 */ GIM_Reject,
     /*  75843 */ // Label 1188: @75843
     /*  75843 */ GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(76531),
     /*  75848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75858 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(75954), // Rule ID 1159 //
     /*  75863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75882 */     // MIs[1] Operand 1
     /*  75882 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75917 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75923 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75925 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75929 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75937 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75939 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  75939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  75942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75952 */     GIR_RootConstrainSelectedInstOperands,
     /*  75953 */     // GIR_Coverage, 1159,
     /*  75953 */     GIR_EraseRootFromParent_Done,
     /*  75954 */   // Label 1271: @75954
     /*  75954 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(76021), // Rule ID 4997 //
     /*  75959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75971 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75975 */     // MIs[1] Operand 1
     /*  75975 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75984 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75990 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75996 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76002 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76006 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  76006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76019 */     GIR_RootConstrainSelectedInstOperands,
     /*  76020 */     // GIR_Coverage, 4997,
     /*  76020 */     GIR_EraseRootFromParent_Done,
     /*  76021 */   // Label 1272: @76021
     /*  76021 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(76106), // Rule ID 13740 //
     /*  76026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76070 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76076 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76087 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76089 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76104 */     GIR_RootConstrainSelectedInstOperands,
     /*  76105 */     // GIR_Coverage, 13740,
     /*  76105 */     GIR_EraseRootFromParent_Done,
     /*  76106 */   // Label 1273: @76106
     /*  76106 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(76191), // Rule ID 13739 //
     /*  76111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76160 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76166 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76174 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76189 */     GIR_RootConstrainSelectedInstOperands,
     /*  76190 */     // GIR_Coverage, 13739,
     /*  76190 */     GIR_EraseRootFromParent_Done,
     /*  76191 */   // Label 1274: @76191
     /*  76191 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(76276), // Rule ID 13738 //
     /*  76196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76244 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76250 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76259 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76274 */     GIR_RootConstrainSelectedInstOperands,
     /*  76275 */     // GIR_Coverage, 13738,
     /*  76275 */     GIR_EraseRootFromParent_Done,
     /*  76276 */   // Label 1275: @76276
     /*  76276 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(76361), // Rule ID 3828 //
     /*  76281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76334 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76340 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76344 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76359 */     GIR_RootConstrainSelectedInstOperands,
     /*  76360 */     // GIR_Coverage, 3828,
     /*  76360 */     GIR_EraseRootFromParent_Done,
     /*  76361 */   // Label 1276: @76361
     /*  76361 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(76393), // Rule ID 4948 //
     /*  76366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76374 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76380 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76384 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  76384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  76387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76391 */     GIR_RootConstrainSelectedInstOperands,
     /*  76392 */     // GIR_Coverage, 4948,
     /*  76392 */     GIR_EraseRootFromParent_Done,
     /*  76393 */   // Label 1277: @76393
     /*  76393 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(76450), // Rule ID 3824 //
     /*  76398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76433 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76448 */     GIR_RootConstrainSelectedInstOperands,
     /*  76449 */     // GIR_Coverage, 3824,
     /*  76449 */     GIR_EraseRootFromParent_Done,
     /*  76450 */   // Label 1278: @76450
     /*  76450 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(76507), // Rule ID 13732 //
     /*  76455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76490 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  76505 */     GIR_RootConstrainSelectedInstOperands,
     /*  76506 */     // GIR_Coverage, 13732,
     /*  76506 */     GIR_EraseRootFromParent_Done,
     /*  76507 */   // Label 1279: @76507
     /*  76507 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(76530), // Rule ID 5051 //
     /*  76512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76523 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  76523 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  76528 */     GIR_RootConstrainSelectedInstOperands,
     /*  76529 */     // GIR_Coverage, 5051,
     /*  76529 */     GIR_Done,
     /*  76530 */   // Label 1280: @76530
     /*  76530 */   GIM_Reject,
     /*  76531 */ // Label 1270: @76531
     /*  76531 */ GIM_Reject,
     /*  76532 */ // Label 1189: @76532
     /*  76532 */ GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(77223),
     /*  76537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76547 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(76643), // Rule ID 1157 //
     /*  76552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76571 */     // MIs[1] Operand 1
     /*  76571 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76606 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76612 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76618 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76624 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76626 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76628 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  76628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  76631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76641 */     GIR_RootConstrainSelectedInstOperands,
     /*  76642 */     // GIR_Coverage, 1157,
     /*  76642 */     GIR_EraseRootFromParent_Done,
     /*  76643 */   // Label 1282: @76643
     /*  76643 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(76710), // Rule ID 4995 //
     /*  76648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76660 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76664 */     // MIs[1] Operand 1
     /*  76664 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76673 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76679 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76685 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76691 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76695 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  76695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  76698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76708 */     GIR_RootConstrainSelectedInstOperands,
     /*  76709 */     // GIR_Coverage, 4995,
     /*  76709 */     GIR_EraseRootFromParent_Done,
     /*  76710 */   // Label 1283: @76710
     /*  76710 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(76795), // Rule ID 13737 //
     /*  76715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76759 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76765 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76778 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76793 */     GIR_RootConstrainSelectedInstOperands,
     /*  76794 */     // GIR_Coverage, 13737,
     /*  76794 */     GIR_EraseRootFromParent_Done,
     /*  76795 */   // Label 1284: @76795
     /*  76795 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(76880), // Rule ID 13736 //
     /*  76800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76849 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76863 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76878 */     GIR_RootConstrainSelectedInstOperands,
     /*  76879 */     // GIR_Coverage, 13736,
     /*  76879 */     GIR_EraseRootFromParent_Done,
     /*  76880 */   // Label 1285: @76880
     /*  76880 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(76965), // Rule ID 13735 //
     /*  76885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76933 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76948 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76963 */     GIR_RootConstrainSelectedInstOperands,
     /*  76964 */     // GIR_Coverage, 13735,
     /*  76964 */     GIR_EraseRootFromParent_Done,
     /*  76965 */   // Label 1286: @76965
     /*  76965 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(77050), // Rule ID 3827 //
     /*  76970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77023 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77033 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77048 */     GIR_RootConstrainSelectedInstOperands,
     /*  77049 */     // GIR_Coverage, 3827,
     /*  77049 */     GIR_EraseRootFromParent_Done,
     /*  77050 */   // Label 1287: @77050
     /*  77050 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(77085), // Rule ID 973 //
     /*  77055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77066 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77076 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  77076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77083 */     GIR_RootConstrainSelectedInstOperands,
     /*  77084 */     // GIR_Coverage, 973,
     /*  77084 */     GIR_EraseRootFromParent_Done,
     /*  77085 */   // Label 1288: @77085
     /*  77085 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(77142), // Rule ID 3823 //
     /*  77090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77125 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77140 */     GIR_RootConstrainSelectedInstOperands,
     /*  77141 */     // GIR_Coverage, 3823,
     /*  77141 */     GIR_EraseRootFromParent_Done,
     /*  77142 */   // Label 1289: @77142
     /*  77142 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(77199), // Rule ID 13731 //
     /*  77147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77182 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77197 */     GIR_RootConstrainSelectedInstOperands,
     /*  77198 */     // GIR_Coverage, 13731,
     /*  77198 */     GIR_EraseRootFromParent_Done,
     /*  77199 */   // Label 1290: @77199
     /*  77199 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(77222), // Rule ID 1600 //
     /*  77204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77215 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77220 */     GIR_RootConstrainSelectedInstOperands,
     /*  77221 */     // GIR_Coverage, 1600,
     /*  77221 */     GIR_Done,
     /*  77222 */   // Label 1291: @77222
     /*  77222 */   GIM_Reject,
     /*  77223 */ // Label 1281: @77223
     /*  77223 */ GIM_Reject,
     /*  77224 */ // Label 1190: @77224
     /*  77224 */ GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(77273), // Rule ID 8420 //
     /*  77229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  77235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  77238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77242 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  77242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77254 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77267 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77269 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77271 */   GIR_RootConstrainSelectedInstOperands,
     /*  77272 */   // GIR_Coverage, 8420,
     /*  77272 */   GIR_EraseRootFromParent_Done,
     /*  77273 */ // Label 1292: @77273
     /*  77273 */ GIM_Reject,
     /*  77274 */ // Label 1191: @77274
     /*  77274 */ GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(77323), // Rule ID 8419 //
     /*  77279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  77285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  77288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77292 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  77292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77304 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77317 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77319 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77321 */   GIR_RootConstrainSelectedInstOperands,
     /*  77322 */   // GIR_Coverage, 8419,
     /*  77322 */   GIR_EraseRootFromParent_Done,
     /*  77323 */ // Label 1293: @77323
     /*  77323 */ GIM_Reject,
     /*  77324 */ // Label 1192: @77324
     /*  77324 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(77786),
     /*  77329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77339 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(77410), // Rule ID 15598 //
     /*  77344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77383 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77393 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77408 */     GIR_RootConstrainSelectedInstOperands,
     /*  77409 */     // GIR_Coverage, 15598,
     /*  77409 */     GIR_EraseRootFromParent_Done,
     /*  77410 */   // Label 1295: @77410
     /*  77410 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(77481), // Rule ID 15597 //
     /*  77415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77454 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77464 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77479 */     GIR_RootConstrainSelectedInstOperands,
     /*  77480 */     // GIR_Coverage, 15597,
     /*  77480 */     GIR_EraseRootFromParent_Done,
     /*  77481 */   // Label 1296: @77481
     /*  77481 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(77552), // Rule ID 15596 //
     /*  77486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77525 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77531 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77535 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77550 */     GIR_RootConstrainSelectedInstOperands,
     /*  77551 */     // GIR_Coverage, 15596,
     /*  77551 */     GIR_EraseRootFromParent_Done,
     /*  77552 */   // Label 1297: @77552
     /*  77552 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(77623), // Rule ID 11850 //
     /*  77557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77596 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77606 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77621 */     GIR_RootConstrainSelectedInstOperands,
     /*  77622 */     // GIR_Coverage, 11850,
     /*  77622 */     GIR_EraseRootFromParent_Done,
     /*  77623 */   // Label 1298: @77623
     /*  77623 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(77684), // Rule ID 11874 //
     /*  77628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  77639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  77651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77655 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77661 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  77663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77665 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  77668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  77678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77682 */     GIR_RootConstrainSelectedInstOperands,
     /*  77683 */     // GIR_Coverage, 11874,
     /*  77683 */     GIR_EraseRootFromParent_Done,
     /*  77684 */   // Label 1299: @77684
     /*  77684 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(77727), // Rule ID 13698 //
     /*  77689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77710 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  77725 */     GIR_RootConstrainSelectedInstOperands,
     /*  77726 */     // GIR_Coverage, 13698,
     /*  77726 */     GIR_EraseRootFromParent_Done,
     /*  77727 */   // Label 1300: @77727
     /*  77727 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(77770), // Rule ID 3154 //
     /*  77732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77753 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77768 */     GIR_RootConstrainSelectedInstOperands,
     /*  77769 */     // GIR_Coverage, 3154,
     /*  77769 */     GIR_EraseRootFromParent_Done,
     /*  77770 */   // Label 1301: @77770
     /*  77770 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(77785), // Rule ID 7439 //
     /*  77775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77778 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  77778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  77783 */     GIR_RootConstrainSelectedInstOperands,
     /*  77784 */     // GIR_Coverage, 7439,
     /*  77784 */     GIR_Done,
     /*  77785 */   // Label 1302: @77785
     /*  77785 */   GIM_Reject,
     /*  77786 */ // Label 1294: @77786
     /*  77786 */ GIM_Reject,
     /*  77787 */ // Label 1193: @77787
     /*  77787 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(77836), // Rule ID 8418 //
     /*  77792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  77798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  77801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77805 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  77805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  77812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77817 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77830 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77832 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77834 */   GIR_RootConstrainSelectedInstOperands,
     /*  77835 */   // GIR_Coverage, 8418,
     /*  77835 */   GIR_EraseRootFromParent_Done,
     /*  77836 */ // Label 1303: @77836
     /*  77836 */ GIM_Reject,
     /*  77837 */ // Label 1194: @77837
     /*  77837 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(78299),
     /*  77842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77852 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(77923), // Rule ID 15595 //
     /*  77857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77896 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77904 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77906 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77921 */     GIR_RootConstrainSelectedInstOperands,
     /*  77922 */     // GIR_Coverage, 15595,
     /*  77922 */     GIR_EraseRootFromParent_Done,
     /*  77923 */   // Label 1305: @77923
     /*  77923 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(77994), // Rule ID 15594 //
     /*  77928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77967 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77973 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77977 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77992 */     GIR_RootConstrainSelectedInstOperands,
     /*  77993 */     // GIR_Coverage, 15594,
     /*  77993 */     GIR_EraseRootFromParent_Done,
     /*  77994 */   // Label 1306: @77994
     /*  77994 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(78065), // Rule ID 15593 //
     /*  77999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78038 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78048 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78063 */     GIR_RootConstrainSelectedInstOperands,
     /*  78064 */     // GIR_Coverage, 15593,
     /*  78064 */     GIR_EraseRootFromParent_Done,
     /*  78065 */   // Label 1307: @78065
     /*  78065 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(78136), // Rule ID 11848 //
     /*  78070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78109 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78115 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78119 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78134 */     GIR_RootConstrainSelectedInstOperands,
     /*  78135 */     // GIR_Coverage, 11848,
     /*  78135 */     GIR_EraseRootFromParent_Done,
     /*  78136 */   // Label 1308: @78136
     /*  78136 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(78197), // Rule ID 11872 //
     /*  78141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78160 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  78164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78168 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78178 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78195 */     GIR_RootConstrainSelectedInstOperands,
     /*  78196 */     // GIR_Coverage, 11872,
     /*  78196 */     GIR_EraseRootFromParent_Done,
     /*  78197 */   // Label 1309: @78197
     /*  78197 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(78240), // Rule ID 13697 //
     /*  78202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78223 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78238 */     GIR_RootConstrainSelectedInstOperands,
     /*  78239 */     // GIR_Coverage, 13697,
     /*  78239 */     GIR_EraseRootFromParent_Done,
     /*  78240 */   // Label 1310: @78240
     /*  78240 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(78283), // Rule ID 3152 //
     /*  78245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78266 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78281 */     GIR_RootConstrainSelectedInstOperands,
     /*  78282 */     // GIR_Coverage, 3152,
     /*  78282 */     GIR_EraseRootFromParent_Done,
     /*  78283 */   // Label 1311: @78283
     /*  78283 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(78298), // Rule ID 7438 //
     /*  78288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78291 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  78291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78296 */     GIR_RootConstrainSelectedInstOperands,
     /*  78297 */     // GIR_Coverage, 7438,
     /*  78297 */     GIR_Done,
     /*  78298 */   // Label 1312: @78298
     /*  78298 */   GIM_Reject,
     /*  78299 */ // Label 1304: @78299
     /*  78299 */ GIM_Reject,
     /*  78300 */ // Label 1195: @78300
     /*  78300 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(78349), // Rule ID 8417 //
     /*  78305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  78311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  78314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78318 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  78318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  78325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78330 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78343 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78345 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78347 */   GIR_RootConstrainSelectedInstOperands,
     /*  78348 */   // GIR_Coverage, 8417,
     /*  78348 */   GIR_EraseRootFromParent_Done,
     /*  78349 */ // Label 1313: @78349
     /*  78349 */ GIM_Reject,
     /*  78350 */ // Label 1196: @78350
     /*  78350 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(78812),
     /*  78355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78365 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(78436), // Rule ID 15592 //
     /*  78370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78409 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78419 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78434 */     GIR_RootConstrainSelectedInstOperands,
     /*  78435 */     // GIR_Coverage, 15592,
     /*  78435 */     GIR_EraseRootFromParent_Done,
     /*  78436 */   // Label 1315: @78436
     /*  78436 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(78507), // Rule ID 15591 //
     /*  78441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78480 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78486 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78490 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78505 */     GIR_RootConstrainSelectedInstOperands,
     /*  78506 */     // GIR_Coverage, 15591,
     /*  78506 */     GIR_EraseRootFromParent_Done,
     /*  78507 */   // Label 1316: @78507
     /*  78507 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(78578), // Rule ID 15590 //
     /*  78512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78561 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78576 */     GIR_RootConstrainSelectedInstOperands,
     /*  78577 */     // GIR_Coverage, 15590,
     /*  78577 */     GIR_EraseRootFromParent_Done,
     /*  78578 */   // Label 1317: @78578
     /*  78578 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(78649), // Rule ID 11846 //
     /*  78583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78622 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78632 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78647 */     GIR_RootConstrainSelectedInstOperands,
     /*  78648 */     // GIR_Coverage, 11846,
     /*  78648 */     GIR_EraseRootFromParent_Done,
     /*  78649 */   // Label 1318: @78649
     /*  78649 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(78710), // Rule ID 11870 //
     /*  78654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78673 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  78677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78681 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78687 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78691 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78708 */     GIR_RootConstrainSelectedInstOperands,
     /*  78709 */     // GIR_Coverage, 11870,
     /*  78709 */     GIR_EraseRootFromParent_Done,
     /*  78710 */   // Label 1319: @78710
     /*  78710 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(78753), // Rule ID 13696 //
     /*  78715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78736 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78751 */     GIR_RootConstrainSelectedInstOperands,
     /*  78752 */     // GIR_Coverage, 13696,
     /*  78752 */     GIR_EraseRootFromParent_Done,
     /*  78753 */   // Label 1320: @78753
     /*  78753 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(78796), // Rule ID 3150 //
     /*  78758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78779 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78794 */     GIR_RootConstrainSelectedInstOperands,
     /*  78795 */     // GIR_Coverage, 3150,
     /*  78795 */     GIR_EraseRootFromParent_Done,
     /*  78796 */   // Label 1321: @78796
     /*  78796 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(78811), // Rule ID 7437 //
     /*  78801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78804 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  78804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78809 */     GIR_RootConstrainSelectedInstOperands,
     /*  78810 */     // GIR_Coverage, 7437,
     /*  78810 */     GIR_Done,
     /*  78811 */   // Label 1322: @78811
     /*  78811 */   GIM_Reject,
     /*  78812 */ // Label 1314: @78812
     /*  78812 */ GIM_Reject,
     /*  78813 */ // Label 1197: @78813
     /*  78813 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(78862), // Rule ID 8416 //
     /*  78818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  78824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  78827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78831 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  78831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  78838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78843 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78856 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78858 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78860 */   GIR_RootConstrainSelectedInstOperands,
     /*  78861 */   // GIR_Coverage, 8416,
     /*  78861 */   GIR_EraseRootFromParent_Done,
     /*  78862 */ // Label 1323: @78862
     /*  78862 */ GIM_Reject,
     /*  78863 */ // Label 1198: @78863
     /*  78863 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(79325),
     /*  78868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78878 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(78949), // Rule ID 15589 //
     /*  78883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78922 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78928 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78932 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78947 */     GIR_RootConstrainSelectedInstOperands,
     /*  78948 */     // GIR_Coverage, 15589,
     /*  78948 */     GIR_EraseRootFromParent_Done,
     /*  78949 */   // Label 1325: @78949
     /*  78949 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(79020), // Rule ID 15588 //
     /*  78954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78993 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79003 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79018 */     GIR_RootConstrainSelectedInstOperands,
     /*  79019 */     // GIR_Coverage, 15588,
     /*  79019 */     GIR_EraseRootFromParent_Done,
     /*  79020 */   // Label 1326: @79020
     /*  79020 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(79091), // Rule ID 15587 //
     /*  79025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79064 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79074 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79089 */     GIR_RootConstrainSelectedInstOperands,
     /*  79090 */     // GIR_Coverage, 15587,
     /*  79090 */     GIR_EraseRootFromParent_Done,
     /*  79091 */   // Label 1327: @79091
     /*  79091 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(79162), // Rule ID 11844 //
     /*  79096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79135 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79143 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79145 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79160 */     GIR_RootConstrainSelectedInstOperands,
     /*  79161 */     // GIR_Coverage, 11844,
     /*  79161 */     GIR_EraseRootFromParent_Done,
     /*  79162 */   // Label 1328: @79162
     /*  79162 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(79223), // Rule ID 11868 //
     /*  79167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79186 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  79190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79194 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79200 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79204 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79221 */     GIR_RootConstrainSelectedInstOperands,
     /*  79222 */     // GIR_Coverage, 11868,
     /*  79222 */     GIR_EraseRootFromParent_Done,
     /*  79223 */   // Label 1329: @79223
     /*  79223 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(79266), // Rule ID 13695 //
     /*  79228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79249 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79264 */     GIR_RootConstrainSelectedInstOperands,
     /*  79265 */     // GIR_Coverage, 13695,
     /*  79265 */     GIR_EraseRootFromParent_Done,
     /*  79266 */   // Label 1330: @79266
     /*  79266 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(79309), // Rule ID 3148 //
     /*  79271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79292 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79307 */     GIR_RootConstrainSelectedInstOperands,
     /*  79308 */     // GIR_Coverage, 3148,
     /*  79308 */     GIR_EraseRootFromParent_Done,
     /*  79309 */   // Label 1331: @79309
     /*  79309 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(79324), // Rule ID 7436 //
     /*  79314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79317 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  79317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79322 */     GIR_RootConstrainSelectedInstOperands,
     /*  79323 */     // GIR_Coverage, 7436,
     /*  79323 */     GIR_Done,
     /*  79324 */   // Label 1332: @79324
     /*  79324 */   GIM_Reject,
     /*  79325 */ // Label 1324: @79325
     /*  79325 */ GIM_Reject,
     /*  79326 */ // Label 1199: @79326
     /*  79326 */ GIM_Reject,
     /*  79327 */ // Label 8: @79327
     /*  79327 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(86850),
     /*  79332 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  79335 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1345*/ GIMT_Encode4(86849),
     /*  79346 */   /*GILLT_v2s64*//*Label 1334*/ GIMT_Encode4(79414), GIMT_Encode4(0),
     /*  79354 */   /*GILLT_v4s32*//*Label 1335*/ GIMT_Encode4(79935), GIMT_Encode4(0),
     /*  79362 */   /*GILLT_v8s16*//*Label 1336*/ GIMT_Encode4(82347),
     /*  79366 */   /*GILLT_v16s8*//*Label 1337*/ GIMT_Encode4(84756), GIMT_Encode4(0),
     /*  79374 */   /*GILLT_nxv2s1*//*Label 1338*/ GIMT_Encode4(86667), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  79390 */   /*GILLT_nxv4s1*//*Label 1339*/ GIMT_Encode4(86693),
     /*  79394 */   /*GILLT_nxv4s16*//*Label 1340*/ GIMT_Encode4(86719),
     /*  79398 */   /*GILLT_nxv4s32*//*Label 1341*/ GIMT_Encode4(86745),
     /*  79402 */   /*GILLT_nxv8s1*//*Label 1342*/ GIMT_Encode4(86771),
     /*  79406 */   /*GILLT_nxv8s16*//*Label 1343*/ GIMT_Encode4(86797),
     /*  79410 */   /*GILLT_nxv16s1*//*Label 1344*/ GIMT_Encode4(86823),
     /*  79414 */   // Label 1334: @79414
     /*  79414 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(79934),
     /*  79419 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  79422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  79425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79433 */     GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(79495), // Rule ID 5782 //
     /*  79438 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79442 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79448 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  79450 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79452 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  79452 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  79455 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  79459 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79464 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  79468 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79470 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79473 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79475 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79478 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79481 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79484 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79489 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79494 */       // GIR_Coverage, 5782,
     /*  79494 */       GIR_EraseRootFromParent_Done,
     /*  79495 */     // Label 1347: @79495
     /*  79495 */     GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(79557), // Rule ID 5786 //
     /*  79500 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79504 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79510 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  79512 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79514 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  79514 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  79517 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  79521 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79526 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  79530 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79532 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79535 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79537 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79540 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79543 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79546 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79551 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79556 */       // GIR_Coverage, 5786,
     /*  79556 */       GIR_EraseRootFromParent_Done,
     /*  79557 */     // Label 1348: @79557
     /*  79557 */     GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(79615), // Rule ID 5783 //
     /*  79562 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79566 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  79570 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79572 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  79572 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  79575 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79579 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79584 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79586 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79589 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79591 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79594 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  79596 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79599 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79604 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79609 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79614 */       // GIR_Coverage, 5783,
     /*  79614 */       GIR_EraseRootFromParent_Done,
     /*  79615 */     // Label 1349: @79615
     /*  79615 */     GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(79673), // Rule ID 5787 //
     /*  79620 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79624 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  79628 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79630 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  79630 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  79633 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79637 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79642 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79649 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79652 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  79654 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79657 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79662 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79667 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79672 */       // GIR_Coverage, 5787,
     /*  79672 */       GIR_EraseRootFromParent_Done,
     /*  79673 */     // Label 1350: @79673
     /*  79673 */     GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(79803), // Rule ID 5781 //
     /*  79678 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79682 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  79682 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  79685 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79689 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79694 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  79696 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  79699 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79703 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79708 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  79711 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  79715 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  79718 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79723 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79728 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79733 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79736 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79740 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79745 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79747 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79750 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79754 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79759 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79762 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79766 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79769 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79774 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79779 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79784 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79787 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79789 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79792 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79795 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79798 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79801 */       GIR_RootConstrainSelectedInstOperands,
     /*  79802 */       // GIR_Coverage, 5781,
     /*  79802 */       GIR_EraseRootFromParent_Done,
     /*  79803 */     // Label 1351: @79803
     /*  79803 */     GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(79933), // Rule ID 5785 //
     /*  79808 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79812 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  79812 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  79815 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79819 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79824 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  79826 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  79829 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79833 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79838 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  79841 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  79845 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  79848 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79853 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79858 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79863 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79866 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79870 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79875 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79877 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79880 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79884 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79889 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79892 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79896 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79899 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79904 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79909 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79914 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79917 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79919 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79922 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79925 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79928 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79931 */       GIR_RootConstrainSelectedInstOperands,
     /*  79932 */       // GIR_Coverage, 5785,
     /*  79932 */       GIR_EraseRootFromParent_Done,
     /*  79933 */     // Label 1352: @79933
     /*  79933 */     GIM_Reject,
     /*  79934 */   // Label 1346: @79934
     /*  79934 */   GIM_Reject,
     /*  79935 */   // Label 1335: @79935
     /*  79935 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(82346),
     /*  79940 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  79943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  79946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79950 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(80079), // Rule ID 5431 //
     /*  79955 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79959 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79963 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79967 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79971 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79975 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79979 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79983 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79987 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79991 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79995 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  79999 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80004 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80008 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80014 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80016 */       // MIs[2] Operand 2
     /*  80016 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80027 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80029 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  80029 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80032 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80036 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80041 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80044 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80048 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80061 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80064 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80066 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80069 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80073 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80077 */       GIR_RootConstrainSelectedInstOperands,
     /*  80078 */       // GIR_Coverage, 5431,
     /*  80078 */       GIR_EraseRootFromParent_Done,
     /*  80079 */     // Label 1354: @80079
     /*  80079 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(80201), // Rule ID 5427 //
     /*  80084 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80088 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80092 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80096 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80100 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80104 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80108 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80112 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80116 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  80120 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80124 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80128 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80133 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80138 */       // MIs[2] Operand 2
     /*  80138 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80149 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80151 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80151 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80154 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80158 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80163 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80166 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80170 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80173 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80178 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80183 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  80186 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80188 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80191 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80195 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80199 */       GIR_RootConstrainSelectedInstOperands,
     /*  80200 */       // GIR_Coverage, 5427,
     /*  80200 */       GIR_EraseRootFromParent_Done,
     /*  80201 */     // Label 1355: @80201
     /*  80201 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(80323), // Rule ID 5429 //
     /*  80206 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80210 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80214 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80218 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80222 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80226 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80230 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80234 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80238 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80242 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80246 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80250 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80255 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80260 */       // MIs[2] Operand 2
     /*  80260 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80271 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80273 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80273 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80276 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80280 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80285 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80288 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80292 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80295 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80300 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80305 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80308 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80310 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80313 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80317 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80321 */       GIR_RootConstrainSelectedInstOperands,
     /*  80322 */       // GIR_Coverage, 5429,
     /*  80322 */       GIR_EraseRootFromParent_Done,
     /*  80323 */     // Label 1356: @80323
     /*  80323 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(80425), // Rule ID 5577 //
     /*  80328 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80332 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80336 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80340 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80344 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80348 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80352 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80357 */       // MIs[2] Operand 2
     /*  80357 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80368 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  80372 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80376 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80380 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  80384 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80388 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80392 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80397 */       // MIs[4] Operand 2
     /*  80397 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  80408 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80410 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  80410 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  80413 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80415 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  80419 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  80423 */       GIR_RootConstrainSelectedInstOperands,
     /*  80424 */       // GIR_Coverage, 5577,
     /*  80424 */       GIR_EraseRootFromParent_Done,
     /*  80425 */     // Label 1357: @80425
     /*  80425 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(80554), // Rule ID 6337 //
     /*  80430 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80434 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80438 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80442 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80445 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  80450 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80454 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  80458 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80463 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  80467 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80469 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  80469 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  80472 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  80476 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80481 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  80484 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  80486 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80489 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80493 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80498 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80500 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80503 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80507 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80512 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80515 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  80519 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80522 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  80540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  80549 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80552 */       GIR_RootConstrainSelectedInstOperands,
     /*  80553 */       // GIR_Coverage, 6337,
     /*  80553 */       GIR_EraseRootFromParent_Done,
     /*  80554 */     // Label 1358: @80554
     /*  80554 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(80596), // Rule ID 5792 //
     /*  80559 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  80566 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  80573 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  80573 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80576 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80578 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  80583 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80586 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  80591 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80594 */       GIR_RootConstrainSelectedInstOperands,
     /*  80595 */       // GIR_Coverage, 5792,
     /*  80595 */       GIR_EraseRootFromParent_Done,
     /*  80596 */     // Label 1359: @80596
     /*  80596 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(80638), // Rule ID 5796 //
     /*  80601 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  80608 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  80615 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  80615 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80618 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80620 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  80625 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80628 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  80633 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80636 */       GIR_RootConstrainSelectedInstOperands,
     /*  80637 */       // GIR_Coverage, 5796,
     /*  80637 */       GIR_EraseRootFromParent_Done,
     /*  80638 */     // Label 1360: @80638
     /*  80638 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80761), // Rule ID 2578 //
     /*  80643 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80646 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80650 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80654 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80658 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80661 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  80666 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80670 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  80674 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80679 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  80683 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80687 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80691 */       // MIs[2] Operand 1
     /*  80691 */       // No operand predicates
     /*  80691 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80693 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  80693 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80696 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80700 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80705 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80707 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80710 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80714 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80719 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80722 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80726 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80729 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80734 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80739 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80744 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  80747 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80749 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80752 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80756 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  80759 */       GIR_RootConstrainSelectedInstOperands,
     /*  80760 */       // GIR_Coverage, 2578,
     /*  80760 */       GIR_EraseRootFromParent_Done,
     /*  80761 */     // Label 1361: @80761
     /*  80761 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80884), // Rule ID 6307 //
     /*  80766 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80769 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80773 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80777 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80781 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80785 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80789 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  80793 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80797 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80802 */       // MIs[2] imm
     /*  80802 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80806 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80810 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80814 */       // MIs[3] Operand 1
     /*  80814 */       // No operand predicates
     /*  80814 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80816 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  80816 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80819 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80823 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80828 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80830 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80833 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80837 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80842 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80845 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80849 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80852 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80857 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80862 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80867 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  80870 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80872 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80875 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  80879 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  80882 */       GIR_RootConstrainSelectedInstOperands,
     /*  80883 */       // GIR_Coverage, 6307,
     /*  80883 */       GIR_EraseRootFromParent_Done,
     /*  80884 */     // Label 1362: @80884
     /*  80884 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(81004), // Rule ID 6343 //
     /*  80889 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80893 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80897 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80901 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80905 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80909 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80913 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80917 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80922 */       // MIs[2] imm
     /*  80922 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80926 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80930 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80934 */       // MIs[3] Operand 1
     /*  80934 */       // No operand predicates
     /*  80934 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80936 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  80936 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80939 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80943 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80948 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80950 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80953 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80957 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80962 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80965 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80969 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80972 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80977 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80982 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80987 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  80990 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80992 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80995 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  80999 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81002 */       GIR_RootConstrainSelectedInstOperands,
     /*  81003 */       // GIR_Coverage, 6343,
     /*  81003 */       GIR_EraseRootFromParent_Done,
     /*  81004 */     // Label 1363: @81004
     /*  81004 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(81121), // Rule ID 2501 //
     /*  81009 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81012 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81016 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81020 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81024 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81027 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  81032 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81036 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81040 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81045 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81050 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81052 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81052 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81055 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81059 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81064 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81066 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81069 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81073 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81078 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81081 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81085 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81088 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81093 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81098 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81103 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  81106 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81108 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81111 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81115 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81119 */       GIR_RootConstrainSelectedInstOperands,
     /*  81120 */       // GIR_Coverage, 2501,
     /*  81120 */       GIR_EraseRootFromParent_Done,
     /*  81121 */     // Label 1364: @81121
     /*  81121 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(81238), // Rule ID 5347 //
     /*  81126 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81129 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81133 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81137 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81141 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81144 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  81149 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81153 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81157 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81162 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81167 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81169 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81169 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81172 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81176 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81181 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81183 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81186 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81190 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81195 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81198 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81202 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81205 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81210 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81215 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81220 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81223 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81225 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81228 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81232 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81236 */       GIR_RootConstrainSelectedInstOperands,
     /*  81237 */       // GIR_Coverage, 5347,
     /*  81237 */       GIR_EraseRootFromParent_Done,
     /*  81238 */     // Label 1365: @81238
     /*  81238 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(81355), // Rule ID 5350 //
     /*  81243 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81246 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81250 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81254 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81258 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81261 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  81266 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81270 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81274 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81279 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81284 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81286 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81286 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81289 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81293 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81298 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81300 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81303 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81307 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81312 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81315 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81319 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81322 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81327 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81332 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81337 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  81340 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81342 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81345 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81349 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81353 */       GIR_RootConstrainSelectedInstOperands,
     /*  81354 */       // GIR_Coverage, 5350,
     /*  81354 */       GIR_EraseRootFromParent_Done,
     /*  81355 */     // Label 1366: @81355
     /*  81355 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(81472), // Rule ID 5353 //
     /*  81360 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81363 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81367 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81371 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81375 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81378 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  81383 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81387 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81391 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81396 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81401 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81403 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81403 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81406 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81410 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81415 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81417 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81420 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81424 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81429 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81432 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81436 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81439 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81444 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81449 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81454 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  81457 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81459 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81462 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81466 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81470 */       GIR_RootConstrainSelectedInstOperands,
     /*  81471 */       // GIR_Coverage, 5353,
     /*  81471 */       GIR_EraseRootFromParent_Done,
     /*  81472 */     // Label 1367: @81472
     /*  81472 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(81576), // Rule ID 2497 //
     /*  81477 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81480 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81484 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81488 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81492 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  81495 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  81500 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81504 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81509 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81511 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  81511 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81514 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81518 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81523 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81525 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81528 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81532 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81537 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81540 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81544 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81547 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81552 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81557 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81562 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  81565 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81570 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81574 */       GIR_RootConstrainSelectedInstOperands,
     /*  81575 */       // GIR_Coverage, 2497,
     /*  81575 */       GIR_EraseRootFromParent_Done,
     /*  81576 */     // Label 1368: @81576
     /*  81576 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(81632), // Rule ID 5510 //
     /*  81581 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81585 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81589 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81593 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81598 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81602 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81606 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81610 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81615 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81617 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  81617 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  81620 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81622 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  81626 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  81630 */       GIR_RootConstrainSelectedInstOperands,
     /*  81631 */       // GIR_Coverage, 5510,
     /*  81631 */       GIR_EraseRootFromParent_Done,
     /*  81632 */     // Label 1369: @81632
     /*  81632 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(81698), // Rule ID 5790 //
     /*  81637 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81641 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81645 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81651 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  81653 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81655 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  81655 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  81658 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  81662 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81667 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  81671 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81673 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81676 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81678 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81681 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81684 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81687 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81692 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81697 */       // GIR_Coverage, 5790,
     /*  81697 */       GIR_EraseRootFromParent_Done,
     /*  81698 */     // Label 1370: @81698
     /*  81698 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(81764), // Rule ID 5794 //
     /*  81703 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81707 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81711 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81717 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  81719 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81721 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  81721 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  81724 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  81728 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81733 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  81737 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81739 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81742 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81744 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81747 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81750 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81753 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81758 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81763 */       // GIR_Coverage, 5794,
     /*  81763 */       GIR_EraseRootFromParent_Done,
     /*  81764 */     // Label 1371: @81764
     /*  81764 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81857), // Rule ID 4914 //
     /*  81769 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81773 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81777 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  81781 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81785 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81790 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81792 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  81792 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81795 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81799 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81804 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81806 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81809 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81813 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81818 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81821 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81825 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81828 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81833 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81838 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81843 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  81846 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81848 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81851 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  81855 */       GIR_RootConstrainSelectedInstOperands,
     /*  81856 */       // GIR_Coverage, 4914,
     /*  81856 */       GIR_EraseRootFromParent_Done,
     /*  81857 */     // Label 1372: @81857
     /*  81857 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81953), // Rule ID 4961 //
     /*  81862 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81865 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81869 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81873 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81877 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81881 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81886 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81888 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  81888 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81891 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81895 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81900 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81902 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81905 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81909 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81914 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81917 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81921 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81924 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81929 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81934 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81939 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  81942 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81944 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81947 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  81951 */       GIR_RootConstrainSelectedInstOperands,
     /*  81952 */       // GIR_Coverage, 4961,
     /*  81952 */       GIR_EraseRootFromParent_Done,
     /*  81953 */     // Label 1373: @81953
     /*  81953 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(82015), // Rule ID 5791 //
     /*  81958 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81962 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81966 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  81970 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81972 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  81972 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81975 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81979 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81984 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81986 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81989 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81991 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81994 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  81996 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81999 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82004 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82009 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82014 */       // GIR_Coverage, 5791,
     /*  82014 */       GIR_EraseRootFromParent_Done,
     /*  82015 */     // Label 1374: @82015
     /*  82015 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(82077), // Rule ID 5795 //
     /*  82020 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82024 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82028 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82032 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82034 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  82034 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82037 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82041 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82046 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82048 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82051 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82053 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82056 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82058 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82061 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82066 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82071 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82076 */       // GIR_Coverage, 5795,
     /*  82076 */       GIR_EraseRootFromParent_Done,
     /*  82077 */     // Label 1375: @82077
     /*  82077 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(82211), // Rule ID 5789 //
     /*  82082 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82086 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82090 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82090 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82093 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82097 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82102 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82104 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82107 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82111 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82116 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82119 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82123 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82126 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82131 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82136 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82141 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82144 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82148 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82153 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82155 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82158 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82162 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82167 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82170 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82174 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82182 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82187 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82192 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82195 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82197 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82200 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82203 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82206 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82209 */       GIR_RootConstrainSelectedInstOperands,
     /*  82210 */       // GIR_Coverage, 5789,
     /*  82210 */       GIR_EraseRootFromParent_Done,
     /*  82211 */     // Label 1376: @82211
     /*  82211 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(82345), // Rule ID 5793 //
     /*  82216 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82220 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82224 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82224 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82227 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82231 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82236 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82238 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82241 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82245 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82250 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82253 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82257 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82260 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82265 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82270 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82275 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82278 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82282 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82287 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82289 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82292 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82296 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82301 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82304 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82308 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82311 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82316 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82321 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82329 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82331 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82334 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82337 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82340 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82343 */       GIR_RootConstrainSelectedInstOperands,
     /*  82344 */       // GIR_Coverage, 5793,
     /*  82344 */       GIR_EraseRootFromParent_Done,
     /*  82345 */     // Label 1377: @82345
     /*  82345 */     GIM_Reject,
     /*  82346 */   // Label 1353: @82346
     /*  82346 */   GIM_Reject,
     /*  82347 */   // Label 1336: @82347
     /*  82347 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(84755),
     /*  82352 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  82355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  82358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82362 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(82491), // Rule ID 5425 //
     /*  82367 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82371 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82375 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82379 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82383 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82387 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82391 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82395 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82399 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82403 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82407 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82411 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82416 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82420 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82426 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82428 */       // MIs[2] Operand 2
     /*  82428 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82439 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82441 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  82441 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82444 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82448 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82453 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82456 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82460 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82463 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82468 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82473 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  82476 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82478 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82481 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82485 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82489 */       GIR_RootConstrainSelectedInstOperands,
     /*  82490 */       // GIR_Coverage, 5425,
     /*  82490 */       GIR_EraseRootFromParent_Done,
     /*  82491 */     // Label 1379: @82491
     /*  82491 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(82613), // Rule ID 5421 //
     /*  82496 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82500 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82504 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82508 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82512 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82516 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82520 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82524 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82528 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  82532 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82536 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82540 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82545 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82550 */       // MIs[2] Operand 2
     /*  82550 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82561 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82563 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82563 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82566 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82570 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82575 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82578 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82582 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82585 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82590 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82595 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  82598 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82600 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82603 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82607 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82611 */       GIR_RootConstrainSelectedInstOperands,
     /*  82612 */       // GIR_Coverage, 5421,
     /*  82612 */       GIR_EraseRootFromParent_Done,
     /*  82613 */     // Label 1380: @82613
     /*  82613 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(82735), // Rule ID 5423 //
     /*  82618 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82622 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82626 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82630 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82634 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82638 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82642 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82646 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82650 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  82654 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82658 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82662 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82667 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82672 */       // MIs[2] Operand 2
     /*  82672 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82683 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82685 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82685 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82688 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82692 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82697 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82700 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82704 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82707 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82712 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82717 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  82720 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82722 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82725 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82729 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82733 */       GIR_RootConstrainSelectedInstOperands,
     /*  82734 */       // GIR_Coverage, 5423,
     /*  82734 */       GIR_EraseRootFromParent_Done,
     /*  82735 */     // Label 1381: @82735
     /*  82735 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82837), // Rule ID 5576 //
     /*  82740 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82744 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82748 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82752 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82756 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82760 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82764 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82769 */       // MIs[2] Operand 2
     /*  82769 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82780 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  82784 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82788 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82792 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  82796 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82800 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82804 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82809 */       // MIs[4] Operand 2
     /*  82809 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  82820 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82822 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  82822 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  82825 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82827 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  82831 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  82835 */       GIR_RootConstrainSelectedInstOperands,
     /*  82836 */       // GIR_Coverage, 5576,
     /*  82836 */       GIR_EraseRootFromParent_Done,
     /*  82837 */     // Label 1382: @82837
     /*  82837 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82966), // Rule ID 6336 //
     /*  82842 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82846 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82850 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82854 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82857 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  82862 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82866 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  82870 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82875 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  82879 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82881 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  82881 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  82884 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  82888 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82893 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  82896 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  82898 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82901 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82905 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82910 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82912 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82915 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82919 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82924 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82927 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  82931 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82934 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82939 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82944 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82949 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  82952 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82954 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82957 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  82961 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82964 */       GIR_RootConstrainSelectedInstOperands,
     /*  82965 */       // GIR_Coverage, 6336,
     /*  82965 */       GIR_EraseRootFromParent_Done,
     /*  82966 */     // Label 1383: @82966
     /*  82966 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(83008), // Rule ID 5800 //
     /*  82971 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  82978 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  82985 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  82985 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82988 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82990 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  82995 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82998 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83003 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83006 */       GIR_RootConstrainSelectedInstOperands,
     /*  83007 */       // GIR_Coverage, 5800,
     /*  83007 */       GIR_EraseRootFromParent_Done,
     /*  83008 */     // Label 1384: @83008
     /*  83008 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(83050), // Rule ID 5804 //
     /*  83013 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83020 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83027 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  83027 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83030 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83032 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83037 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83040 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83045 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83048 */       GIR_RootConstrainSelectedInstOperands,
     /*  83049 */       // GIR_Coverage, 5804,
     /*  83049 */       GIR_EraseRootFromParent_Done,
     /*  83050 */     // Label 1385: @83050
     /*  83050 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(83173), // Rule ID 2576 //
     /*  83055 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83058 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83062 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83066 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83070 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83073 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83078 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83082 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83086 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83091 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  83095 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83099 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83103 */       // MIs[2] Operand 1
     /*  83103 */       // No operand predicates
     /*  83103 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83105 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83105 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83108 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83112 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83117 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83119 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83122 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83126 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83131 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83134 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83138 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83146 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83151 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83156 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  83159 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83161 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83164 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83168 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  83171 */       GIR_RootConstrainSelectedInstOperands,
     /*  83172 */       // GIR_Coverage, 2576,
     /*  83172 */       GIR_EraseRootFromParent_Done,
     /*  83173 */     // Label 1386: @83173
     /*  83173 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(83296), // Rule ID 6306 //
     /*  83178 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83181 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83185 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83189 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83193 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83197 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83201 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  83205 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83209 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83214 */       // MIs[2] imm
     /*  83214 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83218 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83222 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83226 */       // MIs[3] Operand 1
     /*  83226 */       // No operand predicates
     /*  83226 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83228 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83228 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83231 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83235 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83240 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83242 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83245 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83249 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83254 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83257 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83261 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83264 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83269 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83274 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83279 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83282 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83284 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83287 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83291 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83294 */       GIR_RootConstrainSelectedInstOperands,
     /*  83295 */       // GIR_Coverage, 6306,
     /*  83295 */       GIR_EraseRootFromParent_Done,
     /*  83296 */     // Label 1387: @83296
     /*  83296 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(83416), // Rule ID 6342 //
     /*  83301 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83305 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83309 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83313 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83317 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83321 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83325 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83329 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83334 */       // MIs[2] imm
     /*  83334 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83338 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83342 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83346 */       // MIs[3] Operand 1
     /*  83346 */       // No operand predicates
     /*  83346 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83348 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83348 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83351 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83355 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83360 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83362 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83365 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83369 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83374 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83377 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83381 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83384 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83389 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83394 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83399 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83402 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83404 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83407 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83411 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83414 */       GIR_RootConstrainSelectedInstOperands,
     /*  83415 */       // GIR_Coverage, 6342,
     /*  83415 */       GIR_EraseRootFromParent_Done,
     /*  83416 */     // Label 1388: @83416
     /*  83416 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(83533), // Rule ID 2500 //
     /*  83421 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83424 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83428 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83432 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83436 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83439 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  83444 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83448 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83452 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83457 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83462 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83464 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83464 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83467 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83471 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83476 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83478 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83481 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83485 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83490 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83493 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83497 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83500 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83505 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83510 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83515 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  83518 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83520 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83523 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83527 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83531 */       GIR_RootConstrainSelectedInstOperands,
     /*  83532 */       // GIR_Coverage, 2500,
     /*  83532 */       GIR_EraseRootFromParent_Done,
     /*  83533 */     // Label 1389: @83533
     /*  83533 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(83650), // Rule ID 5346 //
     /*  83538 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83541 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83545 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83549 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83553 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83556 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  83561 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83565 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83569 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83574 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83579 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83581 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83581 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83584 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83588 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83593 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83595 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83598 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83602 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83607 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83610 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83614 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83617 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83622 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83627 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83632 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83635 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83637 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83640 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83644 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83648 */       GIR_RootConstrainSelectedInstOperands,
     /*  83649 */       // GIR_Coverage, 5346,
     /*  83649 */       GIR_EraseRootFromParent_Done,
     /*  83650 */     // Label 1390: @83650
     /*  83650 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(83767), // Rule ID 5349 //
     /*  83655 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83658 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83662 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83666 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83670 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83673 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  83678 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83682 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83686 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83691 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83696 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83698 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83698 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83701 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83705 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83710 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83712 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83715 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83719 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83724 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83727 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83731 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83734 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83739 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83749 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  83752 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83754 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83757 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83761 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83765 */       GIR_RootConstrainSelectedInstOperands,
     /*  83766 */       // GIR_Coverage, 5349,
     /*  83766 */       GIR_EraseRootFromParent_Done,
     /*  83767 */     // Label 1391: @83767
     /*  83767 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83884), // Rule ID 5352 //
     /*  83772 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83775 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83779 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83783 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83787 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83790 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  83795 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83799 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83803 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83808 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83813 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83815 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83815 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83818 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83822 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83827 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83829 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83832 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83836 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83841 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83844 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83848 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83851 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83856 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83861 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83866 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  83869 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83871 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83874 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83878 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83882 */       GIR_RootConstrainSelectedInstOperands,
     /*  83883 */       // GIR_Coverage, 5352,
     /*  83883 */       GIR_EraseRootFromParent_Done,
     /*  83884 */     // Label 1392: @83884
     /*  83884 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83985), // Rule ID 4908 //
     /*  83889 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83893 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83897 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83901 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  83904 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  83909 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83913 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83918 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83920 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  83920 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83923 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83927 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83932 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83934 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83937 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83941 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83946 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83949 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83953 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83956 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83961 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83966 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83971 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  83974 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83976 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83979 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83983 */       GIR_RootConstrainSelectedInstOperands,
     /*  83984 */       // GIR_Coverage, 4908,
     /*  83984 */       GIR_EraseRootFromParent_Done,
     /*  83985 */     // Label 1393: @83985
     /*  83985 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(84041), // Rule ID 5501 //
     /*  83990 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83994 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83998 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84002 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84007 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84011 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84015 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84019 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84024 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84026 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  84026 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  84029 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84031 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  84035 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  84039 */       GIR_RootConstrainSelectedInstOperands,
     /*  84040 */       // GIR_Coverage, 5501,
     /*  84040 */       GIR_EraseRootFromParent_Done,
     /*  84041 */     // Label 1394: @84041
     /*  84041 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(84107), // Rule ID 5798 //
     /*  84046 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84050 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84054 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84060 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84062 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84064 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  84064 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84067 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84071 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84076 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84080 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84082 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84085 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84087 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84090 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84093 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84096 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84101 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84106 */       // GIR_Coverage, 5798,
     /*  84106 */       GIR_EraseRootFromParent_Done,
     /*  84107 */     // Label 1395: @84107
     /*  84107 */     GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(84173), // Rule ID 5802 //
     /*  84112 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84116 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84120 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84126 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84128 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84130 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  84130 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84133 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84137 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84142 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84146 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84148 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84151 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84153 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84156 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84159 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84162 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84167 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84172 */       // GIR_Coverage, 5802,
     /*  84172 */       GIR_EraseRootFromParent_Done,
     /*  84173 */     // Label 1396: @84173
     /*  84173 */     GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(84266), // Rule ID 4916 //
     /*  84178 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84182 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84186 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  84190 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84194 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84199 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84201 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84201 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84204 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84208 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84213 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84215 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84218 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84222 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84227 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84230 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84234 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84237 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84242 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84247 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84252 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84255 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84257 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84260 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84264 */       GIR_RootConstrainSelectedInstOperands,
     /*  84265 */       // GIR_Coverage, 4916,
     /*  84265 */       GIR_EraseRootFromParent_Done,
     /*  84266 */     // Label 1397: @84266
     /*  84266 */     GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(84362), // Rule ID 4960 //
     /*  84271 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84274 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84278 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84282 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84286 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84290 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84295 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84297 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  84297 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84300 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84304 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84309 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84311 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84314 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84318 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84323 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84326 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84330 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84333 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84338 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84343 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84348 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  84351 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84353 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84356 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84360 */       GIR_RootConstrainSelectedInstOperands,
     /*  84361 */       // GIR_Coverage, 4960,
     /*  84361 */       GIR_EraseRootFromParent_Done,
     /*  84362 */     // Label 1398: @84362
     /*  84362 */     GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(84424), // Rule ID 5799 //
     /*  84367 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84371 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84375 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  84379 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84381 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  84381 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  84384 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84388 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84393 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84395 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84398 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84400 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84403 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  84405 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84408 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84413 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84418 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84423 */       // GIR_Coverage, 5799,
     /*  84423 */       GIR_EraseRootFromParent_Done,
     /*  84424 */     // Label 1399: @84424
     /*  84424 */     GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(84486), // Rule ID 5803 //
     /*  84429 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84433 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84437 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  84441 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84443 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  84443 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  84446 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84450 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84455 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84457 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84460 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84462 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84465 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  84467 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84470 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84475 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84480 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84485 */       // GIR_Coverage, 5803,
     /*  84485 */       GIR_EraseRootFromParent_Done,
     /*  84486 */     // Label 1400: @84486
     /*  84486 */     GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(84620), // Rule ID 5797 //
     /*  84491 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84495 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84499 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  84499 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  84502 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84506 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84511 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  84513 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  84516 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84520 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84525 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  84528 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  84532 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  84535 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84540 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84545 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84550 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84553 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84557 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84562 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84564 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84567 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84571 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84576 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84579 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84583 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84586 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84591 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84596 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84601 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  84604 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84606 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84609 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  84612 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  84615 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84618 */       GIR_RootConstrainSelectedInstOperands,
     /*  84619 */       // GIR_Coverage, 5797,
     /*  84619 */       GIR_EraseRootFromParent_Done,
     /*  84620 */     // Label 1401: @84620
     /*  84620 */     GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(84754), // Rule ID 5801 //
     /*  84625 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84629 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84633 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  84633 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  84636 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84640 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84645 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  84647 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  84650 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84654 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84659 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  84662 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  84666 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  84669 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84674 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84679 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84684 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84687 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84691 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84696 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84698 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84701 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84705 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84710 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84713 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84717 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84720 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84725 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84730 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84735 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  84738 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84740 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84743 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  84746 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  84749 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84752 */       GIR_RootConstrainSelectedInstOperands,
     /*  84753 */       // GIR_Coverage, 5801,
     /*  84753 */       GIR_EraseRootFromParent_Done,
     /*  84754 */     // Label 1402: @84754
     /*  84754 */     GIM_Reject,
     /*  84755 */   // Label 1378: @84755
     /*  84755 */   GIM_Reject,
     /*  84756 */   // Label 1337: @84756
     /*  84756 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(86666),
     /*  84761 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  84767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84771 */     GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(84900), // Rule ID 5419 //
     /*  84776 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84780 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84784 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84788 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84792 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84796 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84800 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84804 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84808 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84812 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84816 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84820 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84825 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84829 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84835 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84837 */       // MIs[2] Operand 2
     /*  84837 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84848 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84850 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  84850 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84853 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84857 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84862 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84865 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84869 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84872 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84877 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84882 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  84885 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84887 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84890 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  84894 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  84898 */       GIR_RootConstrainSelectedInstOperands,
     /*  84899 */       // GIR_Coverage, 5419,
     /*  84899 */       GIR_EraseRootFromParent_Done,
     /*  84900 */     // Label 1404: @84900
     /*  84900 */     GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(85022), // Rule ID 5415 //
     /*  84905 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84909 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84913 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84917 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84921 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84925 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84929 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84933 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84937 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  84941 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84945 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84949 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84954 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84959 */       // MIs[2] Operand 2
     /*  84959 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84970 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84972 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  84972 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84975 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84979 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84984 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84987 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84991 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84994 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84999 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85004 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85007 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85009 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85012 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85016 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85020 */       GIR_RootConstrainSelectedInstOperands,
     /*  85021 */       // GIR_Coverage, 5415,
     /*  85021 */       GIR_EraseRootFromParent_Done,
     /*  85022 */     // Label 1405: @85022
     /*  85022 */     GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(85144), // Rule ID 5417 //
     /*  85027 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85031 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85035 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85039 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85043 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85047 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85051 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85055 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85059 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  85063 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85067 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85071 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85076 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85081 */       // MIs[2] Operand 2
     /*  85081 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85092 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85094 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85094 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85097 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85101 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85106 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85109 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85113 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85116 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85121 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85126 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85129 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85131 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85134 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85138 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85142 */       GIR_RootConstrainSelectedInstOperands,
     /*  85143 */       // GIR_Coverage, 5417,
     /*  85143 */       GIR_EraseRootFromParent_Done,
     /*  85144 */     // Label 1406: @85144
     /*  85144 */     GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(85246), // Rule ID 5575 //
     /*  85149 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85153 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85157 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85161 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85165 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85169 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85173 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85178 */       // MIs[2] Operand 2
     /*  85178 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85189 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  85193 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85197 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85201 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  85205 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85209 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85213 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85218 */       // MIs[4] Operand 2
     /*  85218 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  85229 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85231 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  85231 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  85234 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85236 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  85240 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  85244 */       GIR_RootConstrainSelectedInstOperands,
     /*  85245 */       // GIR_Coverage, 5575,
     /*  85245 */       GIR_EraseRootFromParent_Done,
     /*  85246 */     // Label 1407: @85246
     /*  85246 */     GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(85375), // Rule ID 6335 //
     /*  85251 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85255 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85259 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85263 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85266 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85271 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85275 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85279 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85284 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  85288 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85290 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  85290 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  85293 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  85297 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85302 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  85305 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  85307 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85310 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85314 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85319 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85321 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85324 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85328 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85333 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85336 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  85340 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85343 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85348 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85353 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85358 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  85361 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85363 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85366 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  85370 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85373 */       GIR_RootConstrainSelectedInstOperands,
     /*  85374 */       // GIR_Coverage, 6335,
     /*  85374 */       GIR_EraseRootFromParent_Done,
     /*  85375 */     // Label 1408: @85375
     /*  85375 */     GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(85417), // Rule ID 5808 //
     /*  85380 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  85387 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  85394 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  85394 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85397 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85399 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  85404 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85407 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  85412 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85415 */       GIR_RootConstrainSelectedInstOperands,
     /*  85416 */       // GIR_Coverage, 5808,
     /*  85416 */       GIR_EraseRootFromParent_Done,
     /*  85417 */     // Label 1409: @85417
     /*  85417 */     GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(85540), // Rule ID 2574 //
     /*  85422 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85425 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85429 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85433 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85437 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85440 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85445 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85449 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85453 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85458 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  85462 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85466 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85470 */       // MIs[2] Operand 1
     /*  85470 */       // No operand predicates
     /*  85470 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85472 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85472 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85475 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85479 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85484 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85486 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85489 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85493 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85498 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85501 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85505 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85508 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85513 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85518 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85523 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  85526 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85528 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85531 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85535 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  85538 */       GIR_RootConstrainSelectedInstOperands,
     /*  85539 */       // GIR_Coverage, 2574,
     /*  85539 */       GIR_EraseRootFromParent_Done,
     /*  85540 */     // Label 1410: @85540
     /*  85540 */     GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(85663), // Rule ID 6305 //
     /*  85545 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85548 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85552 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85556 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85560 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85564 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85568 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  85572 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85576 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85581 */       // MIs[2] imm
     /*  85581 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85585 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85589 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85593 */       // MIs[3] Operand 1
     /*  85593 */       // No operand predicates
     /*  85593 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85595 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85595 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85598 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85602 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85607 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85609 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85612 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85616 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85621 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85624 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85628 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85631 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85636 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85641 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85646 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  85649 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85651 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85654 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  85658 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  85661 */       GIR_RootConstrainSelectedInstOperands,
     /*  85662 */       // GIR_Coverage, 6305,
     /*  85662 */       GIR_EraseRootFromParent_Done,
     /*  85663 */     // Label 1411: @85663
     /*  85663 */     GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(85783), // Rule ID 6341 //
     /*  85668 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85672 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85676 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85680 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85684 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85688 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85692 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85696 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85701 */       // MIs[2] imm
     /*  85701 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85705 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85709 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85713 */       // MIs[3] Operand 1
     /*  85713 */       // No operand predicates
     /*  85713 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85715 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85715 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85718 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85722 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85727 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85729 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85732 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85736 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85741 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85744 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85748 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85751 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85756 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85761 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85766 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  85769 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85771 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85774 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  85778 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  85781 */       GIR_RootConstrainSelectedInstOperands,
     /*  85782 */       // GIR_Coverage, 6341,
     /*  85782 */       GIR_EraseRootFromParent_Done,
     /*  85783 */     // Label 1412: @85783
     /*  85783 */     GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(85900), // Rule ID 2499 //
     /*  85788 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85791 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85795 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85799 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85803 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85806 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  85811 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85815 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85819 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85824 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85829 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85831 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85831 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85834 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85838 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85843 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85845 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85848 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85852 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85857 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85860 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85864 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85867 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85872 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85877 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85882 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85885 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85887 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85890 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85894 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  85898 */       GIR_RootConstrainSelectedInstOperands,
     /*  85899 */       // GIR_Coverage, 2499,
     /*  85899 */       GIR_EraseRootFromParent_Done,
     /*  85900 */     // Label 1413: @85900
     /*  85900 */     GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(86017), // Rule ID 5345 //
     /*  85905 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85908 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85912 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85916 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85920 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85923 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  85928 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85932 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85936 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85941 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85946 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85948 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85948 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85951 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85955 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85960 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85962 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85965 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85969 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85974 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85977 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85981 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85984 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85989 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85994 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85999 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  86002 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86004 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86007 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86011 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86015 */       GIR_RootConstrainSelectedInstOperands,
     /*  86016 */       // GIR_Coverage, 5345,
     /*  86016 */       GIR_EraseRootFromParent_Done,
     /*  86017 */     // Label 1414: @86017
     /*  86017 */     GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(86134), // Rule ID 5348 //
     /*  86022 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86025 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86029 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86033 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86037 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86040 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  86045 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86049 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86053 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86058 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86063 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86065 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86065 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86068 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86072 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86077 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86079 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86082 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86086 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86091 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86094 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86098 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86101 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86106 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86111 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86116 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86119 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86121 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86124 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86128 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86132 */       GIR_RootConstrainSelectedInstOperands,
     /*  86133 */       // GIR_Coverage, 5348,
     /*  86133 */       GIR_EraseRootFromParent_Done,
     /*  86134 */     // Label 1415: @86134
     /*  86134 */     GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(86251), // Rule ID 5351 //
     /*  86139 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86142 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86146 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86150 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86154 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86157 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  86162 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86166 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86170 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86175 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86180 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86182 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86182 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86185 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86189 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86194 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86196 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86199 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86203 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86208 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86211 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86215 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86218 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86223 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86228 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86233 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  86236 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86238 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86241 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86245 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86249 */       GIR_RootConstrainSelectedInstOperands,
     /*  86250 */       // GIR_Coverage, 5351,
     /*  86250 */       GIR_EraseRootFromParent_Done,
     /*  86251 */     // Label 1416: @86251
     /*  86251 */     GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(86307), // Rule ID 5492 //
     /*  86256 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86260 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86264 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86268 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86273 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86277 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86281 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86285 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86290 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86292 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  86292 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  86295 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86297 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  86301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  86305 */       GIR_RootConstrainSelectedInstOperands,
     /*  86306 */       // GIR_Coverage, 5492,
     /*  86306 */       GIR_EraseRootFromParent_Done,
     /*  86307 */     // Label 1417: @86307
     /*  86307 */     GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(86373), // Rule ID 5806 //
     /*  86312 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86316 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86320 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86326 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  86328 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86330 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  86330 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86333 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  86337 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86342 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  86346 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86348 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  86351 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86353 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86356 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86359 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  86362 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86367 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86372 */       // GIR_Coverage, 5806,
     /*  86372 */       GIR_EraseRootFromParent_Done,
     /*  86373 */     // Label 1418: @86373
     /*  86373 */     GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(86469), // Rule ID 4959 //
     /*  86378 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86381 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86385 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86389 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86393 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86397 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86402 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86404 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  86404 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86407 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86411 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86416 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86418 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86421 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86425 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86430 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86433 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86437 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86440 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86445 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86450 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86455 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  86458 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86460 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86463 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86467 */       GIR_RootConstrainSelectedInstOperands,
     /*  86468 */       // GIR_Coverage, 4959,
     /*  86468 */       GIR_EraseRootFromParent_Done,
     /*  86469 */     // Label 1419: @86469
     /*  86469 */     GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(86531), // Rule ID 5807 //
     /*  86474 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86478 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86482 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  86486 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86488 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  86488 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  86491 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86495 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86500 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86502 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86505 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86507 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86510 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86512 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  86515 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86520 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86525 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86530 */       // GIR_Coverage, 5807,
     /*  86530 */       GIR_EraseRootFromParent_Done,
     /*  86531 */     // Label 1420: @86531
     /*  86531 */     GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(86665), // Rule ID 5805 //
     /*  86536 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86540 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86544 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  86544 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  86547 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86551 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86556 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  86558 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  86561 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86565 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86570 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  86573 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  86577 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  86580 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86585 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86590 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86595 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86598 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86602 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86607 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86609 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86612 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86616 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86621 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86624 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86628 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86631 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86636 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86641 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86646 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  86649 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86651 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86654 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  86657 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  86660 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86663 */       GIR_RootConstrainSelectedInstOperands,
     /*  86664 */       // GIR_Coverage, 5805,
     /*  86664 */       GIR_EraseRootFromParent_Done,
     /*  86665 */     // Label 1421: @86665
     /*  86665 */     GIM_Reject,
     /*  86666 */   // Label 1403: @86666
     /*  86666 */   GIM_Reject,
     /*  86667 */   // Label 1338: @86667
     /*  86667 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(86692), // Rule ID 9047 //
     /*  86672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86675 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  86678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  86681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86685 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  86685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  86690 */     GIR_RootConstrainSelectedInstOperands,
     /*  86691 */     // GIR_Coverage, 9047,
     /*  86691 */     GIR_Done,
     /*  86692 */   // Label 1422: @86692
     /*  86692 */   GIM_Reject,
     /*  86693 */   // Label 1339: @86693
     /*  86693 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(86718), // Rule ID 9048 //
     /*  86698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86701 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  86704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  86707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86711 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  86711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  86716 */     GIR_RootConstrainSelectedInstOperands,
     /*  86717 */     // GIR_Coverage, 9048,
     /*  86717 */     GIR_Done,
     /*  86718 */   // Label 1423: @86718
     /*  86718 */   GIM_Reject,
     /*  86719 */   // Label 1340: @86719
     /*  86719 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(86744), // Rule ID 9051 //
     /*  86724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86727 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  86730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  86733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86737 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  86737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  86742 */     GIR_RootConstrainSelectedInstOperands,
     /*  86743 */     // GIR_Coverage, 9051,
     /*  86743 */     GIR_Done,
     /*  86744 */   // Label 1424: @86744
     /*  86744 */   GIM_Reject,
     /*  86745 */   // Label 1341: @86745
     /*  86745 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(86770), // Rule ID 9053 //
     /*  86750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86753 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  86756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  86759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86763 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  86763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  86768 */     GIR_RootConstrainSelectedInstOperands,
     /*  86769 */     // GIR_Coverage, 9053,
     /*  86769 */     GIR_Done,
     /*  86770 */   // Label 1425: @86770
     /*  86770 */   GIM_Reject,
     /*  86771 */   // Label 1342: @86771
     /*  86771 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(86796), // Rule ID 9049 //
     /*  86776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86779 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  86782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  86785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86789 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  86789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  86794 */     GIR_RootConstrainSelectedInstOperands,
     /*  86795 */     // GIR_Coverage, 9049,
     /*  86795 */     GIR_Done,
     /*  86796 */   // Label 1426: @86796
     /*  86796 */   GIM_Reject,
     /*  86797 */   // Label 1343: @86797
     /*  86797 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(86822), // Rule ID 9052 //
     /*  86802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86805 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  86808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  86811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86815 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  86815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  86820 */     GIR_RootConstrainSelectedInstOperands,
     /*  86821 */     // GIR_Coverage, 9052,
     /*  86821 */     GIR_Done,
     /*  86822 */   // Label 1427: @86822
     /*  86822 */   GIM_Reject,
     /*  86823 */   // Label 1344: @86823
     /*  86823 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(86848), // Rule ID 9050 //
     /*  86828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86831 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  86834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  86837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86841 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  86841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  86846 */     GIR_RootConstrainSelectedInstOperands,
     /*  86847 */     // GIR_Coverage, 9050,
     /*  86847 */     GIR_Done,
     /*  86848 */   // Label 1428: @86848
     /*  86848 */   GIM_Reject,
     /*  86849 */   // Label 1345: @86849
     /*  86849 */   GIM_Reject,
     /*  86850 */ // Label 1333: @86850
     /*  86850 */ GIM_Reject,
     /*  86851 */ // Label 9: @86851
     /*  86851 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1443*/ GIMT_Encode4(96794),
     /*  86862 */ /*GILLT_s32*//*Label 1429*/ GIMT_Encode4(86950),
     /*  86866 */ /*GILLT_s64*//*Label 1430*/ GIMT_Encode4(87331),
     /*  86870 */ /*GILLT_s128*//*Label 1431*/ GIMT_Encode4(89306),
     /*  86874 */ /*GILLT_v2s32*//*Label 1432*/ GIMT_Encode4(89952),
     /*  86878 */ /*GILLT_v2s64*//*Label 1433*/ GIMT_Encode4(90867),
     /*  86882 */ /*GILLT_v4s16*//*Label 1434*/ GIMT_Encode4(91636),
     /*  86886 */ /*GILLT_v4s32*//*Label 1435*/ GIMT_Encode4(92551),
     /*  86890 */ /*GILLT_v8s8*//*Label 1436*/ GIMT_Encode4(93396),
     /*  86894 */ /*GILLT_v8s16*//*Label 1437*/ GIMT_Encode4(93957),
     /*  86898 */ /*GILLT_v16s8*//*Label 1438*/ GIMT_Encode4(94802), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86918 */ /*GILLT_nxv2s64*//*Label 1439*/ GIMT_Encode4(95254), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86930 */ /*GILLT_nxv4s32*//*Label 1440*/ GIMT_Encode4(95703), GIMT_Encode4(0),
     /*  86938 */ /*GILLT_nxv8s16*//*Label 1441*/ GIMT_Encode4(96152), GIMT_Encode4(0),
     /*  86946 */ /*GILLT_nxv16s8*//*Label 1442*/ GIMT_Encode4(96601),
     /*  86950 */ // Label 1429: @86950
     /*  86950 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(87330),
     /*  86955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86958 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(87028), // Rule ID 7054 //
     /*  86963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86975 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86978 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86985 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  87001 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  87001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  87004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87026 */     GIR_RootConstrainSelectedInstOperands,
     /*  87027 */     // GIR_Coverage, 7054,
     /*  87027 */     GIR_EraseRootFromParent_Done,
     /*  87028 */   // Label 1445: @87028
     /*  87028 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(87098), // Rule ID 7055 //
     /*  87033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87045 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87048 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87055 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  87071 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  87071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  87074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87096 */     GIR_RootConstrainSelectedInstOperands,
     /*  87097 */     // GIR_Coverage, 7055,
     /*  87097 */     GIR_EraseRootFromParent_Done,
     /*  87098 */   // Label 1446: @87098
     /*  87098 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(87163), // Rule ID 7056 //
     /*  87103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87115 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87118 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87125 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87128 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  87141 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  87144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87161 */     GIR_RootConstrainSelectedInstOperands,
     /*  87162 */     // GIR_Coverage, 7056,
     /*  87162 */     GIR_EraseRootFromParent_Done,
     /*  87163 */   // Label 1447: @87163
     /*  87163 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(87228), // Rule ID 7057 //
     /*  87168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87180 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87183 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87190 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  87206 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  87209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87226 */     GIR_RootConstrainSelectedInstOperands,
     /*  87227 */     // GIR_Coverage, 7057,
     /*  87227 */     GIR_EraseRootFromParent_Done,
     /*  87228 */   // Label 1448: @87228
     /*  87228 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(87281), // Rule ID 5772 //
     /*  87233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87253 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87259 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  87259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87264 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  87270 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87280 */     // GIR_Coverage, 5772,
     /*  87280 */     GIR_EraseRootFromParent_Done,
     /*  87281 */   // Label 1449: @87281
     /*  87281 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(87305), // Rule ID 6667 //
     /*  87286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87294 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  87294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87304 */     // GIR_Coverage, 6667,
     /*  87304 */     GIR_Done,
     /*  87305 */   // Label 1450: @87305
     /*  87305 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(87329), // Rule ID 6668 //
     /*  87310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87318 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  87318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87328 */     // GIR_Coverage, 6668,
     /*  87328 */     GIR_Done,
     /*  87329 */   // Label 1451: @87329
     /*  87329 */   GIM_Reject,
     /*  87330 */ // Label 1444: @87330
     /*  87330 */ GIM_Reject,
     /*  87331 */ // Label 1430: @87331
     /*  87331 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(87404), // Rule ID 7058 //
     /*  87336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87351 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87354 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87361 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87364 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87370 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  87377 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  87377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  87380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87402 */   GIR_RootConstrainSelectedInstOperands,
     /*  87403 */   // GIR_Coverage, 7058,
     /*  87403 */   GIR_EraseRootFromParent_Done,
     /*  87404 */ // Label 1452: @87404
     /*  87404 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(87477), // Rule ID 7059 //
     /*  87409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87416 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87424 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87427 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87434 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87437 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87443 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  87450 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  87450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  87453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87475 */   GIR_RootConstrainSelectedInstOperands,
     /*  87476 */   // GIR_Coverage, 7059,
     /*  87476 */   GIR_EraseRootFromParent_Done,
     /*  87477 */ // Label 1453: @87477
     /*  87477 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(87545), // Rule ID 7060 //
     /*  87482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87489 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87493 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87497 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87500 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87507 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87510 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87514 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87516 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  87523 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  87526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87538 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87543 */   GIR_RootConstrainSelectedInstOperands,
     /*  87544 */   // GIR_Coverage, 7060,
     /*  87544 */   GIR_EraseRootFromParent_Done,
     /*  87545 */ // Label 1454: @87545
     /*  87545 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(87613), // Rule ID 7061 //
     /*  87550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87565 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87568 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87575 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87578 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87584 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  87591 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  87594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87606 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87611 */   GIR_RootConstrainSelectedInstOperands,
     /*  87612 */   // GIR_Coverage, 7061,
     /*  87612 */   GIR_EraseRootFromParent_Done,
     /*  87613 */ // Label 1455: @87613
     /*  87613 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(87669), // Rule ID 5774 //
     /*  87618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87633 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  87637 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87641 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87645 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87647 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  87647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87652 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  87658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87668 */   // GIR_Coverage, 5774,
     /*  87668 */   GIR_EraseRootFromParent_Done,
     /*  87669 */ // Label 1456: @87669
     /*  87669 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(87699), // Rule ID 6642 //
     /*  87674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87688 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  87688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87698 */   // GIR_Coverage, 6642,
     /*  87698 */   GIR_Done,
     /*  87699 */ // Label 1457: @87699
     /*  87699 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(87729), // Rule ID 6643 //
     /*  87704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87718 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  87718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87728 */   // GIR_Coverage, 6643,
     /*  87728 */   GIR_Done,
     /*  87729 */ // Label 1458: @87729
     /*  87729 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(87759), // Rule ID 6644 //
     /*  87734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87748 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  87748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87753 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87758 */   // GIR_Coverage, 6644,
     /*  87758 */   GIR_Done,
     /*  87759 */ // Label 1459: @87759
     /*  87759 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(87789), // Rule ID 6645 //
     /*  87764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87778 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  87778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87788 */   // GIR_Coverage, 6645,
     /*  87788 */   GIR_Done,
     /*  87789 */ // Label 1460: @87789
     /*  87789 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(87819), // Rule ID 6646 //
     /*  87794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87808 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  87808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87818 */   // GIR_Coverage, 6646,
     /*  87818 */   GIR_Done,
     /*  87819 */ // Label 1461: @87819
     /*  87819 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(87849), // Rule ID 6647 //
     /*  87824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87838 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  87838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87848 */   // GIR_Coverage, 6647,
     /*  87848 */   GIR_Done,
     /*  87849 */ // Label 1462: @87849
     /*  87849 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(87899), // Rule ID 6653 //
     /*  87854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87868 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  87868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87880 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  87892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87897 */   GIR_RootConstrainSelectedInstOperands,
     /*  87898 */   // GIR_Coverage, 6653,
     /*  87898 */   GIR_EraseRootFromParent_Done,
     /*  87899 */ // Label 1463: @87899
     /*  87899 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(87949), // Rule ID 6654 //
     /*  87904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87918 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  87918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87930 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87934 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  87942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87947 */   GIR_RootConstrainSelectedInstOperands,
     /*  87948 */   // GIR_Coverage, 6654,
     /*  87948 */   GIR_EraseRootFromParent_Done,
     /*  87949 */ // Label 1464: @87949
     /*  87949 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(87999), // Rule ID 6655 //
     /*  87954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87968 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  87968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87997 */   GIR_RootConstrainSelectedInstOperands,
     /*  87998 */   // GIR_Coverage, 6655,
     /*  87998 */   GIR_EraseRootFromParent_Done,
     /*  87999 */ // Label 1465: @87999
     /*  87999 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(88049), // Rule ID 6656 //
     /*  88004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88018 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88030 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88034 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88047 */   GIR_RootConstrainSelectedInstOperands,
     /*  88048 */   // GIR_Coverage, 6656,
     /*  88048 */   GIR_EraseRootFromParent_Done,
     /*  88049 */ // Label 1466: @88049
     /*  88049 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(88099), // Rule ID 6657 //
     /*  88054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88068 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88080 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88084 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88097 */   GIR_RootConstrainSelectedInstOperands,
     /*  88098 */   // GIR_Coverage, 6657,
     /*  88098 */   GIR_EraseRootFromParent_Done,
     /*  88099 */ // Label 1467: @88099
     /*  88099 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(88126), // Rule ID 6658 //
     /*  88104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88115 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88120 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88125 */   // GIR_Coverage, 6658,
     /*  88125 */   GIR_Done,
     /*  88126 */ // Label 1468: @88126
     /*  88126 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(88153), // Rule ID 6659 //
     /*  88131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88142 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88152 */   // GIR_Coverage, 6659,
     /*  88152 */   GIR_Done,
     /*  88153 */ // Label 1469: @88153
     /*  88153 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(88180), // Rule ID 6660 //
     /*  88158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88169 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  88169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88179 */   // GIR_Coverage, 6660,
     /*  88179 */   GIR_Done,
     /*  88180 */ // Label 1470: @88180
     /*  88180 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(88207), // Rule ID 6669 //
     /*  88185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88196 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88206 */   // GIR_Coverage, 6669,
     /*  88206 */   GIR_Done,
     /*  88207 */ // Label 1471: @88207
     /*  88207 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(88234), // Rule ID 6670 //
     /*  88212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88223 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  88223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88233 */   // GIR_Coverage, 6670,
     /*  88233 */   GIR_Done,
     /*  88234 */ // Label 1472: @88234
     /*  88234 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(88261), // Rule ID 6671 //
     /*  88239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88250 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88260 */   // GIR_Coverage, 6671,
     /*  88260 */   GIR_Done,
     /*  88261 */ // Label 1473: @88261
     /*  88261 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(88293), // Rule ID 6672 //
     /*  88266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88280 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88283 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88285 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88292 */   // GIR_Coverage, 6672,
     /*  88292 */   GIR_EraseRootFromParent_Done,
     /*  88293 */ // Label 1474: @88293
     /*  88293 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(88325), // Rule ID 6673 //
     /*  88298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88312 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88315 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88317 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88324 */   // GIR_Coverage, 6673,
     /*  88324 */   GIR_EraseRootFromParent_Done,
     /*  88325 */ // Label 1475: @88325
     /*  88325 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(88357), // Rule ID 6674 //
     /*  88330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88344 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88347 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88349 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88351 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88356 */   // GIR_Coverage, 6674,
     /*  88356 */   GIR_EraseRootFromParent_Done,
     /*  88357 */ // Label 1476: @88357
     /*  88357 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(88389), // Rule ID 6675 //
     /*  88362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88376 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88379 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88381 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88388 */   // GIR_Coverage, 6675,
     /*  88388 */   GIR_EraseRootFromParent_Done,
     /*  88389 */ // Label 1477: @88389
     /*  88389 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(88421), // Rule ID 6676 //
     /*  88394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88408 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88411 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88413 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88420 */   // GIR_Coverage, 6676,
     /*  88420 */   GIR_EraseRootFromParent_Done,
     /*  88421 */ // Label 1478: @88421
     /*  88421 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(88447), // Rule ID 6677 //
     /*  88426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88440 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  88440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88445 */   GIR_RootConstrainSelectedInstOperands,
     /*  88446 */   // GIR_Coverage, 6677,
     /*  88446 */   GIR_Done,
     /*  88447 */ // Label 1479: @88447
     /*  88447 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(88473), // Rule ID 6678 //
     /*  88452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88466 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  88466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88471 */   GIR_RootConstrainSelectedInstOperands,
     /*  88472 */   // GIR_Coverage, 6678,
     /*  88472 */   GIR_Done,
     /*  88473 */ // Label 1480: @88473
     /*  88473 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(88499), // Rule ID 6679 //
     /*  88478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88492 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  88492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88497 */   GIR_RootConstrainSelectedInstOperands,
     /*  88498 */   // GIR_Coverage, 6679,
     /*  88498 */   GIR_Done,
     /*  88499 */ // Label 1481: @88499
     /*  88499 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(88525), // Rule ID 6680 //
     /*  88504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88518 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  88518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88523 */   GIR_RootConstrainSelectedInstOperands,
     /*  88524 */   // GIR_Coverage, 6680,
     /*  88524 */   GIR_Done,
     /*  88525 */ // Label 1482: @88525
     /*  88525 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(88551), // Rule ID 6681 //
     /*  88530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88544 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  88544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88549 */   GIR_RootConstrainSelectedInstOperands,
     /*  88550 */   // GIR_Coverage, 6681,
     /*  88550 */   GIR_Done,
     /*  88551 */ // Label 1483: @88551
     /*  88551 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(88580), // Rule ID 6682 //
     /*  88556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88567 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88570 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88574 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88579 */   // GIR_Coverage, 6682,
     /*  88579 */   GIR_EraseRootFromParent_Done,
     /*  88580 */ // Label 1484: @88580
     /*  88580 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(88609), // Rule ID 6683 //
     /*  88585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88596 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88599 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88608 */   // GIR_Coverage, 6683,
     /*  88608 */   GIR_EraseRootFromParent_Done,
     /*  88609 */ // Label 1485: @88609
     /*  88609 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(88641), // Rule ID 6737 //
     /*  88614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88628 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88631 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88633 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88640 */   // GIR_Coverage, 6737,
     /*  88640 */   GIR_EraseRootFromParent_Done,
     /*  88641 */ // Label 1486: @88641
     /*  88641 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(88673), // Rule ID 6738 //
     /*  88646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88660 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88663 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88665 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88667 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88672 */   // GIR_Coverage, 6738,
     /*  88672 */   GIR_EraseRootFromParent_Done,
     /*  88673 */ // Label 1487: @88673
     /*  88673 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(88705), // Rule ID 6739 //
     /*  88678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88692 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88695 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88697 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88704 */   // GIR_Coverage, 6739,
     /*  88704 */   GIR_EraseRootFromParent_Done,
     /*  88705 */ // Label 1488: @88705
     /*  88705 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(88737), // Rule ID 6740 //
     /*  88710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88724 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88727 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88729 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88731 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88736 */   // GIR_Coverage, 6740,
     /*  88736 */   GIR_EraseRootFromParent_Done,
     /*  88737 */ // Label 1489: @88737
     /*  88737 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(88769), // Rule ID 6741 //
     /*  88742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88756 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88759 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88763 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88768 */   // GIR_Coverage, 6741,
     /*  88768 */   GIR_EraseRootFromParent_Done,
     /*  88769 */ // Label 1490: @88769
     /*  88769 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(88795), // Rule ID 6742 //
     /*  88774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88788 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  88788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88793 */   GIR_RootConstrainSelectedInstOperands,
     /*  88794 */   // GIR_Coverage, 6742,
     /*  88794 */   GIR_Done,
     /*  88795 */ // Label 1491: @88795
     /*  88795 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(88821), // Rule ID 6743 //
     /*  88800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88814 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  88814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88819 */   GIR_RootConstrainSelectedInstOperands,
     /*  88820 */   // GIR_Coverage, 6743,
     /*  88820 */   GIR_Done,
     /*  88821 */ // Label 1492: @88821
     /*  88821 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(88847), // Rule ID 6744 //
     /*  88826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88840 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  88840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88845 */   GIR_RootConstrainSelectedInstOperands,
     /*  88846 */   // GIR_Coverage, 6744,
     /*  88846 */   GIR_Done,
     /*  88847 */ // Label 1493: @88847
     /*  88847 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(88873), // Rule ID 6745 //
     /*  88852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88866 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  88866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88871 */   GIR_RootConstrainSelectedInstOperands,
     /*  88872 */   // GIR_Coverage, 6745,
     /*  88872 */   GIR_Done,
     /*  88873 */ // Label 1494: @88873
     /*  88873 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(88899), // Rule ID 6746 //
     /*  88878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88892 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  88892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88897 */   GIR_RootConstrainSelectedInstOperands,
     /*  88898 */   // GIR_Coverage, 6746,
     /*  88898 */   GIR_Done,
     /*  88899 */ // Label 1495: @88899
     /*  88899 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(88928), // Rule ID 6747 //
     /*  88904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88915 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88918 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88920 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88922 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88927 */   // GIR_Coverage, 6747,
     /*  88927 */   GIR_EraseRootFromParent_Done,
     /*  88928 */ // Label 1496: @88928
     /*  88928 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(88957), // Rule ID 6748 //
     /*  88933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88944 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88947 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88949 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88951 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88956 */   // GIR_Coverage, 6748,
     /*  88956 */   GIR_EraseRootFromParent_Done,
     /*  88957 */ // Label 1497: @88957
     /*  88957 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(88989), // Rule ID 6749 //
     /*  88962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88976 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88979 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88981 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88988 */   // GIR_Coverage, 6749,
     /*  88988 */   GIR_EraseRootFromParent_Done,
     /*  88989 */ // Label 1498: @88989
     /*  88989 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(89021), // Rule ID 6750 //
     /*  88994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89008 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89011 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89013 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89020 */   // GIR_Coverage, 6750,
     /*  89020 */   GIR_EraseRootFromParent_Done,
     /*  89021 */ // Label 1499: @89021
     /*  89021 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(89053), // Rule ID 6751 //
     /*  89026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89040 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89043 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89052 */   // GIR_Coverage, 6751,
     /*  89052 */   GIR_EraseRootFromParent_Done,
     /*  89053 */ // Label 1500: @89053
     /*  89053 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(89085), // Rule ID 6752 //
     /*  89058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89072 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89075 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89077 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89084 */   // GIR_Coverage, 6752,
     /*  89084 */   GIR_EraseRootFromParent_Done,
     /*  89085 */ // Label 1501: @89085
     /*  89085 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(89117), // Rule ID 6753 //
     /*  89090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89104 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89107 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89109 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89116 */   // GIR_Coverage, 6753,
     /*  89116 */   GIR_EraseRootFromParent_Done,
     /*  89117 */ // Label 1502: @89117
     /*  89117 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(89143), // Rule ID 6754 //
     /*  89122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89136 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89141 */   GIR_RootConstrainSelectedInstOperands,
     /*  89142 */   // GIR_Coverage, 6754,
     /*  89142 */   GIR_Done,
     /*  89143 */ // Label 1503: @89143
     /*  89143 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(89169), // Rule ID 6755 //
     /*  89148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89162 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89167 */   GIR_RootConstrainSelectedInstOperands,
     /*  89168 */   // GIR_Coverage, 6755,
     /*  89168 */   GIR_Done,
     /*  89169 */ // Label 1504: @89169
     /*  89169 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(89195), // Rule ID 6756 //
     /*  89174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89188 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89193 */   GIR_RootConstrainSelectedInstOperands,
     /*  89194 */   // GIR_Coverage, 6756,
     /*  89194 */   GIR_Done,
     /*  89195 */ // Label 1505: @89195
     /*  89195 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(89221), // Rule ID 6757 //
     /*  89200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89214 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89219 */   GIR_RootConstrainSelectedInstOperands,
     /*  89220 */   // GIR_Coverage, 6757,
     /*  89220 */   GIR_Done,
     /*  89221 */ // Label 1506: @89221
     /*  89221 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(89247), // Rule ID 6758 //
     /*  89226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89240 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89245 */   GIR_RootConstrainSelectedInstOperands,
     /*  89246 */   // GIR_Coverage, 6758,
     /*  89246 */   GIR_Done,
     /*  89247 */ // Label 1507: @89247
     /*  89247 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(89276), // Rule ID 6759 //
     /*  89252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89263 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89266 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89268 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89275 */   // GIR_Coverage, 6759,
     /*  89275 */   GIR_EraseRootFromParent_Done,
     /*  89276 */ // Label 1508: @89276
     /*  89276 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(89305), // Rule ID 6760 //
     /*  89281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89292 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89295 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89297 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89304 */   // GIR_Coverage, 6760,
     /*  89304 */   GIR_EraseRootFromParent_Done,
     /*  89305 */ // Label 1509: @89305
     /*  89305 */ GIM_Reject,
     /*  89306 */ // Label 1431: @89306
     /*  89306 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(89338), // Rule ID 6774 //
     /*  89311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89325 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89328 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89330 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89332 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89337 */   // GIR_Coverage, 6774,
     /*  89337 */   GIR_EraseRootFromParent_Done,
     /*  89338 */ // Label 1510: @89338
     /*  89338 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(89370), // Rule ID 6775 //
     /*  89343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89357 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89360 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89369 */   // GIR_Coverage, 6775,
     /*  89369 */   GIR_EraseRootFromParent_Done,
     /*  89370 */ // Label 1511: @89370
     /*  89370 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(89402), // Rule ID 6776 //
     /*  89375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89389 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89401 */   // GIR_Coverage, 6776,
     /*  89401 */   GIR_EraseRootFromParent_Done,
     /*  89402 */ // Label 1512: @89402
     /*  89402 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(89434), // Rule ID 6777 //
     /*  89407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89421 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89433 */   // GIR_Coverage, 6777,
     /*  89433 */   GIR_EraseRootFromParent_Done,
     /*  89434 */ // Label 1513: @89434
     /*  89434 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(89466), // Rule ID 6778 //
     /*  89439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89453 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89465 */   // GIR_Coverage, 6778,
     /*  89465 */   GIR_EraseRootFromParent_Done,
     /*  89466 */ // Label 1514: @89466
     /*  89466 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(89498), // Rule ID 6779 //
     /*  89471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89485 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89488 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89497 */   // GIR_Coverage, 6779,
     /*  89497 */   GIR_EraseRootFromParent_Done,
     /*  89498 */ // Label 1515: @89498
     /*  89498 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(89530), // Rule ID 6780 //
     /*  89503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89517 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89520 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89522 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89529 */   // GIR_Coverage, 6780,
     /*  89529 */   GIR_EraseRootFromParent_Done,
     /*  89530 */ // Label 1516: @89530
     /*  89530 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(89563), // Rule ID 6781 //
     /*  89535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89549 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  89549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89554 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89561 */   GIR_RootConstrainSelectedInstOperands,
     /*  89562 */   // GIR_Coverage, 6781,
     /*  89562 */   GIR_EraseRootFromParent_Done,
     /*  89563 */ // Label 1517: @89563
     /*  89563 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(89634), // Rule ID 6782 //
     /*  89568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89582 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  89582 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89585 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89589 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89594 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89612 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89632 */   GIR_RootConstrainSelectedInstOperands,
     /*  89633 */   // GIR_Coverage, 6782,
     /*  89633 */   GIR_EraseRootFromParent_Done,
     /*  89634 */ // Label 1518: @89634
     /*  89634 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(89705), // Rule ID 6783 //
     /*  89639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89653 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  89653 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89656 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89660 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89665 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89683 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89703 */   GIR_RootConstrainSelectedInstOperands,
     /*  89704 */   // GIR_Coverage, 6783,
     /*  89704 */   GIR_EraseRootFromParent_Done,
     /*  89705 */ // Label 1519: @89705
     /*  89705 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(89776), // Rule ID 6784 //
     /*  89710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89724 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  89724 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89727 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89731 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89736 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89754 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89768 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89774 */   GIR_RootConstrainSelectedInstOperands,
     /*  89775 */   // GIR_Coverage, 6784,
     /*  89775 */   GIR_EraseRootFromParent_Done,
     /*  89776 */ // Label 1520: @89776
     /*  89776 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(89809), // Rule ID 6785 //
     /*  89781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89795 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  89795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89800 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89802 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89807 */   GIR_RootConstrainSelectedInstOperands,
     /*  89808 */   // GIR_Coverage, 6785,
     /*  89808 */   GIR_EraseRootFromParent_Done,
     /*  89809 */ // Label 1521: @89809
     /*  89809 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(89880), // Rule ID 6786 //
     /*  89814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89828 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  89828 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89831 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89835 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89840 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89858 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89878 */   GIR_RootConstrainSelectedInstOperands,
     /*  89879 */   // GIR_Coverage, 6786,
     /*  89879 */   GIR_EraseRootFromParent_Done,
     /*  89880 */ // Label 1522: @89880
     /*  89880 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(89951), // Rule ID 6787 //
     /*  89885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89899 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  89899 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89902 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  89906 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89911 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  89924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89929 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89943 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89949 */   GIR_RootConstrainSelectedInstOperands,
     /*  89950 */   // GIR_Coverage, 6787,
     /*  89950 */   GIR_EraseRootFromParent_Done,
     /*  89951 */ // Label 1523: @89951
     /*  89951 */ GIM_Reject,
     /*  89952 */ // Label 1432: @89952
     /*  89952 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(89982), // Rule ID 6639 //
     /*  89957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89971 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89981 */   // GIR_Coverage, 6639,
     /*  89981 */   GIR_Done,
     /*  89982 */ // Label 1524: @89982
     /*  89982 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(90012), // Rule ID 6641 //
     /*  89987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90001 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90011 */   // GIR_Coverage, 6641,
     /*  90011 */   GIR_Done,
     /*  90012 */ // Label 1525: @90012
     /*  90012 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(90062), // Rule ID 6650 //
     /*  90017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90031 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90043 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90047 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90057 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90060 */   GIR_RootConstrainSelectedInstOperands,
     /*  90061 */   // GIR_Coverage, 6650,
     /*  90061 */   GIR_EraseRootFromParent_Done,
     /*  90062 */ // Label 1526: @90062
     /*  90062 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(90112), // Rule ID 6652 //
     /*  90067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90081 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90093 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90097 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90110 */   GIR_RootConstrainSelectedInstOperands,
     /*  90111 */   // GIR_Coverage, 6652,
     /*  90111 */   GIR_EraseRootFromParent_Done,
     /*  90112 */ // Label 1527: @90112
     /*  90112 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(90144), // Rule ID 6684 //
     /*  90117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90131 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90143 */   // GIR_Coverage, 6684,
     /*  90143 */   GIR_EraseRootFromParent_Done,
     /*  90144 */ // Label 1528: @90144
     /*  90144 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(90176), // Rule ID 6685 //
     /*  90149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90163 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90175 */   // GIR_Coverage, 6685,
     /*  90175 */   GIR_EraseRootFromParent_Done,
     /*  90176 */ // Label 1529: @90176
     /*  90176 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(90208), // Rule ID 6686 //
     /*  90181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90195 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90207 */   // GIR_Coverage, 6686,
     /*  90207 */   GIR_EraseRootFromParent_Done,
     /*  90208 */ // Label 1530: @90208
     /*  90208 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(90240), // Rule ID 6687 //
     /*  90213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90227 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90239 */   // GIR_Coverage, 6687,
     /*  90239 */   GIR_EraseRootFromParent_Done,
     /*  90240 */ // Label 1531: @90240
     /*  90240 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(90272), // Rule ID 6688 //
     /*  90245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90259 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90271 */   // GIR_Coverage, 6688,
     /*  90271 */   GIR_EraseRootFromParent_Done,
     /*  90272 */ // Label 1532: @90272
     /*  90272 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(90304), // Rule ID 6689 //
     /*  90277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90291 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90303 */   // GIR_Coverage, 6689,
     /*  90303 */   GIR_EraseRootFromParent_Done,
     /*  90304 */ // Label 1533: @90304
     /*  90304 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(90330), // Rule ID 6690 //
     /*  90309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90323 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  90323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90328 */   GIR_RootConstrainSelectedInstOperands,
     /*  90329 */   // GIR_Coverage, 6690,
     /*  90329 */   GIR_Done,
     /*  90330 */ // Label 1534: @90330
     /*  90330 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(90356), // Rule ID 6691 //
     /*  90335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90349 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  90349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90354 */   GIR_RootConstrainSelectedInstOperands,
     /*  90355 */   // GIR_Coverage, 6691,
     /*  90355 */   GIR_Done,
     /*  90356 */ // Label 1535: @90356
     /*  90356 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(90382), // Rule ID 6692 //
     /*  90361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90375 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  90375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90380 */   GIR_RootConstrainSelectedInstOperands,
     /*  90381 */   // GIR_Coverage, 6692,
     /*  90381 */   GIR_Done,
     /*  90382 */ // Label 1536: @90382
     /*  90382 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(90408), // Rule ID 6693 //
     /*  90387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90401 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  90401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90406 */   GIR_RootConstrainSelectedInstOperands,
     /*  90407 */   // GIR_Coverage, 6693,
     /*  90407 */   GIR_Done,
     /*  90408 */ // Label 1537: @90408
     /*  90408 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(90434), // Rule ID 6694 //
     /*  90413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90427 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  90427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90432 */   GIR_RootConstrainSelectedInstOperands,
     /*  90433 */   // GIR_Coverage, 6694,
     /*  90433 */   GIR_Done,
     /*  90434 */ // Label 1538: @90434
     /*  90434 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(90460), // Rule ID 6695 //
     /*  90439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90453 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  90453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90458 */   GIR_RootConstrainSelectedInstOperands,
     /*  90459 */   // GIR_Coverage, 6695,
     /*  90459 */   GIR_Done,
     /*  90460 */ // Label 1539: @90460
     /*  90460 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(90489), // Rule ID 6696 //
     /*  90465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90476 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90488 */   // GIR_Coverage, 6696,
     /*  90488 */   GIR_EraseRootFromParent_Done,
     /*  90489 */ // Label 1540: @90489
     /*  90489 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(90521), // Rule ID 6761 //
     /*  90494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90508 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90520 */   // GIR_Coverage, 6761,
     /*  90520 */   GIR_EraseRootFromParent_Done,
     /*  90521 */ // Label 1541: @90521
     /*  90521 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(90553), // Rule ID 6762 //
     /*  90526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90540 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90552 */   // GIR_Coverage, 6762,
     /*  90552 */   GIR_EraseRootFromParent_Done,
     /*  90553 */ // Label 1542: @90553
     /*  90553 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(90585), // Rule ID 6763 //
     /*  90558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90572 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90584 */   // GIR_Coverage, 6763,
     /*  90584 */   GIR_EraseRootFromParent_Done,
     /*  90585 */ // Label 1543: @90585
     /*  90585 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(90617), // Rule ID 6764 //
     /*  90590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90604 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90616 */   // GIR_Coverage, 6764,
     /*  90616 */   GIR_EraseRootFromParent_Done,
     /*  90617 */ // Label 1544: @90617
     /*  90617 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(90649), // Rule ID 6765 //
     /*  90622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90636 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90648 */   // GIR_Coverage, 6765,
     /*  90648 */   GIR_EraseRootFromParent_Done,
     /*  90649 */ // Label 1545: @90649
     /*  90649 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(90681), // Rule ID 6766 //
     /*  90654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90668 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90680 */   // GIR_Coverage, 6766,
     /*  90680 */   GIR_EraseRootFromParent_Done,
     /*  90681 */ // Label 1546: @90681
     /*  90681 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(90707), // Rule ID 6767 //
     /*  90686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90700 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  90700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90705 */   GIR_RootConstrainSelectedInstOperands,
     /*  90706 */   // GIR_Coverage, 6767,
     /*  90706 */   GIR_Done,
     /*  90707 */ // Label 1547: @90707
     /*  90707 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(90733), // Rule ID 6768 //
     /*  90712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90726 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  90726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90731 */   GIR_RootConstrainSelectedInstOperands,
     /*  90732 */   // GIR_Coverage, 6768,
     /*  90732 */   GIR_Done,
     /*  90733 */ // Label 1548: @90733
     /*  90733 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(90759), // Rule ID 6769 //
     /*  90738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90752 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  90752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90757 */   GIR_RootConstrainSelectedInstOperands,
     /*  90758 */   // GIR_Coverage, 6769,
     /*  90758 */   GIR_Done,
     /*  90759 */ // Label 1549: @90759
     /*  90759 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(90785), // Rule ID 6770 //
     /*  90764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90778 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  90778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90783 */   GIR_RootConstrainSelectedInstOperands,
     /*  90784 */   // GIR_Coverage, 6770,
     /*  90784 */   GIR_Done,
     /*  90785 */ // Label 1550: @90785
     /*  90785 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(90811), // Rule ID 6771 //
     /*  90790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90804 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  90804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90809 */   GIR_RootConstrainSelectedInstOperands,
     /*  90810 */   // GIR_Coverage, 6771,
     /*  90810 */   GIR_Done,
     /*  90811 */ // Label 1551: @90811
     /*  90811 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(90837), // Rule ID 6772 //
     /*  90816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90830 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  90830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90835 */   GIR_RootConstrainSelectedInstOperands,
     /*  90836 */   // GIR_Coverage, 6772,
     /*  90836 */   GIR_Done,
     /*  90837 */ // Label 1552: @90837
     /*  90837 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(90866), // Rule ID 6773 //
     /*  90842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90853 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90856 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90858 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90860 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90865 */   // GIR_Coverage, 6773,
     /*  90865 */   GIR_EraseRootFromParent_Done,
     /*  90866 */ // Label 1553: @90866
     /*  90866 */ GIM_Reject,
     /*  90867 */ // Label 1433: @90867
     /*  90867 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(90899), // Rule ID 6788 //
     /*  90872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90886 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90898 */   // GIR_Coverage, 6788,
     /*  90898 */   GIR_EraseRootFromParent_Done,
     /*  90899 */ // Label 1554: @90899
     /*  90899 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(90931), // Rule ID 6789 //
     /*  90904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90918 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90930 */   // GIR_Coverage, 6789,
     /*  90930 */   GIR_EraseRootFromParent_Done,
     /*  90931 */ // Label 1555: @90931
     /*  90931 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(90963), // Rule ID 6790 //
     /*  90936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90950 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90962 */   // GIR_Coverage, 6790,
     /*  90962 */   GIR_EraseRootFromParent_Done,
     /*  90963 */ // Label 1556: @90963
     /*  90963 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(90995), // Rule ID 6791 //
     /*  90968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90982 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90994 */   // GIR_Coverage, 6791,
     /*  90994 */   GIR_EraseRootFromParent_Done,
     /*  90995 */ // Label 1557: @90995
     /*  90995 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(91027), // Rule ID 6792 //
     /*  91000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91014 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91026 */   // GIR_Coverage, 6792,
     /*  91026 */   GIR_EraseRootFromParent_Done,
     /*  91027 */ // Label 1558: @91027
     /*  91027 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(91059), // Rule ID 6793 //
     /*  91032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91046 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91058 */   // GIR_Coverage, 6793,
     /*  91058 */   GIR_EraseRootFromParent_Done,
     /*  91059 */ // Label 1559: @91059
     /*  91059 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(91092), // Rule ID 6794 //
     /*  91064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91078 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91085 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91090 */   GIR_RootConstrainSelectedInstOperands,
     /*  91091 */   // GIR_Coverage, 6794,
     /*  91091 */   GIR_EraseRootFromParent_Done,
     /*  91092 */ // Label 1560: @91092
     /*  91092 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(91118), // Rule ID 6795 //
     /*  91097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91111 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  91111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91116 */   GIR_RootConstrainSelectedInstOperands,
     /*  91117 */   // GIR_Coverage, 6795,
     /*  91117 */   GIR_Done,
     /*  91118 */ // Label 1561: @91118
     /*  91118 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(91144), // Rule ID 6796 //
     /*  91123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91137 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  91137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91142 */   GIR_RootConstrainSelectedInstOperands,
     /*  91143 */   // GIR_Coverage, 6796,
     /*  91143 */   GIR_Done,
     /*  91144 */ // Label 1562: @91144
     /*  91144 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(91170), // Rule ID 6797 //
     /*  91149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91163 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  91163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91168 */   GIR_RootConstrainSelectedInstOperands,
     /*  91169 */   // GIR_Coverage, 6797,
     /*  91169 */   GIR_Done,
     /*  91170 */ // Label 1563: @91170
     /*  91170 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(91196), // Rule ID 6798 //
     /*  91175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91189 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  91189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91194 */   GIR_RootConstrainSelectedInstOperands,
     /*  91195 */   // GIR_Coverage, 6798,
     /*  91195 */   GIR_Done,
     /*  91196 */ // Label 1564: @91196
     /*  91196 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(91222), // Rule ID 6799 //
     /*  91201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91215 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  91215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91220 */   GIR_RootConstrainSelectedInstOperands,
     /*  91221 */   // GIR_Coverage, 6799,
     /*  91221 */   GIR_Done,
     /*  91222 */ // Label 1565: @91222
     /*  91222 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(91251), // Rule ID 6800 //
     /*  91227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91238 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91241 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91243 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91250 */   // GIR_Coverage, 6800,
     /*  91250 */   GIR_EraseRootFromParent_Done,
     /*  91251 */ // Label 1566: @91251
     /*  91251 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(91283), // Rule ID 6814 //
     /*  91256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91270 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91273 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91275 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91277 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91282 */   // GIR_Coverage, 6814,
     /*  91282 */   GIR_EraseRootFromParent_Done,
     /*  91283 */ // Label 1567: @91283
     /*  91283 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(91315), // Rule ID 6815 //
     /*  91288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91302 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91305 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91307 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91314 */   // GIR_Coverage, 6815,
     /*  91314 */   GIR_EraseRootFromParent_Done,
     /*  91315 */ // Label 1568: @91315
     /*  91315 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(91347), // Rule ID 6816 //
     /*  91320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91334 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91337 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91339 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91346 */   // GIR_Coverage, 6816,
     /*  91346 */   GIR_EraseRootFromParent_Done,
     /*  91347 */ // Label 1569: @91347
     /*  91347 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(91379), // Rule ID 6817 //
     /*  91352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91366 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91369 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91378 */   // GIR_Coverage, 6817,
     /*  91378 */   GIR_EraseRootFromParent_Done,
     /*  91379 */ // Label 1570: @91379
     /*  91379 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(91411), // Rule ID 6818 //
     /*  91384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91398 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91401 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91403 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91410 */   // GIR_Coverage, 6818,
     /*  91410 */   GIR_EraseRootFromParent_Done,
     /*  91411 */ // Label 1571: @91411
     /*  91411 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(91443), // Rule ID 6819 //
     /*  91416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91430 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91433 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91442 */   // GIR_Coverage, 6819,
     /*  91442 */   GIR_EraseRootFromParent_Done,
     /*  91443 */ // Label 1572: @91443
     /*  91443 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(91476), // Rule ID 6820 //
     /*  91448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91462 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91469 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91474 */   GIR_RootConstrainSelectedInstOperands,
     /*  91475 */   // GIR_Coverage, 6820,
     /*  91475 */   GIR_EraseRootFromParent_Done,
     /*  91476 */ // Label 1573: @91476
     /*  91476 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(91502), // Rule ID 6821 //
     /*  91481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91495 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  91495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91500 */   GIR_RootConstrainSelectedInstOperands,
     /*  91501 */   // GIR_Coverage, 6821,
     /*  91501 */   GIR_Done,
     /*  91502 */ // Label 1574: @91502
     /*  91502 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(91528), // Rule ID 6822 //
     /*  91507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91521 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  91521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91526 */   GIR_RootConstrainSelectedInstOperands,
     /*  91527 */   // GIR_Coverage, 6822,
     /*  91527 */   GIR_Done,
     /*  91528 */ // Label 1575: @91528
     /*  91528 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(91554), // Rule ID 6823 //
     /*  91533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91547 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  91547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91552 */   GIR_RootConstrainSelectedInstOperands,
     /*  91553 */   // GIR_Coverage, 6823,
     /*  91553 */   GIR_Done,
     /*  91554 */ // Label 1576: @91554
     /*  91554 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(91580), // Rule ID 6824 //
     /*  91559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91573 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  91573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91578 */   GIR_RootConstrainSelectedInstOperands,
     /*  91579 */   // GIR_Coverage, 6824,
     /*  91579 */   GIR_Done,
     /*  91580 */ // Label 1577: @91580
     /*  91580 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(91606), // Rule ID 6825 //
     /*  91585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91599 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  91599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91604 */   GIR_RootConstrainSelectedInstOperands,
     /*  91605 */   // GIR_Coverage, 6825,
     /*  91605 */   GIR_Done,
     /*  91606 */ // Label 1578: @91606
     /*  91606 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(91635), // Rule ID 6826 //
     /*  91611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91622 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91625 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91627 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91629 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91634 */   // GIR_Coverage, 6826,
     /*  91634 */   GIR_EraseRootFromParent_Done,
     /*  91635 */ // Label 1579: @91635
     /*  91635 */ GIM_Reject,
     /*  91636 */ // Label 1434: @91636
     /*  91636 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(91666), // Rule ID 6638 //
     /*  91641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91655 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  91655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91660 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91665 */   // GIR_Coverage, 6638,
     /*  91665 */   GIR_Done,
     /*  91666 */ // Label 1580: @91666
     /*  91666 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(91696), // Rule ID 6640 //
     /*  91671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91685 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  91685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91695 */   // GIR_Coverage, 6640,
     /*  91695 */   GIR_Done,
     /*  91696 */ // Label 1581: @91696
     /*  91696 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(91746), // Rule ID 6649 //
     /*  91701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91715 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  91715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  91731 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91744 */   GIR_RootConstrainSelectedInstOperands,
     /*  91745 */   // GIR_Coverage, 6649,
     /*  91745 */   GIR_EraseRootFromParent_Done,
     /*  91746 */ // Label 1582: @91746
     /*  91746 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(91796), // Rule ID 6651 //
     /*  91751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91765 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  91765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91777 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  91781 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91794 */   GIR_RootConstrainSelectedInstOperands,
     /*  91795 */   // GIR_Coverage, 6651,
     /*  91795 */   GIR_EraseRootFromParent_Done,
     /*  91796 */ // Label 1583: @91796
     /*  91796 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(91828), // Rule ID 6697 //
     /*  91801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91815 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91818 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91820 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91822 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91827 */   // GIR_Coverage, 6697,
     /*  91827 */   GIR_EraseRootFromParent_Done,
     /*  91828 */ // Label 1584: @91828
     /*  91828 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(91860), // Rule ID 6698 //
     /*  91833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91847 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91850 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91852 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91854 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91859 */   // GIR_Coverage, 6698,
     /*  91859 */   GIR_EraseRootFromParent_Done,
     /*  91860 */ // Label 1585: @91860
     /*  91860 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(91892), // Rule ID 6699 //
     /*  91865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91879 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91882 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91884 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91886 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91891 */   // GIR_Coverage, 6699,
     /*  91891 */   GIR_EraseRootFromParent_Done,
     /*  91892 */ // Label 1586: @91892
     /*  91892 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(91924), // Rule ID 6700 //
     /*  91897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91911 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91914 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91916 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91923 */   // GIR_Coverage, 6700,
     /*  91923 */   GIR_EraseRootFromParent_Done,
     /*  91924 */ // Label 1587: @91924
     /*  91924 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(91956), // Rule ID 6701 //
     /*  91929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91943 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91946 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91948 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91955 */   // GIR_Coverage, 6701,
     /*  91955 */   GIR_EraseRootFromParent_Done,
     /*  91956 */ // Label 1588: @91956
     /*  91956 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(91988), // Rule ID 6702 //
     /*  91961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91975 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91978 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91987 */   // GIR_Coverage, 6702,
     /*  91987 */   GIR_EraseRootFromParent_Done,
     /*  91988 */ // Label 1589: @91988
     /*  91988 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(92014), // Rule ID 6703 //
     /*  91993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92007 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  92007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92012 */   GIR_RootConstrainSelectedInstOperands,
     /*  92013 */   // GIR_Coverage, 6703,
     /*  92013 */   GIR_Done,
     /*  92014 */ // Label 1590: @92014
     /*  92014 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(92040), // Rule ID 6704 //
     /*  92019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92033 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  92033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92038 */   GIR_RootConstrainSelectedInstOperands,
     /*  92039 */   // GIR_Coverage, 6704,
     /*  92039 */   GIR_Done,
     /*  92040 */ // Label 1591: @92040
     /*  92040 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(92066), // Rule ID 6705 //
     /*  92045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92059 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  92059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92064 */   GIR_RootConstrainSelectedInstOperands,
     /*  92065 */   // GIR_Coverage, 6705,
     /*  92065 */   GIR_Done,
     /*  92066 */ // Label 1592: @92066
     /*  92066 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(92092), // Rule ID 6706 //
     /*  92071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92085 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  92085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92090 */   GIR_RootConstrainSelectedInstOperands,
     /*  92091 */   // GIR_Coverage, 6706,
     /*  92091 */   GIR_Done,
     /*  92092 */ // Label 1593: @92092
     /*  92092 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(92118), // Rule ID 6707 //
     /*  92097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92111 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  92111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92116 */   GIR_RootConstrainSelectedInstOperands,
     /*  92117 */   // GIR_Coverage, 6707,
     /*  92117 */   GIR_Done,
     /*  92118 */ // Label 1594: @92118
     /*  92118 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(92144), // Rule ID 6708 //
     /*  92123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92137 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  92137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92142 */   GIR_RootConstrainSelectedInstOperands,
     /*  92143 */   // GIR_Coverage, 6708,
     /*  92143 */   GIR_Done,
     /*  92144 */ // Label 1595: @92144
     /*  92144 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(92173), // Rule ID 6709 //
     /*  92149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92160 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92163 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92165 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92172 */   // GIR_Coverage, 6709,
     /*  92172 */   GIR_EraseRootFromParent_Done,
     /*  92173 */ // Label 1596: @92173
     /*  92173 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(92205), // Rule ID 6710 //
     /*  92178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92192 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92195 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92197 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92204 */   // GIR_Coverage, 6710,
     /*  92204 */   GIR_EraseRootFromParent_Done,
     /*  92205 */ // Label 1597: @92205
     /*  92205 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(92237), // Rule ID 6711 //
     /*  92210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92224 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92227 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92236 */   // GIR_Coverage, 6711,
     /*  92236 */   GIR_EraseRootFromParent_Done,
     /*  92237 */ // Label 1598: @92237
     /*  92237 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(92269), // Rule ID 6712 //
     /*  92242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92256 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92259 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92261 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92268 */   // GIR_Coverage, 6712,
     /*  92268 */   GIR_EraseRootFromParent_Done,
     /*  92269 */ // Label 1599: @92269
     /*  92269 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(92301), // Rule ID 6713 //
     /*  92274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92288 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92291 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92300 */   // GIR_Coverage, 6713,
     /*  92300 */   GIR_EraseRootFromParent_Done,
     /*  92301 */ // Label 1600: @92301
     /*  92301 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(92333), // Rule ID 6714 //
     /*  92306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92320 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92323 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92325 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92332 */   // GIR_Coverage, 6714,
     /*  92332 */   GIR_EraseRootFromParent_Done,
     /*  92333 */ // Label 1601: @92333
     /*  92333 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(92365), // Rule ID 6715 //
     /*  92338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92352 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92355 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92357 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92364 */   // GIR_Coverage, 6715,
     /*  92364 */   GIR_EraseRootFromParent_Done,
     /*  92365 */ // Label 1602: @92365
     /*  92365 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(92391), // Rule ID 6716 //
     /*  92370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92384 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  92384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92389 */   GIR_RootConstrainSelectedInstOperands,
     /*  92390 */   // GIR_Coverage, 6716,
     /*  92390 */   GIR_Done,
     /*  92391 */ // Label 1603: @92391
     /*  92391 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(92417), // Rule ID 6717 //
     /*  92396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92410 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  92410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92415 */   GIR_RootConstrainSelectedInstOperands,
     /*  92416 */   // GIR_Coverage, 6717,
     /*  92416 */   GIR_Done,
     /*  92417 */ // Label 1604: @92417
     /*  92417 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(92443), // Rule ID 6718 //
     /*  92422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92436 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  92436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92441 */   GIR_RootConstrainSelectedInstOperands,
     /*  92442 */   // GIR_Coverage, 6718,
     /*  92442 */   GIR_Done,
     /*  92443 */ // Label 1605: @92443
     /*  92443 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(92469), // Rule ID 6719 //
     /*  92448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92462 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  92462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92467 */   GIR_RootConstrainSelectedInstOperands,
     /*  92468 */   // GIR_Coverage, 6719,
     /*  92468 */   GIR_Done,
     /*  92469 */ // Label 1606: @92469
     /*  92469 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(92495), // Rule ID 6720 //
     /*  92474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92488 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  92488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92493 */   GIR_RootConstrainSelectedInstOperands,
     /*  92494 */   // GIR_Coverage, 6720,
     /*  92494 */   GIR_Done,
     /*  92495 */ // Label 1607: @92495
     /*  92495 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(92521), // Rule ID 6721 //
     /*  92500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92514 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  92514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92519 */   GIR_RootConstrainSelectedInstOperands,
     /*  92520 */   // GIR_Coverage, 6721,
     /*  92520 */   GIR_Done,
     /*  92521 */ // Label 1608: @92521
     /*  92521 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(92550), // Rule ID 6722 //
     /*  92526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92537 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92540 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92542 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92549 */   // GIR_Coverage, 6722,
     /*  92549 */   GIR_EraseRootFromParent_Done,
     /*  92550 */ // Label 1609: @92550
     /*  92550 */ GIM_Reject,
     /*  92551 */ // Label 1435: @92551
     /*  92551 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(92583), // Rule ID 6801 //
     /*  92556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92570 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92573 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92575 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92582 */   // GIR_Coverage, 6801,
     /*  92582 */   GIR_EraseRootFromParent_Done,
     /*  92583 */ // Label 1610: @92583
     /*  92583 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(92615), // Rule ID 6802 //
     /*  92588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92602 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92605 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92607 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92614 */   // GIR_Coverage, 6802,
     /*  92614 */   GIR_EraseRootFromParent_Done,
     /*  92615 */ // Label 1611: @92615
     /*  92615 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(92647), // Rule ID 6803 //
     /*  92620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92634 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92637 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92639 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92646 */   // GIR_Coverage, 6803,
     /*  92646 */   GIR_EraseRootFromParent_Done,
     /*  92647 */ // Label 1612: @92647
     /*  92647 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(92679), // Rule ID 6804 //
     /*  92652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92666 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92669 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92671 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92673 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92678 */   // GIR_Coverage, 6804,
     /*  92678 */   GIR_EraseRootFromParent_Done,
     /*  92679 */ // Label 1613: @92679
     /*  92679 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(92711), // Rule ID 6805 //
     /*  92684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92698 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92701 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92710 */   // GIR_Coverage, 6805,
     /*  92710 */   GIR_EraseRootFromParent_Done,
     /*  92711 */ // Label 1614: @92711
     /*  92711 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(92743), // Rule ID 6806 //
     /*  92716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92730 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92733 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92742 */   // GIR_Coverage, 6806,
     /*  92742 */   GIR_EraseRootFromParent_Done,
     /*  92743 */ // Label 1615: @92743
     /*  92743 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(92814), // Rule ID 6807 //
     /*  92748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92762 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  92762 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  92765 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92769 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92774 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92780 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  92783 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92787 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  92801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92806 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  92809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  92812 */   GIR_RootConstrainSelectedInstOperands,
     /*  92813 */   // GIR_Coverage, 6807,
     /*  92813 */   GIR_EraseRootFromParent_Done,
     /*  92814 */ // Label 1616: @92814
     /*  92814 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(92840), // Rule ID 6808 //
     /*  92819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92833 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  92833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92838 */   GIR_RootConstrainSelectedInstOperands,
     /*  92839 */   // GIR_Coverage, 6808,
     /*  92839 */   GIR_Done,
     /*  92840 */ // Label 1617: @92840
     /*  92840 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(92866), // Rule ID 6809 //
     /*  92845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92859 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  92859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92864 */   GIR_RootConstrainSelectedInstOperands,
     /*  92865 */   // GIR_Coverage, 6809,
     /*  92865 */   GIR_Done,
     /*  92866 */ // Label 1618: @92866
     /*  92866 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(92892), // Rule ID 6810 //
     /*  92871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92885 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  92885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  92890 */   GIR_RootConstrainSelectedInstOperands,
     /*  92891 */   // GIR_Coverage, 6810,
     /*  92891 */   GIR_Done,
     /*  92892 */ // Label 1619: @92892
     /*  92892 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(92918), // Rule ID 6811 //
     /*  92897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92911 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  92911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92916 */   GIR_RootConstrainSelectedInstOperands,
     /*  92917 */   // GIR_Coverage, 6811,
     /*  92917 */   GIR_Done,
     /*  92918 */ // Label 1620: @92918
     /*  92918 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(92944), // Rule ID 6812 //
     /*  92923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92937 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  92937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92942 */   GIR_RootConstrainSelectedInstOperands,
     /*  92943 */   // GIR_Coverage, 6812,
     /*  92943 */   GIR_Done,
     /*  92944 */ // Label 1621: @92944
     /*  92944 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(92973), // Rule ID 6813 //
     /*  92949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92960 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92963 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92965 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92972 */   // GIR_Coverage, 6813,
     /*  92972 */   GIR_EraseRootFromParent_Done,
     /*  92973 */ // Label 1622: @92973
     /*  92973 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(93005), // Rule ID 6827 //
     /*  92978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92992 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92995 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92997 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92999 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93004 */   // GIR_Coverage, 6827,
     /*  93004 */   GIR_EraseRootFromParent_Done,
     /*  93005 */ // Label 1623: @93005
     /*  93005 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(93037), // Rule ID 6828 //
     /*  93010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93024 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93027 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93029 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93036 */   // GIR_Coverage, 6828,
     /*  93036 */   GIR_EraseRootFromParent_Done,
     /*  93037 */ // Label 1624: @93037
     /*  93037 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(93069), // Rule ID 6829 //
     /*  93042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93056 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93059 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93068 */   // GIR_Coverage, 6829,
     /*  93068 */   GIR_EraseRootFromParent_Done,
     /*  93069 */ // Label 1625: @93069
     /*  93069 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(93101), // Rule ID 6830 //
     /*  93074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93088 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93091 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93093 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93095 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93100 */   // GIR_Coverage, 6830,
     /*  93100 */   GIR_EraseRootFromParent_Done,
     /*  93101 */ // Label 1626: @93101
     /*  93101 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(93133), // Rule ID 6831 //
     /*  93106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93120 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93123 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93125 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93132 */   // GIR_Coverage, 6831,
     /*  93132 */   GIR_EraseRootFromParent_Done,
     /*  93133 */ // Label 1627: @93133
     /*  93133 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(93165), // Rule ID 6832 //
     /*  93138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93152 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93155 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93157 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93164 */   // GIR_Coverage, 6832,
     /*  93164 */   GIR_EraseRootFromParent_Done,
     /*  93165 */ // Label 1628: @93165
     /*  93165 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(93236), // Rule ID 6833 //
     /*  93170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93184 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93184 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93187 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93191 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93196 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93214 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93218 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93234 */   GIR_RootConstrainSelectedInstOperands,
     /*  93235 */   // GIR_Coverage, 6833,
     /*  93235 */   GIR_EraseRootFromParent_Done,
     /*  93236 */ // Label 1629: @93236
     /*  93236 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(93262), // Rule ID 6834 //
     /*  93241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93255 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  93255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93260 */   GIR_RootConstrainSelectedInstOperands,
     /*  93261 */   // GIR_Coverage, 6834,
     /*  93261 */   GIR_Done,
     /*  93262 */ // Label 1630: @93262
     /*  93262 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(93288), // Rule ID 6835 //
     /*  93267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93281 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  93281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93286 */   GIR_RootConstrainSelectedInstOperands,
     /*  93287 */   // GIR_Coverage, 6835,
     /*  93287 */   GIR_Done,
     /*  93288 */ // Label 1631: @93288
     /*  93288 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(93314), // Rule ID 6836 //
     /*  93293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93307 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  93307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  93312 */   GIR_RootConstrainSelectedInstOperands,
     /*  93313 */   // GIR_Coverage, 6836,
     /*  93313 */   GIR_Done,
     /*  93314 */ // Label 1632: @93314
     /*  93314 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(93340), // Rule ID 6837 //
     /*  93319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93333 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  93333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93338 */   GIR_RootConstrainSelectedInstOperands,
     /*  93339 */   // GIR_Coverage, 6837,
     /*  93339 */   GIR_Done,
     /*  93340 */ // Label 1633: @93340
     /*  93340 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(93366), // Rule ID 6838 //
     /*  93345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93359 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  93359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93364 */   GIR_RootConstrainSelectedInstOperands,
     /*  93365 */   // GIR_Coverage, 6838,
     /*  93365 */   GIR_Done,
     /*  93366 */ // Label 1634: @93366
     /*  93366 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(93395), // Rule ID 6839 //
     /*  93371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93382 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93385 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93394 */   // GIR_Coverage, 6839,
     /*  93394 */   GIR_EraseRootFromParent_Done,
     /*  93395 */ // Label 1635: @93395
     /*  93395 */ GIM_Reject,
     /*  93396 */ // Label 1436: @93396
     /*  93396 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(93470), // Rule ID 5668 //
     /*  93401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93408 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93412 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  93416 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  93420 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  93425 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93427 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  93427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  93434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93439 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  93443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  93448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  93459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93469 */   // GIR_Coverage, 5668,
     /*  93469 */   GIR_EraseRootFromParent_Done,
     /*  93470 */ // Label 1636: @93470
     /*  93470 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(93500), // Rule ID 6637 //
     /*  93475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  93489 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  93489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93499 */   // GIR_Coverage, 6637,
     /*  93499 */   GIR_Done,
     /*  93500 */ // Label 1637: @93500
     /*  93500 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(93550), // Rule ID 6648 //
     /*  93505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  93519 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  93519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  93522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93531 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  93535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93548 */   GIR_RootConstrainSelectedInstOperands,
     /*  93549 */   // GIR_Coverage, 6648,
     /*  93549 */   GIR_EraseRootFromParent_Done,
     /*  93550 */ // Label 1638: @93550
     /*  93550 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(93582), // Rule ID 6723 //
     /*  93555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93569 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93572 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93574 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93581 */   // GIR_Coverage, 6723,
     /*  93581 */   GIR_EraseRootFromParent_Done,
     /*  93582 */ // Label 1639: @93582
     /*  93582 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(93614), // Rule ID 6724 //
     /*  93587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93601 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93604 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93606 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93613 */   // GIR_Coverage, 6724,
     /*  93613 */   GIR_EraseRootFromParent_Done,
     /*  93614 */ // Label 1640: @93614
     /*  93614 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(93646), // Rule ID 6725 //
     /*  93619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93633 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93636 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93645 */   // GIR_Coverage, 6725,
     /*  93645 */   GIR_EraseRootFromParent_Done,
     /*  93646 */ // Label 1641: @93646
     /*  93646 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(93678), // Rule ID 6726 //
     /*  93651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93665 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93668 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93670 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93677 */   // GIR_Coverage, 6726,
     /*  93677 */   GIR_EraseRootFromParent_Done,
     /*  93678 */ // Label 1642: @93678
     /*  93678 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(93710), // Rule ID 6727 //
     /*  93683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93697 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93700 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93702 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93709 */   // GIR_Coverage, 6727,
     /*  93709 */   GIR_EraseRootFromParent_Done,
     /*  93710 */ // Label 1643: @93710
     /*  93710 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(93742), // Rule ID 6728 //
     /*  93715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93729 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93732 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93741 */   // GIR_Coverage, 6728,
     /*  93741 */   GIR_EraseRootFromParent_Done,
     /*  93742 */ // Label 1644: @93742
     /*  93742 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(93774), // Rule ID 6729 //
     /*  93747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93761 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93764 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93766 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93768 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93773 */   // GIR_Coverage, 6729,
     /*  93773 */   GIR_EraseRootFromParent_Done,
     /*  93774 */ // Label 1645: @93774
     /*  93774 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(93800), // Rule ID 6730 //
     /*  93779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93793 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  93793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93798 */   GIR_RootConstrainSelectedInstOperands,
     /*  93799 */   // GIR_Coverage, 6730,
     /*  93799 */   GIR_Done,
     /*  93800 */ // Label 1646: @93800
     /*  93800 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(93826), // Rule ID 6731 //
     /*  93805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93819 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  93819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  93824 */   GIR_RootConstrainSelectedInstOperands,
     /*  93825 */   // GIR_Coverage, 6731,
     /*  93825 */   GIR_Done,
     /*  93826 */ // Label 1647: @93826
     /*  93826 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(93852), // Rule ID 6732 //
     /*  93831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93845 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  93845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93850 */   GIR_RootConstrainSelectedInstOperands,
     /*  93851 */   // GIR_Coverage, 6732,
     /*  93851 */   GIR_Done,
     /*  93852 */ // Label 1648: @93852
     /*  93852 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(93878), // Rule ID 6733 //
     /*  93857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93871 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  93871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93876 */   GIR_RootConstrainSelectedInstOperands,
     /*  93877 */   // GIR_Coverage, 6733,
     /*  93877 */   GIR_Done,
     /*  93878 */ // Label 1649: @93878
     /*  93878 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(93904), // Rule ID 6734 //
     /*  93883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93897 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  93897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  93902 */   GIR_RootConstrainSelectedInstOperands,
     /*  93903 */   // GIR_Coverage, 6734,
     /*  93903 */   GIR_Done,
     /*  93904 */ // Label 1650: @93904
     /*  93904 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(93930), // Rule ID 6735 //
     /*  93909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93923 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  93923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93928 */   GIR_RootConstrainSelectedInstOperands,
     /*  93929 */   // GIR_Coverage, 6735,
     /*  93929 */   GIR_Done,
     /*  93930 */ // Label 1651: @93930
     /*  93930 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(93956), // Rule ID 6736 //
     /*  93935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93949 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  93949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93954 */   GIR_RootConstrainSelectedInstOperands,
     /*  93955 */   // GIR_Coverage, 6736,
     /*  93955 */   GIR_Done,
     /*  93956 */ // Label 1652: @93956
     /*  93956 */ GIM_Reject,
     /*  93957 */ // Label 1437: @93957
     /*  93957 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(93989), // Rule ID 6840 //
     /*  93962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93976 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93979 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93981 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93988 */   // GIR_Coverage, 6840,
     /*  93988 */   GIR_EraseRootFromParent_Done,
     /*  93989 */ // Label 1653: @93989
     /*  93989 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(94021), // Rule ID 6841 //
     /*  93994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94008 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94011 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94013 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94020 */   // GIR_Coverage, 6841,
     /*  94020 */   GIR_EraseRootFromParent_Done,
     /*  94021 */ // Label 1654: @94021
     /*  94021 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(94053), // Rule ID 6842 //
     /*  94026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94040 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94043 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94052 */   // GIR_Coverage, 6842,
     /*  94052 */   GIR_EraseRootFromParent_Done,
     /*  94053 */ // Label 1655: @94053
     /*  94053 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(94085), // Rule ID 6843 //
     /*  94058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94072 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94075 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94077 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94084 */   // GIR_Coverage, 6843,
     /*  94084 */   GIR_EraseRootFromParent_Done,
     /*  94085 */ // Label 1656: @94085
     /*  94085 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(94117), // Rule ID 6844 //
     /*  94090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94104 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94107 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94109 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94116 */   // GIR_Coverage, 6844,
     /*  94116 */   GIR_EraseRootFromParent_Done,
     /*  94117 */ // Label 1657: @94117
     /*  94117 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(94149), // Rule ID 6845 //
     /*  94122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94136 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94139 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94141 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94148 */   // GIR_Coverage, 6845,
     /*  94148 */   GIR_EraseRootFromParent_Done,
     /*  94149 */ // Label 1658: @94149
     /*  94149 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(94220), // Rule ID 6846 //
     /*  94154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94168 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94168 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94171 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94175 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94180 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94198 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94218 */   GIR_RootConstrainSelectedInstOperands,
     /*  94219 */   // GIR_Coverage, 6846,
     /*  94219 */   GIR_EraseRootFromParent_Done,
     /*  94220 */ // Label 1659: @94220
     /*  94220 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(94246), // Rule ID 6847 //
     /*  94225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94239 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  94239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94244 */   GIR_RootConstrainSelectedInstOperands,
     /*  94245 */   // GIR_Coverage, 6847,
     /*  94245 */   GIR_Done,
     /*  94246 */ // Label 1660: @94246
     /*  94246 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(94272), // Rule ID 6848 //
     /*  94251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94265 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  94265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94270 */   GIR_RootConstrainSelectedInstOperands,
     /*  94271 */   // GIR_Coverage, 6848,
     /*  94271 */   GIR_Done,
     /*  94272 */ // Label 1661: @94272
     /*  94272 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(94298), // Rule ID 6849 //
     /*  94277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94291 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  94291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94296 */   GIR_RootConstrainSelectedInstOperands,
     /*  94297 */   // GIR_Coverage, 6849,
     /*  94297 */   GIR_Done,
     /*  94298 */ // Label 1662: @94298
     /*  94298 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(94324), // Rule ID 6850 //
     /*  94303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94317 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  94317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94322 */   GIR_RootConstrainSelectedInstOperands,
     /*  94323 */   // GIR_Coverage, 6850,
     /*  94323 */   GIR_Done,
     /*  94324 */ // Label 1663: @94324
     /*  94324 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(94350), // Rule ID 6851 //
     /*  94329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94343 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  94343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94348 */   GIR_RootConstrainSelectedInstOperands,
     /*  94349 */   // GIR_Coverage, 6851,
     /*  94349 */   GIR_Done,
     /*  94350 */ // Label 1664: @94350
     /*  94350 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(94379), // Rule ID 6852 //
     /*  94355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94366 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94369 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94371 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94373 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94378 */   // GIR_Coverage, 6852,
     /*  94378 */   GIR_EraseRootFromParent_Done,
     /*  94379 */ // Label 1665: @94379
     /*  94379 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(94411), // Rule ID 6853 //
     /*  94384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94398 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94401 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94403 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94410 */   // GIR_Coverage, 6853,
     /*  94410 */   GIR_EraseRootFromParent_Done,
     /*  94411 */ // Label 1666: @94411
     /*  94411 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(94443), // Rule ID 6854 //
     /*  94416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94430 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94433 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94442 */   // GIR_Coverage, 6854,
     /*  94442 */   GIR_EraseRootFromParent_Done,
     /*  94443 */ // Label 1667: @94443
     /*  94443 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(94475), // Rule ID 6855 //
     /*  94448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94462 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94465 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94474 */   // GIR_Coverage, 6855,
     /*  94474 */   GIR_EraseRootFromParent_Done,
     /*  94475 */ // Label 1668: @94475
     /*  94475 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(94507), // Rule ID 6856 //
     /*  94480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94494 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94497 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94499 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94506 */   // GIR_Coverage, 6856,
     /*  94506 */   GIR_EraseRootFromParent_Done,
     /*  94507 */ // Label 1669: @94507
     /*  94507 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(94539), // Rule ID 6857 //
     /*  94512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94526 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94529 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94531 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94538 */   // GIR_Coverage, 6857,
     /*  94538 */   GIR_EraseRootFromParent_Done,
     /*  94539 */ // Label 1670: @94539
     /*  94539 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(94571), // Rule ID 6858 //
     /*  94544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94558 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94570 */   // GIR_Coverage, 6858,
     /*  94570 */   GIR_EraseRootFromParent_Done,
     /*  94571 */ // Label 1671: @94571
     /*  94571 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(94642), // Rule ID 6859 //
     /*  94576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94590 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94590 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94593 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94597 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94602 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94620 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94640 */   GIR_RootConstrainSelectedInstOperands,
     /*  94641 */   // GIR_Coverage, 6859,
     /*  94641 */   GIR_EraseRootFromParent_Done,
     /*  94642 */ // Label 1672: @94642
     /*  94642 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(94668), // Rule ID 6860 //
     /*  94647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94661 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  94661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94666 */   GIR_RootConstrainSelectedInstOperands,
     /*  94667 */   // GIR_Coverage, 6860,
     /*  94667 */   GIR_Done,
     /*  94668 */ // Label 1673: @94668
     /*  94668 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(94694), // Rule ID 6861 //
     /*  94673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94687 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  94687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94692 */   GIR_RootConstrainSelectedInstOperands,
     /*  94693 */   // GIR_Coverage, 6861,
     /*  94693 */   GIR_Done,
     /*  94694 */ // Label 1674: @94694
     /*  94694 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(94720), // Rule ID 6862 //
     /*  94699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94713 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  94713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94718 */   GIR_RootConstrainSelectedInstOperands,
     /*  94719 */   // GIR_Coverage, 6862,
     /*  94719 */   GIR_Done,
     /*  94720 */ // Label 1675: @94720
     /*  94720 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(94746), // Rule ID 6863 //
     /*  94725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94739 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  94739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94744 */   GIR_RootConstrainSelectedInstOperands,
     /*  94745 */   // GIR_Coverage, 6863,
     /*  94745 */   GIR_Done,
     /*  94746 */ // Label 1676: @94746
     /*  94746 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(94772), // Rule ID 6864 //
     /*  94751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94765 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  94765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94770 */   GIR_RootConstrainSelectedInstOperands,
     /*  94771 */   // GIR_Coverage, 6864,
     /*  94771 */   GIR_Done,
     /*  94772 */ // Label 1677: @94772
     /*  94772 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(94801), // Rule ID 6865 //
     /*  94777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94788 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94791 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94793 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94795 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94800 */   // GIR_Coverage, 6865,
     /*  94800 */   GIR_EraseRootFromParent_Done,
     /*  94801 */ // Label 1678: @94801
     /*  94801 */ GIM_Reject,
     /*  94802 */ // Label 1438: @94802
     /*  94802 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(94834), // Rule ID 6866 //
     /*  94807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94821 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94824 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94826 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94833 */   // GIR_Coverage, 6866,
     /*  94833 */   GIR_EraseRootFromParent_Done,
     /*  94834 */ // Label 1679: @94834
     /*  94834 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(94866), // Rule ID 6867 //
     /*  94839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94853 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94856 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94858 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94860 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94865 */   // GIR_Coverage, 6867,
     /*  94865 */   GIR_EraseRootFromParent_Done,
     /*  94866 */ // Label 1680: @94866
     /*  94866 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(94898), // Rule ID 6868 //
     /*  94871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94885 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94888 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94892 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94897 */   // GIR_Coverage, 6868,
     /*  94897 */   GIR_EraseRootFromParent_Done,
     /*  94898 */ // Label 1681: @94898
     /*  94898 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(94930), // Rule ID 6869 //
     /*  94903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94917 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94920 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94922 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94929 */   // GIR_Coverage, 6869,
     /*  94929 */   GIR_EraseRootFromParent_Done,
     /*  94930 */ // Label 1682: @94930
     /*  94930 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(94962), // Rule ID 6870 //
     /*  94935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94949 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94952 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94954 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94956 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94961 */   // GIR_Coverage, 6870,
     /*  94961 */   GIR_EraseRootFromParent_Done,
     /*  94962 */ // Label 1683: @94962
     /*  94962 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(94994), // Rule ID 6871 //
     /*  94967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94981 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94984 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94986 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94993 */   // GIR_Coverage, 6871,
     /*  94993 */   GIR_EraseRootFromParent_Done,
     /*  94994 */ // Label 1684: @94994
     /*  94994 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(95026), // Rule ID 6872 //
     /*  94999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95013 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95016 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95025 */   // GIR_Coverage, 6872,
     /*  95025 */   GIR_EraseRootFromParent_Done,
     /*  95026 */ // Label 1685: @95026
     /*  95026 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(95097), // Rule ID 6873 //
     /*  95031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95045 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95045 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95048 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95052 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95057 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95063 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95066 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95070 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95075 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95095 */   GIR_RootConstrainSelectedInstOperands,
     /*  95096 */   // GIR_Coverage, 6873,
     /*  95096 */   GIR_EraseRootFromParent_Done,
     /*  95097 */ // Label 1686: @95097
     /*  95097 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(95123), // Rule ID 6874 //
     /*  95102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95116 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  95116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95121 */   GIR_RootConstrainSelectedInstOperands,
     /*  95122 */   // GIR_Coverage, 6874,
     /*  95122 */   GIR_Done,
     /*  95123 */ // Label 1687: @95123
     /*  95123 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(95149), // Rule ID 6875 //
     /*  95128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95142 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  95142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95147 */   GIR_RootConstrainSelectedInstOperands,
     /*  95148 */   // GIR_Coverage, 6875,
     /*  95148 */   GIR_Done,
     /*  95149 */ // Label 1688: @95149
     /*  95149 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(95175), // Rule ID 6876 //
     /*  95154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95168 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  95168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95173 */   GIR_RootConstrainSelectedInstOperands,
     /*  95174 */   // GIR_Coverage, 6876,
     /*  95174 */   GIR_Done,
     /*  95175 */ // Label 1689: @95175
     /*  95175 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(95201), // Rule ID 6877 //
     /*  95180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95194 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  95194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95199 */   GIR_RootConstrainSelectedInstOperands,
     /*  95200 */   // GIR_Coverage, 6877,
     /*  95200 */   GIR_Done,
     /*  95201 */ // Label 1690: @95201
     /*  95201 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(95227), // Rule ID 6878 //
     /*  95206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95220 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  95220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95225 */   GIR_RootConstrainSelectedInstOperands,
     /*  95226 */   // GIR_Coverage, 6878,
     /*  95226 */   GIR_Done,
     /*  95227 */ // Label 1691: @95227
     /*  95227 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(95253), // Rule ID 6879 //
     /*  95232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95246 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  95246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95251 */   GIR_RootConstrainSelectedInstOperands,
     /*  95252 */   // GIR_Coverage, 6879,
     /*  95252 */   GIR_Done,
     /*  95253 */ // Label 1692: @95253
     /*  95253 */ GIM_Reject,
     /*  95254 */ // Label 1439: @95254
     /*  95254 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(95286), // Rule ID 10548 //
     /*  95259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95273 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95276 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95278 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95280 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95285 */   // GIR_Coverage, 10548,
     /*  95285 */   GIR_EraseRootFromParent_Done,
     /*  95286 */ // Label 1693: @95286
     /*  95286 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(95318), // Rule ID 10549 //
     /*  95291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95305 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95308 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95310 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95317 */   // GIR_Coverage, 10549,
     /*  95317 */   GIR_EraseRootFromParent_Done,
     /*  95318 */ // Label 1694: @95318
     /*  95318 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(95350), // Rule ID 10550 //
     /*  95323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95337 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95340 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95342 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95344 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95349 */   // GIR_Coverage, 10550,
     /*  95349 */   GIR_EraseRootFromParent_Done,
     /*  95350 */ // Label 1695: @95350
     /*  95350 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(95382), // Rule ID 10551 //
     /*  95355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95369 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95372 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95374 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95381 */   // GIR_Coverage, 10551,
     /*  95381 */   GIR_EraseRootFromParent_Done,
     /*  95382 */ // Label 1696: @95382
     /*  95382 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(95414), // Rule ID 10552 //
     /*  95387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95401 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95404 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95406 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95413 */   // GIR_Coverage, 10552,
     /*  95413 */   GIR_EraseRootFromParent_Done,
     /*  95414 */ // Label 1697: @95414
     /*  95414 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(95446), // Rule ID 10553 //
     /*  95419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95433 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95436 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95445 */   // GIR_Coverage, 10553,
     /*  95445 */   GIR_EraseRootFromParent_Done,
     /*  95446 */ // Label 1698: @95446
     /*  95446 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(95478), // Rule ID 10566 //
     /*  95451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95465 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95468 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95470 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95477 */   // GIR_Coverage, 10566,
     /*  95477 */   GIR_EraseRootFromParent_Done,
     /*  95478 */ // Label 1699: @95478
     /*  95478 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(95510), // Rule ID 10567 //
     /*  95483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95497 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95500 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95502 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95509 */   // GIR_Coverage, 10567,
     /*  95509 */   GIR_EraseRootFromParent_Done,
     /*  95510 */ // Label 1700: @95510
     /*  95510 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(95542), // Rule ID 10568 //
     /*  95515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95529 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95532 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95534 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95541 */   // GIR_Coverage, 10568,
     /*  95541 */   GIR_EraseRootFromParent_Done,
     /*  95542 */ // Label 1701: @95542
     /*  95542 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(95574), // Rule ID 10569 //
     /*  95547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95561 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95573 */   // GIR_Coverage, 10569,
     /*  95573 */   GIR_EraseRootFromParent_Done,
     /*  95574 */ // Label 1702: @95574
     /*  95574 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(95606), // Rule ID 10570 //
     /*  95579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95593 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95605 */   // GIR_Coverage, 10570,
     /*  95605 */   GIR_EraseRootFromParent_Done,
     /*  95606 */ // Label 1703: @95606
     /*  95606 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(95638), // Rule ID 10571 //
     /*  95611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95625 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95637 */   // GIR_Coverage, 10571,
     /*  95637 */   GIR_EraseRootFromParent_Done,
     /*  95638 */ // Label 1704: @95638
     /*  95638 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(95670), // Rule ID 10576 //
     /*  95643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95657 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95669 */   // GIR_Coverage, 10576,
     /*  95669 */   GIR_EraseRootFromParent_Done,
     /*  95670 */ // Label 1705: @95670
     /*  95670 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(95702), // Rule ID 10577 //
     /*  95675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95689 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95701 */   // GIR_Coverage, 10577,
     /*  95701 */   GIR_EraseRootFromParent_Done,
     /*  95702 */ // Label 1706: @95702
     /*  95702 */ GIM_Reject,
     /*  95703 */ // Label 1440: @95703
     /*  95703 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(95735), // Rule ID 10542 //
     /*  95708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95722 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95725 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95727 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95734 */   // GIR_Coverage, 10542,
     /*  95734 */   GIR_EraseRootFromParent_Done,
     /*  95735 */ // Label 1707: @95735
     /*  95735 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(95767), // Rule ID 10543 //
     /*  95740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95754 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95757 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95759 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95766 */   // GIR_Coverage, 10543,
     /*  95766 */   GIR_EraseRootFromParent_Done,
     /*  95767 */ // Label 1708: @95767
     /*  95767 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(95799), // Rule ID 10544 //
     /*  95772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95786 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95789 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95791 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95798 */   // GIR_Coverage, 10544,
     /*  95798 */   GIR_EraseRootFromParent_Done,
     /*  95799 */ // Label 1709: @95799
     /*  95799 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(95831), // Rule ID 10545 //
     /*  95804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95818 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95821 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95823 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95830 */   // GIR_Coverage, 10545,
     /*  95830 */   GIR_EraseRootFromParent_Done,
     /*  95831 */ // Label 1710: @95831
     /*  95831 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(95863), // Rule ID 10546 //
     /*  95836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95850 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95853 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95855 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95857 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95862 */   // GIR_Coverage, 10546,
     /*  95862 */   GIR_EraseRootFromParent_Done,
     /*  95863 */ // Label 1711: @95863
     /*  95863 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(95895), // Rule ID 10547 //
     /*  95868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95882 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95885 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95887 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95894 */   // GIR_Coverage, 10547,
     /*  95894 */   GIR_EraseRootFromParent_Done,
     /*  95895 */ // Label 1712: @95895
     /*  95895 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(95927), // Rule ID 10560 //
     /*  95900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95914 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95917 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95926 */   // GIR_Coverage, 10560,
     /*  95926 */   GIR_EraseRootFromParent_Done,
     /*  95927 */ // Label 1713: @95927
     /*  95927 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(95959), // Rule ID 10561 //
     /*  95932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95946 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95949 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95958 */   // GIR_Coverage, 10561,
     /*  95958 */   GIR_EraseRootFromParent_Done,
     /*  95959 */ // Label 1714: @95959
     /*  95959 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(95991), // Rule ID 10562 //
     /*  95964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95978 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95990 */   // GIR_Coverage, 10562,
     /*  95990 */   GIR_EraseRootFromParent_Done,
     /*  95991 */ // Label 1715: @95991
     /*  95991 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(96023), // Rule ID 10563 //
     /*  95996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  95999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96010 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96013 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96015 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96022 */   // GIR_Coverage, 10563,
     /*  96022 */   GIR_EraseRootFromParent_Done,
     /*  96023 */ // Label 1716: @96023
     /*  96023 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(96055), // Rule ID 10564 //
     /*  96028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96042 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96045 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96047 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96054 */   // GIR_Coverage, 10564,
     /*  96054 */   GIR_EraseRootFromParent_Done,
     /*  96055 */ // Label 1717: @96055
     /*  96055 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(96087), // Rule ID 10565 //
     /*  96060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96074 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96086 */   // GIR_Coverage, 10565,
     /*  96086 */   GIR_EraseRootFromParent_Done,
     /*  96087 */ // Label 1718: @96087
     /*  96087 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(96119), // Rule ID 10574 //
     /*  96092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96106 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96109 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96113 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96118 */   // GIR_Coverage, 10574,
     /*  96118 */   GIR_EraseRootFromParent_Done,
     /*  96119 */ // Label 1719: @96119
     /*  96119 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(96151), // Rule ID 10575 //
     /*  96124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96138 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96141 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96143 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96145 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96150 */   // GIR_Coverage, 10575,
     /*  96150 */   GIR_EraseRootFromParent_Done,
     /*  96151 */ // Label 1720: @96151
     /*  96151 */ GIM_Reject,
     /*  96152 */ // Label 1441: @96152
     /*  96152 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(96184), // Rule ID 10536 //
     /*  96157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96171 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96174 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96176 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96183 */   // GIR_Coverage, 10536,
     /*  96183 */   GIR_EraseRootFromParent_Done,
     /*  96184 */ // Label 1721: @96184
     /*  96184 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(96216), // Rule ID 10537 //
     /*  96189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96203 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96206 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96208 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96210 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96215 */   // GIR_Coverage, 10537,
     /*  96215 */   GIR_EraseRootFromParent_Done,
     /*  96216 */ // Label 1722: @96216
     /*  96216 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(96248), // Rule ID 10538 //
     /*  96221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96235 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96238 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96240 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96242 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96247 */   // GIR_Coverage, 10538,
     /*  96247 */   GIR_EraseRootFromParent_Done,
     /*  96248 */ // Label 1723: @96248
     /*  96248 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(96280), // Rule ID 10539 //
     /*  96253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96267 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96270 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96272 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96279 */   // GIR_Coverage, 10539,
     /*  96279 */   GIR_EraseRootFromParent_Done,
     /*  96280 */ // Label 1724: @96280
     /*  96280 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(96312), // Rule ID 10540 //
     /*  96285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96299 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96302 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96304 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96306 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96311 */   // GIR_Coverage, 10540,
     /*  96311 */   GIR_EraseRootFromParent_Done,
     /*  96312 */ // Label 1725: @96312
     /*  96312 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(96344), // Rule ID 10541 //
     /*  96317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96331 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96334 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96336 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96338 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96343 */   // GIR_Coverage, 10541,
     /*  96343 */   GIR_EraseRootFromParent_Done,
     /*  96344 */ // Label 1726: @96344
     /*  96344 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(96376), // Rule ID 10554 //
     /*  96349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96363 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96366 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96368 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96375 */   // GIR_Coverage, 10554,
     /*  96375 */   GIR_EraseRootFromParent_Done,
     /*  96376 */ // Label 1727: @96376
     /*  96376 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(96408), // Rule ID 10555 //
     /*  96381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96395 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96398 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96400 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96402 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96407 */   // GIR_Coverage, 10555,
     /*  96407 */   GIR_EraseRootFromParent_Done,
     /*  96408 */ // Label 1728: @96408
     /*  96408 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(96440), // Rule ID 10556 //
     /*  96413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96427 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96430 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96432 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96434 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96439 */   // GIR_Coverage, 10556,
     /*  96439 */   GIR_EraseRootFromParent_Done,
     /*  96440 */ // Label 1729: @96440
     /*  96440 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(96472), // Rule ID 10557 //
     /*  96445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96459 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96462 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96464 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96466 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96471 */   // GIR_Coverage, 10557,
     /*  96471 */   GIR_EraseRootFromParent_Done,
     /*  96472 */ // Label 1730: @96472
     /*  96472 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(96504), // Rule ID 10558 //
     /*  96477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96491 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96494 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96496 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96498 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96503 */   // GIR_Coverage, 10558,
     /*  96503 */   GIR_EraseRootFromParent_Done,
     /*  96504 */ // Label 1731: @96504
     /*  96504 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(96536), // Rule ID 10559 //
     /*  96509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96523 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96526 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96535 */   // GIR_Coverage, 10559,
     /*  96535 */   GIR_EraseRootFromParent_Done,
     /*  96536 */ // Label 1732: @96536
     /*  96536 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(96568), // Rule ID 10572 //
     /*  96541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96555 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96558 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96560 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96567 */   // GIR_Coverage, 10572,
     /*  96567 */   GIR_EraseRootFromParent_Done,
     /*  96568 */ // Label 1733: @96568
     /*  96568 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(96600), // Rule ID 10573 //
     /*  96573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96587 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96590 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96592 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96599 */   // GIR_Coverage, 10573,
     /*  96599 */   GIR_EraseRootFromParent_Done,
     /*  96600 */ // Label 1734: @96600
     /*  96600 */ GIM_Reject,
     /*  96601 */ // Label 1442: @96601
     /*  96601 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(96633), // Rule ID 10530 //
     /*  96606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96620 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96623 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96625 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96632 */   // GIR_Coverage, 10530,
     /*  96632 */   GIR_EraseRootFromParent_Done,
     /*  96633 */ // Label 1735: @96633
     /*  96633 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(96665), // Rule ID 10531 //
     /*  96638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96652 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96655 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96657 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96659 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96664 */   // GIR_Coverage, 10531,
     /*  96664 */   GIR_EraseRootFromParent_Done,
     /*  96665 */ // Label 1736: @96665
     /*  96665 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(96697), // Rule ID 10532 //
     /*  96670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96684 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96696 */   // GIR_Coverage, 10532,
     /*  96696 */   GIR_EraseRootFromParent_Done,
     /*  96697 */ // Label 1737: @96697
     /*  96697 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(96729), // Rule ID 10533 //
     /*  96702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96716 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96728 */   // GIR_Coverage, 10533,
     /*  96728 */   GIR_EraseRootFromParent_Done,
     /*  96729 */ // Label 1738: @96729
     /*  96729 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(96761), // Rule ID 10534 //
     /*  96734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96748 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96760 */   // GIR_Coverage, 10534,
     /*  96760 */   GIR_EraseRootFromParent_Done,
     /*  96761 */ // Label 1739: @96761
     /*  96761 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(96793), // Rule ID 10535 //
     /*  96766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /*  96769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96780 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96792 */   // GIR_Coverage, 10535,
     /*  96792 */   GIR_EraseRootFromParent_Done,
     /*  96793 */ // Label 1740: @96793
     /*  96793 */ GIM_Reject,
     /*  96794 */ // Label 1443: @96794
     /*  96794 */ GIM_Reject,
     /*  96795 */ // Label 10: @96795
     /*  96795 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1749*/ GIMT_Encode4(97285),
     /*  96806 */ /*GILLT_s16*//*Label 1741*/ GIMT_Encode4(96846),
     /*  96810 */ /*GILLT_s32*//*Label 1742*/ GIMT_Encode4(96877),
     /*  96814 */ /*GILLT_s64*//*Label 1743*/ GIMT_Encode4(96908), GIMT_Encode4(0),
     /*  96822 */ /*GILLT_v2s32*//*Label 1744*/ GIMT_Encode4(96939),
     /*  96826 */ /*GILLT_v2s64*//*Label 1745*/ GIMT_Encode4(96970),
     /*  96830 */ /*GILLT_v4s16*//*Label 1746*/ GIMT_Encode4(97001),
     /*  96834 */ /*GILLT_v4s32*//*Label 1747*/ GIMT_Encode4(97032), GIMT_Encode4(0),
     /*  96842 */ /*GILLT_v8s16*//*Label 1748*/ GIMT_Encode4(97063),
     /*  96846 */ // Label 1741: @96846
     /*  96846 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96876), // Rule ID 564 //
     /*  96851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  96854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  96857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96865 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  96865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  96870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96874 */   GIR_RootConstrainSelectedInstOperands,
     /*  96875 */   // GIR_Coverage, 564,
     /*  96875 */   GIR_Done,
     /*  96876 */ // Label 1750: @96876
     /*  96876 */ GIM_Reject,
     /*  96877 */ // Label 1742: @96877
     /*  96877 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96907), // Rule ID 566 //
     /*  96882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  96888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96896 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  96896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  96901 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96905 */   GIR_RootConstrainSelectedInstOperands,
     /*  96906 */   // GIR_Coverage, 566,
     /*  96906 */   GIR_Done,
     /*  96907 */ // Label 1751: @96907
     /*  96907 */ GIM_Reject,
     /*  96908 */ // Label 1743: @96908
     /*  96908 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96938), // Rule ID 568 //
     /*  96913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  96919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96927 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  96927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  96932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96936 */   GIR_RootConstrainSelectedInstOperands,
     /*  96937 */   // GIR_Coverage, 568,
     /*  96937 */   GIR_Done,
     /*  96938 */ // Label 1752: @96938
     /*  96938 */ GIM_Reject,
     /*  96939 */ // Label 1744: @96939
     /*  96939 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96969), // Rule ID 933 //
     /*  96944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  96950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96958 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  96958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  96963 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96967 */   GIR_RootConstrainSelectedInstOperands,
     /*  96968 */   // GIR_Coverage, 933,
     /*  96968 */   GIR_Done,
     /*  96969 */ // Label 1753: @96969
     /*  96969 */ GIM_Reject,
     /*  96970 */ // Label 1745: @96970
     /*  96970 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(97000), // Rule ID 937 //
     /*  96975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  96981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96989 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  96989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  96994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96998 */   GIR_RootConstrainSelectedInstOperands,
     /*  96999 */   // GIR_Coverage, 937,
     /*  96999 */   GIR_Done,
     /*  97000 */ // Label 1754: @97000
     /*  97000 */ GIM_Reject,
     /*  97001 */ // Label 1746: @97001
     /*  97001 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(97031), // Rule ID 929 //
     /*  97006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97020 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  97025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97029 */   GIR_RootConstrainSelectedInstOperands,
     /*  97030 */   // GIR_Coverage, 929,
     /*  97030 */   GIR_Done,
     /*  97031 */ // Label 1755: @97031
     /*  97031 */ GIM_Reject,
     /*  97032 */ // Label 1747: @97032
     /*  97032 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(97062), // Rule ID 935 //
     /*  97037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97051 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97056 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97060 */   GIR_RootConstrainSelectedInstOperands,
     /*  97061 */   // GIR_Coverage, 935,
     /*  97061 */   GIR_Done,
     /*  97062 */ // Label 1756: @97062
     /*  97062 */ GIM_Reject,
     /*  97063 */ // Label 1748: @97063
     /*  97063 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(97284),
     /*  97068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97079 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(97098), // Rule ID 931 //
     /*  97084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97087 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  97092 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97096 */     GIR_RootConstrainSelectedInstOperands,
     /*  97097 */     // GIR_Coverage, 931,
     /*  97097 */     GIR_Done,
     /*  97098 */   // Label 1758: @97098
     /*  97098 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(97283), // Rule ID 6998 //
     /*  97103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97106 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97106 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97109 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97113 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97118 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97124 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97127 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97131 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97136 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97141 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97144 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97148 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97153 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97159 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97164 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97169 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97172 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97176 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97181 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97186 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97189 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97193 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97198 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97203 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97206 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97210 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97215 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97220 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97223 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97227 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97246 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97281 */     GIR_RootConstrainSelectedInstOperands,
     /*  97282 */     // GIR_Coverage, 6998,
     /*  97282 */     GIR_EraseRootFromParent_Done,
     /*  97283 */   // Label 1759: @97283
     /*  97283 */   GIM_Reject,
     /*  97284 */ // Label 1757: @97284
     /*  97284 */ GIM_Reject,
     /*  97285 */ // Label 1749: @97285
     /*  97285 */ GIM_Reject,
     /*  97286 */ // Label 11: @97286
     /*  97286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1768*/ GIMT_Encode4(97776),
     /*  97297 */ /*GILLT_s16*//*Label 1760*/ GIMT_Encode4(97337),
     /*  97301 */ /*GILLT_s32*//*Label 1761*/ GIMT_Encode4(97368),
     /*  97305 */ /*GILLT_s64*//*Label 1762*/ GIMT_Encode4(97399), GIMT_Encode4(0),
     /*  97313 */ /*GILLT_v2s32*//*Label 1763*/ GIMT_Encode4(97430),
     /*  97317 */ /*GILLT_v2s64*//*Label 1764*/ GIMT_Encode4(97461),
     /*  97321 */ /*GILLT_v4s16*//*Label 1765*/ GIMT_Encode4(97492),
     /*  97325 */ /*GILLT_v4s32*//*Label 1766*/ GIMT_Encode4(97523), GIMT_Encode4(0),
     /*  97333 */ /*GILLT_v8s16*//*Label 1767*/ GIMT_Encode4(97554),
     /*  97337 */ // Label 1760: @97337
     /*  97337 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97367), // Rule ID 528 //
     /*  97342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97356 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  97361 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97365 */   GIR_RootConstrainSelectedInstOperands,
     /*  97366 */   // GIR_Coverage, 528,
     /*  97366 */   GIR_Done,
     /*  97367 */ // Label 1769: @97367
     /*  97367 */ GIM_Reject,
     /*  97368 */ // Label 1761: @97368
     /*  97368 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97398), // Rule ID 530 //
     /*  97373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97387 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  97392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97396 */   GIR_RootConstrainSelectedInstOperands,
     /*  97397 */   // GIR_Coverage, 530,
     /*  97397 */   GIR_Done,
     /*  97398 */ // Label 1770: @97398
     /*  97398 */ GIM_Reject,
     /*  97399 */ // Label 1762: @97399
     /*  97399 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97429), // Rule ID 532 //
     /*  97404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97418 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  97423 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97427 */   GIR_RootConstrainSelectedInstOperands,
     /*  97428 */   // GIR_Coverage, 532,
     /*  97428 */   GIR_Done,
     /*  97429 */ // Label 1771: @97429
     /*  97429 */ GIM_Reject,
     /*  97430 */ // Label 1763: @97430
     /*  97430 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97460), // Rule ID 873 //
     /*  97435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97449 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  97454 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97458 */   GIR_RootConstrainSelectedInstOperands,
     /*  97459 */   // GIR_Coverage, 873,
     /*  97459 */   GIR_Done,
     /*  97460 */ // Label 1772: @97460
     /*  97460 */ GIM_Reject,
     /*  97461 */ // Label 1764: @97461
     /*  97461 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97491), // Rule ID 877 //
     /*  97466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97480 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  97485 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97489 */   GIR_RootConstrainSelectedInstOperands,
     /*  97490 */   // GIR_Coverage, 877,
     /*  97490 */   GIR_Done,
     /*  97491 */ // Label 1773: @97491
     /*  97491 */ GIM_Reject,
     /*  97492 */ // Label 1765: @97492
     /*  97492 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97522), // Rule ID 869 //
     /*  97497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97511 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  97516 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97520 */   GIR_RootConstrainSelectedInstOperands,
     /*  97521 */   // GIR_Coverage, 869,
     /*  97521 */   GIR_Done,
     /*  97522 */ // Label 1774: @97522
     /*  97522 */ GIM_Reject,
     /*  97523 */ // Label 1766: @97523
     /*  97523 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97553), // Rule ID 875 //
     /*  97528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97542 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97551 */   GIR_RootConstrainSelectedInstOperands,
     /*  97552 */   // GIR_Coverage, 875,
     /*  97552 */   GIR_Done,
     /*  97553 */ // Label 1775: @97553
     /*  97553 */ GIM_Reject,
     /*  97554 */ // Label 1767: @97554
     /*  97554 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97775),
     /*  97559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97570 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(97589), // Rule ID 871 //
     /*  97575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97578 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  97583 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97587 */     GIR_RootConstrainSelectedInstOperands,
     /*  97588 */     // GIR_Coverage, 871,
     /*  97588 */     GIR_Done,
     /*  97589 */   // Label 1777: @97589
     /*  97589 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(97774), // Rule ID 6992 //
     /*  97594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97597 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97597 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97600 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97604 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97609 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97615 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97618 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97622 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97627 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97632 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97635 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97639 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97644 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97650 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97655 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97660 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97663 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97667 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97672 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97677 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97680 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97684 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97689 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97694 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97697 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97701 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97706 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97772 */     GIR_RootConstrainSelectedInstOperands,
     /*  97773 */     // GIR_Coverage, 6992,
     /*  97773 */     GIR_EraseRootFromParent_Done,
     /*  97774 */   // Label 1778: @97774
     /*  97774 */   GIM_Reject,
     /*  97775 */ // Label 1776: @97775
     /*  97775 */ GIM_Reject,
     /*  97776 */ // Label 1768: @97776
     /*  97776 */ GIM_Reject,
     /*  97777 */ // Label 12: @97777
     /*  97777 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1781*/ GIMT_Encode4(98044),
     /*  97788 */ /*GILLT_s32*//*Label 1779*/ GIMT_Encode4(97796),
     /*  97792 */ /*GILLT_s64*//*Label 1780*/ GIMT_Encode4(97920),
     /*  97796 */ // Label 1779: @97796
     /*  97796 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(97839), // Rule ID 4785 //
     /*  97801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97811 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  97832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97837 */   GIR_RootConstrainSelectedInstOperands,
     /*  97838 */   // GIR_Coverage, 4785,
     /*  97838 */   GIR_EraseRootFromParent_Done,
     /*  97839 */ // Label 1782: @97839
     /*  97839 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(97879), // Rule ID 4791 //
     /*  97844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97851 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97863 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  97872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97877 */   GIR_RootConstrainSelectedInstOperands,
     /*  97878 */   // GIR_Coverage, 4791,
     /*  97878 */   GIR_EraseRootFromParent_Done,
     /*  97879 */ // Label 1783: @97879
     /*  97879 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(97919), // Rule ID 4793 //
     /*  97884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97891 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  97891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  97898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97903 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  97912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97917 */   GIR_RootConstrainSelectedInstOperands,
     /*  97918 */   // GIR_Coverage, 4793,
     /*  97918 */   GIR_EraseRootFromParent_Done,
     /*  97919 */ // Label 1784: @97919
     /*  97919 */ GIM_Reject,
     /*  97920 */ // Label 1780: @97920
     /*  97920 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(97963), // Rule ID 4787 //
     /*  97925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97935 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97947 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  97956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97961 */   GIR_RootConstrainSelectedInstOperands,
     /*  97962 */   // GIR_Coverage, 4787,
     /*  97962 */   GIR_EraseRootFromParent_Done,
     /*  97963 */ // Label 1785: @97963
     /*  97963 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98003), // Rule ID 4795 //
     /*  97968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97975 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97987 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  97996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98001 */   GIR_RootConstrainSelectedInstOperands,
     /*  98002 */   // GIR_Coverage, 4795,
     /*  98002 */   GIR_EraseRootFromParent_Done,
     /*  98003 */ // Label 1786: @98003
     /*  98003 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98043), // Rule ID 4797 //
     /*  98008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98015 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98027 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98041 */   GIR_RootConstrainSelectedInstOperands,
     /*  98042 */   // GIR_Coverage, 4797,
     /*  98042 */   GIR_EraseRootFromParent_Done,
     /*  98043 */ // Label 1787: @98043
     /*  98043 */ GIM_Reject,
     /*  98044 */ // Label 1781: @98044
     /*  98044 */ GIM_Reject,
     /*  98045 */ // Label 13: @98045
     /*  98045 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98194),
     /*  98050 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98053 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1792*/ GIMT_Encode4(98193),
     /*  98064 */   /*GILLT_s16*//*Label 1789*/ GIMT_Encode4(98076),
     /*  98068 */   /*GILLT_s32*//*Label 1790*/ GIMT_Encode4(98117),
     /*  98072 */   /*GILLT_s64*//*Label 1791*/ GIMT_Encode4(98155),
     /*  98076 */   // Label 1789: @98076
     /*  98076 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98116), // Rule ID 4789 //
     /*  98081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98088 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98114 */     GIR_RootConstrainSelectedInstOperands,
     /*  98115 */     // GIR_Coverage, 4789,
     /*  98115 */     GIR_EraseRootFromParent_Done,
     /*  98116 */   // Label 1793: @98116
     /*  98116 */   GIM_Reject,
     /*  98117 */   // Label 1790: @98117
     /*  98117 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(98154), // Rule ID 4799 //
     /*  98122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98126 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98152 */     GIR_RootConstrainSelectedInstOperands,
     /*  98153 */     // GIR_Coverage, 4799,
     /*  98153 */     GIR_EraseRootFromParent_Done,
     /*  98154 */   // Label 1794: @98154
     /*  98154 */   GIM_Reject,
     /*  98155 */   // Label 1791: @98155
     /*  98155 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(98192), // Rule ID 4801 //
     /*  98160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98164 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98190 */     GIR_RootConstrainSelectedInstOperands,
     /*  98191 */     // GIR_Coverage, 4801,
     /*  98191 */     GIR_EraseRootFromParent_Done,
     /*  98192 */   // Label 1795: @98192
     /*  98192 */   GIM_Reject,
     /*  98193 */   // Label 1792: @98193
     /*  98193 */   GIM_Reject,
     /*  98194 */ // Label 1788: @98194
     /*  98194 */ GIM_Reject,
     /*  98195 */ // Label 14: @98195
     /*  98195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1804*/ GIMT_Encode4(98685),
     /*  98206 */ /*GILLT_s16*//*Label 1796*/ GIMT_Encode4(98246),
     /*  98210 */ /*GILLT_s32*//*Label 1797*/ GIMT_Encode4(98277),
     /*  98214 */ /*GILLT_s64*//*Label 1798*/ GIMT_Encode4(98308), GIMT_Encode4(0),
     /*  98222 */ /*GILLT_v2s32*//*Label 1799*/ GIMT_Encode4(98339),
     /*  98226 */ /*GILLT_v2s64*//*Label 1800*/ GIMT_Encode4(98370),
     /*  98230 */ /*GILLT_v4s16*//*Label 1801*/ GIMT_Encode4(98401),
     /*  98234 */ /*GILLT_v4s32*//*Label 1802*/ GIMT_Encode4(98432), GIMT_Encode4(0),
     /*  98242 */ /*GILLT_v8s16*//*Label 1803*/ GIMT_Encode4(98463),
     /*  98246 */ // Label 1796: @98246
     /*  98246 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(98276), // Rule ID 546 //
     /*  98251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98265 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  98270 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98274 */   GIR_RootConstrainSelectedInstOperands,
     /*  98275 */   // GIR_Coverage, 546,
     /*  98275 */   GIR_Done,
     /*  98276 */ // Label 1805: @98276
     /*  98276 */ GIM_Reject,
     /*  98277 */ // Label 1797: @98277
     /*  98277 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(98307), // Rule ID 548 //
     /*  98282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98296 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  98296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  98301 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98305 */   GIR_RootConstrainSelectedInstOperands,
     /*  98306 */   // GIR_Coverage, 548,
     /*  98306 */   GIR_Done,
     /*  98307 */ // Label 1806: @98307
     /*  98307 */ GIM_Reject,
     /*  98308 */ // Label 1798: @98308
     /*  98308 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(98338), // Rule ID 550 //
     /*  98313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98327 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  98327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  98332 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98336 */   GIR_RootConstrainSelectedInstOperands,
     /*  98337 */   // GIR_Coverage, 550,
     /*  98337 */   GIR_Done,
     /*  98338 */ // Label 1807: @98338
     /*  98338 */ GIM_Reject,
     /*  98339 */ // Label 1799: @98339
     /*  98339 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(98369), // Rule ID 903 //
     /*  98344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98358 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  98358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  98363 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98367 */   GIR_RootConstrainSelectedInstOperands,
     /*  98368 */   // GIR_Coverage, 903,
     /*  98368 */   GIR_Done,
     /*  98369 */ // Label 1808: @98369
     /*  98369 */ GIM_Reject,
     /*  98370 */ // Label 1800: @98370
     /*  98370 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(98400), // Rule ID 907 //
     /*  98375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98389 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  98389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  98394 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98398 */   GIR_RootConstrainSelectedInstOperands,
     /*  98399 */   // GIR_Coverage, 907,
     /*  98399 */   GIR_Done,
     /*  98400 */ // Label 1809: @98400
     /*  98400 */ GIM_Reject,
     /*  98401 */ // Label 1801: @98401
     /*  98401 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(98431), // Rule ID 899 //
     /*  98406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98420 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  98420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  98425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98429 */   GIR_RootConstrainSelectedInstOperands,
     /*  98430 */   // GIR_Coverage, 899,
     /*  98430 */   GIR_Done,
     /*  98431 */ // Label 1810: @98431
     /*  98431 */ GIM_Reject,
     /*  98432 */ // Label 1802: @98432
     /*  98432 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(98462), // Rule ID 905 //
     /*  98437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98451 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  98451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98460 */   GIR_RootConstrainSelectedInstOperands,
     /*  98461 */   // GIR_Coverage, 905,
     /*  98461 */   GIR_Done,
     /*  98462 */ // Label 1811: @98462
     /*  98462 */ GIM_Reject,
     /*  98463 */ // Label 1803: @98463
     /*  98463 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(98684),
     /*  98468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98479 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(98498), // Rule ID 901 //
     /*  98484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98487 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  98487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  98492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98496 */     GIR_RootConstrainSelectedInstOperands,
     /*  98497 */     // GIR_Coverage, 901,
     /*  98497 */     GIR_Done,
     /*  98498 */   // Label 1813: @98498
     /*  98498 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(98683), // Rule ID 6994 //
     /*  98503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  98506 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  98506 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  98509 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  98513 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98518 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  98524 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  98527 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98531 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98536 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  98539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  98541 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  98544 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98548 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98553 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  98559 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98564 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98569 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  98572 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  98576 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98581 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  98584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  98586 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  98589 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98593 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98598 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  98601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98603 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  98606 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  98610 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98615 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  98618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98649 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  98652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98681 */     GIR_RootConstrainSelectedInstOperands,
     /*  98682 */     // GIR_Coverage, 6994,
     /*  98682 */     GIR_EraseRootFromParent_Done,
     /*  98683 */   // Label 1814: @98683
     /*  98683 */   GIM_Reject,
     /*  98684 */ // Label 1812: @98684
     /*  98684 */ GIM_Reject,
     /*  98685 */ // Label 1804: @98685
     /*  98685 */ GIM_Reject,
     /*  98686 */ // Label 15: @98686
     /*  98686 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(98718), // Rule ID 3904 //
     /*  98691 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98698 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  98698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  98701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98703 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  98713 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  98716 */   GIR_RootConstrainSelectedInstOperands,
     /*  98717 */   // GIR_Coverage, 3904,
     /*  98717 */   GIR_EraseRootFromParent_Done,
     /*  98718 */ // Label 1815: @98718
     /*  98718 */ GIM_Reject,
     /*  98719 */ // Label 16: @98719
     /*  98719 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1836*/ GIMT_Encode4(107528),
     /*  98730 */ /*GILLT_s8*//*Label 1816*/ GIMT_Encode4(98826),
     /*  98734 */ /*GILLT_s16*//*Label 1817*/ GIMT_Encode4(99002),
     /*  98738 */ /*GILLT_s32*//*Label 1818*/ GIMT_Encode4(99178),
     /*  98742 */ /*GILLT_s64*//*Label 1819*/ GIMT_Encode4(101476),
     /*  98746 */ /*GILLT_s128*//*Label 1820*/ GIMT_Encode4(104157),
     /*  98750 */ /*GILLT_v2s32*//*Label 1821*/ GIMT_Encode4(104366),
     /*  98754 */ /*GILLT_v2s64*//*Label 1822*/ GIMT_Encode4(104744),
     /*  98758 */ /*GILLT_v4s16*//*Label 1823*/ GIMT_Encode4(105122),
     /*  98762 */ /*GILLT_v4s32*//*Label 1824*/ GIMT_Encode4(105500),
     /*  98766 */ /*GILLT_v8s8*//*Label 1825*/ GIMT_Encode4(105878),
     /*  98770 */ /*GILLT_v8s16*//*Label 1826*/ GIMT_Encode4(106086),
     /*  98774 */ /*GILLT_v16s8*//*Label 1827*/ GIMT_Encode4(106464), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98786 */ /*GILLT_nxv2s16*//*Label 1828*/ GIMT_Encode4(106672),
     /*  98790 */ /*GILLT_nxv2s32*//*Label 1829*/ GIMT_Encode4(106736),
     /*  98794 */ /*GILLT_nxv2s64*//*Label 1830*/ GIMT_Encode4(106800), GIMT_Encode4(0),
     /*  98802 */ /*GILLT_nxv4s16*//*Label 1831*/ GIMT_Encode4(106974),
     /*  98806 */ /*GILLT_nxv4s32*//*Label 1832*/ GIMT_Encode4(107038), GIMT_Encode4(0),
     /*  98814 */ /*GILLT_nxv8s16*//*Label 1833*/ GIMT_Encode4(107212),
     /*  98818 */ /*GILLT_nxv16s1*//*Label 1834*/ GIMT_Encode4(107386),
     /*  98822 */ /*GILLT_nxv16s8*//*Label 1835*/ GIMT_Encode4(107430),
     /*  98826 */ // Label 1816: @98826
     /*  98826 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(99001),
     /*  98831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  98842 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98846 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(98887), // Rule ID 237 //
     /*  98851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98861 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  98861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  98864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98885 */     GIR_RootConstrainSelectedInstOperands,
     /*  98886 */     // GIR_Coverage, 237,
     /*  98886 */     GIR_EraseRootFromParent_Done,
     /*  98887 */   // Label 1838: @98887
     /*  98887 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(98928), // Rule ID 238 //
     /*  98892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98902 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  98902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  98905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98926 */     GIR_RootConstrainSelectedInstOperands,
     /*  98927 */     // GIR_Coverage, 238,
     /*  98927 */     GIR_EraseRootFromParent_Done,
     /*  98928 */   // Label 1839: @98928
     /*  98928 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(98964), // Rule ID 261 //
     /*  98933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  98943 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  98943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  98946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98962 */     GIR_RootConstrainSelectedInstOperands,
     /*  98963 */     // GIR_Coverage, 261,
     /*  98963 */     GIR_EraseRootFromParent_Done,
     /*  98964 */   // Label 1840: @98964
     /*  98964 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(99000), // Rule ID 282 //
     /*  98969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  98979 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  98979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  98982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98998 */     GIR_RootConstrainSelectedInstOperands,
     /*  98999 */     // GIR_Coverage, 282,
     /*  98999 */     GIR_EraseRootFromParent_Done,
     /*  99000 */   // Label 1841: @99000
     /*  99000 */   GIM_Reject,
     /*  99001 */ // Label 1837: @99001
     /*  99001 */ GIM_Reject,
     /*  99002 */ // Label 1817: @99002
     /*  99002 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(99177),
     /*  99007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99010 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  99018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99022 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(99063), // Rule ID 239 //
     /*  99027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99037 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  99040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99061 */     GIR_RootConstrainSelectedInstOperands,
     /*  99062 */     // GIR_Coverage, 239,
     /*  99062 */     GIR_EraseRootFromParent_Done,
     /*  99063 */   // Label 1843: @99063
     /*  99063 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(99104), // Rule ID 240 //
     /*  99068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99078 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  99081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99102 */     GIR_RootConstrainSelectedInstOperands,
     /*  99103 */     // GIR_Coverage, 240,
     /*  99103 */     GIR_EraseRootFromParent_Done,
     /*  99104 */   // Label 1844: @99104
     /*  99104 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(99140), // Rule ID 262 //
     /*  99109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99119 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  99119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  99122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99138 */     GIR_RootConstrainSelectedInstOperands,
     /*  99139 */     // GIR_Coverage, 262,
     /*  99139 */     GIR_EraseRootFromParent_Done,
     /*  99140 */   // Label 1845: @99140
     /*  99140 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(99176), // Rule ID 283 //
     /*  99145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99155 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  99158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99174 */     GIR_RootConstrainSelectedInstOperands,
     /*  99175 */     // GIR_Coverage, 283,
     /*  99175 */     GIR_EraseRootFromParent_Done,
     /*  99176 */   // Label 1846: @99176
     /*  99176 */   GIM_Reject,
     /*  99177 */ // Label 1842: @99177
     /*  99177 */ GIM_Reject,
     /*  99178 */ // Label 1818: @99178
     /*  99178 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(99231), // Rule ID 233 //
     /*  99183 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99186 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99194 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99205 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99229 */   GIR_RootConstrainSelectedInstOperands,
     /*  99230 */   // GIR_Coverage, 233,
     /*  99230 */   GIR_EraseRootFromParent_Done,
     /*  99231 */ // Label 1847: @99231
     /*  99231 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(99284), // Rule ID 234 //
     /*  99236 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99239 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99251 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99258 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99282 */   GIR_RootConstrainSelectedInstOperands,
     /*  99283 */   // GIR_Coverage, 234,
     /*  99283 */   GIR_EraseRootFromParent_Done,
     /*  99284 */ // Label 1848: @99284
     /*  99284 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(99340), // Rule ID 241 //
     /*  99289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99292 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99295 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99303 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99307 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99314 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  99317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99338 */   GIR_RootConstrainSelectedInstOperands,
     /*  99339 */   // GIR_Coverage, 241,
     /*  99339 */   GIR_EraseRootFromParent_Done,
     /*  99340 */ // Label 1849: @99340
     /*  99340 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(99396), // Rule ID 242 //
     /*  99345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99348 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99351 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99359 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99363 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99370 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  99373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99394 */   GIR_RootConstrainSelectedInstOperands,
     /*  99395 */   // GIR_Coverage, 242,
     /*  99395 */   GIR_EraseRootFromParent_Done,
     /*  99396 */ // Label 1850: @99396
     /*  99396 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(99456), // Rule ID 4120 //
     /*  99401 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99404 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99408 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99419 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99423 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99430 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  99430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  99433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99454 */   GIR_RootConstrainSelectedInstOperands,
     /*  99455 */   // GIR_Coverage, 4120,
     /*  99455 */   GIR_EraseRootFromParent_Done,
     /*  99456 */ // Label 1851: @99456
     /*  99456 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(99516), // Rule ID 4121 //
     /*  99461 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99464 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99483 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99490 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  99490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99514 */   GIR_RootConstrainSelectedInstOperands,
     /*  99515 */   // GIR_Coverage, 4121,
     /*  99515 */   GIR_EraseRootFromParent_Done,
     /*  99516 */ // Label 1852: @99516
     /*  99516 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(99576), // Rule ID 4122 //
     /*  99521 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99524 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99528 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99550 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  99553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99574 */   GIR_RootConstrainSelectedInstOperands,
     /*  99575 */   // GIR_Coverage, 4122,
     /*  99575 */   GIR_EraseRootFromParent_Done,
     /*  99576 */ // Label 1853: @99576
     /*  99576 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(99636), // Rule ID 4123 //
     /*  99581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99584 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99588 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99610 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  99613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99630 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99634 */   GIR_RootConstrainSelectedInstOperands,
     /*  99635 */   // GIR_Coverage, 4123,
     /*  99635 */   GIR_EraseRootFromParent_Done,
     /*  99636 */ // Label 1854: @99636
     /*  99636 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(99696), // Rule ID 4124 //
     /*  99641 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99644 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99648 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99659 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99663 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99670 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99690 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99694 */   GIR_RootConstrainSelectedInstOperands,
     /*  99695 */   // GIR_Coverage, 4124,
     /*  99695 */   GIR_EraseRootFromParent_Done,
     /*  99696 */ // Label 1855: @99696
     /*  99696 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(99756), // Rule ID 4125 //
     /*  99701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99704 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99719 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99723 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99730 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99750 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99754 */   GIR_RootConstrainSelectedInstOperands,
     /*  99755 */   // GIR_Coverage, 4125,
     /*  99755 */   GIR_EraseRootFromParent_Done,
     /*  99756 */ // Label 1856: @99756
     /*  99756 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(99804), // Rule ID 260 //
     /*  99761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99783 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99802 */   GIR_RootConstrainSelectedInstOperands,
     /*  99803 */   // GIR_Coverage, 260,
     /*  99803 */   GIR_EraseRootFromParent_Done,
     /*  99804 */ // Label 1857: @99804
     /*  99804 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(99855), // Rule ID 263 //
     /*  99809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99823 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99827 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99834 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  99837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99849 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99853 */   GIR_RootConstrainSelectedInstOperands,
     /*  99854 */   // GIR_Coverage, 263,
     /*  99854 */   GIR_EraseRootFromParent_Done,
     /*  99855 */ // Label 1858: @99855
     /*  99855 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(99914), // Rule ID 7022 //
     /*  99860 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99863 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99870 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99881 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99888 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15840>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /*  99888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  99891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99912 */   GIR_RootConstrainSelectedInstOperands,
     /*  99913 */   // GIR_Coverage, 7022,
     /*  99913 */   GIR_EraseRootFromParent_Done,
     /*  99914 */ // Label 1859: @99914
     /*  99914 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(99973), // Rule ID 7024 //
     /*  99919 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99929 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99947 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15840>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /*  99947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99971 */   GIR_RootConstrainSelectedInstOperands,
     /*  99972 */   // GIR_Coverage, 7024,
     /*  99972 */   GIR_EraseRootFromParent_Done,
     /*  99973 */ // Label 1860: @99973
     /*  99973 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(100032), // Rule ID 7034 //
     /*  99978 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99981 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99988 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99995 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99999 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100006 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15849>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100030 */   GIR_RootConstrainSelectedInstOperands,
     /* 100031 */   // GIR_Coverage, 7034,
     /* 100031 */   GIR_EraseRootFromParent_Done,
     /* 100032 */ // Label 1861: @100032
     /* 100032 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(100091), // Rule ID 7036 //
     /* 100037 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100040 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100047 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100065 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15849>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100089 */   GIR_RootConstrainSelectedInstOperands,
     /* 100090 */   // GIR_Coverage, 7036,
     /* 100090 */   GIR_EraseRootFromParent_Done,
     /* 100091 */ // Label 1862: @100091
     /* 100091 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(100150), // Rule ID 7044 //
     /* 100096 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100099 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100106 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100113 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100124 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100148 */   GIR_RootConstrainSelectedInstOperands,
     /* 100149 */   // GIR_Coverage, 7044,
     /* 100149 */   GIR_EraseRootFromParent_Done,
     /* 100150 */ // Label 1863: @100150
     /* 100150 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(100209), // Rule ID 7045 //
     /* 100155 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100158 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100165 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100176 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100183 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100207 */   GIR_RootConstrainSelectedInstOperands,
     /* 100208 */   // GIR_Coverage, 7045,
     /* 100208 */   GIR_EraseRootFromParent_Done,
     /* 100209 */ // Label 1864: @100209
     /* 100209 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(100257), // Rule ID 281 //
     /* 100214 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100217 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100236 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100251 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100255 */   GIR_RootConstrainSelectedInstOperands,
     /* 100256 */   // GIR_Coverage, 281,
     /* 100256 */   GIR_EraseRootFromParent_Done,
     /* 100257 */ // Label 1865: @100257
     /* 100257 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100308), // Rule ID 284 //
     /* 100262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100265 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100268 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100276 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100280 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100287 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 100290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100306 */   GIR_RootConstrainSelectedInstOperands,
     /* 100307 */   // GIR_Coverage, 284,
     /* 100307 */   GIR_EraseRootFromParent_Done,
     /* 100308 */ // Label 1866: @100308
     /* 100308 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100362), // Rule ID 7026 //
     /* 100313 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100316 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100323 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100330 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100334 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100341 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15840>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100360 */   GIR_RootConstrainSelectedInstOperands,
     /* 100361 */   // GIR_Coverage, 7026,
     /* 100361 */   GIR_EraseRootFromParent_Done,
     /* 100362 */ // Label 1867: @100362
     /* 100362 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(100416), // Rule ID 7028 //
     /* 100367 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100370 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100377 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100384 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100388 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100395 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15840>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100414 */   GIR_RootConstrainSelectedInstOperands,
     /* 100415 */   // GIR_Coverage, 7028,
     /* 100415 */   GIR_EraseRootFromParent_Done,
     /* 100416 */ // Label 1868: @100416
     /* 100416 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100470), // Rule ID 7038 //
     /* 100421 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100424 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100431 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100438 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100442 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 100449 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15849>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 100449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 100452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100468 */   GIR_RootConstrainSelectedInstOperands,
     /* 100469 */   // GIR_Coverage, 7038,
     /* 100469 */   GIR_EraseRootFromParent_Done,
     /* 100470 */ // Label 1869: @100470
     /* 100470 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(100524), // Rule ID 7040 //
     /* 100475 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100478 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100485 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100496 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100503 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15849>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100518 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100522 */   GIR_RootConstrainSelectedInstOperands,
     /* 100523 */   // GIR_Coverage, 7040,
     /* 100523 */   GIR_EraseRootFromParent_Done,
     /* 100524 */ // Label 1870: @100524
     /* 100524 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(100578), // Rule ID 7046 //
     /* 100529 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100532 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100539 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100557 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 100560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100576 */   GIR_RootConstrainSelectedInstOperands,
     /* 100577 */   // GIR_Coverage, 7046,
     /* 100577 */   GIR_EraseRootFromParent_Done,
     /* 100578 */ // Label 1871: @100578
     /* 100578 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(100632), // Rule ID 7047 //
     /* 100583 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100593 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100604 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100611 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15857>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100630 */   GIR_RootConstrainSelectedInstOperands,
     /* 100631 */   // GIR_Coverage, 7047,
     /* 100631 */   GIR_EraseRootFromParent_Done,
     /* 100632 */ // Label 1872: @100632
     /* 100632 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(100689), // Rule ID 7402 //
     /* 100637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100640 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100643 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100650 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100657 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100668 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15838>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 100671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100687 */   GIR_RootConstrainSelectedInstOperands,
     /* 100688 */   // GIR_Coverage, 7402,
     /* 100688 */   GIR_EraseRootFromParent_Done,
     /* 100689 */ // Label 1873: @100689
     /* 100689 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(100746), // Rule ID 7404 //
     /* 100694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100697 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100707 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100725 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15847>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 100728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100744 */   GIR_RootConstrainSelectedInstOperands,
     /* 100745 */   // GIR_Coverage, 7404,
     /* 100745 */   GIR_EraseRootFromParent_Done,
     /* 100746 */ // Label 1874: @100746
     /* 100746 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(100803), // Rule ID 7406 //
     /* 100751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100754 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100764 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100771 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100775 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100782 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15832>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 100785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100801 */   GIR_RootConstrainSelectedInstOperands,
     /* 100802 */   // GIR_Coverage, 7406,
     /* 100802 */   GIR_EraseRootFromParent_Done,
     /* 100803 */ // Label 1875: @100803
     /* 100803 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(100858), // Rule ID 4147 //
     /* 100808 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100811 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 100837 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 100837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 100840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100856 */   GIR_RootConstrainSelectedInstOperands,
     /* 100857 */   // GIR_Coverage, 4147,
     /* 100857 */   GIR_EraseRootFromParent_Done,
     /* 100858 */ // Label 1876: @100858
     /* 100858 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(100913), // Rule ID 4148 //
     /* 100863 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100866 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100870 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100881 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100892 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100911 */   GIR_RootConstrainSelectedInstOperands,
     /* 100912 */   // GIR_Coverage, 4148,
     /* 100912 */   GIR_EraseRootFromParent_Done,
     /* 100913 */ // Label 1877: @100913
     /* 100913 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(100968), // Rule ID 4149 //
     /* 100918 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100921 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100925 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100940 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100947 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100966 */   GIR_RootConstrainSelectedInstOperands,
     /* 100967 */   // GIR_Coverage, 4149,
     /* 100967 */   GIR_EraseRootFromParent_Done,
     /* 100968 */ // Label 1878: @100968
     /* 100968 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(101023), // Rule ID 4170 //
     /* 100973 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100976 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100991 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100995 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101002 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101021 */   GIR_RootConstrainSelectedInstOperands,
     /* 101022 */   // GIR_Coverage, 4170,
     /* 101022 */   GIR_EraseRootFromParent_Done,
     /* 101023 */ // Label 1879: @101023
     /* 101023 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(101078), // Rule ID 4171 //
     /* 101028 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101031 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101035 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101050 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101057 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101072 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101076 */   GIR_RootConstrainSelectedInstOperands,
     /* 101077 */   // GIR_Coverage, 4171,
     /* 101077 */   GIR_EraseRootFromParent_Done,
     /* 101078 */ // Label 1880: @101078
     /* 101078 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101133), // Rule ID 4172 //
     /* 101083 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101086 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101090 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101112 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101131 */   GIR_RootConstrainSelectedInstOperands,
     /* 101132 */   // GIR_Coverage, 4172,
     /* 101132 */   GIR_EraseRootFromParent_Done,
     /* 101133 */ // Label 1881: @101133
     /* 101133 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(101173), // Rule ID 7014 //
     /* 101138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101141 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101144 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101151 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101158 */   // MIs[0] ptr
     /* 101158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101166 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15828>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 101171 */   GIR_RootConstrainSelectedInstOperands,
     /* 101172 */   // GIR_Coverage, 7014,
     /* 101172 */   GIR_Done,
     /* 101173 */ // Label 1882: @101173
     /* 101173 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(101213), // Rule ID 7015 //
     /* 101178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101181 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101184 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101191 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101198 */   // MIs[0] ptr
     /* 101198 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101206 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15830>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 101211 */   GIR_RootConstrainSelectedInstOperands,
     /* 101212 */   // GIR_Coverage, 7015,
     /* 101212 */   GIR_Done,
     /* 101213 */ // Label 1883: @101213
     /* 101213 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(101253), // Rule ID 7016 //
     /* 101218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101231 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101238 */   // MIs[0] ptr
     /* 101238 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101246 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15832>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 101251 */   GIR_RootConstrainSelectedInstOperands,
     /* 101252 */   // GIR_Coverage, 7016,
     /* 101252 */   GIR_Done,
     /* 101253 */ // Label 1884: @101253
     /* 101253 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101290), // Rule ID 7018 //
     /* 101258 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101268 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101275 */   // MIs[0] ptr
     /* 101275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101283 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15836>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 101288 */   GIR_RootConstrainSelectedInstOperands,
     /* 101289 */   // GIR_Coverage, 7018,
     /* 101289 */   GIR_Done,
     /* 101290 */ // Label 1885: @101290
     /* 101290 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(101327), // Rule ID 7020 //
     /* 101295 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101312 */   // MIs[0] ptr
     /* 101312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101320 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15838>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 101325 */   GIR_RootConstrainSelectedInstOperands,
     /* 101326 */   // GIR_Coverage, 7020,
     /* 101326 */   GIR_Done,
     /* 101327 */ // Label 1886: @101327
     /* 101327 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(101364), // Rule ID 7030 //
     /* 101332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101349 */   // MIs[0] ptr
     /* 101349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101357 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15845>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 101362 */   GIR_RootConstrainSelectedInstOperands,
     /* 101363 */   // GIR_Coverage, 7030,
     /* 101363 */   GIR_Done,
     /* 101364 */ // Label 1887: @101364
     /* 101364 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101401), // Rule ID 7032 //
     /* 101369 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101372 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101386 */   // MIs[0] ptr
     /* 101386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101394 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15847>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 101399 */   GIR_RootConstrainSelectedInstOperands,
     /* 101400 */   // GIR_Coverage, 7032,
     /* 101400 */   GIR_Done,
     /* 101401 */ // Label 1888: @101401
     /* 101401 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101438), // Rule ID 7042 //
     /* 101406 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101409 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101423 */   // MIs[0] ptr
     /* 101423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101431 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15854>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101436 */   GIR_RootConstrainSelectedInstOperands,
     /* 101437 */   // GIR_Coverage, 7042,
     /* 101437 */   GIR_Done,
     /* 101438 */ // Label 1889: @101438
     /* 101438 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101475), // Rule ID 7043 //
     /* 101443 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101446 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101453 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101460 */   // MIs[0] ptr
     /* 101460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101468 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15832>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101473 */   GIR_RootConstrainSelectedInstOperands,
     /* 101474 */   // GIR_Coverage, 7043,
     /* 101474 */   GIR_Done,
     /* 101475 */ // Label 1890: @101475
     /* 101475 */ GIM_Reject,
     /* 101476 */ // Label 1819: @101476
     /* 101476 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(101529), // Rule ID 235 //
     /* 101481 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101484 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 101492 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101496 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101503 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 101506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101527 */   GIR_RootConstrainSelectedInstOperands,
     /* 101528 */   // GIR_Coverage, 235,
     /* 101528 */   GIR_EraseRootFromParent_Done,
     /* 101529 */ // Label 1891: @101529
     /* 101529 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(101582), // Rule ID 236 //
     /* 101534 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101537 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 101545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101556 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 101559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101576 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101580 */   GIR_RootConstrainSelectedInstOperands,
     /* 101581 */   // GIR_Coverage, 236,
     /* 101581 */   GIR_EraseRootFromParent_Done,
     /* 101582 */ // Label 1892: @101582
     /* 101582 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(101638), // Rule ID 243 //
     /* 101587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101590 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101601 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101605 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101612 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101617 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101632 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101636 */   GIR_RootConstrainSelectedInstOperands,
     /* 101637 */   // GIR_Coverage, 243,
     /* 101637 */   GIR_EraseRootFromParent_Done,
     /* 101638 */ // Label 1893: @101638
     /* 101638 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(101694), // Rule ID 244 //
     /* 101643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101646 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101657 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101668 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101688 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101692 */   GIR_RootConstrainSelectedInstOperands,
     /* 101693 */   // GIR_Coverage, 244,
     /* 101693 */   GIR_EraseRootFromParent_Done,
     /* 101694 */ // Label 1894: @101694
     /* 101694 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(101747), // Rule ID 4086 //
     /* 101699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101721 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101741 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101745 */   GIR_RootConstrainSelectedInstOperands,
     /* 101746 */   // GIR_Coverage, 4086,
     /* 101746 */   GIR_EraseRootFromParent_Done,
     /* 101747 */ // Label 1895: @101747
     /* 101747 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(101800), // Rule ID 4087 //
     /* 101752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101774 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101798 */   GIR_RootConstrainSelectedInstOperands,
     /* 101799 */   // GIR_Coverage, 4087,
     /* 101799 */   GIR_EraseRootFromParent_Done,
     /* 101800 */ // Label 1896: @101800
     /* 101800 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(101853), // Rule ID 4088 //
     /* 101805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101808 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101816 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101820 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101827 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101851 */   GIR_RootConstrainSelectedInstOperands,
     /* 101852 */   // GIR_Coverage, 4088,
     /* 101852 */   GIR_EraseRootFromParent_Done,
     /* 101853 */ // Label 1897: @101853
     /* 101853 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(101906), // Rule ID 4089 //
     /* 101858 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101869 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101873 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101880 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101904 */   GIR_RootConstrainSelectedInstOperands,
     /* 101905 */   // GIR_Coverage, 4089,
     /* 101905 */   GIR_EraseRootFromParent_Done,
     /* 101906 */ // Label 1898: @101906
     /* 101906 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(101998), // Rule ID 4112 //
     /* 101911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101914 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101929 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101933 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 101940 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 101947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101967 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101992 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101997 */   // GIR_Coverage, 4112,
     /* 101997 */   GIR_EraseRootFromParent_Done,
     /* 101998 */ // Label 1899: @101998
     /* 101998 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(102090), // Rule ID 4113 //
     /* 102003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102006 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102010 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102021 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102025 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102032 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102059 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102089 */   // GIR_Coverage, 4113,
     /* 102089 */   GIR_EraseRootFromParent_Done,
     /* 102090 */ // Label 1900: @102090
     /* 102090 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(102182), // Rule ID 4114 //
     /* 102095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102098 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102102 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102113 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 102124 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 102131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102151 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102176 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102181 */   // GIR_Coverage, 4114,
     /* 102181 */   GIR_EraseRootFromParent_Done,
     /* 102182 */ // Label 1901: @102182
     /* 102182 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102274), // Rule ID 4115 //
     /* 102187 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102190 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 102216 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 102223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102243 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102273 */   // GIR_Coverage, 4115,
     /* 102273 */   GIR_EraseRootFromParent_Done,
     /* 102274 */ // Label 1902: @102274
     /* 102274 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102366), // Rule ID 4116 //
     /* 102279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102282 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 102308 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102308 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102311 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 102315 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102335 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102365 */   // GIR_Coverage, 4116,
     /* 102365 */   GIR_EraseRootFromParent_Done,
     /* 102366 */ // Label 1903: @102366
     /* 102366 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102458), // Rule ID 4117 //
     /* 102371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102374 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102378 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 102400 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 102407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102427 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102457 */   // GIR_Coverage, 4117,
     /* 102457 */   GIR_EraseRootFromParent_Done,
     /* 102458 */ // Label 1904: @102458
     /* 102458 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102550), // Rule ID 4118 //
     /* 102463 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102466 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102481 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102485 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 102492 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 102499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102519 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102544 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102549 */   // GIR_Coverage, 4118,
     /* 102549 */   GIR_EraseRootFromParent_Done,
     /* 102550 */ // Label 1905: @102550
     /* 102550 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102642), // Rule ID 4119 //
     /* 102555 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102558 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102573 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102577 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102584 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102611 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102641 */   // GIR_Coverage, 4119,
     /* 102641 */   GIR_EraseRootFromParent_Done,
     /* 102642 */ // Label 1906: @102642
     /* 102642 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102690), // Rule ID 259 //
     /* 102647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102669 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 102672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102688 */   GIR_RootConstrainSelectedInstOperands,
     /* 102689 */   // GIR_Coverage, 259,
     /* 102689 */   GIR_EraseRootFromParent_Done,
     /* 102690 */ // Label 1907: @102690
     /* 102690 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102741), // Rule ID 264 //
     /* 102695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102698 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102701 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102713 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102720 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102739 */   GIR_RootConstrainSelectedInstOperands,
     /* 102740 */   // GIR_Coverage, 264,
     /* 102740 */   GIR_EraseRootFromParent_Done,
     /* 102741 */ // Label 1908: @102741
     /* 102741 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102800), // Rule ID 7050 //
     /* 102746 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102749 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102756 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102774 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 102777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102798 */   GIR_RootConstrainSelectedInstOperands,
     /* 102799 */   // GIR_Coverage, 7050,
     /* 102799 */   GIR_EraseRootFromParent_Done,
     /* 102800 */ // Label 1909: @102800
     /* 102800 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102859), // Rule ID 7051 //
     /* 102805 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102808 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102815 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102826 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102833 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 102836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102857 */   GIR_RootConstrainSelectedInstOperands,
     /* 102858 */   // GIR_Coverage, 7051,
     /* 102858 */   GIR_EraseRootFromParent_Done,
     /* 102859 */ // Label 1910: @102859
     /* 102859 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102907), // Rule ID 280 //
     /* 102864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102875 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102886 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 102886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 102889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102905 */   GIR_RootConstrainSelectedInstOperands,
     /* 102906 */   // GIR_Coverage, 280,
     /* 102906 */   GIR_EraseRootFromParent_Done,
     /* 102907 */ // Label 1911: @102907
     /* 102907 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102958), // Rule ID 285 //
     /* 102912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102926 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102930 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102937 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 102937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102952 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102956 */   GIR_RootConstrainSelectedInstOperands,
     /* 102957 */   // GIR_Coverage, 285,
     /* 102957 */   GIR_EraseRootFromParent_Done,
     /* 102958 */ // Label 1912: @102958
     /* 102958 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(103012), // Rule ID 7052 //
     /* 102963 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102973 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102980 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102984 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102991 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 102994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103010 */   GIR_RootConstrainSelectedInstOperands,
     /* 103011 */   // GIR_Coverage, 7052,
     /* 103011 */   GIR_EraseRootFromParent_Done,
     /* 103012 */ // Label 1913: @103012
     /* 103012 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(103066), // Rule ID 7053 //
     /* 103017 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103020 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103027 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103038 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103045 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15865>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103060 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103064 */   GIR_RootConstrainSelectedInstOperands,
     /* 103065 */   // GIR_Coverage, 7053,
     /* 103065 */   GIR_EraseRootFromParent_Done,
     /* 103066 */ // Label 1914: @103066
     /* 103066 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(103123), // Rule ID 7407 //
     /* 103071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 103074 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103084 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103095 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103102 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 103105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103117 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103121 */   GIR_RootConstrainSelectedInstOperands,
     /* 103122 */   // GIR_Coverage, 7407,
     /* 103122 */   GIR_EraseRootFromParent_Done,
     /* 103123 */ // Label 1915: @103123
     /* 103123 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(103171), // Rule ID 4133 //
     /* 103128 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103131 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103139 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103143 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103150 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103165 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103169 */   GIR_RootConstrainSelectedInstOperands,
     /* 103170 */   // GIR_Coverage, 4133,
     /* 103170 */   GIR_EraseRootFromParent_Done,
     /* 103171 */ // Label 1916: @103171
     /* 103171 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(103219), // Rule ID 4134 //
     /* 103176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103179 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103187 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103191 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103198 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103217 */   GIR_RootConstrainSelectedInstOperands,
     /* 103218 */   // GIR_Coverage, 4134,
     /* 103218 */   GIR_EraseRootFromParent_Done,
     /* 103219 */ // Label 1917: @103219
     /* 103219 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(103306), // Rule ID 4150 //
     /* 103224 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103227 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103231 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 103253 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 103260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103275 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103305 */   // GIR_Coverage, 4150,
     /* 103305 */   GIR_EraseRootFromParent_Done,
     /* 103306 */ // Label 1918: @103306
     /* 103306 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(103393), // Rule ID 4151 //
     /* 103311 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103314 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103318 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103329 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103333 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 103340 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 103347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103362 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103392 */   // GIR_Coverage, 4151,
     /* 103392 */   GIR_EraseRootFromParent_Done,
     /* 103393 */ // Label 1919: @103393
     /* 103393 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103480), // Rule ID 4152 //
     /* 103398 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103401 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103405 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 103427 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 103434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103449 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103479 */   // GIR_Coverage, 4152,
     /* 103479 */   GIR_EraseRootFromParent_Done,
     /* 103480 */ // Label 1920: @103480
     /* 103480 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103567), // Rule ID 4153 //
     /* 103485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103488 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 103514 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 103521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103536 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103566 */   // GIR_Coverage, 4153,
     /* 103566 */   GIR_EraseRootFromParent_Done,
     /* 103567 */ // Label 1921: @103567
     /* 103567 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103615), // Rule ID 4161 //
     /* 103572 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103575 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103583 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103587 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103594 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103599 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103604 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103613 */   GIR_RootConstrainSelectedInstOperands,
     /* 103614 */   // GIR_Coverage, 4161,
     /* 103614 */   GIR_EraseRootFromParent_Done,
     /* 103615 */ // Label 1922: @103615
     /* 103615 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103663), // Rule ID 4162 //
     /* 103620 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103623 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103631 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103635 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103642 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103657 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103661 */   GIR_RootConstrainSelectedInstOperands,
     /* 103662 */   // GIR_Coverage, 4162,
     /* 103662 */   GIR_EraseRootFromParent_Done,
     /* 103663 */ // Label 1923: @103663
     /* 103663 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(103750), // Rule ID 4173 //
     /* 103668 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103671 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103675 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103686 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103690 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 103697 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 103704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103719 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103739 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103749 */   // GIR_Coverage, 4173,
     /* 103749 */   GIR_EraseRootFromParent_Done,
     /* 103750 */ // Label 1924: @103750
     /* 103750 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(103837), // Rule ID 4174 //
     /* 103755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103758 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103762 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103777 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 103784 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 103791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103806 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103826 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103831 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103836 */   // GIR_Coverage, 4174,
     /* 103836 */   GIR_EraseRootFromParent_Done,
     /* 103837 */ // Label 1925: @103837
     /* 103837 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103924), // Rule ID 4175 //
     /* 103842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103845 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103849 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103864 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 103871 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103871 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103874 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 103878 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103893 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103923 */   // GIR_Coverage, 4175,
     /* 103923 */   GIR_EraseRootFromParent_Done,
     /* 103924 */ // Label 1926: @103924
     /* 103924 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(104011), // Rule ID 4176 //
     /* 103929 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103932 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103936 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 103958 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 103965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103980 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104000 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104010 */   // GIR_Coverage, 4176,
     /* 104010 */   GIR_EraseRootFromParent_Done,
     /* 104011 */ // Label 1927: @104011
     /* 104011 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(104051), // Rule ID 7017 //
     /* 104016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 104019 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104029 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104036 */   // MIs[0] ptr
     /* 104036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104044 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 104049 */   GIR_RootConstrainSelectedInstOperands,
     /* 104050 */   // GIR_Coverage, 7017,
     /* 104050 */   GIR_Done,
     /* 104051 */ // Label 1928: @104051
     /* 104051 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(104088), // Rule ID 7048 //
     /* 104056 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104066 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 104069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104073 */   // MIs[0] ptr
     /* 104073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104081 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15862>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104086 */   GIR_RootConstrainSelectedInstOperands,
     /* 104087 */   // GIR_Coverage, 7048,
     /* 104087 */   GIR_Done,
     /* 104088 */ // Label 1929: @104088
     /* 104088 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(104125), // Rule ID 7049 //
     /* 104093 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104103 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104110 */   // MIs[0] ptr
     /* 104110 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104118 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104123 */   GIR_RootConstrainSelectedInstOperands,
     /* 104124 */   // GIR_Coverage, 7049,
     /* 104124 */   GIR_Done,
     /* 104125 */ // Label 1930: @104125
     /* 104125 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(104156), // Rule ID 6397 //
     /* 104130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104133 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104141 */   // MIs[0] Rn
     /* 104141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104149 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 104154 */   GIR_RootConstrainSelectedInstOperands,
     /* 104155 */   // GIR_Coverage, 6397,
     /* 104155 */   GIR_Done,
     /* 104156 */ // Label 1931: @104156
     /* 104156 */ GIM_Reject,
     /* 104157 */ // Label 1820: @104157
     /* 104157 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(104365),
     /* 104162 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104165 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104177 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(104218), // Rule ID 245 //
     /* 104182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104192 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104216 */     GIR_RootConstrainSelectedInstOperands,
     /* 104217 */     // GIR_Coverage, 245,
     /* 104217 */     GIR_EraseRootFromParent_Done,
     /* 104218 */   // Label 1933: @104218
     /* 104218 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104259), // Rule ID 246 //
     /* 104223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104233 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104257 */     GIR_RootConstrainSelectedInstOperands,
     /* 104258 */     // GIR_Coverage, 246,
     /* 104258 */     GIR_EraseRootFromParent_Done,
     /* 104259 */   // Label 1934: @104259
     /* 104259 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(104295), // Rule ID 265 //
     /* 104264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104274 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104293 */     GIR_RootConstrainSelectedInstOperands,
     /* 104294 */     // GIR_Coverage, 265,
     /* 104294 */     GIR_EraseRootFromParent_Done,
     /* 104295 */   // Label 1935: @104295
     /* 104295 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(104331), // Rule ID 286 //
     /* 104300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 104310 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 104313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104329 */     GIR_RootConstrainSelectedInstOperands,
     /* 104330 */     // GIR_Coverage, 286,
     /* 104330 */     GIR_EraseRootFromParent_Done,
     /* 104331 */   // Label 1936: @104331
     /* 104331 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(104364), // Rule ID 4142 //
     /* 104336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104343 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104362 */     GIR_RootConstrainSelectedInstOperands,
     /* 104363 */     // GIR_Coverage, 4142,
     /* 104363 */     GIR_EraseRootFromParent_Done,
     /* 104364 */   // Label 1937: @104364
     /* 104364 */   GIM_Reject,
     /* 104365 */ // Label 1932: @104365
     /* 104365 */ GIM_Reject,
     /* 104366 */ // Label 1821: @104366
     /* 104366 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104743),
     /* 104371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104382 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(104427), // Rule ID 4076 //
     /* 104387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104401 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104425 */     GIR_RootConstrainSelectedInstOperands,
     /* 104426 */     // GIR_Coverage, 4076,
     /* 104426 */     GIR_EraseRootFromParent_Done,
     /* 104427 */   // Label 1939: @104427
     /* 104427 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(104472), // Rule ID 4077 //
     /* 104432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104446 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104470 */     GIR_RootConstrainSelectedInstOperands,
     /* 104471 */     // GIR_Coverage, 4077,
     /* 104471 */     GIR_EraseRootFromParent_Done,
     /* 104472 */   // Label 1940: @104472
     /* 104472 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(104517), // Rule ID 4078 //
     /* 104477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104491 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104515 */     GIR_RootConstrainSelectedInstOperands,
     /* 104516 */     // GIR_Coverage, 4078,
     /* 104516 */     GIR_EraseRootFromParent_Done,
     /* 104517 */   // Label 1941: @104517
     /* 104517 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(104562), // Rule ID 4079 //
     /* 104522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104536 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104560 */     GIR_RootConstrainSelectedInstOperands,
     /* 104561 */     // GIR_Coverage, 4079,
     /* 104561 */     GIR_EraseRootFromParent_Done,
     /* 104562 */   // Label 1942: @104562
     /* 104562 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(104602), // Rule ID 4128 //
     /* 104567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104581 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 104584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104600 */     GIR_RootConstrainSelectedInstOperands,
     /* 104601 */     // GIR_Coverage, 4128,
     /* 104601 */     GIR_EraseRootFromParent_Done,
     /* 104602 */   // Label 1943: @104602
     /* 104602 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104642), // Rule ID 4131 //
     /* 104607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104621 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 104624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104640 */     GIR_RootConstrainSelectedInstOperands,
     /* 104641 */     // GIR_Coverage, 4131,
     /* 104641 */     GIR_EraseRootFromParent_Done,
     /* 104642 */   // Label 1944: @104642
     /* 104642 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104682), // Rule ID 4156 //
     /* 104647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104661 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104680 */     GIR_RootConstrainSelectedInstOperands,
     /* 104681 */     // GIR_Coverage, 4156,
     /* 104681 */     GIR_EraseRootFromParent_Done,
     /* 104682 */   // Label 1945: @104682
     /* 104682 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(104722), // Rule ID 4157 //
     /* 104687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104701 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104720 */     GIR_RootConstrainSelectedInstOperands,
     /* 104721 */     // GIR_Coverage, 4157,
     /* 104721 */     GIR_EraseRootFromParent_Done,
     /* 104722 */   // Label 1946: @104722
     /* 104722 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(104742), // Rule ID 6396 //
     /* 104727 */     // MIs[0] Rn
     /* 104727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104735 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 104740 */     GIR_RootConstrainSelectedInstOperands,
     /* 104741 */     // GIR_Coverage, 6396,
     /* 104741 */     GIR_Done,
     /* 104742 */   // Label 1947: @104742
     /* 104742 */   GIM_Reject,
     /* 104743 */ // Label 1938: @104743
     /* 104743 */ GIM_Reject,
     /* 104744 */ // Label 1822: @104744
     /* 104744 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(105121),
     /* 104749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104760 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104805), // Rule ID 4090 //
     /* 104765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104779 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104803 */     GIR_RootConstrainSelectedInstOperands,
     /* 104804 */     // GIR_Coverage, 4090,
     /* 104804 */     GIR_EraseRootFromParent_Done,
     /* 104805 */   // Label 1949: @104805
     /* 104805 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104850), // Rule ID 4091 //
     /* 104810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104824 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104848 */     GIR_RootConstrainSelectedInstOperands,
     /* 104849 */     // GIR_Coverage, 4091,
     /* 104849 */     GIR_EraseRootFromParent_Done,
     /* 104850 */   // Label 1950: @104850
     /* 104850 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104895), // Rule ID 4092 //
     /* 104855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104869 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104893 */     GIR_RootConstrainSelectedInstOperands,
     /* 104894 */     // GIR_Coverage, 4092,
     /* 104894 */     GIR_EraseRootFromParent_Done,
     /* 104895 */   // Label 1951: @104895
     /* 104895 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(104940), // Rule ID 4093 //
     /* 104900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104914 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104938 */     GIR_RootConstrainSelectedInstOperands,
     /* 104939 */     // GIR_Coverage, 4093,
     /* 104939 */     GIR_EraseRootFromParent_Done,
     /* 104940 */   // Label 1952: @104940
     /* 104940 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(104980), // Rule ID 4136 //
     /* 104945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104959 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104978 */     GIR_RootConstrainSelectedInstOperands,
     /* 104979 */     // GIR_Coverage, 4136,
     /* 104979 */     GIR_EraseRootFromParent_Done,
     /* 104980 */   // Label 1953: @104980
     /* 104980 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(105020), // Rule ID 4140 //
     /* 104985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104999 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105018 */     GIR_RootConstrainSelectedInstOperands,
     /* 105019 */     // GIR_Coverage, 4140,
     /* 105019 */     GIR_EraseRootFromParent_Done,
     /* 105020 */   // Label 1954: @105020
     /* 105020 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(105060), // Rule ID 4163 //
     /* 105025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105039 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105058 */     GIR_RootConstrainSelectedInstOperands,
     /* 105059 */     // GIR_Coverage, 4163,
     /* 105059 */     GIR_EraseRootFromParent_Done,
     /* 105060 */   // Label 1955: @105060
     /* 105060 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(105100), // Rule ID 4164 //
     /* 105065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105079 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105098 */     GIR_RootConstrainSelectedInstOperands,
     /* 105099 */     // GIR_Coverage, 4164,
     /* 105099 */     GIR_EraseRootFromParent_Done,
     /* 105100 */   // Label 1956: @105100
     /* 105100 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(105120), // Rule ID 6393 //
     /* 105105 */     // MIs[0] Rn
     /* 105105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105113 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 105118 */     GIR_RootConstrainSelectedInstOperands,
     /* 105119 */     // GIR_Coverage, 6393,
     /* 105119 */     GIR_Done,
     /* 105120 */   // Label 1957: @105120
     /* 105120 */   GIM_Reject,
     /* 105121 */ // Label 1948: @105121
     /* 105121 */ GIM_Reject,
     /* 105122 */ // Label 1823: @105122
     /* 105122 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(105499),
     /* 105127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105130 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105138 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(105183), // Rule ID 4082 //
     /* 105143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105157 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105181 */     GIR_RootConstrainSelectedInstOperands,
     /* 105182 */     // GIR_Coverage, 4082,
     /* 105182 */     GIR_EraseRootFromParent_Done,
     /* 105183 */   // Label 1959: @105183
     /* 105183 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(105228), // Rule ID 4083 //
     /* 105188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105202 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105226 */     GIR_RootConstrainSelectedInstOperands,
     /* 105227 */     // GIR_Coverage, 4083,
     /* 105227 */     GIR_EraseRootFromParent_Done,
     /* 105228 */   // Label 1960: @105228
     /* 105228 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(105273), // Rule ID 4084 //
     /* 105233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105247 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105271 */     GIR_RootConstrainSelectedInstOperands,
     /* 105272 */     // GIR_Coverage, 4084,
     /* 105272 */     GIR_EraseRootFromParent_Done,
     /* 105273 */   // Label 1961: @105273
     /* 105273 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(105318), // Rule ID 4085 //
     /* 105278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105292 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105316 */     GIR_RootConstrainSelectedInstOperands,
     /* 105317 */     // GIR_Coverage, 4085,
     /* 105317 */     GIR_EraseRootFromParent_Done,
     /* 105318 */   // Label 1962: @105318
     /* 105318 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(105358), // Rule ID 4130 //
     /* 105323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105337 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105356 */     GIR_RootConstrainSelectedInstOperands,
     /* 105357 */     // GIR_Coverage, 4130,
     /* 105357 */     GIR_EraseRootFromParent_Done,
     /* 105358 */   // Label 1963: @105358
     /* 105358 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(105398), // Rule ID 4132 //
     /* 105363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105377 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105396 */     GIR_RootConstrainSelectedInstOperands,
     /* 105397 */     // GIR_Coverage, 4132,
     /* 105397 */     GIR_EraseRootFromParent_Done,
     /* 105398 */   // Label 1964: @105398
     /* 105398 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(105438), // Rule ID 4158 //
     /* 105403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105417 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105436 */     GIR_RootConstrainSelectedInstOperands,
     /* 105437 */     // GIR_Coverage, 4158,
     /* 105437 */     GIR_EraseRootFromParent_Done,
     /* 105438 */   // Label 1965: @105438
     /* 105438 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(105478), // Rule ID 4160 //
     /* 105443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105457 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105476 */     GIR_RootConstrainSelectedInstOperands,
     /* 105477 */     // GIR_Coverage, 4160,
     /* 105477 */     GIR_EraseRootFromParent_Done,
     /* 105478 */   // Label 1966: @105478
     /* 105478 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(105498), // Rule ID 6395 //
     /* 105483 */     // MIs[0] Rn
     /* 105483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105491 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 105496 */     GIR_RootConstrainSelectedInstOperands,
     /* 105497 */     // GIR_Coverage, 6395,
     /* 105497 */     GIR_Done,
     /* 105498 */   // Label 1967: @105498
     /* 105498 */   GIM_Reject,
     /* 105499 */ // Label 1958: @105499
     /* 105499 */ GIM_Reject,
     /* 105500 */ // Label 1824: @105500
     /* 105500 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(105877),
     /* 105505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105516 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(105561), // Rule ID 4094 //
     /* 105521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105535 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105559 */     GIR_RootConstrainSelectedInstOperands,
     /* 105560 */     // GIR_Coverage, 4094,
     /* 105560 */     GIR_EraseRootFromParent_Done,
     /* 105561 */   // Label 1969: @105561
     /* 105561 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(105606), // Rule ID 4095 //
     /* 105566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105580 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105604 */     GIR_RootConstrainSelectedInstOperands,
     /* 105605 */     // GIR_Coverage, 4095,
     /* 105605 */     GIR_EraseRootFromParent_Done,
     /* 105606 */   // Label 1970: @105606
     /* 105606 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(105651), // Rule ID 4096 //
     /* 105611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105625 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105649 */     GIR_RootConstrainSelectedInstOperands,
     /* 105650 */     // GIR_Coverage, 4096,
     /* 105650 */     GIR_EraseRootFromParent_Done,
     /* 105651 */   // Label 1971: @105651
     /* 105651 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(105696), // Rule ID 4097 //
     /* 105656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105670 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105694 */     GIR_RootConstrainSelectedInstOperands,
     /* 105695 */     // GIR_Coverage, 4097,
     /* 105695 */     GIR_EraseRootFromParent_Done,
     /* 105696 */   // Label 1972: @105696
     /* 105696 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(105736), // Rule ID 4135 //
     /* 105701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105715 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105734 */     GIR_RootConstrainSelectedInstOperands,
     /* 105735 */     // GIR_Coverage, 4135,
     /* 105735 */     GIR_EraseRootFromParent_Done,
     /* 105736 */   // Label 1973: @105736
     /* 105736 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(105776), // Rule ID 4139 //
     /* 105741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105755 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105774 */     GIR_RootConstrainSelectedInstOperands,
     /* 105775 */     // GIR_Coverage, 4139,
     /* 105775 */     GIR_EraseRootFromParent_Done,
     /* 105776 */   // Label 1974: @105776
     /* 105776 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(105816), // Rule ID 4165 //
     /* 105781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105795 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105814 */     GIR_RootConstrainSelectedInstOperands,
     /* 105815 */     // GIR_Coverage, 4165,
     /* 105815 */     GIR_EraseRootFromParent_Done,
     /* 105816 */   // Label 1975: @105816
     /* 105816 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(105856), // Rule ID 4166 //
     /* 105821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105835 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105854 */     GIR_RootConstrainSelectedInstOperands,
     /* 105855 */     // GIR_Coverage, 4166,
     /* 105855 */     GIR_EraseRootFromParent_Done,
     /* 105856 */   // Label 1976: @105856
     /* 105856 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(105876), // Rule ID 6392 //
     /* 105861 */     // MIs[0] Rn
     /* 105861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105869 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 105874 */     GIR_RootConstrainSelectedInstOperands,
     /* 105875 */     // GIR_Coverage, 6392,
     /* 105875 */     GIR_Done,
     /* 105876 */   // Label 1977: @105876
     /* 105876 */   GIM_Reject,
     /* 105877 */ // Label 1968: @105877
     /* 105877 */ GIM_Reject,
     /* 105878 */ // Label 1825: @105878
     /* 105878 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(106085),
     /* 105883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105894 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(105939), // Rule ID 4080 //
     /* 105899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105913 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105937 */     GIR_RootConstrainSelectedInstOperands,
     /* 105938 */     // GIR_Coverage, 4080,
     /* 105938 */     GIR_EraseRootFromParent_Done,
     /* 105939 */   // Label 1979: @105939
     /* 105939 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(105984), // Rule ID 4081 //
     /* 105944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105958 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105982 */     GIR_RootConstrainSelectedInstOperands,
     /* 105983 */     // GIR_Coverage, 4081,
     /* 105983 */     GIR_EraseRootFromParent_Done,
     /* 105984 */   // Label 1980: @105984
     /* 105984 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(106024), // Rule ID 4129 //
     /* 105989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106003 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106022 */     GIR_RootConstrainSelectedInstOperands,
     /* 106023 */     // GIR_Coverage, 4129,
     /* 106023 */     GIR_EraseRootFromParent_Done,
     /* 106024 */   // Label 1981: @106024
     /* 106024 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(106064), // Rule ID 4159 //
     /* 106029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106043 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106062 */     GIR_RootConstrainSelectedInstOperands,
     /* 106063 */     // GIR_Coverage, 4159,
     /* 106063 */     GIR_EraseRootFromParent_Done,
     /* 106064 */   // Label 1982: @106064
     /* 106064 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(106084), // Rule ID 6394 //
     /* 106069 */     // MIs[0] Rn
     /* 106069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106077 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 106082 */     GIR_RootConstrainSelectedInstOperands,
     /* 106083 */     // GIR_Coverage, 6394,
     /* 106083 */     GIR_Done,
     /* 106084 */   // Label 1983: @106084
     /* 106084 */   GIM_Reject,
     /* 106085 */ // Label 1978: @106085
     /* 106085 */ GIM_Reject,
     /* 106086 */ // Label 1826: @106086
     /* 106086 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(106463),
     /* 106091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106102 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(106147), // Rule ID 4098 //
     /* 106107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106121 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106145 */     GIR_RootConstrainSelectedInstOperands,
     /* 106146 */     // GIR_Coverage, 4098,
     /* 106146 */     GIR_EraseRootFromParent_Done,
     /* 106147 */   // Label 1985: @106147
     /* 106147 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(106192), // Rule ID 4099 //
     /* 106152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106166 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106190 */     GIR_RootConstrainSelectedInstOperands,
     /* 106191 */     // GIR_Coverage, 4099,
     /* 106191 */     GIR_EraseRootFromParent_Done,
     /* 106192 */   // Label 1986: @106192
     /* 106192 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(106237), // Rule ID 4100 //
     /* 106197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106211 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106235 */     GIR_RootConstrainSelectedInstOperands,
     /* 106236 */     // GIR_Coverage, 4100,
     /* 106236 */     GIR_EraseRootFromParent_Done,
     /* 106237 */   // Label 1987: @106237
     /* 106237 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(106282), // Rule ID 4101 //
     /* 106242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106256 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106280 */     GIR_RootConstrainSelectedInstOperands,
     /* 106281 */     // GIR_Coverage, 4101,
     /* 106281 */     GIR_EraseRootFromParent_Done,
     /* 106282 */   // Label 1988: @106282
     /* 106282 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(106322), // Rule ID 4138 //
     /* 106287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106301 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106320 */     GIR_RootConstrainSelectedInstOperands,
     /* 106321 */     // GIR_Coverage, 4138,
     /* 106321 */     GIR_EraseRootFromParent_Done,
     /* 106322 */   // Label 1989: @106322
     /* 106322 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(106362), // Rule ID 4141 //
     /* 106327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106341 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106360 */     GIR_RootConstrainSelectedInstOperands,
     /* 106361 */     // GIR_Coverage, 4141,
     /* 106361 */     GIR_EraseRootFromParent_Done,
     /* 106362 */   // Label 1990: @106362
     /* 106362 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(106402), // Rule ID 4167 //
     /* 106367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106381 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106400 */     GIR_RootConstrainSelectedInstOperands,
     /* 106401 */     // GIR_Coverage, 4167,
     /* 106401 */     GIR_EraseRootFromParent_Done,
     /* 106402 */   // Label 1991: @106402
     /* 106402 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(106442), // Rule ID 4169 //
     /* 106407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106421 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106440 */     GIR_RootConstrainSelectedInstOperands,
     /* 106441 */     // GIR_Coverage, 4169,
     /* 106441 */     GIR_EraseRootFromParent_Done,
     /* 106442 */   // Label 1992: @106442
     /* 106442 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(106462), // Rule ID 6391 //
     /* 106447 */     // MIs[0] Rn
     /* 106447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106455 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 106460 */     GIR_RootConstrainSelectedInstOperands,
     /* 106461 */     // GIR_Coverage, 6391,
     /* 106461 */     GIR_Done,
     /* 106462 */   // Label 1993: @106462
     /* 106462 */   GIM_Reject,
     /* 106463 */ // Label 1984: @106463
     /* 106463 */ GIM_Reject,
     /* 106464 */ // Label 1827: @106464
     /* 106464 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(106671),
     /* 106469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106480 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(106525), // Rule ID 4102 //
     /* 106485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106499 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106523 */     GIR_RootConstrainSelectedInstOperands,
     /* 106524 */     // GIR_Coverage, 4102,
     /* 106524 */     GIR_EraseRootFromParent_Done,
     /* 106525 */   // Label 1995: @106525
     /* 106525 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(106570), // Rule ID 4103 //
     /* 106530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106544 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106568 */     GIR_RootConstrainSelectedInstOperands,
     /* 106569 */     // GIR_Coverage, 4103,
     /* 106569 */     GIR_EraseRootFromParent_Done,
     /* 106570 */   // Label 1996: @106570
     /* 106570 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(106610), // Rule ID 4137 //
     /* 106575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106589 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106608 */     GIR_RootConstrainSelectedInstOperands,
     /* 106609 */     // GIR_Coverage, 4137,
     /* 106609 */     GIR_EraseRootFromParent_Done,
     /* 106610 */   // Label 1997: @106610
     /* 106610 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(106650), // Rule ID 4168 //
     /* 106615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106629 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106648 */     GIR_RootConstrainSelectedInstOperands,
     /* 106649 */     // GIR_Coverage, 4168,
     /* 106649 */     GIR_EraseRootFromParent_Done,
     /* 106650 */   // Label 1998: @106650
     /* 106650 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(106670), // Rule ID 6390 //
     /* 106655 */     // MIs[0] Rn
     /* 106655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106663 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 106668 */     GIR_RootConstrainSelectedInstOperands,
     /* 106669 */     // GIR_Coverage, 6390,
     /* 106669 */     GIR_Done,
     /* 106670 */   // Label 1999: @106670
     /* 106670 */   GIM_Reject,
     /* 106671 */ // Label 1994: @106671
     /* 106671 */ GIM_Reject,
     /* 106672 */ // Label 1828: @106672
     /* 106672 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(106735), // Rule ID 10932 //
     /* 106677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106680 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106683 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106691 */   // MIs[0] base
     /* 106691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106699 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106711 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 106719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106724 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106733 */   GIR_RootConstrainSelectedInstOperands,
     /* 106734 */   // GIR_Coverage, 10932,
     /* 106734 */   GIR_EraseRootFromParent_Done,
     /* 106735 */ // Label 2000: @106735
     /* 106735 */ GIM_Reject,
     /* 106736 */ // Label 1829: @106736
     /* 106736 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(106799), // Rule ID 10938 //
     /* 106741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106744 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106747 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106755 */   // MIs[0] base
     /* 106755 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106763 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106775 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 106783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106788 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106793 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106797 */   GIR_RootConstrainSelectedInstOperands,
     /* 106798 */   // GIR_Coverage, 10938,
     /* 106798 */   GIR_EraseRootFromParent_Done,
     /* 106799 */ // Label 2001: @106799
     /* 106799 */ GIM_Reject,
     /* 106800 */ // Label 1830: @106800
     /* 106800 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(106973),
     /* 106805 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106808 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106816 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106820 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(106868), // Rule ID 10923 //
     /* 106825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106832 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106844 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 106852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106857 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106866 */     GIR_RootConstrainSelectedInstOperands,
     /* 106867 */     // GIR_Coverage, 10923,
     /* 106867 */     GIR_EraseRootFromParent_Done,
     /* 106868 */   // Label 2003: @106868
     /* 106868 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(106916), // Rule ID 10941 //
     /* 106873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106880 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 106900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106905 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106914 */     GIR_RootConstrainSelectedInstOperands,
     /* 106915 */     // GIR_Coverage, 10941,
     /* 106915 */     GIR_EraseRootFromParent_Done,
     /* 106916 */   // Label 2004: @106916
     /* 106916 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(106944), // Rule ID 10968 //
     /* 106921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106928 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106933 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106942 */     GIR_RootConstrainSelectedInstOperands,
     /* 106943 */     // GIR_Coverage, 10968,
     /* 106943 */     GIR_EraseRootFromParent_Done,
     /* 106944 */   // Label 2005: @106944
     /* 106944 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(106972), // Rule ID 10980 //
     /* 106949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106956 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106961 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106970 */     GIR_RootConstrainSelectedInstOperands,
     /* 106971 */     // GIR_Coverage, 10980,
     /* 106971 */     GIR_EraseRootFromParent_Done,
     /* 106972 */   // Label 2006: @106972
     /* 106972 */   GIM_Reject,
     /* 106973 */ // Label 2002: @106973
     /* 106973 */ GIM_Reject,
     /* 106974 */ // Label 1831: @106974
     /* 106974 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(107037), // Rule ID 10929 //
     /* 106979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106993 */   // MIs[0] base
     /* 106993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107001 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107013 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 107021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107026 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107035 */   GIR_RootConstrainSelectedInstOperands,
     /* 107036 */   // GIR_Coverage, 10929,
     /* 107036 */   GIR_EraseRootFromParent_Done,
     /* 107037 */ // Label 2007: @107037
     /* 107037 */ GIM_Reject,
     /* 107038 */ // Label 1832: @107038
     /* 107038 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(107211),
     /* 107043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107046 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107058 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(107106), // Rule ID 10911 //
     /* 107063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107070 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107082 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107095 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107104 */     GIR_RootConstrainSelectedInstOperands,
     /* 107105 */     // GIR_Coverage, 10911,
     /* 107105 */     GIR_EraseRootFromParent_Done,
     /* 107106 */   // Label 2009: @107106
     /* 107106 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(107154), // Rule ID 10935 //
     /* 107111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107118 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107143 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107152 */     GIR_RootConstrainSelectedInstOperands,
     /* 107153 */     // GIR_Coverage, 10935,
     /* 107153 */     GIR_EraseRootFromParent_Done,
     /* 107154 */   // Label 2010: @107154
     /* 107154 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(107182), // Rule ID 10964 //
     /* 107159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107166 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107171 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107180 */     GIR_RootConstrainSelectedInstOperands,
     /* 107181 */     // GIR_Coverage, 10964,
     /* 107181 */     GIR_EraseRootFromParent_Done,
     /* 107182 */   // Label 2011: @107182
     /* 107182 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(107210), // Rule ID 10976 //
     /* 107187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107194 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107199 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107208 */     GIR_RootConstrainSelectedInstOperands,
     /* 107209 */     // GIR_Coverage, 10976,
     /* 107209 */     GIR_EraseRootFromParent_Done,
     /* 107210 */   // Label 2012: @107210
     /* 107210 */   GIM_Reject,
     /* 107211 */ // Label 2008: @107211
     /* 107211 */ GIM_Reject,
     /* 107212 */ // Label 1833: @107212
     /* 107212 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107385),
     /* 107217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107220 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107228 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107232 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107280), // Rule ID 10890 //
     /* 107237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107244 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 107251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 107264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107269 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107278 */     GIR_RootConstrainSelectedInstOperands,
     /* 107279 */     // GIR_Coverage, 10890,
     /* 107279 */     GIR_EraseRootFromParent_Done,
     /* 107280 */   // Label 2014: @107280
     /* 107280 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107328), // Rule ID 10926 //
     /* 107285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107292 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 107299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 107312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107317 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107326 */     GIR_RootConstrainSelectedInstOperands,
     /* 107327 */     // GIR_Coverage, 10926,
     /* 107327 */     GIR_EraseRootFromParent_Done,
     /* 107328 */   // Label 2015: @107328
     /* 107328 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107356), // Rule ID 10960 //
     /* 107333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107340 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107345 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107354 */     GIR_RootConstrainSelectedInstOperands,
     /* 107355 */     // GIR_Coverage, 10960,
     /* 107355 */     GIR_EraseRootFromParent_Done,
     /* 107356 */   // Label 2016: @107356
     /* 107356 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107384), // Rule ID 10972 //
     /* 107361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107368 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107373 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107382 */     GIR_RootConstrainSelectedInstOperands,
     /* 107383 */     // GIR_Coverage, 10972,
     /* 107383 */     GIR_EraseRootFromParent_Done,
     /* 107384 */   // Label 2017: @107384
     /* 107384 */   GIM_Reject,
     /* 107385 */ // Label 2013: @107385
     /* 107385 */ GIM_Reject,
     /* 107386 */ // Label 1834: @107386
     /* 107386 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107429), // Rule ID 2428 //
     /* 107391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107397 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 107405 */   // MIs[0] base
     /* 107405 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107413 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 107416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 107418 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107427 */   GIR_RootConstrainSelectedInstOperands,
     /* 107428 */   // GIR_Coverage, 2428,
     /* 107428 */   GIR_EraseRootFromParent_Done,
     /* 107429 */ // Label 2018: @107429
     /* 107429 */ GIM_Reject,
     /* 107430 */ // Label 1835: @107430
     /* 107430 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(107527),
     /* 107435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107450 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107498), // Rule ID 10858 //
     /* 107455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107462 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 107469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107474 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 107482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107487 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107496 */     GIR_RootConstrainSelectedInstOperands,
     /* 107497 */     // GIR_Coverage, 10858,
     /* 107497 */     GIR_EraseRootFromParent_Done,
     /* 107498 */   // Label 2020: @107498
     /* 107498 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107526), // Rule ID 10956 //
     /* 107503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107510 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107515 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107524 */     GIR_RootConstrainSelectedInstOperands,
     /* 107525 */     // GIR_Coverage, 10956,
     /* 107525 */     GIR_EraseRootFromParent_Done,
     /* 107526 */   // Label 2021: @107526
     /* 107526 */   GIM_Reject,
     /* 107527 */ // Label 2019: @107527
     /* 107527 */ GIM_Reject,
     /* 107528 */ // Label 1836: @107528
     /* 107528 */ GIM_Reject,
     /* 107529 */ // Label 17: @107529
     /* 107529 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2024*/ GIMT_Encode4(108578),
     /* 107540 */ /*GILLT_s32*//*Label 2022*/ GIMT_Encode4(107548),
     /* 107544 */ /*GILLT_s64*//*Label 2023*/ GIMT_Encode4(107962),
     /* 107548 */ // Label 2022: @107548
     /* 107548 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107961),
     /* 107553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107556 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107609), // Rule ID 247 //
     /* 107561 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 107583 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 107583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 107586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107607 */     GIR_RootConstrainSelectedInstOperands,
     /* 107608 */     // GIR_Coverage, 247,
     /* 107608 */     GIR_EraseRootFromParent_Done,
     /* 107609 */   // Label 2026: @107609
     /* 107609 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107662), // Rule ID 248 //
     /* 107614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 107636 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 107636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 107639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107660 */     GIR_RootConstrainSelectedInstOperands,
     /* 107661 */     // GIR_Coverage, 248,
     /* 107661 */     GIR_EraseRootFromParent_Done,
     /* 107662 */   // Label 2027: @107662
     /* 107662 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107715), // Rule ID 251 //
     /* 107667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 107689 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 107689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 107692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107713 */     GIR_RootConstrainSelectedInstOperands,
     /* 107714 */     // GIR_Coverage, 251,
     /* 107714 */     GIR_EraseRootFromParent_Done,
     /* 107715 */   // Label 2028: @107715
     /* 107715 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(107768), // Rule ID 252 //
     /* 107720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 107742 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 107742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 107745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107766 */     GIR_RootConstrainSelectedInstOperands,
     /* 107767 */     // GIR_Coverage, 252,
     /* 107767 */     GIR_EraseRootFromParent_Done,
     /* 107768 */   // Label 2029: @107768
     /* 107768 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107816), // Rule ID 268 //
     /* 107773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107795 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 107795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 107798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107814 */     GIR_RootConstrainSelectedInstOperands,
     /* 107815 */     // GIR_Coverage, 268,
     /* 107815 */     GIR_EraseRootFromParent_Done,
     /* 107816 */   // Label 2030: @107816
     /* 107816 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107864), // Rule ID 270 //
     /* 107821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107843 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 107843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 107846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107862 */     GIR_RootConstrainSelectedInstOperands,
     /* 107863 */     // GIR_Coverage, 270,
     /* 107863 */     GIR_EraseRootFromParent_Done,
     /* 107864 */   // Label 2031: @107864
     /* 107864 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107912), // Rule ID 289 //
     /* 107869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107880 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107891 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 107894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107910 */     GIR_RootConstrainSelectedInstOperands,
     /* 107911 */     // GIR_Coverage, 289,
     /* 107911 */     GIR_EraseRootFromParent_Done,
     /* 107912 */   // Label 2032: @107912
     /* 107912 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107960), // Rule ID 291 //
     /* 107917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107939 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 107942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107958 */     GIR_RootConstrainSelectedInstOperands,
     /* 107959 */     // GIR_Coverage, 291,
     /* 107959 */     GIR_EraseRootFromParent_Done,
     /* 107960 */   // Label 2033: @107960
     /* 107960 */   GIM_Reject,
     /* 107961 */ // Label 2025: @107961
     /* 107961 */ GIM_Reject,
     /* 107962 */ // Label 2023: @107962
     /* 107962 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108577),
     /* 107967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107970 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(108023), // Rule ID 249 //
     /* 107975 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 107997 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 107997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 108000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108021 */     GIR_RootConstrainSelectedInstOperands,
     /* 108022 */     // GIR_Coverage, 249,
     /* 108022 */     GIR_EraseRootFromParent_Done,
     /* 108023 */   // Label 2035: @108023
     /* 108023 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(108076), // Rule ID 250 //
     /* 108028 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108050 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 108053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108074 */     GIR_RootConstrainSelectedInstOperands,
     /* 108075 */     // GIR_Coverage, 250,
     /* 108075 */     GIR_EraseRootFromParent_Done,
     /* 108076 */   // Label 2036: @108076
     /* 108076 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(108129), // Rule ID 253 //
     /* 108081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108103 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 108106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108127 */     GIR_RootConstrainSelectedInstOperands,
     /* 108128 */     // GIR_Coverage, 253,
     /* 108128 */     GIR_EraseRootFromParent_Done,
     /* 108129 */   // Label 2037: @108129
     /* 108129 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(108182), // Rule ID 254 //
     /* 108134 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108156 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 108159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108180 */     GIR_RootConstrainSelectedInstOperands,
     /* 108181 */     // GIR_Coverage, 254,
     /* 108181 */     GIR_EraseRootFromParent_Done,
     /* 108182 */   // Label 2038: @108182
     /* 108182 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108235), // Rule ID 255 //
     /* 108187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 108209 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 108209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 108212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108233 */     GIR_RootConstrainSelectedInstOperands,
     /* 108234 */     // GIR_Coverage, 255,
     /* 108234 */     GIR_EraseRootFromParent_Done,
     /* 108235 */   // Label 2039: @108235
     /* 108235 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(108288), // Rule ID 256 //
     /* 108240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 108262 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 108262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 108265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108286 */     GIR_RootConstrainSelectedInstOperands,
     /* 108287 */     // GIR_Coverage, 256,
     /* 108287 */     GIR_EraseRootFromParent_Done,
     /* 108288 */   // Label 2040: @108288
     /* 108288 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108336), // Rule ID 269 //
     /* 108293 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108315 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 108318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108334 */     GIR_RootConstrainSelectedInstOperands,
     /* 108335 */     // GIR_Coverage, 269,
     /* 108335 */     GIR_EraseRootFromParent_Done,
     /* 108336 */   // Label 2041: @108336
     /* 108336 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(108384), // Rule ID 271 //
     /* 108341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108363 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 108366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108382 */     GIR_RootConstrainSelectedInstOperands,
     /* 108383 */     // GIR_Coverage, 271,
     /* 108383 */     GIR_EraseRootFromParent_Done,
     /* 108384 */   // Label 2042: @108384
     /* 108384 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(108432), // Rule ID 272 //
     /* 108389 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 108411 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 108411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 108414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108430 */     GIR_RootConstrainSelectedInstOperands,
     /* 108431 */     // GIR_Coverage, 272,
     /* 108431 */     GIR_EraseRootFromParent_Done,
     /* 108432 */   // Label 2043: @108432
     /* 108432 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(108480), // Rule ID 290 //
     /* 108437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108459 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 108462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108478 */     GIR_RootConstrainSelectedInstOperands,
     /* 108479 */     // GIR_Coverage, 290,
     /* 108479 */     GIR_EraseRootFromParent_Done,
     /* 108480 */   // Label 2044: @108480
     /* 108480 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108528), // Rule ID 292 //
     /* 108485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108507 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 108510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108526 */     GIR_RootConstrainSelectedInstOperands,
     /* 108527 */     // GIR_Coverage, 292,
     /* 108527 */     GIR_EraseRootFromParent_Done,
     /* 108528 */   // Label 2045: @108528
     /* 108528 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(108576), // Rule ID 293 //
     /* 108533 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 108555 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 108558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108574 */     GIR_RootConstrainSelectedInstOperands,
     /* 108575 */     // GIR_Coverage, 293,
     /* 108575 */     GIR_EraseRootFromParent_Done,
     /* 108576 */   // Label 2046: @108576
     /* 108576 */   GIM_Reject,
     /* 108577 */ // Label 2034: @108577
     /* 108577 */ GIM_Reject,
     /* 108578 */ // Label 2024: @108578
     /* 108578 */ GIM_Reject,
     /* 108579 */ // Label 18: @108579
     /* 108579 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2049*/ GIMT_Encode4(111547),
     /* 108590 */ /*GILLT_s32*//*Label 2047*/ GIMT_Encode4(108598),
     /* 108594 */ /*GILLT_s64*//*Label 2048*/ GIMT_Encode4(110057),
     /* 108598 */ // Label 2047: @108598
     /* 108598 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(108654), // Rule ID 229 //
     /* 108603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108606 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108628 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 108631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108652 */   GIR_RootConstrainSelectedInstOperands,
     /* 108653 */   // GIR_Coverage, 229,
     /* 108653 */   GIR_EraseRootFromParent_Done,
     /* 108654 */ // Label 2050: @108654
     /* 108654 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108710), // Rule ID 230 //
     /* 108659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108662 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108673 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108684 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 108687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108704 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108708 */   GIR_RootConstrainSelectedInstOperands,
     /* 108709 */   // GIR_Coverage, 230,
     /* 108709 */   GIR_EraseRootFromParent_Done,
     /* 108710 */ // Label 2051: @108710
     /* 108710 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(108766), // Rule ID 231 //
     /* 108715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108718 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108733 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108740 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 108743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108764 */   GIR_RootConstrainSelectedInstOperands,
     /* 108765 */   // GIR_Coverage, 231,
     /* 108765 */   GIR_EraseRootFromParent_Done,
     /* 108766 */ // Label 2052: @108766
     /* 108766 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(108822), // Rule ID 232 //
     /* 108771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108789 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108796 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 108799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108801 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108806 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108811 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108820 */   GIR_RootConstrainSelectedInstOperands,
     /* 108821 */   // GIR_Coverage, 232,
     /* 108821 */   GIR_EraseRootFromParent_Done,
     /* 108822 */ // Label 2053: @108822
     /* 108822 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(108878), // Rule ID 4126 //
     /* 108827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108830 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108852 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 108855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108872 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108876 */   GIR_RootConstrainSelectedInstOperands,
     /* 108877 */   // GIR_Coverage, 4126,
     /* 108877 */   GIR_EraseRootFromParent_Done,
     /* 108878 */ // Label 2054: @108878
     /* 108878 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(108934), // Rule ID 4127 //
     /* 108883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108897 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108901 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108908 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 108911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108928 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108932 */   GIR_RootConstrainSelectedInstOperands,
     /* 108933 */   // GIR_Coverage, 4127,
     /* 108933 */   GIR_EraseRootFromParent_Done,
     /* 108934 */ // Label 2055: @108934
     /* 108934 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(108985), // Rule ID 266 //
     /* 108939 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108942 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108964 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 108967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108983 */   GIR_RootConstrainSelectedInstOperands,
     /* 108984 */   // GIR_Coverage, 266,
     /* 108984 */   GIR_EraseRootFromParent_Done,
     /* 108985 */ // Label 2056: @108985
     /* 108985 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109036), // Rule ID 267 //
     /* 108990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109015 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109034 */   GIR_RootConstrainSelectedInstOperands,
     /* 109035 */   // GIR_Coverage, 267,
     /* 109035 */   GIR_EraseRootFromParent_Done,
     /* 109036 */ // Label 2057: @109036
     /* 109036 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109095), // Rule ID 7023 //
     /* 109041 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109044 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109051 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109069 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15840>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 109069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109089 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109093 */   GIR_RootConstrainSelectedInstOperands,
     /* 109094 */   // GIR_Coverage, 7023,
     /* 109094 */   GIR_EraseRootFromParent_Done,
     /* 109095 */ // Label 2058: @109095
     /* 109095 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109154), // Rule ID 7025 //
     /* 109100 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109103 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109110 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109117 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109121 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109128 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15840>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 109128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109152 */   GIR_RootConstrainSelectedInstOperands,
     /* 109153 */   // GIR_Coverage, 7025,
     /* 109153 */   GIR_EraseRootFromParent_Done,
     /* 109154 */ // Label 2059: @109154
     /* 109154 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109213), // Rule ID 7035 //
     /* 109159 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109162 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109169 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109180 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109187 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15849>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109211 */   GIR_RootConstrainSelectedInstOperands,
     /* 109212 */   // GIR_Coverage, 7035,
     /* 109212 */   GIR_EraseRootFromParent_Done,
     /* 109213 */ // Label 2060: @109213
     /* 109213 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109272), // Rule ID 7037 //
     /* 109218 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109221 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109228 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109239 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109246 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15849>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109270 */   GIR_RootConstrainSelectedInstOperands,
     /* 109271 */   // GIR_Coverage, 7037,
     /* 109271 */   GIR_EraseRootFromParent_Done,
     /* 109272 */ // Label 2061: @109272
     /* 109272 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109323), // Rule ID 287 //
     /* 109277 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109295 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109302 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109321 */   GIR_RootConstrainSelectedInstOperands,
     /* 109322 */   // GIR_Coverage, 287,
     /* 109322 */   GIR_EraseRootFromParent_Done,
     /* 109323 */ // Label 2062: @109323
     /* 109323 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109374), // Rule ID 288 //
     /* 109328 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109331 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109342 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109346 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109353 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109372 */   GIR_RootConstrainSelectedInstOperands,
     /* 109373 */   // GIR_Coverage, 288,
     /* 109373 */   GIR_EraseRootFromParent_Done,
     /* 109374 */ // Label 2063: @109374
     /* 109374 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109425), // Rule ID 4145 //
     /* 109379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109382 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109404 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109419 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109423 */   GIR_RootConstrainSelectedInstOperands,
     /* 109424 */   // GIR_Coverage, 4145,
     /* 109424 */   GIR_EraseRootFromParent_Done,
     /* 109425 */ // Label 2064: @109425
     /* 109425 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109476), // Rule ID 4177 //
     /* 109430 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109444 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109448 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109455 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109474 */   GIR_RootConstrainSelectedInstOperands,
     /* 109475 */   // GIR_Coverage, 4177,
     /* 109475 */   GIR_EraseRootFromParent_Done,
     /* 109476 */ // Label 2065: @109476
     /* 109476 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109527), // Rule ID 4178 //
     /* 109481 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109484 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109499 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109506 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109525 */   GIR_RootConstrainSelectedInstOperands,
     /* 109526 */   // GIR_Coverage, 4178,
     /* 109526 */   GIR_EraseRootFromParent_Done,
     /* 109527 */ // Label 2066: @109527
     /* 109527 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(109578), // Rule ID 4179 //
     /* 109532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109535 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109557 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109576 */   GIR_RootConstrainSelectedInstOperands,
     /* 109577 */   // GIR_Coverage, 4179,
     /* 109577 */   GIR_EraseRootFromParent_Done,
     /* 109578 */ // Label 2067: @109578
     /* 109578 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(109632), // Rule ID 7027 //
     /* 109583 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109593 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109604 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109611 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15840>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109626 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109630 */   GIR_RootConstrainSelectedInstOperands,
     /* 109631 */   // GIR_Coverage, 7027,
     /* 109631 */   GIR_EraseRootFromParent_Done,
     /* 109632 */ // Label 2068: @109632
     /* 109632 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(109686), // Rule ID 7029 //
     /* 109637 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109640 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109647 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109654 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109658 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109665 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15840>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109680 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109684 */   GIR_RootConstrainSelectedInstOperands,
     /* 109685 */   // GIR_Coverage, 7029,
     /* 109685 */   GIR_EraseRootFromParent_Done,
     /* 109686 */ // Label 2069: @109686
     /* 109686 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(109740), // Rule ID 7039 //
     /* 109691 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109701 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109719 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15849>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 109722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109738 */   GIR_RootConstrainSelectedInstOperands,
     /* 109739 */   // GIR_Coverage, 7039,
     /* 109739 */   GIR_EraseRootFromParent_Done,
     /* 109740 */ // Label 2070: @109740
     /* 109740 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(109794), // Rule ID 7041 //
     /* 109745 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109755 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109766 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109773 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15849>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109792 */   GIR_RootConstrainSelectedInstOperands,
     /* 109793 */   // GIR_Coverage, 7041,
     /* 109793 */   GIR_EraseRootFromParent_Done,
     /* 109794 */ // Label 2071: @109794
     /* 109794 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(109851), // Rule ID 7403 //
     /* 109799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 109802 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109805 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109830 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15838>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 109833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109849 */   GIR_RootConstrainSelectedInstOperands,
     /* 109850 */   // GIR_Coverage, 7403,
     /* 109850 */   GIR_EraseRootFromParent_Done,
     /* 109851 */ // Label 2072: @109851
     /* 109851 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(109908), // Rule ID 7405 //
     /* 109856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 109859 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109862 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109869 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109887 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15847>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 109890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109897 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109906 */   GIR_RootConstrainSelectedInstOperands,
     /* 109907 */   // GIR_Coverage, 7405,
     /* 109907 */   GIR_EraseRootFromParent_Done,
     /* 109908 */ // Label 2073: @109908
     /* 109908 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(109945), // Rule ID 7019 //
     /* 109913 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109916 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 109926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109930 */   // MIs[0] ptr
     /* 109930 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109938 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15836>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 109943 */   GIR_RootConstrainSelectedInstOperands,
     /* 109944 */   // GIR_Coverage, 7019,
     /* 109944 */   GIR_Done,
     /* 109945 */ // Label 2074: @109945
     /* 109945 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(109982), // Rule ID 7021 //
     /* 109950 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109953 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109967 */   // MIs[0] ptr
     /* 109967 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109975 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15838>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 109980 */   GIR_RootConstrainSelectedInstOperands,
     /* 109981 */   // GIR_Coverage, 7021,
     /* 109981 */   GIR_Done,
     /* 109982 */ // Label 2075: @109982
     /* 109982 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110019), // Rule ID 7031 //
     /* 109987 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109990 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110004 */   // MIs[0] ptr
     /* 110004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110012 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15845>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110017 */   GIR_RootConstrainSelectedInstOperands,
     /* 110018 */   // GIR_Coverage, 7031,
     /* 110018 */   GIR_Done,
     /* 110019 */ // Label 2076: @110019
     /* 110019 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110056), // Rule ID 7033 //
     /* 110024 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110027 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110034 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110041 */   // MIs[0] ptr
     /* 110041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110049 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15847>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110054 */   GIR_RootConstrainSelectedInstOperands,
     /* 110055 */   // GIR_Coverage, 7033,
     /* 110055 */   GIR_Done,
     /* 110056 */ // Label 2077: @110056
     /* 110056 */ GIM_Reject,
     /* 110057 */ // Label 2048: @110057
     /* 110057 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(111546),
     /* 110062 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110065 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110150), // Rule ID 4104 //
     /* 110070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 110092 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 110099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110119 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110149 */     // GIR_Coverage, 4104,
     /* 110149 */     GIR_EraseRootFromParent_Done,
     /* 110150 */   // Label 2079: @110150
     /* 110150 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110235), // Rule ID 4105 //
     /* 110155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 110177 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 110184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110204 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110234 */     // GIR_Coverage, 4105,
     /* 110234 */     GIR_EraseRootFromParent_Done,
     /* 110235 */   // Label 2080: @110235
     /* 110235 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110320), // Rule ID 4106 //
     /* 110240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 110262 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 110269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110289 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110319 */     // GIR_Coverage, 4106,
     /* 110319 */     GIR_EraseRootFromParent_Done,
     /* 110320 */   // Label 2081: @110320
     /* 110320 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110405), // Rule ID 4107 //
     /* 110325 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 110347 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 110354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110374 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110404 */     // GIR_Coverage, 4107,
     /* 110404 */     GIR_EraseRootFromParent_Done,
     /* 110405 */   // Label 2082: @110405
     /* 110405 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110490), // Rule ID 4108 //
     /* 110410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110432 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 110439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110459 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110489 */     // GIR_Coverage, 4108,
     /* 110489 */     GIR_EraseRootFromParent_Done,
     /* 110490 */   // Label 2083: @110490
     /* 110490 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110575), // Rule ID 4109 //
     /* 110495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110517 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 110524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110544 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110574 */     // GIR_Coverage, 4109,
     /* 110574 */     GIR_EraseRootFromParent_Done,
     /* 110575 */   // Label 2084: @110575
     /* 110575 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110660), // Rule ID 4110 //
     /* 110580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 110602 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 110609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110629 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110659 */     // GIR_Coverage, 4110,
     /* 110659 */     GIR_EraseRootFromParent_Done,
     /* 110660 */   // Label 2085: @110660
     /* 110660 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110745), // Rule ID 4111 //
     /* 110665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 110687 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 110694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110714 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110744 */     // GIR_Coverage, 4111,
     /* 110744 */     GIR_EraseRootFromParent_Done,
     /* 110745 */   // Label 2086: @110745
     /* 110745 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110825), // Rule ID 4143 //
     /* 110750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110772 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110794 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110824 */     // GIR_Coverage, 4143,
     /* 110824 */     GIR_EraseRootFromParent_Done,
     /* 110825 */   // Label 2087: @110825
     /* 110825 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110905), // Rule ID 4144 //
     /* 110830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110852 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 110859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110874 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110904 */     // GIR_Coverage, 4144,
     /* 110904 */     GIR_EraseRootFromParent_Done,
     /* 110905 */   // Label 2088: @110905
     /* 110905 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110985), // Rule ID 4146 //
     /* 110910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110932 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110954 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110984 */     // GIR_Coverage, 4146,
     /* 110984 */     GIR_EraseRootFromParent_Done,
     /* 110985 */   // Label 2089: @110985
     /* 110985 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(111065), // Rule ID 4154 //
     /* 110990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 111012 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 111019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111034 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111064 */     // GIR_Coverage, 4154,
     /* 111064 */     GIR_EraseRootFromParent_Done,
     /* 111065 */   // Label 2090: @111065
     /* 111065 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(111145), // Rule ID 4180 //
     /* 111070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 111092 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 111099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111114 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111144 */     // GIR_Coverage, 4180,
     /* 111144 */     GIR_EraseRootFromParent_Done,
     /* 111145 */   // Label 2091: @111145
     /* 111145 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(111225), // Rule ID 4181 //
     /* 111150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 111172 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 111179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111194 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111224 */     // GIR_Coverage, 4181,
     /* 111224 */     GIR_EraseRootFromParent_Done,
     /* 111225 */   // Label 2092: @111225
     /* 111225 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(111305), // Rule ID 4182 //
     /* 111230 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111252 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111274 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111304 */     // GIR_Coverage, 4182,
     /* 111304 */     GIR_EraseRootFromParent_Done,
     /* 111305 */   // Label 2093: @111305
     /* 111305 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(111385), // Rule ID 4183 //
     /* 111310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111332 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111354 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111384 */     // GIR_Coverage, 4183,
     /* 111384 */     GIR_EraseRootFromParent_Done,
     /* 111385 */   // Label 2094: @111385
     /* 111385 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111465), // Rule ID 4184 //
     /* 111390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111412 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111434 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111464 */     // GIR_Coverage, 4184,
     /* 111464 */     GIR_EraseRootFromParent_Done,
     /* 111465 */   // Label 2095: @111465
     /* 111465 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111545), // Rule ID 4185 //
     /* 111470 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 111492 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 111499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111514 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111544 */     // GIR_Coverage, 4185,
     /* 111544 */     GIR_EraseRootFromParent_Done,
     /* 111545 */   // Label 2096: @111545
     /* 111545 */   GIM_Reject,
     /* 111546 */ // Label 2078: @111546
     /* 111546 */ GIM_Reject,
     /* 111547 */ // Label 2049: @111547
     /* 111547 */ GIM_Reject,
     /* 111548 */ // Label 19: @111548
     /* 111548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2117*/ GIMT_Encode4(125073),
     /* 111559 */ /*GILLT_s8*//*Label 2097*/ GIMT_Encode4(111655),
     /* 111563 */ /*GILLT_s16*//*Label 2098*/ GIMT_Encode4(112022),
     /* 111567 */ /*GILLT_s32*//*Label 2099*/ GIMT_Encode4(113161),
     /* 111571 */ /*GILLT_s64*//*Label 2100*/ GIMT_Encode4(117756),
     /* 111575 */ /*GILLT_s128*//*Label 2101*/ GIMT_Encode4(121525),
     /* 111579 */ /*GILLT_v2s32*//*Label 2102*/ GIMT_Encode4(121731),
     /* 111583 */ /*GILLT_v2s64*//*Label 2103*/ GIMT_Encode4(122137),
     /* 111587 */ /*GILLT_v4s16*//*Label 2104*/ GIMT_Encode4(122587),
     /* 111591 */ /*GILLT_v4s32*//*Label 2105*/ GIMT_Encode4(122993),
     /* 111595 */ /*GILLT_v8s8*//*Label 2106*/ GIMT_Encode4(123399),
     /* 111599 */ /*GILLT_v8s16*//*Label 2107*/ GIMT_Encode4(123619),
     /* 111603 */ /*GILLT_v16s8*//*Label 2108*/ GIMT_Encode4(124025), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111615 */ /*GILLT_nxv2s16*//*Label 2109*/ GIMT_Encode4(124245),
     /* 111619 */ /*GILLT_nxv2s32*//*Label 2110*/ GIMT_Encode4(124305),
     /* 111623 */ /*GILLT_nxv2s64*//*Label 2111*/ GIMT_Encode4(124365), GIMT_Encode4(0),
     /* 111631 */ /*GILLT_nxv4s16*//*Label 2112*/ GIMT_Encode4(124535),
     /* 111635 */ /*GILLT_nxv4s32*//*Label 2113*/ GIMT_Encode4(124595), GIMT_Encode4(0),
     /* 111643 */ /*GILLT_nxv8s16*//*Label 2114*/ GIMT_Encode4(124765),
     /* 111647 */ /*GILLT_nxv16s1*//*Label 2115*/ GIMT_Encode4(124935),
     /* 111651 */ /*GILLT_nxv16s8*//*Label 2116*/ GIMT_Encode4(124979),
     /* 111655 */ // Label 2097: @111655
     /* 111655 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(112021),
     /* 111660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111663 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111667 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(111735), // Rule ID 13168 //
     /* 111672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111701 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111705 */     // MIs[2] Operand 1
     /* 111705 */     // No operand predicates
     /* 111705 */     // MIs[0] Rn
     /* 111705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111715 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111733 */     GIR_RootConstrainSelectedInstOperands,
     /* 111734 */     // GIR_Coverage, 13168,
     /* 111734 */     GIR_EraseRootFromParent_Done,
     /* 111735 */   // Label 2119: @111735
     /* 111735 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(111834), // Rule ID 13169 //
     /* 111740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111769 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111773 */     // MIs[2] Operand 1
     /* 111773 */     // No operand predicates
     /* 111773 */     // MIs[0] Rn
     /* 111773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111783 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111795 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111802 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111832 */     GIR_RootConstrainSelectedInstOperands,
     /* 111833 */     // GIR_Coverage, 13169,
     /* 111833 */     GIR_EraseRootFromParent_Done,
     /* 111834 */   // Label 2120: @111834
     /* 111834 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(111883), // Rule ID 303 //
     /* 111839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111857 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 111857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 111860 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111881 */     GIR_RootConstrainSelectedInstOperands,
     /* 111882 */     // GIR_Coverage, 303,
     /* 111882 */     GIR_EraseRootFromParent_Done,
     /* 111883 */   // Label 2121: @111883
     /* 111883 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(111932), // Rule ID 304 //
     /* 111888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111906 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 111906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 111909 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111930 */     GIR_RootConstrainSelectedInstOperands,
     /* 111931 */     // GIR_Coverage, 304,
     /* 111931 */     GIR_EraseRootFromParent_Done,
     /* 111932 */   // Label 2122: @111932
     /* 111932 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(111976), // Rule ID 313 //
     /* 111937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111955 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 111955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 111958 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111974 */     GIR_RootConstrainSelectedInstOperands,
     /* 111975 */     // GIR_Coverage, 313,
     /* 111975 */     GIR_EraseRootFromParent_Done,
     /* 111976 */   // Label 2123: @111976
     /* 111976 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112020), // Rule ID 321 //
     /* 111981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111999 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 111999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 112002 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112018 */     GIR_RootConstrainSelectedInstOperands,
     /* 112019 */     // GIR_Coverage, 321,
     /* 112019 */     GIR_EraseRootFromParent_Done,
     /* 112020 */   // Label 2124: @112020
     /* 112020 */   GIM_Reject,
     /* 112021 */ // Label 2118: @112021
     /* 112021 */ GIM_Reject,
     /* 112022 */ // Label 2098: @112022
     /* 112022 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(113160),
     /* 112027 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112030 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112034 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112133), // Rule ID 4482 //
     /* 112039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112060 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112077 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112089 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112131 */     GIR_RootConstrainSelectedInstOperands,
     /* 112132 */     // GIR_Coverage, 4482,
     /* 112132 */     GIR_EraseRootFromParent_Done,
     /* 112133 */   // Label 2126: @112133
     /* 112133 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112232), // Rule ID 4483 //
     /* 112138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112159 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112176 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112188 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112230 */     GIR_RootConstrainSelectedInstOperands,
     /* 112231 */     // GIR_Coverage, 4483,
     /* 112231 */     GIR_EraseRootFromParent_Done,
     /* 112232 */   // Label 2127: @112232
     /* 112232 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112331), // Rule ID 13166 //
     /* 112237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112275 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112287 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112329 */     GIR_RootConstrainSelectedInstOperands,
     /* 112330 */     // GIR_Coverage, 13166,
     /* 112330 */     GIR_EraseRootFromParent_Done,
     /* 112331 */   // Label 2128: @112331
     /* 112331 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112430), // Rule ID 13167 //
     /* 112336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112357 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112374 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112386 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112428 */     GIR_RootConstrainSelectedInstOperands,
     /* 112429 */     // GIR_Coverage, 13167,
     /* 112429 */     GIR_EraseRootFromParent_Done,
     /* 112430 */   // Label 2129: @112430
     /* 112430 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112524), // Rule ID 4511 //
     /* 112435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112456 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112473 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112485 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 112504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112522 */     GIR_RootConstrainSelectedInstOperands,
     /* 112523 */     // GIR_Coverage, 4511,
     /* 112523 */     GIR_EraseRootFromParent_Done,
     /* 112524 */   // Label 2130: @112524
     /* 112524 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112618), // Rule ID 4538 //
     /* 112529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112550 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 112567 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 112567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 112598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112616 */     GIR_RootConstrainSelectedInstOperands,
     /* 112617 */     // GIR_Coverage, 4538,
     /* 112617 */     GIR_EraseRootFromParent_Done,
     /* 112618 */   // Label 2131: @112618
     /* 112618 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112712), // Rule ID 13165 //
     /* 112623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112644 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112661 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112673 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 112692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112710 */     GIR_RootConstrainSelectedInstOperands,
     /* 112711 */     // GIR_Coverage, 13165,
     /* 112711 */     GIR_EraseRootFromParent_Done,
     /* 112712 */   // Label 2132: @112712
     /* 112712 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112806), // Rule ID 13171 //
     /* 112717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 112755 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 112755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112767 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 112786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112804 */     GIR_RootConstrainSelectedInstOperands,
     /* 112805 */     // GIR_Coverage, 13171,
     /* 112805 */     GIR_EraseRootFromParent_Done,
     /* 112806 */   // Label 2133: @112806
     /* 112806 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112874), // Rule ID 6457 //
     /* 112811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112840 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 112844 */     // MIs[2] Operand 1
     /* 112844 */     // No operand predicates
     /* 112844 */     // MIs[0] Rn
     /* 112844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112854 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 112857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112872 */     GIR_RootConstrainSelectedInstOperands,
     /* 112873 */     // GIR_Coverage, 6457,
     /* 112873 */     GIR_EraseRootFromParent_Done,
     /* 112874 */   // Label 2134: @112874
     /* 112874 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112973), // Rule ID 6462 //
     /* 112879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 112912 */     // MIs[2] Operand 1
     /* 112912 */     // No operand predicates
     /* 112912 */     // MIs[0] Rn
     /* 112912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112922 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 112937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112941 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 112944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 112957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112971 */     GIR_RootConstrainSelectedInstOperands,
     /* 112972 */     // GIR_Coverage, 6462,
     /* 112972 */     GIR_EraseRootFromParent_Done,
     /* 112973 */   // Label 2135: @112973
     /* 112973 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113022), // Rule ID 305 //
     /* 112978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112996 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112999 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113020 */     GIR_RootConstrainSelectedInstOperands,
     /* 113021 */     // GIR_Coverage, 305,
     /* 113021 */     GIR_EraseRootFromParent_Done,
     /* 113022 */   // Label 2136: @113022
     /* 113022 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113071), // Rule ID 306 //
     /* 113027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113045 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113048 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113069 */     GIR_RootConstrainSelectedInstOperands,
     /* 113070 */     // GIR_Coverage, 306,
     /* 113070 */     GIR_EraseRootFromParent_Done,
     /* 113071 */   // Label 2137: @113071
     /* 113071 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(113115), // Rule ID 314 //
     /* 113076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113094 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113097 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113113 */     GIR_RootConstrainSelectedInstOperands,
     /* 113114 */     // GIR_Coverage, 314,
     /* 113114 */     GIR_EraseRootFromParent_Done,
     /* 113115 */   // Label 2138: @113115
     /* 113115 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(113159), // Rule ID 322 //
     /* 113120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113138 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113141 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113157 */     GIR_RootConstrainSelectedInstOperands,
     /* 113158 */     // GIR_Coverage, 322,
     /* 113158 */     GIR_EraseRootFromParent_Done,
     /* 113159 */   // Label 2139: @113159
     /* 113159 */   GIM_Reject,
     /* 113160 */ // Label 2125: @113160
     /* 113160 */ GIM_Reject,
     /* 113161 */ // Label 2099: @113161
     /* 113161 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(113274), // Rule ID 4480 //
     /* 113166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113169 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113173 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113180 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113184 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113188 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113192 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113196 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113201 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113218 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113230 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113241 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113267 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113272 */   GIR_RootConstrainSelectedInstOperands,
     /* 113273 */   // GIR_Coverage, 4480,
     /* 113273 */   GIR_EraseRootFromParent_Done,
     /* 113274 */ // Label 2140: @113274
     /* 113274 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(113387), // Rule ID 4481 //
     /* 113279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113282 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113301 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113305 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113309 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113314 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113318 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113324 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113331 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113343 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113354 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113385 */   GIR_RootConstrainSelectedInstOperands,
     /* 113386 */   // GIR_Coverage, 4481,
     /* 113386 */   GIR_EraseRootFromParent_Done,
     /* 113387 */ // Label 2141: @113387
     /* 113387 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(113493), // Rule ID 4484 //
     /* 113392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113395 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113399 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113407 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113411 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113415 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113420 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113424 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113428 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113430 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113437 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113449 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113455 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113460 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113491 */   GIR_RootConstrainSelectedInstOperands,
     /* 113492 */   // GIR_Coverage, 4484,
     /* 113492 */   GIR_EraseRootFromParent_Done,
     /* 113493 */ // Label 2142: @113493
     /* 113493 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113599), // Rule ID 4485 //
     /* 113498 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113501 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113505 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113509 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113513 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113517 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113521 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113526 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113536 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113543 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113555 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113561 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113566 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113597 */   GIR_RootConstrainSelectedInstOperands,
     /* 113598 */   // GIR_Coverage, 4485,
     /* 113598 */   GIR_EraseRootFromParent_Done,
     /* 113599 */ // Label 2143: @113599
     /* 113599 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113705), // Rule ID 4486 //
     /* 113604 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113607 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113619 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113623 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113627 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113632 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113649 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113661 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113667 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113680 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113698 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113703 */   GIR_RootConstrainSelectedInstOperands,
     /* 113704 */   // GIR_Coverage, 4486,
     /* 113704 */   GIR_EraseRootFromParent_Done,
     /* 113705 */ // Label 2144: @113705
     /* 113705 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113811), // Rule ID 4487 //
     /* 113710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113717 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113725 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113729 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113733 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113738 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113746 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113755 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113767 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113773 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113809 */   GIR_RootConstrainSelectedInstOperands,
     /* 113810 */   // GIR_Coverage, 4487,
     /* 113810 */   GIR_EraseRootFromParent_Done,
     /* 113811 */ // Label 2145: @113811
     /* 113811 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113917), // Rule ID 13173 //
     /* 113816 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113819 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113823 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113827 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113831 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113835 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113839 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113844 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113854 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113861 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113873 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113915 */   GIR_RootConstrainSelectedInstOperands,
     /* 113916 */   // GIR_Coverage, 13173,
     /* 113916 */   GIR_EraseRootFromParent_Done,
     /* 113917 */ // Label 2146: @113917
     /* 113917 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(114023), // Rule ID 13174 //
     /* 113922 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113925 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113937 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113941 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113945 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113950 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113960 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113967 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113979 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113985 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114016 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114021 */   GIR_RootConstrainSelectedInstOperands,
     /* 114022 */   // GIR_Coverage, 13174,
     /* 114022 */   GIR_EraseRootFromParent_Done,
     /* 114023 */ // Label 2147: @114023
     /* 114023 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(114131), // Rule ID 4510 //
     /* 114028 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114031 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114035 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114042 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114050 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114054 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114058 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114063 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114067 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 114080 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 114080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114092 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114103 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 114111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114129 */   GIR_RootConstrainSelectedInstOperands,
     /* 114130 */   // GIR_Coverage, 4510,
     /* 114130 */   GIR_EraseRootFromParent_Done,
     /* 114131 */ // Label 2148: @114131
     /* 114131 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(114232), // Rule ID 4512 //
     /* 114136 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114139 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114151 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114155 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114159 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114164 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114172 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114174 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114181 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114193 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114230 */   GIR_RootConstrainSelectedInstOperands,
     /* 114231 */   // GIR_Coverage, 4512,
     /* 114231 */   GIR_EraseRootFromParent_Done,
     /* 114232 */ // Label 2149: @114232
     /* 114232 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(114333), // Rule ID 4513 //
     /* 114237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114240 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114252 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114256 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114260 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114265 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114269 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114273 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114282 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114294 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114300 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114305 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114331 */   GIR_RootConstrainSelectedInstOperands,
     /* 114332 */   // GIR_Coverage, 4513,
     /* 114332 */   GIR_EraseRootFromParent_Done,
     /* 114333 */ // Label 2150: @114333
     /* 114333 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(114441), // Rule ID 4537 //
     /* 114338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114341 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114360 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114364 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114368 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114373 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114390 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114402 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114408 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114413 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 114421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114439 */   GIR_RootConstrainSelectedInstOperands,
     /* 114440 */   // GIR_Coverage, 4537,
     /* 114440 */   GIR_EraseRootFromParent_Done,
     /* 114441 */ // Label 2151: @114441
     /* 114441 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(114542), // Rule ID 4539 //
     /* 114446 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114449 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114461 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114465 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114469 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114474 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114491 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114503 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114535 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114540 */   GIR_RootConstrainSelectedInstOperands,
     /* 114541 */   // GIR_Coverage, 4539,
     /* 114541 */   GIR_EraseRootFromParent_Done,
     /* 114542 */ // Label 2152: @114542
     /* 114542 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(114643), // Rule ID 4540 //
     /* 114547 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114550 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114562 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114566 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114570 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114575 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114579 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114585 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114592 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114604 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114610 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114641 */   GIR_RootConstrainSelectedInstOperands,
     /* 114642 */   // GIR_Coverage, 4540,
     /* 114642 */   GIR_EraseRootFromParent_Done,
     /* 114643 */ // Label 2153: @114643
     /* 114643 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(114744), // Rule ID 13170 //
     /* 114648 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114651 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114655 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114659 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114663 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114667 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114671 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114676 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114686 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114693 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114705 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114711 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114737 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114742 */   GIR_RootConstrainSelectedInstOperands,
     /* 114743 */   // GIR_Coverage, 13170,
     /* 114743 */   GIR_EraseRootFromParent_Done,
     /* 114744 */ // Label 2154: @114744
     /* 114744 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(114845), // Rule ID 13172 //
     /* 114749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114764 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114768 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114772 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114777 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114787 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 114794 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114794 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114797 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114801 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114806 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114843 */   GIR_RootConstrainSelectedInstOperands,
     /* 114844 */   // GIR_Coverage, 13172,
     /* 114844 */   GIR_EraseRootFromParent_Done,
     /* 114845 */ // Label 2155: @114845
     /* 114845 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(114927), // Rule ID 6451 //
     /* 114850 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114853 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114872 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114880 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114885 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114889 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114893 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 114897 */   // MIs[2] Operand 1
     /* 114897 */   // No operand predicates
     /* 114897 */   // MIs[0] Rn
     /* 114897 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114905 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114907 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 114910 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114914 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114917 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114925 */   GIR_RootConstrainSelectedInstOperands,
     /* 114926 */   // GIR_Coverage, 6451,
     /* 114926 */   GIR_EraseRootFromParent_Done,
     /* 114927 */ // Label 2156: @114927
     /* 114927 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(115009), // Rule ID 6452 //
     /* 114932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114935 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114954 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114958 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114962 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114967 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114971 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114975 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 114979 */   // MIs[2] Operand 1
     /* 114979 */   // No operand predicates
     /* 114979 */   // MIs[0] Rn
     /* 114979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114987 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114989 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 114992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114996 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114999 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115007 */   GIR_RootConstrainSelectedInstOperands,
     /* 115008 */   // GIR_Coverage, 6452,
     /* 115008 */   GIR_EraseRootFromParent_Done,
     /* 115009 */ // Label 2157: @115009
     /* 115009 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(115084), // Rule ID 6453 //
     /* 115014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115017 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115021 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115025 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115029 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115037 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115042 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115046 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115050 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115054 */   // MIs[2] Operand 1
     /* 115054 */   // No operand predicates
     /* 115054 */   // MIs[0] Rn
     /* 115054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115062 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115064 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115067 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115071 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115074 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115082 */   GIR_RootConstrainSelectedInstOperands,
     /* 115083 */   // GIR_Coverage, 6453,
     /* 115083 */   GIR_EraseRootFromParent_Done,
     /* 115084 */ // Label 2158: @115084
     /* 115084 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(115159), // Rule ID 6454 //
     /* 115089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115092 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115096 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115100 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115104 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115108 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115112 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115117 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115121 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115125 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115129 */   // MIs[2] Operand 1
     /* 115129 */   // No operand predicates
     /* 115129 */   // MIs[0] Rn
     /* 115129 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115137 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115139 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115142 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115146 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115149 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115157 */   GIR_RootConstrainSelectedInstOperands,
     /* 115158 */   // GIR_Coverage, 6454,
     /* 115158 */   GIR_EraseRootFromParent_Done,
     /* 115159 */ // Label 2159: @115159
     /* 115159 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(115272), // Rule ID 6458 //
     /* 115164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115167 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115178 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115182 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115186 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 115190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115194 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115199 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115203 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115207 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 115211 */   // MIs[2] Operand 1
     /* 115211 */   // No operand predicates
     /* 115211 */   // MIs[0] Rn
     /* 115211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115219 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115221 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115233 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115236 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115240 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115243 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 115256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115259 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115262 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115264 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115270 */   GIR_RootConstrainSelectedInstOperands,
     /* 115271 */   // GIR_Coverage, 6458,
     /* 115271 */   GIR_EraseRootFromParent_Done,
     /* 115272 */ // Label 2160: @115272
     /* 115272 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(115385), // Rule ID 6459 //
     /* 115277 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115280 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115291 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115299 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115303 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115307 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115312 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115316 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115320 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 115324 */   // MIs[2] Operand 1
     /* 115324 */   // No operand predicates
     /* 115324 */   // MIs[0] Rn
     /* 115324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115332 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115334 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115346 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115349 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115353 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115356 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115361 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 115369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115372 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115375 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115377 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115383 */   GIR_RootConstrainSelectedInstOperands,
     /* 115384 */   // GIR_Coverage, 6459,
     /* 115384 */   GIR_EraseRootFromParent_Done,
     /* 115385 */ // Label 2161: @115385
     /* 115385 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(115491), // Rule ID 6460 //
     /* 115390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115393 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115405 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115409 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115413 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115418 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115422 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115426 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115430 */   // MIs[2] Operand 1
     /* 115430 */   // No operand predicates
     /* 115430 */   // MIs[0] Rn
     /* 115430 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115438 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115440 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115452 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115455 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115459 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115478 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115481 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115489 */   GIR_RootConstrainSelectedInstOperands,
     /* 115490 */   // GIR_Coverage, 6460,
     /* 115490 */   GIR_EraseRootFromParent_Done,
     /* 115491 */ // Label 2162: @115491
     /* 115491 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(115597), // Rule ID 6461 //
     /* 115496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115499 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115511 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115515 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115519 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115524 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115528 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115532 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115536 */   // MIs[2] Operand 1
     /* 115536 */   // No operand predicates
     /* 115536 */   // MIs[0] Rn
     /* 115536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115544 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115546 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115558 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115561 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115565 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115568 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115584 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115587 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115595 */   GIR_RootConstrainSelectedInstOperands,
     /* 115596 */   // GIR_Coverage, 6461,
     /* 115596 */   GIR_EraseRootFromParent_Done,
     /* 115597 */ // Label 2163: @115597
     /* 115597 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(115657), // Rule ID 295 //
     /* 115602 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115605 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115609 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115624 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 115631 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 115631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 115634 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115655 */   GIR_RootConstrainSelectedInstOperands,
     /* 115656 */   // GIR_Coverage, 295,
     /* 115656 */   GIR_EraseRootFromParent_Done,
     /* 115657 */ // Label 2164: @115657
     /* 115657 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(115717), // Rule ID 296 //
     /* 115662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115665 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115684 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 115691 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 115691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 115694 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115715 */   GIR_RootConstrainSelectedInstOperands,
     /* 115716 */   // GIR_Coverage, 296,
     /* 115716 */   GIR_EraseRootFromParent_Done,
     /* 115717 */ // Label 2165: @115717
     /* 115717 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(115777), // Rule ID 297 //
     /* 115722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115725 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 115751 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 115751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 115754 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115775 */   GIR_RootConstrainSelectedInstOperands,
     /* 115776 */   // GIR_Coverage, 297,
     /* 115776 */   GIR_EraseRootFromParent_Done,
     /* 115777 */ // Label 2166: @115777
     /* 115777 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(115837), // Rule ID 298 //
     /* 115782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115785 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115811 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115814 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115835 */   GIR_RootConstrainSelectedInstOperands,
     /* 115836 */   // GIR_Coverage, 298,
     /* 115836 */   GIR_EraseRootFromParent_Done,
     /* 115837 */ // Label 2167: @115837
     /* 115837 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(115890), // Rule ID 299 //
     /* 115842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115845 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115853 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115864 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115867 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115884 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115888 */   GIR_RootConstrainSelectedInstOperands,
     /* 115889 */   // GIR_Coverage, 299,
     /* 115889 */   GIR_EraseRootFromParent_Done,
     /* 115890 */ // Label 2168: @115890
     /* 115890 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(115943), // Rule ID 300 //
     /* 115895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115917 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 115920 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115937 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115941 */   GIR_RootConstrainSelectedInstOperands,
     /* 115942 */   // GIR_Coverage, 300,
     /* 115942 */   GIR_EraseRootFromParent_Done,
     /* 115943 */ // Label 2169: @115943
     /* 115943 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(115999), // Rule ID 307 //
     /* 115948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115951 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115954 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115973 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 115976 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115997 */   GIR_RootConstrainSelectedInstOperands,
     /* 115998 */   // GIR_Coverage, 307,
     /* 115998 */   GIR_EraseRootFromParent_Done,
     /* 115999 */ // Label 2170: @115999
     /* 115999 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(116055), // Rule ID 308 //
     /* 116004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116010 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116029 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116032 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116053 */   GIR_RootConstrainSelectedInstOperands,
     /* 116054 */   // GIR_Coverage, 308,
     /* 116054 */   GIR_EraseRootFromParent_Done,
     /* 116055 */ // Label 2171: @116055
     /* 116055 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(116107), // Rule ID 312 //
     /* 116060 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116063 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116071 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116075 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116082 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116085 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116101 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116105 */   GIR_RootConstrainSelectedInstOperands,
     /* 116106 */   // GIR_Coverage, 312,
     /* 116106 */   GIR_EraseRootFromParent_Done,
     /* 116107 */ // Label 2172: @116107
     /* 116107 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(116158), // Rule ID 315 //
     /* 116112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116118 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116137 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116140 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116156 */   GIR_RootConstrainSelectedInstOperands,
     /* 116157 */   // GIR_Coverage, 315,
     /* 116157 */   GIR_EraseRootFromParent_Done,
     /* 116158 */ // Label 2173: @116158
     /* 116158 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(116217), // Rule ID 317 //
     /* 116163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116166 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116181 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116185 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116192 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116195 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116215 */   GIR_RootConstrainSelectedInstOperands,
     /* 116216 */   // GIR_Coverage, 317,
     /* 116216 */   GIR_EraseRootFromParent_Done,
     /* 116217 */ // Label 2174: @116217
     /* 116217 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(116276), // Rule ID 318 //
     /* 116222 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116225 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116229 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116251 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116254 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116274 */   GIR_RootConstrainSelectedInstOperands,
     /* 116275 */   // GIR_Coverage, 318,
     /* 116275 */   GIR_EraseRootFromParent_Done,
     /* 116276 */ // Label 2175: @116276
     /* 116276 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(116353), // Rule ID 7082 //
     /* 116281 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116291 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116302 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116306 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116311 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116324 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15894>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 116327 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116346 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116351 */   GIR_RootConstrainSelectedInstOperands,
     /* 116352 */   // GIR_Coverage, 7082,
     /* 116352 */   GIR_EraseRootFromParent_Done,
     /* 116353 */ // Label 2176: @116353
     /* 116353 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(116430), // Rule ID 7083 //
     /* 116358 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116361 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116368 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116371 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116375 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116379 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116383 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116388 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116394 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116401 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15894>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116404 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116423 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116428 */   GIR_RootConstrainSelectedInstOperands,
     /* 116429 */   // GIR_Coverage, 7083,
     /* 116429 */   GIR_EraseRootFromParent_Done,
     /* 116430 */ // Label 2177: @116430
     /* 116430 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(116489), // Rule ID 7063 //
     /* 116435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116445 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116463 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15880>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 116466 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116487 */   GIR_RootConstrainSelectedInstOperands,
     /* 116488 */   // GIR_Coverage, 7063,
     /* 116488 */   GIR_EraseRootFromParent_Done,
     /* 116489 */ // Label 2178: @116489
     /* 116489 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(116548), // Rule ID 7064 //
     /* 116494 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116497 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116504 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116522 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15880>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 116525 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116546 */   GIR_RootConstrainSelectedInstOperands,
     /* 116547 */   // GIR_Coverage, 7064,
     /* 116547 */   GIR_EraseRootFromParent_Done,
     /* 116548 */ // Label 2179: @116548
     /* 116548 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(116607), // Rule ID 7068 //
     /* 116553 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116556 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116563 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116581 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15887>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 116584 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116605 */   GIR_RootConstrainSelectedInstOperands,
     /* 116606 */   // GIR_Coverage, 7068,
     /* 116606 */   GIR_EraseRootFromParent_Done,
     /* 116607 */ // Label 2180: @116607
     /* 116607 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(116666), // Rule ID 7069 //
     /* 116612 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116615 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116622 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 116640 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15887>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 116640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 116643 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116664 */   GIR_RootConstrainSelectedInstOperands,
     /* 116665 */   // GIR_Coverage, 7069,
     /* 116665 */   GIR_EraseRootFromParent_Done,
     /* 116666 */ // Label 2181: @116666
     /* 116666 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(116725), // Rule ID 7073 //
     /* 116671 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116681 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116699 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15894>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 116702 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116719 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116723 */   GIR_RootConstrainSelectedInstOperands,
     /* 116724 */   // GIR_Coverage, 7073,
     /* 116724 */   GIR_EraseRootFromParent_Done,
     /* 116725 */ // Label 2182: @116725
     /* 116725 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(116784), // Rule ID 7074 //
     /* 116730 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116733 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116740 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116747 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116751 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116758 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15894>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 116761 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116778 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116782 */   GIR_RootConstrainSelectedInstOperands,
     /* 116783 */   // GIR_Coverage, 7074,
     /* 116783 */   GIR_EraseRootFromParent_Done,
     /* 116784 */ // Label 2183: @116784
     /* 116784 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(116856), // Rule ID 7084 //
     /* 116789 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116792 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116799 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116810 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116814 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116832 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15894>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116835 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116849 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116854 */   GIR_RootConstrainSelectedInstOperands,
     /* 116855 */   // GIR_Coverage, 7084,
     /* 116855 */   GIR_EraseRootFromParent_Done,
     /* 116856 */ // Label 2184: @116856
     /* 116856 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(116928), // Rule ID 7085 //
     /* 116861 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116871 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116886 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116891 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116897 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116904 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15894>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 116907 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116926 */   GIR_RootConstrainSelectedInstOperands,
     /* 116927 */   // GIR_Coverage, 7085,
     /* 116927 */   GIR_EraseRootFromParent_Done,
     /* 116928 */ // Label 2185: @116928
     /* 116928 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(116980), // Rule ID 320 //
     /* 116933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116936 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116944 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116948 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116955 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 116958 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116978 */   GIR_RootConstrainSelectedInstOperands,
     /* 116979 */   // GIR_Coverage, 320,
     /* 116979 */   GIR_EraseRootFromParent_Done,
     /* 116980 */ // Label 2186: @116980
     /* 116980 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(117031), // Rule ID 323 //
     /* 116985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116988 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116999 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117003 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117010 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117013 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117025 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117029 */   GIR_RootConstrainSelectedInstOperands,
     /* 117030 */   // GIR_Coverage, 323,
     /* 117030 */   GIR_EraseRootFromParent_Done,
     /* 117031 */ // Label 2187: @117031
     /* 117031 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(117090), // Rule ID 326 //
     /* 117036 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117039 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117043 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117065 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117068 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117088 */   GIR_RootConstrainSelectedInstOperands,
     /* 117089 */   // GIR_Coverage, 326,
     /* 117089 */   GIR_EraseRootFromParent_Done,
     /* 117090 */ // Label 2188: @117090
     /* 117090 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(117149), // Rule ID 327 //
     /* 117095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117098 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117102 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117113 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117124 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117127 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117143 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117147 */   GIR_RootConstrainSelectedInstOperands,
     /* 117148 */   // GIR_Coverage, 327,
     /* 117148 */   GIR_EraseRootFromParent_Done,
     /* 117149 */ // Label 2189: @117149
     /* 117149 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(117203), // Rule ID 7065 //
     /* 117154 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117157 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117164 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117175 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 117182 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15880>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 117182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 117185 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117197 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117201 */   GIR_RootConstrainSelectedInstOperands,
     /* 117202 */   // GIR_Coverage, 7065,
     /* 117202 */   GIR_EraseRootFromParent_Done,
     /* 117203 */ // Label 2190: @117203
     /* 117203 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(117257), // Rule ID 7066 //
     /* 117208 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117211 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117218 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117236 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15880>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117239 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117251 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117255 */   GIR_RootConstrainSelectedInstOperands,
     /* 117256 */   // GIR_Coverage, 7066,
     /* 117256 */   GIR_EraseRootFromParent_Done,
     /* 117257 */ // Label 2191: @117257
     /* 117257 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(117311), // Rule ID 7070 //
     /* 117262 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117265 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117272 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117290 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15887>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 117293 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117309 */   GIR_RootConstrainSelectedInstOperands,
     /* 117310 */   // GIR_Coverage, 7070,
     /* 117310 */   GIR_EraseRootFromParent_Done,
     /* 117311 */ // Label 2192: @117311
     /* 117311 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(117365), // Rule ID 7071 //
     /* 117316 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117319 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117326 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117333 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117337 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117344 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15887>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117347 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117363 */   GIR_RootConstrainSelectedInstOperands,
     /* 117364 */   // GIR_Coverage, 7071,
     /* 117364 */   GIR_EraseRootFromParent_Done,
     /* 117365 */ // Label 2193: @117365
     /* 117365 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(117419), // Rule ID 7075 //
     /* 117370 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117373 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117380 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117387 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117391 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117398 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15894>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 117401 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117417 */   GIR_RootConstrainSelectedInstOperands,
     /* 117418 */   // GIR_Coverage, 7075,
     /* 117418 */   GIR_EraseRootFromParent_Done,
     /* 117419 */ // Label 2194: @117419
     /* 117419 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(117473), // Rule ID 7076 //
     /* 117424 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117427 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117434 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117441 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117452 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15894>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117455 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117467 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117471 */   GIR_RootConstrainSelectedInstOperands,
     /* 117472 */   // GIR_Coverage, 7076,
     /* 117472 */   GIR_EraseRootFromParent_Done,
     /* 117473 */ // Label 2195: @117473
     /* 117473 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(117530), // Rule ID 7408 //
     /* 117478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117481 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117484 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117491 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117498 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117502 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117509 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15878>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 117512 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117528 */   GIR_RootConstrainSelectedInstOperands,
     /* 117529 */   // GIR_Coverage, 7408,
     /* 117529 */   GIR_EraseRootFromParent_Done,
     /* 117530 */ // Label 2196: @117530
     /* 117530 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(117587), // Rule ID 7409 //
     /* 117535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117538 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117541 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117548 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117566 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15885>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 117569 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117585 */   GIR_RootConstrainSelectedInstOperands,
     /* 117586 */   // GIR_Coverage, 7409,
     /* 117586 */   GIR_EraseRootFromParent_Done,
     /* 117587 */ // Label 2197: @117587
     /* 117587 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(117644), // Rule ID 7410 //
     /* 117592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117595 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117598 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117605 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117612 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117616 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117623 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15892>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 117626 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117638 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117642 */   GIR_RootConstrainSelectedInstOperands,
     /* 117643 */   // GIR_Coverage, 7410,
     /* 117643 */   GIR_EraseRootFromParent_Done,
     /* 117644 */ // Label 2198: @117644
     /* 117644 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(117681), // Rule ID 7062 //
     /* 117649 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117659 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117666 */   // MIs[0] ptr
     /* 117666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117674 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15878>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 117679 */   GIR_RootConstrainSelectedInstOperands,
     /* 117680 */   // GIR_Coverage, 7062,
     /* 117680 */   GIR_Done,
     /* 117681 */ // Label 2199: @117681
     /* 117681 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(117718), // Rule ID 7067 //
     /* 117686 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117689 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117696 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117703 */   // MIs[0] ptr
     /* 117703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117711 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15885>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 117716 */   GIR_RootConstrainSelectedInstOperands,
     /* 117717 */   // GIR_Coverage, 7067,
     /* 117717 */   GIR_Done,
     /* 117718 */ // Label 2200: @117718
     /* 117718 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(117755), // Rule ID 7072 //
     /* 117723 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117726 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117733 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117740 */   // MIs[0] ptr
     /* 117740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117748 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15892>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 117753 */   GIR_RootConstrainSelectedInstOperands,
     /* 117754 */   // GIR_Coverage, 7072,
     /* 117754 */   GIR_Done,
     /* 117755 */ // Label 2201: @117755
     /* 117755 */ GIM_Reject,
     /* 117756 */ // Label 2100: @117756
     /* 117756 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(117862), // Rule ID 4488 //
     /* 117761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117776 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117780 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117784 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117789 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 117806 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 117806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117818 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 117837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117855 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117860 */   GIR_RootConstrainSelectedInstOperands,
     /* 117861 */   // GIR_Coverage, 4488,
     /* 117861 */   GIR_EraseRootFromParent_Done,
     /* 117862 */ // Label 2202: @117862
     /* 117862 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(117968), // Rule ID 4489 //
     /* 117867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117870 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117890 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117895 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117899 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117903 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117905 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 117912 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 117912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117924 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117930 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117935 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 117943 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117966 */   GIR_RootConstrainSelectedInstOperands,
     /* 117967 */   // GIR_Coverage, 4489,
     /* 117967 */   GIR_EraseRootFromParent_Done,
     /* 117968 */ // Label 2203: @117968
     /* 117968 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(118074), // Rule ID 4490 //
     /* 117973 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117988 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117992 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117996 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118001 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118018 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118030 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118036 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118041 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118067 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118072 */   GIR_RootConstrainSelectedInstOperands,
     /* 118073 */   // GIR_Coverage, 4490,
     /* 118073 */   GIR_EraseRootFromParent_Done,
     /* 118074 */ // Label 2204: @118074
     /* 118074 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(118180), // Rule ID 4491 //
     /* 118079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118086 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118090 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118094 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118098 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118102 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118107 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118111 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118124 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118136 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118147 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118178 */   GIR_RootConstrainSelectedInstOperands,
     /* 118179 */   // GIR_Coverage, 4491,
     /* 118179 */   GIR_EraseRootFromParent_Done,
     /* 118180 */ // Label 2205: @118180
     /* 118180 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(118281), // Rule ID 4514 //
     /* 118185 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118192 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118200 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118204 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118208 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118213 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118230 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118242 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118279 */   GIR_RootConstrainSelectedInstOperands,
     /* 118280 */   // GIR_Coverage, 4514,
     /* 118280 */   GIR_EraseRootFromParent_Done,
     /* 118281 */ // Label 2206: @118281
     /* 118281 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(118382), // Rule ID 4515 //
     /* 118286 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118301 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118305 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118309 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118314 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118318 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118322 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118324 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118331 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118343 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118354 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118380 */   GIR_RootConstrainSelectedInstOperands,
     /* 118381 */   // GIR_Coverage, 4515,
     /* 118381 */   GIR_EraseRootFromParent_Done,
     /* 118382 */ // Label 2207: @118382
     /* 118382 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(118483), // Rule ID 4541 //
     /* 118387 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118390 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118394 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118398 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118402 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118406 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118410 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118415 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118419 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118423 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118425 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118432 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118444 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118450 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118455 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118481 */   GIR_RootConstrainSelectedInstOperands,
     /* 118482 */   // GIR_Coverage, 4541,
     /* 118482 */   GIR_EraseRootFromParent_Done,
     /* 118483 */ // Label 2208: @118483
     /* 118483 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(118584), // Rule ID 4542 //
     /* 118488 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118491 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118503 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118507 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118511 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118516 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118520 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118526 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118533 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118545 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118551 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118556 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118582 */   GIR_RootConstrainSelectedInstOperands,
     /* 118583 */   // GIR_Coverage, 4542,
     /* 118583 */   GIR_EraseRootFromParent_Done,
     /* 118584 */ // Label 2209: @118584
     /* 118584 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(118659), // Rule ID 6455 //
     /* 118589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118604 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118608 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118612 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118617 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 118621 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118625 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 118629 */   // MIs[2] Operand 1
     /* 118629 */   // No operand predicates
     /* 118629 */   // MIs[0] Rn
     /* 118629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118637 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118639 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 118639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 118642 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 118646 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 118649 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 118651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118657 */   GIR_RootConstrainSelectedInstOperands,
     /* 118658 */   // GIR_Coverage, 6455,
     /* 118658 */   GIR_EraseRootFromParent_Done,
     /* 118659 */ // Label 2210: @118659
     /* 118659 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(118734), // Rule ID 6456 //
     /* 118664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118679 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118687 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118692 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 118696 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118700 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 118704 */   // MIs[2] Operand 1
     /* 118704 */   // No operand predicates
     /* 118704 */   // MIs[0] Rn
     /* 118704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118712 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118714 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 118714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 118717 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 118721 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 118724 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 118726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118732 */   GIR_RootConstrainSelectedInstOperands,
     /* 118733 */   // GIR_Coverage, 6456,
     /* 118733 */   GIR_EraseRootFromParent_Done,
     /* 118734 */ // Label 2211: @118734
     /* 118734 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(118787), // Rule ID 301 //
     /* 118739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118750 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118754 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118761 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 118764 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118781 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118785 */   GIR_RootConstrainSelectedInstOperands,
     /* 118786 */   // GIR_Coverage, 301,
     /* 118786 */   GIR_EraseRootFromParent_Done,
     /* 118787 */ // Label 2212: @118787
     /* 118787 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(118840), // Rule ID 302 //
     /* 118792 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118795 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118803 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118807 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118814 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 118817 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118838 */   GIR_RootConstrainSelectedInstOperands,
     /* 118839 */   // GIR_Coverage, 302,
     /* 118839 */   GIR_EraseRootFromParent_Done,
     /* 118840 */ // Label 2213: @118840
     /* 118840 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(118896), // Rule ID 309 //
     /* 118845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118851 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118870 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118873 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118894 */   GIR_RootConstrainSelectedInstOperands,
     /* 118895 */   // GIR_Coverage, 309,
     /* 118895 */   GIR_EraseRootFromParent_Done,
     /* 118896 */ // Label 2214: @118896
     /* 118896 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(118952), // Rule ID 310 //
     /* 118901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118904 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118907 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118919 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118926 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118929 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118950 */   GIR_RootConstrainSelectedInstOperands,
     /* 118951 */   // GIR_Coverage, 310,
     /* 118951 */   GIR_EraseRootFromParent_Done,
     /* 118952 */ // Label 2215: @118952
     /* 118952 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(119041), // Rule ID 4446 //
     /* 118957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118960 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118964 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118979 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118986 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118998 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119004 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 119017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119039 */   GIR_RootConstrainSelectedInstOperands,
     /* 119040 */   // GIR_Coverage, 4446,
     /* 119040 */   GIR_EraseRootFromParent_Done,
     /* 119041 */ // Label 2216: @119041
     /* 119041 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(119130), // Rule ID 4447 //
     /* 119046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119049 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119053 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119064 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119068 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119075 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 119075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119087 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119093 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 119106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119128 */   GIR_RootConstrainSelectedInstOperands,
     /* 119129 */   // GIR_Coverage, 4447,
     /* 119129 */   GIR_EraseRootFromParent_Done,
     /* 119130 */ // Label 2217: @119130
     /* 119130 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(119219), // Rule ID 4448 //
     /* 119135 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119138 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119142 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119157 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119164 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119176 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119182 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 119195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119217 */   GIR_RootConstrainSelectedInstOperands,
     /* 119218 */   // GIR_Coverage, 4448,
     /* 119218 */   GIR_EraseRootFromParent_Done,
     /* 119219 */ // Label 2218: @119219
     /* 119219 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(119308), // Rule ID 4449 //
     /* 119224 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119227 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119231 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119253 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119265 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119271 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 119284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119306 */   GIR_RootConstrainSelectedInstOperands,
     /* 119307 */   // GIR_Coverage, 4449,
     /* 119307 */   GIR_EraseRootFromParent_Done,
     /* 119308 */ // Label 2219: @119308
     /* 119308 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(119397), // Rule ID 4450 //
     /* 119313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119316 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119342 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119354 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 119373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119395 */   GIR_RootConstrainSelectedInstOperands,
     /* 119396 */   // GIR_Coverage, 4450,
     /* 119396 */   GIR_EraseRootFromParent_Done,
     /* 119397 */ // Label 2220: @119397
     /* 119397 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(119486), // Rule ID 4451 //
     /* 119402 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119405 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119409 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119420 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119424 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119431 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119443 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119449 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119454 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 119462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119484 */   GIR_RootConstrainSelectedInstOperands,
     /* 119485 */   // GIR_Coverage, 4451,
     /* 119485 */   GIR_EraseRootFromParent_Done,
     /* 119486 */ // Label 2221: @119486
     /* 119486 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(119539), // Rule ID 4462 //
     /* 119491 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119494 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119506 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119513 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119516 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119533 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119537 */   GIR_RootConstrainSelectedInstOperands,
     /* 119538 */   // GIR_Coverage, 4462,
     /* 119538 */   GIR_EraseRootFromParent_Done,
     /* 119539 */ // Label 2222: @119539
     /* 119539 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(119592), // Rule ID 4463 //
     /* 119544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119566 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119569 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119590 */   GIR_RootConstrainSelectedInstOperands,
     /* 119591 */   // GIR_Coverage, 4463,
     /* 119591 */   GIR_EraseRootFromParent_Done,
     /* 119592 */ // Label 2223: @119592
     /* 119592 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(119645), // Rule ID 4464 //
     /* 119597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119600 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119619 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119622 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119643 */   GIR_RootConstrainSelectedInstOperands,
     /* 119644 */   // GIR_Coverage, 4464,
     /* 119644 */   GIR_EraseRootFromParent_Done,
     /* 119645 */ // Label 2224: @119645
     /* 119645 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(119698), // Rule ID 4465 //
     /* 119650 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119653 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119661 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119665 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119672 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119675 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119692 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119696 */   GIR_RootConstrainSelectedInstOperands,
     /* 119697 */   // GIR_Coverage, 4465,
     /* 119697 */   GIR_EraseRootFromParent_Done,
     /* 119698 */ // Label 2225: @119698
     /* 119698 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(119750), // Rule ID 311 //
     /* 119703 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119706 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119725 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 119728 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 119734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119744 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119748 */   GIR_RootConstrainSelectedInstOperands,
     /* 119749 */   // GIR_Coverage, 311,
     /* 119749 */   GIR_EraseRootFromParent_Done,
     /* 119750 */ // Label 2226: @119750
     /* 119750 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(119801), // Rule ID 316 //
     /* 119755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119761 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119769 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119773 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119780 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119783 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119799 */   GIR_RootConstrainSelectedInstOperands,
     /* 119800 */   // GIR_Coverage, 316,
     /* 119800 */   GIR_EraseRootFromParent_Done,
     /* 119801 */ // Label 2227: @119801
     /* 119801 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(119849), // Rule ID 4492 //
     /* 119806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119828 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119831 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119847 */   GIR_RootConstrainSelectedInstOperands,
     /* 119848 */   // GIR_Coverage, 4492,
     /* 119848 */   GIR_EraseRootFromParent_Done,
     /* 119849 */ // Label 2228: @119849
     /* 119849 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(119897), // Rule ID 4493 //
     /* 119854 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119857 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119865 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119869 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119876 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119879 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119895 */   GIR_RootConstrainSelectedInstOperands,
     /* 119896 */   // GIR_Coverage, 4493,
     /* 119896 */   GIR_EraseRootFromParent_Done,
     /* 119897 */ // Label 2229: @119897
     /* 119897 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(119981), // Rule ID 4507 //
     /* 119902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119905 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119909 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119920 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119924 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119931 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119931 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119934 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119938 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119943 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119949 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119954 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 119962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119975 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119979 */   GIR_RootConstrainSelectedInstOperands,
     /* 119980 */   // GIR_Coverage, 4507,
     /* 119980 */   GIR_EraseRootFromParent_Done,
     /* 119981 */ // Label 2230: @119981
     /* 119981 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(120065), // Rule ID 4508 //
     /* 119986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119989 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120015 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120027 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120033 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120038 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 120046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120063 */   GIR_RootConstrainSelectedInstOperands,
     /* 120064 */   // GIR_Coverage, 4508,
     /* 120064 */   GIR_EraseRootFromParent_Done,
     /* 120065 */ // Label 2231: @120065
     /* 120065 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(120149), // Rule ID 4509 //
     /* 120070 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120073 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120077 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120088 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120092 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120099 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120111 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120117 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 120130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120143 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120147 */   GIR_RootConstrainSelectedInstOperands,
     /* 120148 */   // GIR_Coverage, 4509,
     /* 120148 */   GIR_EraseRootFromParent_Done,
     /* 120149 */ // Label 2232: @120149
     /* 120149 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(120226), // Rule ID 7086 //
     /* 120154 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120157 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120164 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120175 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120179 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120190 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120197 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15901>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120200 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120219 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120224 */   GIR_RootConstrainSelectedInstOperands,
     /* 120225 */   // GIR_Coverage, 7086,
     /* 120225 */   GIR_EraseRootFromParent_Done,
     /* 120226 */ // Label 2233: @120226
     /* 120226 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(120303), // Rule ID 7087 //
     /* 120231 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120234 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120241 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120252 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120256 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120265 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120267 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120274 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15901>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120277 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120296 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120301 */   GIR_RootConstrainSelectedInstOperands,
     /* 120302 */   // GIR_Coverage, 7087,
     /* 120302 */   GIR_EraseRootFromParent_Done,
     /* 120303 */ // Label 2234: @120303
     /* 120303 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(120362), // Rule ID 7078 //
     /* 120308 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120311 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120318 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120325 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120329 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120336 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15901>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 120339 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120360 */   GIR_RootConstrainSelectedInstOperands,
     /* 120361 */   // GIR_Coverage, 7078,
     /* 120361 */   GIR_EraseRootFromParent_Done,
     /* 120362 */ // Label 2235: @120362
     /* 120362 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(120421), // Rule ID 7079 //
     /* 120367 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120370 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120377 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120384 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120388 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120395 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15901>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 120398 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120419 */   GIR_RootConstrainSelectedInstOperands,
     /* 120420 */   // GIR_Coverage, 7079,
     /* 120420 */   GIR_EraseRootFromParent_Done,
     /* 120421 */ // Label 2236: @120421
     /* 120421 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(120493), // Rule ID 7088 //
     /* 120426 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120429 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120436 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120447 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120451 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120456 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120462 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120469 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15901>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120472 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120491 */   GIR_RootConstrainSelectedInstOperands,
     /* 120492 */   // GIR_Coverage, 7088,
     /* 120492 */   GIR_EraseRootFromParent_Done,
     /* 120493 */ // Label 2237: @120493
     /* 120493 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(120565), // Rule ID 7089 //
     /* 120498 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120508 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120511 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120519 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120523 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120528 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120532 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120541 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15901>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120544 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120558 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120563 */   GIR_RootConstrainSelectedInstOperands,
     /* 120564 */   // GIR_Coverage, 7089,
     /* 120564 */   GIR_EraseRootFromParent_Done,
     /* 120565 */ // Label 2238: @120565
     /* 120565 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(120662), // Rule ID 7400 //
     /* 120570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 120573 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120576 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120583 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120586 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120590 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120594 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120598 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 120602 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 120606 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 120610 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 120614 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120619 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 120623 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120627 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 120631 */   // MIs[3] Operand 1
     /* 120631 */   // No operand predicates
     /* 120631 */   // MIs[0] Rn
     /* 120631 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120639 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 120641 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15899>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 120641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 120644 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 120648 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 120651 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 120653 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 120660 */   GIR_RootConstrainSelectedInstOperands,
     /* 120661 */   // GIR_Coverage, 7400,
     /* 120661 */   GIR_EraseRootFromParent_Done,
     /* 120662 */ // Label 2239: @120662
     /* 120662 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(120714), // Rule ID 319 //
     /* 120667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120670 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120678 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120682 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120689 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 120692 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 120698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120708 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120712 */   GIR_RootConstrainSelectedInstOperands,
     /* 120713 */   // GIR_Coverage, 319,
     /* 120713 */   GIR_EraseRootFromParent_Done,
     /* 120714 */ // Label 2240: @120714
     /* 120714 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(120765), // Rule ID 324 //
     /* 120719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120725 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120744 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120747 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120759 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120763 */   GIR_RootConstrainSelectedInstOperands,
     /* 120764 */   // GIR_Coverage, 324,
     /* 120764 */   GIR_EraseRootFromParent_Done,
     /* 120765 */ // Label 2241: @120765
     /* 120765 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(120819), // Rule ID 7080 //
     /* 120770 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120773 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120780 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120787 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120791 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120798 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15901>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 120801 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120813 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120817 */   GIR_RootConstrainSelectedInstOperands,
     /* 120818 */   // GIR_Coverage, 7080,
     /* 120818 */   GIR_EraseRootFromParent_Done,
     /* 120819 */ // Label 2242: @120819
     /* 120819 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(120873), // Rule ID 7081 //
     /* 120824 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120827 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120834 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120852 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15901>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 120855 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120871 */   GIR_RootConstrainSelectedInstOperands,
     /* 120872 */   // GIR_Coverage, 7081,
     /* 120872 */   GIR_EraseRootFromParent_Done,
     /* 120873 */ // Label 2243: @120873
     /* 120873 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(120930), // Rule ID 7411 //
     /* 120878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 120881 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120891 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120898 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120902 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120909 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15899>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 120912 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120924 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120928 */   GIR_RootConstrainSelectedInstOperands,
     /* 120929 */   // GIR_Coverage, 7411,
     /* 120929 */   GIR_EraseRootFromParent_Done,
     /* 120930 */ // Label 2244: @120930
     /* 120930 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(120978), // Rule ID 4516 //
     /* 120935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120938 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120946 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120950 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120957 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120960 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120976 */   GIR_RootConstrainSelectedInstOperands,
     /* 120977 */   // GIR_Coverage, 4516,
     /* 120977 */   GIR_EraseRootFromParent_Done,
     /* 120978 */ // Label 2245: @120978
     /* 120978 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(121026), // Rule ID 4517 //
     /* 120983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120986 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121005 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121008 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121020 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121024 */   GIR_RootConstrainSelectedInstOperands,
     /* 121025 */   // GIR_Coverage, 4517,
     /* 121025 */   GIR_EraseRootFromParent_Done,
     /* 121026 */ // Label 2246: @121026
     /* 121026 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(121110), // Rule ID 4532 //
     /* 121031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121034 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121038 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121049 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121053 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121060 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121072 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 121091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121104 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121108 */   GIR_RootConstrainSelectedInstOperands,
     /* 121109 */   // GIR_Coverage, 4532,
     /* 121109 */   GIR_EraseRootFromParent_Done,
     /* 121110 */ // Label 2247: @121110
     /* 121110 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(121194), // Rule ID 4533 //
     /* 121115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121118 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121137 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121144 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121156 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121162 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121167 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 121175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121192 */   GIR_RootConstrainSelectedInstOperands,
     /* 121193 */   // GIR_Coverage, 4533,
     /* 121193 */   GIR_EraseRootFromParent_Done,
     /* 121194 */ // Label 2248: @121194
     /* 121194 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(121278), // Rule ID 4534 //
     /* 121199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121202 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121217 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121221 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121228 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121240 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121246 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 121259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121276 */   GIR_RootConstrainSelectedInstOperands,
     /* 121277 */   // GIR_Coverage, 4534,
     /* 121277 */   GIR_EraseRootFromParent_Done,
     /* 121278 */ // Label 2249: @121278
     /* 121278 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(121362), // Rule ID 7399 //
     /* 121283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121286 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121289 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121296 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 121307 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 121311 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121315 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121320 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 121324 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121328 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 121332 */   // MIs[2] Operand 1
     /* 121332 */   // No operand predicates
     /* 121332 */   // MIs[0] Rn
     /* 121332 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121340 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121342 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15899>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 121342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121345 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 121349 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 121352 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121360 */   GIR_RootConstrainSelectedInstOperands,
     /* 121361 */   // GIR_Coverage, 7399,
     /* 121361 */   GIR_EraseRootFromParent_Done,
     /* 121362 */ // Label 2250: @121362
     /* 121362 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(121460), // Rule ID 7401 //
     /* 121367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121370 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121373 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121380 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121383 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121391 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121395 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121400 */   // MIs[0] Rn
     /* 121400 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121410 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15899>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 121410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 121413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121422 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 121425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 121429 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 121432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121445 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121451 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121458 */   GIR_RootConstrainSelectedInstOperands,
     /* 121459 */   // GIR_Coverage, 7401,
     /* 121459 */   GIR_EraseRootFromParent_Done,
     /* 121460 */ // Label 2251: @121460
     /* 121460 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(121497), // Rule ID 7077 //
     /* 121465 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121468 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121475 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121482 */   // MIs[0] ptr
     /* 121482 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121490 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15899>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 121490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 121495 */   GIR_RootConstrainSelectedInstOperands,
     /* 121496 */   // GIR_Coverage, 7077,
     /* 121496 */   GIR_Done,
     /* 121497 */ // Label 2252: @121497
     /* 121497 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(121524), // Rule ID 6405 //
     /* 121502 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121505 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121509 */   // MIs[0] Rn
     /* 121509 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121517 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 121517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 121522 */   GIR_RootConstrainSelectedInstOperands,
     /* 121523 */   // GIR_Coverage, 6405,
     /* 121523 */   GIR_Done,
     /* 121524 */ // Label 2253: @121524
     /* 121524 */ GIM_Reject,
     /* 121525 */ // Label 2101: @121525
     /* 121525 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(121730),
     /* 121530 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121533 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121545 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(121586), // Rule ID 4444 //
     /* 121550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 121553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 121560 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 121560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 121563 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121584 */     GIR_RootConstrainSelectedInstOperands,
     /* 121585 */     // GIR_Coverage, 4444,
     /* 121585 */     GIR_EraseRootFromParent_Done,
     /* 121586 */   // Label 2255: @121586
     /* 121586 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(121627), // Rule ID 4445 //
     /* 121591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 121594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 121601 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 121601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 121604 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121625 */     GIR_RootConstrainSelectedInstOperands,
     /* 121626 */     // GIR_Coverage, 4445,
     /* 121626 */     GIR_EraseRootFromParent_Done,
     /* 121627 */   // Label 2256: @121627
     /* 121627 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(121660), // Rule ID 4499 //
     /* 121632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 121639 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 121639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 121642 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121658 */     GIR_RootConstrainSelectedInstOperands,
     /* 121659 */     // GIR_Coverage, 4499,
     /* 121659 */     GIR_EraseRootFromParent_Done,
     /* 121660 */   // Label 2257: @121660
     /* 121660 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(121693), // Rule ID 4523 //
     /* 121665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121672 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121675 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121691 */     GIR_RootConstrainSelectedInstOperands,
     /* 121692 */     // GIR_Coverage, 4523,
     /* 121692 */     GIR_EraseRootFromParent_Done,
     /* 121693 */   // Label 2258: @121693
     /* 121693 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(121729), // Rule ID 325 //
     /* 121698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121708 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121711 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121727 */     GIR_RootConstrainSelectedInstOperands,
     /* 121728 */     // GIR_Coverage, 325,
     /* 121728 */     GIR_EraseRootFromParent_Done,
     /* 121729 */   // Label 2259: @121729
     /* 121729 */   GIM_Reject,
     /* 121730 */ // Label 2254: @121730
     /* 121730 */ GIM_Reject,
     /* 121731 */ // Label 2102: @121731
     /* 121731 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(122136),
     /* 121736 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121739 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121743 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(121792), // Rule ID 4452 //
     /* 121748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121766 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121769 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121790 */     GIR_RootConstrainSelectedInstOperands,
     /* 121791 */     // GIR_Coverage, 4452,
     /* 121791 */     GIR_EraseRootFromParent_Done,
     /* 121792 */   // Label 2261: @121792
     /* 121792 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(121841), // Rule ID 4453 //
     /* 121797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121815 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121818 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121839 */     GIR_RootConstrainSelectedInstOperands,
     /* 121840 */     // GIR_Coverage, 4453,
     /* 121840 */     GIR_EraseRootFromParent_Done,
     /* 121841 */   // Label 2262: @121841
     /* 121841 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(121890), // Rule ID 4454 //
     /* 121846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121864 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121867 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121888 */     GIR_RootConstrainSelectedInstOperands,
     /* 121889 */     // GIR_Coverage, 4454,
     /* 121889 */     GIR_EraseRootFromParent_Done,
     /* 121890 */   // Label 2263: @121890
     /* 121890 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(121939), // Rule ID 4455 //
     /* 121895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121913 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121916 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121937 */     GIR_RootConstrainSelectedInstOperands,
     /* 121938 */     // GIR_Coverage, 4455,
     /* 121938 */     GIR_EraseRootFromParent_Done,
     /* 121939 */   // Label 2264: @121939
     /* 121939 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(121983), // Rule ID 4494 //
     /* 121944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121962 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121965 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121981 */     GIR_RootConstrainSelectedInstOperands,
     /* 121982 */     // GIR_Coverage, 4494,
     /* 121982 */     GIR_EraseRootFromParent_Done,
     /* 121983 */   // Label 2265: @121983
     /* 121983 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(122027), // Rule ID 4497 //
     /* 121988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122006 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122009 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122025 */     GIR_RootConstrainSelectedInstOperands,
     /* 122026 */     // GIR_Coverage, 4497,
     /* 122026 */     GIR_EraseRootFromParent_Done,
     /* 122027 */   // Label 2266: @122027
     /* 122027 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(122071), // Rule ID 4518 //
     /* 122032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122050 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122053 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122069 */     GIR_RootConstrainSelectedInstOperands,
     /* 122070 */     // GIR_Coverage, 4518,
     /* 122070 */     GIR_EraseRootFromParent_Done,
     /* 122071 */   // Label 2267: @122071
     /* 122071 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(122115), // Rule ID 4521 //
     /* 122076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122094 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122097 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122113 */     GIR_RootConstrainSelectedInstOperands,
     /* 122114 */     // GIR_Coverage, 4521,
     /* 122114 */     GIR_EraseRootFromParent_Done,
     /* 122115 */   // Label 2268: @122115
     /* 122115 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(122135), // Rule ID 6404 //
     /* 122120 */     // MIs[0] Rn
     /* 122120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122128 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 122133 */     GIR_RootConstrainSelectedInstOperands,
     /* 122134 */     // GIR_Coverage, 6404,
     /* 122134 */     GIR_Done,
     /* 122135 */   // Label 2269: @122135
     /* 122135 */   GIM_Reject,
     /* 122136 */ // Label 2260: @122136
     /* 122136 */ GIM_Reject,
     /* 122137 */ // Label 2103: @122137
     /* 122137 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(122586),
     /* 122142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122145 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122149 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(122198), // Rule ID 4466 //
     /* 122154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122172 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122175 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122196 */     GIR_RootConstrainSelectedInstOperands,
     /* 122197 */     // GIR_Coverage, 4466,
     /* 122197 */     GIR_EraseRootFromParent_Done,
     /* 122198 */   // Label 2271: @122198
     /* 122198 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(122247), // Rule ID 4467 //
     /* 122203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122221 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122224 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122245 */     GIR_RootConstrainSelectedInstOperands,
     /* 122246 */     // GIR_Coverage, 4467,
     /* 122246 */     GIR_EraseRootFromParent_Done,
     /* 122247 */   // Label 2272: @122247
     /* 122247 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(122296), // Rule ID 4468 //
     /* 122252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122270 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122273 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122294 */     GIR_RootConstrainSelectedInstOperands,
     /* 122295 */     // GIR_Coverage, 4468,
     /* 122295 */     GIR_EraseRootFromParent_Done,
     /* 122296 */   // Label 2273: @122296
     /* 122296 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(122345), // Rule ID 4469 //
     /* 122301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122319 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122322 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122343 */     GIR_RootConstrainSelectedInstOperands,
     /* 122344 */     // GIR_Coverage, 4469,
     /* 122344 */     GIR_EraseRootFromParent_Done,
     /* 122345 */   // Label 2274: @122345
     /* 122345 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(122389), // Rule ID 4501 //
     /* 122350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122368 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122371 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122387 */     GIR_RootConstrainSelectedInstOperands,
     /* 122388 */     // GIR_Coverage, 4501,
     /* 122388 */     GIR_EraseRootFromParent_Done,
     /* 122389 */   // Label 2275: @122389
     /* 122389 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(122433), // Rule ID 4505 //
     /* 122394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122412 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122415 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122431 */     GIR_RootConstrainSelectedInstOperands,
     /* 122432 */     // GIR_Coverage, 4505,
     /* 122432 */     GIR_EraseRootFromParent_Done,
     /* 122433 */   // Label 2276: @122433
     /* 122433 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(122477), // Rule ID 4525 //
     /* 122438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122456 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122459 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122475 */     GIR_RootConstrainSelectedInstOperands,
     /* 122476 */     // GIR_Coverage, 4525,
     /* 122476 */     GIR_EraseRootFromParent_Done,
     /* 122477 */   // Label 2277: @122477
     /* 122477 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(122521), // Rule ID 4529 //
     /* 122482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122500 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122503 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122519 */     GIR_RootConstrainSelectedInstOperands,
     /* 122520 */     // GIR_Coverage, 4529,
     /* 122520 */     GIR_EraseRootFromParent_Done,
     /* 122521 */   // Label 2278: @122521
     /* 122521 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(122565), // Rule ID 4530 //
     /* 122526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122544 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122547 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122563 */     GIR_RootConstrainSelectedInstOperands,
     /* 122564 */     // GIR_Coverage, 4530,
     /* 122564 */     GIR_EraseRootFromParent_Done,
     /* 122565 */   // Label 2279: @122565
     /* 122565 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(122585), // Rule ID 6401 //
     /* 122570 */     // MIs[0] Rn
     /* 122570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122578 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 122583 */     GIR_RootConstrainSelectedInstOperands,
     /* 122584 */     // GIR_Coverage, 6401,
     /* 122584 */     GIR_Done,
     /* 122585 */   // Label 2280: @122585
     /* 122585 */   GIM_Reject,
     /* 122586 */ // Label 2270: @122586
     /* 122586 */ GIM_Reject,
     /* 122587 */ // Label 2104: @122587
     /* 122587 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(122992),
     /* 122592 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122595 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122599 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(122648), // Rule ID 4456 //
     /* 122604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122622 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122625 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122646 */     GIR_RootConstrainSelectedInstOperands,
     /* 122647 */     // GIR_Coverage, 4456,
     /* 122647 */     GIR_EraseRootFromParent_Done,
     /* 122648 */   // Label 2282: @122648
     /* 122648 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(122697), // Rule ID 4457 //
     /* 122653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122671 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122674 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122695 */     GIR_RootConstrainSelectedInstOperands,
     /* 122696 */     // GIR_Coverage, 4457,
     /* 122696 */     GIR_EraseRootFromParent_Done,
     /* 122697 */   // Label 2283: @122697
     /* 122697 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(122746), // Rule ID 4460 //
     /* 122702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122720 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122723 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122744 */     GIR_RootConstrainSelectedInstOperands,
     /* 122745 */     // GIR_Coverage, 4460,
     /* 122745 */     GIR_EraseRootFromParent_Done,
     /* 122746 */   // Label 2284: @122746
     /* 122746 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(122795), // Rule ID 4461 //
     /* 122751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122769 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122772 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122793 */     GIR_RootConstrainSelectedInstOperands,
     /* 122794 */     // GIR_Coverage, 4461,
     /* 122794 */     GIR_EraseRootFromParent_Done,
     /* 122795 */   // Label 2285: @122795
     /* 122795 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(122839), // Rule ID 4496 //
     /* 122800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122818 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122821 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122837 */     GIR_RootConstrainSelectedInstOperands,
     /* 122838 */     // GIR_Coverage, 4496,
     /* 122838 */     GIR_EraseRootFromParent_Done,
     /* 122839 */   // Label 2286: @122839
     /* 122839 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(122883), // Rule ID 4498 //
     /* 122844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122862 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122865 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122881 */     GIR_RootConstrainSelectedInstOperands,
     /* 122882 */     // GIR_Coverage, 4498,
     /* 122882 */     GIR_EraseRootFromParent_Done,
     /* 122883 */   // Label 2287: @122883
     /* 122883 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(122927), // Rule ID 4520 //
     /* 122888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122906 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122909 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122925 */     GIR_RootConstrainSelectedInstOperands,
     /* 122926 */     // GIR_Coverage, 4520,
     /* 122926 */     GIR_EraseRootFromParent_Done,
     /* 122927 */   // Label 2288: @122927
     /* 122927 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(122971), // Rule ID 4522 //
     /* 122932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122950 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122953 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122969 */     GIR_RootConstrainSelectedInstOperands,
     /* 122970 */     // GIR_Coverage, 4522,
     /* 122970 */     GIR_EraseRootFromParent_Done,
     /* 122971 */   // Label 2289: @122971
     /* 122971 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(122991), // Rule ID 6403 //
     /* 122976 */     // MIs[0] Rn
     /* 122976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122984 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 122989 */     GIR_RootConstrainSelectedInstOperands,
     /* 122990 */     // GIR_Coverage, 6403,
     /* 122990 */     GIR_Done,
     /* 122991 */   // Label 2290: @122991
     /* 122991 */   GIM_Reject,
     /* 122992 */ // Label 2281: @122992
     /* 122992 */ GIM_Reject,
     /* 122993 */ // Label 2105: @122993
     /* 122993 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(123398),
     /* 122998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123001 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123005 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(123054), // Rule ID 4470 //
     /* 123010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123028 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123031 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123052 */     GIR_RootConstrainSelectedInstOperands,
     /* 123053 */     // GIR_Coverage, 4470,
     /* 123053 */     GIR_EraseRootFromParent_Done,
     /* 123054 */   // Label 2292: @123054
     /* 123054 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(123103), // Rule ID 4471 //
     /* 123059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123077 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123080 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123101 */     GIR_RootConstrainSelectedInstOperands,
     /* 123102 */     // GIR_Coverage, 4471,
     /* 123102 */     GIR_EraseRootFromParent_Done,
     /* 123103 */   // Label 2293: @123103
     /* 123103 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(123152), // Rule ID 4472 //
     /* 123108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123126 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123129 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123150 */     GIR_RootConstrainSelectedInstOperands,
     /* 123151 */     // GIR_Coverage, 4472,
     /* 123151 */     GIR_EraseRootFromParent_Done,
     /* 123152 */   // Label 2294: @123152
     /* 123152 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(123201), // Rule ID 4473 //
     /* 123157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123175 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123178 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123199 */     GIR_RootConstrainSelectedInstOperands,
     /* 123200 */     // GIR_Coverage, 4473,
     /* 123200 */     GIR_EraseRootFromParent_Done,
     /* 123201 */   // Label 2295: @123201
     /* 123201 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(123245), // Rule ID 4500 //
     /* 123206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123224 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123227 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123243 */     GIR_RootConstrainSelectedInstOperands,
     /* 123244 */     // GIR_Coverage, 4500,
     /* 123244 */     GIR_EraseRootFromParent_Done,
     /* 123245 */   // Label 2296: @123245
     /* 123245 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(123289), // Rule ID 4504 //
     /* 123250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123268 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123271 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123287 */     GIR_RootConstrainSelectedInstOperands,
     /* 123288 */     // GIR_Coverage, 4504,
     /* 123288 */     GIR_EraseRootFromParent_Done,
     /* 123289 */   // Label 2297: @123289
     /* 123289 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(123333), // Rule ID 4524 //
     /* 123294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123312 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123315 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123331 */     GIR_RootConstrainSelectedInstOperands,
     /* 123332 */     // GIR_Coverage, 4524,
     /* 123332 */     GIR_EraseRootFromParent_Done,
     /* 123333 */   // Label 2298: @123333
     /* 123333 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(123377), // Rule ID 4528 //
     /* 123338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123356 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123359 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123375 */     GIR_RootConstrainSelectedInstOperands,
     /* 123376 */     // GIR_Coverage, 4528,
     /* 123376 */     GIR_EraseRootFromParent_Done,
     /* 123377 */   // Label 2299: @123377
     /* 123377 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(123397), // Rule ID 6400 //
     /* 123382 */     // MIs[0] Rn
     /* 123382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123390 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 123395 */     GIR_RootConstrainSelectedInstOperands,
     /* 123396 */     // GIR_Coverage, 6400,
     /* 123396 */     GIR_Done,
     /* 123397 */   // Label 2300: @123397
     /* 123397 */   GIM_Reject,
     /* 123398 */ // Label 2291: @123398
     /* 123398 */ GIM_Reject,
     /* 123399 */ // Label 2106: @123399
     /* 123399 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(123618),
     /* 123404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123407 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123411 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(123460), // Rule ID 4458 //
     /* 123416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123434 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123437 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123458 */     GIR_RootConstrainSelectedInstOperands,
     /* 123459 */     // GIR_Coverage, 4458,
     /* 123459 */     GIR_EraseRootFromParent_Done,
     /* 123460 */   // Label 2302: @123460
     /* 123460 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(123509), // Rule ID 4459 //
     /* 123465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123483 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123486 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123507 */     GIR_RootConstrainSelectedInstOperands,
     /* 123508 */     // GIR_Coverage, 4459,
     /* 123508 */     GIR_EraseRootFromParent_Done,
     /* 123509 */   // Label 2303: @123509
     /* 123509 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(123553), // Rule ID 4495 //
     /* 123514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123532 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123535 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123551 */     GIR_RootConstrainSelectedInstOperands,
     /* 123552 */     // GIR_Coverage, 4495,
     /* 123552 */     GIR_EraseRootFromParent_Done,
     /* 123553 */   // Label 2304: @123553
     /* 123553 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(123597), // Rule ID 4519 //
     /* 123558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123576 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123579 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123595 */     GIR_RootConstrainSelectedInstOperands,
     /* 123596 */     // GIR_Coverage, 4519,
     /* 123596 */     GIR_EraseRootFromParent_Done,
     /* 123597 */   // Label 2305: @123597
     /* 123597 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(123617), // Rule ID 6402 //
     /* 123602 */     // MIs[0] Rn
     /* 123602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123610 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 123615 */     GIR_RootConstrainSelectedInstOperands,
     /* 123616 */     // GIR_Coverage, 6402,
     /* 123616 */     GIR_Done,
     /* 123617 */   // Label 2306: @123617
     /* 123617 */   GIM_Reject,
     /* 123618 */ // Label 2301: @123618
     /* 123618 */ GIM_Reject,
     /* 123619 */ // Label 2107: @123619
     /* 123619 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(124024),
     /* 123624 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123627 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123631 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(123680), // Rule ID 4474 //
     /* 123636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123654 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123657 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123678 */     GIR_RootConstrainSelectedInstOperands,
     /* 123679 */     // GIR_Coverage, 4474,
     /* 123679 */     GIR_EraseRootFromParent_Done,
     /* 123680 */   // Label 2308: @123680
     /* 123680 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(123729), // Rule ID 4475 //
     /* 123685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123703 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123706 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123727 */     GIR_RootConstrainSelectedInstOperands,
     /* 123728 */     // GIR_Coverage, 4475,
     /* 123728 */     GIR_EraseRootFromParent_Done,
     /* 123729 */   // Label 2309: @123729
     /* 123729 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(123778), // Rule ID 4478 //
     /* 123734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123752 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123755 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123776 */     GIR_RootConstrainSelectedInstOperands,
     /* 123777 */     // GIR_Coverage, 4478,
     /* 123777 */     GIR_EraseRootFromParent_Done,
     /* 123778 */   // Label 2310: @123778
     /* 123778 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(123827), // Rule ID 4479 //
     /* 123783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123801 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123804 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123825 */     GIR_RootConstrainSelectedInstOperands,
     /* 123826 */     // GIR_Coverage, 4479,
     /* 123826 */     GIR_EraseRootFromParent_Done,
     /* 123827 */   // Label 2311: @123827
     /* 123827 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(123871), // Rule ID 4503 //
     /* 123832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123850 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123853 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123869 */     GIR_RootConstrainSelectedInstOperands,
     /* 123870 */     // GIR_Coverage, 4503,
     /* 123870 */     GIR_EraseRootFromParent_Done,
     /* 123871 */   // Label 2312: @123871
     /* 123871 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(123915), // Rule ID 4506 //
     /* 123876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123894 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123897 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123913 */     GIR_RootConstrainSelectedInstOperands,
     /* 123914 */     // GIR_Coverage, 4506,
     /* 123914 */     GIR_EraseRootFromParent_Done,
     /* 123915 */   // Label 2313: @123915
     /* 123915 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(123959), // Rule ID 4527 //
     /* 123920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123938 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123941 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123957 */     GIR_RootConstrainSelectedInstOperands,
     /* 123958 */     // GIR_Coverage, 4527,
     /* 123958 */     GIR_EraseRootFromParent_Done,
     /* 123959 */   // Label 2314: @123959
     /* 123959 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(124003), // Rule ID 4531 //
     /* 123964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123982 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123985 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124001 */     GIR_RootConstrainSelectedInstOperands,
     /* 124002 */     // GIR_Coverage, 4531,
     /* 124002 */     GIR_EraseRootFromParent_Done,
     /* 124003 */   // Label 2315: @124003
     /* 124003 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(124023), // Rule ID 6399 //
     /* 124008 */     // MIs[0] Rn
     /* 124008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124016 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 124021 */     GIR_RootConstrainSelectedInstOperands,
     /* 124022 */     // GIR_Coverage, 6399,
     /* 124022 */     GIR_Done,
     /* 124023 */   // Label 2316: @124023
     /* 124023 */   GIM_Reject,
     /* 124024 */ // Label 2307: @124024
     /* 124024 */ GIM_Reject,
     /* 124025 */ // Label 2108: @124025
     /* 124025 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(124244),
     /* 124030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124033 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124037 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(124086), // Rule ID 4476 //
     /* 124042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124060 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124063 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124084 */     GIR_RootConstrainSelectedInstOperands,
     /* 124085 */     // GIR_Coverage, 4476,
     /* 124085 */     GIR_EraseRootFromParent_Done,
     /* 124086 */   // Label 2318: @124086
     /* 124086 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(124135), // Rule ID 4477 //
     /* 124091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124109 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124112 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124133 */     GIR_RootConstrainSelectedInstOperands,
     /* 124134 */     // GIR_Coverage, 4477,
     /* 124134 */     GIR_EraseRootFromParent_Done,
     /* 124135 */   // Label 2319: @124135
     /* 124135 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(124179), // Rule ID 4502 //
     /* 124140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124158 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124161 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124177 */     GIR_RootConstrainSelectedInstOperands,
     /* 124178 */     // GIR_Coverage, 4502,
     /* 124178 */     GIR_EraseRootFromParent_Done,
     /* 124179 */   // Label 2320: @124179
     /* 124179 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(124223), // Rule ID 4526 //
     /* 124184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124202 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124205 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124221 */     GIR_RootConstrainSelectedInstOperands,
     /* 124222 */     // GIR_Coverage, 4526,
     /* 124222 */     GIR_EraseRootFromParent_Done,
     /* 124223 */   // Label 2321: @124223
     /* 124223 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(124243), // Rule ID 6398 //
     /* 124228 */     // MIs[0] Rn
     /* 124228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124236 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 124241 */     GIR_RootConstrainSelectedInstOperands,
     /* 124242 */     // GIR_Coverage, 6398,
     /* 124242 */     GIR_Done,
     /* 124243 */   // Label 2322: @124243
     /* 124243 */   GIM_Reject,
     /* 124244 */ // Label 2317: @124244
     /* 124244 */ GIM_Reject,
     /* 124245 */ // Label 2109: @124245
     /* 124245 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(124304), // Rule ID 10848 //
     /* 124250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124260 */   // MIs[0] base
     /* 124260 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124268 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124280 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 124288 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124293 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124302 */   GIR_RootConstrainSelectedInstOperands,
     /* 124303 */   // GIR_Coverage, 10848,
     /* 124303 */   GIR_EraseRootFromParent_Done,
     /* 124304 */ // Label 2323: @124304
     /* 124304 */ GIM_Reject,
     /* 124305 */ // Label 2110: @124305
     /* 124305 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(124364), // Rule ID 10854 //
     /* 124310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124320 */   // MIs[0] base
     /* 124320 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124328 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124340 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 124348 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124353 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124358 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124362 */   GIR_RootConstrainSelectedInstOperands,
     /* 124363 */   // GIR_Coverage, 10854,
     /* 124363 */   GIR_EraseRootFromParent_Done,
     /* 124364 */ // Label 2324: @124364
     /* 124364 */ GIM_Reject,
     /* 124365 */ // Label 2111: @124365
     /* 124365 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(124534),
     /* 124370 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124381 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(124429), // Rule ID 10839 //
     /* 124386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124393 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 124413 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124418 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124427 */     GIR_RootConstrainSelectedInstOperands,
     /* 124428 */     // GIR_Coverage, 10839,
     /* 124428 */     GIR_EraseRootFromParent_Done,
     /* 124429 */   // Label 2326: @124429
     /* 124429 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(124477), // Rule ID 10857 //
     /* 124434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124441 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124453 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 124461 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124466 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124475 */     GIR_RootConstrainSelectedInstOperands,
     /* 124476 */     // GIR_Coverage, 10857,
     /* 124476 */     GIR_EraseRootFromParent_Done,
     /* 124477 */   // Label 2327: @124477
     /* 124477 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(124505), // Rule ID 10969 //
     /* 124482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124489 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124492 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124494 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124503 */     GIR_RootConstrainSelectedInstOperands,
     /* 124504 */     // GIR_Coverage, 10969,
     /* 124504 */     GIR_EraseRootFromParent_Done,
     /* 124505 */   // Label 2328: @124505
     /* 124505 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(124533), // Rule ID 10981 //
     /* 124510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124517 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124520 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124522 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124531 */     GIR_RootConstrainSelectedInstOperands,
     /* 124532 */     // GIR_Coverage, 10981,
     /* 124532 */     GIR_EraseRootFromParent_Done,
     /* 124533 */   // Label 2329: @124533
     /* 124533 */   GIM_Reject,
     /* 124534 */ // Label 2325: @124534
     /* 124534 */ GIM_Reject,
     /* 124535 */ // Label 2112: @124535
     /* 124535 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(124594), // Rule ID 10845 //
     /* 124540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124550 */   // MIs[0] base
     /* 124550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124558 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124570 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 124578 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124583 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124588 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124592 */   GIR_RootConstrainSelectedInstOperands,
     /* 124593 */   // GIR_Coverage, 10845,
     /* 124593 */   GIR_EraseRootFromParent_Done,
     /* 124594 */ // Label 2330: @124594
     /* 124594 */ GIM_Reject,
     /* 124595 */ // Label 2113: @124595
     /* 124595 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(124764),
     /* 124600 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124611 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(124659), // Rule ID 10833 //
     /* 124616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124623 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 124643 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124648 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124657 */     GIR_RootConstrainSelectedInstOperands,
     /* 124658 */     // GIR_Coverage, 10833,
     /* 124658 */     GIR_EraseRootFromParent_Done,
     /* 124659 */   // Label 2332: @124659
     /* 124659 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(124707), // Rule ID 10851 //
     /* 124664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124671 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124683 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 124691 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124696 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124705 */     GIR_RootConstrainSelectedInstOperands,
     /* 124706 */     // GIR_Coverage, 10851,
     /* 124706 */     GIR_EraseRootFromParent_Done,
     /* 124707 */   // Label 2333: @124707
     /* 124707 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(124735), // Rule ID 10965 //
     /* 124712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124719 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124722 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124724 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124733 */     GIR_RootConstrainSelectedInstOperands,
     /* 124734 */     // GIR_Coverage, 10965,
     /* 124734 */     GIR_EraseRootFromParent_Done,
     /* 124735 */   // Label 2334: @124735
     /* 124735 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(124763), // Rule ID 10977 //
     /* 124740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124747 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124750 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124752 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124761 */     GIR_RootConstrainSelectedInstOperands,
     /* 124762 */     // GIR_Coverage, 10977,
     /* 124762 */     GIR_EraseRootFromParent_Done,
     /* 124763 */   // Label 2335: @124763
     /* 124763 */   GIM_Reject,
     /* 124764 */ // Label 2331: @124764
     /* 124764 */ GIM_Reject,
     /* 124765 */ // Label 2114: @124765
     /* 124765 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(124934),
     /* 124770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124781 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(124829), // Rule ID 10824 //
     /* 124786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124793 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 124800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124805 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 124813 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124818 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124827 */     GIR_RootConstrainSelectedInstOperands,
     /* 124828 */     // GIR_Coverage, 10824,
     /* 124828 */     GIR_EraseRootFromParent_Done,
     /* 124829 */   // Label 2337: @124829
     /* 124829 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(124877), // Rule ID 10842 //
     /* 124834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124841 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 124848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 124861 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124866 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124875 */     GIR_RootConstrainSelectedInstOperands,
     /* 124876 */     // GIR_Coverage, 10842,
     /* 124876 */     GIR_EraseRootFromParent_Done,
     /* 124877 */   // Label 2338: @124877
     /* 124877 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(124905), // Rule ID 10961 //
     /* 124882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124889 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124892 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124894 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124903 */     GIR_RootConstrainSelectedInstOperands,
     /* 124904 */     // GIR_Coverage, 10961,
     /* 124904 */     GIR_EraseRootFromParent_Done,
     /* 124905 */   // Label 2339: @124905
     /* 124905 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(124933), // Rule ID 10973 //
     /* 124910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124917 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124920 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124922 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124931 */     GIR_RootConstrainSelectedInstOperands,
     /* 124932 */     // GIR_Coverage, 10973,
     /* 124932 */     GIR_EraseRootFromParent_Done,
     /* 124933 */   // Label 2340: @124933
     /* 124933 */   GIM_Reject,
     /* 124934 */ // Label 2336: @124934
     /* 124934 */ GIM_Reject,
     /* 124935 */ // Label 2115: @124935
     /* 124935 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(124978), // Rule ID 2430 //
     /* 124940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 124954 */   // MIs[0] base
     /* 124954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124962 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 124965 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 124967 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124976 */   GIR_RootConstrainSelectedInstOperands,
     /* 124977 */   // GIR_Coverage, 2430,
     /* 124977 */   GIR_EraseRootFromParent_Done,
     /* 124978 */ // Label 2341: @124978
     /* 124978 */ GIM_Reject,
     /* 124979 */ // Label 2116: @124979
     /* 124979 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(125072),
     /* 124984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124991 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124995 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(125043), // Rule ID 10810 //
     /* 125000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125007 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 125027 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125032 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125041 */     GIR_RootConstrainSelectedInstOperands,
     /* 125042 */     // GIR_Coverage, 10810,
     /* 125042 */     GIR_EraseRootFromParent_Done,
     /* 125043 */   // Label 2343: @125043
     /* 125043 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(125071), // Rule ID 10957 //
     /* 125048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125055 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125058 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125060 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125069 */     GIR_RootConstrainSelectedInstOperands,
     /* 125070 */     // GIR_Coverage, 10957,
     /* 125070 */     GIR_EraseRootFromParent_Done,
     /* 125071 */   // Label 2344: @125071
     /* 125071 */   GIM_Reject,
     /* 125072 */ // Label 2342: @125072
     /* 125072 */ GIM_Reject,
     /* 125073 */ // Label 2117: @125073
     /* 125073 */ GIM_Reject,
     /* 125074 */ // Label 20: @125074
     /* 125074 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2347*/ GIMT_Encode4(126424),
     /* 125085 */ /*GILLT_s32*//*Label 2345*/ GIMT_Encode4(125093),
     /* 125089 */ /*GILLT_s64*//*Label 2346*/ GIMT_Encode4(126111),
     /* 125093 */ // Label 2345: @125093
     /* 125093 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(126110),
     /* 125098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 125104 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(125159), // Rule ID 7300 //
     /* 125109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125126 */     // MIs[0] Rn
     /* 125126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125142 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 125145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125157 */     GIR_RootConstrainSelectedInstOperands,
     /* 125158 */     // GIR_Coverage, 7300,
     /* 125158 */     GIR_EraseRootFromParent_Done,
     /* 125159 */   // Label 2349: @125159
     /* 125159 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(125214), // Rule ID 7301 //
     /* 125164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125174 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125181 */     // MIs[0] Rn
     /* 125181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125197 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 125200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125212 */     GIR_RootConstrainSelectedInstOperands,
     /* 125213 */     // GIR_Coverage, 7301,
     /* 125213 */     GIR_EraseRootFromParent_Done,
     /* 125214 */   // Label 2350: @125214
     /* 125214 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(125269), // Rule ID 7302 //
     /* 125219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125222 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125229 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125236 */     // MIs[0] Rn
     /* 125236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125252 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 125255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125267 */     GIR_RootConstrainSelectedInstOperands,
     /* 125268 */     // GIR_Coverage, 7302,
     /* 125268 */     GIR_EraseRootFromParent_Done,
     /* 125269 */   // Label 2351: @125269
     /* 125269 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(125324), // Rule ID 7303 //
     /* 125274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125277 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125291 */     // MIs[0] Rn
     /* 125291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125307 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 125310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125322 */     GIR_RootConstrainSelectedInstOperands,
     /* 125323 */     // GIR_Coverage, 7303,
     /* 125323 */     GIR_EraseRootFromParent_Done,
     /* 125324 */   // Label 2352: @125324
     /* 125324 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(125379), // Rule ID 7304 //
     /* 125329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125332 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125346 */     // MIs[0] Rn
     /* 125346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125362 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 125365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125377 */     GIR_RootConstrainSelectedInstOperands,
     /* 125378 */     // GIR_Coverage, 7304,
     /* 125378 */     GIR_EraseRootFromParent_Done,
     /* 125379 */   // Label 2353: @125379
     /* 125379 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(125434), // Rule ID 7305 //
     /* 125384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125401 */     // MIs[0] Rn
     /* 125401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125417 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 125420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125432 */     GIR_RootConstrainSelectedInstOperands,
     /* 125433 */     // GIR_Coverage, 7305,
     /* 125433 */     GIR_EraseRootFromParent_Done,
     /* 125434 */   // Label 2354: @125434
     /* 125434 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(125489), // Rule ID 7306 //
     /* 125439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125456 */     // MIs[0] Rn
     /* 125456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125472 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 125475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125487 */     GIR_RootConstrainSelectedInstOperands,
     /* 125488 */     // GIR_Coverage, 7306,
     /* 125488 */     GIR_EraseRootFromParent_Done,
     /* 125489 */   // Label 2355: @125489
     /* 125489 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(125544), // Rule ID 7307 //
     /* 125494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125511 */     // MIs[0] Rn
     /* 125511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125527 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 125530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125542 */     GIR_RootConstrainSelectedInstOperands,
     /* 125543 */     // GIR_Coverage, 7307,
     /* 125543 */     GIR_EraseRootFromParent_Done,
     /* 125544 */   // Label 2356: @125544
     /* 125544 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(125599), // Rule ID 7308 //
     /* 125549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125552 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125566 */     // MIs[0] Rn
     /* 125566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125582 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 125585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125597 */     GIR_RootConstrainSelectedInstOperands,
     /* 125598 */     // GIR_Coverage, 7308,
     /* 125598 */     GIR_EraseRootFromParent_Done,
     /* 125599 */   // Label 2357: @125599
     /* 125599 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(125654), // Rule ID 7309 //
     /* 125604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125621 */     // MIs[0] Rn
     /* 125621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125637 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 125640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125652 */     GIR_RootConstrainSelectedInstOperands,
     /* 125653 */     // GIR_Coverage, 7309,
     /* 125653 */     GIR_EraseRootFromParent_Done,
     /* 125654 */   // Label 2358: @125654
     /* 125654 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(125709), // Rule ID 7310 //
     /* 125659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125676 */     // MIs[0] Rn
     /* 125676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125692 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 125695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125707 */     GIR_RootConstrainSelectedInstOperands,
     /* 125708 */     // GIR_Coverage, 7310,
     /* 125708 */     GIR_EraseRootFromParent_Done,
     /* 125709 */   // Label 2359: @125709
     /* 125709 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(125764), // Rule ID 7311 //
     /* 125714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125724 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125731 */     // MIs[0] Rn
     /* 125731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125747 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 125750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125762 */     GIR_RootConstrainSelectedInstOperands,
     /* 125763 */     // GIR_Coverage, 7311,
     /* 125763 */     GIR_EraseRootFromParent_Done,
     /* 125764 */   // Label 2360: @125764
     /* 125764 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(125819), // Rule ID 7312 //
     /* 125769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125786 */     // MIs[0] Rn
     /* 125786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125802 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 125805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125817 */     GIR_RootConstrainSelectedInstOperands,
     /* 125818 */     // GIR_Coverage, 7312,
     /* 125818 */     GIR_EraseRootFromParent_Done,
     /* 125819 */   // Label 2361: @125819
     /* 125819 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(125874), // Rule ID 7313 //
     /* 125824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125841 */     // MIs[0] Rn
     /* 125841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125857 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 125860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125872 */     GIR_RootConstrainSelectedInstOperands,
     /* 125873 */     // GIR_Coverage, 7313,
     /* 125873 */     GIR_EraseRootFromParent_Done,
     /* 125874 */   // Label 2362: @125874
     /* 125874 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(125929), // Rule ID 7314 //
     /* 125879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125882 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125896 */     // MIs[0] Rn
     /* 125896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125912 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 125915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125927 */     GIR_RootConstrainSelectedInstOperands,
     /* 125928 */     // GIR_Coverage, 7314,
     /* 125928 */     GIR_EraseRootFromParent_Done,
     /* 125929 */   // Label 2363: @125929
     /* 125929 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(125989), // Rule ID 13097 //
     /* 125934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125948 */     // MIs[0] addr
     /* 125948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125964 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 125964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 125970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 125972 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 125977 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 125979 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 125981 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 125983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125987 */     GIR_RootConstrainSelectedInstOperands,
     /* 125988 */     // GIR_Coverage, 13097,
     /* 125988 */     GIR_EraseRootFromParent_Done,
     /* 125989 */   // Label 2364: @125989
     /* 125989 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(126049), // Rule ID 13098 //
     /* 125994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126008 */     // MIs[0] addr
     /* 126008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126024 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 126030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126032 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126037 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126039 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126041 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126047 */     GIR_RootConstrainSelectedInstOperands,
     /* 126048 */     // GIR_Coverage, 13098,
     /* 126048 */     GIR_EraseRootFromParent_Done,
     /* 126049 */   // Label 2365: @126049
     /* 126049 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(126109), // Rule ID 13099 //
     /* 126054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126068 */     // MIs[0] addr
     /* 126068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126084 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 126090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126092 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126097 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126099 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126101 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126107 */     GIR_RootConstrainSelectedInstOperands,
     /* 126108 */     // GIR_Coverage, 13099,
     /* 126108 */     GIR_EraseRootFromParent_Done,
     /* 126109 */   // Label 2366: @126109
     /* 126109 */   GIM_Reject,
     /* 126110 */ // Label 2348: @126110
     /* 126110 */ GIM_Reject,
     /* 126111 */ // Label 2346: @126111
     /* 126111 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(126423),
     /* 126116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 126119 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 126122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 126129 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(126177), // Rule ID 2589 //
     /* 126134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126144 */     // MIs[0] Rn
     /* 126144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126160 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 126163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126175 */     GIR_RootConstrainSelectedInstOperands,
     /* 126176 */     // GIR_Coverage, 2589,
     /* 126176 */     GIR_EraseRootFromParent_Done,
     /* 126177 */   // Label 2368: @126177
     /* 126177 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(126225), // Rule ID 2590 //
     /* 126182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126192 */     // MIs[0] Rn
     /* 126192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126208 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 126211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126223 */     GIR_RootConstrainSelectedInstOperands,
     /* 126224 */     // GIR_Coverage, 2590,
     /* 126224 */     GIR_EraseRootFromParent_Done,
     /* 126225 */   // Label 2369: @126225
     /* 126225 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(126273), // Rule ID 2591 //
     /* 126230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126233 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126240 */     // MIs[0] Rn
     /* 126240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126256 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 126259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126271 */     GIR_RootConstrainSelectedInstOperands,
     /* 126272 */     // GIR_Coverage, 2591,
     /* 126272 */     GIR_EraseRootFromParent_Done,
     /* 126273 */   // Label 2370: @126273
     /* 126273 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(126321), // Rule ID 2592 //
     /* 126278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126281 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126288 */     // MIs[0] Rn
     /* 126288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126304 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 126307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126319 */     GIR_RootConstrainSelectedInstOperands,
     /* 126320 */     // GIR_Coverage, 2592,
     /* 126320 */     GIR_EraseRootFromParent_Done,
     /* 126321 */   // Label 2371: @126321
     /* 126321 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(126369), // Rule ID 2593 //
     /* 126326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126336 */     // MIs[0] Rn
     /* 126336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126352 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 126355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126367 */     GIR_RootConstrainSelectedInstOperands,
     /* 126368 */     // GIR_Coverage, 2593,
     /* 126368 */     GIR_EraseRootFromParent_Done,
     /* 126369 */   // Label 2372: @126369
     /* 126369 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(126422), // Rule ID 13100 //
     /* 126374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126381 */     // MIs[0] addr
     /* 126381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126397 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 126397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 126403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126405 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126410 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126412 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126414 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126420 */     GIR_RootConstrainSelectedInstOperands,
     /* 126421 */     // GIR_Coverage, 13100,
     /* 126421 */     GIR_EraseRootFromParent_Done,
     /* 126422 */   // Label 2373: @126422
     /* 126422 */   GIM_Reject,
     /* 126423 */ // Label 2367: @126423
     /* 126423 */ GIM_Reject,
     /* 126424 */ // Label 2347: @126424
     /* 126424 */ GIM_Reject,
     /* 126425 */ // Label 21: @126425
     /* 126425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2376*/ GIMT_Encode4(127416),
     /* 126436 */ /*GILLT_s32*//*Label 2374*/ GIMT_Encode4(126444),
     /* 126440 */ /*GILLT_s64*//*Label 2375*/ GIMT_Encode4(127189),
     /* 126444 */ // Label 2374: @126444
     /* 126444 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(127188),
     /* 126449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126452 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(126501), // Rule ID 7285 //
     /* 126457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126474 */     // MIs[0] Rn
     /* 126474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126486 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 126489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126499 */     GIR_RootConstrainSelectedInstOperands,
     /* 126500 */     // GIR_Coverage, 7285,
     /* 126500 */     GIR_EraseRootFromParent_Done,
     /* 126501 */   // Label 2378: @126501
     /* 126501 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(126550), // Rule ID 7286 //
     /* 126506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126509 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126516 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126523 */     // MIs[0] Rn
     /* 126523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126535 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 126538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126548 */     GIR_RootConstrainSelectedInstOperands,
     /* 126549 */     // GIR_Coverage, 7286,
     /* 126549 */     GIR_EraseRootFromParent_Done,
     /* 126550 */   // Label 2379: @126550
     /* 126550 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(126599), // Rule ID 7287 //
     /* 126555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126558 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126565 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126572 */     // MIs[0] Rn
     /* 126572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126584 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 126587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126597 */     GIR_RootConstrainSelectedInstOperands,
     /* 126598 */     // GIR_Coverage, 7287,
     /* 126598 */     GIR_EraseRootFromParent_Done,
     /* 126599 */   // Label 2380: @126599
     /* 126599 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(126648), // Rule ID 7288 //
     /* 126604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126607 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126614 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126621 */     // MIs[0] Rn
     /* 126621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126633 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 126636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126646 */     GIR_RootConstrainSelectedInstOperands,
     /* 126647 */     // GIR_Coverage, 7288,
     /* 126647 */     GIR_EraseRootFromParent_Done,
     /* 126648 */   // Label 2381: @126648
     /* 126648 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(126697), // Rule ID 7289 //
     /* 126653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126670 */     // MIs[0] Rn
     /* 126670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126682 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 126685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126695 */     GIR_RootConstrainSelectedInstOperands,
     /* 126696 */     // GIR_Coverage, 7289,
     /* 126696 */     GIR_EraseRootFromParent_Done,
     /* 126697 */   // Label 2382: @126697
     /* 126697 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(126746), // Rule ID 7290 //
     /* 126702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126705 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126712 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126719 */     // MIs[0] Rn
     /* 126719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126731 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 126734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126744 */     GIR_RootConstrainSelectedInstOperands,
     /* 126745 */     // GIR_Coverage, 7290,
     /* 126745 */     GIR_EraseRootFromParent_Done,
     /* 126746 */   // Label 2383: @126746
     /* 126746 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(126795), // Rule ID 7291 //
     /* 126751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126768 */     // MIs[0] Rn
     /* 126768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126780 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 126783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126793 */     GIR_RootConstrainSelectedInstOperands,
     /* 126794 */     // GIR_Coverage, 7291,
     /* 126794 */     GIR_EraseRootFromParent_Done,
     /* 126795 */   // Label 2384: @126795
     /* 126795 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(126844), // Rule ID 7292 //
     /* 126800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126817 */     // MIs[0] Rn
     /* 126817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126829 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 126832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126842 */     GIR_RootConstrainSelectedInstOperands,
     /* 126843 */     // GIR_Coverage, 7292,
     /* 126843 */     GIR_EraseRootFromParent_Done,
     /* 126844 */   // Label 2385: @126844
     /* 126844 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(126893), // Rule ID 7293 //
     /* 126849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126866 */     // MIs[0] Rn
     /* 126866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126878 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 126881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126891 */     GIR_RootConstrainSelectedInstOperands,
     /* 126892 */     // GIR_Coverage, 7293,
     /* 126892 */     GIR_EraseRootFromParent_Done,
     /* 126893 */   // Label 2386: @126893
     /* 126893 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(126942), // Rule ID 7294 //
     /* 126898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126915 */     // MIs[0] Rn
     /* 126915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126927 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 126930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126940 */     GIR_RootConstrainSelectedInstOperands,
     /* 126941 */     // GIR_Coverage, 7294,
     /* 126941 */     GIR_EraseRootFromParent_Done,
     /* 126942 */   // Label 2387: @126942
     /* 126942 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(126991), // Rule ID 7295 //
     /* 126947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126964 */     // MIs[0] Rn
     /* 126964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126976 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 126979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126989 */     GIR_RootConstrainSelectedInstOperands,
     /* 126990 */     // GIR_Coverage, 7295,
     /* 126990 */     GIR_EraseRootFromParent_Done,
     /* 126991 */   // Label 2388: @126991
     /* 126991 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(127040), // Rule ID 7296 //
     /* 126996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127013 */     // MIs[0] Rn
     /* 127013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127025 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 127028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127038 */     GIR_RootConstrainSelectedInstOperands,
     /* 127039 */     // GIR_Coverage, 7296,
     /* 127039 */     GIR_EraseRootFromParent_Done,
     /* 127040 */   // Label 2389: @127040
     /* 127040 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(127089), // Rule ID 7297 //
     /* 127045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127062 */     // MIs[0] Rn
     /* 127062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127074 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 127077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127087 */     GIR_RootConstrainSelectedInstOperands,
     /* 127088 */     // GIR_Coverage, 7297,
     /* 127088 */     GIR_EraseRootFromParent_Done,
     /* 127089 */   // Label 2390: @127089
     /* 127089 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(127138), // Rule ID 7298 //
     /* 127094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127111 */     // MIs[0] Rn
     /* 127111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127123 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127136 */     GIR_RootConstrainSelectedInstOperands,
     /* 127137 */     // GIR_Coverage, 7298,
     /* 127137 */     GIR_EraseRootFromParent_Done,
     /* 127138 */   // Label 2391: @127138
     /* 127138 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(127187), // Rule ID 7299 //
     /* 127143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127160 */     // MIs[0] Rn
     /* 127160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127172 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127185 */     GIR_RootConstrainSelectedInstOperands,
     /* 127186 */     // GIR_Coverage, 7299,
     /* 127186 */     GIR_EraseRootFromParent_Done,
     /* 127187 */   // Label 2392: @127187
     /* 127187 */   GIM_Reject,
     /* 127188 */ // Label 2377: @127188
     /* 127188 */ GIM_Reject,
     /* 127189 */ // Label 2375: @127189
     /* 127189 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(127415),
     /* 127194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127197 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127204 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(127246), // Rule ID 7280 //
     /* 127209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127219 */     // MIs[0] Rn
     /* 127219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127231 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 127234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127244 */     GIR_RootConstrainSelectedInstOperands,
     /* 127245 */     // GIR_Coverage, 7280,
     /* 127245 */     GIR_EraseRootFromParent_Done,
     /* 127246 */   // Label 2394: @127246
     /* 127246 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(127288), // Rule ID 7281 //
     /* 127251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127261 */     // MIs[0] Rn
     /* 127261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127273 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 127276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127286 */     GIR_RootConstrainSelectedInstOperands,
     /* 127287 */     // GIR_Coverage, 7281,
     /* 127287 */     GIR_EraseRootFromParent_Done,
     /* 127288 */   // Label 2395: @127288
     /* 127288 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(127330), // Rule ID 7282 //
     /* 127293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127303 */     // MIs[0] Rn
     /* 127303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127315 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 127318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127328 */     GIR_RootConstrainSelectedInstOperands,
     /* 127329 */     // GIR_Coverage, 7282,
     /* 127329 */     GIR_EraseRootFromParent_Done,
     /* 127330 */   // Label 2396: @127330
     /* 127330 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(127372), // Rule ID 7283 //
     /* 127335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127338 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127345 */     // MIs[0] Rn
     /* 127345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127357 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 127360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127370 */     GIR_RootConstrainSelectedInstOperands,
     /* 127371 */     // GIR_Coverage, 7283,
     /* 127371 */     GIR_EraseRootFromParent_Done,
     /* 127372 */   // Label 2397: @127372
     /* 127372 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(127414), // Rule ID 7284 //
     /* 127377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127387 */     // MIs[0] Rn
     /* 127387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127399 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 127402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127412 */     GIR_RootConstrainSelectedInstOperands,
     /* 127413 */     // GIR_Coverage, 7284,
     /* 127413 */     GIR_EraseRootFromParent_Done,
     /* 127414 */   // Label 2398: @127414
     /* 127414 */   GIM_Reject,
     /* 127415 */ // Label 2393: @127415
     /* 127415 */ GIM_Reject,
     /* 127416 */ // Label 2376: @127416
     /* 127416 */ GIM_Reject,
     /* 127417 */ // Label 22: @127417
     /* 127417 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2401*/ GIMT_Encode4(128408),
     /* 127428 */ /*GILLT_s32*//*Label 2399*/ GIMT_Encode4(127436),
     /* 127432 */ /*GILLT_s64*//*Label 2400*/ GIMT_Encode4(128181),
     /* 127436 */ // Label 2399: @127436
     /* 127436 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(128180),
     /* 127441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127444 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(127493), // Rule ID 7125 //
     /* 127449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127466 */     // MIs[0] Rn
     /* 127466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127478 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 127481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127491 */     GIR_RootConstrainSelectedInstOperands,
     /* 127492 */     // GIR_Coverage, 7125,
     /* 127492 */     GIR_EraseRootFromParent_Done,
     /* 127493 */   // Label 2403: @127493
     /* 127493 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(127542), // Rule ID 7126 //
     /* 127498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127515 */     // MIs[0] Rn
     /* 127515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127527 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 127530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127540 */     GIR_RootConstrainSelectedInstOperands,
     /* 127541 */     // GIR_Coverage, 7126,
     /* 127541 */     GIR_EraseRootFromParent_Done,
     /* 127542 */   // Label 2404: @127542
     /* 127542 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(127591), // Rule ID 7127 //
     /* 127547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127550 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127557 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127564 */     // MIs[0] Rn
     /* 127564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127576 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 127579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127589 */     GIR_RootConstrainSelectedInstOperands,
     /* 127590 */     // GIR_Coverage, 7127,
     /* 127590 */     GIR_EraseRootFromParent_Done,
     /* 127591 */   // Label 2405: @127591
     /* 127591 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(127640), // Rule ID 7128 //
     /* 127596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127599 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127613 */     // MIs[0] Rn
     /* 127613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127625 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 127628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127638 */     GIR_RootConstrainSelectedInstOperands,
     /* 127639 */     // GIR_Coverage, 7128,
     /* 127639 */     GIR_EraseRootFromParent_Done,
     /* 127640 */   // Label 2406: @127640
     /* 127640 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(127689), // Rule ID 7129 //
     /* 127645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127648 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127655 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127662 */     // MIs[0] Rn
     /* 127662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127674 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 127677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127687 */     GIR_RootConstrainSelectedInstOperands,
     /* 127688 */     // GIR_Coverage, 7129,
     /* 127688 */     GIR_EraseRootFromParent_Done,
     /* 127689 */   // Label 2407: @127689
     /* 127689 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(127738), // Rule ID 7130 //
     /* 127694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127711 */     // MIs[0] Rn
     /* 127711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127723 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 127726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127736 */     GIR_RootConstrainSelectedInstOperands,
     /* 127737 */     // GIR_Coverage, 7130,
     /* 127737 */     GIR_EraseRootFromParent_Done,
     /* 127738 */   // Label 2408: @127738
     /* 127738 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(127787), // Rule ID 7131 //
     /* 127743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127746 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127753 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127760 */     // MIs[0] Rn
     /* 127760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127772 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 127775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127785 */     GIR_RootConstrainSelectedInstOperands,
     /* 127786 */     // GIR_Coverage, 7131,
     /* 127786 */     GIR_EraseRootFromParent_Done,
     /* 127787 */   // Label 2409: @127787
     /* 127787 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(127836), // Rule ID 7132 //
     /* 127792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127809 */     // MIs[0] Rn
     /* 127809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127821 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 127824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127834 */     GIR_RootConstrainSelectedInstOperands,
     /* 127835 */     // GIR_Coverage, 7132,
     /* 127835 */     GIR_EraseRootFromParent_Done,
     /* 127836 */   // Label 2410: @127836
     /* 127836 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(127885), // Rule ID 7133 //
     /* 127841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127858 */     // MIs[0] Rn
     /* 127858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127870 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 127873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127883 */     GIR_RootConstrainSelectedInstOperands,
     /* 127884 */     // GIR_Coverage, 7133,
     /* 127884 */     GIR_EraseRootFromParent_Done,
     /* 127885 */   // Label 2411: @127885
     /* 127885 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(127934), // Rule ID 7134 //
     /* 127890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127907 */     // MIs[0] Rn
     /* 127907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127919 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 127922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127932 */     GIR_RootConstrainSelectedInstOperands,
     /* 127933 */     // GIR_Coverage, 7134,
     /* 127933 */     GIR_EraseRootFromParent_Done,
     /* 127934 */   // Label 2412: @127934
     /* 127934 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(127983), // Rule ID 7135 //
     /* 127939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127956 */     // MIs[0] Rn
     /* 127956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127968 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 127971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127981 */     GIR_RootConstrainSelectedInstOperands,
     /* 127982 */     // GIR_Coverage, 7135,
     /* 127982 */     GIR_EraseRootFromParent_Done,
     /* 127983 */   // Label 2413: @127983
     /* 127983 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(128032), // Rule ID 7136 //
     /* 127988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128005 */     // MIs[0] Rn
     /* 128005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128017 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 128020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128030 */     GIR_RootConstrainSelectedInstOperands,
     /* 128031 */     // GIR_Coverage, 7136,
     /* 128031 */     GIR_EraseRootFromParent_Done,
     /* 128032 */   // Label 2414: @128032
     /* 128032 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(128081), // Rule ID 7137 //
     /* 128037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128054 */     // MIs[0] Rn
     /* 128054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128066 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 128069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128079 */     GIR_RootConstrainSelectedInstOperands,
     /* 128080 */     // GIR_Coverage, 7137,
     /* 128080 */     GIR_EraseRootFromParent_Done,
     /* 128081 */   // Label 2415: @128081
     /* 128081 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(128130), // Rule ID 7138 //
     /* 128086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128103 */     // MIs[0] Rn
     /* 128103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128115 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128128 */     GIR_RootConstrainSelectedInstOperands,
     /* 128129 */     // GIR_Coverage, 7138,
     /* 128129 */     GIR_EraseRootFromParent_Done,
     /* 128130 */   // Label 2416: @128130
     /* 128130 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(128179), // Rule ID 7139 //
     /* 128135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128152 */     // MIs[0] Rn
     /* 128152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128164 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128177 */     GIR_RootConstrainSelectedInstOperands,
     /* 128178 */     // GIR_Coverage, 7139,
     /* 128178 */     GIR_EraseRootFromParent_Done,
     /* 128179 */   // Label 2417: @128179
     /* 128179 */   GIM_Reject,
     /* 128180 */ // Label 2402: @128180
     /* 128180 */ GIM_Reject,
     /* 128181 */ // Label 2400: @128181
     /* 128181 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(128407),
     /* 128186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128196 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(128238), // Rule ID 2579 //
     /* 128201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128211 */     // MIs[0] Rn
     /* 128211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128223 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 128226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128236 */     GIR_RootConstrainSelectedInstOperands,
     /* 128237 */     // GIR_Coverage, 2579,
     /* 128237 */     GIR_EraseRootFromParent_Done,
     /* 128238 */   // Label 2419: @128238
     /* 128238 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(128280), // Rule ID 2580 //
     /* 128243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128253 */     // MIs[0] Rn
     /* 128253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128265 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 128268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128278 */     GIR_RootConstrainSelectedInstOperands,
     /* 128279 */     // GIR_Coverage, 2580,
     /* 128279 */     GIR_EraseRootFromParent_Done,
     /* 128280 */   // Label 2420: @128280
     /* 128280 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(128322), // Rule ID 2581 //
     /* 128285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128295 */     // MIs[0] Rn
     /* 128295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128307 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 128310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128320 */     GIR_RootConstrainSelectedInstOperands,
     /* 128321 */     // GIR_Coverage, 2581,
     /* 128321 */     GIR_EraseRootFromParent_Done,
     /* 128322 */   // Label 2421: @128322
     /* 128322 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(128364), // Rule ID 2582 //
     /* 128327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128330 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128337 */     // MIs[0] Rn
     /* 128337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128349 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 128352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128362 */     GIR_RootConstrainSelectedInstOperands,
     /* 128363 */     // GIR_Coverage, 2582,
     /* 128363 */     GIR_EraseRootFromParent_Done,
     /* 128364 */   // Label 2422: @128364
     /* 128364 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(128406), // Rule ID 2583 //
     /* 128369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128379 */     // MIs[0] Rn
     /* 128379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128391 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 128394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128404 */     GIR_RootConstrainSelectedInstOperands,
     /* 128405 */     // GIR_Coverage, 2583,
     /* 128405 */     GIR_EraseRootFromParent_Done,
     /* 128406 */   // Label 2423: @128406
     /* 128406 */   GIM_Reject,
     /* 128407 */ // Label 2418: @128407
     /* 128407 */ GIM_Reject,
     /* 128408 */ // Label 2401: @128408
     /* 128408 */ GIM_Reject,
     /* 128409 */ // Label 23: @128409
     /* 128409 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2426*/ GIMT_Encode4(129900),
     /* 128420 */ /*GILLT_s32*//*Label 2424*/ GIMT_Encode4(128428),
     /* 128424 */ /*GILLT_s64*//*Label 2425*/ GIMT_Encode4(129548),
     /* 128428 */ // Label 2424: @128428
     /* 128428 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(129547),
     /* 128433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128436 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(128510), // Rule ID 7320 //
     /* 128441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128458 */     // MIs[0] Rn
     /* 128458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128470 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128482 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 128497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128508 */     GIR_RootConstrainSelectedInstOperands,
     /* 128509 */     // GIR_Coverage, 7320,
     /* 128509 */     GIR_EraseRootFromParent_Done,
     /* 128510 */   // Label 2428: @128510
     /* 128510 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(128584), // Rule ID 7321 //
     /* 128515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128532 */     // MIs[0] Rn
     /* 128532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128544 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128556 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 128571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128582 */     GIR_RootConstrainSelectedInstOperands,
     /* 128583 */     // GIR_Coverage, 7321,
     /* 128583 */     GIR_EraseRootFromParent_Done,
     /* 128584 */   // Label 2429: @128584
     /* 128584 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(128658), // Rule ID 7322 //
     /* 128589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128606 */     // MIs[0] Rn
     /* 128606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128618 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128630 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 128645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128656 */     GIR_RootConstrainSelectedInstOperands,
     /* 128657 */     // GIR_Coverage, 7322,
     /* 128657 */     GIR_EraseRootFromParent_Done,
     /* 128658 */   // Label 2430: @128658
     /* 128658 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(128732), // Rule ID 7323 //
     /* 128663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128680 */     // MIs[0] Rn
     /* 128680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128692 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128704 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128730 */     GIR_RootConstrainSelectedInstOperands,
     /* 128731 */     // GIR_Coverage, 7323,
     /* 128731 */     GIR_EraseRootFromParent_Done,
     /* 128732 */   // Label 2431: @128732
     /* 128732 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(128806), // Rule ID 7324 //
     /* 128737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128740 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128747 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128754 */     // MIs[0] Rn
     /* 128754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128766 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128778 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128804 */     GIR_RootConstrainSelectedInstOperands,
     /* 128805 */     // GIR_Coverage, 7324,
     /* 128805 */     GIR_EraseRootFromParent_Done,
     /* 128806 */   // Label 2432: @128806
     /* 128806 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(128880), // Rule ID 7325 //
     /* 128811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128828 */     // MIs[0] Rn
     /* 128828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128840 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128852 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 128867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128878 */     GIR_RootConstrainSelectedInstOperands,
     /* 128879 */     // GIR_Coverage, 7325,
     /* 128879 */     GIR_EraseRootFromParent_Done,
     /* 128880 */   // Label 2433: @128880
     /* 128880 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(128954), // Rule ID 7326 //
     /* 128885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128888 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128895 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128902 */     // MIs[0] Rn
     /* 128902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128914 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128926 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 128941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128952 */     GIR_RootConstrainSelectedInstOperands,
     /* 128953 */     // GIR_Coverage, 7326,
     /* 128953 */     GIR_EraseRootFromParent_Done,
     /* 128954 */   // Label 2434: @128954
     /* 128954 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(129028), // Rule ID 7327 //
     /* 128959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128976 */     // MIs[0] Rn
     /* 128976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128988 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129000 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129006 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 129015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129026 */     GIR_RootConstrainSelectedInstOperands,
     /* 129027 */     // GIR_Coverage, 7327,
     /* 129027 */     GIR_EraseRootFromParent_Done,
     /* 129028 */   // Label 2435: @129028
     /* 129028 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(129102), // Rule ID 7328 //
     /* 129033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129050 */     // MIs[0] Rn
     /* 129050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129062 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129074 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129100 */     GIR_RootConstrainSelectedInstOperands,
     /* 129101 */     // GIR_Coverage, 7328,
     /* 129101 */     GIR_EraseRootFromParent_Done,
     /* 129102 */   // Label 2436: @129102
     /* 129102 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(129176), // Rule ID 7329 //
     /* 129107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129110 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129117 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129124 */     // MIs[0] Rn
     /* 129124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129136 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129148 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129154 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129174 */     GIR_RootConstrainSelectedInstOperands,
     /* 129175 */     // GIR_Coverage, 7329,
     /* 129175 */     GIR_EraseRootFromParent_Done,
     /* 129176 */   // Label 2437: @129176
     /* 129176 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(129250), // Rule ID 7330 //
     /* 129181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129184 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129191 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129198 */     // MIs[0] Rn
     /* 129198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129210 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129222 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 129237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129248 */     GIR_RootConstrainSelectedInstOperands,
     /* 129249 */     // GIR_Coverage, 7330,
     /* 129249 */     GIR_EraseRootFromParent_Done,
     /* 129250 */   // Label 2438: @129250
     /* 129250 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(129324), // Rule ID 7331 //
     /* 129255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129258 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129265 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129272 */     // MIs[0] Rn
     /* 129272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129284 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129296 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 129311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129322 */     GIR_RootConstrainSelectedInstOperands,
     /* 129323 */     // GIR_Coverage, 7331,
     /* 129323 */     GIR_EraseRootFromParent_Done,
     /* 129324 */   // Label 2439: @129324
     /* 129324 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(129398), // Rule ID 7332 //
     /* 129329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129332 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129346 */     // MIs[0] Rn
     /* 129346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129358 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129370 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 129385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129396 */     GIR_RootConstrainSelectedInstOperands,
     /* 129397 */     // GIR_Coverage, 7332,
     /* 129397 */     GIR_EraseRootFromParent_Done,
     /* 129398 */   // Label 2440: @129398
     /* 129398 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(129472), // Rule ID 7333 //
     /* 129403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129413 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129420 */     // MIs[0] Rn
     /* 129420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129432 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129444 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129470 */     GIR_RootConstrainSelectedInstOperands,
     /* 129471 */     // GIR_Coverage, 7333,
     /* 129471 */     GIR_EraseRootFromParent_Done,
     /* 129472 */   // Label 2441: @129472
     /* 129472 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(129546), // Rule ID 7334 //
     /* 129477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129480 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129487 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129494 */     // MIs[0] Rn
     /* 129494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129506 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129518 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129544 */     GIR_RootConstrainSelectedInstOperands,
     /* 129545 */     // GIR_Coverage, 7334,
     /* 129545 */     GIR_EraseRootFromParent_Done,
     /* 129546 */   // Label 2442: @129546
     /* 129546 */   GIM_Reject,
     /* 129547 */ // Label 2427: @129547
     /* 129547 */ GIM_Reject,
     /* 129548 */ // Label 2425: @129548
     /* 129548 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(129899),
     /* 129553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129556 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129563 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(129630), // Rule ID 7315 //
     /* 129568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129578 */     // MIs[0] Rn
     /* 129578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129590 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129602 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 129617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129628 */     GIR_RootConstrainSelectedInstOperands,
     /* 129629 */     // GIR_Coverage, 7315,
     /* 129629 */     GIR_EraseRootFromParent_Done,
     /* 129630 */   // Label 2444: @129630
     /* 129630 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(129697), // Rule ID 7316 //
     /* 129635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129645 */     // MIs[0] Rn
     /* 129645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129657 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129669 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 129684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129695 */     GIR_RootConstrainSelectedInstOperands,
     /* 129696 */     // GIR_Coverage, 7316,
     /* 129696 */     GIR_EraseRootFromParent_Done,
     /* 129697 */   // Label 2445: @129697
     /* 129697 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(129764), // Rule ID 7317 //
     /* 129702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129712 */     // MIs[0] Rn
     /* 129712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129724 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129736 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 129751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129762 */     GIR_RootConstrainSelectedInstOperands,
     /* 129763 */     // GIR_Coverage, 7317,
     /* 129763 */     GIR_EraseRootFromParent_Done,
     /* 129764 */   // Label 2446: @129764
     /* 129764 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(129831), // Rule ID 7318 //
     /* 129769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129779 */     // MIs[0] Rn
     /* 129779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129791 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129803 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129829 */     GIR_RootConstrainSelectedInstOperands,
     /* 129830 */     // GIR_Coverage, 7318,
     /* 129830 */     GIR_EraseRootFromParent_Done,
     /* 129831 */   // Label 2447: @129831
     /* 129831 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(129898), // Rule ID 7319 //
     /* 129836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129839 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129846 */     // MIs[0] Rn
     /* 129846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129858 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129870 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129896 */     GIR_RootConstrainSelectedInstOperands,
     /* 129897 */     // GIR_Coverage, 7319,
     /* 129897 */     GIR_EraseRootFromParent_Done,
     /* 129898 */   // Label 2448: @129898
     /* 129898 */   GIM_Reject,
     /* 129899 */ // Label 2443: @129899
     /* 129899 */ GIM_Reject,
     /* 129900 */ // Label 2426: @129900
     /* 129900 */ GIM_Reject,
     /* 129901 */ // Label 24: @129901
     /* 129901 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2451*/ GIMT_Encode4(131392),
     /* 129912 */ /*GILLT_s32*//*Label 2449*/ GIMT_Encode4(129920),
     /* 129916 */ /*GILLT_s64*//*Label 2450*/ GIMT_Encode4(131040),
     /* 129920 */ // Label 2449: @129920
     /* 129920 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(131039),
     /* 129925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129928 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(130002), // Rule ID 7340 //
     /* 129933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129950 */     // MIs[0] Rn
     /* 129950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129962 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129974 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 129989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130000 */     GIR_RootConstrainSelectedInstOperands,
     /* 130001 */     // GIR_Coverage, 7340,
     /* 130001 */     GIR_EraseRootFromParent_Done,
     /* 130002 */   // Label 2453: @130002
     /* 130002 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(130076), // Rule ID 7341 //
     /* 130007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130024 */     // MIs[0] Rn
     /* 130024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130036 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130048 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 130063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130074 */     GIR_RootConstrainSelectedInstOperands,
     /* 130075 */     // GIR_Coverage, 7341,
     /* 130075 */     GIR_EraseRootFromParent_Done,
     /* 130076 */   // Label 2454: @130076
     /* 130076 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(130150), // Rule ID 7342 //
     /* 130081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130098 */     // MIs[0] Rn
     /* 130098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130110 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130122 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 130137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130148 */     GIR_RootConstrainSelectedInstOperands,
     /* 130149 */     // GIR_Coverage, 7342,
     /* 130149 */     GIR_EraseRootFromParent_Done,
     /* 130150 */   // Label 2455: @130150
     /* 130150 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(130224), // Rule ID 7343 //
     /* 130155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130172 */     // MIs[0] Rn
     /* 130172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130184 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130196 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 130211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130222 */     GIR_RootConstrainSelectedInstOperands,
     /* 130223 */     // GIR_Coverage, 7343,
     /* 130223 */     GIR_EraseRootFromParent_Done,
     /* 130224 */   // Label 2456: @130224
     /* 130224 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(130298), // Rule ID 7344 //
     /* 130229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130232 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130239 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130246 */     // MIs[0] Rn
     /* 130246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130258 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130270 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 130285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130296 */     GIR_RootConstrainSelectedInstOperands,
     /* 130297 */     // GIR_Coverage, 7344,
     /* 130297 */     GIR_EraseRootFromParent_Done,
     /* 130298 */   // Label 2457: @130298
     /* 130298 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(130372), // Rule ID 7345 //
     /* 130303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130306 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130313 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130320 */     // MIs[0] Rn
     /* 130320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130332 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130344 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 130359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130370 */     GIR_RootConstrainSelectedInstOperands,
     /* 130371 */     // GIR_Coverage, 7345,
     /* 130371 */     GIR_EraseRootFromParent_Done,
     /* 130372 */   // Label 2458: @130372
     /* 130372 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(130446), // Rule ID 7346 //
     /* 130377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130380 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130387 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130394 */     // MIs[0] Rn
     /* 130394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130406 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130418 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 130433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130444 */     GIR_RootConstrainSelectedInstOperands,
     /* 130445 */     // GIR_Coverage, 7346,
     /* 130445 */     GIR_EraseRootFromParent_Done,
     /* 130446 */   // Label 2459: @130446
     /* 130446 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(130520), // Rule ID 7347 //
     /* 130451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130454 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130461 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130468 */     // MIs[0] Rn
     /* 130468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130480 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130492 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 130507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130518 */     GIR_RootConstrainSelectedInstOperands,
     /* 130519 */     // GIR_Coverage, 7347,
     /* 130519 */     GIR_EraseRootFromParent_Done,
     /* 130520 */   // Label 2460: @130520
     /* 130520 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(130594), // Rule ID 7348 //
     /* 130525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130542 */     // MIs[0] Rn
     /* 130542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130554 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130566 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 130581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130592 */     GIR_RootConstrainSelectedInstOperands,
     /* 130593 */     // GIR_Coverage, 7348,
     /* 130593 */     GIR_EraseRootFromParent_Done,
     /* 130594 */   // Label 2461: @130594
     /* 130594 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(130668), // Rule ID 7349 //
     /* 130599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130602 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130616 */     // MIs[0] Rn
     /* 130616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130628 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130640 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 130655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130666 */     GIR_RootConstrainSelectedInstOperands,
     /* 130667 */     // GIR_Coverage, 7349,
     /* 130667 */     GIR_EraseRootFromParent_Done,
     /* 130668 */   // Label 2462: @130668
     /* 130668 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(130742), // Rule ID 7350 //
     /* 130673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130676 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130690 */     // MIs[0] Rn
     /* 130690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130702 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130714 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 130729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130740 */     GIR_RootConstrainSelectedInstOperands,
     /* 130741 */     // GIR_Coverage, 7350,
     /* 130741 */     GIR_EraseRootFromParent_Done,
     /* 130742 */   // Label 2463: @130742
     /* 130742 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(130816), // Rule ID 7351 //
     /* 130747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130764 */     // MIs[0] Rn
     /* 130764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130776 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130788 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 130803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130814 */     GIR_RootConstrainSelectedInstOperands,
     /* 130815 */     // GIR_Coverage, 7351,
     /* 130815 */     GIR_EraseRootFromParent_Done,
     /* 130816 */   // Label 2464: @130816
     /* 130816 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(130890), // Rule ID 7352 //
     /* 130821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130824 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130838 */     // MIs[0] Rn
     /* 130838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130850 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130862 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 130877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130888 */     GIR_RootConstrainSelectedInstOperands,
     /* 130889 */     // GIR_Coverage, 7352,
     /* 130889 */     GIR_EraseRootFromParent_Done,
     /* 130890 */   // Label 2465: @130890
     /* 130890 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(130964), // Rule ID 7353 //
     /* 130895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130912 */     // MIs[0] Rn
     /* 130912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130924 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130936 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130942 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 130951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130962 */     GIR_RootConstrainSelectedInstOperands,
     /* 130963 */     // GIR_Coverage, 7353,
     /* 130963 */     GIR_EraseRootFromParent_Done,
     /* 130964 */   // Label 2466: @130964
     /* 130964 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(131038), // Rule ID 7354 //
     /* 130969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130979 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130986 */     // MIs[0] Rn
     /* 130986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130998 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131010 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131036 */     GIR_RootConstrainSelectedInstOperands,
     /* 131037 */     // GIR_Coverage, 7354,
     /* 131037 */     GIR_EraseRootFromParent_Done,
     /* 131038 */   // Label 2467: @131038
     /* 131038 */   GIM_Reject,
     /* 131039 */ // Label 2452: @131039
     /* 131039 */ GIM_Reject,
     /* 131040 */ // Label 2450: @131040
     /* 131040 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(131391),
     /* 131045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131055 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(131122), // Rule ID 7335 //
     /* 131060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131070 */     // MIs[0] Rn
     /* 131070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131082 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131094 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 131109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131120 */     GIR_RootConstrainSelectedInstOperands,
     /* 131121 */     // GIR_Coverage, 7335,
     /* 131121 */     GIR_EraseRootFromParent_Done,
     /* 131122 */   // Label 2469: @131122
     /* 131122 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(131189), // Rule ID 7336 //
     /* 131127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131137 */     // MIs[0] Rn
     /* 131137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131149 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131161 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 131176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131187 */     GIR_RootConstrainSelectedInstOperands,
     /* 131188 */     // GIR_Coverage, 7336,
     /* 131188 */     GIR_EraseRootFromParent_Done,
     /* 131189 */   // Label 2470: @131189
     /* 131189 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(131256), // Rule ID 7337 //
     /* 131194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131204 */     // MIs[0] Rn
     /* 131204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131216 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131228 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 131243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131254 */     GIR_RootConstrainSelectedInstOperands,
     /* 131255 */     // GIR_Coverage, 7337,
     /* 131255 */     GIR_EraseRootFromParent_Done,
     /* 131256 */   // Label 2471: @131256
     /* 131256 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(131323), // Rule ID 7338 //
     /* 131261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131271 */     // MIs[0] Rn
     /* 131271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131283 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131295 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131301 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 131310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131321 */     GIR_RootConstrainSelectedInstOperands,
     /* 131322 */     // GIR_Coverage, 7338,
     /* 131322 */     GIR_EraseRootFromParent_Done,
     /* 131323 */   // Label 2472: @131323
     /* 131323 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(131390), // Rule ID 7339 //
     /* 131328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131338 */     // MIs[0] Rn
     /* 131338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131350 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131362 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 131377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131388 */     GIR_RootConstrainSelectedInstOperands,
     /* 131389 */     // GIR_Coverage, 7339,
     /* 131389 */     GIR_EraseRootFromParent_Done,
     /* 131390 */   // Label 2473: @131390
     /* 131390 */   GIM_Reject,
     /* 131391 */ // Label 2468: @131391
     /* 131391 */ GIM_Reject,
     /* 131392 */ // Label 2451: @131392
     /* 131392 */ GIM_Reject,
     /* 131393 */ // Label 25: @131393
     /* 131393 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2476*/ GIMT_Encode4(132384),
     /* 131404 */ /*GILLT_s32*//*Label 2474*/ GIMT_Encode4(131412),
     /* 131408 */ /*GILLT_s64*//*Label 2475*/ GIMT_Encode4(132157),
     /* 131412 */ // Label 2474: @131412
     /* 131412 */ GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(132156),
     /* 131417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131420 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(131469), // Rule ID 7145 //
     /* 131425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131442 */     // MIs[0] Rn
     /* 131442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131454 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 131457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131467 */     GIR_RootConstrainSelectedInstOperands,
     /* 131468 */     // GIR_Coverage, 7145,
     /* 131468 */     GIR_EraseRootFromParent_Done,
     /* 131469 */   // Label 2478: @131469
     /* 131469 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(131518), // Rule ID 7146 //
     /* 131474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131491 */     // MIs[0] Rn
     /* 131491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131503 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 131506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131516 */     GIR_RootConstrainSelectedInstOperands,
     /* 131517 */     // GIR_Coverage, 7146,
     /* 131517 */     GIR_EraseRootFromParent_Done,
     /* 131518 */   // Label 2479: @131518
     /* 131518 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(131567), // Rule ID 7147 //
     /* 131523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131540 */     // MIs[0] Rn
     /* 131540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131552 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 131555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131565 */     GIR_RootConstrainSelectedInstOperands,
     /* 131566 */     // GIR_Coverage, 7147,
     /* 131566 */     GIR_EraseRootFromParent_Done,
     /* 131567 */   // Label 2480: @131567
     /* 131567 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(131616), // Rule ID 7148 //
     /* 131572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131589 */     // MIs[0] Rn
     /* 131589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131601 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 131604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131614 */     GIR_RootConstrainSelectedInstOperands,
     /* 131615 */     // GIR_Coverage, 7148,
     /* 131615 */     GIR_EraseRootFromParent_Done,
     /* 131616 */   // Label 2481: @131616
     /* 131616 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(131665), // Rule ID 7149 //
     /* 131621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131638 */     // MIs[0] Rn
     /* 131638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131650 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 131653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131663 */     GIR_RootConstrainSelectedInstOperands,
     /* 131664 */     // GIR_Coverage, 7149,
     /* 131664 */     GIR_EraseRootFromParent_Done,
     /* 131665 */   // Label 2482: @131665
     /* 131665 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(131714), // Rule ID 7150 //
     /* 131670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131687 */     // MIs[0] Rn
     /* 131687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131699 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 131702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131712 */     GIR_RootConstrainSelectedInstOperands,
     /* 131713 */     // GIR_Coverage, 7150,
     /* 131713 */     GIR_EraseRootFromParent_Done,
     /* 131714 */   // Label 2483: @131714
     /* 131714 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(131763), // Rule ID 7151 //
     /* 131719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131736 */     // MIs[0] Rn
     /* 131736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131748 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 131751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131761 */     GIR_RootConstrainSelectedInstOperands,
     /* 131762 */     // GIR_Coverage, 7151,
     /* 131762 */     GIR_EraseRootFromParent_Done,
     /* 131763 */   // Label 2484: @131763
     /* 131763 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(131812), // Rule ID 7152 //
     /* 131768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131785 */     // MIs[0] Rn
     /* 131785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131797 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 131800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131810 */     GIR_RootConstrainSelectedInstOperands,
     /* 131811 */     // GIR_Coverage, 7152,
     /* 131811 */     GIR_EraseRootFromParent_Done,
     /* 131812 */   // Label 2485: @131812
     /* 131812 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(131861), // Rule ID 7153 //
     /* 131817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131820 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131834 */     // MIs[0] Rn
     /* 131834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131846 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 131849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131859 */     GIR_RootConstrainSelectedInstOperands,
     /* 131860 */     // GIR_Coverage, 7153,
     /* 131860 */     GIR_EraseRootFromParent_Done,
     /* 131861 */   // Label 2486: @131861
     /* 131861 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(131910), // Rule ID 7154 //
     /* 131866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131869 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131883 */     // MIs[0] Rn
     /* 131883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131895 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 131898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131908 */     GIR_RootConstrainSelectedInstOperands,
     /* 131909 */     // GIR_Coverage, 7154,
     /* 131909 */     GIR_EraseRootFromParent_Done,
     /* 131910 */   // Label 2487: @131910
     /* 131910 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(131959), // Rule ID 7155 //
     /* 131915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131932 */     // MIs[0] Rn
     /* 131932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131944 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 131947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131957 */     GIR_RootConstrainSelectedInstOperands,
     /* 131958 */     // GIR_Coverage, 7155,
     /* 131958 */     GIR_EraseRootFromParent_Done,
     /* 131959 */   // Label 2488: @131959
     /* 131959 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(132008), // Rule ID 7156 //
     /* 131964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131967 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131974 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131981 */     // MIs[0] Rn
     /* 131981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131993 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 131996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132006 */     GIR_RootConstrainSelectedInstOperands,
     /* 132007 */     // GIR_Coverage, 7156,
     /* 132007 */     GIR_EraseRootFromParent_Done,
     /* 132008 */   // Label 2489: @132008
     /* 132008 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(132057), // Rule ID 7157 //
     /* 132013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132030 */     // MIs[0] Rn
     /* 132030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132042 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 132045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132055 */     GIR_RootConstrainSelectedInstOperands,
     /* 132056 */     // GIR_Coverage, 7157,
     /* 132056 */     GIR_EraseRootFromParent_Done,
     /* 132057 */   // Label 2490: @132057
     /* 132057 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(132106), // Rule ID 7158 //
     /* 132062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132079 */     // MIs[0] Rn
     /* 132079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132091 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132104 */     GIR_RootConstrainSelectedInstOperands,
     /* 132105 */     // GIR_Coverage, 7158,
     /* 132105 */     GIR_EraseRootFromParent_Done,
     /* 132106 */   // Label 2491: @132106
     /* 132106 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(132155), // Rule ID 7159 //
     /* 132111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132128 */     // MIs[0] Rn
     /* 132128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132140 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132153 */     GIR_RootConstrainSelectedInstOperands,
     /* 132154 */     // GIR_Coverage, 7159,
     /* 132154 */     GIR_EraseRootFromParent_Done,
     /* 132155 */   // Label 2492: @132155
     /* 132155 */   GIM_Reject,
     /* 132156 */ // Label 2477: @132156
     /* 132156 */ GIM_Reject,
     /* 132157 */ // Label 2475: @132157
     /* 132157 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(132383),
     /* 132162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132165 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132172 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(132214), // Rule ID 7140 //
     /* 132177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132187 */     // MIs[0] Rn
     /* 132187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132199 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 132202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132212 */     GIR_RootConstrainSelectedInstOperands,
     /* 132213 */     // GIR_Coverage, 7140,
     /* 132213 */     GIR_EraseRootFromParent_Done,
     /* 132214 */   // Label 2494: @132214
     /* 132214 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(132256), // Rule ID 7141 //
     /* 132219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132229 */     // MIs[0] Rn
     /* 132229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132241 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 132244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132254 */     GIR_RootConstrainSelectedInstOperands,
     /* 132255 */     // GIR_Coverage, 7141,
     /* 132255 */     GIR_EraseRootFromParent_Done,
     /* 132256 */   // Label 2495: @132256
     /* 132256 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(132298), // Rule ID 7142 //
     /* 132261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132271 */     // MIs[0] Rn
     /* 132271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132283 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 132286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132296 */     GIR_RootConstrainSelectedInstOperands,
     /* 132297 */     // GIR_Coverage, 7142,
     /* 132297 */     GIR_EraseRootFromParent_Done,
     /* 132298 */   // Label 2496: @132298
     /* 132298 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(132340), // Rule ID 7143 //
     /* 132303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132313 */     // MIs[0] Rn
     /* 132313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132325 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 132328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132338 */     GIR_RootConstrainSelectedInstOperands,
     /* 132339 */     // GIR_Coverage, 7143,
     /* 132339 */     GIR_EraseRootFromParent_Done,
     /* 132340 */   // Label 2497: @132340
     /* 132340 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(132382), // Rule ID 7144 //
     /* 132345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132355 */     // MIs[0] Rn
     /* 132355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132367 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 132370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132380 */     GIR_RootConstrainSelectedInstOperands,
     /* 132381 */     // GIR_Coverage, 7144,
     /* 132381 */     GIR_EraseRootFromParent_Done,
     /* 132382 */   // Label 2498: @132382
     /* 132382 */   GIM_Reject,
     /* 132383 */ // Label 2493: @132383
     /* 132383 */ GIM_Reject,
     /* 132384 */ // Label 2476: @132384
     /* 132384 */ GIM_Reject,
     /* 132385 */ // Label 26: @132385
     /* 132385 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2501*/ GIMT_Encode4(133376),
     /* 132396 */ /*GILLT_s32*//*Label 2499*/ GIMT_Encode4(132404),
     /* 132400 */ /*GILLT_s64*//*Label 2500*/ GIMT_Encode4(133149),
     /* 132404 */ // Label 2499: @132404
     /* 132404 */ GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(133148),
     /* 132409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132412 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(132461), // Rule ID 7165 //
     /* 132417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132434 */     // MIs[0] Rn
     /* 132434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132446 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 132449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132459 */     GIR_RootConstrainSelectedInstOperands,
     /* 132460 */     // GIR_Coverage, 7165,
     /* 132460 */     GIR_EraseRootFromParent_Done,
     /* 132461 */   // Label 2503: @132461
     /* 132461 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(132510), // Rule ID 7166 //
     /* 132466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132483 */     // MIs[0] Rn
     /* 132483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132495 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 132498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132508 */     GIR_RootConstrainSelectedInstOperands,
     /* 132509 */     // GIR_Coverage, 7166,
     /* 132509 */     GIR_EraseRootFromParent_Done,
     /* 132510 */   // Label 2504: @132510
     /* 132510 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(132559), // Rule ID 7167 //
     /* 132515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132532 */     // MIs[0] Rn
     /* 132532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132544 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 132547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132557 */     GIR_RootConstrainSelectedInstOperands,
     /* 132558 */     // GIR_Coverage, 7167,
     /* 132558 */     GIR_EraseRootFromParent_Done,
     /* 132559 */   // Label 2505: @132559
     /* 132559 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(132608), // Rule ID 7168 //
     /* 132564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132581 */     // MIs[0] Rn
     /* 132581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132593 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 132596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132606 */     GIR_RootConstrainSelectedInstOperands,
     /* 132607 */     // GIR_Coverage, 7168,
     /* 132607 */     GIR_EraseRootFromParent_Done,
     /* 132608 */   // Label 2506: @132608
     /* 132608 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(132657), // Rule ID 7169 //
     /* 132613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132630 */     // MIs[0] Rn
     /* 132630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132642 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 132645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132655 */     GIR_RootConstrainSelectedInstOperands,
     /* 132656 */     // GIR_Coverage, 7169,
     /* 132656 */     GIR_EraseRootFromParent_Done,
     /* 132657 */   // Label 2507: @132657
     /* 132657 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(132706), // Rule ID 7170 //
     /* 132662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132679 */     // MIs[0] Rn
     /* 132679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132691 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 132694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132704 */     GIR_RootConstrainSelectedInstOperands,
     /* 132705 */     // GIR_Coverage, 7170,
     /* 132705 */     GIR_EraseRootFromParent_Done,
     /* 132706 */   // Label 2508: @132706
     /* 132706 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(132755), // Rule ID 7171 //
     /* 132711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132728 */     // MIs[0] Rn
     /* 132728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132740 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 132743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132753 */     GIR_RootConstrainSelectedInstOperands,
     /* 132754 */     // GIR_Coverage, 7171,
     /* 132754 */     GIR_EraseRootFromParent_Done,
     /* 132755 */   // Label 2509: @132755
     /* 132755 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(132804), // Rule ID 7172 //
     /* 132760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132777 */     // MIs[0] Rn
     /* 132777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132789 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 132792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132802 */     GIR_RootConstrainSelectedInstOperands,
     /* 132803 */     // GIR_Coverage, 7172,
     /* 132803 */     GIR_EraseRootFromParent_Done,
     /* 132804 */   // Label 2510: @132804
     /* 132804 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(132853), // Rule ID 7173 //
     /* 132809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132826 */     // MIs[0] Rn
     /* 132826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132838 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 132841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132851 */     GIR_RootConstrainSelectedInstOperands,
     /* 132852 */     // GIR_Coverage, 7173,
     /* 132852 */     GIR_EraseRootFromParent_Done,
     /* 132853 */   // Label 2511: @132853
     /* 132853 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(132902), // Rule ID 7174 //
     /* 132858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132875 */     // MIs[0] Rn
     /* 132875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132887 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 132890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132900 */     GIR_RootConstrainSelectedInstOperands,
     /* 132901 */     // GIR_Coverage, 7174,
     /* 132901 */     GIR_EraseRootFromParent_Done,
     /* 132902 */   // Label 2512: @132902
     /* 132902 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(132951), // Rule ID 7175 //
     /* 132907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132924 */     // MIs[0] Rn
     /* 132924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132936 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 132939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132949 */     GIR_RootConstrainSelectedInstOperands,
     /* 132950 */     // GIR_Coverage, 7175,
     /* 132950 */     GIR_EraseRootFromParent_Done,
     /* 132951 */   // Label 2513: @132951
     /* 132951 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(133000), // Rule ID 7176 //
     /* 132956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132973 */     // MIs[0] Rn
     /* 132973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132985 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 132988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132998 */     GIR_RootConstrainSelectedInstOperands,
     /* 132999 */     // GIR_Coverage, 7176,
     /* 132999 */     GIR_EraseRootFromParent_Done,
     /* 133000 */   // Label 2514: @133000
     /* 133000 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(133049), // Rule ID 7177 //
     /* 133005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133022 */     // MIs[0] Rn
     /* 133022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133034 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 133037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133047 */     GIR_RootConstrainSelectedInstOperands,
     /* 133048 */     // GIR_Coverage, 7177,
     /* 133048 */     GIR_EraseRootFromParent_Done,
     /* 133049 */   // Label 2515: @133049
     /* 133049 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(133098), // Rule ID 7178 //
     /* 133054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133071 */     // MIs[0] Rn
     /* 133071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133083 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133096 */     GIR_RootConstrainSelectedInstOperands,
     /* 133097 */     // GIR_Coverage, 7178,
     /* 133097 */     GIR_EraseRootFromParent_Done,
     /* 133098 */   // Label 2516: @133098
     /* 133098 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(133147), // Rule ID 7179 //
     /* 133103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133120 */     // MIs[0] Rn
     /* 133120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133132 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133145 */     GIR_RootConstrainSelectedInstOperands,
     /* 133146 */     // GIR_Coverage, 7179,
     /* 133146 */     GIR_EraseRootFromParent_Done,
     /* 133147 */   // Label 2517: @133147
     /* 133147 */   GIM_Reject,
     /* 133148 */ // Label 2502: @133148
     /* 133148 */ GIM_Reject,
     /* 133149 */ // Label 2500: @133149
     /* 133149 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(133375),
     /* 133154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133157 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133164 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(133206), // Rule ID 7160 //
     /* 133169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133179 */     // MIs[0] Rn
     /* 133179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133191 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 133194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133204 */     GIR_RootConstrainSelectedInstOperands,
     /* 133205 */     // GIR_Coverage, 7160,
     /* 133205 */     GIR_EraseRootFromParent_Done,
     /* 133206 */   // Label 2519: @133206
     /* 133206 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(133248), // Rule ID 7161 //
     /* 133211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133221 */     // MIs[0] Rn
     /* 133221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133233 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 133236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133246 */     GIR_RootConstrainSelectedInstOperands,
     /* 133247 */     // GIR_Coverage, 7161,
     /* 133247 */     GIR_EraseRootFromParent_Done,
     /* 133248 */   // Label 2520: @133248
     /* 133248 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(133290), // Rule ID 7162 //
     /* 133253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133263 */     // MIs[0] Rn
     /* 133263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133275 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 133278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133288 */     GIR_RootConstrainSelectedInstOperands,
     /* 133289 */     // GIR_Coverage, 7162,
     /* 133289 */     GIR_EraseRootFromParent_Done,
     /* 133290 */   // Label 2521: @133290
     /* 133290 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(133332), // Rule ID 7163 //
     /* 133295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133305 */     // MIs[0] Rn
     /* 133305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133317 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 133320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133330 */     GIR_RootConstrainSelectedInstOperands,
     /* 133331 */     // GIR_Coverage, 7163,
     /* 133331 */     GIR_EraseRootFromParent_Done,
     /* 133332 */   // Label 2522: @133332
     /* 133332 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(133374), // Rule ID 7164 //
     /* 133337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133347 */     // MIs[0] Rn
     /* 133347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133359 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 133362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133372 */     GIR_RootConstrainSelectedInstOperands,
     /* 133373 */     // GIR_Coverage, 7164,
     /* 133373 */     GIR_EraseRootFromParent_Done,
     /* 133374 */   // Label 2523: @133374
     /* 133374 */   GIM_Reject,
     /* 133375 */ // Label 2518: @133375
     /* 133375 */ GIM_Reject,
     /* 133376 */ // Label 2501: @133376
     /* 133376 */ GIM_Reject,
     /* 133377 */ // Label 27: @133377
     /* 133377 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2526*/ GIMT_Encode4(134368),
     /* 133388 */ /*GILLT_s32*//*Label 2524*/ GIMT_Encode4(133396),
     /* 133392 */ /*GILLT_s64*//*Label 2525*/ GIMT_Encode4(134141),
     /* 133396 */ // Label 2524: @133396
     /* 133396 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(134140),
     /* 133401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133404 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(133453), // Rule ID 7205 //
     /* 133409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133426 */     // MIs[0] Rn
     /* 133426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133438 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 133441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133451 */     GIR_RootConstrainSelectedInstOperands,
     /* 133452 */     // GIR_Coverage, 7205,
     /* 133452 */     GIR_EraseRootFromParent_Done,
     /* 133453 */   // Label 2528: @133453
     /* 133453 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(133502), // Rule ID 7206 //
     /* 133458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133475 */     // MIs[0] Rn
     /* 133475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133487 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 133490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133500 */     GIR_RootConstrainSelectedInstOperands,
     /* 133501 */     // GIR_Coverage, 7206,
     /* 133501 */     GIR_EraseRootFromParent_Done,
     /* 133502 */   // Label 2529: @133502
     /* 133502 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(133551), // Rule ID 7207 //
     /* 133507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133524 */     // MIs[0] Rn
     /* 133524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133536 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 133539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133549 */     GIR_RootConstrainSelectedInstOperands,
     /* 133550 */     // GIR_Coverage, 7207,
     /* 133550 */     GIR_EraseRootFromParent_Done,
     /* 133551 */   // Label 2530: @133551
     /* 133551 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(133600), // Rule ID 7208 //
     /* 133556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133573 */     // MIs[0] Rn
     /* 133573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133585 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 133588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133598 */     GIR_RootConstrainSelectedInstOperands,
     /* 133599 */     // GIR_Coverage, 7208,
     /* 133599 */     GIR_EraseRootFromParent_Done,
     /* 133600 */   // Label 2531: @133600
     /* 133600 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(133649), // Rule ID 7209 //
     /* 133605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133622 */     // MIs[0] Rn
     /* 133622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133634 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 133637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133647 */     GIR_RootConstrainSelectedInstOperands,
     /* 133648 */     // GIR_Coverage, 7209,
     /* 133648 */     GIR_EraseRootFromParent_Done,
     /* 133649 */   // Label 2532: @133649
     /* 133649 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(133698), // Rule ID 7210 //
     /* 133654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133671 */     // MIs[0] Rn
     /* 133671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133683 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 133686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133696 */     GIR_RootConstrainSelectedInstOperands,
     /* 133697 */     // GIR_Coverage, 7210,
     /* 133697 */     GIR_EraseRootFromParent_Done,
     /* 133698 */   // Label 2533: @133698
     /* 133698 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(133747), // Rule ID 7211 //
     /* 133703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133706 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133713 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133720 */     // MIs[0] Rn
     /* 133720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133732 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 133735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133745 */     GIR_RootConstrainSelectedInstOperands,
     /* 133746 */     // GIR_Coverage, 7211,
     /* 133746 */     GIR_EraseRootFromParent_Done,
     /* 133747 */   // Label 2534: @133747
     /* 133747 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(133796), // Rule ID 7212 //
     /* 133752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133769 */     // MIs[0] Rn
     /* 133769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133781 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 133784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133794 */     GIR_RootConstrainSelectedInstOperands,
     /* 133795 */     // GIR_Coverage, 7212,
     /* 133795 */     GIR_EraseRootFromParent_Done,
     /* 133796 */   // Label 2535: @133796
     /* 133796 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(133845), // Rule ID 7213 //
     /* 133801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133818 */     // MIs[0] Rn
     /* 133818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133830 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 133833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133843 */     GIR_RootConstrainSelectedInstOperands,
     /* 133844 */     // GIR_Coverage, 7213,
     /* 133844 */     GIR_EraseRootFromParent_Done,
     /* 133845 */   // Label 2536: @133845
     /* 133845 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(133894), // Rule ID 7214 //
     /* 133850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133867 */     // MIs[0] Rn
     /* 133867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133879 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 133882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133892 */     GIR_RootConstrainSelectedInstOperands,
     /* 133893 */     // GIR_Coverage, 7214,
     /* 133893 */     GIR_EraseRootFromParent_Done,
     /* 133894 */   // Label 2537: @133894
     /* 133894 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(133943), // Rule ID 7215 //
     /* 133899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133916 */     // MIs[0] Rn
     /* 133916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133928 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 133931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133941 */     GIR_RootConstrainSelectedInstOperands,
     /* 133942 */     // GIR_Coverage, 7215,
     /* 133942 */     GIR_EraseRootFromParent_Done,
     /* 133943 */   // Label 2538: @133943
     /* 133943 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(133992), // Rule ID 7216 //
     /* 133948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133965 */     // MIs[0] Rn
     /* 133965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133977 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 133980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133990 */     GIR_RootConstrainSelectedInstOperands,
     /* 133991 */     // GIR_Coverage, 7216,
     /* 133991 */     GIR_EraseRootFromParent_Done,
     /* 133992 */   // Label 2539: @133992
     /* 133992 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(134041), // Rule ID 7217 //
     /* 133997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134014 */     // MIs[0] Rn
     /* 134014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134026 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 134029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134039 */     GIR_RootConstrainSelectedInstOperands,
     /* 134040 */     // GIR_Coverage, 7217,
     /* 134040 */     GIR_EraseRootFromParent_Done,
     /* 134041 */   // Label 2540: @134041
     /* 134041 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(134090), // Rule ID 7218 //
     /* 134046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134056 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134063 */     // MIs[0] Rn
     /* 134063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134075 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134088 */     GIR_RootConstrainSelectedInstOperands,
     /* 134089 */     // GIR_Coverage, 7218,
     /* 134089 */     GIR_EraseRootFromParent_Done,
     /* 134090 */   // Label 2541: @134090
     /* 134090 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(134139), // Rule ID 7219 //
     /* 134095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134112 */     // MIs[0] Rn
     /* 134112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134124 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134137 */     GIR_RootConstrainSelectedInstOperands,
     /* 134138 */     // GIR_Coverage, 7219,
     /* 134138 */     GIR_EraseRootFromParent_Done,
     /* 134139 */   // Label 2542: @134139
     /* 134139 */   GIM_Reject,
     /* 134140 */ // Label 2527: @134140
     /* 134140 */ GIM_Reject,
     /* 134141 */ // Label 2525: @134141
     /* 134141 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(134367),
     /* 134146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134149 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134156 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(134198), // Rule ID 7200 //
     /* 134161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134171 */     // MIs[0] Rn
     /* 134171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134183 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 134186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134196 */     GIR_RootConstrainSelectedInstOperands,
     /* 134197 */     // GIR_Coverage, 7200,
     /* 134197 */     GIR_EraseRootFromParent_Done,
     /* 134198 */   // Label 2544: @134198
     /* 134198 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(134240), // Rule ID 7201 //
     /* 134203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134213 */     // MIs[0] Rn
     /* 134213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134225 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 134228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134238 */     GIR_RootConstrainSelectedInstOperands,
     /* 134239 */     // GIR_Coverage, 7201,
     /* 134239 */     GIR_EraseRootFromParent_Done,
     /* 134240 */   // Label 2545: @134240
     /* 134240 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(134282), // Rule ID 7202 //
     /* 134245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134255 */     // MIs[0] Rn
     /* 134255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134267 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 134270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134280 */     GIR_RootConstrainSelectedInstOperands,
     /* 134281 */     // GIR_Coverage, 7202,
     /* 134281 */     GIR_EraseRootFromParent_Done,
     /* 134282 */   // Label 2546: @134282
     /* 134282 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(134324), // Rule ID 7203 //
     /* 134287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134290 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134297 */     // MIs[0] Rn
     /* 134297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134309 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 134312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134322 */     GIR_RootConstrainSelectedInstOperands,
     /* 134323 */     // GIR_Coverage, 7203,
     /* 134323 */     GIR_EraseRootFromParent_Done,
     /* 134324 */   // Label 2547: @134324
     /* 134324 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(134366), // Rule ID 7204 //
     /* 134329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134339 */     // MIs[0] Rn
     /* 134339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134351 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 134354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134364 */     GIR_RootConstrainSelectedInstOperands,
     /* 134365 */     // GIR_Coverage, 7204,
     /* 134365 */     GIR_EraseRootFromParent_Done,
     /* 134366 */   // Label 2548: @134366
     /* 134366 */   GIM_Reject,
     /* 134367 */ // Label 2543: @134367
     /* 134367 */ GIM_Reject,
     /* 134368 */ // Label 2526: @134368
     /* 134368 */ GIM_Reject,
     /* 134369 */ // Label 28: @134369
     /* 134369 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2551*/ GIMT_Encode4(135360),
     /* 134380 */ /*GILLT_s32*//*Label 2549*/ GIMT_Encode4(134388),
     /* 134384 */ /*GILLT_s64*//*Label 2550*/ GIMT_Encode4(135133),
     /* 134388 */ // Label 2549: @134388
     /* 134388 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(135132),
     /* 134393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134396 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(134445), // Rule ID 7225 //
     /* 134401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134418 */     // MIs[0] Rn
     /* 134418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134430 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 134433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134443 */     GIR_RootConstrainSelectedInstOperands,
     /* 134444 */     // GIR_Coverage, 7225,
     /* 134444 */     GIR_EraseRootFromParent_Done,
     /* 134445 */   // Label 2553: @134445
     /* 134445 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(134494), // Rule ID 7226 //
     /* 134450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134453 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134460 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134467 */     // MIs[0] Rn
     /* 134467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134479 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 134482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134492 */     GIR_RootConstrainSelectedInstOperands,
     /* 134493 */     // GIR_Coverage, 7226,
     /* 134493 */     GIR_EraseRootFromParent_Done,
     /* 134494 */   // Label 2554: @134494
     /* 134494 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(134543), // Rule ID 7227 //
     /* 134499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134516 */     // MIs[0] Rn
     /* 134516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134528 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 134531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134541 */     GIR_RootConstrainSelectedInstOperands,
     /* 134542 */     // GIR_Coverage, 7227,
     /* 134542 */     GIR_EraseRootFromParent_Done,
     /* 134543 */   // Label 2555: @134543
     /* 134543 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(134592), // Rule ID 7228 //
     /* 134548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134565 */     // MIs[0] Rn
     /* 134565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134577 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 134580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134590 */     GIR_RootConstrainSelectedInstOperands,
     /* 134591 */     // GIR_Coverage, 7228,
     /* 134591 */     GIR_EraseRootFromParent_Done,
     /* 134592 */   // Label 2556: @134592
     /* 134592 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(134641), // Rule ID 7229 //
     /* 134597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134614 */     // MIs[0] Rn
     /* 134614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134626 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 134629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134639 */     GIR_RootConstrainSelectedInstOperands,
     /* 134640 */     // GIR_Coverage, 7229,
     /* 134640 */     GIR_EraseRootFromParent_Done,
     /* 134641 */   // Label 2557: @134641
     /* 134641 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(134690), // Rule ID 7230 //
     /* 134646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134663 */     // MIs[0] Rn
     /* 134663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134675 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 134678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134688 */     GIR_RootConstrainSelectedInstOperands,
     /* 134689 */     // GIR_Coverage, 7230,
     /* 134689 */     GIR_EraseRootFromParent_Done,
     /* 134690 */   // Label 2558: @134690
     /* 134690 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(134739), // Rule ID 7231 //
     /* 134695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134712 */     // MIs[0] Rn
     /* 134712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134724 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 134727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134737 */     GIR_RootConstrainSelectedInstOperands,
     /* 134738 */     // GIR_Coverage, 7231,
     /* 134738 */     GIR_EraseRootFromParent_Done,
     /* 134739 */   // Label 2559: @134739
     /* 134739 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(134788), // Rule ID 7232 //
     /* 134744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134754 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134761 */     // MIs[0] Rn
     /* 134761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134773 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 134776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134786 */     GIR_RootConstrainSelectedInstOperands,
     /* 134787 */     // GIR_Coverage, 7232,
     /* 134787 */     GIR_EraseRootFromParent_Done,
     /* 134788 */   // Label 2560: @134788
     /* 134788 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(134837), // Rule ID 7233 //
     /* 134793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134803 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134810 */     // MIs[0] Rn
     /* 134810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134822 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 134825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134835 */     GIR_RootConstrainSelectedInstOperands,
     /* 134836 */     // GIR_Coverage, 7233,
     /* 134836 */     GIR_EraseRootFromParent_Done,
     /* 134837 */   // Label 2561: @134837
     /* 134837 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(134886), // Rule ID 7234 //
     /* 134842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134845 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134859 */     // MIs[0] Rn
     /* 134859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134871 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 134874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134884 */     GIR_RootConstrainSelectedInstOperands,
     /* 134885 */     // GIR_Coverage, 7234,
     /* 134885 */     GIR_EraseRootFromParent_Done,
     /* 134886 */   // Label 2562: @134886
     /* 134886 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(134935), // Rule ID 7235 //
     /* 134891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134894 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134908 */     // MIs[0] Rn
     /* 134908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134920 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 134923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134933 */     GIR_RootConstrainSelectedInstOperands,
     /* 134934 */     // GIR_Coverage, 7235,
     /* 134934 */     GIR_EraseRootFromParent_Done,
     /* 134935 */   // Label 2563: @134935
     /* 134935 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(134984), // Rule ID 7236 //
     /* 134940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134943 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134950 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134957 */     // MIs[0] Rn
     /* 134957 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134969 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 134972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134982 */     GIR_RootConstrainSelectedInstOperands,
     /* 134983 */     // GIR_Coverage, 7236,
     /* 134983 */     GIR_EraseRootFromParent_Done,
     /* 134984 */   // Label 2564: @134984
     /* 134984 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(135033), // Rule ID 7237 //
     /* 134989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134992 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134999 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135006 */     // MIs[0] Rn
     /* 135006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135018 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 135021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135031 */     GIR_RootConstrainSelectedInstOperands,
     /* 135032 */     // GIR_Coverage, 7237,
     /* 135032 */     GIR_EraseRootFromParent_Done,
     /* 135033 */   // Label 2565: @135033
     /* 135033 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(135082), // Rule ID 7238 //
     /* 135038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135055 */     // MIs[0] Rn
     /* 135055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135067 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135080 */     GIR_RootConstrainSelectedInstOperands,
     /* 135081 */     // GIR_Coverage, 7238,
     /* 135081 */     GIR_EraseRootFromParent_Done,
     /* 135082 */   // Label 2566: @135082
     /* 135082 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(135131), // Rule ID 7239 //
     /* 135087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135104 */     // MIs[0] Rn
     /* 135104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135116 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135129 */     GIR_RootConstrainSelectedInstOperands,
     /* 135130 */     // GIR_Coverage, 7239,
     /* 135130 */     GIR_EraseRootFromParent_Done,
     /* 135131 */   // Label 2567: @135131
     /* 135131 */   GIM_Reject,
     /* 135132 */ // Label 2552: @135132
     /* 135132 */ GIM_Reject,
     /* 135133 */ // Label 2550: @135133
     /* 135133 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(135359),
     /* 135138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135141 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135148 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(135190), // Rule ID 7220 //
     /* 135153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135163 */     // MIs[0] Rn
     /* 135163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135175 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 135178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135188 */     GIR_RootConstrainSelectedInstOperands,
     /* 135189 */     // GIR_Coverage, 7220,
     /* 135189 */     GIR_EraseRootFromParent_Done,
     /* 135190 */   // Label 2569: @135190
     /* 135190 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(135232), // Rule ID 7221 //
     /* 135195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135205 */     // MIs[0] Rn
     /* 135205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135217 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 135220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135230 */     GIR_RootConstrainSelectedInstOperands,
     /* 135231 */     // GIR_Coverage, 7221,
     /* 135231 */     GIR_EraseRootFromParent_Done,
     /* 135232 */   // Label 2570: @135232
     /* 135232 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(135274), // Rule ID 7222 //
     /* 135237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135240 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135247 */     // MIs[0] Rn
     /* 135247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135259 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 135262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135272 */     GIR_RootConstrainSelectedInstOperands,
     /* 135273 */     // GIR_Coverage, 7222,
     /* 135273 */     GIR_EraseRootFromParent_Done,
     /* 135274 */   // Label 2571: @135274
     /* 135274 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(135316), // Rule ID 7223 //
     /* 135279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135289 */     // MIs[0] Rn
     /* 135289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135301 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 135304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135314 */     GIR_RootConstrainSelectedInstOperands,
     /* 135315 */     // GIR_Coverage, 7223,
     /* 135315 */     GIR_EraseRootFromParent_Done,
     /* 135316 */   // Label 2572: @135316
     /* 135316 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(135358), // Rule ID 7224 //
     /* 135321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135331 */     // MIs[0] Rn
     /* 135331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135343 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 135346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135356 */     GIR_RootConstrainSelectedInstOperands,
     /* 135357 */     // GIR_Coverage, 7224,
     /* 135357 */     GIR_EraseRootFromParent_Done,
     /* 135358 */   // Label 2573: @135358
     /* 135358 */   GIM_Reject,
     /* 135359 */ // Label 2568: @135359
     /* 135359 */ GIM_Reject,
     /* 135360 */ // Label 2551: @135360
     /* 135360 */ GIM_Reject,
     /* 135361 */ // Label 29: @135361
     /* 135361 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2576*/ GIMT_Encode4(136352),
     /* 135372 */ /*GILLT_s32*//*Label 2574*/ GIMT_Encode4(135380),
     /* 135376 */ /*GILLT_s64*//*Label 2575*/ GIMT_Encode4(136125),
     /* 135380 */ // Label 2574: @135380
     /* 135380 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(136124),
     /* 135385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135388 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(135437), // Rule ID 7245 //
     /* 135393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135403 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135410 */     // MIs[0] Rn
     /* 135410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135422 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 135425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135435 */     GIR_RootConstrainSelectedInstOperands,
     /* 135436 */     // GIR_Coverage, 7245,
     /* 135436 */     GIR_EraseRootFromParent_Done,
     /* 135437 */   // Label 2578: @135437
     /* 135437 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(135486), // Rule ID 7246 //
     /* 135442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135452 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135459 */     // MIs[0] Rn
     /* 135459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135471 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 135474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135484 */     GIR_RootConstrainSelectedInstOperands,
     /* 135485 */     // GIR_Coverage, 7246,
     /* 135485 */     GIR_EraseRootFromParent_Done,
     /* 135486 */   // Label 2579: @135486
     /* 135486 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(135535), // Rule ID 7247 //
     /* 135491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135494 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135501 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135508 */     // MIs[0] Rn
     /* 135508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135520 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 135523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135533 */     GIR_RootConstrainSelectedInstOperands,
     /* 135534 */     // GIR_Coverage, 7247,
     /* 135534 */     GIR_EraseRootFromParent_Done,
     /* 135535 */   // Label 2580: @135535
     /* 135535 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(135584), // Rule ID 7248 //
     /* 135540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135557 */     // MIs[0] Rn
     /* 135557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135569 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 135572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135582 */     GIR_RootConstrainSelectedInstOperands,
     /* 135583 */     // GIR_Coverage, 7248,
     /* 135583 */     GIR_EraseRootFromParent_Done,
     /* 135584 */   // Label 2581: @135584
     /* 135584 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(135633), // Rule ID 7249 //
     /* 135589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135606 */     // MIs[0] Rn
     /* 135606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135618 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 135621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135631 */     GIR_RootConstrainSelectedInstOperands,
     /* 135632 */     // GIR_Coverage, 7249,
     /* 135632 */     GIR_EraseRootFromParent_Done,
     /* 135633 */   // Label 2582: @135633
     /* 135633 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(135682), // Rule ID 7250 //
     /* 135638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135655 */     // MIs[0] Rn
     /* 135655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135667 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 135670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135680 */     GIR_RootConstrainSelectedInstOperands,
     /* 135681 */     // GIR_Coverage, 7250,
     /* 135681 */     GIR_EraseRootFromParent_Done,
     /* 135682 */   // Label 2583: @135682
     /* 135682 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(135731), // Rule ID 7251 //
     /* 135687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135704 */     // MIs[0] Rn
     /* 135704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135716 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 135719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135729 */     GIR_RootConstrainSelectedInstOperands,
     /* 135730 */     // GIR_Coverage, 7251,
     /* 135730 */     GIR_EraseRootFromParent_Done,
     /* 135731 */   // Label 2584: @135731
     /* 135731 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(135780), // Rule ID 7252 //
     /* 135736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135753 */     // MIs[0] Rn
     /* 135753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135765 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 135768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135778 */     GIR_RootConstrainSelectedInstOperands,
     /* 135779 */     // GIR_Coverage, 7252,
     /* 135779 */     GIR_EraseRootFromParent_Done,
     /* 135780 */   // Label 2585: @135780
     /* 135780 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(135829), // Rule ID 7253 //
     /* 135785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135802 */     // MIs[0] Rn
     /* 135802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135814 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 135817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135827 */     GIR_RootConstrainSelectedInstOperands,
     /* 135828 */     // GIR_Coverage, 7253,
     /* 135828 */     GIR_EraseRootFromParent_Done,
     /* 135829 */   // Label 2586: @135829
     /* 135829 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(135878), // Rule ID 7254 //
     /* 135834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135837 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135851 */     // MIs[0] Rn
     /* 135851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135863 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 135866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135876 */     GIR_RootConstrainSelectedInstOperands,
     /* 135877 */     // GIR_Coverage, 7254,
     /* 135877 */     GIR_EraseRootFromParent_Done,
     /* 135878 */   // Label 2587: @135878
     /* 135878 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(135927), // Rule ID 7255 //
     /* 135883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135893 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135900 */     // MIs[0] Rn
     /* 135900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135912 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 135915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135925 */     GIR_RootConstrainSelectedInstOperands,
     /* 135926 */     // GIR_Coverage, 7255,
     /* 135926 */     GIR_EraseRootFromParent_Done,
     /* 135927 */   // Label 2588: @135927
     /* 135927 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(135976), // Rule ID 7256 //
     /* 135932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135935 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135949 */     // MIs[0] Rn
     /* 135949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135961 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 135964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135974 */     GIR_RootConstrainSelectedInstOperands,
     /* 135975 */     // GIR_Coverage, 7256,
     /* 135975 */     GIR_EraseRootFromParent_Done,
     /* 135976 */   // Label 2589: @135976
     /* 135976 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(136025), // Rule ID 7257 //
     /* 135981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135984 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135991 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135998 */     // MIs[0] Rn
     /* 135998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136010 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 136013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136023 */     GIR_RootConstrainSelectedInstOperands,
     /* 136024 */     // GIR_Coverage, 7257,
     /* 136024 */     GIR_EraseRootFromParent_Done,
     /* 136025 */   // Label 2590: @136025
     /* 136025 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(136074), // Rule ID 7258 //
     /* 136030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136047 */     // MIs[0] Rn
     /* 136047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136059 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136072 */     GIR_RootConstrainSelectedInstOperands,
     /* 136073 */     // GIR_Coverage, 7258,
     /* 136073 */     GIR_EraseRootFromParent_Done,
     /* 136074 */   // Label 2591: @136074
     /* 136074 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(136123), // Rule ID 7259 //
     /* 136079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136082 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136089 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136096 */     // MIs[0] Rn
     /* 136096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136108 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136121 */     GIR_RootConstrainSelectedInstOperands,
     /* 136122 */     // GIR_Coverage, 7259,
     /* 136122 */     GIR_EraseRootFromParent_Done,
     /* 136123 */   // Label 2592: @136123
     /* 136123 */   GIM_Reject,
     /* 136124 */ // Label 2577: @136124
     /* 136124 */ GIM_Reject,
     /* 136125 */ // Label 2575: @136125
     /* 136125 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(136351),
     /* 136130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136133 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 136140 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(136182), // Rule ID 7240 //
     /* 136145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136155 */     // MIs[0] Rn
     /* 136155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136167 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 136170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136180 */     GIR_RootConstrainSelectedInstOperands,
     /* 136181 */     // GIR_Coverage, 7240,
     /* 136181 */     GIR_EraseRootFromParent_Done,
     /* 136182 */   // Label 2594: @136182
     /* 136182 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(136224), // Rule ID 7241 //
     /* 136187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136197 */     // MIs[0] Rn
     /* 136197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136209 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 136212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136222 */     GIR_RootConstrainSelectedInstOperands,
     /* 136223 */     // GIR_Coverage, 7241,
     /* 136223 */     GIR_EraseRootFromParent_Done,
     /* 136224 */   // Label 2595: @136224
     /* 136224 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(136266), // Rule ID 7242 //
     /* 136229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136232 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136239 */     // MIs[0] Rn
     /* 136239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136251 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 136254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136264 */     GIR_RootConstrainSelectedInstOperands,
     /* 136265 */     // GIR_Coverage, 7242,
     /* 136265 */     GIR_EraseRootFromParent_Done,
     /* 136266 */   // Label 2596: @136266
     /* 136266 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(136308), // Rule ID 7243 //
     /* 136271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136274 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136281 */     // MIs[0] Rn
     /* 136281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136293 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 136296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136306 */     GIR_RootConstrainSelectedInstOperands,
     /* 136307 */     // GIR_Coverage, 7243,
     /* 136307 */     GIR_EraseRootFromParent_Done,
     /* 136308 */   // Label 2597: @136308
     /* 136308 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(136350), // Rule ID 7244 //
     /* 136313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136323 */     // MIs[0] Rn
     /* 136323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136335 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 136338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136348 */     GIR_RootConstrainSelectedInstOperands,
     /* 136349 */     // GIR_Coverage, 7244,
     /* 136349 */     GIR_EraseRootFromParent_Done,
     /* 136350 */   // Label 2598: @136350
     /* 136350 */   GIM_Reject,
     /* 136351 */ // Label 2593: @136351
     /* 136351 */ GIM_Reject,
     /* 136352 */ // Label 2576: @136352
     /* 136352 */ GIM_Reject,
     /* 136353 */ // Label 30: @136353
     /* 136353 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2601*/ GIMT_Encode4(137344),
     /* 136364 */ /*GILLT_s32*//*Label 2599*/ GIMT_Encode4(136372),
     /* 136368 */ /*GILLT_s64*//*Label 2600*/ GIMT_Encode4(137117),
     /* 136372 */ // Label 2599: @136372
     /* 136372 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(137116),
     /* 136377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136380 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(136429), // Rule ID 7265 //
     /* 136385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136402 */     // MIs[0] Rn
     /* 136402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136414 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 136417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136427 */     GIR_RootConstrainSelectedInstOperands,
     /* 136428 */     // GIR_Coverage, 7265,
     /* 136428 */     GIR_EraseRootFromParent_Done,
     /* 136429 */   // Label 2603: @136429
     /* 136429 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(136478), // Rule ID 7266 //
     /* 136434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136444 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136451 */     // MIs[0] Rn
     /* 136451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136463 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 136466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136476 */     GIR_RootConstrainSelectedInstOperands,
     /* 136477 */     // GIR_Coverage, 7266,
     /* 136477 */     GIR_EraseRootFromParent_Done,
     /* 136478 */   // Label 2604: @136478
     /* 136478 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(136527), // Rule ID 7267 //
     /* 136483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136486 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136493 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136500 */     // MIs[0] Rn
     /* 136500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136512 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 136515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136525 */     GIR_RootConstrainSelectedInstOperands,
     /* 136526 */     // GIR_Coverage, 7267,
     /* 136526 */     GIR_EraseRootFromParent_Done,
     /* 136527 */   // Label 2605: @136527
     /* 136527 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(136576), // Rule ID 7268 //
     /* 136532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136535 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136542 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136549 */     // MIs[0] Rn
     /* 136549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136561 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 136564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136574 */     GIR_RootConstrainSelectedInstOperands,
     /* 136575 */     // GIR_Coverage, 7268,
     /* 136575 */     GIR_EraseRootFromParent_Done,
     /* 136576 */   // Label 2606: @136576
     /* 136576 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(136625), // Rule ID 7269 //
     /* 136581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136598 */     // MIs[0] Rn
     /* 136598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136610 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 136613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136623 */     GIR_RootConstrainSelectedInstOperands,
     /* 136624 */     // GIR_Coverage, 7269,
     /* 136624 */     GIR_EraseRootFromParent_Done,
     /* 136625 */   // Label 2607: @136625
     /* 136625 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(136674), // Rule ID 7270 //
     /* 136630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136647 */     // MIs[0] Rn
     /* 136647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136659 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 136662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136672 */     GIR_RootConstrainSelectedInstOperands,
     /* 136673 */     // GIR_Coverage, 7270,
     /* 136673 */     GIR_EraseRootFromParent_Done,
     /* 136674 */   // Label 2608: @136674
     /* 136674 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(136723), // Rule ID 7271 //
     /* 136679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136696 */     // MIs[0] Rn
     /* 136696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136708 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 136711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136721 */     GIR_RootConstrainSelectedInstOperands,
     /* 136722 */     // GIR_Coverage, 7271,
     /* 136722 */     GIR_EraseRootFromParent_Done,
     /* 136723 */   // Label 2609: @136723
     /* 136723 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(136772), // Rule ID 7272 //
     /* 136728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136745 */     // MIs[0] Rn
     /* 136745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136757 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 136760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136770 */     GIR_RootConstrainSelectedInstOperands,
     /* 136771 */     // GIR_Coverage, 7272,
     /* 136771 */     GIR_EraseRootFromParent_Done,
     /* 136772 */   // Label 2610: @136772
     /* 136772 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(136821), // Rule ID 7273 //
     /* 136777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136794 */     // MIs[0] Rn
     /* 136794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136806 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 136809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136819 */     GIR_RootConstrainSelectedInstOperands,
     /* 136820 */     // GIR_Coverage, 7273,
     /* 136820 */     GIR_EraseRootFromParent_Done,
     /* 136821 */   // Label 2611: @136821
     /* 136821 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(136870), // Rule ID 7274 //
     /* 136826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136843 */     // MIs[0] Rn
     /* 136843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136855 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 136858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136868 */     GIR_RootConstrainSelectedInstOperands,
     /* 136869 */     // GIR_Coverage, 7274,
     /* 136869 */     GIR_EraseRootFromParent_Done,
     /* 136870 */   // Label 2612: @136870
     /* 136870 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(136919), // Rule ID 7275 //
     /* 136875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136892 */     // MIs[0] Rn
     /* 136892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136904 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 136907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136917 */     GIR_RootConstrainSelectedInstOperands,
     /* 136918 */     // GIR_Coverage, 7275,
     /* 136918 */     GIR_EraseRootFromParent_Done,
     /* 136919 */   // Label 2613: @136919
     /* 136919 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(136968), // Rule ID 7276 //
     /* 136924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136927 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136934 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136941 */     // MIs[0] Rn
     /* 136941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136953 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 136956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136966 */     GIR_RootConstrainSelectedInstOperands,
     /* 136967 */     // GIR_Coverage, 7276,
     /* 136967 */     GIR_EraseRootFromParent_Done,
     /* 136968 */   // Label 2614: @136968
     /* 136968 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(137017), // Rule ID 7277 //
     /* 136973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136976 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136990 */     // MIs[0] Rn
     /* 136990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137002 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 137005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137015 */     GIR_RootConstrainSelectedInstOperands,
     /* 137016 */     // GIR_Coverage, 7277,
     /* 137016 */     GIR_EraseRootFromParent_Done,
     /* 137017 */   // Label 2615: @137017
     /* 137017 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(137066), // Rule ID 7278 //
     /* 137022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137039 */     // MIs[0] Rn
     /* 137039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137051 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137064 */     GIR_RootConstrainSelectedInstOperands,
     /* 137065 */     // GIR_Coverage, 7278,
     /* 137065 */     GIR_EraseRootFromParent_Done,
     /* 137066 */   // Label 2616: @137066
     /* 137066 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(137115), // Rule ID 7279 //
     /* 137071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137088 */     // MIs[0] Rn
     /* 137088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137100 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137113 */     GIR_RootConstrainSelectedInstOperands,
     /* 137114 */     // GIR_Coverage, 7279,
     /* 137114 */     GIR_EraseRootFromParent_Done,
     /* 137115 */   // Label 2617: @137115
     /* 137115 */   GIM_Reject,
     /* 137116 */ // Label 2602: @137116
     /* 137116 */ GIM_Reject,
     /* 137117 */ // Label 2600: @137117
     /* 137117 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(137343),
     /* 137122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137125 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137132 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(137174), // Rule ID 7260 //
     /* 137137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137147 */     // MIs[0] Rn
     /* 137147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137159 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 137162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137172 */     GIR_RootConstrainSelectedInstOperands,
     /* 137173 */     // GIR_Coverage, 7260,
     /* 137173 */     GIR_EraseRootFromParent_Done,
     /* 137174 */   // Label 2619: @137174
     /* 137174 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(137216), // Rule ID 7261 //
     /* 137179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137182 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137189 */     // MIs[0] Rn
     /* 137189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137201 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 137204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137214 */     GIR_RootConstrainSelectedInstOperands,
     /* 137215 */     // GIR_Coverage, 7261,
     /* 137215 */     GIR_EraseRootFromParent_Done,
     /* 137216 */   // Label 2620: @137216
     /* 137216 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(137258), // Rule ID 7262 //
     /* 137221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137224 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137231 */     // MIs[0] Rn
     /* 137231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137243 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 137246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137256 */     GIR_RootConstrainSelectedInstOperands,
     /* 137257 */     // GIR_Coverage, 7262,
     /* 137257 */     GIR_EraseRootFromParent_Done,
     /* 137258 */   // Label 2621: @137258
     /* 137258 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(137300), // Rule ID 7263 //
     /* 137263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137273 */     // MIs[0] Rn
     /* 137273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137285 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 137288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137298 */     GIR_RootConstrainSelectedInstOperands,
     /* 137299 */     // GIR_Coverage, 7263,
     /* 137299 */     GIR_EraseRootFromParent_Done,
     /* 137300 */   // Label 2622: @137300
     /* 137300 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(137342), // Rule ID 7264 //
     /* 137305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137315 */     // MIs[0] Rn
     /* 137315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137327 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 137330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137340 */     GIR_RootConstrainSelectedInstOperands,
     /* 137341 */     // GIR_Coverage, 7264,
     /* 137341 */     GIR_EraseRootFromParent_Done,
     /* 137342 */   // Label 2623: @137342
     /* 137342 */   GIM_Reject,
     /* 137343 */ // Label 2618: @137343
     /* 137343 */ GIM_Reject,
     /* 137344 */ // Label 2601: @137344
     /* 137344 */ GIM_Reject,
     /* 137345 */ // Label 31: @137345
     /* 137345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2627*/ GIMT_Encode4(138049),
     /* 137356 */ /*GILLT_s16*//*Label 2624*/ GIMT_Encode4(137368),
     /* 137360 */ /*GILLT_s32*//*Label 2625*/ GIMT_Encode4(137595),
     /* 137364 */ /*GILLT_s64*//*Label 2626*/ GIMT_Encode4(137822),
     /* 137368 */ // Label 2624: @137368
     /* 137368 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(137594),
     /* 137373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137376 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137383 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(137425), // Rule ID 2584 //
     /* 137388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137398 */     // MIs[0] Rn
     /* 137398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137410 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 137413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137423 */     GIR_RootConstrainSelectedInstOperands,
     /* 137424 */     // GIR_Coverage, 2584,
     /* 137424 */     GIR_EraseRootFromParent_Done,
     /* 137425 */   // Label 2629: @137425
     /* 137425 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(137467), // Rule ID 2585 //
     /* 137430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137440 */     // MIs[0] Rn
     /* 137440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137452 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 137455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137465 */     GIR_RootConstrainSelectedInstOperands,
     /* 137466 */     // GIR_Coverage, 2585,
     /* 137466 */     GIR_EraseRootFromParent_Done,
     /* 137467 */   // Label 2630: @137467
     /* 137467 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(137509), // Rule ID 2586 //
     /* 137472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137482 */     // MIs[0] Rn
     /* 137482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137494 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 137497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137507 */     GIR_RootConstrainSelectedInstOperands,
     /* 137508 */     // GIR_Coverage, 2586,
     /* 137508 */     GIR_EraseRootFromParent_Done,
     /* 137509 */   // Label 2631: @137509
     /* 137509 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(137551), // Rule ID 2587 //
     /* 137514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137524 */     // MIs[0] Rn
     /* 137524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137536 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 137539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137549 */     GIR_RootConstrainSelectedInstOperands,
     /* 137550 */     // GIR_Coverage, 2587,
     /* 137550 */     GIR_EraseRootFromParent_Done,
     /* 137551 */   // Label 2632: @137551
     /* 137551 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(137593), // Rule ID 2588 //
     /* 137556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137566 */     // MIs[0] Rn
     /* 137566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137578 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 137581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137591 */     GIR_RootConstrainSelectedInstOperands,
     /* 137592 */     // GIR_Coverage, 2588,
     /* 137592 */     GIR_EraseRootFromParent_Done,
     /* 137593 */   // Label 2633: @137593
     /* 137593 */   GIM_Reject,
     /* 137594 */ // Label 2628: @137594
     /* 137594 */ GIM_Reject,
     /* 137595 */ // Label 2625: @137595
     /* 137595 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(137821),
     /* 137600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137610 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(137652), // Rule ID 7355 //
     /* 137615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137625 */     // MIs[0] Rn
     /* 137625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137637 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 137640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137650 */     GIR_RootConstrainSelectedInstOperands,
     /* 137651 */     // GIR_Coverage, 7355,
     /* 137651 */     GIR_EraseRootFromParent_Done,
     /* 137652 */   // Label 2635: @137652
     /* 137652 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(137694), // Rule ID 7356 //
     /* 137657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137667 */     // MIs[0] Rn
     /* 137667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137679 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 137682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137692 */     GIR_RootConstrainSelectedInstOperands,
     /* 137693 */     // GIR_Coverage, 7356,
     /* 137693 */     GIR_EraseRootFromParent_Done,
     /* 137694 */   // Label 2636: @137694
     /* 137694 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(137736), // Rule ID 7357 //
     /* 137699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137709 */     // MIs[0] Rn
     /* 137709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137721 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 137724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137734 */     GIR_RootConstrainSelectedInstOperands,
     /* 137735 */     // GIR_Coverage, 7357,
     /* 137735 */     GIR_EraseRootFromParent_Done,
     /* 137736 */   // Label 2637: @137736
     /* 137736 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(137778), // Rule ID 7358 //
     /* 137741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137751 */     // MIs[0] Rn
     /* 137751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137763 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 137766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137776 */     GIR_RootConstrainSelectedInstOperands,
     /* 137777 */     // GIR_Coverage, 7358,
     /* 137777 */     GIR_EraseRootFromParent_Done,
     /* 137778 */   // Label 2638: @137778
     /* 137778 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(137820), // Rule ID 7359 //
     /* 137783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137793 */     // MIs[0] Rn
     /* 137793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137805 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 137808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137818 */     GIR_RootConstrainSelectedInstOperands,
     /* 137819 */     // GIR_Coverage, 7359,
     /* 137819 */     GIR_EraseRootFromParent_Done,
     /* 137820 */   // Label 2639: @137820
     /* 137820 */   GIM_Reject,
     /* 137821 */ // Label 2634: @137821
     /* 137821 */ GIM_Reject,
     /* 137822 */ // Label 2626: @137822
     /* 137822 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(138048),
     /* 137827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137830 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137837 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(137879), // Rule ID 7360 //
     /* 137842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137852 */     // MIs[0] Rn
     /* 137852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137864 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 137867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137877 */     GIR_RootConstrainSelectedInstOperands,
     /* 137878 */     // GIR_Coverage, 7360,
     /* 137878 */     GIR_EraseRootFromParent_Done,
     /* 137879 */   // Label 2641: @137879
     /* 137879 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(137921), // Rule ID 7361 //
     /* 137884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137894 */     // MIs[0] Rn
     /* 137894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137906 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 137909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137919 */     GIR_RootConstrainSelectedInstOperands,
     /* 137920 */     // GIR_Coverage, 7361,
     /* 137920 */     GIR_EraseRootFromParent_Done,
     /* 137921 */   // Label 2642: @137921
     /* 137921 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(137963), // Rule ID 7362 //
     /* 137926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137929 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137936 */     // MIs[0] Rn
     /* 137936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137948 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 137951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137961 */     GIR_RootConstrainSelectedInstOperands,
     /* 137962 */     // GIR_Coverage, 7362,
     /* 137962 */     GIR_EraseRootFromParent_Done,
     /* 137963 */   // Label 2643: @137963
     /* 137963 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(138005), // Rule ID 7363 //
     /* 137968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137971 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137978 */     // MIs[0] Rn
     /* 137978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137990 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 137993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138003 */     GIR_RootConstrainSelectedInstOperands,
     /* 138004 */     // GIR_Coverage, 7363,
     /* 138004 */     GIR_EraseRootFromParent_Done,
     /* 138005 */   // Label 2644: @138005
     /* 138005 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(138047), // Rule ID 7364 //
     /* 138010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138020 */     // MIs[0] Rn
     /* 138020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138032 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138045 */     GIR_RootConstrainSelectedInstOperands,
     /* 138046 */     // GIR_Coverage, 7364,
     /* 138046 */     GIR_EraseRootFromParent_Done,
     /* 138047 */   // Label 2645: @138047
     /* 138047 */   GIM_Reject,
     /* 138048 */ // Label 2640: @138048
     /* 138048 */ GIM_Reject,
     /* 138049 */ // Label 2627: @138049
     /* 138049 */ GIM_Reject,
     /* 138050 */ // Label 32: @138050
     /* 138050 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2649*/ GIMT_Encode4(138754),
     /* 138061 */ /*GILLT_s16*//*Label 2646*/ GIMT_Encode4(138073),
     /* 138065 */ /*GILLT_s32*//*Label 2647*/ GIMT_Encode4(138300),
     /* 138069 */ /*GILLT_s64*//*Label 2648*/ GIMT_Encode4(138527),
     /* 138073 */ // Label 2646: @138073
     /* 138073 */ GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(138299),
     /* 138078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138081 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138088 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(138130), // Rule ID 7365 //
     /* 138093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138103 */     // MIs[0] Rn
     /* 138103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138115 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 138118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138128 */     GIR_RootConstrainSelectedInstOperands,
     /* 138129 */     // GIR_Coverage, 7365,
     /* 138129 */     GIR_EraseRootFromParent_Done,
     /* 138130 */   // Label 2651: @138130
     /* 138130 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(138172), // Rule ID 7366 //
     /* 138135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138145 */     // MIs[0] Rn
     /* 138145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138157 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 138160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138170 */     GIR_RootConstrainSelectedInstOperands,
     /* 138171 */     // GIR_Coverage, 7366,
     /* 138171 */     GIR_EraseRootFromParent_Done,
     /* 138172 */   // Label 2652: @138172
     /* 138172 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(138214), // Rule ID 7367 //
     /* 138177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138180 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138187 */     // MIs[0] Rn
     /* 138187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138199 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 138202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138212 */     GIR_RootConstrainSelectedInstOperands,
     /* 138213 */     // GIR_Coverage, 7367,
     /* 138213 */     GIR_EraseRootFromParent_Done,
     /* 138214 */   // Label 2653: @138214
     /* 138214 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(138256), // Rule ID 7368 //
     /* 138219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138229 */     // MIs[0] Rn
     /* 138229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138241 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 138244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138254 */     GIR_RootConstrainSelectedInstOperands,
     /* 138255 */     // GIR_Coverage, 7368,
     /* 138255 */     GIR_EraseRootFromParent_Done,
     /* 138256 */   // Label 2654: @138256
     /* 138256 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(138298), // Rule ID 7369 //
     /* 138261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138271 */     // MIs[0] Rn
     /* 138271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138283 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 138286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138296 */     GIR_RootConstrainSelectedInstOperands,
     /* 138297 */     // GIR_Coverage, 7369,
     /* 138297 */     GIR_EraseRootFromParent_Done,
     /* 138298 */   // Label 2655: @138298
     /* 138298 */   GIM_Reject,
     /* 138299 */ // Label 2650: @138299
     /* 138299 */ GIM_Reject,
     /* 138300 */ // Label 2647: @138300
     /* 138300 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(138526),
     /* 138305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138308 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138315 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(138357), // Rule ID 7370 //
     /* 138320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138330 */     // MIs[0] Rn
     /* 138330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138342 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 138345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138355 */     GIR_RootConstrainSelectedInstOperands,
     /* 138356 */     // GIR_Coverage, 7370,
     /* 138356 */     GIR_EraseRootFromParent_Done,
     /* 138357 */   // Label 2657: @138357
     /* 138357 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(138399), // Rule ID 7371 //
     /* 138362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138365 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138372 */     // MIs[0] Rn
     /* 138372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138384 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 138387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138397 */     GIR_RootConstrainSelectedInstOperands,
     /* 138398 */     // GIR_Coverage, 7371,
     /* 138398 */     GIR_EraseRootFromParent_Done,
     /* 138399 */   // Label 2658: @138399
     /* 138399 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(138441), // Rule ID 7372 //
     /* 138404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138414 */     // MIs[0] Rn
     /* 138414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138426 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 138429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138439 */     GIR_RootConstrainSelectedInstOperands,
     /* 138440 */     // GIR_Coverage, 7372,
     /* 138440 */     GIR_EraseRootFromParent_Done,
     /* 138441 */   // Label 2659: @138441
     /* 138441 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(138483), // Rule ID 7373 //
     /* 138446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138456 */     // MIs[0] Rn
     /* 138456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138468 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 138471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138481 */     GIR_RootConstrainSelectedInstOperands,
     /* 138482 */     // GIR_Coverage, 7373,
     /* 138482 */     GIR_EraseRootFromParent_Done,
     /* 138483 */   // Label 2660: @138483
     /* 138483 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(138525), // Rule ID 7374 //
     /* 138488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138498 */     // MIs[0] Rn
     /* 138498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138510 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 138513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138523 */     GIR_RootConstrainSelectedInstOperands,
     /* 138524 */     // GIR_Coverage, 7374,
     /* 138524 */     GIR_EraseRootFromParent_Done,
     /* 138525 */   // Label 2661: @138525
     /* 138525 */   GIM_Reject,
     /* 138526 */ // Label 2656: @138526
     /* 138526 */ GIM_Reject,
     /* 138527 */ // Label 2648: @138527
     /* 138527 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(138753),
     /* 138532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138535 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138542 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(138584), // Rule ID 7375 //
     /* 138547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138557 */     // MIs[0] Rn
     /* 138557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138569 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 138572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138582 */     GIR_RootConstrainSelectedInstOperands,
     /* 138583 */     // GIR_Coverage, 7375,
     /* 138583 */     GIR_EraseRootFromParent_Done,
     /* 138584 */   // Label 2663: @138584
     /* 138584 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(138626), // Rule ID 7376 //
     /* 138589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138599 */     // MIs[0] Rn
     /* 138599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138611 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 138614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138624 */     GIR_RootConstrainSelectedInstOperands,
     /* 138625 */     // GIR_Coverage, 7376,
     /* 138625 */     GIR_EraseRootFromParent_Done,
     /* 138626 */   // Label 2664: @138626
     /* 138626 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(138668), // Rule ID 7377 //
     /* 138631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138641 */     // MIs[0] Rn
     /* 138641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138653 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 138656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138666 */     GIR_RootConstrainSelectedInstOperands,
     /* 138667 */     // GIR_Coverage, 7377,
     /* 138667 */     GIR_EraseRootFromParent_Done,
     /* 138668 */   // Label 2665: @138668
     /* 138668 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(138710), // Rule ID 7378 //
     /* 138673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138683 */     // MIs[0] Rn
     /* 138683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138695 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 138698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138708 */     GIR_RootConstrainSelectedInstOperands,
     /* 138709 */     // GIR_Coverage, 7378,
     /* 138709 */     GIR_EraseRootFromParent_Done,
     /* 138710 */   // Label 2666: @138710
     /* 138710 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(138752), // Rule ID 7379 //
     /* 138715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138725 */     // MIs[0] Rn
     /* 138725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138737 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 138740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138750 */     GIR_RootConstrainSelectedInstOperands,
     /* 138751 */     // GIR_Coverage, 7379,
     /* 138751 */     GIR_EraseRootFromParent_Done,
     /* 138752 */   // Label 2667: @138752
     /* 138752 */   GIM_Reject,
     /* 138753 */ // Label 2662: @138753
     /* 138753 */ GIM_Reject,
     /* 138754 */ // Label 2649: @138754
     /* 138754 */ GIM_Reject,
     /* 138755 */ // Label 33: @138755
     /* 138755 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2671*/ GIMT_Encode4(139459),
     /* 138766 */ /*GILLT_s16*//*Label 2668*/ GIMT_Encode4(138778),
     /* 138770 */ /*GILLT_s32*//*Label 2669*/ GIMT_Encode4(139005),
     /* 138774 */ /*GILLT_s64*//*Label 2670*/ GIMT_Encode4(139232),
     /* 138778 */ // Label 2668: @138778
     /* 138778 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(139004),
     /* 138783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138793 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(138835), // Rule ID 7380 //
     /* 138798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138808 */     // MIs[0] Rn
     /* 138808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138820 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 138823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138833 */     GIR_RootConstrainSelectedInstOperands,
     /* 138834 */     // GIR_Coverage, 7380,
     /* 138834 */     GIR_EraseRootFromParent_Done,
     /* 138835 */   // Label 2673: @138835
     /* 138835 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(138877), // Rule ID 7381 //
     /* 138840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138850 */     // MIs[0] Rn
     /* 138850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138862 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 138865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138875 */     GIR_RootConstrainSelectedInstOperands,
     /* 138876 */     // GIR_Coverage, 7381,
     /* 138876 */     GIR_EraseRootFromParent_Done,
     /* 138877 */   // Label 2674: @138877
     /* 138877 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(138919), // Rule ID 7382 //
     /* 138882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138892 */     // MIs[0] Rn
     /* 138892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138904 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 138907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138917 */     GIR_RootConstrainSelectedInstOperands,
     /* 138918 */     // GIR_Coverage, 7382,
     /* 138918 */     GIR_EraseRootFromParent_Done,
     /* 138919 */   // Label 2675: @138919
     /* 138919 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(138961), // Rule ID 7383 //
     /* 138924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138934 */     // MIs[0] Rn
     /* 138934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138946 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 138949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138953 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138959 */     GIR_RootConstrainSelectedInstOperands,
     /* 138960 */     // GIR_Coverage, 7383,
     /* 138960 */     GIR_EraseRootFromParent_Done,
     /* 138961 */   // Label 2676: @138961
     /* 138961 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(139003), // Rule ID 7384 //
     /* 138966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138976 */     // MIs[0] Rn
     /* 138976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138988 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 138991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139001 */     GIR_RootConstrainSelectedInstOperands,
     /* 139002 */     // GIR_Coverage, 7384,
     /* 139002 */     GIR_EraseRootFromParent_Done,
     /* 139003 */   // Label 2677: @139003
     /* 139003 */   GIM_Reject,
     /* 139004 */ // Label 2672: @139004
     /* 139004 */ GIM_Reject,
     /* 139005 */ // Label 2669: @139005
     /* 139005 */ GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(139231),
     /* 139010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139013 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139020 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(139062), // Rule ID 7385 //
     /* 139025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139035 */     // MIs[0] Rn
     /* 139035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139047 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 139050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139060 */     GIR_RootConstrainSelectedInstOperands,
     /* 139061 */     // GIR_Coverage, 7385,
     /* 139061 */     GIR_EraseRootFromParent_Done,
     /* 139062 */   // Label 2679: @139062
     /* 139062 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(139104), // Rule ID 7386 //
     /* 139067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139077 */     // MIs[0] Rn
     /* 139077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139089 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 139092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139102 */     GIR_RootConstrainSelectedInstOperands,
     /* 139103 */     // GIR_Coverage, 7386,
     /* 139103 */     GIR_EraseRootFromParent_Done,
     /* 139104 */   // Label 2680: @139104
     /* 139104 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(139146), // Rule ID 7387 //
     /* 139109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139119 */     // MIs[0] Rn
     /* 139119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139131 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 139134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139144 */     GIR_RootConstrainSelectedInstOperands,
     /* 139145 */     // GIR_Coverage, 7387,
     /* 139145 */     GIR_EraseRootFromParent_Done,
     /* 139146 */   // Label 2681: @139146
     /* 139146 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(139188), // Rule ID 7388 //
     /* 139151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139161 */     // MIs[0] Rn
     /* 139161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139173 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 139176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139186 */     GIR_RootConstrainSelectedInstOperands,
     /* 139187 */     // GIR_Coverage, 7388,
     /* 139187 */     GIR_EraseRootFromParent_Done,
     /* 139188 */   // Label 2682: @139188
     /* 139188 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(139230), // Rule ID 7389 //
     /* 139193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139203 */     // MIs[0] Rn
     /* 139203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139215 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 139218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139228 */     GIR_RootConstrainSelectedInstOperands,
     /* 139229 */     // GIR_Coverage, 7389,
     /* 139229 */     GIR_EraseRootFromParent_Done,
     /* 139230 */   // Label 2683: @139230
     /* 139230 */   GIM_Reject,
     /* 139231 */ // Label 2678: @139231
     /* 139231 */ GIM_Reject,
     /* 139232 */ // Label 2670: @139232
     /* 139232 */ GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(139458),
     /* 139237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139240 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139247 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(139289), // Rule ID 7390 //
     /* 139252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139262 */     // MIs[0] Rn
     /* 139262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139274 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 139277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139287 */     GIR_RootConstrainSelectedInstOperands,
     /* 139288 */     // GIR_Coverage, 7390,
     /* 139288 */     GIR_EraseRootFromParent_Done,
     /* 139289 */   // Label 2685: @139289
     /* 139289 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(139331), // Rule ID 7391 //
     /* 139294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139297 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139304 */     // MIs[0] Rn
     /* 139304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139316 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 139319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139329 */     GIR_RootConstrainSelectedInstOperands,
     /* 139330 */     // GIR_Coverage, 7391,
     /* 139330 */     GIR_EraseRootFromParent_Done,
     /* 139331 */   // Label 2686: @139331
     /* 139331 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(139373), // Rule ID 7392 //
     /* 139336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139346 */     // MIs[0] Rn
     /* 139346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139358 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 139361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139371 */     GIR_RootConstrainSelectedInstOperands,
     /* 139372 */     // GIR_Coverage, 7392,
     /* 139372 */     GIR_EraseRootFromParent_Done,
     /* 139373 */   // Label 2687: @139373
     /* 139373 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(139415), // Rule ID 7393 //
     /* 139378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139388 */     // MIs[0] Rn
     /* 139388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139400 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 139403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139413 */     GIR_RootConstrainSelectedInstOperands,
     /* 139414 */     // GIR_Coverage, 7393,
     /* 139414 */     GIR_EraseRootFromParent_Done,
     /* 139415 */   // Label 2688: @139415
     /* 139415 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(139457), // Rule ID 7394 //
     /* 139420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139430 */     // MIs[0] Rn
     /* 139430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139442 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 139445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139455 */     GIR_RootConstrainSelectedInstOperands,
     /* 139456 */     // GIR_Coverage, 7394,
     /* 139456 */     GIR_EraseRootFromParent_Done,
     /* 139457 */   // Label 2689: @139457
     /* 139457 */   GIM_Reject,
     /* 139458 */ // Label 2684: @139458
     /* 139458 */ GIM_Reject,
     /* 139459 */ // Label 2671: @139459
     /* 139459 */ GIM_Reject,
     /* 139460 */ // Label 34: @139460
     /* 139460 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(139487), // Rule ID 7012 //
     /* 139465 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139468 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 139472 */   // MIs[0] Operand 1
     /* 139472 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 139475 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 139475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 139478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 139481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139485 */   GIR_RootConstrainSelectedInstOperands,
     /* 139486 */   // GIR_Coverage, 7012,
     /* 139486 */   GIR_EraseRootFromParent_Done,
     /* 139487 */ // Label 2690: @139487
     /* 139487 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(139510), // Rule ID 7013 //
     /* 139492 */   // MIs[0] Operand 0
     /* 139492 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 139495 */   // MIs[0] Operand 1
     /* 139495 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 139498 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 139498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 139501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 139504 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139508 */   GIR_RootConstrainSelectedInstOperands,
     /* 139509 */   // GIR_Coverage, 7013,
     /* 139509 */   GIR_EraseRootFromParent_Done,
     /* 139510 */ // Label 2691: @139510
     /* 139510 */ GIM_Reject,
     /* 139511 */ // Label 35: @139511
     /* 139511 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(152038),
     /* 139516 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 139519 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(139610), // Rule ID 6491 //
     /* 139524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 139527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 139532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 139535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 139550 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 139553 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 139558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139562 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 139566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139578 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 139578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 139581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 139585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 139594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 139598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 139603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139608 */     GIR_RootConstrainSelectedInstOperands,
     /* 139609 */     // GIR_Coverage, 6491,
     /* 139609 */     GIR_EraseRootFromParent_Done,
     /* 139610 */   // Label 2693: @139610
     /* 139610 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(139701), // Rule ID 6492 //
     /* 139615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 139618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 139623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 139626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 139641 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 139644 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 139649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139653 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 139657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139669 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 139669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 139672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 139676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 139685 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 139689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 139694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139699 */     GIR_RootConstrainSelectedInstOperands,
     /* 139700 */     // GIR_Coverage, 6492,
     /* 139700 */     GIR_EraseRootFromParent_Done,
     /* 139701 */   // Label 2694: @139701
     /* 139701 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(139762), // Rule ID 4898 //
     /* 139706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 139711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 139729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 139733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139738 */     // MIs[1] Operand 2
     /* 139738 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 139749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139751 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 139751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 139754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 139760 */     GIR_RootConstrainSelectedInstOperands,
     /* 139761 */     // GIR_Coverage, 4898,
     /* 139761 */     GIR_EraseRootFromParent_Done,
     /* 139762 */   // Label 2695: @139762
     /* 139762 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(139802), // Rule ID 2651 //
     /* 139767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 139775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139782 */     // MIs[0] pattern
     /* 139782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139790 */     // (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 139793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139795 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139800 */     GIR_RootConstrainSelectedInstOperands,
     /* 139801 */     // GIR_Coverage, 2651,
     /* 139801 */     GIR_EraseRootFromParent_Done,
     /* 139802 */   // Label 2696: @139802
     /* 139802 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(139842), // Rule ID 9901 //
     /* 139807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 139815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139822 */     // MIs[0] pattern
     /* 139822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139830 */     // (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 139833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139835 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139840 */     GIR_RootConstrainSelectedInstOperands,
     /* 139841 */     // GIR_Coverage, 9901,
     /* 139841 */     GIR_EraseRootFromParent_Done,
     /* 139842 */   // Label 2697: @139842
     /* 139842 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(139882), // Rule ID 9904 //
     /* 139847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 139855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139862 */     // MIs[0] pattern
     /* 139862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139865 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139870 */     // (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 139873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139875 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139880 */     GIR_RootConstrainSelectedInstOperands,
     /* 139881 */     // GIR_Coverage, 9904,
     /* 139881 */     GIR_EraseRootFromParent_Done,
     /* 139882 */   // Label 2698: @139882
     /* 139882 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(139922), // Rule ID 9907 //
     /* 139887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 139895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139902 */     // MIs[0] pattern
     /* 139902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139910 */     // (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 139913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139915 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139920 */     GIR_RootConstrainSelectedInstOperands,
     /* 139921 */     // GIR_Coverage, 9907,
     /* 139921 */     GIR_EraseRootFromParent_Done,
     /* 139922 */   // Label 2699: @139922
     /* 139922 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(139961), // Rule ID 66 //
     /* 139927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 139930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 139935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139949 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 139949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 139952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 139959 */     GIR_RootConstrainSelectedInstOperands,
     /* 139960 */     // GIR_Coverage, 66,
     /* 139960 */     GIR_EraseRootFromParent_Done,
     /* 139961 */   // Label 2700: @139961
     /* 139961 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(139997), // Rule ID 346 //
     /* 139966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139988 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 139988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 139991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139995 */     GIR_RootConstrainSelectedInstOperands,
     /* 139996 */     // GIR_Coverage, 346,
     /* 139996 */     GIR_EraseRootFromParent_Done,
     /* 139997 */   // Label 2701: @139997
     /* 139997 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(140033), // Rule ID 347 //
     /* 140002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140024 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 140027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140031 */     GIR_RootConstrainSelectedInstOperands,
     /* 140032 */     // GIR_Coverage, 347,
     /* 140032 */     GIR_EraseRootFromParent_Done,
     /* 140033 */   // Label 2702: @140033
     /* 140033 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(140069), // Rule ID 348 //
     /* 140038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140060 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 140063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140067 */     GIR_RootConstrainSelectedInstOperands,
     /* 140068 */     // GIR_Coverage, 348,
     /* 140068 */     GIR_EraseRootFromParent_Done,
     /* 140069 */   // Label 2703: @140069
     /* 140069 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(140105), // Rule ID 349 //
     /* 140074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140096 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 140099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140103 */     GIR_RootConstrainSelectedInstOperands,
     /* 140104 */     // GIR_Coverage, 349,
     /* 140104 */     GIR_EraseRootFromParent_Done,
     /* 140105 */   // Label 2704: @140105
     /* 140105 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(140141), // Rule ID 350 //
     /* 140110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140132 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 140135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140139 */     GIR_RootConstrainSelectedInstOperands,
     /* 140140 */     // GIR_Coverage, 350,
     /* 140140 */     GIR_EraseRootFromParent_Done,
     /* 140141 */   // Label 2705: @140141
     /* 140141 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(140177), // Rule ID 351 //
     /* 140146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140168 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 140171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140175 */     GIR_RootConstrainSelectedInstOperands,
     /* 140176 */     // GIR_Coverage, 351,
     /* 140176 */     GIR_EraseRootFromParent_Done,
     /* 140177 */   // Label 2706: @140177
     /* 140177 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(140213), // Rule ID 352 //
     /* 140182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140204 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 140207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140211 */     GIR_RootConstrainSelectedInstOperands,
     /* 140212 */     // GIR_Coverage, 352,
     /* 140212 */     GIR_EraseRootFromParent_Done,
     /* 140213 */   // Label 2707: @140213
     /* 140213 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(140249), // Rule ID 353 //
     /* 140218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140240 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 140243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140247 */     GIR_RootConstrainSelectedInstOperands,
     /* 140248 */     // GIR_Coverage, 353,
     /* 140248 */     GIR_EraseRootFromParent_Done,
     /* 140249 */   // Label 2708: @140249
     /* 140249 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(140285), // Rule ID 354 //
     /* 140254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140276 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 140279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140283 */     GIR_RootConstrainSelectedInstOperands,
     /* 140284 */     // GIR_Coverage, 354,
     /* 140284 */     GIR_EraseRootFromParent_Done,
     /* 140285 */   // Label 2709: @140285
     /* 140285 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(140321), // Rule ID 355 //
     /* 140290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140312 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 140315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140319 */     GIR_RootConstrainSelectedInstOperands,
     /* 140320 */     // GIR_Coverage, 355,
     /* 140320 */     GIR_EraseRootFromParent_Done,
     /* 140321 */   // Label 2710: @140321
     /* 140321 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(140357), // Rule ID 356 //
     /* 140326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140348 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 140351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140355 */     GIR_RootConstrainSelectedInstOperands,
     /* 140356 */     // GIR_Coverage, 356,
     /* 140356 */     GIR_EraseRootFromParent_Done,
     /* 140357 */   // Label 2711: @140357
     /* 140357 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(140393), // Rule ID 357 //
     /* 140362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140384 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 140387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140391 */     GIR_RootConstrainSelectedInstOperands,
     /* 140392 */     // GIR_Coverage, 357,
     /* 140392 */     GIR_EraseRootFromParent_Done,
     /* 140393 */   // Label 2712: @140393
     /* 140393 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(140429), // Rule ID 358 //
     /* 140398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140420 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 140423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140427 */     GIR_RootConstrainSelectedInstOperands,
     /* 140428 */     // GIR_Coverage, 358,
     /* 140428 */     GIR_EraseRootFromParent_Done,
     /* 140429 */   // Label 2713: @140429
     /* 140429 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(140465), // Rule ID 359 //
     /* 140434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140456 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 140459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140463 */     GIR_RootConstrainSelectedInstOperands,
     /* 140464 */     // GIR_Coverage, 359,
     /* 140464 */     GIR_EraseRootFromParent_Done,
     /* 140465 */   // Label 2714: @140465
     /* 140465 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(140501), // Rule ID 360 //
     /* 140470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140492 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 140495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140499 */     GIR_RootConstrainSelectedInstOperands,
     /* 140500 */     // GIR_Coverage, 360,
     /* 140500 */     GIR_EraseRootFromParent_Done,
     /* 140501 */   // Label 2715: @140501
     /* 140501 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(140537), // Rule ID 361 //
     /* 140506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140528 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 140531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140535 */     GIR_RootConstrainSelectedInstOperands,
     /* 140536 */     // GIR_Coverage, 361,
     /* 140536 */     GIR_EraseRootFromParent_Done,
     /* 140537 */   // Label 2716: @140537
     /* 140537 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(140573), // Rule ID 362 //
     /* 140542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140564 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 140567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140571 */     GIR_RootConstrainSelectedInstOperands,
     /* 140572 */     // GIR_Coverage, 362,
     /* 140572 */     GIR_EraseRootFromParent_Done,
     /* 140573 */   // Label 2717: @140573
     /* 140573 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(140609), // Rule ID 363 //
     /* 140578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140600 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 140603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140607 */     GIR_RootConstrainSelectedInstOperands,
     /* 140608 */     // GIR_Coverage, 363,
     /* 140608 */     GIR_EraseRootFromParent_Done,
     /* 140609 */   // Label 2718: @140609
     /* 140609 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(140645), // Rule ID 364 //
     /* 140614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140636 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 140639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140643 */     GIR_RootConstrainSelectedInstOperands,
     /* 140644 */     // GIR_Coverage, 364,
     /* 140644 */     GIR_EraseRootFromParent_Done,
     /* 140645 */   // Label 2719: @140645
     /* 140645 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(140681), // Rule ID 365 //
     /* 140650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140672 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 140675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140679 */     GIR_RootConstrainSelectedInstOperands,
     /* 140680 */     // GIR_Coverage, 365,
     /* 140680 */     GIR_EraseRootFromParent_Done,
     /* 140681 */   // Label 2720: @140681
     /* 140681 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(140717), // Rule ID 366 //
     /* 140686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140708 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 140711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140715 */     GIR_RootConstrainSelectedInstOperands,
     /* 140716 */     // GIR_Coverage, 366,
     /* 140716 */     GIR_EraseRootFromParent_Done,
     /* 140717 */   // Label 2721: @140717
     /* 140717 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(140753), // Rule ID 367 //
     /* 140722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140744 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 140747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140751 */     GIR_RootConstrainSelectedInstOperands,
     /* 140752 */     // GIR_Coverage, 367,
     /* 140752 */     GIR_EraseRootFromParent_Done,
     /* 140753 */   // Label 2722: @140753
     /* 140753 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(140789), // Rule ID 368 //
     /* 140758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140780 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 140783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140787 */     GIR_RootConstrainSelectedInstOperands,
     /* 140788 */     // GIR_Coverage, 368,
     /* 140788 */     GIR_EraseRootFromParent_Done,
     /* 140789 */   // Label 2723: @140789
     /* 140789 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(140825), // Rule ID 369 //
     /* 140794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140816 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 140819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140823 */     GIR_RootConstrainSelectedInstOperands,
     /* 140824 */     // GIR_Coverage, 369,
     /* 140824 */     GIR_EraseRootFromParent_Done,
     /* 140825 */   // Label 2724: @140825
     /* 140825 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(140861), // Rule ID 370 //
     /* 140830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140852 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 140855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140859 */     GIR_RootConstrainSelectedInstOperands,
     /* 140860 */     // GIR_Coverage, 370,
     /* 140860 */     GIR_EraseRootFromParent_Done,
     /* 140861 */   // Label 2725: @140861
     /* 140861 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(140897), // Rule ID 371 //
     /* 140866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140888 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 140891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140895 */     GIR_RootConstrainSelectedInstOperands,
     /* 140896 */     // GIR_Coverage, 371,
     /* 140896 */     GIR_EraseRootFromParent_Done,
     /* 140897 */   // Label 2726: @140897
     /* 140897 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(140933), // Rule ID 372 //
     /* 140902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140924 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 140927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140931 */     GIR_RootConstrainSelectedInstOperands,
     /* 140932 */     // GIR_Coverage, 372,
     /* 140932 */     GIR_EraseRootFromParent_Done,
     /* 140933 */   // Label 2727: @140933
     /* 140933 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(140969), // Rule ID 373 //
     /* 140938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140960 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 140963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140967 */     GIR_RootConstrainSelectedInstOperands,
     /* 140968 */     // GIR_Coverage, 373,
     /* 140968 */     GIR_EraseRootFromParent_Done,
     /* 140969 */   // Label 2728: @140969
     /* 140969 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(141005), // Rule ID 374 //
     /* 140974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140996 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 140999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141003 */     GIR_RootConstrainSelectedInstOperands,
     /* 141004 */     // GIR_Coverage, 374,
     /* 141004 */     GIR_EraseRootFromParent_Done,
     /* 141005 */   // Label 2729: @141005
     /* 141005 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(141041), // Rule ID 375 //
     /* 141010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141032 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 141035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141039 */     GIR_RootConstrainSelectedInstOperands,
     /* 141040 */     // GIR_Coverage, 375,
     /* 141040 */     GIR_EraseRootFromParent_Done,
     /* 141041 */   // Label 2730: @141041
     /* 141041 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(141077), // Rule ID 376 //
     /* 141046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141068 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 141071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141075 */     GIR_RootConstrainSelectedInstOperands,
     /* 141076 */     // GIR_Coverage, 376,
     /* 141076 */     GIR_EraseRootFromParent_Done,
     /* 141077 */   // Label 2731: @141077
     /* 141077 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(141113), // Rule ID 377 //
     /* 141082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141104 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 141107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141111 */     GIR_RootConstrainSelectedInstOperands,
     /* 141112 */     // GIR_Coverage, 377,
     /* 141112 */     GIR_EraseRootFromParent_Done,
     /* 141113 */   // Label 2732: @141113
     /* 141113 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(141149), // Rule ID 378 //
     /* 141118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141140 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 141143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141147 */     GIR_RootConstrainSelectedInstOperands,
     /* 141148 */     // GIR_Coverage, 378,
     /* 141148 */     GIR_EraseRootFromParent_Done,
     /* 141149 */   // Label 2733: @141149
     /* 141149 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(141185), // Rule ID 379 //
     /* 141154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141176 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 141179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141183 */     GIR_RootConstrainSelectedInstOperands,
     /* 141184 */     // GIR_Coverage, 379,
     /* 141184 */     GIR_EraseRootFromParent_Done,
     /* 141185 */   // Label 2734: @141185
     /* 141185 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(141221), // Rule ID 380 //
     /* 141190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141212 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 141215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141219 */     GIR_RootConstrainSelectedInstOperands,
     /* 141220 */     // GIR_Coverage, 380,
     /* 141220 */     GIR_EraseRootFromParent_Done,
     /* 141221 */   // Label 2735: @141221
     /* 141221 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(141257), // Rule ID 381 //
     /* 141226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141248 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 141251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141255 */     GIR_RootConstrainSelectedInstOperands,
     /* 141256 */     // GIR_Coverage, 381,
     /* 141256 */     GIR_EraseRootFromParent_Done,
     /* 141257 */   // Label 2736: @141257
     /* 141257 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(141293), // Rule ID 382 //
     /* 141262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141284 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 141287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141291 */     GIR_RootConstrainSelectedInstOperands,
     /* 141292 */     // GIR_Coverage, 382,
     /* 141292 */     GIR_EraseRootFromParent_Done,
     /* 141293 */   // Label 2737: @141293
     /* 141293 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(141329), // Rule ID 383 //
     /* 141298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141320 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 141323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141327 */     GIR_RootConstrainSelectedInstOperands,
     /* 141328 */     // GIR_Coverage, 383,
     /* 141328 */     GIR_EraseRootFromParent_Done,
     /* 141329 */   // Label 2738: @141329
     /* 141329 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(141365), // Rule ID 384 //
     /* 141334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141356 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 141359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141363 */     GIR_RootConstrainSelectedInstOperands,
     /* 141364 */     // GIR_Coverage, 384,
     /* 141364 */     GIR_EraseRootFromParent_Done,
     /* 141365 */   // Label 2739: @141365
     /* 141365 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(141401), // Rule ID 385 //
     /* 141370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141392 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 141395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141399 */     GIR_RootConstrainSelectedInstOperands,
     /* 141400 */     // GIR_Coverage, 385,
     /* 141400 */     GIR_EraseRootFromParent_Done,
     /* 141401 */   // Label 2740: @141401
     /* 141401 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(141437), // Rule ID 386 //
     /* 141406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141428 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 141431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141435 */     GIR_RootConstrainSelectedInstOperands,
     /* 141436 */     // GIR_Coverage, 386,
     /* 141436 */     GIR_EraseRootFromParent_Done,
     /* 141437 */   // Label 2741: @141437
     /* 141437 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(141473), // Rule ID 387 //
     /* 141442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141464 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 141467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141471 */     GIR_RootConstrainSelectedInstOperands,
     /* 141472 */     // GIR_Coverage, 387,
     /* 141472 */     GIR_EraseRootFromParent_Done,
     /* 141473 */   // Label 2742: @141473
     /* 141473 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(141509), // Rule ID 388 //
     /* 141478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141500 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 141503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141507 */     GIR_RootConstrainSelectedInstOperands,
     /* 141508 */     // GIR_Coverage, 388,
     /* 141508 */     GIR_EraseRootFromParent_Done,
     /* 141509 */   // Label 2743: @141509
     /* 141509 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(141545), // Rule ID 389 //
     /* 141514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141536 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 141539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141543 */     GIR_RootConstrainSelectedInstOperands,
     /* 141544 */     // GIR_Coverage, 389,
     /* 141544 */     GIR_EraseRootFromParent_Done,
     /* 141545 */   // Label 2744: @141545
     /* 141545 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(141581), // Rule ID 390 //
     /* 141550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141572 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 141575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141579 */     GIR_RootConstrainSelectedInstOperands,
     /* 141580 */     // GIR_Coverage, 390,
     /* 141580 */     GIR_EraseRootFromParent_Done,
     /* 141581 */   // Label 2745: @141581
     /* 141581 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(141617), // Rule ID 391 //
     /* 141586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141608 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 141611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141615 */     GIR_RootConstrainSelectedInstOperands,
     /* 141616 */     // GIR_Coverage, 391,
     /* 141616 */     GIR_EraseRootFromParent_Done,
     /* 141617 */   // Label 2746: @141617
     /* 141617 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(141653), // Rule ID 392 //
     /* 141622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141644 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 141647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141651 */     GIR_RootConstrainSelectedInstOperands,
     /* 141652 */     // GIR_Coverage, 392,
     /* 141652 */     GIR_EraseRootFromParent_Done,
     /* 141653 */   // Label 2747: @141653
     /* 141653 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(141689), // Rule ID 393 //
     /* 141658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141680 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 141683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141687 */     GIR_RootConstrainSelectedInstOperands,
     /* 141688 */     // GIR_Coverage, 393,
     /* 141688 */     GIR_EraseRootFromParent_Done,
     /* 141689 */   // Label 2748: @141689
     /* 141689 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(141725), // Rule ID 575 //
     /* 141694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 141702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141716 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 141719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141723 */     GIR_RootConstrainSelectedInstOperands,
     /* 141724 */     // GIR_Coverage, 575,
     /* 141724 */     GIR_EraseRootFromParent_Done,
     /* 141725 */   // Label 2749: @141725
     /* 141725 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(141761), // Rule ID 576 //
     /* 141730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 141738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141752 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 141755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141759 */     GIR_RootConstrainSelectedInstOperands,
     /* 141760 */     // GIR_Coverage, 576,
     /* 141760 */     GIR_EraseRootFromParent_Done,
     /* 141761 */   // Label 2750: @141761
     /* 141761 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(141797), // Rule ID 577 //
     /* 141766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 141774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141788 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 141791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141795 */     GIR_RootConstrainSelectedInstOperands,
     /* 141796 */     // GIR_Coverage, 577,
     /* 141796 */     GIR_EraseRootFromParent_Done,
     /* 141797 */   // Label 2751: @141797
     /* 141797 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(141833), // Rule ID 578 //
     /* 141802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 141810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141824 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 141827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141831 */     GIR_RootConstrainSelectedInstOperands,
     /* 141832 */     // GIR_Coverage, 578,
     /* 141832 */     GIR_EraseRootFromParent_Done,
     /* 141833 */   // Label 2752: @141833
     /* 141833 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(141869), // Rule ID 579 //
     /* 141838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 141846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141860 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 141863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141867 */     GIR_RootConstrainSelectedInstOperands,
     /* 141868 */     // GIR_Coverage, 579,
     /* 141868 */     GIR_EraseRootFromParent_Done,
     /* 141869 */   // Label 2753: @141869
     /* 141869 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(141905), // Rule ID 580 //
     /* 141874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 141882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141896 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 141899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141903 */     GIR_RootConstrainSelectedInstOperands,
     /* 141904 */     // GIR_Coverage, 580,
     /* 141904 */     GIR_EraseRootFromParent_Done,
     /* 141905 */   // Label 2754: @141905
     /* 141905 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(141941), // Rule ID 581 //
     /* 141910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 141918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141932 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 141935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141939 */     GIR_RootConstrainSelectedInstOperands,
     /* 141940 */     // GIR_Coverage, 581,
     /* 141940 */     GIR_EraseRootFromParent_Done,
     /* 141941 */   // Label 2755: @141941
     /* 141941 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(141977), // Rule ID 582 //
     /* 141946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 141954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141968 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 141971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141975 */     GIR_RootConstrainSelectedInstOperands,
     /* 141976 */     // GIR_Coverage, 582,
     /* 141976 */     GIR_EraseRootFromParent_Done,
     /* 141977 */   // Label 2756: @141977
     /* 141977 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(142013), // Rule ID 710 //
     /* 141982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 141993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 141996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142004 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 142007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142011 */     GIR_RootConstrainSelectedInstOperands,
     /* 142012 */     // GIR_Coverage, 710,
     /* 142012 */     GIR_EraseRootFromParent_Done,
     /* 142013 */   // Label 2757: @142013
     /* 142013 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(142049), // Rule ID 711 //
     /* 142018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 142029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142040 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 142043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142047 */     GIR_RootConstrainSelectedInstOperands,
     /* 142048 */     // GIR_Coverage, 711,
     /* 142048 */     GIR_EraseRootFromParent_Done,
     /* 142049 */   // Label 2758: @142049
     /* 142049 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(142085), // Rule ID 712 //
     /* 142054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142076 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 142079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142083 */     GIR_RootConstrainSelectedInstOperands,
     /* 142084 */     // GIR_Coverage, 712,
     /* 142084 */     GIR_EraseRootFromParent_Done,
     /* 142085 */   // Label 2759: @142085
     /* 142085 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(142121), // Rule ID 713 //
     /* 142090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 142115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142119 */     GIR_RootConstrainSelectedInstOperands,
     /* 142120 */     // GIR_Coverage, 713,
     /* 142120 */     GIR_EraseRootFromParent_Done,
     /* 142121 */   // Label 2760: @142121
     /* 142121 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(142157), // Rule ID 714 //
     /* 142126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142148 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 142148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 142151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142155 */     GIR_RootConstrainSelectedInstOperands,
     /* 142156 */     // GIR_Coverage, 714,
     /* 142156 */     GIR_EraseRootFromParent_Done,
     /* 142157 */   // Label 2761: @142157
     /* 142157 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(142193), // Rule ID 715 //
     /* 142162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142184 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 142184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 142187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142191 */     GIR_RootConstrainSelectedInstOperands,
     /* 142192 */     // GIR_Coverage, 715,
     /* 142192 */     GIR_EraseRootFromParent_Done,
     /* 142193 */   // Label 2762: @142193
     /* 142193 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(142229), // Rule ID 796 //
     /* 142198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142220 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 142223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142227 */     GIR_RootConstrainSelectedInstOperands,
     /* 142228 */     // GIR_Coverage, 796,
     /* 142228 */     GIR_EraseRootFromParent_Done,
     /* 142229 */   // Label 2763: @142229
     /* 142229 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(142265), // Rule ID 797 //
     /* 142234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142256 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 142259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142263 */     GIR_RootConstrainSelectedInstOperands,
     /* 142264 */     // GIR_Coverage, 797,
     /* 142264 */     GIR_EraseRootFromParent_Done,
     /* 142265 */   // Label 2764: @142265
     /* 142265 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(142301), // Rule ID 798 //
     /* 142270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142292 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 142295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142299 */     GIR_RootConstrainSelectedInstOperands,
     /* 142300 */     // GIR_Coverage, 798,
     /* 142300 */     GIR_EraseRootFromParent_Done,
     /* 142301 */   // Label 2765: @142301
     /* 142301 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(142337), // Rule ID 799 //
     /* 142306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142328 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 142331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142335 */     GIR_RootConstrainSelectedInstOperands,
     /* 142336 */     // GIR_Coverage, 799,
     /* 142336 */     GIR_EraseRootFromParent_Done,
     /* 142337 */   // Label 2766: @142337
     /* 142337 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(142373), // Rule ID 800 //
     /* 142342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142364 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 142367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142371 */     GIR_RootConstrainSelectedInstOperands,
     /* 142372 */     // GIR_Coverage, 800,
     /* 142372 */     GIR_EraseRootFromParent_Done,
     /* 142373 */   // Label 2767: @142373
     /* 142373 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(142409), // Rule ID 801 //
     /* 142378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142400 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 142403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142407 */     GIR_RootConstrainSelectedInstOperands,
     /* 142408 */     // GIR_Coverage, 801,
     /* 142408 */     GIR_EraseRootFromParent_Done,
     /* 142409 */   // Label 2768: @142409
     /* 142409 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(142445), // Rule ID 802 //
     /* 142414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142436 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 142439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142443 */     GIR_RootConstrainSelectedInstOperands,
     /* 142444 */     // GIR_Coverage, 802,
     /* 142444 */     GIR_EraseRootFromParent_Done,
     /* 142445 */   // Label 2769: @142445
     /* 142445 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(142481), // Rule ID 803 //
     /* 142450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142472 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 142475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142479 */     GIR_RootConstrainSelectedInstOperands,
     /* 142480 */     // GIR_Coverage, 803,
     /* 142480 */     GIR_EraseRootFromParent_Done,
     /* 142481 */   // Label 2770: @142481
     /* 142481 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(142517), // Rule ID 804 //
     /* 142486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142508 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 142511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142515 */     GIR_RootConstrainSelectedInstOperands,
     /* 142516 */     // GIR_Coverage, 804,
     /* 142516 */     GIR_EraseRootFromParent_Done,
     /* 142517 */   // Label 2771: @142517
     /* 142517 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(142553), // Rule ID 805 //
     /* 142522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142544 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 142547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142551 */     GIR_RootConstrainSelectedInstOperands,
     /* 142552 */     // GIR_Coverage, 805,
     /* 142552 */     GIR_EraseRootFromParent_Done,
     /* 142553 */   // Label 2772: @142553
     /* 142553 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(142589), // Rule ID 806 //
     /* 142558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142580 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 142583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142587 */     GIR_RootConstrainSelectedInstOperands,
     /* 142588 */     // GIR_Coverage, 806,
     /* 142588 */     GIR_EraseRootFromParent_Done,
     /* 142589 */   // Label 2773: @142589
     /* 142589 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(142625), // Rule ID 807 //
     /* 142594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142616 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 142619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142623 */     GIR_RootConstrainSelectedInstOperands,
     /* 142624 */     // GIR_Coverage, 807,
     /* 142624 */     GIR_EraseRootFromParent_Done,
     /* 142625 */   // Label 2774: @142625
     /* 142625 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(142661), // Rule ID 808 //
     /* 142630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142652 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 142655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142659 */     GIR_RootConstrainSelectedInstOperands,
     /* 142660 */     // GIR_Coverage, 808,
     /* 142660 */     GIR_EraseRootFromParent_Done,
     /* 142661 */   // Label 2775: @142661
     /* 142661 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(142697), // Rule ID 809 //
     /* 142666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142688 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 142691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142695 */     GIR_RootConstrainSelectedInstOperands,
     /* 142696 */     // GIR_Coverage, 809,
     /* 142696 */     GIR_EraseRootFromParent_Done,
     /* 142697 */   // Label 2776: @142697
     /* 142697 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(142733), // Rule ID 810 //
     /* 142702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142724 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 142727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142731 */     GIR_RootConstrainSelectedInstOperands,
     /* 142732 */     // GIR_Coverage, 810,
     /* 142732 */     GIR_EraseRootFromParent_Done,
     /* 142733 */   // Label 2777: @142733
     /* 142733 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(142769), // Rule ID 811 //
     /* 142738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142760 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 142763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142767 */     GIR_RootConstrainSelectedInstOperands,
     /* 142768 */     // GIR_Coverage, 811,
     /* 142768 */     GIR_EraseRootFromParent_Done,
     /* 142769 */   // Label 2778: @142769
     /* 142769 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(142805), // Rule ID 812 //
     /* 142774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142796 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 142799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142803 */     GIR_RootConstrainSelectedInstOperands,
     /* 142804 */     // GIR_Coverage, 812,
     /* 142804 */     GIR_EraseRootFromParent_Done,
     /* 142805 */   // Label 2779: @142805
     /* 142805 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(142841), // Rule ID 813 //
     /* 142810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142832 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 142835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142839 */     GIR_RootConstrainSelectedInstOperands,
     /* 142840 */     // GIR_Coverage, 813,
     /* 142840 */     GIR_EraseRootFromParent_Done,
     /* 142841 */   // Label 2780: @142841
     /* 142841 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(142877), // Rule ID 814 //
     /* 142846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142868 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 142871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142875 */     GIR_RootConstrainSelectedInstOperands,
     /* 142876 */     // GIR_Coverage, 814,
     /* 142876 */     GIR_EraseRootFromParent_Done,
     /* 142877 */   // Label 2781: @142877
     /* 142877 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(142913), // Rule ID 815 //
     /* 142882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142904 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 142907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142911 */     GIR_RootConstrainSelectedInstOperands,
     /* 142912 */     // GIR_Coverage, 815,
     /* 142912 */     GIR_EraseRootFromParent_Done,
     /* 142913 */   // Label 2782: @142913
     /* 142913 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(142949), // Rule ID 816 //
     /* 142918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142940 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 142943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142947 */     GIR_RootConstrainSelectedInstOperands,
     /* 142948 */     // GIR_Coverage, 816,
     /* 142948 */     GIR_EraseRootFromParent_Done,
     /* 142949 */   // Label 2783: @142949
     /* 142949 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(142985), // Rule ID 817 //
     /* 142954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142976 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 142979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142983 */     GIR_RootConstrainSelectedInstOperands,
     /* 142984 */     // GIR_Coverage, 817,
     /* 142984 */     GIR_EraseRootFromParent_Done,
     /* 142985 */   // Label 2784: @142985
     /* 142985 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(143021), // Rule ID 818 //
     /* 142990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143012 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 143015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143019 */     GIR_RootConstrainSelectedInstOperands,
     /* 143020 */     // GIR_Coverage, 818,
     /* 143020 */     GIR_EraseRootFromParent_Done,
     /* 143021 */   // Label 2785: @143021
     /* 143021 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(143057), // Rule ID 819 //
     /* 143026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143048 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 143051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143055 */     GIR_RootConstrainSelectedInstOperands,
     /* 143056 */     // GIR_Coverage, 819,
     /* 143056 */     GIR_EraseRootFromParent_Done,
     /* 143057 */   // Label 2786: @143057
     /* 143057 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(143093), // Rule ID 820 //
     /* 143062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143084 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 143087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143091 */     GIR_RootConstrainSelectedInstOperands,
     /* 143092 */     // GIR_Coverage, 820,
     /* 143092 */     GIR_EraseRootFromParent_Done,
     /* 143093 */   // Label 2787: @143093
     /* 143093 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(143129), // Rule ID 821 //
     /* 143098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143120 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 143123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143127 */     GIR_RootConstrainSelectedInstOperands,
     /* 143128 */     // GIR_Coverage, 821,
     /* 143128 */     GIR_EraseRootFromParent_Done,
     /* 143129 */   // Label 2788: @143129
     /* 143129 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(143165), // Rule ID 822 //
     /* 143134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143156 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 143159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143163 */     GIR_RootConstrainSelectedInstOperands,
     /* 143164 */     // GIR_Coverage, 822,
     /* 143164 */     GIR_EraseRootFromParent_Done,
     /* 143165 */   // Label 2789: @143165
     /* 143165 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(143201), // Rule ID 823 //
     /* 143170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143192 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 143195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143199 */     GIR_RootConstrainSelectedInstOperands,
     /* 143200 */     // GIR_Coverage, 823,
     /* 143200 */     GIR_EraseRootFromParent_Done,
     /* 143201 */   // Label 2790: @143201
     /* 143201 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(143237), // Rule ID 824 //
     /* 143206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143228 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 143231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143235 */     GIR_RootConstrainSelectedInstOperands,
     /* 143236 */     // GIR_Coverage, 824,
     /* 143236 */     GIR_EraseRootFromParent_Done,
     /* 143237 */   // Label 2791: @143237
     /* 143237 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(143273), // Rule ID 825 //
     /* 143242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143264 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 143267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143271 */     GIR_RootConstrainSelectedInstOperands,
     /* 143272 */     // GIR_Coverage, 825,
     /* 143272 */     GIR_EraseRootFromParent_Done,
     /* 143273 */   // Label 2792: @143273
     /* 143273 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(143309), // Rule ID 826 //
     /* 143278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143300 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 143303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143307 */     GIR_RootConstrainSelectedInstOperands,
     /* 143308 */     // GIR_Coverage, 826,
     /* 143308 */     GIR_EraseRootFromParent_Done,
     /* 143309 */   // Label 2793: @143309
     /* 143309 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(143345), // Rule ID 827 //
     /* 143314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143336 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 143339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143343 */     GIR_RootConstrainSelectedInstOperands,
     /* 143344 */     // GIR_Coverage, 827,
     /* 143344 */     GIR_EraseRootFromParent_Done,
     /* 143345 */   // Label 2794: @143345
     /* 143345 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(143381), // Rule ID 828 //
     /* 143350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143372 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 143375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143379 */     GIR_RootConstrainSelectedInstOperands,
     /* 143380 */     // GIR_Coverage, 828,
     /* 143380 */     GIR_EraseRootFromParent_Done,
     /* 143381 */   // Label 2795: @143381
     /* 143381 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(143417), // Rule ID 829 //
     /* 143386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143408 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 143411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143415 */     GIR_RootConstrainSelectedInstOperands,
     /* 143416 */     // GIR_Coverage, 829,
     /* 143416 */     GIR_EraseRootFromParent_Done,
     /* 143417 */   // Label 2796: @143417
     /* 143417 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(143453), // Rule ID 830 //
     /* 143422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143444 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 143447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143451 */     GIR_RootConstrainSelectedInstOperands,
     /* 143452 */     // GIR_Coverage, 830,
     /* 143452 */     GIR_EraseRootFromParent_Done,
     /* 143453 */   // Label 2797: @143453
     /* 143453 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(143489), // Rule ID 831 //
     /* 143458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143480 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 143483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143487 */     GIR_RootConstrainSelectedInstOperands,
     /* 143488 */     // GIR_Coverage, 831,
     /* 143488 */     GIR_EraseRootFromParent_Done,
     /* 143489 */   // Label 2798: @143489
     /* 143489 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(143525), // Rule ID 832 //
     /* 143494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143516 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 143519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143523 */     GIR_RootConstrainSelectedInstOperands,
     /* 143524 */     // GIR_Coverage, 832,
     /* 143524 */     GIR_EraseRootFromParent_Done,
     /* 143525 */   // Label 2799: @143525
     /* 143525 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(143561), // Rule ID 833 //
     /* 143530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 143555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143559 */     GIR_RootConstrainSelectedInstOperands,
     /* 143560 */     // GIR_Coverage, 833,
     /* 143560 */     GIR_EraseRootFromParent_Done,
     /* 143561 */   // Label 2800: @143561
     /* 143561 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(143597), // Rule ID 834 //
     /* 143566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 143591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143595 */     GIR_RootConstrainSelectedInstOperands,
     /* 143596 */     // GIR_Coverage, 834,
     /* 143596 */     GIR_EraseRootFromParent_Done,
     /* 143597 */   // Label 2801: @143597
     /* 143597 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(143633), // Rule ID 835 //
     /* 143602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143624 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 143627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143631 */     GIR_RootConstrainSelectedInstOperands,
     /* 143632 */     // GIR_Coverage, 835,
     /* 143632 */     GIR_EraseRootFromParent_Done,
     /* 143633 */   // Label 2802: @143633
     /* 143633 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(143669), // Rule ID 836 //
     /* 143638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 143646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143660 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 143660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 143663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143667 */     GIR_RootConstrainSelectedInstOperands,
     /* 143668 */     // GIR_Coverage, 836,
     /* 143668 */     GIR_EraseRootFromParent_Done,
     /* 143669 */   // Label 2803: @143669
     /* 143669 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(143705), // Rule ID 863 //
     /* 143674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143696 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 143696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 143699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143703 */     GIR_RootConstrainSelectedInstOperands,
     /* 143704 */     // GIR_Coverage, 863,
     /* 143704 */     GIR_EraseRootFromParent_Done,
     /* 143705 */   // Label 2804: @143705
     /* 143705 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(143741), // Rule ID 864 //
     /* 143710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143732 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 143732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 143735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143739 */     GIR_RootConstrainSelectedInstOperands,
     /* 143740 */     // GIR_Coverage, 864,
     /* 143740 */     GIR_EraseRootFromParent_Done,
     /* 143741 */   // Label 2805: @143741
     /* 143741 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(143777), // Rule ID 865 //
     /* 143746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143768 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 143771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143775 */     GIR_RootConstrainSelectedInstOperands,
     /* 143776 */     // GIR_Coverage, 865,
     /* 143776 */     GIR_EraseRootFromParent_Done,
     /* 143777 */   // Label 2806: @143777
     /* 143777 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(143813), // Rule ID 866 //
     /* 143782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143804 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 143807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143811 */     GIR_RootConstrainSelectedInstOperands,
     /* 143812 */     // GIR_Coverage, 866,
     /* 143812 */     GIR_EraseRootFromParent_Done,
     /* 143813 */   // Label 2807: @143813
     /* 143813 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(143849), // Rule ID 867 //
     /* 143818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143840 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 143843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143847 */     GIR_RootConstrainSelectedInstOperands,
     /* 143848 */     // GIR_Coverage, 867,
     /* 143848 */     GIR_EraseRootFromParent_Done,
     /* 143849 */   // Label 2808: @143849
     /* 143849 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(143885), // Rule ID 938 //
     /* 143854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143876 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 143879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143883 */     GIR_RootConstrainSelectedInstOperands,
     /* 143884 */     // GIR_Coverage, 938,
     /* 143884 */     GIR_EraseRootFromParent_Done,
     /* 143885 */   // Label 2809: @143885
     /* 143885 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(143921), // Rule ID 939 //
     /* 143890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143912 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 143915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143919 */     GIR_RootConstrainSelectedInstOperands,
     /* 143920 */     // GIR_Coverage, 939,
     /* 143920 */     GIR_EraseRootFromParent_Done,
     /* 143921 */   // Label 2810: @143921
     /* 143921 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(143957), // Rule ID 940 //
     /* 143926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143948 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 143951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143955 */     GIR_RootConstrainSelectedInstOperands,
     /* 143956 */     // GIR_Coverage, 940,
     /* 143956 */     GIR_EraseRootFromParent_Done,
     /* 143957 */   // Label 2811: @143957
     /* 143957 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(143993), // Rule ID 941 //
     /* 143962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143984 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 143987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143991 */     GIR_RootConstrainSelectedInstOperands,
     /* 143992 */     // GIR_Coverage, 941,
     /* 143992 */     GIR_EraseRootFromParent_Done,
     /* 143993 */   // Label 2812: @143993
     /* 143993 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(144029), // Rule ID 942 //
     /* 143998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144020 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 144023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144027 */     GIR_RootConstrainSelectedInstOperands,
     /* 144028 */     // GIR_Coverage, 942,
     /* 144028 */     GIR_EraseRootFromParent_Done,
     /* 144029 */   // Label 2813: @144029
     /* 144029 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(144065), // Rule ID 943 //
     /* 144034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144056 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 144059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144063 */     GIR_RootConstrainSelectedInstOperands,
     /* 144064 */     // GIR_Coverage, 943,
     /* 144064 */     GIR_EraseRootFromParent_Done,
     /* 144065 */   // Label 2814: @144065
     /* 144065 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(144101), // Rule ID 944 //
     /* 144070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144092 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 144095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144099 */     GIR_RootConstrainSelectedInstOperands,
     /* 144100 */     // GIR_Coverage, 944,
     /* 144100 */     GIR_EraseRootFromParent_Done,
     /* 144101 */   // Label 2815: @144101
     /* 144101 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(144137), // Rule ID 945 //
     /* 144106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144128 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 144131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144135 */     GIR_RootConstrainSelectedInstOperands,
     /* 144136 */     // GIR_Coverage, 945,
     /* 144136 */     GIR_EraseRootFromParent_Done,
     /* 144137 */   // Label 2816: @144137
     /* 144137 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(144173), // Rule ID 946 //
     /* 144142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144164 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 144167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144171 */     GIR_RootConstrainSelectedInstOperands,
     /* 144172 */     // GIR_Coverage, 946,
     /* 144172 */     GIR_EraseRootFromParent_Done,
     /* 144173 */   // Label 2817: @144173
     /* 144173 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(144209), // Rule ID 947 //
     /* 144178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144200 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 144203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144207 */     GIR_RootConstrainSelectedInstOperands,
     /* 144208 */     // GIR_Coverage, 947,
     /* 144208 */     GIR_EraseRootFromParent_Done,
     /* 144209 */   // Label 2818: @144209
     /* 144209 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(144245), // Rule ID 948 //
     /* 144214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144236 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 144239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144243 */     GIR_RootConstrainSelectedInstOperands,
     /* 144244 */     // GIR_Coverage, 948,
     /* 144244 */     GIR_EraseRootFromParent_Done,
     /* 144245 */   // Label 2819: @144245
     /* 144245 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(144281), // Rule ID 949 //
     /* 144250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144272 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 144275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144279 */     GIR_RootConstrainSelectedInstOperands,
     /* 144280 */     // GIR_Coverage, 949,
     /* 144280 */     GIR_EraseRootFromParent_Done,
     /* 144281 */   // Label 2820: @144281
     /* 144281 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(144317), // Rule ID 950 //
     /* 144286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144308 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 144308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 144311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144315 */     GIR_RootConstrainSelectedInstOperands,
     /* 144316 */     // GIR_Coverage, 950,
     /* 144316 */     GIR_EraseRootFromParent_Done,
     /* 144317 */   // Label 2821: @144317
     /* 144317 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(144353), // Rule ID 951 //
     /* 144322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144344 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 144344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 144347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144351 */     GIR_RootConstrainSelectedInstOperands,
     /* 144352 */     // GIR_Coverage, 951,
     /* 144352 */     GIR_EraseRootFromParent_Done,
     /* 144353 */   // Label 2822: @144353
     /* 144353 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(144389), // Rule ID 952 //
     /* 144358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144380 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 144383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144387 */     GIR_RootConstrainSelectedInstOperands,
     /* 144388 */     // GIR_Coverage, 952,
     /* 144388 */     GIR_EraseRootFromParent_Done,
     /* 144389 */   // Label 2823: @144389
     /* 144389 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(144425), // Rule ID 953 //
     /* 144394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144416 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 144419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144423 */     GIR_RootConstrainSelectedInstOperands,
     /* 144424 */     // GIR_Coverage, 953,
     /* 144424 */     GIR_EraseRootFromParent_Done,
     /* 144425 */   // Label 2824: @144425
     /* 144425 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(144461), // Rule ID 954 //
     /* 144430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144452 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 144455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144459 */     GIR_RootConstrainSelectedInstOperands,
     /* 144460 */     // GIR_Coverage, 954,
     /* 144460 */     GIR_EraseRootFromParent_Done,
     /* 144461 */   // Label 2825: @144461
     /* 144461 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(144497), // Rule ID 1001 //
     /* 144466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144488 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 144488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 144491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144495 */     GIR_RootConstrainSelectedInstOperands,
     /* 144496 */     // GIR_Coverage, 1001,
     /* 144496 */     GIR_EraseRootFromParent_Done,
     /* 144497 */   // Label 2826: @144497
     /* 144497 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(144533), // Rule ID 1003 //
     /* 144502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144524 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 144524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 144527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144531 */     GIR_RootConstrainSelectedInstOperands,
     /* 144532 */     // GIR_Coverage, 1003,
     /* 144532 */     GIR_EraseRootFromParent_Done,
     /* 144533 */   // Label 2827: @144533
     /* 144533 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(144569), // Rule ID 1005 //
     /* 144538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144560 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 144560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 144563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144567 */     GIR_RootConstrainSelectedInstOperands,
     /* 144568 */     // GIR_Coverage, 1005,
     /* 144568 */     GIR_EraseRootFromParent_Done,
     /* 144569 */   // Label 2828: @144569
     /* 144569 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(144605), // Rule ID 1007 //
     /* 144574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144596 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 144596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 144599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144603 */     GIR_RootConstrainSelectedInstOperands,
     /* 144604 */     // GIR_Coverage, 1007,
     /* 144604 */     GIR_EraseRootFromParent_Done,
     /* 144605 */   // Label 2829: @144605
     /* 144605 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(144641), // Rule ID 1009 //
     /* 144610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144632 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 144632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 144635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144639 */     GIR_RootConstrainSelectedInstOperands,
     /* 144640 */     // GIR_Coverage, 1009,
     /* 144640 */     GIR_EraseRootFromParent_Done,
     /* 144641 */   // Label 2830: @144641
     /* 144641 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(144677), // Rule ID 1011 //
     /* 144646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144668 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 144668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 144671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144675 */     GIR_RootConstrainSelectedInstOperands,
     /* 144676 */     // GIR_Coverage, 1011,
     /* 144676 */     GIR_EraseRootFromParent_Done,
     /* 144677 */   // Label 2831: @144677
     /* 144677 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(144713), // Rule ID 1022 //
     /* 144682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144704 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 144707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144711 */     GIR_RootConstrainSelectedInstOperands,
     /* 144712 */     // GIR_Coverage, 1022,
     /* 144712 */     GIR_EraseRootFromParent_Done,
     /* 144713 */   // Label 2832: @144713
     /* 144713 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(144749), // Rule ID 1023 //
     /* 144718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144740 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 144743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144747 */     GIR_RootConstrainSelectedInstOperands,
     /* 144748 */     // GIR_Coverage, 1023,
     /* 144748 */     GIR_EraseRootFromParent_Done,
     /* 144749 */   // Label 2833: @144749
     /* 144749 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(144785), // Rule ID 1024 //
     /* 144754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144776 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 144779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144783 */     GIR_RootConstrainSelectedInstOperands,
     /* 144784 */     // GIR_Coverage, 1024,
     /* 144784 */     GIR_EraseRootFromParent_Done,
     /* 144785 */   // Label 2834: @144785
     /* 144785 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(144821), // Rule ID 1025 //
     /* 144790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144812 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 144815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144819 */     GIR_RootConstrainSelectedInstOperands,
     /* 144820 */     // GIR_Coverage, 1025,
     /* 144820 */     GIR_EraseRootFromParent_Done,
     /* 144821 */   // Label 2835: @144821
     /* 144821 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(144857), // Rule ID 1026 //
     /* 144826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144848 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 144851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144855 */     GIR_RootConstrainSelectedInstOperands,
     /* 144856 */     // GIR_Coverage, 1026,
     /* 144856 */     GIR_EraseRootFromParent_Done,
     /* 144857 */   // Label 2836: @144857
     /* 144857 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(144893), // Rule ID 1027 //
     /* 144862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144884 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 144887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144891 */     GIR_RootConstrainSelectedInstOperands,
     /* 144892 */     // GIR_Coverage, 1027,
     /* 144892 */     GIR_EraseRootFromParent_Done,
     /* 144893 */   // Label 2837: @144893
     /* 144893 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(144929), // Rule ID 1028 //
     /* 144898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144920 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 144920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 144923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144927 */     GIR_RootConstrainSelectedInstOperands,
     /* 144928 */     // GIR_Coverage, 1028,
     /* 144928 */     GIR_EraseRootFromParent_Done,
     /* 144929 */   // Label 2838: @144929
     /* 144929 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(144965), // Rule ID 1029 //
     /* 144934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144956 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 144959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144963 */     GIR_RootConstrainSelectedInstOperands,
     /* 144964 */     // GIR_Coverage, 1029,
     /* 144964 */     GIR_EraseRootFromParent_Done,
     /* 144965 */   // Label 2839: @144965
     /* 144965 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(145001), // Rule ID 1030 //
     /* 144970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144992 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 144995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144999 */     GIR_RootConstrainSelectedInstOperands,
     /* 145000 */     // GIR_Coverage, 1030,
     /* 145000 */     GIR_EraseRootFromParent_Done,
     /* 145001 */   // Label 2840: @145001
     /* 145001 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(145037), // Rule ID 1031 //
     /* 145006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145028 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 145028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 145031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145035 */     GIR_RootConstrainSelectedInstOperands,
     /* 145036 */     // GIR_Coverage, 1031,
     /* 145036 */     GIR_EraseRootFromParent_Done,
     /* 145037 */   // Label 2841: @145037
     /* 145037 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(145073), // Rule ID 1032 //
     /* 145042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145064 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 145067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145071 */     GIR_RootConstrainSelectedInstOperands,
     /* 145072 */     // GIR_Coverage, 1032,
     /* 145072 */     GIR_EraseRootFromParent_Done,
     /* 145073 */   // Label 2842: @145073
     /* 145073 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(145109), // Rule ID 1033 //
     /* 145078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145100 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 145103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145107 */     GIR_RootConstrainSelectedInstOperands,
     /* 145108 */     // GIR_Coverage, 1033,
     /* 145108 */     GIR_EraseRootFromParent_Done,
     /* 145109 */   // Label 2843: @145109
     /* 145109 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(145145), // Rule ID 1034 //
     /* 145114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145136 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 145139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145143 */     GIR_RootConstrainSelectedInstOperands,
     /* 145144 */     // GIR_Coverage, 1034,
     /* 145144 */     GIR_EraseRootFromParent_Done,
     /* 145145 */   // Label 2844: @145145
     /* 145145 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(145181), // Rule ID 1035 //
     /* 145150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145172 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 145172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 145175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145179 */     GIR_RootConstrainSelectedInstOperands,
     /* 145180 */     // GIR_Coverage, 1035,
     /* 145180 */     GIR_EraseRootFromParent_Done,
     /* 145181 */   // Label 2845: @145181
     /* 145181 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(145217), // Rule ID 1062 //
     /* 145186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145208 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 145208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 145211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145215 */     GIR_RootConstrainSelectedInstOperands,
     /* 145216 */     // GIR_Coverage, 1062,
     /* 145216 */     GIR_EraseRootFromParent_Done,
     /* 145217 */   // Label 2846: @145217
     /* 145217 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(145253), // Rule ID 1064 //
     /* 145222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145244 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 145244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 145247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145251 */     GIR_RootConstrainSelectedInstOperands,
     /* 145252 */     // GIR_Coverage, 1064,
     /* 145252 */     GIR_EraseRootFromParent_Done,
     /* 145253 */   // Label 2847: @145253
     /* 145253 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(145289), // Rule ID 1066 //
     /* 145258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145280 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 145280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 145283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145287 */     GIR_RootConstrainSelectedInstOperands,
     /* 145288 */     // GIR_Coverage, 1066,
     /* 145288 */     GIR_EraseRootFromParent_Done,
     /* 145289 */   // Label 2848: @145289
     /* 145289 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(145325), // Rule ID 1068 //
     /* 145294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145316 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 145316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 145319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145323 */     GIR_RootConstrainSelectedInstOperands,
     /* 145324 */     // GIR_Coverage, 1068,
     /* 145324 */     GIR_EraseRootFromParent_Done,
     /* 145325 */   // Label 2849: @145325
     /* 145325 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(145361), // Rule ID 1070 //
     /* 145330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145352 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 145352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 145355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145359 */     GIR_RootConstrainSelectedInstOperands,
     /* 145360 */     // GIR_Coverage, 1070,
     /* 145360 */     GIR_EraseRootFromParent_Done,
     /* 145361 */   // Label 2850: @145361
     /* 145361 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(145397), // Rule ID 1072 //
     /* 145366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145388 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 145388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 145391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145395 */     GIR_RootConstrainSelectedInstOperands,
     /* 145396 */     // GIR_Coverage, 1072,
     /* 145396 */     GIR_EraseRootFromParent_Done,
     /* 145397 */   // Label 2851: @145397
     /* 145397 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(145433), // Rule ID 1086 //
     /* 145402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 145410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145424 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 145427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145431 */     GIR_RootConstrainSelectedInstOperands,
     /* 145432 */     // GIR_Coverage, 1086,
     /* 145432 */     GIR_EraseRootFromParent_Done,
     /* 145433 */   // Label 2852: @145433
     /* 145433 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(145469), // Rule ID 1087 //
     /* 145438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 145446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145460 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 145463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145467 */     GIR_RootConstrainSelectedInstOperands,
     /* 145468 */     // GIR_Coverage, 1087,
     /* 145468 */     GIR_EraseRootFromParent_Done,
     /* 145469 */   // Label 2853: @145469
     /* 145469 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(145505), // Rule ID 1088 //
     /* 145474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 145482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145496 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 145499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145503 */     GIR_RootConstrainSelectedInstOperands,
     /* 145504 */     // GIR_Coverage, 1088,
     /* 145504 */     GIR_EraseRootFromParent_Done,
     /* 145505 */   // Label 2854: @145505
     /* 145505 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(145541), // Rule ID 1089 //
     /* 145510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 145518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145532 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 145535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145539 */     GIR_RootConstrainSelectedInstOperands,
     /* 145540 */     // GIR_Coverage, 1089,
     /* 145540 */     GIR_EraseRootFromParent_Done,
     /* 145541 */   // Label 2855: @145541
     /* 145541 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(145577), // Rule ID 1653 //
     /* 145546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 145554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145568 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 145571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145575 */     GIR_RootConstrainSelectedInstOperands,
     /* 145576 */     // GIR_Coverage, 1653,
     /* 145576 */     GIR_EraseRootFromParent_Done,
     /* 145577 */   // Label 2856: @145577
     /* 145577 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(145613), // Rule ID 1659 //
     /* 145582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145604 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 145604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 145607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145611 */     GIR_RootConstrainSelectedInstOperands,
     /* 145612 */     // GIR_Coverage, 1659,
     /* 145612 */     GIR_EraseRootFromParent_Done,
     /* 145613 */   // Label 2857: @145613
     /* 145613 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(145649), // Rule ID 1660 //
     /* 145618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145640 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 145640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 145643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145647 */     GIR_RootConstrainSelectedInstOperands,
     /* 145648 */     // GIR_Coverage, 1660,
     /* 145648 */     GIR_EraseRootFromParent_Done,
     /* 145649 */   // Label 2858: @145649
     /* 145649 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(145685), // Rule ID 1661 //
     /* 145654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145676 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 145676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 145679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145683 */     GIR_RootConstrainSelectedInstOperands,
     /* 145684 */     // GIR_Coverage, 1661,
     /* 145684 */     GIR_EraseRootFromParent_Done,
     /* 145685 */   // Label 2859: @145685
     /* 145685 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(145721), // Rule ID 1662 //
     /* 145690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145712 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 145712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 145715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145719 */     GIR_RootConstrainSelectedInstOperands,
     /* 145720 */     // GIR_Coverage, 1662,
     /* 145720 */     GIR_EraseRootFromParent_Done,
     /* 145721 */   // Label 2860: @145721
     /* 145721 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(145757), // Rule ID 1663 //
     /* 145726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 145734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145748 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 145751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145755 */     GIR_RootConstrainSelectedInstOperands,
     /* 145756 */     // GIR_Coverage, 1663,
     /* 145756 */     GIR_EraseRootFromParent_Done,
     /* 145757 */   // Label 2861: @145757
     /* 145757 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(145793), // Rule ID 1664 //
     /* 145762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 145770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145784 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 145787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145791 */     GIR_RootConstrainSelectedInstOperands,
     /* 145792 */     // GIR_Coverage, 1664,
     /* 145792 */     GIR_EraseRootFromParent_Done,
     /* 145793 */   // Label 2862: @145793
     /* 145793 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(145829), // Rule ID 1670 //
     /* 145798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 145806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145820 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 145823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145827 */     GIR_RootConstrainSelectedInstOperands,
     /* 145828 */     // GIR_Coverage, 1670,
     /* 145828 */     GIR_EraseRootFromParent_Done,
     /* 145829 */   // Label 2863: @145829
     /* 145829 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(145865), // Rule ID 1943 //
     /* 145834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145856 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 145859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145863 */     GIR_RootConstrainSelectedInstOperands,
     /* 145864 */     // GIR_Coverage, 1943,
     /* 145864 */     GIR_EraseRootFromParent_Done,
     /* 145865 */   // Label 2864: @145865
     /* 145865 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(145901), // Rule ID 1945 //
     /* 145870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145892 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 145895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145899 */     GIR_RootConstrainSelectedInstOperands,
     /* 145900 */     // GIR_Coverage, 1945,
     /* 145900 */     GIR_EraseRootFromParent_Done,
     /* 145901 */   // Label 2865: @145901
     /* 145901 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(145937), // Rule ID 1947 //
     /* 145906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145928 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 145931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145935 */     GIR_RootConstrainSelectedInstOperands,
     /* 145936 */     // GIR_Coverage, 1947,
     /* 145936 */     GIR_EraseRootFromParent_Done,
     /* 145937 */   // Label 2866: @145937
     /* 145937 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(145973), // Rule ID 1949 //
     /* 145942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145964 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 145967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145971 */     GIR_RootConstrainSelectedInstOperands,
     /* 145972 */     // GIR_Coverage, 1949,
     /* 145972 */     GIR_EraseRootFromParent_Done,
     /* 145973 */   // Label 2867: @145973
     /* 145973 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(146009), // Rule ID 1951 //
     /* 145978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146000 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 146003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146007 */     GIR_RootConstrainSelectedInstOperands,
     /* 146008 */     // GIR_Coverage, 1951,
     /* 146008 */     GIR_EraseRootFromParent_Done,
     /* 146009 */   // Label 2868: @146009
     /* 146009 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(146045), // Rule ID 1953 //
     /* 146014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 146022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146036 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 146039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146043 */     GIR_RootConstrainSelectedInstOperands,
     /* 146044 */     // GIR_Coverage, 1953,
     /* 146044 */     GIR_EraseRootFromParent_Done,
     /* 146045 */   // Label 2869: @146045
     /* 146045 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(146081), // Rule ID 1955 //
     /* 146050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146072 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 146075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146079 */     GIR_RootConstrainSelectedInstOperands,
     /* 146080 */     // GIR_Coverage, 1955,
     /* 146080 */     GIR_EraseRootFromParent_Done,
     /* 146081 */   // Label 2870: @146081
     /* 146081 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(146117), // Rule ID 1957 //
     /* 146086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146108 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 146111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146115 */     GIR_RootConstrainSelectedInstOperands,
     /* 146116 */     // GIR_Coverage, 1957,
     /* 146116 */     GIR_EraseRootFromParent_Done,
     /* 146117 */   // Label 2871: @146117
     /* 146117 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(146153), // Rule ID 1959 //
     /* 146122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146144 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 146147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146151 */     GIR_RootConstrainSelectedInstOperands,
     /* 146152 */     // GIR_Coverage, 1959,
     /* 146152 */     GIR_EraseRootFromParent_Done,
     /* 146153 */   // Label 2872: @146153
     /* 146153 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(146189), // Rule ID 1961 //
     /* 146158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146180 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 146183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146187 */     GIR_RootConstrainSelectedInstOperands,
     /* 146188 */     // GIR_Coverage, 1961,
     /* 146188 */     GIR_EraseRootFromParent_Done,
     /* 146189 */   // Label 2873: @146189
     /* 146189 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(146225), // Rule ID 1963 //
     /* 146194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146216 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 146219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146223 */     GIR_RootConstrainSelectedInstOperands,
     /* 146224 */     // GIR_Coverage, 1963,
     /* 146224 */     GIR_EraseRootFromParent_Done,
     /* 146225 */   // Label 2874: @146225
     /* 146225 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(146261), // Rule ID 1965 //
     /* 146230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146252 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 146255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146259 */     GIR_RootConstrainSelectedInstOperands,
     /* 146260 */     // GIR_Coverage, 1965,
     /* 146260 */     GIR_EraseRootFromParent_Done,
     /* 146261 */   // Label 2875: @146261
     /* 146261 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(146297), // Rule ID 2305 //
     /* 146266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 146269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 146274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 146277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146288 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 146291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146295 */     GIR_RootConstrainSelectedInstOperands,
     /* 146296 */     // GIR_Coverage, 2305,
     /* 146296 */     GIR_EraseRootFromParent_Done,
     /* 146297 */   // Label 2876: @146297
     /* 146297 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(146333), // Rule ID 2306 //
     /* 146302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 146305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 146310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 146313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146324 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 146327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146331 */     GIR_RootConstrainSelectedInstOperands,
     /* 146332 */     // GIR_Coverage, 2306,
     /* 146332 */     GIR_EraseRootFromParent_Done,
     /* 146333 */   // Label 2877: @146333
     /* 146333 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(146369), // Rule ID 2314 //
     /* 146338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 146341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 146346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146360 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 146360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 146363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146367 */     GIR_RootConstrainSelectedInstOperands,
     /* 146368 */     // GIR_Coverage, 2314,
     /* 146368 */     GIR_EraseRootFromParent_Done,
     /* 146369 */   // Label 2878: @146369
     /* 146369 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(146405), // Rule ID 2515 //
     /* 146374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 146382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146396 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 146396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 146399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146403 */     GIR_RootConstrainSelectedInstOperands,
     /* 146404 */     // GIR_Coverage, 2515,
     /* 146404 */     GIR_EraseRootFromParent_Done,
     /* 146405 */   // Label 2879: @146405
     /* 146405 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(146444), // Rule ID 3548 //
     /* 146410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 146421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 146424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 146432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 146435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146442 */     GIR_RootConstrainSelectedInstOperands,
     /* 146443 */     // GIR_Coverage, 3548,
     /* 146443 */     GIR_EraseRootFromParent_Done,
     /* 146444 */   // Label 2880: @146444
     /* 146444 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(146483), // Rule ID 3549 //
     /* 146449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 146460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 146463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146471 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 146471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 146474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146481 */     GIR_RootConstrainSelectedInstOperands,
     /* 146482 */     // GIR_Coverage, 3549,
     /* 146482 */     GIR_EraseRootFromParent_Done,
     /* 146483 */   // Label 2881: @146483
     /* 146483 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(146522), // Rule ID 3550 //
     /* 146488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 146499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 146502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146510 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 146510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 146513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146520 */     GIR_RootConstrainSelectedInstOperands,
     /* 146521 */     // GIR_Coverage, 3550,
     /* 146521 */     GIR_EraseRootFromParent_Done,
     /* 146522 */   // Label 2882: @146522
     /* 146522 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(146561), // Rule ID 3551 //
     /* 146527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 146538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 146541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146549 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 146549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 146552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146559 */     GIR_RootConstrainSelectedInstOperands,
     /* 146560 */     // GIR_Coverage, 3551,
     /* 146560 */     GIR_EraseRootFromParent_Done,
     /* 146561 */   // Label 2883: @146561
     /* 146561 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(146617), // Rule ID 3555 //
     /* 146566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 146577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 146580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146588 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1629:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 146588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 146605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146615 */     GIR_RootConstrainSelectedInstOperands,
     /* 146616 */     // GIR_Coverage, 3555,
     /* 146616 */     GIR_EraseRootFromParent_Done,
     /* 146617 */   // Label 2884: @146617
     /* 146617 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(146673), // Rule ID 3556 //
     /* 146622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 146633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 146636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1629:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 146644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 146661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146671 */     GIR_RootConstrainSelectedInstOperands,
     /* 146672 */     // GIR_Coverage, 3556,
     /* 146672 */     GIR_EraseRootFromParent_Done,
     /* 146673 */   // Label 2885: @146673
     /* 146673 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(146729), // Rule ID 3557 //
     /* 146678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 146689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 146692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 146700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 146717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146727 */     GIR_RootConstrainSelectedInstOperands,
     /* 146728 */     // GIR_Coverage, 3557,
     /* 146728 */     GIR_EraseRootFromParent_Done,
     /* 146729 */   // Label 2886: @146729
     /* 146729 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(146785), // Rule ID 3558 //
     /* 146734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 146745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 146748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146756 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1629:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 146756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 146773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146783 */     GIR_RootConstrainSelectedInstOperands,
     /* 146784 */     // GIR_Coverage, 3558,
     /* 146784 */     GIR_EraseRootFromParent_Done,
     /* 146785 */   // Label 2887: @146785
     /* 146785 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(146818), // Rule ID 4009 //
     /* 146790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 146795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146809 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 146809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 146812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146816 */     GIR_RootConstrainSelectedInstOperands,
     /* 146817 */     // GIR_Coverage, 4009,
     /* 146817 */     GIR_EraseRootFromParent_Done,
     /* 146818 */   // Label 2888: @146818
     /* 146818 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(146883), // Rule ID 4010 //
     /* 146823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 146828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146842 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 146842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 146845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 146849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146865 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 146872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146882 */     // GIR_Coverage, 4010,
     /* 146882 */     GIR_EraseRootFromParent_Done,
     /* 146883 */   // Label 2889: @146883
     /* 146883 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(146916), // Rule ID 4780 //
     /* 146888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146907 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 146910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146914 */     GIR_RootConstrainSelectedInstOperands,
     /* 146915 */     // GIR_Coverage, 4780,
     /* 146915 */     GIR_EraseRootFromParent_Done,
     /* 146916 */   // Label 2890: @146916
     /* 146916 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(146949), // Rule ID 4781 //
     /* 146921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146940 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 146943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146947 */     GIR_RootConstrainSelectedInstOperands,
     /* 146948 */     // GIR_Coverage, 4781,
     /* 146948 */     GIR_EraseRootFromParent_Done,
     /* 146949 */   // Label 2891: @146949
     /* 146949 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(146982), // Rule ID 4782 //
     /* 146954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146973 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 146976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146980 */     GIR_RootConstrainSelectedInstOperands,
     /* 146981 */     // GIR_Coverage, 4782,
     /* 146981 */     GIR_EraseRootFromParent_Done,
     /* 146982 */   // Label 2892: @146982
     /* 146982 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(147015), // Rule ID 4783 //
     /* 146987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147006 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 147009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147013 */     GIR_RootConstrainSelectedInstOperands,
     /* 147014 */     // GIR_Coverage, 4783,
     /* 147014 */     GIR_EraseRootFromParent_Done,
     /* 147015 */   // Label 2893: @147015
     /* 147015 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(147048), // Rule ID 4897 //
     /* 147020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 147025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147039 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 147039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 147042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147046 */     GIR_RootConstrainSelectedInstOperands,
     /* 147047 */     // GIR_Coverage, 4897,
     /* 147047 */     GIR_EraseRootFromParent_Done,
     /* 147048 */   // Label 2894: @147048
     /* 147048 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(147081), // Rule ID 4907 //
     /* 147053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 147058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147072 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 147072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 147075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147079 */     GIR_RootConstrainSelectedInstOperands,
     /* 147080 */     // GIR_Coverage, 4907,
     /* 147080 */     GIR_EraseRootFromParent_Done,
     /* 147081 */   // Label 2895: @147081
     /* 147081 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(147117), // Rule ID 5249 //
     /* 147086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147108 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 147108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 147111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147115 */     GIR_RootConstrainSelectedInstOperands,
     /* 147116 */     // GIR_Coverage, 5249,
     /* 147116 */     GIR_EraseRootFromParent_Done,
     /* 147117 */   // Label 2896: @147117
     /* 147117 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(147150), // Rule ID 5252 //
     /* 147122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 147127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147141 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 147144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147148 */     GIR_RootConstrainSelectedInstOperands,
     /* 147149 */     // GIR_Coverage, 5252,
     /* 147149 */     GIR_EraseRootFromParent_Done,
     /* 147150 */   // Label 2897: @147150
     /* 147150 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(147183), // Rule ID 5253 //
     /* 147155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 147160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147174 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 147177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147181 */     GIR_RootConstrainSelectedInstOperands,
     /* 147182 */     // GIR_Coverage, 5253,
     /* 147182 */     GIR_EraseRootFromParent_Done,
     /* 147183 */   // Label 2898: @147183
     /* 147183 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(147216), // Rule ID 5254 //
     /* 147188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 147193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147207 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 147210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147214 */     GIR_RootConstrainSelectedInstOperands,
     /* 147215 */     // GIR_Coverage, 5254,
     /* 147215 */     GIR_EraseRootFromParent_Done,
     /* 147216 */   // Label 2899: @147216
     /* 147216 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(147249), // Rule ID 5255 //
     /* 147221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 147226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147240 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 147243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147247 */     GIR_RootConstrainSelectedInstOperands,
     /* 147248 */     // GIR_Coverage, 5255,
     /* 147248 */     GIR_EraseRootFromParent_Done,
     /* 147249 */   // Label 2900: @147249
     /* 147249 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(147282), // Rule ID 5256 //
     /* 147254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 147259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147273 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 147276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147280 */     GIR_RootConstrainSelectedInstOperands,
     /* 147281 */     // GIR_Coverage, 5256,
     /* 147281 */     GIR_EraseRootFromParent_Done,
     /* 147282 */   // Label 2901: @147282
     /* 147282 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(147315), // Rule ID 5257 //
     /* 147287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 147292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147306 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 147309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147313 */     GIR_RootConstrainSelectedInstOperands,
     /* 147314 */     // GIR_Coverage, 5257,
     /* 147314 */     GIR_EraseRootFromParent_Done,
     /* 147315 */   // Label 2902: @147315
     /* 147315 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(147348), // Rule ID 5258 //
     /* 147320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 147325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147339 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 147342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147346 */     GIR_RootConstrainSelectedInstOperands,
     /* 147347 */     // GIR_Coverage, 5258,
     /* 147347 */     GIR_EraseRootFromParent_Done,
     /* 147348 */   // Label 2903: @147348
     /* 147348 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(147381), // Rule ID 5259 //
     /* 147353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 147358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147372 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 147375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147379 */     GIR_RootConstrainSelectedInstOperands,
     /* 147380 */     // GIR_Coverage, 5259,
     /* 147380 */     GIR_EraseRootFromParent_Done,
     /* 147381 */   // Label 2904: @147381
     /* 147381 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(147414), // Rule ID 5260 //
     /* 147386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147405 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 147408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147412 */     GIR_RootConstrainSelectedInstOperands,
     /* 147413 */     // GIR_Coverage, 5260,
     /* 147413 */     GIR_EraseRootFromParent_Done,
     /* 147414 */   // Label 2905: @147414
     /* 147414 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(147447), // Rule ID 5261 //
     /* 147419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147438 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 147441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147445 */     GIR_RootConstrainSelectedInstOperands,
     /* 147446 */     // GIR_Coverage, 5261,
     /* 147446 */     GIR_EraseRootFromParent_Done,
     /* 147447 */   // Label 2906: @147447
     /* 147447 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(147480), // Rule ID 5262 //
     /* 147452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147471 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 147474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147478 */     GIR_RootConstrainSelectedInstOperands,
     /* 147479 */     // GIR_Coverage, 5262,
     /* 147479 */     GIR_EraseRootFromParent_Done,
     /* 147480 */   // Label 2907: @147480
     /* 147480 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(147513), // Rule ID 5263 //
     /* 147485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147504 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 147507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147511 */     GIR_RootConstrainSelectedInstOperands,
     /* 147512 */     // GIR_Coverage, 5263,
     /* 147512 */     GIR_EraseRootFromParent_Done,
     /* 147513 */   // Label 2908: @147513
     /* 147513 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147546), // Rule ID 5264 //
     /* 147518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147537 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 147540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147544 */     GIR_RootConstrainSelectedInstOperands,
     /* 147545 */     // GIR_Coverage, 5264,
     /* 147545 */     GIR_EraseRootFromParent_Done,
     /* 147546 */   // Label 2909: @147546
     /* 147546 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147579), // Rule ID 5265 //
     /* 147551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147570 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 147573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147577 */     GIR_RootConstrainSelectedInstOperands,
     /* 147578 */     // GIR_Coverage, 5265,
     /* 147578 */     GIR_EraseRootFromParent_Done,
     /* 147579 */   // Label 2910: @147579
     /* 147579 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147612), // Rule ID 5277 //
     /* 147584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147603 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 147606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147610 */     GIR_RootConstrainSelectedInstOperands,
     /* 147611 */     // GIR_Coverage, 5277,
     /* 147611 */     GIR_EraseRootFromParent_Done,
     /* 147612 */   // Label 2911: @147612
     /* 147612 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147645), // Rule ID 5278 //
     /* 147617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147636 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 147639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147643 */     GIR_RootConstrainSelectedInstOperands,
     /* 147644 */     // GIR_Coverage, 5278,
     /* 147644 */     GIR_EraseRootFromParent_Done,
     /* 147645 */   // Label 2912: @147645
     /* 147645 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(147678), // Rule ID 5279 //
     /* 147650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147669 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 147672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147676 */     GIR_RootConstrainSelectedInstOperands,
     /* 147677 */     // GIR_Coverage, 5279,
     /* 147677 */     GIR_EraseRootFromParent_Done,
     /* 147678 */   // Label 2913: @147678
     /* 147678 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147711), // Rule ID 5280 //
     /* 147683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147702 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 147705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147709 */     GIR_RootConstrainSelectedInstOperands,
     /* 147710 */     // GIR_Coverage, 5280,
     /* 147710 */     GIR_EraseRootFromParent_Done,
     /* 147711 */   // Label 2914: @147711
     /* 147711 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147744), // Rule ID 5281 //
     /* 147716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147735 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 147738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147742 */     GIR_RootConstrainSelectedInstOperands,
     /* 147743 */     // GIR_Coverage, 5281,
     /* 147743 */     GIR_EraseRootFromParent_Done,
     /* 147744 */   // Label 2915: @147744
     /* 147744 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(147777), // Rule ID 5282 //
     /* 147749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147768 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 147771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147775 */     GIR_RootConstrainSelectedInstOperands,
     /* 147776 */     // GIR_Coverage, 5282,
     /* 147776 */     GIR_EraseRootFromParent_Done,
     /* 147777 */   // Label 2916: @147777
     /* 147777 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(147810), // Rule ID 5283 //
     /* 147782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147801 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 147804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147808 */     GIR_RootConstrainSelectedInstOperands,
     /* 147809 */     // GIR_Coverage, 5283,
     /* 147809 */     GIR_EraseRootFromParent_Done,
     /* 147810 */   // Label 2917: @147810
     /* 147810 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(147843), // Rule ID 5613 //
     /* 147815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147834 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 147837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147841 */     GIR_RootConstrainSelectedInstOperands,
     /* 147842 */     // GIR_Coverage, 5613,
     /* 147842 */     GIR_EraseRootFromParent_Done,
     /* 147843 */   // Label 2918: @147843
     /* 147843 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(147928), // Rule ID 5614 //
     /* 147848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147867 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 147867 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 147870 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 147874 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147879 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147901 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 147908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 147921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147926 */     GIR_RootConstrainSelectedInstOperands,
     /* 147927 */     // GIR_Coverage, 5614,
     /* 147927 */     GIR_EraseRootFromParent_Done,
     /* 147928 */   // Label 2919: @147928
     /* 147928 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(147961), // Rule ID 5615 //
     /* 147933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147952 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 147955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147959 */     GIR_RootConstrainSelectedInstOperands,
     /* 147960 */     // GIR_Coverage, 5615,
     /* 147960 */     GIR_EraseRootFromParent_Done,
     /* 147961 */   // Label 2920: @147961
     /* 147961 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(147994), // Rule ID 5617 //
     /* 147966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 147971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147985 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 147988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147992 */     GIR_RootConstrainSelectedInstOperands,
     /* 147993 */     // GIR_Coverage, 5617,
     /* 147993 */     GIR_EraseRootFromParent_Done,
     /* 147994 */   // Label 2921: @147994
     /* 147994 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(148027), // Rule ID 5619 //
     /* 147999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148018 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 148021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148025 */     GIR_RootConstrainSelectedInstOperands,
     /* 148026 */     // GIR_Coverage, 5619,
     /* 148026 */     GIR_EraseRootFromParent_Done,
     /* 148027 */   // Label 2922: @148027
     /* 148027 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148060), // Rule ID 5621 //
     /* 148032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148051 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 148054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148058 */     GIR_RootConstrainSelectedInstOperands,
     /* 148059 */     // GIR_Coverage, 5621,
     /* 148059 */     GIR_EraseRootFromParent_Done,
     /* 148060 */   // Label 2923: @148060
     /* 148060 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148093), // Rule ID 5623 //
     /* 148065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148084 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 148087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148091 */     GIR_RootConstrainSelectedInstOperands,
     /* 148092 */     // GIR_Coverage, 5623,
     /* 148092 */     GIR_EraseRootFromParent_Done,
     /* 148093 */   // Label 2924: @148093
     /* 148093 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(148126), // Rule ID 5625 //
     /* 148098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148117 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 148120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148124 */     GIR_RootConstrainSelectedInstOperands,
     /* 148125 */     // GIR_Coverage, 5625,
     /* 148125 */     GIR_EraseRootFromParent_Done,
     /* 148126 */   // Label 2925: @148126
     /* 148126 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(148159), // Rule ID 5627 //
     /* 148131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148150 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 148153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148157 */     GIR_RootConstrainSelectedInstOperands,
     /* 148158 */     // GIR_Coverage, 5627,
     /* 148158 */     GIR_EraseRootFromParent_Done,
     /* 148159 */   // Label 2926: @148159
     /* 148159 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(148192), // Rule ID 5629 //
     /* 148164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148183 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 148186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148190 */     GIR_RootConstrainSelectedInstOperands,
     /* 148191 */     // GIR_Coverage, 5629,
     /* 148191 */     GIR_EraseRootFromParent_Done,
     /* 148192 */   // Label 2927: @148192
     /* 148192 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148225), // Rule ID 5631 //
     /* 148197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148216 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 148219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148223 */     GIR_RootConstrainSelectedInstOperands,
     /* 148224 */     // GIR_Coverage, 5631,
     /* 148224 */     GIR_EraseRootFromParent_Done,
     /* 148225 */   // Label 2928: @148225
     /* 148225 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148258), // Rule ID 13104 //
     /* 148230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148249 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 148252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148256 */     GIR_RootConstrainSelectedInstOperands,
     /* 148257 */     // GIR_Coverage, 13104,
     /* 148257 */     GIR_EraseRootFromParent_Done,
     /* 148258 */   // Label 2929: @148258
     /* 148258 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148291), // Rule ID 13106 //
     /* 148263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148282 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 148285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148289 */     GIR_RootConstrainSelectedInstOperands,
     /* 148290 */     // GIR_Coverage, 13106,
     /* 148290 */     GIR_EraseRootFromParent_Done,
     /* 148291 */   // Label 2930: @148291
     /* 148291 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148324), // Rule ID 13108 //
     /* 148296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148315 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 148318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148322 */     GIR_RootConstrainSelectedInstOperands,
     /* 148323 */     // GIR_Coverage, 13108,
     /* 148323 */     GIR_EraseRootFromParent_Done,
     /* 148324 */   // Label 2931: @148324
     /* 148324 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148357), // Rule ID 13110 //
     /* 148329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148348 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 148351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148355 */     GIR_RootConstrainSelectedInstOperands,
     /* 148356 */     // GIR_Coverage, 13110,
     /* 148356 */     GIR_EraseRootFromParent_Done,
     /* 148357 */   // Label 2932: @148357
     /* 148357 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148472), // Rule ID 13111 //
     /* 148362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148381 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148381 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148384 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 148388 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148393 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148425 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148431 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 148434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148454 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148471 */     // GIR_Coverage, 13111,
     /* 148471 */     GIR_EraseRootFromParent_Done,
     /* 148472 */   // Label 2933: @148472
     /* 148472 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148505), // Rule ID 13113 //
     /* 148477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148496 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 148499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148503 */     GIR_RootConstrainSelectedInstOperands,
     /* 148504 */     // GIR_Coverage, 13113,
     /* 148504 */     GIR_EraseRootFromParent_Done,
     /* 148505 */   // Label 2934: @148505
     /* 148505 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(148538), // Rule ID 13115 //
     /* 148510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148529 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 148532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148536 */     GIR_RootConstrainSelectedInstOperands,
     /* 148537 */     // GIR_Coverage, 13115,
     /* 148537 */     GIR_EraseRootFromParent_Done,
     /* 148538 */   // Label 2935: @148538
     /* 148538 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(148571), // Rule ID 13117 //
     /* 148543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148562 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 148565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148569 */     GIR_RootConstrainSelectedInstOperands,
     /* 148570 */     // GIR_Coverage, 13117,
     /* 148570 */     GIR_EraseRootFromParent_Done,
     /* 148571 */   // Label 2936: @148571
     /* 148571 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148604), // Rule ID 13119 //
     /* 148576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148595 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 148598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148602 */     GIR_RootConstrainSelectedInstOperands,
     /* 148603 */     // GIR_Coverage, 13119,
     /* 148603 */     GIR_EraseRootFromParent_Done,
     /* 148604 */   // Label 2937: @148604
     /* 148604 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(148719), // Rule ID 13120 //
     /* 148609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148628 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148628 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148631 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 148635 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148640 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148675 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 148681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148701 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148718 */     // GIR_Coverage, 13120,
     /* 148718 */     GIR_EraseRootFromParent_Done,
     /* 148719 */   // Label 2938: @148719
     /* 148719 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(148838), // Rule ID 13121 //
     /* 148724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148743 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148743 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148746 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 148750 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148755 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148759 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148794 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148797 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148820 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148837 */     // GIR_Coverage, 13121,
     /* 148837 */     GIR_EraseRootFromParent_Done,
     /* 148838 */   // Label 2939: @148838
     /* 148838 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(148953), // Rule ID 13122 //
     /* 148843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148862 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 148862 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148865 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 148869 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148874 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148880 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 148883 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148887 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 148897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148906 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148909 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148952 */     // GIR_Coverage, 13122,
     /* 148952 */     GIR_EraseRootFromParent_Done,
     /* 148953 */   // Label 2940: @148953
     /* 148953 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(149072), // Rule ID 13123 //
     /* 148958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148977 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148977 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148980 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 148984 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148989 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148993 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149025 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149028 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149031 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149054 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149071 */     // GIR_Coverage, 13123,
     /* 149071 */     GIR_EraseRootFromParent_Done,
     /* 149072 */   // Label 2941: @149072
     /* 149072 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(149187), // Rule ID 13124 //
     /* 149077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149096 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 149096 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149099 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 149103 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149108 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 149117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 149131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149169 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149186 */     // GIR_Coverage, 13124,
     /* 149186 */     GIR_EraseRootFromParent_Done,
     /* 149187 */   // Label 2942: @149187
     /* 149187 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(149220), // Rule ID 13126 //
     /* 149192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149211 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 149214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149218 */     GIR_RootConstrainSelectedInstOperands,
     /* 149219 */     // GIR_Coverage, 13126,
     /* 149219 */     GIR_EraseRootFromParent_Done,
     /* 149220 */   // Label 2943: @149220
     /* 149220 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(149253), // Rule ID 13128 //
     /* 149225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149244 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 149247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149251 */     GIR_RootConstrainSelectedInstOperands,
     /* 149252 */     // GIR_Coverage, 13128,
     /* 149252 */     GIR_EraseRootFromParent_Done,
     /* 149253 */   // Label 2944: @149253
     /* 149253 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(149286), // Rule ID 13130 //
     /* 149258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149277 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 149280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149284 */     GIR_RootConstrainSelectedInstOperands,
     /* 149285 */     // GIR_Coverage, 13130,
     /* 149285 */     GIR_EraseRootFromParent_Done,
     /* 149286 */   // Label 2945: @149286
     /* 149286 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(149319), // Rule ID 13132 //
     /* 149291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149310 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 149313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149317 */     GIR_RootConstrainSelectedInstOperands,
     /* 149318 */     // GIR_Coverage, 13132,
     /* 149318 */     GIR_EraseRootFromParent_Done,
     /* 149319 */   // Label 2946: @149319
     /* 149319 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(149434), // Rule ID 13133 //
     /* 149324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149343 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149343 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149346 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 149350 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149355 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149393 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149416 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149433 */     // GIR_Coverage, 13133,
     /* 149433 */     GIR_EraseRootFromParent_Done,
     /* 149434 */   // Label 2947: @149434
     /* 149434 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(149553), // Rule ID 13134 //
     /* 149439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149458 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 149465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149470 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149474 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149483 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149487 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149506 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149509 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149552 */     // GIR_Coverage, 13134,
     /* 149552 */     GIR_EraseRootFromParent_Done,
     /* 149553 */   // Label 2948: @149553
     /* 149553 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(149586), // Rule ID 13136 //
     /* 149558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149577 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 149580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149584 */     GIR_RootConstrainSelectedInstOperands,
     /* 149585 */     // GIR_Coverage, 13136,
     /* 149585 */     GIR_EraseRootFromParent_Done,
     /* 149586 */   // Label 2949: @149586
     /* 149586 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(149619), // Rule ID 13138 //
     /* 149591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149610 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 149613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149617 */     GIR_RootConstrainSelectedInstOperands,
     /* 149618 */     // GIR_Coverage, 13138,
     /* 149618 */     GIR_EraseRootFromParent_Done,
     /* 149619 */   // Label 2950: @149619
     /* 149619 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(149652), // Rule ID 13140 //
     /* 149624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149643 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 149646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149650 */     GIR_RootConstrainSelectedInstOperands,
     /* 149651 */     // GIR_Coverage, 13140,
     /* 149651 */     GIR_EraseRootFromParent_Done,
     /* 149652 */   // Label 2951: @149652
     /* 149652 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(149685), // Rule ID 13142 //
     /* 149657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149676 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 149679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149683 */     GIR_RootConstrainSelectedInstOperands,
     /* 149684 */     // GIR_Coverage, 13142,
     /* 149684 */     GIR_EraseRootFromParent_Done,
     /* 149685 */   // Label 2952: @149685
     /* 149685 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(149800), // Rule ID 13143 //
     /* 149690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149709 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149709 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149712 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 149716 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149721 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149727 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149730 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149734 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149753 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149756 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149759 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149782 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149799 */     // GIR_Coverage, 13143,
     /* 149799 */     GIR_EraseRootFromParent_Done,
     /* 149800 */   // Label 2953: @149800
     /* 149800 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(149919), // Rule ID 13144 //
     /* 149805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149824 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149824 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149827 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 149831 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149836 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149840 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149872 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149878 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149901 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149918 */     // GIR_Coverage, 13144,
     /* 149918 */     GIR_EraseRootFromParent_Done,
     /* 149919 */   // Label 2954: @149919
     /* 149919 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(149952), // Rule ID 13146 //
     /* 149924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149943 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 149946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149950 */     GIR_RootConstrainSelectedInstOperands,
     /* 149951 */     // GIR_Coverage, 13146,
     /* 149951 */     GIR_EraseRootFromParent_Done,
     /* 149952 */   // Label 2955: @149952
     /* 149952 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(149985), // Rule ID 13148 //
     /* 149957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149976 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 149979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149983 */     GIR_RootConstrainSelectedInstOperands,
     /* 149984 */     // GIR_Coverage, 13148,
     /* 149984 */     GIR_EraseRootFromParent_Done,
     /* 149985 */   // Label 2956: @149985
     /* 149985 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(150018), // Rule ID 13150 //
     /* 149990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150009 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 150012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150016 */     GIR_RootConstrainSelectedInstOperands,
     /* 150017 */     // GIR_Coverage, 13150,
     /* 150017 */     GIR_EraseRootFromParent_Done,
     /* 150018 */   // Label 2957: @150018
     /* 150018 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(150051), // Rule ID 13152 //
     /* 150023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150042 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 150045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150049 */     GIR_RootConstrainSelectedInstOperands,
     /* 150050 */     // GIR_Coverage, 13152,
     /* 150050 */     GIR_EraseRootFromParent_Done,
     /* 150051 */   // Label 2958: @150051
     /* 150051 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(150166), // Rule ID 13153 //
     /* 150056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150075 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150075 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150078 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 150082 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150087 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150093 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150096 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150100 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150119 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150122 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150148 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150165 */     // GIR_Coverage, 13153,
     /* 150165 */     GIR_EraseRootFromParent_Done,
     /* 150166 */   // Label 2959: @150166
     /* 150166 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(150285), // Rule ID 13154 //
     /* 150171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150190 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150190 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150193 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 150197 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150202 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150206 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150212 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150215 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150219 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150267 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150284 */     // GIR_Coverage, 13154,
     /* 150284 */     GIR_EraseRootFromParent_Done,
     /* 150285 */   // Label 2960: @150285
     /* 150285 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(150318), // Rule ID 13156 //
     /* 150290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150309 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 150312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150316 */     GIR_RootConstrainSelectedInstOperands,
     /* 150317 */     // GIR_Coverage, 13156,
     /* 150317 */     GIR_EraseRootFromParent_Done,
     /* 150318 */   // Label 2961: @150318
     /* 150318 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(150351), // Rule ID 13158 //
     /* 150323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150342 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 150345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150349 */     GIR_RootConstrainSelectedInstOperands,
     /* 150350 */     // GIR_Coverage, 13158,
     /* 150350 */     GIR_EraseRootFromParent_Done,
     /* 150351 */   // Label 2962: @150351
     /* 150351 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(150384), // Rule ID 13160 //
     /* 150356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150375 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 150378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150382 */     GIR_RootConstrainSelectedInstOperands,
     /* 150383 */     // GIR_Coverage, 13160,
     /* 150383 */     GIR_EraseRootFromParent_Done,
     /* 150384 */   // Label 2963: @150384
     /* 150384 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(150417), // Rule ID 13162 //
     /* 150389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150408 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 150411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150415 */     GIR_RootConstrainSelectedInstOperands,
     /* 150416 */     // GIR_Coverage, 13162,
     /* 150416 */     GIR_EraseRootFromParent_Done,
     /* 150417 */   // Label 2964: @150417
     /* 150417 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(150532), // Rule ID 13163 //
     /* 150422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150441 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150441 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150444 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 150448 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150453 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150459 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150462 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150466 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150514 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150531 */     // GIR_Coverage, 13163,
     /* 150531 */     GIR_EraseRootFromParent_Done,
     /* 150532 */   // Label 2965: @150532
     /* 150532 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(150651), // Rule ID 13164 //
     /* 150537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150556 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150556 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150559 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 150563 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150568 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150572 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150610 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150650 */     // GIR_Coverage, 13164,
     /* 150650 */     GIR_EraseRootFromParent_Done,
     /* 150651 */   // Label 2966: @150651
     /* 150651 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(150683), // Rule ID 2393 //
     /* 150656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 150664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150674 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1669:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 150677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150681 */     GIR_RootConstrainSelectedInstOperands,
     /* 150682 */     // GIR_Coverage, 2393,
     /* 150682 */     GIR_EraseRootFromParent_Done,
     /* 150683 */   // Label 2967: @150683
     /* 150683 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(150715), // Rule ID 2394 //
     /* 150688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 150696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150706 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 150709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150713 */     GIR_RootConstrainSelectedInstOperands,
     /* 150714 */     // GIR_Coverage, 2394,
     /* 150714 */     GIR_EraseRootFromParent_Done,
     /* 150715 */   // Label 2968: @150715
     /* 150715 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(150747), // Rule ID 2395 //
     /* 150720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 150728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150738 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 150741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150745 */     GIR_RootConstrainSelectedInstOperands,
     /* 150746 */     // GIR_Coverage, 2395,
     /* 150746 */     GIR_EraseRootFromParent_Done,
     /* 150747 */   // Label 2969: @150747
     /* 150747 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(150779), // Rule ID 3093 //
     /* 150752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 150763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 150766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150770 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 150770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 150773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150777 */     GIR_RootConstrainSelectedInstOperands,
     /* 150778 */     // GIR_Coverage, 3093,
     /* 150778 */     GIR_EraseRootFromParent_Done,
     /* 150779 */   // Label 2970: @150779
     /* 150779 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(150811), // Rule ID 3094 //
     /* 150784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 150795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 150798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 150802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 150805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150809 */     GIR_RootConstrainSelectedInstOperands,
     /* 150810 */     // GIR_Coverage, 3094,
     /* 150810 */     GIR_EraseRootFromParent_Done,
     /* 150811 */   // Label 2971: @150811
     /* 150811 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(150843), // Rule ID 3095 //
     /* 150816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 150827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 150830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 150834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 150837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150841 */     GIR_RootConstrainSelectedInstOperands,
     /* 150842 */     // GIR_Coverage, 3095,
     /* 150842 */     GIR_EraseRootFromParent_Done,
     /* 150843 */   // Label 2972: @150843
     /* 150843 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(150875), // Rule ID 3349 //
     /* 150848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 150859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150866 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1661:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 150866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150873 */     GIR_RootConstrainSelectedInstOperands,
     /* 150874 */     // GIR_Coverage, 3349,
     /* 150874 */     GIR_EraseRootFromParent_Done,
     /* 150875 */   // Label 2973: @150875
     /* 150875 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(150907), // Rule ID 3350 //
     /* 150880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 150891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 150894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150898 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1661:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 150898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150905 */     GIR_RootConstrainSelectedInstOperands,
     /* 150906 */     // GIR_Coverage, 3350,
     /* 150906 */     GIR_EraseRootFromParent_Done,
     /* 150907 */   // Label 2974: @150907
     /* 150907 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(150939), // Rule ID 3351 //
     /* 150912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 150923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 150926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150930 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1661:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 150930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150937 */     GIR_RootConstrainSelectedInstOperands,
     /* 150938 */     // GIR_Coverage, 3351,
     /* 150938 */     GIR_EraseRootFromParent_Done,
     /* 150939 */   // Label 2975: @150939
     /* 150939 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(150971), // Rule ID 3430 //
     /* 150944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 150947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 150955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 150958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150962 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 150962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 150965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150969 */     GIR_RootConstrainSelectedInstOperands,
     /* 150970 */     // GIR_Coverage, 3430,
     /* 150970 */     GIR_EraseRootFromParent_Done,
     /* 150971 */   // Label 2976: @150971
     /* 150971 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(151003), // Rule ID 3431 //
     /* 150976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 150979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 150987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 150990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150994 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1422:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 150994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 150997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151001 */     GIR_RootConstrainSelectedInstOperands,
     /* 151002 */     // GIR_Coverage, 3431,
     /* 151002 */     GIR_EraseRootFromParent_Done,
     /* 151003 */   // Label 2977: @151003
     /* 151003 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(151035), // Rule ID 3432 //
     /* 151008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 151011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 151016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 151019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151026 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1422:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 151029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151033 */     GIR_RootConstrainSelectedInstOperands,
     /* 151034 */     // GIR_Coverage, 3432,
     /* 151034 */     GIR_EraseRootFromParent_Done,
     /* 151035 */   // Label 2978: @151035
     /* 151035 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(151067), // Rule ID 3458 //
     /* 151040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 151043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 151048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 151054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151058 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 151058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 151061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 151063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151065 */     GIR_RootConstrainSelectedInstOperands,
     /* 151066 */     // GIR_Coverage, 3458,
     /* 151066 */     GIR_EraseRootFromParent_Done,
     /* 151067 */   // Label 2979: @151067
     /* 151067 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(151099), // Rule ID 4625 //
     /* 151072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151090 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 151093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151097 */     GIR_RootConstrainSelectedInstOperands,
     /* 151098 */     // GIR_Coverage, 4625,
     /* 151098 */     GIR_EraseRootFromParent_Done,
     /* 151099 */   // Label 2980: @151099
     /* 151099 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(151131), // Rule ID 4626 //
     /* 151104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151122 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 151125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151129 */     GIR_RootConstrainSelectedInstOperands,
     /* 151130 */     // GIR_Coverage, 4626,
     /* 151130 */     GIR_EraseRootFromParent_Done,
     /* 151131 */   // Label 2981: @151131
     /* 151131 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(151160), // Rule ID 4627 //
     /* 151136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151151 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 151154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151158 */     GIR_RootConstrainSelectedInstOperands,
     /* 151159 */     // GIR_Coverage, 4627,
     /* 151159 */     GIR_EraseRootFromParent_Done,
     /* 151160 */   // Label 2982: @151160
     /* 151160 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(151189), // Rule ID 4628 //
     /* 151165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151180 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 151180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 151183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151187 */     GIR_RootConstrainSelectedInstOperands,
     /* 151188 */     // GIR_Coverage, 4628,
     /* 151188 */     GIR_EraseRootFromParent_Done,
     /* 151189 */   // Label 2983: @151189
     /* 151189 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(151218), // Rule ID 4629 //
     /* 151194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151209 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 151209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 151212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151216 */     GIR_RootConstrainSelectedInstOperands,
     /* 151217 */     // GIR_Coverage, 4629,
     /* 151217 */     GIR_EraseRootFromParent_Done,
     /* 151218 */   // Label 2984: @151218
     /* 151218 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(151247), // Rule ID 4630 //
     /* 151223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151238 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 151238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 151241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151245 */     GIR_RootConstrainSelectedInstOperands,
     /* 151246 */     // GIR_Coverage, 4630,
     /* 151246 */     GIR_EraseRootFromParent_Done,
     /* 151247 */   // Label 2985: @151247
     /* 151247 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(151279), // Rule ID 4637 //
     /* 151252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151270 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 151273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151277 */     GIR_RootConstrainSelectedInstOperands,
     /* 151278 */     // GIR_Coverage, 4637,
     /* 151278 */     GIR_EraseRootFromParent_Done,
     /* 151279 */   // Label 2986: @151279
     /* 151279 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(151311), // Rule ID 4638 //
     /* 151284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151302 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 151305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151309 */     GIR_RootConstrainSelectedInstOperands,
     /* 151310 */     // GIR_Coverage, 4638,
     /* 151310 */     GIR_EraseRootFromParent_Done,
     /* 151311 */   // Label 2987: @151311
     /* 151311 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(151340), // Rule ID 4639 //
     /* 151316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151331 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 151334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151338 */     GIR_RootConstrainSelectedInstOperands,
     /* 151339 */     // GIR_Coverage, 4639,
     /* 151339 */     GIR_EraseRootFromParent_Done,
     /* 151340 */   // Label 2988: @151340
     /* 151340 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(151369), // Rule ID 4640 //
     /* 151345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151360 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 151360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 151363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151367 */     GIR_RootConstrainSelectedInstOperands,
     /* 151368 */     // GIR_Coverage, 4640,
     /* 151368 */     GIR_EraseRootFromParent_Done,
     /* 151369 */   // Label 2989: @151369
     /* 151369 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(151398), // Rule ID 4641 //
     /* 151374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151389 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 151389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 151392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151396 */     GIR_RootConstrainSelectedInstOperands,
     /* 151397 */     // GIR_Coverage, 4641,
     /* 151397 */     GIR_EraseRootFromParent_Done,
     /* 151398 */   // Label 2990: @151398
     /* 151398 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(151427), // Rule ID 4642 //
     /* 151403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151418 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 151418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 151421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151425 */     GIR_RootConstrainSelectedInstOperands,
     /* 151426 */     // GIR_Coverage, 4642,
     /* 151426 */     GIR_EraseRootFromParent_Done,
     /* 151427 */   // Label 2991: @151427
     /* 151427 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(151456), // Rule ID 4937 //
     /* 151432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151447 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 151447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 151450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151454 */     GIR_RootConstrainSelectedInstOperands,
     /* 151455 */     // GIR_Coverage, 4937,
     /* 151455 */     GIR_EraseRootFromParent_Done,
     /* 151456 */   // Label 2992: @151456
     /* 151456 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(151485), // Rule ID 4938 //
     /* 151461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 151469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 151476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 151479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151483 */     GIR_RootConstrainSelectedInstOperands,
     /* 151484 */     // GIR_Coverage, 4938,
     /* 151484 */     GIR_EraseRootFromParent_Done,
     /* 151485 */   // Label 2993: @151485
     /* 151485 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(151514), // Rule ID 4939 //
     /* 151490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151505 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 151505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 151508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151512 */     GIR_RootConstrainSelectedInstOperands,
     /* 151513 */     // GIR_Coverage, 4939,
     /* 151513 */     GIR_EraseRootFromParent_Done,
     /* 151514 */   // Label 2994: @151514
     /* 151514 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(151543), // Rule ID 4940 //
     /* 151519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151534 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 151534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 151537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151541 */     GIR_RootConstrainSelectedInstOperands,
     /* 151542 */     // GIR_Coverage, 4940,
     /* 151542 */     GIR_EraseRootFromParent_Done,
     /* 151543 */   // Label 2995: @151543
     /* 151543 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(151572), // Rule ID 4941 //
     /* 151548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151563 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 151563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 151566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151570 */     GIR_RootConstrainSelectedInstOperands,
     /* 151571 */     // GIR_Coverage, 4941,
     /* 151571 */     GIR_EraseRootFromParent_Done,
     /* 151572 */   // Label 2996: @151572
     /* 151572 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(151601), // Rule ID 4942 //
     /* 151577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151592 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 151592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 151595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151599 */     GIR_RootConstrainSelectedInstOperands,
     /* 151600 */     // GIR_Coverage, 4942,
     /* 151600 */     GIR_EraseRootFromParent_Done,
     /* 151601 */   // Label 2997: @151601
     /* 151601 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(151630), // Rule ID 4943 //
     /* 151606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 151614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151621 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 151621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 151624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151628 */     GIR_RootConstrainSelectedInstOperands,
     /* 151629 */     // GIR_Coverage, 4943,
     /* 151629 */     GIR_EraseRootFromParent_Done,
     /* 151630 */   // Label 2998: @151630
     /* 151630 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(151659), // Rule ID 4944 //
     /* 151635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151650 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 151650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 151653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151657 */     GIR_RootConstrainSelectedInstOperands,
     /* 151658 */     // GIR_Coverage, 4944,
     /* 151658 */     GIR_EraseRootFromParent_Done,
     /* 151659 */   // Label 2999: @151659
     /* 151659 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(151688), // Rule ID 4945 //
     /* 151664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 151679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 151682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151686 */     GIR_RootConstrainSelectedInstOperands,
     /* 151687 */     // GIR_Coverage, 4945,
     /* 151687 */     GIR_EraseRootFromParent_Done,
     /* 151688 */   // Label 3000: @151688
     /* 151688 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(151717), // Rule ID 4946 //
     /* 151693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151708 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 151708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 151711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151715 */     GIR_RootConstrainSelectedInstOperands,
     /* 151716 */     // GIR_Coverage, 4946,
     /* 151716 */     GIR_EraseRootFromParent_Done,
     /* 151717 */   // Label 3001: @151717
     /* 151717 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(151749), // Rule ID 8379 //
     /* 151722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 151733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1660:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 151740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151747 */     GIR_RootConstrainSelectedInstOperands,
     /* 151748 */     // GIR_Coverage, 8379,
     /* 151748 */     GIR_EraseRootFromParent_Done,
     /* 151749 */   // Label 3002: @151749
     /* 151749 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(151781), // Rule ID 8380 //
     /* 151754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 151765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 151768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1660:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 151772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151779 */     GIR_RootConstrainSelectedInstOperands,
     /* 151780 */     // GIR_Coverage, 8380,
     /* 151780 */     GIR_EraseRootFromParent_Done,
     /* 151781 */   // Label 3003: @151781
     /* 151781 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(151813), // Rule ID 8381 //
     /* 151786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 151797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 151800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151804 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1660:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 151804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151811 */     GIR_RootConstrainSelectedInstOperands,
     /* 151812 */     // GIR_Coverage, 8381,
     /* 151812 */     GIR_EraseRootFromParent_Done,
     /* 151813 */   // Label 3004: @151813
     /* 151813 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(151845), // Rule ID 11790 //
     /* 151818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 151839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151843 */     GIR_RootConstrainSelectedInstOperands,
     /* 151844 */     // GIR_Coverage, 11790,
     /* 151844 */     GIR_EraseRootFromParent_Done,
     /* 151845 */   // Label 3005: @151845
     /* 151845 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(151877), // Rule ID 11791 //
     /* 151850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 151871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151875 */     GIR_RootConstrainSelectedInstOperands,
     /* 151876 */     // GIR_Coverage, 11791,
     /* 151876 */     GIR_EraseRootFromParent_Done,
     /* 151877 */   // Label 3006: @151877
     /* 151877 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(151909), // Rule ID 11792 //
     /* 151882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 151903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151907 */     GIR_RootConstrainSelectedInstOperands,
     /* 151908 */     // GIR_Coverage, 11792,
     /* 151908 */     GIR_EraseRootFromParent_Done,
     /* 151909 */   // Label 3007: @151909
     /* 151909 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(151941), // Rule ID 11793 //
     /* 151914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 151935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151939 */     GIR_RootConstrainSelectedInstOperands,
     /* 151940 */     // GIR_Coverage, 11793,
     /* 151940 */     GIR_EraseRootFromParent_Done,
     /* 151941 */   // Label 3008: @151941
     /* 151941 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(151973), // Rule ID 11794 //
     /* 151946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 151967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151971 */     GIR_RootConstrainSelectedInstOperands,
     /* 151972 */     // GIR_Coverage, 11794,
     /* 151972 */     GIR_EraseRootFromParent_Done,
     /* 151973 */   // Label 3009: @151973
     /* 151973 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(152005), // Rule ID 11795 //
     /* 151978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 151999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152003 */     GIR_RootConstrainSelectedInstOperands,
     /* 152004 */     // GIR_Coverage, 11795,
     /* 152004 */     GIR_EraseRootFromParent_Done,
     /* 152005 */   // Label 3010: @152005
     /* 152005 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(152037), // Rule ID 11950 //
     /* 152010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 152013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 152018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 152021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 152024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 152028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 152031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 152033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152035 */     GIR_RootConstrainSelectedInstOperands,
     /* 152036 */     // GIR_Coverage, 11950,
     /* 152036 */     GIR_EraseRootFromParent_Done,
     /* 152037 */   // Label 3011: @152037
     /* 152037 */   GIM_Reject,
     /* 152038 */ // Label 2692: @152038
     /* 152038 */ GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(198352),
     /* 152043 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 152046 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(152230), // Rule ID 2568 //
     /* 152051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152100 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152103 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152112 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152129 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152133 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152137 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152141 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152145 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152149 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152154 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152158 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152162 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152166 */     // MIs[5] Operand 1
     /* 152166 */     // No operand predicates
     /* 152166 */     // MIs[3] Operand 2
     /* 152166 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 152177 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152181 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 152183 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152195 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 152214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 152225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 152228 */     GIR_RootConstrainSelectedInstOperands,
     /* 152229 */     // GIR_Coverage, 2568,
     /* 152229 */     GIR_EraseRootFromParent_Done,
     /* 152230 */   // Label 3013: @152230
     /* 152230 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(152414), // Rule ID 6261 //
     /* 152235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152284 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152287 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152296 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152313 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152317 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152321 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152325 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152329 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152333 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152338 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152342 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152346 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152350 */     // MIs[5] Operand 1
     /* 152350 */     // No operand predicates
     /* 152350 */     // MIs[3] Operand 2
     /* 152350 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 152361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152365 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 152367 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152379 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 152398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 152409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 152412 */     GIR_RootConstrainSelectedInstOperands,
     /* 152413 */     // GIR_Coverage, 6261,
     /* 152413 */     GIR_EraseRootFromParent_Done,
     /* 152414 */   // Label 3014: @152414
     /* 152414 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(152554), // Rule ID 2057 //
     /* 152419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152464 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152488 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152492 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152496 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152501 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152505 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152509 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152513 */     // MIs[4] Operand 1
     /* 152513 */     // No operand predicates
     /* 152513 */     // MIs[2] Operand 2
     /* 152513 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 152524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152526 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 152533 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 152536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152552 */     GIR_RootConstrainSelectedInstOperands,
     /* 152553 */     // GIR_Coverage, 2057,
     /* 152553 */     GIR_EraseRootFromParent_Done,
     /* 152554 */   // Label 3015: @152554
     /* 152554 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152694), // Rule ID 2064 //
     /* 152559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152592 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152595 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152604 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152632 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152636 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152649 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152653 */     // MIs[4] Operand 1
     /* 152653 */     // No operand predicates
     /* 152653 */     // MIs[2] Operand 2
     /* 152653 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 152664 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 152673 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 152676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152692 */     GIR_RootConstrainSelectedInstOperands,
     /* 152693 */     // GIR_Coverage, 2064,
     /* 152693 */     GIR_EraseRootFromParent_Done,
     /* 152694 */   // Label 3016: @152694
     /* 152694 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(152834), // Rule ID 2060 //
     /* 152699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152732 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152735 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152744 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152760 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152764 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152768 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152772 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152776 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152781 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152785 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152789 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152793 */     // MIs[4] Operand 1
     /* 152793 */     // No operand predicates
     /* 152793 */     // MIs[2] Operand 2
     /* 152793 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 152804 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152813 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 152816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152832 */     GIR_RootConstrainSelectedInstOperands,
     /* 152833 */     // GIR_Coverage, 2060,
     /* 152833 */     GIR_EraseRootFromParent_Done,
     /* 152834 */   // Label 3017: @152834
     /* 152834 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152974), // Rule ID 2067 //
     /* 152839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152872 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152875 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152908 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152912 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152916 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152921 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152925 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152929 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152933 */     // MIs[4] Operand 1
     /* 152933 */     // No operand predicates
     /* 152933 */     // MIs[2] Operand 2
     /* 152933 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 152944 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152953 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 152956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152972 */     GIR_RootConstrainSelectedInstOperands,
     /* 152973 */     // GIR_Coverage, 2067,
     /* 152973 */     GIR_EraseRootFromParent_Done,
     /* 152974 */   // Label 3018: @152974
     /* 152974 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(153111), // Rule ID 2055 //
     /* 152979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153024 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153057 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153061 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153066 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153070 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153074 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153078 */     // MIs[4] Operand 1
     /* 153078 */     // No operand predicates
     /* 153078 */     // MIs[2] Operand 2
     /* 153078 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153089 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153091 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 153094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153109 */     GIR_RootConstrainSelectedInstOperands,
     /* 153110 */     // GIR_Coverage, 2055,
     /* 153110 */     GIR_EraseRootFromParent_Done,
     /* 153111 */   // Label 3019: @153111
     /* 153111 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(153248), // Rule ID 2062 //
     /* 153116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153161 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153194 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153198 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153203 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153207 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153211 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153215 */     // MIs[4] Operand 1
     /* 153215 */     // No operand predicates
     /* 153215 */     // MIs[2] Operand 2
     /* 153215 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153226 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153228 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 153231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153246 */     GIR_RootConstrainSelectedInstOperands,
     /* 153247 */     // GIR_Coverage, 2062,
     /* 153247 */     GIR_EraseRootFromParent_Done,
     /* 153248 */   // Label 3020: @153248
     /* 153248 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(153385), // Rule ID 2058 //
     /* 153253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153286 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153289 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153298 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153327 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153331 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153335 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153348 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153352 */     // MIs[4] Operand 1
     /* 153352 */     // No operand predicates
     /* 153352 */     // MIs[2] Operand 2
     /* 153352 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153365 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 153368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153383 */     GIR_RootConstrainSelectedInstOperands,
     /* 153384 */     // GIR_Coverage, 2058,
     /* 153384 */     GIR_EraseRootFromParent_Done,
     /* 153385 */   // Label 3021: @153385
     /* 153385 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(153522), // Rule ID 2065 //
     /* 153390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153423 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153426 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153435 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153468 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153472 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153477 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153481 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153485 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153489 */     // MIs[4] Operand 1
     /* 153489 */     // No operand predicates
     /* 153489 */     // MIs[2] Operand 2
     /* 153489 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153502 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 153505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153520 */     GIR_RootConstrainSelectedInstOperands,
     /* 153521 */     // GIR_Coverage, 2065,
     /* 153521 */     GIR_EraseRootFromParent_Done,
     /* 153522 */   // Label 3022: @153522
     /* 153522 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(153683), // Rule ID 2569 //
     /* 153527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153576 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 153579 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153588 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 153601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153605 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153613 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153622 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153626 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153630 */     // MIs[4] Operand 1
     /* 153630 */     // No operand predicates
     /* 153630 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153636 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153648 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 153667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153681 */     GIR_RootConstrainSelectedInstOperands,
     /* 153682 */     // GIR_Coverage, 2569,
     /* 153682 */     GIR_EraseRootFromParent_Done,
     /* 153683 */   // Label 3023: @153683
     /* 153683 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(153844), // Rule ID 6262 //
     /* 153688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 153740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153749 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 153762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153774 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153787 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153791 */     // MIs[4] Operand 1
     /* 153791 */     // No operand predicates
     /* 153791 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153797 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153809 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 153828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153842 */     GIR_RootConstrainSelectedInstOperands,
     /* 153843 */     // GIR_Coverage, 6262,
     /* 153843 */     GIR_EraseRootFromParent_Done,
     /* 153844 */   // Label 3024: @153844
     /* 153844 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(153954), // Rule ID 2085 //
     /* 153849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153911 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153915 */     // MIs[3] Operand 1
     /* 153915 */     // No operand predicates
     /* 153915 */     // MIs[1] Operand 2
     /* 153915 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 153926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153935 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 153938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153952 */     GIR_RootConstrainSelectedInstOperands,
     /* 153953 */     // GIR_Coverage, 2085,
     /* 153953 */     GIR_EraseRootFromParent_Done,
     /* 153954 */   // Label 3025: @153954
     /* 153954 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(154064), // Rule ID 2088 //
     /* 153959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154021 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154025 */     // MIs[3] Operand 1
     /* 154025 */     // No operand predicates
     /* 154025 */     // MIs[1] Operand 2
     /* 154025 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 154036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154045 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 154048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154062 */     GIR_RootConstrainSelectedInstOperands,
     /* 154063 */     // GIR_Coverage, 2088,
     /* 154063 */     GIR_EraseRootFromParent_Done,
     /* 154064 */   // Label 3026: @154064
     /* 154064 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(154153), // Rule ID 1743 //
     /* 154069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154102 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154105 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154114 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154134 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 154137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154151 */     GIR_RootConstrainSelectedInstOperands,
     /* 154152 */     // GIR_Coverage, 1743,
     /* 154152 */     GIR_EraseRootFromParent_Done,
     /* 154153 */   // Label 3027: @154153
     /* 154153 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(154242), // Rule ID 1745 //
     /* 154158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154191 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154194 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154203 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154223 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 154226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154240 */     GIR_RootConstrainSelectedInstOperands,
     /* 154241 */     // GIR_Coverage, 1745,
     /* 154241 */     GIR_EraseRootFromParent_Done,
     /* 154242 */   // Label 3028: @154242
     /* 154242 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(154331), // Rule ID 1747 //
     /* 154247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154280 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154283 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154292 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 154315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154329 */     GIR_RootConstrainSelectedInstOperands,
     /* 154330 */     // GIR_Coverage, 1747,
     /* 154330 */     GIR_EraseRootFromParent_Done,
     /* 154331 */   // Label 3029: @154331
     /* 154331 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(154420), // Rule ID 1749 //
     /* 154336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154369 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154372 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154381 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154401 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 154404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154418 */     GIR_RootConstrainSelectedInstOperands,
     /* 154419 */     // GIR_Coverage, 1749,
     /* 154419 */     GIR_EraseRootFromParent_Done,
     /* 154420 */   // Label 3030: @154420
     /* 154420 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(154542), // Rule ID 6913 //
     /* 154425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154460 */     // MIs[1] Operand 2
     /* 154460 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154479 */     // MIs[2] Rn
     /* 154479 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154484 */     // MIs[2] Operand 2
     /* 154484 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 154495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154497 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 154497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 154504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154509 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154524 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154541 */     // GIR_Coverage, 6913,
     /* 154541 */     GIR_EraseRootFromParent_Done,
     /* 154542 */   // Label 3031: @154542
     /* 154542 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(154664), // Rule ID 6915 //
     /* 154547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154582 */     // MIs[1] Operand 2
     /* 154582 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154601 */     // MIs[2] Rn
     /* 154601 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154606 */     // MIs[2] Operand 2
     /* 154606 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154619 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 154619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 154626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154646 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154663 */     // GIR_Coverage, 6915,
     /* 154663 */     GIR_EraseRootFromParent_Done,
     /* 154664 */   // Label 3032: @154664
     /* 154664 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(154786), // Rule ID 6917 //
     /* 154669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 154677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 154680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 154683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 154699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154704 */     // MIs[1] Operand 2
     /* 154704 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154723 */     // MIs[2] Rn
     /* 154723 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154728 */     // MIs[2] Operand 2
     /* 154728 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 154739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154741 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 154741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 154748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154768 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154785 */     // GIR_Coverage, 6917,
     /* 154785 */     GIR_EraseRootFromParent_Done,
     /* 154786 */   // Label 3033: @154786
     /* 154786 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(154908), // Rule ID 6919 //
     /* 154791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 154796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154826 */     // MIs[1] Operand 2
     /* 154826 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154845 */     // MIs[2] Rn
     /* 154845 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154850 */     // MIs[2] Operand 2
     /* 154850 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 154861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154863 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 154863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 154870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154875 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154890 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154907 */     // GIR_Coverage, 6919,
     /* 154907 */     GIR_EraseRootFromParent_Done,
     /* 154908 */   // Label 3034: @154908
     /* 154908 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(155030), // Rule ID 6921 //
     /* 154913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 154918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154948 */     // MIs[1] Operand 2
     /* 154948 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154967 */     // MIs[2] Rn
     /* 154967 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154972 */     // MIs[2] Operand 2
     /* 154972 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154985 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 154985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 154992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155012 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155029 */     // GIR_Coverage, 6921,
     /* 155029 */     GIR_EraseRootFromParent_Done,
     /* 155030 */   // Label 3035: @155030
     /* 155030 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(155213), // Rule ID 2567 //
     /* 155035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155084 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155087 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155096 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155110 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155116 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155116 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155119 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155123 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155130 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155133 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155137 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155142 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155145 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155149 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155157 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155162 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155179 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 155198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155211 */     GIR_RootConstrainSelectedInstOperands,
     /* 155212 */     // GIR_Coverage, 2567,
     /* 155212 */     GIR_EraseRootFromParent_Done,
     /* 155213 */   // Label 3036: @155213
     /* 155213 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(155396), // Rule ID 6260 //
     /* 155218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155267 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155270 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155279 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155293 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155299 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155299 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155302 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155306 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155325 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155328 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155332 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155362 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 155381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155394 */     GIR_RootConstrainSelectedInstOperands,
     /* 155395 */     // GIR_Coverage, 6260,
     /* 155395 */     GIR_EraseRootFromParent_Done,
     /* 155396 */   // Label 3037: @155396
     /* 155396 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(155500), // Rule ID 13415 //
     /* 155401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155463 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155467 */     // MIs[3] Operand 1
     /* 155467 */     // No operand predicates
     /* 155467 */     // MIs[1] Operand 2
     /* 155467 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155484 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 155487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155498 */     GIR_RootConstrainSelectedInstOperands,
     /* 155499 */     // GIR_Coverage, 13415,
     /* 155499 */     GIR_EraseRootFromParent_Done,
     /* 155500 */   // Label 3038: @155500
     /* 155500 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(155604), // Rule ID 13418 //
     /* 155505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155567 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155571 */     // MIs[3] Operand 1
     /* 155571 */     // No operand predicates
     /* 155571 */     // MIs[1] Operand 2
     /* 155571 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155588 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 155591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155602 */     GIR_RootConstrainSelectedInstOperands,
     /* 155603 */     // GIR_Coverage, 13418,
     /* 155603 */     GIR_EraseRootFromParent_Done,
     /* 155604 */   // Label 3039: @155604
     /* 155604 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(155735), // Rule ID 2524 //
     /* 155609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155651 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155684 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155688 */     // MIs[3] Operand 1
     /* 155688 */     // No operand predicates
     /* 155688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155690 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 155690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155702 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 155721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155733 */     GIR_RootConstrainSelectedInstOperands,
     /* 155734 */     // GIR_Coverage, 2524,
     /* 155734 */     GIR_EraseRootFromParent_Done,
     /* 155735 */   // Label 3040: @155735
     /* 155735 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(155866), // Rule ID 2525 //
     /* 155740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155815 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155819 */     // MIs[3] Operand 1
     /* 155819 */     // No operand predicates
     /* 155819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155821 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 155821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155833 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 155839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 155852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155864 */     GIR_RootConstrainSelectedInstOperands,
     /* 155865 */     // GIR_Coverage, 2525,
     /* 155865 */     GIR_EraseRootFromParent_Done,
     /* 155866 */   // Label 3041: @155866
     /* 155866 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(155997), // Rule ID 2526 //
     /* 155871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155913 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155946 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155950 */     // MIs[3] Operand 1
     /* 155950 */     // No operand predicates
     /* 155950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155952 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 155952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 155955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155964 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 155970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 155983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155995 */     GIR_RootConstrainSelectedInstOperands,
     /* 155996 */     // GIR_Coverage, 2526,
     /* 155996 */     GIR_EraseRootFromParent_Done,
     /* 155997 */   // Label 3042: @155997
     /* 155997 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(156128), // Rule ID 13601 //
     /* 156002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 156013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 156019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156052 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156056 */     // MIs[2] Operand 1
     /* 156056 */     // No operand predicates
     /* 156056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156064 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156068 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156072 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156077 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156081 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156083 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156095 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 156114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156126 */     GIR_RootConstrainSelectedInstOperands,
     /* 156127 */     // GIR_Coverage, 13601,
     /* 156127 */     GIR_EraseRootFromParent_Done,
     /* 156128 */   // Label 3043: @156128
     /* 156128 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(156259), // Rule ID 13602 //
     /* 156133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156187 */     // MIs[2] Operand 1
     /* 156187 */     // No operand predicates
     /* 156187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156195 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156199 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156203 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156208 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156214 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 156214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156226 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 156232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 156245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156257 */     GIR_RootConstrainSelectedInstOperands,
     /* 156258 */     // GIR_Coverage, 13602,
     /* 156258 */     GIR_EraseRootFromParent_Done,
     /* 156259 */   // Label 3044: @156259
     /* 156259 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(156390), // Rule ID 13603 //
     /* 156264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156314 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 156318 */     // MIs[2] Operand 1
     /* 156318 */     // No operand predicates
     /* 156318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156330 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156334 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156339 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156345 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 156345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 156348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156357 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 156363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 156376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156388 */     GIR_RootConstrainSelectedInstOperands,
     /* 156389 */     // GIR_Coverage, 13603,
     /* 156389 */     GIR_EraseRootFromParent_Done,
     /* 156390 */   // Label 3045: @156390
     /* 156390 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(156504), // Rule ID 2056 //
     /* 156395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156440 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156478 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156482 */     // MIs[3] Operand 1
     /* 156482 */     // No operand predicates
     /* 156482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156484 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 156487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156502 */     GIR_RootConstrainSelectedInstOperands,
     /* 156503 */     // GIR_Coverage, 2056,
     /* 156503 */     GIR_EraseRootFromParent_Done,
     /* 156504 */   // Label 3046: @156504
     /* 156504 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(156618), // Rule ID 2063 //
     /* 156509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156542 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156545 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156554 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156592 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156596 */     // MIs[3] Operand 1
     /* 156596 */     // No operand predicates
     /* 156596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156598 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 156601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156616 */     GIR_RootConstrainSelectedInstOperands,
     /* 156617 */     // GIR_Coverage, 2063,
     /* 156617 */     GIR_EraseRootFromParent_Done,
     /* 156618 */   // Label 3047: @156618
     /* 156618 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(156732), // Rule ID 2059 //
     /* 156623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156656 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156659 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156668 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156710 */     // MIs[3] Operand 1
     /* 156710 */     // No operand predicates
     /* 156710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156712 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 156715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156730 */     GIR_RootConstrainSelectedInstOperands,
     /* 156731 */     // GIR_Coverage, 2059,
     /* 156731 */     GIR_EraseRootFromParent_Done,
     /* 156732 */   // Label 3048: @156732
     /* 156732 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(156846), // Rule ID 2066 //
     /* 156737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156770 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156773 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156782 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156820 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156824 */     // MIs[3] Operand 1
     /* 156824 */     // No operand predicates
     /* 156824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156826 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 156829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156844 */     GIR_RootConstrainSelectedInstOperands,
     /* 156845 */     // GIR_Coverage, 2066,
     /* 156845 */     GIR_EraseRootFromParent_Done,
     /* 156846 */   // Label 3049: @156846
     /* 156846 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(156960), // Rule ID 2061 //
     /* 156851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156884 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156887 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 156892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 156896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 156900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156938 */     // MIs[3] Operand 1
     /* 156938 */     // No operand predicates
     /* 156938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156940 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 156943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156958 */     GIR_RootConstrainSelectedInstOperands,
     /* 156959 */     // GIR_Coverage, 2061,
     /* 156959 */     GIR_EraseRootFromParent_Done,
     /* 156960 */   // Label 3050: @156960
     /* 156960 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(157074), // Rule ID 2068 //
     /* 156965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156998 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157001 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 157006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 157010 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 157014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157048 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157052 */     // MIs[3] Operand 1
     /* 157052 */     // No operand predicates
     /* 157052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157054 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 157057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157072 */     GIR_RootConstrainSelectedInstOperands,
     /* 157073 */     // GIR_Coverage, 2068,
     /* 157073 */     GIR_EraseRootFromParent_Done,
     /* 157074 */   // Label 3051: @157074
     /* 157074 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(157178), // Rule ID 1987 //
     /* 157079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157145 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157149 */     // MIs[3] Operand 1
     /* 157149 */     // No operand predicates
     /* 157149 */     // MIs[1] Operand 2
     /* 157149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157162 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 157165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157176 */     GIR_RootConstrainSelectedInstOperands,
     /* 157177 */     // GIR_Coverage, 1987,
     /* 157177 */     GIR_EraseRootFromParent_Done,
     /* 157178 */   // Label 3052: @157178
     /* 157178 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(157282), // Rule ID 2017 //
     /* 157183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157249 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157253 */     // MIs[3] Operand 1
     /* 157253 */     // No operand predicates
     /* 157253 */     // MIs[1] Operand 2
     /* 157253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157266 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 157269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157280 */     GIR_RootConstrainSelectedInstOperands,
     /* 157281 */     // GIR_Coverage, 2017,
     /* 157281 */     GIR_EraseRootFromParent_Done,
     /* 157282 */   // Label 3053: @157282
     /* 157282 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(157386), // Rule ID 2024 //
     /* 157287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157353 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157357 */     // MIs[3] Operand 1
     /* 157357 */     // No operand predicates
     /* 157357 */     // MIs[1] Operand 2
     /* 157357 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157370 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 157373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157384 */     GIR_RootConstrainSelectedInstOperands,
     /* 157385 */     // GIR_Coverage, 2024,
     /* 157385 */     GIR_EraseRootFromParent_Done,
     /* 157386 */   // Label 3054: @157386
     /* 157386 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(157490), // Rule ID 2083 //
     /* 157391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157461 */     // MIs[3] Operand 1
     /* 157461 */     // No operand predicates
     /* 157461 */     // MIs[1] Operand 2
     /* 157461 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157474 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 157477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157488 */     GIR_RootConstrainSelectedInstOperands,
     /* 157489 */     // GIR_Coverage, 2083,
     /* 157489 */     GIR_EraseRootFromParent_Done,
     /* 157490 */   // Label 3055: @157490
     /* 157490 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(157594), // Rule ID 1990 //
     /* 157495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157561 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157565 */     // MIs[3] Operand 1
     /* 157565 */     // No operand predicates
     /* 157565 */     // MIs[1] Operand 2
     /* 157565 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157578 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 157581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157592 */     GIR_RootConstrainSelectedInstOperands,
     /* 157593 */     // GIR_Coverage, 1990,
     /* 157593 */     GIR_EraseRootFromParent_Done,
     /* 157594 */   // Label 3056: @157594
     /* 157594 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(157698), // Rule ID 2020 //
     /* 157599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157648 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157665 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157669 */     // MIs[3] Operand 1
     /* 157669 */     // No operand predicates
     /* 157669 */     // MIs[1] Operand 2
     /* 157669 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157682 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 157685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157696 */     GIR_RootConstrainSelectedInstOperands,
     /* 157697 */     // GIR_Coverage, 2020,
     /* 157697 */     GIR_EraseRootFromParent_Done,
     /* 157698 */   // Label 3057: @157698
     /* 157698 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(157802), // Rule ID 2027 //
     /* 157703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157769 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157773 */     // MIs[3] Operand 1
     /* 157773 */     // No operand predicates
     /* 157773 */     // MIs[1] Operand 2
     /* 157773 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157786 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 157789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157800 */     GIR_RootConstrainSelectedInstOperands,
     /* 157801 */     // GIR_Coverage, 2027,
     /* 157801 */     GIR_EraseRootFromParent_Done,
     /* 157802 */   // Label 3058: @157802
     /* 157802 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(157906), // Rule ID 2086 //
     /* 157807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157856 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157865 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157869 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157873 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157877 */     // MIs[3] Operand 1
     /* 157877 */     // No operand predicates
     /* 157877 */     // MIs[1] Operand 2
     /* 157877 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157890 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 157893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157904 */     GIR_RootConstrainSelectedInstOperands,
     /* 157905 */     // GIR_Coverage, 2086,
     /* 157905 */     GIR_EraseRootFromParent_Done,
     /* 157906 */   // Label 3059: @157906
     /* 157906 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(157963), // Rule ID 1751 //
     /* 157911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 157939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 157946 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 157946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 157949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 157956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 157961 */     GIR_RootConstrainSelectedInstOperands,
     /* 157962 */     // GIR_Coverage, 1751,
     /* 157962 */     GIR_EraseRootFromParent_Done,
     /* 157963 */   // Label 3060: @157963
     /* 157963 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(158020), // Rule ID 1753 //
     /* 157968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 157996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 158003 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 158003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 158006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 158013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 158018 */     GIR_RootConstrainSelectedInstOperands,
     /* 158019 */     // GIR_Coverage, 1753,
     /* 158019 */     GIR_EraseRootFromParent_Done,
     /* 158020 */   // Label 3061: @158020
     /* 158020 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(158130), // Rule ID 6279 //
     /* 158025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 158030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 158051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158064 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 158075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158083 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 158087 */     // MIs[2] Operand 1
     /* 158087 */     // No operand predicates
     /* 158087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158089 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 158089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158101 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 158120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 158128 */     GIR_RootConstrainSelectedInstOperands,
     /* 158129 */     // GIR_Coverage, 6279,
     /* 158129 */     GIR_EraseRootFromParent_Done,
     /* 158130 */   // Label 3062: @158130
     /* 158130 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(158227), // Rule ID 13872 //
     /* 158135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158177 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158187 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 158187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158199 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 158205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 158218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158225 */     GIR_RootConstrainSelectedInstOperands,
     /* 158226 */     // GIR_Coverage, 13872,
     /* 158226 */     GIR_EraseRootFromParent_Done,
     /* 158227 */   // Label 3063: @158227
     /* 158227 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(158324), // Rule ID 13873 //
     /* 158232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158274 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158284 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 158284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158296 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 158302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 158315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158322 */     GIR_RootConstrainSelectedInstOperands,
     /* 158323 */     // GIR_Coverage, 13873,
     /* 158323 */     GIR_EraseRootFromParent_Done,
     /* 158324 */   // Label 3064: @158324
     /* 158324 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(158421), // Rule ID 13874 //
     /* 158329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158371 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158381 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 158381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158393 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 158399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 158412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158419 */     GIR_RootConstrainSelectedInstOperands,
     /* 158420 */     // GIR_Coverage, 13874,
     /* 158420 */     GIR_EraseRootFromParent_Done,
     /* 158421 */   // Label 3065: @158421
     /* 158421 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(158504), // Rule ID 1742 //
     /* 158426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158459 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158462 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158471 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158487 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 158487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 158490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158502 */     GIR_RootConstrainSelectedInstOperands,
     /* 158503 */     // GIR_Coverage, 1742,
     /* 158503 */     GIR_EraseRootFromParent_Done,
     /* 158504 */   // Label 3066: @158504
     /* 158504 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(158587), // Rule ID 1744 //
     /* 158509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158542 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158545 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158554 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158570 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 158570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 158573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158585 */     GIR_RootConstrainSelectedInstOperands,
     /* 158586 */     // GIR_Coverage, 1744,
     /* 158586 */     GIR_EraseRootFromParent_Done,
     /* 158587 */   // Label 3067: @158587
     /* 158587 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(158670), // Rule ID 1746 //
     /* 158592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158625 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158628 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158637 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158653 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 158653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 158656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158668 */     GIR_RootConstrainSelectedInstOperands,
     /* 158669 */     // GIR_Coverage, 1746,
     /* 158669 */     GIR_EraseRootFromParent_Done,
     /* 158670 */   // Label 3068: @158670
     /* 158670 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(158753), // Rule ID 1748 //
     /* 158675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158708 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158711 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158736 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 158736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 158739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158751 */     GIR_RootConstrainSelectedInstOperands,
     /* 158752 */     // GIR_Coverage, 1748,
     /* 158752 */     GIR_EraseRootFromParent_Done,
     /* 158753 */   // Label 3069: @158753
     /* 158753 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(158833), // Rule ID 5237 //
     /* 158758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158788 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158791 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 158796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158800 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 158804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158816 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 158816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 158819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158831 */     GIR_RootConstrainSelectedInstOperands,
     /* 158832 */     // GIR_Coverage, 5237,
     /* 158832 */     GIR_EraseRootFromParent_Done,
     /* 158833 */   // Label 3070: @158833
     /* 158833 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(158913), // Rule ID 5238 //
     /* 158838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158868 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158871 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 158876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158880 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 158884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158896 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 158896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 158899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158911 */     GIR_RootConstrainSelectedInstOperands,
     /* 158912 */     // GIR_Coverage, 5238,
     /* 158912 */     GIR_EraseRootFromParent_Done,
     /* 158913 */   // Label 3071: @158913
     /* 158913 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(159010), // Rule ID 5234 //
     /* 158918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158964 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158970 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 158970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158982 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 158988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 159001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159008 */     GIR_RootConstrainSelectedInstOperands,
     /* 159009 */     // GIR_Coverage, 5234,
     /* 159009 */     GIR_EraseRootFromParent_Done,
     /* 159010 */   // Label 3072: @159010
     /* 159010 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(159107), // Rule ID 5235 //
     /* 159015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159061 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159067 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 159067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159079 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 159085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 159098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159105 */     GIR_RootConstrainSelectedInstOperands,
     /* 159106 */     // GIR_Coverage, 5235,
     /* 159106 */     GIR_EraseRootFromParent_Done,
     /* 159107 */   // Label 3073: @159107
     /* 159107 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(159204), // Rule ID 5236 //
     /* 159112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159158 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159164 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 159164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 159167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159176 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 159182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 159195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159202 */     GIR_RootConstrainSelectedInstOperands,
     /* 159203 */     // GIR_Coverage, 5236,
     /* 159203 */     GIR_EraseRootFromParent_Done,
     /* 159204 */   // Label 3074: @159204
     /* 159204 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(159285), // Rule ID 13416 //
     /* 159209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159259 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159263 */     // MIs[2] Operand 1
     /* 159263 */     // No operand predicates
     /* 159263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159269 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 159272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159283 */     GIR_RootConstrainSelectedInstOperands,
     /* 159284 */     // GIR_Coverage, 13416,
     /* 159284 */     GIR_EraseRootFromParent_Done,
     /* 159285 */   // Label 3075: @159285
     /* 159285 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(159366), // Rule ID 13417 //
     /* 159290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 159307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159340 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159344 */     // MIs[2] Operand 1
     /* 159344 */     // No operand predicates
     /* 159344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159350 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 159353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159364 */     GIR_RootConstrainSelectedInstOperands,
     /* 159365 */     // GIR_Coverage, 13417,
     /* 159365 */     GIR_EraseRootFromParent_Done,
     /* 159366 */   // Label 3076: @159366
     /* 159366 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(159447), // Rule ID 13419 //
     /* 159371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159421 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159425 */     // MIs[2] Operand 1
     /* 159425 */     // No operand predicates
     /* 159425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159431 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 159434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159445 */     GIR_RootConstrainSelectedInstOperands,
     /* 159446 */     // GIR_Coverage, 13419,
     /* 159446 */     GIR_EraseRootFromParent_Done,
     /* 159447 */   // Label 3077: @159447
     /* 159447 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(159528), // Rule ID 13420 //
     /* 159452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159506 */     // MIs[2] Operand 1
     /* 159506 */     // No operand predicates
     /* 159506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159512 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 159515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159526 */     GIR_RootConstrainSelectedInstOperands,
     /* 159527 */     // GIR_Coverage, 13420,
     /* 159527 */     GIR_EraseRootFromParent_Done,
     /* 159528 */   // Label 3078: @159528
     /* 159528 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159609), // Rule ID 13421 //
     /* 159533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 159562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 159587 */     // MIs[2] Operand 1
     /* 159587 */     // No operand predicates
     /* 159587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159593 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 159596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159607 */     GIR_RootConstrainSelectedInstOperands,
     /* 159608 */     // GIR_Coverage, 13421,
     /* 159608 */     GIR_EraseRootFromParent_Done,
     /* 159609 */   // Label 3079: @159609
     /* 159609 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159690), // Rule ID 13422 //
     /* 159614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 159631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159664 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159668 */     // MIs[2] Operand 1
     /* 159668 */     // No operand predicates
     /* 159668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159674 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 159677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159688 */     GIR_RootConstrainSelectedInstOperands,
     /* 159689 */     // GIR_Coverage, 13422,
     /* 159689 */     GIR_EraseRootFromParent_Done,
     /* 159690 */   // Label 3080: @159690
     /* 159690 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(159771), // Rule ID 13423 //
     /* 159695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159745 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159749 */     // MIs[2] Operand 1
     /* 159749 */     // No operand predicates
     /* 159749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159755 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 159758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159769 */     GIR_RootConstrainSelectedInstOperands,
     /* 159770 */     // GIR_Coverage, 13423,
     /* 159770 */     GIR_EraseRootFromParent_Done,
     /* 159771 */   // Label 3081: @159771
     /* 159771 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(159852), // Rule ID 13424 //
     /* 159776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 159830 */     // MIs[2] Operand 1
     /* 159830 */     // No operand predicates
     /* 159830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159836 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 159839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159850 */     GIR_RootConstrainSelectedInstOperands,
     /* 159851 */     // GIR_Coverage, 13424,
     /* 159851 */     GIR_EraseRootFromParent_Done,
     /* 159852 */   // Label 3082: @159852
     /* 159852 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(159958), // Rule ID 6276 //
     /* 159857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 159883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 159887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159892 */     // MIs[1] Operand 2
     /* 159892 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 159903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 159907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159911 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 159915 */     // MIs[2] Operand 1
     /* 159915 */     // No operand predicates
     /* 159915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159917 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 159917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159929 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 159935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 159948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 159956 */     GIR_RootConstrainSelectedInstOperands,
     /* 159957 */     // GIR_Coverage, 6276,
     /* 159957 */     GIR_EraseRootFromParent_Done,
     /* 159958 */   // Label 3083: @159958
     /* 159958 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(160039), // Rule ID 1988 //
     /* 159963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160017 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160021 */     // MIs[2] Operand 1
     /* 160021 */     // No operand predicates
     /* 160021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160023 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 160026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160037 */     GIR_RootConstrainSelectedInstOperands,
     /* 160038 */     // GIR_Coverage, 1988,
     /* 160038 */     GIR_EraseRootFromParent_Done,
     /* 160039 */   // Label 3084: @160039
     /* 160039 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(160120), // Rule ID 1989 //
     /* 160044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160098 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160102 */     // MIs[2] Operand 1
     /* 160102 */     // No operand predicates
     /* 160102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160104 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 160107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160118 */     GIR_RootConstrainSelectedInstOperands,
     /* 160119 */     // GIR_Coverage, 1989,
     /* 160119 */     GIR_EraseRootFromParent_Done,
     /* 160120 */   // Label 3085: @160120
     /* 160120 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(160201), // Rule ID 2018 //
     /* 160125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160179 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160183 */     // MIs[2] Operand 1
     /* 160183 */     // No operand predicates
     /* 160183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160185 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 160188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160199 */     GIR_RootConstrainSelectedInstOperands,
     /* 160200 */     // GIR_Coverage, 2018,
     /* 160200 */     GIR_EraseRootFromParent_Done,
     /* 160201 */   // Label 3086: @160201
     /* 160201 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(160282), // Rule ID 2019 //
     /* 160206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160260 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160264 */     // MIs[2] Operand 1
     /* 160264 */     // No operand predicates
     /* 160264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160266 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 160269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160280 */     GIR_RootConstrainSelectedInstOperands,
     /* 160281 */     // GIR_Coverage, 2019,
     /* 160281 */     GIR_EraseRootFromParent_Done,
     /* 160282 */   // Label 3087: @160282
     /* 160282 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(160363), // Rule ID 2025 //
     /* 160287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160345 */     // MIs[2] Operand 1
     /* 160345 */     // No operand predicates
     /* 160345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160347 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 160350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160361 */     GIR_RootConstrainSelectedInstOperands,
     /* 160362 */     // GIR_Coverage, 2025,
     /* 160362 */     GIR_EraseRootFromParent_Done,
     /* 160363 */   // Label 3088: @160363
     /* 160363 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(160444), // Rule ID 2026 //
     /* 160368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160426 */     // MIs[2] Operand 1
     /* 160426 */     // No operand predicates
     /* 160426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160428 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 160431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160442 */     GIR_RootConstrainSelectedInstOperands,
     /* 160443 */     // GIR_Coverage, 2026,
     /* 160443 */     GIR_EraseRootFromParent_Done,
     /* 160444 */   // Label 3089: @160444
     /* 160444 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(160525), // Rule ID 2084 //
     /* 160449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160507 */     // MIs[2] Operand 1
     /* 160507 */     // No operand predicates
     /* 160507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160509 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 160512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160523 */     GIR_RootConstrainSelectedInstOperands,
     /* 160524 */     // GIR_Coverage, 2084,
     /* 160524 */     GIR_EraseRootFromParent_Done,
     /* 160525 */   // Label 3090: @160525
     /* 160525 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160606), // Rule ID 1991 //
     /* 160530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160584 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160588 */     // MIs[2] Operand 1
     /* 160588 */     // No operand predicates
     /* 160588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160590 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 160593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160604 */     GIR_RootConstrainSelectedInstOperands,
     /* 160605 */     // GIR_Coverage, 1991,
     /* 160605 */     GIR_EraseRootFromParent_Done,
     /* 160606 */   // Label 3091: @160606
     /* 160606 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160687), // Rule ID 1992 //
     /* 160611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160665 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160669 */     // MIs[2] Operand 1
     /* 160669 */     // No operand predicates
     /* 160669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160671 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 160674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160685 */     GIR_RootConstrainSelectedInstOperands,
     /* 160686 */     // GIR_Coverage, 1992,
     /* 160686 */     GIR_EraseRootFromParent_Done,
     /* 160687 */   // Label 3092: @160687
     /* 160687 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160768), // Rule ID 2021 //
     /* 160692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160750 */     // MIs[2] Operand 1
     /* 160750 */     // No operand predicates
     /* 160750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160752 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 160755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160766 */     GIR_RootConstrainSelectedInstOperands,
     /* 160767 */     // GIR_Coverage, 2021,
     /* 160767 */     GIR_EraseRootFromParent_Done,
     /* 160768 */   // Label 3093: @160768
     /* 160768 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160849), // Rule ID 2022 //
     /* 160773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160831 */     // MIs[2] Operand 1
     /* 160831 */     // No operand predicates
     /* 160831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160833 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 160836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160847 */     GIR_RootConstrainSelectedInstOperands,
     /* 160848 */     // GIR_Coverage, 2022,
     /* 160848 */     GIR_EraseRootFromParent_Done,
     /* 160849 */   // Label 3094: @160849
     /* 160849 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160930), // Rule ID 2028 //
     /* 160854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160912 */     // MIs[2] Operand 1
     /* 160912 */     // No operand predicates
     /* 160912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160914 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 160917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160928 */     GIR_RootConstrainSelectedInstOperands,
     /* 160929 */     // GIR_Coverage, 2028,
     /* 160929 */     GIR_EraseRootFromParent_Done,
     /* 160930 */   // Label 3095: @160930
     /* 160930 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(161011), // Rule ID 2029 //
     /* 160935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160993 */     // MIs[2] Operand 1
     /* 160993 */     // No operand predicates
     /* 160993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160995 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 160998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161009 */     GIR_RootConstrainSelectedInstOperands,
     /* 161010 */     // GIR_Coverage, 2029,
     /* 161010 */     GIR_EraseRootFromParent_Done,
     /* 161011 */   // Label 3096: @161011
     /* 161011 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(161092), // Rule ID 2087 //
     /* 161016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 161024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161074 */     // MIs[2] Operand 1
     /* 161074 */     // No operand predicates
     /* 161074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161076 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 161079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161090 */     GIR_RootConstrainSelectedInstOperands,
     /* 161091 */     // GIR_Coverage, 2087,
     /* 161091 */     GIR_EraseRootFromParent_Done,
     /* 161092 */   // Label 3097: @161092
     /* 161092 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(161173), // Rule ID 1993 //
     /* 161097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 161130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161155 */     // MIs[2] Operand 1
     /* 161155 */     // No operand predicates
     /* 161155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161157 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 161160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161171 */     GIR_RootConstrainSelectedInstOperands,
     /* 161172 */     // GIR_Coverage, 1993,
     /* 161172 */     GIR_EraseRootFromParent_Done,
     /* 161173 */   // Label 3098: @161173
     /* 161173 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(161254), // Rule ID 1994 //
     /* 161178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 161189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161232 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161236 */     // MIs[2] Operand 1
     /* 161236 */     // No operand predicates
     /* 161236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161238 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 161241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161252 */     GIR_RootConstrainSelectedInstOperands,
     /* 161253 */     // GIR_Coverage, 1994,
     /* 161253 */     GIR_EraseRootFromParent_Done,
     /* 161254 */   // Label 3099: @161254
     /* 161254 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(161335), // Rule ID 1995 //
     /* 161259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161317 */     // MIs[2] Operand 1
     /* 161317 */     // No operand predicates
     /* 161317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161319 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 161322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161333 */     GIR_RootConstrainSelectedInstOperands,
     /* 161334 */     // GIR_Coverage, 1995,
     /* 161334 */     GIR_EraseRootFromParent_Done,
     /* 161335 */   // Label 3100: @161335
     /* 161335 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(161416), // Rule ID 1996 //
     /* 161340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161398 */     // MIs[2] Operand 1
     /* 161398 */     // No operand predicates
     /* 161398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161400 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 161403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161414 */     GIR_RootConstrainSelectedInstOperands,
     /* 161415 */     // GIR_Coverage, 1996,
     /* 161415 */     GIR_EraseRootFromParent_Done,
     /* 161416 */   // Label 3101: @161416
     /* 161416 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(161497), // Rule ID 2023 //
     /* 161421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161479 */     // MIs[2] Operand 1
     /* 161479 */     // No operand predicates
     /* 161479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161481 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 161484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161495 */     GIR_RootConstrainSelectedInstOperands,
     /* 161496 */     // GIR_Coverage, 2023,
     /* 161496 */     GIR_EraseRootFromParent_Done,
     /* 161497 */   // Label 3102: @161497
     /* 161497 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(161578), // Rule ID 2030 //
     /* 161502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161560 */     // MIs[2] Operand 1
     /* 161560 */     // No operand predicates
     /* 161560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161562 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 161565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161576 */     GIR_RootConstrainSelectedInstOperands,
     /* 161577 */     // GIR_Coverage, 2030,
     /* 161577 */     GIR_EraseRootFromParent_Done,
     /* 161578 */   // Label 3103: @161578
     /* 161578 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(161656), // Rule ID 6263 //
     /* 161583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 161588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161634 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161638 */     // MIs[2] Operand 1
     /* 161638 */     // No operand predicates
     /* 161638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161640 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 161640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 161643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 161651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161654 */     GIR_RootConstrainSelectedInstOperands,
     /* 161655 */     // GIR_Coverage, 6263,
     /* 161655 */     GIR_EraseRootFromParent_Done,
     /* 161656 */   // Label 3104: @161656
     /* 161656 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161716), // Rule ID 6329 //
     /* 161661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 161687 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 161687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 161690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 161707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161714 */     GIR_RootConstrainSelectedInstOperands,
     /* 161715 */     // GIR_Coverage, 6329,
     /* 161715 */     GIR_EraseRootFromParent_Done,
     /* 161716 */   // Label 3105: @161716
     /* 161716 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(161776), // Rule ID 6330 //
     /* 161721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 161747 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 161747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161759 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 161767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161774 */     GIR_RootConstrainSelectedInstOperands,
     /* 161775 */     // GIR_Coverage, 6330,
     /* 161775 */     GIR_EraseRootFromParent_Done,
     /* 161776 */   // Label 3106: @161776
     /* 161776 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(161836), // Rule ID 6331 //
     /* 161781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 161807 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 161807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 161810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161819 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 161827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161834 */     GIR_RootConstrainSelectedInstOperands,
     /* 161835 */     // GIR_Coverage, 6331,
     /* 161835 */     GIR_EraseRootFromParent_Done,
     /* 161836 */   // Label 3107: @161836
     /* 161836 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161883), // Rule ID 3897 //
     /* 161841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161863 */     // MIs[0] Operand 3
     /* 161863 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 161874 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 161877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161881 */     GIR_RootConstrainSelectedInstOperands,
     /* 161882 */     // GIR_Coverage, 3897,
     /* 161882 */     GIR_EraseRootFromParent_Done,
     /* 161883 */   // Label 3108: @161883
     /* 161883 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161930), // Rule ID 3898 //
     /* 161888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161910 */     // MIs[0] Operand 3
     /* 161910 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 161921 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 161924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161928 */     GIR_RootConstrainSelectedInstOperands,
     /* 161929 */     // GIR_Coverage, 3898,
     /* 161929 */     GIR_EraseRootFromParent_Done,
     /* 161930 */   // Label 3109: @161930
     /* 161930 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161977), // Rule ID 3899 //
     /* 161935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161957 */     // MIs[0] Operand 3
     /* 161957 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 161968 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 161971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161975 */     GIR_RootConstrainSelectedInstOperands,
     /* 161976 */     // GIR_Coverage, 3899,
     /* 161976 */     GIR_EraseRootFromParent_Done,
     /* 161977 */   // Label 3110: @161977
     /* 161977 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(162024), // Rule ID 3900 //
     /* 161982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162004 */     // MIs[0] Operand 3
     /* 162004 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 162015 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 162018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162022 */     GIR_RootConstrainSelectedInstOperands,
     /* 162023 */     // GIR_Coverage, 3900,
     /* 162023 */     GIR_EraseRootFromParent_Done,
     /* 162024 */   // Label 3111: @162024
     /* 162024 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(162070), // Rule ID 3544 //
     /* 162029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 162040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 162043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162051 */     // MIs[0] Idx
     /* 162051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 162059 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 162059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 162062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162068 */     GIR_RootConstrainSelectedInstOperands,
     /* 162069 */     // GIR_Coverage, 3544,
     /* 162069 */     GIR_EraseRootFromParent_Done,
     /* 162070 */   // Label 3112: @162070
     /* 162070 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(162116), // Rule ID 3545 //
     /* 162075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 162086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 162089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162097 */     // MIs[0] Idx
     /* 162097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162100 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 162105 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 162105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 162108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162114 */     GIR_RootConstrainSelectedInstOperands,
     /* 162115 */     // GIR_Coverage, 3545,
     /* 162115 */     GIR_EraseRootFromParent_Done,
     /* 162116 */   // Label 3113: @162116
     /* 162116 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(162162), // Rule ID 3546 //
     /* 162121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 162132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 162135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162143 */     // MIs[0] Idx
     /* 162143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 162151 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 162151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 162154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162160 */     GIR_RootConstrainSelectedInstOperands,
     /* 162161 */     // GIR_Coverage, 3546,
     /* 162161 */     GIR_EraseRootFromParent_Done,
     /* 162162 */   // Label 3114: @162162
     /* 162162 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(162208), // Rule ID 3547 //
     /* 162167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 162178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 162181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162189 */     // MIs[0] Idx
     /* 162189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 162197 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 162197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 162200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162206 */     GIR_RootConstrainSelectedInstOperands,
     /* 162207 */     // GIR_Coverage, 3547,
     /* 162207 */     GIR_EraseRootFromParent_Done,
     /* 162208 */   // Label 3115: @162208
     /* 162208 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(162264), // Rule ID 2109 //
     /* 162213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 162221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162250 */     // MIs[1] Operand 1
     /* 162250 */     // No operand predicates
     /* 162250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162252 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 162255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162262 */     GIR_RootConstrainSelectedInstOperands,
     /* 162263 */     // GIR_Coverage, 2109,
     /* 162263 */     GIR_EraseRootFromParent_Done,
     /* 162264 */   // Label 3116: @162264
     /* 162264 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(162320), // Rule ID 2110 //
     /* 162269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 162277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162306 */     // MIs[1] Operand 1
     /* 162306 */     // No operand predicates
     /* 162306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162308 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 162311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162318 */     GIR_RootConstrainSelectedInstOperands,
     /* 162319 */     // GIR_Coverage, 2110,
     /* 162319 */     GIR_EraseRootFromParent_Done,
     /* 162320 */   // Label 3117: @162320
     /* 162320 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(162376), // Rule ID 2115 //
     /* 162325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 162333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162362 */     // MIs[1] Operand 1
     /* 162362 */     // No operand predicates
     /* 162362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162364 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 162367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162374 */     GIR_RootConstrainSelectedInstOperands,
     /* 162375 */     // GIR_Coverage, 2115,
     /* 162375 */     GIR_EraseRootFromParent_Done,
     /* 162376 */   // Label 3118: @162376
     /* 162376 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(162432), // Rule ID 2116 //
     /* 162381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 162389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162418 */     // MIs[1] Operand 1
     /* 162418 */     // No operand predicates
     /* 162418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162420 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 162423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162430 */     GIR_RootConstrainSelectedInstOperands,
     /* 162431 */     // GIR_Coverage, 2116,
     /* 162431 */     GIR_EraseRootFromParent_Done,
     /* 162432 */   // Label 3119: @162432
     /* 162432 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(162488), // Rule ID 2123 //
     /* 162437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 162445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162474 */     // MIs[1] Operand 1
     /* 162474 */     // No operand predicates
     /* 162474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162476 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 162479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162486 */     GIR_RootConstrainSelectedInstOperands,
     /* 162487 */     // GIR_Coverage, 2123,
     /* 162487 */     GIR_EraseRootFromParent_Done,
     /* 162488 */   // Label 3120: @162488
     /* 162488 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(162544), // Rule ID 2126 //
     /* 162493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 162501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162530 */     // MIs[1] Operand 1
     /* 162530 */     // No operand predicates
     /* 162530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162532 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 162535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162542 */     GIR_RootConstrainSelectedInstOperands,
     /* 162543 */     // GIR_Coverage, 2126,
     /* 162543 */     GIR_EraseRootFromParent_Done,
     /* 162544 */   // Label 3121: @162544
     /* 162544 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(162600), // Rule ID 2148 //
     /* 162549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 162560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 162586 */     // MIs[1] Operand 1
     /* 162586 */     // No operand predicates
     /* 162586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162588 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 162591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162598 */     GIR_RootConstrainSelectedInstOperands,
     /* 162599 */     // GIR_Coverage, 2148,
     /* 162599 */     GIR_EraseRootFromParent_Done,
     /* 162600 */   // Label 3122: @162600
     /* 162600 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(162656), // Rule ID 2150 //
     /* 162605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 162642 */     // MIs[1] Operand 1
     /* 162642 */     // No operand predicates
     /* 162642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162644 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 162647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162654 */     GIR_RootConstrainSelectedInstOperands,
     /* 162655 */     // GIR_Coverage, 2150,
     /* 162655 */     GIR_EraseRootFromParent_Done,
     /* 162656 */   // Label 3123: @162656
     /* 162656 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(162712), // Rule ID 2152 //
     /* 162661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 162698 */     // MIs[1] Operand 1
     /* 162698 */     // No operand predicates
     /* 162698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162700 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 162703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162710 */     GIR_RootConstrainSelectedInstOperands,
     /* 162711 */     // GIR_Coverage, 2152,
     /* 162711 */     GIR_EraseRootFromParent_Done,
     /* 162712 */   // Label 3124: @162712
     /* 162712 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(162765), // Rule ID 6264 //
     /* 162717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162751 */     // MIs[1] Operand 1
     /* 162751 */     // No operand predicates
     /* 162751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162753 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 162756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162763 */     GIR_RootConstrainSelectedInstOperands,
     /* 162764 */     // GIR_Coverage, 6264,
     /* 162764 */     GIR_EraseRootFromParent_Done,
     /* 162765 */   // Label 3125: @162765
     /* 162765 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(162818), // Rule ID 6265 //
     /* 162770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162804 */     // MIs[1] Operand 1
     /* 162804 */     // No operand predicates
     /* 162804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162806 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 162809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162816 */     GIR_RootConstrainSelectedInstOperands,
     /* 162817 */     // GIR_Coverage, 6265,
     /* 162817 */     GIR_EraseRootFromParent_Done,
     /* 162818 */   // Label 3126: @162818
     /* 162818 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(162871), // Rule ID 6266 //
     /* 162823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162857 */     // MIs[1] Operand 1
     /* 162857 */     // No operand predicates
     /* 162857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162859 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 162862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162869 */     GIR_RootConstrainSelectedInstOperands,
     /* 162870 */     // GIR_Coverage, 6266,
     /* 162870 */     GIR_EraseRootFromParent_Done,
     /* 162871 */   // Label 3127: @162871
     /* 162871 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(162924), // Rule ID 6267 //
     /* 162876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162910 */     // MIs[1] Operand 1
     /* 162910 */     // No operand predicates
     /* 162910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162912 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 162915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162922 */     GIR_RootConstrainSelectedInstOperands,
     /* 162923 */     // GIR_Coverage, 6267,
     /* 162923 */     GIR_EraseRootFromParent_Done,
     /* 162924 */   // Label 3128: @162924
     /* 162924 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162977), // Rule ID 6268 //
     /* 162929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162963 */     // MIs[1] Operand 1
     /* 162963 */     // No operand predicates
     /* 162963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162965 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 162968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162975 */     GIR_RootConstrainSelectedInstOperands,
     /* 162976 */     // GIR_Coverage, 6268,
     /* 162976 */     GIR_EraseRootFromParent_Done,
     /* 162977 */   // Label 3129: @162977
     /* 162977 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(163030), // Rule ID 6269 //
     /* 162982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163016 */     // MIs[1] Operand 1
     /* 163016 */     // No operand predicates
     /* 163016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163018 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 163021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163028 */     GIR_RootConstrainSelectedInstOperands,
     /* 163029 */     // GIR_Coverage, 6269,
     /* 163029 */     GIR_EraseRootFromParent_Done,
     /* 163030 */   // Label 3130: @163030
     /* 163030 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(163083), // Rule ID 6270 //
     /* 163035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163069 */     // MIs[1] Operand 1
     /* 163069 */     // No operand predicates
     /* 163069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163071 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 163074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163081 */     GIR_RootConstrainSelectedInstOperands,
     /* 163082 */     // GIR_Coverage, 6270,
     /* 163082 */     GIR_EraseRootFromParent_Done,
     /* 163083 */   // Label 3131: @163083
     /* 163083 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(163136), // Rule ID 6271 //
     /* 163088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163122 */     // MIs[1] Operand 1
     /* 163122 */     // No operand predicates
     /* 163122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163124 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163134 */     GIR_RootConstrainSelectedInstOperands,
     /* 163135 */     // GIR_Coverage, 6271,
     /* 163135 */     GIR_EraseRootFromParent_Done,
     /* 163136 */   // Label 3132: @163136
     /* 163136 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(163189), // Rule ID 6272 //
     /* 163141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163175 */     // MIs[1] Operand 1
     /* 163175 */     // No operand predicates
     /* 163175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163177 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 163180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163187 */     GIR_RootConstrainSelectedInstOperands,
     /* 163188 */     // GIR_Coverage, 6272,
     /* 163188 */     GIR_EraseRootFromParent_Done,
     /* 163189 */   // Label 3133: @163189
     /* 163189 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(163242), // Rule ID 6273 //
     /* 163194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163228 */     // MIs[1] Operand 1
     /* 163228 */     // No operand predicates
     /* 163228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163230 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 163233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163240 */     GIR_RootConstrainSelectedInstOperands,
     /* 163241 */     // GIR_Coverage, 6273,
     /* 163241 */     GIR_EraseRootFromParent_Done,
     /* 163242 */   // Label 3134: @163242
     /* 163242 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(163295), // Rule ID 6274 //
     /* 163247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163281 */     // MIs[1] Operand 1
     /* 163281 */     // No operand predicates
     /* 163281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163283 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163293 */     GIR_RootConstrainSelectedInstOperands,
     /* 163294 */     // GIR_Coverage, 6274,
     /* 163294 */     GIR_EraseRootFromParent_Done,
     /* 163295 */   // Label 3135: @163295
     /* 163295 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(163348), // Rule ID 6275 //
     /* 163300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163334 */     // MIs[1] Operand 1
     /* 163334 */     // No operand predicates
     /* 163334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163336 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 163339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163346 */     GIR_RootConstrainSelectedInstOperands,
     /* 163347 */     // GIR_Coverage, 6275,
     /* 163347 */     GIR_EraseRootFromParent_Done,
     /* 163348 */   // Label 3136: @163348
     /* 163348 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(163430), // Rule ID 6277 //
     /* 163353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163387 */     // MIs[1] Operand 1
     /* 163387 */     // No operand predicates
     /* 163387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163389 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163401 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 163420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163428 */     GIR_RootConstrainSelectedInstOperands,
     /* 163429 */     // GIR_Coverage, 6277,
     /* 163429 */     GIR_EraseRootFromParent_Done,
     /* 163430 */   // Label 3137: @163430
     /* 163430 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(163512), // Rule ID 6278 //
     /* 163435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163469 */     // MIs[1] Operand 1
     /* 163469 */     // No operand predicates
     /* 163469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163471 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163483 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 163502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163510 */     GIR_RootConstrainSelectedInstOperands,
     /* 163511 */     // GIR_Coverage, 6278,
     /* 163511 */     GIR_EraseRootFromParent_Done,
     /* 163512 */   // Label 3138: @163512
     /* 163512 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(163594), // Rule ID 6280 //
     /* 163517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163551 */     // MIs[1] Operand 1
     /* 163551 */     // No operand predicates
     /* 163551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163553 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163565 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 163584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163592 */     GIR_RootConstrainSelectedInstOperands,
     /* 163593 */     // GIR_Coverage, 6280,
     /* 163593 */     GIR_EraseRootFromParent_Done,
     /* 163594 */   // Label 3139: @163594
     /* 163594 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(163676), // Rule ID 6281 //
     /* 163599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163633 */     // MIs[1] Operand 1
     /* 163633 */     // No operand predicates
     /* 163633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163635 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163647 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 163666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163674 */     GIR_RootConstrainSelectedInstOperands,
     /* 163675 */     // GIR_Coverage, 6281,
     /* 163675 */     GIR_EraseRootFromParent_Done,
     /* 163676 */   // Label 3140: @163676
     /* 163676 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(163782), // Rule ID 6282 //
     /* 163681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163715 */     // MIs[1] Operand 1
     /* 163715 */     // No operand predicates
     /* 163715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163717 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 163717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 163724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163729 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 163741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163781 */     // GIR_Coverage, 6282,
     /* 163781 */     GIR_EraseRootFromParent_Done,
     /* 163782 */   // Label 3141: @163782
     /* 163782 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(163888), // Rule ID 6283 //
     /* 163787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163821 */     // MIs[1] Operand 1
     /* 163821 */     // No operand predicates
     /* 163821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163823 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 163823 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163826 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 163830 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 163847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163887 */     // GIR_Coverage, 6283,
     /* 163887 */     GIR_EraseRootFromParent_Done,
     /* 163888 */   // Label 3142: @163888
     /* 163888 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(163994), // Rule ID 6284 //
     /* 163893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163927 */     // MIs[1] Operand 1
     /* 163927 */     // No operand predicates
     /* 163927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163929 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 163929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 163936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163941 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 163953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163993 */     // GIR_Coverage, 6284,
     /* 163993 */     GIR_EraseRootFromParent_Done,
     /* 163994 */   // Label 3143: @163994
     /* 163994 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(164100), // Rule ID 6285 //
     /* 163999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 164004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164033 */     // MIs[1] Operand 1
     /* 164033 */     // No operand predicates
     /* 164033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164035 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 164035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 164042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164047 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164099 */     // GIR_Coverage, 6285,
     /* 164099 */     GIR_EraseRootFromParent_Done,
     /* 164100 */   // Label 3144: @164100
     /* 164100 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(164158), // Rule ID 6974 //
     /* 164105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 164110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 164119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 164139 */     // MIs[1] Operand 1
     /* 164139 */     // No operand predicates
     /* 164139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164141 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 164141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 164144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164148 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 164153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 164156 */     GIR_RootConstrainSelectedInstOperands,
     /* 164157 */     // GIR_Coverage, 6974,
     /* 164157 */     GIR_EraseRootFromParent_Done,
     /* 164158 */   // Label 3145: @164158
     /* 164158 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(164200), // Rule ID 3045 //
     /* 164163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164181 */     // MIs[0] Op2
     /* 164181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 164189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 164189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 164192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164198 */     GIR_RootConstrainSelectedInstOperands,
     /* 164199 */     // GIR_Coverage, 3045,
     /* 164199 */     GIR_EraseRootFromParent_Done,
     /* 164200 */   // Label 3146: @164200
     /* 164200 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(164242), // Rule ID 3046 //
     /* 164205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164223 */     // MIs[0] Op2
     /* 164223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 164231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 164231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 164234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164240 */     GIR_RootConstrainSelectedInstOperands,
     /* 164241 */     // GIR_Coverage, 3046,
     /* 164241 */     GIR_EraseRootFromParent_Done,
     /* 164242 */   // Label 3147: @164242
     /* 164242 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(164284), // Rule ID 3047 //
     /* 164247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164265 */     // MIs[0] Op2
     /* 164265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 164273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 164273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 164276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164282 */     GIR_RootConstrainSelectedInstOperands,
     /* 164283 */     // GIR_Coverage, 3047,
     /* 164283 */     GIR_EraseRootFromParent_Done,
     /* 164284 */   // Label 3148: @164284
     /* 164284 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(164326), // Rule ID 3081 //
     /* 164289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164307 */     // MIs[0] Op2
     /* 164307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164315 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 164318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164324 */     GIR_RootConstrainSelectedInstOperands,
     /* 164325 */     // GIR_Coverage, 3081,
     /* 164325 */     GIR_EraseRootFromParent_Done,
     /* 164326 */   // Label 3149: @164326
     /* 164326 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(164368), // Rule ID 3082 //
     /* 164331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164349 */     // MIs[0] Op2
     /* 164349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164357 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 164360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164366 */     GIR_RootConstrainSelectedInstOperands,
     /* 164367 */     // GIR_Coverage, 3082,
     /* 164367 */     GIR_EraseRootFromParent_Done,
     /* 164368 */   // Label 3150: @164368
     /* 164368 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(164410), // Rule ID 3083 //
     /* 164373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164391 */     // MIs[0] Op2
     /* 164391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 164402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164408 */     GIR_RootConstrainSelectedInstOperands,
     /* 164409 */     // GIR_Coverage, 3083,
     /* 164409 */     GIR_EraseRootFromParent_Done,
     /* 164410 */   // Label 3151: @164410
     /* 164410 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(164452), // Rule ID 3530 //
     /* 164415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164433 */     // MIs[0] Op2
     /* 164433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 164441 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1345:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 164441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 164444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164450 */     GIR_RootConstrainSelectedInstOperands,
     /* 164451 */     // GIR_Coverage, 3530,
     /* 164451 */     GIR_EraseRootFromParent_Done,
     /* 164452 */   // Label 3152: @164452
     /* 164452 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(164494), // Rule ID 3531 //
     /* 164457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164475 */     // MIs[0] Op2
     /* 164475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 164483 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1345:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 164483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 164486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164492 */     GIR_RootConstrainSelectedInstOperands,
     /* 164493 */     // GIR_Coverage, 3531,
     /* 164493 */     GIR_EraseRootFromParent_Done,
     /* 164494 */   // Label 3153: @164494
     /* 164494 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(164536), // Rule ID 3532 //
     /* 164499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164517 */     // MIs[0] Op2
     /* 164517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 164525 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1345:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 164525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 164528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164534 */     GIR_RootConstrainSelectedInstOperands,
     /* 164535 */     // GIR_Coverage, 3532,
     /* 164535 */     GIR_EraseRootFromParent_Done,
     /* 164536 */   // Label 3154: @164536
     /* 164536 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(164578), // Rule ID 3533 //
     /* 164541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164559 */     // MIs[0] Op2
     /* 164559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 164567 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1345:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 164567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 164570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164576 */     GIR_RootConstrainSelectedInstOperands,
     /* 164577 */     // GIR_Coverage, 3533,
     /* 164577 */     GIR_EraseRootFromParent_Done,
     /* 164578 */   // Label 3155: @164578
     /* 164578 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(164620), // Rule ID 3534 //
     /* 164583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164601 */     // MIs[0] Op2
     /* 164601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 164609 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1345:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 164609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 164612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164618 */     GIR_RootConstrainSelectedInstOperands,
     /* 164619 */     // GIR_Coverage, 3534,
     /* 164619 */     GIR_EraseRootFromParent_Done,
     /* 164620 */   // Label 3156: @164620
     /* 164620 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(164662), // Rule ID 3535 //
     /* 164625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164643 */     // MIs[0] Op2
     /* 164643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 164651 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 164651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 164654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164660 */     GIR_RootConstrainSelectedInstOperands,
     /* 164661 */     // GIR_Coverage, 3535,
     /* 164661 */     GIR_EraseRootFromParent_Done,
     /* 164662 */   // Label 3157: @164662
     /* 164662 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(164704), // Rule ID 3536 //
     /* 164667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164685 */     // MIs[0] Op2
     /* 164685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 164693 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1345:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 164693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 164696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164702 */     GIR_RootConstrainSelectedInstOperands,
     /* 164703 */     // GIR_Coverage, 3536,
     /* 164703 */     GIR_EraseRootFromParent_Done,
     /* 164704 */   // Label 3158: @164704
     /* 164704 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(164746), // Rule ID 11727 //
     /* 164709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164727 */     // MIs[0] Op2
     /* 164727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164735 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 164738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164744 */     GIR_RootConstrainSelectedInstOperands,
     /* 164745 */     // GIR_Coverage, 11727,
     /* 164745 */     GIR_EraseRootFromParent_Done,
     /* 164746 */   // Label 3159: @164746
     /* 164746 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(164788), // Rule ID 11728 //
     /* 164751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164769 */     // MIs[0] Op2
     /* 164769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 164780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164786 */     GIR_RootConstrainSelectedInstOperands,
     /* 164787 */     // GIR_Coverage, 11728,
     /* 164787 */     GIR_EraseRootFromParent_Done,
     /* 164788 */   // Label 3160: @164788
     /* 164788 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(164830), // Rule ID 11729 //
     /* 164793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164811 */     // MIs[0] Op2
     /* 164811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 164822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164828 */     GIR_RootConstrainSelectedInstOperands,
     /* 164829 */     // GIR_Coverage, 11729,
     /* 164829 */     GIR_EraseRootFromParent_Done,
     /* 164830 */   // Label 3161: @164830
     /* 164830 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(164872), // Rule ID 11730 //
     /* 164835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164853 */     // MIs[0] Op2
     /* 164853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164861 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1718:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 164864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164870 */     GIR_RootConstrainSelectedInstOperands,
     /* 164871 */     // GIR_Coverage, 11730,
     /* 164871 */     GIR_EraseRootFromParent_Done,
     /* 164872 */   // Label 3162: @164872
     /* 164872 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(164914), // Rule ID 11731 //
     /* 164877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164895 */     // MIs[0] Op2
     /* 164895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164903 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1718:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 164906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164912 */     GIR_RootConstrainSelectedInstOperands,
     /* 164913 */     // GIR_Coverage, 11731,
     /* 164913 */     GIR_EraseRootFromParent_Done,
     /* 164914 */   // Label 3163: @164914
     /* 164914 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(164956), // Rule ID 11732 //
     /* 164919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164937 */     // MIs[0] Op2
     /* 164937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164940 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 164948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164954 */     GIR_RootConstrainSelectedInstOperands,
     /* 164955 */     // GIR_Coverage, 11732,
     /* 164955 */     GIR_EraseRootFromParent_Done,
     /* 164956 */   // Label 3164: @164956
     /* 164956 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(164998), // Rule ID 11734 //
     /* 164961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 164969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164979 */     // MIs[0] Op2
     /* 164979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164987 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 164990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164996 */     GIR_RootConstrainSelectedInstOperands,
     /* 164997 */     // GIR_Coverage, 11734,
     /* 164997 */     GIR_EraseRootFromParent_Done,
     /* 164998 */   // Label 3165: @164998
     /* 164998 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(165040), // Rule ID 11736 //
     /* 165003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165021 */     // MIs[0] Op2
     /* 165021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165029 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 165032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165038 */     GIR_RootConstrainSelectedInstOperands,
     /* 165039 */     // GIR_Coverage, 11736,
     /* 165039 */     GIR_EraseRootFromParent_Done,
     /* 165040 */   // Label 3166: @165040
     /* 165040 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(165082), // Rule ID 11738 //
     /* 165045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165063 */     // MIs[0] Op2
     /* 165063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 165074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165080 */     GIR_RootConstrainSelectedInstOperands,
     /* 165081 */     // GIR_Coverage, 11738,
     /* 165081 */     GIR_EraseRootFromParent_Done,
     /* 165082 */   // Label 3167: @165082
     /* 165082 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(165124), // Rule ID 11739 //
     /* 165087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165105 */     // MIs[0] Op2
     /* 165105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165113 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 165116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165122 */     GIR_RootConstrainSelectedInstOperands,
     /* 165123 */     // GIR_Coverage, 11739,
     /* 165123 */     GIR_EraseRootFromParent_Done,
     /* 165124 */   // Label 3168: @165124
     /* 165124 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(165166), // Rule ID 11740 //
     /* 165129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165147 */     // MIs[0] Op2
     /* 165147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165155 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 165158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165164 */     GIR_RootConstrainSelectedInstOperands,
     /* 165165 */     // GIR_Coverage, 11740,
     /* 165165 */     GIR_EraseRootFromParent_Done,
     /* 165166 */   // Label 3169: @165166
     /* 165166 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(165208), // Rule ID 11741 //
     /* 165171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165189 */     // MIs[0] Op2
     /* 165189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 165200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165206 */     GIR_RootConstrainSelectedInstOperands,
     /* 165207 */     // GIR_Coverage, 11741,
     /* 165207 */     GIR_EraseRootFromParent_Done,
     /* 165208 */   // Label 3170: @165208
     /* 165208 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(165250), // Rule ID 11742 //
     /* 165213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165231 */     // MIs[0] Op2
     /* 165231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 165242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165248 */     GIR_RootConstrainSelectedInstOperands,
     /* 165249 */     // GIR_Coverage, 11742,
     /* 165249 */     GIR_EraseRootFromParent_Done,
     /* 165250 */   // Label 3171: @165250
     /* 165250 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(165292), // Rule ID 11743 //
     /* 165255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165273 */     // MIs[0] Op2
     /* 165273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165281 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 165284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165290 */     GIR_RootConstrainSelectedInstOperands,
     /* 165291 */     // GIR_Coverage, 11743,
     /* 165291 */     GIR_EraseRootFromParent_Done,
     /* 165292 */   // Label 3172: @165292
     /* 165292 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(165334), // Rule ID 11744 //
     /* 165297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165315 */     // MIs[0] Op2
     /* 165315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 165326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165332 */     GIR_RootConstrainSelectedInstOperands,
     /* 165333 */     // GIR_Coverage, 11744,
     /* 165333 */     GIR_EraseRootFromParent_Done,
     /* 165334 */   // Label 3173: @165334
     /* 165334 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(165376), // Rule ID 11745 //
     /* 165339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165357 */     // MIs[0] Op2
     /* 165357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165365 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2038:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 165368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165374 */     GIR_RootConstrainSelectedInstOperands,
     /* 165375 */     // GIR_Coverage, 11745,
     /* 165375 */     GIR_EraseRootFromParent_Done,
     /* 165376 */   // Label 3174: @165376
     /* 165376 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(165418), // Rule ID 11746 //
     /* 165381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165399 */     // MIs[0] Op2
     /* 165399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2038:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 165410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165416 */     GIR_RootConstrainSelectedInstOperands,
     /* 165417 */     // GIR_Coverage, 11746,
     /* 165417 */     GIR_EraseRootFromParent_Done,
     /* 165418 */   // Label 3175: @165418
     /* 165418 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(165460), // Rule ID 11747 //
     /* 165423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165441 */     // MIs[0] Op2
     /* 165441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2038:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 165452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165458 */     GIR_RootConstrainSelectedInstOperands,
     /* 165459 */     // GIR_Coverage, 11747,
     /* 165459 */     GIR_EraseRootFromParent_Done,
     /* 165460 */   // Label 3176: @165460
     /* 165460 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(165502), // Rule ID 11748 //
     /* 165465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165483 */     // MIs[0] Op2
     /* 165483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165491 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2035:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 165494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165500 */     GIR_RootConstrainSelectedInstOperands,
     /* 165501 */     // GIR_Coverage, 11748,
     /* 165501 */     GIR_EraseRootFromParent_Done,
     /* 165502 */   // Label 3177: @165502
     /* 165502 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(165544), // Rule ID 11749 //
     /* 165507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165525 */     // MIs[0] Op2
     /* 165525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165533 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2035:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 165536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165542 */     GIR_RootConstrainSelectedInstOperands,
     /* 165543 */     // GIR_Coverage, 11749,
     /* 165543 */     GIR_EraseRootFromParent_Done,
     /* 165544 */   // Label 3178: @165544
     /* 165544 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(165586), // Rule ID 11750 //
     /* 165549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165567 */     // MIs[0] Op2
     /* 165567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2035:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 165578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165584 */     GIR_RootConstrainSelectedInstOperands,
     /* 165585 */     // GIR_Coverage, 11750,
     /* 165585 */     GIR_EraseRootFromParent_Done,
     /* 165586 */   // Label 3179: @165586
     /* 165586 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(165628), // Rule ID 11808 //
     /* 165591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165609 */     // MIs[0] Op2
     /* 165609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 165620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165626 */     GIR_RootConstrainSelectedInstOperands,
     /* 165627 */     // GIR_Coverage, 11808,
     /* 165627 */     GIR_EraseRootFromParent_Done,
     /* 165628 */   // Label 3180: @165628
     /* 165628 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(165670), // Rule ID 11809 //
     /* 165633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165651 */     // MIs[0] Op2
     /* 165651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165654 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165659 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 165662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165668 */     GIR_RootConstrainSelectedInstOperands,
     /* 165669 */     // GIR_Coverage, 11809,
     /* 165669 */     GIR_EraseRootFromParent_Done,
     /* 165670 */   // Label 3181: @165670
     /* 165670 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(165712), // Rule ID 11810 //
     /* 165675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165693 */     // MIs[0] Op2
     /* 165693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165701 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 165704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165710 */     GIR_RootConstrainSelectedInstOperands,
     /* 165711 */     // GIR_Coverage, 11810,
     /* 165711 */     GIR_EraseRootFromParent_Done,
     /* 165712 */   // Label 3182: @165712
     /* 165712 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(165754), // Rule ID 11811 //
     /* 165717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165735 */     // MIs[0] Op2
     /* 165735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 165746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165752 */     GIR_RootConstrainSelectedInstOperands,
     /* 165753 */     // GIR_Coverage, 11811,
     /* 165753 */     GIR_EraseRootFromParent_Done,
     /* 165754 */   // Label 3183: @165754
     /* 165754 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(165796), // Rule ID 11812 //
     /* 165759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165777 */     // MIs[0] Op2
     /* 165777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 165788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165794 */     GIR_RootConstrainSelectedInstOperands,
     /* 165795 */     // GIR_Coverage, 11812,
     /* 165795 */     GIR_EraseRootFromParent_Done,
     /* 165796 */   // Label 3184: @165796
     /* 165796 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(165838), // Rule ID 11813 //
     /* 165801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165819 */     // MIs[0] Op2
     /* 165819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165827 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 165830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165836 */     GIR_RootConstrainSelectedInstOperands,
     /* 165837 */     // GIR_Coverage, 11813,
     /* 165837 */     GIR_EraseRootFromParent_Done,
     /* 165838 */   // Label 3185: @165838
     /* 165838 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(165880), // Rule ID 11814 //
     /* 165843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165861 */     // MIs[0] Op2
     /* 165861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2059:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 165872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165878 */     GIR_RootConstrainSelectedInstOperands,
     /* 165879 */     // GIR_Coverage, 11814,
     /* 165879 */     GIR_EraseRootFromParent_Done,
     /* 165880 */   // Label 3186: @165880
     /* 165880 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(165922), // Rule ID 11815 //
     /* 165885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165903 */     // MIs[0] Op2
     /* 165903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2059:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 165914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165920 */     GIR_RootConstrainSelectedInstOperands,
     /* 165921 */     // GIR_Coverage, 11815,
     /* 165921 */     GIR_EraseRootFromParent_Done,
     /* 165922 */   // Label 3187: @165922
     /* 165922 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(165964), // Rule ID 11816 //
     /* 165927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165945 */     // MIs[0] Op2
     /* 165945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2059:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 165956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165962 */     GIR_RootConstrainSelectedInstOperands,
     /* 165963 */     // GIR_Coverage, 11816,
     /* 165963 */     GIR_EraseRootFromParent_Done,
     /* 165964 */   // Label 3188: @165964
     /* 165964 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(166016), // Rule ID 2132 //
     /* 165969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166002 */     // MIs[1] Operand 1
     /* 166002 */     // No operand predicates
     /* 166002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166004 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 166007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166014 */     GIR_RootConstrainSelectedInstOperands,
     /* 166015 */     // GIR_Coverage, 2132,
     /* 166015 */     GIR_EraseRootFromParent_Done,
     /* 166016 */   // Label 3189: @166016
     /* 166016 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(166068), // Rule ID 2133 //
     /* 166021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166054 */     // MIs[1] Operand 1
     /* 166054 */     // No operand predicates
     /* 166054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166056 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 166059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166066 */     GIR_RootConstrainSelectedInstOperands,
     /* 166067 */     // GIR_Coverage, 2133,
     /* 166067 */     GIR_EraseRootFromParent_Done,
     /* 166068 */   // Label 3190: @166068
     /* 166068 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(166120), // Rule ID 2134 //
     /* 166073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166106 */     // MIs[1] Operand 1
     /* 166106 */     // No operand predicates
     /* 166106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166108 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 166111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166118 */     GIR_RootConstrainSelectedInstOperands,
     /* 166119 */     // GIR_Coverage, 2134,
     /* 166119 */     GIR_EraseRootFromParent_Done,
     /* 166120 */   // Label 3191: @166120
     /* 166120 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(166172), // Rule ID 2135 //
     /* 166125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166158 */     // MIs[1] Operand 1
     /* 166158 */     // No operand predicates
     /* 166158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166160 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 166163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166170 */     GIR_RootConstrainSelectedInstOperands,
     /* 166171 */     // GIR_Coverage, 2135,
     /* 166171 */     GIR_EraseRootFromParent_Done,
     /* 166172 */   // Label 3192: @166172
     /* 166172 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(166224), // Rule ID 2136 //
     /* 166177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166210 */     // MIs[1] Operand 1
     /* 166210 */     // No operand predicates
     /* 166210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166212 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 166215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166222 */     GIR_RootConstrainSelectedInstOperands,
     /* 166223 */     // GIR_Coverage, 2136,
     /* 166223 */     GIR_EraseRootFromParent_Done,
     /* 166224 */   // Label 3193: @166224
     /* 166224 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(166276), // Rule ID 2137 //
     /* 166229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166262 */     // MIs[1] Operand 1
     /* 166262 */     // No operand predicates
     /* 166262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 166267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166274 */     GIR_RootConstrainSelectedInstOperands,
     /* 166275 */     // GIR_Coverage, 2137,
     /* 166275 */     GIR_EraseRootFromParent_Done,
     /* 166276 */   // Label 3194: @166276
     /* 166276 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(166328), // Rule ID 2138 //
     /* 166281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166314 */     // MIs[1] Operand 1
     /* 166314 */     // No operand predicates
     /* 166314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166316 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 166319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166326 */     GIR_RootConstrainSelectedInstOperands,
     /* 166327 */     // GIR_Coverage, 2138,
     /* 166327 */     GIR_EraseRootFromParent_Done,
     /* 166328 */   // Label 3195: @166328
     /* 166328 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(166380), // Rule ID 2139 //
     /* 166333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166366 */     // MIs[1] Operand 1
     /* 166366 */     // No operand predicates
     /* 166366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166368 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 166371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166378 */     GIR_RootConstrainSelectedInstOperands,
     /* 166379 */     // GIR_Coverage, 2139,
     /* 166379 */     GIR_EraseRootFromParent_Done,
     /* 166380 */   // Label 3196: @166380
     /* 166380 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(166432), // Rule ID 2140 //
     /* 166385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166418 */     // MIs[1] Operand 1
     /* 166418 */     // No operand predicates
     /* 166418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166420 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 166423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166430 */     GIR_RootConstrainSelectedInstOperands,
     /* 166431 */     // GIR_Coverage, 2140,
     /* 166431 */     GIR_EraseRootFromParent_Done,
     /* 166432 */   // Label 3197: @166432
     /* 166432 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(166484), // Rule ID 2141 //
     /* 166437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166470 */     // MIs[1] Operand 1
     /* 166470 */     // No operand predicates
     /* 166470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166472 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 166475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166482 */     GIR_RootConstrainSelectedInstOperands,
     /* 166483 */     // GIR_Coverage, 2141,
     /* 166483 */     GIR_EraseRootFromParent_Done,
     /* 166484 */   // Label 3198: @166484
     /* 166484 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(166536), // Rule ID 2142 //
     /* 166489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166522 */     // MIs[1] Operand 1
     /* 166522 */     // No operand predicates
     /* 166522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166524 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 166527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166534 */     GIR_RootConstrainSelectedInstOperands,
     /* 166535 */     // GIR_Coverage, 2142,
     /* 166535 */     GIR_EraseRootFromParent_Done,
     /* 166536 */   // Label 3199: @166536
     /* 166536 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(166588), // Rule ID 2143 //
     /* 166541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166574 */     // MIs[1] Operand 1
     /* 166574 */     // No operand predicates
     /* 166574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166576 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 166579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166586 */     GIR_RootConstrainSelectedInstOperands,
     /* 166587 */     // GIR_Coverage, 2143,
     /* 166587 */     GIR_EraseRootFromParent_Done,
     /* 166588 */   // Label 3200: @166588
     /* 166588 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(166640), // Rule ID 2144 //
     /* 166593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166626 */     // MIs[1] Operand 1
     /* 166626 */     // No operand predicates
     /* 166626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166628 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 166631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166638 */     GIR_RootConstrainSelectedInstOperands,
     /* 166639 */     // GIR_Coverage, 2144,
     /* 166639 */     GIR_EraseRootFromParent_Done,
     /* 166640 */   // Label 3201: @166640
     /* 166640 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(166692), // Rule ID 2145 //
     /* 166645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166678 */     // MIs[1] Operand 1
     /* 166678 */     // No operand predicates
     /* 166678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166680 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 166683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166690 */     GIR_RootConstrainSelectedInstOperands,
     /* 166691 */     // GIR_Coverage, 2145,
     /* 166691 */     GIR_EraseRootFromParent_Done,
     /* 166692 */   // Label 3202: @166692
     /* 166692 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(166744), // Rule ID 2146 //
     /* 166697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166730 */     // MIs[1] Operand 1
     /* 166730 */     // No operand predicates
     /* 166730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166732 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 166735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166742 */     GIR_RootConstrainSelectedInstOperands,
     /* 166743 */     // GIR_Coverage, 2146,
     /* 166743 */     GIR_EraseRootFromParent_Done,
     /* 166744 */   // Label 3203: @166744
     /* 166744 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(166796), // Rule ID 2244 //
     /* 166749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166782 */     // MIs[1] Operand 1
     /* 166782 */     // No operand predicates
     /* 166782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166784 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 166787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166794 */     GIR_RootConstrainSelectedInstOperands,
     /* 166795 */     // GIR_Coverage, 2244,
     /* 166795 */     GIR_EraseRootFromParent_Done,
     /* 166796 */   // Label 3204: @166796
     /* 166796 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(166848), // Rule ID 2245 //
     /* 166801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166834 */     // MIs[1] Operand 1
     /* 166834 */     // No operand predicates
     /* 166834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166836 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 166839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166846 */     GIR_RootConstrainSelectedInstOperands,
     /* 166847 */     // GIR_Coverage, 2245,
     /* 166847 */     GIR_EraseRootFromParent_Done,
     /* 166848 */   // Label 3205: @166848
     /* 166848 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(166900), // Rule ID 2246 //
     /* 166853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166886 */     // MIs[1] Operand 1
     /* 166886 */     // No operand predicates
     /* 166886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166888 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 166891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166898 */     GIR_RootConstrainSelectedInstOperands,
     /* 166899 */     // GIR_Coverage, 2246,
     /* 166899 */     GIR_EraseRootFromParent_Done,
     /* 166900 */   // Label 3206: @166900
     /* 166900 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(166952), // Rule ID 2247 //
     /* 166905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166938 */     // MIs[1] Operand 1
     /* 166938 */     // No operand predicates
     /* 166938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166940 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 166943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166950 */     GIR_RootConstrainSelectedInstOperands,
     /* 166951 */     // GIR_Coverage, 2247,
     /* 166951 */     GIR_EraseRootFromParent_Done,
     /* 166952 */   // Label 3207: @166952
     /* 166952 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(167004), // Rule ID 2248 //
     /* 166957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166990 */     // MIs[1] Operand 1
     /* 166990 */     // No operand predicates
     /* 166990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166992 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 166995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167002 */     GIR_RootConstrainSelectedInstOperands,
     /* 167003 */     // GIR_Coverage, 2248,
     /* 167003 */     GIR_EraseRootFromParent_Done,
     /* 167004 */   // Label 3208: @167004
     /* 167004 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(167049), // Rule ID 63 //
     /* 167009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 167012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 167017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 167038 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 167038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 167041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167047 */     GIR_RootConstrainSelectedInstOperands,
     /* 167048 */     // GIR_Coverage, 63,
     /* 167048 */     GIR_EraseRootFromParent_Done,
     /* 167049 */   // Label 3209: @167049
     /* 167049 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(167094), // Rule ID 129 //
     /* 167054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 167062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167083 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 167086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167092 */     GIR_RootConstrainSelectedInstOperands,
     /* 167093 */     // GIR_Coverage, 129,
     /* 167093 */     GIR_EraseRootFromParent_Done,
     /* 167094 */   // Label 3210: @167094
     /* 167094 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(167139), // Rule ID 130 //
     /* 167099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 167107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167128 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 167131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167137 */     GIR_RootConstrainSelectedInstOperands,
     /* 167138 */     // GIR_Coverage, 130,
     /* 167138 */     GIR_EraseRootFromParent_Done,
     /* 167139 */   // Label 3211: @167139
     /* 167139 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(167184), // Rule ID 131 //
     /* 167144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 167152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167173 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 167176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167182 */     GIR_RootConstrainSelectedInstOperands,
     /* 167183 */     // GIR_Coverage, 131,
     /* 167183 */     GIR_EraseRootFromParent_Done,
     /* 167184 */   // Label 3212: @167184
     /* 167184 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(167229), // Rule ID 132 //
     /* 167189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 167197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167218 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 167218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 167221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167227 */     GIR_RootConstrainSelectedInstOperands,
     /* 167228 */     // GIR_Coverage, 132,
     /* 167228 */     GIR_EraseRootFromParent_Done,
     /* 167229 */   // Label 3213: @167229
     /* 167229 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(167274), // Rule ID 133 //
     /* 167234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 167242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167263 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 167266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167272 */     GIR_RootConstrainSelectedInstOperands,
     /* 167273 */     // GIR_Coverage, 133,
     /* 167273 */     GIR_EraseRootFromParent_Done,
     /* 167274 */   // Label 3214: @167274
     /* 167274 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(167319), // Rule ID 134 //
     /* 167279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 167287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167308 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 167311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167317 */     GIR_RootConstrainSelectedInstOperands,
     /* 167318 */     // GIR_Coverage, 134,
     /* 167318 */     GIR_EraseRootFromParent_Done,
     /* 167319 */   // Label 3215: @167319
     /* 167319 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(167364), // Rule ID 135 //
     /* 167324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 167332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167353 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 167356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167362 */     GIR_RootConstrainSelectedInstOperands,
     /* 167363 */     // GIR_Coverage, 135,
     /* 167363 */     GIR_EraseRootFromParent_Done,
     /* 167364 */   // Label 3216: @167364
     /* 167364 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(167409), // Rule ID 136 //
     /* 167369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 167377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167398 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 167398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 167401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167407 */     GIR_RootConstrainSelectedInstOperands,
     /* 167408 */     // GIR_Coverage, 136,
     /* 167408 */     GIR_EraseRootFromParent_Done,
     /* 167409 */   // Label 3217: @167409
     /* 167409 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(167454), // Rule ID 1042 //
     /* 167414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167443 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 167443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 167446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167452 */     GIR_RootConstrainSelectedInstOperands,
     /* 167453 */     // GIR_Coverage, 1042,
     /* 167453 */     GIR_EraseRootFromParent_Done,
     /* 167454 */   // Label 3218: @167454
     /* 167454 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(167499), // Rule ID 1043 //
     /* 167459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167488 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 167488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 167491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167497 */     GIR_RootConstrainSelectedInstOperands,
     /* 167498 */     // GIR_Coverage, 1043,
     /* 167498 */     GIR_EraseRootFromParent_Done,
     /* 167499 */   // Label 3219: @167499
     /* 167499 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(167544), // Rule ID 1044 //
     /* 167504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167533 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 167533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 167536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167542 */     GIR_RootConstrainSelectedInstOperands,
     /* 167543 */     // GIR_Coverage, 1044,
     /* 167543 */     GIR_EraseRootFromParent_Done,
     /* 167544 */   // Label 3220: @167544
     /* 167544 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(167589), // Rule ID 1045 //
     /* 167549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167578 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 167578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 167581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167587 */     GIR_RootConstrainSelectedInstOperands,
     /* 167588 */     // GIR_Coverage, 1045,
     /* 167588 */     GIR_EraseRootFromParent_Done,
     /* 167589 */   // Label 3221: @167589
     /* 167589 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(167634), // Rule ID 1046 //
     /* 167594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167623 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 167623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 167626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167632 */     GIR_RootConstrainSelectedInstOperands,
     /* 167633 */     // GIR_Coverage, 1046,
     /* 167633 */     GIR_EraseRootFromParent_Done,
     /* 167634 */   // Label 3222: @167634
     /* 167634 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(167679), // Rule ID 1047 //
     /* 167639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167668 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 167668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 167671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167677 */     GIR_RootConstrainSelectedInstOperands,
     /* 167678 */     // GIR_Coverage, 1047,
     /* 167678 */     GIR_EraseRootFromParent_Done,
     /* 167679 */   // Label 3223: @167679
     /* 167679 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(167724), // Rule ID 1048 //
     /* 167684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167713 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 167713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 167716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167722 */     GIR_RootConstrainSelectedInstOperands,
     /* 167723 */     // GIR_Coverage, 1048,
     /* 167723 */     GIR_EraseRootFromParent_Done,
     /* 167724 */   // Label 3224: @167724
     /* 167724 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(167769), // Rule ID 1090 //
     /* 167729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167758 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 167758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 167761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167767 */     GIR_RootConstrainSelectedInstOperands,
     /* 167768 */     // GIR_Coverage, 1090,
     /* 167768 */     GIR_EraseRootFromParent_Done,
     /* 167769 */   // Label 3225: @167769
     /* 167769 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(167814), // Rule ID 1091 //
     /* 167774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167803 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 167803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 167806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167812 */     GIR_RootConstrainSelectedInstOperands,
     /* 167813 */     // GIR_Coverage, 1091,
     /* 167813 */     GIR_EraseRootFromParent_Done,
     /* 167814 */   // Label 3226: @167814
     /* 167814 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(167859), // Rule ID 1092 //
     /* 167819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167848 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 167848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 167851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167857 */     GIR_RootConstrainSelectedInstOperands,
     /* 167858 */     // GIR_Coverage, 1092,
     /* 167858 */     GIR_EraseRootFromParent_Done,
     /* 167859 */   // Label 3227: @167859
     /* 167859 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(167904), // Rule ID 1093 //
     /* 167864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167893 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 167893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 167896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167902 */     GIR_RootConstrainSelectedInstOperands,
     /* 167903 */     // GIR_Coverage, 1093,
     /* 167903 */     GIR_EraseRootFromParent_Done,
     /* 167904 */   // Label 3228: @167904
     /* 167904 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(167949), // Rule ID 1094 //
     /* 167909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167938 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 167938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 167941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167947 */     GIR_RootConstrainSelectedInstOperands,
     /* 167948 */     // GIR_Coverage, 1094,
     /* 167948 */     GIR_EraseRootFromParent_Done,
     /* 167949 */   // Label 3229: @167949
     /* 167949 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(167994), // Rule ID 1095 //
     /* 167954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167983 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 167983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 167986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167992 */     GIR_RootConstrainSelectedInstOperands,
     /* 167993 */     // GIR_Coverage, 1095,
     /* 167993 */     GIR_EraseRootFromParent_Done,
     /* 167994 */   // Label 3230: @167994
     /* 167994 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(168039), // Rule ID 1096 //
     /* 167999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168028 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 168028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 168031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168037 */     GIR_RootConstrainSelectedInstOperands,
     /* 168038 */     // GIR_Coverage, 1096,
     /* 168038 */     GIR_EraseRootFromParent_Done,
     /* 168039 */   // Label 3231: @168039
     /* 168039 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(168084), // Rule ID 1108 //
     /* 168044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168073 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 168076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168082 */     GIR_RootConstrainSelectedInstOperands,
     /* 168083 */     // GIR_Coverage, 1108,
     /* 168083 */     GIR_EraseRootFromParent_Done,
     /* 168084 */   // Label 3232: @168084
     /* 168084 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(168129), // Rule ID 1110 //
     /* 168089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168118 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 168121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168127 */     GIR_RootConstrainSelectedInstOperands,
     /* 168128 */     // GIR_Coverage, 1110,
     /* 168128 */     GIR_EraseRootFromParent_Done,
     /* 168129 */   // Label 3233: @168129
     /* 168129 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(168174), // Rule ID 1112 //
     /* 168134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168163 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 168166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168172 */     GIR_RootConstrainSelectedInstOperands,
     /* 168173 */     // GIR_Coverage, 1112,
     /* 168173 */     GIR_EraseRootFromParent_Done,
     /* 168174 */   // Label 3234: @168174
     /* 168174 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(168219), // Rule ID 1114 //
     /* 168179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168208 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 168211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168217 */     GIR_RootConstrainSelectedInstOperands,
     /* 168218 */     // GIR_Coverage, 1114,
     /* 168218 */     GIR_EraseRootFromParent_Done,
     /* 168219 */   // Label 3235: @168219
     /* 168219 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(168264), // Rule ID 1116 //
     /* 168224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168253 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168262 */     GIR_RootConstrainSelectedInstOperands,
     /* 168263 */     // GIR_Coverage, 1116,
     /* 168263 */     GIR_EraseRootFromParent_Done,
     /* 168264 */   // Label 3236: @168264
     /* 168264 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(168309), // Rule ID 1118 //
     /* 168269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168298 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 168301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168307 */     GIR_RootConstrainSelectedInstOperands,
     /* 168308 */     // GIR_Coverage, 1118,
     /* 168308 */     GIR_EraseRootFromParent_Done,
     /* 168309 */   // Label 3237: @168309
     /* 168309 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(168354), // Rule ID 1120 //
     /* 168314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168343 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 168346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168352 */     GIR_RootConstrainSelectedInstOperands,
     /* 168353 */     // GIR_Coverage, 1120,
     /* 168353 */     GIR_EraseRootFromParent_Done,
     /* 168354 */   // Label 3238: @168354
     /* 168354 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(168399), // Rule ID 1163 //
     /* 168359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168388 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 168391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168397 */     GIR_RootConstrainSelectedInstOperands,
     /* 168398 */     // GIR_Coverage, 1163,
     /* 168398 */     GIR_EraseRootFromParent_Done,
     /* 168399 */   // Label 3239: @168399
     /* 168399 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(168444), // Rule ID 1164 //
     /* 168404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168433 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 168436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168442 */     GIR_RootConstrainSelectedInstOperands,
     /* 168443 */     // GIR_Coverage, 1164,
     /* 168443 */     GIR_EraseRootFromParent_Done,
     /* 168444 */   // Label 3240: @168444
     /* 168444 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(168489), // Rule ID 1165 //
     /* 168449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168478 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 168481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168487 */     GIR_RootConstrainSelectedInstOperands,
     /* 168488 */     // GIR_Coverage, 1165,
     /* 168488 */     GIR_EraseRootFromParent_Done,
     /* 168489 */   // Label 3241: @168489
     /* 168489 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(168534), // Rule ID 1166 //
     /* 168494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168523 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 168526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168532 */     GIR_RootConstrainSelectedInstOperands,
     /* 168533 */     // GIR_Coverage, 1166,
     /* 168533 */     GIR_EraseRootFromParent_Done,
     /* 168534 */   // Label 3242: @168534
     /* 168534 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(168579), // Rule ID 1167 //
     /* 168539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168568 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 168571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168577 */     GIR_RootConstrainSelectedInstOperands,
     /* 168578 */     // GIR_Coverage, 1167,
     /* 168578 */     GIR_EraseRootFromParent_Done,
     /* 168579 */   // Label 3243: @168579
     /* 168579 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(168624), // Rule ID 1169 //
     /* 168584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168613 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 168616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168622 */     GIR_RootConstrainSelectedInstOperands,
     /* 168623 */     // GIR_Coverage, 1169,
     /* 168623 */     GIR_EraseRootFromParent_Done,
     /* 168624 */   // Label 3244: @168624
     /* 168624 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(168669), // Rule ID 1171 //
     /* 168629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168658 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 168661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168667 */     GIR_RootConstrainSelectedInstOperands,
     /* 168668 */     // GIR_Coverage, 1171,
     /* 168668 */     GIR_EraseRootFromParent_Done,
     /* 168669 */   // Label 3245: @168669
     /* 168669 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(168714), // Rule ID 1173 //
     /* 168674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168703 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 168706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168712 */     GIR_RootConstrainSelectedInstOperands,
     /* 168713 */     // GIR_Coverage, 1173,
     /* 168713 */     GIR_EraseRootFromParent_Done,
     /* 168714 */   // Label 3246: @168714
     /* 168714 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(168759), // Rule ID 1175 //
     /* 168719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168748 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 168751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168757 */     GIR_RootConstrainSelectedInstOperands,
     /* 168758 */     // GIR_Coverage, 1175,
     /* 168758 */     GIR_EraseRootFromParent_Done,
     /* 168759 */   // Label 3247: @168759
     /* 168759 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(168804), // Rule ID 1177 //
     /* 168764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168793 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 168796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168802 */     GIR_RootConstrainSelectedInstOperands,
     /* 168803 */     // GIR_Coverage, 1177,
     /* 168803 */     GIR_EraseRootFromParent_Done,
     /* 168804 */   // Label 3248: @168804
     /* 168804 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(168849), // Rule ID 1179 //
     /* 168809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168838 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 168841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168847 */     GIR_RootConstrainSelectedInstOperands,
     /* 168848 */     // GIR_Coverage, 1179,
     /* 168848 */     GIR_EraseRootFromParent_Done,
     /* 168849 */   // Label 3249: @168849
     /* 168849 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(168894), // Rule ID 1181 //
     /* 168854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168883 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 168886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168892 */     GIR_RootConstrainSelectedInstOperands,
     /* 168893 */     // GIR_Coverage, 1181,
     /* 168893 */     GIR_EraseRootFromParent_Done,
     /* 168894 */   // Label 3250: @168894
     /* 168894 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(168939), // Rule ID 1183 //
     /* 168899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168928 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 168931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168937 */     GIR_RootConstrainSelectedInstOperands,
     /* 168938 */     // GIR_Coverage, 1183,
     /* 168938 */     GIR_EraseRootFromParent_Done,
     /* 168939 */   // Label 3251: @168939
     /* 168939 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(168984), // Rule ID 1185 //
     /* 168944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168973 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 168976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168982 */     GIR_RootConstrainSelectedInstOperands,
     /* 168983 */     // GIR_Coverage, 1185,
     /* 168983 */     GIR_EraseRootFromParent_Done,
     /* 168984 */   // Label 3252: @168984
     /* 168984 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(169029), // Rule ID 1187 //
     /* 168989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169018 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 169021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169027 */     GIR_RootConstrainSelectedInstOperands,
     /* 169028 */     // GIR_Coverage, 1187,
     /* 169028 */     GIR_EraseRootFromParent_Done,
     /* 169029 */   // Label 3253: @169029
     /* 169029 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(169074), // Rule ID 1189 //
     /* 169034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169063 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 169066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169072 */     GIR_RootConstrainSelectedInstOperands,
     /* 169073 */     // GIR_Coverage, 1189,
     /* 169073 */     GIR_EraseRootFromParent_Done,
     /* 169074 */   // Label 3254: @169074
     /* 169074 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(169119), // Rule ID 1191 //
     /* 169079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169108 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 169111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169117 */     GIR_RootConstrainSelectedInstOperands,
     /* 169118 */     // GIR_Coverage, 1191,
     /* 169118 */     GIR_EraseRootFromParent_Done,
     /* 169119 */   // Label 3255: @169119
     /* 169119 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(169164), // Rule ID 1193 //
     /* 169124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169153 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 169156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169162 */     GIR_RootConstrainSelectedInstOperands,
     /* 169163 */     // GIR_Coverage, 1193,
     /* 169163 */     GIR_EraseRootFromParent_Done,
     /* 169164 */   // Label 3256: @169164
     /* 169164 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(169209), // Rule ID 1195 //
     /* 169169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169198 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 169201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169207 */     GIR_RootConstrainSelectedInstOperands,
     /* 169208 */     // GIR_Coverage, 1195,
     /* 169208 */     GIR_EraseRootFromParent_Done,
     /* 169209 */   // Label 3257: @169209
     /* 169209 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(169254), // Rule ID 1197 //
     /* 169214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169243 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 169246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169252 */     GIR_RootConstrainSelectedInstOperands,
     /* 169253 */     // GIR_Coverage, 1197,
     /* 169253 */     GIR_EraseRootFromParent_Done,
     /* 169254 */   // Label 3258: @169254
     /* 169254 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(169299), // Rule ID 1233 //
     /* 169259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169288 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 169291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169297 */     GIR_RootConstrainSelectedInstOperands,
     /* 169298 */     // GIR_Coverage, 1233,
     /* 169298 */     GIR_EraseRootFromParent_Done,
     /* 169299 */   // Label 3259: @169299
     /* 169299 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(169344), // Rule ID 1234 //
     /* 169304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169333 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 169336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169342 */     GIR_RootConstrainSelectedInstOperands,
     /* 169343 */     // GIR_Coverage, 1234,
     /* 169343 */     GIR_EraseRootFromParent_Done,
     /* 169344 */   // Label 3260: @169344
     /* 169344 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(169389), // Rule ID 1235 //
     /* 169349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169378 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 169381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169387 */     GIR_RootConstrainSelectedInstOperands,
     /* 169388 */     // GIR_Coverage, 1235,
     /* 169388 */     GIR_EraseRootFromParent_Done,
     /* 169389 */   // Label 3261: @169389
     /* 169389 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(169434), // Rule ID 1236 //
     /* 169394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169423 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 169426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169432 */     GIR_RootConstrainSelectedInstOperands,
     /* 169433 */     // GIR_Coverage, 1236,
     /* 169433 */     GIR_EraseRootFromParent_Done,
     /* 169434 */   // Label 3262: @169434
     /* 169434 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(169479), // Rule ID 1237 //
     /* 169439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169468 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 169471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169477 */     GIR_RootConstrainSelectedInstOperands,
     /* 169478 */     // GIR_Coverage, 1237,
     /* 169478 */     GIR_EraseRootFromParent_Done,
     /* 169479 */   // Label 3263: @169479
     /* 169479 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(169524), // Rule ID 1248 //
     /* 169484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169513 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 169516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169522 */     GIR_RootConstrainSelectedInstOperands,
     /* 169523 */     // GIR_Coverage, 1248,
     /* 169523 */     GIR_EraseRootFromParent_Done,
     /* 169524 */   // Label 3264: @169524
     /* 169524 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(169569), // Rule ID 1249 //
     /* 169529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169558 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 169561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169567 */     GIR_RootConstrainSelectedInstOperands,
     /* 169568 */     // GIR_Coverage, 1249,
     /* 169568 */     GIR_EraseRootFromParent_Done,
     /* 169569 */   // Label 3265: @169569
     /* 169569 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(169614), // Rule ID 1250 //
     /* 169574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169603 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 169606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169612 */     GIR_RootConstrainSelectedInstOperands,
     /* 169613 */     // GIR_Coverage, 1250,
     /* 169613 */     GIR_EraseRootFromParent_Done,
     /* 169614 */   // Label 3266: @169614
     /* 169614 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(169659), // Rule ID 1251 //
     /* 169619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169648 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 169651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169657 */     GIR_RootConstrainSelectedInstOperands,
     /* 169658 */     // GIR_Coverage, 1251,
     /* 169658 */     GIR_EraseRootFromParent_Done,
     /* 169659 */   // Label 3267: @169659
     /* 169659 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(169704), // Rule ID 1252 //
     /* 169664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169693 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 169696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169702 */     GIR_RootConstrainSelectedInstOperands,
     /* 169703 */     // GIR_Coverage, 1252,
     /* 169703 */     GIR_EraseRootFromParent_Done,
     /* 169704 */   // Label 3268: @169704
     /* 169704 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(169749), // Rule ID 1263 //
     /* 169709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169738 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 169741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169747 */     GIR_RootConstrainSelectedInstOperands,
     /* 169748 */     // GIR_Coverage, 1263,
     /* 169748 */     GIR_EraseRootFromParent_Done,
     /* 169749 */   // Label 3269: @169749
     /* 169749 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(169794), // Rule ID 1264 //
     /* 169754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169783 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 169786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169792 */     GIR_RootConstrainSelectedInstOperands,
     /* 169793 */     // GIR_Coverage, 1264,
     /* 169793 */     GIR_EraseRootFromParent_Done,
     /* 169794 */   // Label 3270: @169794
     /* 169794 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(169839), // Rule ID 1265 //
     /* 169799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169828 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 169831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169837 */     GIR_RootConstrainSelectedInstOperands,
     /* 169838 */     // GIR_Coverage, 1265,
     /* 169838 */     GIR_EraseRootFromParent_Done,
     /* 169839 */   // Label 3271: @169839
     /* 169839 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(169884), // Rule ID 1266 //
     /* 169844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169873 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 169876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169882 */     GIR_RootConstrainSelectedInstOperands,
     /* 169883 */     // GIR_Coverage, 1266,
     /* 169883 */     GIR_EraseRootFromParent_Done,
     /* 169884 */   // Label 3272: @169884
     /* 169884 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(169929), // Rule ID 1267 //
     /* 169889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169918 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 169921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169927 */     GIR_RootConstrainSelectedInstOperands,
     /* 169928 */     // GIR_Coverage, 1267,
     /* 169928 */     GIR_EraseRootFromParent_Done,
     /* 169929 */   // Label 3273: @169929
     /* 169929 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(169974), // Rule ID 1278 //
     /* 169934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169963 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 169966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169972 */     GIR_RootConstrainSelectedInstOperands,
     /* 169973 */     // GIR_Coverage, 1278,
     /* 169973 */     GIR_EraseRootFromParent_Done,
     /* 169974 */   // Label 3274: @169974
     /* 169974 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(170019), // Rule ID 1279 //
     /* 169979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170008 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 170011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170017 */     GIR_RootConstrainSelectedInstOperands,
     /* 170018 */     // GIR_Coverage, 1279,
     /* 170018 */     GIR_EraseRootFromParent_Done,
     /* 170019 */   // Label 3275: @170019
     /* 170019 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(170064), // Rule ID 1280 //
     /* 170024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170053 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 170056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170062 */     GIR_RootConstrainSelectedInstOperands,
     /* 170063 */     // GIR_Coverage, 1280,
     /* 170063 */     GIR_EraseRootFromParent_Done,
     /* 170064 */   // Label 3276: @170064
     /* 170064 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(170109), // Rule ID 1281 //
     /* 170069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170098 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 170101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170107 */     GIR_RootConstrainSelectedInstOperands,
     /* 170108 */     // GIR_Coverage, 1281,
     /* 170108 */     GIR_EraseRootFromParent_Done,
     /* 170109 */   // Label 3277: @170109
     /* 170109 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(170154), // Rule ID 1282 //
     /* 170114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170143 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 170146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170152 */     GIR_RootConstrainSelectedInstOperands,
     /* 170153 */     // GIR_Coverage, 1282,
     /* 170153 */     GIR_EraseRootFromParent_Done,
     /* 170154 */   // Label 3278: @170154
     /* 170154 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(170199), // Rule ID 1313 //
     /* 170159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170188 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 170191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170197 */     GIR_RootConstrainSelectedInstOperands,
     /* 170198 */     // GIR_Coverage, 1313,
     /* 170198 */     GIR_EraseRootFromParent_Done,
     /* 170199 */   // Label 3279: @170199
     /* 170199 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(170244), // Rule ID 1314 //
     /* 170204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170233 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 170236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170242 */     GIR_RootConstrainSelectedInstOperands,
     /* 170243 */     // GIR_Coverage, 1314,
     /* 170243 */     GIR_EraseRootFromParent_Done,
     /* 170244 */   // Label 3280: @170244
     /* 170244 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(170289), // Rule ID 1315 //
     /* 170249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170278 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 170281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170287 */     GIR_RootConstrainSelectedInstOperands,
     /* 170288 */     // GIR_Coverage, 1315,
     /* 170288 */     GIR_EraseRootFromParent_Done,
     /* 170289 */   // Label 3281: @170289
     /* 170289 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(170334), // Rule ID 1316 //
     /* 170294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170323 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 170326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170332 */     GIR_RootConstrainSelectedInstOperands,
     /* 170333 */     // GIR_Coverage, 1316,
     /* 170333 */     GIR_EraseRootFromParent_Done,
     /* 170334 */   // Label 3282: @170334
     /* 170334 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(170379), // Rule ID 1317 //
     /* 170339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170368 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 170371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170377 */     GIR_RootConstrainSelectedInstOperands,
     /* 170378 */     // GIR_Coverage, 1317,
     /* 170378 */     GIR_EraseRootFromParent_Done,
     /* 170379 */   // Label 3283: @170379
     /* 170379 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(170424), // Rule ID 1328 //
     /* 170384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170413 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 170416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170422 */     GIR_RootConstrainSelectedInstOperands,
     /* 170423 */     // GIR_Coverage, 1328,
     /* 170423 */     GIR_EraseRootFromParent_Done,
     /* 170424 */   // Label 3284: @170424
     /* 170424 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(170469), // Rule ID 1329 //
     /* 170429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170458 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 170461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170467 */     GIR_RootConstrainSelectedInstOperands,
     /* 170468 */     // GIR_Coverage, 1329,
     /* 170468 */     GIR_EraseRootFromParent_Done,
     /* 170469 */   // Label 3285: @170469
     /* 170469 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(170514), // Rule ID 1330 //
     /* 170474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170503 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 170506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170512 */     GIR_RootConstrainSelectedInstOperands,
     /* 170513 */     // GIR_Coverage, 1330,
     /* 170513 */     GIR_EraseRootFromParent_Done,
     /* 170514 */   // Label 3286: @170514
     /* 170514 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(170559), // Rule ID 1331 //
     /* 170519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170548 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 170551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170557 */     GIR_RootConstrainSelectedInstOperands,
     /* 170558 */     // GIR_Coverage, 1331,
     /* 170558 */     GIR_EraseRootFromParent_Done,
     /* 170559 */   // Label 3287: @170559
     /* 170559 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(170604), // Rule ID 1332 //
     /* 170564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170593 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 170596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170602 */     GIR_RootConstrainSelectedInstOperands,
     /* 170603 */     // GIR_Coverage, 1332,
     /* 170603 */     GIR_EraseRootFromParent_Done,
     /* 170604 */   // Label 3288: @170604
     /* 170604 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(170649), // Rule ID 1333 //
     /* 170609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170638 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 170641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170647 */     GIR_RootConstrainSelectedInstOperands,
     /* 170648 */     // GIR_Coverage, 1333,
     /* 170648 */     GIR_EraseRootFromParent_Done,
     /* 170649 */   // Label 3289: @170649
     /* 170649 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(170694), // Rule ID 1334 //
     /* 170654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170683 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 170686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170692 */     GIR_RootConstrainSelectedInstOperands,
     /* 170693 */     // GIR_Coverage, 1334,
     /* 170693 */     GIR_EraseRootFromParent_Done,
     /* 170694 */   // Label 3290: @170694
     /* 170694 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(170739), // Rule ID 1335 //
     /* 170699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170728 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 170731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170737 */     GIR_RootConstrainSelectedInstOperands,
     /* 170738 */     // GIR_Coverage, 1335,
     /* 170738 */     GIR_EraseRootFromParent_Done,
     /* 170739 */   // Label 3291: @170739
     /* 170739 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(170784), // Rule ID 1336 //
     /* 170744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170773 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 170776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170782 */     GIR_RootConstrainSelectedInstOperands,
     /* 170783 */     // GIR_Coverage, 1336,
     /* 170783 */     GIR_EraseRootFromParent_Done,
     /* 170784 */   // Label 3292: @170784
     /* 170784 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(170829), // Rule ID 1337 //
     /* 170789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170818 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 170821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170827 */     GIR_RootConstrainSelectedInstOperands,
     /* 170828 */     // GIR_Coverage, 1337,
     /* 170828 */     GIR_EraseRootFromParent_Done,
     /* 170829 */   // Label 3293: @170829
     /* 170829 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(170874), // Rule ID 1354 //
     /* 170834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 170842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170863 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 170866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170872 */     GIR_RootConstrainSelectedInstOperands,
     /* 170873 */     // GIR_Coverage, 1354,
     /* 170873 */     GIR_EraseRootFromParent_Done,
     /* 170874 */   // Label 3294: @170874
     /* 170874 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(170919), // Rule ID 1355 //
     /* 170879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 170887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170908 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 170911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170917 */     GIR_RootConstrainSelectedInstOperands,
     /* 170918 */     // GIR_Coverage, 1355,
     /* 170918 */     GIR_EraseRootFromParent_Done,
     /* 170919 */   // Label 3295: @170919
     /* 170919 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(170964), // Rule ID 1369 //
     /* 170924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170953 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 170956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170962 */     GIR_RootConstrainSelectedInstOperands,
     /* 170963 */     // GIR_Coverage, 1369,
     /* 170963 */     GIR_EraseRootFromParent_Done,
     /* 170964 */   // Label 3296: @170964
     /* 170964 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(171009), // Rule ID 1371 //
     /* 170969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170998 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 171001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171007 */     GIR_RootConstrainSelectedInstOperands,
     /* 171008 */     // GIR_Coverage, 1371,
     /* 171008 */     GIR_EraseRootFromParent_Done,
     /* 171009 */   // Label 3297: @171009
     /* 171009 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(171054), // Rule ID 1373 //
     /* 171014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171043 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 171046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171052 */     GIR_RootConstrainSelectedInstOperands,
     /* 171053 */     // GIR_Coverage, 1373,
     /* 171053 */     GIR_EraseRootFromParent_Done,
     /* 171054 */   // Label 3298: @171054
     /* 171054 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(171099), // Rule ID 1375 //
     /* 171059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171088 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 171091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171097 */     GIR_RootConstrainSelectedInstOperands,
     /* 171098 */     // GIR_Coverage, 1375,
     /* 171098 */     GIR_EraseRootFromParent_Done,
     /* 171099 */   // Label 3299: @171099
     /* 171099 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(171144), // Rule ID 1377 //
     /* 171104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171133 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 171136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171142 */     GIR_RootConstrainSelectedInstOperands,
     /* 171143 */     // GIR_Coverage, 1377,
     /* 171143 */     GIR_EraseRootFromParent_Done,
     /* 171144 */   // Label 3300: @171144
     /* 171144 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(171189), // Rule ID 1379 //
     /* 171149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171178 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 171181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171187 */     GIR_RootConstrainSelectedInstOperands,
     /* 171188 */     // GIR_Coverage, 1379,
     /* 171188 */     GIR_EraseRootFromParent_Done,
     /* 171189 */   // Label 3301: @171189
     /* 171189 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(171234), // Rule ID 1386 //
     /* 171194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171223 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 171226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171232 */     GIR_RootConstrainSelectedInstOperands,
     /* 171233 */     // GIR_Coverage, 1386,
     /* 171233 */     GIR_EraseRootFromParent_Done,
     /* 171234 */   // Label 3302: @171234
     /* 171234 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(171279), // Rule ID 1387 //
     /* 171239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171268 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 171271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171277 */     GIR_RootConstrainSelectedInstOperands,
     /* 171278 */     // GIR_Coverage, 1387,
     /* 171278 */     GIR_EraseRootFromParent_Done,
     /* 171279 */   // Label 3303: @171279
     /* 171279 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(171324), // Rule ID 1388 //
     /* 171284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171313 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 171316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171322 */     GIR_RootConstrainSelectedInstOperands,
     /* 171323 */     // GIR_Coverage, 1388,
     /* 171323 */     GIR_EraseRootFromParent_Done,
     /* 171324 */   // Label 3304: @171324
     /* 171324 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(171369), // Rule ID 1389 //
     /* 171329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171358 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 171361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171367 */     GIR_RootConstrainSelectedInstOperands,
     /* 171368 */     // GIR_Coverage, 1389,
     /* 171368 */     GIR_EraseRootFromParent_Done,
     /* 171369 */   // Label 3305: @171369
     /* 171369 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(171414), // Rule ID 1390 //
     /* 171374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171403 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 171406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171412 */     GIR_RootConstrainSelectedInstOperands,
     /* 171413 */     // GIR_Coverage, 1390,
     /* 171413 */     GIR_EraseRootFromParent_Done,
     /* 171414 */   // Label 3306: @171414
     /* 171414 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(171459), // Rule ID 1391 //
     /* 171419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171448 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 171451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171457 */     GIR_RootConstrainSelectedInstOperands,
     /* 171458 */     // GIR_Coverage, 1391,
     /* 171458 */     GIR_EraseRootFromParent_Done,
     /* 171459 */   // Label 3307: @171459
     /* 171459 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(171504), // Rule ID 1392 //
     /* 171464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171493 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 171496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171502 */     GIR_RootConstrainSelectedInstOperands,
     /* 171503 */     // GIR_Coverage, 1392,
     /* 171503 */     GIR_EraseRootFromParent_Done,
     /* 171504 */   // Label 3308: @171504
     /* 171504 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(171549), // Rule ID 1393 //
     /* 171509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171538 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 171541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171547 */     GIR_RootConstrainSelectedInstOperands,
     /* 171548 */     // GIR_Coverage, 1393,
     /* 171548 */     GIR_EraseRootFromParent_Done,
     /* 171549 */   // Label 3309: @171549
     /* 171549 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(171594), // Rule ID 1394 //
     /* 171554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171583 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 171586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171592 */     GIR_RootConstrainSelectedInstOperands,
     /* 171593 */     // GIR_Coverage, 1394,
     /* 171593 */     GIR_EraseRootFromParent_Done,
     /* 171594 */   // Label 3310: @171594
     /* 171594 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(171639), // Rule ID 1395 //
     /* 171599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171628 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 171631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171637 */     GIR_RootConstrainSelectedInstOperands,
     /* 171638 */     // GIR_Coverage, 1395,
     /* 171638 */     GIR_EraseRootFromParent_Done,
     /* 171639 */   // Label 3311: @171639
     /* 171639 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(171684), // Rule ID 1396 //
     /* 171644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171673 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 171676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171682 */     GIR_RootConstrainSelectedInstOperands,
     /* 171683 */     // GIR_Coverage, 1396,
     /* 171683 */     GIR_EraseRootFromParent_Done,
     /* 171684 */   // Label 3312: @171684
     /* 171684 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(171729), // Rule ID 1397 //
     /* 171689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171718 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 171721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171727 */     GIR_RootConstrainSelectedInstOperands,
     /* 171728 */     // GIR_Coverage, 1397,
     /* 171728 */     GIR_EraseRootFromParent_Done,
     /* 171729 */   // Label 3313: @171729
     /* 171729 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(171774), // Rule ID 1404 //
     /* 171734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171763 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 171766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171772 */     GIR_RootConstrainSelectedInstOperands,
     /* 171773 */     // GIR_Coverage, 1404,
     /* 171773 */     GIR_EraseRootFromParent_Done,
     /* 171774 */   // Label 3314: @171774
     /* 171774 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(171819), // Rule ID 1405 //
     /* 171779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171808 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 171811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171817 */     GIR_RootConstrainSelectedInstOperands,
     /* 171818 */     // GIR_Coverage, 1405,
     /* 171818 */     GIR_EraseRootFromParent_Done,
     /* 171819 */   // Label 3315: @171819
     /* 171819 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(171864), // Rule ID 1406 //
     /* 171824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171853 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 171856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171862 */     GIR_RootConstrainSelectedInstOperands,
     /* 171863 */     // GIR_Coverage, 1406,
     /* 171863 */     GIR_EraseRootFromParent_Done,
     /* 171864 */   // Label 3316: @171864
     /* 171864 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(171909), // Rule ID 1407 //
     /* 171869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171898 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 171901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171907 */     GIR_RootConstrainSelectedInstOperands,
     /* 171908 */     // GIR_Coverage, 1407,
     /* 171908 */     GIR_EraseRootFromParent_Done,
     /* 171909 */   // Label 3317: @171909
     /* 171909 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(171954), // Rule ID 1408 //
     /* 171914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171943 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 171946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171952 */     GIR_RootConstrainSelectedInstOperands,
     /* 171953 */     // GIR_Coverage, 1408,
     /* 171953 */     GIR_EraseRootFromParent_Done,
     /* 171954 */   // Label 3318: @171954
     /* 171954 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(171999), // Rule ID 1409 //
     /* 171959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171988 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 171991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171997 */     GIR_RootConstrainSelectedInstOperands,
     /* 171998 */     // GIR_Coverage, 1409,
     /* 171998 */     GIR_EraseRootFromParent_Done,
     /* 171999 */   // Label 3319: @171999
     /* 171999 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(172044), // Rule ID 1416 //
     /* 172004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172033 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 172036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172042 */     GIR_RootConstrainSelectedInstOperands,
     /* 172043 */     // GIR_Coverage, 1416,
     /* 172043 */     GIR_EraseRootFromParent_Done,
     /* 172044 */   // Label 3320: @172044
     /* 172044 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(172089), // Rule ID 1417 //
     /* 172049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172078 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 172081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172087 */     GIR_RootConstrainSelectedInstOperands,
     /* 172088 */     // GIR_Coverage, 1417,
     /* 172088 */     GIR_EraseRootFromParent_Done,
     /* 172089 */   // Label 3321: @172089
     /* 172089 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(172134), // Rule ID 1418 //
     /* 172094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172123 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 172126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172132 */     GIR_RootConstrainSelectedInstOperands,
     /* 172133 */     // GIR_Coverage, 1418,
     /* 172133 */     GIR_EraseRootFromParent_Done,
     /* 172134 */   // Label 3322: @172134
     /* 172134 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(172179), // Rule ID 1419 //
     /* 172139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172168 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 172171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172177 */     GIR_RootConstrainSelectedInstOperands,
     /* 172178 */     // GIR_Coverage, 1419,
     /* 172178 */     GIR_EraseRootFromParent_Done,
     /* 172179 */   // Label 3323: @172179
     /* 172179 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(172224), // Rule ID 1420 //
     /* 172184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172213 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 172216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172222 */     GIR_RootConstrainSelectedInstOperands,
     /* 172223 */     // GIR_Coverage, 1420,
     /* 172223 */     GIR_EraseRootFromParent_Done,
     /* 172224 */   // Label 3324: @172224
     /* 172224 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(172269), // Rule ID 1421 //
     /* 172229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172258 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 172261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172267 */     GIR_RootConstrainSelectedInstOperands,
     /* 172268 */     // GIR_Coverage, 1421,
     /* 172268 */     GIR_EraseRootFromParent_Done,
     /* 172269 */   // Label 3325: @172269
     /* 172269 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(172314), // Rule ID 1422 //
     /* 172274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172303 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 172306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172312 */     GIR_RootConstrainSelectedInstOperands,
     /* 172313 */     // GIR_Coverage, 1422,
     /* 172313 */     GIR_EraseRootFromParent_Done,
     /* 172314 */   // Label 3326: @172314
     /* 172314 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(172359), // Rule ID 1423 //
     /* 172319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172348 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 172351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172357 */     GIR_RootConstrainSelectedInstOperands,
     /* 172358 */     // GIR_Coverage, 1423,
     /* 172358 */     GIR_EraseRootFromParent_Done,
     /* 172359 */   // Label 3327: @172359
     /* 172359 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(172404), // Rule ID 1424 //
     /* 172364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172393 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 172396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172402 */     GIR_RootConstrainSelectedInstOperands,
     /* 172403 */     // GIR_Coverage, 1424,
     /* 172403 */     GIR_EraseRootFromParent_Done,
     /* 172404 */   // Label 3328: @172404
     /* 172404 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(172449), // Rule ID 1425 //
     /* 172409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172438 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 172441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172447 */     GIR_RootConstrainSelectedInstOperands,
     /* 172448 */     // GIR_Coverage, 1425,
     /* 172448 */     GIR_EraseRootFromParent_Done,
     /* 172449 */   // Label 3329: @172449
     /* 172449 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(172494), // Rule ID 1426 //
     /* 172454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172483 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 172486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172492 */     GIR_RootConstrainSelectedInstOperands,
     /* 172493 */     // GIR_Coverage, 1426,
     /* 172493 */     GIR_EraseRootFromParent_Done,
     /* 172494 */   // Label 3330: @172494
     /* 172494 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(172539), // Rule ID 1427 //
     /* 172499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172528 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 172531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172537 */     GIR_RootConstrainSelectedInstOperands,
     /* 172538 */     // GIR_Coverage, 1427,
     /* 172538 */     GIR_EraseRootFromParent_Done,
     /* 172539 */   // Label 3331: @172539
     /* 172539 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(172584), // Rule ID 1428 //
     /* 172544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172573 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 172576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172582 */     GIR_RootConstrainSelectedInstOperands,
     /* 172583 */     // GIR_Coverage, 1428,
     /* 172583 */     GIR_EraseRootFromParent_Done,
     /* 172584 */   // Label 3332: @172584
     /* 172584 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(172629), // Rule ID 1429 //
     /* 172589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172618 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 172621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172627 */     GIR_RootConstrainSelectedInstOperands,
     /* 172628 */     // GIR_Coverage, 1429,
     /* 172628 */     GIR_EraseRootFromParent_Done,
     /* 172629 */   // Label 3333: @172629
     /* 172629 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(172674), // Rule ID 1430 //
     /* 172634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172663 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 172666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172672 */     GIR_RootConstrainSelectedInstOperands,
     /* 172673 */     // GIR_Coverage, 1430,
     /* 172673 */     GIR_EraseRootFromParent_Done,
     /* 172674 */   // Label 3334: @172674
     /* 172674 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(172719), // Rule ID 1431 //
     /* 172679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172708 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 172711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172717 */     GIR_RootConstrainSelectedInstOperands,
     /* 172718 */     // GIR_Coverage, 1431,
     /* 172718 */     GIR_EraseRootFromParent_Done,
     /* 172719 */   // Label 3335: @172719
     /* 172719 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(172764), // Rule ID 1432 //
     /* 172724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172753 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 172756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172762 */     GIR_RootConstrainSelectedInstOperands,
     /* 172763 */     // GIR_Coverage, 1432,
     /* 172763 */     GIR_EraseRootFromParent_Done,
     /* 172764 */   // Label 3336: @172764
     /* 172764 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(172809), // Rule ID 1433 //
     /* 172769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172798 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 172801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172807 */     GIR_RootConstrainSelectedInstOperands,
     /* 172808 */     // GIR_Coverage, 1433,
     /* 172808 */     GIR_EraseRootFromParent_Done,
     /* 172809 */   // Label 3337: @172809
     /* 172809 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(172854), // Rule ID 1434 //
     /* 172814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172843 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 172846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172852 */     GIR_RootConstrainSelectedInstOperands,
     /* 172853 */     // GIR_Coverage, 1434,
     /* 172853 */     GIR_EraseRootFromParent_Done,
     /* 172854 */   // Label 3338: @172854
     /* 172854 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(172899), // Rule ID 1435 //
     /* 172859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172888 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 172891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172897 */     GIR_RootConstrainSelectedInstOperands,
     /* 172898 */     // GIR_Coverage, 1435,
     /* 172898 */     GIR_EraseRootFromParent_Done,
     /* 172899 */   // Label 3339: @172899
     /* 172899 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(172944), // Rule ID 1436 //
     /* 172904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172933 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 172936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172942 */     GIR_RootConstrainSelectedInstOperands,
     /* 172943 */     // GIR_Coverage, 1436,
     /* 172943 */     GIR_EraseRootFromParent_Done,
     /* 172944 */   // Label 3340: @172944
     /* 172944 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(172989), // Rule ID 1437 //
     /* 172949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172978 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 172981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172987 */     GIR_RootConstrainSelectedInstOperands,
     /* 172988 */     // GIR_Coverage, 1437,
     /* 172988 */     GIR_EraseRootFromParent_Done,
     /* 172989 */   // Label 3341: @172989
     /* 172989 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(173034), // Rule ID 1438 //
     /* 172994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173023 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 173026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173032 */     GIR_RootConstrainSelectedInstOperands,
     /* 173033 */     // GIR_Coverage, 1438,
     /* 173033 */     GIR_EraseRootFromParent_Done,
     /* 173034 */   // Label 3342: @173034
     /* 173034 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(173079), // Rule ID 1439 //
     /* 173039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173068 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 173071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173077 */     GIR_RootConstrainSelectedInstOperands,
     /* 173078 */     // GIR_Coverage, 1439,
     /* 173078 */     GIR_EraseRootFromParent_Done,
     /* 173079 */   // Label 3343: @173079
     /* 173079 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(173124), // Rule ID 1440 //
     /* 173084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173113 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 173116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173122 */     GIR_RootConstrainSelectedInstOperands,
     /* 173123 */     // GIR_Coverage, 1440,
     /* 173123 */     GIR_EraseRootFromParent_Done,
     /* 173124 */   // Label 3344: @173124
     /* 173124 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(173169), // Rule ID 1441 //
     /* 173129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173158 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 173161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173167 */     GIR_RootConstrainSelectedInstOperands,
     /* 173168 */     // GIR_Coverage, 1441,
     /* 173168 */     GIR_EraseRootFromParent_Done,
     /* 173169 */   // Label 3345: @173169
     /* 173169 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(173214), // Rule ID 1442 //
     /* 173174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173203 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 173206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173212 */     GIR_RootConstrainSelectedInstOperands,
     /* 173213 */     // GIR_Coverage, 1442,
     /* 173213 */     GIR_EraseRootFromParent_Done,
     /* 173214 */   // Label 3346: @173214
     /* 173214 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(173259), // Rule ID 1443 //
     /* 173219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173248 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 173251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173257 */     GIR_RootConstrainSelectedInstOperands,
     /* 173258 */     // GIR_Coverage, 1443,
     /* 173258 */     GIR_EraseRootFromParent_Done,
     /* 173259 */   // Label 3347: @173259
     /* 173259 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(173304), // Rule ID 1444 //
     /* 173264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173293 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 173296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173302 */     GIR_RootConstrainSelectedInstOperands,
     /* 173303 */     // GIR_Coverage, 1444,
     /* 173303 */     GIR_EraseRootFromParent_Done,
     /* 173304 */   // Label 3348: @173304
     /* 173304 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(173349), // Rule ID 1445 //
     /* 173309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173338 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 173341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173347 */     GIR_RootConstrainSelectedInstOperands,
     /* 173348 */     // GIR_Coverage, 1445,
     /* 173348 */     GIR_EraseRootFromParent_Done,
     /* 173349 */   // Label 3349: @173349
     /* 173349 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(173394), // Rule ID 1446 //
     /* 173354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173383 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 173386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173392 */     GIR_RootConstrainSelectedInstOperands,
     /* 173393 */     // GIR_Coverage, 1446,
     /* 173393 */     GIR_EraseRootFromParent_Done,
     /* 173394 */   // Label 3350: @173394
     /* 173394 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(173439), // Rule ID 1447 //
     /* 173399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173428 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 173431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173437 */     GIR_RootConstrainSelectedInstOperands,
     /* 173438 */     // GIR_Coverage, 1447,
     /* 173438 */     GIR_EraseRootFromParent_Done,
     /* 173439 */   // Label 3351: @173439
     /* 173439 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(173484), // Rule ID 1448 //
     /* 173444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173473 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 173476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173482 */     GIR_RootConstrainSelectedInstOperands,
     /* 173483 */     // GIR_Coverage, 1448,
     /* 173483 */     GIR_EraseRootFromParent_Done,
     /* 173484 */   // Label 3352: @173484
     /* 173484 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(173529), // Rule ID 1449 //
     /* 173489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173518 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 173521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173527 */     GIR_RootConstrainSelectedInstOperands,
     /* 173528 */     // GIR_Coverage, 1449,
     /* 173528 */     GIR_EraseRootFromParent_Done,
     /* 173529 */   // Label 3353: @173529
     /* 173529 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(173574), // Rule ID 1450 //
     /* 173534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173563 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 173566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173572 */     GIR_RootConstrainSelectedInstOperands,
     /* 173573 */     // GIR_Coverage, 1450,
     /* 173573 */     GIR_EraseRootFromParent_Done,
     /* 173574 */   // Label 3354: @173574
     /* 173574 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(173619), // Rule ID 1451 //
     /* 173579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173608 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 173611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173617 */     GIR_RootConstrainSelectedInstOperands,
     /* 173618 */     // GIR_Coverage, 1451,
     /* 173618 */     GIR_EraseRootFromParent_Done,
     /* 173619 */   // Label 3355: @173619
     /* 173619 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(173664), // Rule ID 1458 //
     /* 173624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173653 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 173656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173662 */     GIR_RootConstrainSelectedInstOperands,
     /* 173663 */     // GIR_Coverage, 1458,
     /* 173663 */     GIR_EraseRootFromParent_Done,
     /* 173664 */   // Label 3356: @173664
     /* 173664 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(173709), // Rule ID 1459 //
     /* 173669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173698 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 173701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173707 */     GIR_RootConstrainSelectedInstOperands,
     /* 173708 */     // GIR_Coverage, 1459,
     /* 173708 */     GIR_EraseRootFromParent_Done,
     /* 173709 */   // Label 3357: @173709
     /* 173709 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(173754), // Rule ID 1460 //
     /* 173714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173743 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 173746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173752 */     GIR_RootConstrainSelectedInstOperands,
     /* 173753 */     // GIR_Coverage, 1460,
     /* 173753 */     GIR_EraseRootFromParent_Done,
     /* 173754 */   // Label 3358: @173754
     /* 173754 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(173799), // Rule ID 1461 //
     /* 173759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173788 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 173791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173797 */     GIR_RootConstrainSelectedInstOperands,
     /* 173798 */     // GIR_Coverage, 1461,
     /* 173798 */     GIR_EraseRootFromParent_Done,
     /* 173799 */   // Label 3359: @173799
     /* 173799 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(173844), // Rule ID 1462 //
     /* 173804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173833 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 173836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173842 */     GIR_RootConstrainSelectedInstOperands,
     /* 173843 */     // GIR_Coverage, 1462,
     /* 173843 */     GIR_EraseRootFromParent_Done,
     /* 173844 */   // Label 3360: @173844
     /* 173844 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(173889), // Rule ID 1463 //
     /* 173849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173878 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 173881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173887 */     GIR_RootConstrainSelectedInstOperands,
     /* 173888 */     // GIR_Coverage, 1463,
     /* 173888 */     GIR_EraseRootFromParent_Done,
     /* 173889 */   // Label 3361: @173889
     /* 173889 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(173934), // Rule ID 1464 //
     /* 173894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173923 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 173926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173932 */     GIR_RootConstrainSelectedInstOperands,
     /* 173933 */     // GIR_Coverage, 1464,
     /* 173933 */     GIR_EraseRootFromParent_Done,
     /* 173934 */   // Label 3362: @173934
     /* 173934 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(173979), // Rule ID 1465 //
     /* 173939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173968 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 173971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173977 */     GIR_RootConstrainSelectedInstOperands,
     /* 173978 */     // GIR_Coverage, 1465,
     /* 173978 */     GIR_EraseRootFromParent_Done,
     /* 173979 */   // Label 3363: @173979
     /* 173979 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(174024), // Rule ID 1466 //
     /* 173984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174013 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 174016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174022 */     GIR_RootConstrainSelectedInstOperands,
     /* 174023 */     // GIR_Coverage, 1466,
     /* 174023 */     GIR_EraseRootFromParent_Done,
     /* 174024 */   // Label 3364: @174024
     /* 174024 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(174069), // Rule ID 1467 //
     /* 174029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174058 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 174061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174067 */     GIR_RootConstrainSelectedInstOperands,
     /* 174068 */     // GIR_Coverage, 1467,
     /* 174068 */     GIR_EraseRootFromParent_Done,
     /* 174069 */   // Label 3365: @174069
     /* 174069 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(174114), // Rule ID 1468 //
     /* 174074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174103 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 174106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174112 */     GIR_RootConstrainSelectedInstOperands,
     /* 174113 */     // GIR_Coverage, 1468,
     /* 174113 */     GIR_EraseRootFromParent_Done,
     /* 174114 */   // Label 3366: @174114
     /* 174114 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(174159), // Rule ID 1469 //
     /* 174119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174148 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 174151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174157 */     GIR_RootConstrainSelectedInstOperands,
     /* 174158 */     // GIR_Coverage, 1469,
     /* 174158 */     GIR_EraseRootFromParent_Done,
     /* 174159 */   // Label 3367: @174159
     /* 174159 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(174204), // Rule ID 1470 //
     /* 174164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174193 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 174196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174202 */     GIR_RootConstrainSelectedInstOperands,
     /* 174203 */     // GIR_Coverage, 1470,
     /* 174203 */     GIR_EraseRootFromParent_Done,
     /* 174204 */   // Label 3368: @174204
     /* 174204 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(174249), // Rule ID 1471 //
     /* 174209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174238 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 174241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174247 */     GIR_RootConstrainSelectedInstOperands,
     /* 174248 */     // GIR_Coverage, 1471,
     /* 174248 */     GIR_EraseRootFromParent_Done,
     /* 174249 */   // Label 3369: @174249
     /* 174249 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(174294), // Rule ID 1492 //
     /* 174254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174283 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 174286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174292 */     GIR_RootConstrainSelectedInstOperands,
     /* 174293 */     // GIR_Coverage, 1492,
     /* 174293 */     GIR_EraseRootFromParent_Done,
     /* 174294 */   // Label 3370: @174294
     /* 174294 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(174339), // Rule ID 1494 //
     /* 174299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174328 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 174331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174337 */     GIR_RootConstrainSelectedInstOperands,
     /* 174338 */     // GIR_Coverage, 1494,
     /* 174338 */     GIR_EraseRootFromParent_Done,
     /* 174339 */   // Label 3371: @174339
     /* 174339 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(174384), // Rule ID 1496 //
     /* 174344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174373 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 174376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174382 */     GIR_RootConstrainSelectedInstOperands,
     /* 174383 */     // GIR_Coverage, 1496,
     /* 174383 */     GIR_EraseRootFromParent_Done,
     /* 174384 */   // Label 3372: @174384
     /* 174384 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(174429), // Rule ID 1498 //
     /* 174389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174418 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 174421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174427 */     GIR_RootConstrainSelectedInstOperands,
     /* 174428 */     // GIR_Coverage, 1498,
     /* 174428 */     GIR_EraseRootFromParent_Done,
     /* 174429 */   // Label 3373: @174429
     /* 174429 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(174474), // Rule ID 1500 //
     /* 174434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174463 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 174466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174472 */     GIR_RootConstrainSelectedInstOperands,
     /* 174473 */     // GIR_Coverage, 1500,
     /* 174473 */     GIR_EraseRootFromParent_Done,
     /* 174474 */   // Label 3374: @174474
     /* 174474 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(174519), // Rule ID 1502 //
     /* 174479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174508 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 174511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174517 */     GIR_RootConstrainSelectedInstOperands,
     /* 174518 */     // GIR_Coverage, 1502,
     /* 174518 */     GIR_EraseRootFromParent_Done,
     /* 174519 */   // Label 3375: @174519
     /* 174519 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(174564), // Rule ID 1509 //
     /* 174524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174553 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 174556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174562 */     GIR_RootConstrainSelectedInstOperands,
     /* 174563 */     // GIR_Coverage, 1509,
     /* 174563 */     GIR_EraseRootFromParent_Done,
     /* 174564 */   // Label 3376: @174564
     /* 174564 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(174609), // Rule ID 1510 //
     /* 174569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174598 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 174601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174607 */     GIR_RootConstrainSelectedInstOperands,
     /* 174608 */     // GIR_Coverage, 1510,
     /* 174608 */     GIR_EraseRootFromParent_Done,
     /* 174609 */   // Label 3377: @174609
     /* 174609 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(174654), // Rule ID 1511 //
     /* 174614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174643 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 174646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174652 */     GIR_RootConstrainSelectedInstOperands,
     /* 174653 */     // GIR_Coverage, 1511,
     /* 174653 */     GIR_EraseRootFromParent_Done,
     /* 174654 */   // Label 3378: @174654
     /* 174654 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(174699), // Rule ID 1512 //
     /* 174659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174688 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 174691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174697 */     GIR_RootConstrainSelectedInstOperands,
     /* 174698 */     // GIR_Coverage, 1512,
     /* 174698 */     GIR_EraseRootFromParent_Done,
     /* 174699 */   // Label 3379: @174699
     /* 174699 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(174744), // Rule ID 1513 //
     /* 174704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174733 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 174736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174742 */     GIR_RootConstrainSelectedInstOperands,
     /* 174743 */     // GIR_Coverage, 1513,
     /* 174743 */     GIR_EraseRootFromParent_Done,
     /* 174744 */   // Label 3380: @174744
     /* 174744 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(174789), // Rule ID 1514 //
     /* 174749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174778 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 174781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174787 */     GIR_RootConstrainSelectedInstOperands,
     /* 174788 */     // GIR_Coverage, 1514,
     /* 174788 */     GIR_EraseRootFromParent_Done,
     /* 174789 */   // Label 3381: @174789
     /* 174789 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(174834), // Rule ID 1515 //
     /* 174794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174823 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 174826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174832 */     GIR_RootConstrainSelectedInstOperands,
     /* 174833 */     // GIR_Coverage, 1515,
     /* 174833 */     GIR_EraseRootFromParent_Done,
     /* 174834 */   // Label 3382: @174834
     /* 174834 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(174879), // Rule ID 1516 //
     /* 174839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174868 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 174871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174877 */     GIR_RootConstrainSelectedInstOperands,
     /* 174878 */     // GIR_Coverage, 1516,
     /* 174878 */     GIR_EraseRootFromParent_Done,
     /* 174879 */   // Label 3383: @174879
     /* 174879 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(174924), // Rule ID 1517 //
     /* 174884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174913 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 174916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174922 */     GIR_RootConstrainSelectedInstOperands,
     /* 174923 */     // GIR_Coverage, 1517,
     /* 174923 */     GIR_EraseRootFromParent_Done,
     /* 174924 */   // Label 3384: @174924
     /* 174924 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(174969), // Rule ID 1518 //
     /* 174929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174958 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 174961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174967 */     GIR_RootConstrainSelectedInstOperands,
     /* 174968 */     // GIR_Coverage, 1518,
     /* 174968 */     GIR_EraseRootFromParent_Done,
     /* 174969 */   // Label 3385: @174969
     /* 174969 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(175014), // Rule ID 1519 //
     /* 174974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175003 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 175006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175012 */     GIR_RootConstrainSelectedInstOperands,
     /* 175013 */     // GIR_Coverage, 1519,
     /* 175013 */     GIR_EraseRootFromParent_Done,
     /* 175014 */   // Label 3386: @175014
     /* 175014 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(175059), // Rule ID 1520 //
     /* 175019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175048 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 175051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175057 */     GIR_RootConstrainSelectedInstOperands,
     /* 175058 */     // GIR_Coverage, 1520,
     /* 175058 */     GIR_EraseRootFromParent_Done,
     /* 175059 */   // Label 3387: @175059
     /* 175059 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175104), // Rule ID 1527 //
     /* 175064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175093 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 175096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175102 */     GIR_RootConstrainSelectedInstOperands,
     /* 175103 */     // GIR_Coverage, 1527,
     /* 175103 */     GIR_EraseRootFromParent_Done,
     /* 175104 */   // Label 3388: @175104
     /* 175104 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175149), // Rule ID 1528 //
     /* 175109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175138 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 175141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175147 */     GIR_RootConstrainSelectedInstOperands,
     /* 175148 */     // GIR_Coverage, 1528,
     /* 175148 */     GIR_EraseRootFromParent_Done,
     /* 175149 */   // Label 3389: @175149
     /* 175149 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(175194), // Rule ID 1529 //
     /* 175154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175183 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 175186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175192 */     GIR_RootConstrainSelectedInstOperands,
     /* 175193 */     // GIR_Coverage, 1529,
     /* 175193 */     GIR_EraseRootFromParent_Done,
     /* 175194 */   // Label 3390: @175194
     /* 175194 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175239), // Rule ID 1530 //
     /* 175199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175228 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 175231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175237 */     GIR_RootConstrainSelectedInstOperands,
     /* 175238 */     // GIR_Coverage, 1530,
     /* 175238 */     GIR_EraseRootFromParent_Done,
     /* 175239 */   // Label 3391: @175239
     /* 175239 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175284), // Rule ID 1531 //
     /* 175244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175273 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 175276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175282 */     GIR_RootConstrainSelectedInstOperands,
     /* 175283 */     // GIR_Coverage, 1531,
     /* 175283 */     GIR_EraseRootFromParent_Done,
     /* 175284 */   // Label 3392: @175284
     /* 175284 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175329), // Rule ID 1532 //
     /* 175289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175318 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 175321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175327 */     GIR_RootConstrainSelectedInstOperands,
     /* 175328 */     // GIR_Coverage, 1532,
     /* 175328 */     GIR_EraseRootFromParent_Done,
     /* 175329 */   // Label 3393: @175329
     /* 175329 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175374), // Rule ID 1539 //
     /* 175334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175363 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 175366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175372 */     GIR_RootConstrainSelectedInstOperands,
     /* 175373 */     // GIR_Coverage, 1539,
     /* 175373 */     GIR_EraseRootFromParent_Done,
     /* 175374 */   // Label 3394: @175374
     /* 175374 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(175419), // Rule ID 1540 //
     /* 175379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175408 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 175411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175417 */     GIR_RootConstrainSelectedInstOperands,
     /* 175418 */     // GIR_Coverage, 1540,
     /* 175418 */     GIR_EraseRootFromParent_Done,
     /* 175419 */   // Label 3395: @175419
     /* 175419 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(175464), // Rule ID 1541 //
     /* 175424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175453 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 175456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175462 */     GIR_RootConstrainSelectedInstOperands,
     /* 175463 */     // GIR_Coverage, 1541,
     /* 175463 */     GIR_EraseRootFromParent_Done,
     /* 175464 */   // Label 3396: @175464
     /* 175464 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(175509), // Rule ID 1542 //
     /* 175469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175498 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 175501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175507 */     GIR_RootConstrainSelectedInstOperands,
     /* 175508 */     // GIR_Coverage, 1542,
     /* 175508 */     GIR_EraseRootFromParent_Done,
     /* 175509 */   // Label 3397: @175509
     /* 175509 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(175554), // Rule ID 1543 //
     /* 175514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175543 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 175546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175552 */     GIR_RootConstrainSelectedInstOperands,
     /* 175553 */     // GIR_Coverage, 1543,
     /* 175553 */     GIR_EraseRootFromParent_Done,
     /* 175554 */   // Label 3398: @175554
     /* 175554 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(175599), // Rule ID 1544 //
     /* 175559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 175591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175597 */     GIR_RootConstrainSelectedInstOperands,
     /* 175598 */     // GIR_Coverage, 1544,
     /* 175598 */     GIR_EraseRootFromParent_Done,
     /* 175599 */   // Label 3399: @175599
     /* 175599 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(175644), // Rule ID 1545 //
     /* 175604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175633 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 175636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175642 */     GIR_RootConstrainSelectedInstOperands,
     /* 175643 */     // GIR_Coverage, 1545,
     /* 175643 */     GIR_EraseRootFromParent_Done,
     /* 175644 */   // Label 3400: @175644
     /* 175644 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(175689), // Rule ID 1546 //
     /* 175649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175678 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 175681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175687 */     GIR_RootConstrainSelectedInstOperands,
     /* 175688 */     // GIR_Coverage, 1546,
     /* 175688 */     GIR_EraseRootFromParent_Done,
     /* 175689 */   // Label 3401: @175689
     /* 175689 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(175734), // Rule ID 1547 //
     /* 175694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175723 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 175726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175732 */     GIR_RootConstrainSelectedInstOperands,
     /* 175733 */     // GIR_Coverage, 1547,
     /* 175733 */     GIR_EraseRootFromParent_Done,
     /* 175734 */   // Label 3402: @175734
     /* 175734 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(175779), // Rule ID 1548 //
     /* 175739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175768 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 175771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175777 */     GIR_RootConstrainSelectedInstOperands,
     /* 175778 */     // GIR_Coverage, 1548,
     /* 175778 */     GIR_EraseRootFromParent_Done,
     /* 175779 */   // Label 3403: @175779
     /* 175779 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(175824), // Rule ID 1549 //
     /* 175784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175813 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 175816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175822 */     GIR_RootConstrainSelectedInstOperands,
     /* 175823 */     // GIR_Coverage, 1549,
     /* 175823 */     GIR_EraseRootFromParent_Done,
     /* 175824 */   // Label 3404: @175824
     /* 175824 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(175869), // Rule ID 1550 //
     /* 175829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175858 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 175861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175867 */     GIR_RootConstrainSelectedInstOperands,
     /* 175868 */     // GIR_Coverage, 1550,
     /* 175868 */     GIR_EraseRootFromParent_Done,
     /* 175869 */   // Label 3405: @175869
     /* 175869 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(175914), // Rule ID 1551 //
     /* 175874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175903 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 175906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175912 */     GIR_RootConstrainSelectedInstOperands,
     /* 175913 */     // GIR_Coverage, 1551,
     /* 175913 */     GIR_EraseRootFromParent_Done,
     /* 175914 */   // Label 3406: @175914
     /* 175914 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(175959), // Rule ID 1552 //
     /* 175919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175948 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 175951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175957 */     GIR_RootConstrainSelectedInstOperands,
     /* 175958 */     // GIR_Coverage, 1552,
     /* 175958 */     GIR_EraseRootFromParent_Done,
     /* 175959 */   // Label 3407: @175959
     /* 175959 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(176004), // Rule ID 1553 //
     /* 175964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175993 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 175996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176002 */     GIR_RootConstrainSelectedInstOperands,
     /* 176003 */     // GIR_Coverage, 1553,
     /* 176003 */     GIR_EraseRootFromParent_Done,
     /* 176004 */   // Label 3408: @176004
     /* 176004 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(176049), // Rule ID 1554 //
     /* 176009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176038 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 176041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176047 */     GIR_RootConstrainSelectedInstOperands,
     /* 176048 */     // GIR_Coverage, 1554,
     /* 176048 */     GIR_EraseRootFromParent_Done,
     /* 176049 */   // Label 3409: @176049
     /* 176049 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176094), // Rule ID 1555 //
     /* 176054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176083 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 176086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176092 */     GIR_RootConstrainSelectedInstOperands,
     /* 176093 */     // GIR_Coverage, 1555,
     /* 176093 */     GIR_EraseRootFromParent_Done,
     /* 176094 */   // Label 3410: @176094
     /* 176094 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(176139), // Rule ID 1556 //
     /* 176099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176128 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 176131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176137 */     GIR_RootConstrainSelectedInstOperands,
     /* 176138 */     // GIR_Coverage, 1556,
     /* 176138 */     GIR_EraseRootFromParent_Done,
     /* 176139 */   // Label 3411: @176139
     /* 176139 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(176184), // Rule ID 1557 //
     /* 176144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176173 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 176176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176182 */     GIR_RootConstrainSelectedInstOperands,
     /* 176183 */     // GIR_Coverage, 1557,
     /* 176183 */     GIR_EraseRootFromParent_Done,
     /* 176184 */   // Label 3412: @176184
     /* 176184 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(176229), // Rule ID 1558 //
     /* 176189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176218 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 176221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176227 */     GIR_RootConstrainSelectedInstOperands,
     /* 176228 */     // GIR_Coverage, 1558,
     /* 176228 */     GIR_EraseRootFromParent_Done,
     /* 176229 */   // Label 3413: @176229
     /* 176229 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(176274), // Rule ID 1559 //
     /* 176234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176263 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 176266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176272 */     GIR_RootConstrainSelectedInstOperands,
     /* 176273 */     // GIR_Coverage, 1559,
     /* 176273 */     GIR_EraseRootFromParent_Done,
     /* 176274 */   // Label 3414: @176274
     /* 176274 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(176319), // Rule ID 1560 //
     /* 176279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176308 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 176311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176317 */     GIR_RootConstrainSelectedInstOperands,
     /* 176318 */     // GIR_Coverage, 1560,
     /* 176318 */     GIR_EraseRootFromParent_Done,
     /* 176319 */   // Label 3415: @176319
     /* 176319 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(176364), // Rule ID 1561 //
     /* 176324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176353 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 176356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176362 */     GIR_RootConstrainSelectedInstOperands,
     /* 176363 */     // GIR_Coverage, 1561,
     /* 176363 */     GIR_EraseRootFromParent_Done,
     /* 176364 */   // Label 3416: @176364
     /* 176364 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(176409), // Rule ID 1562 //
     /* 176369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176398 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 176401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176407 */     GIR_RootConstrainSelectedInstOperands,
     /* 176408 */     // GIR_Coverage, 1562,
     /* 176408 */     GIR_EraseRootFromParent_Done,
     /* 176409 */   // Label 3417: @176409
     /* 176409 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(176454), // Rule ID 1563 //
     /* 176414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176443 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 176446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176452 */     GIR_RootConstrainSelectedInstOperands,
     /* 176453 */     // GIR_Coverage, 1563,
     /* 176453 */     GIR_EraseRootFromParent_Done,
     /* 176454 */   // Label 3418: @176454
     /* 176454 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(176499), // Rule ID 1564 //
     /* 176459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176488 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 176491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176497 */     GIR_RootConstrainSelectedInstOperands,
     /* 176498 */     // GIR_Coverage, 1564,
     /* 176498 */     GIR_EraseRootFromParent_Done,
     /* 176499 */   // Label 3419: @176499
     /* 176499 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(176544), // Rule ID 1565 //
     /* 176504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176533 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 176536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176542 */     GIR_RootConstrainSelectedInstOperands,
     /* 176543 */     // GIR_Coverage, 1565,
     /* 176543 */     GIR_EraseRootFromParent_Done,
     /* 176544 */   // Label 3420: @176544
     /* 176544 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(176589), // Rule ID 1566 //
     /* 176549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176578 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 176581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176587 */     GIR_RootConstrainSelectedInstOperands,
     /* 176588 */     // GIR_Coverage, 1566,
     /* 176588 */     GIR_EraseRootFromParent_Done,
     /* 176589 */   // Label 3421: @176589
     /* 176589 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(176634), // Rule ID 1573 //
     /* 176594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176623 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 176626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176632 */     GIR_RootConstrainSelectedInstOperands,
     /* 176633 */     // GIR_Coverage, 1573,
     /* 176633 */     GIR_EraseRootFromParent_Done,
     /* 176634 */   // Label 3422: @176634
     /* 176634 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(176679), // Rule ID 1574 //
     /* 176639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176668 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 176671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176677 */     GIR_RootConstrainSelectedInstOperands,
     /* 176678 */     // GIR_Coverage, 1574,
     /* 176678 */     GIR_EraseRootFromParent_Done,
     /* 176679 */   // Label 3423: @176679
     /* 176679 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(176724), // Rule ID 1575 //
     /* 176684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176713 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 176716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176722 */     GIR_RootConstrainSelectedInstOperands,
     /* 176723 */     // GIR_Coverage, 1575,
     /* 176723 */     GIR_EraseRootFromParent_Done,
     /* 176724 */   // Label 3424: @176724
     /* 176724 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(176769), // Rule ID 1576 //
     /* 176729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176758 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 176761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176767 */     GIR_RootConstrainSelectedInstOperands,
     /* 176768 */     // GIR_Coverage, 1576,
     /* 176768 */     GIR_EraseRootFromParent_Done,
     /* 176769 */   // Label 3425: @176769
     /* 176769 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(176814), // Rule ID 1577 //
     /* 176774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176803 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 176806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176812 */     GIR_RootConstrainSelectedInstOperands,
     /* 176813 */     // GIR_Coverage, 1577,
     /* 176813 */     GIR_EraseRootFromParent_Done,
     /* 176814 */   // Label 3426: @176814
     /* 176814 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(176859), // Rule ID 1578 //
     /* 176819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176848 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 176851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176857 */     GIR_RootConstrainSelectedInstOperands,
     /* 176858 */     // GIR_Coverage, 1578,
     /* 176858 */     GIR_EraseRootFromParent_Done,
     /* 176859 */   // Label 3427: @176859
     /* 176859 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(176904), // Rule ID 1579 //
     /* 176864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176893 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 176896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176902 */     GIR_RootConstrainSelectedInstOperands,
     /* 176903 */     // GIR_Coverage, 1579,
     /* 176903 */     GIR_EraseRootFromParent_Done,
     /* 176904 */   // Label 3428: @176904
     /* 176904 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(176949), // Rule ID 1580 //
     /* 176909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176938 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 176941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176947 */     GIR_RootConstrainSelectedInstOperands,
     /* 176948 */     // GIR_Coverage, 1580,
     /* 176948 */     GIR_EraseRootFromParent_Done,
     /* 176949 */   // Label 3429: @176949
     /* 176949 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(176994), // Rule ID 1581 //
     /* 176954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176983 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 176986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176992 */     GIR_RootConstrainSelectedInstOperands,
     /* 176993 */     // GIR_Coverage, 1581,
     /* 176993 */     GIR_EraseRootFromParent_Done,
     /* 176994 */   // Label 3430: @176994
     /* 176994 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(177039), // Rule ID 1582 //
     /* 176999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177028 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 177031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177037 */     GIR_RootConstrainSelectedInstOperands,
     /* 177038 */     // GIR_Coverage, 1582,
     /* 177038 */     GIR_EraseRootFromParent_Done,
     /* 177039 */   // Label 3431: @177039
     /* 177039 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(177084), // Rule ID 1583 //
     /* 177044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177073 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 177076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177082 */     GIR_RootConstrainSelectedInstOperands,
     /* 177083 */     // GIR_Coverage, 1583,
     /* 177083 */     GIR_EraseRootFromParent_Done,
     /* 177084 */   // Label 3432: @177084
     /* 177084 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(177129), // Rule ID 1584 //
     /* 177089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177118 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 177121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177127 */     GIR_RootConstrainSelectedInstOperands,
     /* 177128 */     // GIR_Coverage, 1584,
     /* 177128 */     GIR_EraseRootFromParent_Done,
     /* 177129 */   // Label 3433: @177129
     /* 177129 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(177174), // Rule ID 1585 //
     /* 177134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177163 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 177166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177172 */     GIR_RootConstrainSelectedInstOperands,
     /* 177173 */     // GIR_Coverage, 1585,
     /* 177173 */     GIR_EraseRootFromParent_Done,
     /* 177174 */   // Label 3434: @177174
     /* 177174 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(177219), // Rule ID 1586 //
     /* 177179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177208 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 177211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177217 */     GIR_RootConstrainSelectedInstOperands,
     /* 177218 */     // GIR_Coverage, 1586,
     /* 177218 */     GIR_EraseRootFromParent_Done,
     /* 177219 */   // Label 3435: @177219
     /* 177219 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(177264), // Rule ID 1614 //
     /* 177224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177253 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 177256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177262 */     GIR_RootConstrainSelectedInstOperands,
     /* 177263 */     // GIR_Coverage, 1614,
     /* 177263 */     GIR_EraseRootFromParent_Done,
     /* 177264 */   // Label 3436: @177264
     /* 177264 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(177309), // Rule ID 1615 //
     /* 177269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177298 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 177301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177307 */     GIR_RootConstrainSelectedInstOperands,
     /* 177308 */     // GIR_Coverage, 1615,
     /* 177308 */     GIR_EraseRootFromParent_Done,
     /* 177309 */   // Label 3437: @177309
     /* 177309 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(177354), // Rule ID 1616 //
     /* 177314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 177317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177343 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 177346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177352 */     GIR_RootConstrainSelectedInstOperands,
     /* 177353 */     // GIR_Coverage, 1616,
     /* 177353 */     GIR_EraseRootFromParent_Done,
     /* 177354 */   // Label 3438: @177354
     /* 177354 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(177399), // Rule ID 1617 //
     /* 177359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 177367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177388 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 177391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177397 */     GIR_RootConstrainSelectedInstOperands,
     /* 177398 */     // GIR_Coverage, 1617,
     /* 177398 */     GIR_EraseRootFromParent_Done,
     /* 177399 */   // Label 3439: @177399
     /* 177399 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(177444), // Rule ID 1618 //
     /* 177404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 177412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177433 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 177436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177442 */     GIR_RootConstrainSelectedInstOperands,
     /* 177443 */     // GIR_Coverage, 1618,
     /* 177443 */     GIR_EraseRootFromParent_Done,
     /* 177444 */   // Label 3440: @177444
     /* 177444 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(177489), // Rule ID 1619 //
     /* 177449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177478 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 177481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177487 */     GIR_RootConstrainSelectedInstOperands,
     /* 177488 */     // GIR_Coverage, 1619,
     /* 177488 */     GIR_EraseRootFromParent_Done,
     /* 177489 */   // Label 3441: @177489
     /* 177489 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(177534), // Rule ID 1620 //
     /* 177494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177523 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 177526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177532 */     GIR_RootConstrainSelectedInstOperands,
     /* 177533 */     // GIR_Coverage, 1620,
     /* 177533 */     GIR_EraseRootFromParent_Done,
     /* 177534 */   // Label 3442: @177534
     /* 177534 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(177579), // Rule ID 1627 //
     /* 177539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177568 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177577 */     GIR_RootConstrainSelectedInstOperands,
     /* 177578 */     // GIR_Coverage, 1627,
     /* 177578 */     GIR_EraseRootFromParent_Done,
     /* 177579 */   // Label 3443: @177579
     /* 177579 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(177624), // Rule ID 1628 //
     /* 177584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177613 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177622 */     GIR_RootConstrainSelectedInstOperands,
     /* 177623 */     // GIR_Coverage, 1628,
     /* 177623 */     GIR_EraseRootFromParent_Done,
     /* 177624 */   // Label 3444: @177624
     /* 177624 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(177669), // Rule ID 1629 //
     /* 177629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177658 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177667 */     GIR_RootConstrainSelectedInstOperands,
     /* 177668 */     // GIR_Coverage, 1629,
     /* 177668 */     GIR_EraseRootFromParent_Done,
     /* 177669 */   // Label 3445: @177669
     /* 177669 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(177714), // Rule ID 1630 //
     /* 177674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177703 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 177706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177712 */     GIR_RootConstrainSelectedInstOperands,
     /* 177713 */     // GIR_Coverage, 1630,
     /* 177713 */     GIR_EraseRootFromParent_Done,
     /* 177714 */   // Label 3446: @177714
     /* 177714 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(177759), // Rule ID 1631 //
     /* 177719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177748 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 177751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177757 */     GIR_RootConstrainSelectedInstOperands,
     /* 177758 */     // GIR_Coverage, 1631,
     /* 177758 */     GIR_EraseRootFromParent_Done,
     /* 177759 */   // Label 3447: @177759
     /* 177759 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(177804), // Rule ID 1632 //
     /* 177764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177793 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 177796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177802 */     GIR_RootConstrainSelectedInstOperands,
     /* 177803 */     // GIR_Coverage, 1632,
     /* 177803 */     GIR_EraseRootFromParent_Done,
     /* 177804 */   // Label 3448: @177804
     /* 177804 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(177849), // Rule ID 1633 //
     /* 177809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177838 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 177841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177847 */     GIR_RootConstrainSelectedInstOperands,
     /* 177848 */     // GIR_Coverage, 1633,
     /* 177848 */     GIR_EraseRootFromParent_Done,
     /* 177849 */   // Label 3449: @177849
     /* 177849 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(177894), // Rule ID 1634 //
     /* 177854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177883 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 177886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177892 */     GIR_RootConstrainSelectedInstOperands,
     /* 177893 */     // GIR_Coverage, 1634,
     /* 177893 */     GIR_EraseRootFromParent_Done,
     /* 177894 */   // Label 3450: @177894
     /* 177894 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(177939), // Rule ID 1635 //
     /* 177899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177928 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 177931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177937 */     GIR_RootConstrainSelectedInstOperands,
     /* 177938 */     // GIR_Coverage, 1635,
     /* 177938 */     GIR_EraseRootFromParent_Done,
     /* 177939 */   // Label 3451: @177939
     /* 177939 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(177984), // Rule ID 1636 //
     /* 177944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177973 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 177976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177982 */     GIR_RootConstrainSelectedInstOperands,
     /* 177983 */     // GIR_Coverage, 1636,
     /* 177983 */     GIR_EraseRootFromParent_Done,
     /* 177984 */   // Label 3452: @177984
     /* 177984 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(178029), // Rule ID 1637 //
     /* 177989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178018 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 178021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178027 */     GIR_RootConstrainSelectedInstOperands,
     /* 178028 */     // GIR_Coverage, 1637,
     /* 178028 */     GIR_EraseRootFromParent_Done,
     /* 178029 */   // Label 3453: @178029
     /* 178029 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(178074), // Rule ID 1638 //
     /* 178034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178063 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 178066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178072 */     GIR_RootConstrainSelectedInstOperands,
     /* 178073 */     // GIR_Coverage, 1638,
     /* 178073 */     GIR_EraseRootFromParent_Done,
     /* 178074 */   // Label 3454: @178074
     /* 178074 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(178119), // Rule ID 1639 //
     /* 178079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 178087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178108 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 178111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178117 */     GIR_RootConstrainSelectedInstOperands,
     /* 178118 */     // GIR_Coverage, 1639,
     /* 178118 */     GIR_EraseRootFromParent_Done,
     /* 178119 */   // Label 3455: @178119
     /* 178119 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(178164), // Rule ID 1640 //
     /* 178124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 178132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178153 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 178156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178162 */     GIR_RootConstrainSelectedInstOperands,
     /* 178163 */     // GIR_Coverage, 1640,
     /* 178163 */     GIR_EraseRootFromParent_Done,
     /* 178164 */   // Label 3456: @178164
     /* 178164 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(178209), // Rule ID 1641 //
     /* 178169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178198 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 178201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178207 */     GIR_RootConstrainSelectedInstOperands,
     /* 178208 */     // GIR_Coverage, 1641,
     /* 178208 */     GIR_EraseRootFromParent_Done,
     /* 178209 */   // Label 3457: @178209
     /* 178209 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(178254), // Rule ID 1642 //
     /* 178214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 178222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178243 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 178246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178252 */     GIR_RootConstrainSelectedInstOperands,
     /* 178253 */     // GIR_Coverage, 1642,
     /* 178253 */     GIR_EraseRootFromParent_Done,
     /* 178254 */   // Label 3458: @178254
     /* 178254 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(178299), // Rule ID 1643 //
     /* 178259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 178267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178288 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 178291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178297 */     GIR_RootConstrainSelectedInstOperands,
     /* 178298 */     // GIR_Coverage, 1643,
     /* 178298 */     GIR_EraseRootFromParent_Done,
     /* 178299 */   // Label 3459: @178299
     /* 178299 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(178344), // Rule ID 1645 //
     /* 178304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 178312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178333 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 178336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178342 */     GIR_RootConstrainSelectedInstOperands,
     /* 178343 */     // GIR_Coverage, 1645,
     /* 178343 */     GIR_EraseRootFromParent_Done,
     /* 178344 */   // Label 3460: @178344
     /* 178344 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(178389), // Rule ID 1646 //
     /* 178349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178378 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 178381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178387 */     GIR_RootConstrainSelectedInstOperands,
     /* 178388 */     // GIR_Coverage, 1646,
     /* 178388 */     GIR_EraseRootFromParent_Done,
     /* 178389 */   // Label 3461: @178389
     /* 178389 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(178434), // Rule ID 1647 //
     /* 178394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178423 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 178426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178432 */     GIR_RootConstrainSelectedInstOperands,
     /* 178433 */     // GIR_Coverage, 1647,
     /* 178433 */     GIR_EraseRootFromParent_Done,
     /* 178434 */   // Label 3462: @178434
     /* 178434 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(178479), // Rule ID 1648 //
     /* 178439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178468 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 178471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178477 */     GIR_RootConstrainSelectedInstOperands,
     /* 178478 */     // GIR_Coverage, 1648,
     /* 178478 */     GIR_EraseRootFromParent_Done,
     /* 178479 */   // Label 3463: @178479
     /* 178479 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(178524), // Rule ID 1649 //
     /* 178484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 178492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178513 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 178516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178522 */     GIR_RootConstrainSelectedInstOperands,
     /* 178523 */     // GIR_Coverage, 1649,
     /* 178523 */     GIR_EraseRootFromParent_Done,
     /* 178524 */   // Label 3464: @178524
     /* 178524 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(178569), // Rule ID 1650 //
     /* 178529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 178537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178558 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 178561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178567 */     GIR_RootConstrainSelectedInstOperands,
     /* 178568 */     // GIR_Coverage, 1650,
     /* 178568 */     GIR_EraseRootFromParent_Done,
     /* 178569 */   // Label 3465: @178569
     /* 178569 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(178614), // Rule ID 1651 //
     /* 178574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178603 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 178606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178612 */     GIR_RootConstrainSelectedInstOperands,
     /* 178613 */     // GIR_Coverage, 1651,
     /* 178613 */     GIR_EraseRootFromParent_Done,
     /* 178614 */   // Label 3466: @178614
     /* 178614 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(178659), // Rule ID 1665 //
     /* 178619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 178627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178648 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 178648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 178651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178657 */     GIR_RootConstrainSelectedInstOperands,
     /* 178658 */     // GIR_Coverage, 1665,
     /* 178658 */     GIR_EraseRootFromParent_Done,
     /* 178659 */   // Label 3467: @178659
     /* 178659 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(178704), // Rule ID 1666 //
     /* 178664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 178672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178693 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 178693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 178696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178702 */     GIR_RootConstrainSelectedInstOperands,
     /* 178703 */     // GIR_Coverage, 1666,
     /* 178703 */     GIR_EraseRootFromParent_Done,
     /* 178704 */   // Label 3468: @178704
     /* 178704 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(178749), // Rule ID 1671 //
     /* 178709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 178717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178738 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 178738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 178741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178747 */     GIR_RootConstrainSelectedInstOperands,
     /* 178748 */     // GIR_Coverage, 1671,
     /* 178748 */     GIR_EraseRootFromParent_Done,
     /* 178749 */   // Label 3469: @178749
     /* 178749 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(178794), // Rule ID 1672 //
     /* 178754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 178762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178783 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 178783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 178786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178792 */     GIR_RootConstrainSelectedInstOperands,
     /* 178793 */     // GIR_Coverage, 1672,
     /* 178793 */     GIR_EraseRootFromParent_Done,
     /* 178794 */   // Label 3470: @178794
     /* 178794 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(178839), // Rule ID 1673 //
     /* 178799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178828 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 178831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178837 */     GIR_RootConstrainSelectedInstOperands,
     /* 178838 */     // GIR_Coverage, 1673,
     /* 178838 */     GIR_EraseRootFromParent_Done,
     /* 178839 */   // Label 3471: @178839
     /* 178839 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(178884), // Rule ID 1674 //
     /* 178844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178873 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 178876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178882 */     GIR_RootConstrainSelectedInstOperands,
     /* 178883 */     // GIR_Coverage, 1674,
     /* 178883 */     GIR_EraseRootFromParent_Done,
     /* 178884 */   // Label 3472: @178884
     /* 178884 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(178929), // Rule ID 1675 //
     /* 178889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178918 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 178921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178927 */     GIR_RootConstrainSelectedInstOperands,
     /* 178928 */     // GIR_Coverage, 1675,
     /* 178928 */     GIR_EraseRootFromParent_Done,
     /* 178929 */   // Label 3473: @178929
     /* 178929 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(178974), // Rule ID 1676 //
     /* 178934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178963 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 178966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178972 */     GIR_RootConstrainSelectedInstOperands,
     /* 178973 */     // GIR_Coverage, 1676,
     /* 178973 */     GIR_EraseRootFromParent_Done,
     /* 178974 */   // Label 3474: @178974
     /* 178974 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(179019), // Rule ID 1677 //
     /* 178979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179008 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 179011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179017 */     GIR_RootConstrainSelectedInstOperands,
     /* 179018 */     // GIR_Coverage, 1677,
     /* 179018 */     GIR_EraseRootFromParent_Done,
     /* 179019 */   // Label 3475: @179019
     /* 179019 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(179064), // Rule ID 1678 //
     /* 179024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 179032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179053 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 179056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179062 */     GIR_RootConstrainSelectedInstOperands,
     /* 179063 */     // GIR_Coverage, 1678,
     /* 179063 */     GIR_EraseRootFromParent_Done,
     /* 179064 */   // Label 3476: @179064
     /* 179064 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(179109), // Rule ID 1679 //
     /* 179069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179098 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 179101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179107 */     GIR_RootConstrainSelectedInstOperands,
     /* 179108 */     // GIR_Coverage, 1679,
     /* 179108 */     GIR_EraseRootFromParent_Done,
     /* 179109 */   // Label 3477: @179109
     /* 179109 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(179154), // Rule ID 1680 //
     /* 179114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179143 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 179146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179152 */     GIR_RootConstrainSelectedInstOperands,
     /* 179153 */     // GIR_Coverage, 1680,
     /* 179153 */     GIR_EraseRootFromParent_Done,
     /* 179154 */   // Label 3478: @179154
     /* 179154 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(179199), // Rule ID 1681 //
     /* 179159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179188 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 179191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179197 */     GIR_RootConstrainSelectedInstOperands,
     /* 179198 */     // GIR_Coverage, 1681,
     /* 179198 */     GIR_EraseRootFromParent_Done,
     /* 179199 */   // Label 3479: @179199
     /* 179199 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(179244), // Rule ID 1682 //
     /* 179204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179233 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 179236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179242 */     GIR_RootConstrainSelectedInstOperands,
     /* 179243 */     // GIR_Coverage, 1682,
     /* 179243 */     GIR_EraseRootFromParent_Done,
     /* 179244 */   // Label 3480: @179244
     /* 179244 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(179289), // Rule ID 1683 //
     /* 179249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179278 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 179281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179287 */     GIR_RootConstrainSelectedInstOperands,
     /* 179288 */     // GIR_Coverage, 1683,
     /* 179288 */     GIR_EraseRootFromParent_Done,
     /* 179289 */   // Label 3481: @179289
     /* 179289 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(179334), // Rule ID 1684 //
     /* 179294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179323 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 179326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179332 */     GIR_RootConstrainSelectedInstOperands,
     /* 179333 */     // GIR_Coverage, 1684,
     /* 179333 */     GIR_EraseRootFromParent_Done,
     /* 179334 */   // Label 3482: @179334
     /* 179334 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(179379), // Rule ID 1750 //
     /* 179339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179368 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 179371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179377 */     GIR_RootConstrainSelectedInstOperands,
     /* 179378 */     // GIR_Coverage, 1750,
     /* 179378 */     GIR_EraseRootFromParent_Done,
     /* 179379 */   // Label 3483: @179379
     /* 179379 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(179424), // Rule ID 1752 //
     /* 179384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179413 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 179416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179422 */     GIR_RootConstrainSelectedInstOperands,
     /* 179423 */     // GIR_Coverage, 1752,
     /* 179423 */     GIR_EraseRootFromParent_Done,
     /* 179424 */   // Label 3484: @179424
     /* 179424 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(179469), // Rule ID 2303 //
     /* 179429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 179432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 179437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179458 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 179458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 179461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179467 */     GIR_RootConstrainSelectedInstOperands,
     /* 179468 */     // GIR_Coverage, 2303,
     /* 179468 */     GIR_EraseRootFromParent_Done,
     /* 179469 */   // Label 3485: @179469
     /* 179469 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(179514), // Rule ID 2304 //
     /* 179474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 179477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 179482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179503 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 179503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 179506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179512 */     GIR_RootConstrainSelectedInstOperands,
     /* 179513 */     // GIR_Coverage, 2304,
     /* 179513 */     GIR_EraseRootFromParent_Done,
     /* 179514 */   // Label 3486: @179514
     /* 179514 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(179559), // Rule ID 2315 //
     /* 179519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 179522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 179527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179548 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 179548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 179551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179557 */     GIR_RootConstrainSelectedInstOperands,
     /* 179558 */     // GIR_Coverage, 2315,
     /* 179558 */     GIR_EraseRootFromParent_Done,
     /* 179559 */   // Label 3487: @179559
     /* 179559 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(179604), // Rule ID 2316 //
     /* 179564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 179567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 179572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179593 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 179593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 179596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179602 */     GIR_RootConstrainSelectedInstOperands,
     /* 179603 */     // GIR_Coverage, 2316,
     /* 179603 */     GIR_EraseRootFromParent_Done,
     /* 179604 */   // Label 3488: @179604
     /* 179604 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(179649), // Rule ID 2339 //
     /* 179609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179638 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 179641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179647 */     GIR_RootConstrainSelectedInstOperands,
     /* 179648 */     // GIR_Coverage, 2339,
     /* 179648 */     GIR_EraseRootFromParent_Done,
     /* 179649 */   // Label 3489: @179649
     /* 179649 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(179694), // Rule ID 2340 //
     /* 179654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179683 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 179686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179692 */     GIR_RootConstrainSelectedInstOperands,
     /* 179693 */     // GIR_Coverage, 2340,
     /* 179693 */     GIR_EraseRootFromParent_Done,
     /* 179694 */   // Label 3490: @179694
     /* 179694 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(179739), // Rule ID 2341 //
     /* 179699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179728 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 179731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179737 */     GIR_RootConstrainSelectedInstOperands,
     /* 179738 */     // GIR_Coverage, 2341,
     /* 179738 */     GIR_EraseRootFromParent_Done,
     /* 179739 */   // Label 3491: @179739
     /* 179739 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(179784), // Rule ID 2342 //
     /* 179744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179773 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 179776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179782 */     GIR_RootConstrainSelectedInstOperands,
     /* 179783 */     // GIR_Coverage, 2342,
     /* 179783 */     GIR_EraseRootFromParent_Done,
     /* 179784 */   // Label 3492: @179784
     /* 179784 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(179829), // Rule ID 2343 //
     /* 179789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179818 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 179821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179827 */     GIR_RootConstrainSelectedInstOperands,
     /* 179828 */     // GIR_Coverage, 2343,
     /* 179828 */     GIR_EraseRootFromParent_Done,
     /* 179829 */   // Label 3493: @179829
     /* 179829 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(179874), // Rule ID 2344 //
     /* 179834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179863 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 179863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 179866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179872 */     GIR_RootConstrainSelectedInstOperands,
     /* 179873 */     // GIR_Coverage, 2344,
     /* 179873 */     GIR_EraseRootFromParent_Done,
     /* 179874 */   // Label 3494: @179874
     /* 179874 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(179919), // Rule ID 2347 //
     /* 179879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179908 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 179908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 179911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179917 */     GIR_RootConstrainSelectedInstOperands,
     /* 179918 */     // GIR_Coverage, 2347,
     /* 179918 */     GIR_EraseRootFromParent_Done,
     /* 179919 */   // Label 3495: @179919
     /* 179919 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(179964), // Rule ID 2350 //
     /* 179924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179953 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 179953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 179956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179962 */     GIR_RootConstrainSelectedInstOperands,
     /* 179963 */     // GIR_Coverage, 2350,
     /* 179963 */     GIR_EraseRootFromParent_Done,
     /* 179964 */   // Label 3496: @179964
     /* 179964 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(180009), // Rule ID 2353 //
     /* 179969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179998 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 179998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 180001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180007 */     GIR_RootConstrainSelectedInstOperands,
     /* 180008 */     // GIR_Coverage, 2353,
     /* 180008 */     GIR_EraseRootFromParent_Done,
     /* 180009 */   // Label 3497: @180009
     /* 180009 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(180054), // Rule ID 2356 //
     /* 180014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180043 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 180046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180052 */     GIR_RootConstrainSelectedInstOperands,
     /* 180053 */     // GIR_Coverage, 2356,
     /* 180053 */     GIR_EraseRootFromParent_Done,
     /* 180054 */   // Label 3498: @180054
     /* 180054 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(180099), // Rule ID 2359 //
     /* 180059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180088 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 180088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 180091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180097 */     GIR_RootConstrainSelectedInstOperands,
     /* 180098 */     // GIR_Coverage, 2359,
     /* 180098 */     GIR_EraseRootFromParent_Done,
     /* 180099 */   // Label 3499: @180099
     /* 180099 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(180144), // Rule ID 2362 //
     /* 180104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180133 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 180133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 180136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180142 */     GIR_RootConstrainSelectedInstOperands,
     /* 180143 */     // GIR_Coverage, 2362,
     /* 180143 */     GIR_EraseRootFromParent_Done,
     /* 180144 */   // Label 3500: @180144
     /* 180144 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(180189), // Rule ID 2365 //
     /* 180149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180178 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 180178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 180181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180187 */     GIR_RootConstrainSelectedInstOperands,
     /* 180188 */     // GIR_Coverage, 2365,
     /* 180188 */     GIR_EraseRootFromParent_Done,
     /* 180189 */   // Label 3501: @180189
     /* 180189 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(180234), // Rule ID 2368 //
     /* 180194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180223 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 180223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 180226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180232 */     GIR_RootConstrainSelectedInstOperands,
     /* 180233 */     // GIR_Coverage, 2368,
     /* 180233 */     GIR_EraseRootFromParent_Done,
     /* 180234 */   // Label 3502: @180234
     /* 180234 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(180279), // Rule ID 2371 //
     /* 180239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180268 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 180271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180277 */     GIR_RootConstrainSelectedInstOperands,
     /* 180278 */     // GIR_Coverage, 2371,
     /* 180278 */     GIR_EraseRootFromParent_Done,
     /* 180279 */   // Label 3503: @180279
     /* 180279 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(180324), // Rule ID 2508 //
     /* 180284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180313 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 180313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 180316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180322 */     GIR_RootConstrainSelectedInstOperands,
     /* 180323 */     // GIR_Coverage, 2508,
     /* 180323 */     GIR_EraseRootFromParent_Done,
     /* 180324 */   // Label 3504: @180324
     /* 180324 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(180369), // Rule ID 2509 //
     /* 180329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180358 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 180361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180367 */     GIR_RootConstrainSelectedInstOperands,
     /* 180368 */     // GIR_Coverage, 2509,
     /* 180368 */     GIR_EraseRootFromParent_Done,
     /* 180369 */   // Label 3505: @180369
     /* 180369 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(180414), // Rule ID 2510 //
     /* 180374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 180382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180403 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 180406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180412 */     GIR_RootConstrainSelectedInstOperands,
     /* 180413 */     // GIR_Coverage, 2510,
     /* 180413 */     GIR_EraseRootFromParent_Done,
     /* 180414 */   // Label 3506: @180414
     /* 180414 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(180459), // Rule ID 2511 //
     /* 180419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 180427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180448 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 180451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180457 */     GIR_RootConstrainSelectedInstOperands,
     /* 180458 */     // GIR_Coverage, 2511,
     /* 180458 */     GIR_EraseRootFromParent_Done,
     /* 180459 */   // Label 3507: @180459
     /* 180459 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(180504), // Rule ID 2516 //
     /* 180464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 180472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180493 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 180493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 180496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180502 */     GIR_RootConstrainSelectedInstOperands,
     /* 180503 */     // GIR_Coverage, 2516,
     /* 180503 */     GIR_EraseRootFromParent_Done,
     /* 180504 */   // Label 3508: @180504
     /* 180504 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(180549), // Rule ID 2634 //
     /* 180509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180538 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 180541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180547 */     GIR_RootConstrainSelectedInstOperands,
     /* 180548 */     // GIR_Coverage, 2634,
     /* 180548 */     GIR_EraseRootFromParent_Done,
     /* 180549 */   // Label 3509: @180549
     /* 180549 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(180594), // Rule ID 2635 //
     /* 180554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 180571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180583 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 180586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180592 */     GIR_RootConstrainSelectedInstOperands,
     /* 180593 */     // GIR_Coverage, 2635,
     /* 180593 */     GIR_EraseRootFromParent_Done,
     /* 180594 */   // Label 3510: @180594
     /* 180594 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(180639), // Rule ID 2636 //
     /* 180599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 180616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180628 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 180631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180637 */     GIR_RootConstrainSelectedInstOperands,
     /* 180638 */     // GIR_Coverage, 2636,
     /* 180638 */     GIR_EraseRootFromParent_Done,
     /* 180639 */   // Label 3511: @180639
     /* 180639 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(180684), // Rule ID 2637 //
     /* 180644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180673 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 180676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180682 */     GIR_RootConstrainSelectedInstOperands,
     /* 180683 */     // GIR_Coverage, 2637,
     /* 180683 */     GIR_EraseRootFromParent_Done,
     /* 180684 */   // Label 3512: @180684
     /* 180684 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(180729), // Rule ID 2638 //
     /* 180689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180718 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 180721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180727 */     GIR_RootConstrainSelectedInstOperands,
     /* 180728 */     // GIR_Coverage, 2638,
     /* 180728 */     GIR_EraseRootFromParent_Done,
     /* 180729 */   // Label 3513: @180729
     /* 180729 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(180774), // Rule ID 2639 //
     /* 180734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 180751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180763 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 180766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180772 */     GIR_RootConstrainSelectedInstOperands,
     /* 180773 */     // GIR_Coverage, 2639,
     /* 180773 */     GIR_EraseRootFromParent_Done,
     /* 180774 */   // Label 3514: @180774
     /* 180774 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(180819), // Rule ID 2640 //
     /* 180779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 180796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180808 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 180811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180817 */     GIR_RootConstrainSelectedInstOperands,
     /* 180818 */     // GIR_Coverage, 2640,
     /* 180818 */     GIR_EraseRootFromParent_Done,
     /* 180819 */   // Label 3515: @180819
     /* 180819 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(180864), // Rule ID 2641 //
     /* 180824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180853 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 180856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180862 */     GIR_RootConstrainSelectedInstOperands,
     /* 180863 */     // GIR_Coverage, 2641,
     /* 180863 */     GIR_EraseRootFromParent_Done,
     /* 180864 */   // Label 3516: @180864
     /* 180864 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(180909), // Rule ID 3815 //
     /* 180869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 180872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 180877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180898 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 180898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 180901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 180903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180907 */     GIR_RootConstrainSelectedInstOperands,
     /* 180908 */     // GIR_Coverage, 3815,
     /* 180908 */     GIR_EraseRootFromParent_Done,
     /* 180909 */   // Label 3517: @180909
     /* 180909 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(180954), // Rule ID 3843 //
     /* 180914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 180917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 180922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180943 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 180943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 180946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180952 */     GIR_RootConstrainSelectedInstOperands,
     /* 180953 */     // GIR_Coverage, 3843,
     /* 180953 */     GIR_EraseRootFromParent_Done,
     /* 180954 */   // Label 3518: @180954
     /* 180954 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(180999), // Rule ID 3853 //
     /* 180959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 180962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 180967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180988 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 180988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 180991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180997 */     GIR_RootConstrainSelectedInstOperands,
     /* 180998 */     // GIR_Coverage, 3853,
     /* 180998 */     GIR_EraseRootFromParent_Done,
     /* 180999 */   // Label 3519: @180999
     /* 180999 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(181044), // Rule ID 3854 //
     /* 181004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 181007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 181012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181033 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 181033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 181036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 181038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181042 */     GIR_RootConstrainSelectedInstOperands,
     /* 181043 */     // GIR_Coverage, 3854,
     /* 181043 */     GIR_EraseRootFromParent_Done,
     /* 181044 */   // Label 3520: @181044
     /* 181044 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(181092), // Rule ID 3855 //
     /* 181049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181078 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 181078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181090 */     GIR_RootConstrainSelectedInstOperands,
     /* 181091 */     // GIR_Coverage, 3855,
     /* 181091 */     GIR_EraseRootFromParent_Done,
     /* 181092 */   // Label 3521: @181092
     /* 181092 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(181140), // Rule ID 3856 //
     /* 181097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181126 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 181126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181138 */     GIR_RootConstrainSelectedInstOperands,
     /* 181139 */     // GIR_Coverage, 3856,
     /* 181139 */     GIR_EraseRootFromParent_Done,
     /* 181140 */   // Label 3522: @181140
     /* 181140 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(181188), // Rule ID 3857 //
     /* 181145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181174 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 181174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 181177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181186 */     GIR_RootConstrainSelectedInstOperands,
     /* 181187 */     // GIR_Coverage, 3857,
     /* 181187 */     GIR_EraseRootFromParent_Done,
     /* 181188 */   // Label 3523: @181188
     /* 181188 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(181236), // Rule ID 3858 //
     /* 181193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181222 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 181222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 181225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181234 */     GIR_RootConstrainSelectedInstOperands,
     /* 181235 */     // GIR_Coverage, 3858,
     /* 181235 */     GIR_EraseRootFromParent_Done,
     /* 181236 */   // Label 3524: @181236
     /* 181236 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(181284), // Rule ID 3859 //
     /* 181241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181270 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 181270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 181273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181282 */     GIR_RootConstrainSelectedInstOperands,
     /* 181283 */     // GIR_Coverage, 3859,
     /* 181283 */     GIR_EraseRootFromParent_Done,
     /* 181284 */   // Label 3525: @181284
     /* 181284 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(181332), // Rule ID 3860 //
     /* 181289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181318 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 181318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 181321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181330 */     GIR_RootConstrainSelectedInstOperands,
     /* 181331 */     // GIR_Coverage, 3860,
     /* 181331 */     GIR_EraseRootFromParent_Done,
     /* 181332 */   // Label 3526: @181332
     /* 181332 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(181380), // Rule ID 3861 //
     /* 181337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181366 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 181366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 181369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181378 */     GIR_RootConstrainSelectedInstOperands,
     /* 181379 */     // GIR_Coverage, 3861,
     /* 181379 */     GIR_EraseRootFromParent_Done,
     /* 181380 */   // Label 3527: @181380
     /* 181380 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(181428), // Rule ID 3862 //
     /* 181385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181414 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 181414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 181417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181426 */     GIR_RootConstrainSelectedInstOperands,
     /* 181427 */     // GIR_Coverage, 3862,
     /* 181427 */     GIR_EraseRootFromParent_Done,
     /* 181428 */   // Label 3528: @181428
     /* 181428 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(181476), // Rule ID 3863 //
     /* 181433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181462 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 181462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 181465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181474 */     GIR_RootConstrainSelectedInstOperands,
     /* 181475 */     // GIR_Coverage, 3863,
     /* 181475 */     GIR_EraseRootFromParent_Done,
     /* 181476 */   // Label 3529: @181476
     /* 181476 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(181524), // Rule ID 3864 //
     /* 181481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181510 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 181510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 181513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181522 */     GIR_RootConstrainSelectedInstOperands,
     /* 181523 */     // GIR_Coverage, 3864,
     /* 181523 */     GIR_EraseRootFromParent_Done,
     /* 181524 */   // Label 3530: @181524
     /* 181524 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(181566), // Rule ID 3929 //
     /* 181529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 181534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181555 */     // (intrinsic_wo_chain:{ *:[i32] } 2169:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 181555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 181558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181564 */     GIR_RootConstrainSelectedInstOperands,
     /* 181565 */     // GIR_Coverage, 3929,
     /* 181565 */     GIR_EraseRootFromParent_Done,
     /* 181566 */   // Label 3531: @181566
     /* 181566 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(181608), // Rule ID 3930 //
     /* 181571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 181576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181597 */     // (intrinsic_wo_chain:{ *:[i64] } 2169:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 181597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 181600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181606 */     GIR_RootConstrainSelectedInstOperands,
     /* 181607 */     // GIR_Coverage, 3930,
     /* 181607 */     GIR_EraseRootFromParent_Done,
     /* 181608 */   // Label 3532: @181608
     /* 181608 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(181650), // Rule ID 3931 //
     /* 181613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 181618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181639 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 181639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 181642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181648 */     GIR_RootConstrainSelectedInstOperands,
     /* 181649 */     // GIR_Coverage, 3931,
     /* 181649 */     GIR_EraseRootFromParent_Done,
     /* 181650 */   // Label 3533: @181650
     /* 181650 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(181692), // Rule ID 3932 //
     /* 181655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 181660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181681 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 181681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 181684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181690 */     GIR_RootConstrainSelectedInstOperands,
     /* 181691 */     // GIR_Coverage, 3932,
     /* 181691 */     GIR_EraseRootFromParent_Done,
     /* 181692 */   // Label 3534: @181692
     /* 181692 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(181734), // Rule ID 5207 //
     /* 181697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 181702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181723 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 181726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181732 */     GIR_RootConstrainSelectedInstOperands,
     /* 181733 */     // GIR_Coverage, 5207,
     /* 181733 */     GIR_EraseRootFromParent_Done,
     /* 181734 */   // Label 3535: @181734
     /* 181734 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(181779), // Rule ID 5211 //
     /* 181739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 181747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181768 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 181771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181777 */     GIR_RootConstrainSelectedInstOperands,
     /* 181778 */     // GIR_Coverage, 5211,
     /* 181778 */     GIR_EraseRootFromParent_Done,
     /* 181779 */   // Label 3536: @181779
     /* 181779 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(181824), // Rule ID 5215 //
     /* 181784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 181792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181813 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 181816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181822 */     GIR_RootConstrainSelectedInstOperands,
     /* 181823 */     // GIR_Coverage, 5215,
     /* 181823 */     GIR_EraseRootFromParent_Done,
     /* 181824 */   // Label 3537: @181824
     /* 181824 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(181869), // Rule ID 5216 //
     /* 181829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 181837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181858 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 181861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181867 */     GIR_RootConstrainSelectedInstOperands,
     /* 181868 */     // GIR_Coverage, 5216,
     /* 181868 */     GIR_EraseRootFromParent_Done,
     /* 181869 */   // Label 3538: @181869
     /* 181869 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(181914), // Rule ID 5217 //
     /* 181874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 181882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181903 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 181906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181912 */     GIR_RootConstrainSelectedInstOperands,
     /* 181913 */     // GIR_Coverage, 5217,
     /* 181913 */     GIR_EraseRootFromParent_Done,
     /* 181914 */   // Label 3539: @181914
     /* 181914 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(181959), // Rule ID 5218 //
     /* 181919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 181927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181948 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 181951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181957 */     GIR_RootConstrainSelectedInstOperands,
     /* 181958 */     // GIR_Coverage, 5218,
     /* 181958 */     GIR_EraseRootFromParent_Done,
     /* 181959 */   // Label 3540: @181959
     /* 181959 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(182004), // Rule ID 5219 //
     /* 181964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 181972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181993 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 181996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182002 */     GIR_RootConstrainSelectedInstOperands,
     /* 182003 */     // GIR_Coverage, 5219,
     /* 182003 */     GIR_EraseRootFromParent_Done,
     /* 182004 */   // Label 3541: @182004
     /* 182004 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(182049), // Rule ID 5220 //
     /* 182009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182038 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 182041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182047 */     GIR_RootConstrainSelectedInstOperands,
     /* 182048 */     // GIR_Coverage, 5220,
     /* 182048 */     GIR_EraseRootFromParent_Done,
     /* 182049 */   // Label 3542: @182049
     /* 182049 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(182094), // Rule ID 5221 //
     /* 182054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182083 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 182086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182092 */     GIR_RootConstrainSelectedInstOperands,
     /* 182093 */     // GIR_Coverage, 5221,
     /* 182093 */     GIR_EraseRootFromParent_Done,
     /* 182094 */   // Label 3543: @182094
     /* 182094 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(182139), // Rule ID 5222 //
     /* 182099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182128 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 182131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182137 */     GIR_RootConstrainSelectedInstOperands,
     /* 182138 */     // GIR_Coverage, 5222,
     /* 182138 */     GIR_EraseRootFromParent_Done,
     /* 182139 */   // Label 3544: @182139
     /* 182139 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(182184), // Rule ID 5223 //
     /* 182144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182173 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 182176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182182 */     GIR_RootConstrainSelectedInstOperands,
     /* 182183 */     // GIR_Coverage, 5223,
     /* 182183 */     GIR_EraseRootFromParent_Done,
     /* 182184 */   // Label 3545: @182184
     /* 182184 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(182229), // Rule ID 5224 //
     /* 182189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 182197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182218 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 182221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182227 */     GIR_RootConstrainSelectedInstOperands,
     /* 182228 */     // GIR_Coverage, 5224,
     /* 182228 */     GIR_EraseRootFromParent_Done,
     /* 182229 */   // Label 3546: @182229
     /* 182229 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(182274), // Rule ID 5225 //
     /* 182234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 182242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182263 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 182266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182272 */     GIR_RootConstrainSelectedInstOperands,
     /* 182273 */     // GIR_Coverage, 5225,
     /* 182273 */     GIR_EraseRootFromParent_Done,
     /* 182274 */   // Label 3547: @182274
     /* 182274 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(182319), // Rule ID 5226 //
     /* 182279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 182287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182308 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 182311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182317 */     GIR_RootConstrainSelectedInstOperands,
     /* 182318 */     // GIR_Coverage, 5226,
     /* 182318 */     GIR_EraseRootFromParent_Done,
     /* 182319 */   // Label 3548: @182319
     /* 182319 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(182364), // Rule ID 5227 //
     /* 182324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 182332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182353 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 182356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182362 */     GIR_RootConstrainSelectedInstOperands,
     /* 182363 */     // GIR_Coverage, 5227,
     /* 182363 */     GIR_EraseRootFromParent_Done,
     /* 182364 */   // Label 3549: @182364
     /* 182364 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(182409), // Rule ID 5228 //
     /* 182369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 182377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182398 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 182401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182407 */     GIR_RootConstrainSelectedInstOperands,
     /* 182408 */     // GIR_Coverage, 5228,
     /* 182408 */     GIR_EraseRootFromParent_Done,
     /* 182409 */   // Label 3550: @182409
     /* 182409 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(182454), // Rule ID 5229 //
     /* 182414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 182422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182443 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 182446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182452 */     GIR_RootConstrainSelectedInstOperands,
     /* 182453 */     // GIR_Coverage, 5229,
     /* 182453 */     GIR_EraseRootFromParent_Done,
     /* 182454 */   // Label 3551: @182454
     /* 182454 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(182499), // Rule ID 5230 //
     /* 182459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 182467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182488 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 182491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182497 */     GIR_RootConstrainSelectedInstOperands,
     /* 182498 */     // GIR_Coverage, 5230,
     /* 182498 */     GIR_EraseRootFromParent_Done,
     /* 182499 */   // Label 3552: @182499
     /* 182499 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(182544), // Rule ID 5231 //
     /* 182504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 182512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182533 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 182536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182542 */     GIR_RootConstrainSelectedInstOperands,
     /* 182543 */     // GIR_Coverage, 5231,
     /* 182543 */     GIR_EraseRootFromParent_Done,
     /* 182544 */   // Label 3553: @182544
     /* 182544 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(182589), // Rule ID 5250 //
     /* 182549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 182557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182578 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 182578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 182581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182587 */     GIR_RootConstrainSelectedInstOperands,
     /* 182588 */     // GIR_Coverage, 5250,
     /* 182588 */     GIR_EraseRootFromParent_Done,
     /* 182589 */   // Label 3554: @182589
     /* 182589 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(182631), // Rule ID 5584 //
     /* 182594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 182599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 182602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 182605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 182608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182620 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 182620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 182623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 182625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 182629 */     GIR_RootConstrainSelectedInstOperands,
     /* 182630 */     // GIR_Coverage, 5584,
     /* 182630 */     GIR_EraseRootFromParent_Done,
     /* 182631 */   // Label 3555: @182631
     /* 182631 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(182673), // Rule ID 5585 //
     /* 182636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 182641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 182644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 182647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 182650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182662 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 182662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 182665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 182667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 182669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182671 */     GIR_RootConstrainSelectedInstOperands,
     /* 182672 */     // GIR_Coverage, 5585,
     /* 182672 */     GIR_EraseRootFromParent_Done,
     /* 182673 */   // Label 3556: @182673
     /* 182673 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(182770), // Rule ID 6286 //
     /* 182678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 182683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 182692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182704 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 182704 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182707 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 182711 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182716 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182720 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 182724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182769 */     // GIR_Coverage, 6286,
     /* 182769 */     GIR_EraseRootFromParent_Done,
     /* 182770 */   // Label 3557: @182770
     /* 182770 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(182867), // Rule ID 6287 //
     /* 182775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 182780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 182789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182801 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 182801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 182808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182813 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182817 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 182821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182866 */     // GIR_Coverage, 6287,
     /* 182866 */     GIR_EraseRootFromParent_Done,
     /* 182867 */   // Label 3558: @182867
     /* 182867 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(182909), // Rule ID 6932 //
     /* 182872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 182877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182898 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 182901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182907 */     GIR_RootConstrainSelectedInstOperands,
     /* 182908 */     // GIR_Coverage, 6932,
     /* 182908 */     GIR_EraseRootFromParent_Done,
     /* 182909 */   // Label 3559: @182909
     /* 182909 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(182951), // Rule ID 6933 //
     /* 182914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 182919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182940 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 182943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182949 */     GIR_RootConstrainSelectedInstOperands,
     /* 182950 */     // GIR_Coverage, 6933,
     /* 182950 */     GIR_EraseRootFromParent_Done,
     /* 182951 */   // Label 3560: @182951
     /* 182951 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(182993), // Rule ID 6934 //
     /* 182956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 182961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182982 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 182985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182991 */     GIR_RootConstrainSelectedInstOperands,
     /* 182992 */     // GIR_Coverage, 6934,
     /* 182992 */     GIR_EraseRootFromParent_Done,
     /* 182993 */   // Label 3561: @182993
     /* 182993 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(183035), // Rule ID 6935 //
     /* 182998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 183003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183024 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 183027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183033 */     GIR_RootConstrainSelectedInstOperands,
     /* 183034 */     // GIR_Coverage, 6935,
     /* 183034 */     GIR_EraseRootFromParent_Done,
     /* 183035 */   // Label 3562: @183035
     /* 183035 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(183083), // Rule ID 6975 //
     /* 183040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 183045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183066 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 183066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 183069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 183078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 183081 */     GIR_RootConstrainSelectedInstOperands,
     /* 183082 */     // GIR_Coverage, 6975,
     /* 183082 */     GIR_EraseRootFromParent_Done,
     /* 183083 */   // Label 3563: @183083
     /* 183083 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(183128), // Rule ID 10001 //
     /* 183088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183117 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 183120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183126 */     GIR_RootConstrainSelectedInstOperands,
     /* 183127 */     // GIR_Coverage, 10001,
     /* 183127 */     GIR_EraseRootFromParent_Done,
     /* 183128 */   // Label 3564: @183128
     /* 183128 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(183173), // Rule ID 10002 //
     /* 183133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183162 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 183165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183171 */     GIR_RootConstrainSelectedInstOperands,
     /* 183172 */     // GIR_Coverage, 10002,
     /* 183172 */     GIR_EraseRootFromParent_Done,
     /* 183173 */   // Label 3565: @183173
     /* 183173 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(183218), // Rule ID 10003 //
     /* 183178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183207 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 183210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183216 */     GIR_RootConstrainSelectedInstOperands,
     /* 183217 */     // GIR_Coverage, 10003,
     /* 183217 */     GIR_EraseRootFromParent_Done,
     /* 183218 */   // Label 3566: @183218
     /* 183218 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183263), // Rule ID 10004 //
     /* 183223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183252 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 183255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183261 */     GIR_RootConstrainSelectedInstOperands,
     /* 183262 */     // GIR_Coverage, 10004,
     /* 183262 */     GIR_EraseRootFromParent_Done,
     /* 183263 */   // Label 3567: @183263
     /* 183263 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183308), // Rule ID 10013 //
     /* 183268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183297 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 183300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183306 */     GIR_RootConstrainSelectedInstOperands,
     /* 183307 */     // GIR_Coverage, 10013,
     /* 183307 */     GIR_EraseRootFromParent_Done,
     /* 183308 */   // Label 3568: @183308
     /* 183308 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(183353), // Rule ID 10014 //
     /* 183313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183342 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 183345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183351 */     GIR_RootConstrainSelectedInstOperands,
     /* 183352 */     // GIR_Coverage, 10014,
     /* 183352 */     GIR_EraseRootFromParent_Done,
     /* 183353 */   // Label 3569: @183353
     /* 183353 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(183398), // Rule ID 10015 //
     /* 183358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183387 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 183390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183396 */     GIR_RootConstrainSelectedInstOperands,
     /* 183397 */     // GIR_Coverage, 10015,
     /* 183397 */     GIR_EraseRootFromParent_Done,
     /* 183398 */   // Label 3570: @183398
     /* 183398 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(183443), // Rule ID 10016 //
     /* 183403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183432 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 183435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183441 */     GIR_RootConstrainSelectedInstOperands,
     /* 183442 */     // GIR_Coverage, 10016,
     /* 183442 */     GIR_EraseRootFromParent_Done,
     /* 183443 */   // Label 3571: @183443
     /* 183443 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(183488), // Rule ID 10017 //
     /* 183448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183477 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 183480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183486 */     GIR_RootConstrainSelectedInstOperands,
     /* 183487 */     // GIR_Coverage, 10017,
     /* 183487 */     GIR_EraseRootFromParent_Done,
     /* 183488 */   // Label 3572: @183488
     /* 183488 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(183533), // Rule ID 10018 //
     /* 183493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183522 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 183525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183531 */     GIR_RootConstrainSelectedInstOperands,
     /* 183532 */     // GIR_Coverage, 10018,
     /* 183532 */     GIR_EraseRootFromParent_Done,
     /* 183533 */   // Label 3573: @183533
     /* 183533 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(183578), // Rule ID 10019 //
     /* 183538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183567 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 183570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183576 */     GIR_RootConstrainSelectedInstOperands,
     /* 183577 */     // GIR_Coverage, 10019,
     /* 183577 */     GIR_EraseRootFromParent_Done,
     /* 183578 */   // Label 3574: @183578
     /* 183578 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(183623), // Rule ID 10020 //
     /* 183583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183612 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 183615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183621 */     GIR_RootConstrainSelectedInstOperands,
     /* 183622 */     // GIR_Coverage, 10020,
     /* 183622 */     GIR_EraseRootFromParent_Done,
     /* 183623 */   // Label 3575: @183623
     /* 183623 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(183668), // Rule ID 10021 //
     /* 183628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183657 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 183660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183666 */     GIR_RootConstrainSelectedInstOperands,
     /* 183667 */     // GIR_Coverage, 10021,
     /* 183667 */     GIR_EraseRootFromParent_Done,
     /* 183668 */   // Label 3576: @183668
     /* 183668 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(183713), // Rule ID 10022 //
     /* 183673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183702 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 183705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183711 */     GIR_RootConstrainSelectedInstOperands,
     /* 183712 */     // GIR_Coverage, 10022,
     /* 183712 */     GIR_EraseRootFromParent_Done,
     /* 183713 */   // Label 3577: @183713
     /* 183713 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(183758), // Rule ID 10023 //
     /* 183718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183747 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 183750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183756 */     GIR_RootConstrainSelectedInstOperands,
     /* 183757 */     // GIR_Coverage, 10023,
     /* 183757 */     GIR_EraseRootFromParent_Done,
     /* 183758 */   // Label 3578: @183758
     /* 183758 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(183803), // Rule ID 10024 //
     /* 183763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183792 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 183795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183801 */     GIR_RootConstrainSelectedInstOperands,
     /* 183802 */     // GIR_Coverage, 10024,
     /* 183802 */     GIR_EraseRootFromParent_Done,
     /* 183803 */   // Label 3579: @183803
     /* 183803 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(183849), // Rule ID 138 //
     /* 183808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 183811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 183816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183826 */     // MIs[0] Rn
     /* 183826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 183830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183838 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 183838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 183841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183847 */     GIR_RootConstrainSelectedInstOperands,
     /* 183848 */     // GIR_Coverage, 138,
     /* 183848 */     GIR_EraseRootFromParent_Done,
     /* 183849 */   // Label 3580: @183849
     /* 183849 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(183896), // Rule ID 139 //
     /* 183854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 183857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 183862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183869 */     // MIs[0] Rn
     /* 183869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 183873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183877 */     // MIs[0] Rm
     /* 183877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 183881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183885 */     // (intrinsic_wo_chain:{ *:[i64] } 1242:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 183885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 183888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183894 */     GIR_RootConstrainSelectedInstOperands,
     /* 183895 */     // GIR_Coverage, 139,
     /* 183895 */     GIR_EraseRootFromParent_Done,
     /* 183896 */   // Label 3581: @183896
     /* 183896 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(183933), // Rule ID 2399 //
     /* 183901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 183909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2151:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 183925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183931 */     GIR_RootConstrainSelectedInstOperands,
     /* 183932 */     // GIR_Coverage, 2399,
     /* 183932 */     GIR_EraseRootFromParent_Done,
     /* 183933 */   // Label 3582: @183933
     /* 183933 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(183970), // Rule ID 2400 //
     /* 183938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 183946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183959 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 183962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183968 */     GIR_RootConstrainSelectedInstOperands,
     /* 183969 */     // GIR_Coverage, 2400,
     /* 183969 */     GIR_EraseRootFromParent_Done,
     /* 183970 */   // Label 3583: @183970
     /* 183970 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(184007), // Rule ID 2401 //
     /* 183975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 183983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183996 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2153:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 183999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184005 */     GIR_RootConstrainSelectedInstOperands,
     /* 184006 */     // GIR_Coverage, 2401,
     /* 184006 */     GIR_EraseRootFromParent_Done,
     /* 184007 */   // Label 3584: @184007
     /* 184007 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(184044), // Rule ID 2403 //
     /* 184012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 184020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184033 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2156:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 184036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184042 */     GIR_RootConstrainSelectedInstOperands,
     /* 184043 */     // GIR_Coverage, 2403,
     /* 184043 */     GIR_EraseRootFromParent_Done,
     /* 184044 */   // Label 3585: @184044
     /* 184044 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(184081), // Rule ID 2404 //
     /* 184049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 184057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184070 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2157:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 184073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184079 */     GIR_RootConstrainSelectedInstOperands,
     /* 184080 */     // GIR_Coverage, 2404,
     /* 184080 */     GIR_EraseRootFromParent_Done,
     /* 184081 */   // Label 3586: @184081
     /* 184081 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184118), // Rule ID 2405 //
     /* 184086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 184094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184107 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 184110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184116 */     GIR_RootConstrainSelectedInstOperands,
     /* 184117 */     // GIR_Coverage, 2405,
     /* 184117 */     GIR_EraseRootFromParent_Done,
     /* 184118 */   // Label 3587: @184118
     /* 184118 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(184155), // Rule ID 2407 //
     /* 184123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 184131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184144 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2077:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 184147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184153 */     GIR_RootConstrainSelectedInstOperands,
     /* 184154 */     // GIR_Coverage, 2407,
     /* 184154 */     GIR_EraseRootFromParent_Done,
     /* 184155 */   // Label 3588: @184155
     /* 184155 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(184192), // Rule ID 2408 //
     /* 184160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 184168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184181 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2078:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 184184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184190 */     GIR_RootConstrainSelectedInstOperands,
     /* 184191 */     // GIR_Coverage, 2408,
     /* 184191 */     GIR_EraseRootFromParent_Done,
     /* 184192 */   // Label 3589: @184192
     /* 184192 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184229), // Rule ID 2409 //
     /* 184197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 184205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184218 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2079:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 184221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184227 */     GIR_RootConstrainSelectedInstOperands,
     /* 184228 */     // GIR_Coverage, 2409,
     /* 184228 */     GIR_EraseRootFromParent_Done,
     /* 184229 */   // Label 3590: @184229
     /* 184229 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184266), // Rule ID 2411 //
     /* 184234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 184242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184255 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 184258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184264 */     GIR_RootConstrainSelectedInstOperands,
     /* 184265 */     // GIR_Coverage, 2411,
     /* 184265 */     GIR_EraseRootFromParent_Done,
     /* 184266 */   // Label 3591: @184266
     /* 184266 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184303), // Rule ID 2412 //
     /* 184271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 184279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184292 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2083:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 184295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184301 */     GIR_RootConstrainSelectedInstOperands,
     /* 184302 */     // GIR_Coverage, 2412,
     /* 184302 */     GIR_EraseRootFromParent_Done,
     /* 184303 */   // Label 3592: @184303
     /* 184303 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184340), // Rule ID 2413 //
     /* 184308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 184316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184329 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 184332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184338 */     GIR_RootConstrainSelectedInstOperands,
     /* 184339 */     // GIR_Coverage, 2413,
     /* 184339 */     GIR_EraseRootFromParent_Done,
     /* 184340 */   // Label 3593: @184340
     /* 184340 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(184377), // Rule ID 2415 //
     /* 184345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 184353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1921:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 184369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184375 */     GIR_RootConstrainSelectedInstOperands,
     /* 184376 */     // GIR_Coverage, 2415,
     /* 184376 */     GIR_EraseRootFromParent_Done,
     /* 184377 */   // Label 3594: @184377
     /* 184377 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(184414), // Rule ID 2416 //
     /* 184382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 184390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184403 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1922:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 184406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184412 */     GIR_RootConstrainSelectedInstOperands,
     /* 184413 */     // GIR_Coverage, 2416,
     /* 184413 */     GIR_EraseRootFromParent_Done,
     /* 184414 */   // Label 3595: @184414
     /* 184414 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(184451), // Rule ID 2417 //
     /* 184419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 184427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184440 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1923:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 184443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184449 */     GIR_RootConstrainSelectedInstOperands,
     /* 184450 */     // GIR_Coverage, 2417,
     /* 184450 */     GIR_EraseRootFromParent_Done,
     /* 184451 */   // Label 3596: @184451
     /* 184451 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(184488), // Rule ID 2419 //
     /* 184456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 184464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184477 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1926:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 184480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184486 */     GIR_RootConstrainSelectedInstOperands,
     /* 184487 */     // GIR_Coverage, 2419,
     /* 184487 */     GIR_EraseRootFromParent_Done,
     /* 184488 */   // Label 3597: @184488
     /* 184488 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(184525), // Rule ID 2420 //
     /* 184493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 184501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1927:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 184517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184523 */     GIR_RootConstrainSelectedInstOperands,
     /* 184524 */     // GIR_Coverage, 2420,
     /* 184524 */     GIR_EraseRootFromParent_Done,
     /* 184525 */   // Label 3598: @184525
     /* 184525 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(184562), // Rule ID 2421 //
     /* 184530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 184538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184551 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 184554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184560 */     GIR_RootConstrainSelectedInstOperands,
     /* 184561 */     // GIR_Coverage, 2421,
     /* 184561 */     GIR_EraseRootFromParent_Done,
     /* 184562 */   // Label 3599: @184562
     /* 184562 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(184599), // Rule ID 2422 //
     /* 184567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 184570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 184575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184588 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1546:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 184588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 184591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 184595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 184597 */     GIR_RootConstrainSelectedInstOperands,
     /* 184598 */     // GIR_Coverage, 2422,
     /* 184598 */     GIR_EraseRootFromParent_Done,
     /* 184599 */   // Label 3600: @184599
     /* 184599 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(184639), // Rule ID 2621 //
     /* 184604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 184612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184625 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 184628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184637 */     GIR_RootConstrainSelectedInstOperands,
     /* 184638 */     // GIR_Coverage, 2621,
     /* 184638 */     GIR_EraseRootFromParent_Done,
     /* 184639 */   // Label 3601: @184639
     /* 184639 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(184679), // Rule ID 2622 //
     /* 184644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184665 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1633:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 184668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184677 */     GIR_RootConstrainSelectedInstOperands,
     /* 184678 */     // GIR_Coverage, 2622,
     /* 184678 */     GIR_EraseRootFromParent_Done,
     /* 184679 */   // Label 3602: @184679
     /* 184679 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(184719), // Rule ID 2623 //
     /* 184684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 184695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 184698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184705 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1633:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 184708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184717 */     GIR_RootConstrainSelectedInstOperands,
     /* 184718 */     // GIR_Coverage, 2623,
     /* 184718 */     GIR_EraseRootFromParent_Done,
     /* 184719 */   // Label 3603: @184719
     /* 184719 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(184759), // Rule ID 2624 //
     /* 184724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 184735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 184738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184745 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1633:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 184748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184757 */     GIR_RootConstrainSelectedInstOperands,
     /* 184758 */     // GIR_Coverage, 2624,
     /* 184758 */     GIR_EraseRootFromParent_Done,
     /* 184759 */   // Label 3604: @184759
     /* 184759 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(184799), // Rule ID 2625 //
     /* 184764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 184775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 184778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184785 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1633:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 184788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184797 */     GIR_RootConstrainSelectedInstOperands,
     /* 184798 */     // GIR_Coverage, 2625,
     /* 184798 */     GIR_EraseRootFromParent_Done,
     /* 184799 */   // Label 3605: @184799
     /* 184799 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(184836), // Rule ID 2642 //
     /* 184804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184825 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 184828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184834 */     GIR_RootConstrainSelectedInstOperands,
     /* 184835 */     // GIR_Coverage, 2642,
     /* 184835 */     GIR_EraseRootFromParent_Done,
     /* 184836 */   // Label 3606: @184836
     /* 184836 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(184873), // Rule ID 2643 //
     /* 184841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 184865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184871 */     GIR_RootConstrainSelectedInstOperands,
     /* 184872 */     // GIR_Coverage, 2643,
     /* 184872 */     GIR_EraseRootFromParent_Done,
     /* 184873 */   // Label 3607: @184873
     /* 184873 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(184910), // Rule ID 2644 //
     /* 184878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 184902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184908 */     GIR_RootConstrainSelectedInstOperands,
     /* 184909 */     // GIR_Coverage, 2644,
     /* 184909 */     GIR_EraseRootFromParent_Done,
     /* 184910 */   // Label 3608: @184910
     /* 184910 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(184947), // Rule ID 2645 //
     /* 184915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184936 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 184939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184945 */     GIR_RootConstrainSelectedInstOperands,
     /* 184946 */     // GIR_Coverage, 2645,
     /* 184946 */     GIR_EraseRootFromParent_Done,
     /* 184947 */   // Label 3609: @184947
     /* 184947 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(184984), // Rule ID 2646 //
     /* 184952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 184966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184973 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 184976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184982 */     GIR_RootConstrainSelectedInstOperands,
     /* 184983 */     // GIR_Coverage, 2646,
     /* 184983 */     GIR_EraseRootFromParent_Done,
     /* 184984 */   // Label 3610: @184984
     /* 184984 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185021), // Rule ID 2647 //
     /* 184989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 185003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185010 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 185013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185019 */     GIR_RootConstrainSelectedInstOperands,
     /* 185020 */     // GIR_Coverage, 2647,
     /* 185020 */     GIR_EraseRootFromParent_Done,
     /* 185021 */   // Label 3611: @185021
     /* 185021 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185058), // Rule ID 2648 //
     /* 185026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 185040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185047 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 185050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185056 */     GIR_RootConstrainSelectedInstOperands,
     /* 185057 */     // GIR_Coverage, 2648,
     /* 185057 */     GIR_EraseRootFromParent_Done,
     /* 185058 */   // Label 3612: @185058
     /* 185058 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(185095), // Rule ID 2826 //
     /* 185063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185084 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1543:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 185087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185093 */     GIR_RootConstrainSelectedInstOperands,
     /* 185094 */     // GIR_Coverage, 2826,
     /* 185094 */     GIR_EraseRootFromParent_Done,
     /* 185095 */   // Label 3613: @185095
     /* 185095 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(185132), // Rule ID 2827 //
     /* 185100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185121 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1543:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 185124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185130 */     GIR_RootConstrainSelectedInstOperands,
     /* 185131 */     // GIR_Coverage, 2827,
     /* 185131 */     GIR_EraseRootFromParent_Done,
     /* 185132 */   // Label 3614: @185132
     /* 185132 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(185169), // Rule ID 2828 //
     /* 185137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185158 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1543:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 185161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185167 */     GIR_RootConstrainSelectedInstOperands,
     /* 185168 */     // GIR_Coverage, 2828,
     /* 185168 */     GIR_EraseRootFromParent_Done,
     /* 185169 */   // Label 3615: @185169
     /* 185169 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185206), // Rule ID 2999 //
     /* 185174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185195 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1795:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 185198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185204 */     GIR_RootConstrainSelectedInstOperands,
     /* 185205 */     // GIR_Coverage, 2999,
     /* 185205 */     GIR_EraseRootFromParent_Done,
     /* 185206 */   // Label 3616: @185206
     /* 185206 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185243), // Rule ID 3000 //
     /* 185211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 185235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185241 */     GIR_RootConstrainSelectedInstOperands,
     /* 185242 */     // GIR_Coverage, 3000,
     /* 185242 */     GIR_EraseRootFromParent_Done,
     /* 185243 */   // Label 3617: @185243
     /* 185243 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185280), // Rule ID 3001 //
     /* 185248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 185272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185278 */     GIR_RootConstrainSelectedInstOperands,
     /* 185279 */     // GIR_Coverage, 3001,
     /* 185279 */     GIR_EraseRootFromParent_Done,
     /* 185280 */   // Label 3618: @185280
     /* 185280 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(185317), // Rule ID 3002 //
     /* 185285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 185309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185315 */     GIR_RootConstrainSelectedInstOperands,
     /* 185316 */     // GIR_Coverage, 3002,
     /* 185316 */     GIR_EraseRootFromParent_Done,
     /* 185317 */   // Label 3619: @185317
     /* 185317 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(185354), // Rule ID 3003 //
     /* 185322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 185330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185343 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1630:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 185346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185352 */     GIR_RootConstrainSelectedInstOperands,
     /* 185353 */     // GIR_Coverage, 3003,
     /* 185353 */     GIR_EraseRootFromParent_Done,
     /* 185354 */   // Label 3620: @185354
     /* 185354 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(185391), // Rule ID 3025 //
     /* 185359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185380 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 185383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185389 */     GIR_RootConstrainSelectedInstOperands,
     /* 185390 */     // GIR_Coverage, 3025,
     /* 185390 */     GIR_EraseRootFromParent_Done,
     /* 185391 */   // Label 3621: @185391
     /* 185391 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(185428), // Rule ID 3026 //
     /* 185396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185417 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 185420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185426 */     GIR_RootConstrainSelectedInstOperands,
     /* 185427 */     // GIR_Coverage, 3026,
     /* 185427 */     GIR_EraseRootFromParent_Done,
     /* 185428 */   // Label 3622: @185428
     /* 185428 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(185465), // Rule ID 3027 //
     /* 185433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185454 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 185457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185463 */     GIR_RootConstrainSelectedInstOperands,
     /* 185464 */     // GIR_Coverage, 3027,
     /* 185464 */     GIR_EraseRootFromParent_Done,
     /* 185465 */   // Label 3623: @185465
     /* 185465 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(185502), // Rule ID 3031 //
     /* 185470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 185473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185491 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1631:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 185494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185500 */     GIR_RootConstrainSelectedInstOperands,
     /* 185501 */     // GIR_Coverage, 3031,
     /* 185501 */     GIR_EraseRootFromParent_Done,
     /* 185502 */   // Label 3624: @185502
     /* 185502 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(185539), // Rule ID 3032 //
     /* 185507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1631:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 185531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185537 */     GIR_RootConstrainSelectedInstOperands,
     /* 185538 */     // GIR_Coverage, 3032,
     /* 185538 */     GIR_EraseRootFromParent_Done,
     /* 185539 */   // Label 3625: @185539
     /* 185539 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(185576), // Rule ID 3033 //
     /* 185544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1631:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 185568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185574 */     GIR_RootConstrainSelectedInstOperands,
     /* 185575 */     // GIR_Coverage, 3033,
     /* 185575 */     GIR_EraseRootFromParent_Done,
     /* 185576 */   // Label 3626: @185576
     /* 185576 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(185613), // Rule ID 3034 //
     /* 185581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185602 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1273:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 185605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185611 */     GIR_RootConstrainSelectedInstOperands,
     /* 185612 */     // GIR_Coverage, 3034,
     /* 185612 */     GIR_EraseRootFromParent_Done,
     /* 185613 */   // Label 3627: @185613
     /* 185613 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(185650), // Rule ID 3035 //
     /* 185618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1273:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 185642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185648 */     GIR_RootConstrainSelectedInstOperands,
     /* 185649 */     // GIR_Coverage, 3035,
     /* 185649 */     GIR_EraseRootFromParent_Done,
     /* 185650 */   // Label 3628: @185650
     /* 185650 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(185687), // Rule ID 3036 //
     /* 185655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1273:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 185679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185685 */     GIR_RootConstrainSelectedInstOperands,
     /* 185686 */     // GIR_Coverage, 3036,
     /* 185686 */     GIR_EraseRootFromParent_Done,
     /* 185687 */   // Label 3629: @185687
     /* 185687 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(185724), // Rule ID 3037 //
     /* 185692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1273:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 185716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185722 */     GIR_RootConstrainSelectedInstOperands,
     /* 185723 */     // GIR_Coverage, 3037,
     /* 185723 */     GIR_EraseRootFromParent_Done,
     /* 185724 */   // Label 3630: @185724
     /* 185724 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(185761), // Rule ID 3038 //
     /* 185729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185750 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 185753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185759 */     GIR_RootConstrainSelectedInstOperands,
     /* 185760 */     // GIR_Coverage, 3038,
     /* 185760 */     GIR_EraseRootFromParent_Done,
     /* 185761 */   // Label 3631: @185761
     /* 185761 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(185798), // Rule ID 3039 //
     /* 185766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 185790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185796 */     GIR_RootConstrainSelectedInstOperands,
     /* 185797 */     // GIR_Coverage, 3039,
     /* 185797 */     GIR_EraseRootFromParent_Done,
     /* 185798 */   // Label 3632: @185798
     /* 185798 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(185835), // Rule ID 3040 //
     /* 185803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 185827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185833 */     GIR_RootConstrainSelectedInstOperands,
     /* 185834 */     // GIR_Coverage, 3040,
     /* 185834 */     GIR_EraseRootFromParent_Done,
     /* 185835 */   // Label 3633: @185835
     /* 185835 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(185872), // Rule ID 3087 //
     /* 185840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185861 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1250:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 185864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185870 */     GIR_RootConstrainSelectedInstOperands,
     /* 185871 */     // GIR_Coverage, 3087,
     /* 185871 */     GIR_EraseRootFromParent_Done,
     /* 185872 */   // Label 3634: @185872
     /* 185872 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(185909), // Rule ID 3088 //
     /* 185877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185898 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1250:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 185901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185907 */     GIR_RootConstrainSelectedInstOperands,
     /* 185908 */     // GIR_Coverage, 3088,
     /* 185908 */     GIR_EraseRootFromParent_Done,
     /* 185909 */   // Label 3635: @185909
     /* 185909 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(185946), // Rule ID 3089 //
     /* 185914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185935 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1250:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 185938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185944 */     GIR_RootConstrainSelectedInstOperands,
     /* 185945 */     // GIR_Coverage, 3089,
     /* 185945 */     GIR_EraseRootFromParent_Done,
     /* 185946 */   // Label 3636: @185946
     /* 185946 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(185983), // Rule ID 3096 //
     /* 185951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185972 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 185975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185981 */     GIR_RootConstrainSelectedInstOperands,
     /* 185982 */     // GIR_Coverage, 3096,
     /* 185982 */     GIR_EraseRootFromParent_Done,
     /* 185983 */   // Label 3637: @185983
     /* 185983 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186020), // Rule ID 3097 //
     /* 185988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 186012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186018 */     GIR_RootConstrainSelectedInstOperands,
     /* 186019 */     // GIR_Coverage, 3097,
     /* 186019 */     GIR_EraseRootFromParent_Done,
     /* 186020 */   // Label 3638: @186020
     /* 186020 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186057), // Rule ID 3098 //
     /* 186025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 186033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 186049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186055 */     GIR_RootConstrainSelectedInstOperands,
     /* 186056 */     // GIR_Coverage, 3098,
     /* 186056 */     GIR_EraseRootFromParent_Done,
     /* 186057 */   // Label 3639: @186057
     /* 186057 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186097), // Rule ID 3202 //
     /* 186062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 186086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186095 */     GIR_RootConstrainSelectedInstOperands,
     /* 186096 */     // GIR_Coverage, 3202,
     /* 186096 */     GIR_EraseRootFromParent_Done,
     /* 186097 */   // Label 3640: @186097
     /* 186097 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(186137), // Rule ID 3203 //
     /* 186102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186123 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 186126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186135 */     GIR_RootConstrainSelectedInstOperands,
     /* 186136 */     // GIR_Coverage, 3203,
     /* 186136 */     GIR_EraseRootFromParent_Done,
     /* 186137 */   // Label 3641: @186137
     /* 186137 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(186177), // Rule ID 3204 //
     /* 186142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186163 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 186166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186175 */     GIR_RootConstrainSelectedInstOperands,
     /* 186176 */     // GIR_Coverage, 3204,
     /* 186176 */     GIR_EraseRootFromParent_Done,
     /* 186177 */   // Label 3642: @186177
     /* 186177 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186217), // Rule ID 3205 //
     /* 186182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 186193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186203 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 186206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186215 */     GIR_RootConstrainSelectedInstOperands,
     /* 186216 */     // GIR_Coverage, 3205,
     /* 186216 */     GIR_EraseRootFromParent_Done,
     /* 186217 */   // Label 3643: @186217
     /* 186217 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186257), // Rule ID 3210 //
     /* 186222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186243 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 186246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186255 */     GIR_RootConstrainSelectedInstOperands,
     /* 186256 */     // GIR_Coverage, 3210,
     /* 186256 */     GIR_EraseRootFromParent_Done,
     /* 186257 */   // Label 3644: @186257
     /* 186257 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186297), // Rule ID 3211 //
     /* 186262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186283 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 186286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186295 */     GIR_RootConstrainSelectedInstOperands,
     /* 186296 */     // GIR_Coverage, 3211,
     /* 186296 */     GIR_EraseRootFromParent_Done,
     /* 186297 */   // Label 3645: @186297
     /* 186297 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(186337), // Rule ID 3212 //
     /* 186302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186323 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 186326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186335 */     GIR_RootConstrainSelectedInstOperands,
     /* 186336 */     // GIR_Coverage, 3212,
     /* 186336 */     GIR_EraseRootFromParent_Done,
     /* 186337 */   // Label 3646: @186337
     /* 186337 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(186377), // Rule ID 3213 //
     /* 186342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 186353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186363 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 186366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186375 */     GIR_RootConstrainSelectedInstOperands,
     /* 186376 */     // GIR_Coverage, 3213,
     /* 186376 */     GIR_EraseRootFromParent_Done,
     /* 186377 */   // Label 3647: @186377
     /* 186377 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(186414), // Rule ID 3402 //
     /* 186382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186403 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 186406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186412 */     GIR_RootConstrainSelectedInstOperands,
     /* 186413 */     // GIR_Coverage, 3402,
     /* 186413 */     GIR_EraseRootFromParent_Done,
     /* 186414 */   // Label 3648: @186414
     /* 186414 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(186451), // Rule ID 3403 //
     /* 186419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186440 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 186443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186449 */     GIR_RootConstrainSelectedInstOperands,
     /* 186450 */     // GIR_Coverage, 3403,
     /* 186450 */     GIR_EraseRootFromParent_Done,
     /* 186451 */   // Label 3649: @186451
     /* 186451 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(186488), // Rule ID 3404 //
     /* 186456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 186480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186486 */     GIR_RootConstrainSelectedInstOperands,
     /* 186487 */     // GIR_Coverage, 3404,
     /* 186487 */     GIR_EraseRootFromParent_Done,
     /* 186488 */   // Label 3650: @186488
     /* 186488 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(186525), // Rule ID 3405 //
     /* 186493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186514 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 186517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186523 */     GIR_RootConstrainSelectedInstOperands,
     /* 186524 */     // GIR_Coverage, 3405,
     /* 186524 */     GIR_EraseRootFromParent_Done,
     /* 186525 */   // Label 3651: @186525
     /* 186525 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(186562), // Rule ID 3427 //
     /* 186530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186551 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 186554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186560 */     GIR_RootConstrainSelectedInstOperands,
     /* 186561 */     // GIR_Coverage, 3427,
     /* 186561 */     GIR_EraseRootFromParent_Done,
     /* 186562 */   // Label 3652: @186562
     /* 186562 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(186599), // Rule ID 3428 //
     /* 186567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186588 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 186591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186597 */     GIR_RootConstrainSelectedInstOperands,
     /* 186598 */     // GIR_Coverage, 3428,
     /* 186598 */     GIR_EraseRootFromParent_Done,
     /* 186599 */   // Label 3653: @186599
     /* 186599 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(186636), // Rule ID 3429 //
     /* 186604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186625 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 186628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186634 */     GIR_RootConstrainSelectedInstOperands,
     /* 186635 */     // GIR_Coverage, 3429,
     /* 186635 */     GIR_EraseRootFromParent_Done,
     /* 186636 */   // Label 3654: @186636
     /* 186636 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(186673), // Rule ID 3451 //
     /* 186641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 186649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186662 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 186662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 186665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186671 */     GIR_RootConstrainSelectedInstOperands,
     /* 186672 */     // GIR_Coverage, 3451,
     /* 186672 */     GIR_EraseRootFromParent_Done,
     /* 186673 */   // Label 3655: @186673
     /* 186673 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(186710), // Rule ID 3456 //
     /* 186678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 186681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 186686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 186702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186708 */     GIR_RootConstrainSelectedInstOperands,
     /* 186709 */     // GIR_Coverage, 3456,
     /* 186709 */     GIR_EraseRootFromParent_Done,
     /* 186710 */   // Label 3656: @186710
     /* 186710 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(186747), // Rule ID 3457 //
     /* 186715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 186718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 186723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186736 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 186739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 186741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186745 */     GIR_RootConstrainSelectedInstOperands,
     /* 186746 */     // GIR_Coverage, 3457,
     /* 186746 */     GIR_EraseRootFromParent_Done,
     /* 186747 */   // Label 3657: @186747
     /* 186747 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(186784), // Rule ID 3466 //
     /* 186752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186773 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186782 */     GIR_RootConstrainSelectedInstOperands,
     /* 186783 */     // GIR_Coverage, 3466,
     /* 186783 */     GIR_EraseRootFromParent_Done,
     /* 186784 */   // Label 3658: @186784
     /* 186784 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(186821), // Rule ID 3467 //
     /* 186789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186819 */     GIR_RootConstrainSelectedInstOperands,
     /* 186820 */     // GIR_Coverage, 3467,
     /* 186820 */     GIR_EraseRootFromParent_Done,
     /* 186821 */   // Label 3659: @186821
     /* 186821 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(186858), // Rule ID 3468 //
     /* 186826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186847 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2154:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186856 */     GIR_RootConstrainSelectedInstOperands,
     /* 186857 */     // GIR_Coverage, 3468,
     /* 186857 */     GIR_EraseRootFromParent_Done,
     /* 186858 */   // Label 3660: @186858
     /* 186858 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(186895), // Rule ID 3469 //
     /* 186863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186893 */     GIR_RootConstrainSelectedInstOperands,
     /* 186894 */     // GIR_Coverage, 3469,
     /* 186894 */     GIR_EraseRootFromParent_Done,
     /* 186895 */   // Label 3661: @186895
     /* 186895 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(186932), // Rule ID 3470 //
     /* 186900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186921 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2154:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186930 */     GIR_RootConstrainSelectedInstOperands,
     /* 186931 */     // GIR_Coverage, 3470,
     /* 186931 */     GIR_EraseRootFromParent_Done,
     /* 186932 */   // Label 3662: @186932
     /* 186932 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(186969), // Rule ID 3471 //
     /* 186937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186967 */     GIR_RootConstrainSelectedInstOperands,
     /* 186968 */     // GIR_Coverage, 3471,
     /* 186968 */     GIR_EraseRootFromParent_Done,
     /* 186969 */   // Label 3663: @186969
     /* 186969 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(187006), // Rule ID 3472 //
     /* 186974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186995 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2154:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187004 */     GIR_RootConstrainSelectedInstOperands,
     /* 187005 */     // GIR_Coverage, 3472,
     /* 187005 */     GIR_EraseRootFromParent_Done,
     /* 187006 */   // Label 3664: @187006
     /* 187006 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187043), // Rule ID 3527 //
     /* 187011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187032 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 187035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187041 */     GIR_RootConstrainSelectedInstOperands,
     /* 187042 */     // GIR_Coverage, 3527,
     /* 187042 */     GIR_EraseRootFromParent_Done,
     /* 187043 */   // Label 3665: @187043
     /* 187043 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(187080), // Rule ID 3528 //
     /* 187048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187069 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 187072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187078 */     GIR_RootConstrainSelectedInstOperands,
     /* 187079 */     // GIR_Coverage, 3528,
     /* 187079 */     GIR_EraseRootFromParent_Done,
     /* 187080 */   // Label 3666: @187080
     /* 187080 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(187117), // Rule ID 3529 //
     /* 187085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187106 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 187109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187115 */     GIR_RootConstrainSelectedInstOperands,
     /* 187116 */     // GIR_Coverage, 3529,
     /* 187116 */     GIR_EraseRootFromParent_Done,
     /* 187117 */   // Label 3667: @187117
     /* 187117 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(187154), // Rule ID 3559 //
     /* 187122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187143 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 187146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187152 */     GIR_RootConstrainSelectedInstOperands,
     /* 187153 */     // GIR_Coverage, 3559,
     /* 187153 */     GIR_EraseRootFromParent_Done,
     /* 187154 */   // Label 3668: @187154
     /* 187154 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(187191), // Rule ID 3560 //
     /* 187159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187180 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 187183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187189 */     GIR_RootConstrainSelectedInstOperands,
     /* 187190 */     // GIR_Coverage, 3560,
     /* 187190 */     GIR_EraseRootFromParent_Done,
     /* 187191 */   // Label 3669: @187191
     /* 187191 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187228), // Rule ID 3561 //
     /* 187196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187217 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 187220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187226 */     GIR_RootConstrainSelectedInstOperands,
     /* 187227 */     // GIR_Coverage, 3561,
     /* 187227 */     GIR_EraseRootFromParent_Done,
     /* 187228 */   // Label 3670: @187228
     /* 187228 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187265), // Rule ID 3562 //
     /* 187233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187254 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 187257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187263 */     GIR_RootConstrainSelectedInstOperands,
     /* 187264 */     // GIR_Coverage, 3562,
     /* 187264 */     GIR_EraseRootFromParent_Done,
     /* 187265 */   // Label 3671: @187265
     /* 187265 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(187302), // Rule ID 3563 //
     /* 187270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187291 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2162:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 187294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187300 */     GIR_RootConstrainSelectedInstOperands,
     /* 187301 */     // GIR_Coverage, 3563,
     /* 187301 */     GIR_EraseRootFromParent_Done,
     /* 187302 */   // Label 3672: @187302
     /* 187302 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(187339), // Rule ID 3564 //
     /* 187307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2162:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 187331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187337 */     GIR_RootConstrainSelectedInstOperands,
     /* 187338 */     // GIR_Coverage, 3564,
     /* 187338 */     GIR_EraseRootFromParent_Done,
     /* 187339 */   // Label 3673: @187339
     /* 187339 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(187376), // Rule ID 3565 //
     /* 187344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 187368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187374 */     GIR_RootConstrainSelectedInstOperands,
     /* 187375 */     // GIR_Coverage, 3565,
     /* 187375 */     GIR_EraseRootFromParent_Done,
     /* 187376 */   // Label 3674: @187376
     /* 187376 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(187413), // Rule ID 3566 //
     /* 187381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 187405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187411 */     GIR_RootConstrainSelectedInstOperands,
     /* 187412 */     // GIR_Coverage, 3566,
     /* 187412 */     GIR_EraseRootFromParent_Done,
     /* 187413 */   // Label 3675: @187413
     /* 187413 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(187450), // Rule ID 3567 //
     /* 187418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187439 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2162:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 187442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187448 */     GIR_RootConstrainSelectedInstOperands,
     /* 187449 */     // GIR_Coverage, 3567,
     /* 187449 */     GIR_EraseRootFromParent_Done,
     /* 187450 */   // Label 3676: @187450
     /* 187450 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(187487), // Rule ID 3568 //
     /* 187455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2162:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 187479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187485 */     GIR_RootConstrainSelectedInstOperands,
     /* 187486 */     // GIR_Coverage, 3568,
     /* 187486 */     GIR_EraseRootFromParent_Done,
     /* 187487 */   // Label 3677: @187487
     /* 187487 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(187524), // Rule ID 3569 //
     /* 187492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187513 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2162:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 187516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187522 */     GIR_RootConstrainSelectedInstOperands,
     /* 187523 */     // GIR_Coverage, 3569,
     /* 187523 */     GIR_EraseRootFromParent_Done,
     /* 187524 */   // Label 3678: @187524
     /* 187524 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(187561), // Rule ID 3570 //
     /* 187529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1917:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 187553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187559 */     GIR_RootConstrainSelectedInstOperands,
     /* 187560 */     // GIR_Coverage, 3570,
     /* 187560 */     GIR_EraseRootFromParent_Done,
     /* 187561 */   // Label 3679: @187561
     /* 187561 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(187598), // Rule ID 3571 //
     /* 187566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187587 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 187590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187596 */     GIR_RootConstrainSelectedInstOperands,
     /* 187597 */     // GIR_Coverage, 3571,
     /* 187597 */     GIR_EraseRootFromParent_Done,
     /* 187598 */   // Label 3680: @187598
     /* 187598 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(187635), // Rule ID 3572 //
     /* 187603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 187627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187633 */     GIR_RootConstrainSelectedInstOperands,
     /* 187634 */     // GIR_Coverage, 3572,
     /* 187634 */     GIR_EraseRootFromParent_Done,
     /* 187635 */   // Label 3681: @187635
     /* 187635 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(187672), // Rule ID 3573 //
     /* 187640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 187664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187670 */     GIR_RootConstrainSelectedInstOperands,
     /* 187671 */     // GIR_Coverage, 3573,
     /* 187671 */     GIR_EraseRootFromParent_Done,
     /* 187672 */   // Label 3682: @187672
     /* 187672 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(187709), // Rule ID 3574 //
     /* 187677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187698 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1917:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 187701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187707 */     GIR_RootConstrainSelectedInstOperands,
     /* 187708 */     // GIR_Coverage, 3574,
     /* 187708 */     GIR_EraseRootFromParent_Done,
     /* 187709 */   // Label 3683: @187709
     /* 187709 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(187746), // Rule ID 3575 //
     /* 187714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187735 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1917:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 187738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187744 */     GIR_RootConstrainSelectedInstOperands,
     /* 187745 */     // GIR_Coverage, 3575,
     /* 187745 */     GIR_EraseRootFromParent_Done,
     /* 187746 */   // Label 3684: @187746
     /* 187746 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(187783), // Rule ID 3576 //
     /* 187751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187772 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1917:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 187775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187781 */     GIR_RootConstrainSelectedInstOperands,
     /* 187782 */     // GIR_Coverage, 3576,
     /* 187782 */     GIR_EraseRootFromParent_Done,
     /* 187783 */   // Label 3685: @187783
     /* 187783 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(187820), // Rule ID 8384 //
     /* 187788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 187796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187809 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1296:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 187812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187818 */     GIR_RootConstrainSelectedInstOperands,
     /* 187819 */     // GIR_Coverage, 8384,
     /* 187819 */     GIR_EraseRootFromParent_Done,
     /* 187820 */   // Label 3686: @187820
     /* 187820 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(187857), // Rule ID 8860 //
     /* 187825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 187833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1254:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 187849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187855 */     GIR_RootConstrainSelectedInstOperands,
     /* 187856 */     // GIR_Coverage, 8860,
     /* 187856 */     GIR_EraseRootFromParent_Done,
     /* 187857 */   // Label 3687: @187857
     /* 187857 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(187894), // Rule ID 8861 //
     /* 187862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 187870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1256:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 187886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187892 */     GIR_RootConstrainSelectedInstOperands,
     /* 187893 */     // GIR_Coverage, 8861,
     /* 187893 */     GIR_EraseRootFromParent_Done,
     /* 187894 */   // Label 3688: @187894
     /* 187894 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(187931), // Rule ID 8862 //
     /* 187899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 187907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187920 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 187923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187929 */     GIR_RootConstrainSelectedInstOperands,
     /* 187930 */     // GIR_Coverage, 8862,
     /* 187930 */     GIR_EraseRootFromParent_Done,
     /* 187931 */   // Label 3689: @187931
     /* 187931 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(187968), // Rule ID 8863 //
     /* 187936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 187944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187957 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 187960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187966 */     GIR_RootConstrainSelectedInstOperands,
     /* 187967 */     // GIR_Coverage, 8863,
     /* 187967 */     GIR_EraseRootFromParent_Done,
     /* 187968 */   // Label 3690: @187968
     /* 187968 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(188005), // Rule ID 8864 //
     /* 187973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 187981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 187997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188003 */     GIR_RootConstrainSelectedInstOperands,
     /* 188004 */     // GIR_Coverage, 8864,
     /* 188004 */     GIR_EraseRootFromParent_Done,
     /* 188005 */   // Label 3691: @188005
     /* 188005 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(188042), // Rule ID 8865 //
     /* 188010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 188018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188031 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1256:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 188034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188040 */     GIR_RootConstrainSelectedInstOperands,
     /* 188041 */     // GIR_Coverage, 8865,
     /* 188041 */     GIR_EraseRootFromParent_Done,
     /* 188042 */   // Label 3692: @188042
     /* 188042 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(188079), // Rule ID 8866 //
     /* 188047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 188055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188068 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 188071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188077 */     GIR_RootConstrainSelectedInstOperands,
     /* 188078 */     // GIR_Coverage, 8866,
     /* 188078 */     GIR_EraseRootFromParent_Done,
     /* 188079 */   // Label 3693: @188079
     /* 188079 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(188116), // Rule ID 8867 //
     /* 188084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 188092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188105 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 188108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188114 */     GIR_RootConstrainSelectedInstOperands,
     /* 188115 */     // GIR_Coverage, 8867,
     /* 188115 */     GIR_EraseRootFromParent_Done,
     /* 188116 */   // Label 3694: @188116
     /* 188116 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(188156), // Rule ID 9867 //
     /* 188121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 188145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188154 */     GIR_RootConstrainSelectedInstOperands,
     /* 188155 */     // GIR_Coverage, 9867,
     /* 188155 */     GIR_EraseRootFromParent_Done,
     /* 188156 */   // Label 3695: @188156
     /* 188156 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(188196), // Rule ID 9868 //
     /* 188161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 188185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188194 */     GIR_RootConstrainSelectedInstOperands,
     /* 188195 */     // GIR_Coverage, 9868,
     /* 188195 */     GIR_EraseRootFromParent_Done,
     /* 188196 */   // Label 3696: @188196
     /* 188196 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(188236), // Rule ID 9869 //
     /* 188201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188222 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 188225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188234 */     GIR_RootConstrainSelectedInstOperands,
     /* 188235 */     // GIR_Coverage, 9869,
     /* 188235 */     GIR_EraseRootFromParent_Done,
     /* 188236 */   // Label 3697: @188236
     /* 188236 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(188276), // Rule ID 9870 //
     /* 188241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188262 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 188265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188274 */     GIR_RootConstrainSelectedInstOperands,
     /* 188275 */     // GIR_Coverage, 9870,
     /* 188275 */     GIR_EraseRootFromParent_Done,
     /* 188276 */   // Label 3698: @188276
     /* 188276 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(188316), // Rule ID 9871 //
     /* 188281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188302 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 188305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188314 */     GIR_RootConstrainSelectedInstOperands,
     /* 188315 */     // GIR_Coverage, 9871,
     /* 188315 */     GIR_EraseRootFromParent_Done,
     /* 188316 */   // Label 3699: @188316
     /* 188316 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(188356), // Rule ID 9872 //
     /* 188321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 188345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188354 */     GIR_RootConstrainSelectedInstOperands,
     /* 188355 */     // GIR_Coverage, 9872,
     /* 188355 */     GIR_EraseRootFromParent_Done,
     /* 188356 */   // Label 3700: @188356
     /* 188356 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(188396), // Rule ID 9873 //
     /* 188361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 188385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188394 */     GIR_RootConstrainSelectedInstOperands,
     /* 188395 */     // GIR_Coverage, 9873,
     /* 188395 */     GIR_EraseRootFromParent_Done,
     /* 188396 */   // Label 3701: @188396
     /* 188396 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(188436), // Rule ID 9874 //
     /* 188401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 188425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188434 */     GIR_RootConstrainSelectedInstOperands,
     /* 188435 */     // GIR_Coverage, 9874,
     /* 188435 */     GIR_EraseRootFromParent_Done,
     /* 188436 */   // Label 3702: @188436
     /* 188436 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(188476), // Rule ID 9879 //
     /* 188441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188462 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 188465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188474 */     GIR_RootConstrainSelectedInstOperands,
     /* 188475 */     // GIR_Coverage, 9879,
     /* 188475 */     GIR_EraseRootFromParent_Done,
     /* 188476 */   // Label 3703: @188476
     /* 188476 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(188516), // Rule ID 9880 //
     /* 188481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188502 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 188505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188514 */     GIR_RootConstrainSelectedInstOperands,
     /* 188515 */     // GIR_Coverage, 9880,
     /* 188515 */     GIR_EraseRootFromParent_Done,
     /* 188516 */   // Label 3704: @188516
     /* 188516 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(188556), // Rule ID 9881 //
     /* 188521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188542 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 188545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188554 */     GIR_RootConstrainSelectedInstOperands,
     /* 188555 */     // GIR_Coverage, 9881,
     /* 188555 */     GIR_EraseRootFromParent_Done,
     /* 188556 */   // Label 3705: @188556
     /* 188556 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(188596), // Rule ID 9882 //
     /* 188561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188582 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 188585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188594 */     GIR_RootConstrainSelectedInstOperands,
     /* 188595 */     // GIR_Coverage, 9882,
     /* 188595 */     GIR_EraseRootFromParent_Done,
     /* 188596 */   // Label 3706: @188596
     /* 188596 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(188636), // Rule ID 9883 //
     /* 188601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188622 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 188625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188634 */     GIR_RootConstrainSelectedInstOperands,
     /* 188635 */     // GIR_Coverage, 9883,
     /* 188635 */     GIR_EraseRootFromParent_Done,
     /* 188636 */   // Label 3707: @188636
     /* 188636 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(188676), // Rule ID 9884 //
     /* 188641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 188665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188674 */     GIR_RootConstrainSelectedInstOperands,
     /* 188675 */     // GIR_Coverage, 9884,
     /* 188675 */     GIR_EraseRootFromParent_Done,
     /* 188676 */   // Label 3708: @188676
     /* 188676 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(188716), // Rule ID 9885 //
     /* 188681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188702 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 188705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188714 */     GIR_RootConstrainSelectedInstOperands,
     /* 188715 */     // GIR_Coverage, 9885,
     /* 188715 */     GIR_EraseRootFromParent_Done,
     /* 188716 */   // Label 3709: @188716
     /* 188716 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(188756), // Rule ID 9886 //
     /* 188721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 188745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188754 */     GIR_RootConstrainSelectedInstOperands,
     /* 188755 */     // GIR_Coverage, 9886,
     /* 188755 */     GIR_EraseRootFromParent_Done,
     /* 188756 */   // Label 3710: @188756
     /* 188756 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(188796), // Rule ID 9887 //
     /* 188761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188782 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 188785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188794 */     GIR_RootConstrainSelectedInstOperands,
     /* 188795 */     // GIR_Coverage, 9887,
     /* 188795 */     GIR_EraseRootFromParent_Done,
     /* 188796 */   // Label 3711: @188796
     /* 188796 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(188836), // Rule ID 9888 //
     /* 188801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 188825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188834 */     GIR_RootConstrainSelectedInstOperands,
     /* 188835 */     // GIR_Coverage, 9888,
     /* 188835 */     GIR_EraseRootFromParent_Done,
     /* 188836 */   // Label 3712: @188836
     /* 188836 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(188876), // Rule ID 9889 //
     /* 188841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 188865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188874 */     GIR_RootConstrainSelectedInstOperands,
     /* 188875 */     // GIR_Coverage, 9889,
     /* 188875 */     GIR_EraseRootFromParent_Done,
     /* 188876 */   // Label 3713: @188876
     /* 188876 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(188916), // Rule ID 9890 //
     /* 188881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188902 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 188905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188914 */     GIR_RootConstrainSelectedInstOperands,
     /* 188915 */     // GIR_Coverage, 9890,
     /* 188915 */     GIR_EraseRootFromParent_Done,
     /* 188916 */   // Label 3714: @188916
     /* 188916 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(188956), // Rule ID 9895 //
     /* 188921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 188945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188954 */     GIR_RootConstrainSelectedInstOperands,
     /* 188955 */     // GIR_Coverage, 9895,
     /* 188955 */     GIR_EraseRootFromParent_Done,
     /* 188956 */   // Label 3715: @188956
     /* 188956 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(188996), // Rule ID 9896 //
     /* 188961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188982 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 188985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188994 */     GIR_RootConstrainSelectedInstOperands,
     /* 188995 */     // GIR_Coverage, 9896,
     /* 188995 */     GIR_EraseRootFromParent_Done,
     /* 188996 */   // Label 3716: @188996
     /* 188996 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(189036), // Rule ID 9897 //
     /* 189001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189022 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 189025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189034 */     GIR_RootConstrainSelectedInstOperands,
     /* 189035 */     // GIR_Coverage, 9897,
     /* 189035 */     GIR_EraseRootFromParent_Done,
     /* 189036 */   // Label 3717: @189036
     /* 189036 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(189076), // Rule ID 9898 //
     /* 189041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 189065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189074 */     GIR_RootConstrainSelectedInstOperands,
     /* 189075 */     // GIR_Coverage, 9898,
     /* 189075 */     GIR_EraseRootFromParent_Done,
     /* 189076 */   // Label 3718: @189076
     /* 189076 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(189113), // Rule ID 10057 //
     /* 189081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2024:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 189105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189111 */     GIR_RootConstrainSelectedInstOperands,
     /* 189112 */     // GIR_Coverage, 10057,
     /* 189112 */     GIR_EraseRootFromParent_Done,
     /* 189113 */   // Label 3719: @189113
     /* 189113 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(189150), // Rule ID 10058 //
     /* 189118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2024:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 189142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189148 */     GIR_RootConstrainSelectedInstOperands,
     /* 189149 */     // GIR_Coverage, 10058,
     /* 189149 */     GIR_EraseRootFromParent_Done,
     /* 189150 */   // Label 3720: @189150
     /* 189150 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(189187), // Rule ID 10059 //
     /* 189155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2024:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 189179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189185 */     GIR_RootConstrainSelectedInstOperands,
     /* 189186 */     // GIR_Coverage, 10059,
     /* 189186 */     GIR_EraseRootFromParent_Done,
     /* 189187 */   // Label 3721: @189187
     /* 189187 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(189224), // Rule ID 10060 //
     /* 189192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189213 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 189216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189222 */     GIR_RootConstrainSelectedInstOperands,
     /* 189223 */     // GIR_Coverage, 10060,
     /* 189223 */     GIR_EraseRootFromParent_Done,
     /* 189224 */   // Label 3722: @189224
     /* 189224 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(189261), // Rule ID 10061 //
     /* 189229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 189253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189259 */     GIR_RootConstrainSelectedInstOperands,
     /* 189260 */     // GIR_Coverage, 10061,
     /* 189260 */     GIR_EraseRootFromParent_Done,
     /* 189261 */   // Label 3723: @189261
     /* 189261 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(189298), // Rule ID 10062 //
     /* 189266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189287 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 189290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189296 */     GIR_RootConstrainSelectedInstOperands,
     /* 189297 */     // GIR_Coverage, 10062,
     /* 189297 */     GIR_EraseRootFromParent_Done,
     /* 189298 */   // Label 3724: @189298
     /* 189298 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(189335), // Rule ID 10063 //
     /* 189303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2010:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 189327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189333 */     GIR_RootConstrainSelectedInstOperands,
     /* 189334 */     // GIR_Coverage, 10063,
     /* 189334 */     GIR_EraseRootFromParent_Done,
     /* 189335 */   // Label 3725: @189335
     /* 189335 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(189372), // Rule ID 10064 //
     /* 189340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2010:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 189364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189370 */     GIR_RootConstrainSelectedInstOperands,
     /* 189371 */     // GIR_Coverage, 10064,
     /* 189371 */     GIR_EraseRootFromParent_Done,
     /* 189372 */   // Label 3726: @189372
     /* 189372 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(189409), // Rule ID 10065 //
     /* 189377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 189401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189407 */     GIR_RootConstrainSelectedInstOperands,
     /* 189408 */     // GIR_Coverage, 10065,
     /* 189408 */     GIR_EraseRootFromParent_Done,
     /* 189409 */   // Label 3727: @189409
     /* 189409 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(189446), // Rule ID 11253 //
     /* 189414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189435 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2159:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189444 */     GIR_RootConstrainSelectedInstOperands,
     /* 189445 */     // GIR_Coverage, 11253,
     /* 189445 */     GIR_EraseRootFromParent_Done,
     /* 189446 */   // Label 3728: @189446
     /* 189446 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(189483), // Rule ID 11254 //
     /* 189451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2159:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189481 */     GIR_RootConstrainSelectedInstOperands,
     /* 189482 */     // GIR_Coverage, 11254,
     /* 189482 */     GIR_EraseRootFromParent_Done,
     /* 189483 */   // Label 3729: @189483
     /* 189483 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(189520), // Rule ID 11255 //
     /* 189488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189509 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2159:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189518 */     GIR_RootConstrainSelectedInstOperands,
     /* 189519 */     // GIR_Coverage, 11255,
     /* 189519 */     GIR_EraseRootFromParent_Done,
     /* 189520 */   // Label 3730: @189520
     /* 189520 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(189557), // Rule ID 11256 //
     /* 189525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2159:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189555 */     GIR_RootConstrainSelectedInstOperands,
     /* 189556 */     // GIR_Coverage, 11256,
     /* 189556 */     GIR_EraseRootFromParent_Done,
     /* 189557 */   // Label 3731: @189557
     /* 189557 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(189594), // Rule ID 11257 //
     /* 189562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189583 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2159:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189592 */     GIR_RootConstrainSelectedInstOperands,
     /* 189593 */     // GIR_Coverage, 11257,
     /* 189593 */     GIR_EraseRootFromParent_Done,
     /* 189594 */   // Label 3732: @189594
     /* 189594 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(189631), // Rule ID 11258 //
     /* 189599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189620 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2159:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189629 */     GIR_RootConstrainSelectedInstOperands,
     /* 189630 */     // GIR_Coverage, 11258,
     /* 189630 */     GIR_EraseRootFromParent_Done,
     /* 189631 */   // Label 3733: @189631
     /* 189631 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(189668), // Rule ID 11259 //
     /* 189636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2159:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189666 */     GIR_RootConstrainSelectedInstOperands,
     /* 189667 */     // GIR_Coverage, 11259,
     /* 189667 */     GIR_EraseRootFromParent_Done,
     /* 189668 */   // Label 3734: @189668
     /* 189668 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(189705), // Rule ID 11260 //
     /* 189673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2080:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189703 */     GIR_RootConstrainSelectedInstOperands,
     /* 189704 */     // GIR_Coverage, 11260,
     /* 189704 */     GIR_EraseRootFromParent_Done,
     /* 189705 */   // Label 3735: @189705
     /* 189705 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(189742), // Rule ID 11261 //
     /* 189710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2080:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189740 */     GIR_RootConstrainSelectedInstOperands,
     /* 189741 */     // GIR_Coverage, 11261,
     /* 189741 */     GIR_EraseRootFromParent_Done,
     /* 189742 */   // Label 3736: @189742
     /* 189742 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(189779), // Rule ID 11262 //
     /* 189747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189768 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2080:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189777 */     GIR_RootConstrainSelectedInstOperands,
     /* 189778 */     // GIR_Coverage, 11262,
     /* 189778 */     GIR_EraseRootFromParent_Done,
     /* 189779 */   // Label 3737: @189779
     /* 189779 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(189816), // Rule ID 11263 //
     /* 189784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2080:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189814 */     GIR_RootConstrainSelectedInstOperands,
     /* 189815 */     // GIR_Coverage, 11263,
     /* 189815 */     GIR_EraseRootFromParent_Done,
     /* 189816 */   // Label 3738: @189816
     /* 189816 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(189853), // Rule ID 11264 //
     /* 189821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189842 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2080:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189851 */     GIR_RootConstrainSelectedInstOperands,
     /* 189852 */     // GIR_Coverage, 11264,
     /* 189852 */     GIR_EraseRootFromParent_Done,
     /* 189853 */   // Label 3739: @189853
     /* 189853 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(189890), // Rule ID 11265 //
     /* 189858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189879 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2080:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189888 */     GIR_RootConstrainSelectedInstOperands,
     /* 189889 */     // GIR_Coverage, 11265,
     /* 189889 */     GIR_EraseRootFromParent_Done,
     /* 189890 */   // Label 3740: @189890
     /* 189890 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(189927), // Rule ID 11266 //
     /* 189895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189916 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2080:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189925 */     GIR_RootConstrainSelectedInstOperands,
     /* 189926 */     // GIR_Coverage, 11266,
     /* 189926 */     GIR_EraseRootFromParent_Done,
     /* 189927 */   // Label 3741: @189927
     /* 189927 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(189964), // Rule ID 11267 //
     /* 189932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189953 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2085:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189962 */     GIR_RootConstrainSelectedInstOperands,
     /* 189963 */     // GIR_Coverage, 11267,
     /* 189963 */     GIR_EraseRootFromParent_Done,
     /* 189964 */   // Label 3742: @189964
     /* 189964 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(190001), // Rule ID 11268 //
     /* 189969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189990 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2085:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189999 */     GIR_RootConstrainSelectedInstOperands,
     /* 190000 */     // GIR_Coverage, 11268,
     /* 190000 */     GIR_EraseRootFromParent_Done,
     /* 190001 */   // Label 3743: @190001
     /* 190001 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(190038), // Rule ID 11269 //
     /* 190006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190027 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2085:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190036 */     GIR_RootConstrainSelectedInstOperands,
     /* 190037 */     // GIR_Coverage, 11269,
     /* 190037 */     GIR_EraseRootFromParent_Done,
     /* 190038 */   // Label 3744: @190038
     /* 190038 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(190075), // Rule ID 11270 //
     /* 190043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2085:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190073 */     GIR_RootConstrainSelectedInstOperands,
     /* 190074 */     // GIR_Coverage, 11270,
     /* 190074 */     GIR_EraseRootFromParent_Done,
     /* 190075 */   // Label 3745: @190075
     /* 190075 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(190112), // Rule ID 11271 //
     /* 190080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190101 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2085:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190110 */     GIR_RootConstrainSelectedInstOperands,
     /* 190111 */     // GIR_Coverage, 11271,
     /* 190111 */     GIR_EraseRootFromParent_Done,
     /* 190112 */   // Label 3746: @190112
     /* 190112 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(190149), // Rule ID 11272 //
     /* 190117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190138 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2085:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190147 */     GIR_RootConstrainSelectedInstOperands,
     /* 190148 */     // GIR_Coverage, 11272,
     /* 190148 */     GIR_EraseRootFromParent_Done,
     /* 190149 */   // Label 3747: @190149
     /* 190149 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(190186), // Rule ID 11273 //
     /* 190154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2085:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190184 */     GIR_RootConstrainSelectedInstOperands,
     /* 190185 */     // GIR_Coverage, 11273,
     /* 190185 */     GIR_EraseRootFromParent_Done,
     /* 190186 */   // Label 3748: @190186
     /* 190186 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(190223), // Rule ID 11274 //
     /* 190191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190221 */     GIR_RootConstrainSelectedInstOperands,
     /* 190222 */     // GIR_Coverage, 11274,
     /* 190222 */     GIR_EraseRootFromParent_Done,
     /* 190223 */   // Label 3749: @190223
     /* 190223 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(190260), // Rule ID 11275 //
     /* 190228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190258 */     GIR_RootConstrainSelectedInstOperands,
     /* 190259 */     // GIR_Coverage, 11275,
     /* 190259 */     GIR_EraseRootFromParent_Done,
     /* 190260 */   // Label 3750: @190260
     /* 190260 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(190297), // Rule ID 11276 //
     /* 190265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190286 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1924:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190295 */     GIR_RootConstrainSelectedInstOperands,
     /* 190296 */     // GIR_Coverage, 11276,
     /* 190296 */     GIR_EraseRootFromParent_Done,
     /* 190297 */   // Label 3751: @190297
     /* 190297 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(190334), // Rule ID 11277 //
     /* 190302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190332 */     GIR_RootConstrainSelectedInstOperands,
     /* 190333 */     // GIR_Coverage, 11277,
     /* 190333 */     GIR_EraseRootFromParent_Done,
     /* 190334 */   // Label 3752: @190334
     /* 190334 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(190371), // Rule ID 11278 //
     /* 190339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190360 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1924:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190369 */     GIR_RootConstrainSelectedInstOperands,
     /* 190370 */     // GIR_Coverage, 11278,
     /* 190370 */     GIR_EraseRootFromParent_Done,
     /* 190371 */   // Label 3753: @190371
     /* 190371 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(190408), // Rule ID 11279 //
     /* 190376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190397 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190406 */     GIR_RootConstrainSelectedInstOperands,
     /* 190407 */     // GIR_Coverage, 11279,
     /* 190407 */     GIR_EraseRootFromParent_Done,
     /* 190408 */   // Label 3754: @190408
     /* 190408 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(190445), // Rule ID 11280 //
     /* 190413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190434 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1924:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190443 */     GIR_RootConstrainSelectedInstOperands,
     /* 190444 */     // GIR_Coverage, 11280,
     /* 190444 */     GIR_EraseRootFromParent_Done,
     /* 190445 */   // Label 3755: @190445
     /* 190445 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(190482), // Rule ID 11281 //
     /* 190450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190480 */     GIR_RootConstrainSelectedInstOperands,
     /* 190481 */     // GIR_Coverage, 11281,
     /* 190481 */     GIR_EraseRootFromParent_Done,
     /* 190482 */   // Label 3756: @190482
     /* 190482 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(190519), // Rule ID 11282 //
     /* 190487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190517 */     GIR_RootConstrainSelectedInstOperands,
     /* 190518 */     // GIR_Coverage, 11282,
     /* 190518 */     GIR_EraseRootFromParent_Done,
     /* 190519 */   // Label 3757: @190519
     /* 190519 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(190556), // Rule ID 11283 //
     /* 190524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190545 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1929:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190554 */     GIR_RootConstrainSelectedInstOperands,
     /* 190555 */     // GIR_Coverage, 11283,
     /* 190555 */     GIR_EraseRootFromParent_Done,
     /* 190556 */   // Label 3758: @190556
     /* 190556 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(190593), // Rule ID 11284 //
     /* 190561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190591 */     GIR_RootConstrainSelectedInstOperands,
     /* 190592 */     // GIR_Coverage, 11284,
     /* 190592 */     GIR_EraseRootFromParent_Done,
     /* 190593 */   // Label 3759: @190593
     /* 190593 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(190630), // Rule ID 11285 //
     /* 190598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190619 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1929:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190628 */     GIR_RootConstrainSelectedInstOperands,
     /* 190629 */     // GIR_Coverage, 11285,
     /* 190629 */     GIR_EraseRootFromParent_Done,
     /* 190630 */   // Label 3760: @190630
     /* 190630 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(190667), // Rule ID 11286 //
     /* 190635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190665 */     GIR_RootConstrainSelectedInstOperands,
     /* 190666 */     // GIR_Coverage, 11286,
     /* 190666 */     GIR_EraseRootFromParent_Done,
     /* 190667 */   // Label 3761: @190667
     /* 190667 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(190704), // Rule ID 11287 //
     /* 190672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190693 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1929:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190702 */     GIR_RootConstrainSelectedInstOperands,
     /* 190703 */     // GIR_Coverage, 11287,
     /* 190703 */     GIR_EraseRootFromParent_Done,
     /* 190704 */   // Label 3762: @190704
     /* 190704 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(190741), // Rule ID 11307 //
     /* 190709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 190733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190739 */     GIR_RootConstrainSelectedInstOperands,
     /* 190740 */     // GIR_Coverage, 11307,
     /* 190740 */     GIR_EraseRootFromParent_Done,
     /* 190741 */   // Label 3763: @190741
     /* 190741 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(190778), // Rule ID 11308 //
     /* 190746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190767 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 190770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190776 */     GIR_RootConstrainSelectedInstOperands,
     /* 190777 */     // GIR_Coverage, 11308,
     /* 190777 */     GIR_EraseRootFromParent_Done,
     /* 190778 */   // Label 3764: @190778
     /* 190778 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(190815), // Rule ID 11309 //
     /* 190783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 190807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190813 */     GIR_RootConstrainSelectedInstOperands,
     /* 190814 */     // GIR_Coverage, 11309,
     /* 190814 */     GIR_EraseRootFromParent_Done,
     /* 190815 */   // Label 3765: @190815
     /* 190815 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(190852), // Rule ID 11310 //
     /* 190820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 190844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190850 */     GIR_RootConstrainSelectedInstOperands,
     /* 190851 */     // GIR_Coverage, 11310,
     /* 190851 */     GIR_EraseRootFromParent_Done,
     /* 190852 */   // Label 3766: @190852
     /* 190852 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(190889), // Rule ID 11598 //
     /* 190857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 190881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190887 */     GIR_RootConstrainSelectedInstOperands,
     /* 190888 */     // GIR_Coverage, 11598,
     /* 190888 */     GIR_EraseRootFromParent_Done,
     /* 190889 */   // Label 3767: @190889
     /* 190889 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(190926), // Rule ID 11599 //
     /* 190894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 190918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190924 */     GIR_RootConstrainSelectedInstOperands,
     /* 190925 */     // GIR_Coverage, 11599,
     /* 190925 */     GIR_EraseRootFromParent_Done,
     /* 190926 */   // Label 3768: @190926
     /* 190926 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(190963), // Rule ID 11600 //
     /* 190931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190952 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 190955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190961 */     GIR_RootConstrainSelectedInstOperands,
     /* 190962 */     // GIR_Coverage, 11600,
     /* 190962 */     GIR_EraseRootFromParent_Done,
     /* 190963 */   // Label 3769: @190963
     /* 190963 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(191000), // Rule ID 11601 //
     /* 190968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 190976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190989 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 190992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190998 */     GIR_RootConstrainSelectedInstOperands,
     /* 190999 */     // GIR_Coverage, 11601,
     /* 190999 */     GIR_EraseRootFromParent_Done,
     /* 191000 */   // Label 3770: @191000
     /* 191000 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(191037), // Rule ID 11602 //
     /* 191005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 191029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191035 */     GIR_RootConstrainSelectedInstOperands,
     /* 191036 */     // GIR_Coverage, 11602,
     /* 191036 */     GIR_EraseRootFromParent_Done,
     /* 191037 */   // Label 3771: @191037
     /* 191037 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(191074), // Rule ID 11603 //
     /* 191042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191063 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 191066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191072 */     GIR_RootConstrainSelectedInstOperands,
     /* 191073 */     // GIR_Coverage, 11603,
     /* 191073 */     GIR_EraseRootFromParent_Done,
     /* 191074 */   // Label 3772: @191074
     /* 191074 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(191111), // Rule ID 11604 //
     /* 191079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 191103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191109 */     GIR_RootConstrainSelectedInstOperands,
     /* 191110 */     // GIR_Coverage, 11604,
     /* 191110 */     GIR_EraseRootFromParent_Done,
     /* 191111 */   // Label 3773: @191111
     /* 191111 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(191148), // Rule ID 11605 //
     /* 191116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 191140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191146 */     GIR_RootConstrainSelectedInstOperands,
     /* 191147 */     // GIR_Coverage, 11605,
     /* 191147 */     GIR_EraseRootFromParent_Done,
     /* 191148 */   // Label 3774: @191148
     /* 191148 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(191185), // Rule ID 11606 //
     /* 191153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 191177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191183 */     GIR_RootConstrainSelectedInstOperands,
     /* 191184 */     // GIR_Coverage, 11606,
     /* 191184 */     GIR_EraseRootFromParent_Done,
     /* 191185 */   // Label 3775: @191185
     /* 191185 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(191222), // Rule ID 11607 //
     /* 191190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 191214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191220 */     GIR_RootConstrainSelectedInstOperands,
     /* 191221 */     // GIR_Coverage, 11607,
     /* 191221 */     GIR_EraseRootFromParent_Done,
     /* 191222 */   // Label 3776: @191222
     /* 191222 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(191259), // Rule ID 11608 //
     /* 191227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 191251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191257 */     GIR_RootConstrainSelectedInstOperands,
     /* 191258 */     // GIR_Coverage, 11608,
     /* 191258 */     GIR_EraseRootFromParent_Done,
     /* 191259 */   // Label 3777: @191259
     /* 191259 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(191296), // Rule ID 11609 //
     /* 191264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191285 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 191288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191294 */     GIR_RootConstrainSelectedInstOperands,
     /* 191295 */     // GIR_Coverage, 11609,
     /* 191295 */     GIR_EraseRootFromParent_Done,
     /* 191296 */   // Label 3778: @191296
     /* 191296 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(191333), // Rule ID 11610 //
     /* 191301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 191325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191331 */     GIR_RootConstrainSelectedInstOperands,
     /* 191332 */     // GIR_Coverage, 11610,
     /* 191332 */     GIR_EraseRootFromParent_Done,
     /* 191333 */   // Label 3779: @191333
     /* 191333 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(191370), // Rule ID 11611 //
     /* 191338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191359 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 191362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191368 */     GIR_RootConstrainSelectedInstOperands,
     /* 191369 */     // GIR_Coverage, 11611,
     /* 191369 */     GIR_EraseRootFromParent_Done,
     /* 191370 */   // Label 3780: @191370
     /* 191370 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(191407), // Rule ID 11612 //
     /* 191375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191396 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 191399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191405 */     GIR_RootConstrainSelectedInstOperands,
     /* 191406 */     // GIR_Coverage, 11612,
     /* 191406 */     GIR_EraseRootFromParent_Done,
     /* 191407 */   // Label 3781: @191407
     /* 191407 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(191444), // Rule ID 11613 //
     /* 191412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191433 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 191436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191442 */     GIR_RootConstrainSelectedInstOperands,
     /* 191443 */     // GIR_Coverage, 11613,
     /* 191443 */     GIR_EraseRootFromParent_Done,
     /* 191444 */   // Label 3782: @191444
     /* 191444 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(191481), // Rule ID 11614 //
     /* 191449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191470 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 191473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191479 */     GIR_RootConstrainSelectedInstOperands,
     /* 191480 */     // GIR_Coverage, 11614,
     /* 191480 */     GIR_EraseRootFromParent_Done,
     /* 191481 */   // Label 3783: @191481
     /* 191481 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(191518), // Rule ID 11615 //
     /* 191486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191507 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 191510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191516 */     GIR_RootConstrainSelectedInstOperands,
     /* 191517 */     // GIR_Coverage, 11615,
     /* 191517 */     GIR_EraseRootFromParent_Done,
     /* 191518 */   // Label 3784: @191518
     /* 191518 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(191555), // Rule ID 11616 //
     /* 191523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2064:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 191547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191553 */     GIR_RootConstrainSelectedInstOperands,
     /* 191554 */     // GIR_Coverage, 11616,
     /* 191554 */     GIR_EraseRootFromParent_Done,
     /* 191555 */   // Label 3785: @191555
     /* 191555 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(191592), // Rule ID 11617 //
     /* 191560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 191584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191590 */     GIR_RootConstrainSelectedInstOperands,
     /* 191591 */     // GIR_Coverage, 11617,
     /* 191591 */     GIR_EraseRootFromParent_Done,
     /* 191592 */   // Label 3786: @191592
     /* 191592 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(191629), // Rule ID 11618 //
     /* 191597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 191621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191627 */     GIR_RootConstrainSelectedInstOperands,
     /* 191628 */     // GIR_Coverage, 11618,
     /* 191628 */     GIR_EraseRootFromParent_Done,
     /* 191629 */   // Label 3787: @191629
     /* 191629 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(191666), // Rule ID 11619 //
     /* 191634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 191658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191664 */     GIR_RootConstrainSelectedInstOperands,
     /* 191665 */     // GIR_Coverage, 11619,
     /* 191665 */     GIR_EraseRootFromParent_Done,
     /* 191666 */   // Label 3788: @191666
     /* 191666 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(191703), // Rule ID 11620 //
     /* 191671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 191695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191701 */     GIR_RootConstrainSelectedInstOperands,
     /* 191702 */     // GIR_Coverage, 11620,
     /* 191702 */     GIR_EraseRootFromParent_Done,
     /* 191703 */   // Label 3789: @191703
     /* 191703 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(191740), // Rule ID 11621 //
     /* 191708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 191732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191738 */     GIR_RootConstrainSelectedInstOperands,
     /* 191739 */     // GIR_Coverage, 11621,
     /* 191739 */     GIR_EraseRootFromParent_Done,
     /* 191740 */   // Label 3790: @191740
     /* 191740 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(191777), // Rule ID 11622 //
     /* 191745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191766 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 191769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191775 */     GIR_RootConstrainSelectedInstOperands,
     /* 191776 */     // GIR_Coverage, 11622,
     /* 191776 */     GIR_EraseRootFromParent_Done,
     /* 191777 */   // Label 3791: @191777
     /* 191777 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(191814), // Rule ID 11623 //
     /* 191782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 191806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191812 */     GIR_RootConstrainSelectedInstOperands,
     /* 191813 */     // GIR_Coverage, 11623,
     /* 191813 */     GIR_EraseRootFromParent_Done,
     /* 191814 */   // Label 3792: @191814
     /* 191814 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(191851), // Rule ID 11624 //
     /* 191819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 191843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191849 */     GIR_RootConstrainSelectedInstOperands,
     /* 191850 */     // GIR_Coverage, 11624,
     /* 191850 */     GIR_EraseRootFromParent_Done,
     /* 191851 */   // Label 3793: @191851
     /* 191851 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(191888), // Rule ID 11625 //
     /* 191856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1935:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 191880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191886 */     GIR_RootConstrainSelectedInstOperands,
     /* 191887 */     // GIR_Coverage, 11625,
     /* 191887 */     GIR_EraseRootFromParent_Done,
     /* 191888 */   // Label 3794: @191888
     /* 191888 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(191925), // Rule ID 11626 //
     /* 191893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1935:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 191917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191923 */     GIR_RootConstrainSelectedInstOperands,
     /* 191924 */     // GIR_Coverage, 11626,
     /* 191924 */     GIR_EraseRootFromParent_Done,
     /* 191925 */   // Label 3795: @191925
     /* 191925 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(191962), // Rule ID 11627 //
     /* 191930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1935:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 191954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191960 */     GIR_RootConstrainSelectedInstOperands,
     /* 191961 */     // GIR_Coverage, 11627,
     /* 191961 */     GIR_EraseRootFromParent_Done,
     /* 191962 */   // Label 3796: @191962
     /* 191962 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(191999), // Rule ID 11628 //
     /* 191967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 191975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 191991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191997 */     GIR_RootConstrainSelectedInstOperands,
     /* 191998 */     // GIR_Coverage, 11628,
     /* 191998 */     GIR_EraseRootFromParent_Done,
     /* 191999 */   // Label 3797: @191999
     /* 191999 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(192036), // Rule ID 11629 //
     /* 192004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 192028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192034 */     GIR_RootConstrainSelectedInstOperands,
     /* 192035 */     // GIR_Coverage, 11629,
     /* 192035 */     GIR_EraseRootFromParent_Done,
     /* 192036 */   // Label 3798: @192036
     /* 192036 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(192073), // Rule ID 11630 //
     /* 192041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 192065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192071 */     GIR_RootConstrainSelectedInstOperands,
     /* 192072 */     // GIR_Coverage, 11630,
     /* 192072 */     GIR_EraseRootFromParent_Done,
     /* 192073 */   // Label 3799: @192073
     /* 192073 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(192110), // Rule ID 11640 //
     /* 192078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192099 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 192102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192108 */     GIR_RootConstrainSelectedInstOperands,
     /* 192109 */     // GIR_Coverage, 11640,
     /* 192109 */     GIR_EraseRootFromParent_Done,
     /* 192110 */   // Label 3800: @192110
     /* 192110 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(192147), // Rule ID 11641 //
     /* 192115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 192139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192145 */     GIR_RootConstrainSelectedInstOperands,
     /* 192146 */     // GIR_Coverage, 11641,
     /* 192146 */     GIR_EraseRootFromParent_Done,
     /* 192147 */   // Label 3801: @192147
     /* 192147 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(192184), // Rule ID 11642 //
     /* 192152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192173 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 192176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192182 */     GIR_RootConstrainSelectedInstOperands,
     /* 192183 */     // GIR_Coverage, 11642,
     /* 192183 */     GIR_EraseRootFromParent_Done,
     /* 192184 */   // Label 3802: @192184
     /* 192184 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(192221), // Rule ID 11643 //
     /* 192189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 192213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192219 */     GIR_RootConstrainSelectedInstOperands,
     /* 192220 */     // GIR_Coverage, 11643,
     /* 192220 */     GIR_EraseRootFromParent_Done,
     /* 192221 */   // Label 3803: @192221
     /* 192221 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(192258), // Rule ID 11644 //
     /* 192226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 192250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192256 */     GIR_RootConstrainSelectedInstOperands,
     /* 192257 */     // GIR_Coverage, 11644,
     /* 192257 */     GIR_EraseRootFromParent_Done,
     /* 192258 */   // Label 3804: @192258
     /* 192258 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(192295), // Rule ID 11645 //
     /* 192263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 192287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192293 */     GIR_RootConstrainSelectedInstOperands,
     /* 192294 */     // GIR_Coverage, 11645,
     /* 192294 */     GIR_EraseRootFromParent_Done,
     /* 192295 */   // Label 3805: @192295
     /* 192295 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(192332), // Rule ID 11646 //
     /* 192300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192321 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 192324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192330 */     GIR_RootConstrainSelectedInstOperands,
     /* 192331 */     // GIR_Coverage, 11646,
     /* 192331 */     GIR_EraseRootFromParent_Done,
     /* 192332 */   // Label 3806: @192332
     /* 192332 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(192369), // Rule ID 11647 //
     /* 192337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 192361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192367 */     GIR_RootConstrainSelectedInstOperands,
     /* 192368 */     // GIR_Coverage, 11647,
     /* 192368 */     GIR_EraseRootFromParent_Done,
     /* 192369 */   // Label 3807: @192369
     /* 192369 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(192406), // Rule ID 11648 //
     /* 192374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192395 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 192398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192404 */     GIR_RootConstrainSelectedInstOperands,
     /* 192405 */     // GIR_Coverage, 11648,
     /* 192405 */     GIR_EraseRootFromParent_Done,
     /* 192406 */   // Label 3808: @192406
     /* 192406 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(192443), // Rule ID 11649 //
     /* 192411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 192435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192441 */     GIR_RootConstrainSelectedInstOperands,
     /* 192442 */     // GIR_Coverage, 11649,
     /* 192442 */     GIR_EraseRootFromParent_Done,
     /* 192443 */   // Label 3809: @192443
     /* 192443 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(192480), // Rule ID 11650 //
     /* 192448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 192472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192478 */     GIR_RootConstrainSelectedInstOperands,
     /* 192479 */     // GIR_Coverage, 11650,
     /* 192479 */     GIR_EraseRootFromParent_Done,
     /* 192480 */   // Label 3810: @192480
     /* 192480 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(192517), // Rule ID 11651 //
     /* 192485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 192509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192515 */     GIR_RootConstrainSelectedInstOperands,
     /* 192516 */     // GIR_Coverage, 11651,
     /* 192516 */     GIR_EraseRootFromParent_Done,
     /* 192517 */   // Label 3811: @192517
     /* 192517 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(192554), // Rule ID 11652 //
     /* 192522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192543 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1801:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 192546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192552 */     GIR_RootConstrainSelectedInstOperands,
     /* 192553 */     // GIR_Coverage, 11652,
     /* 192553 */     GIR_EraseRootFromParent_Done,
     /* 192554 */   // Label 3812: @192554
     /* 192554 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(192591), // Rule ID 11653 //
     /* 192559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 192583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192589 */     GIR_RootConstrainSelectedInstOperands,
     /* 192590 */     // GIR_Coverage, 11653,
     /* 192590 */     GIR_EraseRootFromParent_Done,
     /* 192591 */   // Label 3813: @192591
     /* 192591 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(192628), // Rule ID 11654 //
     /* 192596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192617 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 192620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192626 */     GIR_RootConstrainSelectedInstOperands,
     /* 192627 */     // GIR_Coverage, 11654,
     /* 192627 */     GIR_EraseRootFromParent_Done,
     /* 192628 */   // Label 3814: @192628
     /* 192628 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(192665), // Rule ID 11655 //
     /* 192633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192654 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 192657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192663 */     GIR_RootConstrainSelectedInstOperands,
     /* 192664 */     // GIR_Coverage, 11655,
     /* 192664 */     GIR_EraseRootFromParent_Done,
     /* 192665 */   // Label 3815: @192665
     /* 192665 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(192702), // Rule ID 11656 //
     /* 192670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 192694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192700 */     GIR_RootConstrainSelectedInstOperands,
     /* 192701 */     // GIR_Coverage, 11656,
     /* 192701 */     GIR_EraseRootFromParent_Done,
     /* 192702 */   // Label 3816: @192702
     /* 192702 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(192739), // Rule ID 11657 //
     /* 192707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 192731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192737 */     GIR_RootConstrainSelectedInstOperands,
     /* 192738 */     // GIR_Coverage, 11657,
     /* 192738 */     GIR_EraseRootFromParent_Done,
     /* 192739 */   // Label 3817: @192739
     /* 192739 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(192776), // Rule ID 11658 //
     /* 192744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 192768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192774 */     GIR_RootConstrainSelectedInstOperands,
     /* 192775 */     // GIR_Coverage, 11658,
     /* 192775 */     GIR_EraseRootFromParent_Done,
     /* 192776 */   // Label 3818: @192776
     /* 192776 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(192813), // Rule ID 11659 //
     /* 192781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 192805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192811 */     GIR_RootConstrainSelectedInstOperands,
     /* 192812 */     // GIR_Coverage, 11659,
     /* 192812 */     GIR_EraseRootFromParent_Done,
     /* 192813 */   // Label 3819: @192813
     /* 192813 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(192850), // Rule ID 11660 //
     /* 192818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192839 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 192842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192848 */     GIR_RootConstrainSelectedInstOperands,
     /* 192849 */     // GIR_Coverage, 11660,
     /* 192849 */     GIR_EraseRootFromParent_Done,
     /* 192850 */   // Label 3820: @192850
     /* 192850 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(192887), // Rule ID 11661 //
     /* 192855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 192879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192885 */     GIR_RootConstrainSelectedInstOperands,
     /* 192886 */     // GIR_Coverage, 11661,
     /* 192886 */     GIR_EraseRootFromParent_Done,
     /* 192887 */   // Label 3821: @192887
     /* 192887 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(192924), // Rule ID 11662 //
     /* 192892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192913 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 192916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192922 */     GIR_RootConstrainSelectedInstOperands,
     /* 192923 */     // GIR_Coverage, 11662,
     /* 192923 */     GIR_EraseRootFromParent_Done,
     /* 192924 */   // Label 3822: @192924
     /* 192924 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(192961), // Rule ID 11663 //
     /* 192929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 192953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192959 */     GIR_RootConstrainSelectedInstOperands,
     /* 192960 */     // GIR_Coverage, 11663,
     /* 192960 */     GIR_EraseRootFromParent_Done,
     /* 192961 */   // Label 3823: @192961
     /* 192961 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(192998), // Rule ID 11664 //
     /* 192966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 192974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1992:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 192990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192996 */     GIR_RootConstrainSelectedInstOperands,
     /* 192997 */     // GIR_Coverage, 11664,
     /* 192997 */     GIR_EraseRootFromParent_Done,
     /* 192998 */   // Label 3824: @192998
     /* 192998 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(193035), // Rule ID 11665 //
     /* 193003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 193027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193033 */     GIR_RootConstrainSelectedInstOperands,
     /* 193034 */     // GIR_Coverage, 11665,
     /* 193034 */     GIR_EraseRootFromParent_Done,
     /* 193035 */   // Label 3825: @193035
     /* 193035 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(193072), // Rule ID 11666 //
     /* 193040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 193064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193070 */     GIR_RootConstrainSelectedInstOperands,
     /* 193071 */     // GIR_Coverage, 11666,
     /* 193071 */     GIR_EraseRootFromParent_Done,
     /* 193072 */   // Label 3826: @193072
     /* 193072 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(193109), // Rule ID 11667 //
     /* 193077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 193101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193107 */     GIR_RootConstrainSelectedInstOperands,
     /* 193108 */     // GIR_Coverage, 11667,
     /* 193108 */     GIR_EraseRootFromParent_Done,
     /* 193109 */   // Label 3827: @193109
     /* 193109 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(193146), // Rule ID 11668 //
     /* 193114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 193138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193144 */     GIR_RootConstrainSelectedInstOperands,
     /* 193145 */     // GIR_Coverage, 11668,
     /* 193145 */     GIR_EraseRootFromParent_Done,
     /* 193146 */   // Label 3828: @193146
     /* 193146 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(193183), // Rule ID 11669 //
     /* 193151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 193175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193181 */     GIR_RootConstrainSelectedInstOperands,
     /* 193182 */     // GIR_Coverage, 11669,
     /* 193182 */     GIR_EraseRootFromParent_Done,
     /* 193183 */   // Label 3829: @193183
     /* 193183 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(193220), // Rule ID 11670 //
     /* 193188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 193196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193209 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1632:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 193212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193218 */     GIR_RootConstrainSelectedInstOperands,
     /* 193219 */     // GIR_Coverage, 11670,
     /* 193219 */     GIR_EraseRootFromParent_Done,
     /* 193220 */   // Label 3830: @193220
     /* 193220 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(193257), // Rule ID 11671 //
     /* 193225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 193233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1632:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 193249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193255 */     GIR_RootConstrainSelectedInstOperands,
     /* 193256 */     // GIR_Coverage, 11671,
     /* 193256 */     GIR_EraseRootFromParent_Done,
     /* 193257 */   // Label 3831: @193257
     /* 193257 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(193294), // Rule ID 11772 //
     /* 193262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193283 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 193286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193292 */     GIR_RootConstrainSelectedInstOperands,
     /* 193293 */     // GIR_Coverage, 11772,
     /* 193293 */     GIR_EraseRootFromParent_Done,
     /* 193294 */   // Label 3832: @193294
     /* 193294 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(193331), // Rule ID 11773 //
     /* 193299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193320 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 193323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193329 */     GIR_RootConstrainSelectedInstOperands,
     /* 193330 */     // GIR_Coverage, 11773,
     /* 193330 */     GIR_EraseRootFromParent_Done,
     /* 193331 */   // Label 3833: @193331
     /* 193331 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(193368), // Rule ID 11774 //
     /* 193336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 193360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193366 */     GIR_RootConstrainSelectedInstOperands,
     /* 193367 */     // GIR_Coverage, 11774,
     /* 193367 */     GIR_EraseRootFromParent_Done,
     /* 193368 */   // Label 3834: @193368
     /* 193368 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(193405), // Rule ID 11775 //
     /* 193373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193394 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 193397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193403 */     GIR_RootConstrainSelectedInstOperands,
     /* 193404 */     // GIR_Coverage, 11775,
     /* 193404 */     GIR_EraseRootFromParent_Done,
     /* 193405 */   // Label 3835: @193405
     /* 193405 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(193442), // Rule ID 11776 //
     /* 193410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193431 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 193434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193440 */     GIR_RootConstrainSelectedInstOperands,
     /* 193441 */     // GIR_Coverage, 11776,
     /* 193441 */     GIR_EraseRootFromParent_Done,
     /* 193442 */   // Label 3836: @193442
     /* 193442 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(193479), // Rule ID 11777 //
     /* 193447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 193471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193477 */     GIR_RootConstrainSelectedInstOperands,
     /* 193478 */     // GIR_Coverage, 11777,
     /* 193478 */     GIR_EraseRootFromParent_Done,
     /* 193479 */   // Label 3837: @193479
     /* 193479 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(193516), // Rule ID 11778 //
     /* 193484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193505 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1678:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 193508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193514 */     GIR_RootConstrainSelectedInstOperands,
     /* 193515 */     // GIR_Coverage, 11778,
     /* 193515 */     GIR_EraseRootFromParent_Done,
     /* 193516 */   // Label 3838: @193516
     /* 193516 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(193553), // Rule ID 11779 //
     /* 193521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1678:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 193545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193551 */     GIR_RootConstrainSelectedInstOperands,
     /* 193552 */     // GIR_Coverage, 11779,
     /* 193552 */     GIR_EraseRootFromParent_Done,
     /* 193553 */   // Label 3839: @193553
     /* 193553 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(193590), // Rule ID 11780 //
     /* 193558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193579 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1678:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 193582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193588 */     GIR_RootConstrainSelectedInstOperands,
     /* 193589 */     // GIR_Coverage, 11780,
     /* 193589 */     GIR_EraseRootFromParent_Done,
     /* 193590 */   // Label 3840: @193590
     /* 193590 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(193627), // Rule ID 11796 //
     /* 193595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193616 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 193619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193625 */     GIR_RootConstrainSelectedInstOperands,
     /* 193626 */     // GIR_Coverage, 11796,
     /* 193626 */     GIR_EraseRootFromParent_Done,
     /* 193627 */   // Label 3841: @193627
     /* 193627 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(193664), // Rule ID 11797 //
     /* 193632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193653 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 193656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193662 */     GIR_RootConstrainSelectedInstOperands,
     /* 193663 */     // GIR_Coverage, 11797,
     /* 193663 */     GIR_EraseRootFromParent_Done,
     /* 193664 */   // Label 3842: @193664
     /* 193664 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(193701), // Rule ID 11798 //
     /* 193669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 193693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193699 */     GIR_RootConstrainSelectedInstOperands,
     /* 193700 */     // GIR_Coverage, 11798,
     /* 193700 */     GIR_EraseRootFromParent_Done,
     /* 193701 */   // Label 3843: @193701
     /* 193701 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(193738), // Rule ID 11799 //
     /* 193706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 193730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193736 */     GIR_RootConstrainSelectedInstOperands,
     /* 193737 */     // GIR_Coverage, 11799,
     /* 193737 */     GIR_EraseRootFromParent_Done,
     /* 193738 */   // Label 3844: @193738
     /* 193738 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(193775), // Rule ID 11800 //
     /* 193743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 193767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193773 */     GIR_RootConstrainSelectedInstOperands,
     /* 193774 */     // GIR_Coverage, 11800,
     /* 193774 */     GIR_EraseRootFromParent_Done,
     /* 193775 */   // Label 3845: @193775
     /* 193775 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(193812), // Rule ID 11801 //
     /* 193780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 193804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193810 */     GIR_RootConstrainSelectedInstOperands,
     /* 193811 */     // GIR_Coverage, 11801,
     /* 193811 */     GIR_EraseRootFromParent_Done,
     /* 193812 */   // Label 3846: @193812
     /* 193812 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(193849), // Rule ID 11817 //
     /* 193817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 193841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193847 */     GIR_RootConstrainSelectedInstOperands,
     /* 193848 */     // GIR_Coverage, 11817,
     /* 193848 */     GIR_EraseRootFromParent_Done,
     /* 193849 */   // Label 3847: @193849
     /* 193849 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(193886), // Rule ID 11818 //
     /* 193854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 193878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193884 */     GIR_RootConstrainSelectedInstOperands,
     /* 193885 */     // GIR_Coverage, 11818,
     /* 193885 */     GIR_EraseRootFromParent_Done,
     /* 193886 */   // Label 3848: @193886
     /* 193886 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(193923), // Rule ID 11819 //
     /* 193891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 193915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193921 */     GIR_RootConstrainSelectedInstOperands,
     /* 193922 */     // GIR_Coverage, 11819,
     /* 193922 */     GIR_EraseRootFromParent_Done,
     /* 193923 */   // Label 3849: @193923
     /* 193923 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(193960), // Rule ID 11820 //
     /* 193928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 193952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193958 */     GIR_RootConstrainSelectedInstOperands,
     /* 193959 */     // GIR_Coverage, 11820,
     /* 193959 */     GIR_EraseRootFromParent_Done,
     /* 193960 */   // Label 3850: @193960
     /* 193960 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(193997), // Rule ID 11821 //
     /* 193965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 193989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193995 */     GIR_RootConstrainSelectedInstOperands,
     /* 193996 */     // GIR_Coverage, 11821,
     /* 193996 */     GIR_EraseRootFromParent_Done,
     /* 193997 */   // Label 3851: @193997
     /* 193997 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(194034), // Rule ID 11822 //
     /* 194002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 194010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194023 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 194026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194032 */     GIR_RootConstrainSelectedInstOperands,
     /* 194033 */     // GIR_Coverage, 11822,
     /* 194033 */     GIR_EraseRootFromParent_Done,
     /* 194034 */   // Label 3852: @194034
     /* 194034 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(194074), // Rule ID 11897 //
     /* 194039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 194063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194072 */     GIR_RootConstrainSelectedInstOperands,
     /* 194073 */     // GIR_Coverage, 11897,
     /* 194073 */     GIR_EraseRootFromParent_Done,
     /* 194074 */   // Label 3853: @194074
     /* 194074 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(194114), // Rule ID 11898 //
     /* 194079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194100 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 194103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194112 */     GIR_RootConstrainSelectedInstOperands,
     /* 194113 */     // GIR_Coverage, 11898,
     /* 194113 */     GIR_EraseRootFromParent_Done,
     /* 194114 */   // Label 3854: @194114
     /* 194114 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(194154), // Rule ID 11899 //
     /* 194119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 194143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194152 */     GIR_RootConstrainSelectedInstOperands,
     /* 194153 */     // GIR_Coverage, 11899,
     /* 194153 */     GIR_EraseRootFromParent_Done,
     /* 194154 */   // Label 3855: @194154
     /* 194154 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(194194), // Rule ID 11900 //
     /* 194159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 194183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194192 */     GIR_RootConstrainSelectedInstOperands,
     /* 194193 */     // GIR_Coverage, 11900,
     /* 194193 */     GIR_EraseRootFromParent_Done,
     /* 194194 */   // Label 3856: @194194
     /* 194194 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(194234), // Rule ID 11901 //
     /* 194199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194220 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 194223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194232 */     GIR_RootConstrainSelectedInstOperands,
     /* 194233 */     // GIR_Coverage, 11901,
     /* 194233 */     GIR_EraseRootFromParent_Done,
     /* 194234 */   // Label 3857: @194234
     /* 194234 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(194274), // Rule ID 11902 //
     /* 194239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194260 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 194263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194272 */     GIR_RootConstrainSelectedInstOperands,
     /* 194273 */     // GIR_Coverage, 11902,
     /* 194273 */     GIR_EraseRootFromParent_Done,
     /* 194274 */   // Label 3858: @194274
     /* 194274 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(194314), // Rule ID 11903 //
     /* 194279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 194303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194312 */     GIR_RootConstrainSelectedInstOperands,
     /* 194313 */     // GIR_Coverage, 11903,
     /* 194313 */     GIR_EraseRootFromParent_Done,
     /* 194314 */   // Label 3859: @194314
     /* 194314 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(194354), // Rule ID 11904 //
     /* 194319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 194343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194352 */     GIR_RootConstrainSelectedInstOperands,
     /* 194353 */     // GIR_Coverage, 11904,
     /* 194353 */     GIR_EraseRootFromParent_Done,
     /* 194354 */   // Label 3860: @194354
     /* 194354 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(194394), // Rule ID 11909 //
     /* 194359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194380 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 194383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194392 */     GIR_RootConstrainSelectedInstOperands,
     /* 194393 */     // GIR_Coverage, 11909,
     /* 194393 */     GIR_EraseRootFromParent_Done,
     /* 194394 */   // Label 3861: @194394
     /* 194394 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(194434), // Rule ID 11910 //
     /* 194399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 194423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194432 */     GIR_RootConstrainSelectedInstOperands,
     /* 194433 */     // GIR_Coverage, 11910,
     /* 194433 */     GIR_EraseRootFromParent_Done,
     /* 194434 */   // Label 3862: @194434
     /* 194434 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(194474), // Rule ID 11911 //
     /* 194439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 194463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194472 */     GIR_RootConstrainSelectedInstOperands,
     /* 194473 */     // GIR_Coverage, 11911,
     /* 194473 */     GIR_EraseRootFromParent_Done,
     /* 194474 */   // Label 3863: @194474
     /* 194474 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(194514), // Rule ID 11912 //
     /* 194479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194500 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 194503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194512 */     GIR_RootConstrainSelectedInstOperands,
     /* 194513 */     // GIR_Coverage, 11912,
     /* 194513 */     GIR_EraseRootFromParent_Done,
     /* 194514 */   // Label 3864: @194514
     /* 194514 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(194554), // Rule ID 11913 //
     /* 194519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 194543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194552 */     GIR_RootConstrainSelectedInstOperands,
     /* 194553 */     // GIR_Coverage, 11913,
     /* 194553 */     GIR_EraseRootFromParent_Done,
     /* 194554 */   // Label 3865: @194554
     /* 194554 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(194594), // Rule ID 11914 //
     /* 194559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 194583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194592 */     GIR_RootConstrainSelectedInstOperands,
     /* 194593 */     // GIR_Coverage, 11914,
     /* 194593 */     GIR_EraseRootFromParent_Done,
     /* 194594 */   // Label 3866: @194594
     /* 194594 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(194634), // Rule ID 11915 //
     /* 194599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 194623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194632 */     GIR_RootConstrainSelectedInstOperands,
     /* 194633 */     // GIR_Coverage, 11915,
     /* 194633 */     GIR_EraseRootFromParent_Done,
     /* 194634 */   // Label 3867: @194634
     /* 194634 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(194674), // Rule ID 11916 //
     /* 194639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 194663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194672 */     GIR_RootConstrainSelectedInstOperands,
     /* 194673 */     // GIR_Coverage, 11916,
     /* 194673 */     GIR_EraseRootFromParent_Done,
     /* 194674 */   // Label 3868: @194674
     /* 194674 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(194714), // Rule ID 11921 //
     /* 194679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 194703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194712 */     GIR_RootConstrainSelectedInstOperands,
     /* 194713 */     // GIR_Coverage, 11921,
     /* 194713 */     GIR_EraseRootFromParent_Done,
     /* 194714 */   // Label 3869: @194714
     /* 194714 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(194754), // Rule ID 11922 //
     /* 194719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 194743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194752 */     GIR_RootConstrainSelectedInstOperands,
     /* 194753 */     // GIR_Coverage, 11922,
     /* 194753 */     GIR_EraseRootFromParent_Done,
     /* 194754 */   // Label 3870: @194754
     /* 194754 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(194794), // Rule ID 11923 //
     /* 194759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194780 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 194783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194792 */     GIR_RootConstrainSelectedInstOperands,
     /* 194793 */     // GIR_Coverage, 11923,
     /* 194793 */     GIR_EraseRootFromParent_Done,
     /* 194794 */   // Label 3871: @194794
     /* 194794 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(194834), // Rule ID 11924 //
     /* 194799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 194823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194832 */     GIR_RootConstrainSelectedInstOperands,
     /* 194833 */     // GIR_Coverage, 11924,
     /* 194833 */     GIR_EraseRootFromParent_Done,
     /* 194834 */   // Label 3872: @194834
     /* 194834 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(194874), // Rule ID 11925 //
     /* 194839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194860 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 194863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194872 */     GIR_RootConstrainSelectedInstOperands,
     /* 194873 */     // GIR_Coverage, 11925,
     /* 194873 */     GIR_EraseRootFromParent_Done,
     /* 194874 */   // Label 3873: @194874
     /* 194874 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(194914), // Rule ID 11926 //
     /* 194879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194900 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 194903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194912 */     GIR_RootConstrainSelectedInstOperands,
     /* 194913 */     // GIR_Coverage, 11926,
     /* 194913 */     GIR_EraseRootFromParent_Done,
     /* 194914 */   // Label 3874: @194914
     /* 194914 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(194954), // Rule ID 11927 //
     /* 194919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194940 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 194943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194952 */     GIR_RootConstrainSelectedInstOperands,
     /* 194953 */     // GIR_Coverage, 11927,
     /* 194953 */     GIR_EraseRootFromParent_Done,
     /* 194954 */   // Label 3875: @194954
     /* 194954 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(194994), // Rule ID 11928 //
     /* 194959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 194983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194992 */     GIR_RootConstrainSelectedInstOperands,
     /* 194993 */     // GIR_Coverage, 11928,
     /* 194993 */     GIR_EraseRootFromParent_Done,
     /* 194994 */   // Label 3876: @194994
     /* 194994 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(195034), // Rule ID 11933 //
     /* 194999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 195023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195032 */     GIR_RootConstrainSelectedInstOperands,
     /* 195033 */     // GIR_Coverage, 11933,
     /* 195033 */     GIR_EraseRootFromParent_Done,
     /* 195034 */   // Label 3877: @195034
     /* 195034 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(195074), // Rule ID 11934 //
     /* 195039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195060 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 195063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195072 */     GIR_RootConstrainSelectedInstOperands,
     /* 195073 */     // GIR_Coverage, 11934,
     /* 195073 */     GIR_EraseRootFromParent_Done,
     /* 195074 */   // Label 3878: @195074
     /* 195074 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(195114), // Rule ID 11935 //
     /* 195079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 195103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195112 */     GIR_RootConstrainSelectedInstOperands,
     /* 195113 */     // GIR_Coverage, 11935,
     /* 195113 */     GIR_EraseRootFromParent_Done,
     /* 195114 */   // Label 3879: @195114
     /* 195114 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(195154), // Rule ID 11936 //
     /* 195119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195140 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 195143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195152 */     GIR_RootConstrainSelectedInstOperands,
     /* 195153 */     // GIR_Coverage, 11936,
     /* 195153 */     GIR_EraseRootFromParent_Done,
     /* 195154 */   // Label 3880: @195154
     /* 195154 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(195194), // Rule ID 11937 //
     /* 195159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195180 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 195183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195192 */     GIR_RootConstrainSelectedInstOperands,
     /* 195193 */     // GIR_Coverage, 11937,
     /* 195193 */     GIR_EraseRootFromParent_Done,
     /* 195194 */   // Label 3881: @195194
     /* 195194 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(195234), // Rule ID 11938 //
     /* 195199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195220 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 195223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195232 */     GIR_RootConstrainSelectedInstOperands,
     /* 195233 */     // GIR_Coverage, 11938,
     /* 195233 */     GIR_EraseRootFromParent_Done,
     /* 195234 */   // Label 3882: @195234
     /* 195234 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(195274), // Rule ID 11939 //
     /* 195239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 195263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195272 */     GIR_RootConstrainSelectedInstOperands,
     /* 195273 */     // GIR_Coverage, 11939,
     /* 195273 */     GIR_EraseRootFromParent_Done,
     /* 195274 */   // Label 3883: @195274
     /* 195274 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(195314), // Rule ID 11940 //
     /* 195279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 195303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195312 */     GIR_RootConstrainSelectedInstOperands,
     /* 195313 */     // GIR_Coverage, 11940,
     /* 195313 */     GIR_EraseRootFromParent_Done,
     /* 195314 */   // Label 3884: @195314
     /* 195314 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(195351), // Rule ID 11949 //
     /* 195319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 195322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 195327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 195343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195349 */     GIR_RootConstrainSelectedInstOperands,
     /* 195350 */     // GIR_Coverage, 11949,
     /* 195350 */     GIR_EraseRootFromParent_Done,
     /* 195351 */   // Label 3885: @195351
     /* 195351 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(195388), // Rule ID 11951 //
     /* 195356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 195359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 195364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1632:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 195380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195386 */     GIR_RootConstrainSelectedInstOperands,
     /* 195387 */     // GIR_Coverage, 11951,
     /* 195387 */     GIR_EraseRootFromParent_Done,
     /* 195388 */   // Label 3886: @195388
     /* 195388 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(195425), // Rule ID 11952 //
     /* 195393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 195396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 195401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1723:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 195417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195423 */     GIR_RootConstrainSelectedInstOperands,
     /* 195424 */     // GIR_Coverage, 11952,
     /* 195424 */     GIR_EraseRootFromParent_Done,
     /* 195425 */   // Label 3887: @195425
     /* 195425 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(195462), // Rule ID 11953 //
     /* 195430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 195433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 195438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 195454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195460 */     GIR_RootConstrainSelectedInstOperands,
     /* 195461 */     // GIR_Coverage, 11953,
     /* 195461 */     GIR_EraseRootFromParent_Done,
     /* 195462 */   // Label 3888: @195462
     /* 195462 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(195499), // Rule ID 11954 //
     /* 195467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1272:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 195491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195497 */     GIR_RootConstrainSelectedInstOperands,
     /* 195498 */     // GIR_Coverage, 11954,
     /* 195498 */     GIR_EraseRootFromParent_Done,
     /* 195499 */   // Label 3889: @195499
     /* 195499 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(195536), // Rule ID 11955 //
     /* 195504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1272:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 195528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195534 */     GIR_RootConstrainSelectedInstOperands,
     /* 195535 */     // GIR_Coverage, 11955,
     /* 195535 */     GIR_EraseRootFromParent_Done,
     /* 195536 */   // Label 3890: @195536
     /* 195536 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195573), // Rule ID 11956 //
     /* 195541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195562 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1272:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 195565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195571 */     GIR_RootConstrainSelectedInstOperands,
     /* 195572 */     // GIR_Coverage, 11956,
     /* 195572 */     GIR_EraseRootFromParent_Done,
     /* 195573 */   // Label 3891: @195573
     /* 195573 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195610), // Rule ID 11957 //
     /* 195578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195599 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1272:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 195602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195608 */     GIR_RootConstrainSelectedInstOperands,
     /* 195609 */     // GIR_Coverage, 11957,
     /* 195609 */     GIR_EraseRootFromParent_Done,
     /* 195610 */   // Label 3892: @195610
     /* 195610 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195647), // Rule ID 11958 //
     /* 195615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1289:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 195639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195645 */     GIR_RootConstrainSelectedInstOperands,
     /* 195646 */     // GIR_Coverage, 11958,
     /* 195646 */     GIR_EraseRootFromParent_Done,
     /* 195647 */   // Label 3893: @195647
     /* 195647 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195684), // Rule ID 11959 //
     /* 195652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1289:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 195676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195682 */     GIR_RootConstrainSelectedInstOperands,
     /* 195683 */     // GIR_Coverage, 11959,
     /* 195683 */     GIR_EraseRootFromParent_Done,
     /* 195684 */   // Label 3894: @195684
     /* 195684 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195721), // Rule ID 11960 //
     /* 195689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1289:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 195713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195719 */     GIR_RootConstrainSelectedInstOperands,
     /* 195720 */     // GIR_Coverage, 11960,
     /* 195720 */     GIR_EraseRootFromParent_Done,
     /* 195721 */   // Label 3895: @195721
     /* 195721 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(195758), // Rule ID 11961 //
     /* 195726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195747 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1289:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 195750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195756 */     GIR_RootConstrainSelectedInstOperands,
     /* 195757 */     // GIR_Coverage, 11961,
     /* 195757 */     GIR_EraseRootFromParent_Done,
     /* 195758 */   // Label 3896: @195758
     /* 195758 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(195795), // Rule ID 12074 //
     /* 195763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195784 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1438:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 195787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195793 */     GIR_RootConstrainSelectedInstOperands,
     /* 195794 */     // GIR_Coverage, 12074,
     /* 195794 */     GIR_EraseRootFromParent_Done,
     /* 195795 */   // Label 3897: @195795
     /* 195795 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(195832), // Rule ID 12075 //
     /* 195800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195821 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1438:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 195824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195830 */     GIR_RootConstrainSelectedInstOperands,
     /* 195831 */     // GIR_Coverage, 12075,
     /* 195831 */     GIR_EraseRootFromParent_Done,
     /* 195832 */   // Label 3898: @195832
     /* 195832 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195869), // Rule ID 12076 //
     /* 195837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195858 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1438:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 195861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195867 */     GIR_RootConstrainSelectedInstOperands,
     /* 195868 */     // GIR_Coverage, 12076,
     /* 195868 */     GIR_EraseRootFromParent_Done,
     /* 195869 */   // Label 3899: @195869
     /* 195869 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195906), // Rule ID 12077 //
     /* 195874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195895 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 195898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195904 */     GIR_RootConstrainSelectedInstOperands,
     /* 195905 */     // GIR_Coverage, 12077,
     /* 195905 */     GIR_EraseRootFromParent_Done,
     /* 195906 */   // Label 3900: @195906
     /* 195906 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195943), // Rule ID 12078 //
     /* 195911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195932 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 195935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195941 */     GIR_RootConstrainSelectedInstOperands,
     /* 195942 */     // GIR_Coverage, 12078,
     /* 195942 */     GIR_EraseRootFromParent_Done,
     /* 195943 */   // Label 3901: @195943
     /* 195943 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195980), // Rule ID 12079 //
     /* 195948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195969 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 195972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195978 */     GIR_RootConstrainSelectedInstOperands,
     /* 195979 */     // GIR_Coverage, 12079,
     /* 195979 */     GIR_EraseRootFromParent_Done,
     /* 195980 */   // Label 3902: @195980
     /* 195980 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(196017), // Rule ID 12080 //
     /* 195985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 195993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196006 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 196009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196015 */     GIR_RootConstrainSelectedInstOperands,
     /* 196016 */     // GIR_Coverage, 12080,
     /* 196016 */     GIR_EraseRootFromParent_Done,
     /* 196017 */   // Label 3903: @196017
     /* 196017 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(196054), // Rule ID 12081 //
     /* 196022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196043 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 196046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196052 */     GIR_RootConstrainSelectedInstOperands,
     /* 196053 */     // GIR_Coverage, 12081,
     /* 196053 */     GIR_EraseRootFromParent_Done,
     /* 196054 */   // Label 3904: @196054
     /* 196054 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(196091), // Rule ID 12082 //
     /* 196059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196080 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 196083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196089 */     GIR_RootConstrainSelectedInstOperands,
     /* 196090 */     // GIR_Coverage, 12082,
     /* 196090 */     GIR_EraseRootFromParent_Done,
     /* 196091 */   // Label 3905: @196091
     /* 196091 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(196128), // Rule ID 12083 //
     /* 196096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196117 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1459:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 196120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196126 */     GIR_RootConstrainSelectedInstOperands,
     /* 196127 */     // GIR_Coverage, 12083,
     /* 196127 */     GIR_EraseRootFromParent_Done,
     /* 196128 */   // Label 3906: @196128
     /* 196128 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(196165), // Rule ID 12084 //
     /* 196133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196154 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1459:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 196157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196163 */     GIR_RootConstrainSelectedInstOperands,
     /* 196164 */     // GIR_Coverage, 12084,
     /* 196164 */     GIR_EraseRootFromParent_Done,
     /* 196165 */   // Label 3907: @196165
     /* 196165 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(196202), // Rule ID 12085 //
     /* 196170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196191 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1459:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 196194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196200 */     GIR_RootConstrainSelectedInstOperands,
     /* 196201 */     // GIR_Coverage, 12085,
     /* 196201 */     GIR_EraseRootFromParent_Done,
     /* 196202 */   // Label 3908: @196202
     /* 196202 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196239), // Rule ID 12086 //
     /* 196207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196228 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1353:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 196231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196237 */     GIR_RootConstrainSelectedInstOperands,
     /* 196238 */     // GIR_Coverage, 12086,
     /* 196238 */     GIR_EraseRootFromParent_Done,
     /* 196239 */   // Label 3909: @196239
     /* 196239 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196276), // Rule ID 12087 //
     /* 196244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196265 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 196268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196274 */     GIR_RootConstrainSelectedInstOperands,
     /* 196275 */     // GIR_Coverage, 12087,
     /* 196275 */     GIR_EraseRootFromParent_Done,
     /* 196276 */   // Label 3910: @196276
     /* 196276 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196313), // Rule ID 12088 //
     /* 196281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196302 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 196305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196311 */     GIR_RootConstrainSelectedInstOperands,
     /* 196312 */     // GIR_Coverage, 12088,
     /* 196312 */     GIR_EraseRootFromParent_Done,
     /* 196313 */   // Label 3911: @196313
     /* 196313 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196350), // Rule ID 12089 //
     /* 196318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196339 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 196342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196348 */     GIR_RootConstrainSelectedInstOperands,
     /* 196349 */     // GIR_Coverage, 12089,
     /* 196349 */     GIR_EraseRootFromParent_Done,
     /* 196350 */   // Label 3912: @196350
     /* 196350 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196387), // Rule ID 12090 //
     /* 196355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196376 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1265:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 196379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196385 */     GIR_RootConstrainSelectedInstOperands,
     /* 196386 */     // GIR_Coverage, 12090,
     /* 196386 */     GIR_EraseRootFromParent_Done,
     /* 196387 */   // Label 3913: @196387
     /* 196387 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196424), // Rule ID 12091 //
     /* 196392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196413 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 196416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196422 */     GIR_RootConstrainSelectedInstOperands,
     /* 196423 */     // GIR_Coverage, 12091,
     /* 196423 */     GIR_EraseRootFromParent_Done,
     /* 196424 */   // Label 3914: @196424
     /* 196424 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196461), // Rule ID 12092 //
     /* 196429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196450 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 196453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196459 */     GIR_RootConstrainSelectedInstOperands,
     /* 196460 */     // GIR_Coverage, 12092,
     /* 196460 */     GIR_EraseRootFromParent_Done,
     /* 196461 */   // Label 3915: @196461
     /* 196461 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196498), // Rule ID 12093 //
     /* 196466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196487 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 196490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196496 */     GIR_RootConstrainSelectedInstOperands,
     /* 196497 */     // GIR_Coverage, 12093,
     /* 196497 */     GIR_EraseRootFromParent_Done,
     /* 196498 */   // Label 3916: @196498
     /* 196498 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196535), // Rule ID 12094 //
     /* 196503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196524 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 196527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196533 */     GIR_RootConstrainSelectedInstOperands,
     /* 196534 */     // GIR_Coverage, 12094,
     /* 196534 */     GIR_EraseRootFromParent_Done,
     /* 196535 */   // Label 3917: @196535
     /* 196535 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196572), // Rule ID 12095 //
     /* 196540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196561 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 196564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196570 */     GIR_RootConstrainSelectedInstOperands,
     /* 196571 */     // GIR_Coverage, 12095,
     /* 196571 */     GIR_EraseRootFromParent_Done,
     /* 196572 */   // Label 3918: @196572
     /* 196572 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196609), // Rule ID 12096 //
     /* 196577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196598 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 196601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196607 */     GIR_RootConstrainSelectedInstOperands,
     /* 196608 */     // GIR_Coverage, 12096,
     /* 196608 */     GIR_EraseRootFromParent_Done,
     /* 196609 */   // Label 3919: @196609
     /* 196609 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196646), // Rule ID 12097 //
     /* 196614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196635 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 196638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196644 */     GIR_RootConstrainSelectedInstOperands,
     /* 196645 */     // GIR_Coverage, 12097,
     /* 196645 */     GIR_EraseRootFromParent_Done,
     /* 196646 */   // Label 3920: @196646
     /* 196646 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(196683), // Rule ID 12098 //
     /* 196651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196672 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1732:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 196675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196681 */     GIR_RootConstrainSelectedInstOperands,
     /* 196682 */     // GIR_Coverage, 12098,
     /* 196682 */     GIR_EraseRootFromParent_Done,
     /* 196683 */   // Label 3921: @196683
     /* 196683 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(196720), // Rule ID 12099 //
     /* 196688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196709 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1732:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 196712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196718 */     GIR_RootConstrainSelectedInstOperands,
     /* 196719 */     // GIR_Coverage, 12099,
     /* 196719 */     GIR_EraseRootFromParent_Done,
     /* 196720 */   // Label 3922: @196720
     /* 196720 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(196757), // Rule ID 12100 //
     /* 196725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196746 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1732:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 196749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196755 */     GIR_RootConstrainSelectedInstOperands,
     /* 196756 */     // GIR_Coverage, 12100,
     /* 196756 */     GIR_EraseRootFromParent_Done,
     /* 196757 */   // Label 3923: @196757
     /* 196757 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(196794), // Rule ID 12101 //
     /* 196762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196783 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1732:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 196786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196792 */     GIR_RootConstrainSelectedInstOperands,
     /* 196793 */     // GIR_Coverage, 12101,
     /* 196793 */     GIR_EraseRootFromParent_Done,
     /* 196794 */   // Label 3924: @196794
     /* 196794 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(196831), // Rule ID 12102 //
     /* 196799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196820 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 196823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196829 */     GIR_RootConstrainSelectedInstOperands,
     /* 196830 */     // GIR_Coverage, 12102,
     /* 196830 */     GIR_EraseRootFromParent_Done,
     /* 196831 */   // Label 3925: @196831
     /* 196831 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(196868), // Rule ID 12103 //
     /* 196836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196857 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 196860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196866 */     GIR_RootConstrainSelectedInstOperands,
     /* 196867 */     // GIR_Coverage, 12103,
     /* 196867 */     GIR_EraseRootFromParent_Done,
     /* 196868 */   // Label 3926: @196868
     /* 196868 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(196905), // Rule ID 12104 //
     /* 196873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196894 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 196897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196903 */     GIR_RootConstrainSelectedInstOperands,
     /* 196904 */     // GIR_Coverage, 12104,
     /* 196904 */     GIR_EraseRootFromParent_Done,
     /* 196905 */   // Label 3927: @196905
     /* 196905 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(196942), // Rule ID 12105 //
     /* 196910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196931 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 196934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196940 */     GIR_RootConstrainSelectedInstOperands,
     /* 196941 */     // GIR_Coverage, 12105,
     /* 196941 */     GIR_EraseRootFromParent_Done,
     /* 196942 */   // Label 3928: @196942
     /* 196942 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(196979), // Rule ID 12106 //
     /* 196947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196968 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 196971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196977 */     GIR_RootConstrainSelectedInstOperands,
     /* 196978 */     // GIR_Coverage, 12106,
     /* 196978 */     GIR_EraseRootFromParent_Done,
     /* 196979 */   // Label 3929: @196979
     /* 196979 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(197016), // Rule ID 12107 //
     /* 196984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197005 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 197008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197014 */     GIR_RootConstrainSelectedInstOperands,
     /* 197015 */     // GIR_Coverage, 12107,
     /* 197015 */     GIR_EraseRootFromParent_Done,
     /* 197016 */   // Label 3930: @197016
     /* 197016 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(197053), // Rule ID 12108 //
     /* 197021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 197045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197051 */     GIR_RootConstrainSelectedInstOperands,
     /* 197052 */     // GIR_Coverage, 12108,
     /* 197052 */     GIR_EraseRootFromParent_Done,
     /* 197053 */   // Label 3931: @197053
     /* 197053 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(197090), // Rule ID 12109 //
     /* 197058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197079 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 197082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197088 */     GIR_RootConstrainSelectedInstOperands,
     /* 197089 */     // GIR_Coverage, 12109,
     /* 197089 */     GIR_EraseRootFromParent_Done,
     /* 197090 */   // Label 3932: @197090
     /* 197090 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(197127), // Rule ID 12110 //
     /* 197095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197116 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 197119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197125 */     GIR_RootConstrainSelectedInstOperands,
     /* 197126 */     // GIR_Coverage, 12110,
     /* 197126 */     GIR_EraseRootFromParent_Done,
     /* 197127 */   // Label 3933: @197127
     /* 197127 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(197164), // Rule ID 12111 //
     /* 197132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197153 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 197156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197162 */     GIR_RootConstrainSelectedInstOperands,
     /* 197163 */     // GIR_Coverage, 12111,
     /* 197163 */     GIR_EraseRootFromParent_Done,
     /* 197164 */   // Label 3934: @197164
     /* 197164 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(197201), // Rule ID 12112 //
     /* 197169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197190 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 197193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197199 */     GIR_RootConstrainSelectedInstOperands,
     /* 197200 */     // GIR_Coverage, 12112,
     /* 197200 */     GIR_EraseRootFromParent_Done,
     /* 197201 */   // Label 3935: @197201
     /* 197201 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197238), // Rule ID 12113 //
     /* 197206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197227 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 197230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197236 */     GIR_RootConstrainSelectedInstOperands,
     /* 197237 */     // GIR_Coverage, 12113,
     /* 197237 */     GIR_EraseRootFromParent_Done,
     /* 197238 */   // Label 3936: @197238
     /* 197238 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197275), // Rule ID 12114 //
     /* 197243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2163:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 197267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197273 */     GIR_RootConstrainSelectedInstOperands,
     /* 197274 */     // GIR_Coverage, 12114,
     /* 197274 */     GIR_EraseRootFromParent_Done,
     /* 197275 */   // Label 3937: @197275
     /* 197275 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197312), // Rule ID 12115 //
     /* 197280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2163:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 197304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197310 */     GIR_RootConstrainSelectedInstOperands,
     /* 197311 */     // GIR_Coverage, 12115,
     /* 197311 */     GIR_EraseRootFromParent_Done,
     /* 197312 */   // Label 3938: @197312
     /* 197312 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197349), // Rule ID 12116 //
     /* 197317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 197341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197347 */     GIR_RootConstrainSelectedInstOperands,
     /* 197348 */     // GIR_Coverage, 12116,
     /* 197348 */     GIR_EraseRootFromParent_Done,
     /* 197349 */   // Label 3939: @197349
     /* 197349 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197386), // Rule ID 12117 //
     /* 197354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197375 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 197378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197384 */     GIR_RootConstrainSelectedInstOperands,
     /* 197385 */     // GIR_Coverage, 12117,
     /* 197385 */     GIR_EraseRootFromParent_Done,
     /* 197386 */   // Label 3940: @197386
     /* 197386 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197423), // Rule ID 12118 //
     /* 197391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197412 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2163:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 197415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197421 */     GIR_RootConstrainSelectedInstOperands,
     /* 197422 */     // GIR_Coverage, 12118,
     /* 197422 */     GIR_EraseRootFromParent_Done,
     /* 197423 */   // Label 3941: @197423
     /* 197423 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197460), // Rule ID 12119 //
     /* 197428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197449 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2163:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 197452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197458 */     GIR_RootConstrainSelectedInstOperands,
     /* 197459 */     // GIR_Coverage, 12119,
     /* 197459 */     GIR_EraseRootFromParent_Done,
     /* 197460 */   // Label 3942: @197460
     /* 197460 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(197497), // Rule ID 12120 //
     /* 197465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197486 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2163:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 197489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197495 */     GIR_RootConstrainSelectedInstOperands,
     /* 197496 */     // GIR_Coverage, 12120,
     /* 197496 */     GIR_EraseRootFromParent_Done,
     /* 197497 */   // Label 3943: @197497
     /* 197497 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(197534), // Rule ID 12121 //
     /* 197502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197523 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2088:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 197526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197532 */     GIR_RootConstrainSelectedInstOperands,
     /* 197533 */     // GIR_Coverage, 12121,
     /* 197533 */     GIR_EraseRootFromParent_Done,
     /* 197534 */   // Label 3944: @197534
     /* 197534 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(197571), // Rule ID 12122 //
     /* 197539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2088:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 197563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197569 */     GIR_RootConstrainSelectedInstOperands,
     /* 197570 */     // GIR_Coverage, 12122,
     /* 197570 */     GIR_EraseRootFromParent_Done,
     /* 197571 */   // Label 3945: @197571
     /* 197571 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(197608), // Rule ID 12123 //
     /* 197576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2088:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 197600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197606 */     GIR_RootConstrainSelectedInstOperands,
     /* 197607 */     // GIR_Coverage, 12123,
     /* 197607 */     GIR_EraseRootFromParent_Done,
     /* 197608 */   // Label 3946: @197608
     /* 197608 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(197645), // Rule ID 12124 //
     /* 197613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2088:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 197637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197643 */     GIR_RootConstrainSelectedInstOperands,
     /* 197644 */     // GIR_Coverage, 12124,
     /* 197644 */     GIR_EraseRootFromParent_Done,
     /* 197645 */   // Label 3947: @197645
     /* 197645 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(197682), // Rule ID 12125 //
     /* 197650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197671 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2088:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 197674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197680 */     GIR_RootConstrainSelectedInstOperands,
     /* 197681 */     // GIR_Coverage, 12125,
     /* 197681 */     GIR_EraseRootFromParent_Done,
     /* 197682 */   // Label 3948: @197682
     /* 197682 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(197719), // Rule ID 12126 //
     /* 197687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197708 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2088:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 197711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197717 */     GIR_RootConstrainSelectedInstOperands,
     /* 197718 */     // GIR_Coverage, 12126,
     /* 197718 */     GIR_EraseRootFromParent_Done,
     /* 197719 */   // Label 3949: @197719
     /* 197719 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(197756), // Rule ID 12127 //
     /* 197724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197745 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2088:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 197748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197754 */     GIR_RootConstrainSelectedInstOperands,
     /* 197755 */     // GIR_Coverage, 12127,
     /* 197755 */     GIR_EraseRootFromParent_Done,
     /* 197756 */   // Label 3950: @197756
     /* 197756 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(197793), // Rule ID 12128 //
     /* 197761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2089:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 197785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197791 */     GIR_RootConstrainSelectedInstOperands,
     /* 197792 */     // GIR_Coverage, 12128,
     /* 197792 */     GIR_EraseRootFromParent_Done,
     /* 197793 */   // Label 3951: @197793
     /* 197793 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(197830), // Rule ID 12129 //
     /* 197798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2089:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 197822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197828 */     GIR_RootConstrainSelectedInstOperands,
     /* 197829 */     // GIR_Coverage, 12129,
     /* 197829 */     GIR_EraseRootFromParent_Done,
     /* 197830 */   // Label 3952: @197830
     /* 197830 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(197867), // Rule ID 12130 //
     /* 197835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2089:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 197859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197865 */     GIR_RootConstrainSelectedInstOperands,
     /* 197866 */     // GIR_Coverage, 12130,
     /* 197866 */     GIR_EraseRootFromParent_Done,
     /* 197867 */   // Label 3953: @197867
     /* 197867 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(197904), // Rule ID 12131 //
     /* 197872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2089:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 197896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197902 */     GIR_RootConstrainSelectedInstOperands,
     /* 197903 */     // GIR_Coverage, 12131,
     /* 197903 */     GIR_EraseRootFromParent_Done,
     /* 197904 */   // Label 3954: @197904
     /* 197904 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(197941), // Rule ID 12132 //
     /* 197909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197930 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2089:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 197933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197939 */     GIR_RootConstrainSelectedInstOperands,
     /* 197940 */     // GIR_Coverage, 12132,
     /* 197940 */     GIR_EraseRootFromParent_Done,
     /* 197941 */   // Label 3955: @197941
     /* 197941 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(197978), // Rule ID 12133 //
     /* 197946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197967 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2089:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 197970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197976 */     GIR_RootConstrainSelectedInstOperands,
     /* 197977 */     // GIR_Coverage, 12133,
     /* 197977 */     GIR_EraseRootFromParent_Done,
     /* 197978 */   // Label 3956: @197978
     /* 197978 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(198015), // Rule ID 12134 //
     /* 197983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198004 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2089:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 198007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198013 */     GIR_RootConstrainSelectedInstOperands,
     /* 198014 */     // GIR_Coverage, 12134,
     /* 198014 */     GIR_EraseRootFromParent_Done,
     /* 198015 */   // Label 3957: @198015
     /* 198015 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(198057), // Rule ID 3218 //
     /* 198020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 198028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 198031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198035 */     // MIs[0] Op1
     /* 198035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198039 */     // MIs[0] Op2
     /* 198039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198043 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 198046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198055 */     GIR_RootConstrainSelectedInstOperands,
     /* 198056 */     // GIR_Coverage, 3218,
     /* 198056 */     GIR_EraseRootFromParent_Done,
     /* 198057 */   // Label 3958: @198057
     /* 198057 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(198099), // Rule ID 3219 //
     /* 198062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 198070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198077 */     // MIs[0] Op1
     /* 198077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198081 */     // MIs[0] Op2
     /* 198081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198085 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2144:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 198088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198097 */     GIR_RootConstrainSelectedInstOperands,
     /* 198098 */     // GIR_Coverage, 3219,
     /* 198098 */     GIR_EraseRootFromParent_Done,
     /* 198099 */   // Label 3959: @198099
     /* 198099 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(198141), // Rule ID 3220 //
     /* 198104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 198112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198119 */     // MIs[0] Op1
     /* 198119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198123 */     // MIs[0] Op2
     /* 198123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198127 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 198130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198139 */     GIR_RootConstrainSelectedInstOperands,
     /* 198140 */     // GIR_Coverage, 3220,
     /* 198140 */     GIR_EraseRootFromParent_Done,
     /* 198141 */   // Label 3960: @198141
     /* 198141 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(198183), // Rule ID 3221 //
     /* 198146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 198154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198161 */     // MIs[0] Op1
     /* 198161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198165 */     // MIs[0] Op2
     /* 198165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198169 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2143:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 198172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198181 */     GIR_RootConstrainSelectedInstOperands,
     /* 198182 */     // GIR_Coverage, 3221,
     /* 198182 */     GIR_EraseRootFromParent_Done,
     /* 198183 */   // Label 3961: @198183
     /* 198183 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(198225), // Rule ID 11945 //
     /* 198188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 198196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 198199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198203 */     // MIs[0] Op1
     /* 198203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198207 */     // MIs[0] Op2
     /* 198207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198211 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2138:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 198214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198223 */     GIR_RootConstrainSelectedInstOperands,
     /* 198224 */     // GIR_Coverage, 11945,
     /* 198224 */     GIR_EraseRootFromParent_Done,
     /* 198225 */   // Label 3962: @198225
     /* 198225 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198267), // Rule ID 11946 //
     /* 198230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 198238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198245 */     // MIs[0] Op1
     /* 198245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198249 */     // MIs[0] Op2
     /* 198249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198253 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2140:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 198256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198265 */     GIR_RootConstrainSelectedInstOperands,
     /* 198266 */     // GIR_Coverage, 11946,
     /* 198266 */     GIR_EraseRootFromParent_Done,
     /* 198267 */   // Label 3963: @198267
     /* 198267 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198309), // Rule ID 11947 //
     /* 198272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 198280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198287 */     // MIs[0] Op1
     /* 198287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198291 */     // MIs[0] Op2
     /* 198291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198295 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2141:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 198298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198307 */     GIR_RootConstrainSelectedInstOperands,
     /* 198308 */     // GIR_Coverage, 11947,
     /* 198308 */     GIR_EraseRootFromParent_Done,
     /* 198309 */   // Label 3964: @198309
     /* 198309 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198351), // Rule ID 11948 //
     /* 198314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 198322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198329 */     // MIs[0] Op1
     /* 198329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198333 */     // MIs[0] Op2
     /* 198333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198337 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 198340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198349 */     GIR_RootConstrainSelectedInstOperands,
     /* 198350 */     // GIR_Coverage, 11948,
     /* 198350 */     GIR_EraseRootFromParent_Done,
     /* 198351 */   // Label 3965: @198351
     /* 198351 */   GIM_Reject,
     /* 198352 */ // Label 3012: @198352
     /* 198352 */ GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(242135),
     /* 198357 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 198360 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(198473), // Rule ID 2069 //
     /* 198365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 198373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198438 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198442 */     // MIs[3] Operand 1
     /* 198442 */     // No operand predicates
     /* 198442 */     // MIs[1] Operand 2
     /* 198442 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198455 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 198458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198471 */     GIR_RootConstrainSelectedInstOperands,
     /* 198472 */     // GIR_Coverage, 2069,
     /* 198472 */     GIR_EraseRootFromParent_Done,
     /* 198473 */   // Label 3967: @198473
     /* 198473 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198586), // Rule ID 2076 //
     /* 198478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 198486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198551 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198555 */     // MIs[3] Operand 1
     /* 198555 */     // No operand predicates
     /* 198555 */     // MIs[1] Operand 2
     /* 198555 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198568 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 198571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198584 */     GIR_RootConstrainSelectedInstOperands,
     /* 198585 */     // GIR_Coverage, 2076,
     /* 198585 */     GIR_EraseRootFromParent_Done,
     /* 198586 */   // Label 3968: @198586
     /* 198586 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(198699), // Rule ID 2072 //
     /* 198591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 198599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 198611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198664 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198668 */     // MIs[3] Operand 1
     /* 198668 */     // No operand predicates
     /* 198668 */     // MIs[1] Operand 2
     /* 198668 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198681 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 198684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198697 */     GIR_RootConstrainSelectedInstOperands,
     /* 198698 */     // GIR_Coverage, 2072,
     /* 198698 */     GIR_EraseRootFromParent_Done,
     /* 198699 */   // Label 3969: @198699
     /* 198699 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(198812), // Rule ID 2079 //
     /* 198704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 198712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 198724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198777 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198781 */     // MIs[3] Operand 1
     /* 198781 */     // No operand predicates
     /* 198781 */     // MIs[1] Operand 2
     /* 198781 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198794 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 198797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198810 */     GIR_RootConstrainSelectedInstOperands,
     /* 198811 */     // GIR_Coverage, 2079,
     /* 198811 */     GIR_EraseRootFromParent_Done,
     /* 198812 */   // Label 3970: @198812
     /* 198812 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(198917), // Rule ID 3869 //
     /* 198817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 198825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198890 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198894 */     // MIs[3] Operand 1
     /* 198894 */     // No operand predicates
     /* 198894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198896 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 198896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198915 */     GIR_RootConstrainSelectedInstOperands,
     /* 198916 */     // GIR_Coverage, 3869,
     /* 198916 */     GIR_EraseRootFromParent_Done,
     /* 198917 */   // Label 3971: @198917
     /* 198917 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(199022), // Rule ID 3870 //
     /* 198922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 198930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198995 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198999 */     // MIs[3] Operand 1
     /* 198999 */     // No operand predicates
     /* 198999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199001 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199020 */     GIR_RootConstrainSelectedInstOperands,
     /* 199021 */     // GIR_Coverage, 3870,
     /* 199021 */     GIR_EraseRootFromParent_Done,
     /* 199022 */   // Label 3972: @199022
     /* 199022 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(199127), // Rule ID 3871 //
     /* 199027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199100 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199104 */     // MIs[3] Operand 1
     /* 199104 */     // No operand predicates
     /* 199104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199106 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199125 */     GIR_RootConstrainSelectedInstOperands,
     /* 199126 */     // GIR_Coverage, 3871,
     /* 199126 */     GIR_EraseRootFromParent_Done,
     /* 199127 */   // Label 3973: @199127
     /* 199127 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(199232), // Rule ID 3872 //
     /* 199132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199205 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199209 */     // MIs[3] Operand 1
     /* 199209 */     // No operand predicates
     /* 199209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199211 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 199211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 199230 */     GIR_RootConstrainSelectedInstOperands,
     /* 199231 */     // GIR_Coverage, 3872,
     /* 199231 */     GIR_EraseRootFromParent_Done,
     /* 199232 */   // Label 3974: @199232
     /* 199232 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(199337), // Rule ID 3877 //
     /* 199237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199310 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199314 */     // MIs[3] Operand 1
     /* 199314 */     // No operand predicates
     /* 199314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199316 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199335 */     GIR_RootConstrainSelectedInstOperands,
     /* 199336 */     // GIR_Coverage, 3877,
     /* 199336 */     GIR_EraseRootFromParent_Done,
     /* 199337 */   // Label 3975: @199337
     /* 199337 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(199442), // Rule ID 3878 //
     /* 199342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199415 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199419 */     // MIs[3] Operand 1
     /* 199419 */     // No operand predicates
     /* 199419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199421 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199440 */     GIR_RootConstrainSelectedInstOperands,
     /* 199441 */     // GIR_Coverage, 3878,
     /* 199441 */     GIR_EraseRootFromParent_Done,
     /* 199442 */   // Label 3976: @199442
     /* 199442 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(199547), // Rule ID 3879 //
     /* 199447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199520 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199524 */     // MIs[3] Operand 1
     /* 199524 */     // No operand predicates
     /* 199524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199526 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199545 */     GIR_RootConstrainSelectedInstOperands,
     /* 199546 */     // GIR_Coverage, 3879,
     /* 199546 */     GIR_EraseRootFromParent_Done,
     /* 199547 */   // Label 3977: @199547
     /* 199547 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(199652), // Rule ID 3880 //
     /* 199552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199629 */     // MIs[3] Operand 1
     /* 199629 */     // No operand predicates
     /* 199629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199631 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 199631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 199650 */     GIR_RootConstrainSelectedInstOperands,
     /* 199651 */     // GIR_Coverage, 3880,
     /* 199651 */     GIR_EraseRootFromParent_Done,
     /* 199652 */   // Label 3978: @199652
     /* 199652 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(199757), // Rule ID 3893 //
     /* 199657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199734 */     // MIs[3] Operand 1
     /* 199734 */     // No operand predicates
     /* 199734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199736 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199755 */     GIR_RootConstrainSelectedInstOperands,
     /* 199756 */     // GIR_Coverage, 3893,
     /* 199756 */     GIR_EraseRootFromParent_Done,
     /* 199757 */   // Label 3979: @199757
     /* 199757 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(199862), // Rule ID 3894 //
     /* 199762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199835 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199839 */     // MIs[3] Operand 1
     /* 199839 */     // No operand predicates
     /* 199839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199841 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199860 */     GIR_RootConstrainSelectedInstOperands,
     /* 199861 */     // GIR_Coverage, 3894,
     /* 199861 */     GIR_EraseRootFromParent_Done,
     /* 199862 */   // Label 3980: @199862
     /* 199862 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199967), // Rule ID 3895 //
     /* 199867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199940 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199944 */     // MIs[3] Operand 1
     /* 199944 */     // No operand predicates
     /* 199944 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199946 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199965 */     GIR_RootConstrainSelectedInstOperands,
     /* 199966 */     // GIR_Coverage, 3895,
     /* 199966 */     GIR_EraseRootFromParent_Done,
     /* 199967 */   // Label 3981: @199967
     /* 199967 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(200072), // Rule ID 3896 //
     /* 199972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200045 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200049 */     // MIs[3] Operand 1
     /* 200049 */     // No operand predicates
     /* 200049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200051 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 200051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 200070 */     GIR_RootConstrainSelectedInstOperands,
     /* 200071 */     // GIR_Coverage, 3896,
     /* 200071 */     GIR_EraseRootFromParent_Done,
     /* 200072 */   // Label 3982: @200072
     /* 200072 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(200126), // Rule ID 59 //
     /* 200077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200102 */     // MIs[0] Operand 3
     /* 200102 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 200113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200117 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 200120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200124 */     GIR_RootConstrainSelectedInstOperands,
     /* 200125 */     // GIR_Coverage, 59,
     /* 200125 */     GIR_EraseRootFromParent_Done,
     /* 200126 */   // Label 3983: @200126
     /* 200126 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(200180), // Rule ID 60 //
     /* 200131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200156 */     // MIs[0] Operand 3
     /* 200156 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 200167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200171 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 200174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200178 */     GIR_RootConstrainSelectedInstOperands,
     /* 200179 */     // GIR_Coverage, 60,
     /* 200179 */     GIR_EraseRootFromParent_Done,
     /* 200180 */   // Label 3984: @200180
     /* 200180 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(200234), // Rule ID 61 //
     /* 200185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200210 */     // MIs[0] Operand 3
     /* 200210 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 200221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200225 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 200228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200232 */     GIR_RootConstrainSelectedInstOperands,
     /* 200233 */     // GIR_Coverage, 61,
     /* 200233 */     GIR_EraseRootFromParent_Done,
     /* 200234 */   // Label 3985: @200234
     /* 200234 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(200288), // Rule ID 62 //
     /* 200239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200264 */     // MIs[0] Operand 3
     /* 200264 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 200275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200279 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 200282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200286 */     GIR_RootConstrainSelectedInstOperands,
     /* 200287 */     // GIR_Coverage, 62,
     /* 200287 */     GIR_EraseRootFromParent_Done,
     /* 200288 */   // Label 3986: @200288
     /* 200288 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200344), // Rule ID 2652 //
     /* 200293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 200301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200315 */     // MIs[0] pattern
     /* 200315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200323 */     // MIs[0] imm4
     /* 200323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 200334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 200338 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200340 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200342 */     GIR_RootConstrainSelectedInstOperands,
     /* 200343 */     // GIR_Coverage, 2652,
     /* 200343 */     GIR_EraseRootFromParent_Done,
     /* 200344 */   // Label 3987: @200344
     /* 200344 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200400), // Rule ID 2661 //
     /* 200349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 200357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200371 */     // MIs[0] pattern
     /* 200371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200379 */     // MIs[0] imm4
     /* 200379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200387 */     // (intrinsic_wo_chain:{ *:[i32] } 2016:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 200390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200394 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200396 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200398 */     GIR_RootConstrainSelectedInstOperands,
     /* 200399 */     // GIR_Coverage, 2661,
     /* 200399 */     GIR_EraseRootFromParent_Done,
     /* 200400 */   // Label 3988: @200400
     /* 200400 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200456), // Rule ID 2662 //
     /* 200405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 200413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200427 */     // MIs[0] pattern
     /* 200427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200430 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200435 */     // MIs[0] imm4
     /* 200435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200443 */     // (intrinsic_wo_chain:{ *:[i64] } 1806:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 200446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200450 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200452 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200454 */     GIR_RootConstrainSelectedInstOperands,
     /* 200455 */     // GIR_Coverage, 2662,
     /* 200455 */     GIR_EraseRootFromParent_Done,
     /* 200456 */   // Label 3989: @200456
     /* 200456 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200512), // Rule ID 9956 //
     /* 200461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 200469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200483 */     // MIs[0] pattern
     /* 200483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200491 */     // MIs[0] imm4
     /* 200491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200499 */     // (intrinsic_wo_chain:{ *:[i32] } 2002:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 200502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200506 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200508 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200510 */     GIR_RootConstrainSelectedInstOperands,
     /* 200511 */     // GIR_Coverage, 9956,
     /* 200511 */     GIR_EraseRootFromParent_Done,
     /* 200512 */   // Label 3990: @200512
     /* 200512 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200568), // Rule ID 9957 //
     /* 200517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 200525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200539 */     // MIs[0] pattern
     /* 200539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200547 */     // MIs[0] imm4
     /* 200547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200555 */     // (intrinsic_wo_chain:{ *:[i64] } 2017:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 200558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200562 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200564 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200566 */     GIR_RootConstrainSelectedInstOperands,
     /* 200567 */     // GIR_Coverage, 9957,
     /* 200567 */     GIR_EraseRootFromParent_Done,
     /* 200568 */   // Label 3991: @200568
     /* 200568 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200624), // Rule ID 9958 //
     /* 200573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 200581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200595 */     // MIs[0] pattern
     /* 200595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200603 */     // MIs[0] imm4
     /* 200603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200606 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200611 */     // (intrinsic_wo_chain:{ *:[i64] } 1772:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 200614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200618 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200620 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200622 */     GIR_RootConstrainSelectedInstOperands,
     /* 200623 */     // GIR_Coverage, 9958,
     /* 200623 */     GIR_EraseRootFromParent_Done,
     /* 200624 */   // Label 3992: @200624
     /* 200624 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200680), // Rule ID 9959 //
     /* 200629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 200637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200651 */     // MIs[0] pattern
     /* 200651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200654 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200659 */     // MIs[0] imm4
     /* 200659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200667 */     // (intrinsic_wo_chain:{ *:[i64] } 2003:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 200670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200674 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200676 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200678 */     GIR_RootConstrainSelectedInstOperands,
     /* 200679 */     // GIR_Coverage, 9959,
     /* 200679 */     GIR_EraseRootFromParent_Done,
     /* 200680 */   // Label 3993: @200680
     /* 200680 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200736), // Rule ID 9962 //
     /* 200685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 200693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200707 */     // MIs[0] pattern
     /* 200707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200715 */     // MIs[0] imm4
     /* 200715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200723 */     // (intrinsic_wo_chain:{ *:[i32] } 2022:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 200726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200730 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200732 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200734 */     GIR_RootConstrainSelectedInstOperands,
     /* 200735 */     // GIR_Coverage, 9962,
     /* 200735 */     GIR_EraseRootFromParent_Done,
     /* 200736 */   // Label 3994: @200736
     /* 200736 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200792), // Rule ID 9965 //
     /* 200741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 200749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200763 */     // MIs[0] pattern
     /* 200763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200771 */     // MIs[0] imm4
     /* 200771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200779 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 200782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200786 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200788 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200790 */     GIR_RootConstrainSelectedInstOperands,
     /* 200791 */     // GIR_Coverage, 9965,
     /* 200791 */     GIR_EraseRootFromParent_Done,
     /* 200792 */   // Label 3995: @200792
     /* 200792 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200848), // Rule ID 9966 //
     /* 200797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 200805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200819 */     // MIs[0] pattern
     /* 200819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200827 */     // MIs[0] imm4
     /* 200827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200835 */     // (intrinsic_wo_chain:{ *:[i64] } 1812:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 200838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200842 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200844 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200846 */     GIR_RootConstrainSelectedInstOperands,
     /* 200847 */     // GIR_Coverage, 9966,
     /* 200847 */     GIR_EraseRootFromParent_Done,
     /* 200848 */   // Label 3996: @200848
     /* 200848 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(200904), // Rule ID 9967 //
     /* 200853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 200861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200875 */     // MIs[0] pattern
     /* 200875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200883 */     // MIs[0] imm4
     /* 200883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200891 */     // (intrinsic_wo_chain:{ *:[i64] } 2023:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 200894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200898 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200900 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200902 */     GIR_RootConstrainSelectedInstOperands,
     /* 200903 */     // GIR_Coverage, 9967,
     /* 200903 */     GIR_EraseRootFromParent_Done,
     /* 200904 */   // Label 3997: @200904
     /* 200904 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(200960), // Rule ID 9968 //
     /* 200909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 200917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200931 */     // MIs[0] pattern
     /* 200931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200939 */     // MIs[0] imm4
     /* 200939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200947 */     // (intrinsic_wo_chain:{ *:[i64] } 1778:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 200950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200954 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200956 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200958 */     GIR_RootConstrainSelectedInstOperands,
     /* 200959 */     // GIR_Coverage, 9968,
     /* 200959 */     GIR_EraseRootFromParent_Done,
     /* 200960 */   // Label 3998: @200960
     /* 200960 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(201016), // Rule ID 9969 //
     /* 200965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 200973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200987 */     // MIs[0] pattern
     /* 200987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200995 */     // MIs[0] imm4
     /* 200995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201003 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 201006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201010 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201012 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201014 */     GIR_RootConstrainSelectedInstOperands,
     /* 201015 */     // GIR_Coverage, 9969,
     /* 201015 */     GIR_EraseRootFromParent_Done,
     /* 201016 */   // Label 3999: @201016
     /* 201016 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(201072), // Rule ID 9972 //
     /* 201021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 201029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201043 */     // MIs[0] pattern
     /* 201043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201051 */     // MIs[0] imm4
     /* 201051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201059 */     // (intrinsic_wo_chain:{ *:[i32] } 2028:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 201062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201066 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201068 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201070 */     GIR_RootConstrainSelectedInstOperands,
     /* 201071 */     // GIR_Coverage, 9972,
     /* 201071 */     GIR_EraseRootFromParent_Done,
     /* 201072 */   // Label 4000: @201072
     /* 201072 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(201128), // Rule ID 9975 //
     /* 201077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 201085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201099 */     // MIs[0] pattern
     /* 201099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201107 */     // MIs[0] imm4
     /* 201107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201115 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 201118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201122 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201124 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201126 */     GIR_RootConstrainSelectedInstOperands,
     /* 201127 */     // GIR_Coverage, 9975,
     /* 201127 */     GIR_EraseRootFromParent_Done,
     /* 201128 */   // Label 4001: @201128
     /* 201128 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(201184), // Rule ID 9976 //
     /* 201133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 201141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201155 */     // MIs[0] pattern
     /* 201155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201163 */     // MIs[0] imm4
     /* 201163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201171 */     // (intrinsic_wo_chain:{ *:[i64] } 1818:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 201174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201178 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201180 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201182 */     GIR_RootConstrainSelectedInstOperands,
     /* 201183 */     // GIR_Coverage, 9976,
     /* 201183 */     GIR_EraseRootFromParent_Done,
     /* 201184 */   // Label 4002: @201184
     /* 201184 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(201240), // Rule ID 9977 //
     /* 201189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 201197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201211 */     // MIs[0] pattern
     /* 201211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201219 */     // MIs[0] imm4
     /* 201219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201227 */     // (intrinsic_wo_chain:{ *:[i64] } 2029:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 201230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201234 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201236 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201238 */     GIR_RootConstrainSelectedInstOperands,
     /* 201239 */     // GIR_Coverage, 9977,
     /* 201239 */     GIR_EraseRootFromParent_Done,
     /* 201240 */   // Label 4003: @201240
     /* 201240 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201296), // Rule ID 9978 //
     /* 201245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 201253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201267 */     // MIs[0] pattern
     /* 201267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201275 */     // MIs[0] imm4
     /* 201275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201283 */     // (intrinsic_wo_chain:{ *:[i64] } 1784:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 201286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201290 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201292 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201294 */     GIR_RootConstrainSelectedInstOperands,
     /* 201295 */     // GIR_Coverage, 9978,
     /* 201295 */     GIR_EraseRootFromParent_Done,
     /* 201296 */   // Label 4004: @201296
     /* 201296 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201352), // Rule ID 9979 //
     /* 201301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 201309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201323 */     // MIs[0] pattern
     /* 201323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201331 */     // MIs[0] imm4
     /* 201331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201339 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 201342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201346 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201348 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201350 */     GIR_RootConstrainSelectedInstOperands,
     /* 201351 */     // GIR_Coverage, 9979,
     /* 201351 */     GIR_EraseRootFromParent_Done,
     /* 201352 */   // Label 4005: @201352
     /* 201352 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201408), // Rule ID 9982 //
     /* 201357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 201365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201379 */     // MIs[0] pattern
     /* 201379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201387 */     // MIs[0] imm4
     /* 201387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201395 */     // (intrinsic_wo_chain:{ *:[i32] } 2019:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 201398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201402 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201404 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201406 */     GIR_RootConstrainSelectedInstOperands,
     /* 201407 */     // GIR_Coverage, 9982,
     /* 201407 */     GIR_EraseRootFromParent_Done,
     /* 201408 */   // Label 4006: @201408
     /* 201408 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201464), // Rule ID 9985 //
     /* 201413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 201421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201435 */     // MIs[0] pattern
     /* 201435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201443 */     // MIs[0] imm4
     /* 201443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201451 */     // (intrinsic_wo_chain:{ *:[i32] } 2005:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 201454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201458 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201460 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201462 */     GIR_RootConstrainSelectedInstOperands,
     /* 201463 */     // GIR_Coverage, 9985,
     /* 201463 */     GIR_EraseRootFromParent_Done,
     /* 201464 */   // Label 4007: @201464
     /* 201464 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201520), // Rule ID 9986 //
     /* 201469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 201477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201491 */     // MIs[0] pattern
     /* 201491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201499 */     // MIs[0] imm4
     /* 201499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201507 */     // (intrinsic_wo_chain:{ *:[i64] } 1809:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 201510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201514 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201516 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201518 */     GIR_RootConstrainSelectedInstOperands,
     /* 201519 */     // GIR_Coverage, 9986,
     /* 201519 */     GIR_EraseRootFromParent_Done,
     /* 201520 */   // Label 4008: @201520
     /* 201520 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201576), // Rule ID 9987 //
     /* 201525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 201533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201547 */     // MIs[0] pattern
     /* 201547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201555 */     // MIs[0] imm4
     /* 201555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201563 */     // (intrinsic_wo_chain:{ *:[i64] } 2020:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 201566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201570 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201572 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201574 */     GIR_RootConstrainSelectedInstOperands,
     /* 201575 */     // GIR_Coverage, 9987,
     /* 201575 */     GIR_EraseRootFromParent_Done,
     /* 201576 */   // Label 4009: @201576
     /* 201576 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201632), // Rule ID 9988 //
     /* 201581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 201589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201603 */     // MIs[0] pattern
     /* 201603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201606 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201611 */     // MIs[0] imm4
     /* 201611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201619 */     // (intrinsic_wo_chain:{ *:[i64] } 1775:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 201622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201626 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201628 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201630 */     GIR_RootConstrainSelectedInstOperands,
     /* 201631 */     // GIR_Coverage, 9988,
     /* 201631 */     GIR_EraseRootFromParent_Done,
     /* 201632 */   // Label 4010: @201632
     /* 201632 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201688), // Rule ID 9989 //
     /* 201637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 201645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201659 */     // MIs[0] pattern
     /* 201659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201667 */     // MIs[0] imm4
     /* 201667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201675 */     // (intrinsic_wo_chain:{ *:[i64] } 2006:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 201678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201682 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201684 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201686 */     GIR_RootConstrainSelectedInstOperands,
     /* 201687 */     // GIR_Coverage, 9989,
     /* 201687 */     GIR_EraseRootFromParent_Done,
     /* 201688 */   // Label 4011: @201688
     /* 201688 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201744), // Rule ID 9990 //
     /* 201693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 201701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201715 */     // MIs[0] pattern
     /* 201715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201723 */     // MIs[0] imm4
     /* 201723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2021:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 201734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201738 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201740 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201742 */     GIR_RootConstrainSelectedInstOperands,
     /* 201743 */     // GIR_Coverage, 9990,
     /* 201743 */     GIR_EraseRootFromParent_Done,
     /* 201744 */   // Label 4012: @201744
     /* 201744 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201800), // Rule ID 9991 //
     /* 201749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 201757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201771 */     // MIs[0] pattern
     /* 201771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201779 */     // MIs[0] imm4
     /* 201779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201787 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 201790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201794 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201796 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201798 */     GIR_RootConstrainSelectedInstOperands,
     /* 201799 */     // GIR_Coverage, 9991,
     /* 201799 */     GIR_EraseRootFromParent_Done,
     /* 201800 */   // Label 4013: @201800
     /* 201800 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201856), // Rule ID 9992 //
     /* 201805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 201813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201827 */     // MIs[0] pattern
     /* 201827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201835 */     // MIs[0] imm4
     /* 201835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2007:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 201846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201850 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201852 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201854 */     GIR_RootConstrainSelectedInstOperands,
     /* 201855 */     // GIR_Coverage, 9992,
     /* 201855 */     GIR_EraseRootFromParent_Done,
     /* 201856 */   // Label 4014: @201856
     /* 201856 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201912), // Rule ID 9993 //
     /* 201861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 201869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201883 */     // MIs[0] pattern
     /* 201883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201891 */     // MIs[0] imm4
     /* 201891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1816:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 201902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201906 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201908 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201910 */     GIR_RootConstrainSelectedInstOperands,
     /* 201911 */     // GIR_Coverage, 9993,
     /* 201911 */     GIR_EraseRootFromParent_Done,
     /* 201912 */   // Label 4015: @201912
     /* 201912 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201968), // Rule ID 9994 //
     /* 201917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 201925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201939 */     // MIs[0] pattern
     /* 201939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201947 */     // MIs[0] imm4
     /* 201947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201955 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2027:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 201958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201962 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201964 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201966 */     GIR_RootConstrainSelectedInstOperands,
     /* 201967 */     // GIR_Coverage, 9994,
     /* 201967 */     GIR_EraseRootFromParent_Done,
     /* 201968 */   // Label 4016: @201968
     /* 201968 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(202024), // Rule ID 9995 //
     /* 201973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 201981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201995 */     // MIs[0] pattern
     /* 201995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202003 */     // MIs[0] imm4
     /* 202003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 202014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202018 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202020 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202022 */     GIR_RootConstrainSelectedInstOperands,
     /* 202023 */     // GIR_Coverage, 9995,
     /* 202023 */     GIR_EraseRootFromParent_Done,
     /* 202024 */   // Label 4017: @202024
     /* 202024 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(202080), // Rule ID 9996 //
     /* 202029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 202037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202051 */     // MIs[0] pattern
     /* 202051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202059 */     // MIs[0] imm4
     /* 202059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2013:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 202070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202074 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202076 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202078 */     GIR_RootConstrainSelectedInstOperands,
     /* 202079 */     // GIR_Coverage, 9996,
     /* 202079 */     GIR_EraseRootFromParent_Done,
     /* 202080 */   // Label 4018: @202080
     /* 202080 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(202136), // Rule ID 9997 //
     /* 202085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 202093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202107 */     // MIs[0] pattern
     /* 202107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202115 */     // MIs[0] imm4
     /* 202115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202123 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1807:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 202126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202130 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202132 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202134 */     GIR_RootConstrainSelectedInstOperands,
     /* 202135 */     // GIR_Coverage, 9997,
     /* 202135 */     GIR_EraseRootFromParent_Done,
     /* 202136 */   // Label 4019: @202136
     /* 202136 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(202192), // Rule ID 9998 //
     /* 202141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 202149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202163 */     // MIs[0] pattern
     /* 202163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202171 */     // MIs[0] imm4
     /* 202171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2018:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 202182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202186 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202188 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202190 */     GIR_RootConstrainSelectedInstOperands,
     /* 202191 */     // GIR_Coverage, 9998,
     /* 202191 */     GIR_EraseRootFromParent_Done,
     /* 202192 */   // Label 4020: @202192
     /* 202192 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(202248), // Rule ID 9999 //
     /* 202197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 202205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202219 */     // MIs[0] pattern
     /* 202219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202227 */     // MIs[0] imm4
     /* 202227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202235 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 202238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202242 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202244 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202246 */     GIR_RootConstrainSelectedInstOperands,
     /* 202247 */     // GIR_Coverage, 9999,
     /* 202247 */     GIR_EraseRootFromParent_Done,
     /* 202248 */   // Label 4021: @202248
     /* 202248 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202304), // Rule ID 10000 //
     /* 202253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 202261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202275 */     // MIs[0] pattern
     /* 202275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202283 */     // MIs[0] imm4
     /* 202283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202291 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 202294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202298 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202300 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202302 */     GIR_RootConstrainSelectedInstOperands,
     /* 202303 */     // GIR_Coverage, 10000,
     /* 202303 */     GIR_EraseRootFromParent_Done,
     /* 202304 */   // Label 4022: @202304
     /* 202304 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(202394), // Rule ID 47 //
     /* 202309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 202317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202370 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202374 */     // MIs[2] Operand 1
     /* 202374 */     // No operand predicates
     /* 202374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202376 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 202379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202392 */     GIR_RootConstrainSelectedInstOperands,
     /* 202393 */     // GIR_Coverage, 47,
     /* 202393 */     GIR_EraseRootFromParent_Done,
     /* 202394 */   // Label 4023: @202394
     /* 202394 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(202484), // Rule ID 48 //
     /* 202399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 202407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202460 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202464 */     // MIs[2] Operand 1
     /* 202464 */     // No operand predicates
     /* 202464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202466 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 202469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202482 */     GIR_RootConstrainSelectedInstOperands,
     /* 202483 */     // GIR_Coverage, 48,
     /* 202483 */     GIR_EraseRootFromParent_Done,
     /* 202484 */   // Label 4024: @202484
     /* 202484 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(202574), // Rule ID 49 //
     /* 202489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 202497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202550 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202554 */     // MIs[2] Operand 1
     /* 202554 */     // No operand predicates
     /* 202554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202556 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 202559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202572 */     GIR_RootConstrainSelectedInstOperands,
     /* 202573 */     // GIR_Coverage, 49,
     /* 202573 */     GIR_EraseRootFromParent_Done,
     /* 202574 */   // Label 4025: @202574
     /* 202574 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202664), // Rule ID 50 //
     /* 202579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 202587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202640 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202644 */     // MIs[2] Operand 1
     /* 202644 */     // No operand predicates
     /* 202644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202646 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 202649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202662 */     GIR_RootConstrainSelectedInstOperands,
     /* 202663 */     // GIR_Coverage, 50,
     /* 202663 */     GIR_EraseRootFromParent_Done,
     /* 202664 */   // Label 4026: @202664
     /* 202664 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202754), // Rule ID 51 //
     /* 202669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 202677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202730 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202734 */     // MIs[2] Operand 1
     /* 202734 */     // No operand predicates
     /* 202734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202736 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 202739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202752 */     GIR_RootConstrainSelectedInstOperands,
     /* 202753 */     // GIR_Coverage, 51,
     /* 202753 */     GIR_EraseRootFromParent_Done,
     /* 202754 */   // Label 4027: @202754
     /* 202754 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(202844), // Rule ID 52 //
     /* 202759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 202767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202820 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202824 */     // MIs[2] Operand 1
     /* 202824 */     // No operand predicates
     /* 202824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202826 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 202829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202842 */     GIR_RootConstrainSelectedInstOperands,
     /* 202843 */     // GIR_Coverage, 52,
     /* 202843 */     GIR_EraseRootFromParent_Done,
     /* 202844 */   // Label 4028: @202844
     /* 202844 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202934), // Rule ID 53 //
     /* 202849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 202857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202910 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202914 */     // MIs[2] Operand 1
     /* 202914 */     // No operand predicates
     /* 202914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202916 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 202919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202932 */     GIR_RootConstrainSelectedInstOperands,
     /* 202933 */     // GIR_Coverage, 53,
     /* 202933 */     GIR_EraseRootFromParent_Done,
     /* 202934 */   // Label 4029: @202934
     /* 202934 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(203024), // Rule ID 54 //
     /* 202939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 202947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203000 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203004 */     // MIs[2] Operand 1
     /* 203004 */     // No operand predicates
     /* 203004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203006 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 203009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203022 */     GIR_RootConstrainSelectedInstOperands,
     /* 203023 */     // GIR_Coverage, 54,
     /* 203023 */     GIR_EraseRootFromParent_Done,
     /* 203024 */   // Label 4030: @203024
     /* 203024 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(203114), // Rule ID 2070 //
     /* 203029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 203040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203090 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203094 */     // MIs[2] Operand 1
     /* 203094 */     // No operand predicates
     /* 203094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203096 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 203099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203112 */     GIR_RootConstrainSelectedInstOperands,
     /* 203113 */     // GIR_Coverage, 2070,
     /* 203113 */     GIR_EraseRootFromParent_Done,
     /* 203114 */   // Label 4031: @203114
     /* 203114 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(203204), // Rule ID 2071 //
     /* 203119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203184 */     // MIs[2] Operand 1
     /* 203184 */     // No operand predicates
     /* 203184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203186 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 203189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203202 */     GIR_RootConstrainSelectedInstOperands,
     /* 203203 */     // GIR_Coverage, 2071,
     /* 203203 */     GIR_EraseRootFromParent_Done,
     /* 203204 */   // Label 4032: @203204
     /* 203204 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(203294), // Rule ID 2077 //
     /* 203209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 203220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203270 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203274 */     // MIs[2] Operand 1
     /* 203274 */     // No operand predicates
     /* 203274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203276 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 203279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203292 */     GIR_RootConstrainSelectedInstOperands,
     /* 203293 */     // GIR_Coverage, 2077,
     /* 203293 */     GIR_EraseRootFromParent_Done,
     /* 203294 */   // Label 4033: @203294
     /* 203294 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(203384), // Rule ID 2078 //
     /* 203299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203364 */     // MIs[2] Operand 1
     /* 203364 */     // No operand predicates
     /* 203364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203366 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 203369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203382 */     GIR_RootConstrainSelectedInstOperands,
     /* 203383 */     // GIR_Coverage, 2078,
     /* 203383 */     GIR_EraseRootFromParent_Done,
     /* 203384 */   // Label 4034: @203384
     /* 203384 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(203474), // Rule ID 2073 //
     /* 203389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 203406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 203409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203450 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203454 */     // MIs[2] Operand 1
     /* 203454 */     // No operand predicates
     /* 203454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203456 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 203459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203472 */     GIR_RootConstrainSelectedInstOperands,
     /* 203473 */     // GIR_Coverage, 2073,
     /* 203473 */     GIR_EraseRootFromParent_Done,
     /* 203474 */   // Label 4035: @203474
     /* 203474 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(203564), // Rule ID 2074 //
     /* 203479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 203496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 203499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203540 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203544 */     // MIs[2] Operand 1
     /* 203544 */     // No operand predicates
     /* 203544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203546 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 203549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203562 */     GIR_RootConstrainSelectedInstOperands,
     /* 203563 */     // GIR_Coverage, 2074,
     /* 203563 */     GIR_EraseRootFromParent_Done,
     /* 203564 */   // Label 4036: @203564
     /* 203564 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(203654), // Rule ID 2080 //
     /* 203569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 203586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 203589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203634 */     // MIs[2] Operand 1
     /* 203634 */     // No operand predicates
     /* 203634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203636 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 203639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203652 */     GIR_RootConstrainSelectedInstOperands,
     /* 203653 */     // GIR_Coverage, 2080,
     /* 203653 */     GIR_EraseRootFromParent_Done,
     /* 203654 */   // Label 4037: @203654
     /* 203654 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(203744), // Rule ID 2081 //
     /* 203659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 203676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 203679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203724 */     // MIs[2] Operand 1
     /* 203724 */     // No operand predicates
     /* 203724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203726 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 203729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203742 */     GIR_RootConstrainSelectedInstOperands,
     /* 203743 */     // GIR_Coverage, 2081,
     /* 203743 */     GIR_EraseRootFromParent_Done,
     /* 203744 */   // Label 4038: @203744
     /* 203744 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(203834), // Rule ID 2075 //
     /* 203749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 203769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 203789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203814 */     // MIs[2] Operand 1
     /* 203814 */     // No operand predicates
     /* 203814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203816 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 203819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203832 */     GIR_RootConstrainSelectedInstOperands,
     /* 203833 */     // GIR_Coverage, 2075,
     /* 203833 */     GIR_EraseRootFromParent_Done,
     /* 203834 */   // Label 4039: @203834
     /* 203834 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(203924), // Rule ID 2082 //
     /* 203839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 203859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 203879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203900 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203904 */     // MIs[2] Operand 1
     /* 203904 */     // No operand predicates
     /* 203904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203906 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 203909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203922 */     GIR_RootConstrainSelectedInstOperands,
     /* 203923 */     // GIR_Coverage, 2082,
     /* 203923 */     GIR_EraseRootFromParent_Done,
     /* 203924 */   // Label 4040: @203924
     /* 203924 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(204001), // Rule ID 2781 //
     /* 203929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203981 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203985 */     // MIs[2] Operand 1
     /* 203985 */     // No operand predicates
     /* 203985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203987 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 203987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 203990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203999 */     GIR_RootConstrainSelectedInstOperands,
     /* 204000 */     // GIR_Coverage, 2781,
     /* 204000 */     GIR_EraseRootFromParent_Done,
     /* 204001 */   // Label 4041: @204001
     /* 204001 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(204078), // Rule ID 2782 //
     /* 204006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204058 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204062 */     // MIs[2] Operand 1
     /* 204062 */     // No operand predicates
     /* 204062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204064 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 204067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204076 */     GIR_RootConstrainSelectedInstOperands,
     /* 204077 */     // GIR_Coverage, 2782,
     /* 204077 */     GIR_EraseRootFromParent_Done,
     /* 204078 */   // Label 4042: @204078
     /* 204078 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(204155), // Rule ID 2783 //
     /* 204083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204135 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204139 */     // MIs[2] Operand 1
     /* 204139 */     // No operand predicates
     /* 204139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204141 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204153 */     GIR_RootConstrainSelectedInstOperands,
     /* 204154 */     // GIR_Coverage, 2783,
     /* 204154 */     GIR_EraseRootFromParent_Done,
     /* 204155 */   // Label 4043: @204155
     /* 204155 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(204232), // Rule ID 2784 //
     /* 204160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204212 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204216 */     // MIs[2] Operand 1
     /* 204216 */     // No operand predicates
     /* 204216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204218 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204230 */     GIR_RootConstrainSelectedInstOperands,
     /* 204231 */     // GIR_Coverage, 2784,
     /* 204231 */     GIR_EraseRootFromParent_Done,
     /* 204232 */   // Label 4044: @204232
     /* 204232 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(204309), // Rule ID 2785 //
     /* 204237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204289 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204293 */     // MIs[2] Operand 1
     /* 204293 */     // No operand predicates
     /* 204293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204295 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 204298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204307 */     GIR_RootConstrainSelectedInstOperands,
     /* 204308 */     // GIR_Coverage, 2785,
     /* 204308 */     GIR_EraseRootFromParent_Done,
     /* 204309 */   // Label 4045: @204309
     /* 204309 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(204386), // Rule ID 2786 //
     /* 204314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204366 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204370 */     // MIs[2] Operand 1
     /* 204370 */     // No operand predicates
     /* 204370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204372 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 204375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204384 */     GIR_RootConstrainSelectedInstOperands,
     /* 204385 */     // GIR_Coverage, 2786,
     /* 204385 */     GIR_EraseRootFromParent_Done,
     /* 204386 */   // Label 4046: @204386
     /* 204386 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(204463), // Rule ID 7843 //
     /* 204391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204443 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204447 */     // MIs[2] Operand 1
     /* 204447 */     // No operand predicates
     /* 204447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204449 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 204452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204461 */     GIR_RootConstrainSelectedInstOperands,
     /* 204462 */     // GIR_Coverage, 7843,
     /* 204462 */     GIR_EraseRootFromParent_Done,
     /* 204463 */   // Label 4047: @204463
     /* 204463 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(204540), // Rule ID 7844 //
     /* 204468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204520 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204524 */     // MIs[2] Operand 1
     /* 204524 */     // No operand predicates
     /* 204524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204526 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 204529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204538 */     GIR_RootConstrainSelectedInstOperands,
     /* 204539 */     // GIR_Coverage, 7844,
     /* 204539 */     GIR_EraseRootFromParent_Done,
     /* 204540 */   // Label 4048: @204540
     /* 204540 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204617), // Rule ID 7845 //
     /* 204545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204597 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204601 */     // MIs[2] Operand 1
     /* 204601 */     // No operand predicates
     /* 204601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204603 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 204606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204615 */     GIR_RootConstrainSelectedInstOperands,
     /* 204616 */     // GIR_Coverage, 7845,
     /* 204616 */     GIR_EraseRootFromParent_Done,
     /* 204617 */   // Label 4049: @204617
     /* 204617 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(204694), // Rule ID 7846 //
     /* 204622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204674 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204678 */     // MIs[2] Operand 1
     /* 204678 */     // No operand predicates
     /* 204678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204680 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 204683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204692 */     GIR_RootConstrainSelectedInstOperands,
     /* 204693 */     // GIR_Coverage, 7846,
     /* 204693 */     GIR_EraseRootFromParent_Done,
     /* 204694 */   // Label 4050: @204694
     /* 204694 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(204771), // Rule ID 7847 //
     /* 204699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204751 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204755 */     // MIs[2] Operand 1
     /* 204755 */     // No operand predicates
     /* 204755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204757 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 204760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204769 */     GIR_RootConstrainSelectedInstOperands,
     /* 204770 */     // GIR_Coverage, 7847,
     /* 204770 */     GIR_EraseRootFromParent_Done,
     /* 204771 */   // Label 4051: @204771
     /* 204771 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(204848), // Rule ID 7848 //
     /* 204776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204828 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204832 */     // MIs[2] Operand 1
     /* 204832 */     // No operand predicates
     /* 204832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204834 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 204837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204846 */     GIR_RootConstrainSelectedInstOperands,
     /* 204847 */     // GIR_Coverage, 7848,
     /* 204847 */     GIR_EraseRootFromParent_Done,
     /* 204848 */   // Label 4052: @204848
     /* 204848 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(204925), // Rule ID 7849 //
     /* 204853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204905 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204909 */     // MIs[2] Operand 1
     /* 204909 */     // No operand predicates
     /* 204909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204911 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 204914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204923 */     GIR_RootConstrainSelectedInstOperands,
     /* 204924 */     // GIR_Coverage, 7849,
     /* 204924 */     GIR_EraseRootFromParent_Done,
     /* 204925 */   // Label 4053: @204925
     /* 204925 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(205002), // Rule ID 7850 //
     /* 204930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204982 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 204986 */     // MIs[2] Operand 1
     /* 204986 */     // No operand predicates
     /* 204986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204988 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 204991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205000 */     GIR_RootConstrainSelectedInstOperands,
     /* 205001 */     // GIR_Coverage, 7850,
     /* 205001 */     GIR_EraseRootFromParent_Done,
     /* 205002 */   // Label 4054: @205002
     /* 205002 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(205079), // Rule ID 7851 //
     /* 205007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205059 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205063 */     // MIs[2] Operand 1
     /* 205063 */     // No operand predicates
     /* 205063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205065 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205077 */     GIR_RootConstrainSelectedInstOperands,
     /* 205078 */     // GIR_Coverage, 7851,
     /* 205078 */     GIR_EraseRootFromParent_Done,
     /* 205079 */   // Label 4055: @205079
     /* 205079 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(205156), // Rule ID 7852 //
     /* 205084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205136 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205140 */     // MIs[2] Operand 1
     /* 205140 */     // No operand predicates
     /* 205140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205142 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205154 */     GIR_RootConstrainSelectedInstOperands,
     /* 205155 */     // GIR_Coverage, 7852,
     /* 205155 */     GIR_EraseRootFromParent_Done,
     /* 205156 */   // Label 4056: @205156
     /* 205156 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(205233), // Rule ID 7853 //
     /* 205161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205213 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205217 */     // MIs[2] Operand 1
     /* 205217 */     // No operand predicates
     /* 205217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205219 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 205222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205231 */     GIR_RootConstrainSelectedInstOperands,
     /* 205232 */     // GIR_Coverage, 7853,
     /* 205232 */     GIR_EraseRootFromParent_Done,
     /* 205233 */   // Label 4057: @205233
     /* 205233 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(205310), // Rule ID 7854 //
     /* 205238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205290 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205294 */     // MIs[2] Operand 1
     /* 205294 */     // No operand predicates
     /* 205294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205296 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 205299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205308 */     GIR_RootConstrainSelectedInstOperands,
     /* 205309 */     // GIR_Coverage, 7854,
     /* 205309 */     GIR_EraseRootFromParent_Done,
     /* 205310 */   // Label 4058: @205310
     /* 205310 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(205387), // Rule ID 7855 //
     /* 205315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205367 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205371 */     // MIs[2] Operand 1
     /* 205371 */     // No operand predicates
     /* 205371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205373 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 205376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205385 */     GIR_RootConstrainSelectedInstOperands,
     /* 205386 */     // GIR_Coverage, 7855,
     /* 205386 */     GIR_EraseRootFromParent_Done,
     /* 205387 */   // Label 4059: @205387
     /* 205387 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205464), // Rule ID 7856 //
     /* 205392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205444 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205448 */     // MIs[2] Operand 1
     /* 205448 */     // No operand predicates
     /* 205448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205450 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 205453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205462 */     GIR_RootConstrainSelectedInstOperands,
     /* 205463 */     // GIR_Coverage, 7856,
     /* 205463 */     GIR_EraseRootFromParent_Done,
     /* 205464 */   // Label 4060: @205464
     /* 205464 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205541), // Rule ID 7857 //
     /* 205469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205521 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205525 */     // MIs[2] Operand 1
     /* 205525 */     // No operand predicates
     /* 205525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205527 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 205530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205539 */     GIR_RootConstrainSelectedInstOperands,
     /* 205540 */     // GIR_Coverage, 7857,
     /* 205540 */     GIR_EraseRootFromParent_Done,
     /* 205541 */   // Label 4061: @205541
     /* 205541 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205618), // Rule ID 7858 //
     /* 205546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205598 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205602 */     // MIs[2] Operand 1
     /* 205602 */     // No operand predicates
     /* 205602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205604 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 205607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205616 */     GIR_RootConstrainSelectedInstOperands,
     /* 205617 */     // GIR_Coverage, 7858,
     /* 205617 */     GIR_EraseRootFromParent_Done,
     /* 205618 */   // Label 4062: @205618
     /* 205618 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205695), // Rule ID 7859 //
     /* 205623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205675 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205679 */     // MIs[2] Operand 1
     /* 205679 */     // No operand predicates
     /* 205679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205681 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 205684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205693 */     GIR_RootConstrainSelectedInstOperands,
     /* 205694 */     // GIR_Coverage, 7859,
     /* 205694 */     GIR_EraseRootFromParent_Done,
     /* 205695 */   // Label 4063: @205695
     /* 205695 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205772), // Rule ID 7860 //
     /* 205700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205752 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205756 */     // MIs[2] Operand 1
     /* 205756 */     // No operand predicates
     /* 205756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205758 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 205761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205770 */     GIR_RootConstrainSelectedInstOperands,
     /* 205771 */     // GIR_Coverage, 7860,
     /* 205771 */     GIR_EraseRootFromParent_Done,
     /* 205772 */   // Label 4064: @205772
     /* 205772 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(205849), // Rule ID 7861 //
     /* 205777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205829 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205833 */     // MIs[2] Operand 1
     /* 205833 */     // No operand predicates
     /* 205833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205835 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 205838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205847 */     GIR_RootConstrainSelectedInstOperands,
     /* 205848 */     // GIR_Coverage, 7861,
     /* 205848 */     GIR_EraseRootFromParent_Done,
     /* 205849 */   // Label 4065: @205849
     /* 205849 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(205926), // Rule ID 7862 //
     /* 205854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205906 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205910 */     // MIs[2] Operand 1
     /* 205910 */     // No operand predicates
     /* 205910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205912 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 205915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205924 */     GIR_RootConstrainSelectedInstOperands,
     /* 205925 */     // GIR_Coverage, 7862,
     /* 205925 */     GIR_EraseRootFromParent_Done,
     /* 205926 */   // Label 4066: @205926
     /* 205926 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(206003), // Rule ID 7863 //
     /* 205931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205983 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205987 */     // MIs[2] Operand 1
     /* 205987 */     // No operand predicates
     /* 205987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205989 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 205992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206001 */     GIR_RootConstrainSelectedInstOperands,
     /* 206002 */     // GIR_Coverage, 7863,
     /* 206002 */     GIR_EraseRootFromParent_Done,
     /* 206003 */   // Label 4067: @206003
     /* 206003 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(206080), // Rule ID 7864 //
     /* 206008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206060 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206064 */     // MIs[2] Operand 1
     /* 206064 */     // No operand predicates
     /* 206064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206066 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 206069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206078 */     GIR_RootConstrainSelectedInstOperands,
     /* 206079 */     // GIR_Coverage, 7864,
     /* 206079 */     GIR_EraseRootFromParent_Done,
     /* 206080 */   // Label 4068: @206080
     /* 206080 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(206157), // Rule ID 7865 //
     /* 206085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206137 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206141 */     // MIs[2] Operand 1
     /* 206141 */     // No operand predicates
     /* 206141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206143 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206155 */     GIR_RootConstrainSelectedInstOperands,
     /* 206156 */     // GIR_Coverage, 7865,
     /* 206156 */     GIR_EraseRootFromParent_Done,
     /* 206157 */   // Label 4069: @206157
     /* 206157 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(206234), // Rule ID 7866 //
     /* 206162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206214 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206218 */     // MIs[2] Operand 1
     /* 206218 */     // No operand predicates
     /* 206218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206220 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206232 */     GIR_RootConstrainSelectedInstOperands,
     /* 206233 */     // GIR_Coverage, 7866,
     /* 206233 */     GIR_EraseRootFromParent_Done,
     /* 206234 */   // Label 4070: @206234
     /* 206234 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(206311), // Rule ID 7867 //
     /* 206239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206291 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206295 */     // MIs[2] Operand 1
     /* 206295 */     // No operand predicates
     /* 206295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206297 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 206300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206309 */     GIR_RootConstrainSelectedInstOperands,
     /* 206310 */     // GIR_Coverage, 7867,
     /* 206310 */     GIR_EraseRootFromParent_Done,
     /* 206311 */   // Label 4071: @206311
     /* 206311 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(206388), // Rule ID 7868 //
     /* 206316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206368 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206372 */     // MIs[2] Operand 1
     /* 206372 */     // No operand predicates
     /* 206372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206374 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 206377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206386 */     GIR_RootConstrainSelectedInstOperands,
     /* 206387 */     // GIR_Coverage, 7868,
     /* 206387 */     GIR_EraseRootFromParent_Done,
     /* 206388 */   // Label 4072: @206388
     /* 206388 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(206465), // Rule ID 7869 //
     /* 206393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206445 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206449 */     // MIs[2] Operand 1
     /* 206449 */     // No operand predicates
     /* 206449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206451 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 206454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206463 */     GIR_RootConstrainSelectedInstOperands,
     /* 206464 */     // GIR_Coverage, 7869,
     /* 206464 */     GIR_EraseRootFromParent_Done,
     /* 206465 */   // Label 4073: @206465
     /* 206465 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206542), // Rule ID 7870 //
     /* 206470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206522 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206526 */     // MIs[2] Operand 1
     /* 206526 */     // No operand predicates
     /* 206526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206528 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 206531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206540 */     GIR_RootConstrainSelectedInstOperands,
     /* 206541 */     // GIR_Coverage, 7870,
     /* 206541 */     GIR_EraseRootFromParent_Done,
     /* 206542 */   // Label 4074: @206542
     /* 206542 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206619), // Rule ID 7871 //
     /* 206547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206599 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206603 */     // MIs[2] Operand 1
     /* 206603 */     // No operand predicates
     /* 206603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206605 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 206608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206617 */     GIR_RootConstrainSelectedInstOperands,
     /* 206618 */     // GIR_Coverage, 7871,
     /* 206618 */     GIR_EraseRootFromParent_Done,
     /* 206619 */   // Label 4075: @206619
     /* 206619 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206696), // Rule ID 7872 //
     /* 206624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206676 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206680 */     // MIs[2] Operand 1
     /* 206680 */     // No operand predicates
     /* 206680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206682 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 206685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206694 */     GIR_RootConstrainSelectedInstOperands,
     /* 206695 */     // GIR_Coverage, 7872,
     /* 206695 */     GIR_EraseRootFromParent_Done,
     /* 206696 */   // Label 4076: @206696
     /* 206696 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206773), // Rule ID 7873 //
     /* 206701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206753 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206757 */     // MIs[2] Operand 1
     /* 206757 */     // No operand predicates
     /* 206757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206759 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 206762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206771 */     GIR_RootConstrainSelectedInstOperands,
     /* 206772 */     // GIR_Coverage, 7873,
     /* 206772 */     GIR_EraseRootFromParent_Done,
     /* 206773 */   // Label 4077: @206773
     /* 206773 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206850), // Rule ID 7874 //
     /* 206778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206830 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206834 */     // MIs[2] Operand 1
     /* 206834 */     // No operand predicates
     /* 206834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206836 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 206839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206848 */     GIR_RootConstrainSelectedInstOperands,
     /* 206849 */     // GIR_Coverage, 7874,
     /* 206849 */     GIR_EraseRootFromParent_Done,
     /* 206850 */   // Label 4078: @206850
     /* 206850 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206927), // Rule ID 7875 //
     /* 206855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206907 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206911 */     // MIs[2] Operand 1
     /* 206911 */     // No operand predicates
     /* 206911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206913 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 206916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206925 */     GIR_RootConstrainSelectedInstOperands,
     /* 206926 */     // GIR_Coverage, 7875,
     /* 206926 */     GIR_EraseRootFromParent_Done,
     /* 206927 */   // Label 4079: @206927
     /* 206927 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(207004), // Rule ID 7876 //
     /* 206932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206984 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206988 */     // MIs[2] Operand 1
     /* 206988 */     // No operand predicates
     /* 206988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206990 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 206993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207002 */     GIR_RootConstrainSelectedInstOperands,
     /* 207003 */     // GIR_Coverage, 7876,
     /* 207003 */     GIR_EraseRootFromParent_Done,
     /* 207004 */   // Label 4080: @207004
     /* 207004 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(207081), // Rule ID 7877 //
     /* 207009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207061 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207065 */     // MIs[2] Operand 1
     /* 207065 */     // No operand predicates
     /* 207065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207067 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207079 */     GIR_RootConstrainSelectedInstOperands,
     /* 207080 */     // GIR_Coverage, 7877,
     /* 207080 */     GIR_EraseRootFromParent_Done,
     /* 207081 */   // Label 4081: @207081
     /* 207081 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(207158), // Rule ID 7878 //
     /* 207086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207138 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207142 */     // MIs[2] Operand 1
     /* 207142 */     // No operand predicates
     /* 207142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207144 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207156 */     GIR_RootConstrainSelectedInstOperands,
     /* 207157 */     // GIR_Coverage, 7878,
     /* 207157 */     GIR_EraseRootFromParent_Done,
     /* 207158 */   // Label 4082: @207158
     /* 207158 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(207235), // Rule ID 7879 //
     /* 207163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207215 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207219 */     // MIs[2] Operand 1
     /* 207219 */     // No operand predicates
     /* 207219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207221 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 207224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207233 */     GIR_RootConstrainSelectedInstOperands,
     /* 207234 */     // GIR_Coverage, 7879,
     /* 207234 */     GIR_EraseRootFromParent_Done,
     /* 207235 */   // Label 4083: @207235
     /* 207235 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(207312), // Rule ID 7880 //
     /* 207240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207292 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207296 */     // MIs[2] Operand 1
     /* 207296 */     // No operand predicates
     /* 207296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207298 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 207301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207310 */     GIR_RootConstrainSelectedInstOperands,
     /* 207311 */     // GIR_Coverage, 7880,
     /* 207311 */     GIR_EraseRootFromParent_Done,
     /* 207312 */   // Label 4084: @207312
     /* 207312 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(207389), // Rule ID 7881 //
     /* 207317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207369 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207373 */     // MIs[2] Operand 1
     /* 207373 */     // No operand predicates
     /* 207373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207375 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 207378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207387 */     GIR_RootConstrainSelectedInstOperands,
     /* 207388 */     // GIR_Coverage, 7881,
     /* 207388 */     GIR_EraseRootFromParent_Done,
     /* 207389 */   // Label 4085: @207389
     /* 207389 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(207466), // Rule ID 7882 //
     /* 207394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207446 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207450 */     // MIs[2] Operand 1
     /* 207450 */     // No operand predicates
     /* 207450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207452 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 207455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207464 */     GIR_RootConstrainSelectedInstOperands,
     /* 207465 */     // GIR_Coverage, 7882,
     /* 207465 */     GIR_EraseRootFromParent_Done,
     /* 207466 */   // Label 4086: @207466
     /* 207466 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(207543), // Rule ID 7883 //
     /* 207471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207523 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207527 */     // MIs[2] Operand 1
     /* 207527 */     // No operand predicates
     /* 207527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207529 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 207532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207541 */     GIR_RootConstrainSelectedInstOperands,
     /* 207542 */     // GIR_Coverage, 7883,
     /* 207542 */     GIR_EraseRootFromParent_Done,
     /* 207543 */   // Label 4087: @207543
     /* 207543 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207620), // Rule ID 7884 //
     /* 207548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207600 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207604 */     // MIs[2] Operand 1
     /* 207604 */     // No operand predicates
     /* 207604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207606 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 207609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207618 */     GIR_RootConstrainSelectedInstOperands,
     /* 207619 */     // GIR_Coverage, 7884,
     /* 207619 */     GIR_EraseRootFromParent_Done,
     /* 207620 */   // Label 4088: @207620
     /* 207620 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207676), // Rule ID 55 //
     /* 207625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207650 */     // MIs[0] Operand 3
     /* 207650 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 207661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207665 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 207668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207674 */     GIR_RootConstrainSelectedInstOperands,
     /* 207675 */     // GIR_Coverage, 55,
     /* 207675 */     GIR_EraseRootFromParent_Done,
     /* 207676 */   // Label 4089: @207676
     /* 207676 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207732), // Rule ID 56 //
     /* 207681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207706 */     // MIs[0] Operand 3
     /* 207706 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 207717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207721 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 207724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207730 */     GIR_RootConstrainSelectedInstOperands,
     /* 207731 */     // GIR_Coverage, 56,
     /* 207731 */     GIR_EraseRootFromParent_Done,
     /* 207732 */   // Label 4090: @207732
     /* 207732 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207788), // Rule ID 57 //
     /* 207737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207762 */     // MIs[0] Operand 3
     /* 207762 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 207773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207777 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 207780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207786 */     GIR_RootConstrainSelectedInstOperands,
     /* 207787 */     // GIR_Coverage, 57,
     /* 207787 */     GIR_EraseRootFromParent_Done,
     /* 207788 */   // Label 4091: @207788
     /* 207788 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207844), // Rule ID 58 //
     /* 207793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207818 */     // MIs[0] Operand 3
     /* 207818 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 207829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207833 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 207836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207842 */     GIR_RootConstrainSelectedInstOperands,
     /* 207843 */     // GIR_Coverage, 58,
     /* 207843 */     GIR_EraseRootFromParent_Done,
     /* 207844 */   // Label 4092: @207844
     /* 207844 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207899), // Rule ID 2799 //
     /* 207849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207878 */     // MIs[0] imm
     /* 207878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207886 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1542:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 207889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207895 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207897 */     GIR_RootConstrainSelectedInstOperands,
     /* 207898 */     // GIR_Coverage, 2799,
     /* 207898 */     GIR_EraseRootFromParent_Done,
     /* 207899 */   // Label 4093: @207899
     /* 207899 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207954), // Rule ID 2800 //
     /* 207904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207933 */     // MIs[0] imm
     /* 207933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207941 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1542:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 207944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207950 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207952 */     GIR_RootConstrainSelectedInstOperands,
     /* 207953 */     // GIR_Coverage, 2800,
     /* 207953 */     GIR_EraseRootFromParent_Done,
     /* 207954 */   // Label 4094: @207954
     /* 207954 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(208009), // Rule ID 2801 //
     /* 207959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207988 */     // MIs[0] imm
     /* 207988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207996 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1542:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 207999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 208003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 208005 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208007 */     GIR_RootConstrainSelectedInstOperands,
     /* 208008 */     // GIR_Coverage, 2801,
     /* 208008 */     GIR_EraseRootFromParent_Done,
     /* 208009 */   // Label 4095: @208009
     /* 208009 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(208064), // Rule ID 3552 //
     /* 208014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208043 */     // MIs[0] Idx
     /* 208043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 208051 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 208051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 208054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208062 */     GIR_RootConstrainSelectedInstOperands,
     /* 208063 */     // GIR_Coverage, 3552,
     /* 208063 */     GIR_EraseRootFromParent_Done,
     /* 208064 */   // Label 4096: @208064
     /* 208064 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(208119), // Rule ID 3553 //
     /* 208069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208098 */     // MIs[0] Idx
     /* 208098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 208106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 208106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 208109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208117 */     GIR_RootConstrainSelectedInstOperands,
     /* 208118 */     // GIR_Coverage, 3553,
     /* 208118 */     GIR_EraseRootFromParent_Done,
     /* 208119 */   // Label 4097: @208119
     /* 208119 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(208174), // Rule ID 3554 //
     /* 208124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208153 */     // MIs[0] Idx
     /* 208153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 208161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 208161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 208164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208172 */     GIR_RootConstrainSelectedInstOperands,
     /* 208173 */     // GIR_Coverage, 3554,
     /* 208173 */     GIR_EraseRootFromParent_Done,
     /* 208174 */   // Label 4098: @208174
     /* 208174 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(208229), // Rule ID 3844 //
     /* 208179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 208182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 208187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 208190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 208193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 208196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208208 */     // MIs[0] imm
     /* 208208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 208216 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 208216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 208219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 208221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 208223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 208225 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208227 */     GIR_RootConstrainSelectedInstOperands,
     /* 208228 */     // GIR_Coverage, 3844,
     /* 208228 */     GIR_EraseRootFromParent_Done,
     /* 208229 */   // Label 4099: @208229
     /* 208229 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(208276), // Rule ID 2853 //
     /* 208234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208255 */     // MIs[0] idx
     /* 208255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208263 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 208263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 208266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208272 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208274 */     GIR_RootConstrainSelectedInstOperands,
     /* 208275 */     // GIR_Coverage, 2853,
     /* 208275 */     GIR_EraseRootFromParent_Done,
     /* 208276 */   // Label 4100: @208276
     /* 208276 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(208323), // Rule ID 2854 //
     /* 208281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208302 */     // MIs[0] idx
     /* 208302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208310 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 208310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 208313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208319 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208321 */     GIR_RootConstrainSelectedInstOperands,
     /* 208322 */     // GIR_Coverage, 2854,
     /* 208322 */     GIR_EraseRootFromParent_Done,
     /* 208323 */   // Label 4101: @208323
     /* 208323 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(208370), // Rule ID 2855 //
     /* 208328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208349 */     // MIs[0] idx
     /* 208349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208357 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 208357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 208360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208366 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208368 */     GIR_RootConstrainSelectedInstOperands,
     /* 208369 */     // GIR_Coverage, 2855,
     /* 208369 */     GIR_EraseRootFromParent_Done,
     /* 208370 */   // Label 4102: @208370
     /* 208370 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(208417), // Rule ID 3004 //
     /* 208375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208396 */     // MIs[0] Op3
     /* 208396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 208407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208415 */     GIR_RootConstrainSelectedInstOperands,
     /* 208416 */     // GIR_Coverage, 3004,
     /* 208416 */     GIR_EraseRootFromParent_Done,
     /* 208417 */   // Label 4103: @208417
     /* 208417 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(208464), // Rule ID 3005 //
     /* 208422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208443 */     // MIs[0] Op3
     /* 208443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 208454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208462 */     GIR_RootConstrainSelectedInstOperands,
     /* 208463 */     // GIR_Coverage, 3005,
     /* 208463 */     GIR_EraseRootFromParent_Done,
     /* 208464 */   // Label 4104: @208464
     /* 208464 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(208511), // Rule ID 3006 //
     /* 208469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208490 */     // MIs[0] Op3
     /* 208490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208498 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 208498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 208501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208509 */     GIR_RootConstrainSelectedInstOperands,
     /* 208510 */     // GIR_Coverage, 3006,
     /* 208510 */     GIR_EraseRootFromParent_Done,
     /* 208511 */   // Label 4105: @208511
     /* 208511 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(208558), // Rule ID 3007 //
     /* 208516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 208524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208537 */     // MIs[0] Op3
     /* 208537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 208548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208556 */     GIR_RootConstrainSelectedInstOperands,
     /* 208557 */     // GIR_Coverage, 3007,
     /* 208557 */     GIR_EraseRootFromParent_Done,
     /* 208558 */   // Label 4106: @208558
     /* 208558 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(208605), // Rule ID 3008 //
     /* 208563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 208571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208584 */     // MIs[0] Op3
     /* 208584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 208595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208603 */     GIR_RootConstrainSelectedInstOperands,
     /* 208604 */     // GIR_Coverage, 3008,
     /* 208604 */     GIR_EraseRootFromParent_Done,
     /* 208605 */   // Label 4107: @208605
     /* 208605 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(208652), // Rule ID 3056 //
     /* 208610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208631 */     // MIs[0] Op3
     /* 208631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 208642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208650 */     GIR_RootConstrainSelectedInstOperands,
     /* 208651 */     // GIR_Coverage, 3056,
     /* 208651 */     GIR_EraseRootFromParent_Done,
     /* 208652 */   // Label 4108: @208652
     /* 208652 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(208699), // Rule ID 3058 //
     /* 208657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208678 */     // MIs[0] Op3
     /* 208678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 208689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208697 */     GIR_RootConstrainSelectedInstOperands,
     /* 208698 */     // GIR_Coverage, 3058,
     /* 208698 */     GIR_EraseRootFromParent_Done,
     /* 208699 */   // Label 4109: @208699
     /* 208699 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(208746), // Rule ID 3060 //
     /* 208704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208725 */     // MIs[0] Op3
     /* 208725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 208736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208744 */     GIR_RootConstrainSelectedInstOperands,
     /* 208745 */     // GIR_Coverage, 3060,
     /* 208745 */     GIR_EraseRootFromParent_Done,
     /* 208746 */   // Label 4110: @208746
     /* 208746 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208793), // Rule ID 3062 //
     /* 208751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208772 */     // MIs[0] Op3
     /* 208772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 208780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 208780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 208783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208791 */     GIR_RootConstrainSelectedInstOperands,
     /* 208792 */     // GIR_Coverage, 3062,
     /* 208792 */     GIR_EraseRootFromParent_Done,
     /* 208793 */   // Label 4111: @208793
     /* 208793 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208840), // Rule ID 3084 //
     /* 208798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208819 */     // MIs[0] Op3
     /* 208819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 208830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208838 */     GIR_RootConstrainSelectedInstOperands,
     /* 208839 */     // GIR_Coverage, 3084,
     /* 208839 */     GIR_EraseRootFromParent_Done,
     /* 208840 */   // Label 4112: @208840
     /* 208840 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208887), // Rule ID 3085 //
     /* 208845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208866 */     // MIs[0] Op3
     /* 208866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 208877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208885 */     GIR_RootConstrainSelectedInstOperands,
     /* 208886 */     // GIR_Coverage, 3085,
     /* 208886 */     GIR_EraseRootFromParent_Done,
     /* 208887 */   // Label 4113: @208887
     /* 208887 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208934), // Rule ID 3086 //
     /* 208892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208913 */     // MIs[0] Op3
     /* 208913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 208924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208932 */     GIR_RootConstrainSelectedInstOperands,
     /* 208933 */     // GIR_Coverage, 3086,
     /* 208933 */     GIR_EraseRootFromParent_Done,
     /* 208934 */   // Label 4114: @208934
     /* 208934 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208981), // Rule ID 3155 //
     /* 208939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208960 */     // MIs[0] Op3
     /* 208960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2147:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 208971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208979 */     GIR_RootConstrainSelectedInstOperands,
     /* 208980 */     // GIR_Coverage, 3155,
     /* 208980 */     GIR_EraseRootFromParent_Done,
     /* 208981 */   // Label 4115: @208981
     /* 208981 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(209028), // Rule ID 3156 //
     /* 208986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209007 */     // MIs[0] Op3
     /* 209007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209015 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2147:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 209018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209026 */     GIR_RootConstrainSelectedInstOperands,
     /* 209027 */     // GIR_Coverage, 3156,
     /* 209027 */     GIR_EraseRootFromParent_Done,
     /* 209028 */   // Label 4116: @209028
     /* 209028 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(209075), // Rule ID 3157 //
     /* 209033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209054 */     // MIs[0] Op3
     /* 209054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2147:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 209065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209073 */     GIR_RootConstrainSelectedInstOperands,
     /* 209074 */     // GIR_Coverage, 3157,
     /* 209074 */     GIR_EraseRootFromParent_Done,
     /* 209075 */   // Label 4117: @209075
     /* 209075 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(209122), // Rule ID 3158 //
     /* 209080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209101 */     // MIs[0] Op3
     /* 209101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2147:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 209112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209120 */     GIR_RootConstrainSelectedInstOperands,
     /* 209121 */     // GIR_Coverage, 3158,
     /* 209121 */     GIR_EraseRootFromParent_Done,
     /* 209122 */   // Label 4118: @209122
     /* 209122 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(209169), // Rule ID 3537 //
     /* 209127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 209130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 209135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209148 */     // MIs[0] Op3
     /* 209148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 209156 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1357:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 209156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 209159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209167 */     GIR_RootConstrainSelectedInstOperands,
     /* 209168 */     // GIR_Coverage, 3537,
     /* 209168 */     GIR_EraseRootFromParent_Done,
     /* 209169 */   // Label 4119: @209169
     /* 209169 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(209216), // Rule ID 3585 //
     /* 209174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209195 */     // MIs[0] Op3
     /* 209195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209203 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 209206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209214 */     GIR_RootConstrainSelectedInstOperands,
     /* 209215 */     // GIR_Coverage, 3585,
     /* 209215 */     GIR_EraseRootFromParent_Done,
     /* 209216 */   // Label 4120: @209216
     /* 209216 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(209263), // Rule ID 3586 //
     /* 209221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209242 */     // MIs[0] Op3
     /* 209242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 209250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 209250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 209253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209261 */     GIR_RootConstrainSelectedInstOperands,
     /* 209262 */     // GIR_Coverage, 3586,
     /* 209262 */     GIR_EraseRootFromParent_Done,
     /* 209263 */   // Label 4121: @209263
     /* 209263 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(209310), // Rule ID 3587 //
     /* 209268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209289 */     // MIs[0] Op3
     /* 209289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 209297 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1596:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 209297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 209300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209308 */     GIR_RootConstrainSelectedInstOperands,
     /* 209309 */     // GIR_Coverage, 3587,
     /* 209309 */     GIR_EraseRootFromParent_Done,
     /* 209310 */   // Label 4122: @209310
     /* 209310 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(209357), // Rule ID 3588 //
     /* 209315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209336 */     // MIs[0] Op3
     /* 209336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 209344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 209344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 209347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209355 */     GIR_RootConstrainSelectedInstOperands,
     /* 209356 */     // GIR_Coverage, 3588,
     /* 209356 */     GIR_EraseRootFromParent_Done,
     /* 209357 */   // Label 4123: @209357
     /* 209357 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(209404), // Rule ID 3589 //
     /* 209362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209383 */     // MIs[0] Op3
     /* 209383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 209394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209402 */     GIR_RootConstrainSelectedInstOperands,
     /* 209403 */     // GIR_Coverage, 3589,
     /* 209403 */     GIR_EraseRootFromParent_Done,
     /* 209404 */   // Label 4124: @209404
     /* 209404 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209451), // Rule ID 3590 //
     /* 209409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209430 */     // MIs[0] Op3
     /* 209430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209438 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1597:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 209441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209449 */     GIR_RootConstrainSelectedInstOperands,
     /* 209450 */     // GIR_Coverage, 3590,
     /* 209450 */     GIR_EraseRootFromParent_Done,
     /* 209451 */   // Label 4125: @209451
     /* 209451 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(209498), // Rule ID 11301 //
     /* 209456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209477 */     // MIs[0] Op3
     /* 209477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209485 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 209488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209496 */     GIR_RootConstrainSelectedInstOperands,
     /* 209497 */     // GIR_Coverage, 11301,
     /* 209497 */     GIR_EraseRootFromParent_Done,
     /* 209498 */   // Label 4126: @209498
     /* 209498 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(209545), // Rule ID 11302 //
     /* 209503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209524 */     // MIs[0] Op3
     /* 209524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 209535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209543 */     GIR_RootConstrainSelectedInstOperands,
     /* 209544 */     // GIR_Coverage, 11302,
     /* 209544 */     GIR_EraseRootFromParent_Done,
     /* 209545 */   // Label 4127: @209545
     /* 209545 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(209592), // Rule ID 11303 //
     /* 209550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209571 */     // MIs[0] Op3
     /* 209571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 209579 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 209579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 209582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209590 */     GIR_RootConstrainSelectedInstOperands,
     /* 209591 */     // GIR_Coverage, 11303,
     /* 209591 */     GIR_EraseRootFromParent_Done,
     /* 209592 */   // Label 4128: @209592
     /* 209592 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(209639), // Rule ID 11304 //
     /* 209597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209618 */     // MIs[0] Op3
     /* 209618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 209629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209637 */     GIR_RootConstrainSelectedInstOperands,
     /* 209638 */     // GIR_Coverage, 11304,
     /* 209638 */     GIR_EraseRootFromParent_Done,
     /* 209639 */   // Label 4129: @209639
     /* 209639 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209686), // Rule ID 11305 //
     /* 209644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209665 */     // MIs[0] Op3
     /* 209665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 209676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209684 */     GIR_RootConstrainSelectedInstOperands,
     /* 209685 */     // GIR_Coverage, 11305,
     /* 209685 */     GIR_EraseRootFromParent_Done,
     /* 209686 */   // Label 4130: @209686
     /* 209686 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209733), // Rule ID 11306 //
     /* 209691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209712 */     // MIs[0] Op3
     /* 209712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 209720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 209720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 209723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209731 */     GIR_RootConstrainSelectedInstOperands,
     /* 209732 */     // GIR_Coverage, 11306,
     /* 209732 */     GIR_EraseRootFromParent_Done,
     /* 209733 */   // Label 4131: @209733
     /* 209733 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209780), // Rule ID 11329 //
     /* 209738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 209746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209759 */     // MIs[0] Op3
     /* 209759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209762 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 209770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209778 */     GIR_RootConstrainSelectedInstOperands,
     /* 209779 */     // GIR_Coverage, 11329,
     /* 209779 */     GIR_EraseRootFromParent_Done,
     /* 209780 */   // Label 4132: @209780
     /* 209780 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209827), // Rule ID 11330 //
     /* 209785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 209793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209806 */     // MIs[0] Op3
     /* 209806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 209817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209825 */     GIR_RootConstrainSelectedInstOperands,
     /* 209826 */     // GIR_Coverage, 11330,
     /* 209826 */     GIR_EraseRootFromParent_Done,
     /* 209827 */   // Label 4133: @209827
     /* 209827 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209874), // Rule ID 11331 //
     /* 209832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 209840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209853 */     // MIs[0] Op3
     /* 209853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 209864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209872 */     GIR_RootConstrainSelectedInstOperands,
     /* 209873 */     // GIR_Coverage, 11331,
     /* 209873 */     GIR_EraseRootFromParent_Done,
     /* 209874 */   // Label 4134: @209874
     /* 209874 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209921), // Rule ID 11332 //
     /* 209879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 209887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209900 */     // MIs[0] Op3
     /* 209900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 209911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209919 */     GIR_RootConstrainSelectedInstOperands,
     /* 209920 */     // GIR_Coverage, 11332,
     /* 209920 */     GIR_EraseRootFromParent_Done,
     /* 209921 */   // Label 4135: @209921
     /* 209921 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209968), // Rule ID 11333 //
     /* 209926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 209934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209947 */     // MIs[0] Op3
     /* 209947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209955 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 209958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209966 */     GIR_RootConstrainSelectedInstOperands,
     /* 209967 */     // GIR_Coverage, 11333,
     /* 209967 */     GIR_EraseRootFromParent_Done,
     /* 209968 */   // Label 4136: @209968
     /* 209968 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(210015), // Rule ID 11334 //
     /* 209973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 209981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209994 */     // MIs[0] Op3
     /* 209994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210002 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 210005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210013 */     GIR_RootConstrainSelectedInstOperands,
     /* 210014 */     // GIR_Coverage, 11334,
     /* 210014 */     GIR_EraseRootFromParent_Done,
     /* 210015 */   // Label 4137: @210015
     /* 210015 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(210062), // Rule ID 11335 //
     /* 210020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210041 */     // MIs[0] Op3
     /* 210041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 210052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210060 */     GIR_RootConstrainSelectedInstOperands,
     /* 210061 */     // GIR_Coverage, 11335,
     /* 210061 */     GIR_EraseRootFromParent_Done,
     /* 210062 */   // Label 4138: @210062
     /* 210062 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(210109), // Rule ID 11336 //
     /* 210067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210088 */     // MIs[0] Op3
     /* 210088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 210099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210107 */     GIR_RootConstrainSelectedInstOperands,
     /* 210108 */     // GIR_Coverage, 11336,
     /* 210108 */     GIR_EraseRootFromParent_Done,
     /* 210109 */   // Label 4139: @210109
     /* 210109 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(210156), // Rule ID 11337 //
     /* 210114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210135 */     // MIs[0] Op3
     /* 210135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 210146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210154 */     GIR_RootConstrainSelectedInstOperands,
     /* 210155 */     // GIR_Coverage, 11337,
     /* 210155 */     GIR_EraseRootFromParent_Done,
     /* 210156 */   // Label 4140: @210156
     /* 210156 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(210203), // Rule ID 11338 //
     /* 210161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210182 */     // MIs[0] Op3
     /* 210182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 210193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210201 */     GIR_RootConstrainSelectedInstOperands,
     /* 210202 */     // GIR_Coverage, 11338,
     /* 210202 */     GIR_EraseRootFromParent_Done,
     /* 210203 */   // Label 4141: @210203
     /* 210203 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(210250), // Rule ID 11582 //
     /* 210208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210229 */     // MIs[0] Op3
     /* 210229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210237 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 210240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210248 */     GIR_RootConstrainSelectedInstOperands,
     /* 210249 */     // GIR_Coverage, 11582,
     /* 210249 */     GIR_EraseRootFromParent_Done,
     /* 210250 */   // Label 4142: @210250
     /* 210250 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210297), // Rule ID 11583 //
     /* 210255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210276 */     // MIs[0] Op3
     /* 210276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 210287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210295 */     GIR_RootConstrainSelectedInstOperands,
     /* 210296 */     // GIR_Coverage, 11583,
     /* 210296 */     GIR_EraseRootFromParent_Done,
     /* 210297 */   // Label 4143: @210297
     /* 210297 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210344), // Rule ID 11584 //
     /* 210302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210323 */     // MIs[0] Op3
     /* 210323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 210334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210342 */     GIR_RootConstrainSelectedInstOperands,
     /* 210343 */     // GIR_Coverage, 11584,
     /* 210343 */     GIR_EraseRootFromParent_Done,
     /* 210344 */   // Label 4144: @210344
     /* 210344 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210391), // Rule ID 11585 //
     /* 210349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210370 */     // MIs[0] Op3
     /* 210370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210373 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 210381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210389 */     GIR_RootConstrainSelectedInstOperands,
     /* 210390 */     // GIR_Coverage, 11585,
     /* 210390 */     GIR_EraseRootFromParent_Done,
     /* 210391 */   // Label 4145: @210391
     /* 210391 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210438), // Rule ID 11586 //
     /* 210396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210417 */     // MIs[0] Op3
     /* 210417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210425 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 210428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210436 */     GIR_RootConstrainSelectedInstOperands,
     /* 210437 */     // GIR_Coverage, 11586,
     /* 210437 */     GIR_EraseRootFromParent_Done,
     /* 210438 */   // Label 4146: @210438
     /* 210438 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210485), // Rule ID 11588 //
     /* 210443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210464 */     // MIs[0] Op3
     /* 210464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 210475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210483 */     GIR_RootConstrainSelectedInstOperands,
     /* 210484 */     // GIR_Coverage, 11588,
     /* 210484 */     GIR_EraseRootFromParent_Done,
     /* 210485 */   // Label 4147: @210485
     /* 210485 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210532), // Rule ID 11590 //
     /* 210490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210511 */     // MIs[0] Op3
     /* 210511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 210522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210530 */     GIR_RootConstrainSelectedInstOperands,
     /* 210531 */     // GIR_Coverage, 11590,
     /* 210531 */     GIR_EraseRootFromParent_Done,
     /* 210532 */   // Label 4148: @210532
     /* 210532 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210579), // Rule ID 11592 //
     /* 210537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210558 */     // MIs[0] Op3
     /* 210558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 210569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210577 */     GIR_RootConstrainSelectedInstOperands,
     /* 210578 */     // GIR_Coverage, 11592,
     /* 210578 */     GIR_EraseRootFromParent_Done,
     /* 210579 */   // Label 4149: @210579
     /* 210579 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210626), // Rule ID 11594 //
     /* 210584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210605 */     // MIs[0] Op3
     /* 210605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 210613 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1842:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 210613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 210616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210624 */     GIR_RootConstrainSelectedInstOperands,
     /* 210625 */     // GIR_Coverage, 11594,
     /* 210625 */     GIR_EraseRootFromParent_Done,
     /* 210626 */   // Label 4150: @210626
     /* 210626 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210673), // Rule ID 11595 //
     /* 210631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210652 */     // MIs[0] Op3
     /* 210652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 210660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 210660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 210663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210671 */     GIR_RootConstrainSelectedInstOperands,
     /* 210672 */     // GIR_Coverage, 11595,
     /* 210672 */     GIR_EraseRootFromParent_Done,
     /* 210673 */   // Label 4151: @210673
     /* 210673 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210720), // Rule ID 11596 //
     /* 210678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210699 */     // MIs[0] Op3
     /* 210699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 210707 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 210707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 210710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210718 */     GIR_RootConstrainSelectedInstOperands,
     /* 210719 */     // GIR_Coverage, 11596,
     /* 210719 */     GIR_EraseRootFromParent_Done,
     /* 210720 */   // Label 4152: @210720
     /* 210720 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210767), // Rule ID 11597 //
     /* 210725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210746 */     // MIs[0] Op3
     /* 210746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 210754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 210754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 210757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210765 */     GIR_RootConstrainSelectedInstOperands,
     /* 210766 */     // GIR_Coverage, 11597,
     /* 210766 */     GIR_EraseRootFromParent_Done,
     /* 210767 */   // Label 4153: @210767
     /* 210767 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210814), // Rule ID 11672 //
     /* 210772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210793 */     // MIs[0] Op3
     /* 210793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210801 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 210804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210812 */     GIR_RootConstrainSelectedInstOperands,
     /* 210813 */     // GIR_Coverage, 11672,
     /* 210813 */     GIR_EraseRootFromParent_Done,
     /* 210814 */   // Label 4154: @210814
     /* 210814 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210861), // Rule ID 11674 //
     /* 210819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210840 */     // MIs[0] Op3
     /* 210840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 210851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210859 */     GIR_RootConstrainSelectedInstOperands,
     /* 210860 */     // GIR_Coverage, 11674,
     /* 210860 */     GIR_EraseRootFromParent_Done,
     /* 210861 */   // Label 4155: @210861
     /* 210861 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210908), // Rule ID 11676 //
     /* 210866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210887 */     // MIs[0] Op3
     /* 210887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 210898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210906 */     GIR_RootConstrainSelectedInstOperands,
     /* 210907 */     // GIR_Coverage, 11676,
     /* 210907 */     GIR_EraseRootFromParent_Done,
     /* 210908 */   // Label 4156: @210908
     /* 210908 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210955), // Rule ID 11678 //
     /* 210913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210934 */     // MIs[0] Op3
     /* 210934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 210945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210953 */     GIR_RootConstrainSelectedInstOperands,
     /* 210954 */     // GIR_Coverage, 11678,
     /* 210954 */     GIR_EraseRootFromParent_Done,
     /* 210955 */   // Label 4157: @210955
     /* 210955 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(211002), // Rule ID 11680 //
     /* 210960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 210968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210981 */     // MIs[0] Op3
     /* 210981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210989 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 210992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211000 */     GIR_RootConstrainSelectedInstOperands,
     /* 211001 */     // GIR_Coverage, 11680,
     /* 211001 */     GIR_EraseRootFromParent_Done,
     /* 211002 */   // Label 4158: @211002
     /* 211002 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(211049), // Rule ID 11681 //
     /* 211007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211028 */     // MIs[0] Op3
     /* 211028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 211039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211047 */     GIR_RootConstrainSelectedInstOperands,
     /* 211048 */     // GIR_Coverage, 11681,
     /* 211048 */     GIR_EraseRootFromParent_Done,
     /* 211049 */   // Label 4159: @211049
     /* 211049 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(211096), // Rule ID 11682 //
     /* 211054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211075 */     // MIs[0] Op3
     /* 211075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 211086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211094 */     GIR_RootConstrainSelectedInstOperands,
     /* 211095 */     // GIR_Coverage, 11682,
     /* 211095 */     GIR_EraseRootFromParent_Done,
     /* 211096 */   // Label 4160: @211096
     /* 211096 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(211143), // Rule ID 11683 //
     /* 211101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211122 */     // MIs[0] Op3
     /* 211122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 211133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211141 */     GIR_RootConstrainSelectedInstOperands,
     /* 211142 */     // GIR_Coverage, 11683,
     /* 211142 */     GIR_EraseRootFromParent_Done,
     /* 211143 */   // Label 4161: @211143
     /* 211143 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(211190), // Rule ID 11688 //
     /* 211148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211169 */     // MIs[0] Op3
     /* 211169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211177 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 211180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211188 */     GIR_RootConstrainSelectedInstOperands,
     /* 211189 */     // GIR_Coverage, 11688,
     /* 211189 */     GIR_EraseRootFromParent_Done,
     /* 211190 */   // Label 4162: @211190
     /* 211190 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(211237), // Rule ID 11689 //
     /* 211195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211216 */     // MIs[0] Op3
     /* 211216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 211227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211235 */     GIR_RootConstrainSelectedInstOperands,
     /* 211236 */     // GIR_Coverage, 11689,
     /* 211236 */     GIR_EraseRootFromParent_Done,
     /* 211237 */   // Label 4163: @211237
     /* 211237 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211284), // Rule ID 11690 //
     /* 211242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211263 */     // MIs[0] Op3
     /* 211263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 211274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211282 */     GIR_RootConstrainSelectedInstOperands,
     /* 211283 */     // GIR_Coverage, 11690,
     /* 211283 */     GIR_EraseRootFromParent_Done,
     /* 211284 */   // Label 4164: @211284
     /* 211284 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211331), // Rule ID 11691 //
     /* 211289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211310 */     // MIs[0] Op3
     /* 211310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 211321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211329 */     GIR_RootConstrainSelectedInstOperands,
     /* 211330 */     // GIR_Coverage, 11691,
     /* 211330 */     GIR_EraseRootFromParent_Done,
     /* 211331 */   // Label 4165: @211331
     /* 211331 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211378), // Rule ID 11751 //
     /* 211336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211357 */     // MIs[0] Op3
     /* 211357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211365 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 211368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211376 */     GIR_RootConstrainSelectedInstOperands,
     /* 211377 */     // GIR_Coverage, 11751,
     /* 211377 */     GIR_EraseRootFromParent_Done,
     /* 211378 */   // Label 4166: @211378
     /* 211378 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211425), // Rule ID 11752 //
     /* 211383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211404 */     // MIs[0] Op3
     /* 211404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 211415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211423 */     GIR_RootConstrainSelectedInstOperands,
     /* 211424 */     // GIR_Coverage, 11752,
     /* 211424 */     GIR_EraseRootFromParent_Done,
     /* 211425 */   // Label 4167: @211425
     /* 211425 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211472), // Rule ID 11753 //
     /* 211430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211451 */     // MIs[0] Op3
     /* 211451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 211462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211470 */     GIR_RootConstrainSelectedInstOperands,
     /* 211471 */     // GIR_Coverage, 11753,
     /* 211471 */     GIR_EraseRootFromParent_Done,
     /* 211472 */   // Label 4168: @211472
     /* 211472 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211519), // Rule ID 11754 //
     /* 211477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211498 */     // MIs[0] Op3
     /* 211498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1719:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 211509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211517 */     GIR_RootConstrainSelectedInstOperands,
     /* 211518 */     // GIR_Coverage, 11754,
     /* 211518 */     GIR_EraseRootFromParent_Done,
     /* 211519 */   // Label 4169: @211519
     /* 211519 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211566), // Rule ID 11755 //
     /* 211524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211545 */     // MIs[0] Op3
     /* 211545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211553 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 211556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211564 */     GIR_RootConstrainSelectedInstOperands,
     /* 211565 */     // GIR_Coverage, 11755,
     /* 211565 */     GIR_EraseRootFromParent_Done,
     /* 211566 */   // Label 4170: @211566
     /* 211566 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211613), // Rule ID 11756 //
     /* 211571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211592 */     // MIs[0] Op3
     /* 211592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 211603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211611 */     GIR_RootConstrainSelectedInstOperands,
     /* 211612 */     // GIR_Coverage, 11756,
     /* 211612 */     GIR_EraseRootFromParent_Done,
     /* 211613 */   // Label 4171: @211613
     /* 211613 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211660), // Rule ID 11757 //
     /* 211618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211639 */     // MIs[0] Op3
     /* 211639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1677:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 211650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211658 */     GIR_RootConstrainSelectedInstOperands,
     /* 211659 */     // GIR_Coverage, 11757,
     /* 211659 */     GIR_EraseRootFromParent_Done,
     /* 211660 */   // Label 4172: @211660
     /* 211660 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211707), // Rule ID 11758 //
     /* 211665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211686 */     // MIs[0] Op3
     /* 211686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1677:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 211697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211705 */     GIR_RootConstrainSelectedInstOperands,
     /* 211706 */     // GIR_Coverage, 11758,
     /* 211706 */     GIR_EraseRootFromParent_Done,
     /* 211707 */   // Label 4173: @211707
     /* 211707 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211754), // Rule ID 11759 //
     /* 211712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211733 */     // MIs[0] Op3
     /* 211733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1677:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 211744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211752 */     GIR_RootConstrainSelectedInstOperands,
     /* 211753 */     // GIR_Coverage, 11759,
     /* 211753 */     GIR_EraseRootFromParent_Done,
     /* 211754 */   // Label 4174: @211754
     /* 211754 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211801), // Rule ID 11760 //
     /* 211759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211780 */     // MIs[0] Op3
     /* 211780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211788 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 211791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211799 */     GIR_RootConstrainSelectedInstOperands,
     /* 211800 */     // GIR_Coverage, 11760,
     /* 211800 */     GIR_EraseRootFromParent_Done,
     /* 211801 */   // Label 4175: @211801
     /* 211801 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211848), // Rule ID 11761 //
     /* 211806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211827 */     // MIs[0] Op3
     /* 211827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 211838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211846 */     GIR_RootConstrainSelectedInstOperands,
     /* 211847 */     // GIR_Coverage, 11761,
     /* 211847 */     GIR_EraseRootFromParent_Done,
     /* 211848 */   // Label 4176: @211848
     /* 211848 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211895), // Rule ID 11762 //
     /* 211853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211874 */     // MIs[0] Op3
     /* 211874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 211885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211893 */     GIR_RootConstrainSelectedInstOperands,
     /* 211894 */     // GIR_Coverage, 11762,
     /* 211894 */     GIR_EraseRootFromParent_Done,
     /* 211895 */   // Label 4177: @211895
     /* 211895 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211942), // Rule ID 11763 //
     /* 211900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211921 */     // MIs[0] Op3
     /* 211921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211929 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 211932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211940 */     GIR_RootConstrainSelectedInstOperands,
     /* 211941 */     // GIR_Coverage, 11763,
     /* 211941 */     GIR_EraseRootFromParent_Done,
     /* 211942 */   // Label 4178: @211942
     /* 211942 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211989), // Rule ID 11764 //
     /* 211947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211968 */     // MIs[0] Op3
     /* 211968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 211979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211987 */     GIR_RootConstrainSelectedInstOperands,
     /* 211988 */     // GIR_Coverage, 11764,
     /* 211988 */     GIR_EraseRootFromParent_Done,
     /* 211989 */   // Label 4179: @211989
     /* 211989 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(212036), // Rule ID 11765 //
     /* 211994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 212002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212015 */     // MIs[0] Op3
     /* 212015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 212026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212034 */     GIR_RootConstrainSelectedInstOperands,
     /* 212035 */     // GIR_Coverage, 11765,
     /* 212035 */     GIR_EraseRootFromParent_Done,
     /* 212036 */   // Label 4180: @212036
     /* 212036 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(212083), // Rule ID 11766 //
     /* 212041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212062 */     // MIs[0] Op3
     /* 212062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212070 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 212073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212081 */     GIR_RootConstrainSelectedInstOperands,
     /* 212082 */     // GIR_Coverage, 11766,
     /* 212082 */     GIR_EraseRootFromParent_Done,
     /* 212083 */   // Label 4181: @212083
     /* 212083 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(212130), // Rule ID 11767 //
     /* 212088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212109 */     // MIs[0] Op3
     /* 212109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 212120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212128 */     GIR_RootConstrainSelectedInstOperands,
     /* 212129 */     // GIR_Coverage, 11767,
     /* 212129 */     GIR_EraseRootFromParent_Done,
     /* 212130 */   // Label 4182: @212130
     /* 212130 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(212177), // Rule ID 11768 //
     /* 212135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212156 */     // MIs[0] Op3
     /* 212156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 212167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212175 */     GIR_RootConstrainSelectedInstOperands,
     /* 212176 */     // GIR_Coverage, 11768,
     /* 212176 */     GIR_EraseRootFromParent_Done,
     /* 212177 */   // Label 4183: @212177
     /* 212177 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(212224), // Rule ID 11769 //
     /* 212182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212203 */     // MIs[0] Op3
     /* 212203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212211 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2036:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 212214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212222 */     GIR_RootConstrainSelectedInstOperands,
     /* 212223 */     // GIR_Coverage, 11769,
     /* 212223 */     GIR_EraseRootFromParent_Done,
     /* 212224 */   // Label 4184: @212224
     /* 212224 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212271), // Rule ID 11770 //
     /* 212229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212250 */     // MIs[0] Op3
     /* 212250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212258 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2036:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 212261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212269 */     GIR_RootConstrainSelectedInstOperands,
     /* 212270 */     // GIR_Coverage, 11770,
     /* 212270 */     GIR_EraseRootFromParent_Done,
     /* 212271 */   // Label 4185: @212271
     /* 212271 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212318), // Rule ID 11771 //
     /* 212276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212297 */     // MIs[0] Op3
     /* 212297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212305 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2036:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 212308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212316 */     GIR_RootConstrainSelectedInstOperands,
     /* 212317 */     // GIR_Coverage, 11771,
     /* 212317 */     GIR_EraseRootFromParent_Done,
     /* 212318 */   // Label 4186: @212318
     /* 212318 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212385), // Rule ID 2604 //
     /* 212323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 212331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 212374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212383 */     GIR_RootConstrainSelectedInstOperands,
     /* 212384 */     // GIR_Coverage, 2604,
     /* 212384 */     GIR_EraseRootFromParent_Done,
     /* 212385 */   // Label 4187: @212385
     /* 212385 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212452), // Rule ID 7682 //
     /* 212390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212424 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 212441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212450 */     GIR_RootConstrainSelectedInstOperands,
     /* 212451 */     // GIR_Coverage, 7682,
     /* 212451 */     GIR_EraseRootFromParent_Done,
     /* 212452 */   // Label 4188: @212452
     /* 212452 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212519), // Rule ID 7684 //
     /* 212457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 212508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212517 */     GIR_RootConstrainSelectedInstOperands,
     /* 212518 */     // GIR_Coverage, 7684,
     /* 212518 */     GIR_EraseRootFromParent_Done,
     /* 212519 */   // Label 4189: @212519
     /* 212519 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212586), // Rule ID 7686 //
     /* 212524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212558 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 212575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212584 */     GIR_RootConstrainSelectedInstOperands,
     /* 212585 */     // GIR_Coverage, 7686,
     /* 212585 */     GIR_EraseRootFromParent_Done,
     /* 212586 */   // Label 4190: @212586
     /* 212586 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212653), // Rule ID 7688 //
     /* 212591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212625 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 212642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212651 */     GIR_RootConstrainSelectedInstOperands,
     /* 212652 */     // GIR_Coverage, 7688,
     /* 212652 */     GIR_EraseRootFromParent_Done,
     /* 212653 */   // Label 4191: @212653
     /* 212653 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212720), // Rule ID 7718 //
     /* 212658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 212709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212718 */     GIR_RootConstrainSelectedInstOperands,
     /* 212719 */     // GIR_Coverage, 7718,
     /* 212719 */     GIR_EraseRootFromParent_Done,
     /* 212720 */   // Label 4192: @212720
     /* 212720 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212787), // Rule ID 7720 //
     /* 212725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212759 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 212776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212785 */     GIR_RootConstrainSelectedInstOperands,
     /* 212786 */     // GIR_Coverage, 7720,
     /* 212786 */     GIR_EraseRootFromParent_Done,
     /* 212787 */   // Label 4193: @212787
     /* 212787 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212854), // Rule ID 7722 //
     /* 212792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 212843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212852 */     GIR_RootConstrainSelectedInstOperands,
     /* 212853 */     // GIR_Coverage, 7722,
     /* 212853 */     GIR_EraseRootFromParent_Done,
     /* 212854 */   // Label 4194: @212854
     /* 212854 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212921), // Rule ID 7724 //
     /* 212859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 212910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212919 */     GIR_RootConstrainSelectedInstOperands,
     /* 212920 */     // GIR_Coverage, 7724,
     /* 212920 */     GIR_EraseRootFromParent_Done,
     /* 212921 */   // Label 4195: @212921
     /* 212921 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212988), // Rule ID 7730 //
     /* 212926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 212977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212986 */     GIR_RootConstrainSelectedInstOperands,
     /* 212987 */     // GIR_Coverage, 7730,
     /* 212987 */     GIR_EraseRootFromParent_Done,
     /* 212988 */   // Label 4196: @212988
     /* 212988 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(213055), // Rule ID 7732 //
     /* 212993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 213044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213053 */     GIR_RootConstrainSelectedInstOperands,
     /* 213054 */     // GIR_Coverage, 7732,
     /* 213054 */     GIR_EraseRootFromParent_Done,
     /* 213055 */   // Label 4197: @213055
     /* 213055 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(213122), // Rule ID 7734 //
     /* 213060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 213111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213120 */     GIR_RootConstrainSelectedInstOperands,
     /* 213121 */     // GIR_Coverage, 7734,
     /* 213121 */     GIR_EraseRootFromParent_Done,
     /* 213122 */   // Label 4198: @213122
     /* 213122 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(213189), // Rule ID 7736 //
     /* 213127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 213178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213187 */     GIR_RootConstrainSelectedInstOperands,
     /* 213188 */     // GIR_Coverage, 7736,
     /* 213188 */     GIR_EraseRootFromParent_Done,
     /* 213189 */   // Label 4199: @213189
     /* 213189 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(213256), // Rule ID 11464 //
     /* 213194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 213202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 213245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213254 */     GIR_RootConstrainSelectedInstOperands,
     /* 213255 */     // GIR_Coverage, 11464,
     /* 213255 */     GIR_EraseRootFromParent_Done,
     /* 213256 */   // Label 4200: @213256
     /* 213256 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(213323), // Rule ID 11466 //
     /* 213261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 213312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213321 */     GIR_RootConstrainSelectedInstOperands,
     /* 213322 */     // GIR_Coverage, 11466,
     /* 213322 */     GIR_EraseRootFromParent_Done,
     /* 213323 */   // Label 4201: @213323
     /* 213323 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(213390), // Rule ID 11468 //
     /* 213328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 213379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213388 */     GIR_RootConstrainSelectedInstOperands,
     /* 213389 */     // GIR_Coverage, 11468,
     /* 213389 */     GIR_EraseRootFromParent_Done,
     /* 213390 */   // Label 4202: @213390
     /* 213390 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(213457), // Rule ID 11470 //
     /* 213395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 213446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213455 */     GIR_RootConstrainSelectedInstOperands,
     /* 213456 */     // GIR_Coverage, 11470,
     /* 213456 */     GIR_EraseRootFromParent_Done,
     /* 213457 */   // Label 4203: @213457
     /* 213457 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(213524), // Rule ID 11472 //
     /* 213462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 213513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213522 */     GIR_RootConstrainSelectedInstOperands,
     /* 213523 */     // GIR_Coverage, 11472,
     /* 213523 */     GIR_EraseRootFromParent_Done,
     /* 213524 */   // Label 4204: @213524
     /* 213524 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213591), // Rule ID 11478 //
     /* 213529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213563 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 213580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213589 */     GIR_RootConstrainSelectedInstOperands,
     /* 213590 */     // GIR_Coverage, 11478,
     /* 213590 */     GIR_EraseRootFromParent_Done,
     /* 213591 */   // Label 4205: @213591
     /* 213591 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213658), // Rule ID 11480 //
     /* 213596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 213647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213656 */     GIR_RootConstrainSelectedInstOperands,
     /* 213657 */     // GIR_Coverage, 11480,
     /* 213657 */     GIR_EraseRootFromParent_Done,
     /* 213658 */   // Label 4206: @213658
     /* 213658 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213725), // Rule ID 11482 //
     /* 213663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 213714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213723 */     GIR_RootConstrainSelectedInstOperands,
     /* 213724 */     // GIR_Coverage, 11482,
     /* 213724 */     GIR_EraseRootFromParent_Done,
     /* 213725 */   // Label 4207: @213725
     /* 213725 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213792), // Rule ID 11484 //
     /* 213730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 213781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213790 */     GIR_RootConstrainSelectedInstOperands,
     /* 213791 */     // GIR_Coverage, 11484,
     /* 213791 */     GIR_EraseRootFromParent_Done,
     /* 213792 */   // Label 4208: @213792
     /* 213792 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213846), // Rule ID 30 //
     /* 213797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 213805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213833 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 213836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213844 */     GIR_RootConstrainSelectedInstOperands,
     /* 213845 */     // GIR_Coverage, 30,
     /* 213845 */     GIR_EraseRootFromParent_Done,
     /* 213846 */   // Label 4209: @213846
     /* 213846 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213900), // Rule ID 31 //
     /* 213851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 213859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 213890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213898 */     GIR_RootConstrainSelectedInstOperands,
     /* 213899 */     // GIR_Coverage, 31,
     /* 213899 */     GIR_EraseRootFromParent_Done,
     /* 213900 */   // Label 4210: @213900
     /* 213900 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213954), // Rule ID 32 //
     /* 213905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 213913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213941 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 213944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213952 */     GIR_RootConstrainSelectedInstOperands,
     /* 213953 */     // GIR_Coverage, 32,
     /* 213953 */     GIR_EraseRootFromParent_Done,
     /* 213954 */   // Label 4211: @213954
     /* 213954 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(214008), // Rule ID 39 //
     /* 213959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 213967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213995 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 213995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 213998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214006 */     GIR_RootConstrainSelectedInstOperands,
     /* 214007 */     // GIR_Coverage, 39,
     /* 214007 */     GIR_EraseRootFromParent_Done,
     /* 214008 */   // Label 4212: @214008
     /* 214008 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(214062), // Rule ID 40 //
     /* 214013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 214021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214049 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 214052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214060 */     GIR_RootConstrainSelectedInstOperands,
     /* 214061 */     // GIR_Coverage, 40,
     /* 214061 */     GIR_EraseRootFromParent_Done,
     /* 214062 */   // Label 4213: @214062
     /* 214062 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(214116), // Rule ID 41 //
     /* 214067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214103 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 214106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214114 */     GIR_RootConstrainSelectedInstOperands,
     /* 214115 */     // GIR_Coverage, 41,
     /* 214115 */     GIR_EraseRootFromParent_Done,
     /* 214116 */   // Label 4214: @214116
     /* 214116 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(214170), // Rule ID 42 //
     /* 214121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214157 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 214160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214168 */     GIR_RootConstrainSelectedInstOperands,
     /* 214169 */     // GIR_Coverage, 42,
     /* 214169 */     GIR_EraseRootFromParent_Done,
     /* 214170 */   // Label 4215: @214170
     /* 214170 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(214224), // Rule ID 43 //
     /* 214175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 214183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214211 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 214214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214222 */     GIR_RootConstrainSelectedInstOperands,
     /* 214223 */     // GIR_Coverage, 43,
     /* 214223 */     GIR_EraseRootFromParent_Done,
     /* 214224 */   // Label 4216: @214224
     /* 214224 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(214278), // Rule ID 44 //
     /* 214229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 214237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214265 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 214268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214276 */     GIR_RootConstrainSelectedInstOperands,
     /* 214277 */     // GIR_Coverage, 44,
     /* 214277 */     GIR_EraseRootFromParent_Done,
     /* 214278 */   // Label 4217: @214278
     /* 214278 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(214332), // Rule ID 45 //
     /* 214283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 214291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214319 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 214322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214330 */     GIR_RootConstrainSelectedInstOperands,
     /* 214331 */     // GIR_Coverage, 45,
     /* 214331 */     GIR_EraseRootFromParent_Done,
     /* 214332 */   // Label 4218: @214332
     /* 214332 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(214386), // Rule ID 46 //
     /* 214337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 214345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214373 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 214376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214384 */     GIR_RootConstrainSelectedInstOperands,
     /* 214385 */     // GIR_Coverage, 46,
     /* 214385 */     GIR_EraseRootFromParent_Done,
     /* 214386 */   // Label 4219: @214386
     /* 214386 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(214440), // Rule ID 1587 //
     /* 214391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214427 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 214427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 214430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214438 */     GIR_RootConstrainSelectedInstOperands,
     /* 214439 */     // GIR_Coverage, 1587,
     /* 214439 */     GIR_EraseRootFromParent_Done,
     /* 214440 */   // Label 4220: @214440
     /* 214440 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(214494), // Rule ID 1588 //
     /* 214445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214481 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 214481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 214484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214492 */     GIR_RootConstrainSelectedInstOperands,
     /* 214493 */     // GIR_Coverage, 1588,
     /* 214493 */     GIR_EraseRootFromParent_Done,
     /* 214494 */   // Label 4221: @214494
     /* 214494 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(214548), // Rule ID 1589 //
     /* 214499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214535 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 214535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 214538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214546 */     GIR_RootConstrainSelectedInstOperands,
     /* 214547 */     // GIR_Coverage, 1589,
     /* 214547 */     GIR_EraseRootFromParent_Done,
     /* 214548 */   // Label 4222: @214548
     /* 214548 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(214602), // Rule ID 1590 //
     /* 214553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214589 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 214592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214600 */     GIR_RootConstrainSelectedInstOperands,
     /* 214601 */     // GIR_Coverage, 1590,
     /* 214601 */     GIR_EraseRootFromParent_Done,
     /* 214602 */   // Label 4223: @214602
     /* 214602 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(214656), // Rule ID 1591 //
     /* 214607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214643 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 214643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 214646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214654 */     GIR_RootConstrainSelectedInstOperands,
     /* 214655 */     // GIR_Coverage, 1591,
     /* 214655 */     GIR_EraseRootFromParent_Done,
     /* 214656 */   // Label 4224: @214656
     /* 214656 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(214710), // Rule ID 1592 //
     /* 214661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214697 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 214697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 214700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214708 */     GIR_RootConstrainSelectedInstOperands,
     /* 214709 */     // GIR_Coverage, 1592,
     /* 214709 */     GIR_EraseRootFromParent_Done,
     /* 214710 */   // Label 4225: @214710
     /* 214710 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214764), // Rule ID 1593 //
     /* 214715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214751 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 214751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 214754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214762 */     GIR_RootConstrainSelectedInstOperands,
     /* 214763 */     // GIR_Coverage, 1593,
     /* 214763 */     GIR_EraseRootFromParent_Done,
     /* 214764 */   // Label 4226: @214764
     /* 214764 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214818), // Rule ID 1594 //
     /* 214769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214805 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 214808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214816 */     GIR_RootConstrainSelectedInstOperands,
     /* 214817 */     // GIR_Coverage, 1594,
     /* 214817 */     GIR_EraseRootFromParent_Done,
     /* 214818 */   // Label 4227: @214818
     /* 214818 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214872), // Rule ID 2307 //
     /* 214823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 214831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214859 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 214862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214870 */     GIR_RootConstrainSelectedInstOperands,
     /* 214871 */     // GIR_Coverage, 2307,
     /* 214871 */     GIR_EraseRootFromParent_Done,
     /* 214872 */   // Label 4228: @214872
     /* 214872 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214926), // Rule ID 2308 //
     /* 214877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 214885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214913 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 214916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214924 */     GIR_RootConstrainSelectedInstOperands,
     /* 214925 */     // GIR_Coverage, 2308,
     /* 214925 */     GIR_EraseRootFromParent_Done,
     /* 214926 */   // Label 4229: @214926
     /* 214926 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214980), // Rule ID 2309 //
     /* 214931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 214939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214967 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 214970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214978 */     GIR_RootConstrainSelectedInstOperands,
     /* 214979 */     // GIR_Coverage, 2309,
     /* 214979 */     GIR_EraseRootFromParent_Done,
     /* 214980 */   // Label 4230: @214980
     /* 214980 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(215034), // Rule ID 2310 //
     /* 214985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 214993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215021 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 215024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215032 */     GIR_RootConstrainSelectedInstOperands,
     /* 215033 */     // GIR_Coverage, 2310,
     /* 215033 */     GIR_EraseRootFromParent_Done,
     /* 215034 */   // Label 4231: @215034
     /* 215034 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(215088), // Rule ID 2311 //
     /* 215039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 215047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215075 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 215078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215086 */     GIR_RootConstrainSelectedInstOperands,
     /* 215087 */     // GIR_Coverage, 2311,
     /* 215087 */     GIR_EraseRootFromParent_Done,
     /* 215088 */   // Label 4232: @215088
     /* 215088 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(215142), // Rule ID 2312 //
     /* 215093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 215101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215129 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 215132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215140 */     GIR_RootConstrainSelectedInstOperands,
     /* 215141 */     // GIR_Coverage, 2312,
     /* 215141 */     GIR_EraseRootFromParent_Done,
     /* 215142 */   // Label 4233: @215142
     /* 215142 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(215196), // Rule ID 2313 //
     /* 215147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 215155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215183 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 215186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215194 */     GIR_RootConstrainSelectedInstOperands,
     /* 215195 */     // GIR_Coverage, 2313,
     /* 215195 */     GIR_EraseRootFromParent_Done,
     /* 215196 */   // Label 4234: @215196
     /* 215196 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(215253), // Rule ID 3640 //
     /* 215201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215237 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 215240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215246 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215251 */     GIR_RootConstrainSelectedInstOperands,
     /* 215252 */     // GIR_Coverage, 3640,
     /* 215252 */     GIR_EraseRootFromParent_Done,
     /* 215253 */   // Label 4235: @215253
     /* 215253 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(215310), // Rule ID 3641 //
     /* 215258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215294 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 215297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215303 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215308 */     GIR_RootConstrainSelectedInstOperands,
     /* 215309 */     // GIR_Coverage, 3641,
     /* 215309 */     GIR_EraseRootFromParent_Done,
     /* 215310 */   // Label 4236: @215310
     /* 215310 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(215367), // Rule ID 3642 //
     /* 215315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215351 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 215354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215360 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215365 */     GIR_RootConstrainSelectedInstOperands,
     /* 215366 */     // GIR_Coverage, 3642,
     /* 215366 */     GIR_EraseRootFromParent_Done,
     /* 215367 */   // Label 4237: @215367
     /* 215367 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(215424), // Rule ID 3643 //
     /* 215372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 215411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215417 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215422 */     GIR_RootConstrainSelectedInstOperands,
     /* 215423 */     // GIR_Coverage, 3643,
     /* 215423 */     GIR_EraseRootFromParent_Done,
     /* 215424 */   // Label 4238: @215424
     /* 215424 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(215478), // Rule ID 3816 //
     /* 215429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 215437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215465 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 215468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215476 */     GIR_RootConstrainSelectedInstOperands,
     /* 215477 */     // GIR_Coverage, 3816,
     /* 215477 */     GIR_EraseRootFromParent_Done,
     /* 215478 */   // Label 4239: @215478
     /* 215478 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(215532), // Rule ID 3817 //
     /* 215483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 215491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215519 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 215522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215530 */     GIR_RootConstrainSelectedInstOperands,
     /* 215531 */     // GIR_Coverage, 3817,
     /* 215531 */     GIR_EraseRootFromParent_Done,
     /* 215532 */   // Label 4240: @215532
     /* 215532 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(215586), // Rule ID 3818 //
     /* 215537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 215545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215573 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 215576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215584 */     GIR_RootConstrainSelectedInstOperands,
     /* 215585 */     // GIR_Coverage, 3818,
     /* 215585 */     GIR_EraseRootFromParent_Done,
     /* 215586 */   // Label 4241: @215586
     /* 215586 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(215640), // Rule ID 3819 //
     /* 215591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215627 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215638 */     GIR_RootConstrainSelectedInstOperands,
     /* 215639 */     // GIR_Coverage, 3819,
     /* 215639 */     GIR_EraseRootFromParent_Done,
     /* 215640 */   // Label 4242: @215640
     /* 215640 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(215694), // Rule ID 3820 //
     /* 215645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215681 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215692 */     GIR_RootConstrainSelectedInstOperands,
     /* 215693 */     // GIR_Coverage, 3820,
     /* 215693 */     GIR_EraseRootFromParent_Done,
     /* 215694 */   // Label 4243: @215694
     /* 215694 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(215748), // Rule ID 3821 //
     /* 215699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215735 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215746 */     GIR_RootConstrainSelectedInstOperands,
     /* 215747 */     // GIR_Coverage, 3821,
     /* 215747 */     GIR_EraseRootFromParent_Done,
     /* 215748 */   // Label 4244: @215748
     /* 215748 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(215802), // Rule ID 3822 //
     /* 215753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215789 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215800 */     GIR_RootConstrainSelectedInstOperands,
     /* 215801 */     // GIR_Coverage, 3822,
     /* 215801 */     GIR_EraseRootFromParent_Done,
     /* 215802 */   // Label 4245: @215802
     /* 215802 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(215856), // Rule ID 3831 //
     /* 215807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215843 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215854 */     GIR_RootConstrainSelectedInstOperands,
     /* 215855 */     // GIR_Coverage, 3831,
     /* 215855 */     GIR_EraseRootFromParent_Done,
     /* 215856 */   // Label 4246: @215856
     /* 215856 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(215910), // Rule ID 3832 //
     /* 215861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215897 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215908 */     GIR_RootConstrainSelectedInstOperands,
     /* 215909 */     // GIR_Coverage, 3832,
     /* 215909 */     GIR_EraseRootFromParent_Done,
     /* 215910 */   // Label 4247: @215910
     /* 215910 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(215964), // Rule ID 3833 //
     /* 215915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215951 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215962 */     GIR_RootConstrainSelectedInstOperands,
     /* 215963 */     // GIR_Coverage, 3833,
     /* 215963 */     GIR_EraseRootFromParent_Done,
     /* 215964 */   // Label 4248: @215964
     /* 215964 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(216018), // Rule ID 3834 //
     /* 215969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216005 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216016 */     GIR_RootConstrainSelectedInstOperands,
     /* 216017 */     // GIR_Coverage, 3834,
     /* 216017 */     GIR_EraseRootFromParent_Done,
     /* 216018 */   // Label 4249: @216018
     /* 216018 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(216072), // Rule ID 3835 //
     /* 216023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216059 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216070 */     GIR_RootConstrainSelectedInstOperands,
     /* 216071 */     // GIR_Coverage, 3835,
     /* 216071 */     GIR_EraseRootFromParent_Done,
     /* 216072 */   // Label 4250: @216072
     /* 216072 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(216126), // Rule ID 3836 //
     /* 216077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216113 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216124 */     GIR_RootConstrainSelectedInstOperands,
     /* 216125 */     // GIR_Coverage, 3836,
     /* 216125 */     GIR_EraseRootFromParent_Done,
     /* 216126 */   // Label 4251: @216126
     /* 216126 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(216180), // Rule ID 3837 //
     /* 216131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216167 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216178 */     GIR_RootConstrainSelectedInstOperands,
     /* 216179 */     // GIR_Coverage, 3837,
     /* 216179 */     GIR_EraseRootFromParent_Done,
     /* 216180 */   // Label 4252: @216180
     /* 216180 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(216234), // Rule ID 3838 //
     /* 216185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216221 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216232 */     GIR_RootConstrainSelectedInstOperands,
     /* 216233 */     // GIR_Coverage, 3838,
     /* 216233 */     GIR_EraseRootFromParent_Done,
     /* 216234 */   // Label 4253: @216234
     /* 216234 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(216288), // Rule ID 3839 //
     /* 216239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216275 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216286 */     GIR_RootConstrainSelectedInstOperands,
     /* 216287 */     // GIR_Coverage, 3839,
     /* 216287 */     GIR_EraseRootFromParent_Done,
     /* 216288 */   // Label 4254: @216288
     /* 216288 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(216342), // Rule ID 3840 //
     /* 216293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216329 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216340 */     GIR_RootConstrainSelectedInstOperands,
     /* 216341 */     // GIR_Coverage, 3840,
     /* 216341 */     GIR_EraseRootFromParent_Done,
     /* 216342 */   // Label 4255: @216342
     /* 216342 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(216396), // Rule ID 3841 //
     /* 216347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216383 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216394 */     GIR_RootConstrainSelectedInstOperands,
     /* 216395 */     // GIR_Coverage, 3841,
     /* 216395 */     GIR_EraseRootFromParent_Done,
     /* 216396 */   // Label 4256: @216396
     /* 216396 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(216450), // Rule ID 3842 //
     /* 216401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216437 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216448 */     GIR_RootConstrainSelectedInstOperands,
     /* 216449 */     // GIR_Coverage, 3842,
     /* 216449 */     GIR_EraseRootFromParent_Done,
     /* 216450 */   // Label 4257: @216450
     /* 216450 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(216504), // Rule ID 3846 //
     /* 216455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 216463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216491 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 216491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 216494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 216498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 216500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 216502 */     GIR_RootConstrainSelectedInstOperands,
     /* 216503 */     // GIR_Coverage, 3846,
     /* 216503 */     GIR_EraseRootFromParent_Done,
     /* 216504 */   // Label 4258: @216504
     /* 216504 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(216558), // Rule ID 3847 //
     /* 216509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 216517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216545 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 216548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216556 */     GIR_RootConstrainSelectedInstOperands,
     /* 216557 */     // GIR_Coverage, 3847,
     /* 216557 */     GIR_EraseRootFromParent_Done,
     /* 216558 */   // Label 4259: @216558
     /* 216558 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(216612), // Rule ID 3848 //
     /* 216563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 216571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216599 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 216602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216610 */     GIR_RootConstrainSelectedInstOperands,
     /* 216611 */     // GIR_Coverage, 3848,
     /* 216611 */     GIR_EraseRootFromParent_Done,
     /* 216612 */   // Label 4260: @216612
     /* 216612 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(216669), // Rule ID 3865 //
     /* 216617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216653 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 216653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216667 */     GIR_RootConstrainSelectedInstOperands,
     /* 216668 */     // GIR_Coverage, 3865,
     /* 216668 */     GIR_EraseRootFromParent_Done,
     /* 216669 */   // Label 4261: @216669
     /* 216669 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(216726), // Rule ID 3866 //
     /* 216674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216710 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 216710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216724 */     GIR_RootConstrainSelectedInstOperands,
     /* 216725 */     // GIR_Coverage, 3866,
     /* 216725 */     GIR_EraseRootFromParent_Done,
     /* 216726 */   // Label 4262: @216726
     /* 216726 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(216783), // Rule ID 3867 //
     /* 216731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216767 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 216767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216781 */     GIR_RootConstrainSelectedInstOperands,
     /* 216782 */     // GIR_Coverage, 3867,
     /* 216782 */     GIR_EraseRootFromParent_Done,
     /* 216783 */   // Label 4263: @216783
     /* 216783 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(216840), // Rule ID 3868 //
     /* 216788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216824 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 216824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216838 */     GIR_RootConstrainSelectedInstOperands,
     /* 216839 */     // GIR_Coverage, 3868,
     /* 216839 */     GIR_EraseRootFromParent_Done,
     /* 216840 */   // Label 4264: @216840
     /* 216840 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(216897), // Rule ID 3873 //
     /* 216845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216881 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 216881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216895 */     GIR_RootConstrainSelectedInstOperands,
     /* 216896 */     // GIR_Coverage, 3873,
     /* 216896 */     GIR_EraseRootFromParent_Done,
     /* 216897 */   // Label 4265: @216897
     /* 216897 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(216954), // Rule ID 3874 //
     /* 216902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216938 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 216938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216952 */     GIR_RootConstrainSelectedInstOperands,
     /* 216953 */     // GIR_Coverage, 3874,
     /* 216953 */     GIR_EraseRootFromParent_Done,
     /* 216954 */   // Label 4266: @216954
     /* 216954 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(217011), // Rule ID 3875 //
     /* 216959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216995 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 216995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217009 */     GIR_RootConstrainSelectedInstOperands,
     /* 217010 */     // GIR_Coverage, 3875,
     /* 217010 */     GIR_EraseRootFromParent_Done,
     /* 217011 */   // Label 4267: @217011
     /* 217011 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(217068), // Rule ID 3876 //
     /* 217016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217052 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 217052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217066 */     GIR_RootConstrainSelectedInstOperands,
     /* 217067 */     // GIR_Coverage, 3876,
     /* 217067 */     GIR_EraseRootFromParent_Done,
     /* 217068 */   // Label 4268: @217068
     /* 217068 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(217125), // Rule ID 3881 //
     /* 217073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217109 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 217109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217123 */     GIR_RootConstrainSelectedInstOperands,
     /* 217124 */     // GIR_Coverage, 3881,
     /* 217124 */     GIR_EraseRootFromParent_Done,
     /* 217125 */   // Label 4269: @217125
     /* 217125 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(217182), // Rule ID 3882 //
     /* 217130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217166 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 217166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217180 */     GIR_RootConstrainSelectedInstOperands,
     /* 217181 */     // GIR_Coverage, 3882,
     /* 217181 */     GIR_EraseRootFromParent_Done,
     /* 217182 */   // Label 4270: @217182
     /* 217182 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(217239), // Rule ID 3883 //
     /* 217187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217223 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 217223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217237 */     GIR_RootConstrainSelectedInstOperands,
     /* 217238 */     // GIR_Coverage, 3883,
     /* 217238 */     GIR_EraseRootFromParent_Done,
     /* 217239 */   // Label 4271: @217239
     /* 217239 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(217296), // Rule ID 3884 //
     /* 217244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217280 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 217280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217294 */     GIR_RootConstrainSelectedInstOperands,
     /* 217295 */     // GIR_Coverage, 3884,
     /* 217295 */     GIR_EraseRootFromParent_Done,
     /* 217296 */   // Label 4272: @217296
     /* 217296 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(217353), // Rule ID 3885 //
     /* 217301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217337 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 217337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217351 */     GIR_RootConstrainSelectedInstOperands,
     /* 217352 */     // GIR_Coverage, 3885,
     /* 217352 */     GIR_EraseRootFromParent_Done,
     /* 217353 */   // Label 4273: @217353
     /* 217353 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(217410), // Rule ID 3886 //
     /* 217358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217394 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 217394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217408 */     GIR_RootConstrainSelectedInstOperands,
     /* 217409 */     // GIR_Coverage, 3886,
     /* 217409 */     GIR_EraseRootFromParent_Done,
     /* 217410 */   // Label 4274: @217410
     /* 217410 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(217467), // Rule ID 3887 //
     /* 217415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217451 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 217451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217465 */     GIR_RootConstrainSelectedInstOperands,
     /* 217466 */     // GIR_Coverage, 3887,
     /* 217466 */     GIR_EraseRootFromParent_Done,
     /* 217467 */   // Label 4275: @217467
     /* 217467 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(217524), // Rule ID 3888 //
     /* 217472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217508 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 217508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217522 */     GIR_RootConstrainSelectedInstOperands,
     /* 217523 */     // GIR_Coverage, 3888,
     /* 217523 */     GIR_EraseRootFromParent_Done,
     /* 217524 */   // Label 4276: @217524
     /* 217524 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(217581), // Rule ID 3889 //
     /* 217529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217565 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 217565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217579 */     GIR_RootConstrainSelectedInstOperands,
     /* 217580 */     // GIR_Coverage, 3889,
     /* 217580 */     GIR_EraseRootFromParent_Done,
     /* 217581 */   // Label 4277: @217581
     /* 217581 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(217638), // Rule ID 3890 //
     /* 217586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217622 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 217622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217636 */     GIR_RootConstrainSelectedInstOperands,
     /* 217637 */     // GIR_Coverage, 3890,
     /* 217637 */     GIR_EraseRootFromParent_Done,
     /* 217638 */   // Label 4278: @217638
     /* 217638 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(217695), // Rule ID 3891 //
     /* 217643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217679 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 217679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217693 */     GIR_RootConstrainSelectedInstOperands,
     /* 217694 */     // GIR_Coverage, 3891,
     /* 217694 */     GIR_EraseRootFromParent_Done,
     /* 217695 */   // Label 4279: @217695
     /* 217695 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(217752), // Rule ID 3892 //
     /* 217700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217736 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 217736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217750 */     GIR_RootConstrainSelectedInstOperands,
     /* 217751 */     // GIR_Coverage, 3892,
     /* 217751 */     GIR_EraseRootFromParent_Done,
     /* 217752 */   // Label 4280: @217752
     /* 217752 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(217806), // Rule ID 5232 //
     /* 217757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 217760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 217765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217793 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 217793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 217796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217804 */     GIR_RootConstrainSelectedInstOperands,
     /* 217805 */     // GIR_Coverage, 5232,
     /* 217805 */     GIR_EraseRootFromParent_Done,
     /* 217806 */   // Label 4281: @217806
     /* 217806 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(217860), // Rule ID 5233 //
     /* 217811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 217814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217847 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 217847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 217850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217858 */     GIR_RootConstrainSelectedInstOperands,
     /* 217859 */     // GIR_Coverage, 5233,
     /* 217859 */     GIR_EraseRootFromParent_Done,
     /* 217860 */   // Label 4282: @217860
     /* 217860 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(217911), // Rule ID 5586 //
     /* 217865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 217870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 217873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 217876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 217882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217898 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 217898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 217901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 217909 */     GIR_RootConstrainSelectedInstOperands,
     /* 217910 */     // GIR_Coverage, 5586,
     /* 217910 */     GIR_EraseRootFromParent_Done,
     /* 217911 */   // Label 4283: @217911
     /* 217911 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(217962), // Rule ID 5587 //
     /* 217916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 217921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 217924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 217927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 217933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217949 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 217949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 217952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 217958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 217960 */     GIR_RootConstrainSelectedInstOperands,
     /* 217961 */     // GIR_Coverage, 5587,
     /* 217961 */     GIR_EraseRootFromParent_Done,
     /* 217962 */   // Label 4284: @217962
     /* 217962 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(218004), // Rule ID 2699 //
     /* 217967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217991 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 217994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218002 */     GIR_RootConstrainSelectedInstOperands,
     /* 218003 */     // GIR_Coverage, 2699,
     /* 218003 */     GIR_EraseRootFromParent_Done,
     /* 218004 */   // Label 4285: @218004
     /* 218004 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(218046), // Rule ID 2700 //
     /* 218009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218033 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218044 */     GIR_RootConstrainSelectedInstOperands,
     /* 218045 */     // GIR_Coverage, 2700,
     /* 218045 */     GIR_EraseRootFromParent_Done,
     /* 218046 */   // Label 4286: @218046
     /* 218046 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(218088), // Rule ID 2701 //
     /* 218051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218075 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218086 */     GIR_RootConstrainSelectedInstOperands,
     /* 218087 */     // GIR_Coverage, 2701,
     /* 218087 */     GIR_EraseRootFromParent_Done,
     /* 218088 */   // Label 4287: @218088
     /* 218088 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(218130), // Rule ID 2702 //
     /* 218093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218128 */     GIR_RootConstrainSelectedInstOperands,
     /* 218129 */     // GIR_Coverage, 2702,
     /* 218129 */     GIR_EraseRootFromParent_Done,
     /* 218130 */   // Label 4288: @218130
     /* 218130 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(218172), // Rule ID 2703 //
     /* 218135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218159 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1918:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218170 */     GIR_RootConstrainSelectedInstOperands,
     /* 218171 */     // GIR_Coverage, 2703,
     /* 218171 */     GIR_EraseRootFromParent_Done,
     /* 218172 */   // Label 4289: @218172
     /* 218172 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(218214), // Rule ID 2704 //
     /* 218177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218201 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1918:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218212 */     GIR_RootConstrainSelectedInstOperands,
     /* 218213 */     // GIR_Coverage, 2704,
     /* 218213 */     GIR_EraseRootFromParent_Done,
     /* 218214 */   // Label 4290: @218214
     /* 218214 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(218256), // Rule ID 2705 //
     /* 218219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218243 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1918:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218254 */     GIR_RootConstrainSelectedInstOperands,
     /* 218255 */     // GIR_Coverage, 2705,
     /* 218255 */     GIR_EraseRootFromParent_Done,
     /* 218256 */   // Label 4291: @218256
     /* 218256 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(218298), // Rule ID 2744 //
     /* 218261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 218272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 218281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218285 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1264:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 218285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218296 */     GIR_RootConstrainSelectedInstOperands,
     /* 218297 */     // GIR_Coverage, 2744,
     /* 218297 */     GIR_EraseRootFromParent_Done,
     /* 218298 */   // Label 4292: @218298
     /* 218298 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(218340), // Rule ID 2745 //
     /* 218303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 218314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 218320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 218323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218327 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 218327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218338 */     GIR_RootConstrainSelectedInstOperands,
     /* 218339 */     // GIR_Coverage, 2745,
     /* 218339 */     GIR_EraseRootFromParent_Done,
     /* 218340 */   // Label 4293: @218340
     /* 218340 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(218382), // Rule ID 2746 //
     /* 218345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 218356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 218365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218369 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 218369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218380 */     GIR_RootConstrainSelectedInstOperands,
     /* 218381 */     // GIR_Coverage, 2746,
     /* 218381 */     GIR_EraseRootFromParent_Done,
     /* 218382 */   // Label 4294: @218382
     /* 218382 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(218424), // Rule ID 2747 //
     /* 218387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 218398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 218407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218411 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 218411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218422 */     GIR_RootConstrainSelectedInstOperands,
     /* 218423 */     // GIR_Coverage, 2747,
     /* 218423 */     GIR_EraseRootFromParent_Done,
     /* 218424 */   // Label 4295: @218424
     /* 218424 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(218466), // Rule ID 2748 //
     /* 218429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 218440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 218443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 218446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 218449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218453 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1264:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 218453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218464 */     GIR_RootConstrainSelectedInstOperands,
     /* 218465 */     // GIR_Coverage, 2748,
     /* 218465 */     GIR_EraseRootFromParent_Done,
     /* 218466 */   // Label 4296: @218466
     /* 218466 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(218508), // Rule ID 2787 //
     /* 218471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218495 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 218498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218506 */     GIR_RootConstrainSelectedInstOperands,
     /* 218507 */     // GIR_Coverage, 2787,
     /* 218507 */     GIR_EraseRootFromParent_Done,
     /* 218508 */   // Label 4297: @218508
     /* 218508 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(218550), // Rule ID 2789 //
     /* 218513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218537 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 218540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218548 */     GIR_RootConstrainSelectedInstOperands,
     /* 218549 */     // GIR_Coverage, 2789,
     /* 218549 */     GIR_EraseRootFromParent_Done,
     /* 218550 */   // Label 4298: @218550
     /* 218550 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(218592), // Rule ID 2791 //
     /* 218555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218579 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 218582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218590 */     GIR_RootConstrainSelectedInstOperands,
     /* 218591 */     // GIR_Coverage, 2791,
     /* 218591 */     GIR_EraseRootFromParent_Done,
     /* 218592 */   // Label 4299: @218592
     /* 218592 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(218634), // Rule ID 2793 //
     /* 218597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218621 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1537:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 218624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218632 */     GIR_RootConstrainSelectedInstOperands,
     /* 218633 */     // GIR_Coverage, 2793,
     /* 218633 */     GIR_EraseRootFromParent_Done,
     /* 218634 */   // Label 4300: @218634
     /* 218634 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(218676), // Rule ID 2794 //
     /* 218639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218663 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1537:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 218666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218674 */     GIR_RootConstrainSelectedInstOperands,
     /* 218675 */     // GIR_Coverage, 2794,
     /* 218675 */     GIR_EraseRootFromParent_Done,
     /* 218676 */   // Label 4301: @218676
     /* 218676 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(218718), // Rule ID 2795 //
     /* 218681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218705 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1537:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 218708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218716 */     GIR_RootConstrainSelectedInstOperands,
     /* 218717 */     // GIR_Coverage, 2795,
     /* 218717 */     GIR_EraseRootFromParent_Done,
     /* 218718 */   // Label 4302: @218718
     /* 218718 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(218760), // Rule ID 2864 //
     /* 218723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 218731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218747 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 218750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218758 */     GIR_RootConstrainSelectedInstOperands,
     /* 218759 */     // GIR_Coverage, 2864,
     /* 218759 */     GIR_EraseRootFromParent_Done,
     /* 218760 */   // Label 4303: @218760
     /* 218760 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(218802), // Rule ID 2865 //
     /* 218765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 218773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218789 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1400:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 218792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218800 */     GIR_RootConstrainSelectedInstOperands,
     /* 218801 */     // GIR_Coverage, 2865,
     /* 218801 */     GIR_EraseRootFromParent_Done,
     /* 218802 */   // Label 4304: @218802
     /* 218802 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(218844), // Rule ID 2866 //
     /* 218807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 218815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218831 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1395:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 218834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218842 */     GIR_RootConstrainSelectedInstOperands,
     /* 218843 */     // GIR_Coverage, 2866,
     /* 218843 */     GIR_EraseRootFromParent_Done,
     /* 218844 */   // Label 4305: @218844
     /* 218844 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(218886), // Rule ID 2867 //
     /* 218849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 218857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218873 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1396:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 218876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218884 */     GIR_RootConstrainSelectedInstOperands,
     /* 218885 */     // GIR_Coverage, 2867,
     /* 218885 */     GIR_EraseRootFromParent_Done,
     /* 218886 */   // Label 4306: @218886
     /* 218886 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(218928), // Rule ID 2868 //
     /* 218891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 218899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218915 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 218918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218926 */     GIR_RootConstrainSelectedInstOperands,
     /* 218927 */     // GIR_Coverage, 2868,
     /* 218927 */     GIR_EraseRootFromParent_Done,
     /* 218928 */   // Label 4307: @218928
     /* 218928 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(218970), // Rule ID 2869 //
     /* 218933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218957 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 218960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218968 */     GIR_RootConstrainSelectedInstOperands,
     /* 218969 */     // GIR_Coverage, 2869,
     /* 218969 */     GIR_EraseRootFromParent_Done,
     /* 218970 */   // Label 4308: @218970
     /* 218970 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(219012), // Rule ID 2870 //
     /* 218975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218999 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 219002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219010 */     GIR_RootConstrainSelectedInstOperands,
     /* 219011 */     // GIR_Coverage, 2870,
     /* 219011 */     GIR_EraseRootFromParent_Done,
     /* 219012 */   // Label 4309: @219012
     /* 219012 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(219054), // Rule ID 2871 //
     /* 219017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 219025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219041 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 219044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219052 */     GIR_RootConstrainSelectedInstOperands,
     /* 219053 */     // GIR_Coverage, 2871,
     /* 219053 */     GIR_EraseRootFromParent_Done,
     /* 219054 */   // Label 4310: @219054
     /* 219054 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(219096), // Rule ID 2882 //
     /* 219059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 219067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219083 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 219086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219094 */     GIR_RootConstrainSelectedInstOperands,
     /* 219095 */     // GIR_Coverage, 2882,
     /* 219095 */     GIR_EraseRootFromParent_Done,
     /* 219096 */   // Label 4311: @219096
     /* 219096 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(219138), // Rule ID 2884 //
     /* 219101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 219109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219125 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 219128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219136 */     GIR_RootConstrainSelectedInstOperands,
     /* 219137 */     // GIR_Coverage, 2884,
     /* 219137 */     GIR_EraseRootFromParent_Done,
     /* 219138 */   // Label 4312: @219138
     /* 219138 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(219180), // Rule ID 2892 //
     /* 219143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1423:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 219170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219178 */     GIR_RootConstrainSelectedInstOperands,
     /* 219179 */     // GIR_Coverage, 2892,
     /* 219179 */     GIR_EraseRootFromParent_Done,
     /* 219180 */   // Label 4313: @219180
     /* 219180 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(219222), // Rule ID 2893 //
     /* 219185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219209 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1423:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 219212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219220 */     GIR_RootConstrainSelectedInstOperands,
     /* 219221 */     // GIR_Coverage, 2893,
     /* 219221 */     GIR_EraseRootFromParent_Done,
     /* 219222 */   // Label 4314: @219222
     /* 219222 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(219264), // Rule ID 2894 //
     /* 219227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 219254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219262 */     GIR_RootConstrainSelectedInstOperands,
     /* 219263 */     // GIR_Coverage, 2894,
     /* 219263 */     GIR_EraseRootFromParent_Done,
     /* 219264 */   // Label 4315: @219264
     /* 219264 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(219306), // Rule ID 2898 //
     /* 219269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 219277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219293 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1401:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 219296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219304 */     GIR_RootConstrainSelectedInstOperands,
     /* 219305 */     // GIR_Coverage, 2898,
     /* 219305 */     GIR_EraseRootFromParent_Done,
     /* 219306 */   // Label 4316: @219306
     /* 219306 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(219348), // Rule ID 2943 //
     /* 219311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 219319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219335 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 219338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219346 */     GIR_RootConstrainSelectedInstOperands,
     /* 219347 */     // GIR_Coverage, 2943,
     /* 219347 */     GIR_EraseRootFromParent_Done,
     /* 219348 */   // Label 4317: @219348
     /* 219348 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(219390), // Rule ID 2944 //
     /* 219353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 219361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 219380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219388 */     GIR_RootConstrainSelectedInstOperands,
     /* 219389 */     // GIR_Coverage, 2944,
     /* 219389 */     GIR_EraseRootFromParent_Done,
     /* 219390 */   // Label 4318: @219390
     /* 219390 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(219432), // Rule ID 2973 //
     /* 219395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219419 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1822:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 219422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219430 */     GIR_RootConstrainSelectedInstOperands,
     /* 219431 */     // GIR_Coverage, 2973,
     /* 219431 */     GIR_EraseRootFromParent_Done,
     /* 219432 */   // Label 4319: @219432
     /* 219432 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(219474), // Rule ID 2974 //
     /* 219437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219461 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1822:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 219464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219472 */     GIR_RootConstrainSelectedInstOperands,
     /* 219473 */     // GIR_Coverage, 2974,
     /* 219473 */     GIR_EraseRootFromParent_Done,
     /* 219474 */   // Label 4320: @219474
     /* 219474 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(219516), // Rule ID 2975 //
     /* 219479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1822:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 219506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219514 */     GIR_RootConstrainSelectedInstOperands,
     /* 219515 */     // GIR_Coverage, 2975,
     /* 219515 */     GIR_EraseRootFromParent_Done,
     /* 219516 */   // Label 4321: @219516
     /* 219516 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(219558), // Rule ID 2976 //
     /* 219521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219545 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1822:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 219548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219556 */     GIR_RootConstrainSelectedInstOperands,
     /* 219557 */     // GIR_Coverage, 2976,
     /* 219557 */     GIR_EraseRootFromParent_Done,
     /* 219558 */   // Label 4322: @219558
     /* 219558 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(219600), // Rule ID 2977 //
     /* 219563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219587 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 219590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219598 */     GIR_RootConstrainSelectedInstOperands,
     /* 219599 */     // GIR_Coverage, 2977,
     /* 219599 */     GIR_EraseRootFromParent_Done,
     /* 219600 */   // Label 4323: @219600
     /* 219600 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(219642), // Rule ID 2978 //
     /* 219605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219629 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 219632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219640 */     GIR_RootConstrainSelectedInstOperands,
     /* 219641 */     // GIR_Coverage, 2978,
     /* 219641 */     GIR_EraseRootFromParent_Done,
     /* 219642 */   // Label 4324: @219642
     /* 219642 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(219684), // Rule ID 2979 //
     /* 219647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219671 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 219674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219682 */     GIR_RootConstrainSelectedInstOperands,
     /* 219683 */     // GIR_Coverage, 2979,
     /* 219683 */     GIR_EraseRootFromParent_Done,
     /* 219684 */   // Label 4325: @219684
     /* 219684 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(219726), // Rule ID 3009 //
     /* 219689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219713 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1717:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 219716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219724 */     GIR_RootConstrainSelectedInstOperands,
     /* 219725 */     // GIR_Coverage, 3009,
     /* 219725 */     GIR_EraseRootFromParent_Done,
     /* 219726 */   // Label 4326: @219726
     /* 219726 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(219768), // Rule ID 3011 //
     /* 219731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219755 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1717:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 219758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219766 */     GIR_RootConstrainSelectedInstOperands,
     /* 219767 */     // GIR_Coverage, 3011,
     /* 219767 */     GIR_EraseRootFromParent_Done,
     /* 219768 */   // Label 4327: @219768
     /* 219768 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(219810), // Rule ID 3013 //
     /* 219773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219797 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 219800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219808 */     GIR_RootConstrainSelectedInstOperands,
     /* 219809 */     // GIR_Coverage, 3013,
     /* 219809 */     GIR_EraseRootFromParent_Done,
     /* 219810 */   // Label 4328: @219810
     /* 219810 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(219852), // Rule ID 3015 //
     /* 219815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219839 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 219842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219850 */     GIR_RootConstrainSelectedInstOperands,
     /* 219851 */     // GIR_Coverage, 3015,
     /* 219851 */     GIR_EraseRootFromParent_Done,
     /* 219852 */   // Label 4329: @219852
     /* 219852 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(219894), // Rule ID 3017 //
     /* 219857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219881 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 219884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219892 */     GIR_RootConstrainSelectedInstOperands,
     /* 219893 */     // GIR_Coverage, 3017,
     /* 219893 */     GIR_EraseRootFromParent_Done,
     /* 219894 */   // Label 4330: @219894
     /* 219894 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(219936), // Rule ID 3018 //
     /* 219899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219923 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 219926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219934 */     GIR_RootConstrainSelectedInstOperands,
     /* 219935 */     // GIR_Coverage, 3018,
     /* 219935 */     GIR_EraseRootFromParent_Done,
     /* 219936 */   // Label 4331: @219936
     /* 219936 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(219978), // Rule ID 3019 //
     /* 219941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219965 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 219968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219976 */     GIR_RootConstrainSelectedInstOperands,
     /* 219977 */     // GIR_Coverage, 3019,
     /* 219977 */     GIR_EraseRootFromParent_Done,
     /* 219978 */   // Label 4332: @219978
     /* 219978 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(220020), // Rule ID 3020 //
     /* 219983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 219991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220007 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 220010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220018 */     GIR_RootConstrainSelectedInstOperands,
     /* 220019 */     // GIR_Coverage, 3020,
     /* 220019 */     GIR_EraseRootFromParent_Done,
     /* 220020 */   // Label 4333: @220020
     /* 220020 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(220062), // Rule ID 3021 //
     /* 220025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220049 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 220052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220060 */     GIR_RootConstrainSelectedInstOperands,
     /* 220061 */     // GIR_Coverage, 3021,
     /* 220061 */     GIR_EraseRootFromParent_Done,
     /* 220062 */   // Label 4334: @220062
     /* 220062 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(220104), // Rule ID 3022 //
     /* 220067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 220094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220102 */     GIR_RootConstrainSelectedInstOperands,
     /* 220103 */     // GIR_Coverage, 3022,
     /* 220103 */     GIR_EraseRootFromParent_Done,
     /* 220104 */   // Label 4335: @220104
     /* 220104 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(220146), // Rule ID 3023 //
     /* 220109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220133 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 220136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220144 */     GIR_RootConstrainSelectedInstOperands,
     /* 220145 */     // GIR_Coverage, 3023,
     /* 220145 */     GIR_EraseRootFromParent_Done,
     /* 220146 */   // Label 4336: @220146
     /* 220146 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(220188), // Rule ID 3024 //
     /* 220151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220175 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 220178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220186 */     GIR_RootConstrainSelectedInstOperands,
     /* 220187 */     // GIR_Coverage, 3024,
     /* 220187 */     GIR_EraseRootFromParent_Done,
     /* 220188 */   // Label 4337: @220188
     /* 220188 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(220230), // Rule ID 3041 //
     /* 220193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220217 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 220220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220228 */     GIR_RootConstrainSelectedInstOperands,
     /* 220229 */     // GIR_Coverage, 3041,
     /* 220229 */     GIR_EraseRootFromParent_Done,
     /* 220230 */   // Label 4338: @220230
     /* 220230 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(220272), // Rule ID 3042 //
     /* 220235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220259 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 220262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220270 */     GIR_RootConstrainSelectedInstOperands,
     /* 220271 */     // GIR_Coverage, 3042,
     /* 220271 */     GIR_EraseRootFromParent_Done,
     /* 220272 */   // Label 4339: @220272
     /* 220272 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(220314), // Rule ID 3043 //
     /* 220277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220301 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 220304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220312 */     GIR_RootConstrainSelectedInstOperands,
     /* 220313 */     // GIR_Coverage, 3043,
     /* 220313 */     GIR_EraseRootFromParent_Done,
     /* 220314 */   // Label 4340: @220314
     /* 220314 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(220356), // Rule ID 3044 //
     /* 220319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 220346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220354 */     GIR_RootConstrainSelectedInstOperands,
     /* 220355 */     // GIR_Coverage, 3044,
     /* 220355 */     GIR_EraseRootFromParent_Done,
     /* 220356 */   // Label 4341: @220356
     /* 220356 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(220398), // Rule ID 3068 //
     /* 220361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220385 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1680:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 220388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220396 */     GIR_RootConstrainSelectedInstOperands,
     /* 220397 */     // GIR_Coverage, 3068,
     /* 220397 */     GIR_EraseRootFromParent_Done,
     /* 220398 */   // Label 4342: @220398
     /* 220398 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(220440), // Rule ID 3070 //
     /* 220403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220427 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1680:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 220430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220438 */     GIR_RootConstrainSelectedInstOperands,
     /* 220439 */     // GIR_Coverage, 3070,
     /* 220439 */     GIR_EraseRootFromParent_Done,
     /* 220440 */   // Label 4343: @220440
     /* 220440 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(220482), // Rule ID 3072 //
     /* 220445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 220472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220480 */     GIR_RootConstrainSelectedInstOperands,
     /* 220481 */     // GIR_Coverage, 3072,
     /* 220481 */     GIR_EraseRootFromParent_Done,
     /* 220482 */   // Label 4344: @220482
     /* 220482 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(220524), // Rule ID 3074 //
     /* 220487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 220514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220522 */     GIR_RootConstrainSelectedInstOperands,
     /* 220523 */     // GIR_Coverage, 3074,
     /* 220523 */     GIR_EraseRootFromParent_Done,
     /* 220524 */   // Label 4345: @220524
     /* 220524 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(220566), // Rule ID 3076 //
     /* 220529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220553 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1681:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 220556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220564 */     GIR_RootConstrainSelectedInstOperands,
     /* 220565 */     // GIR_Coverage, 3076,
     /* 220565 */     GIR_EraseRootFromParent_Done,
     /* 220566 */   // Label 4346: @220566
     /* 220566 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(220608), // Rule ID 3077 //
     /* 220571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220595 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 220598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220606 */     GIR_RootConstrainSelectedInstOperands,
     /* 220607 */     // GIR_Coverage, 3077,
     /* 220607 */     GIR_EraseRootFromParent_Done,
     /* 220608 */   // Label 4347: @220608
     /* 220608 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(220650), // Rule ID 3078 //
     /* 220613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 220640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220648 */     GIR_RootConstrainSelectedInstOperands,
     /* 220649 */     // GIR_Coverage, 3078,
     /* 220649 */     GIR_EraseRootFromParent_Done,
     /* 220650 */   // Label 4348: @220650
     /* 220650 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(220692), // Rule ID 3079 //
     /* 220655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 220663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1244:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 220682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220690 */     GIR_RootConstrainSelectedInstOperands,
     /* 220691 */     // GIR_Coverage, 3079,
     /* 220691 */     GIR_EraseRootFromParent_Done,
     /* 220692 */   // Label 4349: @220692
     /* 220692 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(220734), // Rule ID 3080 //
     /* 220697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 220705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1244:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 220724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220732 */     GIR_RootConstrainSelectedInstOperands,
     /* 220733 */     // GIR_Coverage, 3080,
     /* 220733 */     GIR_EraseRootFromParent_Done,
     /* 220734 */   // Label 4350: @220734
     /* 220734 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(220776), // Rule ID 3090 //
     /* 220739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220763 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 220766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220774 */     GIR_RootConstrainSelectedInstOperands,
     /* 220775 */     // GIR_Coverage, 3090,
     /* 220775 */     GIR_EraseRootFromParent_Done,
     /* 220776 */   // Label 4351: @220776
     /* 220776 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(220818), // Rule ID 3091 //
     /* 220781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 220808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220816 */     GIR_RootConstrainSelectedInstOperands,
     /* 220817 */     // GIR_Coverage, 3091,
     /* 220817 */     GIR_EraseRootFromParent_Done,
     /* 220818 */   // Label 4352: @220818
     /* 220818 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(220860), // Rule ID 3092 //
     /* 220823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 220850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220858 */     GIR_RootConstrainSelectedInstOperands,
     /* 220859 */     // GIR_Coverage, 3092,
     /* 220859 */     GIR_EraseRootFromParent_Done,
     /* 220860 */   // Label 4353: @220860
     /* 220860 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(220902), // Rule ID 3109 //
     /* 220865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220889 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 220889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 220892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220900 */     GIR_RootConstrainSelectedInstOperands,
     /* 220901 */     // GIR_Coverage, 3109,
     /* 220901 */     GIR_EraseRootFromParent_Done,
     /* 220902 */   // Label 4354: @220902
     /* 220902 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(220944), // Rule ID 3110 //
     /* 220907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220931 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 220931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 220934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220942 */     GIR_RootConstrainSelectedInstOperands,
     /* 220943 */     // GIR_Coverage, 3110,
     /* 220943 */     GIR_EraseRootFromParent_Done,
     /* 220944 */   // Label 4355: @220944
     /* 220944 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(220986), // Rule ID 3111 //
     /* 220949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 220973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 220976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220984 */     GIR_RootConstrainSelectedInstOperands,
     /* 220985 */     // GIR_Coverage, 3111,
     /* 220985 */     GIR_EraseRootFromParent_Done,
     /* 220986 */   // Label 4356: @220986
     /* 220986 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(221028), // Rule ID 3112 //
     /* 220991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 221015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 221018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221026 */     GIR_RootConstrainSelectedInstOperands,
     /* 221027 */     // GIR_Coverage, 3112,
     /* 221027 */     GIR_EraseRootFromParent_Done,
     /* 221028 */   // Label 4357: @221028
     /* 221028 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(221070), // Rule ID 3147 //
     /* 221033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221057 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1351:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221068 */     GIR_RootConstrainSelectedInstOperands,
     /* 221069 */     // GIR_Coverage, 3147,
     /* 221069 */     GIR_EraseRootFromParent_Done,
     /* 221070 */   // Label 4358: @221070
     /* 221070 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(221112), // Rule ID 3149 //
     /* 221075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221099 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1351:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221110 */     GIR_RootConstrainSelectedInstOperands,
     /* 221111 */     // GIR_Coverage, 3149,
     /* 221111 */     GIR_EraseRootFromParent_Done,
     /* 221112 */   // Label 4359: @221112
     /* 221112 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(221154), // Rule ID 3151 //
     /* 221117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1351:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221152 */     GIR_RootConstrainSelectedInstOperands,
     /* 221153 */     // GIR_Coverage, 3151,
     /* 221153 */     GIR_EraseRootFromParent_Done,
     /* 221154 */   // Label 4360: @221154
     /* 221154 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(221196), // Rule ID 3153 //
     /* 221159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1351:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221194 */     GIR_RootConstrainSelectedInstOperands,
     /* 221195 */     // GIR_Coverage, 3153,
     /* 221195 */     GIR_EraseRootFromParent_Done,
     /* 221196 */   // Label 4361: @221196
     /* 221196 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(221241), // Rule ID 3192 //
     /* 221201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221225 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 221228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221239 */     GIR_RootConstrainSelectedInstOperands,
     /* 221240 */     // GIR_Coverage, 3192,
     /* 221240 */     GIR_EraseRootFromParent_Done,
     /* 221241 */   // Label 4362: @221241
     /* 221241 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(221286), // Rule ID 3193 //
     /* 221246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221270 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 221273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221284 */     GIR_RootConstrainSelectedInstOperands,
     /* 221285 */     // GIR_Coverage, 3193,
     /* 221285 */     GIR_EraseRootFromParent_Done,
     /* 221286 */   // Label 4363: @221286
     /* 221286 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(221331), // Rule ID 3194 //
     /* 221291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221315 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 221318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221329 */     GIR_RootConstrainSelectedInstOperands,
     /* 221330 */     // GIR_Coverage, 3194,
     /* 221330 */     GIR_EraseRootFromParent_Done,
     /* 221331 */   // Label 4364: @221331
     /* 221331 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(221376), // Rule ID 3195 //
     /* 221336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1317:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 221363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221374 */     GIR_RootConstrainSelectedInstOperands,
     /* 221375 */     // GIR_Coverage, 3195,
     /* 221375 */     GIR_EraseRootFromParent_Done,
     /* 221376 */   // Label 4365: @221376
     /* 221376 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(221421), // Rule ID 3196 //
     /* 221381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221405 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 221408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221419 */     GIR_RootConstrainSelectedInstOperands,
     /* 221420 */     // GIR_Coverage, 3196,
     /* 221420 */     GIR_EraseRootFromParent_Done,
     /* 221421 */   // Label 4366: @221421
     /* 221421 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(221466), // Rule ID 3197 //
     /* 221426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 221453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221464 */     GIR_RootConstrainSelectedInstOperands,
     /* 221465 */     // GIR_Coverage, 3197,
     /* 221465 */     GIR_EraseRootFromParent_Done,
     /* 221466 */   // Label 4367: @221466
     /* 221466 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(221508), // Rule ID 3252 //
     /* 221471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221495 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 221498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221506 */     GIR_RootConstrainSelectedInstOperands,
     /* 221507 */     // GIR_Coverage, 3252,
     /* 221507 */     GIR_EraseRootFromParent_Done,
     /* 221508 */   // Label 4368: @221508
     /* 221508 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(221550), // Rule ID 3253 //
     /* 221513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221537 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 221540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221548 */     GIR_RootConstrainSelectedInstOperands,
     /* 221549 */     // GIR_Coverage, 3253,
     /* 221549 */     GIR_EraseRootFromParent_Done,
     /* 221550 */   // Label 4369: @221550
     /* 221550 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(221592), // Rule ID 3254 //
     /* 221555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 221566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221579 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 221582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221590 */     GIR_RootConstrainSelectedInstOperands,
     /* 221591 */     // GIR_Coverage, 3254,
     /* 221591 */     GIR_EraseRootFromParent_Done,
     /* 221592 */   // Label 4370: @221592
     /* 221592 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(221634), // Rule ID 3306 //
     /* 221597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1267:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 221624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221632 */     GIR_RootConstrainSelectedInstOperands,
     /* 221633 */     // GIR_Coverage, 3306,
     /* 221633 */     GIR_EraseRootFromParent_Done,
     /* 221634 */   // Label 4371: @221634
     /* 221634 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(221676), // Rule ID 3307 //
     /* 221639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221663 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 221666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221674 */     GIR_RootConstrainSelectedInstOperands,
     /* 221675 */     // GIR_Coverage, 3307,
     /* 221675 */     GIR_EraseRootFromParent_Done,
     /* 221676 */   // Label 4372: @221676
     /* 221676 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(221718), // Rule ID 3308 //
     /* 221681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221705 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 221708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221716 */     GIR_RootConstrainSelectedInstOperands,
     /* 221717 */     // GIR_Coverage, 3308,
     /* 221717 */     GIR_EraseRootFromParent_Done,
     /* 221718 */   // Label 4373: @221718
     /* 221718 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(221760), // Rule ID 3309 //
     /* 221723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221747 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 221750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221758 */     GIR_RootConstrainSelectedInstOperands,
     /* 221759 */     // GIR_Coverage, 3309,
     /* 221759 */     GIR_EraseRootFromParent_Done,
     /* 221760 */   // Label 4374: @221760
     /* 221760 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(221802), // Rule ID 3318 //
     /* 221765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221789 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1269:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 221792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221800 */     GIR_RootConstrainSelectedInstOperands,
     /* 221801 */     // GIR_Coverage, 3318,
     /* 221801 */     GIR_EraseRootFromParent_Done,
     /* 221802 */   // Label 4375: @221802
     /* 221802 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(221844), // Rule ID 3319 //
     /* 221807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 221834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221842 */     GIR_RootConstrainSelectedInstOperands,
     /* 221843 */     // GIR_Coverage, 3319,
     /* 221843 */     GIR_EraseRootFromParent_Done,
     /* 221844 */   // Label 4376: @221844
     /* 221844 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(221886), // Rule ID 3320 //
     /* 221849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 221876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221884 */     GIR_RootConstrainSelectedInstOperands,
     /* 221885 */     // GIR_Coverage, 3320,
     /* 221885 */     GIR_EraseRootFromParent_Done,
     /* 221886 */   // Label 4377: @221886
     /* 221886 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(221928), // Rule ID 3359 //
     /* 221891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221915 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 221918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221926 */     GIR_RootConstrainSelectedInstOperands,
     /* 221927 */     // GIR_Coverage, 3359,
     /* 221927 */     GIR_EraseRootFromParent_Done,
     /* 221928 */   // Label 4378: @221928
     /* 221928 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(221970), // Rule ID 3360 //
     /* 221933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221957 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 221960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221968 */     GIR_RootConstrainSelectedInstOperands,
     /* 221969 */     // GIR_Coverage, 3360,
     /* 221969 */     GIR_EraseRootFromParent_Done,
     /* 221970 */   // Label 4379: @221970
     /* 221970 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(222012), // Rule ID 3361 //
     /* 221975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221999 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 222002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222010 */     GIR_RootConstrainSelectedInstOperands,
     /* 222011 */     // GIR_Coverage, 3361,
     /* 222011 */     GIR_EraseRootFromParent_Done,
     /* 222012 */   // Label 4380: @222012
     /* 222012 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(222054), // Rule ID 3362 //
     /* 222017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222041 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222052 */     GIR_RootConstrainSelectedInstOperands,
     /* 222053 */     // GIR_Coverage, 3362,
     /* 222053 */     GIR_EraseRootFromParent_Done,
     /* 222054 */   // Label 4381: @222054
     /* 222054 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(222096), // Rule ID 3363 //
     /* 222059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222083 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 222086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222094 */     GIR_RootConstrainSelectedInstOperands,
     /* 222095 */     // GIR_Coverage, 3363,
     /* 222095 */     GIR_EraseRootFromParent_Done,
     /* 222096 */   // Label 4382: @222096
     /* 222096 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(222138), // Rule ID 3364 //
     /* 222101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222125 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 222128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222136 */     GIR_RootConstrainSelectedInstOperands,
     /* 222137 */     // GIR_Coverage, 3364,
     /* 222137 */     GIR_EraseRootFromParent_Done,
     /* 222138 */   // Label 4383: @222138
     /* 222138 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(222180), // Rule ID 3365 //
     /* 222143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222167 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222178 */     GIR_RootConstrainSelectedInstOperands,
     /* 222179 */     // GIR_Coverage, 3365,
     /* 222179 */     GIR_EraseRootFromParent_Done,
     /* 222180 */   // Label 4384: @222180
     /* 222180 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(222222), // Rule ID 3448 //
     /* 222185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 222193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222209 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1298:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 222212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222220 */     GIR_RootConstrainSelectedInstOperands,
     /* 222221 */     // GIR_Coverage, 3448,
     /* 222221 */     GIR_EraseRootFromParent_Done,
     /* 222222 */   // Label 4385: @222222
     /* 222222 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(222264), // Rule ID 3449 //
     /* 222227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 222235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222251 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 222254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 222256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222262 */     GIR_RootConstrainSelectedInstOperands,
     /* 222263 */     // GIR_Coverage, 3449,
     /* 222263 */     GIR_EraseRootFromParent_Done,
     /* 222264 */   // Label 4386: @222264
     /* 222264 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(222306), // Rule ID 3450 //
     /* 222269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 222277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222293 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1293:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 222296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222304 */     GIR_RootConstrainSelectedInstOperands,
     /* 222305 */     // GIR_Coverage, 3450,
     /* 222305 */     GIR_EraseRootFromParent_Done,
     /* 222306 */   // Label 4387: @222306
     /* 222306 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(222351), // Rule ID 3452 //
     /* 222311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 222319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222335 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 222338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222349 */     GIR_RootConstrainSelectedInstOperands,
     /* 222350 */     // GIR_Coverage, 3452,
     /* 222350 */     GIR_EraseRootFromParent_Done,
     /* 222351 */   // Label 4388: @222351
     /* 222351 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(222396), // Rule ID 3453 //
     /* 222356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 222364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 222383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222394 */     GIR_RootConstrainSelectedInstOperands,
     /* 222395 */     // GIR_Coverage, 3453,
     /* 222395 */     GIR_EraseRootFromParent_Done,
     /* 222396 */   // Label 4389: @222396
     /* 222396 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(222438), // Rule ID 3454 //
     /* 222401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 222409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1545:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 222428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222436 */     GIR_RootConstrainSelectedInstOperands,
     /* 222437 */     // GIR_Coverage, 3454,
     /* 222437 */     GIR_EraseRootFromParent_Done,
     /* 222438 */   // Label 4390: @222438
     /* 222438 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(222480), // Rule ID 3455 //
     /* 222443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 222451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222467 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1545:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 222470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222478 */     GIR_RootConstrainSelectedInstOperands,
     /* 222479 */     // GIR_Coverage, 3455,
     /* 222479 */     GIR_EraseRootFromParent_Done,
     /* 222480 */   // Label 4391: @222480
     /* 222480 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(222522), // Rule ID 3460 //
     /* 222485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 222488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 222493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 222512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222520 */     GIR_RootConstrainSelectedInstOperands,
     /* 222521 */     // GIR_Coverage, 3460,
     /* 222521 */     GIR_EraseRootFromParent_Done,
     /* 222522 */   // Label 4392: @222522
     /* 222522 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(222564), // Rule ID 3499 //
     /* 222527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222551 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 222554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222562 */     GIR_RootConstrainSelectedInstOperands,
     /* 222563 */     // GIR_Coverage, 3499,
     /* 222563 */     GIR_EraseRootFromParent_Done,
     /* 222564 */   // Label 4393: @222564
     /* 222564 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(222606), // Rule ID 3501 //
     /* 222569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222593 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 222596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222604 */     GIR_RootConstrainSelectedInstOperands,
     /* 222605 */     // GIR_Coverage, 3501,
     /* 222605 */     GIR_EraseRootFromParent_Done,
     /* 222606 */   // Label 4394: @222606
     /* 222606 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(222648), // Rule ID 3503 //
     /* 222611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222635 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 222638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222646 */     GIR_RootConstrainSelectedInstOperands,
     /* 222647 */     // GIR_Coverage, 3503,
     /* 222647 */     GIR_EraseRootFromParent_Done,
     /* 222648 */   // Label 4395: @222648
     /* 222648 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(222690), // Rule ID 3505 //
     /* 222653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 222661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1712:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 222680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222688 */     GIR_RootConstrainSelectedInstOperands,
     /* 222689 */     // GIR_Coverage, 3505,
     /* 222689 */     GIR_EraseRootFromParent_Done,
     /* 222690 */   // Label 4396: @222690
     /* 222690 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(222732), // Rule ID 3632 //
     /* 222695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222719 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 222722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222730 */     GIR_RootConstrainSelectedInstOperands,
     /* 222731 */     // GIR_Coverage, 3632,
     /* 222731 */     GIR_EraseRootFromParent_Done,
     /* 222732 */   // Label 4397: @222732
     /* 222732 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(222774), // Rule ID 3634 //
     /* 222737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 222764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222772 */     GIR_RootConstrainSelectedInstOperands,
     /* 222773 */     // GIR_Coverage, 3634,
     /* 222773 */     GIR_EraseRootFromParent_Done,
     /* 222774 */   // Label 4398: @222774
     /* 222774 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(222816), // Rule ID 3636 //
     /* 222779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 222806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222814 */     GIR_RootConstrainSelectedInstOperands,
     /* 222815 */     // GIR_Coverage, 3636,
     /* 222815 */     GIR_EraseRootFromParent_Done,
     /* 222816 */   // Label 4399: @222816
     /* 222816 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(222858), // Rule ID 3638 //
     /* 222821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222845 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 222848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222856 */     GIR_RootConstrainSelectedInstOperands,
     /* 222857 */     // GIR_Coverage, 3638,
     /* 222857 */     GIR_EraseRootFromParent_Done,
     /* 222858 */   // Label 4400: @222858
     /* 222858 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222900), // Rule ID 7464 //
     /* 222863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222887 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 222890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222898 */     GIR_RootConstrainSelectedInstOperands,
     /* 222899 */     // GIR_Coverage, 7464,
     /* 222899 */     GIR_EraseRootFromParent_Done,
     /* 222900 */   // Label 4401: @222900
     /* 222900 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(222942), // Rule ID 7466 //
     /* 222905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 222932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222940 */     GIR_RootConstrainSelectedInstOperands,
     /* 222941 */     // GIR_Coverage, 7466,
     /* 222941 */     GIR_EraseRootFromParent_Done,
     /* 222942 */   // Label 4402: @222942
     /* 222942 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(222984), // Rule ID 7468 //
     /* 222947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 222974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222982 */     GIR_RootConstrainSelectedInstOperands,
     /* 222983 */     // GIR_Coverage, 7468,
     /* 222983 */     GIR_EraseRootFromParent_Done,
     /* 222984 */   // Label 4403: @222984
     /* 222984 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(223026), // Rule ID 7470 //
     /* 222989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223013 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1905:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 223016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223024 */     GIR_RootConstrainSelectedInstOperands,
     /* 223025 */     // GIR_Coverage, 7470,
     /* 223025 */     GIR_EraseRootFromParent_Done,
     /* 223026 */   // Label 4404: @223026
     /* 223026 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(223068), // Rule ID 7488 //
     /* 223031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223055 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1290:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 223058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223066 */     GIR_RootConstrainSelectedInstOperands,
     /* 223067 */     // GIR_Coverage, 7488,
     /* 223067 */     GIR_EraseRootFromParent_Done,
     /* 223068 */   // Label 4405: @223068
     /* 223068 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(223110), // Rule ID 7489 //
     /* 223073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223097 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1290:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 223100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223108 */     GIR_RootConstrainSelectedInstOperands,
     /* 223109 */     // GIR_Coverage, 7489,
     /* 223109 */     GIR_EraseRootFromParent_Done,
     /* 223110 */   // Label 4406: @223110
     /* 223110 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(223152), // Rule ID 7490 //
     /* 223115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1290:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 223142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223150 */     GIR_RootConstrainSelectedInstOperands,
     /* 223151 */     // GIR_Coverage, 7490,
     /* 223151 */     GIR_EraseRootFromParent_Done,
     /* 223152 */   // Label 4407: @223152
     /* 223152 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(223194), // Rule ID 7491 //
     /* 223157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223181 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1290:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 223184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223192 */     GIR_RootConstrainSelectedInstOperands,
     /* 223193 */     // GIR_Coverage, 7491,
     /* 223193 */     GIR_EraseRootFromParent_Done,
     /* 223194 */   // Label 4408: @223194
     /* 223194 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(223236), // Rule ID 7604 //
     /* 223199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223223 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 223226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223234 */     GIR_RootConstrainSelectedInstOperands,
     /* 223235 */     // GIR_Coverage, 7604,
     /* 223235 */     GIR_EraseRootFromParent_Done,
     /* 223236 */   // Label 4409: @223236
     /* 223236 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(223278), // Rule ID 7605 //
     /* 223241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223265 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 223268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223276 */     GIR_RootConstrainSelectedInstOperands,
     /* 223277 */     // GIR_Coverage, 7605,
     /* 223277 */     GIR_EraseRootFromParent_Done,
     /* 223278 */   // Label 4410: @223278
     /* 223278 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(223320), // Rule ID 7606 //
     /* 223283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 223310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223318 */     GIR_RootConstrainSelectedInstOperands,
     /* 223319 */     // GIR_Coverage, 7606,
     /* 223319 */     GIR_EraseRootFromParent_Done,
     /* 223320 */   // Label 4411: @223320
     /* 223320 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(223362), // Rule ID 7607 //
     /* 223325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 223352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223360 */     GIR_RootConstrainSelectedInstOperands,
     /* 223361 */     // GIR_Coverage, 7607,
     /* 223361 */     GIR_EraseRootFromParent_Done,
     /* 223362 */   // Label 4412: @223362
     /* 223362 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(223404), // Rule ID 7608 //
     /* 223367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223391 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 223394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223402 */     GIR_RootConstrainSelectedInstOperands,
     /* 223403 */     // GIR_Coverage, 7608,
     /* 223403 */     GIR_EraseRootFromParent_Done,
     /* 223404 */   // Label 4413: @223404
     /* 223404 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223446), // Rule ID 7609 //
     /* 223409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223433 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1990:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 223436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223444 */     GIR_RootConstrainSelectedInstOperands,
     /* 223445 */     // GIR_Coverage, 7609,
     /* 223445 */     GIR_EraseRootFromParent_Done,
     /* 223446 */   // Label 4414: @223446
     /* 223446 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223488), // Rule ID 7610 //
     /* 223451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 223478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223486 */     GIR_RootConstrainSelectedInstOperands,
     /* 223487 */     // GIR_Coverage, 7610,
     /* 223487 */     GIR_EraseRootFromParent_Done,
     /* 223488 */   // Label 4415: @223488
     /* 223488 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(223530), // Rule ID 7611 //
     /* 223493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 223520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223528 */     GIR_RootConstrainSelectedInstOperands,
     /* 223529 */     // GIR_Coverage, 7611,
     /* 223529 */     GIR_EraseRootFromParent_Done,
     /* 223530 */   // Label 4416: @223530
     /* 223530 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223572), // Rule ID 7620 //
     /* 223535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 223543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 223562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223570 */     GIR_RootConstrainSelectedInstOperands,
     /* 223571 */     // GIR_Coverage, 7620,
     /* 223571 */     GIR_EraseRootFromParent_Done,
     /* 223572 */   // Label 4417: @223572
     /* 223572 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223614), // Rule ID 7621 //
     /* 223577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 223585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223601 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 223604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223612 */     GIR_RootConstrainSelectedInstOperands,
     /* 223613 */     // GIR_Coverage, 7621,
     /* 223613 */     GIR_EraseRootFromParent_Done,
     /* 223614 */   // Label 4418: @223614
     /* 223614 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223656), // Rule ID 7622 //
     /* 223619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 223627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 223646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223654 */     GIR_RootConstrainSelectedInstOperands,
     /* 223655 */     // GIR_Coverage, 7622,
     /* 223655 */     GIR_EraseRootFromParent_Done,
     /* 223656 */   // Label 4419: @223656
     /* 223656 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223698), // Rule ID 7623 //
     /* 223661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 223669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223685 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 223688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223696 */     GIR_RootConstrainSelectedInstOperands,
     /* 223697 */     // GIR_Coverage, 7623,
     /* 223697 */     GIR_EraseRootFromParent_Done,
     /* 223698 */   // Label 4420: @223698
     /* 223698 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223740), // Rule ID 7624 //
     /* 223703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 223711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223727 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1955:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 223730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223738 */     GIR_RootConstrainSelectedInstOperands,
     /* 223739 */     // GIR_Coverage, 7624,
     /* 223739 */     GIR_EraseRootFromParent_Done,
     /* 223740 */   // Label 4421: @223740
     /* 223740 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223782), // Rule ID 7625 //
     /* 223745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 223753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1955:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 223772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223780 */     GIR_RootConstrainSelectedInstOperands,
     /* 223781 */     // GIR_Coverage, 7625,
     /* 223781 */     GIR_EraseRootFromParent_Done,
     /* 223782 */   // Label 4422: @223782
     /* 223782 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223824), // Rule ID 7714 //
     /* 223787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223811 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 223814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223822 */     GIR_RootConstrainSelectedInstOperands,
     /* 223823 */     // GIR_Coverage, 7714,
     /* 223823 */     GIR_EraseRootFromParent_Done,
     /* 223824 */   // Label 4423: @223824
     /* 223824 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223866), // Rule ID 7715 //
     /* 223829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223853 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 223853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 223856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223864 */     GIR_RootConstrainSelectedInstOperands,
     /* 223865 */     // GIR_Coverage, 7715,
     /* 223865 */     GIR_EraseRootFromParent_Done,
     /* 223866 */   // Label 4424: @223866
     /* 223866 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223908), // Rule ID 7716 //
     /* 223871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 223895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 223898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223906 */     GIR_RootConstrainSelectedInstOperands,
     /* 223907 */     // GIR_Coverage, 7716,
     /* 223907 */     GIR_EraseRootFromParent_Done,
     /* 223908 */   // Label 4425: @223908
     /* 223908 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(223950), // Rule ID 7717 //
     /* 223913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223937 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 223937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 223940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223948 */     GIR_RootConstrainSelectedInstOperands,
     /* 223949 */     // GIR_Coverage, 7717,
     /* 223949 */     GIR_EraseRootFromParent_Done,
     /* 223950 */   // Label 4426: @223950
     /* 223950 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(223992), // Rule ID 7726 //
     /* 223955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223979 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 223982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223990 */     GIR_RootConstrainSelectedInstOperands,
     /* 223991 */     // GIR_Coverage, 7726,
     /* 223991 */     GIR_EraseRootFromParent_Done,
     /* 223992 */   // Label 4427: @223992
     /* 223992 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(224034), // Rule ID 7727 //
     /* 223997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 224014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 224021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 224024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224032 */     GIR_RootConstrainSelectedInstOperands,
     /* 224033 */     // GIR_Coverage, 7727,
     /* 224033 */     GIR_EraseRootFromParent_Done,
     /* 224034 */   // Label 4428: @224034
     /* 224034 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(224076), // Rule ID 7728 //
     /* 224039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224063 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 224063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 224066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224074 */     GIR_RootConstrainSelectedInstOperands,
     /* 224075 */     // GIR_Coverage, 7728,
     /* 224075 */     GIR_EraseRootFromParent_Done,
     /* 224076 */   // Label 4429: @224076
     /* 224076 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224118), // Rule ID 7729 //
     /* 224081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224105 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 224105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 224108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224116 */     GIR_RootConstrainSelectedInstOperands,
     /* 224117 */     // GIR_Coverage, 7729,
     /* 224117 */     GIR_EraseRootFromParent_Done,
     /* 224118 */   // Label 4430: @224118
     /* 224118 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224160), // Rule ID 7808 //
     /* 224123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224147 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 224150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224158 */     GIR_RootConstrainSelectedInstOperands,
     /* 224159 */     // GIR_Coverage, 7808,
     /* 224159 */     GIR_EraseRootFromParent_Done,
     /* 224160 */   // Label 4431: @224160
     /* 224160 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224202), // Rule ID 7809 //
     /* 224165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 224192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224200 */     GIR_RootConstrainSelectedInstOperands,
     /* 224201 */     // GIR_Coverage, 7809,
     /* 224201 */     GIR_EraseRootFromParent_Done,
     /* 224202 */   // Label 4432: @224202
     /* 224202 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224244), // Rule ID 7810 //
     /* 224207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 224234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224242 */     GIR_RootConstrainSelectedInstOperands,
     /* 224243 */     // GIR_Coverage, 7810,
     /* 224243 */     GIR_EraseRootFromParent_Done,
     /* 224244 */   // Label 4433: @224244
     /* 224244 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224286), // Rule ID 7811 //
     /* 224249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1683:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 224276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224284 */     GIR_RootConstrainSelectedInstOperands,
     /* 224285 */     // GIR_Coverage, 7811,
     /* 224285 */     GIR_EraseRootFromParent_Done,
     /* 224286 */   // Label 4434: @224286
     /* 224286 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224328), // Rule ID 7812 //
     /* 224291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224315 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 224318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224326 */     GIR_RootConstrainSelectedInstOperands,
     /* 224327 */     // GIR_Coverage, 7812,
     /* 224327 */     GIR_EraseRootFromParent_Done,
     /* 224328 */   // Label 4435: @224328
     /* 224328 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224370), // Rule ID 7813 //
     /* 224333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224357 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1933:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 224360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224368 */     GIR_RootConstrainSelectedInstOperands,
     /* 224369 */     // GIR_Coverage, 7813,
     /* 224369 */     GIR_EraseRootFromParent_Done,
     /* 224370 */   // Label 4436: @224370
     /* 224370 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224412), // Rule ID 7814 //
     /* 224375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 224402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224410 */     GIR_RootConstrainSelectedInstOperands,
     /* 224411 */     // GIR_Coverage, 7814,
     /* 224411 */     GIR_EraseRootFromParent_Done,
     /* 224412 */   // Label 4437: @224412
     /* 224412 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224454), // Rule ID 7815 //
     /* 224417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1933:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 224444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224452 */     GIR_RootConstrainSelectedInstOperands,
     /* 224453 */     // GIR_Coverage, 7815,
     /* 224453 */     GIR_EraseRootFromParent_Done,
     /* 224454 */   // Label 4438: @224454
     /* 224454 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224496), // Rule ID 8011 //
     /* 224459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224483 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 224486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224494 */     GIR_RootConstrainSelectedInstOperands,
     /* 224495 */     // GIR_Coverage, 8011,
     /* 224495 */     GIR_EraseRootFromParent_Done,
     /* 224496 */   // Label 4439: @224496
     /* 224496 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224538), // Rule ID 8013 //
     /* 224501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224525 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 224528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224536 */     GIR_RootConstrainSelectedInstOperands,
     /* 224537 */     // GIR_Coverage, 8013,
     /* 224537 */     GIR_EraseRootFromParent_Done,
     /* 224538 */   // Label 4440: @224538
     /* 224538 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224580), // Rule ID 8015 //
     /* 224543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224567 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 224570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224578 */     GIR_RootConstrainSelectedInstOperands,
     /* 224579 */     // GIR_Coverage, 8015,
     /* 224579 */     GIR_EraseRootFromParent_Done,
     /* 224580 */   // Label 4441: @224580
     /* 224580 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224622), // Rule ID 8023 //
     /* 224585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224609 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 224612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224620 */     GIR_RootConstrainSelectedInstOperands,
     /* 224621 */     // GIR_Coverage, 8023,
     /* 224621 */     GIR_EraseRootFromParent_Done,
     /* 224622 */   // Label 4442: @224622
     /* 224622 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224664), // Rule ID 8025 //
     /* 224627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224651 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 224654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224662 */     GIR_RootConstrainSelectedInstOperands,
     /* 224663 */     // GIR_Coverage, 8025,
     /* 224663 */     GIR_EraseRootFromParent_Done,
     /* 224664 */   // Label 4443: @224664
     /* 224664 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(224706), // Rule ID 8027 //
     /* 224669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224693 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 224696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224704 */     GIR_RootConstrainSelectedInstOperands,
     /* 224705 */     // GIR_Coverage, 8027,
     /* 224705 */     GIR_EraseRootFromParent_Done,
     /* 224706 */   // Label 4444: @224706
     /* 224706 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(224748), // Rule ID 8065 //
     /* 224711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224735 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 224738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224746 */     GIR_RootConstrainSelectedInstOperands,
     /* 224747 */     // GIR_Coverage, 8065,
     /* 224747 */     GIR_EraseRootFromParent_Done,
     /* 224748 */   // Label 4445: @224748
     /* 224748 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(224790), // Rule ID 8066 //
     /* 224753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224777 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 224780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224788 */     GIR_RootConstrainSelectedInstOperands,
     /* 224789 */     // GIR_Coverage, 8066,
     /* 224789 */     GIR_EraseRootFromParent_Done,
     /* 224790 */   // Label 4446: @224790
     /* 224790 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(224832), // Rule ID 8067 //
     /* 224795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224819 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 224822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224830 */     GIR_RootConstrainSelectedInstOperands,
     /* 224831 */     // GIR_Coverage, 8067,
     /* 224831 */     GIR_EraseRootFromParent_Done,
     /* 224832 */   // Label 4447: @224832
     /* 224832 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(224874), // Rule ID 8068 //
     /* 224837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224861 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 224864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224872 */     GIR_RootConstrainSelectedInstOperands,
     /* 224873 */     // GIR_Coverage, 8068,
     /* 224873 */     GIR_EraseRootFromParent_Done,
     /* 224874 */   // Label 4448: @224874
     /* 224874 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(224916), // Rule ID 8069 //
     /* 224879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224903 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 224906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224914 */     GIR_RootConstrainSelectedInstOperands,
     /* 224915 */     // GIR_Coverage, 8069,
     /* 224915 */     GIR_EraseRootFromParent_Done,
     /* 224916 */   // Label 4449: @224916
     /* 224916 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(224958), // Rule ID 8070 //
     /* 224921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224945 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 224948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224956 */     GIR_RootConstrainSelectedInstOperands,
     /* 224957 */     // GIR_Coverage, 8070,
     /* 224957 */     GIR_EraseRootFromParent_Done,
     /* 224958 */   // Label 4450: @224958
     /* 224958 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(225000), // Rule ID 8071 //
     /* 224963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 224971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224987 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1419:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 224990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224998 */     GIR_RootConstrainSelectedInstOperands,
     /* 224999 */     // GIR_Coverage, 8071,
     /* 224999 */     GIR_EraseRootFromParent_Done,
     /* 225000 */   // Label 4451: @225000
     /* 225000 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(225042), // Rule ID 8072 //
     /* 225005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225029 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 225032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225040 */     GIR_RootConstrainSelectedInstOperands,
     /* 225041 */     // GIR_Coverage, 8072,
     /* 225041 */     GIR_EraseRootFromParent_Done,
     /* 225042 */   // Label 4452: @225042
     /* 225042 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225084), // Rule ID 8073 //
     /* 225047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225071 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1419:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 225074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225082 */     GIR_RootConstrainSelectedInstOperands,
     /* 225083 */     // GIR_Coverage, 8073,
     /* 225083 */     GIR_EraseRootFromParent_Done,
     /* 225084 */   // Label 4453: @225084
     /* 225084 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225126), // Rule ID 8074 //
     /* 225089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225113 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 225116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225124 */     GIR_RootConstrainSelectedInstOperands,
     /* 225125 */     // GIR_Coverage, 8074,
     /* 225125 */     GIR_EraseRootFromParent_Done,
     /* 225126 */   // Label 4454: @225126
     /* 225126 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(225168), // Rule ID 8075 //
     /* 225131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225155 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 225158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225166 */     GIR_RootConstrainSelectedInstOperands,
     /* 225167 */     // GIR_Coverage, 8075,
     /* 225167 */     GIR_EraseRootFromParent_Done,
     /* 225168 */   // Label 4455: @225168
     /* 225168 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(225210), // Rule ID 8076 //
     /* 225173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225197 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 225200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225208 */     GIR_RootConstrainSelectedInstOperands,
     /* 225209 */     // GIR_Coverage, 8076,
     /* 225209 */     GIR_EraseRootFromParent_Done,
     /* 225210 */   // Label 4456: @225210
     /* 225210 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(225252), // Rule ID 8113 //
     /* 225215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225239 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1359:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225250 */     GIR_RootConstrainSelectedInstOperands,
     /* 225251 */     // GIR_Coverage, 8113,
     /* 225251 */     GIR_EraseRootFromParent_Done,
     /* 225252 */   // Label 4457: @225252
     /* 225252 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(225294), // Rule ID 8115 //
     /* 225257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 225268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 225274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 225277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225281 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 225281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225292 */     GIR_RootConstrainSelectedInstOperands,
     /* 225293 */     // GIR_Coverage, 8115,
     /* 225293 */     GIR_EraseRootFromParent_Done,
     /* 225294 */   // Label 4458: @225294
     /* 225294 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(225336), // Rule ID 8117 //
     /* 225299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 225310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 225316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 225319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225323 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 225323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225334 */     GIR_RootConstrainSelectedInstOperands,
     /* 225335 */     // GIR_Coverage, 8117,
     /* 225335 */     GIR_EraseRootFromParent_Done,
     /* 225336 */   // Label 4459: @225336
     /* 225336 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(225378), // Rule ID 8119 //
     /* 225341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225365 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 225368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225376 */     GIR_RootConstrainSelectedInstOperands,
     /* 225377 */     // GIR_Coverage, 8119,
     /* 225377 */     GIR_EraseRootFromParent_Done,
     /* 225378 */   // Label 4460: @225378
     /* 225378 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(225420), // Rule ID 8121 //
     /* 225383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 225394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 225400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 225403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225407 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 225407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 225410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225418 */     GIR_RootConstrainSelectedInstOperands,
     /* 225419 */     // GIR_Coverage, 8121,
     /* 225419 */     GIR_EraseRootFromParent_Done,
     /* 225420 */   // Label 4461: @225420
     /* 225420 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(225462), // Rule ID 8123 //
     /* 225425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225449 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 225452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225460 */     GIR_RootConstrainSelectedInstOperands,
     /* 225461 */     // GIR_Coverage, 8123,
     /* 225461 */     GIR_EraseRootFromParent_Done,
     /* 225462 */   // Label 4462: @225462
     /* 225462 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(225504), // Rule ID 8125 //
     /* 225467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225491 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1481:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225502 */     GIR_RootConstrainSelectedInstOperands,
     /* 225503 */     // GIR_Coverage, 8125,
     /* 225503 */     GIR_EraseRootFromParent_Done,
     /* 225504 */   // Label 4463: @225504
     /* 225504 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(225546), // Rule ID 8126 //
     /* 225509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 225520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 225526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 225529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225533 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 225533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225544 */     GIR_RootConstrainSelectedInstOperands,
     /* 225545 */     // GIR_Coverage, 8126,
     /* 225545 */     GIR_EraseRootFromParent_Done,
     /* 225546 */   // Label 4464: @225546
     /* 225546 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(225588), // Rule ID 8127 //
     /* 225551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 225562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 225568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 225571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225575 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 225575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225586 */     GIR_RootConstrainSelectedInstOperands,
     /* 225587 */     // GIR_Coverage, 8127,
     /* 225587 */     GIR_EraseRootFromParent_Done,
     /* 225588 */   // Label 4465: @225588
     /* 225588 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(225630), // Rule ID 8128 //
     /* 225593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225617 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 225620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225628 */     GIR_RootConstrainSelectedInstOperands,
     /* 225629 */     // GIR_Coverage, 8128,
     /* 225629 */     GIR_EraseRootFromParent_Done,
     /* 225630 */   // Label 4466: @225630
     /* 225630 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225672), // Rule ID 8129 //
     /* 225635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 225646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 225652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 225655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225659 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 225659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 225662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225670 */     GIR_RootConstrainSelectedInstOperands,
     /* 225671 */     // GIR_Coverage, 8129,
     /* 225671 */     GIR_EraseRootFromParent_Done,
     /* 225672 */   // Label 4467: @225672
     /* 225672 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225714), // Rule ID 8130 //
     /* 225677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225701 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 225704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225712 */     GIR_RootConstrainSelectedInstOperands,
     /* 225713 */     // GIR_Coverage, 8130,
     /* 225713 */     GIR_EraseRootFromParent_Done,
     /* 225714 */   // Label 4468: @225714
     /* 225714 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225756), // Rule ID 8383 //
     /* 225719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 225727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225743 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 225746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225754 */     GIR_RootConstrainSelectedInstOperands,
     /* 225755 */     // GIR_Coverage, 8383,
     /* 225755 */     GIR_EraseRootFromParent_Done,
     /* 225756 */   // Label 4469: @225756
     /* 225756 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225798), // Rule ID 8385 //
     /* 225761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 225769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225785 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1295:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 225788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225796 */     GIR_RootConstrainSelectedInstOperands,
     /* 225797 */     // GIR_Coverage, 8385,
     /* 225797 */     GIR_EraseRootFromParent_Done,
     /* 225798 */   // Label 4470: @225798
     /* 225798 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225840), // Rule ID 8386 //
     /* 225803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225827 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1292:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225838 */     GIR_RootConstrainSelectedInstOperands,
     /* 225839 */     // GIR_Coverage, 8386,
     /* 225839 */     GIR_EraseRootFromParent_Done,
     /* 225840 */   // Label 4471: @225840
     /* 225840 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225882), // Rule ID 8387 //
     /* 225845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 225856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 225865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225869 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 225869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225880 */     GIR_RootConstrainSelectedInstOperands,
     /* 225881 */     // GIR_Coverage, 8387,
     /* 225881 */     GIR_EraseRootFromParent_Done,
     /* 225882 */   // Label 4472: @225882
     /* 225882 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225924), // Rule ID 8388 //
     /* 225887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 225898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 225907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225911 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 225911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225922 */     GIR_RootConstrainSelectedInstOperands,
     /* 225923 */     // GIR_Coverage, 8388,
     /* 225923 */     GIR_EraseRootFromParent_Done,
     /* 225924 */   // Label 4473: @225924
     /* 225924 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225966), // Rule ID 8389 //
     /* 225929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 225940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 225949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225953 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 225953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225964 */     GIR_RootConstrainSelectedInstOperands,
     /* 225965 */     // GIR_Coverage, 8389,
     /* 225965 */     GIR_EraseRootFromParent_Done,
     /* 225966 */   // Label 4474: @225966
     /* 225966 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(226008), // Rule ID 8390 //
     /* 225971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 225982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 225985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 225988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 225991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225995 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1292:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 225995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226006 */     GIR_RootConstrainSelectedInstOperands,
     /* 226007 */     // GIR_Coverage, 8390,
     /* 226007 */     GIR_EraseRootFromParent_Done,
     /* 226008 */   // Label 4475: @226008
     /* 226008 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(226050), // Rule ID 8411 //
     /* 226013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226037 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1350:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226048 */     GIR_RootConstrainSelectedInstOperands,
     /* 226049 */     // GIR_Coverage, 8411,
     /* 226049 */     GIR_EraseRootFromParent_Done,
     /* 226050 */   // Label 4476: @226050
     /* 226050 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(226092), // Rule ID 8412 //
     /* 226055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226079 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1350:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226090 */     GIR_RootConstrainSelectedInstOperands,
     /* 226091 */     // GIR_Coverage, 8412,
     /* 226091 */     GIR_EraseRootFromParent_Done,
     /* 226092 */   // Label 4477: @226092
     /* 226092 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(226134), // Rule ID 8413 //
     /* 226097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226121 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226132 */     GIR_RootConstrainSelectedInstOperands,
     /* 226133 */     // GIR_Coverage, 8413,
     /* 226133 */     GIR_EraseRootFromParent_Done,
     /* 226134 */   // Label 4478: @226134
     /* 226134 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(226176), // Rule ID 8414 //
     /* 226139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226163 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226174 */     GIR_RootConstrainSelectedInstOperands,
     /* 226175 */     // GIR_Coverage, 8414,
     /* 226175 */     GIR_EraseRootFromParent_Done,
     /* 226176 */   // Label 4479: @226176
     /* 226176 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(226218), // Rule ID 8415 //
     /* 226181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226205 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1350:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226216 */     GIR_RootConstrainSelectedInstOperands,
     /* 226217 */     // GIR_Coverage, 8415,
     /* 226217 */     GIR_EraseRootFromParent_Done,
     /* 226218 */   // Label 4480: @226218
     /* 226218 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226260), // Rule ID 8431 //
     /* 226223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226247 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226258 */     GIR_RootConstrainSelectedInstOperands,
     /* 226259 */     // GIR_Coverage, 8431,
     /* 226259 */     GIR_EraseRootFromParent_Done,
     /* 226260 */   // Label 4481: @226260
     /* 226260 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226302), // Rule ID 8432 //
     /* 226265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226289 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226300 */     GIR_RootConstrainSelectedInstOperands,
     /* 226301 */     // GIR_Coverage, 8432,
     /* 226301 */     GIR_EraseRootFromParent_Done,
     /* 226302 */   // Label 4482: @226302
     /* 226302 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226344), // Rule ID 8433 //
     /* 226307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226331 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226342 */     GIR_RootConstrainSelectedInstOperands,
     /* 226343 */     // GIR_Coverage, 8433,
     /* 226343 */     GIR_EraseRootFromParent_Done,
     /* 226344 */   // Label 4483: @226344
     /* 226344 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226386), // Rule ID 8434 //
     /* 226349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226373 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226384 */     GIR_RootConstrainSelectedInstOperands,
     /* 226385 */     // GIR_Coverage, 8434,
     /* 226385 */     GIR_EraseRootFromParent_Done,
     /* 226386 */   // Label 4484: @226386
     /* 226386 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226428), // Rule ID 8435 //
     /* 226391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226415 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1621:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226426 */     GIR_RootConstrainSelectedInstOperands,
     /* 226427 */     // GIR_Coverage, 8435,
     /* 226427 */     GIR_EraseRootFromParent_Done,
     /* 226428 */   // Label 4485: @226428
     /* 226428 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226470), // Rule ID 8436 //
     /* 226433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226457 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226468 */     GIR_RootConstrainSelectedInstOperands,
     /* 226469 */     // GIR_Coverage, 8436,
     /* 226469 */     GIR_EraseRootFromParent_Done,
     /* 226470 */   // Label 4486: @226470
     /* 226470 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226512), // Rule ID 8437 //
     /* 226475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226499 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1617:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226510 */     GIR_RootConstrainSelectedInstOperands,
     /* 226511 */     // GIR_Coverage, 8437,
     /* 226511 */     GIR_EraseRootFromParent_Done,
     /* 226512 */   // Label 4487: @226512
     /* 226512 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226554), // Rule ID 8438 //
     /* 226517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226541 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1617:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226552 */     GIR_RootConstrainSelectedInstOperands,
     /* 226553 */     // GIR_Coverage, 8438,
     /* 226553 */     GIR_EraseRootFromParent_Done,
     /* 226554 */   // Label 4488: @226554
     /* 226554 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226596), // Rule ID 8439 //
     /* 226559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226583 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1617:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226594 */     GIR_RootConstrainSelectedInstOperands,
     /* 226595 */     // GIR_Coverage, 8439,
     /* 226595 */     GIR_EraseRootFromParent_Done,
     /* 226596 */   // Label 4489: @226596
     /* 226596 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226638), // Rule ID 8440 //
     /* 226601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226625 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1617:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226636 */     GIR_RootConstrainSelectedInstOperands,
     /* 226637 */     // GIR_Coverage, 8440,
     /* 226637 */     GIR_EraseRootFromParent_Done,
     /* 226638 */   // Label 4490: @226638
     /* 226638 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226680), // Rule ID 8441 //
     /* 226643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226667 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1615:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226678 */     GIR_RootConstrainSelectedInstOperands,
     /* 226679 */     // GIR_Coverage, 8441,
     /* 226679 */     GIR_EraseRootFromParent_Done,
     /* 226680 */   // Label 4491: @226680
     /* 226680 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226722), // Rule ID 8442 //
     /* 226685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226709 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1615:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226720 */     GIR_RootConstrainSelectedInstOperands,
     /* 226721 */     // GIR_Coverage, 8442,
     /* 226721 */     GIR_EraseRootFromParent_Done,
     /* 226722 */   // Label 4492: @226722
     /* 226722 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226764), // Rule ID 8443 //
     /* 226727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226751 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1615:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226762 */     GIR_RootConstrainSelectedInstOperands,
     /* 226763 */     // GIR_Coverage, 8443,
     /* 226763 */     GIR_EraseRootFromParent_Done,
     /* 226764 */   // Label 4493: @226764
     /* 226764 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226806), // Rule ID 8444 //
     /* 226769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226793 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1615:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226804 */     GIR_RootConstrainSelectedInstOperands,
     /* 226805 */     // GIR_Coverage, 8444,
     /* 226805 */     GIR_EraseRootFromParent_Done,
     /* 226806 */   // Label 4494: @226806
     /* 226806 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(226848), // Rule ID 8445 //
     /* 226811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226835 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1615:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226846 */     GIR_RootConstrainSelectedInstOperands,
     /* 226847 */     // GIR_Coverage, 8445,
     /* 226847 */     GIR_EraseRootFromParent_Done,
     /* 226848 */   // Label 4495: @226848
     /* 226848 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(226890), // Rule ID 8446 //
     /* 226853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226877 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226888 */     GIR_RootConstrainSelectedInstOperands,
     /* 226889 */     // GIR_Coverage, 8446,
     /* 226889 */     GIR_EraseRootFromParent_Done,
     /* 226890 */   // Label 4496: @226890
     /* 226890 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(226932), // Rule ID 8447 //
     /* 226895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226930 */     GIR_RootConstrainSelectedInstOperands,
     /* 226931 */     // GIR_Coverage, 8447,
     /* 226931 */     GIR_EraseRootFromParent_Done,
     /* 226932 */   // Label 4497: @226932
     /* 226932 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(226974), // Rule ID 8448 //
     /* 226937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226961 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226972 */     GIR_RootConstrainSelectedInstOperands,
     /* 226973 */     // GIR_Coverage, 8448,
     /* 226973 */     GIR_EraseRootFromParent_Done,
     /* 226974 */   // Label 4498: @226974
     /* 226974 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227016), // Rule ID 8449 //
     /* 226979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227003 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 227003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227014 */     GIR_RootConstrainSelectedInstOperands,
     /* 227015 */     // GIR_Coverage, 8449,
     /* 227015 */     GIR_EraseRootFromParent_Done,
     /* 227016 */   // Label 4499: @227016
     /* 227016 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227058), // Rule ID 8450 //
     /* 227021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227045 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1611:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227056 */     GIR_RootConstrainSelectedInstOperands,
     /* 227057 */     // GIR_Coverage, 8450,
     /* 227057 */     GIR_EraseRootFromParent_Done,
     /* 227058 */   // Label 4500: @227058
     /* 227058 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227100), // Rule ID 8458 //
     /* 227063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227087 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1308:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 227090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227098 */     GIR_RootConstrainSelectedInstOperands,
     /* 227099 */     // GIR_Coverage, 8458,
     /* 227099 */     GIR_EraseRootFromParent_Done,
     /* 227100 */   // Label 4501: @227100
     /* 227100 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227142), // Rule ID 8459 //
     /* 227105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227129 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227140 */     GIR_RootConstrainSelectedInstOperands,
     /* 227141 */     // GIR_Coverage, 8459,
     /* 227141 */     GIR_EraseRootFromParent_Done,
     /* 227142 */   // Label 4502: @227142
     /* 227142 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227184), // Rule ID 8460 //
     /* 227147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 227174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227182 */     GIR_RootConstrainSelectedInstOperands,
     /* 227183 */     // GIR_Coverage, 8460,
     /* 227183 */     GIR_EraseRootFromParent_Done,
     /* 227184 */   // Label 4503: @227184
     /* 227184 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227226), // Rule ID 8461 //
     /* 227189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227213 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 227216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227224 */     GIR_RootConstrainSelectedInstOperands,
     /* 227225 */     // GIR_Coverage, 8461,
     /* 227225 */     GIR_EraseRootFromParent_Done,
     /* 227226 */   // Label 4504: @227226
     /* 227226 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227268), // Rule ID 8462 //
     /* 227231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227255 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227266 */     GIR_RootConstrainSelectedInstOperands,
     /* 227267 */     // GIR_Coverage, 8462,
     /* 227267 */     GIR_EraseRootFromParent_Done,
     /* 227268 */   // Label 4505: @227268
     /* 227268 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227310), // Rule ID 8463 //
     /* 227273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227297 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 227300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227308 */     GIR_RootConstrainSelectedInstOperands,
     /* 227309 */     // GIR_Coverage, 8463,
     /* 227309 */     GIR_EraseRootFromParent_Done,
     /* 227310 */   // Label 4506: @227310
     /* 227310 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227352), // Rule ID 8464 //
     /* 227315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227339 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 227342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227350 */     GIR_RootConstrainSelectedInstOperands,
     /* 227351 */     // GIR_Coverage, 8464,
     /* 227351 */     GIR_EraseRootFromParent_Done,
     /* 227352 */   // Label 4507: @227352
     /* 227352 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(227397), // Rule ID 9160 //
     /* 227357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227381 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1329:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 227384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227395 */     GIR_RootConstrainSelectedInstOperands,
     /* 227396 */     // GIR_Coverage, 9160,
     /* 227396 */     GIR_EraseRootFromParent_Done,
     /* 227397 */   // Label 4508: @227397
     /* 227397 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(227442), // Rule ID 9161 //
     /* 227402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227426 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 227429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227440 */     GIR_RootConstrainSelectedInstOperands,
     /* 227441 */     // GIR_Coverage, 9161,
     /* 227441 */     GIR_EraseRootFromParent_Done,
     /* 227442 */   // Label 4509: @227442
     /* 227442 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(227487), // Rule ID 9162 //
     /* 227447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227471 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1329:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 227474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227485 */     GIR_RootConstrainSelectedInstOperands,
     /* 227486 */     // GIR_Coverage, 9162,
     /* 227486 */     GIR_EraseRootFromParent_Done,
     /* 227487 */   // Label 4510: @227487
     /* 227487 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(227532), // Rule ID 9163 //
     /* 227492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227516 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1319:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 227519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227530 */     GIR_RootConstrainSelectedInstOperands,
     /* 227531 */     // GIR_Coverage, 9163,
     /* 227531 */     GIR_EraseRootFromParent_Done,
     /* 227532 */   // Label 4511: @227532
     /* 227532 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(227577), // Rule ID 9164 //
     /* 227537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227561 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1319:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 227564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227575 */     GIR_RootConstrainSelectedInstOperands,
     /* 227576 */     // GIR_Coverage, 9164,
     /* 227576 */     GIR_EraseRootFromParent_Done,
     /* 227577 */   // Label 4512: @227577
     /* 227577 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(227622), // Rule ID 9165 //
     /* 227582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227606 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1319:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 227609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227620 */     GIR_RootConstrainSelectedInstOperands,
     /* 227621 */     // GIR_Coverage, 9165,
     /* 227621 */     GIR_EraseRootFromParent_Done,
     /* 227622 */   // Label 4513: @227622
     /* 227622 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(227667), // Rule ID 9166 //
     /* 227627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 227654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227665 */     GIR_RootConstrainSelectedInstOperands,
     /* 227666 */     // GIR_Coverage, 9166,
     /* 227666 */     GIR_EraseRootFromParent_Done,
     /* 227667 */   // Label 4514: @227667
     /* 227667 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(227712), // Rule ID 9167 //
     /* 227672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227696 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 227699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227710 */     GIR_RootConstrainSelectedInstOperands,
     /* 227711 */     // GIR_Coverage, 9167,
     /* 227711 */     GIR_EraseRootFromParent_Done,
     /* 227712 */   // Label 4515: @227712
     /* 227712 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(227757), // Rule ID 9168 //
     /* 227717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227741 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 227744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227755 */     GIR_RootConstrainSelectedInstOperands,
     /* 227756 */     // GIR_Coverage, 9168,
     /* 227756 */     GIR_EraseRootFromParent_Done,
     /* 227757 */   // Label 4516: @227757
     /* 227757 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(227802), // Rule ID 9169 //
     /* 227762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 227789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227800 */     GIR_RootConstrainSelectedInstOperands,
     /* 227801 */     // GIR_Coverage, 9169,
     /* 227801 */     GIR_EraseRootFromParent_Done,
     /* 227802 */   // Label 4517: @227802
     /* 227802 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(227847), // Rule ID 9170 //
     /* 227807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 227834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227845 */     GIR_RootConstrainSelectedInstOperands,
     /* 227846 */     // GIR_Coverage, 9170,
     /* 227846 */     GIR_EraseRootFromParent_Done,
     /* 227847 */   // Label 4518: @227847
     /* 227847 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(227892), // Rule ID 9171 //
     /* 227852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 227879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227890 */     GIR_RootConstrainSelectedInstOperands,
     /* 227891 */     // GIR_Coverage, 9171,
     /* 227891 */     GIR_EraseRootFromParent_Done,
     /* 227892 */   // Label 4519: @227892
     /* 227892 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(227937), // Rule ID 9172 //
     /* 227897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227921 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1323:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 227924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227935 */     GIR_RootConstrainSelectedInstOperands,
     /* 227936 */     // GIR_Coverage, 9172,
     /* 227936 */     GIR_EraseRootFromParent_Done,
     /* 227937 */   // Label 4520: @227937
     /* 227937 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(227982), // Rule ID 9173 //
     /* 227942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 227969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227980 */     GIR_RootConstrainSelectedInstOperands,
     /* 227981 */     // GIR_Coverage, 9173,
     /* 227981 */     GIR_EraseRootFromParent_Done,
     /* 227982 */   // Label 4521: @227982
     /* 227982 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(228027), // Rule ID 9174 //
     /* 227987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 228014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228025 */     GIR_RootConstrainSelectedInstOperands,
     /* 228026 */     // GIR_Coverage, 9174,
     /* 228026 */     GIR_EraseRootFromParent_Done,
     /* 228027 */   // Label 4522: @228027
     /* 228027 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(228072), // Rule ID 9175 //
     /* 228032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 228059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228070 */     GIR_RootConstrainSelectedInstOperands,
     /* 228071 */     // GIR_Coverage, 9175,
     /* 228071 */     GIR_EraseRootFromParent_Done,
     /* 228072 */   // Label 4523: @228072
     /* 228072 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(228117), // Rule ID 9176 //
     /* 228077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228101 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 228104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228115 */     GIR_RootConstrainSelectedInstOperands,
     /* 228116 */     // GIR_Coverage, 9176,
     /* 228116 */     GIR_EraseRootFromParent_Done,
     /* 228117 */   // Label 4524: @228117
     /* 228117 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(228162), // Rule ID 9177 //
     /* 228122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228146 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 228149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228160 */     GIR_RootConstrainSelectedInstOperands,
     /* 228161 */     // GIR_Coverage, 9177,
     /* 228161 */     GIR_EraseRootFromParent_Done,
     /* 228162 */   // Label 4525: @228162
     /* 228162 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(228207), // Rule ID 9178 //
     /* 228167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228191 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 228194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228205 */     GIR_RootConstrainSelectedInstOperands,
     /* 228206 */     // GIR_Coverage, 9178,
     /* 228206 */     GIR_EraseRootFromParent_Done,
     /* 228207 */   // Label 4526: @228207
     /* 228207 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(228252), // Rule ID 9179 //
     /* 228212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228236 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 228239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228250 */     GIR_RootConstrainSelectedInstOperands,
     /* 228251 */     // GIR_Coverage, 9179,
     /* 228251 */     GIR_EraseRootFromParent_Done,
     /* 228252 */   // Label 4527: @228252
     /* 228252 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(228297), // Rule ID 9180 //
     /* 228257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228281 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 228284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228295 */     GIR_RootConstrainSelectedInstOperands,
     /* 228296 */     // GIR_Coverage, 9180,
     /* 228296 */     GIR_EraseRootFromParent_Done,
     /* 228297 */   // Label 4528: @228297
     /* 228297 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(228342), // Rule ID 9181 //
     /* 228302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228326 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 228329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228340 */     GIR_RootConstrainSelectedInstOperands,
     /* 228341 */     // GIR_Coverage, 9181,
     /* 228341 */     GIR_EraseRootFromParent_Done,
     /* 228342 */   // Label 4529: @228342
     /* 228342 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(228387), // Rule ID 9182 //
     /* 228347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228371 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 228374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228385 */     GIR_RootConstrainSelectedInstOperands,
     /* 228386 */     // GIR_Coverage, 9182,
     /* 228386 */     GIR_EraseRootFromParent_Done,
     /* 228387 */   // Label 4530: @228387
     /* 228387 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(228432), // Rule ID 9183 //
     /* 228392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 228419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228430 */     GIR_RootConstrainSelectedInstOperands,
     /* 228431 */     // GIR_Coverage, 9183,
     /* 228431 */     GIR_EraseRootFromParent_Done,
     /* 228432 */   // Label 4531: @228432
     /* 228432 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(228474), // Rule ID 9580 //
     /* 228437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228461 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 228461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 228464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228472 */     GIR_RootConstrainSelectedInstOperands,
     /* 228473 */     // GIR_Coverage, 9580,
     /* 228473 */     GIR_EraseRootFromParent_Done,
     /* 228474 */   // Label 4532: @228474
     /* 228474 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(228516), // Rule ID 9581 //
     /* 228479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228503 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 228503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 228506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228514 */     GIR_RootConstrainSelectedInstOperands,
     /* 228515 */     // GIR_Coverage, 9581,
     /* 228515 */     GIR_EraseRootFromParent_Done,
     /* 228516 */   // Label 4533: @228516
     /* 228516 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(228558), // Rule ID 9582 //
     /* 228521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228545 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 228548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228556 */     GIR_RootConstrainSelectedInstOperands,
     /* 228557 */     // GIR_Coverage, 9582,
     /* 228557 */     GIR_EraseRootFromParent_Done,
     /* 228558 */   // Label 4534: @228558
     /* 228558 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(228600), // Rule ID 10120 //
     /* 228563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228587 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 228590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228598 */     GIR_RootConstrainSelectedInstOperands,
     /* 228599 */     // GIR_Coverage, 10120,
     /* 228599 */     GIR_EraseRootFromParent_Done,
     /* 228600 */   // Label 4535: @228600
     /* 228600 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(228642), // Rule ID 10121 //
     /* 228605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228629 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 228632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228640 */     GIR_RootConstrainSelectedInstOperands,
     /* 228641 */     // GIR_Coverage, 10121,
     /* 228641 */     GIR_EraseRootFromParent_Done,
     /* 228642 */   // Label 4536: @228642
     /* 228642 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(228684), // Rule ID 10122 //
     /* 228647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 228674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228682 */     GIR_RootConstrainSelectedInstOperands,
     /* 228683 */     // GIR_Coverage, 10122,
     /* 228683 */     GIR_EraseRootFromParent_Done,
     /* 228684 */   // Label 4537: @228684
     /* 228684 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(228726), // Rule ID 10123 //
     /* 228689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 228716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228724 */     GIR_RootConstrainSelectedInstOperands,
     /* 228725 */     // GIR_Coverage, 10123,
     /* 228725 */     GIR_EraseRootFromParent_Done,
     /* 228726 */   // Label 4538: @228726
     /* 228726 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(228768), // Rule ID 10124 //
     /* 228731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228755 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1590:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 228758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228766 */     GIR_RootConstrainSelectedInstOperands,
     /* 228767 */     // GIR_Coverage, 10124,
     /* 228767 */     GIR_EraseRootFromParent_Done,
     /* 228768 */   // Label 4539: @228768
     /* 228768 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(228810), // Rule ID 10125 //
     /* 228773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1590:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 228800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228808 */     GIR_RootConstrainSelectedInstOperands,
     /* 228809 */     // GIR_Coverage, 10125,
     /* 228809 */     GIR_EraseRootFromParent_Done,
     /* 228810 */   // Label 4540: @228810
     /* 228810 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(228852), // Rule ID 10126 //
     /* 228815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 228842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228850 */     GIR_RootConstrainSelectedInstOperands,
     /* 228851 */     // GIR_Coverage, 10126,
     /* 228851 */     GIR_EraseRootFromParent_Done,
     /* 228852 */   // Label 4541: @228852
     /* 228852 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(228894), // Rule ID 10127 //
     /* 228857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 228884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228892 */     GIR_RootConstrainSelectedInstOperands,
     /* 228893 */     // GIR_Coverage, 10127,
     /* 228893 */     GIR_EraseRootFromParent_Done,
     /* 228894 */   // Label 4542: @228894
     /* 228894 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(228936), // Rule ID 10140 //
     /* 228899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228923 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1595:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 228926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228934 */     GIR_RootConstrainSelectedInstOperands,
     /* 228935 */     // GIR_Coverage, 10140,
     /* 228935 */     GIR_EraseRootFromParent_Done,
     /* 228936 */   // Label 4543: @228936
     /* 228936 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(228978), // Rule ID 10141 //
     /* 228941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 228968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228976 */     GIR_RootConstrainSelectedInstOperands,
     /* 228977 */     // GIR_Coverage, 10141,
     /* 228977 */     GIR_EraseRootFromParent_Done,
     /* 228978 */   // Label 4544: @228978
     /* 228978 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(229020), // Rule ID 10142 //
     /* 228983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229007 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 229010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229018 */     GIR_RootConstrainSelectedInstOperands,
     /* 229019 */     // GIR_Coverage, 10142,
     /* 229019 */     GIR_EraseRootFromParent_Done,
     /* 229020 */   // Label 4545: @229020
     /* 229020 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(229062), // Rule ID 10143 //
     /* 229025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229049 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 229052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229060 */     GIR_RootConstrainSelectedInstOperands,
     /* 229061 */     // GIR_Coverage, 10143,
     /* 229061 */     GIR_EraseRootFromParent_Done,
     /* 229062 */   // Label 4546: @229062
     /* 229062 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(229104), // Rule ID 10144 //
     /* 229067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 229094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229102 */     GIR_RootConstrainSelectedInstOperands,
     /* 229103 */     // GIR_Coverage, 10144,
     /* 229103 */     GIR_EraseRootFromParent_Done,
     /* 229104 */   // Label 4547: @229104
     /* 229104 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(229146), // Rule ID 10145 //
     /* 229109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229133 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 229136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229144 */     GIR_RootConstrainSelectedInstOperands,
     /* 229145 */     // GIR_Coverage, 10145,
     /* 229145 */     GIR_EraseRootFromParent_Done,
     /* 229146 */   // Label 4548: @229146
     /* 229146 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(229188), // Rule ID 10172 //
     /* 229151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 229159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229175 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 229178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229186 */     GIR_RootConstrainSelectedInstOperands,
     /* 229187 */     // GIR_Coverage, 10172,
     /* 229187 */     GIR_EraseRootFromParent_Done,
     /* 229188 */   // Label 4549: @229188
     /* 229188 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(229230), // Rule ID 10176 //
     /* 229193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 229201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229217 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 229220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229228 */     GIR_RootConstrainSelectedInstOperands,
     /* 229229 */     // GIR_Coverage, 10176,
     /* 229229 */     GIR_EraseRootFromParent_Done,
     /* 229230 */   // Label 4550: @229230
     /* 229230 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(229272), // Rule ID 10180 //
     /* 229235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 229243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229259 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 229262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229270 */     GIR_RootConstrainSelectedInstOperands,
     /* 229271 */     // GIR_Coverage, 10180,
     /* 229271 */     GIR_EraseRootFromParent_Done,
     /* 229272 */   // Label 4551: @229272
     /* 229272 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(229314), // Rule ID 10184 //
     /* 229277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 229285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229301 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 229304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229312 */     GIR_RootConstrainSelectedInstOperands,
     /* 229313 */     // GIR_Coverage, 10184,
     /* 229313 */     GIR_EraseRootFromParent_Done,
     /* 229314 */   // Label 4552: @229314
     /* 229314 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(229356), // Rule ID 10188 //
     /* 229319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 229327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229343 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1703:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 229346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229354 */     GIR_RootConstrainSelectedInstOperands,
     /* 229355 */     // GIR_Coverage, 10188,
     /* 229355 */     GIR_EraseRootFromParent_Done,
     /* 229356 */   // Label 4553: @229356
     /* 229356 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(229398), // Rule ID 10189 //
     /* 229361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 229369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229385 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1950:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 229388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229396 */     GIR_RootConstrainSelectedInstOperands,
     /* 229397 */     // GIR_Coverage, 10189,
     /* 229397 */     GIR_EraseRootFromParent_Done,
     /* 229398 */   // Label 4554: @229398
     /* 229398 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(229440), // Rule ID 10190 //
     /* 229403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 229411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229427 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1947:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 229430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229438 */     GIR_RootConstrainSelectedInstOperands,
     /* 229439 */     // GIR_Coverage, 10190,
     /* 229439 */     GIR_EraseRootFromParent_Done,
     /* 229440 */   // Label 4555: @229440
     /* 229440 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(229482), // Rule ID 10194 //
     /* 229445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 229453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229469 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1702:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 229472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229480 */     GIR_RootConstrainSelectedInstOperands,
     /* 229481 */     // GIR_Coverage, 10194,
     /* 229481 */     GIR_EraseRootFromParent_Done,
     /* 229482 */   // Label 4556: @229482
     /* 229482 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(229524), // Rule ID 10198 //
     /* 229487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 229495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229511 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1700:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 229514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229522 */     GIR_RootConstrainSelectedInstOperands,
     /* 229523 */     // GIR_Coverage, 10198,
     /* 229523 */     GIR_EraseRootFromParent_Done,
     /* 229524 */   // Label 4557: @229524
     /* 229524 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(229566), // Rule ID 10202 //
     /* 229529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 229537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229553 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1701:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 229556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229564 */     GIR_RootConstrainSelectedInstOperands,
     /* 229565 */     // GIR_Coverage, 10202,
     /* 229565 */     GIR_EraseRootFromParent_Done,
     /* 229566 */   // Label 4558: @229566
     /* 229566 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(229608), // Rule ID 10206 //
     /* 229571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 229579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229595 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1949:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 229598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229606 */     GIR_RootConstrainSelectedInstOperands,
     /* 229607 */     // GIR_Coverage, 10206,
     /* 229607 */     GIR_EraseRootFromParent_Done,
     /* 229608 */   // Label 4559: @229608
     /* 229608 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(229650), // Rule ID 10210 //
     /* 229613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 229621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229637 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1948:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 229640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229648 */     GIR_RootConstrainSelectedInstOperands,
     /* 229649 */     // GIR_Coverage, 10210,
     /* 229649 */     GIR_EraseRootFromParent_Done,
     /* 229650 */   // Label 4560: @229650
     /* 229650 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(229692), // Rule ID 10220 //
     /* 229655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 229663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1405:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 229682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229690 */     GIR_RootConstrainSelectedInstOperands,
     /* 229691 */     // GIR_Coverage, 10220,
     /* 229691 */     GIR_EraseRootFromParent_Done,
     /* 229692 */   // Label 4561: @229692
     /* 229692 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(229734), // Rule ID 10221 //
     /* 229697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 229705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 229724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229732 */     GIR_RootConstrainSelectedInstOperands,
     /* 229733 */     // GIR_Coverage, 10221,
     /* 229733 */     GIR_EraseRootFromParent_Done,
     /* 229734 */   // Label 4562: @229734
     /* 229734 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(229776), // Rule ID 10222 //
     /* 229739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 229747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1407:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 229766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229774 */     GIR_RootConstrainSelectedInstOperands,
     /* 229775 */     // GIR_Coverage, 10222,
     /* 229775 */     GIR_EraseRootFromParent_Done,
     /* 229776 */   // Label 4563: @229776
     /* 229776 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(229818), // Rule ID 10226 //
     /* 229781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 229789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1404:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 229808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229816 */     GIR_RootConstrainSelectedInstOperands,
     /* 229817 */     // GIR_Coverage, 10226,
     /* 229817 */     GIR_EraseRootFromParent_Done,
     /* 229818 */   // Label 4564: @229818
     /* 229818 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(229860), // Rule ID 10230 //
     /* 229823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 229831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229847 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1406:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 229850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229858 */     GIR_RootConstrainSelectedInstOperands,
     /* 229859 */     // GIR_Coverage, 10230,
     /* 229859 */     GIR_EraseRootFromParent_Done,
     /* 229860 */   // Label 4565: @229860
     /* 229860 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(229902), // Rule ID 10234 //
     /* 229865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 229873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229889 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 229892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229900 */     GIR_RootConstrainSelectedInstOperands,
     /* 229901 */     // GIR_Coverage, 10234,
     /* 229901 */     GIR_EraseRootFromParent_Done,
     /* 229902 */   // Label 4566: @229902
     /* 229902 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(229944), // Rule ID 10238 //
     /* 229907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 229915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1413:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 229934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229942 */     GIR_RootConstrainSelectedInstOperands,
     /* 229943 */     // GIR_Coverage, 10238,
     /* 229943 */     GIR_EraseRootFromParent_Done,
     /* 229944 */   // Label 4567: @229944
     /* 229944 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(229986), // Rule ID 10242 //
     /* 229949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 229957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229973 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 229976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229984 */     GIR_RootConstrainSelectedInstOperands,
     /* 229985 */     // GIR_Coverage, 10242,
     /* 229985 */     GIR_EraseRootFromParent_Done,
     /* 229986 */   // Label 4568: @229986
     /* 229986 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(230028), // Rule ID 11239 //
     /* 229991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 229994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 229999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 230018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230026 */     GIR_RootConstrainSelectedInstOperands,
     /* 230027 */     // GIR_Coverage, 11239,
     /* 230027 */     GIR_EraseRootFromParent_Done,
     /* 230028 */   // Label 4569: @230028
     /* 230028 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(230070), // Rule ID 11240 //
     /* 230033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 230036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 230041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 230060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230068 */     GIR_RootConstrainSelectedInstOperands,
     /* 230069 */     // GIR_Coverage, 11240,
     /* 230069 */     GIR_EraseRootFromParent_Done,
     /* 230070 */   // Label 4570: @230070
     /* 230070 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(230112), // Rule ID 11242 //
     /* 230075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 230078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230099 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 230102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230110 */     GIR_RootConstrainSelectedInstOperands,
     /* 230111 */     // GIR_Coverage, 11242,
     /* 230111 */     GIR_EraseRootFromParent_Done,
     /* 230112 */   // Label 4571: @230112
     /* 230112 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(230154), // Rule ID 11243 //
     /* 230117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 230120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230141 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 230144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230152 */     GIR_RootConstrainSelectedInstOperands,
     /* 230153 */     // GIR_Coverage, 11243,
     /* 230153 */     GIR_EraseRootFromParent_Done,
     /* 230154 */   // Label 4572: @230154
     /* 230154 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(230196), // Rule ID 11297 //
     /* 230159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230183 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 230186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230194 */     GIR_RootConstrainSelectedInstOperands,
     /* 230195 */     // GIR_Coverage, 11297,
     /* 230195 */     GIR_EraseRootFromParent_Done,
     /* 230196 */   // Label 4573: @230196
     /* 230196 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(230238), // Rule ID 11298 //
     /* 230201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230225 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 230228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230236 */     GIR_RootConstrainSelectedInstOperands,
     /* 230237 */     // GIR_Coverage, 11298,
     /* 230237 */     GIR_EraseRootFromParent_Done,
     /* 230238 */   // Label 4574: @230238
     /* 230238 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(230280), // Rule ID 11299 //
     /* 230243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 230270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230278 */     GIR_RootConstrainSelectedInstOperands,
     /* 230279 */     // GIR_Coverage, 11299,
     /* 230279 */     GIR_EraseRootFromParent_Done,
     /* 230280 */   // Label 4575: @230280
     /* 230280 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(230322), // Rule ID 11300 //
     /* 230285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 230312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230320 */     GIR_RootConstrainSelectedInstOperands,
     /* 230321 */     // GIR_Coverage, 11300,
     /* 230321 */     GIR_EraseRootFromParent_Done,
     /* 230322 */   // Label 4576: @230322
     /* 230322 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(230364), // Rule ID 11353 //
     /* 230327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 230354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230362 */     GIR_RootConstrainSelectedInstOperands,
     /* 230363 */     // GIR_Coverage, 11353,
     /* 230363 */     GIR_EraseRootFromParent_Done,
     /* 230364 */   // Label 4577: @230364
     /* 230364 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(230406), // Rule ID 11354 //
     /* 230369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 230396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230404 */     GIR_RootConstrainSelectedInstOperands,
     /* 230405 */     // GIR_Coverage, 11354,
     /* 230405 */     GIR_EraseRootFromParent_Done,
     /* 230406 */   // Label 4578: @230406
     /* 230406 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(230448), // Rule ID 11355 //
     /* 230411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 230438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230446 */     GIR_RootConstrainSelectedInstOperands,
     /* 230447 */     // GIR_Coverage, 11355,
     /* 230447 */     GIR_EraseRootFromParent_Done,
     /* 230448 */   // Label 4579: @230448
     /* 230448 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(230490), // Rule ID 11356 //
     /* 230453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230477 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1981:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 230480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230488 */     GIR_RootConstrainSelectedInstOperands,
     /* 230489 */     // GIR_Coverage, 11356,
     /* 230489 */     GIR_EraseRootFromParent_Done,
     /* 230490 */   // Label 4580: @230490
     /* 230490 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(230532), // Rule ID 11357 //
     /* 230495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 230522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230530 */     GIR_RootConstrainSelectedInstOperands,
     /* 230531 */     // GIR_Coverage, 11357,
     /* 230531 */     GIR_EraseRootFromParent_Done,
     /* 230532 */   // Label 4581: @230532
     /* 230532 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(230574), // Rule ID 11358 //
     /* 230537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1981:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 230564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230572 */     GIR_RootConstrainSelectedInstOperands,
     /* 230573 */     // GIR_Coverage, 11358,
     /* 230573 */     GIR_EraseRootFromParent_Done,
     /* 230574 */   // Label 4582: @230574
     /* 230574 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(230616), // Rule ID 11359 //
     /* 230579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230603 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1983:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 230606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230614 */     GIR_RootConstrainSelectedInstOperands,
     /* 230615 */     // GIR_Coverage, 11359,
     /* 230615 */     GIR_EraseRootFromParent_Done,
     /* 230616 */   // Label 4583: @230616
     /* 230616 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(230658), // Rule ID 11360 //
     /* 230621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230645 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1983:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 230648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230656 */     GIR_RootConstrainSelectedInstOperands,
     /* 230657 */     // GIR_Coverage, 11360,
     /* 230657 */     GIR_EraseRootFromParent_Done,
     /* 230658 */   // Label 4584: @230658
     /* 230658 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(230700), // Rule ID 11361 //
     /* 230663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230687 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1983:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 230690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230698 */     GIR_RootConstrainSelectedInstOperands,
     /* 230699 */     // GIR_Coverage, 11361,
     /* 230699 */     GIR_EraseRootFromParent_Done,
     /* 230700 */   // Label 4585: @230700
     /* 230700 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(230742), // Rule ID 11362 //
     /* 230705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230729 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 230732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230740 */     GIR_RootConstrainSelectedInstOperands,
     /* 230741 */     // GIR_Coverage, 11362,
     /* 230741 */     GIR_EraseRootFromParent_Done,
     /* 230742 */   // Label 4586: @230742
     /* 230742 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(230784), // Rule ID 11363 //
     /* 230747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 230774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230782 */     GIR_RootConstrainSelectedInstOperands,
     /* 230783 */     // GIR_Coverage, 11363,
     /* 230783 */     GIR_EraseRootFromParent_Done,
     /* 230784 */   // Label 4587: @230784
     /* 230784 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(230826), // Rule ID 11364 //
     /* 230789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230813 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 230816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230824 */     GIR_RootConstrainSelectedInstOperands,
     /* 230825 */     // GIR_Coverage, 11364,
     /* 230825 */     GIR_EraseRootFromParent_Done,
     /* 230826 */   // Label 4588: @230826
     /* 230826 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(230868), // Rule ID 11365 //
     /* 230831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230855 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 230858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230866 */     GIR_RootConstrainSelectedInstOperands,
     /* 230867 */     // GIR_Coverage, 11365,
     /* 230867 */     GIR_EraseRootFromParent_Done,
     /* 230868 */   // Label 4589: @230868
     /* 230868 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(230910), // Rule ID 11366 //
     /* 230873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230897 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 230900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230908 */     GIR_RootConstrainSelectedInstOperands,
     /* 230909 */     // GIR_Coverage, 11366,
     /* 230909 */     GIR_EraseRootFromParent_Done,
     /* 230910 */   // Label 4590: @230910
     /* 230910 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(230952), // Rule ID 11367 //
     /* 230915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230939 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 230942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230950 */     GIR_RootConstrainSelectedInstOperands,
     /* 230951 */     // GIR_Coverage, 11367,
     /* 230951 */     GIR_EraseRootFromParent_Done,
     /* 230952 */   // Label 4591: @230952
     /* 230952 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(230994), // Rule ID 11368 //
     /* 230957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 230965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230981 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1985:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 230984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230992 */     GIR_RootConstrainSelectedInstOperands,
     /* 230993 */     // GIR_Coverage, 11368,
     /* 230993 */     GIR_EraseRootFromParent_Done,
     /* 230994 */   // Label 4592: @230994
     /* 230994 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(231036), // Rule ID 11369 //
     /* 230999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 231026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231034 */     GIR_RootConstrainSelectedInstOperands,
     /* 231035 */     // GIR_Coverage, 11369,
     /* 231035 */     GIR_EraseRootFromParent_Done,
     /* 231036 */   // Label 4593: @231036
     /* 231036 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(231078), // Rule ID 11370 //
     /* 231041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231065 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 231068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231076 */     GIR_RootConstrainSelectedInstOperands,
     /* 231077 */     // GIR_Coverage, 11370,
     /* 231077 */     GIR_EraseRootFromParent_Done,
     /* 231078 */   // Label 4594: @231078
     /* 231078 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(231120), // Rule ID 11371 //
     /* 231083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231107 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1987:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 231110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231118 */     GIR_RootConstrainSelectedInstOperands,
     /* 231119 */     // GIR_Coverage, 11371,
     /* 231119 */     GIR_EraseRootFromParent_Done,
     /* 231120 */   // Label 4595: @231120
     /* 231120 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(231162), // Rule ID 11372 //
     /* 231125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231149 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1987:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 231152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231160 */     GIR_RootConstrainSelectedInstOperands,
     /* 231161 */     // GIR_Coverage, 11372,
     /* 231161 */     GIR_EraseRootFromParent_Done,
     /* 231162 */   // Label 4596: @231162
     /* 231162 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(231204), // Rule ID 11373 //
     /* 231167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1987:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 231194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231202 */     GIR_RootConstrainSelectedInstOperands,
     /* 231203 */     // GIR_Coverage, 11373,
     /* 231203 */     GIR_EraseRootFromParent_Done,
     /* 231204 */   // Label 4597: @231204
     /* 231204 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(231246), // Rule ID 11382 //
     /* 231209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1785:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 231236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231244 */     GIR_RootConstrainSelectedInstOperands,
     /* 231245 */     // GIR_Coverage, 11382,
     /* 231245 */     GIR_EraseRootFromParent_Done,
     /* 231246 */   // Label 4598: @231246
     /* 231246 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(231288), // Rule ID 11383 //
     /* 231251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1785:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 231278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231286 */     GIR_RootConstrainSelectedInstOperands,
     /* 231287 */     // GIR_Coverage, 11383,
     /* 231287 */     GIR_EraseRootFromParent_Done,
     /* 231288 */   // Label 4599: @231288
     /* 231288 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(231330), // Rule ID 11384 //
     /* 231293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1785:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 231320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231328 */     GIR_RootConstrainSelectedInstOperands,
     /* 231329 */     // GIR_Coverage, 11384,
     /* 231329 */     GIR_EraseRootFromParent_Done,
     /* 231330 */   // Label 4600: @231330
     /* 231330 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(231372), // Rule ID 11385 //
     /* 231335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231359 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 231362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231370 */     GIR_RootConstrainSelectedInstOperands,
     /* 231371 */     // GIR_Coverage, 11385,
     /* 231371 */     GIR_EraseRootFromParent_Done,
     /* 231372 */   // Label 4601: @231372
     /* 231372 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(231414), // Rule ID 11386 //
     /* 231377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 231404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231412 */     GIR_RootConstrainSelectedInstOperands,
     /* 231413 */     // GIR_Coverage, 11386,
     /* 231413 */     GIR_EraseRootFromParent_Done,
     /* 231414 */   // Label 4602: @231414
     /* 231414 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(231456), // Rule ID 11387 //
     /* 231419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 231446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231454 */     GIR_RootConstrainSelectedInstOperands,
     /* 231455 */     // GIR_Coverage, 11387,
     /* 231455 */     GIR_EraseRootFromParent_Done,
     /* 231456 */   // Label 4603: @231456
     /* 231456 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(231498), // Rule ID 11388 //
     /* 231461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231485 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1790:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 231488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231496 */     GIR_RootConstrainSelectedInstOperands,
     /* 231497 */     // GIR_Coverage, 11388,
     /* 231497 */     GIR_EraseRootFromParent_Done,
     /* 231498 */   // Label 4604: @231498
     /* 231498 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(231540), // Rule ID 11389 //
     /* 231503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 231530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231538 */     GIR_RootConstrainSelectedInstOperands,
     /* 231539 */     // GIR_Coverage, 11389,
     /* 231539 */     GIR_EraseRootFromParent_Done,
     /* 231540 */   // Label 4605: @231540
     /* 231540 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(231582), // Rule ID 11390 //
     /* 231545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231569 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 231572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231580 */     GIR_RootConstrainSelectedInstOperands,
     /* 231581 */     // GIR_Coverage, 11390,
     /* 231581 */     GIR_EraseRootFromParent_Done,
     /* 231582 */   // Label 4606: @231582
     /* 231582 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(231624), // Rule ID 11391 //
     /* 231587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231611 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1793:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 231614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231622 */     GIR_RootConstrainSelectedInstOperands,
     /* 231623 */     // GIR_Coverage, 11391,
     /* 231623 */     GIR_EraseRootFromParent_Done,
     /* 231624 */   // Label 4607: @231624
     /* 231624 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(231666), // Rule ID 11392 //
     /* 231629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231653 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 231656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231664 */     GIR_RootConstrainSelectedInstOperands,
     /* 231665 */     // GIR_Coverage, 11392,
     /* 231665 */     GIR_EraseRootFromParent_Done,
     /* 231666 */   // Label 4608: @231666
     /* 231666 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(231708), // Rule ID 11393 //
     /* 231671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231695 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 231698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231706 */     GIR_RootConstrainSelectedInstOperands,
     /* 231707 */     // GIR_Coverage, 11393,
     /* 231707 */     GIR_EraseRootFromParent_Done,
     /* 231708 */   // Label 4609: @231708
     /* 231708 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(231750), // Rule ID 11394 //
     /* 231713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231737 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 231740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231748 */     GIR_RootConstrainSelectedInstOperands,
     /* 231749 */     // GIR_Coverage, 11394,
     /* 231749 */     GIR_EraseRootFromParent_Done,
     /* 231750 */   // Label 4610: @231750
     /* 231750 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(231792), // Rule ID 11395 //
     /* 231755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 231782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231790 */     GIR_RootConstrainSelectedInstOperands,
     /* 231791 */     // GIR_Coverage, 11395,
     /* 231791 */     GIR_EraseRootFromParent_Done,
     /* 231792 */   // Label 4611: @231792
     /* 231792 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(231834), // Rule ID 11396 //
     /* 231797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 231824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231832 */     GIR_RootConstrainSelectedInstOperands,
     /* 231833 */     // GIR_Coverage, 11396,
     /* 231833 */     GIR_EraseRootFromParent_Done,
     /* 231834 */   // Label 4612: @231834
     /* 231834 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(231876), // Rule ID 11397 //
     /* 231839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231863 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1792:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 231866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231872 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231874 */     GIR_RootConstrainSelectedInstOperands,
     /* 231875 */     // GIR_Coverage, 11397,
     /* 231875 */     GIR_EraseRootFromParent_Done,
     /* 231876 */   // Label 4613: @231876
     /* 231876 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(231918), // Rule ID 11398 //
     /* 231881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231905 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 231908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231916 */     GIR_RootConstrainSelectedInstOperands,
     /* 231917 */     // GIR_Coverage, 11398,
     /* 231917 */     GIR_EraseRootFromParent_Done,
     /* 231918 */   // Label 4614: @231918
     /* 231918 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(231960), // Rule ID 11399 //
     /* 231923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231947 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 231950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231958 */     GIR_RootConstrainSelectedInstOperands,
     /* 231959 */     // GIR_Coverage, 11399,
     /* 231959 */     GIR_EraseRootFromParent_Done,
     /* 231960 */   // Label 4615: @231960
     /* 231960 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(232002), // Rule ID 11400 //
     /* 231965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 231973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231989 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1960:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 231992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232000 */     GIR_RootConstrainSelectedInstOperands,
     /* 232001 */     // GIR_Coverage, 11400,
     /* 232001 */     GIR_EraseRootFromParent_Done,
     /* 232002 */   // Label 4616: @232002
     /* 232002 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(232044), // Rule ID 11402 //
     /* 232007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1960:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 232034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232042 */     GIR_RootConstrainSelectedInstOperands,
     /* 232043 */     // GIR_Coverage, 11402,
     /* 232043 */     GIR_EraseRootFromParent_Done,
     /* 232044 */   // Label 4617: @232044
     /* 232044 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(232086), // Rule ID 11404 //
     /* 232049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232073 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 232076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232084 */     GIR_RootConstrainSelectedInstOperands,
     /* 232085 */     // GIR_Coverage, 11404,
     /* 232085 */     GIR_EraseRootFromParent_Done,
     /* 232086 */   // Label 4618: @232086
     /* 232086 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(232128), // Rule ID 11406 //
     /* 232091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232115 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 232118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232126 */     GIR_RootConstrainSelectedInstOperands,
     /* 232127 */     // GIR_Coverage, 11406,
     /* 232127 */     GIR_EraseRootFromParent_Done,
     /* 232128 */   // Label 4619: @232128
     /* 232128 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(232170), // Rule ID 11408 //
     /* 232133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232157 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1720:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 232160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232168 */     GIR_RootConstrainSelectedInstOperands,
     /* 232169 */     // GIR_Coverage, 11408,
     /* 232169 */     GIR_EraseRootFromParent_Done,
     /* 232170 */   // Label 4620: @232170
     /* 232170 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(232212), // Rule ID 11409 //
     /* 232175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1720:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 232202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232210 */     GIR_RootConstrainSelectedInstOperands,
     /* 232211 */     // GIR_Coverage, 11409,
     /* 232211 */     GIR_EraseRootFromParent_Done,
     /* 232212 */   // Label 4621: @232212
     /* 232212 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(232254), // Rule ID 11410 //
     /* 232217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 232244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232252 */     GIR_RootConstrainSelectedInstOperands,
     /* 232253 */     // GIR_Coverage, 11410,
     /* 232253 */     GIR_EraseRootFromParent_Done,
     /* 232254 */   // Label 4622: @232254
     /* 232254 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(232296), // Rule ID 11411 //
     /* 232259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232283 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1720:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 232286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232294 */     GIR_RootConstrainSelectedInstOperands,
     /* 232295 */     // GIR_Coverage, 11411,
     /* 232295 */     GIR_EraseRootFromParent_Done,
     /* 232296 */   // Label 4623: @232296
     /* 232296 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(232338), // Rule ID 11412 //
     /* 232301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232325 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 232328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232336 */     GIR_RootConstrainSelectedInstOperands,
     /* 232337 */     // GIR_Coverage, 11412,
     /* 232337 */     GIR_EraseRootFromParent_Done,
     /* 232338 */   // Label 4624: @232338
     /* 232338 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(232380), // Rule ID 11413 //
     /* 232343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232367 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 232370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232378 */     GIR_RootConstrainSelectedInstOperands,
     /* 232379 */     // GIR_Coverage, 11413,
     /* 232379 */     GIR_EraseRootFromParent_Done,
     /* 232380 */   // Label 4625: @232380
     /* 232380 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(232422), // Rule ID 11414 //
     /* 232385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 232412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232420 */     GIR_RootConstrainSelectedInstOperands,
     /* 232421 */     // GIR_Coverage, 11414,
     /* 232421 */     GIR_EraseRootFromParent_Done,
     /* 232422 */   // Label 4626: @232422
     /* 232422 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(232464), // Rule ID 11415 //
     /* 232427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 232454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232462 */     GIR_RootConstrainSelectedInstOperands,
     /* 232463 */     // GIR_Coverage, 11415,
     /* 232463 */     GIR_EraseRootFromParent_Done,
     /* 232464 */   // Label 4627: @232464
     /* 232464 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(232506), // Rule ID 11416 //
     /* 232469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 232496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232504 */     GIR_RootConstrainSelectedInstOperands,
     /* 232505 */     // GIR_Coverage, 11416,
     /* 232505 */     GIR_EraseRootFromParent_Done,
     /* 232506 */   // Label 4628: @232506
     /* 232506 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(232548), // Rule ID 11418 //
     /* 232511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232535 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 232538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232546 */     GIR_RootConstrainSelectedInstOperands,
     /* 232547 */     // GIR_Coverage, 11418,
     /* 232547 */     GIR_EraseRootFromParent_Done,
     /* 232548 */   // Label 4629: @232548
     /* 232548 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(232590), // Rule ID 11420 //
     /* 232553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232577 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 232580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232588 */     GIR_RootConstrainSelectedInstOperands,
     /* 232589 */     // GIR_Coverage, 11420,
     /* 232589 */     GIR_EraseRootFromParent_Done,
     /* 232590 */   // Label 4630: @232590
     /* 232590 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(232632), // Rule ID 11422 //
     /* 232595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232619 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 232622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232630 */     GIR_RootConstrainSelectedInstOperands,
     /* 232631 */     // GIR_Coverage, 11422,
     /* 232631 */     GIR_EraseRootFromParent_Done,
     /* 232632 */   // Label 4631: @232632
     /* 232632 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(232674), // Rule ID 11424 //
     /* 232637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232661 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 232664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232672 */     GIR_RootConstrainSelectedInstOperands,
     /* 232673 */     // GIR_Coverage, 11424,
     /* 232673 */     GIR_EraseRootFromParent_Done,
     /* 232674 */   // Label 4632: @232674
     /* 232674 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(232716), // Rule ID 11426 //
     /* 232679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 232706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232714 */     GIR_RootConstrainSelectedInstOperands,
     /* 232715 */     // GIR_Coverage, 11426,
     /* 232715 */     GIR_EraseRootFromParent_Done,
     /* 232716 */   // Label 4633: @232716
     /* 232716 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(232758), // Rule ID 11428 //
     /* 232721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 232748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232756 */     GIR_RootConstrainSelectedInstOperands,
     /* 232757 */     // GIR_Coverage, 11428,
     /* 232757 */     GIR_EraseRootFromParent_Done,
     /* 232758 */   // Label 4634: @232758
     /* 232758 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(232800), // Rule ID 11430 //
     /* 232763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 232790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232798 */     GIR_RootConstrainSelectedInstOperands,
     /* 232799 */     // GIR_Coverage, 11430,
     /* 232799 */     GIR_EraseRootFromParent_Done,
     /* 232800 */   // Label 4635: @232800
     /* 232800 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(232842), // Rule ID 11432 //
     /* 232805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232829 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1721:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 232832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232840 */     GIR_RootConstrainSelectedInstOperands,
     /* 232841 */     // GIR_Coverage, 11432,
     /* 232841 */     GIR_EraseRootFromParent_Done,
     /* 232842 */   // Label 4636: @232842
     /* 232842 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(232884), // Rule ID 11433 //
     /* 232847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232871 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1721:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 232874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232882 */     GIR_RootConstrainSelectedInstOperands,
     /* 232883 */     // GIR_Coverage, 11433,
     /* 232883 */     GIR_EraseRootFromParent_Done,
     /* 232884 */   // Label 4637: @232884
     /* 232884 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(232926), // Rule ID 11434 //
     /* 232889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232913 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 232916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232924 */     GIR_RootConstrainSelectedInstOperands,
     /* 232925 */     // GIR_Coverage, 11434,
     /* 232925 */     GIR_EraseRootFromParent_Done,
     /* 232926 */   // Label 4638: @232926
     /* 232926 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(232968), // Rule ID 11435 //
     /* 232931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232955 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1721:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 232958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232966 */     GIR_RootConstrainSelectedInstOperands,
     /* 232967 */     // GIR_Coverage, 11435,
     /* 232967 */     GIR_EraseRootFromParent_Done,
     /* 232968 */   // Label 4639: @232968
     /* 232968 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(233010), // Rule ID 11436 //
     /* 232973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 232981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232997 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1962:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 233000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233008 */     GIR_RootConstrainSelectedInstOperands,
     /* 233009 */     // GIR_Coverage, 11436,
     /* 233009 */     GIR_EraseRootFromParent_Done,
     /* 233010 */   // Label 4640: @233010
     /* 233010 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(233052), // Rule ID 11437 //
     /* 233015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233039 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1962:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 233042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233050 */     GIR_RootConstrainSelectedInstOperands,
     /* 233051 */     // GIR_Coverage, 11437,
     /* 233051 */     GIR_EraseRootFromParent_Done,
     /* 233052 */   // Label 4641: @233052
     /* 233052 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(233094), // Rule ID 11438 //
     /* 233057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 233084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233092 */     GIR_RootConstrainSelectedInstOperands,
     /* 233093 */     // GIR_Coverage, 11438,
     /* 233093 */     GIR_EraseRootFromParent_Done,
     /* 233094 */   // Label 4642: @233094
     /* 233094 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(233136), // Rule ID 11439 //
     /* 233099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233123 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 233126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233134 */     GIR_RootConstrainSelectedInstOperands,
     /* 233135 */     // GIR_Coverage, 11439,
     /* 233135 */     GIR_EraseRootFromParent_Done,
     /* 233136 */   // Label 4643: @233136
     /* 233136 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(233178), // Rule ID 11440 //
     /* 233141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233165 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 233168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233176 */     GIR_RootConstrainSelectedInstOperands,
     /* 233177 */     // GIR_Coverage, 11440,
     /* 233177 */     GIR_EraseRootFromParent_Done,
     /* 233178 */   // Label 4644: @233178
     /* 233178 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(233220), // Rule ID 11441 //
     /* 233183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 233210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233218 */     GIR_RootConstrainSelectedInstOperands,
     /* 233219 */     // GIR_Coverage, 11441,
     /* 233219 */     GIR_EraseRootFromParent_Done,
     /* 233220 */   // Label 4645: @233220
     /* 233220 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(233262), // Rule ID 11442 //
     /* 233225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 233252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233260 */     GIR_RootConstrainSelectedInstOperands,
     /* 233261 */     // GIR_Coverage, 11442,
     /* 233261 */     GIR_EraseRootFromParent_Done,
     /* 233262 */   // Label 4646: @233262
     /* 233262 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(233304), // Rule ID 11443 //
     /* 233267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233291 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1252:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 233294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233302 */     GIR_RootConstrainSelectedInstOperands,
     /* 233303 */     // GIR_Coverage, 11443,
     /* 233303 */     GIR_EraseRootFromParent_Done,
     /* 233304 */   // Label 4647: @233304
     /* 233304 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(233346), // Rule ID 11444 //
     /* 233309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233333 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1252:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 233336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233344 */     GIR_RootConstrainSelectedInstOperands,
     /* 233345 */     // GIR_Coverage, 11444,
     /* 233345 */     GIR_EraseRootFromParent_Done,
     /* 233346 */   // Label 4648: @233346
     /* 233346 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(233388), // Rule ID 11445 //
     /* 233351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 233378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233386 */     GIR_RootConstrainSelectedInstOperands,
     /* 233387 */     // GIR_Coverage, 11445,
     /* 233387 */     GIR_EraseRootFromParent_Done,
     /* 233388 */   // Label 4649: @233388
     /* 233388 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(233430), // Rule ID 11446 //
     /* 233393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1252:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 233420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233428 */     GIR_RootConstrainSelectedInstOperands,
     /* 233429 */     // GIR_Coverage, 11446,
     /* 233429 */     GIR_EraseRootFromParent_Done,
     /* 233430 */   // Label 4650: @233430
     /* 233430 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(233472), // Rule ID 11447 //
     /* 233435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 233462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233470 */     GIR_RootConstrainSelectedInstOperands,
     /* 233471 */     // GIR_Coverage, 11447,
     /* 233471 */     GIR_EraseRootFromParent_Done,
     /* 233472 */   // Label 4651: @233472
     /* 233472 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(233514), // Rule ID 11448 //
     /* 233477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233501 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 233504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233512 */     GIR_RootConstrainSelectedInstOperands,
     /* 233513 */     // GIR_Coverage, 11448,
     /* 233513 */     GIR_EraseRootFromParent_Done,
     /* 233514 */   // Label 4652: @233514
     /* 233514 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(233556), // Rule ID 11449 //
     /* 233519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 233546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233554 */     GIR_RootConstrainSelectedInstOperands,
     /* 233555 */     // GIR_Coverage, 11449,
     /* 233555 */     GIR_EraseRootFromParent_Done,
     /* 233556 */   // Label 4653: @233556
     /* 233556 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(233598), // Rule ID 11450 //
     /* 233561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 233588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233596 */     GIR_RootConstrainSelectedInstOperands,
     /* 233597 */     // GIR_Coverage, 11450,
     /* 233597 */     GIR_EraseRootFromParent_Done,
     /* 233598 */   // Label 4654: @233598
     /* 233598 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(233640), // Rule ID 11451 //
     /* 233603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 233630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233638 */     GIR_RootConstrainSelectedInstOperands,
     /* 233639 */     // GIR_Coverage, 11451,
     /* 233639 */     GIR_EraseRootFromParent_Done,
     /* 233640 */   // Label 4655: @233640
     /* 233640 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(233682), // Rule ID 11452 //
     /* 233645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233669 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 233672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233680 */     GIR_RootConstrainSelectedInstOperands,
     /* 233681 */     // GIR_Coverage, 11452,
     /* 233681 */     GIR_EraseRootFromParent_Done,
     /* 233682 */   // Label 4656: @233682
     /* 233682 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(233724), // Rule ID 11453 //
     /* 233687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 233714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233722 */     GIR_RootConstrainSelectedInstOperands,
     /* 233723 */     // GIR_Coverage, 11453,
     /* 233723 */     GIR_EraseRootFromParent_Done,
     /* 233724 */   // Label 4657: @233724
     /* 233724 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(233766), // Rule ID 11454 //
     /* 233729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233753 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 233756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233764 */     GIR_RootConstrainSelectedInstOperands,
     /* 233765 */     // GIR_Coverage, 11454,
     /* 233765 */     GIR_EraseRootFromParent_Done,
     /* 233766 */   // Label 4658: @233766
     /* 233766 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(233808), // Rule ID 11455 //
     /* 233771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233795 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 233798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233806 */     GIR_RootConstrainSelectedInstOperands,
     /* 233807 */     // GIR_Coverage, 11455,
     /* 233807 */     GIR_EraseRootFromParent_Done,
     /* 233808 */   // Label 4659: @233808
     /* 233808 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(233850), // Rule ID 11456 //
     /* 233813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233837 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 233840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233848 */     GIR_RootConstrainSelectedInstOperands,
     /* 233849 */     // GIR_Coverage, 11456,
     /* 233849 */     GIR_EraseRootFromParent_Done,
     /* 233850 */   // Label 4660: @233850
     /* 233850 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(233892), // Rule ID 11457 //
     /* 233855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233879 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 233882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233890 */     GIR_RootConstrainSelectedInstOperands,
     /* 233891 */     // GIR_Coverage, 11457,
     /* 233891 */     GIR_EraseRootFromParent_Done,
     /* 233892 */   // Label 4661: @233892
     /* 233892 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(233934), // Rule ID 11458 //
     /* 233897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 233924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233932 */     GIR_RootConstrainSelectedInstOperands,
     /* 233933 */     // GIR_Coverage, 11458,
     /* 233933 */     GIR_EraseRootFromParent_Done,
     /* 233934 */   // Label 4662: @233934
     /* 233934 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(233976), // Rule ID 11459 //
     /* 233939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233963 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1978:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 233966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233974 */     GIR_RootConstrainSelectedInstOperands,
     /* 233975 */     // GIR_Coverage, 11459,
     /* 233975 */     GIR_EraseRootFromParent_Done,
     /* 233976 */   // Label 4663: @233976
     /* 233976 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(234018), // Rule ID 11460 //
     /* 233981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234005 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1978:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 234008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234016 */     GIR_RootConstrainSelectedInstOperands,
     /* 234017 */     // GIR_Coverage, 11460,
     /* 234017 */     GIR_EraseRootFromParent_Done,
     /* 234018 */   // Label 4664: @234018
     /* 234018 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(234060), // Rule ID 11461 //
     /* 234023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234047 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 234050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234058 */     GIR_RootConstrainSelectedInstOperands,
     /* 234059 */     // GIR_Coverage, 11461,
     /* 234059 */     GIR_EraseRootFromParent_Done,
     /* 234060 */   // Label 4665: @234060
     /* 234060 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(234102), // Rule ID 11462 //
     /* 234065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 234092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234100 */     GIR_RootConstrainSelectedInstOperands,
     /* 234101 */     // GIR_Coverage, 11462,
     /* 234101 */     GIR_EraseRootFromParent_Done,
     /* 234102 */   // Label 4666: @234102
     /* 234102 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(234144), // Rule ID 11463 //
     /* 234107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 234115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 234134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234142 */     GIR_RootConstrainSelectedInstOperands,
     /* 234143 */     // GIR_Coverage, 11463,
     /* 234143 */     GIR_EraseRootFromParent_Done,
     /* 234144 */   // Label 4667: @234144
     /* 234144 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(234186), // Rule ID 11474 //
     /* 234149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 234166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234173 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 234176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234184 */     GIR_RootConstrainSelectedInstOperands,
     /* 234185 */     // GIR_Coverage, 11474,
     /* 234185 */     GIR_EraseRootFromParent_Done,
     /* 234186 */   // Label 4668: @234186
     /* 234186 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(234228), // Rule ID 11475 //
     /* 234191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234215 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 234218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234226 */     GIR_RootConstrainSelectedInstOperands,
     /* 234227 */     // GIR_Coverage, 11475,
     /* 234227 */     GIR_EraseRootFromParent_Done,
     /* 234228 */   // Label 4669: @234228
     /* 234228 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(234270), // Rule ID 11476 //
     /* 234233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234257 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 234260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234268 */     GIR_RootConstrainSelectedInstOperands,
     /* 234269 */     // GIR_Coverage, 11476,
     /* 234269 */     GIR_EraseRootFromParent_Done,
     /* 234270 */   // Label 4670: @234270
     /* 234270 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(234312), // Rule ID 11477 //
     /* 234275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234299 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 234302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234310 */     GIR_RootConstrainSelectedInstOperands,
     /* 234311 */     // GIR_Coverage, 11477,
     /* 234311 */     GIR_EraseRootFromParent_Done,
     /* 234312 */   // Label 4671: @234312
     /* 234312 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(234354), // Rule ID 11486 //
     /* 234317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234341 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 234344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234352 */     GIR_RootConstrainSelectedInstOperands,
     /* 234353 */     // GIR_Coverage, 11486,
     /* 234353 */     GIR_EraseRootFromParent_Done,
     /* 234354 */   // Label 4672: @234354
     /* 234354 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(234396), // Rule ID 11487 //
     /* 234359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 234386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234394 */     GIR_RootConstrainSelectedInstOperands,
     /* 234395 */     // GIR_Coverage, 11487,
     /* 234395 */     GIR_EraseRootFromParent_Done,
     /* 234396 */   // Label 4673: @234396
     /* 234396 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(234438), // Rule ID 11488 //
     /* 234401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 234428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234436 */     GIR_RootConstrainSelectedInstOperands,
     /* 234437 */     // GIR_Coverage, 11488,
     /* 234437 */     GIR_EraseRootFromParent_Done,
     /* 234438 */   // Label 4674: @234438
     /* 234438 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(234480), // Rule ID 11489 //
     /* 234443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234467 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 234470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234478 */     GIR_RootConstrainSelectedInstOperands,
     /* 234479 */     // GIR_Coverage, 11489,
     /* 234479 */     GIR_EraseRootFromParent_Done,
     /* 234480 */   // Label 4675: @234480
     /* 234480 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(234522), // Rule ID 11490 //
     /* 234485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234509 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1996:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 234512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234520 */     GIR_RootConstrainSelectedInstOperands,
     /* 234521 */     // GIR_Coverage, 11490,
     /* 234521 */     GIR_EraseRootFromParent_Done,
     /* 234522 */   // Label 4676: @234522
     /* 234522 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(234564), // Rule ID 11491 //
     /* 234527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234551 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1996:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 234554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234562 */     GIR_RootConstrainSelectedInstOperands,
     /* 234563 */     // GIR_Coverage, 11491,
     /* 234563 */     GIR_EraseRootFromParent_Done,
     /* 234564 */   // Label 4677: @234564
     /* 234564 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(234606), // Rule ID 11492 //
     /* 234569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234593 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 234596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234604 */     GIR_RootConstrainSelectedInstOperands,
     /* 234605 */     // GIR_Coverage, 11492,
     /* 234605 */     GIR_EraseRootFromParent_Done,
     /* 234606 */   // Label 4678: @234606
     /* 234606 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(234648), // Rule ID 11493 //
     /* 234611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234635 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 234638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234646 */     GIR_RootConstrainSelectedInstOperands,
     /* 234647 */     // GIR_Coverage, 11493,
     /* 234647 */     GIR_EraseRootFromParent_Done,
     /* 234648 */   // Label 4679: @234648
     /* 234648 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(234690), // Rule ID 11494 //
     /* 234653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234677 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 234680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234688 */     GIR_RootConstrainSelectedInstOperands,
     /* 234689 */     // GIR_Coverage, 11494,
     /* 234689 */     GIR_EraseRootFromParent_Done,
     /* 234690 */   // Label 4680: @234690
     /* 234690 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(234732), // Rule ID 11495 //
     /* 234695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234719 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 234722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234730 */     GIR_RootConstrainSelectedInstOperands,
     /* 234731 */     // GIR_Coverage, 11495,
     /* 234731 */     GIR_EraseRootFromParent_Done,
     /* 234732 */   // Label 4681: @234732
     /* 234732 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(234774), // Rule ID 11496 //
     /* 234737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 234764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234772 */     GIR_RootConstrainSelectedInstOperands,
     /* 234773 */     // GIR_Coverage, 11496,
     /* 234773 */     GIR_EraseRootFromParent_Done,
     /* 234774 */   // Label 4682: @234774
     /* 234774 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(234816), // Rule ID 11497 //
     /* 234779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234803 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1847:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 234806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234814 */     GIR_RootConstrainSelectedInstOperands,
     /* 234815 */     // GIR_Coverage, 11497,
     /* 234815 */     GIR_EraseRootFromParent_Done,
     /* 234816 */   // Label 4683: @234816
     /* 234816 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(234858), // Rule ID 11498 //
     /* 234821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234845 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 234848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234856 */     GIR_RootConstrainSelectedInstOperands,
     /* 234857 */     // GIR_Coverage, 11498,
     /* 234857 */     GIR_EraseRootFromParent_Done,
     /* 234858 */   // Label 4684: @234858
     /* 234858 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(234900), // Rule ID 11499 //
     /* 234863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 234890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234898 */     GIR_RootConstrainSelectedInstOperands,
     /* 234899 */     // GIR_Coverage, 11499,
     /* 234899 */     GIR_EraseRootFromParent_Done,
     /* 234900 */   // Label 4685: @234900
     /* 234900 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(234942), // Rule ID 11500 //
     /* 234905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 234932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234940 */     GIR_RootConstrainSelectedInstOperands,
     /* 234941 */     // GIR_Coverage, 11500,
     /* 234941 */     GIR_EraseRootFromParent_Done,
     /* 234942 */   // Label 4686: @234942
     /* 234942 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(234984), // Rule ID 11501 //
     /* 234947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234971 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 234974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234982 */     GIR_RootConstrainSelectedInstOperands,
     /* 234983 */     // GIR_Coverage, 11501,
     /* 234983 */     GIR_EraseRootFromParent_Done,
     /* 234984 */   // Label 4687: @234984
     /* 234984 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(235026), // Rule ID 11502 //
     /* 234989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 234997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235013 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 235016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235024 */     GIR_RootConstrainSelectedInstOperands,
     /* 235025 */     // GIR_Coverage, 11502,
     /* 235025 */     GIR_EraseRootFromParent_Done,
     /* 235026 */   // Label 4688: @235026
     /* 235026 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(235068), // Rule ID 11503 //
     /* 235031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235055 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 235058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235066 */     GIR_RootConstrainSelectedInstOperands,
     /* 235067 */     // GIR_Coverage, 11503,
     /* 235067 */     GIR_EraseRootFromParent_Done,
     /* 235068 */   // Label 4689: @235068
     /* 235068 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(235110), // Rule ID 11504 //
     /* 235073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235097 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 235100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235108 */     GIR_RootConstrainSelectedInstOperands,
     /* 235109 */     // GIR_Coverage, 11504,
     /* 235109 */     GIR_EraseRootFromParent_Done,
     /* 235110 */   // Label 4690: @235110
     /* 235110 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(235152), // Rule ID 11505 //
     /* 235115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235139 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1911:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 235142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235150 */     GIR_RootConstrainSelectedInstOperands,
     /* 235151 */     // GIR_Coverage, 11505,
     /* 235151 */     GIR_EraseRootFromParent_Done,
     /* 235152 */   // Label 4691: @235152
     /* 235152 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(235194), // Rule ID 11506 //
     /* 235157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235181 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2061:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 235184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235192 */     GIR_RootConstrainSelectedInstOperands,
     /* 235193 */     // GIR_Coverage, 11506,
     /* 235193 */     GIR_EraseRootFromParent_Done,
     /* 235194 */   // Label 4692: @235194
     /* 235194 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(235236), // Rule ID 11507 //
     /* 235199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235223 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2061:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 235226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235234 */     GIR_RootConstrainSelectedInstOperands,
     /* 235235 */     // GIR_Coverage, 11507,
     /* 235235 */     GIR_EraseRootFromParent_Done,
     /* 235236 */   // Label 4693: @235236
     /* 235236 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(235278), // Rule ID 11508 //
     /* 235241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 235268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235276 */     GIR_RootConstrainSelectedInstOperands,
     /* 235277 */     // GIR_Coverage, 11508,
     /* 235277 */     GIR_EraseRootFromParent_Done,
     /* 235278 */   // Label 4694: @235278
     /* 235278 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(235320), // Rule ID 11509 //
     /* 235283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235307 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2061:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 235310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235318 */     GIR_RootConstrainSelectedInstOperands,
     /* 235319 */     // GIR_Coverage, 11509,
     /* 235319 */     GIR_EraseRootFromParent_Done,
     /* 235320 */   // Label 4695: @235320
     /* 235320 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(235362), // Rule ID 11510 //
     /* 235325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235349 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 235352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235360 */     GIR_RootConstrainSelectedInstOperands,
     /* 235361 */     // GIR_Coverage, 11510,
     /* 235361 */     GIR_EraseRootFromParent_Done,
     /* 235362 */   // Label 4696: @235362
     /* 235362 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(235404), // Rule ID 11511 //
     /* 235367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 235394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235402 */     GIR_RootConstrainSelectedInstOperands,
     /* 235403 */     // GIR_Coverage, 11511,
     /* 235403 */     GIR_EraseRootFromParent_Done,
     /* 235404 */   // Label 4697: @235404
     /* 235404 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(235446), // Rule ID 11512 //
     /* 235409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 235436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235444 */     GIR_RootConstrainSelectedInstOperands,
     /* 235445 */     // GIR_Coverage, 11512,
     /* 235445 */     GIR_EraseRootFromParent_Done,
     /* 235446 */   // Label 4698: @235446
     /* 235446 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(235488), // Rule ID 11513 //
     /* 235451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235475 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1850:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 235478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235486 */     GIR_RootConstrainSelectedInstOperands,
     /* 235487 */     // GIR_Coverage, 11513,
     /* 235487 */     GIR_EraseRootFromParent_Done,
     /* 235488 */   // Label 4699: @235488
     /* 235488 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(235530), // Rule ID 11514 //
     /* 235493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235517 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 235520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235528 */     GIR_RootConstrainSelectedInstOperands,
     /* 235529 */     // GIR_Coverage, 11514,
     /* 235529 */     GIR_EraseRootFromParent_Done,
     /* 235530 */   // Label 4700: @235530
     /* 235530 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(235572), // Rule ID 11515 //
     /* 235535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235559 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 235562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235570 */     GIR_RootConstrainSelectedInstOperands,
     /* 235571 */     // GIR_Coverage, 11515,
     /* 235571 */     GIR_EraseRootFromParent_Done,
     /* 235572 */   // Label 4701: @235572
     /* 235572 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(235614), // Rule ID 11516 //
     /* 235577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 235604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235612 */     GIR_RootConstrainSelectedInstOperands,
     /* 235613 */     // GIR_Coverage, 11516,
     /* 235613 */     GIR_EraseRootFromParent_Done,
     /* 235614 */   // Label 4702: @235614
     /* 235614 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(235656), // Rule ID 11517 //
     /* 235619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2043:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 235646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235654 */     GIR_RootConstrainSelectedInstOperands,
     /* 235655 */     // GIR_Coverage, 11517,
     /* 235655 */     GIR_EraseRootFromParent_Done,
     /* 235656 */   // Label 4703: @235656
     /* 235656 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(235698), // Rule ID 11518 //
     /* 235661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235685 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 235688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235696 */     GIR_RootConstrainSelectedInstOperands,
     /* 235697 */     // GIR_Coverage, 11518,
     /* 235697 */     GIR_EraseRootFromParent_Done,
     /* 235698 */   // Label 4704: @235698
     /* 235698 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(235740), // Rule ID 11519 //
     /* 235703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235727 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 235730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235738 */     GIR_RootConstrainSelectedInstOperands,
     /* 235739 */     // GIR_Coverage, 11519,
     /* 235739 */     GIR_EraseRootFromParent_Done,
     /* 235740 */   // Label 4705: @235740
     /* 235740 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(235782), // Rule ID 11520 //
     /* 235745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235769 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 235772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235780 */     GIR_RootConstrainSelectedInstOperands,
     /* 235781 */     // GIR_Coverage, 11520,
     /* 235781 */     GIR_EraseRootFromParent_Done,
     /* 235782 */   // Label 4706: @235782
     /* 235782 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(235824), // Rule ID 11521 //
     /* 235787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235811 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 235814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235822 */     GIR_RootConstrainSelectedInstOperands,
     /* 235823 */     // GIR_Coverage, 11521,
     /* 235823 */     GIR_EraseRootFromParent_Done,
     /* 235824 */   // Label 4707: @235824
     /* 235824 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(235866), // Rule ID 11522 //
     /* 235829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235853 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 235856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235864 */     GIR_RootConstrainSelectedInstOperands,
     /* 235865 */     // GIR_Coverage, 11522,
     /* 235865 */     GIR_EraseRootFromParent_Done,
     /* 235866 */   // Label 4708: @235866
     /* 235866 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(235908), // Rule ID 11523 //
     /* 235871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235895 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 235898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235906 */     GIR_RootConstrainSelectedInstOperands,
     /* 235907 */     // GIR_Coverage, 11523,
     /* 235907 */     GIR_EraseRootFromParent_Done,
     /* 235908 */   // Label 4709: @235908
     /* 235908 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(235950), // Rule ID 11524 //
     /* 235913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 235940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235948 */     GIR_RootConstrainSelectedInstOperands,
     /* 235949 */     // GIR_Coverage, 11524,
     /* 235949 */     GIR_EraseRootFromParent_Done,
     /* 235950 */   // Label 4710: @235950
     /* 235950 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(235992), // Rule ID 11525 //
     /* 235955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235979 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 235982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235990 */     GIR_RootConstrainSelectedInstOperands,
     /* 235991 */     // GIR_Coverage, 11525,
     /* 235991 */     GIR_EraseRootFromParent_Done,
     /* 235992 */   // Label 4711: @235992
     /* 235992 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(236034), // Rule ID 11526 //
     /* 235997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236021 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 236024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236032 */     GIR_RootConstrainSelectedInstOperands,
     /* 236033 */     // GIR_Coverage, 11526,
     /* 236033 */     GIR_EraseRootFromParent_Done,
     /* 236034 */   // Label 4712: @236034
     /* 236034 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(236076), // Rule ID 11527 //
     /* 236039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236063 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 236066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236074 */     GIR_RootConstrainSelectedInstOperands,
     /* 236075 */     // GIR_Coverage, 11527,
     /* 236075 */     GIR_EraseRootFromParent_Done,
     /* 236076 */   // Label 4713: @236076
     /* 236076 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(236118), // Rule ID 11528 //
     /* 236081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 236108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236116 */     GIR_RootConstrainSelectedInstOperands,
     /* 236117 */     // GIR_Coverage, 11528,
     /* 236117 */     GIR_EraseRootFromParent_Done,
     /* 236118 */   // Label 4714: @236118
     /* 236118 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(236160), // Rule ID 11529 //
     /* 236123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236147 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 236150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236158 */     GIR_RootConstrainSelectedInstOperands,
     /* 236159 */     // GIR_Coverage, 11529,
     /* 236159 */     GIR_EraseRootFromParent_Done,
     /* 236160 */   // Label 4715: @236160
     /* 236160 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(236202), // Rule ID 11530 //
     /* 236165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236189 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 236192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236200 */     GIR_RootConstrainSelectedInstOperands,
     /* 236201 */     // GIR_Coverage, 11530,
     /* 236201 */     GIR_EraseRootFromParent_Done,
     /* 236202 */   // Label 4716: @236202
     /* 236202 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(236244), // Rule ID 11531 //
     /* 236207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236231 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 236234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236242 */     GIR_RootConstrainSelectedInstOperands,
     /* 236243 */     // GIR_Coverage, 11531,
     /* 236243 */     GIR_EraseRootFromParent_Done,
     /* 236244 */   // Label 4717: @236244
     /* 236244 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(236286), // Rule ID 11532 //
     /* 236249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 236276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236284 */     GIR_RootConstrainSelectedInstOperands,
     /* 236285 */     // GIR_Coverage, 11532,
     /* 236285 */     GIR_EraseRootFromParent_Done,
     /* 236286 */   // Label 4718: @236286
     /* 236286 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(236328), // Rule ID 11533 //
     /* 236291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2037:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 236318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236326 */     GIR_RootConstrainSelectedInstOperands,
     /* 236327 */     // GIR_Coverage, 11533,
     /* 236327 */     GIR_EraseRootFromParent_Done,
     /* 236328 */   // Label 4719: @236328
     /* 236328 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(236370), // Rule ID 11534 //
     /* 236333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236357 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 236360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236368 */     GIR_RootConstrainSelectedInstOperands,
     /* 236369 */     // GIR_Coverage, 11534,
     /* 236369 */     GIR_EraseRootFromParent_Done,
     /* 236370 */   // Label 4720: @236370
     /* 236370 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(236412), // Rule ID 11535 //
     /* 236375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236399 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 236402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236410 */     GIR_RootConstrainSelectedInstOperands,
     /* 236411 */     // GIR_Coverage, 11535,
     /* 236411 */     GIR_EraseRootFromParent_Done,
     /* 236412 */   // Label 4721: @236412
     /* 236412 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(236454), // Rule ID 11536 //
     /* 236417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 236444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236452 */     GIR_RootConstrainSelectedInstOperands,
     /* 236453 */     // GIR_Coverage, 11536,
     /* 236453 */     GIR_EraseRootFromParent_Done,
     /* 236454 */   // Label 4722: @236454
     /* 236454 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(236496), // Rule ID 11537 //
     /* 236459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236483 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 236486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236494 */     GIR_RootConstrainSelectedInstOperands,
     /* 236495 */     // GIR_Coverage, 11537,
     /* 236495 */     GIR_EraseRootFromParent_Done,
     /* 236496 */   // Label 4723: @236496
     /* 236496 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(236538), // Rule ID 11538 //
     /* 236501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236525 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 236528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236536 */     GIR_RootConstrainSelectedInstOperands,
     /* 236537 */     // GIR_Coverage, 11538,
     /* 236537 */     GIR_EraseRootFromParent_Done,
     /* 236538 */   // Label 4724: @236538
     /* 236538 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(236580), // Rule ID 11539 //
     /* 236543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236567 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 236570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236578 */     GIR_RootConstrainSelectedInstOperands,
     /* 236579 */     // GIR_Coverage, 11539,
     /* 236579 */     GIR_EraseRootFromParent_Done,
     /* 236580 */   // Label 4725: @236580
     /* 236580 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(236622), // Rule ID 11540 //
     /* 236585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236609 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 236612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236620 */     GIR_RootConstrainSelectedInstOperands,
     /* 236621 */     // GIR_Coverage, 11540,
     /* 236621 */     GIR_EraseRootFromParent_Done,
     /* 236622 */   // Label 4726: @236622
     /* 236622 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(236664), // Rule ID 11541 //
     /* 236627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2030:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 236654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236662 */     GIR_RootConstrainSelectedInstOperands,
     /* 236663 */     // GIR_Coverage, 11541,
     /* 236663 */     GIR_EraseRootFromParent_Done,
     /* 236664 */   // Label 4727: @236664
     /* 236664 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(236706), // Rule ID 11704 //
     /* 236669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1930:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 236696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236704 */     GIR_RootConstrainSelectedInstOperands,
     /* 236705 */     // GIR_Coverage, 11704,
     /* 236705 */     GIR_EraseRootFromParent_Done,
     /* 236706 */   // Label 4728: @236706
     /* 236706 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(236748), // Rule ID 11706 //
     /* 236711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236735 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 236738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236746 */     GIR_RootConstrainSelectedInstOperands,
     /* 236747 */     // GIR_Coverage, 11706,
     /* 236747 */     GIR_EraseRootFromParent_Done,
     /* 236748 */   // Label 4729: @236748
     /* 236748 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(236790), // Rule ID 11708 //
     /* 236753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 236780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236788 */     GIR_RootConstrainSelectedInstOperands,
     /* 236789 */     // GIR_Coverage, 11708,
     /* 236789 */     GIR_EraseRootFromParent_Done,
     /* 236790 */   // Label 4730: @236790
     /* 236790 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(236832), // Rule ID 11710 //
     /* 236795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236819 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 236822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236830 */     GIR_RootConstrainSelectedInstOperands,
     /* 236831 */     // GIR_Coverage, 11710,
     /* 236831 */     GIR_EraseRootFromParent_Done,
     /* 236832 */   // Label 4731: @236832
     /* 236832 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(236874), // Rule ID 11712 //
     /* 236837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236861 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 236864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236872 */     GIR_RootConstrainSelectedInstOperands,
     /* 236873 */     // GIR_Coverage, 11712,
     /* 236873 */     GIR_EraseRootFromParent_Done,
     /* 236874 */   // Label 4732: @236874
     /* 236874 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(236916), // Rule ID 11713 //
     /* 236879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236903 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 236906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236914 */     GIR_RootConstrainSelectedInstOperands,
     /* 236915 */     // GIR_Coverage, 11713,
     /* 236915 */     GIR_EraseRootFromParent_Done,
     /* 236916 */   // Label 4733: @236916
     /* 236916 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(236958), // Rule ID 11714 //
     /* 236921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236945 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 236948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236956 */     GIR_RootConstrainSelectedInstOperands,
     /* 236957 */     // GIR_Coverage, 11714,
     /* 236957 */     GIR_EraseRootFromParent_Done,
     /* 236958 */   // Label 4734: @236958
     /* 236958 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(237000), // Rule ID 11715 //
     /* 236963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 236971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 236990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236998 */     GIR_RootConstrainSelectedInstOperands,
     /* 236999 */     // GIR_Coverage, 11715,
     /* 236999 */     GIR_EraseRootFromParent_Done,
     /* 237000 */   // Label 4735: @237000
     /* 237000 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(237042), // Rule ID 11716 //
     /* 237005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 237032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237040 */     GIR_RootConstrainSelectedInstOperands,
     /* 237041 */     // GIR_Coverage, 11716,
     /* 237041 */     GIR_EraseRootFromParent_Done,
     /* 237042 */   // Label 4736: @237042
     /* 237042 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(237084), // Rule ID 11717 //
     /* 237047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 237074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237082 */     GIR_RootConstrainSelectedInstOperands,
     /* 237083 */     // GIR_Coverage, 11717,
     /* 237083 */     GIR_EraseRootFromParent_Done,
     /* 237084 */   // Label 4737: @237084
     /* 237084 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(237126), // Rule ID 11718 //
     /* 237089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237113 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1932:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 237116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237124 */     GIR_RootConstrainSelectedInstOperands,
     /* 237125 */     // GIR_Coverage, 11718,
     /* 237125 */     GIR_EraseRootFromParent_Done,
     /* 237126 */   // Label 4738: @237126
     /* 237126 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(237168), // Rule ID 11719 //
     /* 237131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1932:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 237158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237166 */     GIR_RootConstrainSelectedInstOperands,
     /* 237167 */     // GIR_Coverage, 11719,
     /* 237167 */     GIR_EraseRootFromParent_Done,
     /* 237168 */   // Label 4739: @237168
     /* 237168 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(237210), // Rule ID 11720 //
     /* 237173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237197 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1932:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 237200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237208 */     GIR_RootConstrainSelectedInstOperands,
     /* 237209 */     // GIR_Coverage, 11720,
     /* 237209 */     GIR_EraseRootFromParent_Done,
     /* 237210 */   // Label 4740: @237210
     /* 237210 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(237252), // Rule ID 11721 //
     /* 237215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 237223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1245:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 237242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237250 */     GIR_RootConstrainSelectedInstOperands,
     /* 237251 */     // GIR_Coverage, 11721,
     /* 237251 */     GIR_EraseRootFromParent_Done,
     /* 237252 */   // Label 4741: @237252
     /* 237252 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(237294), // Rule ID 11722 //
     /* 237257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 237265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237281 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1245:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 237284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237292 */     GIR_RootConstrainSelectedInstOperands,
     /* 237293 */     // GIR_Coverage, 11722,
     /* 237293 */     GIR_EraseRootFromParent_Done,
     /* 237294 */   // Label 4742: @237294
     /* 237294 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(237336), // Rule ID 11723 //
     /* 237299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 237307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 237326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237334 */     GIR_RootConstrainSelectedInstOperands,
     /* 237335 */     // GIR_Coverage, 11723,
     /* 237335 */     GIR_EraseRootFromParent_Done,
     /* 237336 */   // Label 4743: @237336
     /* 237336 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(237378), // Rule ID 11724 //
     /* 237341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 237349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237365 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 237368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237376 */     GIR_RootConstrainSelectedInstOperands,
     /* 237377 */     // GIR_Coverage, 11724,
     /* 237377 */     GIR_EraseRootFromParent_Done,
     /* 237378 */   // Label 4744: @237378
     /* 237378 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(237420), // Rule ID 11725 //
     /* 237383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 237391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 237410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237418 */     GIR_RootConstrainSelectedInstOperands,
     /* 237419 */     // GIR_Coverage, 11725,
     /* 237419 */     GIR_EraseRootFromParent_Done,
     /* 237420 */   // Label 4745: @237420
     /* 237420 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(237462), // Rule ID 11726 //
     /* 237425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 237433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237449 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 237452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237460 */     GIR_RootConstrainSelectedInstOperands,
     /* 237461 */     // GIR_Coverage, 11726,
     /* 237461 */     GIR_EraseRootFromParent_Done,
     /* 237462 */   // Label 4746: @237462
     /* 237462 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(237504), // Rule ID 11781 //
     /* 237467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237491 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 237494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237502 */     GIR_RootConstrainSelectedInstOperands,
     /* 237503 */     // GIR_Coverage, 11781,
     /* 237503 */     GIR_EraseRootFromParent_Done,
     /* 237504 */   // Label 4747: @237504
     /* 237504 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(237546), // Rule ID 11782 //
     /* 237509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237533 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 237536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237544 */     GIR_RootConstrainSelectedInstOperands,
     /* 237545 */     // GIR_Coverage, 11782,
     /* 237545 */     GIR_EraseRootFromParent_Done,
     /* 237546 */   // Label 4748: @237546
     /* 237546 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(237588), // Rule ID 11783 //
     /* 237551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 237578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237586 */     GIR_RootConstrainSelectedInstOperands,
     /* 237587 */     // GIR_Coverage, 11783,
     /* 237587 */     GIR_EraseRootFromParent_Done,
     /* 237588 */   // Label 4749: @237588
     /* 237588 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237630), // Rule ID 11784 //
     /* 237593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237617 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 237620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237628 */     GIR_RootConstrainSelectedInstOperands,
     /* 237629 */     // GIR_Coverage, 11784,
     /* 237629 */     GIR_EraseRootFromParent_Done,
     /* 237630 */   // Label 4750: @237630
     /* 237630 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237672), // Rule ID 11785 //
     /* 237635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 237662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237670 */     GIR_RootConstrainSelectedInstOperands,
     /* 237671 */     // GIR_Coverage, 11785,
     /* 237671 */     GIR_EraseRootFromParent_Done,
     /* 237672 */   // Label 4751: @237672
     /* 237672 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237714), // Rule ID 11786 //
     /* 237677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 237704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237712 */     GIR_RootConstrainSelectedInstOperands,
     /* 237713 */     // GIR_Coverage, 11786,
     /* 237713 */     GIR_EraseRootFromParent_Done,
     /* 237714 */   // Label 4752: @237714
     /* 237714 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237756), // Rule ID 11787 //
     /* 237719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237743 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1679:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 237746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237754 */     GIR_RootConstrainSelectedInstOperands,
     /* 237755 */     // GIR_Coverage, 11787,
     /* 237755 */     GIR_EraseRootFromParent_Done,
     /* 237756 */   // Label 4753: @237756
     /* 237756 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237798), // Rule ID 11788 //
     /* 237761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237785 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1679:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 237788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237796 */     GIR_RootConstrainSelectedInstOperands,
     /* 237797 */     // GIR_Coverage, 11788,
     /* 237797 */     GIR_EraseRootFromParent_Done,
     /* 237798 */   // Label 4754: @237798
     /* 237798 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237840), // Rule ID 11789 //
     /* 237803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1679:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 237830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237838 */     GIR_RootConstrainSelectedInstOperands,
     /* 237839 */     // GIR_Coverage, 11789,
     /* 237839 */     GIR_EraseRootFromParent_Done,
     /* 237840 */   // Label 4755: @237840
     /* 237840 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237885), // Rule ID 11802 //
     /* 237845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 237853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237869 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 237872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237883 */     GIR_RootConstrainSelectedInstOperands,
     /* 237884 */     // GIR_Coverage, 11802,
     /* 237884 */     GIR_EraseRootFromParent_Done,
     /* 237885 */   // Label 4756: @237885
     /* 237885 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(237930), // Rule ID 11803 //
     /* 237890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 237898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237914 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 237917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237928 */     GIR_RootConstrainSelectedInstOperands,
     /* 237929 */     // GIR_Coverage, 11803,
     /* 237929 */     GIR_EraseRootFromParent_Done,
     /* 237930 */   // Label 4757: @237930
     /* 237930 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(237972), // Rule ID 11804 //
     /* 237935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237959 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1354:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 237962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237970 */     GIR_RootConstrainSelectedInstOperands,
     /* 237971 */     // GIR_Coverage, 11804,
     /* 237971 */     GIR_EraseRootFromParent_Done,
     /* 237972 */   // Label 4758: @237972
     /* 237972 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(238014), // Rule ID 11805 //
     /* 237977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238001 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1354:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 238004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238012 */     GIR_RootConstrainSelectedInstOperands,
     /* 238013 */     // GIR_Coverage, 11805,
     /* 238013 */     GIR_EraseRootFromParent_Done,
     /* 238014 */   // Label 4759: @238014
     /* 238014 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(238056), // Rule ID 11806 //
     /* 238019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1354:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 238046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238054 */     GIR_RootConstrainSelectedInstOperands,
     /* 238055 */     // GIR_Coverage, 11806,
     /* 238055 */     GIR_EraseRootFromParent_Done,
     /* 238056 */   // Label 4760: @238056
     /* 238056 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(238098), // Rule ID 11807 //
     /* 238061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238085 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1354:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 238088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238096 */     GIR_RootConstrainSelectedInstOperands,
     /* 238097 */     // GIR_Coverage, 11807,
     /* 238097 */     GIR_EraseRootFromParent_Done,
     /* 238098 */   // Label 4761: @238098
     /* 238098 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(238140), // Rule ID 11823 //
     /* 238103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238127 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1437:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 238130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238138 */     GIR_RootConstrainSelectedInstOperands,
     /* 238139 */     // GIR_Coverage, 11823,
     /* 238139 */     GIR_EraseRootFromParent_Done,
     /* 238140 */   // Label 4762: @238140
     /* 238140 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(238182), // Rule ID 11824 //
     /* 238145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238169 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1437:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 238172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238180 */     GIR_RootConstrainSelectedInstOperands,
     /* 238181 */     // GIR_Coverage, 11824,
     /* 238181 */     GIR_EraseRootFromParent_Done,
     /* 238182 */   // Label 4763: @238182
     /* 238182 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(238224), // Rule ID 11825 //
     /* 238187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238211 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1437:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 238214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238222 */     GIR_RootConstrainSelectedInstOperands,
     /* 238223 */     // GIR_Coverage, 11825,
     /* 238223 */     GIR_EraseRootFromParent_Done,
     /* 238224 */   // Label 4764: @238224
     /* 238224 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(238266), // Rule ID 11826 //
     /* 238229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238253 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1455:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 238256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238264 */     GIR_RootConstrainSelectedInstOperands,
     /* 238265 */     // GIR_Coverage, 11826,
     /* 238265 */     GIR_EraseRootFromParent_Done,
     /* 238266 */   // Label 4765: @238266
     /* 238266 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(238308), // Rule ID 11827 //
     /* 238271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238295 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1455:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 238298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238306 */     GIR_RootConstrainSelectedInstOperands,
     /* 238307 */     // GIR_Coverage, 11827,
     /* 238307 */     GIR_EraseRootFromParent_Done,
     /* 238308 */   // Label 4766: @238308
     /* 238308 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(238350), // Rule ID 11828 //
     /* 238313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238337 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1455:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 238340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238348 */     GIR_RootConstrainSelectedInstOperands,
     /* 238349 */     // GIR_Coverage, 11828,
     /* 238349 */     GIR_EraseRootFromParent_Done,
     /* 238350 */   // Label 4767: @238350
     /* 238350 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238392), // Rule ID 11829 //
     /* 238355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238379 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1440:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 238382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238390 */     GIR_RootConstrainSelectedInstOperands,
     /* 238391 */     // GIR_Coverage, 11829,
     /* 238391 */     GIR_EraseRootFromParent_Done,
     /* 238392 */   // Label 4768: @238392
     /* 238392 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238434), // Rule ID 11830 //
     /* 238397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238421 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1440:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 238424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238432 */     GIR_RootConstrainSelectedInstOperands,
     /* 238433 */     // GIR_Coverage, 11830,
     /* 238433 */     GIR_EraseRootFromParent_Done,
     /* 238434 */   // Label 4769: @238434
     /* 238434 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238476), // Rule ID 11831 //
     /* 238439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238463 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1440:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 238466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238474 */     GIR_RootConstrainSelectedInstOperands,
     /* 238475 */     // GIR_Coverage, 11831,
     /* 238475 */     GIR_EraseRootFromParent_Done,
     /* 238476 */   // Label 4770: @238476
     /* 238476 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238518), // Rule ID 11832 //
     /* 238481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238505 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1458:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 238508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238516 */     GIR_RootConstrainSelectedInstOperands,
     /* 238517 */     // GIR_Coverage, 11832,
     /* 238517 */     GIR_EraseRootFromParent_Done,
     /* 238518 */   // Label 4771: @238518
     /* 238518 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238560), // Rule ID 11833 //
     /* 238523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238547 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 238550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238558 */     GIR_RootConstrainSelectedInstOperands,
     /* 238559 */     // GIR_Coverage, 11833,
     /* 238559 */     GIR_EraseRootFromParent_Done,
     /* 238560 */   // Label 4772: @238560
     /* 238560 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238602), // Rule ID 11834 //
     /* 238565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238589 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1458:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 238592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238600 */     GIR_RootConstrainSelectedInstOperands,
     /* 238601 */     // GIR_Coverage, 11834,
     /* 238601 */     GIR_EraseRootFromParent_Done,
     /* 238602 */   // Label 4773: @238602
     /* 238602 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238644), // Rule ID 11839 //
     /* 238607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 238615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238631 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 238634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238642 */     GIR_RootConstrainSelectedInstOperands,
     /* 238643 */     // GIR_Coverage, 11839,
     /* 238643 */     GIR_EraseRootFromParent_Done,
     /* 238644 */   // Label 4774: @238644
     /* 238644 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238686), // Rule ID 11840 //
     /* 238649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 238657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238673 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 238676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238684 */     GIR_RootConstrainSelectedInstOperands,
     /* 238685 */     // GIR_Coverage, 11840,
     /* 238685 */     GIR_EraseRootFromParent_Done,
     /* 238686 */   // Label 4775: @238686
     /* 238686 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238728), // Rule ID 11841 //
     /* 238691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 238699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238715 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 238718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238726 */     GIR_RootConstrainSelectedInstOperands,
     /* 238727 */     // GIR_Coverage, 11841,
     /* 238727 */     GIR_EraseRootFromParent_Done,
     /* 238728 */   // Label 4776: @238728
     /* 238728 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238770), // Rule ID 11842 //
     /* 238733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 238741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238757 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 238760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238768 */     GIR_RootConstrainSelectedInstOperands,
     /* 238769 */     // GIR_Coverage, 11842,
     /* 238769 */     GIR_EraseRootFromParent_Done,
     /* 238770 */   // Label 4777: @238770
     /* 238770 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238812), // Rule ID 11843 //
     /* 238775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238799 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1271:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238810 */     GIR_RootConstrainSelectedInstOperands,
     /* 238811 */     // GIR_Coverage, 11843,
     /* 238811 */     GIR_EraseRootFromParent_Done,
     /* 238812 */   // Label 4778: @238812
     /* 238812 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238854), // Rule ID 11845 //
     /* 238817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238841 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1271:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238852 */     GIR_RootConstrainSelectedInstOperands,
     /* 238853 */     // GIR_Coverage, 11845,
     /* 238853 */     GIR_EraseRootFromParent_Done,
     /* 238854 */   // Label 4779: @238854
     /* 238854 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238896), // Rule ID 11847 //
     /* 238859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1271:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238894 */     GIR_RootConstrainSelectedInstOperands,
     /* 238895 */     // GIR_Coverage, 11847,
     /* 238895 */     GIR_EraseRootFromParent_Done,
     /* 238896 */   // Label 4780: @238896
     /* 238896 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(238938), // Rule ID 11849 //
     /* 238901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1271:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238936 */     GIR_RootConstrainSelectedInstOperands,
     /* 238937 */     // GIR_Coverage, 11849,
     /* 238937 */     GIR_EraseRootFromParent_Done,
     /* 238938 */   // Label 4781: @238938
     /* 238938 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(238980), // Rule ID 11851 //
     /* 238943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1300:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 238970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238978 */     GIR_RootConstrainSelectedInstOperands,
     /* 238979 */     // GIR_Coverage, 11851,
     /* 238979 */     GIR_EraseRootFromParent_Done,
     /* 238980 */   // Label 4782: @238980
     /* 238980 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(239022), // Rule ID 11853 //
     /* 238985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1300:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239020 */     GIR_RootConstrainSelectedInstOperands,
     /* 239021 */     // GIR_Coverage, 11853,
     /* 239021 */     GIR_EraseRootFromParent_Done,
     /* 239022 */   // Label 4783: @239022
     /* 239022 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(239064), // Rule ID 11855 //
     /* 239027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1300:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239062 */     GIR_RootConstrainSelectedInstOperands,
     /* 239063 */     // GIR_Coverage, 11855,
     /* 239063 */     GIR_EraseRootFromParent_Done,
     /* 239064 */   // Label 4784: @239064
     /* 239064 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(239106), // Rule ID 11857 //
     /* 239069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1300:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239104 */     GIR_RootConstrainSelectedInstOperands,
     /* 239105 */     // GIR_Coverage, 11857,
     /* 239105 */     GIR_EraseRootFromParent_Done,
     /* 239106 */   // Label 4785: @239106
     /* 239106 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(239148), // Rule ID 11859 //
     /* 239111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239135 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1301:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239146 */     GIR_RootConstrainSelectedInstOperands,
     /* 239147 */     // GIR_Coverage, 11859,
     /* 239147 */     GIR_EraseRootFromParent_Done,
     /* 239148 */   // Label 4786: @239148
     /* 239148 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(239190), // Rule ID 11860 //
     /* 239153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1301:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239188 */     GIR_RootConstrainSelectedInstOperands,
     /* 239189 */     // GIR_Coverage, 11860,
     /* 239189 */     GIR_EraseRootFromParent_Done,
     /* 239190 */   // Label 4787: @239190
     /* 239190 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239232), // Rule ID 11861 //
     /* 239195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1301:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239230 */     GIR_RootConstrainSelectedInstOperands,
     /* 239231 */     // GIR_Coverage, 11861,
     /* 239231 */     GIR_EraseRootFromParent_Done,
     /* 239232 */   // Label 4788: @239232
     /* 239232 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239274), // Rule ID 11862 //
     /* 239237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239261 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1301:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239272 */     GIR_RootConstrainSelectedInstOperands,
     /* 239273 */     // GIR_Coverage, 11862,
     /* 239273 */     GIR_EraseRootFromParent_Done,
     /* 239274 */   // Label 4789: @239274
     /* 239274 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239316), // Rule ID 11863 //
     /* 239279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239303 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1302:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239314 */     GIR_RootConstrainSelectedInstOperands,
     /* 239315 */     // GIR_Coverage, 11863,
     /* 239315 */     GIR_EraseRootFromParent_Done,
     /* 239316 */   // Label 4790: @239316
     /* 239316 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239358), // Rule ID 11864 //
     /* 239321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239345 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1302:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239356 */     GIR_RootConstrainSelectedInstOperands,
     /* 239357 */     // GIR_Coverage, 11864,
     /* 239357 */     GIR_EraseRootFromParent_Done,
     /* 239358 */   // Label 4791: @239358
     /* 239358 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239400), // Rule ID 11865 //
     /* 239363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1302:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239398 */     GIR_RootConstrainSelectedInstOperands,
     /* 239399 */     // GIR_Coverage, 11865,
     /* 239399 */     GIR_EraseRootFromParent_Done,
     /* 239400 */   // Label 4792: @239400
     /* 239400 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239442), // Rule ID 11866 //
     /* 239405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1302:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239440 */     GIR_RootConstrainSelectedInstOperands,
     /* 239441 */     // GIR_Coverage, 11866,
     /* 239441 */     GIR_EraseRootFromParent_Done,
     /* 239442 */   // Label 4793: @239442
     /* 239442 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239484), // Rule ID 11867 //
     /* 239447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1612:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239482 */     GIR_RootConstrainSelectedInstOperands,
     /* 239483 */     // GIR_Coverage, 11867,
     /* 239483 */     GIR_EraseRootFromParent_Done,
     /* 239484 */   // Label 4794: @239484
     /* 239484 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239526), // Rule ID 11869 //
     /* 239489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239513 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239524 */     GIR_RootConstrainSelectedInstOperands,
     /* 239525 */     // GIR_Coverage, 11869,
     /* 239525 */     GIR_EraseRootFromParent_Done,
     /* 239526 */   // Label 4795: @239526
     /* 239526 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239568), // Rule ID 11871 //
     /* 239531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239566 */     GIR_RootConstrainSelectedInstOperands,
     /* 239567 */     // GIR_Coverage, 11871,
     /* 239567 */     GIR_EraseRootFromParent_Done,
     /* 239568 */   // Label 4796: @239568
     /* 239568 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239610), // Rule ID 11873 //
     /* 239573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239597 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239608 */     GIR_RootConstrainSelectedInstOperands,
     /* 239609 */     // GIR_Coverage, 11873,
     /* 239609 */     GIR_EraseRootFromParent_Done,
     /* 239610 */   // Label 4797: @239610
     /* 239610 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239652), // Rule ID 11962 //
     /* 239615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 239642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239650 */     GIR_RootConstrainSelectedInstOperands,
     /* 239651 */     // GIR_Coverage, 11962,
     /* 239651 */     GIR_EraseRootFromParent_Done,
     /* 239652 */   // Label 4798: @239652
     /* 239652 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239694), // Rule ID 11964 //
     /* 239657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 239684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239692 */     GIR_RootConstrainSelectedInstOperands,
     /* 239693 */     // GIR_Coverage, 11964,
     /* 239693 */     GIR_EraseRootFromParent_Done,
     /* 239694 */   // Label 4799: @239694
     /* 239694 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239736), // Rule ID 11966 //
     /* 239699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 239726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239734 */     GIR_RootConstrainSelectedInstOperands,
     /* 239735 */     // GIR_Coverage, 11966,
     /* 239735 */     GIR_EraseRootFromParent_Done,
     /* 239736 */   // Label 4800: @239736
     /* 239736 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239778), // Rule ID 11968 //
     /* 239741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239765 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 239768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239776 */     GIR_RootConstrainSelectedInstOperands,
     /* 239777 */     // GIR_Coverage, 11968,
     /* 239777 */     GIR_EraseRootFromParent_Done,
     /* 239778 */   // Label 4801: @239778
     /* 239778 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239820), // Rule ID 11970 //
     /* 239783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 239791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239807 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 239810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239818 */     GIR_RootConstrainSelectedInstOperands,
     /* 239819 */     // GIR_Coverage, 11970,
     /* 239819 */     GIR_EraseRootFromParent_Done,
     /* 239820 */   // Label 4802: @239820
     /* 239820 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239862), // Rule ID 11972 //
     /* 239825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 239833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 239852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239860 */     GIR_RootConstrainSelectedInstOperands,
     /* 239861 */     // GIR_Coverage, 11972,
     /* 239861 */     GIR_EraseRootFromParent_Done,
     /* 239862 */   // Label 4803: @239862
     /* 239862 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239904), // Rule ID 12135 //
     /* 239867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 239894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239902 */     GIR_RootConstrainSelectedInstOperands,
     /* 239903 */     // GIR_Coverage, 12135,
     /* 239903 */     GIR_EraseRootFromParent_Done,
     /* 239904 */   // Label 4804: @239904
     /* 239904 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(239946), // Rule ID 12136 //
     /* 239909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 239936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239944 */     GIR_RootConstrainSelectedInstOperands,
     /* 239945 */     // GIR_Coverage, 12136,
     /* 239945 */     GIR_EraseRootFromParent_Done,
     /* 239946 */   // Label 4805: @239946
     /* 239946 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(239988), // Rule ID 12137 //
     /* 239951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 239978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239986 */     GIR_RootConstrainSelectedInstOperands,
     /* 239987 */     // GIR_Coverage, 12137,
     /* 239987 */     GIR_EraseRootFromParent_Done,
     /* 239988 */   // Label 4806: @239988
     /* 239988 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(240030), // Rule ID 12138 //
     /* 239993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240028 */     GIR_RootConstrainSelectedInstOperands,
     /* 240029 */     // GIR_Coverage, 12138,
     /* 240029 */     GIR_EraseRootFromParent_Done,
     /* 240030 */   // Label 4807: @240030
     /* 240030 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(240072), // Rule ID 12139 //
     /* 240035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240059 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1919:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 240062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240070 */     GIR_RootConstrainSelectedInstOperands,
     /* 240071 */     // GIR_Coverage, 12139,
     /* 240071 */     GIR_EraseRootFromParent_Done,
     /* 240072 */   // Label 4808: @240072
     /* 240072 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(240114), // Rule ID 12140 //
     /* 240077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240101 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1919:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 240104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240112 */     GIR_RootConstrainSelectedInstOperands,
     /* 240113 */     // GIR_Coverage, 12140,
     /* 240113 */     GIR_EraseRootFromParent_Done,
     /* 240114 */   // Label 4809: @240114
     /* 240114 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(240156), // Rule ID 12141 //
     /* 240119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240143 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1919:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240154 */     GIR_RootConstrainSelectedInstOperands,
     /* 240155 */     // GIR_Coverage, 12141,
     /* 240155 */     GIR_EraseRootFromParent_Done,
     /* 240156 */   // Label 4810: @240156
     /* 240156 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(240198), // Rule ID 12486 //
     /* 240161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240185 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 240188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240196 */     GIR_RootConstrainSelectedInstOperands,
     /* 240197 */     // GIR_Coverage, 12486,
     /* 240197 */     GIR_EraseRootFromParent_Done,
     /* 240198 */   // Label 4811: @240198
     /* 240198 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240240), // Rule ID 12487 //
     /* 240203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240227 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 240230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240238 */     GIR_RootConstrainSelectedInstOperands,
     /* 240239 */     // GIR_Coverage, 12487,
     /* 240239 */     GIR_EraseRootFromParent_Done,
     /* 240240 */   // Label 4812: @240240
     /* 240240 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240282), // Rule ID 12488 //
     /* 240245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240269 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 240272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240280 */     GIR_RootConstrainSelectedInstOperands,
     /* 240281 */     // GIR_Coverage, 12488,
     /* 240281 */     GIR_EraseRootFromParent_Done,
     /* 240282 */   // Label 4813: @240282
     /* 240282 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240324), // Rule ID 12489 //
     /* 240287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240311 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 240314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240322 */     GIR_RootConstrainSelectedInstOperands,
     /* 240323 */     // GIR_Coverage, 12489,
     /* 240323 */     GIR_EraseRootFromParent_Done,
     /* 240324 */   // Label 4814: @240324
     /* 240324 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240366), // Rule ID 12490 //
     /* 240329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240353 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 240356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240364 */     GIR_RootConstrainSelectedInstOperands,
     /* 240365 */     // GIR_Coverage, 12490,
     /* 240365 */     GIR_EraseRootFromParent_Done,
     /* 240366 */   // Label 4815: @240366
     /* 240366 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240408), // Rule ID 12491 //
     /* 240371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240395 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 240398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240406 */     GIR_RootConstrainSelectedInstOperands,
     /* 240407 */     // GIR_Coverage, 12491,
     /* 240407 */     GIR_EraseRootFromParent_Done,
     /* 240408 */   // Label 4816: @240408
     /* 240408 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240450), // Rule ID 12492 //
     /* 240413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240437 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240448 */     GIR_RootConstrainSelectedInstOperands,
     /* 240449 */     // GIR_Coverage, 12492,
     /* 240449 */     GIR_EraseRootFromParent_Done,
     /* 240450 */   // Label 4817: @240450
     /* 240450 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240492), // Rule ID 12495 //
     /* 240455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240479 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 240479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240490 */     GIR_RootConstrainSelectedInstOperands,
     /* 240491 */     // GIR_Coverage, 12495,
     /* 240491 */     GIR_EraseRootFromParent_Done,
     /* 240492 */   // Label 4818: @240492
     /* 240492 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240534), // Rule ID 12498 //
     /* 240497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240521 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 240521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240532 */     GIR_RootConstrainSelectedInstOperands,
     /* 240533 */     // GIR_Coverage, 12498,
     /* 240533 */     GIR_EraseRootFromParent_Done,
     /* 240534 */   // Label 4819: @240534
     /* 240534 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240576), // Rule ID 12501 //
     /* 240539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240563 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 240566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240574 */     GIR_RootConstrainSelectedInstOperands,
     /* 240575 */     // GIR_Coverage, 12501,
     /* 240575 */     GIR_EraseRootFromParent_Done,
     /* 240576 */   // Label 4820: @240576
     /* 240576 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240618), // Rule ID 12504 //
     /* 240581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240605 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 240605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 240608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240616 */     GIR_RootConstrainSelectedInstOperands,
     /* 240617 */     // GIR_Coverage, 12504,
     /* 240617 */     GIR_EraseRootFromParent_Done,
     /* 240618 */   // Label 4821: @240618
     /* 240618 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240660), // Rule ID 12507 //
     /* 240623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240647 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 240650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240658 */     GIR_RootConstrainSelectedInstOperands,
     /* 240659 */     // GIR_Coverage, 12507,
     /* 240659 */     GIR_EraseRootFromParent_Done,
     /* 240660 */   // Label 4822: @240660
     /* 240660 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240702), // Rule ID 12510 //
     /* 240665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240689 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240700 */     GIR_RootConstrainSelectedInstOperands,
     /* 240701 */     // GIR_Coverage, 12510,
     /* 240701 */     GIR_EraseRootFromParent_Done,
     /* 240702 */   // Label 4823: @240702
     /* 240702 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240744), // Rule ID 12513 //
     /* 240707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240731 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 240731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240742 */     GIR_RootConstrainSelectedInstOperands,
     /* 240743 */     // GIR_Coverage, 12513,
     /* 240743 */     GIR_EraseRootFromParent_Done,
     /* 240744 */   // Label 4824: @240744
     /* 240744 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240786), // Rule ID 12516 //
     /* 240749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240773 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 240773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240784 */     GIR_RootConstrainSelectedInstOperands,
     /* 240785 */     // GIR_Coverage, 12516,
     /* 240785 */     GIR_EraseRootFromParent_Done,
     /* 240786 */   // Label 4825: @240786
     /* 240786 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240828), // Rule ID 12519 //
     /* 240791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240815 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 240818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240826 */     GIR_RootConstrainSelectedInstOperands,
     /* 240827 */     // GIR_Coverage, 12519,
     /* 240827 */     GIR_EraseRootFromParent_Done,
     /* 240828 */   // Label 4826: @240828
     /* 240828 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240870), // Rule ID 12522 //
     /* 240833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240857 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 240857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 240860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240868 */     GIR_RootConstrainSelectedInstOperands,
     /* 240869 */     // GIR_Coverage, 12522,
     /* 240869 */     GIR_EraseRootFromParent_Done,
     /* 240870 */   // Label 4827: @240870
     /* 240870 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240912), // Rule ID 12525 //
     /* 240875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240899 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 240902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240910 */     GIR_RootConstrainSelectedInstOperands,
     /* 240911 */     // GIR_Coverage, 12525,
     /* 240911 */     GIR_EraseRootFromParent_Done,
     /* 240912 */   // Label 4828: @240912
     /* 240912 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(241055), // Rule ID 5588 //
     /* 240917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 240925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 240928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 240931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 240934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240938 */     // MIs[0] idx
     /* 240938 */     // No operand predicates
     /* 240938 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240938 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 240941 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240945 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 240952 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 240955 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240959 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240964 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 240967 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 240971 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 240974 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240979 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240984 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241015 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241022 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241051 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241053 */     GIR_RootConstrainSelectedInstOperands,
     /* 241054 */     // GIR_Coverage, 5588,
     /* 241054 */     GIR_EraseRootFromParent_Done,
     /* 241055 */   // Label 4829: @241055
     /* 241055 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(241146), // Rule ID 5589 //
     /* 241060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 241074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241081 */     // MIs[0] idx
     /* 241081 */     // No operand predicates
     /* 241081 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241081 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241084 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241088 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241142 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241144 */     GIR_RootConstrainSelectedInstOperands,
     /* 241145 */     // GIR_Coverage, 5589,
     /* 241145 */     GIR_EraseRootFromParent_Done,
     /* 241146 */   // Label 4830: @241146
     /* 241146 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(241237), // Rule ID 5590 //
     /* 241151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241172 */     // MIs[0] idx
     /* 241172 */     // No operand predicates
     /* 241172 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241233 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241235 */     GIR_RootConstrainSelectedInstOperands,
     /* 241236 */     // GIR_Coverage, 5590,
     /* 241236 */     GIR_EraseRootFromParent_Done,
     /* 241237 */   // Label 4831: @241237
     /* 241237 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(241276), // Rule ID 5591 //
     /* 241242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241263 */     // MIs[0] idx
     /* 241263 */     // No operand predicates
     /* 241263 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241272 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241274 */     GIR_RootConstrainSelectedInstOperands,
     /* 241275 */     // GIR_Coverage, 5591,
     /* 241275 */     GIR_EraseRootFromParent_Done,
     /* 241276 */   // Label 4832: @241276
     /* 241276 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(241419), // Rule ID 5592 //
     /* 241281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241302 */     // MIs[0] idx
     /* 241302 */     // No operand predicates
     /* 241302 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241302 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241305 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241309 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241316 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241328 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241331 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241335 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241338 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241343 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241348 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241386 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241415 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241417 */     GIR_RootConstrainSelectedInstOperands,
     /* 241418 */     // GIR_Coverage, 5592,
     /* 241418 */     GIR_EraseRootFromParent_Done,
     /* 241419 */   // Label 4833: @241419
     /* 241419 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241510), // Rule ID 5593 //
     /* 241424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241445 */     // MIs[0] idx
     /* 241445 */     // No operand predicates
     /* 241445 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241445 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241448 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241452 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241506 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241508 */     GIR_RootConstrainSelectedInstOperands,
     /* 241509 */     // GIR_Coverage, 5593,
     /* 241509 */     GIR_EraseRootFromParent_Done,
     /* 241510 */   // Label 4834: @241510
     /* 241510 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241601), // Rule ID 5594 //
     /* 241515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241536 */     // MIs[0] idx
     /* 241536 */     // No operand predicates
     /* 241536 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241569 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241597 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241599 */     GIR_RootConstrainSelectedInstOperands,
     /* 241600 */     // GIR_Coverage, 5594,
     /* 241600 */     GIR_EraseRootFromParent_Done,
     /* 241601 */   // Label 4835: @241601
     /* 241601 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241640), // Rule ID 5595 //
     /* 241606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241627 */     // MIs[0] idx
     /* 241627 */     // No operand predicates
     /* 241627 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241636 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241638 */     GIR_RootConstrainSelectedInstOperands,
     /* 241639 */     // GIR_Coverage, 5595,
     /* 241639 */     GIR_EraseRootFromParent_Done,
     /* 241640 */   // Label 4836: @241640
     /* 241640 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241783), // Rule ID 5596 //
     /* 241645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241666 */     // MIs[0] idx
     /* 241666 */     // No operand predicates
     /* 241666 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241666 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241669 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241673 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241680 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241683 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241687 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241692 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241695 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241699 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241702 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241707 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241712 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241779 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241781 */     GIR_RootConstrainSelectedInstOperands,
     /* 241782 */     // GIR_Coverage, 5596,
     /* 241782 */     GIR_EraseRootFromParent_Done,
     /* 241783 */   // Label 4837: @241783
     /* 241783 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241874), // Rule ID 5597 //
     /* 241788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241809 */     // MIs[0] idx
     /* 241809 */     // No operand predicates
     /* 241809 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241835 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241870 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241872 */     GIR_RootConstrainSelectedInstOperands,
     /* 241873 */     // GIR_Coverage, 5597,
     /* 241873 */     GIR_EraseRootFromParent_Done,
     /* 241874 */   // Label 4838: @241874
     /* 241874 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241965), // Rule ID 5598 //
     /* 241879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241900 */     // MIs[0] idx
     /* 241900 */     // No operand predicates
     /* 241900 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241900 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241903 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241907 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241929 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241933 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241961 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241963 */     GIR_RootConstrainSelectedInstOperands,
     /* 241964 */     // GIR_Coverage, 5598,
     /* 241964 */     GIR_EraseRootFromParent_Done,
     /* 241965 */   // Label 4839: @241965
     /* 241965 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(242004), // Rule ID 5599 //
     /* 241970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241991 */     // MIs[0] idx
     /* 241991 */     // No operand predicates
     /* 241991 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242000 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242002 */     GIR_RootConstrainSelectedInstOperands,
     /* 242003 */     // GIR_Coverage, 5599,
     /* 242003 */     GIR_EraseRootFromParent_Done,
     /* 242004 */   // Label 4840: @242004
     /* 242004 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(242043), // Rule ID 5600 //
     /* 242009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 242017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242030 */     // MIs[0] idx
     /* 242030 */     // No operand predicates
     /* 242030 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242039 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242041 */     GIR_RootConstrainSelectedInstOperands,
     /* 242042 */     // GIR_Coverage, 5600,
     /* 242042 */     GIR_EraseRootFromParent_Done,
     /* 242043 */   // Label 4841: @242043
     /* 242043 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(242134), // Rule ID 5601 //
     /* 242048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 242056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242069 */     // MIs[0] idx
     /* 242069 */     // No operand predicates
     /* 242069 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242102 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242130 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242132 */     GIR_RootConstrainSelectedInstOperands,
     /* 242133 */     // GIR_Coverage, 5601,
     /* 242133 */     GIR_EraseRootFromParent_Done,
     /* 242134 */   // Label 4842: @242134
     /* 242134 */   GIM_Reject,
     /* 242135 */ // Label 3966: @242135
     /* 242135 */ GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(249246),
     /* 242140 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 242143 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(242190), // Rule ID 2965 //
     /* 242148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242175 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 242178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242186 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242188 */     GIR_RootConstrainSelectedInstOperands,
     /* 242189 */     // GIR_Coverage, 2965,
     /* 242189 */     GIR_EraseRootFromParent_Done,
     /* 242190 */   // Label 4844: @242190
     /* 242190 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(242237), // Rule ID 2967 //
     /* 242195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 242225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242233 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242235 */     GIR_RootConstrainSelectedInstOperands,
     /* 242236 */     // GIR_Coverage, 2967,
     /* 242236 */     GIR_EraseRootFromParent_Done,
     /* 242237 */   // Label 4845: @242237
     /* 242237 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(242284), // Rule ID 2969 //
     /* 242242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 242272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242280 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242282 */     GIR_RootConstrainSelectedInstOperands,
     /* 242283 */     // GIR_Coverage, 2969,
     /* 242283 */     GIR_EraseRootFromParent_Done,
     /* 242284 */   // Label 4846: @242284
     /* 242284 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(242331), // Rule ID 2971 //
     /* 242289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 242319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242327 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242329 */     GIR_RootConstrainSelectedInstOperands,
     /* 242330 */     // GIR_Coverage, 2971,
     /* 242330 */     GIR_EraseRootFromParent_Done,
     /* 242331 */   // Label 4847: @242331
     /* 242331 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(242378), // Rule ID 7560 //
     /* 242336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 242366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242374 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242376 */     GIR_RootConstrainSelectedInstOperands,
     /* 242377 */     // GIR_Coverage, 7560,
     /* 242377 */     GIR_EraseRootFromParent_Done,
     /* 242378 */   // Label 4848: @242378
     /* 242378 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(242425), // Rule ID 7562 //
     /* 242383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 242413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242421 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242423 */     GIR_RootConstrainSelectedInstOperands,
     /* 242424 */     // GIR_Coverage, 7562,
     /* 242424 */     GIR_EraseRootFromParent_Done,
     /* 242425 */   // Label 4849: @242425
     /* 242425 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(242472), // Rule ID 7564 //
     /* 242430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 242460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242468 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242470 */     GIR_RootConstrainSelectedInstOperands,
     /* 242471 */     // GIR_Coverage, 7564,
     /* 242471 */     GIR_EraseRootFromParent_Done,
     /* 242472 */   // Label 4850: @242472
     /* 242472 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(242519), // Rule ID 7566 //
     /* 242477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242504 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 242507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242515 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242517 */     GIR_RootConstrainSelectedInstOperands,
     /* 242518 */     // GIR_Coverage, 7566,
     /* 242518 */     GIR_EraseRootFromParent_Done,
     /* 242519 */   // Label 4851: @242519
     /* 242519 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242599), // Rule ID 5708 //
     /* 242524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 242541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 242564 */     // MIs[1] Operand 1
     /* 242564 */     // No operand predicates
     /* 242564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 242580 */     // MIs[2] Operand 1
     /* 242580 */     // No operand predicates
     /* 242580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242582 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 242582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 242585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242597 */     GIR_RootConstrainSelectedInstOperands,
     /* 242598 */     // GIR_Coverage, 5708,
     /* 242598 */     GIR_EraseRootFromParent_Done,
     /* 242599 */   // Label 4852: @242599
     /* 242599 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242679), // Rule ID 5709 //
     /* 242604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 242621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 242644 */     // MIs[1] Operand 1
     /* 242644 */     // No operand predicates
     /* 242644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 242660 */     // MIs[2] Operand 1
     /* 242660 */     // No operand predicates
     /* 242660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242662 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 242662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 242665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242677 */     GIR_RootConstrainSelectedInstOperands,
     /* 242678 */     // GIR_Coverage, 5709,
     /* 242678 */     GIR_EraseRootFromParent_Done,
     /* 242679 */   // Label 4853: @242679
     /* 242679 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242759), // Rule ID 5710 //
     /* 242684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 242724 */     // MIs[1] Operand 1
     /* 242724 */     // No operand predicates
     /* 242724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242736 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 242740 */     // MIs[2] Operand 1
     /* 242740 */     // No operand predicates
     /* 242740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242742 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 242742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 242745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242757 */     GIR_RootConstrainSelectedInstOperands,
     /* 242758 */     // GIR_Coverage, 5710,
     /* 242758 */     GIR_EraseRootFromParent_Done,
     /* 242759 */   // Label 4854: @242759
     /* 242759 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242839), // Rule ID 5711 //
     /* 242764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 242772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 242775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 242781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 242804 */     // MIs[1] Operand 1
     /* 242804 */     // No operand predicates
     /* 242804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 242820 */     // MIs[2] Operand 1
     /* 242820 */     // No operand predicates
     /* 242820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242822 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 242822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 242825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242837 */     GIR_RootConstrainSelectedInstOperands,
     /* 242838 */     // GIR_Coverage, 5711,
     /* 242838 */     GIR_EraseRootFromParent_Done,
     /* 242839 */   // Label 4855: @242839
     /* 242839 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242903), // Rule ID 3849 //
     /* 242844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 242852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242880 */     // MIs[0] imm
     /* 242880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242888 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 242891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242899 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242901 */     GIR_RootConstrainSelectedInstOperands,
     /* 242902 */     // GIR_Coverage, 3849,
     /* 242902 */     GIR_EraseRootFromParent_Done,
     /* 242903 */   // Label 4856: @242903
     /* 242903 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242967), // Rule ID 3850 //
     /* 242908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 242916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242944 */     // MIs[0] imm
     /* 242944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242952 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 242955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242963 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242965 */     GIR_RootConstrainSelectedInstOperands,
     /* 242966 */     // GIR_Coverage, 3850,
     /* 242966 */     GIR_EraseRootFromParent_Done,
     /* 242967 */   // Label 4857: @242967
     /* 242967 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(243031), // Rule ID 3851 //
     /* 242972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 242980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243008 */     // MIs[0] imm
     /* 243008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243016 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 243019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243027 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243029 */     GIR_RootConstrainSelectedInstOperands,
     /* 243030 */     // GIR_Coverage, 3851,
     /* 243030 */     GIR_EraseRootFromParent_Done,
     /* 243031 */   // Label 4858: @243031
     /* 243031 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(243095), // Rule ID 3852 //
     /* 243036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 243044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243072 */     // MIs[0] imm
     /* 243072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243080 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 243083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243091 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243093 */     GIR_RootConstrainSelectedInstOperands,
     /* 243094 */     // GIR_Coverage, 3852,
     /* 243094 */     GIR_EraseRootFromParent_Done,
     /* 243095 */   // Label 4859: @243095
     /* 243095 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(243147), // Rule ID 2850 //
     /* 243100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243124 */     // MIs[0] idx
     /* 243124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243132 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 243135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243143 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243145 */     GIR_RootConstrainSelectedInstOperands,
     /* 243146 */     // GIR_Coverage, 2850,
     /* 243146 */     GIR_EraseRootFromParent_Done,
     /* 243147 */   // Label 4860: @243147
     /* 243147 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(243199), // Rule ID 2851 //
     /* 243152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243176 */     // MIs[0] idx
     /* 243176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243184 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 243187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243195 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243197 */     GIR_RootConstrainSelectedInstOperands,
     /* 243198 */     // GIR_Coverage, 2851,
     /* 243198 */     GIR_EraseRootFromParent_Done,
     /* 243199 */   // Label 4861: @243199
     /* 243199 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(243251), // Rule ID 2852 //
     /* 243204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243228 */     // MIs[0] idx
     /* 243228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243236 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 243236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 243239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243247 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243249 */     GIR_RootConstrainSelectedInstOperands,
     /* 243250 */     // GIR_Coverage, 2852,
     /* 243250 */     GIR_EraseRootFromParent_Done,
     /* 243251 */   // Label 4862: @243251
     /* 243251 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(243303), // Rule ID 2980 //
     /* 243256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243280 */     // MIs[0] Op4
     /* 243280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 243291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243299 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243301 */     GIR_RootConstrainSelectedInstOperands,
     /* 243302 */     // GIR_Coverage, 2980,
     /* 243302 */     GIR_EraseRootFromParent_Done,
     /* 243303 */   // Label 4863: @243303
     /* 243303 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(243355), // Rule ID 2981 //
     /* 243308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243332 */     // MIs[0] Op4
     /* 243332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 243343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243351 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243353 */     GIR_RootConstrainSelectedInstOperands,
     /* 243354 */     // GIR_Coverage, 2981,
     /* 243354 */     GIR_EraseRootFromParent_Done,
     /* 243355 */   // Label 4864: @243355
     /* 243355 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(243407), // Rule ID 2982 //
     /* 243360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243384 */     // MIs[0] Op4
     /* 243384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 243395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243403 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243405 */     GIR_RootConstrainSelectedInstOperands,
     /* 243406 */     // GIR_Coverage, 2982,
     /* 243406 */     GIR_EraseRootFromParent_Done,
     /* 243407 */   // Label 4865: @243407
     /* 243407 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(243459), // Rule ID 2983 //
     /* 243412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 243420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243436 */     // MIs[0] Op4
     /* 243436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1744:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 243447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243455 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243457 */     GIR_RootConstrainSelectedInstOperands,
     /* 243458 */     // GIR_Coverage, 2983,
     /* 243458 */     GIR_EraseRootFromParent_Done,
     /* 243459 */   // Label 4866: @243459
     /* 243459 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(243511), // Rule ID 2984 //
     /* 243464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 243472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243488 */     // MIs[0] Op4
     /* 243488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1744:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 243499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243507 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243509 */     GIR_RootConstrainSelectedInstOperands,
     /* 243510 */     // GIR_Coverage, 2984,
     /* 243510 */     GIR_EraseRootFromParent_Done,
     /* 243511 */   // Label 4867: @243511
     /* 243511 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(243563), // Rule ID 2987 //
     /* 243516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 243524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243540 */     // MIs[0] Op4
     /* 243540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 243551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243559 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243561 */     GIR_RootConstrainSelectedInstOperands,
     /* 243562 */     // GIR_Coverage, 2987,
     /* 243562 */     GIR_EraseRootFromParent_Done,
     /* 243563 */   // Label 4868: @243563
     /* 243563 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(243615), // Rule ID 2988 //
     /* 243568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 243576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243592 */     // MIs[0] Op4
     /* 243592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243600 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 243603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243611 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243613 */     GIR_RootConstrainSelectedInstOperands,
     /* 243614 */     // GIR_Coverage, 2988,
     /* 243614 */     GIR_EraseRootFromParent_Done,
     /* 243615 */   // Label 4869: @243615
     /* 243615 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(243667), // Rule ID 3462 //
     /* 243620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 243623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 243628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243644 */     // MIs[0] Op4
     /* 243644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 243655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243663 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243665 */     GIR_RootConstrainSelectedInstOperands,
     /* 243666 */     // GIR_Coverage, 3462,
     /* 243666 */     GIR_EraseRootFromParent_Done,
     /* 243667 */   // Label 4870: @243667
     /* 243667 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(243719), // Rule ID 3506 //
     /* 243672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 243675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 243680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243696 */     // MIs[0] Op4
     /* 243696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1711:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 243707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243715 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243717 */     GIR_RootConstrainSelectedInstOperands,
     /* 243718 */     // GIR_Coverage, 3506,
     /* 243718 */     GIR_EraseRootFromParent_Done,
     /* 243719 */   // Label 4871: @243719
     /* 243719 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(243771), // Rule ID 7634 //
     /* 243724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 243732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243748 */     // MIs[0] Op4
     /* 243748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1957:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 243759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243767 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243769 */     GIR_RootConstrainSelectedInstOperands,
     /* 243770 */     // GIR_Coverage, 7634,
     /* 243770 */     GIR_EraseRootFromParent_Done,
     /* 243771 */   // Label 4872: @243771
     /* 243771 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(243823), // Rule ID 7635 //
     /* 243776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 243784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243800 */     // MIs[0] Op4
     /* 243800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1957:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 243811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243819 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243821 */     GIR_RootConstrainSelectedInstOperands,
     /* 243822 */     // GIR_Coverage, 7635,
     /* 243822 */     GIR_EraseRootFromParent_Done,
     /* 243823 */   // Label 4873: @243823
     /* 243823 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(243875), // Rule ID 8275 //
     /* 243828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243852 */     // MIs[0] idx
     /* 243852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 243863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243871 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243873 */     GIR_RootConstrainSelectedInstOperands,
     /* 243874 */     // GIR_Coverage, 8275,
     /* 243874 */     GIR_EraseRootFromParent_Done,
     /* 243875 */   // Label 4874: @243875
     /* 243875 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(243927), // Rule ID 8276 //
     /* 243880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243904 */     // MIs[0] idx
     /* 243904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243912 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 243915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243923 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243925 */     GIR_RootConstrainSelectedInstOperands,
     /* 243926 */     // GIR_Coverage, 8276,
     /* 243926 */     GIR_EraseRootFromParent_Done,
     /* 243927 */   // Label 4875: @243927
     /* 243927 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243979), // Rule ID 8277 //
     /* 243932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243956 */     // MIs[0] idx
     /* 243956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 243964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 243967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243975 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243977 */     GIR_RootConstrainSelectedInstOperands,
     /* 243978 */     // GIR_Coverage, 8277,
     /* 243978 */     GIR_EraseRootFromParent_Done,
     /* 243979 */   // Label 4876: @243979
     /* 243979 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(244031), // Rule ID 11241 //
     /* 243984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 243987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 243992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244008 */     // MIs[0] Op4
     /* 244008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1906:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 244019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244027 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244029 */     GIR_RootConstrainSelectedInstOperands,
     /* 244030 */     // GIR_Coverage, 11241,
     /* 244030 */     GIR_EraseRootFromParent_Done,
     /* 244031 */   // Label 4877: @244031
     /* 244031 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(244083), // Rule ID 11288 //
     /* 244036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244060 */     // MIs[0] Op4
     /* 244060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 244071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244079 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244081 */     GIR_RootConstrainSelectedInstOperands,
     /* 244082 */     // GIR_Coverage, 11288,
     /* 244082 */     GIR_EraseRootFromParent_Done,
     /* 244083 */   // Label 4878: @244083
     /* 244083 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(244135), // Rule ID 11289 //
     /* 244088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244112 */     // MIs[0] Op4
     /* 244112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 244123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244131 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244133 */     GIR_RootConstrainSelectedInstOperands,
     /* 244134 */     // GIR_Coverage, 11289,
     /* 244134 */     GIR_EraseRootFromParent_Done,
     /* 244135 */   // Label 4879: @244135
     /* 244135 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(244187), // Rule ID 11290 //
     /* 244140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244164 */     // MIs[0] Op4
     /* 244164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1605:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 244175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244183 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244185 */     GIR_RootConstrainSelectedInstOperands,
     /* 244186 */     // GIR_Coverage, 11290,
     /* 244186 */     GIR_EraseRootFromParent_Done,
     /* 244187 */   // Label 4880: @244187
     /* 244187 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(244239), // Rule ID 11291 //
     /* 244192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244216 */     // MIs[0] Op4
     /* 244216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 244227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244235 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244237 */     GIR_RootConstrainSelectedInstOperands,
     /* 244238 */     // GIR_Coverage, 11291,
     /* 244238 */     GIR_EraseRootFromParent_Done,
     /* 244239 */   // Label 4881: @244239
     /* 244239 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(244291), // Rule ID 11292 //
     /* 244244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244268 */     // MIs[0] Op4
     /* 244268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 244279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244289 */     GIR_RootConstrainSelectedInstOperands,
     /* 244290 */     // GIR_Coverage, 11292,
     /* 244290 */     GIR_EraseRootFromParent_Done,
     /* 244291 */   // Label 4882: @244291
     /* 244291 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(244343), // Rule ID 11293 //
     /* 244296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244320 */     // MIs[0] Op4
     /* 244320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244328 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 244331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244339 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244341 */     GIR_RootConstrainSelectedInstOperands,
     /* 244342 */     // GIR_Coverage, 11293,
     /* 244342 */     GIR_EraseRootFromParent_Done,
     /* 244343 */   // Label 4883: @244343
     /* 244343 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(244395), // Rule ID 11294 //
     /* 244348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244372 */     // MIs[0] Op4
     /* 244372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244380 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 244383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244391 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244393 */     GIR_RootConstrainSelectedInstOperands,
     /* 244394 */     // GIR_Coverage, 11294,
     /* 244394 */     GIR_EraseRootFromParent_Done,
     /* 244395 */   // Label 4884: @244395
     /* 244395 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(244447), // Rule ID 11295 //
     /* 244400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244424 */     // MIs[0] Op4
     /* 244424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 244435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244443 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244445 */     GIR_RootConstrainSelectedInstOperands,
     /* 244446 */     // GIR_Coverage, 11295,
     /* 244446 */     GIR_EraseRootFromParent_Done,
     /* 244447 */   // Label 4885: @244447
     /* 244447 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(244499), // Rule ID 11296 //
     /* 244452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244476 */     // MIs[0] Op4
     /* 244476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244484 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 244487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244495 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244497 */     GIR_RootConstrainSelectedInstOperands,
     /* 244498 */     // GIR_Coverage, 11296,
     /* 244498 */     GIR_EraseRootFromParent_Done,
     /* 244499 */   // Label 4886: @244499
     /* 244499 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(244551), // Rule ID 11339 //
     /* 244504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 244512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244528 */     // MIs[0] Op4
     /* 244528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 244539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244547 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244549 */     GIR_RootConstrainSelectedInstOperands,
     /* 244550 */     // GIR_Coverage, 11339,
     /* 244550 */     GIR_EraseRootFromParent_Done,
     /* 244551 */   // Label 4887: @244551
     /* 244551 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(244603), // Rule ID 11340 //
     /* 244556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 244564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244580 */     // MIs[0] Op4
     /* 244580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 244591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244599 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244601 */     GIR_RootConstrainSelectedInstOperands,
     /* 244602 */     // GIR_Coverage, 11340,
     /* 244602 */     GIR_EraseRootFromParent_Done,
     /* 244603 */   // Label 4888: @244603
     /* 244603 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(244655), // Rule ID 11341 //
     /* 244608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 244616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244632 */     // MIs[0] Op4
     /* 244632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 244643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244651 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244653 */     GIR_RootConstrainSelectedInstOperands,
     /* 244654 */     // GIR_Coverage, 11341,
     /* 244654 */     GIR_EraseRootFromParent_Done,
     /* 244655 */   // Label 4889: @244655
     /* 244655 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(244707), // Rule ID 11342 //
     /* 244660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 244668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244684 */     // MIs[0] Op4
     /* 244684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 244695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244703 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244705 */     GIR_RootConstrainSelectedInstOperands,
     /* 244706 */     // GIR_Coverage, 11342,
     /* 244706 */     GIR_EraseRootFromParent_Done,
     /* 244707 */   // Label 4890: @244707
     /* 244707 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(244759), // Rule ID 11343 //
     /* 244712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 244720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244736 */     // MIs[0] Op4
     /* 244736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1984:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 244747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244755 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244757 */     GIR_RootConstrainSelectedInstOperands,
     /* 244758 */     // GIR_Coverage, 11343,
     /* 244758 */     GIR_EraseRootFromParent_Done,
     /* 244759 */   // Label 4891: @244759
     /* 244759 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(244811), // Rule ID 11344 //
     /* 244764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 244772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244788 */     // MIs[0] Op4
     /* 244788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1984:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 244799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244807 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244809 */     GIR_RootConstrainSelectedInstOperands,
     /* 244810 */     // GIR_Coverage, 11344,
     /* 244810 */     GIR_EraseRootFromParent_Done,
     /* 244811 */   // Label 4892: @244811
     /* 244811 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(244863), // Rule ID 11345 //
     /* 244816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 244824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244840 */     // MIs[0] Op4
     /* 244840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 244851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244859 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244861 */     GIR_RootConstrainSelectedInstOperands,
     /* 244862 */     // GIR_Coverage, 11345,
     /* 244862 */     GIR_EraseRootFromParent_Done,
     /* 244863 */   // Label 4893: @244863
     /* 244863 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244915), // Rule ID 11346 //
     /* 244868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 244876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244892 */     // MIs[0] Op4
     /* 244892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 244903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244913 */     GIR_RootConstrainSelectedInstOperands,
     /* 244914 */     // GIR_Coverage, 11346,
     /* 244914 */     GIR_EraseRootFromParent_Done,
     /* 244915 */   // Label 4894: @244915
     /* 244915 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(244967), // Rule ID 11347 //
     /* 244920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 244928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244944 */     // MIs[0] Op4
     /* 244944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 244955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244963 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244965 */     GIR_RootConstrainSelectedInstOperands,
     /* 244966 */     // GIR_Coverage, 11347,
     /* 244966 */     GIR_EraseRootFromParent_Done,
     /* 244967 */   // Label 4895: @244967
     /* 244967 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(245019), // Rule ID 11348 //
     /* 244972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 244980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244996 */     // MIs[0] Op4
     /* 244996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244999 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 245007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245015 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245017 */     GIR_RootConstrainSelectedInstOperands,
     /* 245018 */     // GIR_Coverage, 11348,
     /* 245018 */     GIR_EraseRootFromParent_Done,
     /* 245019 */   // Label 4896: @245019
     /* 245019 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(245071), // Rule ID 11349 //
     /* 245024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245048 */     // MIs[0] Op4
     /* 245048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 245059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245067 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245069 */     GIR_RootConstrainSelectedInstOperands,
     /* 245070 */     // GIR_Coverage, 11349,
     /* 245070 */     GIR_EraseRootFromParent_Done,
     /* 245071 */   // Label 4897: @245071
     /* 245071 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(245123), // Rule ID 11350 //
     /* 245076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245100 */     // MIs[0] Op4
     /* 245100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 245111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245117 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245119 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245121 */     GIR_RootConstrainSelectedInstOperands,
     /* 245122 */     // GIR_Coverage, 11350,
     /* 245122 */     GIR_EraseRootFromParent_Done,
     /* 245123 */   // Label 4898: @245123
     /* 245123 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(245175), // Rule ID 11351 //
     /* 245128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245152 */     // MIs[0] Op4
     /* 245152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 245163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245171 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245173 */     GIR_RootConstrainSelectedInstOperands,
     /* 245174 */     // GIR_Coverage, 11351,
     /* 245174 */     GIR_EraseRootFromParent_Done,
     /* 245175 */   // Label 4899: @245175
     /* 245175 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(245227), // Rule ID 11352 //
     /* 245180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245204 */     // MIs[0] Op4
     /* 245204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 245215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245223 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245225 */     GIR_RootConstrainSelectedInstOperands,
     /* 245226 */     // GIR_Coverage, 11352,
     /* 245226 */     GIR_EraseRootFromParent_Done,
     /* 245227 */   // Label 4900: @245227
     /* 245227 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(245279), // Rule ID 11374 //
     /* 245232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 245240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245256 */     // MIs[0] Op4
     /* 245256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 245267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245275 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245277 */     GIR_RootConstrainSelectedInstOperands,
     /* 245278 */     // GIR_Coverage, 11374,
     /* 245278 */     GIR_EraseRootFromParent_Done,
     /* 245279 */   // Label 4901: @245279
     /* 245279 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(245331), // Rule ID 11375 //
     /* 245284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 245292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245308 */     // MIs[0] Op4
     /* 245308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 245319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245327 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245329 */     GIR_RootConstrainSelectedInstOperands,
     /* 245330 */     // GIR_Coverage, 11375,
     /* 245330 */     GIR_EraseRootFromParent_Done,
     /* 245331 */   // Label 4902: @245331
     /* 245331 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(245383), // Rule ID 11376 //
     /* 245336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 245344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245360 */     // MIs[0] Op4
     /* 245360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 245371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245379 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245381 */     GIR_RootConstrainSelectedInstOperands,
     /* 245382 */     // GIR_Coverage, 11376,
     /* 245382 */     GIR_EraseRootFromParent_Done,
     /* 245383 */   // Label 4903: @245383
     /* 245383 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(245435), // Rule ID 11377 //
     /* 245388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 245396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245412 */     // MIs[0] Op4
     /* 245412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 245423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245431 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245433 */     GIR_RootConstrainSelectedInstOperands,
     /* 245434 */     // GIR_Coverage, 11377,
     /* 245434 */     GIR_EraseRootFromParent_Done,
     /* 245435 */   // Label 4904: @245435
     /* 245435 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(245487), // Rule ID 11378 //
     /* 245440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 245448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245464 */     // MIs[0] Op4
     /* 245464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245472 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1791:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 245475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245483 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245485 */     GIR_RootConstrainSelectedInstOperands,
     /* 245486 */     // GIR_Coverage, 11378,
     /* 245486 */     GIR_EraseRootFromParent_Done,
     /* 245487 */   // Label 4905: @245487
     /* 245487 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(245539), // Rule ID 11379 //
     /* 245492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 245500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245516 */     // MIs[0] Op4
     /* 245516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1791:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 245527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245535 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245537 */     GIR_RootConstrainSelectedInstOperands,
     /* 245538 */     // GIR_Coverage, 11379,
     /* 245538 */     GIR_EraseRootFromParent_Done,
     /* 245539 */   // Label 4906: @245539
     /* 245539 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(245591), // Rule ID 11380 //
     /* 245544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 245552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245568 */     // MIs[0] Op4
     /* 245568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 245579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245587 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245589 */     GIR_RootConstrainSelectedInstOperands,
     /* 245590 */     // GIR_Coverage, 11380,
     /* 245590 */     GIR_EraseRootFromParent_Done,
     /* 245591 */   // Label 4907: @245591
     /* 245591 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(245643), // Rule ID 11381 //
     /* 245596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 245604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245620 */     // MIs[0] Op4
     /* 245620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245623 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 245631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245639 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245641 */     GIR_RootConstrainSelectedInstOperands,
     /* 245642 */     // GIR_Coverage, 11381,
     /* 245642 */     GIR_EraseRootFromParent_Done,
     /* 245643 */   // Label 4908: @245643
     /* 245643 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(245695), // Rule ID 11835 //
     /* 245648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 245656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245672 */     // MIs[0] Op4
     /* 245672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245680 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 245683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245691 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245693 */     GIR_RootConstrainSelectedInstOperands,
     /* 245694 */     // GIR_Coverage, 11835,
     /* 245694 */     GIR_EraseRootFromParent_Done,
     /* 245695 */   // Label 4909: @245695
     /* 245695 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(245747), // Rule ID 11836 //
     /* 245700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 245708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245724 */     // MIs[0] Op4
     /* 245724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245732 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 245735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245743 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245745 */     GIR_RootConstrainSelectedInstOperands,
     /* 245746 */     // GIR_Coverage, 11836,
     /* 245746 */     GIR_EraseRootFromParent_Done,
     /* 245747 */   // Label 4910: @245747
     /* 245747 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(245799), // Rule ID 11837 //
     /* 245752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 245760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245776 */     // MIs[0] Op4
     /* 245776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245784 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 245787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245795 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245797 */     GIR_RootConstrainSelectedInstOperands,
     /* 245798 */     // GIR_Coverage, 11837,
     /* 245798 */     GIR_EraseRootFromParent_Done,
     /* 245799 */   // Label 4911: @245799
     /* 245799 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(245851), // Rule ID 11838 //
     /* 245804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 245812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245828 */     // MIs[0] Op4
     /* 245828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 245839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245847 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245849 */     GIR_RootConstrainSelectedInstOperands,
     /* 245850 */     // GIR_Coverage, 11838,
     /* 245850 */     GIR_EraseRootFromParent_Done,
     /* 245851 */   // Label 4912: @245851
     /* 245851 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(245903), // Rule ID 11971 //
     /* 245856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 245859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 245864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245880 */     // MIs[0] Op4
     /* 245880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245888 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 245891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245899 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245901 */     GIR_RootConstrainSelectedInstOperands,
     /* 245902 */     // GIR_Coverage, 11971,
     /* 245902 */     GIR_EraseRootFromParent_Done,
     /* 245903 */   // Label 4913: @245903
     /* 245903 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245955), // Rule ID 11973 //
     /* 245908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 245911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 245916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245932 */     // MIs[0] Op4
     /* 245932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1958:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 245943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245949 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245951 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245953 */     GIR_RootConstrainSelectedInstOperands,
     /* 245954 */     // GIR_Coverage, 11973,
     /* 245954 */     GIR_EraseRootFromParent_Done,
     /* 245955 */   // Label 4914: @245955
     /* 245955 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(246002), // Rule ID 2829 //
     /* 245960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245987 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1461:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 245987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 245990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245998 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246000 */     GIR_RootConstrainSelectedInstOperands,
     /* 246001 */     // GIR_Coverage, 2829,
     /* 246001 */     GIR_EraseRootFromParent_Done,
     /* 246002 */   // Label 4915: @246002
     /* 246002 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(246049), // Rule ID 2832 //
     /* 246007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 246018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 246024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 246027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 246030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246034 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 246034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246045 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246047 */     GIR_RootConstrainSelectedInstOperands,
     /* 246048 */     // GIR_Coverage, 2832,
     /* 246048 */     GIR_EraseRootFromParent_Done,
     /* 246049 */   // Label 4916: @246049
     /* 246049 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(246096), // Rule ID 2835 //
     /* 246054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 246065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 246071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 246074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 246077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246081 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 246081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246092 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246094 */     GIR_RootConstrainSelectedInstOperands,
     /* 246095 */     // GIR_Coverage, 2835,
     /* 246095 */     GIR_EraseRootFromParent_Done,
     /* 246096 */   // Label 4917: @246096
     /* 246096 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(246143), // Rule ID 2838 //
     /* 246101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246128 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246139 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246141 */     GIR_RootConstrainSelectedInstOperands,
     /* 246142 */     // GIR_Coverage, 2838,
     /* 246142 */     GIR_EraseRootFromParent_Done,
     /* 246143 */   // Label 4918: @246143
     /* 246143 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(246190), // Rule ID 2841 //
     /* 246148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 246159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 246165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 246168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 246171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246175 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 246175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246186 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246188 */     GIR_RootConstrainSelectedInstOperands,
     /* 246189 */     // GIR_Coverage, 2841,
     /* 246189 */     GIR_EraseRootFromParent_Done,
     /* 246190 */   // Label 4919: @246190
     /* 246190 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(246237), // Rule ID 2844 //
     /* 246195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246222 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 246225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246233 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246235 */     GIR_RootConstrainSelectedInstOperands,
     /* 246236 */     // GIR_Coverage, 2844,
     /* 246236 */     GIR_EraseRootFromParent_Done,
     /* 246237 */   // Label 4920: @246237
     /* 246237 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(246284), // Rule ID 2847 //
     /* 246242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246269 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 246272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246280 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246282 */     GIR_RootConstrainSelectedInstOperands,
     /* 246283 */     // GIR_Coverage, 2847,
     /* 246283 */     GIR_EraseRootFromParent_Done,
     /* 246284 */   // Label 4921: @246284
     /* 246284 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(246331), // Rule ID 2848 //
     /* 246289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246316 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 246319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246327 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246329 */     GIR_RootConstrainSelectedInstOperands,
     /* 246330 */     // GIR_Coverage, 2848,
     /* 246330 */     GIR_EraseRootFromParent_Done,
     /* 246331 */   // Label 4922: @246331
     /* 246331 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(246378), // Rule ID 2849 //
     /* 246336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246363 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 246366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246374 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246376 */     GIR_RootConstrainSelectedInstOperands,
     /* 246377 */     // GIR_Coverage, 2849,
     /* 246377 */     GIR_EraseRootFromParent_Done,
     /* 246378 */   // Label 4923: @246378
     /* 246378 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(246425), // Rule ID 2945 //
     /* 246383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246410 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 246413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246421 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246423 */     GIR_RootConstrainSelectedInstOperands,
     /* 246424 */     // GIR_Coverage, 2945,
     /* 246424 */     GIR_EraseRootFromParent_Done,
     /* 246425 */   // Label 4924: @246425
     /* 246425 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(246472), // Rule ID 2948 //
     /* 246430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246457 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 246460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246468 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246470 */     GIR_RootConstrainSelectedInstOperands,
     /* 246471 */     // GIR_Coverage, 2948,
     /* 246471 */     GIR_EraseRootFromParent_Done,
     /* 246472 */   // Label 4925: @246472
     /* 246472 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(246519), // Rule ID 2951 //
     /* 246477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 246507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246515 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246517 */     GIR_RootConstrainSelectedInstOperands,
     /* 246518 */     // GIR_Coverage, 2951,
     /* 246518 */     GIR_EraseRootFromParent_Done,
     /* 246519 */   // Label 4926: @246519
     /* 246519 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(246566), // Rule ID 2954 //
     /* 246524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246551 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1599:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 246554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246562 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246564 */     GIR_RootConstrainSelectedInstOperands,
     /* 246565 */     // GIR_Coverage, 2954,
     /* 246565 */     GIR_EraseRootFromParent_Done,
     /* 246566 */   // Label 4927: @246566
     /* 246566 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(246613), // Rule ID 2957 //
     /* 246571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246598 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 246601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246609 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246611 */     GIR_RootConstrainSelectedInstOperands,
     /* 246612 */     // GIR_Coverage, 2957,
     /* 246612 */     GIR_EraseRootFromParent_Done,
     /* 246613 */   // Label 4928: @246613
     /* 246613 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(246660), // Rule ID 2959 //
     /* 246618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246645 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 246648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246656 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246658 */     GIR_RootConstrainSelectedInstOperands,
     /* 246659 */     // GIR_Coverage, 2959,
     /* 246659 */     GIR_EraseRootFromParent_Done,
     /* 246660 */   // Label 4929: @246660
     /* 246660 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(246707), // Rule ID 2961 //
     /* 246665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 246695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246703 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246705 */     GIR_RootConstrainSelectedInstOperands,
     /* 246706 */     // GIR_Coverage, 2961,
     /* 246706 */     GIR_EraseRootFromParent_Done,
     /* 246707 */   // Label 4930: @246707
     /* 246707 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(246754), // Rule ID 2963 //
     /* 246712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246739 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 246742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246750 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246752 */     GIR_RootConstrainSelectedInstOperands,
     /* 246753 */     // GIR_Coverage, 2963,
     /* 246753 */     GIR_EraseRootFromParent_Done,
     /* 246754 */   // Label 4931: @246754
     /* 246754 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246801), // Rule ID 7540 //
     /* 246759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246786 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 246789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246797 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246799 */     GIR_RootConstrainSelectedInstOperands,
     /* 246800 */     // GIR_Coverage, 7540,
     /* 246800 */     GIR_EraseRootFromParent_Done,
     /* 246801 */   // Label 4932: @246801
     /* 246801 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246848), // Rule ID 7543 //
     /* 246806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246833 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 246836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246844 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246846 */     GIR_RootConstrainSelectedInstOperands,
     /* 246847 */     // GIR_Coverage, 7543,
     /* 246847 */     GIR_EraseRootFromParent_Done,
     /* 246848 */   // Label 4933: @246848
     /* 246848 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246895), // Rule ID 7546 //
     /* 246853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 246883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246891 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246893 */     GIR_RootConstrainSelectedInstOperands,
     /* 246894 */     // GIR_Coverage, 7546,
     /* 246894 */     GIR_EraseRootFromParent_Done,
     /* 246895 */   // Label 4934: @246895
     /* 246895 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246942), // Rule ID 7549 //
     /* 246900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 246930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246938 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246940 */     GIR_RootConstrainSelectedInstOperands,
     /* 246941 */     // GIR_Coverage, 7549,
     /* 246941 */     GIR_EraseRootFromParent_Done,
     /* 246942 */   // Label 4935: @246942
     /* 246942 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246989), // Rule ID 7552 //
     /* 246947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246974 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 246977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246985 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246987 */     GIR_RootConstrainSelectedInstOperands,
     /* 246988 */     // GIR_Coverage, 7552,
     /* 246988 */     GIR_EraseRootFromParent_Done,
     /* 246989 */   // Label 4936: @246989
     /* 246989 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(247036), // Rule ID 7554 //
     /* 246994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 247024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247032 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247034 */     GIR_RootConstrainSelectedInstOperands,
     /* 247035 */     // GIR_Coverage, 7554,
     /* 247035 */     GIR_EraseRootFromParent_Done,
     /* 247036 */   // Label 4937: @247036
     /* 247036 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(247083), // Rule ID 7556 //
     /* 247041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 247071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247079 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247081 */     GIR_RootConstrainSelectedInstOperands,
     /* 247082 */     // GIR_Coverage, 7556,
     /* 247082 */     GIR_EraseRootFromParent_Done,
     /* 247083 */   // Label 4938: @247083
     /* 247083 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(247130), // Rule ID 7558 //
     /* 247088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247115 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 247118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247126 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247128 */     GIR_RootConstrainSelectedInstOperands,
     /* 247129 */     // GIR_Coverage, 7558,
     /* 247129 */     GIR_EraseRootFromParent_Done,
     /* 247130 */   // Label 4939: @247130
     /* 247130 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(247177), // Rule ID 8188 //
     /* 247135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247162 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247173 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247175 */     GIR_RootConstrainSelectedInstOperands,
     /* 247176 */     // GIR_Coverage, 8188,
     /* 247176 */     GIR_EraseRootFromParent_Done,
     /* 247177 */   // Label 4940: @247177
     /* 247177 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(247224), // Rule ID 8191 //
     /* 247182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247209 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247220 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247222 */     GIR_RootConstrainSelectedInstOperands,
     /* 247223 */     // GIR_Coverage, 8191,
     /* 247223 */     GIR_EraseRootFromParent_Done,
     /* 247224 */   // Label 4941: @247224
     /* 247224 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(247271), // Rule ID 8194 //
     /* 247229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247256 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247267 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247269 */     GIR_RootConstrainSelectedInstOperands,
     /* 247270 */     // GIR_Coverage, 8194,
     /* 247270 */     GIR_EraseRootFromParent_Done,
     /* 247271 */   // Label 4942: @247271
     /* 247271 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(247318), // Rule ID 8197 //
     /* 247276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247303 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 247306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247314 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247316 */     GIR_RootConstrainSelectedInstOperands,
     /* 247317 */     // GIR_Coverage, 8197,
     /* 247317 */     GIR_EraseRootFromParent_Done,
     /* 247318 */   // Label 4943: @247318
     /* 247318 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(247365), // Rule ID 8200 //
     /* 247323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247350 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 247353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247361 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247363 */     GIR_RootConstrainSelectedInstOperands,
     /* 247364 */     // GIR_Coverage, 8200,
     /* 247364 */     GIR_EraseRootFromParent_Done,
     /* 247365 */   // Label 4944: @247365
     /* 247365 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(247412), // Rule ID 8203 //
     /* 247370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247397 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 247400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247408 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247410 */     GIR_RootConstrainSelectedInstOperands,
     /* 247411 */     // GIR_Coverage, 8203,
     /* 247411 */     GIR_EraseRootFromParent_Done,
     /* 247412 */   // Label 4945: @247412
     /* 247412 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247459), // Rule ID 8206 //
     /* 247417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247444 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247455 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247457 */     GIR_RootConstrainSelectedInstOperands,
     /* 247458 */     // GIR_Coverage, 8206,
     /* 247458 */     GIR_EraseRootFromParent_Done,
     /* 247459 */   // Label 4946: @247459
     /* 247459 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247506), // Rule ID 8207 //
     /* 247464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247491 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247502 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247504 */     GIR_RootConstrainSelectedInstOperands,
     /* 247505 */     // GIR_Coverage, 8207,
     /* 247505 */     GIR_EraseRootFromParent_Done,
     /* 247506 */   // Label 4947: @247506
     /* 247506 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247553), // Rule ID 8208 //
     /* 247511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247538 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247549 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247551 */     GIR_RootConstrainSelectedInstOperands,
     /* 247552 */     // GIR_Coverage, 8208,
     /* 247552 */     GIR_EraseRootFromParent_Done,
     /* 247553 */   // Label 4948: @247553
     /* 247553 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247600), // Rule ID 8209 //
     /* 247558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247585 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 247588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247596 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247598 */     GIR_RootConstrainSelectedInstOperands,
     /* 247599 */     // GIR_Coverage, 8209,
     /* 247599 */     GIR_EraseRootFromParent_Done,
     /* 247600 */   // Label 4949: @247600
     /* 247600 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247647), // Rule ID 8210 //
     /* 247605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247632 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 247635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247643 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247645 */     GIR_RootConstrainSelectedInstOperands,
     /* 247646 */     // GIR_Coverage, 8210,
     /* 247646 */     GIR_EraseRootFromParent_Done,
     /* 247647 */   // Label 4950: @247647
     /* 247647 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247694), // Rule ID 8211 //
     /* 247652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247679 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 247682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247690 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247692 */     GIR_RootConstrainSelectedInstOperands,
     /* 247693 */     // GIR_Coverage, 8211,
     /* 247693 */     GIR_EraseRootFromParent_Done,
     /* 247694 */   // Label 4951: @247694
     /* 247694 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247741), // Rule ID 8212 //
     /* 247699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247726 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247737 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247739 */     GIR_RootConstrainSelectedInstOperands,
     /* 247740 */     // GIR_Coverage, 8212,
     /* 247740 */     GIR_EraseRootFromParent_Done,
     /* 247741 */   // Label 4952: @247741
     /* 247741 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247788), // Rule ID 8213 //
     /* 247746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247773 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247784 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247786 */     GIR_RootConstrainSelectedInstOperands,
     /* 247787 */     // GIR_Coverage, 8213,
     /* 247787 */     GIR_EraseRootFromParent_Done,
     /* 247788 */   // Label 4953: @247788
     /* 247788 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247835), // Rule ID 8214 //
     /* 247793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247820 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247831 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247833 */     GIR_RootConstrainSelectedInstOperands,
     /* 247834 */     // GIR_Coverage, 8214,
     /* 247834 */     GIR_EraseRootFromParent_Done,
     /* 247835 */   // Label 4954: @247835
     /* 247835 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247882), // Rule ID 8215 //
     /* 247840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247867 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 247870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247878 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247880 */     GIR_RootConstrainSelectedInstOperands,
     /* 247881 */     // GIR_Coverage, 8215,
     /* 247881 */     GIR_EraseRootFromParent_Done,
     /* 247882 */   // Label 4955: @247882
     /* 247882 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247929), // Rule ID 8216 //
     /* 247887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247914 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 247917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247925 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247927 */     GIR_RootConstrainSelectedInstOperands,
     /* 247928 */     // GIR_Coverage, 8216,
     /* 247928 */     GIR_EraseRootFromParent_Done,
     /* 247929 */   // Label 4956: @247929
     /* 247929 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247976), // Rule ID 8217 //
     /* 247934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247961 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 247964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247972 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247974 */     GIR_RootConstrainSelectedInstOperands,
     /* 247975 */     // GIR_Coverage, 8217,
     /* 247975 */     GIR_EraseRootFromParent_Done,
     /* 247976 */   // Label 4957: @247976
     /* 247976 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(248023), // Rule ID 8218 //
     /* 247981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 247989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248008 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 248011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248019 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248021 */     GIR_RootConstrainSelectedInstOperands,
     /* 248022 */     // GIR_Coverage, 8218,
     /* 248022 */     GIR_EraseRootFromParent_Done,
     /* 248023 */   // Label 4958: @248023
     /* 248023 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(248070), // Rule ID 8219 //
     /* 248028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248055 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 248058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248066 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248068 */     GIR_RootConstrainSelectedInstOperands,
     /* 248069 */     // GIR_Coverage, 8219,
     /* 248069 */     GIR_EraseRootFromParent_Done,
     /* 248070 */   // Label 4959: @248070
     /* 248070 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(248117), // Rule ID 8220 //
     /* 248075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248102 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 248105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248113 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248115 */     GIR_RootConstrainSelectedInstOperands,
     /* 248116 */     // GIR_Coverage, 8220,
     /* 248116 */     GIR_EraseRootFromParent_Done,
     /* 248117 */   // Label 4960: @248117
     /* 248117 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(248164), // Rule ID 8221 //
     /* 248122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248149 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 248152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248160 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248162 */     GIR_RootConstrainSelectedInstOperands,
     /* 248163 */     // GIR_Coverage, 8221,
     /* 248163 */     GIR_EraseRootFromParent_Done,
     /* 248164 */   // Label 4961: @248164
     /* 248164 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(248211), // Rule ID 8222 //
     /* 248169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248196 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 248199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248207 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248209 */     GIR_RootConstrainSelectedInstOperands,
     /* 248210 */     // GIR_Coverage, 8222,
     /* 248210 */     GIR_EraseRootFromParent_Done,
     /* 248211 */   // Label 4962: @248211
     /* 248211 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(248258), // Rule ID 8223 //
     /* 248216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248243 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 248246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248254 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248256 */     GIR_RootConstrainSelectedInstOperands,
     /* 248257 */     // GIR_Coverage, 8223,
     /* 248257 */     GIR_EraseRootFromParent_Done,
     /* 248258 */   // Label 4963: @248258
     /* 248258 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(248305), // Rule ID 8224 //
     /* 248263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248290 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 248293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248301 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248303 */     GIR_RootConstrainSelectedInstOperands,
     /* 248304 */     // GIR_Coverage, 8224,
     /* 248304 */     GIR_EraseRootFromParent_Done,
     /* 248305 */   // Label 4964: @248305
     /* 248305 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(248352), // Rule ID 8225 //
     /* 248310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248337 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 248340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248348 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248350 */     GIR_RootConstrainSelectedInstOperands,
     /* 248351 */     // GIR_Coverage, 8225,
     /* 248351 */     GIR_EraseRootFromParent_Done,
     /* 248352 */   // Label 4965: @248352
     /* 248352 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248399), // Rule ID 8226 //
     /* 248357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248384 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 248387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248395 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248397 */     GIR_RootConstrainSelectedInstOperands,
     /* 248398 */     // GIR_Coverage, 8226,
     /* 248398 */     GIR_EraseRootFromParent_Done,
     /* 248399 */   // Label 4966: @248399
     /* 248399 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248446), // Rule ID 8227 //
     /* 248404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248431 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248442 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248444 */     GIR_RootConstrainSelectedInstOperands,
     /* 248445 */     // GIR_Coverage, 8227,
     /* 248445 */     GIR_EraseRootFromParent_Done,
     /* 248446 */   // Label 4967: @248446
     /* 248446 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248493), // Rule ID 8230 //
     /* 248451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248478 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248489 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248491 */     GIR_RootConstrainSelectedInstOperands,
     /* 248492 */     // GIR_Coverage, 8230,
     /* 248492 */     GIR_EraseRootFromParent_Done,
     /* 248493 */   // Label 4968: @248493
     /* 248493 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248540), // Rule ID 8233 //
     /* 248498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248525 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248536 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248538 */     GIR_RootConstrainSelectedInstOperands,
     /* 248539 */     // GIR_Coverage, 8233,
     /* 248539 */     GIR_EraseRootFromParent_Done,
     /* 248540 */   // Label 4969: @248540
     /* 248540 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248587), // Rule ID 8236 //
     /* 248545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248572 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 248575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248583 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248585 */     GIR_RootConstrainSelectedInstOperands,
     /* 248586 */     // GIR_Coverage, 8236,
     /* 248586 */     GIR_EraseRootFromParent_Done,
     /* 248587 */   // Label 4970: @248587
     /* 248587 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248634), // Rule ID 8239 //
     /* 248592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248619 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 248622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248630 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248632 */     GIR_RootConstrainSelectedInstOperands,
     /* 248633 */     // GIR_Coverage, 8239,
     /* 248633 */     GIR_EraseRootFromParent_Done,
     /* 248634 */   // Label 4971: @248634
     /* 248634 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248681), // Rule ID 8242 //
     /* 248639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248666 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 248669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248677 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248679 */     GIR_RootConstrainSelectedInstOperands,
     /* 248680 */     // GIR_Coverage, 8242,
     /* 248680 */     GIR_EraseRootFromParent_Done,
     /* 248681 */   // Label 4972: @248681
     /* 248681 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248728), // Rule ID 8245 //
     /* 248686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248713 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248724 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248726 */     GIR_RootConstrainSelectedInstOperands,
     /* 248727 */     // GIR_Coverage, 8245,
     /* 248727 */     GIR_EraseRootFromParent_Done,
     /* 248728 */   // Label 4973: @248728
     /* 248728 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248775), // Rule ID 8248 //
     /* 248733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248760 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248771 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248773 */     GIR_RootConstrainSelectedInstOperands,
     /* 248774 */     // GIR_Coverage, 8248,
     /* 248774 */     GIR_EraseRootFromParent_Done,
     /* 248775 */   // Label 4974: @248775
     /* 248775 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248822), // Rule ID 8251 //
     /* 248780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248807 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248818 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248820 */     GIR_RootConstrainSelectedInstOperands,
     /* 248821 */     // GIR_Coverage, 8251,
     /* 248821 */     GIR_EraseRootFromParent_Done,
     /* 248822 */   // Label 4975: @248822
     /* 248822 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248869), // Rule ID 8254 //
     /* 248827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 248857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248865 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248867 */     GIR_RootConstrainSelectedInstOperands,
     /* 248868 */     // GIR_Coverage, 8254,
     /* 248868 */     GIR_EraseRootFromParent_Done,
     /* 248869 */   // Label 4976: @248869
     /* 248869 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248916), // Rule ID 8257 //
     /* 248874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248901 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 248904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248912 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248914 */     GIR_RootConstrainSelectedInstOperands,
     /* 248915 */     // GIR_Coverage, 8257,
     /* 248915 */     GIR_EraseRootFromParent_Done,
     /* 248916 */   // Label 4977: @248916
     /* 248916 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248963), // Rule ID 8260 //
     /* 248921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248948 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 248951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248959 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248961 */     GIR_RootConstrainSelectedInstOperands,
     /* 248962 */     // GIR_Coverage, 8260,
     /* 248962 */     GIR_EraseRootFromParent_Done,
     /* 248963 */   // Label 4978: @248963
     /* 248963 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(249010), // Rule ID 8263 //
     /* 248968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248995 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 248998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249006 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249008 */     GIR_RootConstrainSelectedInstOperands,
     /* 249009 */     // GIR_Coverage, 8263,
     /* 249009 */     GIR_EraseRootFromParent_Done,
     /* 249010 */   // Label 4979: @249010
     /* 249010 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(249057), // Rule ID 8265 //
     /* 249015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249042 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249053 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249055 */     GIR_RootConstrainSelectedInstOperands,
     /* 249056 */     // GIR_Coverage, 8265,
     /* 249056 */     GIR_EraseRootFromParent_Done,
     /* 249057 */   // Label 4980: @249057
     /* 249057 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(249104), // Rule ID 8267 //
     /* 249062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249089 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249100 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249102 */     GIR_RootConstrainSelectedInstOperands,
     /* 249103 */     // GIR_Coverage, 8267,
     /* 249103 */     GIR_EraseRootFromParent_Done,
     /* 249104 */   // Label 4981: @249104
     /* 249104 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(249151), // Rule ID 8269 //
     /* 249109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249136 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249147 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249149 */     GIR_RootConstrainSelectedInstOperands,
     /* 249150 */     // GIR_Coverage, 8269,
     /* 249150 */     GIR_EraseRootFromParent_Done,
     /* 249151 */   // Label 4982: @249151
     /* 249151 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(249198), // Rule ID 8271 //
     /* 249156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249183 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249194 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249196 */     GIR_RootConstrainSelectedInstOperands,
     /* 249197 */     // GIR_Coverage, 8271,
     /* 249197 */     GIR_EraseRootFromParent_Done,
     /* 249198 */   // Label 4983: @249198
     /* 249198 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(249245), // Rule ID 8273 //
     /* 249203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249230 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 249233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249241 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249243 */     GIR_RootConstrainSelectedInstOperands,
     /* 249244 */     // GIR_Coverage, 8273,
     /* 249244 */     GIR_EraseRootFromParent_Done,
     /* 249245 */   // Label 4984: @249245
     /* 249245 */   GIM_Reject,
     /* 249246 */ // Label 4843: @249246
     /* 249246 */ GIM_Reject,
     /* 249247 */ // Label 36: @249247
     /* 249247 */ GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249325),
     /* 249252 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 249255 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249277), // Rule ID 78 //
     /* 249260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 249268 */     // (intrinsic_void 2166:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 249268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 249271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249275 */     GIR_RootConstrainSelectedInstOperands,
     /* 249276 */     // GIR_Coverage, 78,
     /* 249276 */     GIR_EraseRootFromParent_Done,
     /* 249277 */   // Label 4986: @249277
     /* 249277 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249302), // Rule ID 2386 //
     /* 249282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 249290 */     // (intrinsic_void 1716:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 249290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 249293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 249296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249300 */     GIR_RootConstrainSelectedInstOperands,
     /* 249301 */     // GIR_Coverage, 2386,
     /* 249301 */     GIR_EraseRootFromParent_Done,
     /* 249302 */   // Label 4987: @249302
     /* 249302 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249324), // Rule ID 7124 //
     /* 249307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 249312 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 249312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 249315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 249318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249322 */     GIR_RootConstrainSelectedInstOperands,
     /* 249323 */     // GIR_Coverage, 7124,
     /* 249323 */     GIR_EraseRootFromParent_Done,
     /* 249324 */   // Label 4988: @249324
     /* 249324 */   GIM_Reject,
     /* 249325 */ // Label 4985: @249325
     /* 249325 */ GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249925),
     /* 249330 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 249333 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249365), // Rule ID 79 //
     /* 249338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 249346 */     // MIs[0] imm
     /* 249346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 249354 */     // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 249354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 249357 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249363 */     GIR_RootConstrainSelectedInstOperands,
     /* 249364 */     // GIR_Coverage, 79,
     /* 249364 */     GIR_EraseRootFromParent_Done,
     /* 249365 */   // Label 4990: @249365
     /* 249365 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249390), // Rule ID 227 //
     /* 249370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 249375 */     // MIs[0] imm
     /* 249375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 249383 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 249383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 249386 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249388 */     GIR_RootConstrainSelectedInstOperands,
     /* 249389 */     // GIR_Coverage, 227,
     /* 249389 */     GIR_EraseRootFromParent_Done,
     /* 249390 */   // Label 4991: @249390
     /* 249390 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249415), // Rule ID 228 //
     /* 249395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 249400 */     // MIs[0] imm
     /* 249400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 249408 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 249408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 249411 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249413 */     GIR_RootConstrainSelectedInstOperands,
     /* 249414 */     // GIR_Coverage, 228,
     /* 249414 */     GIR_EraseRootFromParent_Done,
     /* 249415 */   // Label 4992: @249415
     /* 249415 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249447), // Rule ID 3624 //
     /* 249420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 249428 */     // MIs[0] imm
     /* 249428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 249436 */     // (intrinsic_void 1222:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 249436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 249439 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249445 */     GIR_RootConstrainSelectedInstOperands,
     /* 249446 */     // GIR_Coverage, 3624,
     /* 249446 */     GIR_EraseRootFromParent_Done,
     /* 249447 */   // Label 4993: @249447
     /* 249447 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249487), // Rule ID 16 //
     /* 249452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 249457 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 249472 */     // MIs[1] Operand 1
     /* 249472 */     // No operand predicates
     /* 249472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249474 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 249474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 249477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 249480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249485 */     GIR_RootConstrainSelectedInstOperands,
     /* 249486 */     // GIR_Coverage, 16,
     /* 249486 */     GIR_EraseRootFromParent_Done,
     /* 249487 */   // Label 4994: @249487
     /* 249487 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249527), // Rule ID 17 //
     /* 249492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 249497 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249512 */     // MIs[1] Operand 1
     /* 249512 */     // No operand predicates
     /* 249512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249514 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 249514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 249517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249525 */     GIR_RootConstrainSelectedInstOperands,
     /* 249526 */     // GIR_Coverage, 17,
     /* 249526 */     GIR_EraseRootFromParent_Done,
     /* 249527 */   // Label 4995: @249527
     /* 249527 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249567), // Rule ID 18 //
     /* 249532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 249537 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249552 */     // MIs[1] Operand 1
     /* 249552 */     // No operand predicates
     /* 249552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249554 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 249554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 249557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249565 */     GIR_RootConstrainSelectedInstOperands,
     /* 249566 */     // GIR_Coverage, 18,
     /* 249566 */     GIR_EraseRootFromParent_Done,
     /* 249567 */   // Label 4996: @249567
     /* 249567 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249607), // Rule ID 19 //
     /* 249572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 249577 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249592 */     // MIs[1] Operand 1
     /* 249592 */     // No operand predicates
     /* 249592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249594 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 249594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 249597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249605 */     GIR_RootConstrainSelectedInstOperands,
     /* 249606 */     // GIR_Coverage, 19,
     /* 249606 */     GIR_EraseRootFromParent_Done,
     /* 249607 */   // Label 4997: @249607
     /* 249607 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249631), // Rule ID 72 //
     /* 249612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 249617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249624 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 249624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 249627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249629 */     GIR_RootConstrainSelectedInstOperands,
     /* 249630 */     // GIR_Coverage, 72,
     /* 249630 */     GIR_EraseRootFromParent_Done,
     /* 249631 */   // Label 4998: @249631
     /* 249631 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249655), // Rule ID 74 //
     /* 249636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 249641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249648 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 249648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 249651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249653 */     GIR_RootConstrainSelectedInstOperands,
     /* 249654 */     // GIR_Coverage, 74,
     /* 249654 */     GIR_EraseRootFromParent_Done,
     /* 249655 */   // Label 4999: @249655
     /* 249655 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(249686), // Rule ID 77 //
     /* 249660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 249668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249675 */     // (intrinsic_w_chain:{ *:[i64] } 2167:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 249675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 249678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249684 */     GIR_RootConstrainSelectedInstOperands,
     /* 249685 */     // GIR_Coverage, 77,
     /* 249685 */     GIR_EraseRootFromParent_Done,
     /* 249686 */   // Label 5000: @249686
     /* 249686 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(249713), // Rule ID 80 //
     /* 249691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 249699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249706 */     // (intrinsic_w_chain:{ *:[i64] } 2168:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 249706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 249709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249711 */     GIR_RootConstrainSelectedInstOperands,
     /* 249712 */     // GIR_Coverage, 80,
     /* 249712 */     GIR_EraseRootFromParent_Done,
     /* 249713 */   // Label 5001: @249713
     /* 249713 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(249744), // Rule ID 2385 //
     /* 249718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 249726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 249729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249733 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1666:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 249733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 249736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 249738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249742 */     GIR_RootConstrainSelectedInstOperands,
     /* 249743 */     // GIR_Coverage, 2385,
     /* 249743 */     GIR_EraseRootFromParent_Done,
     /* 249744 */   // Label 5002: @249744
     /* 249744 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(249784), // Rule ID 12757 //
     /* 249749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 249757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249764 */     // (intrinsic_w_chain:{ *:[i64] } 891:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 249764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 249767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249769 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 249779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 249782 */     GIR_RootConstrainSelectedInstOperands,
     /* 249783 */     // GIR_Coverage, 12757,
     /* 249783 */     GIR_EraseRootFromParent_Done,
     /* 249784 */   // Label 5003: @249784
     /* 249784 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(249818), // Rule ID 2387 //
     /* 249789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 249797 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 249800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249804 */     // (intrinsic_void 2146:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 249804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 249807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 249809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 249812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249816 */     GIR_RootConstrainSelectedInstOperands,
     /* 249817 */     // GIR_Coverage, 2387,
     /* 249817 */     GIR_EraseRootFromParent_Done,
     /* 249818 */   // Label 5004: @249818
     /* 249818 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(249841), // Rule ID 73 //
     /* 249823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 249828 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249831 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 249831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 249834 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 249839 */     GIR_RootConstrainSelectedInstOperands,
     /* 249840 */     // GIR_Coverage, 73,
     /* 249840 */     GIR_EraseRootFromParent_Done,
     /* 249841 */   // Label 5005: @249841
     /* 249841 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(249864), // Rule ID 75 //
     /* 249846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 249851 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249854 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 249854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 249857 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 249862 */     GIR_RootConstrainSelectedInstOperands,
     /* 249863 */     // GIR_Coverage, 75,
     /* 249863 */     GIR_EraseRootFromParent_Done,
     /* 249864 */   // Label 5006: @249864
     /* 249864 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(249891), // Rule ID 76 //
     /* 249869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 249874 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249877 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 249877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 249880 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 249885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249889 */     GIR_RootConstrainSelectedInstOperands,
     /* 249890 */     // GIR_Coverage, 76,
     /* 249890 */     GIR_EraseRootFromParent_Done,
     /* 249891 */   // Label 5007: @249891
     /* 249891 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(249924), // Rule ID 12756 //
     /* 249896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 249904 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249907 */     // (intrinsic_void 966:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 249907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 249910 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 249920 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249922 */     GIR_RootConstrainSelectedInstOperands,
     /* 249923 */     // GIR_Coverage, 12756,
     /* 249923 */     GIR_EraseRootFromParent_Done,
     /* 249924 */   // Label 5008: @249924
     /* 249924 */   GIM_Reject,
     /* 249925 */ // Label 4989: @249925
     /* 249925 */ GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250896),
     /* 249930 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 249933 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250009), // Rule ID 7090 //
     /* 249938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 249943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249950 */     // MIs[0] addr
     /* 249950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249958 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 249962 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 249969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249978 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250008 */     // GIR_Coverage, 7090,
     /* 250008 */     GIR_EraseRootFromParent_Done,
     /* 250009 */   // Label 5010: @250009
     /* 250009 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250085), // Rule ID 7091 //
     /* 250014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250026 */     // MIs[0] addr
     /* 250026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250034 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 250038 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 250045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250054 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250084 */     // GIR_Coverage, 7091,
     /* 250084 */     GIR_EraseRootFromParent_Done,
     /* 250085 */   // Label 5011: @250085
     /* 250085 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250161), // Rule ID 7092 //
     /* 250090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250102 */     // MIs[0] addr
     /* 250102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 250114 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 250121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250130 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250160 */     // GIR_Coverage, 7092,
     /* 250160 */     GIR_EraseRootFromParent_Done,
     /* 250161 */   // Label 5012: @250161
     /* 250161 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250203), // Rule ID 7093 //
     /* 250166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250178 */     // MIs[0] addr
     /* 250178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250186 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 250190 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 250190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 250193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250195 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 250197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250201 */     GIR_RootConstrainSelectedInstOperands,
     /* 250202 */     // GIR_Coverage, 7093,
     /* 250202 */     GIR_EraseRootFromParent_Done,
     /* 250203 */   // Label 5013: @250203
     /* 250203 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250279), // Rule ID 7097 //
     /* 250208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250220 */     // MIs[0] addr
     /* 250220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 250232 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 250239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250248 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250278 */     // GIR_Coverage, 7097,
     /* 250278 */     GIR_EraseRootFromParent_Done,
     /* 250279 */   // Label 5014: @250279
     /* 250279 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250355), // Rule ID 7098 //
     /* 250284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250296 */     // MIs[0] addr
     /* 250296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250304 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 250308 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 250315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250324 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250354 */     // GIR_Coverage, 7098,
     /* 250354 */     GIR_EraseRootFromParent_Done,
     /* 250355 */   // Label 5015: @250355
     /* 250355 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250431), // Rule ID 7099 //
     /* 250360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250372 */     // MIs[0] addr
     /* 250372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250380 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 250384 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 250391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250400 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250430 */     // GIR_Coverage, 7099,
     /* 250430 */     GIR_EraseRootFromParent_Done,
     /* 250431 */   // Label 5016: @250431
     /* 250431 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250473), // Rule ID 7100 //
     /* 250436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250448 */     // MIs[0] addr
     /* 250448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250456 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 250460 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 250460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 250463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250465 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 250467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250471 */     GIR_RootConstrainSelectedInstOperands,
     /* 250472 */     // GIR_Coverage, 7100,
     /* 250472 */     GIR_EraseRootFromParent_Done,
     /* 250473 */   // Label 5017: @250473
     /* 250473 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250513), // Rule ID 20 //
     /* 250478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 250481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 250486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250500 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 250500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 250503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250505 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250511 */     GIR_RootConstrainSelectedInstOperands,
     /* 250512 */     // GIR_Coverage, 20,
     /* 250512 */     GIR_EraseRootFromParent_Done,
     /* 250513 */   // Label 5018: @250513
     /* 250513 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250553), // Rule ID 2384 //
     /* 250518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 250526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 250529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250540 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1667:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 250540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 250543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 250545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 250547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250551 */     GIR_RootConstrainSelectedInstOperands,
     /* 250552 */     // GIR_Coverage, 2384,
     /* 250552 */     GIR_EraseRootFromParent_Done,
     /* 250553 */   // Label 5019: @250553
     /* 250553 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250593), // Rule ID 2495 //
     /* 250558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 250566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 250572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250580 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 250580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 250583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250591 */     GIR_RootConstrainSelectedInstOperands,
     /* 250592 */     // GIR_Coverage, 2495,
     /* 250592 */     GIR_EraseRootFromParent_Done,
     /* 250593 */   // Label 5020: @250593
     /* 250593 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(250633), // Rule ID 2496 //
     /* 250598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 250606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 250612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250620 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 250620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 250623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250631 */     GIR_RootConstrainSelectedInstOperands,
     /* 250632 */     // GIR_Coverage, 2496,
     /* 250632 */     GIR_EraseRootFromParent_Done,
     /* 250633 */   // Label 5021: @250633
     /* 250633 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(250673), // Rule ID 6979 //
     /* 250638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 250646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 250652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250660 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 250660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 250663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250671 */     GIR_RootConstrainSelectedInstOperands,
     /* 250672 */     // GIR_Coverage, 6979,
     /* 250672 */     GIR_EraseRootFromParent_Done,
     /* 250673 */   // Label 5022: @250673
     /* 250673 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(250713), // Rule ID 6980 //
     /* 250678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 250686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 250692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250700 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 250700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 250703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250711 */     GIR_RootConstrainSelectedInstOperands,
     /* 250712 */     // GIR_Coverage, 6980,
     /* 250712 */     GIR_EraseRootFromParent_Done,
     /* 250713 */   // Label 5023: @250713
     /* 250713 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(250749), // Rule ID 3577 //
     /* 250718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 250726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250736 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 250739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250747 */     GIR_RootConstrainSelectedInstOperands,
     /* 250748 */     // GIR_Coverage, 3577,
     /* 250748 */     GIR_EraseRootFromParent_Done,
     /* 250749 */   // Label 5024: @250749
     /* 250749 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(250787), // Rule ID 4001 //
     /* 250754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 250757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 250762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250772 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 250772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 250775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 250783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 250785 */     GIR_RootConstrainSelectedInstOperands,
     /* 250786 */     // GIR_Coverage, 4001,
     /* 250786 */     GIR_EraseRootFromParent_Done,
     /* 250787 */   // Label 5025: @250787
     /* 250787 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(250823), // Rule ID 12482 //
     /* 250792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 250800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250810 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 250813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250821 */     GIR_RootConstrainSelectedInstOperands,
     /* 250822 */     // GIR_Coverage, 12482,
     /* 250822 */     GIR_EraseRootFromParent_Done,
     /* 250823 */   // Label 5026: @250823
     /* 250823 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(250859), // Rule ID 12483 //
     /* 250828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 250836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250846 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 250849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250857 */     GIR_RootConstrainSelectedInstOperands,
     /* 250858 */     // GIR_Coverage, 12483,
     /* 250858 */     GIR_EraseRootFromParent_Done,
     /* 250859 */   // Label 5027: @250859
     /* 250859 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(250895), // Rule ID 12484 //
     /* 250864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 250872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250882 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 250885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250893 */     GIR_RootConstrainSelectedInstOperands,
     /* 250894 */     // GIR_Coverage, 12484,
     /* 250894 */     GIR_EraseRootFromParent_Done,
     /* 250895 */   // Label 5028: @250895
     /* 250895 */   GIM_Reject,
     /* 250896 */ // Label 5009: @250896
     /* 250896 */ GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(255064),
     /* 250901 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 250904 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(251001), // Rule ID 7108 //
     /* 250909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 250932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 250936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 250940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 250948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 250952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250957 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 250968 */     // MIs[0] addr
     /* 250968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 250980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 250982 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 250982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 250985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 250991 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 250999 */     GIR_RootConstrainSelectedInstOperands,
     /* 251000 */     // GIR_Coverage, 7108,
     /* 251000 */     GIR_EraseRootFromParent_Done,
     /* 251001 */   // Label 5030: @251001
     /* 251001 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251098), // Rule ID 7109 //
     /* 251006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251054 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251065 */     // MIs[0] addr
     /* 251065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251073 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251079 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251088 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251096 */     GIR_RootConstrainSelectedInstOperands,
     /* 251097 */     // GIR_Coverage, 7109,
     /* 251097 */     GIR_EraseRootFromParent_Done,
     /* 251098 */   // Label 5031: @251098
     /* 251098 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251195), // Rule ID 7118 //
     /* 251103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251151 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 251162 */     // MIs[0] addr
     /* 251162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 251174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251176 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 251179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251185 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251193 */     GIR_RootConstrainSelectedInstOperands,
     /* 251194 */     // GIR_Coverage, 7118,
     /* 251194 */     GIR_EraseRootFromParent_Done,
     /* 251195 */   // Label 5032: @251195
     /* 251195 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251292), // Rule ID 7119 //
     /* 251200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251248 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251259 */     // MIs[0] addr
     /* 251259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 251271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251273 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 251276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251282 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251290 */     GIR_RootConstrainSelectedInstOperands,
     /* 251291 */     // GIR_Coverage, 7119,
     /* 251291 */     GIR_EraseRootFromParent_Done,
     /* 251292 */   // Label 5033: @251292
     /* 251292 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(251403), // Rule ID 7111 //
     /* 251297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251333 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 251344 */     // MIs[0] addr
     /* 251344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 251356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251358 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251370 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 251389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251394 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251401 */     GIR_RootConstrainSelectedInstOperands,
     /* 251402 */     // GIR_Coverage, 7111,
     /* 251402 */     GIR_EraseRootFromParent_Done,
     /* 251403 */   // Label 5034: @251403
     /* 251403 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(251514), // Rule ID 7112 //
     /* 251408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251444 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 251455 */     // MIs[0] addr
     /* 251455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251463 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251469 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251481 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251505 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251512 */     GIR_RootConstrainSelectedInstOperands,
     /* 251513 */     // GIR_Coverage, 7112,
     /* 251513 */     GIR_EraseRootFromParent_Done,
     /* 251514 */   // Label 5035: @251514
     /* 251514 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251625), // Rule ID 7113 //
     /* 251519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251555 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 251566 */     // MIs[0] addr
     /* 251566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251574 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 251578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251580 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251592 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 251611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251616 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251623 */     GIR_RootConstrainSelectedInstOperands,
     /* 251624 */     // GIR_Coverage, 7113,
     /* 251624 */     GIR_EraseRootFromParent_Done,
     /* 251625 */   // Label 5036: @251625
     /* 251625 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251736), // Rule ID 7121 //
     /* 251630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251666 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 251677 */     // MIs[0] addr
     /* 251677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251685 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 251689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251691 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251703 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 251722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251727 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251734 */     GIR_RootConstrainSelectedInstOperands,
     /* 251735 */     // GIR_Coverage, 7121,
     /* 251735 */     GIR_EraseRootFromParent_Done,
     /* 251736 */   // Label 5037: @251736
     /* 251736 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251847), // Rule ID 7122 //
     /* 251741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251777 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 251788 */     // MIs[0] addr
     /* 251788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251796 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 251800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251802 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251814 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 251833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251838 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251845 */     GIR_RootConstrainSelectedInstOperands,
     /* 251846 */     // GIR_Coverage, 7122,
     /* 251846 */     GIR_EraseRootFromParent_Done,
     /* 251847 */   // Label 5038: @251847
     /* 251847 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251958), // Rule ID 7123 //
     /* 251852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251888 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 251899 */     // MIs[0] addr
     /* 251899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251907 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 251911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251913 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251925 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 251944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251949 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251956 */     GIR_RootConstrainSelectedInstOperands,
     /* 251957 */     // GIR_Coverage, 7123,
     /* 251957 */     GIR_EraseRootFromParent_Done,
     /* 251958 */   // Label 5039: @251958
     /* 251958 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(252009), // Rule ID 70 //
     /* 251963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 251968 */     // MIs[0] ptr
     /* 251968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 251972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 251976 */     // MIs[0] accessinfo
     /* 251976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 251979 */     // MIs[0] fixed_shadow
     /* 251979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251982 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 251982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 251985 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 251987 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 251989 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 251991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 251994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 251997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252007 */     GIR_RootConstrainSelectedInstOperands,
     /* 252008 */     // GIR_Coverage, 70,
     /* 252008 */     GIR_EraseRootFromParent_Done,
     /* 252009 */   // Label 5040: @252009
     /* 252009 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(252060), // Rule ID 71 //
     /* 252014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 252019 */     // MIs[0] ptr
     /* 252019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 252023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 252027 */     // MIs[0] accessinfo
     /* 252027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252030 */     // MIs[0] fixed_shadow
     /* 252030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252033 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 252033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 252036 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 252038 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 252040 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 252042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252058 */     GIR_RootConstrainSelectedInstOperands,
     /* 252059 */     // GIR_Coverage, 71,
     /* 252059 */     GIR_EraseRootFromParent_Done,
     /* 252060 */   // Label 5041: @252060
     /* 252060 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(252129), // Rule ID 7110 //
     /* 252065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252097 */     // MIs[0] addr
     /* 252097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 252109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252111 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 252114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252120 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252127 */     GIR_RootConstrainSelectedInstOperands,
     /* 252128 */     // GIR_Coverage, 7110,
     /* 252128 */     GIR_EraseRootFromParent_Done,
     /* 252129 */   // Label 5042: @252129
     /* 252129 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(252198), // Rule ID 7120 //
     /* 252134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252166 */     // MIs[0] addr
     /* 252166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252174 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 252178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252180 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 252183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252189 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252196 */     GIR_RootConstrainSelectedInstOperands,
     /* 252197 */     // GIR_Coverage, 7120,
     /* 252197 */     GIR_EraseRootFromParent_Done,
     /* 252198 */   // Label 5043: @252198
     /* 252198 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(252240), // Rule ID 3601 //
     /* 252203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 252211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252217 */     // MIs[0] tile
     /* 252217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252225 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 252228 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252238 */     GIR_RootConstrainSelectedInstOperands,
     /* 252239 */     // GIR_Coverage, 3601,
     /* 252239 */     GIR_EraseRootFromParent_Done,
     /* 252240 */   // Label 5044: @252240
     /* 252240 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(252282), // Rule ID 3605 //
     /* 252245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 252253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252259 */     // MIs[0] tile
     /* 252259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252267 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 252270 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252280 */     GIR_RootConstrainSelectedInstOperands,
     /* 252281 */     // GIR_Coverage, 3605,
     /* 252281 */     GIR_EraseRootFromParent_Done,
     /* 252282 */   // Label 5045: @252282
     /* 252282 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(252324), // Rule ID 3609 //
     /* 252287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 252295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252301 */     // MIs[0] tile
     /* 252301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252309 */     // (intrinsic_void 1019:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 252312 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252322 */     GIR_RootConstrainSelectedInstOperands,
     /* 252323 */     // GIR_Coverage, 3609,
     /* 252323 */     GIR_EraseRootFromParent_Done,
     /* 252324 */   // Label 5046: @252324
     /* 252324 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(252366), // Rule ID 3779 //
     /* 252329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 252332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252343 */     // MIs[0] tile
     /* 252343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 252351 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 252354 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252364 */     GIR_RootConstrainSelectedInstOperands,
     /* 252365 */     // GIR_Coverage, 3779,
     /* 252365 */     GIR_EraseRootFromParent_Done,
     /* 252366 */   // Label 5047: @252366
     /* 252366 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252408), // Rule ID 3783 //
     /* 252371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 252374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 252379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252385 */     // MIs[0] tile
     /* 252385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252393 */     // (intrinsic_void 875:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 252396 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252406 */     GIR_RootConstrainSelectedInstOperands,
     /* 252407 */     // GIR_Coverage, 3783,
     /* 252407 */     GIR_EraseRootFromParent_Done,
     /* 252408 */   // Label 5048: @252408
     /* 252408 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252450), // Rule ID 3787 //
     /* 252413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252427 */     // MIs[0] tile
     /* 252427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252430 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252435 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 252435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 252438 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252448 */     GIR_RootConstrainSelectedInstOperands,
     /* 252449 */     // GIR_Coverage, 3787,
     /* 252449 */     GIR_EraseRootFromParent_Done,
     /* 252450 */   // Label 5049: @252450
     /* 252450 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252492), // Rule ID 3791 //
     /* 252455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 252458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252469 */     // MIs[0] tile
     /* 252469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252477 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 252477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 252480 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252490 */     GIR_RootConstrainSelectedInstOperands,
     /* 252491 */     // GIR_Coverage, 3791,
     /* 252491 */     GIR_EraseRootFromParent_Done,
     /* 252492 */   // Label 5050: @252492
     /* 252492 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(252534), // Rule ID 3795 //
     /* 252497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 252505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252511 */     // MIs[0] tile
     /* 252511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252519 */     // (intrinsic_void 916:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 252522 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252532 */     GIR_RootConstrainSelectedInstOperands,
     /* 252533 */     // GIR_Coverage, 3795,
     /* 252533 */     GIR_EraseRootFromParent_Done,
     /* 252534 */   // Label 5051: @252534
     /* 252534 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(252576), // Rule ID 3799 //
     /* 252539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 252542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 252547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252553 */     // MIs[0] tile
     /* 252553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 252561 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 252564 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252574 */     GIR_RootConstrainSelectedInstOperands,
     /* 252575 */     // GIR_Coverage, 3799,
     /* 252575 */     GIR_EraseRootFromParent_Done,
     /* 252576 */   // Label 5052: @252576
     /* 252576 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(252618), // Rule ID 12561 //
     /* 252581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 252589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252595 */     // MIs[0] tile
     /* 252595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252603 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 252606 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252616 */     GIR_RootConstrainSelectedInstOperands,
     /* 252617 */     // GIR_Coverage, 12561,
     /* 252617 */     GIR_EraseRootFromParent_Done,
     /* 252618 */   // Label 5053: @252618
     /* 252618 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(252660), // Rule ID 12565 //
     /* 252623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 252631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252637 */     // MIs[0] tile
     /* 252637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252645 */     // (intrinsic_void 1067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 252648 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252658 */     GIR_RootConstrainSelectedInstOperands,
     /* 252659 */     // GIR_Coverage, 12565,
     /* 252659 */     GIR_EraseRootFromParent_Done,
     /* 252660 */   // Label 5054: @252660
     /* 252660 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(252702), // Rule ID 12569 //
     /* 252665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 252673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252679 */     // MIs[0] tile
     /* 252679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252687 */     // (intrinsic_void 1075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 252690 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252700 */     GIR_RootConstrainSelectedInstOperands,
     /* 252701 */     // GIR_Coverage, 12569,
     /* 252701 */     GIR_EraseRootFromParent_Done,
     /* 252702 */   // Label 5055: @252702
     /* 252702 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252744), // Rule ID 12573 //
     /* 252707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 252715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252721 */     // MIs[0] tile
     /* 252721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252729 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 252732 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252742 */     GIR_RootConstrainSelectedInstOperands,
     /* 252743 */     // GIR_Coverage, 12573,
     /* 252743 */     GIR_EraseRootFromParent_Done,
     /* 252744 */   // Label 5056: @252744
     /* 252744 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252786), // Rule ID 12577 //
     /* 252749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 252757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252763 */     // MIs[0] tile
     /* 252763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252771 */     // (intrinsic_void 1192:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 252774 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252784 */     GIR_RootConstrainSelectedInstOperands,
     /* 252785 */     // GIR_Coverage, 12577,
     /* 252785 */     GIR_EraseRootFromParent_Done,
     /* 252786 */   // Label 5057: @252786
     /* 252786 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252828), // Rule ID 12581 //
     /* 252791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 252799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252805 */     // MIs[0] tile
     /* 252805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252808 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252813 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 252816 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252826 */     GIR_RootConstrainSelectedInstOperands,
     /* 252827 */     // GIR_Coverage, 12581,
     /* 252827 */     GIR_EraseRootFromParent_Done,
     /* 252828 */   // Label 5058: @252828
     /* 252828 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252870), // Rule ID 12585 //
     /* 252833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 252841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252847 */     // MIs[0] tile
     /* 252847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252855 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 252858 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252868 */     GIR_RootConstrainSelectedInstOperands,
     /* 252869 */     // GIR_Coverage, 12585,
     /* 252869 */     GIR_EraseRootFromParent_Done,
     /* 252870 */   // Label 5059: @252870
     /* 252870 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(252912), // Rule ID 12589 //
     /* 252875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 252883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252889 */     // MIs[0] tile
     /* 252889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252897 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 252900 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252910 */     GIR_RootConstrainSelectedInstOperands,
     /* 252911 */     // GIR_Coverage, 12589,
     /* 252911 */     GIR_EraseRootFromParent_Done,
     /* 252912 */   // Label 5060: @252912
     /* 252912 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(252954), // Rule ID 12593 //
     /* 252917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 252925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252931 */     // MIs[0] tile
     /* 252931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252939 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 252942 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252952 */     GIR_RootConstrainSelectedInstOperands,
     /* 252953 */     // GIR_Coverage, 12593,
     /* 252953 */     GIR_EraseRootFromParent_Done,
     /* 252954 */   // Label 5061: @252954
     /* 252954 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(252996), // Rule ID 12597 //
     /* 252959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 252967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252973 */     // MIs[0] tile
     /* 252973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252981 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 252984 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252994 */     GIR_RootConstrainSelectedInstOperands,
     /* 252995 */     // GIR_Coverage, 12597,
     /* 252995 */     GIR_EraseRootFromParent_Done,
     /* 252996 */   // Label 5062: @252996
     /* 252996 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(253038), // Rule ID 12601 //
     /* 253001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 253009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253015 */     // MIs[0] tile
     /* 253015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253023 */     // (intrinsic_void 1027:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 253026 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253036 */     GIR_RootConstrainSelectedInstOperands,
     /* 253037 */     // GIR_Coverage, 12601,
     /* 253037 */     GIR_EraseRootFromParent_Done,
     /* 253038 */   // Label 5063: @253038
     /* 253038 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(253080), // Rule ID 12605 //
     /* 253043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 253051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253057 */     // MIs[0] tile
     /* 253057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253065 */     // (intrinsic_void 1071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 253068 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253078 */     GIR_RootConstrainSelectedInstOperands,
     /* 253079 */     // GIR_Coverage, 12605,
     /* 253079 */     GIR_EraseRootFromParent_Done,
     /* 253080 */   // Label 5064: @253080
     /* 253080 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(253122), // Rule ID 12609 //
     /* 253085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 253093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253099 */     // MIs[0] tile
     /* 253099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253107 */     // (intrinsic_void 1079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 253110 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253120 */     GIR_RootConstrainSelectedInstOperands,
     /* 253121 */     // GIR_Coverage, 12609,
     /* 253121 */     GIR_EraseRootFromParent_Done,
     /* 253122 */   // Label 5065: @253122
     /* 253122 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(253164), // Rule ID 12613 //
     /* 253127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 253135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253141 */     // MIs[0] tile
     /* 253141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253149 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 253152 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253162 */     GIR_RootConstrainSelectedInstOperands,
     /* 253163 */     // GIR_Coverage, 12613,
     /* 253163 */     GIR_EraseRootFromParent_Done,
     /* 253164 */   // Label 5066: @253164
     /* 253164 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(253206), // Rule ID 12617 //
     /* 253169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 253177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253183 */     // MIs[0] tile
     /* 253183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253191 */     // (intrinsic_void 1162:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 253194 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253204 */     GIR_RootConstrainSelectedInstOperands,
     /* 253205 */     // GIR_Coverage, 12617,
     /* 253205 */     GIR_EraseRootFromParent_Done,
     /* 253206 */   // Label 5067: @253206
     /* 253206 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(253248), // Rule ID 12621 //
     /* 253211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 253219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253225 */     // MIs[0] tile
     /* 253225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253233 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 253236 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253246 */     GIR_RootConstrainSelectedInstOperands,
     /* 253247 */     // GIR_Coverage, 12621,
     /* 253247 */     GIR_EraseRootFromParent_Done,
     /* 253248 */   // Label 5068: @253248
     /* 253248 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(253290), // Rule ID 12625 //
     /* 253253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 253261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253267 */     // MIs[0] tile
     /* 253267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253275 */     // (intrinsic_void 1196:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 253278 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253288 */     GIR_RootConstrainSelectedInstOperands,
     /* 253289 */     // GIR_Coverage, 12625,
     /* 253289 */     GIR_EraseRootFromParent_Done,
     /* 253290 */   // Label 5069: @253290
     /* 253290 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(253332), // Rule ID 13080 //
     /* 253295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 253303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253309 */     // MIs[0] tile
     /* 253309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253317 */     // (intrinsic_void 924:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 253320 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253330 */     GIR_RootConstrainSelectedInstOperands,
     /* 253331 */     // GIR_Coverage, 13080,
     /* 253331 */     GIR_EraseRootFromParent_Done,
     /* 253332 */   // Label 5070: @253332
     /* 253332 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253374), // Rule ID 13084 //
     /* 253337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253351 */     // MIs[0] tile
     /* 253351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253359 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 253359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 253362 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253372 */     GIR_RootConstrainSelectedInstOperands,
     /* 253373 */     // GIR_Coverage, 13084,
     /* 253373 */     GIR_EraseRootFromParent_Done,
     /* 253374 */   // Label 5071: @253374
     /* 253374 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253416), // Rule ID 13088 //
     /* 253379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 253382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253393 */     // MIs[0] tile
     /* 253393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253401 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 253404 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253414 */     GIR_RootConstrainSelectedInstOperands,
     /* 253415 */     // GIR_Coverage, 13088,
     /* 253415 */     GIR_EraseRootFromParent_Done,
     /* 253416 */   // Label 5072: @253416
     /* 253416 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253458), // Rule ID 13092 //
     /* 253421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 253424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253435 */     // MIs[0] tile
     /* 253435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253443 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 253443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 253446 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253456 */     GIR_RootConstrainSelectedInstOperands,
     /* 253457 */     // GIR_Coverage, 13092,
     /* 253457 */     GIR_EraseRootFromParent_Done,
     /* 253458 */   // Label 5073: @253458
     /* 253458 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(253512), // Rule ID 8827 //
     /* 253463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253471 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 253474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253478 */     // MIs[0] base
     /* 253478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253486 */     // MIs[0] prfop
     /* 253486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253494 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 253497 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253499 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253501 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253510 */     GIR_RootConstrainSelectedInstOperands,
     /* 253511 */     // GIR_Coverage, 8827,
     /* 253511 */     GIR_EraseRootFromParent_Done,
     /* 253512 */   // Label 5074: @253512
     /* 253512 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(253566), // Rule ID 8830 //
     /* 253517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253525 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 253528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253532 */     // MIs[0] base
     /* 253532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253540 */     // MIs[0] prfop
     /* 253540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253548 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 253551 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253553 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253555 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253564 */     GIR_RootConstrainSelectedInstOperands,
     /* 253565 */     // GIR_Coverage, 8830,
     /* 253565 */     GIR_EraseRootFromParent_Done,
     /* 253566 */   // Label 5075: @253566
     /* 253566 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(253620), // Rule ID 8833 //
     /* 253571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253579 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 253582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253586 */     // MIs[0] base
     /* 253586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253594 */     // MIs[0] prfop
     /* 253594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253602 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 253605 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253607 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253609 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253618 */     GIR_RootConstrainSelectedInstOperands,
     /* 253619 */     // GIR_Coverage, 8833,
     /* 253619 */     GIR_EraseRootFromParent_Done,
     /* 253620 */   // Label 5076: @253620
     /* 253620 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(253674), // Rule ID 8836 //
     /* 253625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253633 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 253636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253640 */     // MIs[0] base
     /* 253640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253648 */     // MIs[0] prfop
     /* 253648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253656 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 253659 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253661 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253663 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253672 */     GIR_RootConstrainSelectedInstOperands,
     /* 253673 */     // GIR_Coverage, 8836,
     /* 253673 */     GIR_EraseRootFromParent_Done,
     /* 253674 */   // Label 5077: @253674
     /* 253674 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(253728), // Rule ID 15 //
     /* 253679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 253684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 253693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 253705 */     // MIs[1] Operand 1
     /* 253705 */     // No operand predicates
     /* 253705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253711 */     // (intrinsic_w_chain:{ *:[i64] } 1232:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 253711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 253714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 253719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253726 */     GIR_RootConstrainSelectedInstOperands,
     /* 253727 */     // GIR_Coverage, 15,
     /* 253727 */     GIR_EraseRootFromParent_Done,
     /* 253728 */   // Label 5078: @253728
     /* 253728 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253796), // Rule ID 68 //
     /* 253733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 253738 */     // MIs[0] Operand 1
     /* 253738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 253742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 253746 */     // MIs[0] ptr
     /* 253746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 253754 */     // MIs[0] accessinfo
     /* 253754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253757 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 253757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253761 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 253771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 253774 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 253776 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 253778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 253781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 253784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 253787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 253790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253794 */     GIR_RootConstrainSelectedInstOperands,
     /* 253795 */     // GIR_Coverage, 68,
     /* 253795 */     GIR_EraseRootFromParent_Done,
     /* 253796 */   // Label 5079: @253796
     /* 253796 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253864), // Rule ID 69 //
     /* 253801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 253806 */     // MIs[0] Operand 1
     /* 253806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 253810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 253814 */     // MIs[0] ptr
     /* 253814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 253822 */     // MIs[0] accessinfo
     /* 253822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253825 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 253825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253829 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 253839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 253842 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 253844 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 253846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 253849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 253852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 253855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 253858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253862 */     GIR_RootConstrainSelectedInstOperands,
     /* 253863 */     // GIR_Coverage, 69,
     /* 253863 */     GIR_EraseRootFromParent_Done,
     /* 253864 */   // Label 5080: @253864
     /* 253864 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253944), // Rule ID 7104 //
     /* 253869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253888 */     // MIs[0] addr
     /* 253888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 253900 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253912 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 253931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253936 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253942 */     GIR_RootConstrainSelectedInstOperands,
     /* 253943 */     // GIR_Coverage, 7104,
     /* 253943 */     GIR_EraseRootFromParent_Done,
     /* 253944 */   // Label 5081: @253944
     /* 253944 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(254024), // Rule ID 7105 //
     /* 253949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253968 */     // MIs[0] addr
     /* 253968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253976 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 253980 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253992 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 254011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254016 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254022 */     GIR_RootConstrainSelectedInstOperands,
     /* 254023 */     // GIR_Coverage, 7105,
     /* 254023 */     GIR_EraseRootFromParent_Done,
     /* 254024 */   // Label 5082: @254024
     /* 254024 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(254104), // Rule ID 7106 //
     /* 254029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254048 */     // MIs[0] addr
     /* 254048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254056 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 254060 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 254091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254096 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254102 */     GIR_RootConstrainSelectedInstOperands,
     /* 254103 */     // GIR_Coverage, 7106,
     /* 254103 */     GIR_EraseRootFromParent_Done,
     /* 254104 */   // Label 5083: @254104
     /* 254104 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(254155), // Rule ID 7107 //
     /* 254109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254128 */     // MIs[0] addr
     /* 254128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254136 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 254140 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 254143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254145 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 254147 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254153 */     GIR_RootConstrainSelectedInstOperands,
     /* 254154 */     // GIR_Coverage, 7107,
     /* 254154 */     GIR_EraseRootFromParent_Done,
     /* 254155 */   // Label 5084: @254155
     /* 254155 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(254235), // Rule ID 7114 //
     /* 254160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254179 */     // MIs[0] addr
     /* 254179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 254191 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254203 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 254222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254227 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254233 */     GIR_RootConstrainSelectedInstOperands,
     /* 254234 */     // GIR_Coverage, 7114,
     /* 254234 */     GIR_EraseRootFromParent_Done,
     /* 254235 */   // Label 5085: @254235
     /* 254235 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(254315), // Rule ID 7115 //
     /* 254240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254259 */     // MIs[0] addr
     /* 254259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254267 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 254271 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254283 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 254302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254307 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254313 */     GIR_RootConstrainSelectedInstOperands,
     /* 254314 */     // GIR_Coverage, 7115,
     /* 254314 */     GIR_EraseRootFromParent_Done,
     /* 254315 */   // Label 5086: @254315
     /* 254315 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(254395), // Rule ID 7116 //
     /* 254320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254339 */     // MIs[0] addr
     /* 254339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254347 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 254351 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254363 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 254382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254387 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254393 */     GIR_RootConstrainSelectedInstOperands,
     /* 254394 */     // GIR_Coverage, 7116,
     /* 254394 */     GIR_EraseRootFromParent_Done,
     /* 254395 */   // Label 5087: @254395
     /* 254395 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(254446), // Rule ID 7117 //
     /* 254400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254419 */     // MIs[0] addr
     /* 254419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 254431 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 254434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254436 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 254438 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254444 */     GIR_RootConstrainSelectedInstOperands,
     /* 254445 */     // GIR_Coverage, 7117,
     /* 254445 */     GIR_EraseRootFromParent_Done,
     /* 254446 */   // Label 5088: @254446
     /* 254446 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(254495), // Rule ID 2488 //
     /* 254451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 254462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254480 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 254480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 254483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254493 */     GIR_RootConstrainSelectedInstOperands,
     /* 254494 */     // GIR_Coverage, 2488,
     /* 254494 */     GIR_EraseRootFromParent_Done,
     /* 254495 */   // Label 5089: @254495
     /* 254495 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(254544), // Rule ID 2489 //
     /* 254500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 254511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254529 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 254529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 254532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254542 */     GIR_RootConstrainSelectedInstOperands,
     /* 254543 */     // GIR_Coverage, 2489,
     /* 254543 */     GIR_EraseRootFromParent_Done,
     /* 254544 */   // Label 5090: @254544
     /* 254544 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254593), // Rule ID 2490 //
     /* 254549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 254560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 254566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254578 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 254578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 254581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254591 */     GIR_RootConstrainSelectedInstOperands,
     /* 254592 */     // GIR_Coverage, 2490,
     /* 254592 */     GIR_EraseRootFromParent_Done,
     /* 254593 */   // Label 5091: @254593
     /* 254593 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254646), // Rule ID 8713 //
     /* 254598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 254606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254620 */     // MIs[0] base
     /* 254620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254628 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 254631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254635 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254644 */     GIR_RootConstrainSelectedInstOperands,
     /* 254645 */     // GIR_Coverage, 8713,
     /* 254645 */     GIR_EraseRootFromParent_Done,
     /* 254646 */   // Label 5092: @254646
     /* 254646 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254699), // Rule ID 8716 //
     /* 254651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 254659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254673 */     // MIs[0] base
     /* 254673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254681 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 254684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254688 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254697 */     GIR_RootConstrainSelectedInstOperands,
     /* 254698 */     // GIR_Coverage, 8716,
     /* 254698 */     GIR_EraseRootFromParent_Done,
     /* 254699 */   // Label 5093: @254699
     /* 254699 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254752), // Rule ID 8725 //
     /* 254704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 254712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254726 */     // MIs[0] base
     /* 254726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254734 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 254737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254741 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254750 */     GIR_RootConstrainSelectedInstOperands,
     /* 254751 */     // GIR_Coverage, 8725,
     /* 254751 */     GIR_EraseRootFromParent_Done,
     /* 254752 */   // Label 5094: @254752
     /* 254752 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254805), // Rule ID 8728 //
     /* 254757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 254765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254779 */     // MIs[0] base
     /* 254779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254787 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 254790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254794 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254803 */     GIR_RootConstrainSelectedInstOperands,
     /* 254804 */     // GIR_Coverage, 8728,
     /* 254804 */     GIR_EraseRootFromParent_Done,
     /* 254805 */   // Label 5095: @254805
     /* 254805 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254851), // Rule ID 137 //
     /* 254810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 254813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 254818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 254821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254828 */     // MIs[0] Rn
     /* 254828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254840 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 254840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 254843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254849 */     GIR_RootConstrainSelectedInstOperands,
     /* 254850 */     // GIR_Coverage, 137,
     /* 254850 */     GIR_EraseRootFromParent_Done,
     /* 254851 */   // Label 5096: @254851
     /* 254851 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254904), // Rule ID 8719 //
     /* 254856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 254864 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 254867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254878 */     // MIs[0] base
     /* 254878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254886 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 254889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254893 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254902 */     GIR_RootConstrainSelectedInstOperands,
     /* 254903 */     // GIR_Coverage, 8719,
     /* 254903 */     GIR_EraseRootFromParent_Done,
     /* 254904 */   // Label 5097: @254904
     /* 254904 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254957), // Rule ID 8722 //
     /* 254909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 254917 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 254920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254931 */     // MIs[0] base
     /* 254931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254939 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 254942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254946 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254955 */     GIR_RootConstrainSelectedInstOperands,
     /* 254956 */     // GIR_Coverage, 8722,
     /* 254956 */     GIR_EraseRootFromParent_Done,
     /* 254957 */   // Label 5098: @254957
     /* 254957 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(255010), // Rule ID 8731 //
     /* 254962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 254970 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 254973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254984 */     // MIs[0] base
     /* 254984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254992 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 254995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254999 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255008 */     GIR_RootConstrainSelectedInstOperands,
     /* 255009 */     // GIR_Coverage, 8731,
     /* 255009 */     GIR_EraseRootFromParent_Done,
     /* 255010 */   // Label 5099: @255010
     /* 255010 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(255063), // Rule ID 8734 //
     /* 255015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 255023 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 255026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255037 */     // MIs[0] base
     /* 255037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255045 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 255048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255052 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255061 */     GIR_RootConstrainSelectedInstOperands,
     /* 255062 */     // GIR_Coverage, 8734,
     /* 255062 */     GIR_EraseRootFromParent_Done,
     /* 255063 */   // Label 5100: @255063
     /* 255063 */   GIM_Reject,
     /* 255064 */ // Label 5029: @255064
     /* 255064 */ GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(257769),
     /* 255069 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 255072 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(255143), // Rule ID 3413 //
     /* 255077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 255085 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 255094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 255106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 255110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 255114 */     // MIs[1] Operand 1
     /* 255114 */     // No operand predicates
     /* 255114 */     // MIs[0] prfop
     /* 255114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255124 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 255124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 255127 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 255136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 255141 */     GIR_RootConstrainSelectedInstOperands,
     /* 255142 */     // GIR_Coverage, 3413,
     /* 255142 */     GIR_EraseRootFromParent_Done,
     /* 255143 */   // Label 5102: @255143
     /* 255143 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(255214), // Rule ID 3426 //
     /* 255148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 255156 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 255165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 255177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 255181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 255185 */     // MIs[1] Operand 1
     /* 255185 */     // No operand predicates
     /* 255185 */     // MIs[0] prfop
     /* 255185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255195 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 255195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 255198 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 255207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 255212 */     GIR_RootConstrainSelectedInstOperands,
     /* 255213 */     // GIR_Coverage, 3426,
     /* 255213 */     GIR_EraseRootFromParent_Done,
     /* 255214 */   // Label 5103: @255214
     /* 255214 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(255273), // Rule ID 3613 //
     /* 255219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 255222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 255227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 255233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255236 */     // MIs[0] tile
     /* 255236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255256 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 255256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 255259 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255261 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255263 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255265 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255271 */     GIR_RootConstrainSelectedInstOperands,
     /* 255272 */     // GIR_Coverage, 3613,
     /* 255272 */     GIR_EraseRootFromParent_Done,
     /* 255273 */   // Label 5104: @255273
     /* 255273 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(255332), // Rule ID 3614 //
     /* 255278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 255286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 255292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255295 */     // MIs[0] tile
     /* 255295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255315 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 255315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 255318 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255320 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255322 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255324 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255330 */     GIR_RootConstrainSelectedInstOperands,
     /* 255331 */     // GIR_Coverage, 3614,
     /* 255331 */     GIR_EraseRootFromParent_Done,
     /* 255332 */   // Label 5105: @255332
     /* 255332 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(255391), // Rule ID 12542 //
     /* 255337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 255340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 255345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 255351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255354 */     // MIs[0] tile
     /* 255354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255374 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 255374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 255377 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255379 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255381 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255383 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255389 */     GIR_RootConstrainSelectedInstOperands,
     /* 255390 */     // GIR_Coverage, 12542,
     /* 255390 */     GIR_EraseRootFromParent_Done,
     /* 255391 */   // Label 5106: @255391
     /* 255391 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(255450), // Rule ID 12543 //
     /* 255396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 255404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 255410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255413 */     // MIs[0] tile
     /* 255413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255433 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 255433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 255436 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255438 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255440 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255442 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255448 */     GIR_RootConstrainSelectedInstOperands,
     /* 255449 */     // GIR_Coverage, 12543,
     /* 255449 */     GIR_EraseRootFromParent_Done,
     /* 255450 */   // Label 5107: @255450
     /* 255450 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255510), // Rule ID 3411 //
     /* 255455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 255463 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255473 */     // MIs[0] Rn
     /* 255473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255485 */     // MIs[0] prfop
     /* 255485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255493 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 255493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 255496 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255508 */     GIR_RootConstrainSelectedInstOperands,
     /* 255509 */     // GIR_Coverage, 3411,
     /* 255509 */     GIR_EraseRootFromParent_Done,
     /* 255510 */   // Label 5108: @255510
     /* 255510 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255570), // Rule ID 3412 //
     /* 255515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 255523 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255533 */     // MIs[0] Rn
     /* 255533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255545 */     // MIs[0] prfop
     /* 255545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255553 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 255553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 255556 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255568 */     GIR_RootConstrainSelectedInstOperands,
     /* 255569 */     // GIR_Coverage, 3412,
     /* 255569 */     GIR_EraseRootFromParent_Done,
     /* 255570 */   // Label 5109: @255570
     /* 255570 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255630), // Rule ID 3423 //
     /* 255575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 255583 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255593 */     // MIs[0] Rn
     /* 255593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255605 */     // MIs[0] prfop
     /* 255605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255613 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 255613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 255616 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255628 */     GIR_RootConstrainSelectedInstOperands,
     /* 255629 */     // GIR_Coverage, 3423,
     /* 255629 */     GIR_EraseRootFromParent_Done,
     /* 255630 */   // Label 5110: @255630
     /* 255630 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(255690), // Rule ID 3424 //
     /* 255635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 255643 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255653 */     // MIs[0] Rn
     /* 255653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255665 */     // MIs[0] prfop
     /* 255665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255673 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 255673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 255676 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255688 */     GIR_RootConstrainSelectedInstOperands,
     /* 255689 */     // GIR_Coverage, 3424,
     /* 255689 */     GIR_EraseRootFromParent_Done,
     /* 255690 */   // Label 5111: @255690
     /* 255690 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(255750), // Rule ID 3425 //
     /* 255695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 255703 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255713 */     // MIs[0] Rn
     /* 255713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255725 */     // MIs[0] prfop
     /* 255725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255733 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 255733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 255736 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255748 */     GIR_RootConstrainSelectedInstOperands,
     /* 255749 */     // GIR_Coverage, 3425,
     /* 255749 */     GIR_EraseRootFromParent_Done,
     /* 255750 */   // Label 5112: @255750
     /* 255750 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255810), // Rule ID 8839 //
     /* 255755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 255763 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255773 */     // MIs[0] Rn
     /* 255773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255785 */     // MIs[0] prfop
     /* 255785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255793 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 255793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 255796 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255808 */     GIR_RootConstrainSelectedInstOperands,
     /* 255809 */     // GIR_Coverage, 8839,
     /* 255809 */     GIR_EraseRootFromParent_Done,
     /* 255810 */   // Label 5113: @255810
     /* 255810 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255870), // Rule ID 8840 //
     /* 255815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 255823 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255833 */     // MIs[0] Rn
     /* 255833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255845 */     // MIs[0] prfop
     /* 255845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255853 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 255853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 255856 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255868 */     GIR_RootConstrainSelectedInstOperands,
     /* 255869 */     // GIR_Coverage, 8840,
     /* 255869 */     GIR_EraseRootFromParent_Done,
     /* 255870 */   // Label 5114: @255870
     /* 255870 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255930), // Rule ID 8841 //
     /* 255875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 255883 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255893 */     // MIs[0] Rn
     /* 255893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255905 */     // MIs[0] prfop
     /* 255905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255913 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 255913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 255916 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255928 */     GIR_RootConstrainSelectedInstOperands,
     /* 255929 */     // GIR_Coverage, 8841,
     /* 255929 */     GIR_EraseRootFromParent_Done,
     /* 255930 */   // Label 5115: @255930
     /* 255930 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255990), // Rule ID 8842 //
     /* 255935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 255943 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255953 */     // MIs[0] Rn
     /* 255953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255965 */     // MIs[0] prfop
     /* 255965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255973 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 255973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 255976 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255988 */     GIR_RootConstrainSelectedInstOperands,
     /* 255989 */     // GIR_Coverage, 8842,
     /* 255989 */     GIR_EraseRootFromParent_Done,
     /* 255990 */   // Label 5116: @255990
     /* 255990 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(256050), // Rule ID 8843 //
     /* 255995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 256003 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256013 */     // MIs[0] Rn
     /* 256013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256025 */     // MIs[0] prfop
     /* 256025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256033 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 256033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 256036 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256048 */     GIR_RootConstrainSelectedInstOperands,
     /* 256049 */     // GIR_Coverage, 8843,
     /* 256049 */     GIR_EraseRootFromParent_Done,
     /* 256050 */   // Label 5117: @256050
     /* 256050 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(256110), // Rule ID 8844 //
     /* 256055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 256063 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256073 */     // MIs[0] Rn
     /* 256073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256085 */     // MIs[0] prfop
     /* 256085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256093 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 256093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 256096 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256108 */     GIR_RootConstrainSelectedInstOperands,
     /* 256109 */     // GIR_Coverage, 8844,
     /* 256109 */     GIR_EraseRootFromParent_Done,
     /* 256110 */   // Label 5118: @256110
     /* 256110 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(256170), // Rule ID 8845 //
     /* 256115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 256123 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256133 */     // MIs[0] Rn
     /* 256133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256145 */     // MIs[0] prfop
     /* 256145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256153 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 256153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 256156 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256168 */     GIR_RootConstrainSelectedInstOperands,
     /* 256169 */     // GIR_Coverage, 8845,
     /* 256169 */     GIR_EraseRootFromParent_Done,
     /* 256170 */   // Label 5119: @256170
     /* 256170 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(256230), // Rule ID 8846 //
     /* 256175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 256183 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256193 */     // MIs[0] Rn
     /* 256193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256205 */     // MIs[0] prfop
     /* 256205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256213 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 256213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 256216 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256228 */     GIR_RootConstrainSelectedInstOperands,
     /* 256229 */     // GIR_Coverage, 8846,
     /* 256229 */     GIR_EraseRootFromParent_Done,
     /* 256230 */   // Label 5120: @256230
     /* 256230 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(256290), // Rule ID 8847 //
     /* 256235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 256243 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256253 */     // MIs[0] Rn
     /* 256253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256265 */     // MIs[0] prfop
     /* 256265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256273 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 256273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 256276 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256288 */     GIR_RootConstrainSelectedInstOperands,
     /* 256289 */     // GIR_Coverage, 8847,
     /* 256289 */     GIR_EraseRootFromParent_Done,
     /* 256290 */   // Label 5121: @256290
     /* 256290 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(256350), // Rule ID 8848 //
     /* 256295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 256303 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256313 */     // MIs[0] Rn
     /* 256313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256325 */     // MIs[0] prfop
     /* 256325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256333 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 256333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 256336 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256348 */     GIR_RootConstrainSelectedInstOperands,
     /* 256349 */     // GIR_Coverage, 8848,
     /* 256349 */     GIR_EraseRootFromParent_Done,
     /* 256350 */   // Label 5122: @256350
     /* 256350 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(256410), // Rule ID 8849 //
     /* 256355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 256363 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256373 */     // MIs[0] Rn
     /* 256373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256385 */     // MIs[0] prfop
     /* 256385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256393 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 256393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 256396 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256408 */     GIR_RootConstrainSelectedInstOperands,
     /* 256409 */     // GIR_Coverage, 8849,
     /* 256409 */     GIR_EraseRootFromParent_Done,
     /* 256410 */   // Label 5123: @256410
     /* 256410 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(256470), // Rule ID 8850 //
     /* 256415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 256423 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256433 */     // MIs[0] Rn
     /* 256433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256445 */     // MIs[0] prfop
     /* 256445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256453 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 256453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 256456 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256468 */     GIR_RootConstrainSelectedInstOperands,
     /* 256469 */     // GIR_Coverage, 8850,
     /* 256469 */     GIR_EraseRootFromParent_Done,
     /* 256470 */   // Label 5124: @256470
     /* 256470 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(256530), // Rule ID 8851 //
     /* 256475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 256483 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256493 */     // MIs[0] Rn
     /* 256493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256505 */     // MIs[0] prfop
     /* 256505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256513 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 256513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 256516 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256528 */     GIR_RootConstrainSelectedInstOperands,
     /* 256529 */     // GIR_Coverage, 8851,
     /* 256529 */     GIR_EraseRootFromParent_Done,
     /* 256530 */   // Label 5125: @256530
     /* 256530 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(256590), // Rule ID 8852 //
     /* 256535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 256543 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256553 */     // MIs[0] Rn
     /* 256553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256565 */     // MIs[0] prfop
     /* 256565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256573 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 256573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 256576 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256588 */     GIR_RootConstrainSelectedInstOperands,
     /* 256589 */     // GIR_Coverage, 8852,
     /* 256589 */     GIR_EraseRootFromParent_Done,
     /* 256590 */   // Label 5126: @256590
     /* 256590 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(256650), // Rule ID 8853 //
     /* 256595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 256603 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256613 */     // MIs[0] Rn
     /* 256613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256625 */     // MIs[0] prfop
     /* 256625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256633 */     // (intrinsic_void 1639:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 256633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 256636 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256648 */     GIR_RootConstrainSelectedInstOperands,
     /* 256649 */     // GIR_Coverage, 8853,
     /* 256649 */     GIR_EraseRootFromParent_Done,
     /* 256650 */   // Label 5127: @256650
     /* 256650 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(256708), // Rule ID 2374 //
     /* 256655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 256663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256691 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 256694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256706 */     GIR_RootConstrainSelectedInstOperands,
     /* 256707 */     // GIR_Coverage, 2374,
     /* 256707 */     GIR_EraseRootFromParent_Done,
     /* 256708 */   // Label 5128: @256708
     /* 256708 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(256766), // Rule ID 2375 //
     /* 256713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 256721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256749 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 256752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256764 */     GIR_RootConstrainSelectedInstOperands,
     /* 256765 */     // GIR_Coverage, 2375,
     /* 256765 */     GIR_EraseRootFromParent_Done,
     /* 256766 */   // Label 5129: @256766
     /* 256766 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(256824), // Rule ID 2376 //
     /* 256771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 256779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256807 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 256810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256822 */     GIR_RootConstrainSelectedInstOperands,
     /* 256823 */     // GIR_Coverage, 2376,
     /* 256823 */     GIR_EraseRootFromParent_Done,
     /* 256824 */   // Label 5130: @256824
     /* 256824 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(256882), // Rule ID 2377 //
     /* 256829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 256837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256865 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 256868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256880 */     GIR_RootConstrainSelectedInstOperands,
     /* 256881 */     // GIR_Coverage, 2377,
     /* 256881 */     GIR_EraseRootFromParent_Done,
     /* 256882 */   // Label 5131: @256882
     /* 256882 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256940), // Rule ID 2378 //
     /* 256887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 256895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256923 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 256926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256938 */     GIR_RootConstrainSelectedInstOperands,
     /* 256939 */     // GIR_Coverage, 2378,
     /* 256939 */     GIR_EraseRootFromParent_Done,
     /* 256940 */   // Label 5132: @256940
     /* 256940 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256998), // Rule ID 2379 //
     /* 256945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 256953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256981 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 256984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256996 */     GIR_RootConstrainSelectedInstOperands,
     /* 256997 */     // GIR_Coverage, 2379,
     /* 256997 */     GIR_EraseRootFromParent_Done,
     /* 256998 */   // Label 5133: @256998
     /* 256998 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(257056), // Rule ID 2380 //
     /* 257003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 257011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 257014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 257023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257039 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 257039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 257042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257054 */     GIR_RootConstrainSelectedInstOperands,
     /* 257055 */     // GIR_Coverage, 2380,
     /* 257055 */     GIR_EraseRootFromParent_Done,
     /* 257056 */   // Label 5134: @257056
     /* 257056 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(257114), // Rule ID 2381 //
     /* 257061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 257069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257097 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 257100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257112 */     GIR_RootConstrainSelectedInstOperands,
     /* 257113 */     // GIR_Coverage, 2381,
     /* 257113 */     GIR_EraseRootFromParent_Done,
     /* 257114 */   // Label 5135: @257114
     /* 257114 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(257172), // Rule ID 2382 //
     /* 257119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 257127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 257130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 257139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257155 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 257155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 257158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257170 */     GIR_RootConstrainSelectedInstOperands,
     /* 257171 */     // GIR_Coverage, 2382,
     /* 257171 */     GIR_EraseRootFromParent_Done,
     /* 257172 */   // Label 5136: @257172
     /* 257172 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(257230), // Rule ID 2383 //
     /* 257177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 257185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257213 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 257216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257228 */     GIR_RootConstrainSelectedInstOperands,
     /* 257229 */     // GIR_Coverage, 2383,
     /* 257229 */     GIR_EraseRootFromParent_Done,
     /* 257230 */   // Label 5137: @257230
     /* 257230 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(257288), // Rule ID 2491 //
     /* 257235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 257238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 257243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257271 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 257271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 257274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257276 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 257278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257286 */     GIR_RootConstrainSelectedInstOperands,
     /* 257287 */     // GIR_Coverage, 2491,
     /* 257287 */     GIR_EraseRootFromParent_Done,
     /* 257288 */   // Label 5138: @257288
     /* 257288 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(257344), // Rule ID 13101 //
     /* 257293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 257298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 257304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257319 */     // MIs[0] addr
     /* 257319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 257323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257327 */     // (intrinsic_w_chain:{ *:[i32] } 1238:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 257327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 257330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 257332 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 257334 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 257336 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 257338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257342 */     GIR_RootConstrainSelectedInstOperands,
     /* 257343 */     // GIR_Coverage, 13101,
     /* 257343 */     GIR_EraseRootFromParent_Done,
     /* 257344 */   // Label 5139: @257344
     /* 257344 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(257400), // Rule ID 13102 //
     /* 257349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 257354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 257360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257375 */     // MIs[0] addr
     /* 257375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 257379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257383 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 257383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 257386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 257388 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 257390 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 257392 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 257394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257398 */     GIR_RootConstrainSelectedInstOperands,
     /* 257399 */     // GIR_Coverage, 13102,
     /* 257399 */     GIR_EraseRootFromParent_Done,
     /* 257400 */   // Label 5140: @257400
     /* 257400 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(257446), // Rule ID 3459 //
     /* 257405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 257408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 257413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257429 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 257432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257444 */     GIR_RootConstrainSelectedInstOperands,
     /* 257445 */     // GIR_Coverage, 3459,
     /* 257445 */     GIR_EraseRootFromParent_Done,
     /* 257446 */   // Label 5141: @257446
     /* 257446 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(257492), // Rule ID 3581 //
     /* 257451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 257459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257475 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 257478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257490 */     GIR_RootConstrainSelectedInstOperands,
     /* 257491 */     // GIR_Coverage, 3581,
     /* 257491 */     GIR_EraseRootFromParent_Done,
     /* 257492 */   // Label 5142: @257492
     /* 257492 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(257538), // Rule ID 12529 //
     /* 257497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 257505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257521 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1515:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 257524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257536 */     GIR_RootConstrainSelectedInstOperands,
     /* 257537 */     // GIR_Coverage, 12529,
     /* 257537 */     GIR_EraseRootFromParent_Done,
     /* 257538 */   // Label 5143: @257538
     /* 257538 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(257584), // Rule ID 12533 //
     /* 257543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 257551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257567 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1507:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 257570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257582 */     GIR_RootConstrainSelectedInstOperands,
     /* 257583 */     // GIR_Coverage, 12533,
     /* 257583 */     GIR_EraseRootFromParent_Done,
     /* 257584 */   // Label 5144: @257584
     /* 257584 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(257630), // Rule ID 12534 //
     /* 257589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 257597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257613 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1509:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 257616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257628 */     GIR_RootConstrainSelectedInstOperands,
     /* 257629 */     // GIR_Coverage, 12534,
     /* 257629 */     GIR_EraseRootFromParent_Done,
     /* 257630 */   // Label 5145: @257630
     /* 257630 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(257676), // Rule ID 12535 //
     /* 257635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 257643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257659 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 257662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257674 */     GIR_RootConstrainSelectedInstOperands,
     /* 257675 */     // GIR_Coverage, 12535,
     /* 257675 */     GIR_EraseRootFromParent_Done,
     /* 257676 */   // Label 5146: @257676
     /* 257676 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257722), // Rule ID 12536 //
     /* 257681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 257689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257705 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 257708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257720 */     GIR_RootConstrainSelectedInstOperands,
     /* 257721 */     // GIR_Coverage, 12536,
     /* 257721 */     GIR_EraseRootFromParent_Done,
     /* 257722 */   // Label 5147: @257722
     /* 257722 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257768), // Rule ID 12537 //
     /* 257727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 257730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 257735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257751 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1503:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 257754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257766 */     GIR_RootConstrainSelectedInstOperands,
     /* 257767 */     // GIR_Coverage, 12537,
     /* 257767 */     GIR_EraseRootFromParent_Done,
     /* 257768 */   // Label 5148: @257768
     /* 257768 */   GIM_Reject,
     /* 257769 */ // Label 5101: @257769
     /* 257769 */ GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(260762),
     /* 257774 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 257777 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257845), // Rule ID 2518 //
     /* 257782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 257790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257818 */     // MIs[0] Idx
     /* 257818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257826 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 257829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257837 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257843 */     GIR_RootConstrainSelectedInstOperands,
     /* 257844 */     // GIR_Coverage, 2518,
     /* 257844 */     GIR_EraseRootFromParent_Done,
     /* 257845 */   // Label 5150: @257845
     /* 257845 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257913), // Rule ID 2519 //
     /* 257850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 257858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257886 */     // MIs[0] Idx
     /* 257886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257894 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 257897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257905 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257911 */     GIR_RootConstrainSelectedInstOperands,
     /* 257912 */     // GIR_Coverage, 2519,
     /* 257912 */     GIR_EraseRootFromParent_Done,
     /* 257913 */   // Label 5151: @257913
     /* 257913 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257981), // Rule ID 2520 //
     /* 257918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 257926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 257929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257954 */     // MIs[0] Idx
     /* 257954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 257962 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 257965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257973 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257979 */     GIR_RootConstrainSelectedInstOperands,
     /* 257980 */     // GIR_Coverage, 2520,
     /* 257980 */     GIR_EraseRootFromParent_Done,
     /* 257981 */   // Label 5152: @257981
     /* 257981 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(258049), // Rule ID 2521 //
     /* 257986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 257994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258022 */     // MIs[0] Idx
     /* 258022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258025 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258030 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 258033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258041 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258047 */     GIR_RootConstrainSelectedInstOperands,
     /* 258048 */     // GIR_Coverage, 2521,
     /* 258048 */     GIR_EraseRootFromParent_Done,
     /* 258049 */   // Label 5153: @258049
     /* 258049 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(258117), // Rule ID 2522 //
     /* 258054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 258057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 258062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 258065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 258090 */     // MIs[0] Idx
     /* 258090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258098 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 258101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258109 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258115 */     GIR_RootConstrainSelectedInstOperands,
     /* 258116 */     // GIR_Coverage, 2522,
     /* 258116 */     GIR_EraseRootFromParent_Done,
     /* 258117 */   // Label 5154: @258117
     /* 258117 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(258185), // Rule ID 2523 //
     /* 258122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 258125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 258130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 258158 */     // MIs[0] Idx
     /* 258158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258166 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 258169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258177 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258183 */     GIR_RootConstrainSelectedInstOperands,
     /* 258184 */     // GIR_Coverage, 2523,
     /* 258184 */     GIR_EraseRootFromParent_Done,
     /* 258185 */   // Label 5155: @258185
     /* 258185 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(258253), // Rule ID 6981 //
     /* 258190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 258198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258226 */     // MIs[0] Idx
     /* 258226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258234 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 258237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258245 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258251 */     GIR_RootConstrainSelectedInstOperands,
     /* 258252 */     // GIR_Coverage, 6981,
     /* 258252 */     GIR_EraseRootFromParent_Done,
     /* 258253 */   // Label 5156: @258253
     /* 258253 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(258321), // Rule ID 6982 //
     /* 258258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 258266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258294 */     // MIs[0] Idx
     /* 258294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258302 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 258305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258313 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258319 */     GIR_RootConstrainSelectedInstOperands,
     /* 258320 */     // GIR_Coverage, 6982,
     /* 258320 */     GIR_EraseRootFromParent_Done,
     /* 258321 */   // Label 5157: @258321
     /* 258321 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(258389), // Rule ID 6983 //
     /* 258326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 258334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258362 */     // MIs[0] Idx
     /* 258362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258370 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 258373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258381 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258387 */     GIR_RootConstrainSelectedInstOperands,
     /* 258388 */     // GIR_Coverage, 6983,
     /* 258388 */     GIR_EraseRootFromParent_Done,
     /* 258389 */   // Label 5158: @258389
     /* 258389 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(258457), // Rule ID 6984 //
     /* 258394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 258402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258430 */     // MIs[0] Idx
     /* 258430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258438 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 258441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258449 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258455 */     GIR_RootConstrainSelectedInstOperands,
     /* 258456 */     // GIR_Coverage, 6984,
     /* 258456 */     GIR_EraseRootFromParent_Done,
     /* 258457 */   // Label 5159: @258457
     /* 258457 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(258517), // Rule ID 3593 //
     /* 258462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258482 */     // MIs[0] tile
     /* 258482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258498 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 258498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 258501 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258509 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258515 */     GIR_RootConstrainSelectedInstOperands,
     /* 258516 */     // GIR_Coverage, 3593,
     /* 258516 */     GIR_EraseRootFromParent_Done,
     /* 258517 */   // Label 5160: @258517
     /* 258517 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(258577), // Rule ID 3594 //
     /* 258522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 258525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 258530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258542 */     // MIs[0] tile
     /* 258542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258545 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258558 */     // (intrinsic_void 880:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 258561 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258569 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258575 */     GIR_RootConstrainSelectedInstOperands,
     /* 258576 */     // GIR_Coverage, 3594,
     /* 258576 */     GIR_EraseRootFromParent_Done,
     /* 258577 */   // Label 5161: @258577
     /* 258577 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(258637), // Rule ID 3595 //
     /* 258582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 258585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 258596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258602 */     // MIs[0] tile
     /* 258602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258618 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 258618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 258621 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258629 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258635 */     GIR_RootConstrainSelectedInstOperands,
     /* 258636 */     // GIR_Coverage, 3595,
     /* 258636 */     GIR_EraseRootFromParent_Done,
     /* 258637 */   // Label 5162: @258637
     /* 258637 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(258697), // Rule ID 3596 //
     /* 258642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 258645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 258650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258662 */     // MIs[0] tile
     /* 258662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 258670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258678 */     // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 258681 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258689 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258695 */     GIR_RootConstrainSelectedInstOperands,
     /* 258696 */     // GIR_Coverage, 3596,
     /* 258696 */     GIR_EraseRootFromParent_Done,
     /* 258697 */   // Label 5163: @258697
     /* 258697 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(258757), // Rule ID 3597 //
     /* 258702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 258705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258722 */     // MIs[0] tile
     /* 258722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 258730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258738 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 258738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 258741 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258749 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258755 */     GIR_RootConstrainSelectedInstOperands,
     /* 258756 */     // GIR_Coverage, 3597,
     /* 258756 */     GIR_EraseRootFromParent_Done,
     /* 258757 */   // Label 5164: @258757
     /* 258757 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(258817), // Rule ID 3598 //
     /* 258762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 258770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258782 */     // MIs[0] tile
     /* 258782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258798 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 258801 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258809 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258815 */     GIR_RootConstrainSelectedInstOperands,
     /* 258816 */     // GIR_Coverage, 3598,
     /* 258816 */     GIR_EraseRootFromParent_Done,
     /* 258817 */   // Label 5165: @258817
     /* 258817 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(258877), // Rule ID 3599 //
     /* 258822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 258825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 258830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258842 */     // MIs[0] tile
     /* 258842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258858 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 258861 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258869 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258875 */     GIR_RootConstrainSelectedInstOperands,
     /* 258876 */     // GIR_Coverage, 3599,
     /* 258876 */     GIR_EraseRootFromParent_Done,
     /* 258877 */   // Label 5166: @258877
     /* 258877 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(258937), // Rule ID 3600 //
     /* 258882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 258890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258902 */     // MIs[0] tile
     /* 258902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258918 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 258918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 258921 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258929 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258935 */     GIR_RootConstrainSelectedInstOperands,
     /* 258936 */     // GIR_Coverage, 3600,
     /* 258936 */     GIR_EraseRootFromParent_Done,
     /* 258937 */   // Label 5167: @258937
     /* 258937 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258997), // Rule ID 3694 //
     /* 258942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 258945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 258950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258962 */     // MIs[0] tile
     /* 258962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258978 */     // (intrinsic_void 1032:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 258981 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258989 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258995 */     GIR_RootConstrainSelectedInstOperands,
     /* 258996 */     // GIR_Coverage, 3694,
     /* 258996 */     GIR_EraseRootFromParent_Done,
     /* 258997 */   // Label 5168: @258997
     /* 258997 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(259057), // Rule ID 3695 //
     /* 259002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 259010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259022 */     // MIs[0] tile
     /* 259022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259025 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259038 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 259038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 259041 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259049 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259055 */     GIR_RootConstrainSelectedInstOperands,
     /* 259056 */     // GIR_Coverage, 3695,
     /* 259056 */     GIR_EraseRootFromParent_Done,
     /* 259057 */   // Label 5169: @259057
     /* 259057 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(259117), // Rule ID 12544 //
     /* 259062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 259070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259082 */     // MIs[0] tile
     /* 259082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259085 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259098 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 259098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 259101 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259109 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259115 */     GIR_RootConstrainSelectedInstOperands,
     /* 259116 */     // GIR_Coverage, 12544,
     /* 259116 */     GIR_EraseRootFromParent_Done,
     /* 259117 */   // Label 5170: @259117
     /* 259117 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(259177), // Rule ID 12545 //
     /* 259122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 259125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 259130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 259136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 259142 */     // MIs[0] tile
     /* 259142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259145 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259158 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 259158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 259161 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259169 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259175 */     GIR_RootConstrainSelectedInstOperands,
     /* 259176 */     // GIR_Coverage, 12545,
     /* 259176 */     GIR_EraseRootFromParent_Done,
     /* 259177 */   // Label 5171: @259177
     /* 259177 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(259237), // Rule ID 12546 //
     /* 259182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 259190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259202 */     // MIs[0] tile
     /* 259202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259218 */     // (intrinsic_void 933:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 259218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 259221 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259229 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259235 */     GIR_RootConstrainSelectedInstOperands,
     /* 259236 */     // GIR_Coverage, 12546,
     /* 259236 */     GIR_EraseRootFromParent_Done,
     /* 259237 */   // Label 5172: @259237
     /* 259237 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(259297), // Rule ID 12547 //
     /* 259242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 259250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259262 */     // MIs[0] tile
     /* 259262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259278 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 259281 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259289 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259295 */     GIR_RootConstrainSelectedInstOperands,
     /* 259296 */     // GIR_Coverage, 12547,
     /* 259296 */     GIR_EraseRootFromParent_Done,
     /* 259297 */   // Label 5173: @259297
     /* 259297 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(259357), // Rule ID 12548 //
     /* 259302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 259310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259322 */     // MIs[0] tile
     /* 259322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259338 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 259341 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259349 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259355 */     GIR_RootConstrainSelectedInstOperands,
     /* 259356 */     // GIR_Coverage, 12548,
     /* 259356 */     GIR_EraseRootFromParent_Done,
     /* 259357 */   // Label 5174: @259357
     /* 259357 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(259417), // Rule ID 12549 //
     /* 259362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 259370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259382 */     // MIs[0] tile
     /* 259382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259398 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 259401 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259409 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259415 */     GIR_RootConstrainSelectedInstOperands,
     /* 259416 */     // GIR_Coverage, 12549,
     /* 259416 */     GIR_EraseRootFromParent_Done,
     /* 259417 */   // Label 5175: @259417
     /* 259417 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(259477), // Rule ID 12550 //
     /* 259422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 259430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259442 */     // MIs[0] tile
     /* 259442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259458 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 259461 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259469 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259475 */     GIR_RootConstrainSelectedInstOperands,
     /* 259476 */     // GIR_Coverage, 12550,
     /* 259476 */     GIR_EraseRootFromParent_Done,
     /* 259477 */   // Label 5176: @259477
     /* 259477 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(259537), // Rule ID 12551 //
     /* 259482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 259490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259502 */     // MIs[0] tile
     /* 259502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259518 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 259521 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259529 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259535 */     GIR_RootConstrainSelectedInstOperands,
     /* 259536 */     // GIR_Coverage, 12551,
     /* 259536 */     GIR_EraseRootFromParent_Done,
     /* 259537 */   // Label 5177: @259537
     /* 259537 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(259597), // Rule ID 12552 //
     /* 259542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 259550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259562 */     // MIs[0] tile
     /* 259562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259578 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 259581 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259589 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259595 */     GIR_RootConstrainSelectedInstOperands,
     /* 259596 */     // GIR_Coverage, 12552,
     /* 259596 */     GIR_EraseRootFromParent_Done,
     /* 259597 */   // Label 5178: @259597
     /* 259597 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(259657), // Rule ID 12553 //
     /* 259602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 259610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259622 */     // MIs[0] tile
     /* 259622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259638 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 259641 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259649 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259655 */     GIR_RootConstrainSelectedInstOperands,
     /* 259656 */     // GIR_Coverage, 12553,
     /* 259656 */     GIR_EraseRootFromParent_Done,
     /* 259657 */   // Label 5179: @259657
     /* 259657 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(259717), // Rule ID 12554 //
     /* 259662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 259670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259682 */     // MIs[0] tile
     /* 259682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259698 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 259701 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259709 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259715 */     GIR_RootConstrainSelectedInstOperands,
     /* 259716 */     // GIR_Coverage, 12554,
     /* 259716 */     GIR_EraseRootFromParent_Done,
     /* 259717 */   // Label 5180: @259717
     /* 259717 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(259777), // Rule ID 12555 //
     /* 259722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 259730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259742 */     // MIs[0] tile
     /* 259742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259758 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 259761 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259769 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259775 */     GIR_RootConstrainSelectedInstOperands,
     /* 259776 */     // GIR_Coverage, 12555,
     /* 259776 */     GIR_EraseRootFromParent_Done,
     /* 259777 */   // Label 5181: @259777
     /* 259777 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(259837), // Rule ID 12556 //
     /* 259782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 259790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259802 */     // MIs[0] tile
     /* 259802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259818 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 259821 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259829 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259835 */     GIR_RootConstrainSelectedInstOperands,
     /* 259836 */     // GIR_Coverage, 12556,
     /* 259836 */     GIR_EraseRootFromParent_Done,
     /* 259837 */   // Label 5182: @259837
     /* 259837 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(259897), // Rule ID 12557 //
     /* 259842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 259850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259862 */     // MIs[0] tile
     /* 259862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259865 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259878 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 259881 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259889 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259895 */     GIR_RootConstrainSelectedInstOperands,
     /* 259896 */     // GIR_Coverage, 12557,
     /* 259896 */     GIR_EraseRootFromParent_Done,
     /* 259897 */   // Label 5183: @259897
     /* 259897 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259957), // Rule ID 12558 //
     /* 259902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 259910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259922 */     // MIs[0] tile
     /* 259922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259938 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 259941 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259949 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259955 */     GIR_RootConstrainSelectedInstOperands,
     /* 259956 */     // GIR_Coverage, 12558,
     /* 259956 */     GIR_EraseRootFromParent_Done,
     /* 259957 */   // Label 5184: @259957
     /* 259957 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(260017), // Rule ID 12559 //
     /* 259962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 259970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259982 */     // MIs[0] tile
     /* 259982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259985 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259998 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 260001 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260009 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260015 */     GIR_RootConstrainSelectedInstOperands,
     /* 260016 */     // GIR_Coverage, 12559,
     /* 260016 */     GIR_EraseRootFromParent_Done,
     /* 260017 */   // Label 5185: @260017
     /* 260017 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(260077), // Rule ID 12560 //
     /* 260022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 260030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260042 */     // MIs[0] tile
     /* 260042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260045 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260058 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 260061 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260069 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260075 */     GIR_RootConstrainSelectedInstOperands,
     /* 260076 */     // GIR_Coverage, 12560,
     /* 260076 */     GIR_EraseRootFromParent_Done,
     /* 260077 */   // Label 5186: @260077
     /* 260077 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(260137), // Rule ID 12934 //
     /* 260082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 260090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 260093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 260096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 260102 */     // MIs[0] tile
     /* 260102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260118 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 260118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 260121 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260129 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260135 */     GIR_RootConstrainSelectedInstOperands,
     /* 260136 */     // GIR_Coverage, 12934,
     /* 260136 */     GIR_EraseRootFromParent_Done,
     /* 260137 */   // Label 5187: @260137
     /* 260137 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(260197), // Rule ID 12935 //
     /* 260142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 260150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260162 */     // MIs[0] tile
     /* 260162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260178 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 260181 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260189 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260195 */     GIR_RootConstrainSelectedInstOperands,
     /* 260196 */     // GIR_Coverage, 12935,
     /* 260196 */     GIR_EraseRootFromParent_Done,
     /* 260197 */   // Label 5188: @260197
     /* 260197 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(260257), // Rule ID 12936 //
     /* 260202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 260210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260222 */     // MIs[0] tile
     /* 260222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260238 */     // (intrinsic_void 1167:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 260241 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260249 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260255 */     GIR_RootConstrainSelectedInstOperands,
     /* 260256 */     // GIR_Coverage, 12936,
     /* 260256 */     GIR_EraseRootFromParent_Done,
     /* 260257 */   // Label 5189: @260257
     /* 260257 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(260317), // Rule ID 12937 //
     /* 260262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 260270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260282 */     // MIs[0] tile
     /* 260282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260298 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 260301 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260309 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260315 */     GIR_RootConstrainSelectedInstOperands,
     /* 260316 */     // GIR_Coverage, 12937,
     /* 260316 */     GIR_EraseRootFromParent_Done,
     /* 260317 */   // Label 5190: @260317
     /* 260317 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(260377), // Rule ID 13048 //
     /* 260322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 260325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 260330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260342 */     // MIs[0] tile
     /* 260342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260345 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 260350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260358 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 260358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 260361 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260369 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260375 */     GIR_RootConstrainSelectedInstOperands,
     /* 260376 */     // GIR_Coverage, 13048,
     /* 260376 */     GIR_EraseRootFromParent_Done,
     /* 260377 */   // Label 5191: @260377
     /* 260377 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(260425), // Rule ID 3580 //
     /* 260382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 260390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260406 */     // MIs[0] Op4
     /* 260406 */     // No operand predicates
     /* 260406 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1506:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 260409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260417 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260423 */     GIR_RootConstrainSelectedInstOperands,
     /* 260424 */     // GIR_Coverage, 3580,
     /* 260424 */     GIR_EraseRootFromParent_Done,
     /* 260425 */   // Label 5192: @260425
     /* 260425 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(260473), // Rule ID 3582 //
     /* 260430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 260438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260454 */     // MIs[0] Op4
     /* 260454 */     // No operand predicates
     /* 260454 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1508:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 260457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260465 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260471 */     GIR_RootConstrainSelectedInstOperands,
     /* 260472 */     // GIR_Coverage, 3582,
     /* 260472 */     GIR_EraseRootFromParent_Done,
     /* 260473 */   // Label 5193: @260473
     /* 260473 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(260521), // Rule ID 3583 //
     /* 260478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 260481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 260486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260502 */     // MIs[0] Op4
     /* 260502 */     // No operand predicates
     /* 260502 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 260505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260513 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260519 */     GIR_RootConstrainSelectedInstOperands,
     /* 260520 */     // GIR_Coverage, 3583,
     /* 260520 */     GIR_EraseRootFromParent_Done,
     /* 260521 */   // Label 5194: @260521
     /* 260521 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(260569), // Rule ID 3584 //
     /* 260526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 260529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 260534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260550 */     // MIs[0] Op4
     /* 260550 */     // No operand predicates
     /* 260550 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1504:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 260553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260561 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260567 */     GIR_RootConstrainSelectedInstOperands,
     /* 260568 */     // GIR_Coverage, 3584,
     /* 260568 */     GIR_EraseRootFromParent_Done,
     /* 260569 */   // Label 5195: @260569
     /* 260569 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(260617), // Rule ID 12528 //
     /* 260574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 260582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260598 */     // MIs[0] Op4
     /* 260598 */     // No operand predicates
     /* 260598 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 260601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260609 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260615 */     GIR_RootConstrainSelectedInstOperands,
     /* 260616 */     // GIR_Coverage, 12528,
     /* 260616 */     GIR_EraseRootFromParent_Done,
     /* 260617 */   // Label 5196: @260617
     /* 260617 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(260665), // Rule ID 12530 //
     /* 260622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 260630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260646 */     // MIs[0] Op4
     /* 260646 */     // No operand predicates
     /* 260646 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 260649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260657 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260663 */     GIR_RootConstrainSelectedInstOperands,
     /* 260664 */     // GIR_Coverage, 12530,
     /* 260664 */     GIR_EraseRootFromParent_Done,
     /* 260665 */   // Label 5197: @260665
     /* 260665 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(260713), // Rule ID 12531 //
     /* 260670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 260678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260694 */     // MIs[0] Op4
     /* 260694 */     // No operand predicates
     /* 260694 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1512:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 260697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260705 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260711 */     GIR_RootConstrainSelectedInstOperands,
     /* 260712 */     // GIR_Coverage, 12531,
     /* 260712 */     GIR_EraseRootFromParent_Done,
     /* 260713 */   // Label 5198: @260713
     /* 260713 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(260761), // Rule ID 12532 //
     /* 260718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 260726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260742 */     // MIs[0] Op4
     /* 260742 */     // No operand predicates
     /* 260742 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 260745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260753 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260759 */     GIR_RootConstrainSelectedInstOperands,
     /* 260760 */     // GIR_Coverage, 12532,
     /* 260760 */     GIR_EraseRootFromParent_Done,
     /* 260761 */   // Label 5199: @260761
     /* 260761 */   GIM_Reject,
     /* 260762 */ // Label 5149: @260762
     /* 260762 */ GIM_Reject,
     /* 260763 */ // Label 37: @260763
     /* 260763 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5204*/ GIMT_Encode4(261052),
     /* 260774 */ /*GILLT_s64*//*Label 5200*/ GIMT_Encode4(260806), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 260786 */ /*GILLT_v2s64*//*Label 5201*/ GIMT_Encode4(260866), GIMT_Encode4(0),
     /* 260794 */ /*GILLT_v4s32*//*Label 5202*/ GIMT_Encode4(260928), GIMT_Encode4(0),
     /* 260802 */ /*GILLT_v8s16*//*Label 5203*/ GIMT_Encode4(260990),
     /* 260806 */ // Label 5200: @260806
     /* 260806 */ GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(260865), // Rule ID 6493 //
     /* 260811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 260814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260822 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 260822 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 260825 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260829 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 260836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 260846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 260849 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260854 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260864 */   // GIR_Coverage, 6493,
     /* 260864 */   GIR_EraseRootFromParent_Done,
     /* 260865 */ // Label 5205: @260865
     /* 260865 */ GIM_Reject,
     /* 260866 */ // Label 5201: @260866
     /* 260866 */ GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(260927),
     /* 260871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 260874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260878 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(260905), // Rule ID 6365 //
     /* 260883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260890 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 260890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 260893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260903 */     GIR_RootConstrainSelectedInstOperands,
     /* 260904 */     // GIR_Coverage, 6365,
     /* 260904 */     GIR_EraseRootFromParent_Done,
     /* 260905 */   // Label 5207: @260905
     /* 260905 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(260926), // Rule ID 6358 //
     /* 260910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260914 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 260914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 260917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260924 */     GIR_RootConstrainSelectedInstOperands,
     /* 260925 */     // GIR_Coverage, 6358,
     /* 260925 */     GIR_EraseRootFromParent_Done,
     /* 260926 */   // Label 5208: @260926
     /* 260926 */   GIM_Reject,
     /* 260927 */ // Label 5206: @260927
     /* 260927 */ GIM_Reject,
     /* 260928 */ // Label 5202: @260928
     /* 260928 */ GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(260989),
     /* 260933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 260936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260940 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(260967), // Rule ID 6362 //
     /* 260945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 260952 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 260952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 260955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260965 */     GIR_RootConstrainSelectedInstOperands,
     /* 260966 */     // GIR_Coverage, 6362,
     /* 260966 */     GIR_EraseRootFromParent_Done,
     /* 260967 */   // Label 5210: @260967
     /* 260967 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(260988), // Rule ID 6355 //
     /* 260972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260976 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 260976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 260979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260986 */     GIR_RootConstrainSelectedInstOperands,
     /* 260987 */     // GIR_Coverage, 6355,
     /* 260987 */     GIR_EraseRootFromParent_Done,
     /* 260988 */   // Label 5211: @260988
     /* 260988 */   GIM_Reject,
     /* 260989 */ // Label 5209: @260989
     /* 260989 */ GIM_Reject,
     /* 260990 */ // Label 5203: @260990
     /* 260990 */ GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(261051),
     /* 260995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 260998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261002 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(261029), // Rule ID 6359 //
     /* 261007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261014 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 261014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 261017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261027 */     GIR_RootConstrainSelectedInstOperands,
     /* 261028 */     // GIR_Coverage, 6359,
     /* 261028 */     GIR_EraseRootFromParent_Done,
     /* 261029 */   // Label 5213: @261029
     /* 261029 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(261050), // Rule ID 6352 //
     /* 261034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261038 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 261038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 261041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261048 */     GIR_RootConstrainSelectedInstOperands,
     /* 261049 */     // GIR_Coverage, 6352,
     /* 261049 */     GIR_EraseRootFromParent_Done,
     /* 261050 */   // Label 5214: @261050
     /* 261050 */   GIM_Reject,
     /* 261051 */ // Label 5212: @261051
     /* 261051 */ GIM_Reject,
     /* 261052 */ // Label 5204: @261052
     /* 261052 */ GIM_Reject,
     /* 261053 */ // Label 38: @261053
     /* 261053 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5219*/ GIMT_Encode4(262489),
     /* 261064 */ /*GILLT_s32*//*Label 5215*/ GIMT_Encode4(261096), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261076 */ /*GILLT_v2s32*//*Label 5216*/ GIMT_Encode4(261135), GIMT_Encode4(0),
     /* 261084 */ /*GILLT_v4s16*//*Label 5217*/ GIMT_Encode4(261491), GIMT_Encode4(0),
     /* 261092 */ /*GILLT_v8s8*//*Label 5218*/ GIMT_Encode4(261990),
     /* 261096 */ // Label 5215: @261096
     /* 261096 */ GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261134), // Rule ID 6514 //
     /* 261101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 261104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 261108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 261112 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 261112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261117 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 261123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 261128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 261133 */   // GIR_Coverage, 6514,
     /* 261133 */   GIR_EraseRootFromParent_Done,
     /* 261134 */ // Label 5220: @261134
     /* 261134 */ GIM_Reject,
     /* 261135 */ // Label 5216: @261135
     /* 261135 */ GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261490),
     /* 261140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261147 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261225), // Rule ID 5430 //
     /* 261152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261197 */     // MIs[1] Operand 2
     /* 261197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261210 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 261210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 261213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261223 */     GIR_RootConstrainSelectedInstOperands,
     /* 261224 */     // GIR_Coverage, 5430,
     /* 261224 */     GIR_EraseRootFromParent_Done,
     /* 261225 */   // Label 5222: @261225
     /* 261225 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(261296), // Rule ID 5426 //
     /* 261230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261268 */     // MIs[1] Operand 2
     /* 261268 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261281 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 261281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 261284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261294 */     GIR_RootConstrainSelectedInstOperands,
     /* 261295 */     // GIR_Coverage, 5426,
     /* 261295 */     GIR_EraseRootFromParent_Done,
     /* 261296 */   // Label 5223: @261296
     /* 261296 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261367), // Rule ID 5428 //
     /* 261301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261339 */     // MIs[1] Operand 2
     /* 261339 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261352 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 261352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 261355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261365 */     GIR_RootConstrainSelectedInstOperands,
     /* 261366 */     // GIR_Coverage, 5428,
     /* 261366 */     GIR_EraseRootFromParent_Done,
     /* 261367 */   // Label 5224: @261367
     /* 261367 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(261420), // Rule ID 2162 //
     /* 261372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 261383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261392 */     // MIs[1] imm
     /* 261392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 261404 */     // MIs[2] Operand 1
     /* 261404 */     // No operand predicates
     /* 261404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261406 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 261406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 261409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261418 */     GIR_RootConstrainSelectedInstOperands,
     /* 261419 */     // GIR_Coverage, 2162,
     /* 261419 */     GIR_EraseRootFromParent_Done,
     /* 261420 */   // Label 5225: @261420
     /* 261420 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(261470), // Rule ID 6340 //
     /* 261425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261442 */     // MIs[1] imm
     /* 261442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261450 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 261454 */     // MIs[2] Operand 1
     /* 261454 */     // No operand predicates
     /* 261454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261456 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 261456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 261459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261468 */     GIR_RootConstrainSelectedInstOperands,
     /* 261469 */     // GIR_Coverage, 6340,
     /* 261469 */     GIR_EraseRootFromParent_Done,
     /* 261470 */   // Label 5226: @261470
     /* 261470 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(261489), // Rule ID 1099 //
     /* 261475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261482 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 261482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 261487 */     GIR_RootConstrainSelectedInstOperands,
     /* 261488 */     // GIR_Coverage, 1099,
     /* 261488 */     GIR_Done,
     /* 261489 */   // Label 5227: @261489
     /* 261489 */   GIM_Reject,
     /* 261490 */ // Label 5221: @261490
     /* 261490 */ GIM_Reject,
     /* 261491 */ // Label 5217: @261491
     /* 261491 */ GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(261989),
     /* 261496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261503 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(261581), // Rule ID 5424 //
     /* 261508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261545 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261551 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261553 */     // MIs[1] Operand 2
     /* 261553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261566 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 261566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 261569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261579 */     GIR_RootConstrainSelectedInstOperands,
     /* 261580 */     // GIR_Coverage, 5424,
     /* 261580 */     GIR_EraseRootFromParent_Done,
     /* 261581 */   // Label 5229: @261581
     /* 261581 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(261652), // Rule ID 5420 //
     /* 261586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261624 */     // MIs[1] Operand 2
     /* 261624 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261637 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 261640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261650 */     GIR_RootConstrainSelectedInstOperands,
     /* 261651 */     // GIR_Coverage, 5420,
     /* 261651 */     GIR_EraseRootFromParent_Done,
     /* 261652 */   // Label 5230: @261652
     /* 261652 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261723), // Rule ID 5422 //
     /* 261657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261695 */     // MIs[1] Operand 2
     /* 261695 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261708 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 261711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261721 */     GIR_RootConstrainSelectedInstOperands,
     /* 261722 */     // GIR_Coverage, 5422,
     /* 261722 */     GIR_EraseRootFromParent_Done,
     /* 261723 */   // Label 5231: @261723
     /* 261723 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261815), // Rule ID 5546 //
     /* 261728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261736 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 261755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 261768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 261772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261776 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261783 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 261783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 261786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 261790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 261799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 261803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 261808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261813 */     GIR_RootConstrainSelectedInstOperands,
     /* 261814 */     // GIR_Coverage, 5546,
     /* 261814 */     GIR_EraseRootFromParent_Done,
     /* 261815 */   // Label 5232: @261815
     /* 261815 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(261868), // Rule ID 2161 //
     /* 261820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 261831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261840 */     // MIs[1] imm
     /* 261840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261848 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 261852 */     // MIs[2] Operand 1
     /* 261852 */     // No operand predicates
     /* 261852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261854 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 261854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 261857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261866 */     GIR_RootConstrainSelectedInstOperands,
     /* 261867 */     // GIR_Coverage, 2161,
     /* 261867 */     GIR_EraseRootFromParent_Done,
     /* 261868 */   // Label 5233: @261868
     /* 261868 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(261918), // Rule ID 6339 //
     /* 261873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261890 */     // MIs[1] imm
     /* 261890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261898 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 261902 */     // MIs[2] Operand 1
     /* 261902 */     // No operand predicates
     /* 261902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261904 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 261904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 261907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261916 */     GIR_RootConstrainSelectedInstOperands,
     /* 261917 */     // GIR_Coverage, 6339,
     /* 261917 */     GIR_EraseRootFromParent_Done,
     /* 261918 */   // Label 5234: @261918
     /* 261918 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(261969), // Rule ID 5574 //
     /* 261923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261931 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261954 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 261954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 261957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 261963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 261967 */     GIR_RootConstrainSelectedInstOperands,
     /* 261968 */     // GIR_Coverage, 5574,
     /* 261968 */     GIR_EraseRootFromParent_Done,
     /* 261969 */   // Label 5235: @261969
     /* 261969 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(261988), // Rule ID 1098 //
     /* 261974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261981 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 261981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 261986 */     GIR_RootConstrainSelectedInstOperands,
     /* 261987 */     // GIR_Coverage, 1098,
     /* 261987 */     GIR_Done,
     /* 261988 */   // Label 5236: @261988
     /* 261988 */   GIM_Reject,
     /* 261989 */ // Label 5228: @261989
     /* 261989 */ GIM_Reject,
     /* 261990 */ // Label 5218: @261990
     /* 261990 */ GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(262488),
     /* 261995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262002 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(262080), // Rule ID 5418 //
     /* 262007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 262027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 262044 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 262050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 262052 */     // MIs[1] Operand 2
     /* 262052 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 262063 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262065 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 262065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 262068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262078 */     GIR_RootConstrainSelectedInstOperands,
     /* 262079 */     // GIR_Coverage, 5418,
     /* 262079 */     GIR_EraseRootFromParent_Done,
     /* 262080 */   // Label 5238: @262080
     /* 262080 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(262151), // Rule ID 5414 //
     /* 262085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 262105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262123 */     // MIs[1] Operand 2
     /* 262123 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 262134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262136 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 262136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 262139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262149 */     GIR_RootConstrainSelectedInstOperands,
     /* 262150 */     // GIR_Coverage, 5414,
     /* 262150 */     GIR_EraseRootFromParent_Done,
     /* 262151 */   // Label 5239: @262151
     /* 262151 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262222), // Rule ID 5416 //
     /* 262156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 262176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262194 */     // MIs[1] Operand 2
     /* 262194 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 262205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262207 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 262207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 262210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262220 */     GIR_RootConstrainSelectedInstOperands,
     /* 262221 */     // GIR_Coverage, 5416,
     /* 262221 */     GIR_EraseRootFromParent_Done,
     /* 262222 */   // Label 5240: @262222
     /* 262222 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(262314), // Rule ID 5519 //
     /* 262227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262235 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 262267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262271 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262275 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262282 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 262282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 262285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 262289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 262298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 262302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 262307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262312 */     GIR_RootConstrainSelectedInstOperands,
     /* 262313 */     // GIR_Coverage, 5519,
     /* 262313 */     GIR_EraseRootFromParent_Done,
     /* 262314 */   // Label 5241: @262314
     /* 262314 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(262367), // Rule ID 2160 //
     /* 262319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 262330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262339 */     // MIs[1] imm
     /* 262339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 262351 */     // MIs[2] Operand 1
     /* 262351 */     // No operand predicates
     /* 262351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262353 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 262353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 262356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262365 */     GIR_RootConstrainSelectedInstOperands,
     /* 262366 */     // GIR_Coverage, 2160,
     /* 262366 */     GIR_EraseRootFromParent_Done,
     /* 262367 */   // Label 5242: @262367
     /* 262367 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(262417), // Rule ID 6338 //
     /* 262372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262389 */     // MIs[1] imm
     /* 262389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262397 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 262401 */     // MIs[2] Operand 1
     /* 262401 */     // No operand predicates
     /* 262401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262403 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 262403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 262406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262415 */     GIR_RootConstrainSelectedInstOperands,
     /* 262416 */     // GIR_Coverage, 6338,
     /* 262416 */     GIR_EraseRootFromParent_Done,
     /* 262417 */   // Label 5243: @262417
     /* 262417 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262468), // Rule ID 5573 //
     /* 262422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262430 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262453 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 262453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 262456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 262462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 262466 */     GIR_RootConstrainSelectedInstOperands,
     /* 262467 */     // GIR_Coverage, 5573,
     /* 262467 */     GIR_EraseRootFromParent_Done,
     /* 262468 */   // Label 5244: @262468
     /* 262468 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262487), // Rule ID 1097 //
     /* 262473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262480 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 262480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 262485 */     GIR_RootConstrainSelectedInstOperands,
     /* 262486 */     // GIR_Coverage, 1097,
     /* 262486 */     GIR_Done,
     /* 262487 */   // Label 5245: @262487
     /* 262487 */   GIM_Reject,
     /* 262488 */ // Label 5237: @262488
     /* 262488 */ GIM_Reject,
     /* 262489 */ // Label 5219: @262489
     /* 262489 */ GIM_Reject,
     /* 262490 */ // Label 39: @262490
     /* 262490 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5248*/ GIMT_Encode4(262609),
     /* 262501 */ /*GILLT_s32*//*Label 5246*/ GIMT_Encode4(262509),
     /* 262505 */ /*GILLT_s64*//*Label 5247*/ GIMT_Encode4(262529),
     /* 262509 */ // Label 5246: @262509
     /* 262509 */ GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(262528), // Rule ID 81 //
     /* 262514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262518 */   // MIs[0] Operand 1
     /* 262518 */   // No operand predicates
     /* 262518 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 262518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 262521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262523 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 262526 */   GIR_RootConstrainSelectedInstOperands,
     /* 262527 */   // GIR_Coverage, 81,
     /* 262527 */   GIR_EraseRootFromParent_Done,
     /* 262528 */ // Label 5249: @262528
     /* 262528 */ GIM_Reject,
     /* 262529 */ // Label 5247: @262529
     /* 262529 */ GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(262589), // Rule ID 3905 //
     /* 262534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 262537 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 262541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262545 */   // MIs[0] Operand 1
     /* 262545 */   // No operand predicates
     /* 262545 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 262545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 262552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262557 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 262562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 262578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262588 */   // GIR_Coverage, 3905,
     /* 262588 */   GIR_EraseRootFromParent_Done,
     /* 262589 */ // Label 5250: @262589
     /* 262589 */ GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(262608), // Rule ID 82 //
     /* 262594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262598 */   // MIs[0] Operand 1
     /* 262598 */   // No operand predicates
     /* 262598 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 262598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 262601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262603 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 262606 */   GIR_RootConstrainSelectedInstOperands,
     /* 262607 */   // GIR_Coverage, 82,
     /* 262607 */   GIR_EraseRootFromParent_Done,
     /* 262608 */ // Label 5251: @262608
     /* 262608 */ GIM_Reject,
     /* 262609 */ // Label 5248: @262609
     /* 262609 */ GIM_Reject,
     /* 262610 */ // Label 40: @262610
     /* 262610 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5255*/ GIMT_Encode4(262850),
     /* 262621 */ /*GILLT_s16*//*Label 5252*/ GIMT_Encode4(262633),
     /* 262625 */ /*GILLT_s32*//*Label 5253*/ GIMT_Encode4(262685),
     /* 262629 */ /*GILLT_s64*//*Label 5254*/ GIMT_Encode4(262798),
     /* 262633 */ // Label 5252: @262633
     /* 262633 */ GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(262656), // Rule ID 506 //
     /* 262638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262641 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262649 */   // MIs[0] Operand 1
     /* 262649 */   // No operand predicates
     /* 262649 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 262649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 262652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262654 */   GIR_RootConstrainSelectedInstOperands,
     /* 262655 */   // GIR_Coverage, 506,
     /* 262655 */   GIR_EraseRootFromParent_Done,
     /* 262656 */ // Label 5256: @262656
     /* 262656 */ GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(262684), // Rule ID 688 //
     /* 262661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 262664 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 262668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262672 */   // MIs[0] Operand 1
     /* 262672 */   // No operand predicates
     /* 262672 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 262672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 262675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262677 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 262682 */   GIR_RootConstrainSelectedInstOperands,
     /* 262683 */   // GIR_Coverage, 688,
     /* 262683 */   GIR_EraseRootFromParent_Done,
     /* 262684 */ // Label 5257: @262684
     /* 262684 */ GIM_Reject,
     /* 262685 */ // Label 5253: @262685
     /* 262685 */ GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(262708), // Rule ID 507 //
     /* 262690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262693 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262701 */   // MIs[0] Operand 1
     /* 262701 */   // No operand predicates
     /* 262701 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 262701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 262704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262706 */   GIR_RootConstrainSelectedInstOperands,
     /* 262707 */   // GIR_Coverage, 507,
     /* 262707 */   GIR_EraseRootFromParent_Done,
     /* 262708 */ // Label 5258: @262708
     /* 262708 */ GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(262736), // Rule ID 689 //
     /* 262713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262716 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 262720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262724 */   // MIs[0] Operand 1
     /* 262724 */   // No operand predicates
     /* 262724 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 262724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 262727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262729 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 262734 */   GIR_RootConstrainSelectedInstOperands,
     /* 262735 */   // GIR_Coverage, 689,
     /* 262735 */   GIR_EraseRootFromParent_Done,
     /* 262736 */ // Label 5259: @262736
     /* 262736 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(262797), // Rule ID 6027 //
     /* 262741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262744 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 262748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262752 */   // MIs[0] Operand 1
     /* 262752 */   // No operand predicates
     /* 262752 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 262752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 262759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262764 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 262769 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 262772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262779 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262796 */   // GIR_Coverage, 6027,
     /* 262796 */   GIR_EraseRootFromParent_Done,
     /* 262797 */ // Label 5260: @262797
     /* 262797 */ GIM_Reject,
     /* 262798 */ // Label 5254: @262798
     /* 262798 */ GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(262821), // Rule ID 508 //
     /* 262803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262806 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262814 */   // MIs[0] Operand 1
     /* 262814 */   // No operand predicates
     /* 262814 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 262814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 262817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262819 */   GIR_RootConstrainSelectedInstOperands,
     /* 262820 */   // GIR_Coverage, 508,
     /* 262820 */   GIR_EraseRootFromParent_Done,
     /* 262821 */ // Label 5261: @262821
     /* 262821 */ GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(262849), // Rule ID 690 //
     /* 262826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262829 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 262833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262837 */   // MIs[0] Operand 1
     /* 262837 */   // No operand predicates
     /* 262837 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 262837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 262840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262842 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 262847 */   GIR_RootConstrainSelectedInstOperands,
     /* 262848 */   // GIR_Coverage, 690,
     /* 262848 */   GIR_EraseRootFromParent_Done,
     /* 262849 */ // Label 5262: @262849
     /* 262849 */ GIM_Reject,
     /* 262850 */ // Label 5255: @262850
     /* 262850 */ GIM_Reject,
     /* 262851 */ // Label 41: @262851
     /* 262851 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5268*/ GIMT_Encode4(264748),
     /* 262862 */ /*GILLT_s32*//*Label 5263*/ GIMT_Encode4(262898),
     /* 262866 */ /*GILLT_s64*//*Label 5264*/ GIMT_Encode4(264339), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 262878 */ /*GILLT_v2s64*//*Label 5265*/ GIMT_Encode4(264562), GIMT_Encode4(0),
     /* 262886 */ /*GILLT_v4s32*//*Label 5266*/ GIMT_Encode4(264624), GIMT_Encode4(0),
     /* 262894 */ /*GILLT_v8s16*//*Label 5267*/ GIMT_Encode4(264686),
     /* 262898 */ // Label 5263: @262898
     /* 262898 */ GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(263018), // Rule ID 13103 //
     /* 262903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262910 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262918 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262921 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262937 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262937 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262940 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 262944 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262949 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262955 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262958 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262962 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262981 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262984 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262987 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263016 */   GIR_RootConstrainSelectedInstOperands,
     /* 263017 */   // GIR_Coverage, 13103,
     /* 263017 */   GIR_EraseRootFromParent_Done,
     /* 263018 */ // Label 5269: @263018
     /* 263018 */ GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(263138), // Rule ID 13105 //
     /* 263023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263030 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263038 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263041 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263046 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263050 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263055 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263057 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263057 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263060 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 263064 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263069 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263073 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263075 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263078 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263082 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263101 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263104 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263107 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263110 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263115 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263120 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263136 */   GIR_RootConstrainSelectedInstOperands,
     /* 263137 */   // GIR_Coverage, 13105,
     /* 263137 */   GIR_EraseRootFromParent_Done,
     /* 263138 */ // Label 5270: @263138
     /* 263138 */ GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(263258), // Rule ID 13107 //
     /* 263143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263150 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263158 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263161 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263166 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263170 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263177 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263177 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263180 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 263184 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263189 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263195 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263198 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263202 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263209 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263212 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263216 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263221 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263224 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263227 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263230 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263240 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263256 */   GIR_RootConstrainSelectedInstOperands,
     /* 263257 */   // GIR_Coverage, 13107,
     /* 263257 */   GIR_EraseRootFromParent_Done,
     /* 263258 */ // Label 5271: @263258
     /* 263258 */ GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(263378), // Rule ID 13109 //
     /* 263263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263270 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263278 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263281 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263290 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263295 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263297 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263297 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263300 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 263304 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263309 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263315 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263318 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263322 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263341 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263344 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263347 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263350 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263355 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263376 */   GIR_RootConstrainSelectedInstOperands,
     /* 263377 */   // GIR_Coverage, 13109,
     /* 263377 */   GIR_EraseRootFromParent_Done,
     /* 263378 */ // Label 5272: @263378
     /* 263378 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(263498), // Rule ID 13125 //
     /* 263383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263390 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263398 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263401 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263406 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263410 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263417 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263417 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263420 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 263424 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263429 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263435 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263438 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263442 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263461 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263464 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263467 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263496 */   GIR_RootConstrainSelectedInstOperands,
     /* 263497 */   // GIR_Coverage, 13125,
     /* 263497 */   GIR_EraseRootFromParent_Done,
     /* 263498 */ // Label 5273: @263498
     /* 263498 */ GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263618), // Rule ID 13127 //
     /* 263503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263510 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263518 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263521 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263526 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263530 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263537 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263537 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263540 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 263544 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263549 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263555 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263558 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263562 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263569 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263572 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263576 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263581 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263584 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263587 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263590 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263616 */   GIR_RootConstrainSelectedInstOperands,
     /* 263617 */   // GIR_Coverage, 13127,
     /* 263617 */   GIR_EraseRootFromParent_Done,
     /* 263618 */ // Label 5274: @263618
     /* 263618 */ GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263738), // Rule ID 13129 //
     /* 263623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263630 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263638 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263641 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263646 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263650 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263657 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263657 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263660 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 263664 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263669 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263673 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263675 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263678 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263682 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263689 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263692 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263696 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263701 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263704 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263707 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263710 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263715 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263720 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263736 */   GIR_RootConstrainSelectedInstOperands,
     /* 263737 */   // GIR_Coverage, 13129,
     /* 263737 */   GIR_EraseRootFromParent_Done,
     /* 263738 */ // Label 5275: @263738
     /* 263738 */ GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263858), // Rule ID 13131 //
     /* 263743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263750 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263758 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263761 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263766 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263770 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263777 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263777 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263780 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 263784 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263789 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263795 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263798 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263802 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263821 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263824 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263827 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263856 */   GIR_RootConstrainSelectedInstOperands,
     /* 263857 */   // GIR_Coverage, 13131,
     /* 263857 */   GIR_EraseRootFromParent_Done,
     /* 263858 */ // Label 5276: @263858
     /* 263858 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263978), // Rule ID 13135 //
     /* 263863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263870 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263874 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263878 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263881 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263890 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263897 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263897 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263900 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 263904 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263909 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263915 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263918 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263922 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263941 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263944 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263947 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263950 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263955 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263960 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263976 */   GIR_RootConstrainSelectedInstOperands,
     /* 263977 */   // GIR_Coverage, 13135,
     /* 263977 */   GIR_EraseRootFromParent_Done,
     /* 263978 */ // Label 5277: @263978
     /* 263978 */ GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(264098), // Rule ID 13137 //
     /* 263983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263990 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263998 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264001 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264006 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 264010 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264015 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264017 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264017 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 264020 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 264024 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264029 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264035 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264038 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264042 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264061 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264064 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264067 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 264070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264075 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264080 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 264085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264096 */   GIR_RootConstrainSelectedInstOperands,
     /* 264097 */   // GIR_Coverage, 13137,
     /* 264097 */   GIR_EraseRootFromParent_Done,
     /* 264098 */ // Label 5278: @264098
     /* 264098 */ GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(264218), // Rule ID 13139 //
     /* 264103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264110 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264118 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264121 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264126 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264130 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264137 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 264144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264155 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264158 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264162 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264181 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264184 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264187 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264190 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264195 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264200 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264216 */   GIR_RootConstrainSelectedInstOperands,
     /* 264217 */   // GIR_Coverage, 13139,
     /* 264217 */   GIR_EraseRootFromParent_Done,
     /* 264218 */ // Label 5279: @264218
     /* 264218 */ GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(264338), // Rule ID 13141 //
     /* 264223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264230 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264234 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264238 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264241 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264246 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264250 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264255 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264257 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264257 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264260 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 264264 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264269 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264275 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264278 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264282 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264301 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264304 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264307 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264310 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264315 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264320 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264336 */   GIR_RootConstrainSelectedInstOperands,
     /* 264337 */   // GIR_Coverage, 13141,
     /* 264337 */   GIR_EraseRootFromParent_Done,
     /* 264338 */ // Label 5280: @264338
     /* 264338 */ GIM_Reject,
     /* 264339 */ // Label 5264: @264339
     /* 264339 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(264561),
     /* 264344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264351 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(264405), // Rule ID 5657 //
     /* 264356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264385 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 264389 */     // MIs[2] Operand 1
     /* 264389 */     // No operand predicates
     /* 264389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264391 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 264391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 264394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264403 */     GIR_RootConstrainSelectedInstOperands,
     /* 264404 */     // GIR_Coverage, 5657,
     /* 264404 */     GIR_EraseRootFromParent_Done,
     /* 264405 */   // Label 5282: @264405
     /* 264405 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(264484), // Rule ID 11208 //
     /* 264410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 264425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 264441 */     // MIs[2] Operand 1
     /* 264441 */     // No operand predicates
     /* 264441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264443 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 264443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 264446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264455 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 264474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264482 */     GIR_RootConstrainSelectedInstOperands,
     /* 264483 */     // GIR_Coverage, 11208,
     /* 264483 */     GIR_EraseRootFromParent_Done,
     /* 264484 */   // Label 5283: @264484
     /* 264484 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(264560), // Rule ID 6495 //
     /* 264489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264493 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 264493 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 264496 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264500 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 264526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 264547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 264558 */     GIR_RootConstrainSelectedInstOperands,
     /* 264559 */     // GIR_Coverage, 6495,
     /* 264559 */     GIR_EraseRootFromParent_Done,
     /* 264560 */   // Label 5284: @264560
     /* 264560 */   GIM_Reject,
     /* 264561 */ // Label 5281: @264561
     /* 264561 */ GIM_Reject,
     /* 264562 */ // Label 5265: @264562
     /* 264562 */ GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(264623),
     /* 264567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264574 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(264601), // Rule ID 6367 //
     /* 264579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 264586 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 264586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 264589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264599 */     GIR_RootConstrainSelectedInstOperands,
     /* 264600 */     // GIR_Coverage, 6367,
     /* 264600 */     GIR_EraseRootFromParent_Done,
     /* 264601 */   // Label 5286: @264601
     /* 264601 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264622), // Rule ID 6356 //
     /* 264606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264610 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 264610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 264613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264620 */     GIR_RootConstrainSelectedInstOperands,
     /* 264621 */     // GIR_Coverage, 6356,
     /* 264621 */     GIR_EraseRootFromParent_Done,
     /* 264622 */   // Label 5287: @264622
     /* 264622 */   GIM_Reject,
     /* 264623 */ // Label 5285: @264623
     /* 264623 */ GIM_Reject,
     /* 264624 */ // Label 5266: @264624
     /* 264624 */ GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(264685),
     /* 264629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264636 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(264663), // Rule ID 6364 //
     /* 264641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 264648 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 264648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 264651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264661 */     GIR_RootConstrainSelectedInstOperands,
     /* 264662 */     // GIR_Coverage, 6364,
     /* 264662 */     GIR_EraseRootFromParent_Done,
     /* 264663 */   // Label 5289: @264663
     /* 264663 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(264684), // Rule ID 6353 //
     /* 264668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264672 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 264672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 264675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264682 */     GIR_RootConstrainSelectedInstOperands,
     /* 264683 */     // GIR_Coverage, 6353,
     /* 264683 */     GIR_EraseRootFromParent_Done,
     /* 264684 */   // Label 5290: @264684
     /* 264684 */   GIM_Reject,
     /* 264685 */ // Label 5288: @264685
     /* 264685 */ GIM_Reject,
     /* 264686 */ // Label 5267: @264686
     /* 264686 */ GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(264747),
     /* 264691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 264694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264698 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264725), // Rule ID 6361 //
     /* 264703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 264710 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 264710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 264713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264723 */     GIR_RootConstrainSelectedInstOperands,
     /* 264724 */     // GIR_Coverage, 6361,
     /* 264724 */     GIR_EraseRootFromParent_Done,
     /* 264725 */   // Label 5292: @264725
     /* 264725 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264746), // Rule ID 6350 //
     /* 264730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264734 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 264734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 264737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264744 */     GIR_RootConstrainSelectedInstOperands,
     /* 264745 */     // GIR_Coverage, 6350,
     /* 264745 */     GIR_EraseRootFromParent_Done,
     /* 264746 */   // Label 5293: @264746
     /* 264746 */   GIM_Reject,
     /* 264747 */ // Label 5291: @264747
     /* 264747 */ GIM_Reject,
     /* 264748 */ // Label 5268: @264748
     /* 264748 */ GIM_Reject,
     /* 264749 */ // Label 42: @264749
     /* 264749 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5299*/ GIMT_Encode4(266402),
     /* 264760 */ /*GILLT_s32*//*Label 5294*/ GIMT_Encode4(264840),
     /* 264764 */ /*GILLT_s64*//*Label 5295*/ GIMT_Encode4(265334), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 264816 */ /*GILLT_nxv2s64*//*Label 5296*/ GIMT_Encode4(265976), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 264828 */ /*GILLT_nxv4s32*//*Label 5297*/ GIMT_Encode4(266185), GIMT_Encode4(0),
     /* 264836 */ /*GILLT_nxv8s16*//*Label 5298*/ GIMT_Encode4(266329),
     /* 264840 */ // Label 5294: @264840
     /* 264840 */ GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(265333),
     /* 264845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264852 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(264917), // Rule ID 5652 //
     /* 264857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 264869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264886 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264890 */     // MIs[2] Operand 1
     /* 264890 */     // No operand predicates
     /* 264890 */     // MIs[0] Operand 2
     /* 264890 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264903 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 264903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264915 */     GIR_RootConstrainSelectedInstOperands,
     /* 264916 */     // GIR_Coverage, 5652,
     /* 264916 */     GIR_EraseRootFromParent_Done,
     /* 264917 */   // Label 5301: @264917
     /* 264917 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(264982), // Rule ID 5654 //
     /* 264922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264955 */     // MIs[2] Operand 1
     /* 264955 */     // No operand predicates
     /* 264955 */     // MIs[0] Operand 2
     /* 264955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264968 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264980 */     GIR_RootConstrainSelectedInstOperands,
     /* 264981 */     // GIR_Coverage, 5654,
     /* 264981 */     GIR_EraseRootFromParent_Done,
     /* 264982 */   // Label 5302: @264982
     /* 264982 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(265047), // Rule ID 5656 //
     /* 264987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265020 */     // MIs[2] Operand 1
     /* 265020 */     // No operand predicates
     /* 265020 */     // MIs[0] Operand 2
     /* 265020 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265033 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265045 */     GIR_RootConstrainSelectedInstOperands,
     /* 265046 */     // GIR_Coverage, 5656,
     /* 265046 */     GIR_EraseRootFromParent_Done,
     /* 265047 */   // Label 5303: @265047
     /* 265047 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(265137), // Rule ID 11204 //
     /* 265052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 265067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265083 */     // MIs[2] Operand 1
     /* 265083 */     // No operand predicates
     /* 265083 */     // MIs[0] Operand 2
     /* 265083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265096 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 265096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265108 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 265135 */     GIR_RootConstrainSelectedInstOperands,
     /* 265136 */     // GIR_Coverage, 11204,
     /* 265136 */     GIR_EraseRootFromParent_Done,
     /* 265137 */   // Label 5304: @265137
     /* 265137 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(265227), // Rule ID 11206 //
     /* 265142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 265157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265169 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265173 */     // MIs[2] Operand 1
     /* 265173 */     // No operand predicates
     /* 265173 */     // MIs[0] Operand 2
     /* 265173 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265186 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 265186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 265189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265198 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 265225 */     GIR_RootConstrainSelectedInstOperands,
     /* 265226 */     // GIR_Coverage, 11206,
     /* 265226 */     GIR_EraseRootFromParent_Done,
     /* 265227 */   // Label 5305: @265227
     /* 265227 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(265262), // Rule ID 6500 //
     /* 265232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265236 */     // MIs[0] Operand 2
     /* 265236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265247 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 265247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265260 */     GIR_RootConstrainSelectedInstOperands,
     /* 265261 */     // GIR_Coverage, 6500,
     /* 265261 */     GIR_EraseRootFromParent_Done,
     /* 265262 */   // Label 5306: @265262
     /* 265262 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(265297), // Rule ID 6501 //
     /* 265267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265271 */     // MIs[0] Operand 2
     /* 265271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265282 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 265282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265295 */     GIR_RootConstrainSelectedInstOperands,
     /* 265296 */     // GIR_Coverage, 6501,
     /* 265296 */     GIR_EraseRootFromParent_Done,
     /* 265297 */   // Label 5307: @265297
     /* 265297 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(265332), // Rule ID 6502 //
     /* 265302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265306 */     // MIs[0] Operand 2
     /* 265306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 265317 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 265317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265330 */     GIR_RootConstrainSelectedInstOperands,
     /* 265331 */     // GIR_Coverage, 6502,
     /* 265331 */     GIR_EraseRootFromParent_Done,
     /* 265332 */   // Label 5308: @265332
     /* 265332 */   GIM_Reject,
     /* 265333 */ // Label 5300: @265333
     /* 265333 */ GIM_Reject,
     /* 265334 */ // Label 5295: @265334
     /* 265334 */ GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(265975),
     /* 265339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 265342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265346 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(265423), // Rule ID 5658 //
     /* 265351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265375 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265392 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265396 */     // MIs[3] Operand 1
     /* 265396 */     // No operand predicates
     /* 265396 */     // MIs[0] Operand 2
     /* 265396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265409 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 265418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 265421 */     GIR_RootConstrainSelectedInstOperands,
     /* 265422 */     // GIR_Coverage, 5658,
     /* 265422 */     GIR_EraseRootFromParent_Done,
     /* 265423 */   // Label 5310: @265423
     /* 265423 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(265500), // Rule ID 5659 //
     /* 265428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265469 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265473 */     // MIs[3] Operand 1
     /* 265473 */     // No operand predicates
     /* 265473 */     // MIs[0] Operand 2
     /* 265473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265486 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 265495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 265498 */     GIR_RootConstrainSelectedInstOperands,
     /* 265499 */     // GIR_Coverage, 5659,
     /* 265499 */     GIR_EraseRootFromParent_Done,
     /* 265500 */   // Label 5311: @265500
     /* 265500 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(265602), // Rule ID 11205 //
     /* 265505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 265532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265544 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265548 */     // MIs[3] Operand 1
     /* 265548 */     // No operand predicates
     /* 265548 */     // MIs[0] Operand 2
     /* 265548 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265561 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 265561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265573 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 265600 */     GIR_RootConstrainSelectedInstOperands,
     /* 265601 */     // GIR_Coverage, 11205,
     /* 265601 */     GIR_EraseRootFromParent_Done,
     /* 265602 */   // Label 5312: @265602
     /* 265602 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(265704), // Rule ID 11207 //
     /* 265607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 265634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265646 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265650 */     // MIs[3] Operand 1
     /* 265650 */     // No operand predicates
     /* 265650 */     // MIs[0] Operand 2
     /* 265650 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265663 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 265663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 265666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 265702 */     GIR_RootConstrainSelectedInstOperands,
     /* 265703 */     // GIR_Coverage, 11207,
     /* 265703 */     GIR_EraseRootFromParent_Done,
     /* 265704 */   // Label 5313: @265704
     /* 265704 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(265769), // Rule ID 5653 //
     /* 265709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265738 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265742 */     // MIs[2] Operand 1
     /* 265742 */     // No operand predicates
     /* 265742 */     // MIs[0] Operand 2
     /* 265742 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265755 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265767 */     GIR_RootConstrainSelectedInstOperands,
     /* 265768 */     // GIR_Coverage, 5653,
     /* 265768 */     GIR_EraseRootFromParent_Done,
     /* 265769 */   // Label 5314: @265769
     /* 265769 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(265834), // Rule ID 5655 //
     /* 265774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265803 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265807 */     // MIs[2] Operand 1
     /* 265807 */     // No operand predicates
     /* 265807 */     // MIs[0] Operand 2
     /* 265807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265820 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265832 */     GIR_RootConstrainSelectedInstOperands,
     /* 265833 */     // GIR_Coverage, 5655,
     /* 265833 */     GIR_EraseRootFromParent_Done,
     /* 265834 */   // Label 5315: @265834
     /* 265834 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(265869), // Rule ID 6496 //
     /* 265839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265843 */     // MIs[0] Operand 2
     /* 265843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 265854 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 265854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265859 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 265867 */     GIR_RootConstrainSelectedInstOperands,
     /* 265868 */     // GIR_Coverage, 6496,
     /* 265868 */     GIR_EraseRootFromParent_Done,
     /* 265869 */   // Label 5316: @265869
     /* 265869 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(265904), // Rule ID 6497 //
     /* 265874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265878 */     // MIs[0] Operand 2
     /* 265878 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265889 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 265889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265902 */     GIR_RootConstrainSelectedInstOperands,
     /* 265903 */     // GIR_Coverage, 6497,
     /* 265903 */     GIR_EraseRootFromParent_Done,
     /* 265904 */   // Label 5317: @265904
     /* 265904 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(265939), // Rule ID 6498 //
     /* 265909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265913 */     // MIs[0] Operand 2
     /* 265913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265924 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 265924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265929 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265937 */     GIR_RootConstrainSelectedInstOperands,
     /* 265938 */     // GIR_Coverage, 6498,
     /* 265938 */     GIR_EraseRootFromParent_Done,
     /* 265939 */   // Label 5318: @265939
     /* 265939 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(265974), // Rule ID 6499 //
     /* 265944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265948 */     // MIs[0] Operand 2
     /* 265948 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 265959 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 265959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265972 */     GIR_RootConstrainSelectedInstOperands,
     /* 265973 */     // GIR_Coverage, 6499,
     /* 265973 */     GIR_EraseRootFromParent_Done,
     /* 265974 */   // Label 5319: @265974
     /* 265974 */   GIM_Reject,
     /* 265975 */ // Label 5309: @265975
     /* 265975 */ GIM_Reject,
     /* 265976 */ // Label 5296: @265976
     /* 265976 */ GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(266184),
     /* 265981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 265984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265988 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(266053), // Rule ID 10476 //
     /* 265993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265996 */     // MIs[0] Operand 2
     /* 265996 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 266007 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266019 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 266041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266051 */     GIR_RootConstrainSelectedInstOperands,
     /* 266052 */     // GIR_Coverage, 10476,
     /* 266052 */     GIR_EraseRootFromParent_Done,
     /* 266053 */   // Label 5321: @266053
     /* 266053 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(266118), // Rule ID 10477 //
     /* 266058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266061 */     // MIs[0] Operand 2
     /* 266061 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266072 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266072 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266075 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266079 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266084 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 266106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266116 */     GIR_RootConstrainSelectedInstOperands,
     /* 266117 */     // GIR_Coverage, 10477,
     /* 266117 */     GIR_EraseRootFromParent_Done,
     /* 266118 */   // Label 5322: @266118
     /* 266118 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(266183), // Rule ID 10478 //
     /* 266123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266126 */     // MIs[0] Operand 2
     /* 266126 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266137 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266149 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 266171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266181 */     GIR_RootConstrainSelectedInstOperands,
     /* 266182 */     // GIR_Coverage, 10478,
     /* 266182 */     GIR_EraseRootFromParent_Done,
     /* 266183 */   // Label 5323: @266183
     /* 266183 */   GIM_Reject,
     /* 266184 */ // Label 5320: @266184
     /* 266184 */ GIM_Reject,
     /* 266185 */ // Label 5297: @266185
     /* 266185 */ GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(266328),
     /* 266190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 266193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266197 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(266262), // Rule ID 10479 //
     /* 266202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266205 */     // MIs[0] Operand 2
     /* 266205 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266216 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 266216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 266223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266228 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 266250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266260 */     GIR_RootConstrainSelectedInstOperands,
     /* 266261 */     // GIR_Coverage, 10479,
     /* 266261 */     GIR_EraseRootFromParent_Done,
     /* 266262 */   // Label 5325: @266262
     /* 266262 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(266327), // Rule ID 10480 //
     /* 266267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266270 */     // MIs[0] Operand 2
     /* 266270 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266281 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 266281 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266284 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 266288 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266293 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 266315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266325 */     GIR_RootConstrainSelectedInstOperands,
     /* 266326 */     // GIR_Coverage, 10480,
     /* 266326 */     GIR_EraseRootFromParent_Done,
     /* 266327 */   // Label 5326: @266327
     /* 266327 */   GIM_Reject,
     /* 266328 */ // Label 5324: @266328
     /* 266328 */ GIM_Reject,
     /* 266329 */ // Label 5298: @266329
     /* 266329 */ GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(266401), // Rule ID 10481 //
     /* 266334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 266340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266344 */   // MIs[0] Operand 2
     /* 266344 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266355 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 266355 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266358 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 266362 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266367 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266372 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266375 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266379 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 266389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266397 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266399 */   GIR_RootConstrainSelectedInstOperands,
     /* 266400 */   // GIR_Coverage, 10481,
     /* 266400 */   GIR_EraseRootFromParent_Done,
     /* 266401 */ // Label 5327: @266401
     /* 266401 */ GIM_Reject,
     /* 266402 */ // Label 5299: @266402
     /* 266402 */ GIM_Reject,
     /* 266403 */ // Label 43: @266403
     /* 266403 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5332*/ GIMT_Encode4(269181),
     /* 266414 */ /*GILLT_s32*//*Label 5328*/ GIMT_Encode4(266450), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 266430 */ /*GILLT_v2s64*//*Label 5329*/ GIMT_Encode4(268251), GIMT_Encode4(0),
     /* 266438 */ /*GILLT_v4s32*//*Label 5330*/ GIMT_Encode4(268561), GIMT_Encode4(0),
     /* 266446 */ /*GILLT_v8s16*//*Label 5331*/ GIMT_Encode4(268871),
     /* 266450 */ // Label 5328: @266450
     /* 266450 */ GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(266600), // Rule ID 13112 //
     /* 266455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266462 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266466 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266470 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266473 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266478 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266482 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266489 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266489 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266492 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 266496 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266501 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266507 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266510 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266514 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266521 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266524 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266528 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266533 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266536 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266539 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266542 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266547 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266552 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266569 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266599 */   // GIR_Coverage, 13112,
     /* 266599 */   GIR_EraseRootFromParent_Done,
     /* 266600 */ // Label 5333: @266600
     /* 266600 */ GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(266750), // Rule ID 13114 //
     /* 266605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266612 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266620 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266623 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266628 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266632 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266637 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266639 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266639 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266642 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 266646 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266651 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266657 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266660 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266664 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266683 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266686 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266689 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266692 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266697 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266702 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266719 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266731 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266749 */   // GIR_Coverage, 13114,
     /* 266749 */   GIR_EraseRootFromParent_Done,
     /* 266750 */ // Label 5334: @266750
     /* 266750 */ GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(266900), // Rule ID 13116 //
     /* 266755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266762 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266770 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266773 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266778 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266782 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266787 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266789 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266789 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 266792 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 266796 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266801 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266807 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266810 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266814 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266821 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266824 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266828 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266833 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266836 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266839 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266842 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266847 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266852 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266857 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266860 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266864 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266869 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266876 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266881 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266899 */   // GIR_Coverage, 13116,
     /* 266899 */   GIR_EraseRootFromParent_Done,
     /* 266900 */ // Label 5335: @266900
     /* 266900 */ GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(267050), // Rule ID 13118 //
     /* 266905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266912 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266920 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266923 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266928 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266932 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266937 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266939 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266939 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 266942 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 266946 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266951 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266957 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266960 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266964 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266971 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266974 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266978 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266983 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266986 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266989 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266992 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266997 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267002 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267019 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267049 */   // GIR_Coverage, 13118,
     /* 267049 */   GIR_EraseRootFromParent_Done,
     /* 267050 */ // Label 5336: @267050
     /* 267050 */ GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(267200), // Rule ID 13145 //
     /* 267055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267062 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267066 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267070 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267073 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267078 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267089 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267089 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267092 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 267096 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267101 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267107 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267110 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267114 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267121 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267124 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267128 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267133 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267136 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267139 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267142 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267147 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267152 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267157 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267160 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267164 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267169 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267176 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267181 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267199 */   // GIR_Coverage, 13145,
     /* 267199 */   GIR_EraseRootFromParent_Done,
     /* 267200 */ // Label 5337: @267200
     /* 267200 */ GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(267350), // Rule ID 13147 //
     /* 267205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267212 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267220 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267223 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267228 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267232 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267239 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267239 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267242 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 267246 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267251 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267257 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267260 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267264 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267271 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267274 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267278 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267283 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267286 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267289 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267292 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267297 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267302 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267319 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267326 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267331 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267344 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267349 */   // GIR_Coverage, 13147,
     /* 267349 */   GIR_EraseRootFromParent_Done,
     /* 267350 */ // Label 5338: @267350
     /* 267350 */ GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(267500), // Rule ID 13149 //
     /* 267355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267362 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267370 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267373 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267378 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267382 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267389 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267389 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267392 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 267396 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267401 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267407 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267410 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267414 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267421 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267424 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267428 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267433 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267436 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267439 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267442 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267447 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267452 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267469 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267476 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267499 */   // GIR_Coverage, 13149,
     /* 267499 */   GIR_EraseRootFromParent_Done,
     /* 267500 */ // Label 5339: @267500
     /* 267500 */ GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(267650), // Rule ID 13151 //
     /* 267505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267512 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267520 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267523 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267528 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267532 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267537 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267539 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267539 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267542 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 267546 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267551 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267557 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267560 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267564 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267571 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267574 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267578 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267583 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267586 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267589 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267592 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267597 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267602 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267619 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267631 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267649 */   // GIR_Coverage, 13151,
     /* 267649 */   GIR_EraseRootFromParent_Done,
     /* 267650 */ // Label 5340: @267650
     /* 267650 */ GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(267800), // Rule ID 13155 //
     /* 267655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267662 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267666 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267670 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267673 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267678 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267682 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267687 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267689 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267689 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267692 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 267696 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267701 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267705 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267707 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267710 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267714 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267721 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267724 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267728 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267733 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267736 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267739 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267742 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267747 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267752 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267769 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267781 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267799 */   // GIR_Coverage, 13155,
     /* 267799 */   GIR_EraseRootFromParent_Done,
     /* 267800 */ // Label 5341: @267800
     /* 267800 */ GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(267950), // Rule ID 13157 //
     /* 267805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267812 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267820 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267823 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267828 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267832 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267837 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267839 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267839 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267842 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 267846 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267851 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267857 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267860 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267864 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267871 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267874 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267878 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267883 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267886 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267889 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267892 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267897 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267902 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267919 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267926 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267949 */   // GIR_Coverage, 13157,
     /* 267949 */   GIR_EraseRootFromParent_Done,
     /* 267950 */ // Label 5342: @267950
     /* 267950 */ GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(268100), // Rule ID 13159 //
     /* 267955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267962 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267966 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267970 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267973 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267978 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267982 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267987 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267989 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267989 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267992 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 267996 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268001 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268007 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268010 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268014 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268033 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268036 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268039 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 268042 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268047 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268052 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 268057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268069 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268094 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268099 */   // GIR_Coverage, 13159,
     /* 268099 */   GIR_EraseRootFromParent_Done,
     /* 268100 */ // Label 5343: @268100
     /* 268100 */ GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(268250), // Rule ID 13161 //
     /* 268105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 268108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268112 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268120 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268123 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 268128 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 268132 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268137 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268139 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268139 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 268142 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 268146 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268151 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268157 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268160 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268164 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268171 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268174 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268178 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268183 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268186 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268189 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 268192 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268197 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268202 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 268207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268219 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268226 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268249 */   // GIR_Coverage, 13161,
     /* 268249 */   GIR_EraseRootFromParent_Done,
     /* 268250 */ // Label 5344: @268250
     /* 268250 */ GIM_Reject,
     /* 268251 */ // Label 5329: @268251
     /* 268251 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(268560),
     /* 268256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 268259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268263 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(268328), // Rule ID 702 //
     /* 268268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268297 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268311 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 268311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 268314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268326 */     GIR_RootConstrainSelectedInstOperands,
     /* 268327 */     // GIR_Coverage, 702,
     /* 268327 */     GIR_EraseRootFromParent_Done,
     /* 268328 */   // Label 5346: @268328
     /* 268328 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(268393), // Rule ID 1711 //
     /* 268333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268344 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268347 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268376 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 268376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 268379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268391 */     GIR_RootConstrainSelectedInstOperands,
     /* 268392 */     // GIR_Coverage, 1711,
     /* 268392 */     GIR_EraseRootFromParent_Done,
     /* 268393 */   // Label 5347: @268393
     /* 268393 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(268452), // Rule ID 700 //
     /* 268398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268409 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268412 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268421 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268437 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 268437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 268440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268450 */     GIR_RootConstrainSelectedInstOperands,
     /* 268451 */     // GIR_Coverage, 700,
     /* 268451 */     GIR_EraseRootFromParent_Done,
     /* 268452 */   // Label 5348: @268452
     /* 268452 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(268511), // Rule ID 1709 //
     /* 268457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268496 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 268496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 268499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268509 */     GIR_RootConstrainSelectedInstOperands,
     /* 268510 */     // GIR_Coverage, 1709,
     /* 268510 */     GIR_EraseRootFromParent_Done,
     /* 268511 */   // Label 5349: @268511
     /* 268511 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(268538), // Rule ID 6366 //
     /* 268516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268523 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 268523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 268526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268536 */     GIR_RootConstrainSelectedInstOperands,
     /* 268537 */     // GIR_Coverage, 6366,
     /* 268537 */     GIR_EraseRootFromParent_Done,
     /* 268538 */   // Label 5350: @268538
     /* 268538 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(268559), // Rule ID 6357 //
     /* 268543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268547 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 268547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 268550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268557 */     GIR_RootConstrainSelectedInstOperands,
     /* 268558 */     // GIR_Coverage, 6357,
     /* 268558 */     GIR_EraseRootFromParent_Done,
     /* 268559 */   // Label 5351: @268559
     /* 268559 */   GIM_Reject,
     /* 268560 */ // Label 5345: @268560
     /* 268560 */ GIM_Reject,
     /* 268561 */ // Label 5330: @268561
     /* 268561 */ GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(268870),
     /* 268566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 268569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268573 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(268638), // Rule ID 698 //
     /* 268578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268589 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268592 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268601 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268621 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 268624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268636 */     GIR_RootConstrainSelectedInstOperands,
     /* 268637 */     // GIR_Coverage, 698,
     /* 268637 */     GIR_EraseRootFromParent_Done,
     /* 268638 */   // Label 5353: @268638
     /* 268638 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(268703), // Rule ID 1707 //
     /* 268643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268654 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268657 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268666 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268686 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 268689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268701 */     GIR_RootConstrainSelectedInstOperands,
     /* 268702 */     // GIR_Coverage, 1707,
     /* 268702 */     GIR_EraseRootFromParent_Done,
     /* 268703 */   // Label 5354: @268703
     /* 268703 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(268762), // Rule ID 696 //
     /* 268708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268719 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268722 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268731 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268747 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 268750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268760 */     GIR_RootConstrainSelectedInstOperands,
     /* 268761 */     // GIR_Coverage, 696,
     /* 268761 */     GIR_EraseRootFromParent_Done,
     /* 268762 */   // Label 5355: @268762
     /* 268762 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(268821), // Rule ID 1705 //
     /* 268767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268778 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268781 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268790 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268806 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 268809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268819 */     GIR_RootConstrainSelectedInstOperands,
     /* 268820 */     // GIR_Coverage, 1705,
     /* 268820 */     GIR_EraseRootFromParent_Done,
     /* 268821 */   // Label 5356: @268821
     /* 268821 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(268848), // Rule ID 6363 //
     /* 268826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268833 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 268833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 268836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268846 */     GIR_RootConstrainSelectedInstOperands,
     /* 268847 */     // GIR_Coverage, 6363,
     /* 268847 */     GIR_EraseRootFromParent_Done,
     /* 268848 */   // Label 5357: @268848
     /* 268848 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(268869), // Rule ID 6354 //
     /* 268853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268857 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 268857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 268860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268867 */     GIR_RootConstrainSelectedInstOperands,
     /* 268868 */     // GIR_Coverage, 6354,
     /* 268868 */     GIR_EraseRootFromParent_Done,
     /* 268869 */   // Label 5358: @268869
     /* 268869 */   GIM_Reject,
     /* 268870 */ // Label 5352: @268870
     /* 268870 */ GIM_Reject,
     /* 268871 */ // Label 5331: @268871
     /* 268871 */ GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(269180),
     /* 268876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 268879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268883 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(268948), // Rule ID 694 //
     /* 268888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268911 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268931 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 268934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268946 */     GIR_RootConstrainSelectedInstOperands,
     /* 268947 */     // GIR_Coverage, 694,
     /* 268947 */     GIR_EraseRootFromParent_Done,
     /* 268948 */   // Label 5360: @268948
     /* 268948 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(269013), // Rule ID 1703 //
     /* 268953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268964 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268967 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268976 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268996 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 268999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269011 */     GIR_RootConstrainSelectedInstOperands,
     /* 269012 */     // GIR_Coverage, 1703,
     /* 269012 */     GIR_EraseRootFromParent_Done,
     /* 269013 */   // Label 5361: @269013
     /* 269013 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(269072), // Rule ID 692 //
     /* 269018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269029 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269032 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269041 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269057 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 269060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269070 */     GIR_RootConstrainSelectedInstOperands,
     /* 269071 */     // GIR_Coverage, 692,
     /* 269071 */     GIR_EraseRootFromParent_Done,
     /* 269072 */   // Label 5362: @269072
     /* 269072 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(269131), // Rule ID 1701 //
     /* 269077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269088 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269091 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269100 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269116 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 269119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269129 */     GIR_RootConstrainSelectedInstOperands,
     /* 269130 */     // GIR_Coverage, 1701,
     /* 269130 */     GIR_EraseRootFromParent_Done,
     /* 269131 */   // Label 5363: @269131
     /* 269131 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(269158), // Rule ID 6360 //
     /* 269136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269143 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 269143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 269146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269156 */     GIR_RootConstrainSelectedInstOperands,
     /* 269157 */     // GIR_Coverage, 6360,
     /* 269157 */     GIR_EraseRootFromParent_Done,
     /* 269158 */   // Label 5364: @269158
     /* 269158 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(269179), // Rule ID 6351 //
     /* 269163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269167 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 269167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 269170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269177 */     GIR_RootConstrainSelectedInstOperands,
     /* 269178 */     // GIR_Coverage, 6351,
     /* 269178 */     GIR_EraseRootFromParent_Done,
     /* 269179 */   // Label 5365: @269179
     /* 269179 */   GIM_Reject,
     /* 269180 */ // Label 5359: @269180
     /* 269180 */ GIM_Reject,
     /* 269181 */ // Label 5332: @269181
     /* 269181 */ GIM_Reject,
     /* 269182 */ // Label 44: @269182
     /* 269182 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5371*/ GIMT_Encode4(269961),
     /* 269193 */ /*GILLT_s32*//*Label 5366*/ GIMT_Encode4(269229),
     /* 269197 */ /*GILLT_s64*//*Label 5367*/ GIMT_Encode4(269361), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 269209 */ /*GILLT_v2s64*//*Label 5368*/ GIMT_Encode4(269534), GIMT_Encode4(0),
     /* 269217 */ /*GILLT_v4s32*//*Label 5369*/ GIMT_Encode4(269679), GIMT_Encode4(0),
     /* 269225 */ /*GILLT_v8s16*//*Label 5370*/ GIMT_Encode4(269820),
     /* 269229 */ // Label 5366: @269229
     /* 269229 */ GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(269360),
     /* 269234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 269237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269248 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(269285), // Rule ID 3935 //
     /* 269253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 269261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269272 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269283 */     GIR_RootConstrainSelectedInstOperands,
     /* 269284 */     // GIR_Coverage, 3935,
     /* 269284 */     GIR_EraseRootFromParent_Done,
     /* 269285 */   // Label 5373: @269285
     /* 269285 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(269322), // Rule ID 3936 //
     /* 269290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269309 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269320 */     GIR_RootConstrainSelectedInstOperands,
     /* 269321 */     // GIR_Coverage, 3936,
     /* 269321 */     GIR_EraseRootFromParent_Done,
     /* 269322 */   // Label 5374: @269322
     /* 269322 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(269359), // Rule ID 3934 //
     /* 269327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269346 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269357 */     GIR_RootConstrainSelectedInstOperands,
     /* 269358 */     // GIR_Coverage, 3934,
     /* 269358 */     GIR_EraseRootFromParent_Done,
     /* 269359 */   // Label 5375: @269359
     /* 269359 */   GIM_Reject,
     /* 269360 */ // Label 5372: @269360
     /* 269360 */ GIM_Reject,
     /* 269361 */ // Label 5367: @269361
     /* 269361 */ GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(269533),
     /* 269366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269380 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(269448), // Rule ID 3937 //
     /* 269385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269404 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269416 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269423 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269446 */     GIR_RootConstrainSelectedInstOperands,
     /* 269447 */     // GIR_Coverage, 3937,
     /* 269447 */     GIR_EraseRootFromParent_Done,
     /* 269448 */   // Label 5377: @269448
     /* 269448 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(269516), // Rule ID 3938 //
     /* 269453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269472 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269487 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269514 */     GIR_RootConstrainSelectedInstOperands,
     /* 269515 */     // GIR_Coverage, 3938,
     /* 269515 */     GIR_EraseRootFromParent_Done,
     /* 269516 */   // Label 5378: @269516
     /* 269516 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(269532), // Rule ID 120 //
     /* 269521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269525 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269530 */     GIR_RootConstrainSelectedInstOperands,
     /* 269531 */     // GIR_Coverage, 120,
     /* 269531 */     GIR_Done,
     /* 269532 */   // Label 5379: @269532
     /* 269532 */   GIM_Reject,
     /* 269533 */ // Label 5376: @269533
     /* 269533 */ GIM_Reject,
     /* 269534 */ // Label 5368: @269534
     /* 269534 */ GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(269678),
     /* 269539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 269542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 269545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269549 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(269613), // Rule ID 6349 //
     /* 269554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 269583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269591 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269595 */     // MIs[3] Operand 1
     /* 269595 */     // No operand predicates
     /* 269595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269597 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 269597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 269600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269606 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 269611 */     GIR_RootConstrainSelectedInstOperands,
     /* 269612 */     // GIR_Coverage, 6349,
     /* 269612 */     GIR_EraseRootFromParent_Done,
     /* 269613 */   // Label 5381: @269613
     /* 269613 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(269677), // Rule ID 6346 //
     /* 269618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 269647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269655 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269659 */     // MIs[3] Operand 1
     /* 269659 */     // No operand predicates
     /* 269659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269661 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 269661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 269664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269670 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 269675 */     GIR_RootConstrainSelectedInstOperands,
     /* 269676 */     // GIR_Coverage, 6346,
     /* 269676 */     GIR_EraseRootFromParent_Done,
     /* 269677 */   // Label 5382: @269677
     /* 269677 */   GIM_Reject,
     /* 269678 */ // Label 5380: @269678
     /* 269678 */ GIM_Reject,
     /* 269679 */ // Label 5369: @269679
     /* 269679 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(269819),
     /* 269684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 269687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269694 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(269756), // Rule ID 6348 //
     /* 269699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 269711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269736 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 269740 */     // MIs[3] Operand 1
     /* 269740 */     // No operand predicates
     /* 269740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269742 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 269742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 269745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269754 */     GIR_RootConstrainSelectedInstOperands,
     /* 269755 */     // GIR_Coverage, 6348,
     /* 269755 */     GIR_EraseRootFromParent_Done,
     /* 269756 */   // Label 5384: @269756
     /* 269756 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(269818), // Rule ID 6345 //
     /* 269761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 269773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 269802 */     // MIs[3] Operand 1
     /* 269802 */     // No operand predicates
     /* 269802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269804 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 269804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 269807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269816 */     GIR_RootConstrainSelectedInstOperands,
     /* 269817 */     // GIR_Coverage, 6345,
     /* 269817 */     GIR_EraseRootFromParent_Done,
     /* 269818 */   // Label 5385: @269818
     /* 269818 */   GIM_Reject,
     /* 269819 */ // Label 5383: @269819
     /* 269819 */ GIM_Reject,
     /* 269820 */ // Label 5370: @269820
     /* 269820 */ GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(269960),
     /* 269825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 269828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269835 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(269897), // Rule ID 6347 //
     /* 269840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 269852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269877 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 269881 */     // MIs[3] Operand 1
     /* 269881 */     // No operand predicates
     /* 269881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269883 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 269883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 269886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269895 */     GIR_RootConstrainSelectedInstOperands,
     /* 269896 */     // GIR_Coverage, 6347,
     /* 269896 */     GIR_EraseRootFromParent_Done,
     /* 269897 */   // Label 5387: @269897
     /* 269897 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(269959), // Rule ID 6344 //
     /* 269902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 269914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269939 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 269943 */     // MIs[3] Operand 1
     /* 269943 */     // No operand predicates
     /* 269943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269945 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 269945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 269948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269957 */     GIR_RootConstrainSelectedInstOperands,
     /* 269958 */     // GIR_Coverage, 6344,
     /* 269958 */     GIR_EraseRootFromParent_Done,
     /* 269959 */   // Label 5388: @269959
     /* 269959 */   GIM_Reject,
     /* 269960 */ // Label 5386: @269960
     /* 269960 */ GIM_Reject,
     /* 269961 */ // Label 5371: @269961
     /* 269961 */ GIM_Reject,
     /* 269962 */ // Label 45: @269962
     /* 269962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5391*/ GIMT_Encode4(270354),
     /* 269973 */ /*GILLT_s32*//*Label 5389*/ GIMT_Encode4(269981),
     /* 269977 */ /*GILLT_s64*//*Label 5390*/ GIMT_Encode4(270147),
     /* 269981 */ // Label 5389: @269981
     /* 269981 */ GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(270146),
     /* 269986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 269989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270000 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(270034), // Rule ID 4024 //
     /* 270005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270017 */     // MIs[1] Operand 1
     /* 270017 */     // No operand predicates
     /* 270017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270019 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 270022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270032 */     GIR_RootConstrainSelectedInstOperands,
     /* 270033 */     // GIR_Coverage, 4024,
     /* 270033 */     GIR_EraseRootFromParent_Done,
     /* 270034 */   // Label 5393: @270034
     /* 270034 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(270071), // Rule ID 3941 //
     /* 270039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270058 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 270061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270069 */     GIR_RootConstrainSelectedInstOperands,
     /* 270070 */     // GIR_Coverage, 3941,
     /* 270070 */     GIR_EraseRootFromParent_Done,
     /* 270071 */   // Label 5394: @270071
     /* 270071 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(270108), // Rule ID 3942 //
     /* 270076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270095 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 270098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270106 */     GIR_RootConstrainSelectedInstOperands,
     /* 270107 */     // GIR_Coverage, 3942,
     /* 270107 */     GIR_EraseRootFromParent_Done,
     /* 270108 */   // Label 5395: @270108
     /* 270108 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(270145), // Rule ID 3940 //
     /* 270113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270132 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 270135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270143 */     GIR_RootConstrainSelectedInstOperands,
     /* 270144 */     // GIR_Coverage, 3940,
     /* 270144 */     GIR_EraseRootFromParent_Done,
     /* 270145 */   // Label 5396: @270145
     /* 270145 */   GIM_Reject,
     /* 270146 */ // Label 5392: @270146
     /* 270146 */ GIM_Reject,
     /* 270147 */ // Label 5390: @270147
     /* 270147 */ GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(270353),
     /* 270152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270166 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(270200), // Rule ID 4025 //
     /* 270171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 270183 */     // MIs[1] Operand 1
     /* 270183 */     // No operand predicates
     /* 270183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270185 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 270185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 270188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 270198 */     GIR_RootConstrainSelectedInstOperands,
     /* 270199 */     // GIR_Coverage, 4025,
     /* 270199 */     GIR_EraseRootFromParent_Done,
     /* 270200 */   // Label 5398: @270200
     /* 270200 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(270268), // Rule ID 3943 //
     /* 270205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270224 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270266 */     GIR_RootConstrainSelectedInstOperands,
     /* 270267 */     // GIR_Coverage, 3943,
     /* 270267 */     GIR_EraseRootFromParent_Done,
     /* 270268 */   // Label 5399: @270268
     /* 270268 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(270336), // Rule ID 3944 //
     /* 270273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270292 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270334 */     GIR_RootConstrainSelectedInstOperands,
     /* 270335 */     // GIR_Coverage, 3944,
     /* 270335 */     GIR_EraseRootFromParent_Done,
     /* 270336 */   // Label 5400: @270336
     /* 270336 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(270352), // Rule ID 121 //
     /* 270341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270345 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270350 */     GIR_RootConstrainSelectedInstOperands,
     /* 270351 */     // GIR_Coverage, 121,
     /* 270351 */     GIR_Done,
     /* 270352 */   // Label 5401: @270352
     /* 270352 */   GIM_Reject,
     /* 270353 */ // Label 5397: @270353
     /* 270353 */ GIM_Reject,
     /* 270354 */ // Label 5391: @270354
     /* 270354 */ GIM_Reject,
     /* 270355 */ // Label 46: @270355
     /* 270355 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5404*/ GIMT_Encode4(271130),
     /* 270366 */ /*GILLT_s32*//*Label 5402*/ GIMT_Encode4(270374),
     /* 270370 */ /*GILLT_s64*//*Label 5403*/ GIMT_Encode4(270680),
     /* 270374 */ // Label 5402: @270374
     /* 270374 */ GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(270679),
     /* 270379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270389 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(270453), // Rule ID 6509 //
     /* 270394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270411 */     // MIs[1] Operand 2
     /* 270411 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 270422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270430 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 270434 */     // MIs[2] Operand 1
     /* 270434 */     // No operand predicates
     /* 270434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270436 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 270436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 270451 */     GIR_RootConstrainSelectedInstOperands,
     /* 270452 */     // GIR_Coverage, 6509,
     /* 270452 */     GIR_EraseRootFromParent_Done,
     /* 270453 */   // Label 5406: @270453
     /* 270453 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(270517), // Rule ID 6511 //
     /* 270458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270475 */     // MIs[1] Operand 2
     /* 270475 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 270486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270494 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 270498 */     // MIs[2] Operand 1
     /* 270498 */     // No operand predicates
     /* 270498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270500 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 270500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 270515 */     GIR_RootConstrainSelectedInstOperands,
     /* 270516 */     // GIR_Coverage, 6511,
     /* 270516 */     GIR_EraseRootFromParent_Done,
     /* 270517 */   // Label 5407: @270517
     /* 270517 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(270555), // Rule ID 4022 //
     /* 270522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270538 */     // MIs[1] Operand 1
     /* 270538 */     // No operand predicates
     /* 270538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270540 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270553 */     GIR_RootConstrainSelectedInstOperands,
     /* 270554 */     // GIR_Coverage, 4022,
     /* 270554 */     GIR_EraseRootFromParent_Done,
     /* 270555 */   // Label 5408: @270555
     /* 270555 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(270596), // Rule ID 2435 //
     /* 270560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270583 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270594 */     GIR_RootConstrainSelectedInstOperands,
     /* 270595 */     // GIR_Coverage, 2435,
     /* 270595 */     GIR_EraseRootFromParent_Done,
     /* 270596 */   // Label 5409: @270596
     /* 270596 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(270637), // Rule ID 2436 //
     /* 270601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270624 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270635 */     GIR_RootConstrainSelectedInstOperands,
     /* 270636 */     // GIR_Coverage, 2436,
     /* 270636 */     GIR_EraseRootFromParent_Done,
     /* 270637 */   // Label 5410: @270637
     /* 270637 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(270678), // Rule ID 2434 //
     /* 270642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270665 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270676 */     GIR_RootConstrainSelectedInstOperands,
     /* 270677 */     // GIR_Coverage, 2434,
     /* 270677 */     GIR_EraseRootFromParent_Done,
     /* 270678 */   // Label 5411: @270678
     /* 270678 */   GIM_Reject,
     /* 270679 */ // Label 5405: @270679
     /* 270679 */ GIM_Reject,
     /* 270680 */ // Label 5403: @270680
     /* 270680 */ GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(271129),
     /* 270685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270695 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(270759), // Rule ID 6510 //
     /* 270700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270717 */     // MIs[1] Operand 2
     /* 270717 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 270728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270736 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 270740 */     // MIs[2] Operand 1
     /* 270740 */     // No operand predicates
     /* 270740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270742 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 270742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 270757 */     GIR_RootConstrainSelectedInstOperands,
     /* 270758 */     // GIR_Coverage, 6510,
     /* 270758 */     GIR_EraseRootFromParent_Done,
     /* 270759 */   // Label 5413: @270759
     /* 270759 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(270823), // Rule ID 6512 //
     /* 270764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270781 */     // MIs[1] Operand 2
     /* 270781 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 270792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270800 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 270804 */     // MIs[2] Operand 1
     /* 270804 */     // No operand predicates
     /* 270804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270806 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 270806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 270821 */     GIR_RootConstrainSelectedInstOperands,
     /* 270822 */     // GIR_Coverage, 6512,
     /* 270822 */     GIR_EraseRootFromParent_Done,
     /* 270823 */   // Label 5414: @270823
     /* 270823 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(270926), // Rule ID 6513 //
     /* 270828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270857 */     // MIs[2] Operand 1
     /* 270857 */     // No operand predicates
     /* 270857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270859 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 270873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270924 */     GIR_RootConstrainSelectedInstOperands,
     /* 270925 */     // GIR_Coverage, 6513,
     /* 270925 */     GIR_EraseRootFromParent_Done,
     /* 270926 */   // Label 5415: @270926
     /* 270926 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(270964), // Rule ID 4023 //
     /* 270931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 270947 */     // MIs[1] Operand 1
     /* 270947 */     // No operand predicates
     /* 270947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270949 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 270949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 270962 */     GIR_RootConstrainSelectedInstOperands,
     /* 270963 */     // GIR_Coverage, 4023,
     /* 270963 */     GIR_EraseRootFromParent_Done,
     /* 270964 */   // Label 5416: @270964
     /* 270964 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(271036), // Rule ID 2437 //
     /* 270969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270992 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271004 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271011 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 271027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271034 */     GIR_RootConstrainSelectedInstOperands,
     /* 271035 */     // GIR_Coverage, 2437,
     /* 271035 */     GIR_EraseRootFromParent_Done,
     /* 271036 */   // Label 5417: @271036
     /* 271036 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(271108), // Rule ID 2438 //
     /* 271041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271064 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271083 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 271099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271106 */     GIR_RootConstrainSelectedInstOperands,
     /* 271107 */     // GIR_Coverage, 2438,
     /* 271107 */     GIR_EraseRootFromParent_Done,
     /* 271108 */   // Label 5418: @271108
     /* 271108 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(271128), // Rule ID 119 //
     /* 271113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271121 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 271126 */     GIR_RootConstrainSelectedInstOperands,
     /* 271127 */     // GIR_Coverage, 119,
     /* 271127 */     GIR_Done,
     /* 271128 */   // Label 5419: @271128
     /* 271128 */   GIM_Reject,
     /* 271129 */ // Label 5412: @271129
     /* 271129 */ GIM_Reject,
     /* 271130 */ // Label 5404: @271130
     /* 271130 */ GIM_Reject,
     /* 271131 */ // Label 47: @271131
     /* 271131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5422*/ GIMT_Encode4(271260),
     /* 271142 */ /*GILLT_s32*//*Label 5420*/ GIMT_Encode4(271150),
     /* 271146 */ /*GILLT_s64*//*Label 5421*/ GIMT_Encode4(271205),
     /* 271150 */ // Label 5420: @271150
     /* 271150 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(271204), // Rule ID 188 //
     /* 271155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 271161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271176 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271180 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271184 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271188 */   // MIs[1] Operand 1
     /* 271188 */   // No operand predicates
     /* 271188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271190 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 271190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 271193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271195 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271197 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 271199 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271202 */   GIR_RootConstrainSelectedInstOperands,
     /* 271203 */   // GIR_Coverage, 188,
     /* 271203 */   GIR_EraseRootFromParent_Done,
     /* 271204 */ // Label 5423: @271204
     /* 271204 */ GIM_Reject,
     /* 271205 */ // Label 5421: @271205
     /* 271205 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(271259), // Rule ID 189 //
     /* 271210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271239 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271243 */   // MIs[1] Operand 1
     /* 271243 */   // No operand predicates
     /* 271243 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271245 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 271245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 271248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271250 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271252 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 271254 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271257 */   GIR_RootConstrainSelectedInstOperands,
     /* 271258 */   // GIR_Coverage, 189,
     /* 271258 */   GIR_EraseRootFromParent_Done,
     /* 271259 */ // Label 5424: @271259
     /* 271259 */ GIM_Reject,
     /* 271260 */ // Label 5422: @271260
     /* 271260 */ GIM_Reject,
     /* 271261 */ // Label 48: @271261
     /* 271261 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5427*/ GIMT_Encode4(271753),
     /* 271272 */ /*GILLT_s32*//*Label 5425*/ GIMT_Encode4(271280),
     /* 271276 */ /*GILLT_s64*//*Label 5426*/ GIMT_Encode4(271496),
     /* 271280 */ // Label 5425: @271280
     /* 271280 */ GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(271495),
     /* 271285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271295 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(271334), // Rule ID 184 //
     /* 271300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 271308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 271321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271323 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 271323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 271326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271332 */     GIR_RootConstrainSelectedInstOperands,
     /* 271333 */     // GIR_Coverage, 184,
     /* 271333 */     GIR_EraseRootFromParent_Done,
     /* 271334 */   // Label 5429: @271334
     /* 271334 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(271371), // Rule ID 4018 //
     /* 271339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271355 */     // MIs[1] Operand 1
     /* 271355 */     // No operand predicates
     /* 271355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271357 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 271360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271369 */     GIR_RootConstrainSelectedInstOperands,
     /* 271370 */     // GIR_Coverage, 4018,
     /* 271370 */     GIR_EraseRootFromParent_Done,
     /* 271371 */   // Label 5430: @271371
     /* 271371 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(271412), // Rule ID 3947 //
     /* 271376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 271388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271399 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271410 */     GIR_RootConstrainSelectedInstOperands,
     /* 271411 */     // GIR_Coverage, 3947,
     /* 271411 */     GIR_EraseRootFromParent_Done,
     /* 271412 */   // Label 5431: @271412
     /* 271412 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(271453), // Rule ID 3948 //
     /* 271417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271440 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271451 */     GIR_RootConstrainSelectedInstOperands,
     /* 271452 */     // GIR_Coverage, 3948,
     /* 271452 */     GIR_EraseRootFromParent_Done,
     /* 271453 */   // Label 5432: @271453
     /* 271453 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(271494), // Rule ID 3946 //
     /* 271458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271481 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271492 */     GIR_RootConstrainSelectedInstOperands,
     /* 271493 */     // GIR_Coverage, 3946,
     /* 271493 */     GIR_EraseRootFromParent_Done,
     /* 271494 */   // Label 5433: @271494
     /* 271494 */   GIM_Reject,
     /* 271495 */ // Label 5428: @271495
     /* 271495 */ GIM_Reject,
     /* 271496 */ // Label 5426: @271496
     /* 271496 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271752),
     /* 271501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271511 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(271550), // Rule ID 187 //
     /* 271516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 271524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 271537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271539 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 271539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 271542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271548 */     GIR_RootConstrainSelectedInstOperands,
     /* 271549 */     // GIR_Coverage, 187,
     /* 271549 */     GIR_EraseRootFromParent_Done,
     /* 271550 */   // Label 5435: @271550
     /* 271550 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(271587), // Rule ID 4019 //
     /* 271555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271571 */     // MIs[1] Operand 1
     /* 271571 */     // No operand predicates
     /* 271571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271573 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 271573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 271576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271585 */     GIR_RootConstrainSelectedInstOperands,
     /* 271586 */     // GIR_Coverage, 4019,
     /* 271586 */     GIR_EraseRootFromParent_Done,
     /* 271587 */   // Label 5436: @271587
     /* 271587 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(271659), // Rule ID 3949 //
     /* 271592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271615 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271634 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271657 */     GIR_RootConstrainSelectedInstOperands,
     /* 271658 */     // GIR_Coverage, 3949,
     /* 271658 */     GIR_EraseRootFromParent_Done,
     /* 271659 */   // Label 5437: @271659
     /* 271659 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(271731), // Rule ID 3950 //
     /* 271664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271687 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271699 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271702 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271706 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271729 */     GIR_RootConstrainSelectedInstOperands,
     /* 271730 */     // GIR_Coverage, 3950,
     /* 271730 */     GIR_EraseRootFromParent_Done,
     /* 271731 */   // Label 5438: @271731
     /* 271731 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(271751), // Rule ID 122 //
     /* 271736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271744 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271749 */     GIR_RootConstrainSelectedInstOperands,
     /* 271750 */     // GIR_Coverage, 122,
     /* 271750 */     GIR_Done,
     /* 271751 */   // Label 5439: @271751
     /* 271751 */   GIM_Reject,
     /* 271752 */ // Label 5434: @271752
     /* 271752 */ GIM_Reject,
     /* 271753 */ // Label 5427: @271753
     /* 271753 */ GIM_Reject,
     /* 271754 */ // Label 49: @271754
     /* 271754 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5448*/ GIMT_Encode4(279530),
     /* 271765 */ /*GILLT_s64*//*Label 5440*/ GIMT_Encode4(271801), GIMT_Encode4(0),
     /* 271773 */ /*GILLT_v2s32*//*Label 5441*/ GIMT_Encode4(272194),
     /* 271777 */ /*GILLT_v2s64*//*Label 5442*/ GIMT_Encode4(273242),
     /* 271781 */ /*GILLT_v4s16*//*Label 5443*/ GIMT_Encode4(274290),
     /* 271785 */ /*GILLT_v4s32*//*Label 5444*/ GIMT_Encode4(275338),
     /* 271789 */ /*GILLT_v8s8*//*Label 5445*/ GIMT_Encode4(276386),
     /* 271793 */ /*GILLT_v8s16*//*Label 5446*/ GIMT_Encode4(277434),
     /* 271797 */ /*GILLT_v16s8*//*Label 5447*/ GIMT_Encode4(278482),
     /* 271801 */ // Label 5440: @271801
     /* 271801 */ GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(272193),
     /* 271806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271809 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271816 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(271852), // Rule ID 5242 //
     /* 271821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271824 */     // MIs[0] Operand 1
     /* 271824 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271833 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271839 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271843 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 271846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271850 */     GIR_RootConstrainSelectedInstOperands,
     /* 271851 */     // GIR_Coverage, 5242,
     /* 271851 */     GIR_EraseRootFromParent_Done,
     /* 271852 */   // Label 5450: @271852
     /* 271852 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(271888), // Rule ID 5243 //
     /* 271857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271860 */     // MIs[0] Operand 1
     /* 271860 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271869 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271875 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271879 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 271882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271886 */     GIR_RootConstrainSelectedInstOperands,
     /* 271887 */     // GIR_Coverage, 5243,
     /* 271887 */     GIR_EraseRootFromParent_Done,
     /* 271888 */   // Label 5451: @271888
     /* 271888 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(271924), // Rule ID 2512 //
     /* 271893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271896 */     // MIs[0] Operand 1
     /* 271896 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271905 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271911 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271915 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 271918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271922 */     GIR_RootConstrainSelectedInstOperands,
     /* 271923 */     // GIR_Coverage, 2512,
     /* 271923 */     GIR_EraseRootFromParent_Done,
     /* 271924 */   // Label 5452: @271924
     /* 271924 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(271960), // Rule ID 5239 //
     /* 271929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271932 */     // MIs[0] Operand 1
     /* 271932 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271941 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271947 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271951 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 271954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271958 */     GIR_RootConstrainSelectedInstOperands,
     /* 271959 */     // GIR_Coverage, 5239,
     /* 271959 */     GIR_EraseRootFromParent_Done,
     /* 271960 */   // Label 5453: @271960
     /* 271960 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(271996), // Rule ID 5240 //
     /* 271965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271968 */     // MIs[0] Operand 1
     /* 271968 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271977 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 271985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271987 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 271990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271994 */     GIR_RootConstrainSelectedInstOperands,
     /* 271995 */     // GIR_Coverage, 5240,
     /* 271995 */     GIR_EraseRootFromParent_Done,
     /* 271996 */   // Label 5454: @271996
     /* 271996 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(272032), // Rule ID 5241 //
     /* 272001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272004 */     // MIs[0] Operand 1
     /* 272004 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272013 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272019 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272023 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 272026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272030 */     GIR_RootConstrainSelectedInstOperands,
     /* 272031 */     // GIR_Coverage, 5241,
     /* 272031 */     GIR_EraseRootFromParent_Done,
     /* 272032 */   // Label 5455: @272032
     /* 272032 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(272064), // Rule ID 1608 //
     /* 272037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272040 */     // MIs[0] Operand 1
     /* 272040 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272053 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 272056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272062 */     GIR_RootConstrainSelectedInstOperands,
     /* 272063 */     // GIR_Coverage, 1608,
     /* 272063 */     GIR_EraseRootFromParent_Done,
     /* 272064 */   // Label 5456: @272064
     /* 272064 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(272096), // Rule ID 1609 //
     /* 272069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272072 */     // MIs[0] Operand 1
     /* 272072 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272085 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 272088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272094 */     GIR_RootConstrainSelectedInstOperands,
     /* 272095 */     // GIR_Coverage, 1609,
     /* 272095 */     GIR_EraseRootFromParent_Done,
     /* 272096 */   // Label 5457: @272096
     /* 272096 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(272128), // Rule ID 1610 //
     /* 272101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272104 */     // MIs[0] Operand 1
     /* 272104 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272117 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 272120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272126 */     GIR_RootConstrainSelectedInstOperands,
     /* 272127 */     // GIR_Coverage, 1610,
     /* 272127 */     GIR_EraseRootFromParent_Done,
     /* 272128 */   // Label 5458: @272128
     /* 272128 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(272160), // Rule ID 1611 //
     /* 272133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272136 */     // MIs[0] Operand 1
     /* 272136 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 272141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272149 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 272152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272158 */     GIR_RootConstrainSelectedInstOperands,
     /* 272159 */     // GIR_Coverage, 1611,
     /* 272159 */     GIR_EraseRootFromParent_Done,
     /* 272160 */   // Label 5459: @272160
     /* 272160 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(272192), // Rule ID 1612 //
     /* 272165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272168 */     // MIs[0] Operand 1
     /* 272168 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 272173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272181 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 272184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272190 */     GIR_RootConstrainSelectedInstOperands,
     /* 272191 */     // GIR_Coverage, 1612,
     /* 272191 */     GIR_EraseRootFromParent_Done,
     /* 272192 */   // Label 5460: @272192
     /* 272192 */   GIM_Reject,
     /* 272193 */ // Label 5449: @272193
     /* 272193 */ GIM_Reject,
     /* 272194 */ // Label 5441: @272194
     /* 272194 */ GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(273241),
     /* 272199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 272202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 272205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272209 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(272249), // Rule ID 754 //
     /* 272214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272217 */     // MIs[0] Operand 1
     /* 272217 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272226 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272232 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272240 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272247 */     GIR_RootConstrainSelectedInstOperands,
     /* 272248 */     // GIR_Coverage, 754,
     /* 272248 */     GIR_EraseRootFromParent_Done,
     /* 272249 */   // Label 5462: @272249
     /* 272249 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(272289), // Rule ID 761 //
     /* 272254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272257 */     // MIs[0] Operand 1
     /* 272257 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272266 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272272 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272280 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272287 */     GIR_RootConstrainSelectedInstOperands,
     /* 272288 */     // GIR_Coverage, 761,
     /* 272288 */     GIR_EraseRootFromParent_Done,
     /* 272289 */   // Label 5463: @272289
     /* 272289 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(272326), // Rule ID 5176 //
     /* 272294 */     // MIs[0] Operand 1
     /* 272294 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272303 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272309 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272317 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272324 */     GIR_RootConstrainSelectedInstOperands,
     /* 272325 */     // GIR_Coverage, 5176,
     /* 272325 */     GIR_EraseRootFromParent_Done,
     /* 272326 */   // Label 5464: @272326
     /* 272326 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(272363), // Rule ID 5183 //
     /* 272331 */     // MIs[0] Operand 1
     /* 272331 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272340 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272346 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272354 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272361 */     GIR_RootConstrainSelectedInstOperands,
     /* 272362 */     // GIR_Coverage, 5183,
     /* 272362 */     GIR_EraseRootFromParent_Done,
     /* 272363 */   // Label 5465: @272363
     /* 272363 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(272400), // Rule ID 5190 //
     /* 272368 */     // MIs[0] Operand 1
     /* 272368 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272383 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272391 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272398 */     GIR_RootConstrainSelectedInstOperands,
     /* 272399 */     // GIR_Coverage, 5190,
     /* 272399 */     GIR_EraseRootFromParent_Done,
     /* 272400 */   // Label 5466: @272400
     /* 272400 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(272437), // Rule ID 5197 //
     /* 272405 */     // MIs[0] Operand 1
     /* 272405 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272414 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272420 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272428 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272435 */     GIR_RootConstrainSelectedInstOperands,
     /* 272436 */     // GIR_Coverage, 5197,
     /* 272436 */     GIR_EraseRootFromParent_Done,
     /* 272437 */   // Label 5467: @272437
     /* 272437 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(272474), // Rule ID 5204 //
     /* 272442 */     // MIs[0] Operand 1
     /* 272442 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272457 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272465 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272472 */     GIR_RootConstrainSelectedInstOperands,
     /* 272473 */     // GIR_Coverage, 5204,
     /* 272473 */     GIR_EraseRootFromParent_Done,
     /* 272474 */   // Label 5468: @272474
     /* 272474 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(272514), // Rule ID 726 //
     /* 272479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272482 */     // MIs[0] Operand 1
     /* 272482 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272495 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272501 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272505 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272512 */     GIR_RootConstrainSelectedInstOperands,
     /* 272513 */     // GIR_Coverage, 726,
     /* 272513 */     GIR_EraseRootFromParent_Done,
     /* 272514 */   // Label 5469: @272514
     /* 272514 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(272554), // Rule ID 737 //
     /* 272519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272522 */     // MIs[0] Operand 1
     /* 272522 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272535 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272541 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272545 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272552 */     GIR_RootConstrainSelectedInstOperands,
     /* 272553 */     // GIR_Coverage, 737,
     /* 272553 */     GIR_EraseRootFromParent_Done,
     /* 272554 */   // Label 5470: @272554
     /* 272554 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(272594), // Rule ID 738 //
     /* 272559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272562 */     // MIs[0] Operand 1
     /* 272562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272575 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272581 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 272583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272585 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272592 */     GIR_RootConstrainSelectedInstOperands,
     /* 272593 */     // GIR_Coverage, 738,
     /* 272593 */     GIR_EraseRootFromParent_Done,
     /* 272594 */   // Label 5471: @272594
     /* 272594 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(272634), // Rule ID 747 //
     /* 272599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272602 */     // MIs[0] Operand 1
     /* 272602 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272615 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272621 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272625 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272632 */     GIR_RootConstrainSelectedInstOperands,
     /* 272633 */     // GIR_Coverage, 747,
     /* 272633 */     GIR_EraseRootFromParent_Done,
     /* 272634 */   // Label 5472: @272634
     /* 272634 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(272671), // Rule ID 5141 //
     /* 272639 */     // MIs[0] Operand 1
     /* 272639 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272662 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272669 */     GIR_RootConstrainSelectedInstOperands,
     /* 272670 */     // GIR_Coverage, 5141,
     /* 272670 */     GIR_EraseRootFromParent_Done,
     /* 272671 */   // Label 5473: @272671
     /* 272671 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(272708), // Rule ID 5148 //
     /* 272676 */     // MIs[0] Operand 1
     /* 272676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272689 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272695 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272699 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272706 */     GIR_RootConstrainSelectedInstOperands,
     /* 272707 */     // GIR_Coverage, 5148,
     /* 272707 */     GIR_EraseRootFromParent_Done,
     /* 272708 */   // Label 5474: @272708
     /* 272708 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(272745), // Rule ID 5155 //
     /* 272713 */     // MIs[0] Operand 1
     /* 272713 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272726 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272732 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272736 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272743 */     GIR_RootConstrainSelectedInstOperands,
     /* 272744 */     // GIR_Coverage, 5155,
     /* 272744 */     GIR_EraseRootFromParent_Done,
     /* 272745 */   // Label 5475: @272745
     /* 272745 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(272782), // Rule ID 5162 //
     /* 272750 */     // MIs[0] Operand 1
     /* 272750 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272763 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272769 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272773 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272780 */     GIR_RootConstrainSelectedInstOperands,
     /* 272781 */     // GIR_Coverage, 5162,
     /* 272781 */     GIR_EraseRootFromParent_Done,
     /* 272782 */   // Label 5476: @272782
     /* 272782 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(272819), // Rule ID 5169 //
     /* 272787 */     // MIs[0] Operand 1
     /* 272787 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272800 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272806 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272810 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272817 */     GIR_RootConstrainSelectedInstOperands,
     /* 272818 */     // GIR_Coverage, 5169,
     /* 272818 */     GIR_EraseRootFromParent_Done,
     /* 272819 */   // Label 5477: @272819
     /* 272819 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(272851), // Rule ID 1125 //
     /* 272824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272827 */     // MIs[0] Operand 1
     /* 272827 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272840 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 272843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272849 */     GIR_RootConstrainSelectedInstOperands,
     /* 272850 */     // GIR_Coverage, 1125,
     /* 272850 */     GIR_EraseRootFromParent_Done,
     /* 272851 */   // Label 5478: @272851
     /* 272851 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(272883), // Rule ID 1132 //
     /* 272856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272859 */     // MIs[0] Operand 1
     /* 272859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272872 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 272875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272881 */     GIR_RootConstrainSelectedInstOperands,
     /* 272882 */     // GIR_Coverage, 1132,
     /* 272882 */     GIR_EraseRootFromParent_Done,
     /* 272883 */   // Label 5479: @272883
     /* 272883 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(272915), // Rule ID 1139 //
     /* 272888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272891 */     // MIs[0] Operand 1
     /* 272891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272904 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 272907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272913 */     GIR_RootConstrainSelectedInstOperands,
     /* 272914 */     // GIR_Coverage, 1139,
     /* 272914 */     GIR_EraseRootFromParent_Done,
     /* 272915 */   // Label 5480: @272915
     /* 272915 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(272947), // Rule ID 1146 //
     /* 272920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272923 */     // MIs[0] Operand 1
     /* 272923 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 272928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272936 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 272939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272945 */     GIR_RootConstrainSelectedInstOperands,
     /* 272946 */     // GIR_Coverage, 1146,
     /* 272946 */     GIR_EraseRootFromParent_Done,
     /* 272947 */   // Label 5481: @272947
     /* 272947 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(272979), // Rule ID 1153 //
     /* 272952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272955 */     // MIs[0] Operand 1
     /* 272955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 272960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272968 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 272971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272977 */     GIR_RootConstrainSelectedInstOperands,
     /* 272978 */     // GIR_Coverage, 1153,
     /* 272978 */     GIR_EraseRootFromParent_Done,
     /* 272979 */   // Label 5482: @272979
     /* 272979 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(273008), // Rule ID 5078 //
     /* 272984 */     // MIs[0] Operand 1
     /* 272984 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272997 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 273000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273006 */     GIR_RootConstrainSelectedInstOperands,
     /* 273007 */     // GIR_Coverage, 5078,
     /* 273007 */     GIR_EraseRootFromParent_Done,
     /* 273008 */   // Label 5483: @273008
     /* 273008 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(273037), // Rule ID 5085 //
     /* 273013 */     // MIs[0] Operand 1
     /* 273013 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273026 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 273029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273035 */     GIR_RootConstrainSelectedInstOperands,
     /* 273036 */     // GIR_Coverage, 5085,
     /* 273036 */     GIR_EraseRootFromParent_Done,
     /* 273037 */   // Label 5484: @273037
     /* 273037 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(273066), // Rule ID 5092 //
     /* 273042 */     // MIs[0] Operand 1
     /* 273042 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273055 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 273058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273064 */     GIR_RootConstrainSelectedInstOperands,
     /* 273065 */     // GIR_Coverage, 5092,
     /* 273065 */     GIR_EraseRootFromParent_Done,
     /* 273066 */   // Label 5485: @273066
     /* 273066 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(273095), // Rule ID 5099 //
     /* 273071 */     // MIs[0] Operand 1
     /* 273071 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273084 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 273087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273093 */     GIR_RootConstrainSelectedInstOperands,
     /* 273094 */     // GIR_Coverage, 5099,
     /* 273094 */     GIR_EraseRootFromParent_Done,
     /* 273095 */   // Label 5486: @273095
     /* 273095 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(273124), // Rule ID 5106 //
     /* 273100 */     // MIs[0] Operand 1
     /* 273100 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273113 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 273116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273122 */     GIR_RootConstrainSelectedInstOperands,
     /* 273123 */     // GIR_Coverage, 5106,
     /* 273123 */     GIR_EraseRootFromParent_Done,
     /* 273124 */   // Label 5487: @273124
     /* 273124 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(273153), // Rule ID 5113 //
     /* 273129 */     // MIs[0] Operand 1
     /* 273129 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273142 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 273145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273151 */     GIR_RootConstrainSelectedInstOperands,
     /* 273152 */     // GIR_Coverage, 5113,
     /* 273152 */     GIR_EraseRootFromParent_Done,
     /* 273153 */   // Label 5488: @273153
     /* 273153 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(273182), // Rule ID 5120 //
     /* 273158 */     // MIs[0] Operand 1
     /* 273158 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273171 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 273174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273180 */     GIR_RootConstrainSelectedInstOperands,
     /* 273181 */     // GIR_Coverage, 5120,
     /* 273181 */     GIR_EraseRootFromParent_Done,
     /* 273182 */   // Label 5489: @273182
     /* 273182 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(273211), // Rule ID 5127 //
     /* 273187 */     // MIs[0] Operand 1
     /* 273187 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 273192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273200 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 273203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273209 */     GIR_RootConstrainSelectedInstOperands,
     /* 273210 */     // GIR_Coverage, 5127,
     /* 273210 */     GIR_EraseRootFromParent_Done,
     /* 273211 */   // Label 5490: @273211
     /* 273211 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(273240), // Rule ID 5134 //
     /* 273216 */     // MIs[0] Operand 1
     /* 273216 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 273221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273229 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 273232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273238 */     GIR_RootConstrainSelectedInstOperands,
     /* 273239 */     // GIR_Coverage, 5134,
     /* 273239 */     GIR_EraseRootFromParent_Done,
     /* 273240 */   // Label 5491: @273240
     /* 273240 */   GIM_Reject,
     /* 273241 */ // Label 5461: @273241
     /* 273241 */ GIM_Reject,
     /* 273242 */ // Label 5442: @273242
     /* 273242 */ GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(274289),
     /* 273247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 273253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273257 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(273297), // Rule ID 756 //
     /* 273262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273265 */     // MIs[0] Operand 1
     /* 273265 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273274 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273280 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273288 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273295 */     GIR_RootConstrainSelectedInstOperands,
     /* 273296 */     // GIR_Coverage, 756,
     /* 273296 */     GIR_EraseRootFromParent_Done,
     /* 273297 */   // Label 5493: @273297
     /* 273297 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(273337), // Rule ID 763 //
     /* 273302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273305 */     // MIs[0] Operand 1
     /* 273305 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273314 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273320 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273328 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273335 */     GIR_RootConstrainSelectedInstOperands,
     /* 273336 */     // GIR_Coverage, 763,
     /* 273336 */     GIR_EraseRootFromParent_Done,
     /* 273337 */   // Label 5494: @273337
     /* 273337 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(273374), // Rule ID 5178 //
     /* 273342 */     // MIs[0] Operand 1
     /* 273342 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273351 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273357 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273365 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273372 */     GIR_RootConstrainSelectedInstOperands,
     /* 273373 */     // GIR_Coverage, 5178,
     /* 273373 */     GIR_EraseRootFromParent_Done,
     /* 273374 */   // Label 5495: @273374
     /* 273374 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(273411), // Rule ID 5185 //
     /* 273379 */     // MIs[0] Operand 1
     /* 273379 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273388 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273394 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273402 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273409 */     GIR_RootConstrainSelectedInstOperands,
     /* 273410 */     // GIR_Coverage, 5185,
     /* 273410 */     GIR_EraseRootFromParent_Done,
     /* 273411 */   // Label 5496: @273411
     /* 273411 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(273448), // Rule ID 5192 //
     /* 273416 */     // MIs[0] Operand 1
     /* 273416 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273425 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273431 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273439 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273446 */     GIR_RootConstrainSelectedInstOperands,
     /* 273447 */     // GIR_Coverage, 5192,
     /* 273447 */     GIR_EraseRootFromParent_Done,
     /* 273448 */   // Label 5497: @273448
     /* 273448 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(273485), // Rule ID 5199 //
     /* 273453 */     // MIs[0] Operand 1
     /* 273453 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273462 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273468 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273476 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273483 */     GIR_RootConstrainSelectedInstOperands,
     /* 273484 */     // GIR_Coverage, 5199,
     /* 273484 */     GIR_EraseRootFromParent_Done,
     /* 273485 */   // Label 5498: @273485
     /* 273485 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(273522), // Rule ID 5206 //
     /* 273490 */     // MIs[0] Operand 1
     /* 273490 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273499 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273505 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273513 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273520 */     GIR_RootConstrainSelectedInstOperands,
     /* 273521 */     // GIR_Coverage, 5206,
     /* 273521 */     GIR_EraseRootFromParent_Done,
     /* 273522 */   // Label 5499: @273522
     /* 273522 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(273562), // Rule ID 728 //
     /* 273527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273530 */     // MIs[0] Operand 1
     /* 273530 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273543 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273549 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273553 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273560 */     GIR_RootConstrainSelectedInstOperands,
     /* 273561 */     // GIR_Coverage, 728,
     /* 273561 */     GIR_EraseRootFromParent_Done,
     /* 273562 */   // Label 5500: @273562
     /* 273562 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(273602), // Rule ID 741 //
     /* 273567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273570 */     // MIs[0] Operand 1
     /* 273570 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273583 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273589 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273593 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273600 */     GIR_RootConstrainSelectedInstOperands,
     /* 273601 */     // GIR_Coverage, 741,
     /* 273601 */     GIR_EraseRootFromParent_Done,
     /* 273602 */   // Label 5501: @273602
     /* 273602 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(273642), // Rule ID 742 //
     /* 273607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273610 */     // MIs[0] Operand 1
     /* 273610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273623 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273629 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 273631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273633 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273640 */     GIR_RootConstrainSelectedInstOperands,
     /* 273641 */     // GIR_Coverage, 742,
     /* 273641 */     GIR_EraseRootFromParent_Done,
     /* 273642 */   // Label 5502: @273642
     /* 273642 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(273682), // Rule ID 749 //
     /* 273647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273650 */     // MIs[0] Operand 1
     /* 273650 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273663 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273669 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273673 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273680 */     GIR_RootConstrainSelectedInstOperands,
     /* 273681 */     // GIR_Coverage, 749,
     /* 273681 */     GIR_EraseRootFromParent_Done,
     /* 273682 */   // Label 5503: @273682
     /* 273682 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(273719), // Rule ID 5143 //
     /* 273687 */     // MIs[0] Operand 1
     /* 273687 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273700 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273706 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273710 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273717 */     GIR_RootConstrainSelectedInstOperands,
     /* 273718 */     // GIR_Coverage, 5143,
     /* 273718 */     GIR_EraseRootFromParent_Done,
     /* 273719 */   // Label 5504: @273719
     /* 273719 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(273756), // Rule ID 5150 //
     /* 273724 */     // MIs[0] Operand 1
     /* 273724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273737 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273743 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273747 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273754 */     GIR_RootConstrainSelectedInstOperands,
     /* 273755 */     // GIR_Coverage, 5150,
     /* 273755 */     GIR_EraseRootFromParent_Done,
     /* 273756 */   // Label 5505: @273756
     /* 273756 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(273793), // Rule ID 5157 //
     /* 273761 */     // MIs[0] Operand 1
     /* 273761 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273784 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273791 */     GIR_RootConstrainSelectedInstOperands,
     /* 273792 */     // GIR_Coverage, 5157,
     /* 273792 */     GIR_EraseRootFromParent_Done,
     /* 273793 */   // Label 5506: @273793
     /* 273793 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(273830), // Rule ID 5164 //
     /* 273798 */     // MIs[0] Operand 1
     /* 273798 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273811 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273817 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273821 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273828 */     GIR_RootConstrainSelectedInstOperands,
     /* 273829 */     // GIR_Coverage, 5164,
     /* 273829 */     GIR_EraseRootFromParent_Done,
     /* 273830 */   // Label 5507: @273830
     /* 273830 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(273867), // Rule ID 5171 //
     /* 273835 */     // MIs[0] Operand 1
     /* 273835 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273848 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273854 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273858 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273865 */     GIR_RootConstrainSelectedInstOperands,
     /* 273866 */     // GIR_Coverage, 5171,
     /* 273866 */     GIR_EraseRootFromParent_Done,
     /* 273867 */   // Label 5508: @273867
     /* 273867 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(273899), // Rule ID 1127 //
     /* 273872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273875 */     // MIs[0] Operand 1
     /* 273875 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273888 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 273891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273897 */     GIR_RootConstrainSelectedInstOperands,
     /* 273898 */     // GIR_Coverage, 1127,
     /* 273898 */     GIR_EraseRootFromParent_Done,
     /* 273899 */   // Label 5509: @273899
     /* 273899 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(273931), // Rule ID 1134 //
     /* 273904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273907 */     // MIs[0] Operand 1
     /* 273907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273920 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 273923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273929 */     GIR_RootConstrainSelectedInstOperands,
     /* 273930 */     // GIR_Coverage, 1134,
     /* 273930 */     GIR_EraseRootFromParent_Done,
     /* 273931 */   // Label 5510: @273931
     /* 273931 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(273963), // Rule ID 1141 //
     /* 273936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273939 */     // MIs[0] Operand 1
     /* 273939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273952 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 273955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273961 */     GIR_RootConstrainSelectedInstOperands,
     /* 273962 */     // GIR_Coverage, 1141,
     /* 273962 */     GIR_EraseRootFromParent_Done,
     /* 273963 */   // Label 5511: @273963
     /* 273963 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(273995), // Rule ID 1148 //
     /* 273968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273971 */     // MIs[0] Operand 1
     /* 273971 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273984 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 273987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273993 */     GIR_RootConstrainSelectedInstOperands,
     /* 273994 */     // GIR_Coverage, 1148,
     /* 273994 */     GIR_EraseRootFromParent_Done,
     /* 273995 */   // Label 5512: @273995
     /* 273995 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(274027), // Rule ID 1155 //
     /* 274000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274003 */     // MIs[0] Operand 1
     /* 274003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274016 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 274019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274025 */     GIR_RootConstrainSelectedInstOperands,
     /* 274026 */     // GIR_Coverage, 1155,
     /* 274026 */     GIR_EraseRootFromParent_Done,
     /* 274027 */   // Label 5513: @274027
     /* 274027 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(274056), // Rule ID 5080 //
     /* 274032 */     // MIs[0] Operand 1
     /* 274032 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274045 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 274048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274054 */     GIR_RootConstrainSelectedInstOperands,
     /* 274055 */     // GIR_Coverage, 5080,
     /* 274055 */     GIR_EraseRootFromParent_Done,
     /* 274056 */   // Label 5514: @274056
     /* 274056 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(274085), // Rule ID 5087 //
     /* 274061 */     // MIs[0] Operand 1
     /* 274061 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274074 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 274077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274083 */     GIR_RootConstrainSelectedInstOperands,
     /* 274084 */     // GIR_Coverage, 5087,
     /* 274084 */     GIR_EraseRootFromParent_Done,
     /* 274085 */   // Label 5515: @274085
     /* 274085 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(274114), // Rule ID 5094 //
     /* 274090 */     // MIs[0] Operand 1
     /* 274090 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274103 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 274106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274112 */     GIR_RootConstrainSelectedInstOperands,
     /* 274113 */     // GIR_Coverage, 5094,
     /* 274113 */     GIR_EraseRootFromParent_Done,
     /* 274114 */   // Label 5516: @274114
     /* 274114 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(274143), // Rule ID 5101 //
     /* 274119 */     // MIs[0] Operand 1
     /* 274119 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274132 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 274135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274141 */     GIR_RootConstrainSelectedInstOperands,
     /* 274142 */     // GIR_Coverage, 5101,
     /* 274142 */     GIR_EraseRootFromParent_Done,
     /* 274143 */   // Label 5517: @274143
     /* 274143 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(274172), // Rule ID 5108 //
     /* 274148 */     // MIs[0] Operand 1
     /* 274148 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274161 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 274164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274170 */     GIR_RootConstrainSelectedInstOperands,
     /* 274171 */     // GIR_Coverage, 5108,
     /* 274171 */     GIR_EraseRootFromParent_Done,
     /* 274172 */   // Label 5518: @274172
     /* 274172 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(274201), // Rule ID 5115 //
     /* 274177 */     // MIs[0] Operand 1
     /* 274177 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274190 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 274193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274199 */     GIR_RootConstrainSelectedInstOperands,
     /* 274200 */     // GIR_Coverage, 5115,
     /* 274200 */     GIR_EraseRootFromParent_Done,
     /* 274201 */   // Label 5519: @274201
     /* 274201 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(274230), // Rule ID 5122 //
     /* 274206 */     // MIs[0] Operand 1
     /* 274206 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274219 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 274222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274228 */     GIR_RootConstrainSelectedInstOperands,
     /* 274229 */     // GIR_Coverage, 5122,
     /* 274229 */     GIR_EraseRootFromParent_Done,
     /* 274230 */   // Label 5520: @274230
     /* 274230 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(274259), // Rule ID 5129 //
     /* 274235 */     // MIs[0] Operand 1
     /* 274235 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 274240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274248 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 274251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274257 */     GIR_RootConstrainSelectedInstOperands,
     /* 274258 */     // GIR_Coverage, 5129,
     /* 274258 */     GIR_EraseRootFromParent_Done,
     /* 274259 */   // Label 5521: @274259
     /* 274259 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(274288), // Rule ID 5136 //
     /* 274264 */     // MIs[0] Operand 1
     /* 274264 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 274269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274277 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 274280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274286 */     GIR_RootConstrainSelectedInstOperands,
     /* 274287 */     // GIR_Coverage, 5136,
     /* 274287 */     GIR_EraseRootFromParent_Done,
     /* 274288 */   // Label 5522: @274288
     /* 274288 */   GIM_Reject,
     /* 274289 */ // Label 5492: @274289
     /* 274289 */ GIM_Reject,
     /* 274290 */ // Label 5443: @274290
     /* 274290 */ GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(275337),
     /* 274295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 274301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274305 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(274345), // Rule ID 752 //
     /* 274310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274313 */     // MIs[0] Operand 1
     /* 274313 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274322 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274328 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274336 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274343 */     GIR_RootConstrainSelectedInstOperands,
     /* 274344 */     // GIR_Coverage, 752,
     /* 274344 */     GIR_EraseRootFromParent_Done,
     /* 274345 */   // Label 5524: @274345
     /* 274345 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(274385), // Rule ID 759 //
     /* 274350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274353 */     // MIs[0] Operand 1
     /* 274353 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274362 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274368 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274376 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274383 */     GIR_RootConstrainSelectedInstOperands,
     /* 274384 */     // GIR_Coverage, 759,
     /* 274384 */     GIR_EraseRootFromParent_Done,
     /* 274385 */   // Label 5525: @274385
     /* 274385 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(274422), // Rule ID 5174 //
     /* 274390 */     // MIs[0] Operand 1
     /* 274390 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274399 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274405 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274413 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274420 */     GIR_RootConstrainSelectedInstOperands,
     /* 274421 */     // GIR_Coverage, 5174,
     /* 274421 */     GIR_EraseRootFromParent_Done,
     /* 274422 */   // Label 5526: @274422
     /* 274422 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(274459), // Rule ID 5181 //
     /* 274427 */     // MIs[0] Operand 1
     /* 274427 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274436 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274442 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274450 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274457 */     GIR_RootConstrainSelectedInstOperands,
     /* 274458 */     // GIR_Coverage, 5181,
     /* 274458 */     GIR_EraseRootFromParent_Done,
     /* 274459 */   // Label 5527: @274459
     /* 274459 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(274496), // Rule ID 5188 //
     /* 274464 */     // MIs[0] Operand 1
     /* 274464 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274473 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274479 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274487 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274494 */     GIR_RootConstrainSelectedInstOperands,
     /* 274495 */     // GIR_Coverage, 5188,
     /* 274495 */     GIR_EraseRootFromParent_Done,
     /* 274496 */   // Label 5528: @274496
     /* 274496 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(274533), // Rule ID 5195 //
     /* 274501 */     // MIs[0] Operand 1
     /* 274501 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274510 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274516 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274524 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274531 */     GIR_RootConstrainSelectedInstOperands,
     /* 274532 */     // GIR_Coverage, 5195,
     /* 274532 */     GIR_EraseRootFromParent_Done,
     /* 274533 */   // Label 5529: @274533
     /* 274533 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(274570), // Rule ID 5202 //
     /* 274538 */     // MIs[0] Operand 1
     /* 274538 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274547 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274553 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274561 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274568 */     GIR_RootConstrainSelectedInstOperands,
     /* 274569 */     // GIR_Coverage, 5202,
     /* 274569 */     GIR_EraseRootFromParent_Done,
     /* 274570 */   // Label 5530: @274570
     /* 274570 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(274610), // Rule ID 724 //
     /* 274575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274578 */     // MIs[0] Operand 1
     /* 274578 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274591 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274597 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274601 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274608 */     GIR_RootConstrainSelectedInstOperands,
     /* 274609 */     // GIR_Coverage, 724,
     /* 274609 */     GIR_EraseRootFromParent_Done,
     /* 274610 */   // Label 5531: @274610
     /* 274610 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(274650), // Rule ID 733 //
     /* 274615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274618 */     // MIs[0] Operand 1
     /* 274618 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274631 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274637 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274641 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274648 */     GIR_RootConstrainSelectedInstOperands,
     /* 274649 */     // GIR_Coverage, 733,
     /* 274649 */     GIR_EraseRootFromParent_Done,
     /* 274650 */   // Label 5532: @274650
     /* 274650 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(274690), // Rule ID 734 //
     /* 274655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274658 */     // MIs[0] Operand 1
     /* 274658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274677 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 274679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274681 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274688 */     GIR_RootConstrainSelectedInstOperands,
     /* 274689 */     // GIR_Coverage, 734,
     /* 274689 */     GIR_EraseRootFromParent_Done,
     /* 274690 */   // Label 5533: @274690
     /* 274690 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(274730), // Rule ID 745 //
     /* 274695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274698 */     // MIs[0] Operand 1
     /* 274698 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274721 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274728 */     GIR_RootConstrainSelectedInstOperands,
     /* 274729 */     // GIR_Coverage, 745,
     /* 274729 */     GIR_EraseRootFromParent_Done,
     /* 274730 */   // Label 5534: @274730
     /* 274730 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(274767), // Rule ID 5139 //
     /* 274735 */     // MIs[0] Operand 1
     /* 274735 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274748 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274754 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274758 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274765 */     GIR_RootConstrainSelectedInstOperands,
     /* 274766 */     // GIR_Coverage, 5139,
     /* 274766 */     GIR_EraseRootFromParent_Done,
     /* 274767 */   // Label 5535: @274767
     /* 274767 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(274804), // Rule ID 5146 //
     /* 274772 */     // MIs[0] Operand 1
     /* 274772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274785 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274791 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274795 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274802 */     GIR_RootConstrainSelectedInstOperands,
     /* 274803 */     // GIR_Coverage, 5146,
     /* 274803 */     GIR_EraseRootFromParent_Done,
     /* 274804 */   // Label 5536: @274804
     /* 274804 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(274841), // Rule ID 5153 //
     /* 274809 */     // MIs[0] Operand 1
     /* 274809 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274822 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274828 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274832 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274839 */     GIR_RootConstrainSelectedInstOperands,
     /* 274840 */     // GIR_Coverage, 5153,
     /* 274840 */     GIR_EraseRootFromParent_Done,
     /* 274841 */   // Label 5537: @274841
     /* 274841 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(274878), // Rule ID 5160 //
     /* 274846 */     // MIs[0] Operand 1
     /* 274846 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274859 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274865 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274869 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274876 */     GIR_RootConstrainSelectedInstOperands,
     /* 274877 */     // GIR_Coverage, 5160,
     /* 274877 */     GIR_EraseRootFromParent_Done,
     /* 274878 */   // Label 5538: @274878
     /* 274878 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(274915), // Rule ID 5167 //
     /* 274883 */     // MIs[0] Operand 1
     /* 274883 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274896 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274902 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274906 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274913 */     GIR_RootConstrainSelectedInstOperands,
     /* 274914 */     // GIR_Coverage, 5167,
     /* 274914 */     GIR_EraseRootFromParent_Done,
     /* 274915 */   // Label 5539: @274915
     /* 274915 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(274947), // Rule ID 1123 //
     /* 274920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274923 */     // MIs[0] Operand 1
     /* 274923 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274936 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 274939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274945 */     GIR_RootConstrainSelectedInstOperands,
     /* 274946 */     // GIR_Coverage, 1123,
     /* 274946 */     GIR_EraseRootFromParent_Done,
     /* 274947 */   // Label 5540: @274947
     /* 274947 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(274979), // Rule ID 1130 //
     /* 274952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274955 */     // MIs[0] Operand 1
     /* 274955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274968 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 274971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274977 */     GIR_RootConstrainSelectedInstOperands,
     /* 274978 */     // GIR_Coverage, 1130,
     /* 274978 */     GIR_EraseRootFromParent_Done,
     /* 274979 */   // Label 5541: @274979
     /* 274979 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(275011), // Rule ID 1137 //
     /* 274984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274987 */     // MIs[0] Operand 1
     /* 274987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275000 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 275003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275009 */     GIR_RootConstrainSelectedInstOperands,
     /* 275010 */     // GIR_Coverage, 1137,
     /* 275010 */     GIR_EraseRootFromParent_Done,
     /* 275011 */   // Label 5542: @275011
     /* 275011 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(275043), // Rule ID 1144 //
     /* 275016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275019 */     // MIs[0] Operand 1
     /* 275019 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275032 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 275035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275041 */     GIR_RootConstrainSelectedInstOperands,
     /* 275042 */     // GIR_Coverage, 1144,
     /* 275042 */     GIR_EraseRootFromParent_Done,
     /* 275043 */   // Label 5543: @275043
     /* 275043 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(275075), // Rule ID 1151 //
     /* 275048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275051 */     // MIs[0] Operand 1
     /* 275051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275064 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275073 */     GIR_RootConstrainSelectedInstOperands,
     /* 275074 */     // GIR_Coverage, 1151,
     /* 275074 */     GIR_EraseRootFromParent_Done,
     /* 275075 */   // Label 5544: @275075
     /* 275075 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(275104), // Rule ID 5076 //
     /* 275080 */     // MIs[0] Operand 1
     /* 275080 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275093 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 275096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275102 */     GIR_RootConstrainSelectedInstOperands,
     /* 275103 */     // GIR_Coverage, 5076,
     /* 275103 */     GIR_EraseRootFromParent_Done,
     /* 275104 */   // Label 5545: @275104
     /* 275104 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(275133), // Rule ID 5083 //
     /* 275109 */     // MIs[0] Operand 1
     /* 275109 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275122 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 275125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275131 */     GIR_RootConstrainSelectedInstOperands,
     /* 275132 */     // GIR_Coverage, 5083,
     /* 275132 */     GIR_EraseRootFromParent_Done,
     /* 275133 */   // Label 5546: @275133
     /* 275133 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(275162), // Rule ID 5090 //
     /* 275138 */     // MIs[0] Operand 1
     /* 275138 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275151 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 275154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275160 */     GIR_RootConstrainSelectedInstOperands,
     /* 275161 */     // GIR_Coverage, 5090,
     /* 275161 */     GIR_EraseRootFromParent_Done,
     /* 275162 */   // Label 5547: @275162
     /* 275162 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(275191), // Rule ID 5097 //
     /* 275167 */     // MIs[0] Operand 1
     /* 275167 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275180 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 275183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275189 */     GIR_RootConstrainSelectedInstOperands,
     /* 275190 */     // GIR_Coverage, 5097,
     /* 275190 */     GIR_EraseRootFromParent_Done,
     /* 275191 */   // Label 5548: @275191
     /* 275191 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(275220), // Rule ID 5104 //
     /* 275196 */     // MIs[0] Operand 1
     /* 275196 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275209 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275218 */     GIR_RootConstrainSelectedInstOperands,
     /* 275219 */     // GIR_Coverage, 5104,
     /* 275219 */     GIR_EraseRootFromParent_Done,
     /* 275220 */   // Label 5549: @275220
     /* 275220 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(275249), // Rule ID 5111 //
     /* 275225 */     // MIs[0] Operand 1
     /* 275225 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275238 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 275241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275247 */     GIR_RootConstrainSelectedInstOperands,
     /* 275248 */     // GIR_Coverage, 5111,
     /* 275248 */     GIR_EraseRootFromParent_Done,
     /* 275249 */   // Label 5550: @275249
     /* 275249 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(275278), // Rule ID 5118 //
     /* 275254 */     // MIs[0] Operand 1
     /* 275254 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275267 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 275270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275276 */     GIR_RootConstrainSelectedInstOperands,
     /* 275277 */     // GIR_Coverage, 5118,
     /* 275277 */     GIR_EraseRootFromParent_Done,
     /* 275278 */   // Label 5551: @275278
     /* 275278 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(275307), // Rule ID 5125 //
     /* 275283 */     // MIs[0] Operand 1
     /* 275283 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 275288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275296 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 275299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275305 */     GIR_RootConstrainSelectedInstOperands,
     /* 275306 */     // GIR_Coverage, 5125,
     /* 275306 */     GIR_EraseRootFromParent_Done,
     /* 275307 */   // Label 5552: @275307
     /* 275307 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(275336), // Rule ID 5132 //
     /* 275312 */     // MIs[0] Operand 1
     /* 275312 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 275317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275325 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275334 */     GIR_RootConstrainSelectedInstOperands,
     /* 275335 */     // GIR_Coverage, 5132,
     /* 275335 */     GIR_EraseRootFromParent_Done,
     /* 275336 */   // Label 5553: @275336
     /* 275336 */   GIM_Reject,
     /* 275337 */ // Label 5523: @275337
     /* 275337 */ GIM_Reject,
     /* 275338 */ // Label 5444: @275338
     /* 275338 */ GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(276385),
     /* 275343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275353 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(275393), // Rule ID 755 //
     /* 275358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275361 */     // MIs[0] Operand 1
     /* 275361 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275370 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275376 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275384 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275391 */     GIR_RootConstrainSelectedInstOperands,
     /* 275392 */     // GIR_Coverage, 755,
     /* 275392 */     GIR_EraseRootFromParent_Done,
     /* 275393 */   // Label 5555: @275393
     /* 275393 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(275433), // Rule ID 762 //
     /* 275398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275401 */     // MIs[0] Operand 1
     /* 275401 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275410 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275416 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275424 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275431 */     GIR_RootConstrainSelectedInstOperands,
     /* 275432 */     // GIR_Coverage, 762,
     /* 275432 */     GIR_EraseRootFromParent_Done,
     /* 275433 */   // Label 5556: @275433
     /* 275433 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(275470), // Rule ID 5177 //
     /* 275438 */     // MIs[0] Operand 1
     /* 275438 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275447 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275453 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275461 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275468 */     GIR_RootConstrainSelectedInstOperands,
     /* 275469 */     // GIR_Coverage, 5177,
     /* 275469 */     GIR_EraseRootFromParent_Done,
     /* 275470 */   // Label 5557: @275470
     /* 275470 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(275507), // Rule ID 5184 //
     /* 275475 */     // MIs[0] Operand 1
     /* 275475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275484 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275490 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275498 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275505 */     GIR_RootConstrainSelectedInstOperands,
     /* 275506 */     // GIR_Coverage, 5184,
     /* 275506 */     GIR_EraseRootFromParent_Done,
     /* 275507 */   // Label 5558: @275507
     /* 275507 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(275544), // Rule ID 5191 //
     /* 275512 */     // MIs[0] Operand 1
     /* 275512 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275521 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275527 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275535 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275542 */     GIR_RootConstrainSelectedInstOperands,
     /* 275543 */     // GIR_Coverage, 5191,
     /* 275543 */     GIR_EraseRootFromParent_Done,
     /* 275544 */   // Label 5559: @275544
     /* 275544 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(275581), // Rule ID 5198 //
     /* 275549 */     // MIs[0] Operand 1
     /* 275549 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275558 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275564 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275572 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275579 */     GIR_RootConstrainSelectedInstOperands,
     /* 275580 */     // GIR_Coverage, 5198,
     /* 275580 */     GIR_EraseRootFromParent_Done,
     /* 275581 */   // Label 5560: @275581
     /* 275581 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(275618), // Rule ID 5205 //
     /* 275586 */     // MIs[0] Operand 1
     /* 275586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275609 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275616 */     GIR_RootConstrainSelectedInstOperands,
     /* 275617 */     // GIR_Coverage, 5205,
     /* 275617 */     GIR_EraseRootFromParent_Done,
     /* 275618 */   // Label 5561: @275618
     /* 275618 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(275658), // Rule ID 727 //
     /* 275623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275626 */     // MIs[0] Operand 1
     /* 275626 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275639 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275645 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275649 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275656 */     GIR_RootConstrainSelectedInstOperands,
     /* 275657 */     // GIR_Coverage, 727,
     /* 275657 */     GIR_EraseRootFromParent_Done,
     /* 275658 */   // Label 5562: @275658
     /* 275658 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(275698), // Rule ID 739 //
     /* 275663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275666 */     // MIs[0] Operand 1
     /* 275666 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275679 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275685 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275689 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275696 */     GIR_RootConstrainSelectedInstOperands,
     /* 275697 */     // GIR_Coverage, 739,
     /* 275697 */     GIR_EraseRootFromParent_Done,
     /* 275698 */   // Label 5563: @275698
     /* 275698 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(275738), // Rule ID 740 //
     /* 275703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275706 */     // MIs[0] Operand 1
     /* 275706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275719 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275725 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 275727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275729 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275736 */     GIR_RootConstrainSelectedInstOperands,
     /* 275737 */     // GIR_Coverage, 740,
     /* 275737 */     GIR_EraseRootFromParent_Done,
     /* 275738 */   // Label 5564: @275738
     /* 275738 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(275778), // Rule ID 748 //
     /* 275743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275746 */     // MIs[0] Operand 1
     /* 275746 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275759 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275765 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275769 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275776 */     GIR_RootConstrainSelectedInstOperands,
     /* 275777 */     // GIR_Coverage, 748,
     /* 275777 */     GIR_EraseRootFromParent_Done,
     /* 275778 */   // Label 5565: @275778
     /* 275778 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(275815), // Rule ID 5142 //
     /* 275783 */     // MIs[0] Operand 1
     /* 275783 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275802 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275806 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275813 */     GIR_RootConstrainSelectedInstOperands,
     /* 275814 */     // GIR_Coverage, 5142,
     /* 275814 */     GIR_EraseRootFromParent_Done,
     /* 275815 */   // Label 5566: @275815
     /* 275815 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(275852), // Rule ID 5149 //
     /* 275820 */     // MIs[0] Operand 1
     /* 275820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275833 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275839 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275843 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275850 */     GIR_RootConstrainSelectedInstOperands,
     /* 275851 */     // GIR_Coverage, 5149,
     /* 275851 */     GIR_EraseRootFromParent_Done,
     /* 275852 */   // Label 5567: @275852
     /* 275852 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(275889), // Rule ID 5156 //
     /* 275857 */     // MIs[0] Operand 1
     /* 275857 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275870 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275876 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275880 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275887 */     GIR_RootConstrainSelectedInstOperands,
     /* 275888 */     // GIR_Coverage, 5156,
     /* 275888 */     GIR_EraseRootFromParent_Done,
     /* 275889 */   // Label 5568: @275889
     /* 275889 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(275926), // Rule ID 5163 //
     /* 275894 */     // MIs[0] Operand 1
     /* 275894 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275907 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275913 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275917 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275924 */     GIR_RootConstrainSelectedInstOperands,
     /* 275925 */     // GIR_Coverage, 5163,
     /* 275925 */     GIR_EraseRootFromParent_Done,
     /* 275926 */   // Label 5569: @275926
     /* 275926 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(275963), // Rule ID 5170 //
     /* 275931 */     // MIs[0] Operand 1
     /* 275931 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275944 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275950 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275954 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275961 */     GIR_RootConstrainSelectedInstOperands,
     /* 275962 */     // GIR_Coverage, 5170,
     /* 275962 */     GIR_EraseRootFromParent_Done,
     /* 275963 */   // Label 5570: @275963
     /* 275963 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(275995), // Rule ID 1126 //
     /* 275968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275971 */     // MIs[0] Operand 1
     /* 275971 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275984 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 275987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275993 */     GIR_RootConstrainSelectedInstOperands,
     /* 275994 */     // GIR_Coverage, 1126,
     /* 275994 */     GIR_EraseRootFromParent_Done,
     /* 275995 */   // Label 5571: @275995
     /* 275995 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(276027), // Rule ID 1133 //
     /* 276000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276003 */     // MIs[0] Operand 1
     /* 276003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276016 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 276019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276025 */     GIR_RootConstrainSelectedInstOperands,
     /* 276026 */     // GIR_Coverage, 1133,
     /* 276026 */     GIR_EraseRootFromParent_Done,
     /* 276027 */   // Label 5572: @276027
     /* 276027 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(276059), // Rule ID 1140 //
     /* 276032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276035 */     // MIs[0] Operand 1
     /* 276035 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276048 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 276051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276057 */     GIR_RootConstrainSelectedInstOperands,
     /* 276058 */     // GIR_Coverage, 1140,
     /* 276058 */     GIR_EraseRootFromParent_Done,
     /* 276059 */   // Label 5573: @276059
     /* 276059 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(276091), // Rule ID 1147 //
     /* 276064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276067 */     // MIs[0] Operand 1
     /* 276067 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276080 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276089 */     GIR_RootConstrainSelectedInstOperands,
     /* 276090 */     // GIR_Coverage, 1147,
     /* 276090 */     GIR_EraseRootFromParent_Done,
     /* 276091 */   // Label 5574: @276091
     /* 276091 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(276123), // Rule ID 1154 //
     /* 276096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276099 */     // MIs[0] Operand 1
     /* 276099 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276112 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276121 */     GIR_RootConstrainSelectedInstOperands,
     /* 276122 */     // GIR_Coverage, 1154,
     /* 276122 */     GIR_EraseRootFromParent_Done,
     /* 276123 */   // Label 5575: @276123
     /* 276123 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(276152), // Rule ID 5079 //
     /* 276128 */     // MIs[0] Operand 1
     /* 276128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276141 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 276144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276150 */     GIR_RootConstrainSelectedInstOperands,
     /* 276151 */     // GIR_Coverage, 5079,
     /* 276151 */     GIR_EraseRootFromParent_Done,
     /* 276152 */   // Label 5576: @276152
     /* 276152 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(276181), // Rule ID 5086 //
     /* 276157 */     // MIs[0] Operand 1
     /* 276157 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276170 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 276173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276179 */     GIR_RootConstrainSelectedInstOperands,
     /* 276180 */     // GIR_Coverage, 5086,
     /* 276180 */     GIR_EraseRootFromParent_Done,
     /* 276181 */   // Label 5577: @276181
     /* 276181 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(276210), // Rule ID 5093 //
     /* 276186 */     // MIs[0] Operand 1
     /* 276186 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276199 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 276202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276208 */     GIR_RootConstrainSelectedInstOperands,
     /* 276209 */     // GIR_Coverage, 5093,
     /* 276209 */     GIR_EraseRootFromParent_Done,
     /* 276210 */   // Label 5578: @276210
     /* 276210 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(276239), // Rule ID 5100 //
     /* 276215 */     // MIs[0] Operand 1
     /* 276215 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276228 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276237 */     GIR_RootConstrainSelectedInstOperands,
     /* 276238 */     // GIR_Coverage, 5100,
     /* 276238 */     GIR_EraseRootFromParent_Done,
     /* 276239 */   // Label 5579: @276239
     /* 276239 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(276268), // Rule ID 5107 //
     /* 276244 */     // MIs[0] Operand 1
     /* 276244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276257 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276266 */     GIR_RootConstrainSelectedInstOperands,
     /* 276267 */     // GIR_Coverage, 5107,
     /* 276267 */     GIR_EraseRootFromParent_Done,
     /* 276268 */   // Label 5580: @276268
     /* 276268 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(276297), // Rule ID 5114 //
     /* 276273 */     // MIs[0] Operand 1
     /* 276273 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276286 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 276289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276295 */     GIR_RootConstrainSelectedInstOperands,
     /* 276296 */     // GIR_Coverage, 5114,
     /* 276296 */     GIR_EraseRootFromParent_Done,
     /* 276297 */   // Label 5581: @276297
     /* 276297 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(276326), // Rule ID 5121 //
     /* 276302 */     // MIs[0] Operand 1
     /* 276302 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276315 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 276318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276324 */     GIR_RootConstrainSelectedInstOperands,
     /* 276325 */     // GIR_Coverage, 5121,
     /* 276325 */     GIR_EraseRootFromParent_Done,
     /* 276326 */   // Label 5582: @276326
     /* 276326 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(276355), // Rule ID 5128 //
     /* 276331 */     // MIs[0] Operand 1
     /* 276331 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 276336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276344 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276353 */     GIR_RootConstrainSelectedInstOperands,
     /* 276354 */     // GIR_Coverage, 5128,
     /* 276354 */     GIR_EraseRootFromParent_Done,
     /* 276355 */   // Label 5583: @276355
     /* 276355 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(276384), // Rule ID 5135 //
     /* 276360 */     // MIs[0] Operand 1
     /* 276360 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 276365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276373 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276382 */     GIR_RootConstrainSelectedInstOperands,
     /* 276383 */     // GIR_Coverage, 5135,
     /* 276383 */     GIR_EraseRootFromParent_Done,
     /* 276384 */   // Label 5584: @276384
     /* 276384 */   GIM_Reject,
     /* 276385 */ // Label 5554: @276385
     /* 276385 */ GIM_Reject,
     /* 276386 */ // Label 5445: @276386
     /* 276386 */ GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(277433),
     /* 276391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 276394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 276397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276401 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(276441), // Rule ID 750 //
     /* 276406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276409 */     // MIs[0] Operand 1
     /* 276409 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276424 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276432 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276439 */     GIR_RootConstrainSelectedInstOperands,
     /* 276440 */     // GIR_Coverage, 750,
     /* 276440 */     GIR_EraseRootFromParent_Done,
     /* 276441 */   // Label 5586: @276441
     /* 276441 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(276481), // Rule ID 757 //
     /* 276446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276449 */     // MIs[0] Operand 1
     /* 276449 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276458 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276464 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276472 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276479 */     GIR_RootConstrainSelectedInstOperands,
     /* 276480 */     // GIR_Coverage, 757,
     /* 276480 */     GIR_EraseRootFromParent_Done,
     /* 276481 */   // Label 5587: @276481
     /* 276481 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(276518), // Rule ID 5172 //
     /* 276486 */     // MIs[0] Operand 1
     /* 276486 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276495 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276501 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276509 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276516 */     GIR_RootConstrainSelectedInstOperands,
     /* 276517 */     // GIR_Coverage, 5172,
     /* 276517 */     GIR_EraseRootFromParent_Done,
     /* 276518 */   // Label 5588: @276518
     /* 276518 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(276555), // Rule ID 5179 //
     /* 276523 */     // MIs[0] Operand 1
     /* 276523 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276532 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276538 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276546 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276553 */     GIR_RootConstrainSelectedInstOperands,
     /* 276554 */     // GIR_Coverage, 5179,
     /* 276554 */     GIR_EraseRootFromParent_Done,
     /* 276555 */   // Label 5589: @276555
     /* 276555 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(276592), // Rule ID 5186 //
     /* 276560 */     // MIs[0] Operand 1
     /* 276560 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276569 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276575 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276583 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276590 */     GIR_RootConstrainSelectedInstOperands,
     /* 276591 */     // GIR_Coverage, 5186,
     /* 276591 */     GIR_EraseRootFromParent_Done,
     /* 276592 */   // Label 5590: @276592
     /* 276592 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(276629), // Rule ID 5193 //
     /* 276597 */     // MIs[0] Operand 1
     /* 276597 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276606 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276612 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276620 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276627 */     GIR_RootConstrainSelectedInstOperands,
     /* 276628 */     // GIR_Coverage, 5193,
     /* 276628 */     GIR_EraseRootFromParent_Done,
     /* 276629 */   // Label 5591: @276629
     /* 276629 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(276666), // Rule ID 5200 //
     /* 276634 */     // MIs[0] Operand 1
     /* 276634 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276643 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276649 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276657 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276664 */     GIR_RootConstrainSelectedInstOperands,
     /* 276665 */     // GIR_Coverage, 5200,
     /* 276665 */     GIR_EraseRootFromParent_Done,
     /* 276666 */   // Label 5592: @276666
     /* 276666 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(276706), // Rule ID 722 //
     /* 276671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276674 */     // MIs[0] Operand 1
     /* 276674 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276687 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276693 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276697 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276704 */     GIR_RootConstrainSelectedInstOperands,
     /* 276705 */     // GIR_Coverage, 722,
     /* 276705 */     GIR_EraseRootFromParent_Done,
     /* 276706 */   // Label 5593: @276706
     /* 276706 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(276746), // Rule ID 729 //
     /* 276711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276714 */     // MIs[0] Operand 1
     /* 276714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276737 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276744 */     GIR_RootConstrainSelectedInstOperands,
     /* 276745 */     // GIR_Coverage, 729,
     /* 276745 */     GIR_EraseRootFromParent_Done,
     /* 276746 */   // Label 5594: @276746
     /* 276746 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(276786), // Rule ID 730 //
     /* 276751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276754 */     // MIs[0] Operand 1
     /* 276754 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276767 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276773 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 276775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276777 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276784 */     GIR_RootConstrainSelectedInstOperands,
     /* 276785 */     // GIR_Coverage, 730,
     /* 276785 */     GIR_EraseRootFromParent_Done,
     /* 276786 */   // Label 5595: @276786
     /* 276786 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(276826), // Rule ID 743 //
     /* 276791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276794 */     // MIs[0] Operand 1
     /* 276794 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276817 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276824 */     GIR_RootConstrainSelectedInstOperands,
     /* 276825 */     // GIR_Coverage, 743,
     /* 276825 */     GIR_EraseRootFromParent_Done,
     /* 276826 */   // Label 5596: @276826
     /* 276826 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(276863), // Rule ID 5137 //
     /* 276831 */     // MIs[0] Operand 1
     /* 276831 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276844 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276850 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276854 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276861 */     GIR_RootConstrainSelectedInstOperands,
     /* 276862 */     // GIR_Coverage, 5137,
     /* 276862 */     GIR_EraseRootFromParent_Done,
     /* 276863 */   // Label 5597: @276863
     /* 276863 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(276900), // Rule ID 5144 //
     /* 276868 */     // MIs[0] Operand 1
     /* 276868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276891 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276898 */     GIR_RootConstrainSelectedInstOperands,
     /* 276899 */     // GIR_Coverage, 5144,
     /* 276899 */     GIR_EraseRootFromParent_Done,
     /* 276900 */   // Label 5598: @276900
     /* 276900 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(276937), // Rule ID 5151 //
     /* 276905 */     // MIs[0] Operand 1
     /* 276905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276918 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276924 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276928 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276935 */     GIR_RootConstrainSelectedInstOperands,
     /* 276936 */     // GIR_Coverage, 5151,
     /* 276936 */     GIR_EraseRootFromParent_Done,
     /* 276937 */   // Label 5599: @276937
     /* 276937 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(276974), // Rule ID 5158 //
     /* 276942 */     // MIs[0] Operand 1
     /* 276942 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276955 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276961 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276965 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276972 */     GIR_RootConstrainSelectedInstOperands,
     /* 276973 */     // GIR_Coverage, 5158,
     /* 276973 */     GIR_EraseRootFromParent_Done,
     /* 276974 */   // Label 5600: @276974
     /* 276974 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(277011), // Rule ID 5165 //
     /* 276979 */     // MIs[0] Operand 1
     /* 276979 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276998 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277002 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 277005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277009 */     GIR_RootConstrainSelectedInstOperands,
     /* 277010 */     // GIR_Coverage, 5165,
     /* 277010 */     GIR_EraseRootFromParent_Done,
     /* 277011 */   // Label 5601: @277011
     /* 277011 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(277043), // Rule ID 1121 //
     /* 277016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277019 */     // MIs[0] Operand 1
     /* 277019 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277032 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 277035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277041 */     GIR_RootConstrainSelectedInstOperands,
     /* 277042 */     // GIR_Coverage, 1121,
     /* 277042 */     GIR_EraseRootFromParent_Done,
     /* 277043 */   // Label 5602: @277043
     /* 277043 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(277075), // Rule ID 1128 //
     /* 277048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277051 */     // MIs[0] Operand 1
     /* 277051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277064 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277073 */     GIR_RootConstrainSelectedInstOperands,
     /* 277074 */     // GIR_Coverage, 1128,
     /* 277074 */     GIR_EraseRootFromParent_Done,
     /* 277075 */   // Label 5603: @277075
     /* 277075 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(277107), // Rule ID 1135 //
     /* 277080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277083 */     // MIs[0] Operand 1
     /* 277083 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277096 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277105 */     GIR_RootConstrainSelectedInstOperands,
     /* 277106 */     // GIR_Coverage, 1135,
     /* 277106 */     GIR_EraseRootFromParent_Done,
     /* 277107 */   // Label 5604: @277107
     /* 277107 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(277139), // Rule ID 1142 //
     /* 277112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277115 */     // MIs[0] Operand 1
     /* 277115 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277128 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277137 */     GIR_RootConstrainSelectedInstOperands,
     /* 277138 */     // GIR_Coverage, 1142,
     /* 277138 */     GIR_EraseRootFromParent_Done,
     /* 277139 */   // Label 5605: @277139
     /* 277139 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(277171), // Rule ID 1149 //
     /* 277144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277147 */     // MIs[0] Operand 1
     /* 277147 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277160 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277169 */     GIR_RootConstrainSelectedInstOperands,
     /* 277170 */     // GIR_Coverage, 1149,
     /* 277170 */     GIR_EraseRootFromParent_Done,
     /* 277171 */   // Label 5606: @277171
     /* 277171 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(277200), // Rule ID 5074 //
     /* 277176 */     // MIs[0] Operand 1
     /* 277176 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277189 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 277192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277198 */     GIR_RootConstrainSelectedInstOperands,
     /* 277199 */     // GIR_Coverage, 5074,
     /* 277199 */     GIR_EraseRootFromParent_Done,
     /* 277200 */   // Label 5607: @277200
     /* 277200 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(277229), // Rule ID 5081 //
     /* 277205 */     // MIs[0] Operand 1
     /* 277205 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277218 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277227 */     GIR_RootConstrainSelectedInstOperands,
     /* 277228 */     // GIR_Coverage, 5081,
     /* 277228 */     GIR_EraseRootFromParent_Done,
     /* 277229 */   // Label 5608: @277229
     /* 277229 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(277258), // Rule ID 5088 //
     /* 277234 */     // MIs[0] Operand 1
     /* 277234 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277247 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277256 */     GIR_RootConstrainSelectedInstOperands,
     /* 277257 */     // GIR_Coverage, 5088,
     /* 277257 */     GIR_EraseRootFromParent_Done,
     /* 277258 */   // Label 5609: @277258
     /* 277258 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(277287), // Rule ID 5095 //
     /* 277263 */     // MIs[0] Operand 1
     /* 277263 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277276 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277285 */     GIR_RootConstrainSelectedInstOperands,
     /* 277286 */     // GIR_Coverage, 5095,
     /* 277286 */     GIR_EraseRootFromParent_Done,
     /* 277287 */   // Label 5610: @277287
     /* 277287 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(277316), // Rule ID 5102 //
     /* 277292 */     // MIs[0] Operand 1
     /* 277292 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277305 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277314 */     GIR_RootConstrainSelectedInstOperands,
     /* 277315 */     // GIR_Coverage, 5102,
     /* 277315 */     GIR_EraseRootFromParent_Done,
     /* 277316 */   // Label 5611: @277316
     /* 277316 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(277345), // Rule ID 5109 //
     /* 277321 */     // MIs[0] Operand 1
     /* 277321 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277334 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277343 */     GIR_RootConstrainSelectedInstOperands,
     /* 277344 */     // GIR_Coverage, 5109,
     /* 277344 */     GIR_EraseRootFromParent_Done,
     /* 277345 */   // Label 5612: @277345
     /* 277345 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(277374), // Rule ID 5116 //
     /* 277350 */     // MIs[0] Operand 1
     /* 277350 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277363 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277372 */     GIR_RootConstrainSelectedInstOperands,
     /* 277373 */     // GIR_Coverage, 5116,
     /* 277373 */     GIR_EraseRootFromParent_Done,
     /* 277374 */   // Label 5613: @277374
     /* 277374 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(277403), // Rule ID 5123 //
     /* 277379 */     // MIs[0] Operand 1
     /* 277379 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 277384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277392 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277401 */     GIR_RootConstrainSelectedInstOperands,
     /* 277402 */     // GIR_Coverage, 5123,
     /* 277402 */     GIR_EraseRootFromParent_Done,
     /* 277403 */   // Label 5614: @277403
     /* 277403 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(277432), // Rule ID 5130 //
     /* 277408 */     // MIs[0] Operand 1
     /* 277408 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 277413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277421 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277430 */     GIR_RootConstrainSelectedInstOperands,
     /* 277431 */     // GIR_Coverage, 5130,
     /* 277431 */     GIR_EraseRootFromParent_Done,
     /* 277432 */   // Label 5615: @277432
     /* 277432 */   GIM_Reject,
     /* 277433 */ // Label 5585: @277433
     /* 277433 */ GIM_Reject,
     /* 277434 */ // Label 5446: @277434
     /* 277434 */ GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(278481),
     /* 277439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 277445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277449 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(277489), // Rule ID 753 //
     /* 277454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277457 */     // MIs[0] Operand 1
     /* 277457 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277466 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277472 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277480 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277487 */     GIR_RootConstrainSelectedInstOperands,
     /* 277488 */     // GIR_Coverage, 753,
     /* 277488 */     GIR_EraseRootFromParent_Done,
     /* 277489 */   // Label 5617: @277489
     /* 277489 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(277529), // Rule ID 760 //
     /* 277494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277497 */     // MIs[0] Operand 1
     /* 277497 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277506 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277512 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277520 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277527 */     GIR_RootConstrainSelectedInstOperands,
     /* 277528 */     // GIR_Coverage, 760,
     /* 277528 */     GIR_EraseRootFromParent_Done,
     /* 277529 */   // Label 5618: @277529
     /* 277529 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(277566), // Rule ID 5175 //
     /* 277534 */     // MIs[0] Operand 1
     /* 277534 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277543 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277549 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277557 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277564 */     GIR_RootConstrainSelectedInstOperands,
     /* 277565 */     // GIR_Coverage, 5175,
     /* 277565 */     GIR_EraseRootFromParent_Done,
     /* 277566 */   // Label 5619: @277566
     /* 277566 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(277603), // Rule ID 5182 //
     /* 277571 */     // MIs[0] Operand 1
     /* 277571 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277580 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277586 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277594 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277601 */     GIR_RootConstrainSelectedInstOperands,
     /* 277602 */     // GIR_Coverage, 5182,
     /* 277602 */     GIR_EraseRootFromParent_Done,
     /* 277603 */   // Label 5620: @277603
     /* 277603 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(277640), // Rule ID 5189 //
     /* 277608 */     // MIs[0] Operand 1
     /* 277608 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277617 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277623 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277631 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277638 */     GIR_RootConstrainSelectedInstOperands,
     /* 277639 */     // GIR_Coverage, 5189,
     /* 277639 */     GIR_EraseRootFromParent_Done,
     /* 277640 */   // Label 5621: @277640
     /* 277640 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(277677), // Rule ID 5196 //
     /* 277645 */     // MIs[0] Operand 1
     /* 277645 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277654 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277660 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277668 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277675 */     GIR_RootConstrainSelectedInstOperands,
     /* 277676 */     // GIR_Coverage, 5196,
     /* 277676 */     GIR_EraseRootFromParent_Done,
     /* 277677 */   // Label 5622: @277677
     /* 277677 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(277714), // Rule ID 5203 //
     /* 277682 */     // MIs[0] Operand 1
     /* 277682 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277691 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277697 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277705 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277712 */     GIR_RootConstrainSelectedInstOperands,
     /* 277713 */     // GIR_Coverage, 5203,
     /* 277713 */     GIR_EraseRootFromParent_Done,
     /* 277714 */   // Label 5623: @277714
     /* 277714 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(277754), // Rule ID 725 //
     /* 277719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277722 */     // MIs[0] Operand 1
     /* 277722 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277735 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277741 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277745 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277752 */     GIR_RootConstrainSelectedInstOperands,
     /* 277753 */     // GIR_Coverage, 725,
     /* 277753 */     GIR_EraseRootFromParent_Done,
     /* 277754 */   // Label 5624: @277754
     /* 277754 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(277794), // Rule ID 735 //
     /* 277759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277762 */     // MIs[0] Operand 1
     /* 277762 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277775 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277781 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277785 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277792 */     GIR_RootConstrainSelectedInstOperands,
     /* 277793 */     // GIR_Coverage, 735,
     /* 277793 */     GIR_EraseRootFromParent_Done,
     /* 277794 */   // Label 5625: @277794
     /* 277794 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(277834), // Rule ID 736 //
     /* 277799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277802 */     // MIs[0] Operand 1
     /* 277802 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277815 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277821 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 277823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277825 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277832 */     GIR_RootConstrainSelectedInstOperands,
     /* 277833 */     // GIR_Coverage, 736,
     /* 277833 */     GIR_EraseRootFromParent_Done,
     /* 277834 */   // Label 5626: @277834
     /* 277834 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(277874), // Rule ID 746 //
     /* 277839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277842 */     // MIs[0] Operand 1
     /* 277842 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277865 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277872 */     GIR_RootConstrainSelectedInstOperands,
     /* 277873 */     // GIR_Coverage, 746,
     /* 277873 */     GIR_EraseRootFromParent_Done,
     /* 277874 */   // Label 5627: @277874
     /* 277874 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(277911), // Rule ID 5140 //
     /* 277879 */     // MIs[0] Operand 1
     /* 277879 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277892 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277898 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277902 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277909 */     GIR_RootConstrainSelectedInstOperands,
     /* 277910 */     // GIR_Coverage, 5140,
     /* 277910 */     GIR_EraseRootFromParent_Done,
     /* 277911 */   // Label 5628: @277911
     /* 277911 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(277948), // Rule ID 5147 //
     /* 277916 */     // MIs[0] Operand 1
     /* 277916 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277929 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277935 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277939 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277946 */     GIR_RootConstrainSelectedInstOperands,
     /* 277947 */     // GIR_Coverage, 5147,
     /* 277947 */     GIR_EraseRootFromParent_Done,
     /* 277948 */   // Label 5629: @277948
     /* 277948 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(277985), // Rule ID 5154 //
     /* 277953 */     // MIs[0] Operand 1
     /* 277953 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277966 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277972 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277976 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277983 */     GIR_RootConstrainSelectedInstOperands,
     /* 277984 */     // GIR_Coverage, 5154,
     /* 277984 */     GIR_EraseRootFromParent_Done,
     /* 277985 */   // Label 5630: @277985
     /* 277985 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(278022), // Rule ID 5161 //
     /* 277990 */     // MIs[0] Operand 1
     /* 277990 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278003 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278009 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278013 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 278016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278020 */     GIR_RootConstrainSelectedInstOperands,
     /* 278021 */     // GIR_Coverage, 5161,
     /* 278021 */     GIR_EraseRootFromParent_Done,
     /* 278022 */   // Label 5631: @278022
     /* 278022 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(278059), // Rule ID 5168 //
     /* 278027 */     // MIs[0] Operand 1
     /* 278027 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278040 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278046 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278050 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 278053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278057 */     GIR_RootConstrainSelectedInstOperands,
     /* 278058 */     // GIR_Coverage, 5168,
     /* 278058 */     GIR_EraseRootFromParent_Done,
     /* 278059 */   // Label 5632: @278059
     /* 278059 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(278091), // Rule ID 1124 //
     /* 278064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278067 */     // MIs[0] Operand 1
     /* 278067 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278080 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 278083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278089 */     GIR_RootConstrainSelectedInstOperands,
     /* 278090 */     // GIR_Coverage, 1124,
     /* 278090 */     GIR_EraseRootFromParent_Done,
     /* 278091 */   // Label 5633: @278091
     /* 278091 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(278123), // Rule ID 1131 //
     /* 278096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278099 */     // MIs[0] Operand 1
     /* 278099 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278112 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278121 */     GIR_RootConstrainSelectedInstOperands,
     /* 278122 */     // GIR_Coverage, 1131,
     /* 278122 */     GIR_EraseRootFromParent_Done,
     /* 278123 */   // Label 5634: @278123
     /* 278123 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(278155), // Rule ID 1138 //
     /* 278128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278131 */     // MIs[0] Operand 1
     /* 278131 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278144 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278153 */     GIR_RootConstrainSelectedInstOperands,
     /* 278154 */     // GIR_Coverage, 1138,
     /* 278154 */     GIR_EraseRootFromParent_Done,
     /* 278155 */   // Label 5635: @278155
     /* 278155 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(278187), // Rule ID 1145 //
     /* 278160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278163 */     // MIs[0] Operand 1
     /* 278163 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278176 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278185 */     GIR_RootConstrainSelectedInstOperands,
     /* 278186 */     // GIR_Coverage, 1145,
     /* 278186 */     GIR_EraseRootFromParent_Done,
     /* 278187 */   // Label 5636: @278187
     /* 278187 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(278219), // Rule ID 1152 //
     /* 278192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278195 */     // MIs[0] Operand 1
     /* 278195 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278208 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278217 */     GIR_RootConstrainSelectedInstOperands,
     /* 278218 */     // GIR_Coverage, 1152,
     /* 278218 */     GIR_EraseRootFromParent_Done,
     /* 278219 */   // Label 5637: @278219
     /* 278219 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(278248), // Rule ID 5077 //
     /* 278224 */     // MIs[0] Operand 1
     /* 278224 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278237 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 278240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278246 */     GIR_RootConstrainSelectedInstOperands,
     /* 278247 */     // GIR_Coverage, 5077,
     /* 278247 */     GIR_EraseRootFromParent_Done,
     /* 278248 */   // Label 5638: @278248
     /* 278248 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(278277), // Rule ID 5084 //
     /* 278253 */     // MIs[0] Operand 1
     /* 278253 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278266 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278275 */     GIR_RootConstrainSelectedInstOperands,
     /* 278276 */     // GIR_Coverage, 5084,
     /* 278276 */     GIR_EraseRootFromParent_Done,
     /* 278277 */   // Label 5639: @278277
     /* 278277 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(278306), // Rule ID 5091 //
     /* 278282 */     // MIs[0] Operand 1
     /* 278282 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278295 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278304 */     GIR_RootConstrainSelectedInstOperands,
     /* 278305 */     // GIR_Coverage, 5091,
     /* 278305 */     GIR_EraseRootFromParent_Done,
     /* 278306 */   // Label 5640: @278306
     /* 278306 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(278335), // Rule ID 5098 //
     /* 278311 */     // MIs[0] Operand 1
     /* 278311 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278324 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278333 */     GIR_RootConstrainSelectedInstOperands,
     /* 278334 */     // GIR_Coverage, 5098,
     /* 278334 */     GIR_EraseRootFromParent_Done,
     /* 278335 */   // Label 5641: @278335
     /* 278335 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(278364), // Rule ID 5105 //
     /* 278340 */     // MIs[0] Operand 1
     /* 278340 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278353 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278362 */     GIR_RootConstrainSelectedInstOperands,
     /* 278363 */     // GIR_Coverage, 5105,
     /* 278363 */     GIR_EraseRootFromParent_Done,
     /* 278364 */   // Label 5642: @278364
     /* 278364 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(278393), // Rule ID 5112 //
     /* 278369 */     // MIs[0] Operand 1
     /* 278369 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278382 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278391 */     GIR_RootConstrainSelectedInstOperands,
     /* 278392 */     // GIR_Coverage, 5112,
     /* 278392 */     GIR_EraseRootFromParent_Done,
     /* 278393 */   // Label 5643: @278393
     /* 278393 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(278422), // Rule ID 5119 //
     /* 278398 */     // MIs[0] Operand 1
     /* 278398 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278411 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278420 */     GIR_RootConstrainSelectedInstOperands,
     /* 278421 */     // GIR_Coverage, 5119,
     /* 278421 */     GIR_EraseRootFromParent_Done,
     /* 278422 */   // Label 5644: @278422
     /* 278422 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(278451), // Rule ID 5126 //
     /* 278427 */     // MIs[0] Operand 1
     /* 278427 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 278432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278440 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278449 */     GIR_RootConstrainSelectedInstOperands,
     /* 278450 */     // GIR_Coverage, 5126,
     /* 278450 */     GIR_EraseRootFromParent_Done,
     /* 278451 */   // Label 5645: @278451
     /* 278451 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(278480), // Rule ID 5133 //
     /* 278456 */     // MIs[0] Operand 1
     /* 278456 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 278461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278469 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278478 */     GIR_RootConstrainSelectedInstOperands,
     /* 278479 */     // GIR_Coverage, 5133,
     /* 278479 */     GIR_EraseRootFromParent_Done,
     /* 278480 */   // Label 5646: @278480
     /* 278480 */   GIM_Reject,
     /* 278481 */ // Label 5616: @278481
     /* 278481 */ GIM_Reject,
     /* 278482 */ // Label 5447: @278482
     /* 278482 */ GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(279529),
     /* 278487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 278493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278497 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(278537), // Rule ID 751 //
     /* 278502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278505 */     // MIs[0] Operand 1
     /* 278505 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278514 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278528 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278535 */     GIR_RootConstrainSelectedInstOperands,
     /* 278536 */     // GIR_Coverage, 751,
     /* 278536 */     GIR_EraseRootFromParent_Done,
     /* 278537 */   // Label 5648: @278537
     /* 278537 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(278577), // Rule ID 758 //
     /* 278542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278545 */     // MIs[0] Operand 1
     /* 278545 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278554 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278560 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278568 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278575 */     GIR_RootConstrainSelectedInstOperands,
     /* 278576 */     // GIR_Coverage, 758,
     /* 278576 */     GIR_EraseRootFromParent_Done,
     /* 278577 */   // Label 5649: @278577
     /* 278577 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(278614), // Rule ID 5173 //
     /* 278582 */     // MIs[0] Operand 1
     /* 278582 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278591 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278597 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278605 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278612 */     GIR_RootConstrainSelectedInstOperands,
     /* 278613 */     // GIR_Coverage, 5173,
     /* 278613 */     GIR_EraseRootFromParent_Done,
     /* 278614 */   // Label 5650: @278614
     /* 278614 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(278651), // Rule ID 5180 //
     /* 278619 */     // MIs[0] Operand 1
     /* 278619 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278628 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278634 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278642 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278649 */     GIR_RootConstrainSelectedInstOperands,
     /* 278650 */     // GIR_Coverage, 5180,
     /* 278650 */     GIR_EraseRootFromParent_Done,
     /* 278651 */   // Label 5651: @278651
     /* 278651 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(278688), // Rule ID 5187 //
     /* 278656 */     // MIs[0] Operand 1
     /* 278656 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278665 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278671 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278679 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278686 */     GIR_RootConstrainSelectedInstOperands,
     /* 278687 */     // GIR_Coverage, 5187,
     /* 278687 */     GIR_EraseRootFromParent_Done,
     /* 278688 */   // Label 5652: @278688
     /* 278688 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(278725), // Rule ID 5194 //
     /* 278693 */     // MIs[0] Operand 1
     /* 278693 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278702 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278708 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278716 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278723 */     GIR_RootConstrainSelectedInstOperands,
     /* 278724 */     // GIR_Coverage, 5194,
     /* 278724 */     GIR_EraseRootFromParent_Done,
     /* 278725 */   // Label 5653: @278725
     /* 278725 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(278762), // Rule ID 5201 //
     /* 278730 */     // MIs[0] Operand 1
     /* 278730 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278739 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278745 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278753 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278760 */     GIR_RootConstrainSelectedInstOperands,
     /* 278761 */     // GIR_Coverage, 5201,
     /* 278761 */     GIR_EraseRootFromParent_Done,
     /* 278762 */   // Label 5654: @278762
     /* 278762 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(278802), // Rule ID 723 //
     /* 278767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278770 */     // MIs[0] Operand 1
     /* 278770 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278783 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278789 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278793 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278800 */     GIR_RootConstrainSelectedInstOperands,
     /* 278801 */     // GIR_Coverage, 723,
     /* 278801 */     GIR_EraseRootFromParent_Done,
     /* 278802 */   // Label 5655: @278802
     /* 278802 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(278842), // Rule ID 731 //
     /* 278807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278810 */     // MIs[0] Operand 1
     /* 278810 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278823 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278829 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278833 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278840 */     GIR_RootConstrainSelectedInstOperands,
     /* 278841 */     // GIR_Coverage, 731,
     /* 278841 */     GIR_EraseRootFromParent_Done,
     /* 278842 */   // Label 5656: @278842
     /* 278842 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(278882), // Rule ID 732 //
     /* 278847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278850 */     // MIs[0] Operand 1
     /* 278850 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278863 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278869 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 278871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278873 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278880 */     GIR_RootConstrainSelectedInstOperands,
     /* 278881 */     // GIR_Coverage, 732,
     /* 278881 */     GIR_EraseRootFromParent_Done,
     /* 278882 */   // Label 5657: @278882
     /* 278882 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(278922), // Rule ID 744 //
     /* 278887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278890 */     // MIs[0] Operand 1
     /* 278890 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278913 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278920 */     GIR_RootConstrainSelectedInstOperands,
     /* 278921 */     // GIR_Coverage, 744,
     /* 278921 */     GIR_EraseRootFromParent_Done,
     /* 278922 */   // Label 5658: @278922
     /* 278922 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(278959), // Rule ID 5138 //
     /* 278927 */     // MIs[0] Operand 1
     /* 278927 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278940 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278946 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278950 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278957 */     GIR_RootConstrainSelectedInstOperands,
     /* 278958 */     // GIR_Coverage, 5138,
     /* 278958 */     GIR_EraseRootFromParent_Done,
     /* 278959 */   // Label 5659: @278959
     /* 278959 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(278996), // Rule ID 5145 //
     /* 278964 */     // MIs[0] Operand 1
     /* 278964 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278977 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278983 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278987 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278994 */     GIR_RootConstrainSelectedInstOperands,
     /* 278995 */     // GIR_Coverage, 5145,
     /* 278995 */     GIR_EraseRootFromParent_Done,
     /* 278996 */   // Label 5660: @278996
     /* 278996 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(279033), // Rule ID 5152 //
     /* 279001 */     // MIs[0] Operand 1
     /* 279001 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279014 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279020 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279024 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 279027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279031 */     GIR_RootConstrainSelectedInstOperands,
     /* 279032 */     // GIR_Coverage, 5152,
     /* 279032 */     GIR_EraseRootFromParent_Done,
     /* 279033 */   // Label 5661: @279033
     /* 279033 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(279070), // Rule ID 5159 //
     /* 279038 */     // MIs[0] Operand 1
     /* 279038 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279051 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279057 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279061 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 279064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279068 */     GIR_RootConstrainSelectedInstOperands,
     /* 279069 */     // GIR_Coverage, 5159,
     /* 279069 */     GIR_EraseRootFromParent_Done,
     /* 279070 */   // Label 5662: @279070
     /* 279070 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(279107), // Rule ID 5166 //
     /* 279075 */     // MIs[0] Operand 1
     /* 279075 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279088 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279094 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279098 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 279101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279105 */     GIR_RootConstrainSelectedInstOperands,
     /* 279106 */     // GIR_Coverage, 5166,
     /* 279106 */     GIR_EraseRootFromParent_Done,
     /* 279107 */   // Label 5663: @279107
     /* 279107 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(279139), // Rule ID 1122 //
     /* 279112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279115 */     // MIs[0] Operand 1
     /* 279115 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279128 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 279131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279137 */     GIR_RootConstrainSelectedInstOperands,
     /* 279138 */     // GIR_Coverage, 1122,
     /* 279138 */     GIR_EraseRootFromParent_Done,
     /* 279139 */   // Label 5664: @279139
     /* 279139 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(279171), // Rule ID 1129 //
     /* 279144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279147 */     // MIs[0] Operand 1
     /* 279147 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279160 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279169 */     GIR_RootConstrainSelectedInstOperands,
     /* 279170 */     // GIR_Coverage, 1129,
     /* 279170 */     GIR_EraseRootFromParent_Done,
     /* 279171 */   // Label 5665: @279171
     /* 279171 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(279203), // Rule ID 1136 //
     /* 279176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279179 */     // MIs[0] Operand 1
     /* 279179 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279192 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279201 */     GIR_RootConstrainSelectedInstOperands,
     /* 279202 */     // GIR_Coverage, 1136,
     /* 279202 */     GIR_EraseRootFromParent_Done,
     /* 279203 */   // Label 5666: @279203
     /* 279203 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(279235), // Rule ID 1143 //
     /* 279208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279211 */     // MIs[0] Operand 1
     /* 279211 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279224 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279233 */     GIR_RootConstrainSelectedInstOperands,
     /* 279234 */     // GIR_Coverage, 1143,
     /* 279234 */     GIR_EraseRootFromParent_Done,
     /* 279235 */   // Label 5667: @279235
     /* 279235 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(279267), // Rule ID 1150 //
     /* 279240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279243 */     // MIs[0] Operand 1
     /* 279243 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279256 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279265 */     GIR_RootConstrainSelectedInstOperands,
     /* 279266 */     // GIR_Coverage, 1150,
     /* 279266 */     GIR_EraseRootFromParent_Done,
     /* 279267 */   // Label 5668: @279267
     /* 279267 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(279296), // Rule ID 5075 //
     /* 279272 */     // MIs[0] Operand 1
     /* 279272 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279285 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 279288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279294 */     GIR_RootConstrainSelectedInstOperands,
     /* 279295 */     // GIR_Coverage, 5075,
     /* 279295 */     GIR_EraseRootFromParent_Done,
     /* 279296 */   // Label 5669: @279296
     /* 279296 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(279325), // Rule ID 5082 //
     /* 279301 */     // MIs[0] Operand 1
     /* 279301 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279314 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279323 */     GIR_RootConstrainSelectedInstOperands,
     /* 279324 */     // GIR_Coverage, 5082,
     /* 279324 */     GIR_EraseRootFromParent_Done,
     /* 279325 */   // Label 5670: @279325
     /* 279325 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(279354), // Rule ID 5089 //
     /* 279330 */     // MIs[0] Operand 1
     /* 279330 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279343 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279352 */     GIR_RootConstrainSelectedInstOperands,
     /* 279353 */     // GIR_Coverage, 5089,
     /* 279353 */     GIR_EraseRootFromParent_Done,
     /* 279354 */   // Label 5671: @279354
     /* 279354 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(279383), // Rule ID 5096 //
     /* 279359 */     // MIs[0] Operand 1
     /* 279359 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279372 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279381 */     GIR_RootConstrainSelectedInstOperands,
     /* 279382 */     // GIR_Coverage, 5096,
     /* 279382 */     GIR_EraseRootFromParent_Done,
     /* 279383 */   // Label 5672: @279383
     /* 279383 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(279412), // Rule ID 5103 //
     /* 279388 */     // MIs[0] Operand 1
     /* 279388 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279401 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279410 */     GIR_RootConstrainSelectedInstOperands,
     /* 279411 */     // GIR_Coverage, 5103,
     /* 279411 */     GIR_EraseRootFromParent_Done,
     /* 279412 */   // Label 5673: @279412
     /* 279412 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(279441), // Rule ID 5110 //
     /* 279417 */     // MIs[0] Operand 1
     /* 279417 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279430 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279439 */     GIR_RootConstrainSelectedInstOperands,
     /* 279440 */     // GIR_Coverage, 5110,
     /* 279440 */     GIR_EraseRootFromParent_Done,
     /* 279441 */   // Label 5674: @279441
     /* 279441 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(279470), // Rule ID 5117 //
     /* 279446 */     // MIs[0] Operand 1
     /* 279446 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279459 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279468 */     GIR_RootConstrainSelectedInstOperands,
     /* 279469 */     // GIR_Coverage, 5117,
     /* 279469 */     GIR_EraseRootFromParent_Done,
     /* 279470 */   // Label 5675: @279470
     /* 279470 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(279499), // Rule ID 5124 //
     /* 279475 */     // MIs[0] Operand 1
     /* 279475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 279480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279488 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279497 */     GIR_RootConstrainSelectedInstOperands,
     /* 279498 */     // GIR_Coverage, 5124,
     /* 279498 */     GIR_EraseRootFromParent_Done,
     /* 279499 */   // Label 5676: @279499
     /* 279499 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(279528), // Rule ID 5131 //
     /* 279504 */     // MIs[0] Operand 1
     /* 279504 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 279509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279517 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279526 */     GIR_RootConstrainSelectedInstOperands,
     /* 279527 */     // GIR_Coverage, 5131,
     /* 279527 */     GIR_EraseRootFromParent_Done,
     /* 279528 */   // Label 5677: @279528
     /* 279528 */   GIM_Reject,
     /* 279529 */ // Label 5647: @279529
     /* 279529 */ GIM_Reject,
     /* 279530 */ // Label 5448: @279530
     /* 279530 */ GIM_Reject,
     /* 279531 */ // Label 50: @279531
     /* 279531 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5690*/ GIMT_Encode4(280575),
     /* 279542 */ /*GILLT_nxv1s1*//*Label 5678*/ GIMT_Encode4(279590),
     /* 279546 */ /*GILLT_nxv2s1*//*Label 5679*/ GIMT_Encode4(279619),
     /* 279550 */ /*GILLT_nxv2s16*//*Label 5680*/ GIMT_Encode4(279648),
     /* 279554 */ /*GILLT_nxv2s32*//*Label 5681*/ GIMT_Encode4(279733),
     /* 279558 */ /*GILLT_nxv2s64*//*Label 5682*/ GIMT_Encode4(279818),
     /* 279562 */ /*GILLT_nxv4s1*//*Label 5683*/ GIMT_Encode4(279984),
     /* 279566 */ /*GILLT_nxv4s16*//*Label 5684*/ GIMT_Encode4(280013),
     /* 279570 */ /*GILLT_nxv4s32*//*Label 5685*/ GIMT_Encode4(280098),
     /* 279574 */ /*GILLT_nxv8s1*//*Label 5686*/ GIMT_Encode4(280264),
     /* 279578 */ /*GILLT_nxv8s16*//*Label 5687*/ GIMT_Encode4(280293),
     /* 279582 */ /*GILLT_nxv16s1*//*Label 5688*/ GIMT_Encode4(280459),
     /* 279586 */ /*GILLT_nxv16s8*//*Label 5689*/ GIMT_Encode4(280488),
     /* 279590 */ // Label 5678: @279590
     /* 279590 */ GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(279618), // Rule ID 8425 //
     /* 279595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 279601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 279604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 279607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279611 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 279611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279616 */   GIR_RootConstrainSelectedInstOperands,
     /* 279617 */   // GIR_Coverage, 8425,
     /* 279617 */   GIR_Done,
     /* 279618 */ // Label 5691: @279618
     /* 279618 */ GIM_Reject,
     /* 279619 */ // Label 5679: @279619
     /* 279619 */ GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(279647), // Rule ID 8424 //
     /* 279624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 279633 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 279636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279640 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 279640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279645 */   GIR_RootConstrainSelectedInstOperands,
     /* 279646 */   // GIR_Coverage, 8424,
     /* 279646 */   GIR_Done,
     /* 279647 */ // Label 5692: @279647
     /* 279647 */ GIM_Reject,
     /* 279648 */ // Label 5680: @279648
     /* 279648 */ GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(279732),
     /* 279653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 279659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 279662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279666 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(279716), // Rule ID 3161 //
     /* 279671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279694 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279698 */     // MIs[2] Operand 1
     /* 279698 */     // No operand predicates
     /* 279698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279700 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 279700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 279703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279705 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279707 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279709 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 279714 */     GIR_RootConstrainSelectedInstOperands,
     /* 279715 */     // GIR_Coverage, 3161,
     /* 279715 */     GIR_EraseRootFromParent_Done,
     /* 279716 */   // Label 5694: @279716
     /* 279716 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(279731), // Rule ID 2741 //
     /* 279721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279724 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 279724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279729 */     GIR_RootConstrainSelectedInstOperands,
     /* 279730 */     // GIR_Coverage, 2741,
     /* 279730 */     GIR_Done,
     /* 279731 */   // Label 5695: @279731
     /* 279731 */   GIM_Reject,
     /* 279732 */ // Label 5693: @279732
     /* 279732 */ GIM_Reject,
     /* 279733 */ // Label 5681: @279733
     /* 279733 */ GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(279817),
     /* 279738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 279744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 279747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279751 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(279801), // Rule ID 3163 //
     /* 279756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 279771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279779 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279783 */     // MIs[2] Operand 1
     /* 279783 */     // No operand predicates
     /* 279783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279785 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 279785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 279788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279790 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279792 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279794 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 279799 */     GIR_RootConstrainSelectedInstOperands,
     /* 279800 */     // GIR_Coverage, 3163,
     /* 279800 */     GIR_EraseRootFromParent_Done,
     /* 279801 */   // Label 5697: @279801
     /* 279801 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(279816), // Rule ID 2742 //
     /* 279806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279809 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 279809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279814 */     GIR_RootConstrainSelectedInstOperands,
     /* 279815 */     // GIR_Coverage, 2742,
     /* 279815 */     GIR_Done,
     /* 279816 */   // Label 5698: @279816
     /* 279816 */   GIM_Reject,
     /* 279817 */ // Label 5696: @279817
     /* 279817 */ GIM_Reject,
     /* 279818 */ // Label 5682: @279818
     /* 279818 */ GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(279983),
     /* 279823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 279829 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(279886), // Rule ID 3164 //
     /* 279834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 279856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279864 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 279868 */     // MIs[2] Operand 1
     /* 279868 */     // No operand predicates
     /* 279868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279870 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 279870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 279873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279875 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279877 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279879 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 279884 */     GIR_RootConstrainSelectedInstOperands,
     /* 279885 */     // GIR_Coverage, 3164,
     /* 279885 */     GIR_EraseRootFromParent_Done,
     /* 279886 */   // Label 5700: @279886
     /* 279886 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(279938), // Rule ID 7471 //
     /* 279891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 279906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 279910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 279914 */     // MIs[0] Op2
     /* 279914 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 279919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279921 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 279921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 279924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 279926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 279928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 279932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 279936 */     GIR_RootConstrainSelectedInstOperands,
     /* 279937 */     // GIR_Coverage, 7471,
     /* 279937 */     GIR_EraseRootFromParent_Done,
     /* 279938 */   // Label 5701: @279938
     /* 279938 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(279960), // Rule ID 2737 //
     /* 279943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279953 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 279953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279958 */     GIR_RootConstrainSelectedInstOperands,
     /* 279959 */     // GIR_Coverage, 2737,
     /* 279959 */     GIR_Done,
     /* 279960 */   // Label 5702: @279960
     /* 279960 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(279982), // Rule ID 2743 //
     /* 279965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279975 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 279975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279980 */     GIR_RootConstrainSelectedInstOperands,
     /* 279981 */     // GIR_Coverage, 2743,
     /* 279981 */     GIR_Done,
     /* 279982 */   // Label 5703: @279982
     /* 279982 */   GIM_Reject,
     /* 279983 */ // Label 5699: @279983
     /* 279983 */ GIM_Reject,
     /* 279984 */ // Label 5683: @279984
     /* 279984 */ GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(280012), // Rule ID 8423 //
     /* 279989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 279995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 279998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 280001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280005 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 280005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280010 */   GIR_RootConstrainSelectedInstOperands,
     /* 280011 */   // GIR_Coverage, 8423,
     /* 280011 */   GIR_Done,
     /* 280012 */ // Label 5704: @280012
     /* 280012 */ GIM_Reject,
     /* 280013 */ // Label 5684: @280013
     /* 280013 */ GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(280097),
     /* 280018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 280021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 280024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 280027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280031 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(280081), // Rule ID 3160 //
     /* 280036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280059 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 280063 */     // MIs[2] Operand 1
     /* 280063 */     // No operand predicates
     /* 280063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280065 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 280065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 280068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280070 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280072 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280074 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 280079 */     GIR_RootConstrainSelectedInstOperands,
     /* 280080 */     // GIR_Coverage, 3160,
     /* 280080 */     GIR_EraseRootFromParent_Done,
     /* 280081 */   // Label 5706: @280081
     /* 280081 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(280096), // Rule ID 2739 //
     /* 280086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280089 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 280089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280094 */     GIR_RootConstrainSelectedInstOperands,
     /* 280095 */     // GIR_Coverage, 2739,
     /* 280095 */     GIR_Done,
     /* 280096 */   // Label 5707: @280096
     /* 280096 */   GIM_Reject,
     /* 280097 */ // Label 5705: @280097
     /* 280097 */ GIM_Reject,
     /* 280098 */ // Label 5685: @280098
     /* 280098 */ GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(280263),
     /* 280103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 280106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 280109 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(280166), // Rule ID 3162 //
     /* 280114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280144 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 280148 */     // MIs[2] Operand 1
     /* 280148 */     // No operand predicates
     /* 280148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280150 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 280150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 280153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280155 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280157 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280159 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 280164 */     GIR_RootConstrainSelectedInstOperands,
     /* 280165 */     // GIR_Coverage, 3162,
     /* 280165 */     GIR_EraseRootFromParent_Done,
     /* 280166 */   // Label 5709: @280166
     /* 280166 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(280218), // Rule ID 7469 //
     /* 280171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 280190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 280194 */     // MIs[0] Op2
     /* 280194 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280201 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 280201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 280204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280216 */     GIR_RootConstrainSelectedInstOperands,
     /* 280217 */     // GIR_Coverage, 7469,
     /* 280217 */     GIR_EraseRootFromParent_Done,
     /* 280218 */   // Label 5710: @280218
     /* 280218 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(280240), // Rule ID 2736 //
     /* 280223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280233 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 280233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280238 */     GIR_RootConstrainSelectedInstOperands,
     /* 280239 */     // GIR_Coverage, 2736,
     /* 280239 */     GIR_Done,
     /* 280240 */   // Label 5711: @280240
     /* 280240 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(280262), // Rule ID 2740 //
     /* 280245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280255 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 280255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280260 */     GIR_RootConstrainSelectedInstOperands,
     /* 280261 */     // GIR_Coverage, 2740,
     /* 280261 */     GIR_Done,
     /* 280262 */   // Label 5712: @280262
     /* 280262 */   GIM_Reject,
     /* 280263 */ // Label 5708: @280263
     /* 280263 */ GIM_Reject,
     /* 280264 */ // Label 5686: @280264
     /* 280264 */ GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(280292), // Rule ID 8422 //
     /* 280269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 280275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 280278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 280281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280285 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 280285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280290 */   GIR_RootConstrainSelectedInstOperands,
     /* 280291 */   // GIR_Coverage, 8422,
     /* 280291 */   GIR_Done,
     /* 280292 */ // Label 5713: @280292
     /* 280292 */ GIM_Reject,
     /* 280293 */ // Label 5687: @280293
     /* 280293 */ GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(280458),
     /* 280298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 280301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280304 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(280361), // Rule ID 3159 //
     /* 280309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280339 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 280343 */     // MIs[2] Operand 1
     /* 280343 */     // No operand predicates
     /* 280343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280345 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 280345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 280348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280350 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280352 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280354 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 280359 */     GIR_RootConstrainSelectedInstOperands,
     /* 280360 */     // GIR_Coverage, 3159,
     /* 280360 */     GIR_EraseRootFromParent_Done,
     /* 280361 */   // Label 5715: @280361
     /* 280361 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(280413), // Rule ID 7467 //
     /* 280366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280389 */     // MIs[0] Op2
     /* 280389 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280396 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 280396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 280399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280411 */     GIR_RootConstrainSelectedInstOperands,
     /* 280412 */     // GIR_Coverage, 7467,
     /* 280412 */     GIR_EraseRootFromParent_Done,
     /* 280413 */   // Label 5716: @280413
     /* 280413 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(280435), // Rule ID 2735 //
     /* 280418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280428 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 280428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 280433 */     GIR_RootConstrainSelectedInstOperands,
     /* 280434 */     // GIR_Coverage, 2735,
     /* 280434 */     GIR_Done,
     /* 280435 */   // Label 5717: @280435
     /* 280435 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(280457), // Rule ID 2738 //
     /* 280440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280450 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 280450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 280455 */     GIR_RootConstrainSelectedInstOperands,
     /* 280456 */     // GIR_Coverage, 2738,
     /* 280456 */     GIR_Done,
     /* 280457 */   // Label 5718: @280457
     /* 280457 */   GIM_Reject,
     /* 280458 */ // Label 5714: @280458
     /* 280458 */ GIM_Reject,
     /* 280459 */ // Label 5688: @280459
     /* 280459 */ GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(280487), // Rule ID 8421 //
     /* 280464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 280470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 280473 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 280476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280480 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 280480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280485 */   GIR_RootConstrainSelectedInstOperands,
     /* 280486 */   // GIR_Coverage, 8421,
     /* 280486 */   GIR_Done,
     /* 280487 */ // Label 5719: @280487
     /* 280487 */ GIM_Reject,
     /* 280488 */ // Label 5689: @280488
     /* 280488 */ GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(280574),
     /* 280493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 280496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 280499 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(280551), // Rule ID 7465 //
     /* 280504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 280523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 280527 */     // MIs[0] Op2
     /* 280527 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280534 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 280534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 280537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280549 */     GIR_RootConstrainSelectedInstOperands,
     /* 280550 */     // GIR_Coverage, 7465,
     /* 280550 */     GIR_EraseRootFromParent_Done,
     /* 280551 */   // Label 5721: @280551
     /* 280551 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(280573), // Rule ID 2734 //
     /* 280556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 280562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280566 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 280566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 280571 */     GIR_RootConstrainSelectedInstOperands,
     /* 280572 */     // GIR_Coverage, 2734,
     /* 280572 */     GIR_Done,
     /* 280573 */   // Label 5722: @280573
     /* 280573 */   GIM_Reject,
     /* 280574 */ // Label 5720: @280574
     /* 280574 */ GIM_Reject,
     /* 280575 */ // Label 5690: @280575
     /* 280575 */ GIM_Reject,
     /* 280576 */ // Label 51: @280576
     /* 280576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5727*/ GIMT_Encode4(281059),
     /* 280587 */ /*GILLT_s64*//*Label 5723*/ GIMT_Encode4(280623), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 280607 */ /*GILLT_v4s32*//*Label 5724*/ GIMT_Encode4(280654), GIMT_Encode4(0),
     /* 280615 */ /*GILLT_v8s16*//*Label 5725*/ GIMT_Encode4(280789),
     /* 280619 */ /*GILLT_v16s8*//*Label 5726*/ GIMT_Encode4(280924),
     /* 280623 */ // Label 5723: @280623
     /* 280623 */ GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(280653), // Rule ID 128 //
     /* 280628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 280631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 280634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280646 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 280646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 280651 */   GIR_RootConstrainSelectedInstOperands,
     /* 280652 */   // GIR_Coverage, 128,
     /* 280652 */   GIR_Done,
     /* 280653 */ // Label 5728: @280653
     /* 280653 */ GIM_Reject,
     /* 280654 */ // Label 5724: @280654
     /* 280654 */ GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(280788), // Rule ID 6523 //
     /* 280659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280677 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 280677 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280680 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 280684 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280689 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280693 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280699 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280702 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280706 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280711 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280717 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280722 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280727 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280730 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280734 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280739 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280745 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280750 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 280762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280767 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280770 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 280778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280786 */   GIR_RootConstrainSelectedInstOperands,
     /* 280787 */   // GIR_Coverage, 6523,
     /* 280787 */   GIR_EraseRootFromParent_Done,
     /* 280788 */ // Label 5729: @280788
     /* 280788 */ GIM_Reject,
     /* 280789 */ // Label 5725: @280789
     /* 280789 */ GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(280923), // Rule ID 6522 //
     /* 280794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280812 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 280812 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280815 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 280819 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280824 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280828 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280834 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280837 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280841 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280846 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280852 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280857 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280874 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280880 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280885 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 280897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280902 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280905 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 280913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280921 */   GIR_RootConstrainSelectedInstOperands,
     /* 280922 */   // GIR_Coverage, 6522,
     /* 280922 */   GIR_EraseRootFromParent_Done,
     /* 280923 */ // Label 5730: @280923
     /* 280923 */ GIM_Reject,
     /* 280924 */ // Label 5726: @280924
     /* 280924 */ GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(281058), // Rule ID 6521 //
     /* 280929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 280932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280947 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 280947 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280950 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 280954 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280959 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280963 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280969 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280972 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280976 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280981 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280987 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280992 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280997 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281000 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281004 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281009 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281015 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281020 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 281032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281037 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281040 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 281048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281053 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281056 */   GIR_RootConstrainSelectedInstOperands,
     /* 281057 */   // GIR_Coverage, 6521,
     /* 281057 */   GIR_EraseRootFromParent_Done,
     /* 281058 */ // Label 5731: @281058
     /* 281058 */ GIM_Reject,
     /* 281059 */ // Label 5727: @281059
     /* 281059 */ GIM_Reject,
     /* 281060 */ // Label 52: @281060
     /* 281060 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5736*/ GIMT_Encode4(281543),
     /* 281071 */ /*GILLT_s64*//*Label 5732*/ GIMT_Encode4(281107), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281091 */ /*GILLT_v4s32*//*Label 5733*/ GIMT_Encode4(281138), GIMT_Encode4(0),
     /* 281099 */ /*GILLT_v8s16*//*Label 5734*/ GIMT_Encode4(281273),
     /* 281103 */ /*GILLT_v16s8*//*Label 5735*/ GIMT_Encode4(281408),
     /* 281107 */ // Label 5732: @281107
     /* 281107 */ GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(281137), // Rule ID 127 //
     /* 281112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 281118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281126 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281130 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 281130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 281135 */   GIR_RootConstrainSelectedInstOperands,
     /* 281136 */   // GIR_Coverage, 127,
     /* 281136 */   GIR_Done,
     /* 281137 */ // Label 5737: @281137
     /* 281137 */ GIM_Reject,
     /* 281138 */ // Label 5733: @281138
     /* 281138 */ GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(281272), // Rule ID 6520 //
     /* 281143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281161 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 281161 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281164 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 281168 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281173 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281177 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281183 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281186 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281190 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281195 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281201 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281206 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281211 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281214 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281218 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281223 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281229 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281234 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 281246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281251 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281254 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 281262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281270 */   GIR_RootConstrainSelectedInstOperands,
     /* 281271 */   // GIR_Coverage, 6520,
     /* 281271 */   GIR_EraseRootFromParent_Done,
     /* 281272 */ // Label 5738: @281272
     /* 281272 */ GIM_Reject,
     /* 281273 */ // Label 5734: @281273
     /* 281273 */ GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(281407), // Rule ID 6519 //
     /* 281278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281296 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 281296 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281299 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 281303 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281308 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281312 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281318 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281321 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281325 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281330 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281336 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281341 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281346 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281349 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281353 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281358 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281364 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281369 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281374 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281377 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 281381 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281386 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281389 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 281397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281405 */   GIR_RootConstrainSelectedInstOperands,
     /* 281406 */   // GIR_Coverage, 6519,
     /* 281406 */   GIR_EraseRootFromParent_Done,
     /* 281407 */ // Label 5739: @281407
     /* 281407 */ GIM_Reject,
     /* 281408 */ // Label 5735: @281408
     /* 281408 */ GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(281542), // Rule ID 6518 //
     /* 281413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281431 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 281431 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281434 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 281438 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281443 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281447 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281453 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281456 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281460 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281465 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281471 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281476 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281481 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281484 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281488 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281493 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281499 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281504 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 281516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281521 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 281532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281540 */   GIR_RootConstrainSelectedInstOperands,
     /* 281541 */   // GIR_Coverage, 6518,
     /* 281541 */   GIR_EraseRootFromParent_Done,
     /* 281542 */ // Label 5740: @281542
     /* 281542 */ GIM_Reject,
     /* 281543 */ // Label 5736: @281543
     /* 281543 */ GIM_Reject,
     /* 281544 */ // Label 53: @281544
     /* 281544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5752*/ GIMT_Encode4(281973),
     /* 281555 */ /*GILLT_v2s32*//*Label 5741*/ GIMT_Encode4(281631),
     /* 281559 */ /*GILLT_v2s64*//*Label 5742*/ GIMT_Encode4(281665),
     /* 281563 */ /*GILLT_v4s16*//*Label 5743*/ GIMT_Encode4(281699),
     /* 281567 */ /*GILLT_v4s32*//*Label 5744*/ GIMT_Encode4(281733),
     /* 281571 */ /*GILLT_v8s8*//*Label 5745*/ GIMT_Encode4(281767),
     /* 281575 */ /*GILLT_v8s16*//*Label 5746*/ GIMT_Encode4(281801),
     /* 281579 */ /*GILLT_v16s8*//*Label 5747*/ GIMT_Encode4(281835), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281599 */ /*GILLT_nxv2s64*//*Label 5748*/ GIMT_Encode4(281869), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281611 */ /*GILLT_nxv4s32*//*Label 5749*/ GIMT_Encode4(281895), GIMT_Encode4(0),
     /* 281619 */ /*GILLT_nxv8s16*//*Label 5750*/ GIMT_Encode4(281921), GIMT_Encode4(0),
     /* 281627 */ /*GILLT_nxv16s8*//*Label 5751*/ GIMT_Encode4(281947),
     /* 281631 */ // Label 5741: @281631
     /* 281631 */ GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(281664), // Rule ID 5023 //
     /* 281636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 281645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281657 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 281657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 281662 */   GIR_RootConstrainSelectedInstOperands,
     /* 281663 */   // GIR_Coverage, 5023,
     /* 281663 */   GIR_Done,
     /* 281664 */ // Label 5753: @281664
     /* 281664 */ GIM_Reject,
     /* 281665 */ // Label 5742: @281665
     /* 281665 */ GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(281698), // Rule ID 5027 //
     /* 281670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 281676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 281679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281691 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 281691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 281696 */   GIR_RootConstrainSelectedInstOperands,
     /* 281697 */   // GIR_Coverage, 5027,
     /* 281697 */   GIR_Done,
     /* 281698 */ // Label 5754: @281698
     /* 281698 */ GIM_Reject,
     /* 281699 */ // Label 5743: @281699
     /* 281699 */ GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(281732), // Rule ID 5022 //
     /* 281704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281725 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 281725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 281730 */   GIR_RootConstrainSelectedInstOperands,
     /* 281731 */   // GIR_Coverage, 5022,
     /* 281731 */   GIR_Done,
     /* 281732 */ // Label 5755: @281732
     /* 281732 */ GIM_Reject,
     /* 281733 */ // Label 5744: @281733
     /* 281733 */ GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(281766), // Rule ID 5026 //
     /* 281738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281759 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 281759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 281764 */   GIR_RootConstrainSelectedInstOperands,
     /* 281765 */   // GIR_Coverage, 5026,
     /* 281765 */   GIR_Done,
     /* 281766 */ // Label 5756: @281766
     /* 281766 */ GIM_Reject,
     /* 281767 */ // Label 5745: @281767
     /* 281767 */ GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(281800), // Rule ID 5021 //
     /* 281772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 281778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281793 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 281793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 281798 */   GIR_RootConstrainSelectedInstOperands,
     /* 281799 */   // GIR_Coverage, 5021,
     /* 281799 */   GIR_Done,
     /* 281800 */ // Label 5757: @281800
     /* 281800 */ GIM_Reject,
     /* 281801 */ // Label 5746: @281801
     /* 281801 */ GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(281834), // Rule ID 5025 //
     /* 281806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281827 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 281827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 281832 */   GIR_RootConstrainSelectedInstOperands,
     /* 281833 */   // GIR_Coverage, 5025,
     /* 281833 */   GIR_Done,
     /* 281834 */ // Label 5758: @281834
     /* 281834 */ GIM_Reject,
     /* 281835 */ // Label 5747: @281835
     /* 281835 */ GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(281868), // Rule ID 5024 //
     /* 281840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281861 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 281861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 281866 */   GIR_RootConstrainSelectedInstOperands,
     /* 281867 */   // GIR_Coverage, 5024,
     /* 281867 */   GIR_Done,
     /* 281868 */ // Label 5759: @281868
     /* 281868 */ GIM_Reject,
     /* 281869 */ // Label 5748: @281869
     /* 281869 */ GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(281894), // Rule ID 7423 //
     /* 281874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 281880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 281883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281887 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 281887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 281892 */   GIR_RootConstrainSelectedInstOperands,
     /* 281893 */   // GIR_Coverage, 7423,
     /* 281893 */   GIR_Done,
     /* 281894 */ // Label 5760: @281894
     /* 281894 */ GIM_Reject,
     /* 281895 */ // Label 5749: @281895
     /* 281895 */ GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(281920), // Rule ID 7422 //
     /* 281900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 281909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281913 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 281913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 281918 */   GIR_RootConstrainSelectedInstOperands,
     /* 281919 */   // GIR_Coverage, 7422,
     /* 281919 */   GIR_Done,
     /* 281920 */ // Label 5761: @281920
     /* 281920 */ GIM_Reject,
     /* 281921 */ // Label 5750: @281921
     /* 281921 */ GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(281946), // Rule ID 7421 //
     /* 281926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 281935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281939 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 281939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 281944 */   GIR_RootConstrainSelectedInstOperands,
     /* 281945 */   // GIR_Coverage, 7421,
     /* 281945 */   GIR_Done,
     /* 281946 */ // Label 5762: @281946
     /* 281946 */ GIM_Reject,
     /* 281947 */ // Label 5751: @281947
     /* 281947 */ GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(281972), // Rule ID 7420 //
     /* 281952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 281961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281965 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 281965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 281970 */   GIR_RootConstrainSelectedInstOperands,
     /* 281971 */   // GIR_Coverage, 7420,
     /* 281971 */   GIR_Done,
     /* 281972 */ // Label 5763: @281972
     /* 281972 */ GIM_Reject,
     /* 281973 */ // Label 5752: @281973
     /* 281973 */ GIM_Reject,
     /* 281974 */ // Label 54: @281974
     /* 281974 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5775*/ GIMT_Encode4(282403),
     /* 281985 */ /*GILLT_v2s32*//*Label 5764*/ GIMT_Encode4(282061),
     /* 281989 */ /*GILLT_v2s64*//*Label 5765*/ GIMT_Encode4(282095),
     /* 281993 */ /*GILLT_v4s16*//*Label 5766*/ GIMT_Encode4(282129),
     /* 281997 */ /*GILLT_v4s32*//*Label 5767*/ GIMT_Encode4(282163),
     /* 282001 */ /*GILLT_v8s8*//*Label 5768*/ GIMT_Encode4(282197),
     /* 282005 */ /*GILLT_v8s16*//*Label 5769*/ GIMT_Encode4(282231),
     /* 282009 */ /*GILLT_v16s8*//*Label 5770*/ GIMT_Encode4(282265), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282029 */ /*GILLT_nxv2s64*//*Label 5771*/ GIMT_Encode4(282299), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282041 */ /*GILLT_nxv4s32*//*Label 5772*/ GIMT_Encode4(282325), GIMT_Encode4(0),
     /* 282049 */ /*GILLT_nxv8s16*//*Label 5773*/ GIMT_Encode4(282351), GIMT_Encode4(0),
     /* 282057 */ /*GILLT_nxv16s8*//*Label 5774*/ GIMT_Encode4(282377),
     /* 282061 */ // Label 5764: @282061
     /* 282061 */ GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(282094), // Rule ID 2477 //
     /* 282066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282087 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 282092 */   GIR_RootConstrainSelectedInstOperands,
     /* 282093 */   // GIR_Coverage, 2477,
     /* 282093 */   GIR_Done,
     /* 282094 */ // Label 5776: @282094
     /* 282094 */ GIM_Reject,
     /* 282095 */ // Label 5765: @282095
     /* 282095 */ GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(282128), // Rule ID 2481 //
     /* 282100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282121 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 282126 */   GIR_RootConstrainSelectedInstOperands,
     /* 282127 */   // GIR_Coverage, 2481,
     /* 282127 */   GIR_Done,
     /* 282128 */ // Label 5777: @282128
     /* 282128 */ GIM_Reject,
     /* 282129 */ // Label 5766: @282129
     /* 282129 */ GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(282162), // Rule ID 2476 //
     /* 282134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282155 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 282160 */   GIR_RootConstrainSelectedInstOperands,
     /* 282161 */   // GIR_Coverage, 2476,
     /* 282161 */   GIR_Done,
     /* 282162 */ // Label 5778: @282162
     /* 282162 */ GIM_Reject,
     /* 282163 */ // Label 5767: @282163
     /* 282163 */ GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(282196), // Rule ID 2480 //
     /* 282168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282189 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 282194 */   GIR_RootConstrainSelectedInstOperands,
     /* 282195 */   // GIR_Coverage, 2480,
     /* 282195 */   GIR_Done,
     /* 282196 */ // Label 5779: @282196
     /* 282196 */ GIM_Reject,
     /* 282197 */ // Label 5768: @282197
     /* 282197 */ GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(282230), // Rule ID 2475 //
     /* 282202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282223 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 282228 */   GIR_RootConstrainSelectedInstOperands,
     /* 282229 */   // GIR_Coverage, 2475,
     /* 282229 */   GIR_Done,
     /* 282230 */ // Label 5780: @282230
     /* 282230 */ GIM_Reject,
     /* 282231 */ // Label 5769: @282231
     /* 282231 */ GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(282264), // Rule ID 2479 //
     /* 282236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282257 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 282262 */   GIR_RootConstrainSelectedInstOperands,
     /* 282263 */   // GIR_Coverage, 2479,
     /* 282263 */   GIR_Done,
     /* 282264 */ // Label 5781: @282264
     /* 282264 */ GIM_Reject,
     /* 282265 */ // Label 5770: @282265
     /* 282265 */ GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(282298), // Rule ID 2478 //
     /* 282270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282291 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 282296 */   GIR_RootConstrainSelectedInstOperands,
     /* 282297 */   // GIR_Coverage, 2478,
     /* 282297 */   GIR_Done,
     /* 282298 */ // Label 5782: @282298
     /* 282298 */ GIM_Reject,
     /* 282299 */ // Label 5771: @282299
     /* 282299 */ GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(282324), // Rule ID 7419 //
     /* 282304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282317 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 282322 */   GIR_RootConstrainSelectedInstOperands,
     /* 282323 */   // GIR_Coverage, 7419,
     /* 282323 */   GIR_Done,
     /* 282324 */ // Label 5783: @282324
     /* 282324 */ GIM_Reject,
     /* 282325 */ // Label 5772: @282325
     /* 282325 */ GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(282350), // Rule ID 7418 //
     /* 282330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282343 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 282348 */   GIR_RootConstrainSelectedInstOperands,
     /* 282349 */   // GIR_Coverage, 7418,
     /* 282349 */   GIR_Done,
     /* 282350 */ // Label 5784: @282350
     /* 282350 */ GIM_Reject,
     /* 282351 */ // Label 5773: @282351
     /* 282351 */ GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(282376), // Rule ID 7417 //
     /* 282356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282369 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 282374 */   GIR_RootConstrainSelectedInstOperands,
     /* 282375 */   // GIR_Coverage, 7417,
     /* 282375 */   GIR_Done,
     /* 282376 */ // Label 5785: @282376
     /* 282376 */ GIM_Reject,
     /* 282377 */ // Label 5774: @282377
     /* 282377 */ GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(282402), // Rule ID 7416 //
     /* 282382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282395 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 282400 */   GIR_RootConstrainSelectedInstOperands,
     /* 282401 */   // GIR_Coverage, 7416,
     /* 282401 */   GIR_Done,
     /* 282402 */ // Label 5786: @282402
     /* 282402 */ GIM_Reject,
     /* 282403 */ // Label 5775: @282403
     /* 282403 */ GIM_Reject,
     /* 282404 */ // Label 55: @282404
     /* 282404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5798*/ GIMT_Encode4(282833),
     /* 282415 */ /*GILLT_v2s32*//*Label 5787*/ GIMT_Encode4(282491),
     /* 282419 */ /*GILLT_v2s64*//*Label 5788*/ GIMT_Encode4(282525),
     /* 282423 */ /*GILLT_v4s16*//*Label 5789*/ GIMT_Encode4(282559),
     /* 282427 */ /*GILLT_v4s32*//*Label 5790*/ GIMT_Encode4(282593),
     /* 282431 */ /*GILLT_v8s8*//*Label 5791*/ GIMT_Encode4(282627),
     /* 282435 */ /*GILLT_v8s16*//*Label 5792*/ GIMT_Encode4(282661),
     /* 282439 */ /*GILLT_v16s8*//*Label 5793*/ GIMT_Encode4(282695), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282459 */ /*GILLT_nxv2s64*//*Label 5794*/ GIMT_Encode4(282729), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282471 */ /*GILLT_nxv4s32*//*Label 5795*/ GIMT_Encode4(282755), GIMT_Encode4(0),
     /* 282479 */ /*GILLT_nxv8s16*//*Label 5796*/ GIMT_Encode4(282781), GIMT_Encode4(0),
     /* 282487 */ /*GILLT_nxv16s8*//*Label 5797*/ GIMT_Encode4(282807),
     /* 282491 */ // Label 5787: @282491
     /* 282491 */ GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(282524), // Rule ID 5037 //
     /* 282496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282517 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 282522 */   GIR_RootConstrainSelectedInstOperands,
     /* 282523 */   // GIR_Coverage, 5037,
     /* 282523 */   GIR_Done,
     /* 282524 */ // Label 5799: @282524
     /* 282524 */ GIM_Reject,
     /* 282525 */ // Label 5788: @282525
     /* 282525 */ GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(282558), // Rule ID 5041 //
     /* 282530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282551 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 282556 */   GIR_RootConstrainSelectedInstOperands,
     /* 282557 */   // GIR_Coverage, 5041,
     /* 282557 */   GIR_Done,
     /* 282558 */ // Label 5800: @282558
     /* 282558 */ GIM_Reject,
     /* 282559 */ // Label 5789: @282559
     /* 282559 */ GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(282592), // Rule ID 5036 //
     /* 282564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282585 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 282590 */   GIR_RootConstrainSelectedInstOperands,
     /* 282591 */   // GIR_Coverage, 5036,
     /* 282591 */   GIR_Done,
     /* 282592 */ // Label 5801: @282592
     /* 282592 */ GIM_Reject,
     /* 282593 */ // Label 5790: @282593
     /* 282593 */ GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(282626), // Rule ID 5040 //
     /* 282598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282619 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 282624 */   GIR_RootConstrainSelectedInstOperands,
     /* 282625 */   // GIR_Coverage, 5040,
     /* 282625 */   GIR_Done,
     /* 282626 */ // Label 5802: @282626
     /* 282626 */ GIM_Reject,
     /* 282627 */ // Label 5791: @282627
     /* 282627 */ GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(282660), // Rule ID 5035 //
     /* 282632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282653 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 282658 */   GIR_RootConstrainSelectedInstOperands,
     /* 282659 */   // GIR_Coverage, 5035,
     /* 282659 */   GIR_Done,
     /* 282660 */ // Label 5803: @282660
     /* 282660 */ GIM_Reject,
     /* 282661 */ // Label 5792: @282661
     /* 282661 */ GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(282694), // Rule ID 5039 //
     /* 282666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282687 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 282692 */   GIR_RootConstrainSelectedInstOperands,
     /* 282693 */   // GIR_Coverage, 5039,
     /* 282693 */   GIR_Done,
     /* 282694 */ // Label 5804: @282694
     /* 282694 */ GIM_Reject,
     /* 282695 */ // Label 5793: @282695
     /* 282695 */ GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(282728), // Rule ID 5038 //
     /* 282700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282721 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 282726 */   GIR_RootConstrainSelectedInstOperands,
     /* 282727 */   // GIR_Coverage, 5038,
     /* 282727 */   GIR_Done,
     /* 282728 */ // Label 5805: @282728
     /* 282728 */ GIM_Reject,
     /* 282729 */ // Label 5794: @282729
     /* 282729 */ GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(282754), // Rule ID 7431 //
     /* 282734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282747 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 282752 */   GIR_RootConstrainSelectedInstOperands,
     /* 282753 */   // GIR_Coverage, 7431,
     /* 282753 */   GIR_Done,
     /* 282754 */ // Label 5806: @282754
     /* 282754 */ GIM_Reject,
     /* 282755 */ // Label 5795: @282755
     /* 282755 */ GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(282780), // Rule ID 7430 //
     /* 282760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282773 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 282778 */   GIR_RootConstrainSelectedInstOperands,
     /* 282779 */   // GIR_Coverage, 7430,
     /* 282779 */   GIR_Done,
     /* 282780 */ // Label 5807: @282780
     /* 282780 */ GIM_Reject,
     /* 282781 */ // Label 5796: @282781
     /* 282781 */ GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(282806), // Rule ID 7429 //
     /* 282786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282799 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 282804 */   GIR_RootConstrainSelectedInstOperands,
     /* 282805 */   // GIR_Coverage, 7429,
     /* 282805 */   GIR_Done,
     /* 282806 */ // Label 5808: @282806
     /* 282806 */ GIM_Reject,
     /* 282807 */ // Label 5797: @282807
     /* 282807 */ GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(282832), // Rule ID 7428 //
     /* 282812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282825 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 282830 */   GIR_RootConstrainSelectedInstOperands,
     /* 282831 */   // GIR_Coverage, 7428,
     /* 282831 */   GIR_Done,
     /* 282832 */ // Label 5809: @282832
     /* 282832 */ GIM_Reject,
     /* 282833 */ // Label 5798: @282833
     /* 282833 */ GIM_Reject,
     /* 282834 */ // Label 56: @282834
     /* 282834 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5821*/ GIMT_Encode4(283263),
     /* 282845 */ /*GILLT_v2s32*//*Label 5810*/ GIMT_Encode4(282921),
     /* 282849 */ /*GILLT_v2s64*//*Label 5811*/ GIMT_Encode4(282955),
     /* 282853 */ /*GILLT_v4s16*//*Label 5812*/ GIMT_Encode4(282989),
     /* 282857 */ /*GILLT_v4s32*//*Label 5813*/ GIMT_Encode4(283023),
     /* 282861 */ /*GILLT_v8s8*//*Label 5814*/ GIMT_Encode4(283057),
     /* 282865 */ /*GILLT_v8s16*//*Label 5815*/ GIMT_Encode4(283091),
     /* 282869 */ /*GILLT_v16s8*//*Label 5816*/ GIMT_Encode4(283125), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282889 */ /*GILLT_nxv2s64*//*Label 5817*/ GIMT_Encode4(283159), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282901 */ /*GILLT_nxv4s32*//*Label 5818*/ GIMT_Encode4(283185), GIMT_Encode4(0),
     /* 282909 */ /*GILLT_nxv8s16*//*Label 5819*/ GIMT_Encode4(283211), GIMT_Encode4(0),
     /* 282917 */ /*GILLT_nxv16s8*//*Label 5820*/ GIMT_Encode4(283237),
     /* 282921 */ // Label 5810: @282921
     /* 282921 */ GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(282954), // Rule ID 5030 //
     /* 282926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282947 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 282952 */   GIR_RootConstrainSelectedInstOperands,
     /* 282953 */   // GIR_Coverage, 5030,
     /* 282953 */   GIR_Done,
     /* 282954 */ // Label 5822: @282954
     /* 282954 */ GIM_Reject,
     /* 282955 */ // Label 5811: @282955
     /* 282955 */ GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(282988), // Rule ID 5034 //
     /* 282960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282981 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 282986 */   GIR_RootConstrainSelectedInstOperands,
     /* 282987 */   // GIR_Coverage, 5034,
     /* 282987 */   GIR_Done,
     /* 282988 */ // Label 5823: @282988
     /* 282988 */ GIM_Reject,
     /* 282989 */ // Label 5812: @282989
     /* 282989 */ GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(283022), // Rule ID 5029 //
     /* 282994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 283000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283015 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 283015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 283020 */   GIR_RootConstrainSelectedInstOperands,
     /* 283021 */   // GIR_Coverage, 5029,
     /* 283021 */   GIR_Done,
     /* 283022 */ // Label 5824: @283022
     /* 283022 */ GIM_Reject,
     /* 283023 */ // Label 5813: @283023
     /* 283023 */ GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(283056), // Rule ID 5033 //
     /* 283028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 283037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283049 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 283049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 283054 */   GIR_RootConstrainSelectedInstOperands,
     /* 283055 */   // GIR_Coverage, 5033,
     /* 283055 */   GIR_Done,
     /* 283056 */ // Label 5825: @283056
     /* 283056 */ GIM_Reject,
     /* 283057 */ // Label 5814: @283057
     /* 283057 */ GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(283090), // Rule ID 5028 //
     /* 283062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 283068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283083 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 283083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 283088 */   GIR_RootConstrainSelectedInstOperands,
     /* 283089 */   // GIR_Coverage, 5028,
     /* 283089 */   GIR_Done,
     /* 283090 */ // Label 5826: @283090
     /* 283090 */ GIM_Reject,
     /* 283091 */ // Label 5815: @283091
     /* 283091 */ GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(283124), // Rule ID 5032 //
     /* 283096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283117 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 283117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 283122 */   GIR_RootConstrainSelectedInstOperands,
     /* 283123 */   // GIR_Coverage, 5032,
     /* 283123 */   GIR_Done,
     /* 283124 */ // Label 5827: @283124
     /* 283124 */ GIM_Reject,
     /* 283125 */ // Label 5816: @283125
     /* 283125 */ GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(283158), // Rule ID 5031 //
     /* 283130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283151 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 283151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 283156 */   GIR_RootConstrainSelectedInstOperands,
     /* 283157 */   // GIR_Coverage, 5031,
     /* 283157 */   GIR_Done,
     /* 283158 */ // Label 5828: @283158
     /* 283158 */ GIM_Reject,
     /* 283159 */ // Label 5817: @283159
     /* 283159 */ GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(283184), // Rule ID 7427 //
     /* 283164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 283170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 283173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283177 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 283177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 283182 */   GIR_RootConstrainSelectedInstOperands,
     /* 283183 */   // GIR_Coverage, 7427,
     /* 283183 */   GIR_Done,
     /* 283184 */ // Label 5829: @283184
     /* 283184 */ GIM_Reject,
     /* 283185 */ // Label 5818: @283185
     /* 283185 */ GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(283210), // Rule ID 7426 //
     /* 283190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 283196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 283199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283203 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 283203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 283208 */   GIR_RootConstrainSelectedInstOperands,
     /* 283209 */   // GIR_Coverage, 7426,
     /* 283209 */   GIR_Done,
     /* 283210 */ // Label 5830: @283210
     /* 283210 */ GIM_Reject,
     /* 283211 */ // Label 5819: @283211
     /* 283211 */ GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(283236), // Rule ID 7425 //
     /* 283216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 283225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283229 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 283229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 283234 */   GIR_RootConstrainSelectedInstOperands,
     /* 283235 */   // GIR_Coverage, 7425,
     /* 283235 */   GIR_Done,
     /* 283236 */ // Label 5831: @283236
     /* 283236 */ GIM_Reject,
     /* 283237 */ // Label 5820: @283237
     /* 283237 */ GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(283262), // Rule ID 7424 //
     /* 283242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283255 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 283255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 283260 */   GIR_RootConstrainSelectedInstOperands,
     /* 283261 */   // GIR_Coverage, 7424,
     /* 283261 */   GIR_Done,
     /* 283262 */ // Label 5832: @283262
     /* 283262 */ GIM_Reject,
     /* 283263 */ // Label 5821: @283263
     /* 283263 */ GIM_Reject,
     /* 283264 */ // Label 57: @283264
     /* 283264 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5844*/ GIMT_Encode4(285061),
     /* 283275 */ /*GILLT_s16*//*Label 5833*/ GIMT_Encode4(283359),
     /* 283279 */ /*GILLT_s32*//*Label 5834*/ GIMT_Encode4(283585),
     /* 283283 */ /*GILLT_s64*//*Label 5835*/ GIMT_Encode4(283939), GIMT_Encode4(0),
     /* 283291 */ /*GILLT_v2s32*//*Label 5836*/ GIMT_Encode4(284111),
     /* 283295 */ /*GILLT_v2s64*//*Label 5837*/ GIMT_Encode4(284149),
     /* 283299 */ /*GILLT_v4s16*//*Label 5838*/ GIMT_Encode4(284325),
     /* 283303 */ /*GILLT_v4s32*//*Label 5839*/ GIMT_Encode4(284363), GIMT_Encode4(0),
     /* 283311 */ /*GILLT_v8s16*//*Label 5840*/ GIMT_Encode4(284539), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283335 */ /*GILLT_nxv2s64*//*Label 5841*/ GIMT_Encode4(284983), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283347 */ /*GILLT_nxv4s32*//*Label 5842*/ GIMT_Encode4(285009), GIMT_Encode4(0),
     /* 283355 */ /*GILLT_nxv8s16*//*Label 5843*/ GIMT_Encode4(285035),
     /* 283359 */ // Label 5833: @283359
     /* 283359 */ GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(283584),
     /* 283364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 283370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283374 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(283465), // Rule ID 6911 //
     /* 283379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283400 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283416 */     // MIs[2] Rn
     /* 283416 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283421 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283427 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 283427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283439 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 283458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283463 */     GIR_RootConstrainSelectedInstOperands,
     /* 283464 */     // GIR_Coverage, 6911,
     /* 283464 */     GIR_EraseRootFromParent_Done,
     /* 283465 */   // Label 5846: @283465
     /* 283465 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(283556), // Rule ID 13914 //
     /* 283470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283507 */     // MIs[2] Rn
     /* 283507 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283512 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283518 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 283518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283530 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 283549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283554 */     GIR_RootConstrainSelectedInstOperands,
     /* 283555 */     // GIR_Coverage, 13914,
     /* 283555 */     GIR_EraseRootFromParent_Done,
     /* 283556 */   // Label 5847: @283556
     /* 283556 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(283583), // Rule ID 584 //
     /* 283561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283572 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 283572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 283577 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283581 */     GIR_RootConstrainSelectedInstOperands,
     /* 283582 */     // GIR_Coverage, 584,
     /* 283582 */     GIR_Done,
     /* 283583 */   // Label 5848: @283583
     /* 283583 */   GIM_Reject,
     /* 283584 */ // Label 5845: @283584
     /* 283584 */ GIM_Reject,
     /* 283585 */ // Label 5834: @283585
     /* 283585 */ GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(283938),
     /* 283590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 283596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283600 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(283691), // Rule ID 6909 //
     /* 283605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283626 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283642 */     // MIs[2] Rn
     /* 283642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283653 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 283653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283665 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283689 */     GIR_RootConstrainSelectedInstOperands,
     /* 283690 */     // GIR_Coverage, 6909,
     /* 283690 */     GIR_EraseRootFromParent_Done,
     /* 283691 */   // Label 5850: @283691
     /* 283691 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(283755), // Rule ID 13096 //
     /* 283696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283717 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283733 */     // MIs[2] Rn
     /* 283733 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283738 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283744 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 283744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283753 */     GIR_RootConstrainSelectedInstOperands,
     /* 283754 */     // GIR_Coverage, 13096,
     /* 283754 */     GIR_EraseRootFromParent_Done,
     /* 283755 */   // Label 5851: @283755
     /* 283755 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(283846), // Rule ID 13912 //
     /* 283760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283781 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283797 */     // MIs[2] Rn
     /* 283797 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283802 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283808 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 283808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283820 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283844 */     GIR_RootConstrainSelectedInstOperands,
     /* 283845 */     // GIR_Coverage, 13912,
     /* 283845 */     GIR_EraseRootFromParent_Done,
     /* 283846 */   // Label 5852: @283846
     /* 283846 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(283910), // Rule ID 15599 //
     /* 283851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283872 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283888 */     // MIs[2] Rn
     /* 283888 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283893 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283899 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 283899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283908 */     GIR_RootConstrainSelectedInstOperands,
     /* 283909 */     // GIR_Coverage, 15599,
     /* 283909 */     GIR_EraseRootFromParent_Done,
     /* 283910 */   // Label 5853: @283910
     /* 283910 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(283937), // Rule ID 586 //
     /* 283915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283926 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 283926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 283931 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283935 */     GIR_RootConstrainSelectedInstOperands,
     /* 283936 */     // GIR_Coverage, 586,
     /* 283936 */     GIR_Done,
     /* 283937 */   // Label 5854: @283937
     /* 283937 */   GIM_Reject,
     /* 283938 */ // Label 5849: @283938
     /* 283938 */ GIM_Reject,
     /* 283939 */ // Label 5835: @283939
     /* 283939 */ GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(284110),
     /* 283944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 283950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283954 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(284018), // Rule ID 6907 //
     /* 283959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283980 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283996 */     // MIs[2] Rn
     /* 283996 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 284005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284007 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 284007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 284010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284016 */     GIR_RootConstrainSelectedInstOperands,
     /* 284017 */     // GIR_Coverage, 6907,
     /* 284017 */     GIR_EraseRootFromParent_Done,
     /* 284018 */   // Label 5856: @284018
     /* 284018 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(284082), // Rule ID 13910 //
     /* 284023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284044 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 284048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284060 */     // MIs[2] Rn
     /* 284060 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284065 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284071 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 284071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 284074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284080 */     GIR_RootConstrainSelectedInstOperands,
     /* 284081 */     // GIR_Coverage, 13910,
     /* 284081 */     GIR_EraseRootFromParent_Done,
     /* 284082 */   // Label 5857: @284082
     /* 284082 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(284109), // Rule ID 588 //
     /* 284087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284098 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 284098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 284103 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284107 */     GIR_RootConstrainSelectedInstOperands,
     /* 284108 */     // GIR_Coverage, 588,
     /* 284108 */     GIR_Done,
     /* 284109 */   // Label 5858: @284109
     /* 284109 */   GIM_Reject,
     /* 284110 */ // Label 5855: @284110
     /* 284110 */ GIM_Reject,
     /* 284111 */ // Label 5836: @284111
     /* 284111 */ GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(284148), // Rule ID 1203 //
     /* 284116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284137 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 284137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 284142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284146 */   GIR_RootConstrainSelectedInstOperands,
     /* 284147 */   // GIR_Coverage, 1203,
     /* 284147 */   GIR_Done,
     /* 284148 */ // Label 5859: @284148
     /* 284148 */ GIM_Reject,
     /* 284149 */ // Label 5837: @284149
     /* 284149 */ GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(284324),
     /* 284154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284164 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(284230), // Rule ID 6929 //
     /* 284169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 284177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 284203 */     // MIs[2] Rn
     /* 284203 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284208 */     // MIs[2] Rm
     /* 284208 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284215 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 284215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 284218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284228 */     GIR_RootConstrainSelectedInstOperands,
     /* 284229 */     // GIR_Coverage, 6929,
     /* 284229 */     GIR_EraseRootFromParent_Done,
     /* 284230 */   // Label 5861: @284230
     /* 284230 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(284296), // Rule ID 13922 //
     /* 284235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 284243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 284269 */     // MIs[2] Rn
     /* 284269 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284274 */     // MIs[2] Rm
     /* 284274 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284281 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 284281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 284284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284294 */     GIR_RootConstrainSelectedInstOperands,
     /* 284295 */     // GIR_Coverage, 13922,
     /* 284295 */     GIR_EraseRootFromParent_Done,
     /* 284296 */   // Label 5862: @284296
     /* 284296 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(284323), // Rule ID 1207 //
     /* 284301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284312 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 284312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 284317 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284321 */     GIR_RootConstrainSelectedInstOperands,
     /* 284322 */     // GIR_Coverage, 1207,
     /* 284322 */     GIR_Done,
     /* 284323 */   // Label 5863: @284323
     /* 284323 */   GIM_Reject,
     /* 284324 */ // Label 5860: @284324
     /* 284324 */ GIM_Reject,
     /* 284325 */ // Label 5838: @284325
     /* 284325 */ GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(284362), // Rule ID 1199 //
     /* 284330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284351 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 284351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 284356 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284360 */   GIR_RootConstrainSelectedInstOperands,
     /* 284361 */   // GIR_Coverage, 1199,
     /* 284361 */   GIR_Done,
     /* 284362 */ // Label 5864: @284362
     /* 284362 */ GIM_Reject,
     /* 284363 */ // Label 5839: @284363
     /* 284363 */ GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(284538),
     /* 284368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284378 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(284444), // Rule ID 6930 //
     /* 284383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 284391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 284417 */     // MIs[2] Rn
     /* 284417 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284422 */     // MIs[2] Rm
     /* 284422 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284429 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 284429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 284432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284442 */     GIR_RootConstrainSelectedInstOperands,
     /* 284443 */     // GIR_Coverage, 6930,
     /* 284443 */     GIR_EraseRootFromParent_Done,
     /* 284444 */   // Label 5866: @284444
     /* 284444 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(284510), // Rule ID 13923 //
     /* 284449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 284457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 284483 */     // MIs[2] Rn
     /* 284483 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284488 */     // MIs[2] Rm
     /* 284488 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284495 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 284495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 284498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284508 */     GIR_RootConstrainSelectedInstOperands,
     /* 284509 */     // GIR_Coverage, 13923,
     /* 284509 */     GIR_EraseRootFromParent_Done,
     /* 284510 */   // Label 5867: @284510
     /* 284510 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(284537), // Rule ID 1205 //
     /* 284515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284526 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 284526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284531 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284535 */     GIR_RootConstrainSelectedInstOperands,
     /* 284536 */     // GIR_Coverage, 1205,
     /* 284536 */     GIR_Done,
     /* 284537 */   // Label 5868: @284537
     /* 284537 */   GIM_Reject,
     /* 284538 */ // Label 5865: @284538
     /* 284538 */ GIM_Reject,
     /* 284539 */ // Label 5840: @284539
     /* 284539 */ GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(284982),
     /* 284544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284554 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(284623), // Rule ID 6931 //
     /* 284559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 284570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 284596 */     // MIs[2] Rn
     /* 284596 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284601 */     // MIs[2] Rm
     /* 284601 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284608 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 284608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 284611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284621 */     GIR_RootConstrainSelectedInstOperands,
     /* 284622 */     // GIR_Coverage, 6931,
     /* 284622 */     GIR_EraseRootFromParent_Done,
     /* 284623 */   // Label 5870: @284623
     /* 284623 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(284692), // Rule ID 13924 //
     /* 284628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 284639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 284665 */     // MIs[2] Rn
     /* 284665 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284670 */     // MIs[2] Rm
     /* 284670 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284677 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 284677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 284680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284690 */     GIR_RootConstrainSelectedInstOperands,
     /* 284691 */     // GIR_Coverage, 13924,
     /* 284691 */     GIR_EraseRootFromParent_Done,
     /* 284692 */   // Label 5871: @284692
     /* 284692 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(284719), // Rule ID 1201 //
     /* 284697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284708 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 284708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 284713 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284717 */     GIR_RootConstrainSelectedInstOperands,
     /* 284718 */     // GIR_Coverage, 1201,
     /* 284718 */     GIR_Done,
     /* 284719 */   // Label 5872: @284719
     /* 284719 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(284981), // Rule ID 7000 //
     /* 284724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 284727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284735 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 284735 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 284738 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 284742 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284747 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 284751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 284753 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 284756 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 284760 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284765 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 284769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 284771 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 284774 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284778 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284783 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 284786 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 284789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 284791 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 284794 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284798 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284803 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 284809 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284814 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284819 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 284822 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 284826 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284831 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 284834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 284836 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 284839 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284843 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284848 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284854 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284859 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284864 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 284867 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 284871 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284876 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 284879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 284881 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 284884 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284888 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284893 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 284896 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 284899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284901 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 284904 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 284908 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284913 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 284916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284918 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 284921 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284925 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 284935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284944 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284947 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 284950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 284953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 284971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 284979 */     GIR_RootConstrainSelectedInstOperands,
     /* 284980 */     // GIR_Coverage, 7000,
     /* 284980 */     GIR_EraseRootFromParent_Done,
     /* 284981 */   // Label 5873: @284981
     /* 284981 */   GIM_Reject,
     /* 284982 */ // Label 5869: @284982
     /* 284982 */ GIM_Reject,
     /* 284983 */ // Label 5841: @284983
     /* 284983 */ GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(285008), // Rule ID 2824 //
     /* 284988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 284997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285001 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 285001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 285006 */   GIR_RootConstrainSelectedInstOperands,
     /* 285007 */   // GIR_Coverage, 2824,
     /* 285007 */   GIR_Done,
     /* 285008 */ // Label 5874: @285008
     /* 285008 */ GIM_Reject,
     /* 285009 */ // Label 5842: @285009
     /* 285009 */ GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(285034), // Rule ID 2822 //
     /* 285014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285027 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 285027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 285032 */   GIR_RootConstrainSelectedInstOperands,
     /* 285033 */   // GIR_Coverage, 2822,
     /* 285033 */   GIR_Done,
     /* 285034 */ // Label 5875: @285034
     /* 285034 */ GIM_Reject,
     /* 285035 */ // Label 5843: @285035
     /* 285035 */ GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(285060), // Rule ID 2820 //
     /* 285040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285053 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 285053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 285058 */   GIR_RootConstrainSelectedInstOperands,
     /* 285059 */   // GIR_Coverage, 2820,
     /* 285059 */   GIR_Done,
     /* 285060 */ // Label 5876: @285060
     /* 285060 */ GIM_Reject,
     /* 285061 */ // Label 5844: @285061
     /* 285061 */ GIM_Reject,
     /* 285062 */ // Label 58: @285062
     /* 285062 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5888*/ GIMT_Encode4(285799),
     /* 285073 */ /*GILLT_s16*//*Label 5877*/ GIMT_Encode4(285157),
     /* 285077 */ /*GILLT_s32*//*Label 5878*/ GIMT_Encode4(285195),
     /* 285081 */ /*GILLT_s64*//*Label 5879*/ GIMT_Encode4(285233), GIMT_Encode4(0),
     /* 285089 */ /*GILLT_v2s32*//*Label 5880*/ GIMT_Encode4(285271),
     /* 285093 */ /*GILLT_v2s64*//*Label 5881*/ GIMT_Encode4(285309),
     /* 285097 */ /*GILLT_v4s16*//*Label 5882*/ GIMT_Encode4(285347),
     /* 285101 */ /*GILLT_v4s32*//*Label 5883*/ GIMT_Encode4(285385), GIMT_Encode4(0),
     /* 285109 */ /*GILLT_v8s16*//*Label 5884*/ GIMT_Encode4(285423), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285133 */ /*GILLT_nxv2s64*//*Label 5885*/ GIMT_Encode4(285721), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285145 */ /*GILLT_nxv4s32*//*Label 5886*/ GIMT_Encode4(285747), GIMT_Encode4(0),
     /* 285153 */ /*GILLT_nxv8s16*//*Label 5887*/ GIMT_Encode4(285773),
     /* 285157 */ // Label 5877: @285157
     /* 285157 */ GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(285194), // Rule ID 632 //
     /* 285162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285183 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 285183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 285188 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285192 */   GIR_RootConstrainSelectedInstOperands,
     /* 285193 */   // GIR_Coverage, 632,
     /* 285193 */   GIR_Done,
     /* 285194 */ // Label 5889: @285194
     /* 285194 */ GIM_Reject,
     /* 285195 */ // Label 5878: @285195
     /* 285195 */ GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(285232), // Rule ID 634 //
     /* 285200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 285209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285221 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 285221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 285226 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285230 */   GIR_RootConstrainSelectedInstOperands,
     /* 285231 */   // GIR_Coverage, 634,
     /* 285231 */   GIR_Done,
     /* 285232 */ // Label 5890: @285232
     /* 285232 */ GIM_Reject,
     /* 285233 */ // Label 5879: @285233
     /* 285233 */ GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(285270), // Rule ID 636 //
     /* 285238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285259 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 285259 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 285264 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285268 */   GIR_RootConstrainSelectedInstOperands,
     /* 285269 */   // GIR_Coverage, 636,
     /* 285269 */   GIR_Done,
     /* 285270 */ // Label 5891: @285270
     /* 285270 */ GIM_Reject,
     /* 285271 */ // Label 5880: @285271
     /* 285271 */ GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(285308), // Rule ID 1343 //
     /* 285276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285297 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 285297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 285302 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285306 */   GIR_RootConstrainSelectedInstOperands,
     /* 285307 */   // GIR_Coverage, 1343,
     /* 285307 */   GIR_Done,
     /* 285308 */ // Label 5892: @285308
     /* 285308 */ GIM_Reject,
     /* 285309 */ // Label 5881: @285309
     /* 285309 */ GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(285346), // Rule ID 1347 //
     /* 285314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285335 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 285335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 285340 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285344 */   GIR_RootConstrainSelectedInstOperands,
     /* 285345 */   // GIR_Coverage, 1347,
     /* 285345 */   GIR_Done,
     /* 285346 */ // Label 5893: @285346
     /* 285346 */ GIM_Reject,
     /* 285347 */ // Label 5882: @285347
     /* 285347 */ GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(285384), // Rule ID 1339 //
     /* 285352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285373 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 285373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 285378 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285382 */   GIR_RootConstrainSelectedInstOperands,
     /* 285383 */   // GIR_Coverage, 1339,
     /* 285383 */   GIR_Done,
     /* 285384 */ // Label 5894: @285384
     /* 285384 */ GIM_Reject,
     /* 285385 */ // Label 5883: @285385
     /* 285385 */ GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(285422), // Rule ID 1345 //
     /* 285390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285411 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 285411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285420 */   GIR_RootConstrainSelectedInstOperands,
     /* 285421 */   // GIR_Coverage, 1345,
     /* 285421 */   GIR_Done,
     /* 285422 */ // Label 5895: @285422
     /* 285422 */ GIM_Reject,
     /* 285423 */ // Label 5884: @285423
     /* 285423 */ GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(285720),
     /* 285428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285446 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(285465), // Rule ID 1341 //
     /* 285451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285454 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 285454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 285459 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285463 */     GIR_RootConstrainSelectedInstOperands,
     /* 285464 */     // GIR_Coverage, 1341,
     /* 285464 */     GIR_Done,
     /* 285465 */   // Label 5897: @285465
     /* 285465 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(285719), // Rule ID 7006 //
     /* 285470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 285473 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 285473 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 285476 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285480 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285485 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 285489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 285491 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 285494 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285498 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285503 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 285507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 285509 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 285512 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285516 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285521 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 285524 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 285527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 285529 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 285532 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285536 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285541 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285547 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285552 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285557 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 285560 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285564 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285569 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 285572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 285574 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 285577 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285581 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285586 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285592 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285597 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285602 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 285605 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285609 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285614 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 285617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 285619 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 285622 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285626 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285631 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 285634 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 285637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285639 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 285642 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 285646 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285651 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 285654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285656 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 285659 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285663 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 285673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285682 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 285688 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 285691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 285709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 285717 */     GIR_RootConstrainSelectedInstOperands,
     /* 285718 */     // GIR_Coverage, 7006,
     /* 285718 */     GIR_EraseRootFromParent_Done,
     /* 285719 */   // Label 5898: @285719
     /* 285719 */   GIM_Reject,
     /* 285720 */ // Label 5896: @285720
     /* 285720 */ GIM_Reject,
     /* 285721 */ // Label 5885: @285721
     /* 285721 */ GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(285746), // Rule ID 8174 //
     /* 285726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285739 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 285739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 285744 */   GIR_RootConstrainSelectedInstOperands,
     /* 285745 */   // GIR_Coverage, 8174,
     /* 285745 */   GIR_Done,
     /* 285746 */ // Label 5899: @285746
     /* 285746 */ GIM_Reject,
     /* 285747 */ // Label 5886: @285747
     /* 285747 */ GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(285772), // Rule ID 8172 //
     /* 285752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285765 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 285765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 285770 */   GIR_RootConstrainSelectedInstOperands,
     /* 285771 */   // GIR_Coverage, 8172,
     /* 285771 */   GIR_Done,
     /* 285772 */ // Label 5900: @285772
     /* 285772 */ GIM_Reject,
     /* 285773 */ // Label 5887: @285773
     /* 285773 */ GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(285798), // Rule ID 8170 //
     /* 285778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285791 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 285791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 285796 */   GIR_RootConstrainSelectedInstOperands,
     /* 285797 */   // GIR_Coverage, 8170,
     /* 285797 */   GIR_Done,
     /* 285798 */ // Label 5901: @285798
     /* 285798 */ GIM_Reject,
     /* 285799 */ // Label 5888: @285799
     /* 285799 */ GIM_Reject,
     /* 285800 */ // Label 59: @285800
     /* 285800 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5913*/ GIMT_Encode4(289895),
     /* 285811 */ /*GILLT_s16*//*Label 5902*/ GIMT_Encode4(285895),
     /* 285815 */ /*GILLT_s32*//*Label 5903*/ GIMT_Encode4(286537),
     /* 285819 */ /*GILLT_s64*//*Label 5904*/ GIMT_Encode4(287167), GIMT_Encode4(0),
     /* 285827 */ /*GILLT_v2s32*//*Label 5905*/ GIMT_Encode4(287797),
     /* 285831 */ /*GILLT_v2s64*//*Label 5906*/ GIMT_Encode4(288327),
     /* 285835 */ /*GILLT_v4s16*//*Label 5907*/ GIMT_Encode4(288685),
     /* 285839 */ /*GILLT_v4s32*//*Label 5908*/ GIMT_Encode4(289027), GIMT_Encode4(0),
     /* 285847 */ /*GILLT_v8s16*//*Label 5909*/ GIMT_Encode4(289385), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285871 */ /*GILLT_nxv2s64*//*Label 5910*/ GIMT_Encode4(289817), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285883 */ /*GILLT_nxv4s32*//*Label 5911*/ GIMT_Encode4(289843), GIMT_Encode4(0),
     /* 285891 */ /*GILLT_nxv8s16*//*Label 5912*/ GIMT_Encode4(289869),
     /* 285895 */ // Label 5902: @285895
     /* 285895 */ GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(286536),
     /* 285900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285910 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(286023), // Rule ID 6241 //
     /* 285915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285939 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 285968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285972 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 285976 */     // MIs[3] Operand 1
     /* 285976 */     // No operand predicates
     /* 285976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285978 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 285978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 285981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285990 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 285996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286021 */     GIR_RootConstrainSelectedInstOperands,
     /* 286022 */     // GIR_Coverage, 6241,
     /* 286022 */     GIR_EraseRootFromParent_Done,
     /* 286023 */   // Label 5915: @286023
     /* 286023 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(286136), // Rule ID 13891 //
     /* 286028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286060 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286064 */     // MIs[2] Operand 1
     /* 286064 */     // No operand predicates
     /* 286064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286072 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286076 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286080 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286085 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286091 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 286091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286103 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286134 */     GIR_RootConstrainSelectedInstOperands,
     /* 286135 */     // GIR_Coverage, 13891,
     /* 286135 */     GIR_EraseRootFromParent_Done,
     /* 286136 */   // Label 5916: @286136
     /* 286136 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(286215), // Rule ID 13825 //
     /* 286141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286165 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286175 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 286175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286187 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286213 */     GIR_RootConstrainSelectedInstOperands,
     /* 286214 */     // GIR_Coverage, 13825,
     /* 286214 */     GIR_EraseRootFromParent_Done,
     /* 286215 */   // Label 5917: @286215
     /* 286215 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(286294), // Rule ID 4803 //
     /* 286220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286248 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286254 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 286254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286266 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286292 */     GIR_RootConstrainSelectedInstOperands,
     /* 286293 */     // GIR_Coverage, 4803,
     /* 286293 */     GIR_EraseRootFromParent_Done,
     /* 286294 */   // Label 5918: @286294
     /* 286294 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(286357), // Rule ID 13440 //
     /* 286299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286331 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286335 */     // MIs[2] Operand 1
     /* 286335 */     // No operand predicates
     /* 286335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286341 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286355 */     GIR_RootConstrainSelectedInstOperands,
     /* 286356 */     // GIR_Coverage, 13440,
     /* 286356 */     GIR_EraseRootFromParent_Done,
     /* 286357 */   // Label 5919: @286357
     /* 286357 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(286420), // Rule ID 2012 //
     /* 286362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286398 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286402 */     // MIs[2] Operand 1
     /* 286402 */     // No operand predicates
     /* 286402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286404 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286418 */     GIR_RootConstrainSelectedInstOperands,
     /* 286419 */     // GIR_Coverage, 2012,
     /* 286419 */     GIR_EraseRootFromParent_Done,
     /* 286420 */   // Label 5920: @286420
     /* 286420 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(286464), // Rule ID 4808 //
     /* 286425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286451 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 286451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 286454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286460 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 286462 */     GIR_RootConstrainSelectedInstOperands,
     /* 286463 */     // GIR_Coverage, 4808,
     /* 286463 */     GIR_EraseRootFromParent_Done,
     /* 286464 */   // Label 5921: @286464
     /* 286464 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(286508), // Rule ID 13830 //
     /* 286469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286495 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 286495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 286498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286504 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 286506 */     GIR_RootConstrainSelectedInstOperands,
     /* 286507 */     // GIR_Coverage, 13830,
     /* 286507 */     GIR_EraseRootFromParent_Done,
     /* 286508 */   // Label 5922: @286508
     /* 286508 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(286535), // Rule ID 620 //
     /* 286513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286524 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 286524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286529 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286533 */     GIR_RootConstrainSelectedInstOperands,
     /* 286534 */     // GIR_Coverage, 620,
     /* 286534 */     GIR_Done,
     /* 286535 */   // Label 5923: @286535
     /* 286535 */   GIM_Reject,
     /* 286536 */ // Label 5914: @286536
     /* 286536 */ GIM_Reject,
     /* 286537 */ // Label 5903: @286537
     /* 286537 */ GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(287166),
     /* 286542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286552 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(286665), // Rule ID 6243 //
     /* 286557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286581 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286614 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286618 */     // MIs[3] Operand 1
     /* 286618 */     // No operand predicates
     /* 286618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286620 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286632 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286663 */     GIR_RootConstrainSelectedInstOperands,
     /* 286664 */     // GIR_Coverage, 6243,
     /* 286664 */     GIR_EraseRootFromParent_Done,
     /* 286665 */   // Label 5925: @286665
     /* 286665 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(286778), // Rule ID 13893 //
     /* 286670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286702 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286706 */     // MIs[2] Operand 1
     /* 286706 */     // No operand predicates
     /* 286706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286722 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286727 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286733 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286776 */     GIR_RootConstrainSelectedInstOperands,
     /* 286777 */     // GIR_Coverage, 13893,
     /* 286777 */     GIR_EraseRootFromParent_Done,
     /* 286778 */   // Label 5926: @286778
     /* 286778 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(286854), // Rule ID 13827 //
     /* 286783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286814 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 286814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286826 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 286845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286852 */     GIR_RootConstrainSelectedInstOperands,
     /* 286853 */     // GIR_Coverage, 13827,
     /* 286853 */     GIR_EraseRootFromParent_Done,
     /* 286854 */   // Label 5927: @286854
     /* 286854 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(286930), // Rule ID 4805 //
     /* 286859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286884 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286890 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 286890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286902 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 286921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286928 */     GIR_RootConstrainSelectedInstOperands,
     /* 286929 */     // GIR_Coverage, 4805,
     /* 286929 */     GIR_EraseRootFromParent_Done,
     /* 286930 */   // Label 5928: @286930
     /* 286930 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(286993), // Rule ID 13442 //
     /* 286935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286971 */     // MIs[2] Operand 1
     /* 286971 */     // No operand predicates
     /* 286971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286977 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286991 */     GIR_RootConstrainSelectedInstOperands,
     /* 286992 */     // GIR_Coverage, 13442,
     /* 286992 */     GIR_EraseRootFromParent_Done,
     /* 286993 */   // Label 5929: @286993
     /* 286993 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(287056), // Rule ID 2014 //
     /* 286998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287034 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287038 */     // MIs[2] Operand 1
     /* 287038 */     // No operand predicates
     /* 287038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287040 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 287043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287054 */     GIR_RootConstrainSelectedInstOperands,
     /* 287055 */     // GIR_Coverage, 2014,
     /* 287055 */     GIR_EraseRootFromParent_Done,
     /* 287056 */   // Label 5930: @287056
     /* 287056 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(287097), // Rule ID 4809 //
     /* 287061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287084 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 287084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 287087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287093 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 287095 */     GIR_RootConstrainSelectedInstOperands,
     /* 287096 */     // GIR_Coverage, 4809,
     /* 287096 */     GIR_EraseRootFromParent_Done,
     /* 287097 */   // Label 5931: @287097
     /* 287097 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(287138), // Rule ID 13831 //
     /* 287102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287125 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 287125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 287128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287134 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 287136 */     GIR_RootConstrainSelectedInstOperands,
     /* 287137 */     // GIR_Coverage, 13831,
     /* 287137 */     GIR_EraseRootFromParent_Done,
     /* 287138 */   // Label 5932: @287138
     /* 287138 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(287165), // Rule ID 622 //
     /* 287143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287154 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 287154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 287159 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287163 */     GIR_RootConstrainSelectedInstOperands,
     /* 287164 */     // GIR_Coverage, 622,
     /* 287164 */     GIR_Done,
     /* 287165 */   // Label 5933: @287165
     /* 287165 */   GIM_Reject,
     /* 287166 */ // Label 5924: @287166
     /* 287166 */ GIM_Reject,
     /* 287167 */ // Label 5904: @287167
     /* 287167 */ GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(287796),
     /* 287172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287182 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(287295), // Rule ID 6245 //
     /* 287187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287244 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287248 */     // MIs[3] Operand 1
     /* 287248 */     // No operand predicates
     /* 287248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287250 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287262 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287293 */     GIR_RootConstrainSelectedInstOperands,
     /* 287294 */     // GIR_Coverage, 6245,
     /* 287294 */     GIR_EraseRootFromParent_Done,
     /* 287295 */   // Label 5935: @287295
     /* 287295 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(287408), // Rule ID 13895 //
     /* 287300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287332 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287336 */     // MIs[2] Operand 1
     /* 287336 */     // No operand predicates
     /* 287336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287344 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 287352 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287357 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 287361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287363 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287375 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287406 */     GIR_RootConstrainSelectedInstOperands,
     /* 287407 */     // GIR_Coverage, 13895,
     /* 287407 */     GIR_EraseRootFromParent_Done,
     /* 287408 */   // Label 5936: @287408
     /* 287408 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(287484), // Rule ID 13829 //
     /* 287413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287434 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287444 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 287444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287456 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287482 */     GIR_RootConstrainSelectedInstOperands,
     /* 287483 */     // GIR_Coverage, 13829,
     /* 287483 */     GIR_EraseRootFromParent_Done,
     /* 287484 */   // Label 5937: @287484
     /* 287484 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(287560), // Rule ID 4807 //
     /* 287489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287514 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287520 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 287520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287532 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287558 */     GIR_RootConstrainSelectedInstOperands,
     /* 287559 */     // GIR_Coverage, 4807,
     /* 287559 */     GIR_EraseRootFromParent_Done,
     /* 287560 */   // Label 5938: @287560
     /* 287560 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(287623), // Rule ID 13444 //
     /* 287565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287601 */     // MIs[2] Operand 1
     /* 287601 */     // No operand predicates
     /* 287601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287607 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287621 */     GIR_RootConstrainSelectedInstOperands,
     /* 287622 */     // GIR_Coverage, 13444,
     /* 287622 */     GIR_EraseRootFromParent_Done,
     /* 287623 */   // Label 5939: @287623
     /* 287623 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(287686), // Rule ID 2016 //
     /* 287628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287664 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287668 */     // MIs[2] Operand 1
     /* 287668 */     // No operand predicates
     /* 287668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287670 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287684 */     GIR_RootConstrainSelectedInstOperands,
     /* 287685 */     // GIR_Coverage, 2016,
     /* 287685 */     GIR_EraseRootFromParent_Done,
     /* 287686 */   // Label 5940: @287686
     /* 287686 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(287727), // Rule ID 4810 //
     /* 287691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287714 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 287714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 287717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287723 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 287725 */     GIR_RootConstrainSelectedInstOperands,
     /* 287726 */     // GIR_Coverage, 4810,
     /* 287726 */     GIR_EraseRootFromParent_Done,
     /* 287727 */   // Label 5941: @287727
     /* 287727 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(287768), // Rule ID 13832 //
     /* 287732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287755 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 287755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 287758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287764 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 287766 */     GIR_RootConstrainSelectedInstOperands,
     /* 287767 */     // GIR_Coverage, 13832,
     /* 287767 */     GIR_EraseRootFromParent_Done,
     /* 287768 */   // Label 5942: @287768
     /* 287768 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(287795), // Rule ID 624 //
     /* 287773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287784 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 287784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287789 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287793 */     GIR_RootConstrainSelectedInstOperands,
     /* 287794 */     // GIR_Coverage, 624,
     /* 287794 */     GIR_Done,
     /* 287795 */   // Label 5943: @287795
     /* 287795 */   GIM_Reject,
     /* 287796 */ // Label 5934: @287796
     /* 287796 */ GIM_Reject,
     /* 287797 */ // Label 5905: @287797
     /* 287797 */ GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(288326),
     /* 287802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 287805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287812 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(287898), // Rule ID 13433 //
     /* 287817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 287828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287861 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287865 */     // MIs[3] Operand 1
     /* 287865 */     // No operand predicates
     /* 287865 */     // MIs[1] Operand 2
     /* 287865 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 287876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287882 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287896 */     GIR_RootConstrainSelectedInstOperands,
     /* 287897 */     // GIR_Coverage, 13433,
     /* 287897 */     GIR_EraseRootFromParent_Done,
     /* 287898 */   // Label 5945: @287898
     /* 287898 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(287984), // Rule ID 2005 //
     /* 287903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 287918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287934 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287951 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287955 */     // MIs[3] Operand 1
     /* 287955 */     // No operand predicates
     /* 287955 */     // MIs[1] Operand 2
     /* 287955 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 287966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287968 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287982 */     GIR_RootConstrainSelectedInstOperands,
     /* 287983 */     // GIR_Coverage, 2005,
     /* 287983 */     GIR_EraseRootFromParent_Done,
     /* 287984 */   // Label 5946: @287984
     /* 287984 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(288047), // Rule ID 13434 //
     /* 287989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288021 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288025 */     // MIs[2] Operand 1
     /* 288025 */     // No operand predicates
     /* 288025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288029 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288031 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288045 */     GIR_RootConstrainSelectedInstOperands,
     /* 288046 */     // GIR_Coverage, 13434,
     /* 288046 */     GIR_EraseRootFromParent_Done,
     /* 288047 */   // Label 5947: @288047
     /* 288047 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(288110), // Rule ID 2006 //
     /* 288052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288092 */     // MIs[2] Operand 1
     /* 288092 */     // No operand predicates
     /* 288092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288094 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288108 */     GIR_RootConstrainSelectedInstOperands,
     /* 288109 */     // GIR_Coverage, 2006,
     /* 288109 */     GIR_EraseRootFromParent_Done,
     /* 288110 */   // Label 5948: @288110
     /* 288110 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(288204), // Rule ID 13897 //
     /* 288115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288138 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288138 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288141 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288145 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288164 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 288174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288202 */     GIR_RootConstrainSelectedInstOperands,
     /* 288203 */     // GIR_Coverage, 13897,
     /* 288203 */     GIR_EraseRootFromParent_Done,
     /* 288204 */   // Label 5949: @288204
     /* 288204 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(288298), // Rule ID 6247 //
     /* 288209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288232 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288232 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288235 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288239 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288258 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 288268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288296 */     GIR_RootConstrainSelectedInstOperands,
     /* 288297 */     // GIR_Coverage, 6247,
     /* 288297 */     GIR_EraseRootFromParent_Done,
     /* 288298 */   // Label 5950: @288298
     /* 288298 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(288325), // Rule ID 1323 //
     /* 288303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288314 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 288314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 288319 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288323 */     GIR_RootConstrainSelectedInstOperands,
     /* 288324 */     // GIR_Coverage, 1323,
     /* 288324 */     GIR_Done,
     /* 288325 */   // Label 5951: @288325
     /* 288325 */   GIM_Reject,
     /* 288326 */ // Label 5944: @288326
     /* 288326 */ GIM_Reject,
     /* 288327 */ // Label 5906: @288327
     /* 288327 */ GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(288684),
     /* 288332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 288338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288342 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(288405), // Rule ID 13438 //
     /* 288347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 288358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288383 */     // MIs[2] Operand 1
     /* 288383 */     // No operand predicates
     /* 288383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288389 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288403 */     GIR_RootConstrainSelectedInstOperands,
     /* 288404 */     // GIR_Coverage, 13438,
     /* 288404 */     GIR_EraseRootFromParent_Done,
     /* 288405 */   // Label 5953: @288405
     /* 288405 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(288468), // Rule ID 2010 //
     /* 288410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 288425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288446 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288450 */     // MIs[2] Operand 1
     /* 288450 */     // No operand predicates
     /* 288450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288452 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288466 */     GIR_RootConstrainSelectedInstOperands,
     /* 288467 */     // GIR_Coverage, 2010,
     /* 288467 */     GIR_EraseRootFromParent_Done,
     /* 288468 */   // Label 5954: @288468
     /* 288468 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(288562), // Rule ID 13901 //
     /* 288473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288496 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288496 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288499 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288503 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288560 */     GIR_RootConstrainSelectedInstOperands,
     /* 288561 */     // GIR_Coverage, 13901,
     /* 288561 */     GIR_EraseRootFromParent_Done,
     /* 288562 */   // Label 5955: @288562
     /* 288562 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(288656), // Rule ID 6251 //
     /* 288567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288590 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288616 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288654 */     GIR_RootConstrainSelectedInstOperands,
     /* 288655 */     // GIR_Coverage, 6251,
     /* 288655 */     GIR_EraseRootFromParent_Done,
     /* 288656 */   // Label 5956: @288656
     /* 288656 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(288683), // Rule ID 1327 //
     /* 288661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288672 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 288672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 288677 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288681 */     GIR_RootConstrainSelectedInstOperands,
     /* 288682 */     // GIR_Coverage, 1327,
     /* 288682 */     GIR_Done,
     /* 288683 */   // Label 5957: @288683
     /* 288683 */   GIM_Reject,
     /* 288684 */ // Label 5952: @288684
     /* 288684 */ GIM_Reject,
     /* 288685 */ // Label 5907: @288685
     /* 288685 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(289026),
     /* 288690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 288693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 288696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288700 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(288786), // Rule ID 13427 //
     /* 288705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288749 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288753 */     // MIs[3] Operand 1
     /* 288753 */     // No operand predicates
     /* 288753 */     // MIs[1] Operand 2
     /* 288753 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288768 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288770 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288784 */     GIR_RootConstrainSelectedInstOperands,
     /* 288785 */     // GIR_Coverage, 13427,
     /* 288785 */     GIR_EraseRootFromParent_Done,
     /* 288786 */   // Label 5959: @288786
     /* 288786 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(288872), // Rule ID 1999 //
     /* 288791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288839 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288843 */     // MIs[3] Operand 1
     /* 288843 */     // No operand predicates
     /* 288843 */     // MIs[1] Operand 2
     /* 288843 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288856 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288870 */     GIR_RootConstrainSelectedInstOperands,
     /* 288871 */     // GIR_Coverage, 1999,
     /* 288871 */     GIR_EraseRootFromParent_Done,
     /* 288872 */   // Label 5960: @288872
     /* 288872 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(288935), // Rule ID 13428 //
     /* 288877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288909 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288913 */     // MIs[2] Operand 1
     /* 288913 */     // No operand predicates
     /* 288913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288919 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288933 */     GIR_RootConstrainSelectedInstOperands,
     /* 288934 */     // GIR_Coverage, 13428,
     /* 288934 */     GIR_EraseRootFromParent_Done,
     /* 288935 */   // Label 5961: @288935
     /* 288935 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(288998), // Rule ID 2000 //
     /* 288940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288980 */     // MIs[2] Operand 1
     /* 288980 */     // No operand predicates
     /* 288980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288982 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288996 */     GIR_RootConstrainSelectedInstOperands,
     /* 288997 */     // GIR_Coverage, 2000,
     /* 288997 */     GIR_EraseRootFromParent_Done,
     /* 288998 */   // Label 5962: @288998
     /* 288998 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(289025), // Rule ID 1319 //
     /* 289003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289014 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 289014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 289019 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289023 */     GIR_RootConstrainSelectedInstOperands,
     /* 289024 */     // GIR_Coverage, 1319,
     /* 289024 */     GIR_Done,
     /* 289025 */   // Label 5963: @289025
     /* 289025 */   GIM_Reject,
     /* 289026 */ // Label 5958: @289026
     /* 289026 */ GIM_Reject,
     /* 289027 */ // Label 5908: @289027
     /* 289027 */ GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(289384),
     /* 289032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 289038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289042 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(289105), // Rule ID 13436 //
     /* 289047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289083 */     // MIs[2] Operand 1
     /* 289083 */     // No operand predicates
     /* 289083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289089 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289103 */     GIR_RootConstrainSelectedInstOperands,
     /* 289104 */     // GIR_Coverage, 13436,
     /* 289104 */     GIR_EraseRootFromParent_Done,
     /* 289105 */   // Label 5965: @289105
     /* 289105 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(289168), // Rule ID 2008 //
     /* 289110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289150 */     // MIs[2] Operand 1
     /* 289150 */     // No operand predicates
     /* 289150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289152 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289166 */     GIR_RootConstrainSelectedInstOperands,
     /* 289167 */     // GIR_Coverage, 2008,
     /* 289167 */     GIR_EraseRootFromParent_Done,
     /* 289168 */   // Label 5966: @289168
     /* 289168 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(289262), // Rule ID 13899 //
     /* 289173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289196 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289222 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289260 */     GIR_RootConstrainSelectedInstOperands,
     /* 289261 */     // GIR_Coverage, 13899,
     /* 289261 */     GIR_EraseRootFromParent_Done,
     /* 289262 */   // Label 5967: @289262
     /* 289262 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(289356), // Rule ID 6249 //
     /* 289267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289290 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289323 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289354 */     GIR_RootConstrainSelectedInstOperands,
     /* 289355 */     // GIR_Coverage, 6249,
     /* 289355 */     GIR_EraseRootFromParent_Done,
     /* 289356 */   // Label 5968: @289356
     /* 289356 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(289383), // Rule ID 1325 //
     /* 289361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289372 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 289372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289377 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289381 */     GIR_RootConstrainSelectedInstOperands,
     /* 289382 */     // GIR_Coverage, 1325,
     /* 289382 */     GIR_Done,
     /* 289383 */   // Label 5969: @289383
     /* 289383 */   GIM_Reject,
     /* 289384 */ // Label 5964: @289384
     /* 289384 */ GIM_Reject,
     /* 289385 */ // Label 5909: @289385
     /* 289385 */ GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(289816),
     /* 289390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 289396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289400 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(289463), // Rule ID 13430 //
     /* 289405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289441 */     // MIs[2] Operand 1
     /* 289441 */     // No operand predicates
     /* 289441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289447 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 289450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289461 */     GIR_RootConstrainSelectedInstOperands,
     /* 289462 */     // GIR_Coverage, 13430,
     /* 289462 */     GIR_EraseRootFromParent_Done,
     /* 289463 */   // Label 5971: @289463
     /* 289463 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(289526), // Rule ID 2002 //
     /* 289468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289508 */     // MIs[2] Operand 1
     /* 289508 */     // No operand predicates
     /* 289508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289510 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 289513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289524 */     GIR_RootConstrainSelectedInstOperands,
     /* 289525 */     // GIR_Coverage, 2002,
     /* 289525 */     GIR_EraseRootFromParent_Done,
     /* 289526 */   // Label 5972: @289526
     /* 289526 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(289553), // Rule ID 1321 //
     /* 289531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289542 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 289542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 289547 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289551 */     GIR_RootConstrainSelectedInstOperands,
     /* 289552 */     // GIR_Coverage, 1321,
     /* 289552 */     GIR_Done,
     /* 289553 */   // Label 5973: @289553
     /* 289553 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(289815), // Rule ID 7004 //
     /* 289558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 289561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289569 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 289569 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 289572 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 289576 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289581 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 289585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 289587 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 289590 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 289594 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289599 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 289603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 289605 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 289608 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289612 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289617 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 289620 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 289623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 289625 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 289628 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289632 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289637 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 289643 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289648 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289653 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 289656 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 289660 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289665 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 289668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 289670 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 289673 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289677 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289682 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289688 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289693 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289698 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 289701 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 289705 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289710 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 289713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 289715 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 289718 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289722 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289727 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 289730 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 289733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 289735 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 289738 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 289742 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289747 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 289750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 289752 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 289755 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289759 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289778 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 289784 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 289787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 289805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 289813 */     GIR_RootConstrainSelectedInstOperands,
     /* 289814 */     // GIR_Coverage, 7004,
     /* 289814 */     GIR_EraseRootFromParent_Done,
     /* 289815 */   // Label 5974: @289815
     /* 289815 */   GIM_Reject,
     /* 289816 */ // Label 5970: @289816
     /* 289816 */ GIM_Reject,
     /* 289817 */ // Label 5910: @289817
     /* 289817 */ GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(289842), // Rule ID 8180 //
     /* 289822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 289828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 289831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289835 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 289835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 289840 */   GIR_RootConstrainSelectedInstOperands,
     /* 289841 */   // GIR_Coverage, 8180,
     /* 289841 */   GIR_Done,
     /* 289842 */ // Label 5975: @289842
     /* 289842 */ GIM_Reject,
     /* 289843 */ // Label 5911: @289843
     /* 289843 */ GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(289868), // Rule ID 8178 //
     /* 289848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 289854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 289857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289861 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 289861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 289866 */   GIR_RootConstrainSelectedInstOperands,
     /* 289867 */   // GIR_Coverage, 8178,
     /* 289867 */   GIR_Done,
     /* 289868 */ // Label 5976: @289868
     /* 289868 */ GIM_Reject,
     /* 289869 */ // Label 5912: @289869
     /* 289869 */ GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(289894), // Rule ID 8176 //
     /* 289874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 289880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 289883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289887 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 289887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 289892 */   GIR_RootConstrainSelectedInstOperands,
     /* 289893 */   // GIR_Coverage, 8176,
     /* 289893 */   GIR_Done,
     /* 289894 */ // Label 5977: @289894
     /* 289894 */ GIM_Reject,
     /* 289895 */ // Label 5913: @289895
     /* 289895 */ GIM_Reject,
     /* 289896 */ // Label 60: @289896
     /* 289896 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5986*/ GIMT_Encode4(306168),
     /* 289907 */ /*GILLT_s16*//*Label 5978*/ GIMT_Encode4(289947),
     /* 289911 */ /*GILLT_s32*//*Label 5979*/ GIMT_Encode4(292951),
     /* 289915 */ /*GILLT_s64*//*Label 5980*/ GIMT_Encode4(296099), GIMT_Encode4(0),
     /* 289923 */ /*GILLT_v2s32*//*Label 5981*/ GIMT_Encode4(299247),
     /* 289927 */ /*GILLT_v2s64*//*Label 5982*/ GIMT_Encode4(300768),
     /* 289931 */ /*GILLT_v4s16*//*Label 5983*/ GIMT_Encode4(302289),
     /* 289935 */ /*GILLT_v4s32*//*Label 5984*/ GIMT_Encode4(303468), GIMT_Encode4(0),
     /* 289943 */ /*GILLT_v8s16*//*Label 5985*/ GIMT_Encode4(304989),
     /* 289947 */ // Label 5978: @289947
     /* 289947 */ GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(292950),
     /* 289952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 289955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 289958 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 289961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289965 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(290115), // Rule ID 4865 //
     /* 289970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289994 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290019 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 290027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 290035 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290042 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290042 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290045 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290049 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290054 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290060 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290082 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 290101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 290113 */     GIR_RootConstrainSelectedInstOperands,
     /* 290114 */     // GIR_Coverage, 4865,
     /* 290114 */     GIR_EraseRootFromParent_Done,
     /* 290115 */   // Label 5988: @290115
     /* 290115 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(290262), // Rule ID 4829 //
     /* 290120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290144 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 290160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 290164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290172 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290176 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290181 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 290185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290191 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290203 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290231 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 290250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290260 */     GIR_RootConstrainSelectedInstOperands,
     /* 290261 */     // GIR_Coverage, 4829,
     /* 290261 */     GIR_EraseRootFromParent_Done,
     /* 290262 */   // Label 5989: @290262
     /* 290262 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(290409), // Rule ID 13838 //
     /* 290267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290315 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290319 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290323 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290328 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 290332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290338 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290338 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290341 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290345 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290350 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290378 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 290397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290407 */     GIR_RootConstrainSelectedInstOperands,
     /* 290408 */     // GIR_Coverage, 13838,
     /* 290408 */     GIR_EraseRootFromParent_Done,
     /* 290409 */   // Label 5990: @290409
     /* 290409 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(290540), // Rule ID 6079 //
     /* 290414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290438 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 290454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 290458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290466 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290470 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290475 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 290479 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290483 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290487 */     // MIs[4] Operand 1
     /* 290487 */     // No operand predicates
     /* 290487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290491 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290493 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290505 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 290535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 290538 */     GIR_RootConstrainSelectedInstOperands,
     /* 290539 */     // GIR_Coverage, 6079,
     /* 290539 */     GIR_EraseRootFromParent_Done,
     /* 290540 */   // Label 5991: @290540
     /* 290540 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(290671), // Rule ID 6111 //
     /* 290545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290577 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290581 */     // MIs[2] Operand 1
     /* 290581 */     // No operand predicates
     /* 290581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290589 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 290593 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 290597 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290601 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290605 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 290609 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290614 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 290618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290622 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290624 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290636 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290669 */     GIR_RootConstrainSelectedInstOperands,
     /* 290670 */     // GIR_Coverage, 6111,
     /* 290670 */     GIR_EraseRootFromParent_Done,
     /* 290671 */   // Label 5992: @290671
     /* 290671 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(290802), // Rule ID 6175 //
     /* 290676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290712 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290724 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290728 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290732 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290737 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 290741 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290745 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290749 */     // MIs[4] Operand 1
     /* 290749 */     // No operand predicates
     /* 290749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290753 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290755 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290767 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 290797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 290800 */     GIR_RootConstrainSelectedInstOperands,
     /* 290801 */     // GIR_Coverage, 6175,
     /* 290801 */     GIR_EraseRootFromParent_Done,
     /* 290802 */   // Label 5993: @290802
     /* 290802 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(290933), // Rule ID 6143 //
     /* 290807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290851 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290855 */     // MIs[3] Operand 1
     /* 290855 */     // No operand predicates
     /* 290855 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 290859 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290863 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290867 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 290871 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290876 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 290880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290886 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290898 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290931 */     GIR_RootConstrainSelectedInstOperands,
     /* 290932 */     // GIR_Coverage, 6143,
     /* 290932 */     GIR_EraseRootFromParent_Done,
     /* 290933 */   // Label 5994: @290933
     /* 290933 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(291068), // Rule ID 2456 //
     /* 290938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290987 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290997 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 291000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291009 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291037 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 291056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 291064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291066 */     GIR_RootConstrainSelectedInstOperands,
     /* 291067 */     // GIR_Coverage, 2456,
     /* 291067 */     GIR_EraseRootFromParent_Done,
     /* 291068 */   // Label 5995: @291068
     /* 291068 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(291187), // Rule ID 6047 //
     /* 291073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291097 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291130 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291134 */     // MIs[3] Operand 1
     /* 291134 */     // No operand predicates
     /* 291134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291140 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291152 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 291171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291185 */     GIR_RootConstrainSelectedInstOperands,
     /* 291186 */     // GIR_Coverage, 6047,
     /* 291186 */     GIR_EraseRootFromParent_Done,
     /* 291187 */   // Label 5996: @291187
     /* 291187 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(291306), // Rule ID 2538 //
     /* 291192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291224 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291228 */     // MIs[2] Operand 1
     /* 291228 */     // No operand predicates
     /* 291228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291236 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291240 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291244 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291249 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 291253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291259 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291271 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 291290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291304 */     GIR_RootConstrainSelectedInstOperands,
     /* 291305 */     // GIR_Coverage, 2538,
     /* 291305 */     GIR_EraseRootFromParent_Done,
     /* 291306 */   // Label 5997: @291306
     /* 291306 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(291406), // Rule ID 4827 //
     /* 291311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291335 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291362 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291374 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291404 */     GIR_RootConstrainSelectedInstOperands,
     /* 291405 */     // GIR_Coverage, 4827,
     /* 291405 */     GIR_EraseRootFromParent_Done,
     /* 291406 */   // Label 5998: @291406
     /* 291406 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(291506), // Rule ID 4863 //
     /* 291411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291435 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291462 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291474 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 291493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291504 */     GIR_RootConstrainSelectedInstOperands,
     /* 291505 */     // GIR_Coverage, 4863,
     /* 291505 */     GIR_EraseRootFromParent_Done,
     /* 291506 */   // Label 5999: @291506
     /* 291506 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(291603), // Rule ID 13834 //
     /* 291511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291547 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291561 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291573 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291601 */     GIR_RootConstrainSelectedInstOperands,
     /* 291602 */     // GIR_Coverage, 13834,
     /* 291602 */     GIR_EraseRootFromParent_Done,
     /* 291603 */   // Label 6000: @291603
     /* 291603 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(291703), // Rule ID 13836 //
     /* 291608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291649 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291659 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291671 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291701 */     GIR_RootConstrainSelectedInstOperands,
     /* 291702 */     // GIR_Coverage, 13836,
     /* 291702 */     GIR_EraseRootFromParent_Done,
     /* 291703 */   // Label 6001: @291703
     /* 291703 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(291803), // Rule ID 4861 //
     /* 291708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291736 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291759 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 291790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291801 */     GIR_RootConstrainSelectedInstOperands,
     /* 291802 */     // GIR_Coverage, 4861,
     /* 291802 */     GIR_EraseRootFromParent_Done,
     /* 291803 */   // Label 6002: @291803
     /* 291803 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(291900), // Rule ID 4825 //
     /* 291808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291848 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291858 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291898 */     GIR_RootConstrainSelectedInstOperands,
     /* 291899 */     // GIR_Coverage, 4825,
     /* 291899 */     GIR_EraseRootFromParent_Done,
     /* 291900 */   // Label 6003: @291900
     /* 291900 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(291984), // Rule ID 6109 //
     /* 291905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291937 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291941 */     // MIs[2] Operand 1
     /* 291941 */     // No operand predicates
     /* 291941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291949 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 291953 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291964 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 291975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291982 */     GIR_RootConstrainSelectedInstOperands,
     /* 291983 */     // GIR_Coverage, 6109,
     /* 291983 */     GIR_EraseRootFromParent_Done,
     /* 291984 */   // Label 6004: @291984
     /* 291984 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(292065), // Rule ID 6141 //
     /* 291989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292037 */     // MIs[3] Operand 1
     /* 292037 */     // No operand predicates
     /* 292037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292045 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292047 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292063 */     GIR_RootConstrainSelectedInstOperands,
     /* 292064 */     // GIR_Coverage, 6141,
     /* 292064 */     GIR_EraseRootFromParent_Done,
     /* 292065 */   // Label 6005: @292065
     /* 292065 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(292149), // Rule ID 6173 //
     /* 292070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292102 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292115 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292119 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292123 */     // MIs[3] Operand 1
     /* 292123 */     // No operand predicates
     /* 292123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292129 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292147 */     GIR_RootConstrainSelectedInstOperands,
     /* 292148 */     // GIR_Coverage, 6173,
     /* 292148 */     GIR_EraseRootFromParent_Done,
     /* 292149 */   // Label 6006: @292149
     /* 292149 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(292230), // Rule ID 6077 //
     /* 292154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292202 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292206 */     // MIs[3] Operand 1
     /* 292206 */     // No operand predicates
     /* 292206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292212 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292228 */     GIR_RootConstrainSelectedInstOperands,
     /* 292229 */     // GIR_Coverage, 6077,
     /* 292229 */     GIR_EraseRootFromParent_Done,
     /* 292230 */   // Label 6007: @292230
     /* 292230 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(292315), // Rule ID 2454 //
     /* 292235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292259 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292273 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292285 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292313 */     GIR_RootConstrainSelectedInstOperands,
     /* 292314 */     // GIR_Coverage, 2454,
     /* 292314 */     GIR_EraseRootFromParent_Done,
     /* 292315 */   // Label 6008: @292315
     /* 292315 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(292400), // Rule ID 2452 //
     /* 292320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292348 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292358 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292370 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292398 */     GIR_RootConstrainSelectedInstOperands,
     /* 292399 */     // GIR_Coverage, 2452,
     /* 292399 */     GIR_EraseRootFromParent_Done,
     /* 292400 */   // Label 6009: @292400
     /* 292400 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(292469), // Rule ID 2536 //
     /* 292405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292441 */     // MIs[2] Operand 1
     /* 292441 */     // No operand predicates
     /* 292441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292451 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292467 */     GIR_RootConstrainSelectedInstOperands,
     /* 292468 */     // GIR_Coverage, 2536,
     /* 292468 */     GIR_EraseRootFromParent_Done,
     /* 292469 */   // Label 6010: @292469
     /* 292469 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(292538), // Rule ID 6045 //
     /* 292474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292510 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292514 */     // MIs[2] Operand 1
     /* 292514 */     // No operand predicates
     /* 292514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292520 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292536 */     GIR_RootConstrainSelectedInstOperands,
     /* 292537 */     // GIR_Coverage, 6045,
     /* 292537 */     GIR_EraseRootFromParent_Done,
     /* 292538 */   // Label 6011: @292538
     /* 292538 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(292603), // Rule ID 4881 //
     /* 292543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292586 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 292589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292601 */     GIR_RootConstrainSelectedInstOperands,
     /* 292602 */     // GIR_Coverage, 4881,
     /* 292602 */     GIR_EraseRootFromParent_Done,
     /* 292603 */   // Label 6012: @292603
     /* 292603 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(292668), // Rule ID 13854 //
     /* 292608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292644 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292651 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 292654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292666 */     GIR_RootConstrainSelectedInstOperands,
     /* 292667 */     // GIR_Coverage, 13854,
     /* 292667 */     GIR_EraseRootFromParent_Done,
     /* 292668 */   // Label 6013: @292668
     /* 292668 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(292718), // Rule ID 4878 //
     /* 292673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292703 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292716 */     GIR_RootConstrainSelectedInstOperands,
     /* 292717 */     // GIR_Coverage, 4878,
     /* 292717 */     GIR_EraseRootFromParent_Done,
     /* 292718 */   // Label 6014: @292718
     /* 292718 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(292768), // Rule ID 13280 //
     /* 292723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292753 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292766 */     GIR_RootConstrainSelectedInstOperands,
     /* 292767 */     // GIR_Coverage, 13280,
     /* 292767 */     GIR_EraseRootFromParent_Done,
     /* 292768 */   // Label 6015: @292768
     /* 292768 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(292818), // Rule ID 644 //
     /* 292773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292803 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292816 */     GIR_RootConstrainSelectedInstOperands,
     /* 292817 */     // GIR_Coverage, 644,
     /* 292817 */     GIR_EraseRootFromParent_Done,
     /* 292818 */   // Label 6016: @292818
     /* 292818 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(292868), // Rule ID 13851 //
     /* 292823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292853 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292866 */     GIR_RootConstrainSelectedInstOperands,
     /* 292867 */     // GIR_Coverage, 13851,
     /* 292867 */     GIR_EraseRootFromParent_Done,
     /* 292868 */   // Label 6017: @292868
     /* 292868 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(292918), // Rule ID 656 //
     /* 292873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292903 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 292906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 292916 */     GIR_RootConstrainSelectedInstOperands,
     /* 292917 */     // GIR_Coverage, 656,
     /* 292917 */     GIR_EraseRootFromParent_Done,
     /* 292918 */   // Label 6018: @292918
     /* 292918 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(292949), // Rule ID 638 //
     /* 292923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292938 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292943 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 292947 */     GIR_RootConstrainSelectedInstOperands,
     /* 292948 */     // GIR_Coverage, 638,
     /* 292948 */     GIR_Done,
     /* 292949 */   // Label 6019: @292949
     /* 292949 */   GIM_Reject,
     /* 292950 */ // Label 5987: @292950
     /* 292950 */ GIM_Reject,
     /* 292951 */ // Label 5979: @292951
     /* 292951 */ GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(296098),
     /* 292956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 292965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292969 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(293119), // Rule ID 4871 //
     /* 292974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 292977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292998 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293023 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 293031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293035 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 293039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293046 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293058 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293064 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293069 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293086 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 293105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 293117 */     GIR_RootConstrainSelectedInstOperands,
     /* 293118 */     // GIR_Coverage, 4871,
     /* 293118 */     GIR_EraseRootFromParent_Done,
     /* 293119 */   // Label 6021: @293119
     /* 293119 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(293266), // Rule ID 4835 //
     /* 293124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293148 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 293168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293176 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293180 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293185 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293195 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293207 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293213 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293218 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 293254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293264 */     GIR_RootConstrainSelectedInstOperands,
     /* 293265 */     // GIR_Coverage, 4835,
     /* 293265 */     GIR_EraseRootFromParent_Done,
     /* 293266 */   // Label 6022: @293266
     /* 293266 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(293413), // Rule ID 13844 //
     /* 293271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293307 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293319 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293323 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293332 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293340 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293342 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293354 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293365 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293382 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 293401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293411 */     GIR_RootConstrainSelectedInstOperands,
     /* 293412 */     // GIR_Coverage, 13844,
     /* 293412 */     GIR_EraseRootFromParent_Done,
     /* 293413 */   // Label 6023: @293413
     /* 293413 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(293544), // Rule ID 6095 //
     /* 293418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293442 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 293462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293470 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293474 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293479 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293483 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293487 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293491 */     // MIs[4] Operand 1
     /* 293491 */     // No operand predicates
     /* 293491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293495 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293497 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293509 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293542 */     GIR_RootConstrainSelectedInstOperands,
     /* 293543 */     // GIR_Coverage, 6095,
     /* 293543 */     GIR_EraseRootFromParent_Done,
     /* 293544 */   // Label 6024: @293544
     /* 293544 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(293675), // Rule ID 6127 //
     /* 293549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293585 */     // MIs[2] Operand 1
     /* 293585 */     // No operand predicates
     /* 293585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293593 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 293597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 293601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293605 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293609 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293613 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293618 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293626 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293628 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293640 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293673 */     GIR_RootConstrainSelectedInstOperands,
     /* 293674 */     // GIR_Coverage, 6127,
     /* 293674 */     GIR_EraseRootFromParent_Done,
     /* 293675 */   // Label 6025: @293675
     /* 293675 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(293806), // Rule ID 6191 //
     /* 293680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293716 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293736 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293741 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293745 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293749 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293753 */     // MIs[4] Operand 1
     /* 293753 */     // No operand predicates
     /* 293753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293757 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293759 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293804 */     GIR_RootConstrainSelectedInstOperands,
     /* 293805 */     // GIR_Coverage, 6191,
     /* 293805 */     GIR_EraseRootFromParent_Done,
     /* 293806 */   // Label 6026: @293806
     /* 293806 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(293937), // Rule ID 6159 //
     /* 293811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293855 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293859 */     // MIs[3] Operand 1
     /* 293859 */     // No operand predicates
     /* 293859 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 293863 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293867 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293871 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293875 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293880 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293888 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293890 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293902 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293935 */     GIR_RootConstrainSelectedInstOperands,
     /* 293936 */     // GIR_Coverage, 6159,
     /* 293936 */     GIR_EraseRootFromParent_Done,
     /* 293937 */   // Label 6027: @293937
     /* 293937 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(294072), // Rule ID 2462 //
     /* 293942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293966 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293991 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294001 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 294004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294013 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294024 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294041 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 294060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 294068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294070 */     GIR_RootConstrainSelectedInstOperands,
     /* 294071 */     // GIR_Coverage, 2462,
     /* 294071 */     GIR_EraseRootFromParent_Done,
     /* 294072 */   // Label 6028: @294072
     /* 294072 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(294191), // Rule ID 6063 //
     /* 294077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294101 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294134 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294138 */     // MIs[3] Operand 1
     /* 294138 */     // No operand predicates
     /* 294138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294144 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294156 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 294175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294189 */     GIR_RootConstrainSelectedInstOperands,
     /* 294190 */     // GIR_Coverage, 6063,
     /* 294190 */     GIR_EraseRootFromParent_Done,
     /* 294191 */   // Label 6029: @294191
     /* 294191 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(294310), // Rule ID 2554 //
     /* 294196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294232 */     // MIs[2] Operand 1
     /* 294232 */     // No operand predicates
     /* 294232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294244 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294248 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294253 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 294257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294263 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294275 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 294294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294308 */     GIR_RootConstrainSelectedInstOperands,
     /* 294309 */     // GIR_Coverage, 2554,
     /* 294309 */     GIR_EraseRootFromParent_Done,
     /* 294310 */   // Label 6030: @294310
     /* 294310 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(294410), // Rule ID 4833 //
     /* 294315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294339 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294366 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294378 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294408 */     GIR_RootConstrainSelectedInstOperands,
     /* 294409 */     // GIR_Coverage, 4833,
     /* 294409 */     GIR_EraseRootFromParent_Done,
     /* 294410 */   // Label 6031: @294410
     /* 294410 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(294510), // Rule ID 4869 //
     /* 294415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294439 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294466 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294478 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 294497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294508 */     GIR_RootConstrainSelectedInstOperands,
     /* 294509 */     // GIR_Coverage, 4869,
     /* 294509 */     GIR_EraseRootFromParent_Done,
     /* 294510 */   // Label 6032: @294510
     /* 294510 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(294607), // Rule ID 13840 //
     /* 294515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294551 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294565 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294577 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294605 */     GIR_RootConstrainSelectedInstOperands,
     /* 294606 */     // GIR_Coverage, 13840,
     /* 294606 */     GIR_EraseRootFromParent_Done,
     /* 294607 */   // Label 6033: @294607
     /* 294607 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(294707), // Rule ID 13842 //
     /* 294612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294653 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294663 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294705 */     GIR_RootConstrainSelectedInstOperands,
     /* 294706 */     // GIR_Coverage, 13842,
     /* 294706 */     GIR_EraseRootFromParent_Done,
     /* 294707 */   // Label 6034: @294707
     /* 294707 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(294807), // Rule ID 4867 //
     /* 294712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294740 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294763 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294775 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 294794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294805 */     GIR_RootConstrainSelectedInstOperands,
     /* 294806 */     // GIR_Coverage, 4867,
     /* 294806 */     GIR_EraseRootFromParent_Done,
     /* 294807 */   // Label 6035: @294807
     /* 294807 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(294904), // Rule ID 4831 //
     /* 294812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294852 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294862 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294874 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294902 */     GIR_RootConstrainSelectedInstOperands,
     /* 294903 */     // GIR_Coverage, 4831,
     /* 294903 */     GIR_EraseRootFromParent_Done,
     /* 294904 */   // Label 6036: @294904
     /* 294904 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(294982), // Rule ID 6213 //
     /* 294909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 294946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294950 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294954 */     // MIs[3] Operand 1
     /* 294954 */     // No operand predicates
     /* 294954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294964 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294980 */     GIR_RootConstrainSelectedInstOperands,
     /* 294981 */     // GIR_Coverage, 6213,
     /* 294981 */     GIR_EraseRootFromParent_Done,
     /* 294982 */   // Label 6037: @294982
     /* 294982 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(295066), // Rule ID 6125 //
     /* 294987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295023 */     // MIs[2] Operand 1
     /* 295023 */     // No operand predicates
     /* 295023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 295027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 295035 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295046 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 295057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295064 */     GIR_RootConstrainSelectedInstOperands,
     /* 295065 */     // GIR_Coverage, 6125,
     /* 295065 */     GIR_EraseRootFromParent_Done,
     /* 295066 */   // Label 6038: @295066
     /* 295066 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(295147), // Rule ID 6157 //
     /* 295071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295115 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295119 */     // MIs[3] Operand 1
     /* 295119 */     // No operand predicates
     /* 295119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295129 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295145 */     GIR_RootConstrainSelectedInstOperands,
     /* 295146 */     // GIR_Coverage, 6157,
     /* 295146 */     GIR_EraseRootFromParent_Done,
     /* 295147 */   // Label 6039: @295147
     /* 295147 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(295231), // Rule ID 6189 //
     /* 295152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295201 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295205 */     // MIs[3] Operand 1
     /* 295205 */     // No operand predicates
     /* 295205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295211 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295229 */     GIR_RootConstrainSelectedInstOperands,
     /* 295230 */     // GIR_Coverage, 6189,
     /* 295230 */     GIR_EraseRootFromParent_Done,
     /* 295231 */   // Label 6040: @295231
     /* 295231 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(295309), // Rule ID 6235 //
     /* 295236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295281 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295285 */     // MIs[3] Operand 1
     /* 295285 */     // No operand predicates
     /* 295285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295291 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295307 */     GIR_RootConstrainSelectedInstOperands,
     /* 295308 */     // GIR_Coverage, 6235,
     /* 295308 */     GIR_EraseRootFromParent_Done,
     /* 295309 */   // Label 6041: @295309
     /* 295309 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(295390), // Rule ID 6093 //
     /* 295314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295358 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295362 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295366 */     // MIs[3] Operand 1
     /* 295366 */     // No operand predicates
     /* 295366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295372 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295388 */     GIR_RootConstrainSelectedInstOperands,
     /* 295389 */     // GIR_Coverage, 6093,
     /* 295389 */     GIR_EraseRootFromParent_Done,
     /* 295390 */   // Label 6042: @295390
     /* 295390 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(295475), // Rule ID 2460 //
     /* 295395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295419 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295433 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295473 */     GIR_RootConstrainSelectedInstOperands,
     /* 295474 */     // GIR_Coverage, 2460,
     /* 295474 */     GIR_EraseRootFromParent_Done,
     /* 295475 */   // Label 6043: @295475
     /* 295475 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(295560), // Rule ID 2458 //
     /* 295480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295518 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295530 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295558 */     GIR_RootConstrainSelectedInstOperands,
     /* 295559 */     // GIR_Coverage, 2458,
     /* 295559 */     GIR_EraseRootFromParent_Done,
     /* 295560 */   // Label 6044: @295560
     /* 295560 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(295629), // Rule ID 2552 //
     /* 295565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295601 */     // MIs[2] Operand 1
     /* 295601 */     // No operand predicates
     /* 295601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295611 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295627 */     GIR_RootConstrainSelectedInstOperands,
     /* 295628 */     // GIR_Coverage, 2552,
     /* 295628 */     GIR_EraseRootFromParent_Done,
     /* 295629 */   // Label 6045: @295629
     /* 295629 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(295698), // Rule ID 6061 //
     /* 295634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295674 */     // MIs[2] Operand 1
     /* 295674 */     // No operand predicates
     /* 295674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295680 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295696 */     GIR_RootConstrainSelectedInstOperands,
     /* 295697 */     // GIR_Coverage, 6061,
     /* 295697 */     GIR_EraseRootFromParent_Done,
     /* 295698 */   // Label 6046: @295698
     /* 295698 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(295760), // Rule ID 4882 //
     /* 295703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295743 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 295746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295758 */     GIR_RootConstrainSelectedInstOperands,
     /* 295759 */     // GIR_Coverage, 4882,
     /* 295759 */     GIR_EraseRootFromParent_Done,
     /* 295760 */   // Label 6047: @295760
     /* 295760 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(295822), // Rule ID 13855 //
     /* 295765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295805 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 295808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295820 */     GIR_RootConstrainSelectedInstOperands,
     /* 295821 */     // GIR_Coverage, 13855,
     /* 295821 */     GIR_EraseRootFromParent_Done,
     /* 295822 */   // Label 6048: @295822
     /* 295822 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(295869), // Rule ID 4879 //
     /* 295827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295854 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295867 */     GIR_RootConstrainSelectedInstOperands,
     /* 295868 */     // GIR_Coverage, 4879,
     /* 295868 */     GIR_EraseRootFromParent_Done,
     /* 295869 */   // Label 6049: @295869
     /* 295869 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(295919), // Rule ID 13282 //
     /* 295874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295904 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295917 */     GIR_RootConstrainSelectedInstOperands,
     /* 295918 */     // GIR_Coverage, 13282,
     /* 295918 */     GIR_EraseRootFromParent_Done,
     /* 295919 */   // Label 6050: @295919
     /* 295919 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(295969), // Rule ID 646 //
     /* 295924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295954 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295967 */     GIR_RootConstrainSelectedInstOperands,
     /* 295968 */     // GIR_Coverage, 646,
     /* 295968 */     GIR_EraseRootFromParent_Done,
     /* 295969 */   // Label 6051: @295969
     /* 295969 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(296016), // Rule ID 13852 //
     /* 295974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296001 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 296012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296014 */     GIR_RootConstrainSelectedInstOperands,
     /* 296015 */     // GIR_Coverage, 13852,
     /* 296015 */     GIR_EraseRootFromParent_Done,
     /* 296016 */   // Label 6052: @296016
     /* 296016 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(296066), // Rule ID 658 //
     /* 296021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296051 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 296054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 296060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 296064 */     GIR_RootConstrainSelectedInstOperands,
     /* 296065 */     // GIR_Coverage, 658,
     /* 296065 */     GIR_EraseRootFromParent_Done,
     /* 296066 */   // Label 6053: @296066
     /* 296066 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(296097), // Rule ID 640 //
     /* 296071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296086 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 296091 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 296095 */     GIR_RootConstrainSelectedInstOperands,
     /* 296096 */     // GIR_Coverage, 640,
     /* 296096 */     GIR_Done,
     /* 296097 */   // Label 6054: @296097
     /* 296097 */   GIM_Reject,
     /* 296098 */ // Label 6020: @296098
     /* 296098 */ GIM_Reject,
     /* 296099 */ // Label 5980: @296099
     /* 296099 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(299246),
     /* 296104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 296107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 296110 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 296113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296117 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(296267), // Rule ID 4877 //
     /* 296122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296146 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296171 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 296179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296183 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 296187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296194 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296194 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296197 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296201 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296206 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 296253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 296265 */     GIR_RootConstrainSelectedInstOperands,
     /* 296266 */     // GIR_Coverage, 4877,
     /* 296266 */     GIR_EraseRootFromParent_Done,
     /* 296267 */   // Label 6056: @296267
     /* 296267 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(296414), // Rule ID 4841 //
     /* 296272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 296312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296324 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296328 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296333 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296343 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296343 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296346 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296350 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296355 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296383 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 296402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296412 */     GIR_RootConstrainSelectedInstOperands,
     /* 296413 */     // GIR_Coverage, 4841,
     /* 296413 */     GIR_EraseRootFromParent_Done,
     /* 296414 */   // Label 6057: @296414
     /* 296414 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(296561), // Rule ID 13850 //
     /* 296419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296455 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296463 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296467 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296471 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296475 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296480 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296490 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296502 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296508 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296513 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296530 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 296549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296559 */     GIR_RootConstrainSelectedInstOperands,
     /* 296560 */     // GIR_Coverage, 13850,
     /* 296560 */     GIR_EraseRootFromParent_Done,
     /* 296561 */   // Label 6058: @296561
     /* 296561 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(296692), // Rule ID 6099 //
     /* 296566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296590 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 296606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296635 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296639 */     // MIs[4] Operand 1
     /* 296639 */     // No operand predicates
     /* 296639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296645 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296657 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296690 */     GIR_RootConstrainSelectedInstOperands,
     /* 296691 */     // GIR_Coverage, 6099,
     /* 296691 */     GIR_EraseRootFromParent_Done,
     /* 296692 */   // Label 6059: @296692
     /* 296692 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(296823), // Rule ID 6131 //
     /* 296697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296733 */     // MIs[2] Operand 1
     /* 296733 */     // No operand predicates
     /* 296733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296741 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 296745 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 296749 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296753 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296757 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296761 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296766 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296774 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296776 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296788 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296821 */     GIR_RootConstrainSelectedInstOperands,
     /* 296822 */     // GIR_Coverage, 6131,
     /* 296822 */     GIR_EraseRootFromParent_Done,
     /* 296823 */   // Label 6060: @296823
     /* 296823 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(296954), // Rule ID 6195 //
     /* 296828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296864 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296876 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296880 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296884 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296897 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296901 */     // MIs[4] Operand 1
     /* 296901 */     // No operand predicates
     /* 296901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296905 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296907 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296919 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296952 */     GIR_RootConstrainSelectedInstOperands,
     /* 296953 */     // GIR_Coverage, 6195,
     /* 296953 */     GIR_EraseRootFromParent_Done,
     /* 296954 */   // Label 6061: @296954
     /* 296954 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(297085), // Rule ID 6163 //
     /* 296959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297003 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297007 */     // MIs[3] Operand 1
     /* 297007 */     // No operand predicates
     /* 297007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 297011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297015 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297019 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 297023 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297028 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 297032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297038 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297050 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297083 */     GIR_RootConstrainSelectedInstOperands,
     /* 297084 */     // GIR_Coverage, 6163,
     /* 297084 */     GIR_EraseRootFromParent_Done,
     /* 297085 */   // Label 6062: @297085
     /* 297085 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(297220), // Rule ID 2468 //
     /* 297090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297139 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297149 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297161 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297167 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297172 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297189 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 297208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297218 */     GIR_RootConstrainSelectedInstOperands,
     /* 297219 */     // GIR_Coverage, 2468,
     /* 297219 */     GIR_EraseRootFromParent_Done,
     /* 297220 */   // Label 6063: @297220
     /* 297220 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(297339), // Rule ID 6067 //
     /* 297225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297249 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297282 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297286 */     // MIs[3] Operand 1
     /* 297286 */     // No operand predicates
     /* 297286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297292 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 297323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297337 */     GIR_RootConstrainSelectedInstOperands,
     /* 297338 */     // GIR_Coverage, 6067,
     /* 297338 */     GIR_EraseRootFromParent_Done,
     /* 297339 */   // Label 6064: @297339
     /* 297339 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(297458), // Rule ID 2558 //
     /* 297344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297380 */     // MIs[2] Operand 1
     /* 297380 */     // No operand predicates
     /* 297380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297392 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297396 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297401 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297411 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297423 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 297442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297456 */     GIR_RootConstrainSelectedInstOperands,
     /* 297457 */     // GIR_Coverage, 2558,
     /* 297457 */     GIR_EraseRootFromParent_Done,
     /* 297458 */   // Label 6065: @297458
     /* 297458 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(297558), // Rule ID 4839 //
     /* 297463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297487 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297514 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297526 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297556 */     GIR_RootConstrainSelectedInstOperands,
     /* 297557 */     // GIR_Coverage, 4839,
     /* 297557 */     GIR_EraseRootFromParent_Done,
     /* 297558 */   // Label 6066: @297558
     /* 297558 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(297658), // Rule ID 4875 //
     /* 297563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297587 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297614 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297626 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 297645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 297652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297656 */     GIR_RootConstrainSelectedInstOperands,
     /* 297657 */     // GIR_Coverage, 4875,
     /* 297657 */     GIR_EraseRootFromParent_Done,
     /* 297658 */   // Label 6067: @297658
     /* 297658 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(297755), // Rule ID 13846 //
     /* 297663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297699 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297713 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297725 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297753 */     GIR_RootConstrainSelectedInstOperands,
     /* 297754 */     // GIR_Coverage, 13846,
     /* 297754 */     GIR_EraseRootFromParent_Done,
     /* 297755 */   // Label 6068: @297755
     /* 297755 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(297855), // Rule ID 13848 //
     /* 297760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297801 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297811 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297823 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297853 */     GIR_RootConstrainSelectedInstOperands,
     /* 297854 */     // GIR_Coverage, 13848,
     /* 297854 */     GIR_EraseRootFromParent_Done,
     /* 297855 */   // Label 6069: @297855
     /* 297855 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(297955), // Rule ID 4873 //
     /* 297860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297888 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297911 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297923 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 297942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297953 */     GIR_RootConstrainSelectedInstOperands,
     /* 297954 */     // GIR_Coverage, 4873,
     /* 297954 */     GIR_EraseRootFromParent_Done,
     /* 297955 */   // Label 6070: @297955
     /* 297955 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(298052), // Rule ID 4837 //
     /* 297960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298000 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298010 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298022 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298050 */     GIR_RootConstrainSelectedInstOperands,
     /* 298051 */     // GIR_Coverage, 4837,
     /* 298051 */     GIR_EraseRootFromParent_Done,
     /* 298052 */   // Label 6071: @298052
     /* 298052 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(298130), // Rule ID 6217 //
     /* 298057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298098 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298102 */     // MIs[3] Operand 1
     /* 298102 */     // No operand predicates
     /* 298102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298112 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298128 */     GIR_RootConstrainSelectedInstOperands,
     /* 298129 */     // GIR_Coverage, 6217,
     /* 298129 */     GIR_EraseRootFromParent_Done,
     /* 298130 */   // Label 6072: @298130
     /* 298130 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(298214), // Rule ID 6129 //
     /* 298135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298167 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298171 */     // MIs[2] Operand 1
     /* 298171 */     // No operand predicates
     /* 298171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 298175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 298183 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298192 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298194 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 298205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298212 */     GIR_RootConstrainSelectedInstOperands,
     /* 298213 */     // GIR_Coverage, 6129,
     /* 298213 */     GIR_EraseRootFromParent_Done,
     /* 298214 */   // Label 6073: @298214
     /* 298214 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(298295), // Rule ID 6161 //
     /* 298219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298263 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298267 */     // MIs[3] Operand 1
     /* 298267 */     // No operand predicates
     /* 298267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298277 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298293 */     GIR_RootConstrainSelectedInstOperands,
     /* 298294 */     // GIR_Coverage, 6161,
     /* 298294 */     GIR_EraseRootFromParent_Done,
     /* 298295 */   // Label 6074: @298295
     /* 298295 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(298379), // Rule ID 6193 //
     /* 298300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298345 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298349 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298353 */     // MIs[3] Operand 1
     /* 298353 */     // No operand predicates
     /* 298353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298359 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298377 */     GIR_RootConstrainSelectedInstOperands,
     /* 298378 */     // GIR_Coverage, 6193,
     /* 298378 */     GIR_EraseRootFromParent_Done,
     /* 298379 */   // Label 6075: @298379
     /* 298379 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(298457), // Rule ID 6239 //
     /* 298384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298429 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298433 */     // MIs[3] Operand 1
     /* 298433 */     // No operand predicates
     /* 298433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298439 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298455 */     GIR_RootConstrainSelectedInstOperands,
     /* 298456 */     // GIR_Coverage, 6239,
     /* 298456 */     GIR_EraseRootFromParent_Done,
     /* 298457 */   // Label 6076: @298457
     /* 298457 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(298538), // Rule ID 6097 //
     /* 298462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298510 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298514 */     // MIs[3] Operand 1
     /* 298514 */     // No operand predicates
     /* 298514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298520 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298536 */     GIR_RootConstrainSelectedInstOperands,
     /* 298537 */     // GIR_Coverage, 6097,
     /* 298537 */     GIR_EraseRootFromParent_Done,
     /* 298538 */   // Label 6077: @298538
     /* 298538 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(298623), // Rule ID 2466 //
     /* 298543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298567 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298581 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298593 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298621 */     GIR_RootConstrainSelectedInstOperands,
     /* 298622 */     // GIR_Coverage, 2466,
     /* 298622 */     GIR_EraseRootFromParent_Done,
     /* 298623 */   // Label 6078: @298623
     /* 298623 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(298708), // Rule ID 2464 //
     /* 298628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298656 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298666 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298678 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298706 */     GIR_RootConstrainSelectedInstOperands,
     /* 298707 */     // GIR_Coverage, 2464,
     /* 298707 */     GIR_EraseRootFromParent_Done,
     /* 298708 */   // Label 6079: @298708
     /* 298708 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(298777), // Rule ID 2556 //
     /* 298713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298745 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298749 */     // MIs[2] Operand 1
     /* 298749 */     // No operand predicates
     /* 298749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298759 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 298762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298775 */     GIR_RootConstrainSelectedInstOperands,
     /* 298776 */     // GIR_Coverage, 2556,
     /* 298776 */     GIR_EraseRootFromParent_Done,
     /* 298777 */   // Label 6080: @298777
     /* 298777 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(298846), // Rule ID 6065 //
     /* 298782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298818 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298822 */     // MIs[2] Operand 1
     /* 298822 */     // No operand predicates
     /* 298822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298828 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 298831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298844 */     GIR_RootConstrainSelectedInstOperands,
     /* 298845 */     // GIR_Coverage, 6065,
     /* 298845 */     GIR_EraseRootFromParent_Done,
     /* 298846 */   // Label 6081: @298846
     /* 298846 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(298908), // Rule ID 4883 //
     /* 298851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298891 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298906 */     GIR_RootConstrainSelectedInstOperands,
     /* 298907 */     // GIR_Coverage, 4883,
     /* 298907 */     GIR_EraseRootFromParent_Done,
     /* 298908 */   // Label 6082: @298908
     /* 298908 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(298970), // Rule ID 13856 //
     /* 298913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298953 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298968 */     GIR_RootConstrainSelectedInstOperands,
     /* 298969 */     // GIR_Coverage, 13856,
     /* 298969 */     GIR_EraseRootFromParent_Done,
     /* 298970 */   // Label 6083: @298970
     /* 298970 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(299017), // Rule ID 4880 //
     /* 298975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299002 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 299013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299015 */     GIR_RootConstrainSelectedInstOperands,
     /* 299016 */     // GIR_Coverage, 4880,
     /* 299016 */     GIR_EraseRootFromParent_Done,
     /* 299017 */   // Label 6084: @299017
     /* 299017 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(299067), // Rule ID 13284 //
     /* 299022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299052 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299065 */     GIR_RootConstrainSelectedInstOperands,
     /* 299066 */     // GIR_Coverage, 13284,
     /* 299066 */     GIR_EraseRootFromParent_Done,
     /* 299067 */   // Label 6085: @299067
     /* 299067 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(299117), // Rule ID 648 //
     /* 299072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299102 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299115 */     GIR_RootConstrainSelectedInstOperands,
     /* 299116 */     // GIR_Coverage, 648,
     /* 299116 */     GIR_EraseRootFromParent_Done,
     /* 299117 */   // Label 6086: @299117
     /* 299117 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(299164), // Rule ID 13853 //
     /* 299122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299149 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 299160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299162 */     GIR_RootConstrainSelectedInstOperands,
     /* 299163 */     // GIR_Coverage, 13853,
     /* 299163 */     GIR_EraseRootFromParent_Done,
     /* 299164 */   // Label 6087: @299164
     /* 299164 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(299214), // Rule ID 660 //
     /* 299169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 299184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299199 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 299202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 299208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 299212 */     GIR_RootConstrainSelectedInstOperands,
     /* 299213 */     // GIR_Coverage, 660,
     /* 299213 */     GIR_EraseRootFromParent_Done,
     /* 299214 */   // Label 6088: @299214
     /* 299214 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(299245), // Rule ID 642 //
     /* 299219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299234 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 299239 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299243 */     GIR_RootConstrainSelectedInstOperands,
     /* 299244 */     // GIR_Coverage, 642,
     /* 299244 */     GIR_Done,
     /* 299245 */   // Label 6089: @299245
     /* 299245 */   GIM_Reject,
     /* 299246 */ // Label 6055: @299246
     /* 299246 */ GIM_Reject,
     /* 299247 */ // Label 5981: @299247
     /* 299247 */ GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(300767),
     /* 299252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299265 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(299343), // Rule ID 6197 //
     /* 299270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299311 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299315 */     // MIs[3] Operand 1
     /* 299315 */     // No operand predicates
     /* 299315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299325 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299341 */     GIR_RootConstrainSelectedInstOperands,
     /* 299342 */     // GIR_Coverage, 6197,
     /* 299342 */     GIR_EraseRootFromParent_Done,
     /* 299343 */   // Label 6091: @299343
     /* 299343 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(299427), // Rule ID 6113 //
     /* 299348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299384 */     // MIs[2] Operand 1
     /* 299384 */     // No operand predicates
     /* 299384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299396 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299407 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 299418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299425 */     GIR_RootConstrainSelectedInstOperands,
     /* 299426 */     // GIR_Coverage, 6113,
     /* 299426 */     GIR_EraseRootFromParent_Done,
     /* 299427 */   // Label 6092: @299427
     /* 299427 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(299508), // Rule ID 6145 //
     /* 299432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299476 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299480 */     // MIs[3] Operand 1
     /* 299480 */     // No operand predicates
     /* 299480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299490 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299506 */     GIR_RootConstrainSelectedInstOperands,
     /* 299507 */     // GIR_Coverage, 6145,
     /* 299507 */     GIR_EraseRootFromParent_Done,
     /* 299508 */   // Label 6093: @299508
     /* 299508 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(299592), // Rule ID 6177 //
     /* 299513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299554 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299558 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299562 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299566 */     // MIs[3] Operand 1
     /* 299566 */     // No operand predicates
     /* 299566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299572 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299590 */     GIR_RootConstrainSelectedInstOperands,
     /* 299591 */     // GIR_Coverage, 6177,
     /* 299591 */     GIR_EraseRootFromParent_Done,
     /* 299592 */   // Label 6094: @299592
     /* 299592 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(299670), // Rule ID 6219 //
     /* 299597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299642 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299646 */     // MIs[3] Operand 1
     /* 299646 */     // No operand predicates
     /* 299646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299652 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299668 */     GIR_RootConstrainSelectedInstOperands,
     /* 299669 */     // GIR_Coverage, 6219,
     /* 299669 */     GIR_EraseRootFromParent_Done,
     /* 299670 */   // Label 6095: @299670
     /* 299670 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(299751), // Rule ID 6081 //
     /* 299675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299727 */     // MIs[3] Operand 1
     /* 299727 */     // No operand predicates
     /* 299727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299733 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299749 */     GIR_RootConstrainSelectedInstOperands,
     /* 299750 */     // GIR_Coverage, 6081,
     /* 299750 */     GIR_EraseRootFromParent_Done,
     /* 299751 */   // Label 6096: @299751
     /* 299751 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(299820), // Rule ID 2540 //
     /* 299756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299788 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299792 */     // MIs[2] Operand 1
     /* 299792 */     // No operand predicates
     /* 299792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299802 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 299805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299818 */     GIR_RootConstrainSelectedInstOperands,
     /* 299819 */     // GIR_Coverage, 2540,
     /* 299819 */     GIR_EraseRootFromParent_Done,
     /* 299820 */   // Label 6097: @299820
     /* 299820 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(299889), // Rule ID 6049 //
     /* 299825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299861 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299865 */     // MIs[2] Operand 1
     /* 299865 */     // No operand predicates
     /* 299865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299869 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299871 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 299874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299887 */     GIR_RootConstrainSelectedInstOperands,
     /* 299888 */     // GIR_Coverage, 6049,
     /* 299888 */     GIR_EraseRootFromParent_Done,
     /* 299889 */   // Label 6098: @299889
     /* 299889 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(299982), // Rule ID 6201 //
     /* 299894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 299918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299933 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299945 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 299955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299980 */     GIR_RootConstrainSelectedInstOperands,
     /* 299981 */     // GIR_Coverage, 6201,
     /* 299981 */     GIR_EraseRootFromParent_Done,
     /* 299982 */   // Label 6099: @299982
     /* 299982 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(300081), // Rule ID 6115 //
     /* 299987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300030 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300045 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300049 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 300073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300079 */     GIR_RootConstrainSelectedInstOperands,
     /* 300080 */     // GIR_Coverage, 6115,
     /* 300080 */     GIR_EraseRootFromParent_Done,
     /* 300081 */   // Label 6100: @300081
     /* 300081 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(300177), // Rule ID 6147 //
     /* 300086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300128 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300175 */     GIR_RootConstrainSelectedInstOperands,
     /* 300176 */     // GIR_Coverage, 6147,
     /* 300176 */     GIR_EraseRootFromParent_Done,
     /* 300177 */   // Label 6101: @300177
     /* 300177 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(300276), // Rule ID 6179 //
     /* 300182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300225 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300274 */     GIR_RootConstrainSelectedInstOperands,
     /* 300275 */     // GIR_Coverage, 6179,
     /* 300275 */     GIR_EraseRootFromParent_Done,
     /* 300276 */   // Label 6102: @300276
     /* 300276 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(300369), // Rule ID 6223 //
     /* 300281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300320 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300339 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300367 */     GIR_RootConstrainSelectedInstOperands,
     /* 300368 */     // GIR_Coverage, 6223,
     /* 300368 */     GIR_EraseRootFromParent_Done,
     /* 300369 */   // Label 6103: @300369
     /* 300369 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(300465), // Rule ID 6083 //
     /* 300374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300416 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300463 */     GIR_RootConstrainSelectedInstOperands,
     /* 300464 */     // GIR_Coverage, 6083,
     /* 300464 */     GIR_EraseRootFromParent_Done,
     /* 300465 */   // Label 6104: @300465
     /* 300465 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(300549), // Rule ID 2542 //
     /* 300470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300500 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300547 */     GIR_RootConstrainSelectedInstOperands,
     /* 300548 */     // GIR_Coverage, 2542,
     /* 300548 */     GIR_EraseRootFromParent_Done,
     /* 300549 */   // Label 6105: @300549
     /* 300549 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(300599), // Rule ID 13314 //
     /* 300554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300584 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 300587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300597 */     GIR_RootConstrainSelectedInstOperands,
     /* 300598 */     // GIR_Coverage, 13314,
     /* 300598 */     GIR_EraseRootFromParent_Done,
     /* 300599 */   // Label 6106: @300599
     /* 300599 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(300683), // Rule ID 6051 //
     /* 300604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300634 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300681 */     GIR_RootConstrainSelectedInstOperands,
     /* 300682 */     // GIR_Coverage, 6051,
     /* 300682 */     GIR_EraseRootFromParent_Done,
     /* 300683 */   // Label 6107: @300683
     /* 300683 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(300733), // Rule ID 1308 //
     /* 300688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300718 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 300721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300731 */     GIR_RootConstrainSelectedInstOperands,
     /* 300732 */     // GIR_Coverage, 1308,
     /* 300732 */     GIR_EraseRootFromParent_Done,
     /* 300733 */   // Label 6108: @300733
     /* 300733 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(300766), // Rule ID 1298 //
     /* 300738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300753 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 300756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 300764 */     GIR_RootConstrainSelectedInstOperands,
     /* 300765 */     // GIR_Coverage, 1298,
     /* 300765 */     GIR_EraseRootFromParent_Done,
     /* 300766 */   // Label 6109: @300766
     /* 300766 */   GIM_Reject,
     /* 300767 */ // Label 6090: @300767
     /* 300767 */ GIM_Reject,
     /* 300768 */ // Label 5982: @300768
     /* 300768 */ GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(302288),
     /* 300773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 300779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 300782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300786 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(300864), // Rule ID 6209 //
     /* 300791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300832 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300836 */     // MIs[3] Operand 1
     /* 300836 */     // No operand predicates
     /* 300836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300846 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300862 */     GIR_RootConstrainSelectedInstOperands,
     /* 300863 */     // GIR_Coverage, 6209,
     /* 300863 */     GIR_EraseRootFromParent_Done,
     /* 300864 */   // Label 6111: @300864
     /* 300864 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(300948), // Rule ID 6121 //
     /* 300869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300901 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300905 */     // MIs[2] Operand 1
     /* 300905 */     // No operand predicates
     /* 300905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 300909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300917 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300928 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 300939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300946 */     GIR_RootConstrainSelectedInstOperands,
     /* 300947 */     // GIR_Coverage, 6121,
     /* 300947 */     GIR_EraseRootFromParent_Done,
     /* 300948 */   // Label 6112: @300948
     /* 300948 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(301029), // Rule ID 6153 //
     /* 300953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301001 */     // MIs[3] Operand 1
     /* 301001 */     // No operand predicates
     /* 301001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301011 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301027 */     GIR_RootConstrainSelectedInstOperands,
     /* 301028 */     // GIR_Coverage, 6153,
     /* 301028 */     GIR_EraseRootFromParent_Done,
     /* 301029 */   // Label 6113: @301029
     /* 301029 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(301113), // Rule ID 6185 //
     /* 301034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301083 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301087 */     // MIs[3] Operand 1
     /* 301087 */     // No operand predicates
     /* 301087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301093 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301111 */     GIR_RootConstrainSelectedInstOperands,
     /* 301112 */     // GIR_Coverage, 6185,
     /* 301112 */     GIR_EraseRootFromParent_Done,
     /* 301113 */   // Label 6114: @301113
     /* 301113 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(301191), // Rule ID 6231 //
     /* 301118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 301159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301163 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301167 */     // MIs[3] Operand 1
     /* 301167 */     // No operand predicates
     /* 301167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301173 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301189 */     GIR_RootConstrainSelectedInstOperands,
     /* 301190 */     // GIR_Coverage, 6231,
     /* 301190 */     GIR_EraseRootFromParent_Done,
     /* 301191 */   // Label 6115: @301191
     /* 301191 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(301272), // Rule ID 6089 //
     /* 301196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301244 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301248 */     // MIs[3] Operand 1
     /* 301248 */     // No operand predicates
     /* 301248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301254 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301270 */     GIR_RootConstrainSelectedInstOperands,
     /* 301271 */     // GIR_Coverage, 6089,
     /* 301271 */     GIR_EraseRootFromParent_Done,
     /* 301272 */   // Label 6116: @301272
     /* 301272 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(301341), // Rule ID 2548 //
     /* 301277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301309 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301313 */     // MIs[2] Operand 1
     /* 301313 */     // No operand predicates
     /* 301313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301323 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301339 */     GIR_RootConstrainSelectedInstOperands,
     /* 301340 */     // GIR_Coverage, 2548,
     /* 301340 */     GIR_EraseRootFromParent_Done,
     /* 301341 */   // Label 6117: @301341
     /* 301341 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(301410), // Rule ID 6057 //
     /* 301346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301382 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301386 */     // MIs[2] Operand 1
     /* 301386 */     // No operand predicates
     /* 301386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301392 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301408 */     GIR_RootConstrainSelectedInstOperands,
     /* 301409 */     // GIR_Coverage, 6057,
     /* 301409 */     GIR_EraseRootFromParent_Done,
     /* 301410 */   // Label 6118: @301410
     /* 301410 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(301503), // Rule ID 6211 //
     /* 301415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301454 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301473 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301501 */     GIR_RootConstrainSelectedInstOperands,
     /* 301502 */     // GIR_Coverage, 6211,
     /* 301502 */     GIR_EraseRootFromParent_Done,
     /* 301503 */   // Label 6119: @301503
     /* 301503 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(301602), // Rule ID 6123 //
     /* 301508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301551 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 301594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301600 */     GIR_RootConstrainSelectedInstOperands,
     /* 301601 */     // GIR_Coverage, 6123,
     /* 301601 */     GIR_EraseRootFromParent_Done,
     /* 301602 */   // Label 6120: @301602
     /* 301602 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(301698), // Rule ID 6155 //
     /* 301607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301649 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301661 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301664 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301668 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301696 */     GIR_RootConstrainSelectedInstOperands,
     /* 301697 */     // GIR_Coverage, 6155,
     /* 301697 */     GIR_EraseRootFromParent_Done,
     /* 301698 */   // Label 6121: @301698
     /* 301698 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(301797), // Rule ID 6187 //
     /* 301703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301746 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301758 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301765 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301795 */     GIR_RootConstrainSelectedInstOperands,
     /* 301796 */     // GIR_Coverage, 6187,
     /* 301796 */     GIR_EraseRootFromParent_Done,
     /* 301797 */   // Label 6122: @301797
     /* 301797 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(301890), // Rule ID 6233 //
     /* 301802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301841 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301888 */     GIR_RootConstrainSelectedInstOperands,
     /* 301889 */     // GIR_Coverage, 6233,
     /* 301889 */     GIR_EraseRootFromParent_Done,
     /* 301890 */   // Label 6123: @301890
     /* 301890 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(301986), // Rule ID 6091 //
     /* 301895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301937 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301949 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301984 */     GIR_RootConstrainSelectedInstOperands,
     /* 301985 */     // GIR_Coverage, 6091,
     /* 301985 */     GIR_EraseRootFromParent_Done,
     /* 301986 */   // Label 6124: @301986
     /* 301986 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(302070), // Rule ID 2550 //
     /* 301991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302021 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302040 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 302056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302068 */     GIR_RootConstrainSelectedInstOperands,
     /* 302069 */     // GIR_Coverage, 2550,
     /* 302069 */     GIR_EraseRootFromParent_Done,
     /* 302070 */   // Label 6125: @302070
     /* 302070 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(302120), // Rule ID 13318 //
     /* 302075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302105 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 302108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302118 */     GIR_RootConstrainSelectedInstOperands,
     /* 302119 */     // GIR_Coverage, 13318,
     /* 302119 */     GIR_EraseRootFromParent_Done,
     /* 302120 */   // Label 6126: @302120
     /* 302120 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(302204), // Rule ID 6059 //
     /* 302125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302155 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302167 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 302190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302202 */     GIR_RootConstrainSelectedInstOperands,
     /* 302203 */     // GIR_Coverage, 6059,
     /* 302203 */     GIR_EraseRootFromParent_Done,
     /* 302204 */   // Label 6127: @302204
     /* 302204 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(302254), // Rule ID 1312 //
     /* 302209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302239 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 302242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302252 */     GIR_RootConstrainSelectedInstOperands,
     /* 302253 */     // GIR_Coverage, 1312,
     /* 302253 */     GIR_EraseRootFromParent_Done,
     /* 302254 */   // Label 6128: @302254
     /* 302254 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(302287), // Rule ID 1302 //
     /* 302259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302274 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 302277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 302285 */     GIR_RootConstrainSelectedInstOperands,
     /* 302286 */     // GIR_Coverage, 1302,
     /* 302286 */     GIR_EraseRootFromParent_Done,
     /* 302287 */   // Label 6129: @302287
     /* 302287 */   GIM_Reject,
     /* 302288 */ // Label 6110: @302288
     /* 302288 */ GIM_Reject,
     /* 302289 */ // Label 5983: @302289
     /* 302289 */ GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(303467),
     /* 302294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302307 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(302391), // Rule ID 6105 //
     /* 302312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302344 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302348 */     // MIs[2] Operand 1
     /* 302348 */     // No operand predicates
     /* 302348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 302352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302360 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302371 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 302382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302389 */     GIR_RootConstrainSelectedInstOperands,
     /* 302390 */     // GIR_Coverage, 6105,
     /* 302390 */     GIR_EraseRootFromParent_Done,
     /* 302391 */   // Label 6131: @302391
     /* 302391 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(302472), // Rule ID 6137 //
     /* 302396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302440 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302444 */     // MIs[3] Operand 1
     /* 302444 */     // No operand predicates
     /* 302444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302454 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302470 */     GIR_RootConstrainSelectedInstOperands,
     /* 302471 */     // GIR_Coverage, 6137,
     /* 302471 */     GIR_EraseRootFromParent_Done,
     /* 302472 */   // Label 6132: @302472
     /* 302472 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(302556), // Rule ID 6169 //
     /* 302477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302518 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302522 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302526 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302530 */     // MIs[3] Operand 1
     /* 302530 */     // No operand predicates
     /* 302530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302536 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302554 */     GIR_RootConstrainSelectedInstOperands,
     /* 302555 */     // GIR_Coverage, 6169,
     /* 302555 */     GIR_EraseRootFromParent_Done,
     /* 302556 */   // Label 6133: @302556
     /* 302556 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(302637), // Rule ID 6073 //
     /* 302561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302613 */     // MIs[3] Operand 1
     /* 302613 */     // No operand predicates
     /* 302613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302619 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302635 */     GIR_RootConstrainSelectedInstOperands,
     /* 302636 */     // GIR_Coverage, 6073,
     /* 302636 */     GIR_EraseRootFromParent_Done,
     /* 302637 */   // Label 6134: @302637
     /* 302637 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(302706), // Rule ID 2532 //
     /* 302642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302674 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302678 */     // MIs[2] Operand 1
     /* 302678 */     // No operand predicates
     /* 302678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302688 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 302691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302704 */     GIR_RootConstrainSelectedInstOperands,
     /* 302705 */     // GIR_Coverage, 2532,
     /* 302705 */     GIR_EraseRootFromParent_Done,
     /* 302706 */   // Label 6135: @302706
     /* 302706 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(302775), // Rule ID 6041 //
     /* 302711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302747 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302751 */     // MIs[2] Operand 1
     /* 302751 */     // No operand predicates
     /* 302751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302757 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 302760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302773 */     GIR_RootConstrainSelectedInstOperands,
     /* 302774 */     // GIR_Coverage, 6041,
     /* 302774 */     GIR_EraseRootFromParent_Done,
     /* 302775 */   // Label 6136: @302775
     /* 302775 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(302874), // Rule ID 6107 //
     /* 302780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302823 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302842 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 302866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302872 */     GIR_RootConstrainSelectedInstOperands,
     /* 302873 */     // GIR_Coverage, 6107,
     /* 302873 */     GIR_EraseRootFromParent_Done,
     /* 302874 */   // Label 6137: @302874
     /* 302874 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(302970), // Rule ID 6139 //
     /* 302879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 302906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302921 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302933 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302940 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302968 */     GIR_RootConstrainSelectedInstOperands,
     /* 302969 */     // GIR_Coverage, 6139,
     /* 302969 */     GIR_EraseRootFromParent_Done,
     /* 302970 */   // Label 6138: @302970
     /* 302970 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(303069), // Rule ID 6171 //
     /* 302975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 303003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 303007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303018 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303030 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303033 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303067 */     GIR_RootConstrainSelectedInstOperands,
     /* 303068 */     // GIR_Coverage, 6171,
     /* 303068 */     GIR_EraseRootFromParent_Done,
     /* 303069 */   // Label 6139: @303069
     /* 303069 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(303165), // Rule ID 6075 //
     /* 303074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 303101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 303105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303116 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303128 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303135 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303163 */     GIR_RootConstrainSelectedInstOperands,
     /* 303164 */     // GIR_Coverage, 6075,
     /* 303164 */     GIR_EraseRootFromParent_Done,
     /* 303165 */   // Label 6140: @303165
     /* 303165 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(303249), // Rule ID 2534 //
     /* 303170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303200 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303247 */     GIR_RootConstrainSelectedInstOperands,
     /* 303248 */     // GIR_Coverage, 2534,
     /* 303248 */     GIR_EraseRootFromParent_Done,
     /* 303249 */   // Label 6141: @303249
     /* 303249 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(303299), // Rule ID 13310 //
     /* 303254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303284 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 303287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303297 */     GIR_RootConstrainSelectedInstOperands,
     /* 303298 */     // GIR_Coverage, 13310,
     /* 303298 */     GIR_EraseRootFromParent_Done,
     /* 303299 */   // Label 6142: @303299
     /* 303299 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(303383), // Rule ID 6043 //
     /* 303304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303334 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303381 */     GIR_RootConstrainSelectedInstOperands,
     /* 303382 */     // GIR_Coverage, 6043,
     /* 303382 */     GIR_EraseRootFromParent_Done,
     /* 303383 */   // Label 6143: @303383
     /* 303383 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(303433), // Rule ID 1304 //
     /* 303388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303418 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 303421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303431 */     GIR_RootConstrainSelectedInstOperands,
     /* 303432 */     // GIR_Coverage, 1304,
     /* 303432 */     GIR_EraseRootFromParent_Done,
     /* 303433 */   // Label 6144: @303433
     /* 303433 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(303466), // Rule ID 1294 //
     /* 303438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303453 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 303456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 303464 */     GIR_RootConstrainSelectedInstOperands,
     /* 303465 */     // GIR_Coverage, 1294,
     /* 303465 */     GIR_EraseRootFromParent_Done,
     /* 303466 */   // Label 6145: @303466
     /* 303466 */   GIM_Reject,
     /* 303467 */ // Label 6130: @303467
     /* 303467 */ GIM_Reject,
     /* 303468 */ // Label 5984: @303468
     /* 303468 */ GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(304988),
     /* 303473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 303482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303486 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(303564), // Rule ID 6203 //
     /* 303491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303532 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303536 */     // MIs[3] Operand 1
     /* 303536 */     // No operand predicates
     /* 303536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303546 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303562 */     GIR_RootConstrainSelectedInstOperands,
     /* 303563 */     // GIR_Coverage, 6203,
     /* 303563 */     GIR_EraseRootFromParent_Done,
     /* 303564 */   // Label 6147: @303564
     /* 303564 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(303648), // Rule ID 6117 //
     /* 303569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303605 */     // MIs[2] Operand 1
     /* 303605 */     // No operand predicates
     /* 303605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 303609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303617 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303628 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 303639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303646 */     GIR_RootConstrainSelectedInstOperands,
     /* 303647 */     // GIR_Coverage, 6117,
     /* 303647 */     GIR_EraseRootFromParent_Done,
     /* 303648 */   // Label 6148: @303648
     /* 303648 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(303729), // Rule ID 6149 //
     /* 303653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303697 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303701 */     // MIs[3] Operand 1
     /* 303701 */     // No operand predicates
     /* 303701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303711 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303727 */     GIR_RootConstrainSelectedInstOperands,
     /* 303728 */     // GIR_Coverage, 6149,
     /* 303728 */     GIR_EraseRootFromParent_Done,
     /* 303729 */   // Label 6149: @303729
     /* 303729 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(303813), // Rule ID 6181 //
     /* 303734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303783 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303787 */     // MIs[3] Operand 1
     /* 303787 */     // No operand predicates
     /* 303787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303791 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303793 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303811 */     GIR_RootConstrainSelectedInstOperands,
     /* 303812 */     // GIR_Coverage, 6181,
     /* 303812 */     GIR_EraseRootFromParent_Done,
     /* 303813 */   // Label 6150: @303813
     /* 303813 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(303891), // Rule ID 6225 //
     /* 303818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303863 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303867 */     // MIs[3] Operand 1
     /* 303867 */     // No operand predicates
     /* 303867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303873 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303889 */     GIR_RootConstrainSelectedInstOperands,
     /* 303890 */     // GIR_Coverage, 6225,
     /* 303890 */     GIR_EraseRootFromParent_Done,
     /* 303891 */   // Label 6151: @303891
     /* 303891 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(303972), // Rule ID 6085 //
     /* 303896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303944 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303948 */     // MIs[3] Operand 1
     /* 303948 */     // No operand predicates
     /* 303948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303954 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303970 */     GIR_RootConstrainSelectedInstOperands,
     /* 303971 */     // GIR_Coverage, 6085,
     /* 303971 */     GIR_EraseRootFromParent_Done,
     /* 303972 */   // Label 6152: @303972
     /* 303972 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(304041), // Rule ID 2544 //
     /* 303977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304009 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304013 */     // MIs[2] Operand 1
     /* 304013 */     // No operand predicates
     /* 304013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304023 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304039 */     GIR_RootConstrainSelectedInstOperands,
     /* 304040 */     // GIR_Coverage, 2544,
     /* 304040 */     GIR_EraseRootFromParent_Done,
     /* 304041 */   // Label 6153: @304041
     /* 304041 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(304110), // Rule ID 6053 //
     /* 304046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304082 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304086 */     // MIs[2] Operand 1
     /* 304086 */     // No operand predicates
     /* 304086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304092 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304108 */     GIR_RootConstrainSelectedInstOperands,
     /* 304109 */     // GIR_Coverage, 6053,
     /* 304109 */     GIR_EraseRootFromParent_Done,
     /* 304110 */   // Label 6154: @304110
     /* 304110 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(304203), // Rule ID 6207 //
     /* 304115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304154 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304166 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304173 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304201 */     GIR_RootConstrainSelectedInstOperands,
     /* 304202 */     // GIR_Coverage, 6207,
     /* 304202 */     GIR_EraseRootFromParent_Done,
     /* 304203 */   // Label 6155: @304203
     /* 304203 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(304302), // Rule ID 6119 //
     /* 304208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304251 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304263 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 304294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304300 */     GIR_RootConstrainSelectedInstOperands,
     /* 304301 */     // GIR_Coverage, 6119,
     /* 304301 */     GIR_EraseRootFromParent_Done,
     /* 304302 */   // Label 6156: @304302
     /* 304302 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(304398), // Rule ID 6151 //
     /* 304307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304349 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304361 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304368 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304396 */     GIR_RootConstrainSelectedInstOperands,
     /* 304397 */     // GIR_Coverage, 6151,
     /* 304397 */     GIR_EraseRootFromParent_Done,
     /* 304398 */   // Label 6157: @304398
     /* 304398 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(304497), // Rule ID 6183 //
     /* 304403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304446 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304495 */     GIR_RootConstrainSelectedInstOperands,
     /* 304496 */     // GIR_Coverage, 6183,
     /* 304496 */     GIR_EraseRootFromParent_Done,
     /* 304497 */   // Label 6158: @304497
     /* 304497 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(304590), // Rule ID 6229 //
     /* 304502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304541 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304553 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304588 */     GIR_RootConstrainSelectedInstOperands,
     /* 304589 */     // GIR_Coverage, 6229,
     /* 304589 */     GIR_EraseRootFromParent_Done,
     /* 304590 */   // Label 6159: @304590
     /* 304590 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(304686), // Rule ID 6087 //
     /* 304595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304637 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304649 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304656 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304684 */     GIR_RootConstrainSelectedInstOperands,
     /* 304685 */     // GIR_Coverage, 6087,
     /* 304685 */     GIR_EraseRootFromParent_Done,
     /* 304686 */   // Label 6160: @304686
     /* 304686 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(304770), // Rule ID 2546 //
     /* 304691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304721 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304740 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304768 */     GIR_RootConstrainSelectedInstOperands,
     /* 304769 */     // GIR_Coverage, 2546,
     /* 304769 */     GIR_EraseRootFromParent_Done,
     /* 304770 */   // Label 6161: @304770
     /* 304770 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(304820), // Rule ID 13316 //
     /* 304775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304805 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 304808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304818 */     GIR_RootConstrainSelectedInstOperands,
     /* 304819 */     // GIR_Coverage, 13316,
     /* 304819 */     GIR_EraseRootFromParent_Done,
     /* 304820 */   // Label 6162: @304820
     /* 304820 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(304904), // Rule ID 6055 //
     /* 304825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304855 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304867 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304902 */     GIR_RootConstrainSelectedInstOperands,
     /* 304903 */     // GIR_Coverage, 6055,
     /* 304903 */     GIR_EraseRootFromParent_Done,
     /* 304904 */   // Label 6163: @304904
     /* 304904 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(304954), // Rule ID 1310 //
     /* 304909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304939 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 304942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304952 */     GIR_RootConstrainSelectedInstOperands,
     /* 304953 */     // GIR_Coverage, 1310,
     /* 304953 */     GIR_EraseRootFromParent_Done,
     /* 304954 */   // Label 6164: @304954
     /* 304954 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(304987), // Rule ID 1300 //
     /* 304959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304974 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 304977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 304985 */     GIR_RootConstrainSelectedInstOperands,
     /* 304986 */     // GIR_Coverage, 1300,
     /* 304986 */     GIR_EraseRootFromParent_Done,
     /* 304987 */   // Label 6165: @304987
     /* 304987 */   GIM_Reject,
     /* 304988 */ // Label 6146: @304988
     /* 304988 */ GIM_Reject,
     /* 304989 */ // Label 5985: @304989
     /* 304989 */ GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(306167),
     /* 304994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 305000 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 305003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305007 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(305091), // Rule ID 6101 //
     /* 305012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305044 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305048 */     // MIs[2] Operand 1
     /* 305048 */     // No operand predicates
     /* 305048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305060 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305071 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 305082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305089 */     GIR_RootConstrainSelectedInstOperands,
     /* 305090 */     // GIR_Coverage, 6101,
     /* 305090 */     GIR_EraseRootFromParent_Done,
     /* 305091 */   // Label 6167: @305091
     /* 305091 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(305172), // Rule ID 6133 //
     /* 305096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305140 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305144 */     // MIs[3] Operand 1
     /* 305144 */     // No operand predicates
     /* 305144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305154 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305170 */     GIR_RootConstrainSelectedInstOperands,
     /* 305171 */     // GIR_Coverage, 6133,
     /* 305171 */     GIR_EraseRootFromParent_Done,
     /* 305172 */   // Label 6168: @305172
     /* 305172 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(305256), // Rule ID 6165 //
     /* 305177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305230 */     // MIs[3] Operand 1
     /* 305230 */     // No operand predicates
     /* 305230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305236 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305254 */     GIR_RootConstrainSelectedInstOperands,
     /* 305255 */     // GIR_Coverage, 6165,
     /* 305255 */     GIR_EraseRootFromParent_Done,
     /* 305256 */   // Label 6169: @305256
     /* 305256 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(305337), // Rule ID 6069 //
     /* 305261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305313 */     // MIs[3] Operand 1
     /* 305313 */     // No operand predicates
     /* 305313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305319 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305335 */     GIR_RootConstrainSelectedInstOperands,
     /* 305336 */     // GIR_Coverage, 6069,
     /* 305336 */     GIR_EraseRootFromParent_Done,
     /* 305337 */   // Label 6170: @305337
     /* 305337 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(305406), // Rule ID 2528 //
     /* 305342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305374 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305378 */     // MIs[2] Operand 1
     /* 305378 */     // No operand predicates
     /* 305378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305388 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305404 */     GIR_RootConstrainSelectedInstOperands,
     /* 305405 */     // GIR_Coverage, 2528,
     /* 305405 */     GIR_EraseRootFromParent_Done,
     /* 305406 */   // Label 6171: @305406
     /* 305406 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(305475), // Rule ID 6037 //
     /* 305411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305451 */     // MIs[2] Operand 1
     /* 305451 */     // No operand predicates
     /* 305451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305457 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305473 */     GIR_RootConstrainSelectedInstOperands,
     /* 305474 */     // GIR_Coverage, 6037,
     /* 305474 */     GIR_EraseRootFromParent_Done,
     /* 305475 */   // Label 6172: @305475
     /* 305475 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(305574), // Rule ID 6103 //
     /* 305480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305523 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305535 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305542 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 305566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305572 */     GIR_RootConstrainSelectedInstOperands,
     /* 305573 */     // GIR_Coverage, 6103,
     /* 305573 */     GIR_EraseRootFromParent_Done,
     /* 305574 */   // Label 6173: @305574
     /* 305574 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(305670), // Rule ID 6135 //
     /* 305579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305621 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305633 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305640 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305668 */     GIR_RootConstrainSelectedInstOperands,
     /* 305669 */     // GIR_Coverage, 6135,
     /* 305669 */     GIR_EraseRootFromParent_Done,
     /* 305670 */   // Label 6174: @305670
     /* 305670 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(305769), // Rule ID 6167 //
     /* 305675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305718 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305730 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305737 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305767 */     GIR_RootConstrainSelectedInstOperands,
     /* 305768 */     // GIR_Coverage, 6167,
     /* 305768 */     GIR_EraseRootFromParent_Done,
     /* 305769 */   // Label 6175: @305769
     /* 305769 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(305865), // Rule ID 6071 //
     /* 305774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305816 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305835 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305863 */     GIR_RootConstrainSelectedInstOperands,
     /* 305864 */     // GIR_Coverage, 6071,
     /* 305864 */     GIR_EraseRootFromParent_Done,
     /* 305865 */   // Label 6176: @305865
     /* 305865 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(305949), // Rule ID 2530 //
     /* 305870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305900 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305919 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305947 */     GIR_RootConstrainSelectedInstOperands,
     /* 305948 */     // GIR_Coverage, 2530,
     /* 305948 */     GIR_EraseRootFromParent_Done,
     /* 305949 */   // Label 6177: @305949
     /* 305949 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(305999), // Rule ID 13312 //
     /* 305954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305984 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 305987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305997 */     GIR_RootConstrainSelectedInstOperands,
     /* 305998 */     // GIR_Coverage, 13312,
     /* 305998 */     GIR_EraseRootFromParent_Done,
     /* 305999 */   // Label 6178: @305999
     /* 305999 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(306083), // Rule ID 6039 //
     /* 306004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306034 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306046 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306053 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 306069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306081 */     GIR_RootConstrainSelectedInstOperands,
     /* 306082 */     // GIR_Coverage, 6039,
     /* 306082 */     GIR_EraseRootFromParent_Done,
     /* 306083 */   // Label 6179: @306083
     /* 306083 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(306133), // Rule ID 1306 //
     /* 306088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306118 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 306121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306131 */     GIR_RootConstrainSelectedInstOperands,
     /* 306132 */     // GIR_Coverage, 1306,
     /* 306132 */     GIR_EraseRootFromParent_Done,
     /* 306133 */   // Label 6180: @306133
     /* 306133 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(306166), // Rule ID 1296 //
     /* 306138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306153 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 306156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 306164 */     GIR_RootConstrainSelectedInstOperands,
     /* 306165 */     // GIR_Coverage, 1296,
     /* 306165 */     GIR_EraseRootFromParent_Done,
     /* 306166 */   // Label 6181: @306166
     /* 306166 */   GIM_Reject,
     /* 306167 */ // Label 6166: @306167
     /* 306167 */ GIM_Reject,
     /* 306168 */ // Label 5986: @306168
     /* 306168 */ GIM_Reject,
     /* 306169 */ // Label 61: @306169
     /* 306169 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6190*/ GIMT_Encode4(306784),
     /* 306180 */ /*GILLT_s16*//*Label 6182*/ GIMT_Encode4(306220),
     /* 306184 */ /*GILLT_s32*//*Label 6183*/ GIMT_Encode4(306258),
     /* 306188 */ /*GILLT_s64*//*Label 6184*/ GIMT_Encode4(306296), GIMT_Encode4(0),
     /* 306196 */ /*GILLT_v2s32*//*Label 6185*/ GIMT_Encode4(306334),
     /* 306200 */ /*GILLT_v2s64*//*Label 6186*/ GIMT_Encode4(306372),
     /* 306204 */ /*GILLT_v4s16*//*Label 6187*/ GIMT_Encode4(306410),
     /* 306208 */ /*GILLT_v4s32*//*Label 6188*/ GIMT_Encode4(306448), GIMT_Encode4(0),
     /* 306216 */ /*GILLT_v8s16*//*Label 6189*/ GIMT_Encode4(306486),
     /* 306220 */ // Label 6182: @306220
     /* 306220 */ GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(306257), // Rule ID 590 //
     /* 306225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 306234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306246 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 306246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 306251 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306255 */   GIR_RootConstrainSelectedInstOperands,
     /* 306256 */   // GIR_Coverage, 590,
     /* 306256 */   GIR_Done,
     /* 306257 */ // Label 6191: @306257
     /* 306257 */ GIM_Reject,
     /* 306258 */ // Label 6183: @306258
     /* 306258 */ GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(306295), // Rule ID 592 //
     /* 306263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306284 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 306284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 306289 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306293 */   GIR_RootConstrainSelectedInstOperands,
     /* 306294 */   // GIR_Coverage, 592,
     /* 306294 */   GIR_Done,
     /* 306295 */ // Label 6192: @306295
     /* 306295 */ GIM_Reject,
     /* 306296 */ // Label 6184: @306296
     /* 306296 */ GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(306333), // Rule ID 594 //
     /* 306301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306322 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 306322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 306327 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306331 */   GIR_RootConstrainSelectedInstOperands,
     /* 306332 */   // GIR_Coverage, 594,
     /* 306332 */   GIR_Done,
     /* 306333 */ // Label 6193: @306333
     /* 306333 */ GIM_Reject,
     /* 306334 */ // Label 6185: @306334
     /* 306334 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(306371), // Rule ID 1228 //
     /* 306339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 306348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306360 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 306360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 306365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306369 */   GIR_RootConstrainSelectedInstOperands,
     /* 306370 */   // GIR_Coverage, 1228,
     /* 306370 */   GIR_Done,
     /* 306371 */ // Label 6194: @306371
     /* 306371 */ GIM_Reject,
     /* 306372 */ // Label 6186: @306372
     /* 306372 */ GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(306409), // Rule ID 1232 //
     /* 306377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 306386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306398 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 306398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 306403 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306407 */   GIR_RootConstrainSelectedInstOperands,
     /* 306408 */   // GIR_Coverage, 1232,
     /* 306408 */   GIR_Done,
     /* 306409 */ // Label 6195: @306409
     /* 306409 */ GIM_Reject,
     /* 306410 */ // Label 6187: @306410
     /* 306410 */ GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(306447), // Rule ID 1224 //
     /* 306415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 306424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306436 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 306436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 306441 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306445 */   GIR_RootConstrainSelectedInstOperands,
     /* 306446 */   // GIR_Coverage, 1224,
     /* 306446 */   GIR_Done,
     /* 306447 */ // Label 6196: @306447
     /* 306447 */ GIM_Reject,
     /* 306448 */ // Label 6188: @306448
     /* 306448 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(306485), // Rule ID 1230 //
     /* 306453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 306462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306474 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 306474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306483 */   GIR_RootConstrainSelectedInstOperands,
     /* 306484 */   // GIR_Coverage, 1230,
     /* 306484 */   GIR_Done,
     /* 306485 */ // Label 6197: @306485
     /* 306485 */ GIM_Reject,
     /* 306486 */ // Label 6189: @306486
     /* 306486 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(306783),
     /* 306491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 306497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306509 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(306528), // Rule ID 1226 //
     /* 306514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306517 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 306522 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306526 */     GIR_RootConstrainSelectedInstOperands,
     /* 306527 */     // GIR_Coverage, 1226,
     /* 306527 */     GIR_Done,
     /* 306528 */   // Label 6199: @306528
     /* 306528 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(306782), // Rule ID 7002 //
     /* 306533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 306536 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 306536 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 306539 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306543 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306548 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 306552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 306554 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 306557 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306561 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306566 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 306570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 306572 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 306575 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306579 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306584 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 306587 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 306590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 306592 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 306595 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306599 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306604 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 306610 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306615 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306620 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 306623 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306627 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306632 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 306635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 306637 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 306640 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306644 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306649 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306655 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306660 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306665 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 306668 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306672 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306677 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 306680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 306682 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 306685 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306689 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306694 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 306697 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 306700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306702 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 306705 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 306709 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306714 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 306717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306719 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 306722 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306726 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306748 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 306751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 306754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 306772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 306780 */     GIR_RootConstrainSelectedInstOperands,
     /* 306781 */     // GIR_Coverage, 7002,
     /* 306781 */     GIR_EraseRootFromParent_Done,
     /* 306782 */   // Label 6200: @306782
     /* 306782 */   GIM_Reject,
     /* 306783 */ // Label 6198: @306783
     /* 306783 */ GIM_Reject,
     /* 306784 */ // Label 6190: @306784
     /* 306784 */ GIM_Reject,
     /* 306785 */ // Label 62: @306785
     /* 306785 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6209*/ GIMT_Encode4(310291),
     /* 306796 */ /*GILLT_s16*//*Label 6201*/ GIMT_Encode4(306836),
     /* 306800 */ /*GILLT_s32*//*Label 6202*/ GIMT_Encode4(308004),
     /* 306804 */ /*GILLT_s64*//*Label 6203*/ GIMT_Encode4(309027), GIMT_Encode4(0),
     /* 306812 */ /*GILLT_v2s32*//*Label 6204*/ GIMT_Encode4(310050),
     /* 306816 */ /*GILLT_v2s64*//*Label 6205*/ GIMT_Encode4(310077),
     /* 306820 */ /*GILLT_v4s16*//*Label 6206*/ GIMT_Encode4(310104),
     /* 306824 */ /*GILLT_v4s32*//*Label 6207*/ GIMT_Encode4(310184), GIMT_Encode4(0),
     /* 306832 */ /*GILLT_v8s16*//*Label 6208*/ GIMT_Encode4(310211),
     /* 306836 */ // Label 6201: @306836
     /* 306836 */ GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(308003),
     /* 306841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306848 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(307006), // Rule ID 4847 //
     /* 306853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 306864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 306872 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 306876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306897 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306909 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306913 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306917 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306922 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306933 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 306933 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306936 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306940 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306945 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306973 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 306992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 307000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307004 */     GIR_RootConstrainSelectedInstOperands,
     /* 307005 */     // GIR_Coverage, 4847,
     /* 307005 */     GIR_EraseRootFromParent_Done,
     /* 307006 */   // Label 6211: @307006
     /* 307006 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(307164), // Rule ID 4846 //
     /* 307011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307030 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307055 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 307063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307091 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 307094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307103 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 307158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307162 */     GIR_RootConstrainSelectedInstOperands,
     /* 307163 */     // GIR_Coverage, 4846,
     /* 307163 */     GIR_EraseRootFromParent_Done,
     /* 307164 */   // Label 6212: @307164
     /* 307164 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(307275), // Rule ID 4845 //
     /* 307169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307188 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307213 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307229 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307241 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307273 */     GIR_RootConstrainSelectedInstOperands,
     /* 307274 */     // GIR_Coverage, 4845,
     /* 307274 */     GIR_EraseRootFromParent_Done,
     /* 307275 */   // Label 6213: @307275
     /* 307275 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(307386), // Rule ID 4843 //
     /* 307280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307340 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307352 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307384 */     GIR_RootConstrainSelectedInstOperands,
     /* 307385 */     // GIR_Coverage, 4843,
     /* 307385 */     GIR_EraseRootFromParent_Done,
     /* 307386 */   // Label 6214: @307386
     /* 307386 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(307497), // Rule ID 4844 //
     /* 307391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307410 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307435 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307451 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307463 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307495 */     GIR_RootConstrainSelectedInstOperands,
     /* 307496 */     // GIR_Coverage, 4844,
     /* 307496 */     GIR_EraseRootFromParent_Done,
     /* 307497 */   // Label 6215: @307497
     /* 307497 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(307608), // Rule ID 4842 //
     /* 307502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307521 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307551 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307562 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307574 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307606 */     GIR_RootConstrainSelectedInstOperands,
     /* 307607 */     // GIR_Coverage, 4842,
     /* 307607 */     GIR_EraseRootFromParent_Done,
     /* 307608 */   // Label 6216: @307608
     /* 307608 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(307672), // Rule ID 650 //
     /* 307613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307632 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307653 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307670 */     GIR_RootConstrainSelectedInstOperands,
     /* 307671 */     // GIR_Coverage, 650,
     /* 307671 */     GIR_EraseRootFromParent_Done,
     /* 307672 */   // Label 6217: @307672
     /* 307672 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(307736), // Rule ID 649 //
     /* 307677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307696 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307717 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307734 */     GIR_RootConstrainSelectedInstOperands,
     /* 307735 */     // GIR_Coverage, 649,
     /* 307735 */     GIR_EraseRootFromParent_Done,
     /* 307736 */   // Label 6218: @307736
     /* 307736 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(307787), // Rule ID 626 //
     /* 307741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 307752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307772 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 307772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 307775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307785 */     GIR_RootConstrainSelectedInstOperands,
     /* 307786 */     // GIR_Coverage, 626,
     /* 307786 */     GIR_EraseRootFromParent_Done,
     /* 307787 */   // Label 6219: @307787
     /* 307787 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(307838), // Rule ID 625 //
     /* 307792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 307803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307823 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 307823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 307826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307836 */     GIR_RootConstrainSelectedInstOperands,
     /* 307837 */     // GIR_Coverage, 625,
     /* 307837 */     GIR_EraseRootFromParent_Done,
     /* 307838 */   // Label 6220: @307838
     /* 307838 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(307857), // Rule ID 524 //
     /* 307843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307850 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 307850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 307855 */     GIR_RootConstrainSelectedInstOperands,
     /* 307856 */     // GIR_Coverage, 524,
     /* 307856 */     GIR_Done,
     /* 307857 */   // Label 6221: @307857
     /* 307857 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(308002), // Rule ID 6369 //
     /* 307862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307866 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 307866 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 307869 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307873 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307880 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 307883 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307887 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307892 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 307895 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 307899 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 307902 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307907 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307912 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307917 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 307920 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307924 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307929 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307932 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 307944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307949 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 307952 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 307957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307971 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307984 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 307991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308001 */     // GIR_Coverage, 6369,
     /* 308001 */     GIR_EraseRootFromParent_Done,
     /* 308002 */   // Label 6222: @308002
     /* 308002 */   GIM_Reject,
     /* 308003 */ // Label 6210: @308003
     /* 308003 */ GIM_Reject,
     /* 308004 */ // Label 6202: @308004
     /* 308004 */ GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(309026),
     /* 308009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308016 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(308174), // Rule ID 4853 //
     /* 308021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308040 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308065 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 308073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308077 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308081 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308085 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308090 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308101 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308113 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308141 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308172 */     GIR_RootConstrainSelectedInstOperands,
     /* 308173 */     // GIR_Coverage, 4853,
     /* 308173 */     GIR_EraseRootFromParent_Done,
     /* 308174 */   // Label 6224: @308174
     /* 308174 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(308332), // Rule ID 4852 //
     /* 308179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308198 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308223 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 308231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308243 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308248 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308259 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308259 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308262 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308266 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308271 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308299 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308330 */     GIR_RootConstrainSelectedInstOperands,
     /* 308331 */     // GIR_Coverage, 4852,
     /* 308331 */     GIR_EraseRootFromParent_Done,
     /* 308332 */   // Label 6225: @308332
     /* 308332 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(308443), // Rule ID 4851 //
     /* 308337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308381 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308397 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308409 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308441 */     GIR_RootConstrainSelectedInstOperands,
     /* 308442 */     // GIR_Coverage, 4851,
     /* 308442 */     GIR_EraseRootFromParent_Done,
     /* 308443 */   // Label 6226: @308443
     /* 308443 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(308554), // Rule ID 4849 //
     /* 308448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308508 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308520 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308552 */     GIR_RootConstrainSelectedInstOperands,
     /* 308553 */     // GIR_Coverage, 4849,
     /* 308553 */     GIR_EraseRootFromParent_Done,
     /* 308554 */   // Label 6227: @308554
     /* 308554 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(308665), // Rule ID 4850 //
     /* 308559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308578 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308603 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308619 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308631 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308663 */     GIR_RootConstrainSelectedInstOperands,
     /* 308664 */     // GIR_Coverage, 4850,
     /* 308664 */     GIR_EraseRootFromParent_Done,
     /* 308665 */   // Label 6228: @308665
     /* 308665 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(308776), // Rule ID 4848 //
     /* 308670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308689 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308719 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308730 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308742 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308774 */     GIR_RootConstrainSelectedInstOperands,
     /* 308775 */     // GIR_Coverage, 4848,
     /* 308775 */     GIR_EraseRootFromParent_Done,
     /* 308776 */   // Label 6229: @308776
     /* 308776 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(308840), // Rule ID 652 //
     /* 308781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308800 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308821 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308838 */     GIR_RootConstrainSelectedInstOperands,
     /* 308839 */     // GIR_Coverage, 652,
     /* 308839 */     GIR_EraseRootFromParent_Done,
     /* 308840 */   // Label 6230: @308840
     /* 308840 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(308904), // Rule ID 651 //
     /* 308845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308864 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308885 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308902 */     GIR_RootConstrainSelectedInstOperands,
     /* 308903 */     // GIR_Coverage, 651,
     /* 308903 */     GIR_EraseRootFromParent_Done,
     /* 308904 */   // Label 6231: @308904
     /* 308904 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(308955), // Rule ID 628 //
     /* 308909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 308920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308940 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 308940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 308943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308953 */     GIR_RootConstrainSelectedInstOperands,
     /* 308954 */     // GIR_Coverage, 628,
     /* 308954 */     GIR_EraseRootFromParent_Done,
     /* 308955 */   // Label 6232: @308955
     /* 308955 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(309006), // Rule ID 627 //
     /* 308960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 308971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308991 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 308991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 308994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309004 */     GIR_RootConstrainSelectedInstOperands,
     /* 309005 */     // GIR_Coverage, 627,
     /* 309005 */     GIR_EraseRootFromParent_Done,
     /* 309006 */   // Label 6233: @309006
     /* 309006 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(309025), // Rule ID 525 //
     /* 309011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309018 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 309018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 309023 */     GIR_RootConstrainSelectedInstOperands,
     /* 309024 */     // GIR_Coverage, 525,
     /* 309024 */     GIR_Done,
     /* 309025 */   // Label 6234: @309025
     /* 309025 */   GIM_Reject,
     /* 309026 */ // Label 6223: @309026
     /* 309026 */ GIM_Reject,
     /* 309027 */ // Label 6203: @309027
     /* 309027 */ GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(310049),
     /* 309032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309039 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(309197), // Rule ID 4859 //
     /* 309044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309063 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309104 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309108 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309113 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309124 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309136 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309142 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309164 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309195 */     GIR_RootConstrainSelectedInstOperands,
     /* 309196 */     // GIR_Coverage, 4859,
     /* 309196 */     GIR_EraseRootFromParent_Done,
     /* 309197 */   // Label 6236: @309197
     /* 309197 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(309355), // Rule ID 4858 //
     /* 309202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309221 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309258 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309262 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309266 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309271 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309282 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309294 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309353 */     GIR_RootConstrainSelectedInstOperands,
     /* 309354 */     // GIR_Coverage, 4858,
     /* 309354 */     GIR_EraseRootFromParent_Done,
     /* 309355 */   // Label 6237: @309355
     /* 309355 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(309466), // Rule ID 4857 //
     /* 309360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309379 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309404 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309420 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309464 */     GIR_RootConstrainSelectedInstOperands,
     /* 309465 */     // GIR_Coverage, 4857,
     /* 309465 */     GIR_EraseRootFromParent_Done,
     /* 309466 */   // Label 6238: @309466
     /* 309466 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(309577), // Rule ID 4855 //
     /* 309471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309490 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309520 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309531 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309543 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309575 */     GIR_RootConstrainSelectedInstOperands,
     /* 309576 */     // GIR_Coverage, 4855,
     /* 309576 */     GIR_EraseRootFromParent_Done,
     /* 309577 */   // Label 6239: @309577
     /* 309577 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(309688), // Rule ID 4856 //
     /* 309582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309601 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309626 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309642 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309654 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309686 */     GIR_RootConstrainSelectedInstOperands,
     /* 309687 */     // GIR_Coverage, 4856,
     /* 309687 */     GIR_EraseRootFromParent_Done,
     /* 309688 */   // Label 6240: @309688
     /* 309688 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(309799), // Rule ID 4854 //
     /* 309693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309712 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309742 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309753 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309765 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309797 */     GIR_RootConstrainSelectedInstOperands,
     /* 309798 */     // GIR_Coverage, 4854,
     /* 309798 */     GIR_EraseRootFromParent_Done,
     /* 309799 */   // Label 6241: @309799
     /* 309799 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(309863), // Rule ID 654 //
     /* 309804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309823 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309844 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309861 */     GIR_RootConstrainSelectedInstOperands,
     /* 309862 */     // GIR_Coverage, 654,
     /* 309862 */     GIR_EraseRootFromParent_Done,
     /* 309863 */   // Label 6242: @309863
     /* 309863 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(309927), // Rule ID 653 //
     /* 309868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309887 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309908 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309925 */     GIR_RootConstrainSelectedInstOperands,
     /* 309926 */     // GIR_Coverage, 653,
     /* 309926 */     GIR_EraseRootFromParent_Done,
     /* 309927 */   // Label 6243: @309927
     /* 309927 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(309978), // Rule ID 630 //
     /* 309932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 309943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309963 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 309963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 309966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309976 */     GIR_RootConstrainSelectedInstOperands,
     /* 309977 */     // GIR_Coverage, 630,
     /* 309977 */     GIR_EraseRootFromParent_Done,
     /* 309978 */   // Label 6244: @309978
     /* 309978 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(310029), // Rule ID 629 //
     /* 309983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 309994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310014 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 310014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 310017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310027 */     GIR_RootConstrainSelectedInstOperands,
     /* 310028 */     // GIR_Coverage, 629,
     /* 310028 */     GIR_EraseRootFromParent_Done,
     /* 310029 */   // Label 6245: @310029
     /* 310029 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(310048), // Rule ID 526 //
     /* 310034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310041 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 310041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 310046 */     GIR_RootConstrainSelectedInstOperands,
     /* 310047 */     // GIR_Coverage, 526,
     /* 310047 */     GIR_Done,
     /* 310048 */   // Label 6246: @310048
     /* 310048 */   GIM_Reject,
     /* 310049 */ // Label 6235: @310049
     /* 310049 */ GIM_Reject,
     /* 310050 */ // Label 6204: @310050
     /* 310050 */ GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(310076), // Rule ID 860 //
     /* 310055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310069 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 310069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 310074 */   GIR_RootConstrainSelectedInstOperands,
     /* 310075 */   // GIR_Coverage, 860,
     /* 310075 */   GIR_Done,
     /* 310076 */ // Label 6247: @310076
     /* 310076 */ GIM_Reject,
     /* 310077 */ // Label 6205: @310077
     /* 310077 */ GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(310103), // Rule ID 862 //
     /* 310082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310096 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 310096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 310101 */   GIR_RootConstrainSelectedInstOperands,
     /* 310102 */   // GIR_Coverage, 862,
     /* 310102 */   GIR_Done,
     /* 310103 */ // Label 6248: @310103
     /* 310103 */ GIM_Reject,
     /* 310104 */ // Label 6206: @310104
     /* 310104 */ GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(310183),
     /* 310109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310120 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(310135), // Rule ID 858 //
     /* 310125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310128 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 310128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 310133 */     GIR_RootConstrainSelectedInstOperands,
     /* 310134 */     // GIR_Coverage, 858,
     /* 310134 */     GIR_Done,
     /* 310135 */   // Label 6250: @310135
     /* 310135 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(310182), // Rule ID 6372 //
     /* 310140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310143 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 310143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 310150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310155 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 310165 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 310168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 310173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310180 */     GIR_RootConstrainSelectedInstOperands,
     /* 310181 */     // GIR_Coverage, 6372,
     /* 310181 */     GIR_EraseRootFromParent_Done,
     /* 310182 */   // Label 6251: @310182
     /* 310182 */   GIM_Reject,
     /* 310183 */ // Label 6249: @310183
     /* 310183 */ GIM_Reject,
     /* 310184 */ // Label 6207: @310184
     /* 310184 */ GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(310210), // Rule ID 861 //
     /* 310189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310203 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 310203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 310208 */   GIR_RootConstrainSelectedInstOperands,
     /* 310209 */   // GIR_Coverage, 861,
     /* 310209 */   GIR_Done,
     /* 310210 */ // Label 6252: @310210
     /* 310210 */ GIM_Reject,
     /* 310211 */ // Label 6208: @310211
     /* 310211 */ GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(310290),
     /* 310216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310227 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(310242), // Rule ID 859 //
     /* 310232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310235 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 310235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 310240 */     GIR_RootConstrainSelectedInstOperands,
     /* 310241 */     // GIR_Coverage, 859,
     /* 310241 */     GIR_Done,
     /* 310242 */   // Label 6254: @310242
     /* 310242 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(310289), // Rule ID 6373 //
     /* 310247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310250 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 310250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 310253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 310257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310262 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 310272 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 310275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 310280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310287 */     GIR_RootConstrainSelectedInstOperands,
     /* 310288 */     // GIR_Coverage, 6373,
     /* 310288 */     GIR_EraseRootFromParent_Done,
     /* 310289 */   // Label 6255: @310289
     /* 310289 */   GIM_Reject,
     /* 310290 */ // Label 6253: @310290
     /* 310290 */ GIM_Reject,
     /* 310291 */ // Label 6209: @310291
     /* 310291 */ GIM_Reject,
     /* 310292 */ // Label 63: @310292
     /* 310292 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6260*/ GIMT_Encode4(310539),
     /* 310303 */ /*GILLT_s32*//*Label 6256*/ GIMT_Encode4(310331),
     /* 310307 */ /*GILLT_s64*//*Label 6257*/ GIMT_Encode4(310362), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 310319 */ /*GILLT_v2s64*//*Label 6258*/ GIMT_Encode4(310423), GIMT_Encode4(0),
     /* 310327 */ /*GILLT_v4s32*//*Label 6259*/ GIMT_Encode4(310481),
     /* 310331 */ // Label 6256: @310331
     /* 310331 */ GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(310361), // Rule ID 516 //
     /* 310336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310350 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 310350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 310355 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310359 */   GIR_RootConstrainSelectedInstOperands,
     /* 310360 */   // GIR_Coverage, 516,
     /* 310360 */   GIR_Done,
     /* 310361 */ // Label 6261: @310361
     /* 310361 */ GIM_Reject,
     /* 310362 */ // Label 6257: @310362
     /* 310362 */ GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(310392), // Rule ID 514 //
     /* 310367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310381 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 310381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 310386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310390 */   GIR_RootConstrainSelectedInstOperands,
     /* 310391 */   // GIR_Coverage, 514,
     /* 310391 */   GIR_Done,
     /* 310392 */ // Label 6262: @310392
     /* 310392 */ GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(310422), // Rule ID 518 //
     /* 310397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310411 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 310411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 310416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310420 */   GIR_RootConstrainSelectedInstOperands,
     /* 310421 */   // GIR_Coverage, 518,
     /* 310421 */   GIR_Done,
     /* 310422 */ // Label 6263: @310422
     /* 310422 */ GIM_Reject,
     /* 310423 */ // Label 6258: @310423
     /* 310423 */ GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(310480),
     /* 310428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310435 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(310459), // Rule ID 4902 //
     /* 310440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 310447 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 310447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 310450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310457 */     GIR_RootConstrainSelectedInstOperands,
     /* 310458 */     // GIR_Coverage, 4902,
     /* 310458 */     GIR_EraseRootFromParent_Done,
     /* 310459 */   // Label 6265: @310459
     /* 310459 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(310479), // Rule ID 4900 //
     /* 310464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310468 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 310468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 310473 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310477 */     GIR_RootConstrainSelectedInstOperands,
     /* 310478 */     // GIR_Coverage, 4900,
     /* 310478 */     GIR_Done,
     /* 310479 */   // Label 6266: @310479
     /* 310479 */   GIM_Reject,
     /* 310480 */ // Label 6264: @310480
     /* 310480 */ GIM_Reject,
     /* 310481 */ // Label 6259: @310481
     /* 310481 */ GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(310538),
     /* 310486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310493 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(310517), // Rule ID 4906 //
     /* 310498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 310505 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 310505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 310508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310515 */     GIR_RootConstrainSelectedInstOperands,
     /* 310516 */     // GIR_Coverage, 4906,
     /* 310516 */     GIR_EraseRootFromParent_Done,
     /* 310517 */   // Label 6268: @310517
     /* 310517 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(310537), // Rule ID 4904 //
     /* 310522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310526 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 310526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 310531 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310535 */     GIR_RootConstrainSelectedInstOperands,
     /* 310536 */     // GIR_Coverage, 4904,
     /* 310536 */     GIR_Done,
     /* 310537 */   // Label 6269: @310537
     /* 310537 */   GIM_Reject,
     /* 310538 */ // Label 6267: @310538
     /* 310538 */ GIM_Reject,
     /* 310539 */ // Label 6260: @310539
     /* 310539 */ GIM_Reject,
     /* 310540 */ // Label 64: @310540
     /* 310540 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6274*/ GIMT_Encode4(310727),
     /* 310551 */ /*GILLT_s16*//*Label 6270*/ GIMT_Encode4(310579),
     /* 310555 */ /*GILLT_s32*//*Label 6271*/ GIMT_Encode4(310640), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 310567 */ /*GILLT_v2s32*//*Label 6272*/ GIMT_Encode4(310671), GIMT_Encode4(0),
     /* 310575 */ /*GILLT_v4s16*//*Label 6273*/ GIMT_Encode4(310699),
     /* 310579 */ // Label 6270: @310579
     /* 310579 */ GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(310609), // Rule ID 510 //
     /* 310584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310598 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 310598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 310603 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310607 */   GIR_RootConstrainSelectedInstOperands,
     /* 310608 */   // GIR_Coverage, 510,
     /* 310608 */   GIR_Done,
     /* 310609 */ // Label 6275: @310609
     /* 310609 */ GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(310639), // Rule ID 520 //
     /* 310614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310628 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 310628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 310633 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310637 */   GIR_RootConstrainSelectedInstOperands,
     /* 310638 */   // GIR_Coverage, 520,
     /* 310638 */   GIR_Done,
     /* 310639 */ // Label 6276: @310639
     /* 310639 */ GIM_Reject,
     /* 310640 */ // Label 6271: @310640
     /* 310640 */ GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(310670), // Rule ID 512 //
     /* 310645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310659 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 310659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 310664 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310668 */   GIR_RootConstrainSelectedInstOperands,
     /* 310669 */   // GIR_Coverage, 512,
     /* 310669 */   GIR_Done,
     /* 310670 */ // Label 6277: @310670
     /* 310670 */ GIM_Reject,
     /* 310671 */ // Label 6272: @310671
     /* 310671 */ GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(310698), // Rule ID 4910 //
     /* 310676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310687 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 310687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 310692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310696 */   GIR_RootConstrainSelectedInstOperands,
     /* 310697 */   // GIR_Coverage, 4910,
     /* 310697 */   GIR_Done,
     /* 310698 */ // Label 6278: @310698
     /* 310698 */ GIM_Reject,
     /* 310699 */ // Label 6273: @310699
     /* 310699 */ GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(310726), // Rule ID 4912 //
     /* 310704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310715 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 310715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 310720 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310724 */   GIR_RootConstrainSelectedInstOperands,
     /* 310725 */   // GIR_Coverage, 4912,
     /* 310725 */   GIR_Done,
     /* 310726 */ // Label 6279: @310726
     /* 310726 */ GIM_Reject,
     /* 310727 */ // Label 6274: @310727
     /* 310727 */ GIM_Reject,
     /* 310728 */ // Label 65: @310728
     /* 310728 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6287*/ GIMT_Encode4(311704),
     /* 310739 */ /*GILLT_s32*//*Label 6280*/ GIMT_Encode4(310775),
     /* 310743 */ /*GILLT_s64*//*Label 6281*/ GIMT_Encode4(311162), GIMT_Encode4(0),
     /* 310751 */ /*GILLT_v2s32*//*Label 6282*/ GIMT_Encode4(311549),
     /* 310755 */ /*GILLT_v2s64*//*Label 6283*/ GIMT_Encode4(311580),
     /* 310759 */ /*GILLT_v4s16*//*Label 6284*/ GIMT_Encode4(311611),
     /* 310763 */ /*GILLT_v4s32*//*Label 6285*/ GIMT_Encode4(311642), GIMT_Encode4(0),
     /* 310771 */ /*GILLT_v8s16*//*Label 6286*/ GIMT_Encode4(311673),
     /* 310775 */ // Label 6280: @310775
     /* 310775 */ GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(310812), // Rule ID 4649 //
     /* 310780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310795 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310799 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310801 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 310804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310806 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310810 */   GIR_RootConstrainSelectedInstOperands,
     /* 310811 */   // GIR_Coverage, 4649,
     /* 310811 */   GIR_EraseRootFromParent_Done,
     /* 310812 */ // Label 6288: @310812
     /* 310812 */ GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(310849), // Rule ID 4651 //
     /* 310817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310832 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310838 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 310841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310843 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310847 */   GIR_RootConstrainSelectedInstOperands,
     /* 310848 */   // GIR_Coverage, 4651,
     /* 310848 */   GIR_EraseRootFromParent_Done,
     /* 310849 */ // Label 6289: @310849
     /* 310849 */ GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(310886), // Rule ID 4669 //
     /* 310854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310861 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310865 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 310869 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310875 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 310878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310880 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310884 */   GIR_RootConstrainSelectedInstOperands,
     /* 310885 */   // GIR_Coverage, 4669,
     /* 310885 */   GIR_EraseRootFromParent_Done,
     /* 310886 */ // Label 6290: @310886
     /* 310886 */ GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(310923), // Rule ID 4671 //
     /* 310891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 310906 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310910 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310912 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 310915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310917 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310921 */   GIR_RootConstrainSelectedInstOperands,
     /* 310922 */   // GIR_Coverage, 4671,
     /* 310922 */   GIR_EraseRootFromParent_Done,
     /* 310923 */ // Label 6291: @310923
     /* 310923 */ GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(310960), // Rule ID 4709 //
     /* 310928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 310943 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310947 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310949 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 310952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310954 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310958 */   GIR_RootConstrainSelectedInstOperands,
     /* 310959 */   // GIR_Coverage, 4709,
     /* 310959 */   GIR_EraseRootFromParent_Done,
     /* 310960 */ // Label 6292: @310960
     /* 310960 */ GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(310997), // Rule ID 4711 //
     /* 310965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 310980 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310986 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 310989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310991 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310995 */   GIR_RootConstrainSelectedInstOperands,
     /* 310996 */   // GIR_Coverage, 4711,
     /* 310996 */   GIR_EraseRootFromParent_Done,
     /* 310997 */ // Label 6293: @310997
     /* 310997 */ GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(311034), // Rule ID 4689 //
     /* 311002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311023 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 311026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311028 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311032 */   GIR_RootConstrainSelectedInstOperands,
     /* 311033 */   // GIR_Coverage, 4689,
     /* 311033 */   GIR_EraseRootFromParent_Done,
     /* 311034 */ // Label 6294: @311034
     /* 311034 */ GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(311071), // Rule ID 4691 //
     /* 311039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311046 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311054 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311058 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311060 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 311063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311065 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311069 */   GIR_RootConstrainSelectedInstOperands,
     /* 311070 */   // GIR_Coverage, 4691,
     /* 311070 */   GIR_EraseRootFromParent_Done,
     /* 311071 */ // Label 6295: @311071
     /* 311071 */ GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(311101), // Rule ID 395 //
     /* 311076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311090 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 311090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 311095 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311099 */   GIR_RootConstrainSelectedInstOperands,
     /* 311100 */   // GIR_Coverage, 395,
     /* 311100 */   GIR_Done,
     /* 311101 */ // Label 6296: @311101
     /* 311101 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(311131), // Rule ID 399 //
     /* 311106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311120 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 311120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 311125 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311129 */   GIR_RootConstrainSelectedInstOperands,
     /* 311130 */   // GIR_Coverage, 399,
     /* 311130 */   GIR_Done,
     /* 311131 */ // Label 6297: @311131
     /* 311131 */ GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(311161), // Rule ID 403 //
     /* 311136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311150 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 311150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 311155 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311159 */   GIR_RootConstrainSelectedInstOperands,
     /* 311160 */   // GIR_Coverage, 403,
     /* 311160 */   GIR_Done,
     /* 311161 */ // Label 6298: @311161
     /* 311161 */ GIM_Reject,
     /* 311162 */ // Label 6281: @311162
     /* 311162 */ GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(311199), // Rule ID 4650 //
     /* 311167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311182 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311188 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 311191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311193 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311197 */   GIR_RootConstrainSelectedInstOperands,
     /* 311198 */   // GIR_Coverage, 4650,
     /* 311198 */   GIR_EraseRootFromParent_Done,
     /* 311199 */ // Label 6299: @311199
     /* 311199 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(311236), // Rule ID 4652 //
     /* 311204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311219 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311223 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311225 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 311228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311230 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311234 */   GIR_RootConstrainSelectedInstOperands,
     /* 311235 */   // GIR_Coverage, 4652,
     /* 311235 */   GIR_EraseRootFromParent_Done,
     /* 311236 */ // Label 6300: @311236
     /* 311236 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(311273), // Rule ID 4670 //
     /* 311241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311256 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311262 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 311265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311267 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311271 */   GIR_RootConstrainSelectedInstOperands,
     /* 311272 */   // GIR_Coverage, 4670,
     /* 311272 */   GIR_EraseRootFromParent_Done,
     /* 311273 */ // Label 6301: @311273
     /* 311273 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(311310), // Rule ID 4672 //
     /* 311278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311297 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311299 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 311302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311304 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311308 */   GIR_RootConstrainSelectedInstOperands,
     /* 311309 */   // GIR_Coverage, 4672,
     /* 311309 */   GIR_EraseRootFromParent_Done,
     /* 311310 */ // Label 6302: @311310
     /* 311310 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(311347), // Rule ID 4710 //
     /* 311315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311330 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311334 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311336 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 311339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311341 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311345 */   GIR_RootConstrainSelectedInstOperands,
     /* 311346 */   // GIR_Coverage, 4710,
     /* 311346 */   GIR_EraseRootFromParent_Done,
     /* 311347 */ // Label 6303: @311347
     /* 311347 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(311384), // Rule ID 4712 //
     /* 311352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311373 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 311376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311378 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311382 */   GIR_RootConstrainSelectedInstOperands,
     /* 311383 */   // GIR_Coverage, 4712,
     /* 311383 */   GIR_EraseRootFromParent_Done,
     /* 311384 */ // Label 6304: @311384
     /* 311384 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(311421), // Rule ID 4690 //
     /* 311389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311404 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311410 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 311413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311415 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311419 */   GIR_RootConstrainSelectedInstOperands,
     /* 311420 */   // GIR_Coverage, 4690,
     /* 311420 */   GIR_EraseRootFromParent_Done,
     /* 311421 */ // Label 6305: @311421
     /* 311421 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(311458), // Rule ID 4692 //
     /* 311426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311433 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311437 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311441 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311445 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311447 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 311450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311452 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311456 */   GIR_RootConstrainSelectedInstOperands,
     /* 311457 */   // GIR_Coverage, 4692,
     /* 311457 */   GIR_EraseRootFromParent_Done,
     /* 311458 */ // Label 6306: @311458
     /* 311458 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(311488), // Rule ID 397 //
     /* 311463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311477 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 311477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 311482 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311486 */   GIR_RootConstrainSelectedInstOperands,
     /* 311487 */   // GIR_Coverage, 397,
     /* 311487 */   GIR_Done,
     /* 311488 */ // Label 6307: @311488
     /* 311488 */ GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(311518), // Rule ID 401 //
     /* 311493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311507 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 311507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 311512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311516 */   GIR_RootConstrainSelectedInstOperands,
     /* 311517 */   // GIR_Coverage, 401,
     /* 311517 */   GIR_Done,
     /* 311518 */ // Label 6308: @311518
     /* 311518 */ GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(311548), // Rule ID 405 //
     /* 311523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311537 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 311537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 311542 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311546 */   GIR_RootConstrainSelectedInstOperands,
     /* 311547 */   // GIR_Coverage, 405,
     /* 311547 */   GIR_Done,
     /* 311548 */ // Label 6309: @311548
     /* 311548 */ GIM_Reject,
     /* 311549 */ // Label 6282: @311549
     /* 311549 */ GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(311579), // Rule ID 843 //
     /* 311554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311568 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 311568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 311573 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311577 */   GIR_RootConstrainSelectedInstOperands,
     /* 311578 */   // GIR_Coverage, 843,
     /* 311578 */   GIR_Done,
     /* 311579 */ // Label 6310: @311579
     /* 311579 */ GIM_Reject,
     /* 311580 */ // Label 6283: @311580
     /* 311580 */ GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(311610), // Rule ID 847 //
     /* 311585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311599 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 311599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 311604 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311608 */   GIR_RootConstrainSelectedInstOperands,
     /* 311609 */   // GIR_Coverage, 847,
     /* 311609 */   GIR_Done,
     /* 311610 */ // Label 6311: @311610
     /* 311610 */ GIM_Reject,
     /* 311611 */ // Label 6284: @311611
     /* 311611 */ GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(311641), // Rule ID 839 //
     /* 311616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311630 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 311630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 311635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311639 */   GIR_RootConstrainSelectedInstOperands,
     /* 311640 */   // GIR_Coverage, 839,
     /* 311640 */   GIR_Done,
     /* 311641 */ // Label 6312: @311641
     /* 311641 */ GIM_Reject,
     /* 311642 */ // Label 6285: @311642
     /* 311642 */ GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(311672), // Rule ID 845 //
     /* 311647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311661 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 311661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 311666 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311670 */   GIR_RootConstrainSelectedInstOperands,
     /* 311671 */   // GIR_Coverage, 845,
     /* 311671 */   GIR_Done,
     /* 311672 */ // Label 6313: @311672
     /* 311672 */ GIM_Reject,
     /* 311673 */ // Label 6286: @311673
     /* 311673 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(311703), // Rule ID 841 //
     /* 311678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311692 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 311692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 311697 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311701 */   GIR_RootConstrainSelectedInstOperands,
     /* 311702 */   // GIR_Coverage, 841,
     /* 311702 */   GIR_Done,
     /* 311703 */ // Label 6314: @311703
     /* 311703 */ GIM_Reject,
     /* 311704 */ // Label 6287: @311704
     /* 311704 */ GIM_Reject,
     /* 311705 */ // Label 66: @311705
     /* 311705 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6322*/ GIMT_Encode4(312681),
     /* 311716 */ /*GILLT_s32*//*Label 6315*/ GIMT_Encode4(311752),
     /* 311720 */ /*GILLT_s64*//*Label 6316*/ GIMT_Encode4(312139), GIMT_Encode4(0),
     /* 311728 */ /*GILLT_v2s32*//*Label 6317*/ GIMT_Encode4(312526),
     /* 311732 */ /*GILLT_v2s64*//*Label 6318*/ GIMT_Encode4(312557),
     /* 311736 */ /*GILLT_v4s16*//*Label 6319*/ GIMT_Encode4(312588),
     /* 311740 */ /*GILLT_v4s32*//*Label 6320*/ GIMT_Encode4(312619), GIMT_Encode4(0),
     /* 311748 */ /*GILLT_v8s16*//*Label 6321*/ GIMT_Encode4(312650),
     /* 311752 */ // Label 6315: @311752
     /* 311752 */ GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(311789), // Rule ID 4659 //
     /* 311757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311764 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311772 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311778 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 311781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311787 */   GIR_RootConstrainSelectedInstOperands,
     /* 311788 */   // GIR_Coverage, 4659,
     /* 311788 */   GIR_EraseRootFromParent_Done,
     /* 311789 */ // Label 6323: @311789
     /* 311789 */ GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(311826), // Rule ID 4661 //
     /* 311794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311809 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311815 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 311818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311820 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311824 */   GIR_RootConstrainSelectedInstOperands,
     /* 311825 */   // GIR_Coverage, 4661,
     /* 311825 */   GIR_EraseRootFromParent_Done,
     /* 311826 */ // Label 6324: @311826
     /* 311826 */ GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(311863), // Rule ID 4679 //
     /* 311831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311850 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311852 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 311855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311857 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311861 */   GIR_RootConstrainSelectedInstOperands,
     /* 311862 */   // GIR_Coverage, 4679,
     /* 311862 */   GIR_EraseRootFromParent_Done,
     /* 311863 */ // Label 6325: @311863
     /* 311863 */ GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(311900), // Rule ID 4681 //
     /* 311868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311875 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311883 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311889 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 311892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311894 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311898 */   GIR_RootConstrainSelectedInstOperands,
     /* 311899 */   // GIR_Coverage, 4681,
     /* 311899 */   GIR_EraseRootFromParent_Done,
     /* 311900 */ // Label 6326: @311900
     /* 311900 */ GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(311937), // Rule ID 4719 //
     /* 311905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311920 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311924 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311926 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 311929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311931 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311935 */   GIR_RootConstrainSelectedInstOperands,
     /* 311936 */   // GIR_Coverage, 4719,
     /* 311936 */   GIR_EraseRootFromParent_Done,
     /* 311937 */ // Label 6327: @311937
     /* 311937 */ GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(311974), // Rule ID 4721 //
     /* 311942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311957 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311963 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 311966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311968 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311972 */   GIR_RootConstrainSelectedInstOperands,
     /* 311973 */   // GIR_Coverage, 4721,
     /* 311973 */   GIR_EraseRootFromParent_Done,
     /* 311974 */ // Label 6328: @311974
     /* 311974 */ GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(312011), // Rule ID 4699 //
     /* 311979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311986 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311994 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311998 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312000 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 312003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312005 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312009 */   GIR_RootConstrainSelectedInstOperands,
     /* 312010 */   // GIR_Coverage, 4699,
     /* 312010 */   GIR_EraseRootFromParent_Done,
     /* 312011 */ // Label 6329: @312011
     /* 312011 */ GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(312048), // Rule ID 4701 //
     /* 312016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312023 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312027 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312031 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312035 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312037 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 312040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312042 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312046 */   GIR_RootConstrainSelectedInstOperands,
     /* 312047 */   // GIR_Coverage, 4701,
     /* 312047 */   GIR_EraseRootFromParent_Done,
     /* 312048 */ // Label 6330: @312048
     /* 312048 */ GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(312078), // Rule ID 407 //
     /* 312053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312067 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 312067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 312072 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312076 */   GIR_RootConstrainSelectedInstOperands,
     /* 312077 */   // GIR_Coverage, 407,
     /* 312077 */   GIR_Done,
     /* 312078 */ // Label 6331: @312078
     /* 312078 */ GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(312108), // Rule ID 411 //
     /* 312083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312097 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 312097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 312102 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312106 */   GIR_RootConstrainSelectedInstOperands,
     /* 312107 */   // GIR_Coverage, 411,
     /* 312107 */   GIR_Done,
     /* 312108 */ // Label 6332: @312108
     /* 312108 */ GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(312138), // Rule ID 415 //
     /* 312113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312127 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 312127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 312132 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312136 */   GIR_RootConstrainSelectedInstOperands,
     /* 312137 */   // GIR_Coverage, 415,
     /* 312137 */   GIR_Done,
     /* 312138 */ // Label 6333: @312138
     /* 312138 */ GIM_Reject,
     /* 312139 */ // Label 6316: @312139
     /* 312139 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(312176), // Rule ID 4660 //
     /* 312144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312159 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312165 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 312168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312170 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312174 */   GIR_RootConstrainSelectedInstOperands,
     /* 312175 */   // GIR_Coverage, 4660,
     /* 312175 */   GIR_EraseRootFromParent_Done,
     /* 312176 */ // Label 6334: @312176
     /* 312176 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(312213), // Rule ID 4662 //
     /* 312181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312196 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312202 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 312205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312207 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312211 */   GIR_RootConstrainSelectedInstOperands,
     /* 312212 */   // GIR_Coverage, 4662,
     /* 312212 */   GIR_EraseRootFromParent_Done,
     /* 312213 */ // Label 6335: @312213
     /* 312213 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(312250), // Rule ID 4680 //
     /* 312218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312225 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312233 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312239 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 312242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312244 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312248 */   GIR_RootConstrainSelectedInstOperands,
     /* 312249 */   // GIR_Coverage, 4680,
     /* 312249 */   GIR_EraseRootFromParent_Done,
     /* 312250 */ // Label 6336: @312250
     /* 312250 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(312287), // Rule ID 4682 //
     /* 312255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312270 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312274 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312276 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 312279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312281 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312285 */   GIR_RootConstrainSelectedInstOperands,
     /* 312286 */   // GIR_Coverage, 4682,
     /* 312286 */   GIR_EraseRootFromParent_Done,
     /* 312287 */ // Label 6337: @312287
     /* 312287 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(312324), // Rule ID 4720 //
     /* 312292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312307 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312311 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312313 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 312316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312318 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312322 */   GIR_RootConstrainSelectedInstOperands,
     /* 312323 */   // GIR_Coverage, 4720,
     /* 312323 */   GIR_EraseRootFromParent_Done,
     /* 312324 */ // Label 6338: @312324
     /* 312324 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(312361), // Rule ID 4722 //
     /* 312329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312344 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312348 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312350 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 312353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312355 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312359 */   GIR_RootConstrainSelectedInstOperands,
     /* 312360 */   // GIR_Coverage, 4722,
     /* 312360 */   GIR_EraseRootFromParent_Done,
     /* 312361 */ // Label 6339: @312361
     /* 312361 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(312398), // Rule ID 4700 //
     /* 312366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312381 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312387 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 312390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312392 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312396 */   GIR_RootConstrainSelectedInstOperands,
     /* 312397 */   // GIR_Coverage, 4700,
     /* 312397 */   GIR_EraseRootFromParent_Done,
     /* 312398 */ // Label 6340: @312398
     /* 312398 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(312435), // Rule ID 4702 //
     /* 312403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312418 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312424 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 312427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312429 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312433 */   GIR_RootConstrainSelectedInstOperands,
     /* 312434 */   // GIR_Coverage, 4702,
     /* 312434 */   GIR_EraseRootFromParent_Done,
     /* 312435 */ // Label 6341: @312435
     /* 312435 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(312465), // Rule ID 409 //
     /* 312440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312454 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 312454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 312459 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312463 */   GIR_RootConstrainSelectedInstOperands,
     /* 312464 */   // GIR_Coverage, 409,
     /* 312464 */   GIR_Done,
     /* 312465 */ // Label 6342: @312465
     /* 312465 */ GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(312495), // Rule ID 413 //
     /* 312470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312484 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 312484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 312489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312493 */   GIR_RootConstrainSelectedInstOperands,
     /* 312494 */   // GIR_Coverage, 413,
     /* 312494 */   GIR_Done,
     /* 312495 */ // Label 6343: @312495
     /* 312495 */ GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(312525), // Rule ID 417 //
     /* 312500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312514 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 312514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 312519 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312523 */   GIR_RootConstrainSelectedInstOperands,
     /* 312524 */   // GIR_Coverage, 417,
     /* 312524 */   GIR_Done,
     /* 312525 */ // Label 6344: @312525
     /* 312525 */ GIM_Reject,
     /* 312526 */ // Label 6317: @312526
     /* 312526 */ GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(312556), // Rule ID 853 //
     /* 312531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312545 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 312545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 312550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312554 */   GIR_RootConstrainSelectedInstOperands,
     /* 312555 */   // GIR_Coverage, 853,
     /* 312555 */   GIR_Done,
     /* 312556 */ // Label 6345: @312556
     /* 312556 */ GIM_Reject,
     /* 312557 */ // Label 6318: @312557
     /* 312557 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(312587), // Rule ID 857 //
     /* 312562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312576 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 312576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 312581 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312585 */   GIR_RootConstrainSelectedInstOperands,
     /* 312586 */   // GIR_Coverage, 857,
     /* 312586 */   GIR_Done,
     /* 312587 */ // Label 6346: @312587
     /* 312587 */ GIM_Reject,
     /* 312588 */ // Label 6319: @312588
     /* 312588 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(312618), // Rule ID 849 //
     /* 312593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312607 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 312607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 312612 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312616 */   GIR_RootConstrainSelectedInstOperands,
     /* 312617 */   // GIR_Coverage, 849,
     /* 312617 */   GIR_Done,
     /* 312618 */ // Label 6347: @312618
     /* 312618 */ GIM_Reject,
     /* 312619 */ // Label 6320: @312619
     /* 312619 */ GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(312649), // Rule ID 855 //
     /* 312624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312638 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 312638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 312643 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312647 */   GIR_RootConstrainSelectedInstOperands,
     /* 312648 */   // GIR_Coverage, 855,
     /* 312648 */   GIR_Done,
     /* 312649 */ // Label 6348: @312649
     /* 312649 */ GIM_Reject,
     /* 312650 */ // Label 6321: @312650
     /* 312650 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(312680), // Rule ID 851 //
     /* 312655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312669 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 312669 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 312674 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312678 */   GIR_RootConstrainSelectedInstOperands,
     /* 312679 */   // GIR_Coverage, 851,
     /* 312679 */   GIR_Done,
     /* 312680 */ // Label 6349: @312680
     /* 312680 */ GIM_Reject,
     /* 312681 */ // Label 6322: @312681
     /* 312681 */ GIM_Reject,
     /* 312682 */ // Label 67: @312682
     /* 312682 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6358*/ GIMT_Encode4(316989),
     /* 312693 */ /*GILLT_s16*//*Label 6350*/ GIMT_Encode4(312733),
     /* 312697 */ /*GILLT_s32*//*Label 6351*/ GIMT_Encode4(313014),
     /* 312701 */ /*GILLT_s64*//*Label 6352*/ GIMT_Encode4(314930), GIMT_Encode4(0),
     /* 312709 */ /*GILLT_v2s32*//*Label 6353*/ GIMT_Encode4(316834),
     /* 312713 */ /*GILLT_v2s64*//*Label 6354*/ GIMT_Encode4(316865),
     /* 312717 */ /*GILLT_v4s16*//*Label 6355*/ GIMT_Encode4(316896),
     /* 312721 */ /*GILLT_v4s32*//*Label 6356*/ GIMT_Encode4(316927), GIMT_Encode4(0),
     /* 312729 */ /*GILLT_v8s16*//*Label 6357*/ GIMT_Encode4(316958),
     /* 312733 */ // Label 6350: @312733
     /* 312733 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(312836), // Rule ID 5323 //
     /* 312738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 312741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312748 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 312756 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312760 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312764 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312768 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312772 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312776 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312781 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312785 */   // MIs[1] Operand 2
     /* 312785 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 312796 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312798 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 312798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312810 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312816 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312821 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 312829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312834 */   GIR_RootConstrainSelectedInstOperands,
     /* 312835 */   // GIR_Coverage, 5323,
     /* 312835 */   GIR_EraseRootFromParent_Done,
     /* 312836 */ // Label 6359: @312836
     /* 312836 */ GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(312893), // Rule ID 5314 //
     /* 312841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 312844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312851 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312855 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 312859 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312865 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 312865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 312872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312877 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 312886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312891 */   GIR_RootConstrainSelectedInstOperands,
     /* 312892 */   // GIR_Coverage, 5314,
     /* 312892 */   GIR_EraseRootFromParent_Done,
     /* 312893 */ // Label 6360: @312893
     /* 312893 */ GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(312923), // Rule ID 443 //
     /* 312898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312912 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 312912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 312917 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312921 */   GIR_RootConstrainSelectedInstOperands,
     /* 312922 */   // GIR_Coverage, 443,
     /* 312922 */   GIR_Done,
     /* 312923 */ // Label 6361: @312923
     /* 312923 */ GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(312953), // Rule ID 449 //
     /* 312928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312942 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 312942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 312947 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312951 */   GIR_RootConstrainSelectedInstOperands,
     /* 312952 */   // GIR_Coverage, 449,
     /* 312952 */   GIR_Done,
     /* 312953 */ // Label 6362: @312953
     /* 312953 */ GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(312983), // Rule ID 491 //
     /* 312958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 312961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312972 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 312972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 312977 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312981 */   GIR_RootConstrainSelectedInstOperands,
     /* 312982 */   // GIR_Coverage, 491,
     /* 312982 */   GIR_Done,
     /* 312983 */ // Label 6363: @312983
     /* 312983 */ GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(313013), // Rule ID 495 //
     /* 312988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 312991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313002 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 313002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 313007 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313011 */   GIR_RootConstrainSelectedInstOperands,
     /* 313012 */   // GIR_Coverage, 495,
     /* 313012 */   GIR_Done,
     /* 313013 */ // Label 6364: @313013
     /* 313013 */ GIM_Reject,
     /* 313014 */ // Label 6351: @313014
     /* 313014 */ GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(313252), // Rule ID 6374 //
     /* 313019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313037 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313040 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313047 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313053 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 313060 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313060 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313063 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 313067 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313087 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313094 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313097 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313101 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313108 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313111 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313115 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313120 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313123 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313126 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313129 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313134 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313139 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313144 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313147 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313151 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313156 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313159 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313164 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313167 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313171 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313176 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313183 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313188 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313193 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313196 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313200 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313205 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313208 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313225 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313232 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313250 */   GIR_RootConstrainSelectedInstOperands,
     /* 313251 */   // GIR_Coverage, 6374,
     /* 313251 */   GIR_EraseRootFromParent_Done,
     /* 313252 */ // Label 6365: @313252
     /* 313252 */ GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(313490), // Rule ID 6375 //
     /* 313257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313267 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313275 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313278 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313285 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313289 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313291 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 313298 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313298 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313301 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 313305 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313325 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313332 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313335 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313339 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313346 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313349 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313353 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313358 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313361 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313364 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313367 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313372 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313377 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313382 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313385 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313389 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313394 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313397 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313402 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313405 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313409 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313414 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313421 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313426 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313431 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313434 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313438 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313443 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313446 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313451 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313454 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313458 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313463 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313485 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313488 */   GIR_RootConstrainSelectedInstOperands,
     /* 313489 */   // GIR_Coverage, 6375,
     /* 313489 */   GIR_EraseRootFromParent_Done,
     /* 313490 */ // Label 6366: @313490
     /* 313490 */ GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(313679), // Rule ID 6378 //
     /* 313495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313505 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313509 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313513 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313516 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313523 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313527 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313529 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 313536 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313536 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 313539 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 313543 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313563 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 313570 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 313573 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313577 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313584 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313587 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313591 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313596 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 313599 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 313602 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 313605 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313610 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313615 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313620 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313623 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313627 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313632 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313635 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313652 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313664 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313677 */   GIR_RootConstrainSelectedInstOperands,
     /* 313678 */   // GIR_Coverage, 6378,
     /* 313678 */   GIR_EraseRootFromParent_Done,
     /* 313679 */ // Label 6367: @313679
     /* 313679 */ GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(313868), // Rule ID 6379 //
     /* 313684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313694 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313698 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313702 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313705 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313712 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313718 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 313725 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313725 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 313728 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 313732 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313752 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 313759 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 313762 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313766 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313773 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313776 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313780 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313785 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 313788 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 313791 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 313794 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313799 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313804 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313809 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313812 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313816 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313821 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313824 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313841 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313848 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313853 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313863 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313866 */   GIR_RootConstrainSelectedInstOperands,
     /* 313867 */   // GIR_Coverage, 6379,
     /* 313867 */   GIR_EraseRootFromParent_Done,
     /* 313868 */ // Label 6368: @313868
     /* 313868 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(314101), // Rule ID 6376 //
     /* 313873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313891 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313894 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313901 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313907 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 313914 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313914 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313917 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 313921 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 313936 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313943 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313946 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313950 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313957 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313960 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313964 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313969 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313972 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313975 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313978 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313983 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313988 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313993 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313996 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 314000 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314005 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 314008 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 314011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314013 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314016 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314020 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314025 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314032 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314037 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314042 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314045 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314049 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314054 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314057 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314074 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314086 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314099 */   GIR_RootConstrainSelectedInstOperands,
     /* 314100 */   // GIR_Coverage, 6376,
     /* 314100 */   GIR_EraseRootFromParent_Done,
     /* 314101 */ // Label 6369: @314101
     /* 314101 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(314334), // Rule ID 6377 //
     /* 314106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314116 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314120 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314124 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314127 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 314134 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314138 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314140 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 314147 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314147 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 314150 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 314154 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314169 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 314176 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 314179 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314183 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 314190 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 314193 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314197 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314202 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 314205 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 314208 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 314211 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314216 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314221 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314226 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 314229 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 314233 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314238 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 314241 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 314244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314246 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314249 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314253 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314258 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314265 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314270 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314275 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314278 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314282 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314287 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314290 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314307 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314314 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314319 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314332 */   GIR_RootConstrainSelectedInstOperands,
     /* 314333 */   // GIR_Coverage, 6377,
     /* 314333 */   GIR_EraseRootFromParent_Done,
     /* 314334 */ // Label 6370: @314334
     /* 314334 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(314518), // Rule ID 6380 //
     /* 314339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314349 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314353 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314357 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314360 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314367 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314373 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 314380 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314380 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314383 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 314387 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314402 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314409 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314412 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314416 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314423 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314426 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314430 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314435 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314438 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314441 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314444 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314449 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314454 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314459 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314462 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314466 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314471 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314474 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314491 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314498 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314503 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314516 */   GIR_RootConstrainSelectedInstOperands,
     /* 314517 */   // GIR_Coverage, 6380,
     /* 314517 */   GIR_EraseRootFromParent_Done,
     /* 314518 */ // Label 6371: @314518
     /* 314518 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(314702), // Rule ID 6381 //
     /* 314523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314541 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314544 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314551 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314557 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 314564 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314564 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314567 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 314571 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314586 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314593 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314596 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314600 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314607 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314610 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314614 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314619 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314622 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314625 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314628 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314633 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314638 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314655 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314658 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314675 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314700 */   GIR_RootConstrainSelectedInstOperands,
     /* 314701 */   // GIR_Coverage, 6381,
     /* 314701 */   GIR_EraseRootFromParent_Done,
     /* 314702 */ // Label 6372: @314702
     /* 314702 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(314782), // Rule ID 5319 //
     /* 314707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314717 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314725 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314729 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314733 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314738 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314744 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 314744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314756 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314762 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314780 */   GIR_RootConstrainSelectedInstOperands,
     /* 314781 */   // GIR_Coverage, 5319,
     /* 314781 */   GIR_EraseRootFromParent_Done,
     /* 314782 */ // Label 6373: @314782
     /* 314782 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(314839), // Rule ID 5302 //
     /* 314787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 314805 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314811 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 314811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 314818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 314829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314837 */   GIR_RootConstrainSelectedInstOperands,
     /* 314838 */   // GIR_Coverage, 5302,
     /* 314838 */   GIR_EraseRootFromParent_Done,
     /* 314839 */ // Label 6374: @314839
     /* 314839 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(314869), // Rule ID 445 //
     /* 314844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314858 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 314858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 314863 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314867 */   GIR_RootConstrainSelectedInstOperands,
     /* 314868 */   // GIR_Coverage, 445,
     /* 314868 */   GIR_Done,
     /* 314869 */ // Label 6375: @314869
     /* 314869 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(314899), // Rule ID 451 //
     /* 314874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314888 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 314888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 314893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314897 */   GIR_RootConstrainSelectedInstOperands,
     /* 314898 */   // GIR_Coverage, 451,
     /* 314898 */   GIR_Done,
     /* 314899 */ // Label 6376: @314899
     /* 314899 */ GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(314929), // Rule ID 497 //
     /* 314904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 314907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314918 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 314918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 314923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314927 */   GIR_RootConstrainSelectedInstOperands,
     /* 314928 */   // GIR_Coverage, 497,
     /* 314928 */   GIR_Done,
     /* 314929 */ // Label 6377: @314929
     /* 314929 */ GIM_Reject,
     /* 314930 */ // Label 6352: @314930
     /* 314930 */ GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(315116), // Rule ID 6386 //
     /* 314935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 314953 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314956 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 314960 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314966 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 314973 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 314973 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 314976 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 314980 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315000 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315007 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315010 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315014 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315021 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315024 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315028 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315033 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315036 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315039 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315042 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315047 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315052 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315057 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315060 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315064 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315069 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315072 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315089 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315114 */   GIR_RootConstrainSelectedInstOperands,
     /* 315115 */   // GIR_Coverage, 6386,
     /* 315115 */   GIR_EraseRootFromParent_Done,
     /* 315116 */ // Label 6378: @315116
     /* 315116 */ GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(315302), // Rule ID 6387 //
     /* 315121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315139 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315146 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315152 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 315159 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315159 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315162 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 315166 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315186 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315193 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315196 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315200 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315207 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315210 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315214 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315219 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315222 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315225 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315228 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315233 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315238 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315243 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315246 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315250 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315255 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315258 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315263 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315266 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315270 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315275 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315282 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315287 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315300 */   GIR_RootConstrainSelectedInstOperands,
     /* 315301 */   // GIR_Coverage, 6387,
     /* 315301 */   GIR_EraseRootFromParent_Done,
     /* 315302 */ // Label 6379: @315302
     /* 315302 */ GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(315540), // Rule ID 6382 //
     /* 315307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315325 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315328 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315335 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315339 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315341 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 315348 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315348 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 315351 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 315355 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315375 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315382 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315385 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315389 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315396 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315399 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315403 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315408 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315411 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315414 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 315417 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315422 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315427 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315432 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315435 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315439 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315444 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315447 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315452 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315455 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315459 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315464 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315471 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315476 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315481 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315484 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315488 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315493 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315496 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315513 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315538 */   GIR_RootConstrainSelectedInstOperands,
     /* 315539 */   // GIR_Coverage, 6382,
     /* 315539 */   GIR_EraseRootFromParent_Done,
     /* 315540 */ // Label 6380: @315540
     /* 315540 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(315778), // Rule ID 6383 //
     /* 315545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315563 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315566 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315573 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315579 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 315586 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315586 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 315589 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 315593 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315613 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315620 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315623 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315627 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315634 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315637 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315641 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315646 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315649 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315652 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 315655 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315660 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315665 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315670 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315673 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315677 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315682 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315685 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315690 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315693 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315697 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315702 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315709 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315714 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315719 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315722 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315726 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315731 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315734 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315751 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315758 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315763 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315776 */   GIR_RootConstrainSelectedInstOperands,
     /* 315777 */   // GIR_Coverage, 6383,
     /* 315777 */   GIR_EraseRootFromParent_Done,
     /* 315778 */ // Label 6381: @315778
     /* 315778 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(315959), // Rule ID 6388 //
     /* 315783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315801 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315804 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315808 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315814 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 315821 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315821 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315824 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 315828 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315843 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315850 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315853 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315857 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315864 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315867 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315871 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315876 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315879 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315882 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315885 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315890 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315895 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315912 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315915 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315932 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315957 */   GIR_RootConstrainSelectedInstOperands,
     /* 315958 */   // GIR_Coverage, 6388,
     /* 315958 */   GIR_EraseRootFromParent_Done,
     /* 315959 */ // Label 6382: @315959
     /* 315959 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(316140), // Rule ID 6389 //
     /* 315964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315974 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315982 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315989 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315995 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 316002 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316002 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 316005 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 316009 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316024 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316031 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316034 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316038 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316045 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316048 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316052 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316057 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316060 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316063 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 316066 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316071 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316076 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316081 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316084 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316088 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316093 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316096 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316101 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316108 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316113 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316120 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316125 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316138 */   GIR_RootConstrainSelectedInstOperands,
     /* 316139 */   // GIR_Coverage, 6389,
     /* 316139 */   GIR_EraseRootFromParent_Done,
     /* 316140 */ // Label 6383: @316140
     /* 316140 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(316373), // Rule ID 6384 //
     /* 316145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316163 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316166 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316173 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316177 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316179 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 316186 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316186 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316189 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 316193 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316203 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316208 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316215 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316218 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316222 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316229 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316232 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316236 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316241 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316244 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316247 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316250 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316255 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316260 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316265 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316268 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316272 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316277 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316280 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316285 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316288 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316292 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316297 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316304 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316309 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316314 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316317 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316321 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316326 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316329 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316346 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316353 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316358 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316371 */   GIR_RootConstrainSelectedInstOperands,
     /* 316372 */   // GIR_Coverage, 6384,
     /* 316372 */   GIR_EraseRootFromParent_Done,
     /* 316373 */ // Label 6384: @316373
     /* 316373 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(316606), // Rule ID 6385 //
     /* 316378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316396 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316399 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316406 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316410 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316412 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 316419 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316419 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316422 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 316426 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316441 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316448 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316451 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316455 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316462 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316465 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316469 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316474 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316477 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316480 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316483 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316488 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316493 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316498 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316501 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316505 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316510 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316513 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316518 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316521 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316525 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316530 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316537 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316542 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316547 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316550 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316554 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316559 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316562 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316579 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316604 */   GIR_RootConstrainSelectedInstOperands,
     /* 316605 */   // GIR_Coverage, 6385,
     /* 316605 */   GIR_EraseRootFromParent_Done,
     /* 316606 */ // Label 6385: @316606
     /* 316606 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(316686), // Rule ID 5321 //
     /* 316611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316629 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316633 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316637 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316642 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316648 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 316648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316660 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316684 */   GIR_RootConstrainSelectedInstOperands,
     /* 316685 */   // GIR_Coverage, 5321,
     /* 316685 */   GIR_EraseRootFromParent_Done,
     /* 316686 */ // Label 6386: @316686
     /* 316686 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(316743), // Rule ID 5298 //
     /* 316691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 316709 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316713 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316715 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 316715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 316722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316741 */   GIR_RootConstrainSelectedInstOperands,
     /* 316742 */   // GIR_Coverage, 5298,
     /* 316742 */   GIR_EraseRootFromParent_Done,
     /* 316743 */ // Label 6387: @316743
     /* 316743 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(316773), // Rule ID 447 //
     /* 316748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316762 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 316762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 316767 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316771 */   GIR_RootConstrainSelectedInstOperands,
     /* 316772 */   // GIR_Coverage, 447,
     /* 316772 */   GIR_Done,
     /* 316773 */ // Label 6388: @316773
     /* 316773 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(316803), // Rule ID 453 //
     /* 316778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316792 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 316792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 316797 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316801 */   GIR_RootConstrainSelectedInstOperands,
     /* 316802 */   // GIR_Coverage, 453,
     /* 316802 */   GIR_Done,
     /* 316803 */ // Label 6389: @316803
     /* 316803 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(316833), // Rule ID 493 //
     /* 316808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 316811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316822 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 316822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 316827 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316831 */   GIR_RootConstrainSelectedInstOperands,
     /* 316832 */   // GIR_Coverage, 493,
     /* 316832 */   GIR_Done,
     /* 316833 */ // Label 6390: @316833
     /* 316833 */ GIM_Reject,
     /* 316834 */ // Label 6353: @316834
     /* 316834 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(316864), // Rule ID 1017 //
     /* 316839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316853 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 316853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 316858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316862 */   GIR_RootConstrainSelectedInstOperands,
     /* 316863 */   // GIR_Coverage, 1017,
     /* 316863 */   GIR_Done,
     /* 316864 */ // Label 6391: @316864
     /* 316864 */ GIM_Reject,
     /* 316865 */ // Label 6354: @316865
     /* 316865 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(316895), // Rule ID 1021 //
     /* 316870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316884 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 316884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 316889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316893 */   GIR_RootConstrainSelectedInstOperands,
     /* 316894 */   // GIR_Coverage, 1021,
     /* 316894 */   GIR_Done,
     /* 316895 */ // Label 6392: @316895
     /* 316895 */ GIM_Reject,
     /* 316896 */ // Label 6355: @316896
     /* 316896 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(316926), // Rule ID 1013 //
     /* 316901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316915 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 316915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 316920 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316924 */   GIR_RootConstrainSelectedInstOperands,
     /* 316925 */   // GIR_Coverage, 1013,
     /* 316925 */   GIR_Done,
     /* 316926 */ // Label 6393: @316926
     /* 316926 */ GIM_Reject,
     /* 316927 */ // Label 6356: @316927
     /* 316927 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(316957), // Rule ID 1019 //
     /* 316932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316946 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 316946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 316951 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316955 */   GIR_RootConstrainSelectedInstOperands,
     /* 316956 */   // GIR_Coverage, 1019,
     /* 316956 */   GIR_Done,
     /* 316957 */ // Label 6394: @316957
     /* 316957 */ GIM_Reject,
     /* 316958 */ // Label 6357: @316958
     /* 316958 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(316988), // Rule ID 1015 //
     /* 316963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316977 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 316977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 316982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316986 */   GIR_RootConstrainSelectedInstOperands,
     /* 316987 */   // GIR_Coverage, 1015,
     /* 316987 */   GIR_Done,
     /* 316988 */ // Label 6395: @316988
     /* 316988 */ GIM_Reject,
     /* 316989 */ // Label 6358: @316989
     /* 316989 */ GIM_Reject,
     /* 316990 */ // Label 68: @316990
     /* 316990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6404*/ GIMT_Encode4(320675),
     /* 317001 */ /*GILLT_s16*//*Label 6396*/ GIMT_Encode4(317041),
     /* 317005 */ /*GILLT_s32*//*Label 6397*/ GIMT_Encode4(317326),
     /* 317009 */ /*GILLT_s64*//*Label 6398*/ GIMT_Encode4(318654), GIMT_Encode4(0),
     /* 317017 */ /*GILLT_v2s32*//*Label 6399*/ GIMT_Encode4(320520),
     /* 317021 */ /*GILLT_v2s64*//*Label 6400*/ GIMT_Encode4(320551),
     /* 317025 */ /*GILLT_v4s16*//*Label 6401*/ GIMT_Encode4(320582),
     /* 317029 */ /*GILLT_v4s32*//*Label 6402*/ GIMT_Encode4(320613), GIMT_Encode4(0),
     /* 317037 */ /*GILLT_v8s16*//*Label 6403*/ GIMT_Encode4(320644),
     /* 317041 */ // Label 6396: @317041
     /* 317041 */ GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(317148), // Rule ID 5324 //
     /* 317046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 317049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 317064 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 317068 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 317072 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317076 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317080 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317084 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317088 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317093 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317097 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 317108 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317110 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 317110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 317113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317122 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 317128 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317133 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 317141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317146 */   GIR_RootConstrainSelectedInstOperands,
     /* 317147 */   // GIR_Coverage, 5324,
     /* 317147 */   GIR_EraseRootFromParent_Done,
     /* 317148 */ // Label 6405: @317148
     /* 317148 */ GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(317205), // Rule ID 5318 //
     /* 317153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 317156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 317171 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317177 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 317177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 317180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 317184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317189 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 317198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317203 */   GIR_RootConstrainSelectedInstOperands,
     /* 317204 */   // GIR_Coverage, 5318,
     /* 317204 */   GIR_EraseRootFromParent_Done,
     /* 317205 */ // Label 6406: @317205
     /* 317205 */ GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(317235), // Rule ID 467 //
     /* 317210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317224 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 317224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 317229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317233 */   GIR_RootConstrainSelectedInstOperands,
     /* 317234 */   // GIR_Coverage, 467,
     /* 317234 */   GIR_Done,
     /* 317235 */ // Label 6407: @317235
     /* 317235 */ GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(317265), // Rule ID 473 //
     /* 317240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317254 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 317254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 317259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317263 */   GIR_RootConstrainSelectedInstOperands,
     /* 317264 */   // GIR_Coverage, 473,
     /* 317264 */   GIR_Done,
     /* 317265 */ // Label 6408: @317265
     /* 317265 */ GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(317295), // Rule ID 499 //
     /* 317270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317284 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 317284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 317289 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317293 */   GIR_RootConstrainSelectedInstOperands,
     /* 317294 */   // GIR_Coverage, 499,
     /* 317294 */   GIR_Done,
     /* 317295 */ // Label 6409: @317295
     /* 317295 */ GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(317325), // Rule ID 503 //
     /* 317300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317314 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 317314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 317319 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317323 */   GIR_RootConstrainSelectedInstOperands,
     /* 317324 */   // GIR_Coverage, 503,
     /* 317324 */   GIR_Done,
     /* 317325 */ // Label 6410: @317325
     /* 317325 */ GIM_Reject,
     /* 317326 */ // Label 6397: @317326
     /* 317326 */ GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(317466), // Rule ID 5325 //
     /* 317331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317341 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317345 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317349 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317352 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317359 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317365 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 317372 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 317372 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317375 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 317379 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317399 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317406 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317409 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317413 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317432 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317435 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317438 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317441 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317446 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317451 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 317456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317464 */   GIR_RootConstrainSelectedInstOperands,
     /* 317465 */   // GIR_Coverage, 5325,
     /* 317465 */   GIR_EraseRootFromParent_Done,
     /* 317466 */ // Label 6411: @317466
     /* 317466 */ GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(317606), // Rule ID 5326 //
     /* 317471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317489 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317492 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317499 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317505 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 317512 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 317512 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317515 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 317519 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317539 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317546 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317549 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317553 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317572 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317575 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317578 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 317596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317604 */   GIR_RootConstrainSelectedInstOperands,
     /* 317605 */   // GIR_Coverage, 5326,
     /* 317605 */   GIR_EraseRootFromParent_Done,
     /* 317606 */ // Label 6412: @317606
     /* 317606 */ GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(317746), // Rule ID 5329 //
     /* 317611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317629 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317632 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317639 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317643 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317645 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 317652 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 317652 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 317655 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 317659 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317679 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317686 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317689 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317693 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317712 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317715 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317718 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 317721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317731 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317744 */   GIR_RootConstrainSelectedInstOperands,
     /* 317745 */   // GIR_Coverage, 5329,
     /* 317745 */   GIR_EraseRootFromParent_Done,
     /* 317746 */ // Label 6413: @317746
     /* 317746 */ GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(317886), // Rule ID 5330 //
     /* 317751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317761 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317769 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317772 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317779 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317785 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 317792 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 317792 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 317795 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 317799 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317819 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317826 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317829 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317833 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317852 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317855 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317858 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 317861 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317871 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317884 */   GIR_RootConstrainSelectedInstOperands,
     /* 317885 */   // GIR_Coverage, 5330,
     /* 317885 */   GIR_EraseRootFromParent_Done,
     /* 317886 */ // Label 6414: @317886
     /* 317886 */ GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(318021), // Rule ID 5327 //
     /* 317891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317909 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317912 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317919 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317923 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317925 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 317932 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 317932 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317935 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 317939 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317954 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317961 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317964 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317968 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317987 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317990 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317993 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317996 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318001 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318019 */   GIR_RootConstrainSelectedInstOperands,
     /* 318020 */   // GIR_Coverage, 5327,
     /* 318020 */   GIR_EraseRootFromParent_Done,
     /* 318021 */ // Label 6415: @318021
     /* 318021 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(318156), // Rule ID 5328 //
     /* 318026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318040 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318044 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318047 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318054 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318058 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318060 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 318067 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 318067 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318070 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 318074 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318089 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318096 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318099 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318103 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318122 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318125 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318128 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318131 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318136 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318141 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318154 */   GIR_RootConstrainSelectedInstOperands,
     /* 318155 */   // GIR_Coverage, 5328,
     /* 318155 */   GIR_EraseRootFromParent_Done,
     /* 318156 */ // Label 6416: @318156
     /* 318156 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(318291), // Rule ID 5331 //
     /* 318161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318171 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318175 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318179 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318182 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318189 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318195 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 318202 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 318202 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318205 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 318209 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318214 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318219 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318224 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318231 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318234 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318238 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318257 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318260 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318263 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318266 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318271 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318289 */   GIR_RootConstrainSelectedInstOperands,
     /* 318290 */   // GIR_Coverage, 5331,
     /* 318290 */   GIR_EraseRootFromParent_Done,
     /* 318291 */ // Label 6417: @318291
     /* 318291 */ GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(318426), // Rule ID 5332 //
     /* 318296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318314 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318317 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318324 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318328 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318330 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 318337 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 318337 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318340 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 318344 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318359 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318366 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318369 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318373 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318392 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318395 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318398 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318401 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318411 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318424 */   GIR_RootConstrainSelectedInstOperands,
     /* 318425 */   // GIR_Coverage, 5332,
     /* 318425 */   GIR_EraseRootFromParent_Done,
     /* 318426 */ // Label 6418: @318426
     /* 318426 */ GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(318506), // Rule ID 5320 //
     /* 318431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318449 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318453 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318462 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318466 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318468 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 318468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318480 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 318486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318491 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318504 */   GIR_RootConstrainSelectedInstOperands,
     /* 318505 */   // GIR_Coverage, 5320,
     /* 318505 */   GIR_EraseRootFromParent_Done,
     /* 318506 */ // Label 6419: @318506
     /* 318506 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(318563), // Rule ID 5310 //
     /* 318511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318521 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318525 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 318529 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318533 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318535 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 318535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 318542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318547 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318561 */   GIR_RootConstrainSelectedInstOperands,
     /* 318562 */   // GIR_Coverage, 5310,
     /* 318562 */   GIR_EraseRootFromParent_Done,
     /* 318563 */ // Label 6420: @318563
     /* 318563 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(318593), // Rule ID 469 //
     /* 318568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318582 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 318582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 318587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318591 */   GIR_RootConstrainSelectedInstOperands,
     /* 318592 */   // GIR_Coverage, 469,
     /* 318592 */   GIR_Done,
     /* 318593 */ // Label 6421: @318593
     /* 318593 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(318623), // Rule ID 475 //
     /* 318598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318612 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 318612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 318617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318621 */   GIR_RootConstrainSelectedInstOperands,
     /* 318622 */   // GIR_Coverage, 475,
     /* 318622 */   GIR_Done,
     /* 318623 */ // Label 6422: @318623
     /* 318623 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(318653), // Rule ID 505 //
     /* 318628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 318631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318642 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 318642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 318647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318651 */   GIR_RootConstrainSelectedInstOperands,
     /* 318652 */   // GIR_Coverage, 505,
     /* 318652 */   GIR_Done,
     /* 318653 */ // Label 6423: @318653
     /* 318653 */ GIM_Reject,
     /* 318654 */ // Label 6398: @318654
     /* 318654 */ GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(318791), // Rule ID 5341 //
     /* 318659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318669 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318677 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318680 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318684 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318688 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318690 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 318697 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 318697 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 318700 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 318704 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318724 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318731 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 318734 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318738 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318757 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318760 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318763 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318766 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318771 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 318784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318789 */   GIR_RootConstrainSelectedInstOperands,
     /* 318790 */   // GIR_Coverage, 5341,
     /* 318790 */   GIR_EraseRootFromParent_Done,
     /* 318791 */ // Label 6424: @318791
     /* 318791 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(318928), // Rule ID 5342 //
     /* 318796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318806 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318810 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318814 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318821 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318825 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318827 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 318834 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 318834 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 318837 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 318841 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318861 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318868 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 318871 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318875 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318894 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318897 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318900 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318913 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 318921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318926 */   GIR_RootConstrainSelectedInstOperands,
     /* 318927 */   // GIR_Coverage, 5342,
     /* 318927 */   GIR_EraseRootFromParent_Done,
     /* 318928 */ // Label 6425: @318928
     /* 318928 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(319068), // Rule ID 5333 //
     /* 318933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318951 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318954 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318961 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318965 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318967 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 318974 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 318974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 318981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318986 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319001 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319008 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319011 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319015 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319034 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319037 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319040 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319043 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319048 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319066 */   GIR_RootConstrainSelectedInstOperands,
     /* 319067 */   // GIR_Coverage, 5333,
     /* 319067 */   GIR_EraseRootFromParent_Done,
     /* 319068 */ // Label 6426: @319068
     /* 319068 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(319208), // Rule ID 5334 //
     /* 319073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319091 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319094 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319101 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319105 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319107 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 319114 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 319114 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319117 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 319121 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319141 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319148 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319151 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319155 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319174 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319177 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319180 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319183 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319188 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319193 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319206 */   GIR_RootConstrainSelectedInstOperands,
     /* 319207 */   // GIR_Coverage, 5334,
     /* 319207 */   GIR_EraseRootFromParent_Done,
     /* 319208 */ // Label 6427: @319208
     /* 319208 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(319348), // Rule ID 5337 //
     /* 319213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319231 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319234 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319241 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319245 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319247 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 319254 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319254 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319257 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 319261 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319271 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319281 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319288 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319291 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319295 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319314 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319317 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319320 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319323 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319328 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319333 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319346 */   GIR_RootConstrainSelectedInstOperands,
     /* 319347 */   // GIR_Coverage, 5337,
     /* 319347 */   GIR_EraseRootFromParent_Done,
     /* 319348 */ // Label 6428: @319348
     /* 319348 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(319488), // Rule ID 5338 //
     /* 319353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319371 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319374 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319381 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319387 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 319394 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319394 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319397 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 319401 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319421 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319428 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319431 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319435 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319454 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319457 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319460 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319486 */   GIR_RootConstrainSelectedInstOperands,
     /* 319487 */   // GIR_Coverage, 5338,
     /* 319487 */   GIR_EraseRootFromParent_Done,
     /* 319488 */ // Label 6429: @319488
     /* 319488 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(319620), // Rule ID 5343 //
     /* 319493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 319511 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319514 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 319518 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319524 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 319531 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 319531 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 319534 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 319538 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319553 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319560 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319563 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319567 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319589 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319592 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319605 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319615 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319618 */   GIR_RootConstrainSelectedInstOperands,
     /* 319619 */   // GIR_Coverage, 5343,
     /* 319619 */   GIR_EraseRootFromParent_Done,
     /* 319620 */ // Label 6430: @319620
     /* 319620 */ GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(319752), // Rule ID 5344 //
     /* 319625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319635 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319639 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 319643 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319646 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 319650 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319654 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319656 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 319663 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 319663 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 319666 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 319670 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319685 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319692 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319695 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319699 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319718 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319721 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319724 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319750 */   GIR_RootConstrainSelectedInstOperands,
     /* 319751 */   // GIR_Coverage, 5344,
     /* 319751 */   GIR_EraseRootFromParent_Done,
     /* 319752 */ // Label 6431: @319752
     /* 319752 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(319887), // Rule ID 5335 //
     /* 319757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319775 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319778 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319785 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319791 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 319798 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 319798 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319801 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 319805 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319820 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319827 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319830 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319834 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319853 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319856 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319859 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319862 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319885 */   GIR_RootConstrainSelectedInstOperands,
     /* 319886 */   // GIR_Coverage, 5335,
     /* 319886 */   GIR_EraseRootFromParent_Done,
     /* 319887 */ // Label 6432: @319887
     /* 319887 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(320022), // Rule ID 5336 //
     /* 319892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319902 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319906 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319910 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319913 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319920 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319924 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319926 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 319933 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 319933 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319936 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 319940 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319955 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319962 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319965 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319969 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319988 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319991 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319994 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319997 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320020 */   GIR_RootConstrainSelectedInstOperands,
     /* 320021 */   // GIR_Coverage, 5336,
     /* 320021 */   GIR_EraseRootFromParent_Done,
     /* 320022 */ // Label 6433: @320022
     /* 320022 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(320157), // Rule ID 5339 //
     /* 320027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320045 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320048 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320055 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320061 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 320068 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 320068 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320071 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 320075 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320090 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320097 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320100 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320104 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320123 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320126 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320129 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320137 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320155 */   GIR_RootConstrainSelectedInstOperands,
     /* 320156 */   // GIR_Coverage, 5339,
     /* 320156 */   GIR_EraseRootFromParent_Done,
     /* 320157 */ // Label 6434: @320157
     /* 320157 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(320292), // Rule ID 5340 //
     /* 320162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320180 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320183 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320190 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320196 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 320203 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 320203 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320206 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 320210 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320215 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320225 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320232 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320235 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320239 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320258 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320261 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320264 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320272 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320277 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320290 */   GIR_RootConstrainSelectedInstOperands,
     /* 320291 */   // GIR_Coverage, 5340,
     /* 320291 */   GIR_EraseRootFromParent_Done,
     /* 320292 */ // Label 6435: @320292
     /* 320292 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(320372), // Rule ID 5322 //
     /* 320297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320307 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320311 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320315 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320319 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320323 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320328 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320334 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 320334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320346 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320352 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320370 */   GIR_RootConstrainSelectedInstOperands,
     /* 320371 */   // GIR_Coverage, 5322,
     /* 320371 */   GIR_EraseRootFromParent_Done,
     /* 320372 */ // Label 6436: @320372
     /* 320372 */ GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(320429), // Rule ID 5306 //
     /* 320377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 320395 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320399 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320401 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 320401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 320408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320413 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320427 */   GIR_RootConstrainSelectedInstOperands,
     /* 320428 */   // GIR_Coverage, 5306,
     /* 320428 */   GIR_EraseRootFromParent_Done,
     /* 320429 */ // Label 6437: @320429
     /* 320429 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(320459), // Rule ID 471 //
     /* 320434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320448 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 320448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 320453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320457 */   GIR_RootConstrainSelectedInstOperands,
     /* 320458 */   // GIR_Coverage, 471,
     /* 320458 */   GIR_Done,
     /* 320459 */ // Label 6438: @320459
     /* 320459 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(320489), // Rule ID 477 //
     /* 320464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320478 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 320478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 320483 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320487 */   GIR_RootConstrainSelectedInstOperands,
     /* 320488 */   // GIR_Coverage, 477,
     /* 320488 */   GIR_Done,
     /* 320489 */ // Label 6439: @320489
     /* 320489 */ GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(320519), // Rule ID 501 //
     /* 320494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320508 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 320508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 320513 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320517 */   GIR_RootConstrainSelectedInstOperands,
     /* 320518 */   // GIR_Coverage, 501,
     /* 320518 */   GIR_Done,
     /* 320519 */ // Label 6440: @320519
     /* 320519 */ GIM_Reject,
     /* 320520 */ // Label 6399: @320520
     /* 320520 */ GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(320550), // Rule ID 1078 //
     /* 320525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320539 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 320539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 320544 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320548 */   GIR_RootConstrainSelectedInstOperands,
     /* 320549 */   // GIR_Coverage, 1078,
     /* 320549 */   GIR_Done,
     /* 320550 */ // Label 6441: @320550
     /* 320550 */ GIM_Reject,
     /* 320551 */ // Label 6400: @320551
     /* 320551 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(320581), // Rule ID 1082 //
     /* 320556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320570 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 320570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 320575 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320579 */   GIR_RootConstrainSelectedInstOperands,
     /* 320580 */   // GIR_Coverage, 1082,
     /* 320580 */   GIR_Done,
     /* 320581 */ // Label 6442: @320581
     /* 320581 */ GIM_Reject,
     /* 320582 */ // Label 6401: @320582
     /* 320582 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(320612), // Rule ID 1074 //
     /* 320587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320601 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 320601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 320606 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320610 */   GIR_RootConstrainSelectedInstOperands,
     /* 320611 */   // GIR_Coverage, 1074,
     /* 320611 */   GIR_Done,
     /* 320612 */ // Label 6443: @320612
     /* 320612 */ GIM_Reject,
     /* 320613 */ // Label 6402: @320613
     /* 320613 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(320643), // Rule ID 1080 //
     /* 320618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320632 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 320632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 320637 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320641 */   GIR_RootConstrainSelectedInstOperands,
     /* 320642 */   // GIR_Coverage, 1080,
     /* 320642 */   GIR_Done,
     /* 320643 */ // Label 6444: @320643
     /* 320643 */ GIM_Reject,
     /* 320644 */ // Label 6403: @320644
     /* 320644 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(320674), // Rule ID 1076 //
     /* 320649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320663 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 320663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 320668 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320672 */   GIR_RootConstrainSelectedInstOperands,
     /* 320673 */   // GIR_Coverage, 1076,
     /* 320673 */   GIR_Done,
     /* 320674 */ // Label 6445: @320674
     /* 320674 */ GIM_Reject,
     /* 320675 */ // Label 6404: @320675
     /* 320675 */ GIM_Reject,
     /* 320676 */ // Label 69: @320676
     /* 320676 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6453*/ GIMT_Encode4(320995),
     /* 320687 */ /*GILLT_s32*//*Label 6446*/ GIMT_Encode4(320723),
     /* 320691 */ /*GILLT_s64*//*Label 6447*/ GIMT_Encode4(320796), GIMT_Encode4(0),
     /* 320699 */ /*GILLT_v2s32*//*Label 6448*/ GIMT_Encode4(320869),
     /* 320703 */ /*GILLT_v2s64*//*Label 6449*/ GIMT_Encode4(320893),
     /* 320707 */ /*GILLT_v4s16*//*Label 6450*/ GIMT_Encode4(320917),
     /* 320711 */ /*GILLT_v4s32*//*Label 6451*/ GIMT_Encode4(320944), GIMT_Encode4(0),
     /* 320719 */ /*GILLT_v8s16*//*Label 6452*/ GIMT_Encode4(320968),
     /* 320723 */ // Label 6446: @320723
     /* 320723 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(320749), // Rule ID 4583 //
     /* 320728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320738 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 320738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 320743 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320747 */   GIR_RootConstrainSelectedInstOperands,
     /* 320748 */   // GIR_Coverage, 4583,
     /* 320748 */   GIR_Done,
     /* 320749 */ // Label 6454: @320749
     /* 320749 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(320772), // Rule ID 4585 //
     /* 320754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320761 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 320761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 320766 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320770 */   GIR_RootConstrainSelectedInstOperands,
     /* 320771 */   // GIR_Coverage, 4585,
     /* 320771 */   GIR_Done,
     /* 320772 */ // Label 6455: @320772
     /* 320772 */ GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(320795), // Rule ID 4587 //
     /* 320777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320784 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 320784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 320789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320793 */   GIR_RootConstrainSelectedInstOperands,
     /* 320794 */   // GIR_Coverage, 4587,
     /* 320794 */   GIR_Done,
     /* 320795 */ // Label 6456: @320795
     /* 320795 */ GIM_Reject,
     /* 320796 */ // Label 6447: @320796
     /* 320796 */ GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(320822), // Rule ID 4584 //
     /* 320801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320811 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 320811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 320816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320820 */   GIR_RootConstrainSelectedInstOperands,
     /* 320821 */   // GIR_Coverage, 4584,
     /* 320821 */   GIR_Done,
     /* 320822 */ // Label 6457: @320822
     /* 320822 */ GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(320845), // Rule ID 4586 //
     /* 320827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320834 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 320834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 320839 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320843 */   GIR_RootConstrainSelectedInstOperands,
     /* 320844 */   // GIR_Coverage, 4586,
     /* 320844 */   GIR_Done,
     /* 320845 */ // Label 6458: @320845
     /* 320845 */ GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(320868), // Rule ID 4588 //
     /* 320850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320857 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 320857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 320862 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320866 */   GIR_RootConstrainSelectedInstOperands,
     /* 320867 */   // GIR_Coverage, 4588,
     /* 320867 */   GIR_Done,
     /* 320868 */ // Label 6459: @320868
     /* 320868 */ GIM_Reject,
     /* 320869 */ // Label 6448: @320869
     /* 320869 */ GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(320892), // Rule ID 4924 //
     /* 320874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320881 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 320881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 320886 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320890 */   GIR_RootConstrainSelectedInstOperands,
     /* 320891 */   // GIR_Coverage, 4924,
     /* 320891 */   GIR_Done,
     /* 320892 */ // Label 6460: @320892
     /* 320892 */ GIM_Reject,
     /* 320893 */ // Label 6449: @320893
     /* 320893 */ GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(320916), // Rule ID 4926 //
     /* 320898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320905 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 320905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 320910 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320914 */   GIR_RootConstrainSelectedInstOperands,
     /* 320915 */   // GIR_Coverage, 4926,
     /* 320915 */   GIR_Done,
     /* 320916 */ // Label 6461: @320916
     /* 320916 */ GIM_Reject,
     /* 320917 */ // Label 6450: @320917
     /* 320917 */ GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(320943), // Rule ID 4919 //
     /* 320922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320932 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 320932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 320937 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320941 */   GIR_RootConstrainSelectedInstOperands,
     /* 320942 */   // GIR_Coverage, 4919,
     /* 320942 */   GIR_Done,
     /* 320943 */ // Label 6462: @320943
     /* 320943 */ GIM_Reject,
     /* 320944 */ // Label 6451: @320944
     /* 320944 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(320967), // Rule ID 4925 //
     /* 320949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320956 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 320956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 320961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320965 */   GIR_RootConstrainSelectedInstOperands,
     /* 320966 */   // GIR_Coverage, 4925,
     /* 320966 */   GIR_Done,
     /* 320967 */ // Label 6463: @320967
     /* 320967 */ GIM_Reject,
     /* 320968 */ // Label 6452: @320968
     /* 320968 */ GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(320994), // Rule ID 4920 //
     /* 320973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320983 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 320983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 320988 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320992 */   GIR_RootConstrainSelectedInstOperands,
     /* 320993 */   // GIR_Coverage, 4920,
     /* 320993 */   GIR_Done,
     /* 320994 */ // Label 6464: @320994
     /* 320994 */ GIM_Reject,
     /* 320995 */ // Label 6453: @320995
     /* 320995 */ GIM_Reject,
     /* 320996 */ // Label 70: @320996
     /* 320996 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6472*/ GIMT_Encode4(321315),
     /* 321007 */ /*GILLT_s32*//*Label 6465*/ GIMT_Encode4(321043),
     /* 321011 */ /*GILLT_s64*//*Label 6466*/ GIMT_Encode4(321116), GIMT_Encode4(0),
     /* 321019 */ /*GILLT_v2s32*//*Label 6467*/ GIMT_Encode4(321189),
     /* 321023 */ /*GILLT_v2s64*//*Label 6468*/ GIMT_Encode4(321213),
     /* 321027 */ /*GILLT_v4s16*//*Label 6469*/ GIMT_Encode4(321237),
     /* 321031 */ /*GILLT_v4s32*//*Label 6470*/ GIMT_Encode4(321264), GIMT_Encode4(0),
     /* 321039 */ /*GILLT_v8s16*//*Label 6471*/ GIMT_Encode4(321288),
     /* 321043 */ // Label 6465: @321043
     /* 321043 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(321069), // Rule ID 4607 //
     /* 321048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321058 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 321058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 321063 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321067 */   GIR_RootConstrainSelectedInstOperands,
     /* 321068 */   // GIR_Coverage, 4607,
     /* 321068 */   GIR_Done,
     /* 321069 */ // Label 6473: @321069
     /* 321069 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(321092), // Rule ID 4609 //
     /* 321074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321081 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 321081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 321086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321090 */   GIR_RootConstrainSelectedInstOperands,
     /* 321091 */   // GIR_Coverage, 4609,
     /* 321091 */   GIR_Done,
     /* 321092 */ // Label 6474: @321092
     /* 321092 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(321115), // Rule ID 4611 //
     /* 321097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321104 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 321104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 321109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321113 */   GIR_RootConstrainSelectedInstOperands,
     /* 321114 */   // GIR_Coverage, 4611,
     /* 321114 */   GIR_Done,
     /* 321115 */ // Label 6475: @321115
     /* 321115 */ GIM_Reject,
     /* 321116 */ // Label 6466: @321116
     /* 321116 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(321142), // Rule ID 4608 //
     /* 321121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321131 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 321131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 321136 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321140 */   GIR_RootConstrainSelectedInstOperands,
     /* 321141 */   // GIR_Coverage, 4608,
     /* 321141 */   GIR_Done,
     /* 321142 */ // Label 6476: @321142
     /* 321142 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(321165), // Rule ID 4610 //
     /* 321147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321154 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 321154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 321159 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321163 */   GIR_RootConstrainSelectedInstOperands,
     /* 321164 */   // GIR_Coverage, 4610,
     /* 321164 */   GIR_Done,
     /* 321165 */ // Label 6477: @321165
     /* 321165 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(321188), // Rule ID 4612 //
     /* 321170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321177 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 321177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 321182 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321186 */   GIR_RootConstrainSelectedInstOperands,
     /* 321187 */   // GIR_Coverage, 4612,
     /* 321187 */   GIR_Done,
     /* 321188 */ // Label 6478: @321188
     /* 321188 */ GIM_Reject,
     /* 321189 */ // Label 6467: @321189
     /* 321189 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(321212), // Rule ID 4934 //
     /* 321194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321201 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 321201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 321206 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321210 */   GIR_RootConstrainSelectedInstOperands,
     /* 321211 */   // GIR_Coverage, 4934,
     /* 321211 */   GIR_Done,
     /* 321212 */ // Label 6479: @321212
     /* 321212 */ GIM_Reject,
     /* 321213 */ // Label 6468: @321213
     /* 321213 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(321236), // Rule ID 4936 //
     /* 321218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321225 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 321225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 321230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321234 */   GIR_RootConstrainSelectedInstOperands,
     /* 321235 */   // GIR_Coverage, 4936,
     /* 321235 */   GIR_Done,
     /* 321236 */ // Label 6480: @321236
     /* 321236 */ GIM_Reject,
     /* 321237 */ // Label 6469: @321237
     /* 321237 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(321263), // Rule ID 4929 //
     /* 321242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321252 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 321252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 321257 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321261 */   GIR_RootConstrainSelectedInstOperands,
     /* 321262 */   // GIR_Coverage, 4929,
     /* 321262 */   GIR_Done,
     /* 321263 */ // Label 6481: @321263
     /* 321263 */ GIM_Reject,
     /* 321264 */ // Label 6470: @321264
     /* 321264 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(321287), // Rule ID 4935 //
     /* 321269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321276 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 321276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 321281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321285 */   GIR_RootConstrainSelectedInstOperands,
     /* 321286 */   // GIR_Coverage, 4935,
     /* 321286 */   GIR_Done,
     /* 321287 */ // Label 6482: @321287
     /* 321287 */ GIM_Reject,
     /* 321288 */ // Label 6471: @321288
     /* 321288 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(321314), // Rule ID 4930 //
     /* 321293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321303 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 321303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 321308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321312 */   GIR_RootConstrainSelectedInstOperands,
     /* 321313 */   // GIR_Coverage, 4930,
     /* 321313 */   GIR_Done,
     /* 321314 */ // Label 6483: @321314
     /* 321314 */ GIM_Reject,
     /* 321315 */ // Label 6472: @321315
     /* 321315 */ GIM_Reject,
     /* 321316 */ // Label 71: @321316
     /* 321316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6492*/ GIMT_Encode4(322172),
     /* 321327 */ /*GILLT_s16*//*Label 6484*/ GIMT_Encode4(321367),
     /* 321331 */ /*GILLT_s32*//*Label 6485*/ GIMT_Encode4(321586),
     /* 321335 */ /*GILLT_s64*//*Label 6486*/ GIMT_Encode4(321660), GIMT_Encode4(0),
     /* 321343 */ /*GILLT_v2s32*//*Label 6487*/ GIMT_Encode4(321734),
     /* 321347 */ /*GILLT_v2s64*//*Label 6488*/ GIMT_Encode4(321808),
     /* 321351 */ /*GILLT_v4s16*//*Label 6489*/ GIMT_Encode4(321882),
     /* 321355 */ /*GILLT_v4s32*//*Label 6490*/ GIMT_Encode4(321990), GIMT_Encode4(0),
     /* 321363 */ /*GILLT_v8s16*//*Label 6491*/ GIMT_Encode4(322064),
     /* 321367 */ // Label 6484: @321367
     /* 321367 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(321585),
     /* 321372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321379 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(321420), // Rule ID 5208 //
     /* 321384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321405 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 321405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 321408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321418 */     GIR_RootConstrainSelectedInstOperands,
     /* 321419 */     // GIR_Coverage, 5208,
     /* 321419 */     GIR_EraseRootFromParent_Done,
     /* 321420 */   // Label 6494: @321420
     /* 321420 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(321439), // Rule ID 521 //
     /* 321425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321432 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 321432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 321437 */     GIR_RootConstrainSelectedInstOperands,
     /* 321438 */     // GIR_Coverage, 521,
     /* 321438 */     GIR_Done,
     /* 321439 */   // Label 6495: @321439
     /* 321439 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(321584), // Rule ID 6368 //
     /* 321444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321448 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 321448 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 321451 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321455 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 321462 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 321465 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321469 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321474 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 321477 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321481 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 321484 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321489 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321494 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321499 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321502 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321506 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321511 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 321514 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 321526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321531 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 321534 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 321539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321553 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321566 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 321573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321583 */     // GIR_Coverage, 6368,
     /* 321583 */     GIR_EraseRootFromParent_Done,
     /* 321584 */   // Label 6496: @321584
     /* 321584 */   GIM_Reject,
     /* 321585 */ // Label 6493: @321585
     /* 321585 */ GIM_Reject,
     /* 321586 */ // Label 6485: @321586
     /* 321586 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(321659),
     /* 321591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321598 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(321639), // Rule ID 5209 //
     /* 321603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 321618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 321622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321624 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 321624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 321627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321637 */     GIR_RootConstrainSelectedInstOperands,
     /* 321638 */     // GIR_Coverage, 5209,
     /* 321638 */     GIR_EraseRootFromParent_Done,
     /* 321639 */   // Label 6498: @321639
     /* 321639 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(321658), // Rule ID 522 //
     /* 321644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321651 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 321651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 321656 */     GIR_RootConstrainSelectedInstOperands,
     /* 321657 */     // GIR_Coverage, 522,
     /* 321657 */     GIR_Done,
     /* 321658 */   // Label 6499: @321658
     /* 321658 */   GIM_Reject,
     /* 321659 */ // Label 6497: @321659
     /* 321659 */ GIM_Reject,
     /* 321660 */ // Label 6486: @321660
     /* 321660 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(321733),
     /* 321665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321672 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(321713), // Rule ID 5210 //
     /* 321677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321698 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 321698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 321701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321711 */     GIR_RootConstrainSelectedInstOperands,
     /* 321712 */     // GIR_Coverage, 5210,
     /* 321712 */     GIR_EraseRootFromParent_Done,
     /* 321713 */   // Label 6501: @321713
     /* 321713 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(321732), // Rule ID 523 //
     /* 321718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321725 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 321725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 321730 */     GIR_RootConstrainSelectedInstOperands,
     /* 321731 */     // GIR_Coverage, 523,
     /* 321731 */     GIR_Done,
     /* 321732 */   // Label 6502: @321732
     /* 321732 */   GIM_Reject,
     /* 321733 */ // Label 6500: @321733
     /* 321733 */ GIM_Reject,
     /* 321734 */ // Label 6487: @321734
     /* 321734 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(321807),
     /* 321739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321746 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(321787), // Rule ID 5001 //
     /* 321751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 321770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321772 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 321772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 321775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321785 */     GIR_RootConstrainSelectedInstOperands,
     /* 321786 */     // GIR_Coverage, 5001,
     /* 321786 */     GIR_EraseRootFromParent_Done,
     /* 321787 */   // Label 6504: @321787
     /* 321787 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(321806), // Rule ID 768 //
     /* 321792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321799 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 321799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 321804 */     GIR_RootConstrainSelectedInstOperands,
     /* 321805 */     // GIR_Coverage, 768,
     /* 321805 */     GIR_Done,
     /* 321806 */   // Label 6505: @321806
     /* 321806 */   GIM_Reject,
     /* 321807 */ // Label 6503: @321807
     /* 321807 */ GIM_Reject,
     /* 321808 */ // Label 6488: @321808
     /* 321808 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(321881),
     /* 321813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321820 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(321861), // Rule ID 5003 //
     /* 321825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 321844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321846 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 321846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 321849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321859 */     GIR_RootConstrainSelectedInstOperands,
     /* 321860 */     // GIR_Coverage, 5003,
     /* 321860 */     GIR_EraseRootFromParent_Done,
     /* 321861 */   // Label 6507: @321861
     /* 321861 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(321880), // Rule ID 770 //
     /* 321866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321873 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 321873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 321878 */     GIR_RootConstrainSelectedInstOperands,
     /* 321879 */     // GIR_Coverage, 770,
     /* 321879 */     GIR_Done,
     /* 321880 */   // Label 6508: @321880
     /* 321880 */   GIM_Reject,
     /* 321881 */ // Label 6506: @321881
     /* 321881 */ GIM_Reject,
     /* 321882 */ // Label 6489: @321882
     /* 321882 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(321989),
     /* 321887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321894 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(321935), // Rule ID 5004 //
     /* 321899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 321918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321920 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 321920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 321923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321933 */     GIR_RootConstrainSelectedInstOperands,
     /* 321934 */     // GIR_Coverage, 5004,
     /* 321934 */     GIR_EraseRootFromParent_Done,
     /* 321935 */   // Label 6510: @321935
     /* 321935 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(321954), // Rule ID 766 //
     /* 321940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321947 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 321947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 321952 */     GIR_RootConstrainSelectedInstOperands,
     /* 321953 */     // GIR_Coverage, 766,
     /* 321953 */     GIR_Done,
     /* 321954 */   // Label 6511: @321954
     /* 321954 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(321988), // Rule ID 6370 //
     /* 321959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321966 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 321966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 321969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321973 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 321983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 321986 */     GIR_RootConstrainSelectedInstOperands,
     /* 321987 */     // GIR_Coverage, 6370,
     /* 321987 */     GIR_EraseRootFromParent_Done,
     /* 321988 */   // Label 6512: @321988
     /* 321988 */   GIM_Reject,
     /* 321989 */ // Label 6509: @321989
     /* 321989 */ GIM_Reject,
     /* 321990 */ // Label 6490: @321990
     /* 321990 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(322063),
     /* 321995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322002 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(322043), // Rule ID 5002 //
     /* 322007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322028 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 322028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 322031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322041 */     GIR_RootConstrainSelectedInstOperands,
     /* 322042 */     // GIR_Coverage, 5002,
     /* 322042 */     GIR_EraseRootFromParent_Done,
     /* 322043 */   // Label 6514: @322043
     /* 322043 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(322062), // Rule ID 769 //
     /* 322048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322055 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 322055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 322060 */     GIR_RootConstrainSelectedInstOperands,
     /* 322061 */     // GIR_Coverage, 769,
     /* 322061 */     GIR_Done,
     /* 322062 */   // Label 6515: @322062
     /* 322062 */   GIM_Reject,
     /* 322063 */ // Label 6513: @322063
     /* 322063 */ GIM_Reject,
     /* 322064 */ // Label 6491: @322064
     /* 322064 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(322171),
     /* 322069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322076 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(322117), // Rule ID 5005 //
     /* 322081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322102 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 322102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 322105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322115 */     GIR_RootConstrainSelectedInstOperands,
     /* 322116 */     // GIR_Coverage, 5005,
     /* 322116 */     GIR_EraseRootFromParent_Done,
     /* 322117 */   // Label 6517: @322117
     /* 322117 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(322136), // Rule ID 767 //
     /* 322122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322129 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 322129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 322134 */     GIR_RootConstrainSelectedInstOperands,
     /* 322135 */     // GIR_Coverage, 767,
     /* 322135 */     GIR_Done,
     /* 322136 */   // Label 6518: @322136
     /* 322136 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(322170), // Rule ID 6371 //
     /* 322141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322148 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 322148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 322151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322155 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 322165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 322168 */     GIR_RootConstrainSelectedInstOperands,
     /* 322169 */     // GIR_Coverage, 6371,
     /* 322169 */     GIR_EraseRootFromParent_Done,
     /* 322170 */   // Label 6519: @322170
     /* 322170 */   GIM_Reject,
     /* 322171 */ // Label 6516: @322171
     /* 322171 */ GIM_Reject,
     /* 322172 */ // Label 6492: @322172
     /* 322172 */ GIM_Reject,
     /* 322173 */ // Label 72: @322173
     /* 322173 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6528*/ GIMT_Encode4(322454),
     /* 322184 */ /*GILLT_s16*//*Label 6520*/ GIMT_Encode4(322224),
     /* 322188 */ /*GILLT_s32*//*Label 6521*/ GIMT_Encode4(322251),
     /* 322192 */ /*GILLT_s64*//*Label 6522*/ GIMT_Encode4(322275), GIMT_Encode4(0),
     /* 322200 */ /*GILLT_v2s32*//*Label 6523*/ GIMT_Encode4(322299),
     /* 322204 */ /*GILLT_v2s64*//*Label 6524*/ GIMT_Encode4(322330),
     /* 322208 */ /*GILLT_v4s16*//*Label 6525*/ GIMT_Encode4(322361),
     /* 322212 */ /*GILLT_v4s32*//*Label 6526*/ GIMT_Encode4(322392), GIMT_Encode4(0),
     /* 322220 */ /*GILLT_v8s16*//*Label 6527*/ GIMT_Encode4(322423),
     /* 322224 */ // Label 6520: @322224
     /* 322224 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(322250), // Rule ID 4823 //
     /* 322229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322239 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 322239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 322242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322244 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322246 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322248 */   GIR_RootConstrainSelectedInstOperands,
     /* 322249 */   // GIR_Coverage, 4823,
     /* 322249 */   GIR_EraseRootFromParent_Done,
     /* 322250 */ // Label 6529: @322250
     /* 322250 */ GIM_Reject,
     /* 322251 */ // Label 6521: @322251
     /* 322251 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(322274), // Rule ID 4820 //
     /* 322256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322263 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 322263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 322266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322268 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322270 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322272 */   GIR_RootConstrainSelectedInstOperands,
     /* 322273 */   // GIR_Coverage, 4820,
     /* 322273 */   GIR_EraseRootFromParent_Done,
     /* 322274 */ // Label 6530: @322274
     /* 322274 */ GIM_Reject,
     /* 322275 */ // Label 6522: @322275
     /* 322275 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(322298), // Rule ID 4817 //
     /* 322280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322287 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 322287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322292 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322294 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322296 */   GIR_RootConstrainSelectedInstOperands,
     /* 322297 */   // GIR_Coverage, 4817,
     /* 322297 */   GIR_EraseRootFromParent_Done,
     /* 322298 */ // Label 6531: @322298
     /* 322298 */ GIM_Reject,
     /* 322299 */ // Label 6523: @322299
     /* 322299 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(322329), // Rule ID 5014 //
     /* 322304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322318 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 322318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 322321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322323 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322325 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322327 */   GIR_RootConstrainSelectedInstOperands,
     /* 322328 */   // GIR_Coverage, 5014,
     /* 322328 */   GIR_EraseRootFromParent_Done,
     /* 322329 */ // Label 6532: @322329
     /* 322329 */ GIM_Reject,
     /* 322330 */ // Label 6524: @322330
     /* 322330 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(322360), // Rule ID 5008 //
     /* 322335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322349 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 322349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 322352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322354 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322356 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322358 */   GIR_RootConstrainSelectedInstOperands,
     /* 322359 */   // GIR_Coverage, 5008,
     /* 322359 */   GIR_EraseRootFromParent_Done,
     /* 322360 */ // Label 6533: @322360
     /* 322360 */ GIM_Reject,
     /* 322361 */ // Label 6525: @322361
     /* 322361 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(322391), // Rule ID 5020 //
     /* 322366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322380 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 322380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 322383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322385 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322387 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322389 */   GIR_RootConstrainSelectedInstOperands,
     /* 322390 */   // GIR_Coverage, 5020,
     /* 322390 */   GIR_EraseRootFromParent_Done,
     /* 322391 */ // Label 6534: @322391
     /* 322391 */ GIM_Reject,
     /* 322392 */ // Label 6526: @322392
     /* 322392 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(322422), // Rule ID 5011 //
     /* 322397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322411 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 322411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 322414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322416 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322418 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322420 */   GIR_RootConstrainSelectedInstOperands,
     /* 322421 */   // GIR_Coverage, 5011,
     /* 322421 */   GIR_EraseRootFromParent_Done,
     /* 322422 */ // Label 6535: @322422
     /* 322422 */ GIM_Reject,
     /* 322423 */ // Label 6527: @322423
     /* 322423 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(322453), // Rule ID 5017 //
     /* 322428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322442 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 322442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 322445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322447 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322449 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322451 */   GIR_RootConstrainSelectedInstOperands,
     /* 322452 */   // GIR_Coverage, 5017,
     /* 322452 */   GIR_EraseRootFromParent_Done,
     /* 322453 */ // Label 6536: @322453
     /* 322453 */ GIM_Reject,
     /* 322454 */ // Label 6528: @322454
     /* 322454 */ GIM_Reject,
     /* 322455 */ // Label 73: @322455
     /* 322455 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6545*/ GIMT_Encode4(322832),
     /* 322466 */ /*GILLT_s16*//*Label 6537*/ GIMT_Encode4(322506),
     /* 322470 */ /*GILLT_s32*//*Label 6538*/ GIMT_Encode4(322544),
     /* 322474 */ /*GILLT_s64*//*Label 6539*/ GIMT_Encode4(322582), GIMT_Encode4(0),
     /* 322482 */ /*GILLT_v2s32*//*Label 6540*/ GIMT_Encode4(322642),
     /* 322486 */ /*GILLT_v2s64*//*Label 6541*/ GIMT_Encode4(322680),
     /* 322490 */ /*GILLT_v4s16*//*Label 6542*/ GIMT_Encode4(322718),
     /* 322494 */ /*GILLT_v4s32*//*Label 6543*/ GIMT_Encode4(322756), GIMT_Encode4(0),
     /* 322502 */ /*GILLT_v8s16*//*Label 6544*/ GIMT_Encode4(322794),
     /* 322506 */ // Label 6537: @322506
     /* 322506 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(322543), // Rule ID 608 //
     /* 322511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 322520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322532 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 322532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 322537 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322541 */   GIR_RootConstrainSelectedInstOperands,
     /* 322542 */   // GIR_Coverage, 608,
     /* 322542 */   GIR_Done,
     /* 322543 */ // Label 6546: @322543
     /* 322543 */ GIM_Reject,
     /* 322544 */ // Label 6538: @322544
     /* 322544 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(322581), // Rule ID 610 //
     /* 322549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 322558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322570 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 322570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 322575 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322579 */   GIR_RootConstrainSelectedInstOperands,
     /* 322580 */   // GIR_Coverage, 610,
     /* 322580 */   GIR_Done,
     /* 322581 */ // Label 6547: @322581
     /* 322581 */ GIM_Reject,
     /* 322582 */ // Label 6539: @322582
     /* 322582 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(322641),
     /* 322587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322605 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(322624), // Rule ID 612 //
     /* 322610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322613 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 322613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322618 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322622 */     GIR_RootConstrainSelectedInstOperands,
     /* 322623 */     // GIR_Coverage, 612,
     /* 322623 */     GIR_Done,
     /* 322624 */   // Label 6549: @322624
     /* 322624 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(322640), // Rule ID 4814 //
     /* 322629 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 322629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322634 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322638 */     GIR_RootConstrainSelectedInstOperands,
     /* 322639 */     // GIR_Coverage, 4814,
     /* 322639 */     GIR_Done,
     /* 322640 */   // Label 6550: @322640
     /* 322640 */   GIM_Reject,
     /* 322641 */ // Label 6548: @322641
     /* 322641 */ GIM_Reject,
     /* 322642 */ // Label 6540: @322642
     /* 322642 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(322679), // Rule ID 1273 //
     /* 322647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 322656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322668 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 322668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 322673 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322677 */   GIR_RootConstrainSelectedInstOperands,
     /* 322678 */   // GIR_Coverage, 1273,
     /* 322678 */   GIR_Done,
     /* 322679 */ // Label 6551: @322679
     /* 322679 */ GIM_Reject,
     /* 322680 */ // Label 6541: @322680
     /* 322680 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(322717), // Rule ID 1277 //
     /* 322685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 322694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322706 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 322711 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322715 */   GIR_RootConstrainSelectedInstOperands,
     /* 322716 */   // GIR_Coverage, 1277,
     /* 322716 */   GIR_Done,
     /* 322717 */ // Label 6552: @322717
     /* 322717 */ GIM_Reject,
     /* 322718 */ // Label 6542: @322718
     /* 322718 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(322755), // Rule ID 1269 //
     /* 322723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322744 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 322749 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322753 */   GIR_RootConstrainSelectedInstOperands,
     /* 322754 */   // GIR_Coverage, 1269,
     /* 322754 */   GIR_Done,
     /* 322755 */ // Label 6553: @322755
     /* 322755 */ GIM_Reject,
     /* 322756 */ // Label 6543: @322756
     /* 322756 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(322793), // Rule ID 1275 //
     /* 322761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322782 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 322782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 322787 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322791 */   GIR_RootConstrainSelectedInstOperands,
     /* 322792 */   // GIR_Coverage, 1275,
     /* 322792 */   GIR_Done,
     /* 322793 */ // Label 6554: @322793
     /* 322793 */ GIM_Reject,
     /* 322794 */ // Label 6544: @322794
     /* 322794 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(322831), // Rule ID 1271 //
     /* 322799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322820 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 322820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 322825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322829 */   GIR_RootConstrainSelectedInstOperands,
     /* 322830 */   // GIR_Coverage, 1271,
     /* 322830 */   GIR_Done,
     /* 322831 */ // Label 6555: @322831
     /* 322831 */ GIM_Reject,
     /* 322832 */ // Label 6545: @322832
     /* 322832 */ GIM_Reject,
     /* 322833 */ // Label 74: @322833
     /* 322833 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6564*/ GIMT_Encode4(323210),
     /* 322844 */ /*GILLT_s16*//*Label 6556*/ GIMT_Encode4(322884),
     /* 322848 */ /*GILLT_s32*//*Label 6557*/ GIMT_Encode4(322922),
     /* 322852 */ /*GILLT_s64*//*Label 6558*/ GIMT_Encode4(322960), GIMT_Encode4(0),
     /* 322860 */ /*GILLT_v2s32*//*Label 6559*/ GIMT_Encode4(323020),
     /* 322864 */ /*GILLT_v2s64*//*Label 6560*/ GIMT_Encode4(323058),
     /* 322868 */ /*GILLT_v4s16*//*Label 6561*/ GIMT_Encode4(323096),
     /* 322872 */ /*GILLT_v4s32*//*Label 6562*/ GIMT_Encode4(323134), GIMT_Encode4(0),
     /* 322880 */ /*GILLT_v8s16*//*Label 6563*/ GIMT_Encode4(323172),
     /* 322884 */ // Label 6556: @322884
     /* 322884 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(322921), // Rule ID 596 //
     /* 322889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 322898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322910 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 322910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 322915 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322919 */   GIR_RootConstrainSelectedInstOperands,
     /* 322920 */   // GIR_Coverage, 596,
     /* 322920 */   GIR_Done,
     /* 322921 */ // Label 6565: @322921
     /* 322921 */ GIM_Reject,
     /* 322922 */ // Label 6557: @322922
     /* 322922 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(322959), // Rule ID 598 //
     /* 322927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 322936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322948 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 322948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 322953 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322957 */   GIR_RootConstrainSelectedInstOperands,
     /* 322958 */   // GIR_Coverage, 598,
     /* 322958 */   GIR_Done,
     /* 322959 */ // Label 6566: @322959
     /* 322959 */ GIM_Reject,
     /* 322960 */ // Label 6558: @322960
     /* 322960 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(323019),
     /* 322965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322983 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(323002), // Rule ID 600 //
     /* 322988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322991 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 322991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 322996 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323000 */     GIR_RootConstrainSelectedInstOperands,
     /* 323001 */     // GIR_Coverage, 600,
     /* 323001 */     GIR_Done,
     /* 323002 */   // Label 6568: @323002
     /* 323002 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(323018), // Rule ID 4813 //
     /* 323007 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 323007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 323012 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323016 */     GIR_RootConstrainSelectedInstOperands,
     /* 323017 */     // GIR_Coverage, 4813,
     /* 323017 */     GIR_Done,
     /* 323018 */   // Label 6569: @323018
     /* 323018 */   GIM_Reject,
     /* 323019 */ // Label 6567: @323019
     /* 323019 */ GIM_Reject,
     /* 323020 */ // Label 6559: @323020
     /* 323020 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(323057), // Rule ID 1243 //
     /* 323025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323046 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 323051 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323055 */   GIR_RootConstrainSelectedInstOperands,
     /* 323056 */   // GIR_Coverage, 1243,
     /* 323056 */   GIR_Done,
     /* 323057 */ // Label 6570: @323057
     /* 323057 */ GIM_Reject,
     /* 323058 */ // Label 6560: @323058
     /* 323058 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(323095), // Rule ID 1247 //
     /* 323063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323084 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 323089 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323093 */   GIR_RootConstrainSelectedInstOperands,
     /* 323094 */   // GIR_Coverage, 1247,
     /* 323094 */   GIR_Done,
     /* 323095 */ // Label 6571: @323095
     /* 323095 */ GIM_Reject,
     /* 323096 */ // Label 6561: @323096
     /* 323096 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(323133), // Rule ID 1239 //
     /* 323101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323122 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 323127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323131 */   GIR_RootConstrainSelectedInstOperands,
     /* 323132 */   // GIR_Coverage, 1239,
     /* 323132 */   GIR_Done,
     /* 323133 */ // Label 6572: @323133
     /* 323133 */ GIM_Reject,
     /* 323134 */ // Label 6562: @323134
     /* 323134 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(323171), // Rule ID 1245 //
     /* 323139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323160 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 323165 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323169 */   GIR_RootConstrainSelectedInstOperands,
     /* 323170 */   // GIR_Coverage, 1245,
     /* 323170 */   GIR_Done,
     /* 323171 */ // Label 6573: @323171
     /* 323171 */ GIM_Reject,
     /* 323172 */ // Label 6563: @323172
     /* 323172 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(323209), // Rule ID 1241 //
     /* 323177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323198 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 323203 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323207 */   GIR_RootConstrainSelectedInstOperands,
     /* 323208 */   // GIR_Coverage, 1241,
     /* 323208 */   GIR_Done,
     /* 323209 */ // Label 6574: @323209
     /* 323209 */ GIM_Reject,
     /* 323210 */ // Label 6564: @323210
     /* 323210 */ GIM_Reject,
     /* 323211 */ // Label 75: @323211
     /* 323211 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6583*/ GIMT_Encode4(323560),
     /* 323222 */ /*GILLT_s16*//*Label 6575*/ GIMT_Encode4(323262),
     /* 323226 */ /*GILLT_s32*//*Label 6576*/ GIMT_Encode4(323300),
     /* 323230 */ /*GILLT_s64*//*Label 6577*/ GIMT_Encode4(323335), GIMT_Encode4(0),
     /* 323238 */ /*GILLT_v2s32*//*Label 6578*/ GIMT_Encode4(323370),
     /* 323242 */ /*GILLT_v2s64*//*Label 6579*/ GIMT_Encode4(323408),
     /* 323246 */ /*GILLT_v4s16*//*Label 6580*/ GIMT_Encode4(323446),
     /* 323250 */ /*GILLT_v4s32*//*Label 6581*/ GIMT_Encode4(323484), GIMT_Encode4(0),
     /* 323258 */ /*GILLT_v8s16*//*Label 6582*/ GIMT_Encode4(323522),
     /* 323262 */ // Label 6575: @323262
     /* 323262 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(323299), // Rule ID 4821 //
     /* 323267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323288 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 323288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 323293 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323297 */   GIR_RootConstrainSelectedInstOperands,
     /* 323298 */   // GIR_Coverage, 4821,
     /* 323298 */   GIR_Done,
     /* 323299 */ // Label 6584: @323299
     /* 323299 */ GIM_Reject,
     /* 323300 */ // Label 6576: @323300
     /* 323300 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(323334), // Rule ID 4818 //
     /* 323305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323323 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 323323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 323328 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323332 */   GIR_RootConstrainSelectedInstOperands,
     /* 323333 */   // GIR_Coverage, 4818,
     /* 323333 */   GIR_Done,
     /* 323334 */ // Label 6585: @323334
     /* 323334 */ GIM_Reject,
     /* 323335 */ // Label 6577: @323335
     /* 323335 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(323369), // Rule ID 4815 //
     /* 323340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323358 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 323358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 323363 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323367 */   GIR_RootConstrainSelectedInstOperands,
     /* 323368 */   // GIR_Coverage, 4815,
     /* 323368 */   GIR_Done,
     /* 323369 */ // Label 6586: @323369
     /* 323369 */ GIM_Reject,
     /* 323370 */ // Label 6578: @323370
     /* 323370 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(323407), // Rule ID 5012 //
     /* 323375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323396 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 323401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323405 */   GIR_RootConstrainSelectedInstOperands,
     /* 323406 */   // GIR_Coverage, 5012,
     /* 323406 */   GIR_Done,
     /* 323407 */ // Label 6587: @323407
     /* 323407 */ GIM_Reject,
     /* 323408 */ // Label 6579: @323408
     /* 323408 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(323445), // Rule ID 5006 //
     /* 323413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323434 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 323439 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323443 */   GIR_RootConstrainSelectedInstOperands,
     /* 323444 */   // GIR_Coverage, 5006,
     /* 323444 */   GIR_Done,
     /* 323445 */ // Label 6588: @323445
     /* 323445 */ GIM_Reject,
     /* 323446 */ // Label 6580: @323446
     /* 323446 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(323483), // Rule ID 5018 //
     /* 323451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323472 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 323477 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323481 */   GIR_RootConstrainSelectedInstOperands,
     /* 323482 */   // GIR_Coverage, 5018,
     /* 323482 */   GIR_Done,
     /* 323483 */ // Label 6589: @323483
     /* 323483 */ GIM_Reject,
     /* 323484 */ // Label 6581: @323484
     /* 323484 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(323521), // Rule ID 5009 //
     /* 323489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323510 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 323515 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323519 */   GIR_RootConstrainSelectedInstOperands,
     /* 323520 */   // GIR_Coverage, 5009,
     /* 323520 */   GIR_Done,
     /* 323521 */ // Label 6590: @323521
     /* 323521 */ GIM_Reject,
     /* 323522 */ // Label 6582: @323522
     /* 323522 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(323559), // Rule ID 5015 //
     /* 323527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323548 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 323553 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323557 */   GIR_RootConstrainSelectedInstOperands,
     /* 323558 */   // GIR_Coverage, 5015,
     /* 323558 */   GIR_Done,
     /* 323559 */ // Label 6591: @323559
     /* 323559 */ GIM_Reject,
     /* 323560 */ // Label 6583: @323560
     /* 323560 */ GIM_Reject,
     /* 323561 */ // Label 76: @323561
     /* 323561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6600*/ GIMT_Encode4(323910),
     /* 323572 */ /*GILLT_s16*//*Label 6592*/ GIMT_Encode4(323612),
     /* 323576 */ /*GILLT_s32*//*Label 6593*/ GIMT_Encode4(323650),
     /* 323580 */ /*GILLT_s64*//*Label 6594*/ GIMT_Encode4(323685), GIMT_Encode4(0),
     /* 323588 */ /*GILLT_v2s32*//*Label 6595*/ GIMT_Encode4(323720),
     /* 323592 */ /*GILLT_v2s64*//*Label 6596*/ GIMT_Encode4(323758),
     /* 323596 */ /*GILLT_v4s16*//*Label 6597*/ GIMT_Encode4(323796),
     /* 323600 */ /*GILLT_v4s32*//*Label 6598*/ GIMT_Encode4(323834), GIMT_Encode4(0),
     /* 323608 */ /*GILLT_v8s16*//*Label 6599*/ GIMT_Encode4(323872),
     /* 323612 */ // Label 6592: @323612
     /* 323612 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(323649), // Rule ID 4822 //
     /* 323617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323638 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 323638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 323643 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323647 */   GIR_RootConstrainSelectedInstOperands,
     /* 323648 */   // GIR_Coverage, 4822,
     /* 323648 */   GIR_Done,
     /* 323649 */ // Label 6601: @323649
     /* 323649 */ GIM_Reject,
     /* 323650 */ // Label 6593: @323650
     /* 323650 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(323684), // Rule ID 4819 //
     /* 323655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323673 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 323673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 323678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323682 */   GIR_RootConstrainSelectedInstOperands,
     /* 323683 */   // GIR_Coverage, 4819,
     /* 323683 */   GIR_Done,
     /* 323684 */ // Label 6602: @323684
     /* 323684 */ GIM_Reject,
     /* 323685 */ // Label 6594: @323685
     /* 323685 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(323719), // Rule ID 4816 //
     /* 323690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323708 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 323708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 323713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323717 */   GIR_RootConstrainSelectedInstOperands,
     /* 323718 */   // GIR_Coverage, 4816,
     /* 323718 */   GIR_Done,
     /* 323719 */ // Label 6603: @323719
     /* 323719 */ GIM_Reject,
     /* 323720 */ // Label 6595: @323720
     /* 323720 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(323757), // Rule ID 5013 //
     /* 323725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323746 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 323751 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323755 */   GIR_RootConstrainSelectedInstOperands,
     /* 323756 */   // GIR_Coverage, 5013,
     /* 323756 */   GIR_Done,
     /* 323757 */ // Label 6604: @323757
     /* 323757 */ GIM_Reject,
     /* 323758 */ // Label 6596: @323758
     /* 323758 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(323795), // Rule ID 5007 //
     /* 323763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323784 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 323789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323793 */   GIR_RootConstrainSelectedInstOperands,
     /* 323794 */   // GIR_Coverage, 5007,
     /* 323794 */   GIR_Done,
     /* 323795 */ // Label 6605: @323795
     /* 323795 */ GIM_Reject,
     /* 323796 */ // Label 6597: @323796
     /* 323796 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(323833), // Rule ID 5019 //
     /* 323801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323822 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 323827 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323831 */   GIR_RootConstrainSelectedInstOperands,
     /* 323832 */   // GIR_Coverage, 5019,
     /* 323832 */   GIR_Done,
     /* 323833 */ // Label 6606: @323833
     /* 323833 */ GIM_Reject,
     /* 323834 */ // Label 6598: @323834
     /* 323834 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(323871), // Rule ID 5010 //
     /* 323839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323860 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 323865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323869 */   GIR_RootConstrainSelectedInstOperands,
     /* 323870 */   // GIR_Coverage, 5010,
     /* 323870 */   GIR_Done,
     /* 323871 */ // Label 6607: @323871
     /* 323871 */ GIM_Reject,
     /* 323872 */ // Label 6599: @323872
     /* 323872 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(323909), // Rule ID 5016 //
     /* 323877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323898 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 323903 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323907 */   GIR_RootConstrainSelectedInstOperands,
     /* 323908 */   // GIR_Coverage, 5016,
     /* 323908 */   GIR_Done,
     /* 323909 */ // Label 6608: @323909
     /* 323909 */ GIM_Reject,
     /* 323910 */ // Label 6600: @323910
     /* 323910 */ GIM_Reject,
     /* 323911 */ // Label 77: @323911
     /* 323911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6617*/ GIMT_Encode4(324613),
     /* 323922 */ /*GILLT_s16*//*Label 6609*/ GIMT_Encode4(323962),
     /* 323926 */ /*GILLT_s32*//*Label 6610*/ GIMT_Encode4(324000),
     /* 323930 */ /*GILLT_s64*//*Label 6611*/ GIMT_Encode4(324038), GIMT_Encode4(0),
     /* 323938 */ /*GILLT_v2s32*//*Label 6612*/ GIMT_Encode4(324098),
     /* 323942 */ /*GILLT_v2s64*//*Label 6613*/ GIMT_Encode4(324201),
     /* 323946 */ /*GILLT_v4s16*//*Label 6614*/ GIMT_Encode4(324304),
     /* 323950 */ /*GILLT_v4s32*//*Label 6615*/ GIMT_Encode4(324407), GIMT_Encode4(0),
     /* 323958 */ /*GILLT_v8s16*//*Label 6616*/ GIMT_Encode4(324510),
     /* 323962 */ // Label 6609: @323962
     /* 323962 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(323999), // Rule ID 614 //
     /* 323967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323988 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 323988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 323993 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323997 */   GIR_RootConstrainSelectedInstOperands,
     /* 323998 */   // GIR_Coverage, 614,
     /* 323998 */   GIR_Done,
     /* 323999 */ // Label 6618: @323999
     /* 323999 */ GIM_Reject,
     /* 324000 */ // Label 6610: @324000
     /* 324000 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(324037), // Rule ID 616 //
     /* 324005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324026 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 324031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324035 */   GIR_RootConstrainSelectedInstOperands,
     /* 324036 */   // GIR_Coverage, 616,
     /* 324036 */   GIR_Done,
     /* 324037 */ // Label 6619: @324037
     /* 324037 */ GIM_Reject,
     /* 324038 */ // Label 6611: @324038
     /* 324038 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(324097),
     /* 324043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324061 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(324080), // Rule ID 618 //
     /* 324066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324069 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 324074 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324078 */     GIR_RootConstrainSelectedInstOperands,
     /* 324079 */     // GIR_Coverage, 618,
     /* 324079 */     GIR_Done,
     /* 324080 */   // Label 6621: @324080
     /* 324080 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(324096), // Rule ID 4812 //
     /* 324085 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 324085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 324090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324094 */     GIR_RootConstrainSelectedInstOperands,
     /* 324095 */     // GIR_Coverage, 4812,
     /* 324095 */     GIR_Done,
     /* 324096 */   // Label 6622: @324096
     /* 324096 */   GIM_Reject,
     /* 324097 */ // Label 6620: @324097
     /* 324097 */ GIM_Reject,
     /* 324098 */ // Label 6612: @324098
     /* 324098 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(324200),
     /* 324103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324113 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(324172), // Rule ID 2366 //
     /* 324118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324157 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 324160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324170 */     GIR_RootConstrainSelectedInstOperands,
     /* 324171 */     // GIR_Coverage, 2366,
     /* 324171 */     GIR_EraseRootFromParent_Done,
     /* 324172 */   // Label 6624: @324172
     /* 324172 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(324199), // Rule ID 1288 //
     /* 324177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324188 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 324193 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324197 */     GIR_RootConstrainSelectedInstOperands,
     /* 324198 */     // GIR_Coverage, 1288,
     /* 324198 */     GIR_Done,
     /* 324199 */   // Label 6625: @324199
     /* 324199 */   GIM_Reject,
     /* 324200 */ // Label 6623: @324200
     /* 324200 */ GIM_Reject,
     /* 324201 */ // Label 6613: @324201
     /* 324201 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(324303),
     /* 324206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324216 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(324275), // Rule ID 2372 //
     /* 324221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324260 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 324263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324273 */     GIR_RootConstrainSelectedInstOperands,
     /* 324274 */     // GIR_Coverage, 2372,
     /* 324274 */     GIR_EraseRootFromParent_Done,
     /* 324275 */   // Label 6627: @324275
     /* 324275 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(324302), // Rule ID 1292 //
     /* 324280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324291 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 324296 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324300 */     GIR_RootConstrainSelectedInstOperands,
     /* 324301 */     // GIR_Coverage, 1292,
     /* 324301 */     GIR_Done,
     /* 324302 */   // Label 6628: @324302
     /* 324302 */   GIM_Reject,
     /* 324303 */ // Label 6626: @324303
     /* 324303 */ GIM_Reject,
     /* 324304 */ // Label 6614: @324304
     /* 324304 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(324406),
     /* 324309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324319 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(324378), // Rule ID 2360 //
     /* 324324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324363 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 324366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324376 */     GIR_RootConstrainSelectedInstOperands,
     /* 324377 */     // GIR_Coverage, 2360,
     /* 324377 */     GIR_EraseRootFromParent_Done,
     /* 324378 */   // Label 6630: @324378
     /* 324378 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(324405), // Rule ID 1284 //
     /* 324383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324394 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 324399 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324403 */     GIR_RootConstrainSelectedInstOperands,
     /* 324404 */     // GIR_Coverage, 1284,
     /* 324404 */     GIR_Done,
     /* 324405 */   // Label 6631: @324405
     /* 324405 */   GIM_Reject,
     /* 324406 */ // Label 6629: @324406
     /* 324406 */ GIM_Reject,
     /* 324407 */ // Label 6615: @324407
     /* 324407 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(324509),
     /* 324412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324422 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(324481), // Rule ID 2369 //
     /* 324427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324466 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 324469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324479 */     GIR_RootConstrainSelectedInstOperands,
     /* 324480 */     // GIR_Coverage, 2369,
     /* 324480 */     GIR_EraseRootFromParent_Done,
     /* 324481 */   // Label 6633: @324481
     /* 324481 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(324508), // Rule ID 1290 //
     /* 324486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324497 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 324502 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324506 */     GIR_RootConstrainSelectedInstOperands,
     /* 324507 */     // GIR_Coverage, 1290,
     /* 324507 */     GIR_Done,
     /* 324508 */   // Label 6634: @324508
     /* 324508 */   GIM_Reject,
     /* 324509 */ // Label 6632: @324509
     /* 324509 */ GIM_Reject,
     /* 324510 */ // Label 6616: @324510
     /* 324510 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(324612),
     /* 324515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324525 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(324584), // Rule ID 2363 //
     /* 324530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324569 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 324572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324582 */     GIR_RootConstrainSelectedInstOperands,
     /* 324583 */     // GIR_Coverage, 2363,
     /* 324583 */     GIR_EraseRootFromParent_Done,
     /* 324584 */   // Label 6636: @324584
     /* 324584 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(324611), // Rule ID 1286 //
     /* 324589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324600 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 324605 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324609 */     GIR_RootConstrainSelectedInstOperands,
     /* 324610 */     // GIR_Coverage, 1286,
     /* 324610 */     GIR_Done,
     /* 324611 */   // Label 6637: @324611
     /* 324611 */   GIM_Reject,
     /* 324612 */ // Label 6635: @324612
     /* 324612 */ GIM_Reject,
     /* 324613 */ // Label 6617: @324613
     /* 324613 */ GIM_Reject,
     /* 324614 */ // Label 78: @324614
     /* 324614 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6646*/ GIMT_Encode4(325316),
     /* 324625 */ /*GILLT_s16*//*Label 6638*/ GIMT_Encode4(324665),
     /* 324629 */ /*GILLT_s32*//*Label 6639*/ GIMT_Encode4(324703),
     /* 324633 */ /*GILLT_s64*//*Label 6640*/ GIMT_Encode4(324741), GIMT_Encode4(0),
     /* 324641 */ /*GILLT_v2s32*//*Label 6641*/ GIMT_Encode4(324801),
     /* 324645 */ /*GILLT_v2s64*//*Label 6642*/ GIMT_Encode4(324904),
     /* 324649 */ /*GILLT_v4s16*//*Label 6643*/ GIMT_Encode4(325007),
     /* 324653 */ /*GILLT_v4s32*//*Label 6644*/ GIMT_Encode4(325110), GIMT_Encode4(0),
     /* 324661 */ /*GILLT_v8s16*//*Label 6645*/ GIMT_Encode4(325213),
     /* 324665 */ // Label 6638: @324665
     /* 324665 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(324702), // Rule ID 602 //
     /* 324670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324691 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 324696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324700 */   GIR_RootConstrainSelectedInstOperands,
     /* 324701 */   // GIR_Coverage, 602,
     /* 324701 */   GIR_Done,
     /* 324702 */ // Label 6647: @324702
     /* 324702 */ GIM_Reject,
     /* 324703 */ // Label 6639: @324703
     /* 324703 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(324740), // Rule ID 604 //
     /* 324708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324729 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 324734 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324738 */   GIR_RootConstrainSelectedInstOperands,
     /* 324739 */   // GIR_Coverage, 604,
     /* 324739 */   GIR_Done,
     /* 324740 */ // Label 6648: @324740
     /* 324740 */ GIM_Reject,
     /* 324741 */ // Label 6640: @324741
     /* 324741 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(324800),
     /* 324746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324764 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(324783), // Rule ID 606 //
     /* 324769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324772 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 324777 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324781 */     GIR_RootConstrainSelectedInstOperands,
     /* 324782 */     // GIR_Coverage, 606,
     /* 324782 */     GIR_Done,
     /* 324783 */   // Label 6650: @324783
     /* 324783 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(324799), // Rule ID 4811 //
     /* 324788 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 324788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 324793 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324797 */     GIR_RootConstrainSelectedInstOperands,
     /* 324798 */     // GIR_Coverage, 4811,
     /* 324798 */     GIR_Done,
     /* 324799 */   // Label 6651: @324799
     /* 324799 */   GIM_Reject,
     /* 324800 */ // Label 6649: @324800
     /* 324800 */ GIM_Reject,
     /* 324801 */ // Label 6641: @324801
     /* 324801 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(324903),
     /* 324806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324816 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(324875), // Rule ID 2351 //
     /* 324821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324860 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 324863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324873 */     GIR_RootConstrainSelectedInstOperands,
     /* 324874 */     // GIR_Coverage, 2351,
     /* 324874 */     GIR_EraseRootFromParent_Done,
     /* 324875 */   // Label 6653: @324875
     /* 324875 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(324902), // Rule ID 1258 //
     /* 324880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324891 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 324896 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324900 */     GIR_RootConstrainSelectedInstOperands,
     /* 324901 */     // GIR_Coverage, 1258,
     /* 324901 */     GIR_Done,
     /* 324902 */   // Label 6654: @324902
     /* 324902 */   GIM_Reject,
     /* 324903 */ // Label 6652: @324903
     /* 324903 */ GIM_Reject,
     /* 324904 */ // Label 6642: @324904
     /* 324904 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(325006),
     /* 324909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324919 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(324978), // Rule ID 2357 //
     /* 324924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324963 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 324966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324976 */     GIR_RootConstrainSelectedInstOperands,
     /* 324977 */     // GIR_Coverage, 2357,
     /* 324977 */     GIR_EraseRootFromParent_Done,
     /* 324978 */   // Label 6656: @324978
     /* 324978 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(325005), // Rule ID 1262 //
     /* 324983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324994 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 324999 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325003 */     GIR_RootConstrainSelectedInstOperands,
     /* 325004 */     // GIR_Coverage, 1262,
     /* 325004 */     GIR_Done,
     /* 325005 */   // Label 6657: @325005
     /* 325005 */   GIM_Reject,
     /* 325006 */ // Label 6655: @325006
     /* 325006 */ GIM_Reject,
     /* 325007 */ // Label 6643: @325007
     /* 325007 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(325109),
     /* 325012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325022 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(325081), // Rule ID 2345 //
     /* 325027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325066 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 325069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325079 */     GIR_RootConstrainSelectedInstOperands,
     /* 325080 */     // GIR_Coverage, 2345,
     /* 325080 */     GIR_EraseRootFromParent_Done,
     /* 325081 */   // Label 6659: @325081
     /* 325081 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(325108), // Rule ID 1254 //
     /* 325086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325097 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 325102 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325106 */     GIR_RootConstrainSelectedInstOperands,
     /* 325107 */     // GIR_Coverage, 1254,
     /* 325107 */     GIR_Done,
     /* 325108 */   // Label 6660: @325108
     /* 325108 */   GIM_Reject,
     /* 325109 */ // Label 6658: @325109
     /* 325109 */ GIM_Reject,
     /* 325110 */ // Label 6644: @325110
     /* 325110 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(325212),
     /* 325115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325125 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(325184), // Rule ID 2354 //
     /* 325130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325169 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 325172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325182 */     GIR_RootConstrainSelectedInstOperands,
     /* 325183 */     // GIR_Coverage, 2354,
     /* 325183 */     GIR_EraseRootFromParent_Done,
     /* 325184 */   // Label 6662: @325184
     /* 325184 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(325211), // Rule ID 1260 //
     /* 325189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325200 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 325205 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325209 */     GIR_RootConstrainSelectedInstOperands,
     /* 325210 */     // GIR_Coverage, 1260,
     /* 325210 */     GIR_Done,
     /* 325211 */   // Label 6663: @325211
     /* 325211 */   GIM_Reject,
     /* 325212 */ // Label 6661: @325212
     /* 325212 */ GIM_Reject,
     /* 325213 */ // Label 6645: @325213
     /* 325213 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(325315),
     /* 325218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325228 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(325287), // Rule ID 2348 //
     /* 325233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325272 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 325275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325285 */     GIR_RootConstrainSelectedInstOperands,
     /* 325286 */     // GIR_Coverage, 2348,
     /* 325286 */     GIR_EraseRootFromParent_Done,
     /* 325287 */   // Label 6665: @325287
     /* 325287 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(325314), // Rule ID 1256 //
     /* 325292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325303 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 325308 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325312 */     GIR_RootConstrainSelectedInstOperands,
     /* 325313 */     // GIR_Coverage, 1256,
     /* 325313 */     GIR_Done,
     /* 325314 */   // Label 6666: @325314
     /* 325314 */   GIM_Reject,
     /* 325315 */ // Label 6664: @325315
     /* 325315 */ GIM_Reject,
     /* 325316 */ // Label 6646: @325316
     /* 325316 */ GIM_Reject,
     /* 325317 */ // Label 79: @325317
     /* 325317 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6675*/ GIMT_Encode4(325720),
     /* 325328 */ /*GILLT_s32*//*Label 6667*/ GIMT_Encode4(325368),
     /* 325332 */ /*GILLT_s64*//*Label 6668*/ GIMT_Encode4(325442), GIMT_Encode4(0),
     /* 325340 */ /*GILLT_v2s32*//*Label 6669*/ GIMT_Encode4(325516), GIMT_Encode4(0),
     /* 325348 */ /*GILLT_v4s16*//*Label 6670*/ GIMT_Encode4(325550),
     /* 325352 */ /*GILLT_v4s32*//*Label 6671*/ GIMT_Encode4(325584),
     /* 325356 */ /*GILLT_v8s8*//*Label 6672*/ GIMT_Encode4(325618),
     /* 325360 */ /*GILLT_v8s16*//*Label 6673*/ GIMT_Encode4(325652),
     /* 325364 */ /*GILLT_v16s8*//*Label 6674*/ GIMT_Encode4(325686),
     /* 325368 */ // Label 6667: @325368
     /* 325368 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(325441),
     /* 325373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325387 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(325421), // Rule ID 2328 //
     /* 325392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 325407 */     // MIs[1] Operand 1
     /* 325407 */     // No operand predicates
     /* 325407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325409 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 325409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 325412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325419 */     GIR_RootConstrainSelectedInstOperands,
     /* 325420 */     // GIR_Coverage, 2328,
     /* 325420 */     GIR_EraseRootFromParent_Done,
     /* 325421 */   // Label 6677: @325421
     /* 325421 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(325440), // Rule ID 2327 //
     /* 325426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325433 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 325433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 325438 */     GIR_RootConstrainSelectedInstOperands,
     /* 325439 */     // GIR_Coverage, 2327,
     /* 325439 */     GIR_Done,
     /* 325440 */   // Label 6678: @325440
     /* 325440 */   GIM_Reject,
     /* 325441 */ // Label 6676: @325441
     /* 325441 */ GIM_Reject,
     /* 325442 */ // Label 6668: @325442
     /* 325442 */ GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(325515),
     /* 325447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325461 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(325495), // Rule ID 2330 //
     /* 325466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 325481 */     // MIs[1] Operand 1
     /* 325481 */     // No operand predicates
     /* 325481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325483 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 325483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 325486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325493 */     GIR_RootConstrainSelectedInstOperands,
     /* 325494 */     // GIR_Coverage, 2330,
     /* 325494 */     GIR_EraseRootFromParent_Done,
     /* 325495 */   // Label 6680: @325495
     /* 325495 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(325514), // Rule ID 2329 //
     /* 325500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325507 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 325507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 325512 */     GIR_RootConstrainSelectedInstOperands,
     /* 325513 */     // GIR_Coverage, 2329,
     /* 325513 */     GIR_Done,
     /* 325514 */   // Label 6681: @325514
     /* 325514 */   GIM_Reject,
     /* 325515 */ // Label 6679: @325515
     /* 325515 */ GIM_Reject,
     /* 325516 */ // Label 6669: @325516
     /* 325516 */ GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(325549), // Rule ID 1414 //
     /* 325521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325542 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 325542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 325547 */   GIR_RootConstrainSelectedInstOperands,
     /* 325548 */   // GIR_Coverage, 1414,
     /* 325548 */   GIR_Done,
     /* 325549 */ // Label 6682: @325549
     /* 325549 */ GIM_Reject,
     /* 325550 */ // Label 6670: @325550
     /* 325550 */ GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(325583), // Rule ID 1412 //
     /* 325555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325576 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 325576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 325581 */   GIR_RootConstrainSelectedInstOperands,
     /* 325582 */   // GIR_Coverage, 1412,
     /* 325582 */   GIR_Done,
     /* 325583 */ // Label 6683: @325583
     /* 325583 */ GIM_Reject,
     /* 325584 */ // Label 6671: @325584
     /* 325584 */ GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(325617), // Rule ID 1415 //
     /* 325589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325610 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 325610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 325615 */   GIR_RootConstrainSelectedInstOperands,
     /* 325616 */   // GIR_Coverage, 1415,
     /* 325616 */   GIR_Done,
     /* 325617 */ // Label 6684: @325617
     /* 325617 */ GIM_Reject,
     /* 325618 */ // Label 6672: @325618
     /* 325618 */ GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(325651), // Rule ID 1410 //
     /* 325623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 325629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 325632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325644 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 325644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 325649 */   GIR_RootConstrainSelectedInstOperands,
     /* 325650 */   // GIR_Coverage, 1410,
     /* 325650 */   GIR_Done,
     /* 325651 */ // Label 6685: @325651
     /* 325651 */ GIM_Reject,
     /* 325652 */ // Label 6673: @325652
     /* 325652 */ GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(325685), // Rule ID 1413 //
     /* 325657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325678 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 325678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 325683 */   GIR_RootConstrainSelectedInstOperands,
     /* 325684 */   // GIR_Coverage, 1413,
     /* 325684 */   GIR_Done,
     /* 325685 */ // Label 6686: @325685
     /* 325685 */ GIM_Reject,
     /* 325686 */ // Label 6674: @325686
     /* 325686 */ GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(325719), // Rule ID 1411 //
     /* 325691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 325697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 325700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325712 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 325712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 325717 */   GIR_RootConstrainSelectedInstOperands,
     /* 325718 */   // GIR_Coverage, 1411,
     /* 325718 */   GIR_Done,
     /* 325719 */ // Label 6687: @325719
     /* 325719 */ GIM_Reject,
     /* 325720 */ // Label 6675: @325720
     /* 325720 */ GIM_Reject,
     /* 325721 */ // Label 80: @325721
     /* 325721 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6696*/ GIMT_Encode4(326124),
     /* 325732 */ /*GILLT_s32*//*Label 6688*/ GIMT_Encode4(325772),
     /* 325736 */ /*GILLT_s64*//*Label 6689*/ GIMT_Encode4(325846), GIMT_Encode4(0),
     /* 325744 */ /*GILLT_v2s32*//*Label 6690*/ GIMT_Encode4(325920), GIMT_Encode4(0),
     /* 325752 */ /*GILLT_v4s16*//*Label 6691*/ GIMT_Encode4(325954),
     /* 325756 */ /*GILLT_v4s32*//*Label 6692*/ GIMT_Encode4(325988),
     /* 325760 */ /*GILLT_v8s8*//*Label 6693*/ GIMT_Encode4(326022),
     /* 325764 */ /*GILLT_v8s16*//*Label 6694*/ GIMT_Encode4(326056),
     /* 325768 */ /*GILLT_v16s8*//*Label 6695*/ GIMT_Encode4(326090),
     /* 325772 */ // Label 6688: @325772
     /* 325772 */ GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(325845),
     /* 325777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325791 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(325825), // Rule ID 2324 //
     /* 325796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 325811 */     // MIs[1] Operand 1
     /* 325811 */     // No operand predicates
     /* 325811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325813 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 325813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 325816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325823 */     GIR_RootConstrainSelectedInstOperands,
     /* 325824 */     // GIR_Coverage, 2324,
     /* 325824 */     GIR_EraseRootFromParent_Done,
     /* 325825 */   // Label 6698: @325825
     /* 325825 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(325844), // Rule ID 2323 //
     /* 325830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325837 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 325837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 325842 */     GIR_RootConstrainSelectedInstOperands,
     /* 325843 */     // GIR_Coverage, 2323,
     /* 325843 */     GIR_Done,
     /* 325844 */   // Label 6699: @325844
     /* 325844 */   GIM_Reject,
     /* 325845 */ // Label 6697: @325845
     /* 325845 */ GIM_Reject,
     /* 325846 */ // Label 6689: @325846
     /* 325846 */ GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(325919),
     /* 325851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325865 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(325899), // Rule ID 2326 //
     /* 325870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 325885 */     // MIs[1] Operand 1
     /* 325885 */     // No operand predicates
     /* 325885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325887 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 325887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 325890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325897 */     GIR_RootConstrainSelectedInstOperands,
     /* 325898 */     // GIR_Coverage, 2326,
     /* 325898 */     GIR_EraseRootFromParent_Done,
     /* 325899 */   // Label 6701: @325899
     /* 325899 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(325918), // Rule ID 2325 //
     /* 325904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325911 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 325911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 325916 */     GIR_RootConstrainSelectedInstOperands,
     /* 325917 */     // GIR_Coverage, 2325,
     /* 325917 */     GIR_Done,
     /* 325918 */   // Label 6702: @325918
     /* 325918 */   GIM_Reject,
     /* 325919 */ // Label 6700: @325919
     /* 325919 */ GIM_Reject,
     /* 325920 */ // Label 6690: @325920
     /* 325920 */ GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(325953), // Rule ID 1402 //
     /* 325925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325946 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 325946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 325951 */   GIR_RootConstrainSelectedInstOperands,
     /* 325952 */   // GIR_Coverage, 1402,
     /* 325952 */   GIR_Done,
     /* 325953 */ // Label 6703: @325953
     /* 325953 */ GIM_Reject,
     /* 325954 */ // Label 6691: @325954
     /* 325954 */ GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(325987), // Rule ID 1400 //
     /* 325959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325980 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 325980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 325985 */   GIR_RootConstrainSelectedInstOperands,
     /* 325986 */   // GIR_Coverage, 1400,
     /* 325986 */   GIR_Done,
     /* 325987 */ // Label 6704: @325987
     /* 325987 */ GIM_Reject,
     /* 325988 */ // Label 6692: @325988
     /* 325988 */ GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(326021), // Rule ID 1403 //
     /* 325993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326014 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 326019 */   GIR_RootConstrainSelectedInstOperands,
     /* 326020 */   // GIR_Coverage, 1403,
     /* 326020 */   GIR_Done,
     /* 326021 */ // Label 6705: @326021
     /* 326021 */ GIM_Reject,
     /* 326022 */ // Label 6693: @326022
     /* 326022 */ GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(326055), // Rule ID 1398 //
     /* 326027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326048 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326048 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 326053 */   GIR_RootConstrainSelectedInstOperands,
     /* 326054 */   // GIR_Coverage, 1398,
     /* 326054 */   GIR_Done,
     /* 326055 */ // Label 6706: @326055
     /* 326055 */ GIM_Reject,
     /* 326056 */ // Label 6694: @326056
     /* 326056 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(326089), // Rule ID 1401 //
     /* 326061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326082 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 326087 */   GIR_RootConstrainSelectedInstOperands,
     /* 326088 */   // GIR_Coverage, 1401,
     /* 326088 */   GIR_Done,
     /* 326089 */ // Label 6707: @326089
     /* 326089 */ GIM_Reject,
     /* 326090 */ // Label 6695: @326090
     /* 326090 */ GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(326123), // Rule ID 1399 //
     /* 326095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326116 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 326121 */   GIR_RootConstrainSelectedInstOperands,
     /* 326122 */   // GIR_Coverage, 1399,
     /* 326122 */   GIR_Done,
     /* 326123 */ // Label 6708: @326123
     /* 326123 */ GIM_Reject,
     /* 326124 */ // Label 6696: @326124
     /* 326124 */ GIM_Reject,
     /* 326125 */ // Label 81: @326125
     /* 326125 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6717*/ GIMT_Encode4(326528),
     /* 326136 */ /*GILLT_s32*//*Label 6709*/ GIMT_Encode4(326176),
     /* 326140 */ /*GILLT_s64*//*Label 6710*/ GIMT_Encode4(326250), GIMT_Encode4(0),
     /* 326148 */ /*GILLT_v2s32*//*Label 6711*/ GIMT_Encode4(326324), GIMT_Encode4(0),
     /* 326156 */ /*GILLT_v4s16*//*Label 6712*/ GIMT_Encode4(326358),
     /* 326160 */ /*GILLT_v4s32*//*Label 6713*/ GIMT_Encode4(326392),
     /* 326164 */ /*GILLT_v8s8*//*Label 6714*/ GIMT_Encode4(326426),
     /* 326168 */ /*GILLT_v8s16*//*Label 6715*/ GIMT_Encode4(326460),
     /* 326172 */ /*GILLT_v16s8*//*Label 6716*/ GIMT_Encode4(326494),
     /* 326176 */ // Label 6709: @326176
     /* 326176 */ GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(326249),
     /* 326181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326195 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(326229), // Rule ID 2336 //
     /* 326200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 326215 */     // MIs[1] Operand 1
     /* 326215 */     // No operand predicates
     /* 326215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326217 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 326220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326227 */     GIR_RootConstrainSelectedInstOperands,
     /* 326228 */     // GIR_Coverage, 2336,
     /* 326228 */     GIR_EraseRootFromParent_Done,
     /* 326229 */   // Label 6719: @326229
     /* 326229 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(326248), // Rule ID 2335 //
     /* 326234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326241 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 326246 */     GIR_RootConstrainSelectedInstOperands,
     /* 326247 */     // GIR_Coverage, 2335,
     /* 326247 */     GIR_Done,
     /* 326248 */   // Label 6720: @326248
     /* 326248 */   GIM_Reject,
     /* 326249 */ // Label 6718: @326249
     /* 326249 */ GIM_Reject,
     /* 326250 */ // Label 6710: @326250
     /* 326250 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(326323),
     /* 326255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326269 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(326303), // Rule ID 2338 //
     /* 326274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 326289 */     // MIs[1] Operand 1
     /* 326289 */     // No operand predicates
     /* 326289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326291 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 326294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326301 */     GIR_RootConstrainSelectedInstOperands,
     /* 326302 */     // GIR_Coverage, 2338,
     /* 326302 */     GIR_EraseRootFromParent_Done,
     /* 326303 */   // Label 6722: @326303
     /* 326303 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(326322), // Rule ID 2337 //
     /* 326308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326315 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 326320 */     GIR_RootConstrainSelectedInstOperands,
     /* 326321 */     // GIR_Coverage, 2337,
     /* 326321 */     GIR_Done,
     /* 326322 */   // Label 6723: @326322
     /* 326322 */   GIM_Reject,
     /* 326323 */ // Label 6721: @326323
     /* 326323 */ GIM_Reject,
     /* 326324 */ // Label 6711: @326324
     /* 326324 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(326357), // Rule ID 1537 //
     /* 326329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326350 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 326355 */   GIR_RootConstrainSelectedInstOperands,
     /* 326356 */   // GIR_Coverage, 1537,
     /* 326356 */   GIR_Done,
     /* 326357 */ // Label 6724: @326357
     /* 326357 */ GIM_Reject,
     /* 326358 */ // Label 6712: @326358
     /* 326358 */ GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(326391), // Rule ID 1535 //
     /* 326363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326384 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 326389 */   GIR_RootConstrainSelectedInstOperands,
     /* 326390 */   // GIR_Coverage, 1535,
     /* 326390 */   GIR_Done,
     /* 326391 */ // Label 6725: @326391
     /* 326391 */ GIM_Reject,
     /* 326392 */ // Label 6713: @326392
     /* 326392 */ GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(326425), // Rule ID 1538 //
     /* 326397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326418 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 326423 */   GIR_RootConstrainSelectedInstOperands,
     /* 326424 */   // GIR_Coverage, 1538,
     /* 326424 */   GIR_Done,
     /* 326425 */ // Label 6726: @326425
     /* 326425 */ GIM_Reject,
     /* 326426 */ // Label 6714: @326426
     /* 326426 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(326459), // Rule ID 1533 //
     /* 326431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326452 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 326457 */   GIR_RootConstrainSelectedInstOperands,
     /* 326458 */   // GIR_Coverage, 1533,
     /* 326458 */   GIR_Done,
     /* 326459 */ // Label 6727: @326459
     /* 326459 */ GIM_Reject,
     /* 326460 */ // Label 6715: @326460
     /* 326460 */ GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(326493), // Rule ID 1536 //
     /* 326465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326486 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 326491 */   GIR_RootConstrainSelectedInstOperands,
     /* 326492 */   // GIR_Coverage, 1536,
     /* 326492 */   GIR_Done,
     /* 326493 */ // Label 6728: @326493
     /* 326493 */ GIM_Reject,
     /* 326494 */ // Label 6716: @326494
     /* 326494 */ GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(326527), // Rule ID 1534 //
     /* 326499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326520 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 326525 */   GIR_RootConstrainSelectedInstOperands,
     /* 326526 */   // GIR_Coverage, 1534,
     /* 326526 */   GIR_Done,
     /* 326527 */ // Label 6729: @326527
     /* 326527 */ GIM_Reject,
     /* 326528 */ // Label 6717: @326528
     /* 326528 */ GIM_Reject,
     /* 326529 */ // Label 82: @326529
     /* 326529 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6738*/ GIMT_Encode4(326932),
     /* 326540 */ /*GILLT_s32*//*Label 6730*/ GIMT_Encode4(326580),
     /* 326544 */ /*GILLT_s64*//*Label 6731*/ GIMT_Encode4(326654), GIMT_Encode4(0),
     /* 326552 */ /*GILLT_v2s32*//*Label 6732*/ GIMT_Encode4(326728), GIMT_Encode4(0),
     /* 326560 */ /*GILLT_v4s16*//*Label 6733*/ GIMT_Encode4(326762),
     /* 326564 */ /*GILLT_v4s32*//*Label 6734*/ GIMT_Encode4(326796),
     /* 326568 */ /*GILLT_v8s8*//*Label 6735*/ GIMT_Encode4(326830),
     /* 326572 */ /*GILLT_v8s16*//*Label 6736*/ GIMT_Encode4(326864),
     /* 326576 */ /*GILLT_v16s8*//*Label 6737*/ GIMT_Encode4(326898),
     /* 326580 */ // Label 6730: @326580
     /* 326580 */ GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(326653),
     /* 326585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326599 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(326633), // Rule ID 2332 //
     /* 326604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 326619 */     // MIs[1] Operand 1
     /* 326619 */     // No operand predicates
     /* 326619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326621 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 326624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326631 */     GIR_RootConstrainSelectedInstOperands,
     /* 326632 */     // GIR_Coverage, 2332,
     /* 326632 */     GIR_EraseRootFromParent_Done,
     /* 326633 */   // Label 6740: @326633
     /* 326633 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(326652), // Rule ID 2331 //
     /* 326638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326645 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 326650 */     GIR_RootConstrainSelectedInstOperands,
     /* 326651 */     // GIR_Coverage, 2331,
     /* 326651 */     GIR_Done,
     /* 326652 */   // Label 6741: @326652
     /* 326652 */   GIM_Reject,
     /* 326653 */ // Label 6739: @326653
     /* 326653 */ GIM_Reject,
     /* 326654 */ // Label 6731: @326654
     /* 326654 */ GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(326727),
     /* 326659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326673 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(326707), // Rule ID 2334 //
     /* 326678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 326693 */     // MIs[1] Operand 1
     /* 326693 */     // No operand predicates
     /* 326693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326695 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 326698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326705 */     GIR_RootConstrainSelectedInstOperands,
     /* 326706 */     // GIR_Coverage, 2334,
     /* 326706 */     GIR_EraseRootFromParent_Done,
     /* 326707 */   // Label 6743: @326707
     /* 326707 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(326726), // Rule ID 2333 //
     /* 326712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326719 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 326724 */     GIR_RootConstrainSelectedInstOperands,
     /* 326725 */     // GIR_Coverage, 2333,
     /* 326725 */     GIR_Done,
     /* 326726 */   // Label 6744: @326726
     /* 326726 */   GIM_Reject,
     /* 326727 */ // Label 6742: @326727
     /* 326727 */ GIM_Reject,
     /* 326728 */ // Label 6732: @326728
     /* 326728 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(326761), // Rule ID 1525 //
     /* 326733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326754 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 326759 */   GIR_RootConstrainSelectedInstOperands,
     /* 326760 */   // GIR_Coverage, 1525,
     /* 326760 */   GIR_Done,
     /* 326761 */ // Label 6745: @326761
     /* 326761 */ GIM_Reject,
     /* 326762 */ // Label 6733: @326762
     /* 326762 */ GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(326795), // Rule ID 1523 //
     /* 326767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326788 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 326793 */   GIR_RootConstrainSelectedInstOperands,
     /* 326794 */   // GIR_Coverage, 1523,
     /* 326794 */   GIR_Done,
     /* 326795 */ // Label 6746: @326795
     /* 326795 */ GIM_Reject,
     /* 326796 */ // Label 6734: @326796
     /* 326796 */ GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(326829), // Rule ID 1526 //
     /* 326801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326822 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 326827 */   GIR_RootConstrainSelectedInstOperands,
     /* 326828 */   // GIR_Coverage, 1526,
     /* 326828 */   GIR_Done,
     /* 326829 */ // Label 6747: @326829
     /* 326829 */ GIM_Reject,
     /* 326830 */ // Label 6735: @326830
     /* 326830 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(326863), // Rule ID 1521 //
     /* 326835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326856 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 326861 */   GIR_RootConstrainSelectedInstOperands,
     /* 326862 */   // GIR_Coverage, 1521,
     /* 326862 */   GIR_Done,
     /* 326863 */ // Label 6748: @326863
     /* 326863 */ GIM_Reject,
     /* 326864 */ // Label 6736: @326864
     /* 326864 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(326897), // Rule ID 1524 //
     /* 326869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326890 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 326895 */   GIR_RootConstrainSelectedInstOperands,
     /* 326896 */   // GIR_Coverage, 1524,
     /* 326896 */   GIR_Done,
     /* 326897 */ // Label 6749: @326897
     /* 326897 */ GIM_Reject,
     /* 326898 */ // Label 6737: @326898
     /* 326898 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(326931), // Rule ID 1522 //
     /* 326903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326924 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 326929 */   GIR_RootConstrainSelectedInstOperands,
     /* 326930 */   // GIR_Coverage, 1522,
     /* 326930 */   GIR_Done,
     /* 326931 */ // Label 6750: @326931
     /* 326931 */ GIM_Reject,
     /* 326932 */ // Label 6738: @326932
     /* 326932 */ GIM_Reject,
     /* 326933 */ // Label 83: @326933
     /* 326933 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6760*/ GIMT_Encode4(327747),
     /* 326944 */ /*GILLT_s32*//*Label 6751*/ GIMT_Encode4(326984),
     /* 326948 */ /*GILLT_s64*//*Label 6752*/ GIMT_Encode4(327011), GIMT_Encode4(0),
     /* 326956 */ /*GILLT_v2s32*//*Label 6753*/ GIMT_Encode4(327090),
     /* 326960 */ /*GILLT_v2s64*//*Label 6754*/ GIMT_Encode4(327117),
     /* 326964 */ /*GILLT_v4s16*//*Label 6755*/ GIMT_Encode4(327300),
     /* 326968 */ /*GILLT_v4s32*//*Label 6756*/ GIMT_Encode4(327327),
     /* 326972 */ /*GILLT_v8s8*//*Label 6757*/ GIMT_Encode4(327510),
     /* 326976 */ /*GILLT_v8s16*//*Label 6758*/ GIMT_Encode4(327537),
     /* 326980 */ /*GILLT_v16s8*//*Label 6759*/ GIMT_Encode4(327720),
     /* 326984 */ // Label 6751: @326984
     /* 326984 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(327010), // Rule ID 2317 //
     /* 326989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327003 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 327003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 327008 */   GIR_RootConstrainSelectedInstOperands,
     /* 327009 */   // GIR_Coverage, 2317,
     /* 327009 */   GIR_Done,
     /* 327010 */ // Label 6761: @327010
     /* 327010 */ GIM_Reject,
     /* 327011 */ // Label 6752: @327011
     /* 327011 */ GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(327089),
     /* 327016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327019 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(327042), // Rule ID 1652 //
     /* 327024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327035 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 327035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 327040 */     GIR_RootConstrainSelectedInstOperands,
     /* 327041 */     // GIR_Coverage, 1652,
     /* 327041 */     GIR_Done,
     /* 327042 */   // Label 6763: @327042
     /* 327042 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(327065), // Rule ID 2318 //
     /* 327047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327058 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 327058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 327063 */     GIR_RootConstrainSelectedInstOperands,
     /* 327064 */     // GIR_Coverage, 2318,
     /* 327064 */     GIR_Done,
     /* 327065 */   // Label 6764: @327065
     /* 327065 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(327088), // Rule ID 2514 //
     /* 327070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 327073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327081 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 327081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 327086 */     GIR_RootConstrainSelectedInstOperands,
     /* 327087 */     // GIR_Coverage, 2514,
     /* 327087 */     GIR_Done,
     /* 327088 */   // Label 6765: @327088
     /* 327088 */   GIM_Reject,
     /* 327089 */ // Label 6762: @327089
     /* 327089 */ GIM_Reject,
     /* 327090 */ // Label 6753: @327090
     /* 327090 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(327116), // Rule ID 707 //
     /* 327095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327109 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 327109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 327114 */   GIR_RootConstrainSelectedInstOperands,
     /* 327115 */   // GIR_Coverage, 707,
     /* 327115 */   GIR_Done,
     /* 327116 */ // Label 6766: @327116
     /* 327116 */ GIM_Reject,
     /* 327117 */ // Label 6754: @327117
     /* 327117 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(327299),
     /* 327122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327129 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(327207), // Rule ID 4889 //
     /* 327134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327170 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 327183 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 327190 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 327190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 327193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327205 */     GIR_RootConstrainSelectedInstOperands,
     /* 327206 */     // GIR_Coverage, 4889,
     /* 327206 */     GIR_EraseRootFromParent_Done,
     /* 327207 */   // Label 6768: @327207
     /* 327207 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(327279), // Rule ID 4888 //
     /* 327212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327253 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327264 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 327264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 327267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327277 */     GIR_RootConstrainSelectedInstOperands,
     /* 327278 */     // GIR_Coverage, 4888,
     /* 327278 */     GIR_EraseRootFromParent_Done,
     /* 327279 */   // Label 6769: @327279
     /* 327279 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(327298), // Rule ID 709 //
     /* 327284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327291 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 327291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 327296 */     GIR_RootConstrainSelectedInstOperands,
     /* 327297 */     // GIR_Coverage, 709,
     /* 327297 */     GIR_Done,
     /* 327298 */   // Label 6770: @327298
     /* 327298 */   GIM_Reject,
     /* 327299 */ // Label 6767: @327299
     /* 327299 */ GIM_Reject,
     /* 327300 */ // Label 6755: @327300
     /* 327300 */ GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(327326), // Rule ID 705 //
     /* 327305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327319 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 327319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 327324 */   GIR_RootConstrainSelectedInstOperands,
     /* 327325 */   // GIR_Coverage, 705,
     /* 327325 */   GIR_Done,
     /* 327326 */ // Label 6771: @327326
     /* 327326 */ GIM_Reject,
     /* 327327 */ // Label 6756: @327327
     /* 327327 */ GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(327509),
     /* 327332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327339 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(327417), // Rule ID 4887 //
     /* 327344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 327393 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 327400 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 327400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 327403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327415 */     GIR_RootConstrainSelectedInstOperands,
     /* 327416 */     // GIR_Coverage, 4887,
     /* 327416 */     GIR_EraseRootFromParent_Done,
     /* 327417 */   // Label 6773: @327417
     /* 327417 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(327489), // Rule ID 4886 //
     /* 327422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327463 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327467 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327474 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 327474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 327477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327487 */     GIR_RootConstrainSelectedInstOperands,
     /* 327488 */     // GIR_Coverage, 4886,
     /* 327488 */     GIR_EraseRootFromParent_Done,
     /* 327489 */   // Label 6774: @327489
     /* 327489 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(327508), // Rule ID 708 //
     /* 327494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327501 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 327501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 327506 */     GIR_RootConstrainSelectedInstOperands,
     /* 327507 */     // GIR_Coverage, 708,
     /* 327507 */     GIR_Done,
     /* 327508 */   // Label 6775: @327508
     /* 327508 */   GIM_Reject,
     /* 327509 */ // Label 6772: @327509
     /* 327509 */ GIM_Reject,
     /* 327510 */ // Label 6757: @327510
     /* 327510 */ GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(327536), // Rule ID 703 //
     /* 327515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327529 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 327529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 327534 */   GIR_RootConstrainSelectedInstOperands,
     /* 327535 */   // GIR_Coverage, 703,
     /* 327535 */   GIR_Done,
     /* 327536 */ // Label 6776: @327536
     /* 327536 */ GIM_Reject,
     /* 327537 */ // Label 6758: @327537
     /* 327537 */ GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(327719),
     /* 327542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327549 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(327627), // Rule ID 4885 //
     /* 327554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327590 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327596 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 327603 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 327610 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 327610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 327613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327625 */     GIR_RootConstrainSelectedInstOperands,
     /* 327626 */     // GIR_Coverage, 4885,
     /* 327626 */     GIR_EraseRootFromParent_Done,
     /* 327627 */   // Label 6778: @327627
     /* 327627 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(327699), // Rule ID 4884 //
     /* 327632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327673 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327677 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327684 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 327684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 327687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327697 */     GIR_RootConstrainSelectedInstOperands,
     /* 327698 */     // GIR_Coverage, 4884,
     /* 327698 */     GIR_EraseRootFromParent_Done,
     /* 327699 */   // Label 6779: @327699
     /* 327699 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(327718), // Rule ID 706 //
     /* 327704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327711 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 327711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 327716 */     GIR_RootConstrainSelectedInstOperands,
     /* 327717 */     // GIR_Coverage, 706,
     /* 327717 */     GIR_Done,
     /* 327718 */   // Label 6780: @327718
     /* 327718 */   GIM_Reject,
     /* 327719 */ // Label 6777: @327719
     /* 327719 */ GIM_Reject,
     /* 327720 */ // Label 6759: @327720
     /* 327720 */ GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(327746), // Rule ID 704 //
     /* 327725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 327731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327739 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 327739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 327744 */   GIR_RootConstrainSelectedInstOperands,
     /* 327745 */   // GIR_Coverage, 704,
     /* 327745 */   GIR_Done,
     /* 327746 */ // Label 6781: @327746
     /* 327746 */ GIM_Reject,
     /* 327747 */ // Label 6760: @327747
     /* 327747 */ GIM_Reject,
     /* 327748 */ // Label 84: @327748
     /* 327748 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6784*/ GIMT_Encode4(327913),
     /* 327759 */ /*GILLT_s32*//*Label 6782*/ GIMT_Encode4(327767),
     /* 327763 */ /*GILLT_s64*//*Label 6783*/ GIMT_Encode4(327840),
     /* 327767 */ // Label 6782: @327767
     /* 327767 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(327793), // Rule ID 4730 //
     /* 327772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327782 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 327782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 327787 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327791 */   GIR_RootConstrainSelectedInstOperands,
     /* 327792 */   // GIR_Coverage, 4730,
     /* 327792 */   GIR_Done,
     /* 327793 */ // Label 6785: @327793
     /* 327793 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(327816), // Rule ID 4736 //
     /* 327798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327805 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 327805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 327810 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327814 */   GIR_RootConstrainSelectedInstOperands,
     /* 327815 */   // GIR_Coverage, 4736,
     /* 327815 */   GIR_Done,
     /* 327816 */ // Label 6786: @327816
     /* 327816 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(327839), // Rule ID 4738 //
     /* 327821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327828 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 327828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 327833 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327837 */   GIR_RootConstrainSelectedInstOperands,
     /* 327838 */   // GIR_Coverage, 4738,
     /* 327838 */   GIR_Done,
     /* 327839 */ // Label 6787: @327839
     /* 327839 */ GIM_Reject,
     /* 327840 */ // Label 6783: @327840
     /* 327840 */ GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(327866), // Rule ID 4732 //
     /* 327845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327855 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 327855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 327860 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327864 */   GIR_RootConstrainSelectedInstOperands,
     /* 327865 */   // GIR_Coverage, 4732,
     /* 327865 */   GIR_Done,
     /* 327866 */ // Label 6788: @327866
     /* 327866 */ GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(327889), // Rule ID 4740 //
     /* 327871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327878 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 327878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 327883 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327887 */   GIR_RootConstrainSelectedInstOperands,
     /* 327888 */   // GIR_Coverage, 4740,
     /* 327888 */   GIR_Done,
     /* 327889 */ // Label 6789: @327889
     /* 327889 */ GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(327912), // Rule ID 4742 //
     /* 327894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327901 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 327901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 327906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327910 */   GIR_RootConstrainSelectedInstOperands,
     /* 327911 */   // GIR_Coverage, 4742,
     /* 327911 */   GIR_Done,
     /* 327912 */ // Label 6790: @327912
     /* 327912 */ GIM_Reject,
     /* 327913 */ // Label 6784: @327913
     /* 327913 */ GIM_Reject,
     /* 327914 */ // Label 85: @327914
     /* 327914 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(328012),
     /* 327919 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 327922 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6795*/ GIMT_Encode4(328011),
     /* 327933 */   /*GILLT_s16*//*Label 6792*/ GIMT_Encode4(327945),
     /* 327937 */   /*GILLT_s32*//*Label 6793*/ GIMT_Encode4(327969),
     /* 327941 */   /*GILLT_s64*//*Label 6794*/ GIMT_Encode4(327990),
     /* 327945 */   // Label 6792: @327945
     /* 327945 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(327968), // Rule ID 4734 //
     /* 327950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327957 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 327957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 327962 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327966 */     GIR_RootConstrainSelectedInstOperands,
     /* 327967 */     // GIR_Coverage, 4734,
     /* 327967 */     GIR_Done,
     /* 327968 */   // Label 6796: @327968
     /* 327968 */   GIM_Reject,
     /* 327969 */   // Label 6793: @327969
     /* 327969 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(327989), // Rule ID 4744 //
     /* 327974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327978 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 327978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 327983 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327987 */     GIR_RootConstrainSelectedInstOperands,
     /* 327988 */     // GIR_Coverage, 4744,
     /* 327988 */     GIR_Done,
     /* 327989 */   // Label 6797: @327989
     /* 327989 */   GIM_Reject,
     /* 327990 */   // Label 6794: @327990
     /* 327990 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(328010), // Rule ID 4746 //
     /* 327995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327999 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 327999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 328004 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328008 */     GIR_RootConstrainSelectedInstOperands,
     /* 328009 */     // GIR_Coverage, 4746,
     /* 328009 */     GIR_Done,
     /* 328010 */   // Label 6798: @328010
     /* 328010 */   GIM_Reject,
     /* 328011 */   // Label 6795: @328011
     /* 328011 */   GIM_Reject,
     /* 328012 */ // Label 6791: @328012
     /* 328012 */ GIM_Reject,
     /* 328013 */ // Label 86: @328013
     /* 328013 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(328028), // Rule ID 225 //
     /* 328018 */   // MIs[0] addr
     /* 328018 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 328021 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 328021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 328026 */   GIR_RootConstrainSelectedInstOperands,
     /* 328027 */   // GIR_Coverage, 225,
     /* 328027 */   GIR_Done,
     /* 328028 */ // Label 6799: @328028
     /* 328028 */ GIM_Reject,
     /* 328029 */ // Label 87: @328029
     /* 328029 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6811*/ GIMT_Encode4(333400),
     /* 328040 */ /*GILLT_s64*//*Label 6800*/ GIMT_Encode4(328112), GIMT_Encode4(0),
     /* 328048 */ /*GILLT_v2s32*//*Label 6801*/ GIMT_Encode4(328514), GIMT_Encode4(0),
     /* 328056 */ /*GILLT_v4s16*//*Label 6802*/ GIMT_Encode4(328916), GIMT_Encode4(0),
     /* 328064 */ /*GILLT_v8s8*//*Label 6803*/ GIMT_Encode4(329318), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 328076 */ /*GILLT_nxv1s1*//*Label 6804*/ GIMT_Encode4(329498),
     /* 328080 */ /*GILLT_nxv2s1*//*Label 6805*/ GIMT_Encode4(331761),
     /* 328084 */ /*GILLT_nxv2s16*//*Label 6806*/ GIMT_Encode4(332616),
     /* 328088 */ /*GILLT_nxv2s32*//*Label 6807*/ GIMT_Encode4(332903), GIMT_Encode4(0),
     /* 328096 */ /*GILLT_nxv4s1*//*Label 6808*/ GIMT_Encode4(332973),
     /* 328100 */ /*GILLT_nxv4s16*//*Label 6809*/ GIMT_Encode4(333260), GIMT_Encode4(0),
     /* 328108 */ /*GILLT_nxv8s1*//*Label 6810*/ GIMT_Encode4(333330),
     /* 328112 */ // Label 6800: @328112
     /* 328112 */ GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(328513),
     /* 328117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328124 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(328176), // Rule ID 5580 //
     /* 328129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328141 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328148 */     // MIs[0] Operand 2
     /* 328148 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328161 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 328161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 328164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328174 */     GIR_RootConstrainSelectedInstOperands,
     /* 328175 */     // GIR_Coverage, 5580,
     /* 328175 */     GIR_EraseRootFromParent_Done,
     /* 328176 */   // Label 6813: @328176
     /* 328176 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(328228), // Rule ID 5583 //
     /* 328181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328193 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328200 */     // MIs[0] Operand 2
     /* 328200 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328213 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 328213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 328216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328226 */     GIR_RootConstrainSelectedInstOperands,
     /* 328227 */     // GIR_Coverage, 5583,
     /* 328227 */     GIR_EraseRootFromParent_Done,
     /* 328228 */   // Label 6814: @328228
     /* 328228 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(328296), // Rule ID 5459 //
     /* 328233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328237 */     // MIs[0] Operand 2
     /* 328237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328248 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328268 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328278 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328295 */     // GIR_Coverage, 5459,
     /* 328295 */     GIR_EraseRootFromParent_Done,
     /* 328296 */   // Label 6815: @328296
     /* 328296 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(328364), // Rule ID 5464 //
     /* 328301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328305 */     // MIs[0] Operand 2
     /* 328305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328316 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328336 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328346 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328363 */     // GIR_Coverage, 5464,
     /* 328363 */     GIR_EraseRootFromParent_Done,
     /* 328364 */   // Label 6816: @328364
     /* 328364 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(328406), // Rule ID 6885 //
     /* 328369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328373 */     // MIs[0] Operand 2
     /* 328373 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328384 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 328384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328389 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328405 */     // GIR_Coverage, 6885,
     /* 328405 */     GIR_EraseRootFromParent_Done,
     /* 328406 */   // Label 6817: @328406
     /* 328406 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(328448), // Rule ID 6886 //
     /* 328411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328415 */     // MIs[0] Operand 2
     /* 328415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328426 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 328426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328431 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328447 */     // GIR_Coverage, 6886,
     /* 328447 */     GIR_EraseRootFromParent_Done,
     /* 328448 */   // Label 6818: @328448
     /* 328448 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(328512), // Rule ID 6890 //
     /* 328453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328457 */     // MIs[0] Operand 2
     /* 328457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328468 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 328468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 328475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 328487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328494 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328511 */     // GIR_Coverage, 6890,
     /* 328511 */     GIR_EraseRootFromParent_Done,
     /* 328512 */   // Label 6819: @328512
     /* 328512 */   GIM_Reject,
     /* 328513 */ // Label 6812: @328513
     /* 328513 */ GIM_Reject,
     /* 328514 */ // Label 6801: @328514
     /* 328514 */ GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(328915),
     /* 328519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328526 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(328578), // Rule ID 5579 //
     /* 328531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328543 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328550 */     // MIs[0] Operand 2
     /* 328550 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328563 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 328563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 328566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328576 */     GIR_RootConstrainSelectedInstOperands,
     /* 328577 */     // GIR_Coverage, 5579,
     /* 328577 */     GIR_EraseRootFromParent_Done,
     /* 328578 */   // Label 6821: @328578
     /* 328578 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(328630), // Rule ID 5582 //
     /* 328583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328595 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328602 */     // MIs[0] Operand 2
     /* 328602 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328615 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 328615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 328618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328628 */     GIR_RootConstrainSelectedInstOperands,
     /* 328629 */     // GIR_Coverage, 5582,
     /* 328629 */     GIR_EraseRootFromParent_Done,
     /* 328630 */   // Label 6822: @328630
     /* 328630 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(328698), // Rule ID 5449 //
     /* 328635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328639 */     // MIs[0] Operand 2
     /* 328639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328650 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328670 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328680 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328697 */     // GIR_Coverage, 5449,
     /* 328697 */     GIR_EraseRootFromParent_Done,
     /* 328698 */   // Label 6823: @328698
     /* 328698 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(328766), // Rule ID 5454 //
     /* 328703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328707 */     // MIs[0] Operand 2
     /* 328707 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328718 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328738 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328748 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328765 */     // GIR_Coverage, 5454,
     /* 328765 */     GIR_EraseRootFromParent_Done,
     /* 328766 */   // Label 6824: @328766
     /* 328766 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(328808), // Rule ID 6882 //
     /* 328771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328775 */     // MIs[0] Operand 2
     /* 328775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328786 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 328786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328791 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328807 */     // GIR_Coverage, 6882,
     /* 328807 */     GIR_EraseRootFromParent_Done,
     /* 328808 */   // Label 6825: @328808
     /* 328808 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(328850), // Rule ID 6884 //
     /* 328813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328817 */     // MIs[0] Operand 2
     /* 328817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328828 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 328828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328833 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328849 */     // GIR_Coverage, 6884,
     /* 328849 */     GIR_EraseRootFromParent_Done,
     /* 328850 */   // Label 6826: @328850
     /* 328850 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(328914), // Rule ID 6889 //
     /* 328855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328859 */     // MIs[0] Operand 2
     /* 328859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328870 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 328870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 328877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328886 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 328889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328896 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328913 */     // GIR_Coverage, 6889,
     /* 328913 */     GIR_EraseRootFromParent_Done,
     /* 328914 */   // Label 6827: @328914
     /* 328914 */   GIM_Reject,
     /* 328915 */ // Label 6820: @328915
     /* 328915 */ GIM_Reject,
     /* 328916 */ // Label 6802: @328916
     /* 328916 */ GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(329317),
     /* 328921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328928 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(328980), // Rule ID 5578 //
     /* 328933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328945 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328952 */     // MIs[0] Operand 2
     /* 328952 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328965 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 328965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 328968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328978 */     GIR_RootConstrainSelectedInstOperands,
     /* 328979 */     // GIR_Coverage, 5578,
     /* 328979 */     GIR_EraseRootFromParent_Done,
     /* 328980 */   // Label 6829: @328980
     /* 328980 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(329032), // Rule ID 5581 //
     /* 328985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328997 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329004 */     // MIs[0] Operand 2
     /* 329004 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329017 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 329017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 329020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329030 */     GIR_RootConstrainSelectedInstOperands,
     /* 329031 */     // GIR_Coverage, 5581,
     /* 329031 */     GIR_EraseRootFromParent_Done,
     /* 329032 */   // Label 6830: @329032
     /* 329032 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(329100), // Rule ID 5439 //
     /* 329037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329041 */     // MIs[0] Operand 2
     /* 329041 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329052 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329072 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329082 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329099 */     // GIR_Coverage, 5439,
     /* 329099 */     GIR_EraseRootFromParent_Done,
     /* 329100 */   // Label 6831: @329100
     /* 329100 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(329168), // Rule ID 5444 //
     /* 329105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329109 */     // MIs[0] Operand 2
     /* 329109 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329120 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329140 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329150 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329167 */     // GIR_Coverage, 5444,
     /* 329167 */     GIR_EraseRootFromParent_Done,
     /* 329168 */   // Label 6832: @329168
     /* 329168 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(329210), // Rule ID 6880 //
     /* 329173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329177 */     // MIs[0] Operand 2
     /* 329177 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329188 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 329188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329193 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329209 */     // GIR_Coverage, 6880,
     /* 329209 */     GIR_EraseRootFromParent_Done,
     /* 329210 */   // Label 6833: @329210
     /* 329210 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(329252), // Rule ID 6883 //
     /* 329215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329219 */     // MIs[0] Operand 2
     /* 329219 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329230 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 329230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329235 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329251 */     // GIR_Coverage, 6883,
     /* 329251 */     GIR_EraseRootFromParent_Done,
     /* 329252 */   // Label 6834: @329252
     /* 329252 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(329316), // Rule ID 6888 //
     /* 329257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329261 */     // MIs[0] Operand 2
     /* 329261 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329272 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329298 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329315 */     // GIR_Coverage, 6888,
     /* 329315 */     GIR_EraseRootFromParent_Done,
     /* 329316 */   // Label 6835: @329316
     /* 329316 */   GIM_Reject,
     /* 329317 */ // Label 6828: @329317
     /* 329317 */ GIM_Reject,
     /* 329318 */ // Label 6803: @329318
     /* 329318 */ GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(329497),
     /* 329323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329334 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(329398), // Rule ID 5434 //
     /* 329339 */     // MIs[0] Operand 2
     /* 329339 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 329350 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329380 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329397 */     // GIR_Coverage, 5434,
     /* 329397 */     GIR_EraseRootFromParent_Done,
     /* 329398 */   // Label 6837: @329398
     /* 329398 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(329436), // Rule ID 6881 //
     /* 329403 */     // MIs[0] Operand 2
     /* 329403 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329414 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 329414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329419 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329435 */     // GIR_Coverage, 6881,
     /* 329435 */     GIR_EraseRootFromParent_Done,
     /* 329436 */   // Label 6838: @329436
     /* 329436 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(329496), // Rule ID 6887 //
     /* 329441 */     // MIs[0] Operand 2
     /* 329441 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329452 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329468 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329478 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329495 */     // GIR_Coverage, 6887,
     /* 329495 */     GIR_EraseRootFromParent_Done,
     /* 329496 */   // Label 6839: @329496
     /* 329496 */   GIM_Reject,
     /* 329497 */ // Label 6836: @329497
     /* 329497 */ GIM_Reject,
     /* 329498 */ // Label 6804: @329498
     /* 329498 */ GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(329533), // Rule ID 8947 //
     /* 329503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 329509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329513 */   // MIs[0] Operand 2
     /* 329513 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329524 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 329524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329529 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329531 */   GIR_RootConstrainSelectedInstOperands,
     /* 329532 */   // GIR_Coverage, 8947,
     /* 329532 */   GIR_EraseRootFromParent_Done,
     /* 329533 */ // Label 6840: @329533
     /* 329533 */ GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(329568), // Rule ID 8948 //
     /* 329538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 329544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329548 */   // MIs[0] Operand 2
     /* 329548 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329559 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 329559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329564 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329566 */   GIR_RootConstrainSelectedInstOperands,
     /* 329567 */   // GIR_Coverage, 8948,
     /* 329567 */   GIR_EraseRootFromParent_Done,
     /* 329568 */ // Label 6841: @329568
     /* 329568 */ GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(329622), // Rule ID 8955 //
     /* 329573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329583 */   // MIs[0] Operand 2
     /* 329583 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329594 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329606 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329620 */   GIR_RootConstrainSelectedInstOperands,
     /* 329621 */   // GIR_Coverage, 8955,
     /* 329621 */   GIR_EraseRootFromParent_Done,
     /* 329622 */ // Label 6842: @329622
     /* 329622 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(329676), // Rule ID 8956 //
     /* 329627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329637 */   // MIs[0] Operand 2
     /* 329637 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329648 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329660 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329674 */   GIR_RootConstrainSelectedInstOperands,
     /* 329675 */   // GIR_Coverage, 8956,
     /* 329675 */   GIR_EraseRootFromParent_Done,
     /* 329676 */ // Label 6843: @329676
     /* 329676 */ GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(329730), // Rule ID 8957 //
     /* 329681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329691 */   // MIs[0] Operand 2
     /* 329691 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329702 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329714 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329728 */   GIR_RootConstrainSelectedInstOperands,
     /* 329729 */   // GIR_Coverage, 8957,
     /* 329729 */   GIR_EraseRootFromParent_Done,
     /* 329730 */ // Label 6844: @329730
     /* 329730 */ GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(329784), // Rule ID 8958 //
     /* 329735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329745 */   // MIs[0] Operand 2
     /* 329745 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 329756 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329768 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329782 */   GIR_RootConstrainSelectedInstOperands,
     /* 329783 */   // GIR_Coverage, 8958,
     /* 329783 */   GIR_EraseRootFromParent_Done,
     /* 329784 */ // Label 6845: @329784
     /* 329784 */ GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(329855), // Rule ID 8967 //
     /* 329789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329799 */   // MIs[0] Operand 2
     /* 329799 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329810 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329810 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329813 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329817 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329822 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329828 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329831 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329835 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329840 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329853 */   GIR_RootConstrainSelectedInstOperands,
     /* 329854 */   // GIR_Coverage, 8967,
     /* 329854 */   GIR_EraseRootFromParent_Done,
     /* 329855 */ // Label 6846: @329855
     /* 329855 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(329926), // Rule ID 8968 //
     /* 329860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329870 */   // MIs[0] Operand 2
     /* 329870 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329881 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329881 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329884 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329888 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329893 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329897 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329911 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329924 */   GIR_RootConstrainSelectedInstOperands,
     /* 329925 */   // GIR_Coverage, 8968,
     /* 329925 */   GIR_EraseRootFromParent_Done,
     /* 329926 */ // Label 6847: @329926
     /* 329926 */ GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(329997), // Rule ID 8969 //
     /* 329931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329941 */   // MIs[0] Operand 2
     /* 329941 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329952 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329952 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329955 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329959 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329964 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329982 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329995 */   GIR_RootConstrainSelectedInstOperands,
     /* 329996 */   // GIR_Coverage, 8969,
     /* 329996 */   GIR_EraseRootFromParent_Done,
     /* 329997 */ // Label 6848: @329997
     /* 329997 */ GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(330068), // Rule ID 8970 //
     /* 330002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330012 */   // MIs[0] Operand 2
     /* 330012 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 330023 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330023 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330026 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330030 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330035 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330041 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330044 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330048 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330053 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330066 */   GIR_RootConstrainSelectedInstOperands,
     /* 330067 */   // GIR_Coverage, 8970,
     /* 330067 */   GIR_EraseRootFromParent_Done,
     /* 330068 */ // Label 6849: @330068
     /* 330068 */ GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(330139), // Rule ID 8971 //
     /* 330073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330083 */   // MIs[0] Operand 2
     /* 330083 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330094 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330094 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330097 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330101 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330106 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330124 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330137 */   GIR_RootConstrainSelectedInstOperands,
     /* 330138 */   // GIR_Coverage, 8971,
     /* 330138 */   GIR_EraseRootFromParent_Done,
     /* 330139 */ // Label 6850: @330139
     /* 330139 */ GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(330210), // Rule ID 8972 //
     /* 330144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330154 */   // MIs[0] Operand 2
     /* 330154 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 330165 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330165 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330168 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330172 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330177 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330195 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330208 */   GIR_RootConstrainSelectedInstOperands,
     /* 330209 */   // GIR_Coverage, 8972,
     /* 330209 */   GIR_EraseRootFromParent_Done,
     /* 330210 */ // Label 6851: @330210
     /* 330210 */ GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(330281), // Rule ID 8973 //
     /* 330215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330225 */   // MIs[0] Operand 2
     /* 330225 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 330236 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330236 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330239 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330243 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330248 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330266 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330279 */   GIR_RootConstrainSelectedInstOperands,
     /* 330280 */   // GIR_Coverage, 8973,
     /* 330280 */   GIR_EraseRootFromParent_Done,
     /* 330281 */ // Label 6852: @330281
     /* 330281 */ GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(330352), // Rule ID 8974 //
     /* 330286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330296 */   // MIs[0] Operand 2
     /* 330296 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 330307 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330307 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330310 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330314 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330319 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330337 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330350 */   GIR_RootConstrainSelectedInstOperands,
     /* 330351 */   // GIR_Coverage, 8974,
     /* 330351 */   GIR_EraseRootFromParent_Done,
     /* 330352 */ // Label 6853: @330352
     /* 330352 */ GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(330440), // Rule ID 8983 //
     /* 330357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330367 */   // MIs[0] Operand 2
     /* 330367 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330378 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330378 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330381 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330385 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330390 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330396 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330399 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330403 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330408 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330425 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330438 */   GIR_RootConstrainSelectedInstOperands,
     /* 330439 */   // GIR_Coverage, 8983,
     /* 330439 */   GIR_EraseRootFromParent_Done,
     /* 330440 */ // Label 6854: @330440
     /* 330440 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(330528), // Rule ID 8984 //
     /* 330445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330455 */   // MIs[0] Operand 2
     /* 330455 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330466 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330466 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330469 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330473 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330478 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330484 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330487 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330491 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330496 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330513 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330526 */   GIR_RootConstrainSelectedInstOperands,
     /* 330527 */   // GIR_Coverage, 8984,
     /* 330527 */   GIR_EraseRootFromParent_Done,
     /* 330528 */ // Label 6855: @330528
     /* 330528 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(330616), // Rule ID 8985 //
     /* 330533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330543 */   // MIs[0] Operand 2
     /* 330543 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330554 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330554 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330557 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330561 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330566 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330572 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330575 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330579 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330584 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330601 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330614 */   GIR_RootConstrainSelectedInstOperands,
     /* 330615 */   // GIR_Coverage, 8985,
     /* 330615 */   GIR_EraseRootFromParent_Done,
     /* 330616 */ // Label 6856: @330616
     /* 330616 */ GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(330704), // Rule ID 8986 //
     /* 330621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330631 */   // MIs[0] Operand 2
     /* 330631 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 330642 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330642 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330645 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330649 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330654 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330660 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330663 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330667 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330672 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330689 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330702 */   GIR_RootConstrainSelectedInstOperands,
     /* 330703 */   // GIR_Coverage, 8986,
     /* 330703 */   GIR_EraseRootFromParent_Done,
     /* 330704 */ // Label 6857: @330704
     /* 330704 */ GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(330792), // Rule ID 8987 //
     /* 330709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330719 */   // MIs[0] Operand 2
     /* 330719 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330730 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330730 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330733 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330737 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330742 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330748 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330751 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330755 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330760 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330777 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330790 */   GIR_RootConstrainSelectedInstOperands,
     /* 330791 */   // GIR_Coverage, 8987,
     /* 330791 */   GIR_EraseRootFromParent_Done,
     /* 330792 */ // Label 6858: @330792
     /* 330792 */ GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(330880), // Rule ID 8988 //
     /* 330797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330807 */   // MIs[0] Operand 2
     /* 330807 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 330818 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330818 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330821 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330825 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330830 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330836 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330839 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330843 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330848 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330865 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330878 */   GIR_RootConstrainSelectedInstOperands,
     /* 330879 */   // GIR_Coverage, 8988,
     /* 330879 */   GIR_EraseRootFromParent_Done,
     /* 330880 */ // Label 6859: @330880
     /* 330880 */ GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(330968), // Rule ID 8989 //
     /* 330885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330895 */   // MIs[0] Operand 2
     /* 330895 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 330906 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330906 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330909 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330913 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330918 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330924 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330927 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330931 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330936 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330953 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330966 */   GIR_RootConstrainSelectedInstOperands,
     /* 330967 */   // GIR_Coverage, 8989,
     /* 330967 */   GIR_EraseRootFromParent_Done,
     /* 330968 */ // Label 6860: @330968
     /* 330968 */ GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(331056), // Rule ID 8990 //
     /* 330973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330983 */   // MIs[0] Operand 2
     /* 330983 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 330994 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330994 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330997 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331001 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331006 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331024 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331029 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331032 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331036 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331041 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331054 */   GIR_RootConstrainSelectedInstOperands,
     /* 331055 */   // GIR_Coverage, 8990,
     /* 331055 */   GIR_EraseRootFromParent_Done,
     /* 331056 */ // Label 6861: @331056
     /* 331056 */ GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(331144), // Rule ID 8991 //
     /* 331061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331071 */   // MIs[0] Operand 2
     /* 331071 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 331082 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331082 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331085 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331089 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331094 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331100 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331103 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331107 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331112 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331129 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331142 */   GIR_RootConstrainSelectedInstOperands,
     /* 331143 */   // GIR_Coverage, 8991,
     /* 331143 */   GIR_EraseRootFromParent_Done,
     /* 331144 */ // Label 6862: @331144
     /* 331144 */ GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(331232), // Rule ID 8992 //
     /* 331149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331159 */   // MIs[0] Operand 2
     /* 331159 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 331170 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331170 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331173 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331177 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331182 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331188 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331191 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331195 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331200 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331217 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331230 */   GIR_RootConstrainSelectedInstOperands,
     /* 331231 */   // GIR_Coverage, 8992,
     /* 331231 */   GIR_EraseRootFromParent_Done,
     /* 331232 */ // Label 6863: @331232
     /* 331232 */ GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(331320), // Rule ID 8993 //
     /* 331237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331247 */   // MIs[0] Operand 2
     /* 331247 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 331258 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331258 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331261 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331265 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331270 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331276 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331279 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331283 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331288 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331305 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331318 */   GIR_RootConstrainSelectedInstOperands,
     /* 331319 */   // GIR_Coverage, 8993,
     /* 331319 */   GIR_EraseRootFromParent_Done,
     /* 331320 */ // Label 6864: @331320
     /* 331320 */ GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(331408), // Rule ID 8994 //
     /* 331325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331335 */   // MIs[0] Operand 2
     /* 331335 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 331346 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331346 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331349 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331353 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331358 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331364 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331367 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331371 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331376 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331393 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331406 */   GIR_RootConstrainSelectedInstOperands,
     /* 331407 */   // GIR_Coverage, 8994,
     /* 331407 */   GIR_EraseRootFromParent_Done,
     /* 331408 */ // Label 6865: @331408
     /* 331408 */ GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(331496), // Rule ID 8995 //
     /* 331413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331423 */   // MIs[0] Operand 2
     /* 331423 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 331434 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331434 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331437 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331441 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331446 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331452 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331455 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331459 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331464 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331481 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331494 */   GIR_RootConstrainSelectedInstOperands,
     /* 331495 */   // GIR_Coverage, 8995,
     /* 331495 */   GIR_EraseRootFromParent_Done,
     /* 331496 */ // Label 6866: @331496
     /* 331496 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(331584), // Rule ID 8996 //
     /* 331501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331511 */   // MIs[0] Operand 2
     /* 331511 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 331522 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331522 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331525 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331529 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331534 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331552 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331569 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331582 */   GIR_RootConstrainSelectedInstOperands,
     /* 331583 */   // GIR_Coverage, 8996,
     /* 331583 */   GIR_EraseRootFromParent_Done,
     /* 331584 */ // Label 6867: @331584
     /* 331584 */ GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(331672), // Rule ID 8997 //
     /* 331589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331599 */   // MIs[0] Operand 2
     /* 331599 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 331610 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331610 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331613 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331617 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331622 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331628 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331631 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331635 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331640 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331657 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331670 */   GIR_RootConstrainSelectedInstOperands,
     /* 331671 */   // GIR_Coverage, 8997,
     /* 331671 */   GIR_EraseRootFromParent_Done,
     /* 331672 */ // Label 6868: @331672
     /* 331672 */ GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(331760), // Rule ID 8998 //
     /* 331677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331687 */   // MIs[0] Operand 2
     /* 331687 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 331698 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331710 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331728 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331745 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331758 */   GIR_RootConstrainSelectedInstOperands,
     /* 331759 */   // GIR_Coverage, 8998,
     /* 331759 */   GIR_EraseRootFromParent_Done,
     /* 331760 */ // Label 6869: @331760
     /* 331760 */ GIM_Reject,
     /* 331761 */ // Label 6805: @331761
     /* 331761 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(331796), // Rule ID 8949 //
     /* 331766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331776 */   // MIs[0] Operand 2
     /* 331776 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331787 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 331787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331792 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 331794 */   GIR_RootConstrainSelectedInstOperands,
     /* 331795 */   // GIR_Coverage, 8949,
     /* 331795 */   GIR_EraseRootFromParent_Done,
     /* 331796 */ // Label 6870: @331796
     /* 331796 */ GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(331831), // Rule ID 8950 //
     /* 331801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331811 */   // MIs[0] Operand 2
     /* 331811 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331822 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 331822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331827 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 331829 */   GIR_RootConstrainSelectedInstOperands,
     /* 331830 */   // GIR_Coverage, 8950,
     /* 331830 */   GIR_EraseRootFromParent_Done,
     /* 331831 */ // Label 6871: @331831
     /* 331831 */ GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(331885), // Rule ID 8959 //
     /* 331836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331846 */   // MIs[0] Operand 2
     /* 331846 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331857 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 331857 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331860 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331864 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331869 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331883 */   GIR_RootConstrainSelectedInstOperands,
     /* 331884 */   // GIR_Coverage, 8959,
     /* 331884 */   GIR_EraseRootFromParent_Done,
     /* 331885 */ // Label 6872: @331885
     /* 331885 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(331939), // Rule ID 8960 //
     /* 331890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331900 */   // MIs[0] Operand 2
     /* 331900 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331911 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 331911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331923 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331937 */   GIR_RootConstrainSelectedInstOperands,
     /* 331938 */   // GIR_Coverage, 8960,
     /* 331938 */   GIR_EraseRootFromParent_Done,
     /* 331939 */ // Label 6873: @331939
     /* 331939 */ GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(331993), // Rule ID 8961 //
     /* 331944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331954 */   // MIs[0] Operand 2
     /* 331954 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 331965 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 331965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331977 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331991 */   GIR_RootConstrainSelectedInstOperands,
     /* 331992 */   // GIR_Coverage, 8961,
     /* 331992 */   GIR_EraseRootFromParent_Done,
     /* 331993 */ // Label 6874: @331993
     /* 331993 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(332047), // Rule ID 8962 //
     /* 331998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332008 */   // MIs[0] Operand 2
     /* 332008 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332019 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 332019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332045 */   GIR_RootConstrainSelectedInstOperands,
     /* 332046 */   // GIR_Coverage, 8962,
     /* 332046 */   GIR_EraseRootFromParent_Done,
     /* 332047 */ // Label 6875: @332047
     /* 332047 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(332118), // Rule ID 8975 //
     /* 332052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332062 */   // MIs[0] Operand 2
     /* 332062 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332073 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332073 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332076 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332080 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332085 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332091 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332094 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332098 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332103 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332116 */   GIR_RootConstrainSelectedInstOperands,
     /* 332117 */   // GIR_Coverage, 8975,
     /* 332117 */   GIR_EraseRootFromParent_Done,
     /* 332118 */ // Label 6876: @332118
     /* 332118 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(332189), // Rule ID 8976 //
     /* 332123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332133 */   // MIs[0] Operand 2
     /* 332133 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332144 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332144 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332147 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332151 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332156 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332174 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332187 */   GIR_RootConstrainSelectedInstOperands,
     /* 332188 */   // GIR_Coverage, 8976,
     /* 332188 */   GIR_EraseRootFromParent_Done,
     /* 332189 */ // Label 6877: @332189
     /* 332189 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(332260), // Rule ID 8977 //
     /* 332194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332204 */   // MIs[0] Operand 2
     /* 332204 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332215 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332215 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332218 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332222 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332227 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332258 */   GIR_RootConstrainSelectedInstOperands,
     /* 332259 */   // GIR_Coverage, 8977,
     /* 332259 */   GIR_EraseRootFromParent_Done,
     /* 332260 */ // Label 6878: @332260
     /* 332260 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(332331), // Rule ID 8978 //
     /* 332265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332275 */   // MIs[0] Operand 2
     /* 332275 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332286 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332286 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332289 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332293 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332298 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332316 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332329 */   GIR_RootConstrainSelectedInstOperands,
     /* 332330 */   // GIR_Coverage, 8978,
     /* 332330 */   GIR_EraseRootFromParent_Done,
     /* 332331 */ // Label 6879: @332331
     /* 332331 */ GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(332402), // Rule ID 8979 //
     /* 332336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332346 */   // MIs[0] Operand 2
     /* 332346 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 332357 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332357 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332360 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332364 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332369 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332387 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332400 */   GIR_RootConstrainSelectedInstOperands,
     /* 332401 */   // GIR_Coverage, 8979,
     /* 332401 */   GIR_EraseRootFromParent_Done,
     /* 332402 */ // Label 6880: @332402
     /* 332402 */ GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(332473), // Rule ID 8980 //
     /* 332407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332417 */   // MIs[0] Operand 2
     /* 332417 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 332428 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332428 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332431 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332435 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332440 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332458 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332471 */   GIR_RootConstrainSelectedInstOperands,
     /* 332472 */   // GIR_Coverage, 8980,
     /* 332472 */   GIR_EraseRootFromParent_Done,
     /* 332473 */ // Label 6881: @332473
     /* 332473 */ GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(332544), // Rule ID 8981 //
     /* 332478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332488 */   // MIs[0] Operand 2
     /* 332488 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 332499 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332499 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332502 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332506 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332511 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332529 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332542 */   GIR_RootConstrainSelectedInstOperands,
     /* 332543 */   // GIR_Coverage, 8981,
     /* 332543 */   GIR_EraseRootFromParent_Done,
     /* 332544 */ // Label 6882: @332544
     /* 332544 */ GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(332615), // Rule ID 8982 //
     /* 332549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332559 */   // MIs[0] Operand 2
     /* 332559 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 332570 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332570 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332573 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332577 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332582 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332600 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332613 */   GIR_RootConstrainSelectedInstOperands,
     /* 332614 */   // GIR_Coverage, 8982,
     /* 332614 */   GIR_EraseRootFromParent_Done,
     /* 332615 */ // Label 6883: @332615
     /* 332615 */ GIM_Reject,
     /* 332616 */ // Label 6806: @332616
     /* 332616 */ GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(332651), // Rule ID 8999 //
     /* 332621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 332627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332631 */   // MIs[0] Operand 2
     /* 332631 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332642 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 332642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332649 */   GIR_RootConstrainSelectedInstOperands,
     /* 332650 */   // GIR_Coverage, 8999,
     /* 332650 */   GIR_EraseRootFromParent_Done,
     /* 332651 */ // Label 6884: @332651
     /* 332651 */ GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(332686), // Rule ID 9000 //
     /* 332656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 332662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332666 */   // MIs[0] Operand 2
     /* 332666 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332677 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 332677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332682 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332684 */   GIR_RootConstrainSelectedInstOperands,
     /* 332685 */   // GIR_Coverage, 9000,
     /* 332685 */   GIR_EraseRootFromParent_Done,
     /* 332686 */ // Label 6885: @332686
     /* 332686 */ GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(332740), // Rule ID 9005 //
     /* 332691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332701 */   // MIs[0] Operand 2
     /* 332701 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332712 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 332719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332724 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332738 */   GIR_RootConstrainSelectedInstOperands,
     /* 332739 */   // GIR_Coverage, 9005,
     /* 332739 */   GIR_EraseRootFromParent_Done,
     /* 332740 */ // Label 6886: @332740
     /* 332740 */ GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(332794), // Rule ID 9006 //
     /* 332745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332755 */   // MIs[0] Operand 2
     /* 332755 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332766 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 332773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332778 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332792 */   GIR_RootConstrainSelectedInstOperands,
     /* 332793 */   // GIR_Coverage, 9006,
     /* 332793 */   GIR_EraseRootFromParent_Done,
     /* 332794 */ // Label 6887: @332794
     /* 332794 */ GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(332848), // Rule ID 9007 //
     /* 332799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332809 */   // MIs[0] Operand 2
     /* 332809 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332820 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 332827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332832 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332846 */   GIR_RootConstrainSelectedInstOperands,
     /* 332847 */   // GIR_Coverage, 9007,
     /* 332847 */   GIR_EraseRootFromParent_Done,
     /* 332848 */ // Label 6888: @332848
     /* 332848 */ GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(332902), // Rule ID 9008 //
     /* 332853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332863 */   // MIs[0] Operand 2
     /* 332863 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332874 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 332881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332900 */   GIR_RootConstrainSelectedInstOperands,
     /* 332901 */   // GIR_Coverage, 9008,
     /* 332901 */   GIR_EraseRootFromParent_Done,
     /* 332902 */ // Label 6889: @332902
     /* 332902 */ GIM_Reject,
     /* 332903 */ // Label 6807: @332903
     /* 332903 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(332972),
     /* 332908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 332911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332915 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(332943), // Rule ID 9003 //
     /* 332920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332923 */     // MIs[0] Operand 2
     /* 332923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332934 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 332934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332941 */     GIR_RootConstrainSelectedInstOperands,
     /* 332942 */     // GIR_Coverage, 9003,
     /* 332942 */     GIR_EraseRootFromParent_Done,
     /* 332943 */   // Label 6891: @332943
     /* 332943 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(332971), // Rule ID 9004 //
     /* 332948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332951 */     // MIs[0] Operand 2
     /* 332951 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332962 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 332962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332969 */     GIR_RootConstrainSelectedInstOperands,
     /* 332970 */     // GIR_Coverage, 9004,
     /* 332970 */     GIR_EraseRootFromParent_Done,
     /* 332971 */   // Label 6892: @332971
     /* 332971 */   GIM_Reject,
     /* 332972 */ // Label 6890: @332972
     /* 332972 */ GIM_Reject,
     /* 332973 */ // Label 6808: @332973
     /* 332973 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(333008), // Rule ID 8951 //
     /* 332978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332988 */   // MIs[0] Operand 2
     /* 332988 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332999 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 332999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333004 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333006 */   GIR_RootConstrainSelectedInstOperands,
     /* 333007 */   // GIR_Coverage, 8951,
     /* 333007 */   GIR_EraseRootFromParent_Done,
     /* 333008 */ // Label 6893: @333008
     /* 333008 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(333043), // Rule ID 8952 //
     /* 333013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333023 */   // MIs[0] Operand 2
     /* 333023 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333034 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 333034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333039 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333041 */   GIR_RootConstrainSelectedInstOperands,
     /* 333042 */   // GIR_Coverage, 8952,
     /* 333042 */   GIR_EraseRootFromParent_Done,
     /* 333043 */ // Label 6894: @333043
     /* 333043 */ GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(333097), // Rule ID 8963 //
     /* 333048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333058 */   // MIs[0] Operand 2
     /* 333058 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333069 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333069 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333072 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333076 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333081 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333095 */   GIR_RootConstrainSelectedInstOperands,
     /* 333096 */   // GIR_Coverage, 8963,
     /* 333096 */   GIR_EraseRootFromParent_Done,
     /* 333097 */ // Label 6895: @333097
     /* 333097 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(333151), // Rule ID 8964 //
     /* 333102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333112 */   // MIs[0] Operand 2
     /* 333112 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333123 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333123 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333126 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333130 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333135 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333149 */   GIR_RootConstrainSelectedInstOperands,
     /* 333150 */   // GIR_Coverage, 8964,
     /* 333150 */   GIR_EraseRootFromParent_Done,
     /* 333151 */ // Label 6896: @333151
     /* 333151 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(333205), // Rule ID 8965 //
     /* 333156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333166 */   // MIs[0] Operand 2
     /* 333166 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 333177 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333189 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333203 */   GIR_RootConstrainSelectedInstOperands,
     /* 333204 */   // GIR_Coverage, 8965,
     /* 333204 */   GIR_EraseRootFromParent_Done,
     /* 333205 */ // Label 6897: @333205
     /* 333205 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(333259), // Rule ID 8966 //
     /* 333210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333220 */   // MIs[0] Operand 2
     /* 333220 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 333231 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333243 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333257 */   GIR_RootConstrainSelectedInstOperands,
     /* 333258 */   // GIR_Coverage, 8966,
     /* 333258 */   GIR_EraseRootFromParent_Done,
     /* 333259 */ // Label 6898: @333259
     /* 333259 */ GIM_Reject,
     /* 333260 */ // Label 6809: @333260
     /* 333260 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(333329),
     /* 333265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 333268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333272 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(333300), // Rule ID 9001 //
     /* 333277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333280 */     // MIs[0] Operand 2
     /* 333280 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333291 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 333291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 333294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333298 */     GIR_RootConstrainSelectedInstOperands,
     /* 333299 */     // GIR_Coverage, 9001,
     /* 333299 */     GIR_EraseRootFromParent_Done,
     /* 333300 */   // Label 6900: @333300
     /* 333300 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(333328), // Rule ID 9002 //
     /* 333305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333308 */     // MIs[0] Operand 2
     /* 333308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333319 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 333319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 333322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333326 */     GIR_RootConstrainSelectedInstOperands,
     /* 333327 */     // GIR_Coverage, 9002,
     /* 333327 */     GIR_EraseRootFromParent_Done,
     /* 333328 */   // Label 6901: @333328
     /* 333328 */   GIM_Reject,
     /* 333329 */ // Label 6899: @333329
     /* 333329 */ GIM_Reject,
     /* 333330 */ // Label 6810: @333330
     /* 333330 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(333399),
     /* 333335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333342 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(333370), // Rule ID 8953 //
     /* 333347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333350 */     // MIs[0] Operand 2
     /* 333350 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333361 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 333361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333368 */     GIR_RootConstrainSelectedInstOperands,
     /* 333369 */     // GIR_Coverage, 8953,
     /* 333369 */     GIR_EraseRootFromParent_Done,
     /* 333370 */   // Label 6903: @333370
     /* 333370 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(333398), // Rule ID 8954 //
     /* 333375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333378 */     // MIs[0] Operand 2
     /* 333378 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 333389 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 333389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333396 */     GIR_RootConstrainSelectedInstOperands,
     /* 333397 */     // GIR_Coverage, 8954,
     /* 333397 */     GIR_EraseRootFromParent_Done,
     /* 333398 */   // Label 6904: @333398
     /* 333398 */   GIM_Reject,
     /* 333399 */ // Label 6902: @333399
     /* 333399 */ GIM_Reject,
     /* 333400 */ // Label 6811: @333400
     /* 333400 */ GIM_Reject,
     /* 333401 */ // Label 88: @333401
     /* 333401 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6920*/ GIMT_Encode4(361884),
     /* 333412 */ /*GILLT_s64*//*Label 6905*/ GIMT_Encode4(333496), GIMT_Encode4(0),
     /* 333420 */ /*GILLT_v2s32*//*Label 6906*/ GIMT_Encode4(334206),
     /* 333424 */ /*GILLT_v2s64*//*Label 6907*/ GIMT_Encode4(337737),
     /* 333428 */ /*GILLT_v4s16*//*Label 6908*/ GIMT_Encode4(340792),
     /* 333432 */ /*GILLT_v4s32*//*Label 6909*/ GIMT_Encode4(344432),
     /* 333436 */ /*GILLT_v8s8*//*Label 6910*/ GIMT_Encode4(347322),
     /* 333440 */ /*GILLT_v8s16*//*Label 6911*/ GIMT_Encode4(349166),
     /* 333444 */ /*GILLT_v16s8*//*Label 6912*/ GIMT_Encode4(352387), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 333456 */ /*GILLT_nxv2s16*//*Label 6913*/ GIMT_Encode4(354090),
     /* 333460 */ /*GILLT_nxv2s32*//*Label 6914*/ GIMT_Encode4(354215),
     /* 333464 */ /*GILLT_nxv2s64*//*Label 6915*/ GIMT_Encode4(354340), GIMT_Encode4(0),
     /* 333472 */ /*GILLT_nxv4s16*//*Label 6916*/ GIMT_Encode4(356318),
     /* 333476 */ /*GILLT_nxv4s32*//*Label 6917*/ GIMT_Encode4(356470), GIMT_Encode4(0),
     /* 333484 */ /*GILLT_nxv8s16*//*Label 6918*/ GIMT_Encode4(358502), GIMT_Encode4(0),
     /* 333492 */ /*GILLT_nxv16s8*//*Label 6919*/ GIMT_Encode4(360770),
     /* 333496 */ // Label 6905: @333496
     /* 333496 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(334205),
     /* 333501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 333507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333514 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(333644), // Rule ID 5734 //
     /* 333519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333552 */     // MIs[2] Operand 1
     /* 333552 */     // No operand predicates
     /* 333552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333560 */     // MIs[3] Operand 1
     /* 333560 */     // No operand predicates
     /* 333560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333562 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333574 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333577 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333581 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333626 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333643 */     // GIR_Coverage, 5734,
     /* 333643 */     GIR_EraseRootFromParent_Done,
     /* 333644 */   // Label 6922: @333644
     /* 333644 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(333805), // Rule ID 5735 //
     /* 333649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 333665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333682 */     // MIs[2] Operand 1
     /* 333682 */     // No operand predicates
     /* 333682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333690 */     // MIs[3] Operand 1
     /* 333690 */     // No operand predicates
     /* 333690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333692 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 333695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333704 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 333707 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333711 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 333714 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333719 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333724 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333727 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333731 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333736 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333739 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333743 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333746 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333768 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333774 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 333777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333787 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333804 */     // GIR_Coverage, 5735,
     /* 333804 */     GIR_EraseRootFromParent_Done,
     /* 333805 */   // Label 6923: @333805
     /* 333805 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(333935), // Rule ID 5766 //
     /* 333810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333843 */     // MIs[2] Operand 1
     /* 333843 */     // No operand predicates
     /* 333843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333847 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333851 */     // MIs[3] Operand 1
     /* 333851 */     // No operand predicates
     /* 333851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333853 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333865 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333868 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333872 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333880 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333903 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333934 */     // GIR_Coverage, 5766,
     /* 333934 */     GIR_EraseRootFromParent_Done,
     /* 333935 */   // Label 6924: @333935
     /* 333935 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(334096), // Rule ID 5767 //
     /* 333940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 333956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333973 */     // MIs[2] Operand 1
     /* 333973 */     // No operand predicates
     /* 333973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333981 */     // MIs[3] Operand 1
     /* 333981 */     // No operand predicates
     /* 333981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333983 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333983 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 333986 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333990 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333995 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 333998 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334002 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 334005 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334010 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334027 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334030 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334034 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334042 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 334054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334059 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 334068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334078 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334095 */     // GIR_Coverage, 5767,
     /* 334095 */     GIR_EraseRootFromParent_Done,
     /* 334096 */   // Label 6925: @334096
     /* 334096 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(334132), // Rule ID 6661 //
     /* 334101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334119 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 334119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334131 */     // GIR_Coverage, 6661,
     /* 334131 */     GIR_EraseRootFromParent_Done,
     /* 334132 */   // Label 6926: @334132
     /* 334132 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(334168), // Rule ID 6663 //
     /* 334137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334155 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 334155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334167 */     // GIR_Coverage, 6663,
     /* 334167 */     GIR_EraseRootFromParent_Done,
     /* 334168 */   // Label 6927: @334168
     /* 334168 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(334204), // Rule ID 6665 //
     /* 334173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334191 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 334191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334194 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 334196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334203 */     // GIR_Coverage, 6665,
     /* 334203 */     GIR_EraseRootFromParent_Done,
     /* 334204 */   // Label 6928: @334204
     /* 334204 */   GIM_Reject,
     /* 334205 */ // Label 6921: @334205
     /* 334205 */ GIM_Reject,
     /* 334206 */ // Label 6906: @334206
     /* 334206 */ GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(337736),
     /* 334211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 334214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 334217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334224 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(334333), // Rule ID 4272 //
     /* 334229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334239 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334249 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334256 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334273 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334300 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334332 */     // GIR_Coverage, 4272,
     /* 334332 */     GIR_EraseRootFromParent_Done,
     /* 334333 */   // Label 6930: @334333
     /* 334333 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(334442), // Rule ID 4273 //
     /* 334338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334342 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334348 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334358 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334365 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334382 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334409 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334441 */     // GIR_Coverage, 4273,
     /* 334441 */     GIR_EraseRootFromParent_Done,
     /* 334442 */   // Label 6931: @334442
     /* 334442 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(334551), // Rule ID 4380 //
     /* 334447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334457 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334467 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334470 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334474 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334491 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334518 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334550 */     // GIR_Coverage, 4380,
     /* 334550 */     GIR_EraseRootFromParent_Done,
     /* 334551 */   // Label 6932: @334551
     /* 334551 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(334660), // Rule ID 4381 //
     /* 334556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334560 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334566 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334576 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334583 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334600 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334627 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334659 */     // GIR_Coverage, 4381,
     /* 334659 */     GIR_EraseRootFromParent_Done,
     /* 334660 */   // Label 6933: @334660
     /* 334660 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(334765), // Rule ID 4278 //
     /* 334665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334681 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334705 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334732 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334764 */     // GIR_Coverage, 4278,
     /* 334764 */     GIR_EraseRootFromParent_Done,
     /* 334765 */   // Label 6934: @334765
     /* 334765 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(334870), // Rule ID 4280 //
     /* 334770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334786 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334793 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334803 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334810 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334837 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334869 */     // GIR_Coverage, 4280,
     /* 334869 */     GIR_EraseRootFromParent_Done,
     /* 334870 */   // Label 6935: @334870
     /* 334870 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(334975), // Rule ID 4386 //
     /* 334875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334891 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334898 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334915 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334942 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334974 */     // GIR_Coverage, 4386,
     /* 334974 */     GIR_EraseRootFromParent_Done,
     /* 334975 */   // Label 6936: @334975
     /* 334975 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(335080), // Rule ID 4388 //
     /* 334980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334996 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335003 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335020 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335047 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335079 */     // GIR_Coverage, 4388,
     /* 335079 */     GIR_EraseRootFromParent_Done,
     /* 335080 */   // Label 6937: @335080
     /* 335080 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(335184), // Rule ID 4270 //
     /* 335085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335129 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335183 */     // GIR_Coverage, 4270,
     /* 335183 */     GIR_EraseRootFromParent_Done,
     /* 335184 */   // Label 6938: @335184
     /* 335184 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(335288), // Rule ID 4271 //
     /* 335189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335193 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335199 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335209 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335216 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335233 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335255 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335287 */     // GIR_Coverage, 4271,
     /* 335287 */     GIR_EraseRootFromParent_Done,
     /* 335288 */   // Label 6939: @335288
     /* 335288 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(335392), // Rule ID 4378 //
     /* 335293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335297 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335303 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335313 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335316 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335320 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335330 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335337 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335359 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335391 */     // GIR_Coverage, 4378,
     /* 335391 */     GIR_EraseRootFromParent_Done,
     /* 335392 */   // Label 6940: @335392
     /* 335392 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(335496), // Rule ID 4379 //
     /* 335397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335401 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335407 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335417 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335420 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335424 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335441 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335463 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335495 */     // GIR_Coverage, 4379,
     /* 335495 */     GIR_EraseRootFromParent_Done,
     /* 335496 */   // Label 6941: @335496
     /* 335496 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(335596), // Rule ID 4274 //
     /* 335501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335517 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335541 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335563 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335595 */     // GIR_Coverage, 4274,
     /* 335595 */     GIR_EraseRootFromParent_Done,
     /* 335596 */   // Label 6942: @335596
     /* 335596 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(335696), // Rule ID 4276 //
     /* 335601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335617 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335624 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335641 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335663 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335695 */     // GIR_Coverage, 4276,
     /* 335695 */     GIR_EraseRootFromParent_Done,
     /* 335696 */   // Label 6943: @335696
     /* 335696 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(335796), // Rule ID 4382 //
     /* 335701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335717 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335724 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335734 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335741 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335763 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335795 */     // GIR_Coverage, 4382,
     /* 335795 */     GIR_EraseRootFromParent_Done,
     /* 335796 */   // Label 6944: @335796
     /* 335796 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(335896), // Rule ID 4384 //
     /* 335801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335817 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335820 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335824 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335834 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335841 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335863 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335895 */     // GIR_Coverage, 4384,
     /* 335895 */     GIR_EraseRootFromParent_Done,
     /* 335896 */   // Label 6945: @335896
     /* 335896 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(336016), // Rule ID 6440 //
     /* 335901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335920 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335923 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335927 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335934 */     // MIs[2] Rn
     /* 335934 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 335938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335949 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 335949 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 335952 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335956 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 335970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335975 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 335978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 335985 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335998 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336015 */     // GIR_Coverage, 6440,
     /* 336015 */     GIR_EraseRootFromParent_Done,
     /* 336016 */   // Label 6946: @336016
     /* 336016 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(336136), // Rule ID 6442 //
     /* 336021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336040 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336043 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336047 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336054 */     // MIs[2] Rn
     /* 336054 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 336058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336069 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 336069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 336072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 336090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 336101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 336105 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336118 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336135 */     // GIR_Coverage, 6442,
     /* 336135 */     GIR_EraseRootFromParent_Done,
     /* 336136 */   // Label 6947: @336136
     /* 336136 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(336266), // Rule ID 5726 //
     /* 336141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336174 */     // MIs[2] Operand 1
     /* 336174 */     // No operand predicates
     /* 336174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336182 */     // MIs[3] Operand 1
     /* 336182 */     // No operand predicates
     /* 336182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336184 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336184 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336187 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336191 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336196 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336203 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336206 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336211 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336228 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336248 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336265 */     // GIR_Coverage, 5726,
     /* 336265 */     GIR_EraseRootFromParent_Done,
     /* 336266 */   // Label 6948: @336266
     /* 336266 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(336427), // Rule ID 5727 //
     /* 336271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336304 */     // MIs[2] Operand 1
     /* 336304 */     // No operand predicates
     /* 336304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336312 */     // MIs[3] Operand 1
     /* 336312 */     // No operand predicates
     /* 336312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336314 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336314 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336317 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336321 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336326 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336329 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336333 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336336 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336341 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336346 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336349 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336353 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336358 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336361 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336365 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336426 */     // GIR_Coverage, 5727,
     /* 336426 */     GIR_EraseRootFromParent_Done,
     /* 336427 */   // Label 6949: @336427
     /* 336427 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(336557), // Rule ID 5758 //
     /* 336432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336465 */     // MIs[2] Operand 1
     /* 336465 */     // No operand predicates
     /* 336465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336473 */     // MIs[3] Operand 1
     /* 336473 */     // No operand predicates
     /* 336473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336475 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336487 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336494 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336539 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336556 */     // GIR_Coverage, 5758,
     /* 336556 */     GIR_EraseRootFromParent_Done,
     /* 336557 */   // Label 6950: @336557
     /* 336557 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(336718), // Rule ID 5759 //
     /* 336562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336595 */     // MIs[2] Operand 1
     /* 336595 */     // No operand predicates
     /* 336595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336603 */     // MIs[3] Operand 1
     /* 336603 */     // No operand predicates
     /* 336603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336605 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336605 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336608 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336612 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336617 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336620 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336624 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336627 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336632 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336637 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336640 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336644 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336649 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336652 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336656 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336681 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336700 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336717 */     // GIR_Coverage, 5759,
     /* 336717 */     GIR_EraseRootFromParent_Done,
     /* 336718 */   // Label 6951: @336718
     /* 336718 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(336784), // Rule ID 5677 //
     /* 336723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336741 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 336741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 336744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336783 */     // GIR_Coverage, 5677,
     /* 336783 */     GIR_EraseRootFromParent_Done,
     /* 336784 */   // Label 6952: @336784
     /* 336784 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(336850), // Rule ID 5689 //
     /* 336789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336807 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 336807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 336810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336849 */     // GIR_Coverage, 5689,
     /* 336849 */     GIR_EraseRootFromParent_Done,
     /* 336850 */   // Label 6953: @336850
     /* 336850 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(336985), // Rule ID 5697 //
     /* 336855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 336867 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 336871 */     // MIs[1] Operand 1
     /* 336871 */     // No operand predicates
     /* 336871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336879 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336883 */     // MIs[2] Operand 1
     /* 336883 */     // No operand predicates
     /* 336883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336885 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 336885 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 336888 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336892 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 336902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336911 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336914 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 336918 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336921 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336926 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336931 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 336943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336948 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 336954 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 336960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336967 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336984 */     // GIR_Coverage, 5697,
     /* 336984 */     GIR_EraseRootFromParent_Done,
     /* 336985 */   // Label 6954: @336985
     /* 336985 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(337117), // Rule ID 6448 //
     /* 336990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337002 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337009 */     // MIs[1] Rn
     /* 337009 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337030 */     // MIs[2] Operand 1
     /* 337030 */     // No operand predicates
     /* 337030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337032 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337044 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337047 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337051 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337059 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 337071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337076 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337086 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337099 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337116 */     // GIR_Coverage, 6448,
     /* 337116 */     GIR_EraseRootFromParent_Done,
     /* 337117 */   // Label 6955: @337117
     /* 337117 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(337249), // Rule ID 6449 //
     /* 337122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337141 */     // MIs[1] Rn
     /* 337141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337158 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337162 */     // MIs[2] Operand 1
     /* 337162 */     // No operand predicates
     /* 337162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337164 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337176 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 337203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337208 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337218 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337231 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337248 */     // GIR_Coverage, 6449,
     /* 337248 */     GIR_EraseRootFromParent_Done,
     /* 337249 */   // Label 6956: @337249
     /* 337249 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(337432), // Rule ID 5769 //
     /* 337254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 337262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337279 */     // MIs[2] Operand 1
     /* 337279 */     // No operand predicates
     /* 337279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337281 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337281 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 337284 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337288 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337295 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 337298 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337302 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337307 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337310 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 337314 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 337317 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337322 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337327 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337332 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337335 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337339 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337346 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337349 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337353 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337358 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337361 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337365 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 337401 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 337404 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337414 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337431 */     // GIR_Coverage, 5769,
     /* 337431 */     GIR_EraseRootFromParent_Done,
     /* 337432 */   // Label 6957: @337432
     /* 337432 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(337610), // Rule ID 5700 //
     /* 337437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337457 */     // MIs[1] Operand 1
     /* 337457 */     // No operand predicates
     /* 337457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337459 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337459 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 337462 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337466 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337473 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 337476 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337480 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337485 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337488 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337492 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 337495 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337500 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337505 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337510 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337513 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337517 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337524 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337527 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337531 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337536 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337543 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337579 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 337582 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337592 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337609 */     // GIR_Coverage, 5700,
     /* 337609 */     GIR_EraseRootFromParent_Done,
     /* 337610 */   // Label 6958: @337610
     /* 337610 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(337735), // Rule ID 5703 //
     /* 337615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337635 */     // MIs[1] Operand 1
     /* 337635 */     // No operand predicates
     /* 337635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337637 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 337637 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337640 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337644 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337663 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337670 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337678 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 337695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337717 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337734 */     // GIR_Coverage, 5703,
     /* 337734 */     GIR_EraseRootFromParent_Done,
     /* 337735 */   // Label 6959: @337735
     /* 337735 */   GIM_Reject,
     /* 337736 */ // Label 6929: @337736
     /* 337736 */ GIM_Reject,
     /* 337737 */ // Label 6907: @337737
     /* 337737 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(340791),
     /* 337742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 337748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337755 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(337864), // Rule ID 4296 //
     /* 337760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337780 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337787 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 337804 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 337804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 337811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337831 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 337853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337863 */     // GIR_Coverage, 4296,
     /* 337863 */     GIR_EraseRootFromParent_Done,
     /* 337864 */   // Label 6961: @337864
     /* 337864 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(337973), // Rule ID 4297 //
     /* 337869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337873 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337879 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337889 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337892 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337896 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337906 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 337913 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 337913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 337920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337940 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 337962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337972 */     // GIR_Coverage, 4297,
     /* 337972 */     GIR_EraseRootFromParent_Done,
     /* 337973 */   // Label 6962: @337973
     /* 337973 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(338082), // Rule ID 4404 //
     /* 337978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337982 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337988 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337998 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338005 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338009 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338022 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338049 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338081 */     // GIR_Coverage, 4404,
     /* 338081 */     GIR_EraseRootFromParent_Done,
     /* 338082 */   // Label 6963: @338082
     /* 338082 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(338191), // Rule ID 4405 //
     /* 338087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338091 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338097 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338114 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338131 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338158 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338190 */     // GIR_Coverage, 4405,
     /* 338190 */     GIR_EraseRootFromParent_Done,
     /* 338191 */   // Label 6964: @338191
     /* 338191 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(338296), // Rule ID 4302 //
     /* 338196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338212 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338219 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338229 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338236 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338263 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338295 */     // GIR_Coverage, 4302,
     /* 338295 */     GIR_EraseRootFromParent_Done,
     /* 338296 */   // Label 6965: @338296
     /* 338296 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(338401), // Rule ID 4304 //
     /* 338301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338317 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338324 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338334 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338341 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338368 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338400 */     // GIR_Coverage, 4304,
     /* 338400 */     GIR_EraseRootFromParent_Done,
     /* 338401 */   // Label 6966: @338401
     /* 338401 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(338506), // Rule ID 4410 //
     /* 338406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338422 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338429 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338446 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338473 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338505 */     // GIR_Coverage, 4410,
     /* 338505 */     GIR_EraseRootFromParent_Done,
     /* 338506 */   // Label 6967: @338506
     /* 338506 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(338611), // Rule ID 4412 //
     /* 338511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338527 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338534 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338551 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338578 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338610 */     // GIR_Coverage, 4412,
     /* 338610 */     GIR_EraseRootFromParent_Done,
     /* 338611 */   // Label 6968: @338611
     /* 338611 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(338715), // Rule ID 4294 //
     /* 338616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338620 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338626 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338636 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338643 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 338660 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 338660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 338667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338682 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338714 */     // GIR_Coverage, 4294,
     /* 338714 */     GIR_EraseRootFromParent_Done,
     /* 338715 */   // Label 6969: @338715
     /* 338715 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(338819), // Rule ID 4295 //
     /* 338720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338724 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338730 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338740 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338747 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 338764 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 338764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 338771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338786 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338818 */     // GIR_Coverage, 4295,
     /* 338818 */     GIR_EraseRootFromParent_Done,
     /* 338819 */   // Label 6970: @338819
     /* 338819 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(338923), // Rule ID 4402 //
     /* 338824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338828 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338834 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338844 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338851 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338861 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 338868 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 338868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 338875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338890 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338922 */     // GIR_Coverage, 4402,
     /* 338922 */     GIR_EraseRootFromParent_Done,
     /* 338923 */   // Label 6971: @338923
     /* 338923 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(339027), // Rule ID 4403 //
     /* 338928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338932 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338938 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338948 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338955 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338965 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 338972 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 338972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 338979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338994 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339026 */     // GIR_Coverage, 4403,
     /* 339026 */     GIR_EraseRootFromParent_Done,
     /* 339027 */   // Label 6972: @339027
     /* 339027 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(339127), // Rule ID 4298 //
     /* 339032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339072 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339094 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339126 */     // GIR_Coverage, 4298,
     /* 339126 */     GIR_EraseRootFromParent_Done,
     /* 339127 */   // Label 6973: @339127
     /* 339127 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(339227), // Rule ID 4300 //
     /* 339132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339148 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339172 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339194 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339226 */     // GIR_Coverage, 4300,
     /* 339226 */     GIR_EraseRootFromParent_Done,
     /* 339227 */   // Label 6974: @339227
     /* 339227 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(339327), // Rule ID 4406 //
     /* 339232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339248 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339255 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339272 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339326 */     // GIR_Coverage, 4406,
     /* 339326 */     GIR_EraseRootFromParent_Done,
     /* 339327 */   // Label 6975: @339327
     /* 339327 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(339427), // Rule ID 4408 //
     /* 339332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339348 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339351 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339355 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339372 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339394 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339426 */     // GIR_Coverage, 4408,
     /* 339426 */     GIR_EraseRootFromParent_Done,
     /* 339427 */   // Label 6976: @339427
     /* 339427 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(339540), // Rule ID 5732 //
     /* 339432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 339456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339469 */     // MIs[3] Operand 1
     /* 339469 */     // No operand predicates
     /* 339469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339475 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 339482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 339494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 339499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 339521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339539 */     // GIR_Coverage, 5732,
     /* 339539 */     GIR_EraseRootFromParent_Done,
     /* 339540 */   // Label 6977: @339540
     /* 339540 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(339653), // Rule ID 5764 //
     /* 339545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 339569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 339578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339582 */     // MIs[3] Operand 1
     /* 339582 */     // No operand predicates
     /* 339582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339588 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339588 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339591 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 339595 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339600 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 339607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 339612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 339634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339652 */     // GIR_Coverage, 5764,
     /* 339652 */     GIR_EraseRootFromParent_Done,
     /* 339653 */   // Label 6978: @339653
     /* 339653 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(339731), // Rule ID 1941 //
     /* 339658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339694 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339698 */     // MIs[2] Operand 1
     /* 339698 */     // No operand predicates
     /* 339698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339710 */     // MIs[3] Operand 1
     /* 339710 */     // No operand predicates
     /* 339710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339712 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 339712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 339722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 339729 */     GIR_RootConstrainSelectedInstOperands,
     /* 339730 */     // GIR_Coverage, 1941,
     /* 339730 */     GIR_EraseRootFromParent_Done,
     /* 339731 */   // Label 6979: @339731
     /* 339731 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(339822), // Rule ID 7396 //
     /* 339736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 339739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 339751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 339759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339763 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 339766 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 339773 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 339776 */     // MIs[2] Rn
     /* 339776 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 339780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339793 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339797 */     // MIs[3] Operand 1
     /* 339797 */     // No operand predicates
     /* 339797 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339799 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 339799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 339802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 339809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 339820 */     GIR_RootConstrainSelectedInstOperands,
     /* 339821 */     // GIR_Coverage, 7396,
     /* 339821 */     GIR_EraseRootFromParent_Done,
     /* 339822 */   // Label 6980: @339822
     /* 339822 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(339889), // Rule ID 5731 //
     /* 339827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339860 */     // MIs[2] Operand 1
     /* 339860 */     // No operand predicates
     /* 339860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339868 */     // MIs[3] Operand 1
     /* 339868 */     // No operand predicates
     /* 339868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339870 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339875 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339887 */     GIR_RootConstrainSelectedInstOperands,
     /* 339888 */     // GIR_Coverage, 5731,
     /* 339888 */     GIR_EraseRootFromParent_Done,
     /* 339889 */   // Label 6981: @339889
     /* 339889 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(339987), // Rule ID 5733 //
     /* 339894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339927 */     // MIs[2] Operand 1
     /* 339927 */     // No operand predicates
     /* 339927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339935 */     // MIs[3] Operand 1
     /* 339935 */     // No operand predicates
     /* 339935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339937 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 339937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339949 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 339959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339985 */     GIR_RootConstrainSelectedInstOperands,
     /* 339986 */     // GIR_Coverage, 5733,
     /* 339986 */     GIR_EraseRootFromParent_Done,
     /* 339987 */   // Label 6982: @339987
     /* 339987 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(340054), // Rule ID 5763 //
     /* 339992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340025 */     // MIs[2] Operand 1
     /* 340025 */     // No operand predicates
     /* 340025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340033 */     // MIs[3] Operand 1
     /* 340033 */     // No operand predicates
     /* 340033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340035 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 340035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340052 */     GIR_RootConstrainSelectedInstOperands,
     /* 340053 */     // GIR_Coverage, 5763,
     /* 340053 */     GIR_EraseRootFromParent_Done,
     /* 340054 */   // Label 6983: @340054
     /* 340054 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(340152), // Rule ID 5765 //
     /* 340059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340092 */     // MIs[2] Operand 1
     /* 340092 */     // No operand predicates
     /* 340092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340100 */     // MIs[3] Operand 1
     /* 340100 */     // No operand predicates
     /* 340100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340102 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 340102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340121 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340150 */     GIR_RootConstrainSelectedInstOperands,
     /* 340151 */     // GIR_Coverage, 5765,
     /* 340151 */     GIR_EraseRootFromParent_Done,
     /* 340152 */   // Label 6984: @340152
     /* 340152 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(340218), // Rule ID 5681 //
     /* 340157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340175 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 340175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340217 */     // GIR_Coverage, 5681,
     /* 340217 */     GIR_EraseRootFromParent_Done,
     /* 340218 */   // Label 6985: @340218
     /* 340218 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(340284), // Rule ID 5691 //
     /* 340223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340241 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 340241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340283 */     // GIR_Coverage, 5691,
     /* 340283 */     GIR_EraseRootFromParent_Done,
     /* 340284 */   // Label 6986: @340284
     /* 340284 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(340362), // Rule ID 7395 //
     /* 340289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 340292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340304 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 340307 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 340314 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 340317 */     // MIs[1] Rn
     /* 340317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340334 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340338 */     // MIs[2] Operand 1
     /* 340338 */     // No operand predicates
     /* 340338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340340 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15834>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 340343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340360 */     GIR_RootConstrainSelectedInstOperands,
     /* 340361 */     // GIR_Coverage, 7395,
     /* 340361 */     GIR_EraseRootFromParent_Done,
     /* 340362 */   // Label 6987: @340362
     /* 340362 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(340431), // Rule ID 6431 //
     /* 340367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340386 */     // MIs[1] Rn
     /* 340386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340407 */     // MIs[2] Operand 1
     /* 340407 */     // No operand predicates
     /* 340407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340409 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 340412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340429 */     GIR_RootConstrainSelectedInstOperands,
     /* 340430 */     // GIR_Coverage, 6431,
     /* 340430 */     GIR_EraseRootFromParent_Done,
     /* 340431 */   // Label 6988: @340431
     /* 340431 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(340500), // Rule ID 6432 //
     /* 340436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340455 */     // MIs[1] Rn
     /* 340455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340472 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340476 */     // MIs[2] Operand 1
     /* 340476 */     // No operand predicates
     /* 340476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340478 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 340481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340498 */     GIR_RootConstrainSelectedInstOperands,
     /* 340499 */     // GIR_Coverage, 6432,
     /* 340499 */     GIR_EraseRootFromParent_Done,
     /* 340500 */   // Label 6989: @340500
     /* 340500 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(340549), // Rule ID 5698 //
     /* 340505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340513 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340517 */     // MIs[1] Operand 1
     /* 340517 */     // No operand predicates
     /* 340517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340529 */     // MIs[2] Operand 1
     /* 340529 */     // No operand predicates
     /* 340529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340531 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 340531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 340534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 340541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340547 */     GIR_RootConstrainSelectedInstOperands,
     /* 340548 */     // GIR_Coverage, 5698,
     /* 340548 */     GIR_EraseRootFromParent_Done,
     /* 340549 */   // Label 6990: @340549
     /* 340549 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(340650), // Rule ID 5770 //
     /* 340554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 340562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340579 */     // MIs[2] Operand 1
     /* 340579 */     // No operand predicates
     /* 340579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340581 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 340581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 340614 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340627 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340637 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 340642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340648 */     GIR_RootConstrainSelectedInstOperands,
     /* 340649 */     // GIR_Coverage, 5770,
     /* 340649 */     GIR_EraseRootFromParent_Done,
     /* 340650 */   // Label 6991: @340650
     /* 340650 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(340694), // Rule ID 1937 //
     /* 340655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340678 */     // MIs[1] Operand 1
     /* 340678 */     // No operand predicates
     /* 340678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340680 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 340680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 340683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 340690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340692 */     GIR_RootConstrainSelectedInstOperands,
     /* 340693 */     // GIR_Coverage, 1937,
     /* 340693 */     GIR_EraseRootFromParent_Done,
     /* 340694 */   // Label 6992: @340694
     /* 340694 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(340790), // Rule ID 5702 //
     /* 340699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340719 */     // MIs[1] Operand 1
     /* 340719 */     // No operand predicates
     /* 340719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340721 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 340721 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 340724 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340728 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340747 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340754 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 340782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340788 */     GIR_RootConstrainSelectedInstOperands,
     /* 340789 */     // GIR_Coverage, 5702,
     /* 340789 */     GIR_EraseRootFromParent_Done,
     /* 340790 */   // Label 6993: @340790
     /* 340790 */   GIM_Reject,
     /* 340791 */ // Label 6960: @340791
     /* 340791 */ GIM_Reject,
     /* 340792 */ // Label 6908: @340792
     /* 340792 */ GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(344431),
     /* 340797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340800 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(340926), // Rule ID 4236 //
     /* 340805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340835 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340838 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340842 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340849 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340859 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340866 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340893 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340925 */     // GIR_Coverage, 4236,
     /* 340925 */     GIR_EraseRootFromParent_Done,
     /* 340926 */   // Label 6995: @340926
     /* 340926 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(341052), // Rule ID 4237 //
     /* 340931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340945 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340951 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340961 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340964 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340968 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340975 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 340992 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 340999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341019 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341051 */     // GIR_Coverage, 4237,
     /* 341051 */     GIR_EraseRootFromParent_Done,
     /* 341052 */   // Label 6996: @341052
     /* 341052 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(341171), // Rule ID 4344 //
     /* 341057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341071 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341077 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341087 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341094 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341104 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341111 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341138 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341170 */     // GIR_Coverage, 4344,
     /* 341170 */     GIR_EraseRootFromParent_Done,
     /* 341171 */   // Label 6997: @341171
     /* 341171 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(341290), // Rule ID 4345 //
     /* 341176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341190 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341196 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341206 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341213 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341223 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341230 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341257 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341289 */     // GIR_Coverage, 4345,
     /* 341289 */     GIR_EraseRootFromParent_Done,
     /* 341290 */   // Label 6998: @341290
     /* 341290 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(341412), // Rule ID 4242 //
     /* 341295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341321 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341324 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341328 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341335 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341352 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341379 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341411 */     // GIR_Coverage, 4242,
     /* 341411 */     GIR_EraseRootFromParent_Done,
     /* 341412 */   // Label 6999: @341412
     /* 341412 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(341534), // Rule ID 4244 //
     /* 341417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341443 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341446 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341450 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341457 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341474 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341501 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341533 */     // GIR_Coverage, 4244,
     /* 341533 */     GIR_EraseRootFromParent_Done,
     /* 341534 */   // Label 7000: @341534
     /* 341534 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(341649), // Rule ID 4350 //
     /* 341539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341565 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341572 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341589 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341616 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341648 */     // GIR_Coverage, 4350,
     /* 341648 */     GIR_EraseRootFromParent_Done,
     /* 341649 */   // Label 7001: @341649
     /* 341649 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(341764), // Rule ID 4352 //
     /* 341654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341680 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341687 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341704 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341731 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341763 */     // GIR_Coverage, 4352,
     /* 341763 */     GIR_EraseRootFromParent_Done,
     /* 341764 */   // Label 7002: @341764
     /* 341764 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(341885), // Rule ID 4234 //
     /* 341769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341783 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341789 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341799 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341802 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341806 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341813 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341830 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 341830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341852 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341884 */     // GIR_Coverage, 4234,
     /* 341884 */     GIR_EraseRootFromParent_Done,
     /* 341885 */   // Label 7003: @341885
     /* 341885 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(342006), // Rule ID 4235 //
     /* 341890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341904 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341910 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341920 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341923 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341927 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341934 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 341951 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 341951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 341958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341973 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342005 */     // GIR_Coverage, 4235,
     /* 342005 */     GIR_EraseRootFromParent_Done,
     /* 342006 */   // Label 7004: @342006
     /* 342006 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(342120), // Rule ID 4342 //
     /* 342011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342041 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342048 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342065 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342087 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342119 */     // GIR_Coverage, 4342,
     /* 342119 */     GIR_EraseRootFromParent_Done,
     /* 342120 */   // Label 7005: @342120
     /* 342120 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(342234), // Rule ID 4343 //
     /* 342125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342139 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342145 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342155 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342162 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342172 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342179 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342201 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342233 */     // GIR_Coverage, 4343,
     /* 342233 */     GIR_EraseRootFromParent_Done,
     /* 342234 */   // Label 7006: @342234
     /* 342234 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(342351), // Rule ID 4238 //
     /* 342239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342265 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342268 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342272 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342279 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342289 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342296 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342318 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342350 */     // GIR_Coverage, 4238,
     /* 342350 */     GIR_EraseRootFromParent_Done,
     /* 342351 */   // Label 7007: @342351
     /* 342351 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(342468), // Rule ID 4240 //
     /* 342356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342382 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342385 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342389 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342396 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342413 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342435 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342467 */     // GIR_Coverage, 4240,
     /* 342467 */     GIR_EraseRootFromParent_Done,
     /* 342468 */   // Label 7008: @342468
     /* 342468 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(342578), // Rule ID 4346 //
     /* 342473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342499 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342506 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342516 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342523 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342545 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342577 */     // GIR_Coverage, 4346,
     /* 342577 */     GIR_EraseRootFromParent_Done,
     /* 342578 */   // Label 7009: @342578
     /* 342578 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(342688), // Rule ID 4348 //
     /* 342583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342609 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342616 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342633 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342655 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342687 */     // GIR_Coverage, 4348,
     /* 342687 */     GIR_EraseRootFromParent_Done,
     /* 342688 */   // Label 7010: @342688
     /* 342688 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(342818), // Rule ID 6444 //
     /* 342693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342722 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342725 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342729 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 342736 */     // MIs[2] Rn
     /* 342736 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 342740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342751 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 342751 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 342754 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342758 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 342772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342780 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 342783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 342787 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342800 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342817 */     // GIR_Coverage, 6444,
     /* 342817 */     GIR_EraseRootFromParent_Done,
     /* 342818 */   // Label 7011: @342818
     /* 342818 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(342958), // Rule ID 5718 //
     /* 342823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342866 */     // MIs[2] Operand 1
     /* 342866 */     // No operand predicates
     /* 342866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342874 */     // MIs[3] Operand 1
     /* 342874 */     // No operand predicates
     /* 342874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342876 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342876 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342879 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342883 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342888 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 342891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 342895 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 342898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342920 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 342926 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 342933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342940 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342957 */     // GIR_Coverage, 5718,
     /* 342957 */     GIR_EraseRootFromParent_Done,
     /* 342958 */   // Label 7012: @342958
     /* 342958 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(343129), // Rule ID 5719 //
     /* 342963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343006 */     // MIs[2] Operand 1
     /* 343006 */     // No operand predicates
     /* 343006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343014 */     // MIs[3] Operand 1
     /* 343014 */     // No operand predicates
     /* 343014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343016 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343016 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 343019 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343023 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343028 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 343031 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343035 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 343038 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343043 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343048 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343051 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343055 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343060 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343063 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343067 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343098 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 343101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343111 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343128 */     // GIR_Coverage, 5719,
     /* 343128 */     GIR_EraseRootFromParent_Done,
     /* 343129 */   // Label 7013: @343129
     /* 343129 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(343269), // Rule ID 5750 //
     /* 343134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343177 */     // MIs[2] Operand 1
     /* 343177 */     // No operand predicates
     /* 343177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343185 */     // MIs[3] Operand 1
     /* 343185 */     // No operand predicates
     /* 343185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343187 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343187 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343194 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343199 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343206 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343268 */     // GIR_Coverage, 5750,
     /* 343268 */     GIR_EraseRootFromParent_Done,
     /* 343269 */   // Label 7014: @343269
     /* 343269 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(343440), // Rule ID 5751 //
     /* 343274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343317 */     // MIs[2] Operand 1
     /* 343317 */     // No operand predicates
     /* 343317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343325 */     // MIs[3] Operand 1
     /* 343325 */     // No operand predicates
     /* 343325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343327 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343327 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 343330 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343334 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343339 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 343342 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343346 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 343349 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343354 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343371 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343378 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343403 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 343412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343422 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343439 */     // GIR_Coverage, 5751,
     /* 343439 */     GIR_EraseRootFromParent_Done,
     /* 343440 */   // Label 7015: @343440
     /* 343440 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(343519), // Rule ID 5671 //
     /* 343445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 343467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343473 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 343473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 343476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 343489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 343508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343518 */     // GIR_Coverage, 5671,
     /* 343518 */     GIR_EraseRootFromParent_Done,
     /* 343519 */   // Label 7016: @343519
     /* 343519 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(343595), // Rule ID 5673 //
     /* 343524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343552 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 343555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343594 */     // GIR_Coverage, 5673,
     /* 343594 */     GIR_EraseRootFromParent_Done,
     /* 343595 */   // Label 7017: @343595
     /* 343595 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(343671), // Rule ID 5683 //
     /* 343600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343628 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 343631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343670 */     // GIR_Coverage, 5683,
     /* 343670 */     GIR_EraseRootFromParent_Done,
     /* 343671 */   // Label 7018: @343671
     /* 343671 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(343816), // Rule ID 5695 //
     /* 343676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 343698 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 343702 */     // MIs[1] Operand 1
     /* 343702 */     // No operand predicates
     /* 343702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343710 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343714 */     // MIs[2] Operand 1
     /* 343714 */     // No operand predicates
     /* 343714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343716 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 343716 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 343719 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343723 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 343730 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 343733 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343737 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343742 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 343745 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 343749 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343752 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 343774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343779 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 343785 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 343791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343798 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343815 */     // GIR_Coverage, 5695,
     /* 343815 */     GIR_EraseRootFromParent_Done,
     /* 343816 */   // Label 7019: @343816
     /* 343816 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(343965), // Rule ID 6447 //
     /* 343821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343846 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343850 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 343857 */     // MIs[1] Rn
     /* 343857 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343878 */     // MIs[2] Operand 1
     /* 343878 */     // No operand predicates
     /* 343878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343880 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 343880 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343883 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343887 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343892 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343895 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 343899 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343902 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343907 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 343919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343924 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 343930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343934 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343947 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343964 */     // GIR_Coverage, 6447,
     /* 343964 */     GIR_EraseRootFromParent_Done,
     /* 343965 */   // Label 7020: @343965
     /* 343965 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(344107), // Rule ID 6450 //
     /* 343970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343992 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343999 */     // MIs[1] Rn
     /* 343999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 344003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 344008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 344012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344016 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 344020 */     // MIs[2] Operand 1
     /* 344020 */     // No operand predicates
     /* 344020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344022 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 344022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 344025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344034 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 344037 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 344041 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 344061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 344072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344076 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344089 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344106 */     // GIR_Coverage, 6450,
     /* 344106 */     GIR_EraseRootFromParent_Done,
     /* 344107 */   // Label 7021: @344107
     /* 344107 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(344295), // Rule ID 5693 //
     /* 344112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 344142 */     // MIs[1] Operand 1
     /* 344142 */     // No operand predicates
     /* 344142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344144 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 344144 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 344147 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344151 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 344158 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 344161 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344165 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344170 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 344173 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344177 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 344180 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344185 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344190 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344195 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 344198 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344202 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 344212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344221 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344224 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344228 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344241 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 344253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344258 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 344264 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 344270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344294 */     // GIR_Coverage, 5693,
     /* 344294 */     GIR_EraseRootFromParent_Done,
     /* 344295 */   // Label 7022: @344295
     /* 344295 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(344430), // Rule ID 5704 //
     /* 344300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 344330 */     // MIs[1] Operand 1
     /* 344330 */     // No operand predicates
     /* 344330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344332 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 344332 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 344335 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344339 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344346 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 344349 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344353 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344358 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344361 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344365 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344368 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344373 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344378 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 344390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 344401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344429 */     // GIR_Coverage, 5704,
     /* 344429 */     GIR_EraseRootFromParent_Done,
     /* 344430 */   // Label 7023: @344430
     /* 344430 */   GIM_Reject,
     /* 344431 */ // Label 6994: @344431
     /* 344431 */ GIM_Reject,
     /* 344432 */ // Label 6909: @344432
     /* 344432 */ GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(347321),
     /* 344437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344450 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(344559), // Rule ID 4260 //
     /* 344455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344459 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344465 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344475 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344478 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344482 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344499 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344526 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344558 */     // GIR_Coverage, 4260,
     /* 344558 */     GIR_EraseRootFromParent_Done,
     /* 344559 */   // Label 7025: @344559
     /* 344559 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(344668), // Rule ID 4261 //
     /* 344564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344568 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344574 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344584 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344591 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344608 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344635 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344667 */     // GIR_Coverage, 4261,
     /* 344667 */     GIR_EraseRootFromParent_Done,
     /* 344668 */   // Label 7026: @344668
     /* 344668 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(344777), // Rule ID 4368 //
     /* 344673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344677 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344683 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344693 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344700 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344717 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344744 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344776 */     // GIR_Coverage, 4368,
     /* 344776 */     GIR_EraseRootFromParent_Done,
     /* 344777 */   // Label 7027: @344777
     /* 344777 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(344886), // Rule ID 4369 //
     /* 344782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344786 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344792 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344802 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344805 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344809 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344826 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344853 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344885 */     // GIR_Coverage, 4369,
     /* 344885 */     GIR_EraseRootFromParent_Done,
     /* 344886 */   // Label 7028: @344886
     /* 344886 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(344991), // Rule ID 4266 //
     /* 344891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344907 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344914 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344931 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344958 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344990 */     // GIR_Coverage, 4266,
     /* 344990 */     GIR_EraseRootFromParent_Done,
     /* 344991 */   // Label 7029: @344991
     /* 344991 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(345096), // Rule ID 4268 //
     /* 344996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345012 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345019 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345036 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345063 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345095 */     // GIR_Coverage, 4268,
     /* 345095 */     GIR_EraseRootFromParent_Done,
     /* 345096 */   // Label 7030: @345096
     /* 345096 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(345201), // Rule ID 4374 //
     /* 345101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345117 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345124 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345134 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345141 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345168 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345200 */     // GIR_Coverage, 4374,
     /* 345200 */     GIR_EraseRootFromParent_Done,
     /* 345201 */   // Label 7031: @345201
     /* 345201 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(345306), // Rule ID 4376 //
     /* 345206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345222 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345229 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345246 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345273 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345305 */     // GIR_Coverage, 4376,
     /* 345305 */     GIR_EraseRootFromParent_Done,
     /* 345306 */   // Label 7032: @345306
     /* 345306 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(345410), // Rule ID 4258 //
     /* 345311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345331 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345338 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345348 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345355 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345377 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345409 */     // GIR_Coverage, 4258,
     /* 345409 */     GIR_EraseRootFromParent_Done,
     /* 345410 */   // Label 7033: @345410
     /* 345410 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(345514), // Rule ID 4259 //
     /* 345415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345419 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345425 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345435 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345442 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345459 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345481 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345513 */     // GIR_Coverage, 4259,
     /* 345513 */     GIR_EraseRootFromParent_Done,
     /* 345514 */   // Label 7034: @345514
     /* 345514 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(345618), // Rule ID 4366 //
     /* 345519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345539 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345542 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345546 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345563 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345585 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345617 */     // GIR_Coverage, 4366,
     /* 345617 */     GIR_EraseRootFromParent_Done,
     /* 345618 */   // Label 7035: @345618
     /* 345618 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(345722), // Rule ID 4367 //
     /* 345623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345627 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345633 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345643 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345650 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345667 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345689 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345721 */     // GIR_Coverage, 4367,
     /* 345721 */     GIR_EraseRootFromParent_Done,
     /* 345722 */   // Label 7036: @345722
     /* 345722 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(345822), // Rule ID 4262 //
     /* 345727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345743 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345750 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345767 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345789 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345821 */     // GIR_Coverage, 4262,
     /* 345821 */     GIR_EraseRootFromParent_Done,
     /* 345822 */   // Label 7037: @345822
     /* 345822 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(345922), // Rule ID 4264 //
     /* 345827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345843 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345850 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345867 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345889 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345921 */     // GIR_Coverage, 4264,
     /* 345921 */     GIR_EraseRootFromParent_Done,
     /* 345922 */   // Label 7038: @345922
     /* 345922 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(346022), // Rule ID 4370 //
     /* 345927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345943 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345950 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345967 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345989 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346021 */     // GIR_Coverage, 4370,
     /* 346021 */     GIR_EraseRootFromParent_Done,
     /* 346022 */   // Label 7039: @346022
     /* 346022 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(346122), // Rule ID 4372 //
     /* 346027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346043 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346050 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346067 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346089 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346121 */     // GIR_Coverage, 4372,
     /* 346121 */     GIR_EraseRootFromParent_Done,
     /* 346122 */   // Label 7040: @346122
     /* 346122 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(346235), // Rule ID 5724 //
     /* 346127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 346151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346164 */     // MIs[3] Operand 1
     /* 346164 */     // No operand predicates
     /* 346164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346170 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 346170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 346173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 346177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 346186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 346189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 346216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346234 */     // GIR_Coverage, 5724,
     /* 346234 */     GIR_EraseRootFromParent_Done,
     /* 346235 */   // Label 7041: @346235
     /* 346235 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(346348), // Rule ID 5756 //
     /* 346240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 346264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 346273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346277 */     // MIs[3] Operand 1
     /* 346277 */     // No operand predicates
     /* 346277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346283 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 346283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 346286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 346290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346295 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 346299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 346302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 346329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346347 */     // GIR_Coverage, 5756,
     /* 346347 */     GIR_EraseRootFromParent_Done,
     /* 346348 */   // Label 7042: @346348
     /* 346348 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(346426), // Rule ID 1940 //
     /* 346353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346389 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346393 */     // MIs[2] Operand 1
     /* 346393 */     // No operand predicates
     /* 346393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346401 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346405 */     // MIs[3] Operand 1
     /* 346405 */     // No operand predicates
     /* 346405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346407 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 346407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 346417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 346424 */     GIR_RootConstrainSelectedInstOperands,
     /* 346425 */     // GIR_Coverage, 1940,
     /* 346425 */     GIR_EraseRootFromParent_Done,
     /* 346426 */   // Label 7043: @346426
     /* 346426 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(346493), // Rule ID 5723 //
     /* 346431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346464 */     // MIs[2] Operand 1
     /* 346464 */     // No operand predicates
     /* 346464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346472 */     // MIs[3] Operand 1
     /* 346472 */     // No operand predicates
     /* 346472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346474 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 346474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346479 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346491 */     GIR_RootConstrainSelectedInstOperands,
     /* 346492 */     // GIR_Coverage, 5723,
     /* 346492 */     GIR_EraseRootFromParent_Done,
     /* 346493 */   // Label 7044: @346493
     /* 346493 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(346591), // Rule ID 5725 //
     /* 346498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346531 */     // MIs[2] Operand 1
     /* 346531 */     // No operand predicates
     /* 346531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346535 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346539 */     // MIs[3] Operand 1
     /* 346539 */     // No operand predicates
     /* 346539 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346541 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 346541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346553 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 346563 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346589 */     GIR_RootConstrainSelectedInstOperands,
     /* 346590 */     // GIR_Coverage, 5725,
     /* 346590 */     GIR_EraseRootFromParent_Done,
     /* 346591 */   // Label 7045: @346591
     /* 346591 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(346658), // Rule ID 5755 //
     /* 346596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346629 */     // MIs[2] Operand 1
     /* 346629 */     // No operand predicates
     /* 346629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346637 */     // MIs[3] Operand 1
     /* 346637 */     // No operand predicates
     /* 346637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346639 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 346639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346644 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346656 */     GIR_RootConstrainSelectedInstOperands,
     /* 346657 */     // GIR_Coverage, 5755,
     /* 346657 */     GIR_EraseRootFromParent_Done,
     /* 346658 */   // Label 7046: @346658
     /* 346658 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(346756), // Rule ID 5757 //
     /* 346663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346696 */     // MIs[2] Operand 1
     /* 346696 */     // No operand predicates
     /* 346696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346704 */     // MIs[3] Operand 1
     /* 346704 */     // No operand predicates
     /* 346704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346706 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 346706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 346728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346754 */     GIR_RootConstrainSelectedInstOperands,
     /* 346755 */     // GIR_Coverage, 5757,
     /* 346755 */     GIR_EraseRootFromParent_Done,
     /* 346756 */   // Label 7047: @346756
     /* 346756 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(346822), // Rule ID 5679 //
     /* 346761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346779 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 346779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346821 */     // GIR_Coverage, 5679,
     /* 346821 */     GIR_EraseRootFromParent_Done,
     /* 346822 */   // Label 7048: @346822
     /* 346822 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(346888), // Rule ID 5687 //
     /* 346827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346845 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 346845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346887 */     // GIR_Coverage, 5687,
     /* 346887 */     GIR_EraseRootFromParent_Done,
     /* 346888 */   // Label 7049: @346888
     /* 346888 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(346941), // Rule ID 5696 //
     /* 346893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 346905 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 346909 */     // MIs[1] Operand 1
     /* 346909 */     // No operand predicates
     /* 346909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346921 */     // MIs[2] Operand 1
     /* 346921 */     // No operand predicates
     /* 346921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346923 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 346923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 346926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 346933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 346939 */     GIR_RootConstrainSelectedInstOperands,
     /* 346940 */     // GIR_Coverage, 5696,
     /* 346940 */     GIR_EraseRootFromParent_Done,
     /* 346941 */   // Label 7050: @346941
     /* 346941 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(347010), // Rule ID 6429 //
     /* 346946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 346965 */     // MIs[1] Rn
     /* 346965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 346969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346982 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346986 */     // MIs[2] Operand 1
     /* 346986 */     // No operand predicates
     /* 346986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346988 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 346988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 346991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 346998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347008 */     GIR_RootConstrainSelectedInstOperands,
     /* 347009 */     // GIR_Coverage, 6429,
     /* 347009 */     GIR_EraseRootFromParent_Done,
     /* 347010 */   // Label 7051: @347010
     /* 347010 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(347079), // Rule ID 6430 //
     /* 347015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347027 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347034 */     // MIs[1] Rn
     /* 347034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347051 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347055 */     // MIs[2] Operand 1
     /* 347055 */     // No operand predicates
     /* 347055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347057 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 347057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 347060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 347064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 347067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347077 */     GIR_RootConstrainSelectedInstOperands,
     /* 347078 */     // GIR_Coverage, 6430,
     /* 347078 */     GIR_EraseRootFromParent_Done,
     /* 347079 */   // Label 7052: @347079
     /* 347079 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(347180), // Rule ID 5768 //
     /* 347084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 347092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 347096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347109 */     // MIs[2] Operand 1
     /* 347109 */     // No operand predicates
     /* 347109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347111 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 347111 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 347114 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347118 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 347125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347137 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 347144 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 347147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 347165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347167 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 347169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 347172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347178 */     GIR_RootConstrainSelectedInstOperands,
     /* 347179 */     // GIR_Coverage, 5768,
     /* 347179 */     GIR_EraseRootFromParent_Done,
     /* 347180 */   // Label 7053: @347180
     /* 347180 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(347224), // Rule ID 1936 //
     /* 347185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347208 */     // MIs[1] Operand 1
     /* 347208 */     // No operand predicates
     /* 347208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347210 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 347210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 347213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 347217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 347220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 347222 */     GIR_RootConstrainSelectedInstOperands,
     /* 347223 */     // GIR_Coverage, 1936,
     /* 347223 */     GIR_EraseRootFromParent_Done,
     /* 347224 */   // Label 7054: @347224
     /* 347224 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(347320), // Rule ID 5701 //
     /* 347229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347249 */     // MIs[1] Operand 1
     /* 347249 */     // No operand predicates
     /* 347249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347251 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 347251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 347254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 347265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 347268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 347284 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 347287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 347305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347318 */     GIR_RootConstrainSelectedInstOperands,
     /* 347319 */     // GIR_Coverage, 5701,
     /* 347319 */     GIR_EraseRootFromParent_Done,
     /* 347320 */   // Label 7055: @347320
     /* 347320 */   GIM_Reject,
     /* 347321 */ // Label 7024: @347321
     /* 347321 */ GIM_Reject,
     /* 347322 */ // Label 6910: @347322
     /* 347322 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(349165),
     /* 347327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347330 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(347456), // Rule ID 4200 //
     /* 347335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347349 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347355 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347365 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347368 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347372 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347379 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347389 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 347396 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 347403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347423 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347455 */     // GIR_Coverage, 4200,
     /* 347455 */     GIR_EraseRootFromParent_Done,
     /* 347456 */   // Label 7057: @347456
     /* 347456 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(347582), // Rule ID 4201 //
     /* 347461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347475 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347481 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347491 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347494 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347498 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347505 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347515 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 347522 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 347529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347549 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347581 */     // GIR_Coverage, 4201,
     /* 347581 */     GIR_EraseRootFromParent_Done,
     /* 347582 */   // Label 7058: @347582
     /* 347582 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(347704), // Rule ID 4206 //
     /* 347587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347613 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347616 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347620 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347627 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 347644 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 347651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347671 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347703 */     // GIR_Coverage, 4206,
     /* 347703 */     GIR_EraseRootFromParent_Done,
     /* 347704 */   // Label 7059: @347704
     /* 347704 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(347826), // Rule ID 4208 //
     /* 347709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347735 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347738 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347742 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347749 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 347766 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 347773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347793 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347825 */     // GIR_Coverage, 4208,
     /* 347825 */     GIR_EraseRootFromParent_Done,
     /* 347826 */   // Label 7060: @347826
     /* 347826 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(347947), // Rule ID 4198 //
     /* 347831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347845 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347851 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347861 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347864 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347868 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347875 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347885 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 347892 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 347892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 347899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347914 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347946 */     // GIR_Coverage, 4198,
     /* 347946 */     GIR_EraseRootFromParent_Done,
     /* 347947 */   // Label 7061: @347947
     /* 347947 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(348068), // Rule ID 4199 //
     /* 347952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347966 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347972 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347982 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347985 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347989 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347996 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 348013 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 348013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 348020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348035 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348067 */     // GIR_Coverage, 4199,
     /* 348067 */     GIR_EraseRootFromParent_Done,
     /* 348068 */   // Label 7062: @348068
     /* 348068 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(348185), // Rule ID 4202 //
     /* 348073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348099 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348102 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348106 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348113 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 348130 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 348130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 348137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348152 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348184 */     // GIR_Coverage, 4202,
     /* 348184 */     GIR_EraseRootFromParent_Done,
     /* 348185 */   // Label 7063: @348185
     /* 348185 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(348302), // Rule ID 4204 //
     /* 348190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348216 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348219 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348223 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348230 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 348247 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 348247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 348254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348269 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348301 */     // GIR_Coverage, 4204,
     /* 348301 */     GIR_EraseRootFromParent_Done,
     /* 348302 */   // Label 7064: @348302
     /* 348302 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(348442), // Rule ID 5742 //
     /* 348307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348350 */     // MIs[2] Operand 1
     /* 348350 */     // No operand predicates
     /* 348350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348358 */     // MIs[3] Operand 1
     /* 348358 */     // No operand predicates
     /* 348358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348360 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 348360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348372 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 348379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348404 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 348410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 348417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348424 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348441 */     // GIR_Coverage, 5742,
     /* 348441 */     GIR_EraseRootFromParent_Done,
     /* 348442 */   // Label 7065: @348442
     /* 348442 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(348613), // Rule ID 5743 //
     /* 348447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348490 */     // MIs[2] Operand 1
     /* 348490 */     // No operand predicates
     /* 348490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348498 */     // MIs[3] Operand 1
     /* 348498 */     // No operand predicates
     /* 348498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348500 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 348500 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 348503 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348507 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348512 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 348515 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348519 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 348522 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348527 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348544 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 348551 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 348582 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 348585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 348588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348595 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348612 */     // GIR_Coverage, 5743,
     /* 348612 */     GIR_EraseRootFromParent_Done,
     /* 348613 */   // Label 7066: @348613
     /* 348613 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(348692), // Rule ID 5666 //
     /* 348618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348646 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 348646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 348662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348691 */     // GIR_Coverage, 5666,
     /* 348691 */     GIR_EraseRootFromParent_Done,
     /* 348692 */   // Label 7067: @348692
     /* 348692 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(348841), // Rule ID 6446 //
     /* 348697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348719 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348722 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 348726 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348733 */     // MIs[1] Rn
     /* 348733 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 348737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 348742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 348746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348750 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348754 */     // MIs[2] Operand 1
     /* 348754 */     // No operand predicates
     /* 348754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348756 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 348756 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348759 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348763 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348768 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348771 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 348775 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348778 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348783 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 348795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348800 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 348806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348823 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348840 */     // GIR_Coverage, 6446,
     /* 348840 */     GIR_EraseRootFromParent_Done,
     /* 348841 */   // Label 7068: @348841
     /* 348841 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(348976), // Rule ID 5705 //
     /* 348846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 348868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348876 */     // MIs[1] Operand 1
     /* 348876 */     // No operand predicates
     /* 348876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348878 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 348878 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 348881 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348885 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348892 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 348895 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348899 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348904 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 348907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348911 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348924 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 348936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348941 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 348947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 348951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348958 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348975 */     // GIR_Coverage, 5705,
     /* 348975 */     GIR_EraseRootFromParent_Done,
     /* 348976 */   // Label 7069: @348976
     /* 348976 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(349164), // Rule ID 5706 //
     /* 348981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 348984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 349003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 349011 */     // MIs[1] Operand 1
     /* 349011 */     // No operand predicates
     /* 349011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349013 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349013 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 349016 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349020 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 349027 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 349030 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349034 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349039 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 349042 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 349046 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 349049 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349054 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349059 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349064 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 349067 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349071 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 349081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349090 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349097 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 349100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 349122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 349133 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349136 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 349139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349146 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349163 */     // GIR_Coverage, 5706,
     /* 349163 */     GIR_EraseRootFromParent_Done,
     /* 349164 */   // Label 7070: @349164
     /* 349164 */   GIM_Reject,
     /* 349165 */ // Label 7056: @349165
     /* 349165 */ GIM_Reject,
     /* 349166 */ // Label 6911: @349166
     /* 349166 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(352386),
     /* 349171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349174 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(349300), // Rule ID 4224 //
     /* 349179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349193 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349199 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349209 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349212 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349216 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349223 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349240 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349267 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349299 */     // GIR_Coverage, 4224,
     /* 349299 */     GIR_EraseRootFromParent_Done,
     /* 349300 */   // Label 7072: @349300
     /* 349300 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(349426), // Rule ID 4225 //
     /* 349305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349319 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349325 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349335 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349338 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349342 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349349 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349366 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349393 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349415 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349425 */     // GIR_Coverage, 4225,
     /* 349425 */     GIR_EraseRootFromParent_Done,
     /* 349426 */   // Label 7073: @349426
     /* 349426 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(349545), // Rule ID 4332 //
     /* 349431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349445 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349451 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349461 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349464 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349468 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349478 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349485 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349544 */     // GIR_Coverage, 4332,
     /* 349544 */     GIR_EraseRootFromParent_Done,
     /* 349545 */   // Label 7074: @349545
     /* 349545 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(349664), // Rule ID 4333 //
     /* 349550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349564 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349570 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349580 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349587 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349604 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349631 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349663 */     // GIR_Coverage, 4333,
     /* 349663 */     GIR_EraseRootFromParent_Done,
     /* 349664 */   // Label 7075: @349664
     /* 349664 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(349786), // Rule ID 4230 //
     /* 349669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349695 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349698 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349702 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349709 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349726 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349753 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349785 */     // GIR_Coverage, 4230,
     /* 349785 */     GIR_EraseRootFromParent_Done,
     /* 349786 */   // Label 7076: @349786
     /* 349786 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(349908), // Rule ID 4232 //
     /* 349791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349817 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349820 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349824 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349831 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349848 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349875 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349907 */     // GIR_Coverage, 4232,
     /* 349907 */     GIR_EraseRootFromParent_Done,
     /* 349908 */   // Label 7077: @349908
     /* 349908 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(350023), // Rule ID 4338 //
     /* 349913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349946 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349963 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349990 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350022 */     // GIR_Coverage, 4338,
     /* 350022 */     GIR_EraseRootFromParent_Done,
     /* 350023 */   // Label 7078: @350023
     /* 350023 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(350138), // Rule ID 4340 //
     /* 350028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350054 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350057 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350061 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 350078 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 350078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 350085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350105 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350137 */     // GIR_Coverage, 4340,
     /* 350137 */     GIR_EraseRootFromParent_Done,
     /* 350138 */   // Label 7079: @350138
     /* 350138 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(350259), // Rule ID 4222 //
     /* 350143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350157 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350163 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350173 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350176 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350180 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350187 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350204 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350226 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350258 */     // GIR_Coverage, 4222,
     /* 350258 */     GIR_EraseRootFromParent_Done,
     /* 350259 */   // Label 7080: @350259
     /* 350259 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(350380), // Rule ID 4223 //
     /* 350264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350278 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350284 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350294 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350297 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350301 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350308 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350325 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350347 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350379 */     // GIR_Coverage, 4223,
     /* 350379 */     GIR_EraseRootFromParent_Done,
     /* 350380 */   // Label 7081: @350380
     /* 350380 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(350494), // Rule ID 4330 //
     /* 350385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350399 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350405 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350415 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350422 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350439 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350461 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350493 */     // GIR_Coverage, 4330,
     /* 350493 */     GIR_EraseRootFromParent_Done,
     /* 350494 */   // Label 7082: @350494
     /* 350494 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(350608), // Rule ID 4331 //
     /* 350499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350513 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350519 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350529 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350536 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350553 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350575 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350607 */     // GIR_Coverage, 4331,
     /* 350607 */     GIR_EraseRootFromParent_Done,
     /* 350608 */   // Label 7083: @350608
     /* 350608 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(350725), // Rule ID 4226 //
     /* 350613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350639 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350642 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350646 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350653 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350663 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350670 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350692 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350724 */     // GIR_Coverage, 4226,
     /* 350724 */     GIR_EraseRootFromParent_Done,
     /* 350725 */   // Label 7084: @350725
     /* 350725 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(350842), // Rule ID 4228 //
     /* 350730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350756 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350759 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350763 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350770 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350780 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350787 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350809 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350841 */     // GIR_Coverage, 4228,
     /* 350841 */     GIR_EraseRootFromParent_Done,
     /* 350842 */   // Label 7085: @350842
     /* 350842 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(350952), // Rule ID 4334 //
     /* 350847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350873 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350880 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350897 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350919 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350951 */     // GIR_Coverage, 4334,
     /* 350951 */     GIR_EraseRootFromParent_Done,
     /* 350952 */   // Label 7086: @350952
     /* 350952 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(351062), // Rule ID 4336 //
     /* 350957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350983 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350986 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350990 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 351007 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 351007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 351014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351029 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351061 */     // GIR_Coverage, 4336,
     /* 351061 */     GIR_EraseRootFromParent_Done,
     /* 351062 */   // Label 7087: @351062
     /* 351062 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(351185), // Rule ID 5716 //
     /* 351067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 351101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 351110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351114 */     // MIs[3] Operand 1
     /* 351114 */     // No operand predicates
     /* 351114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351120 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 351120 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 351123 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 351127 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351132 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 351136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 351139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 351166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351184 */     // GIR_Coverage, 5716,
     /* 351184 */     GIR_EraseRootFromParent_Done,
     /* 351185 */   // Label 7088: @351185
     /* 351185 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(351308), // Rule ID 5748 //
     /* 351190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 351224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 351233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351237 */     // MIs[3] Operand 1
     /* 351237 */     // No operand predicates
     /* 351237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351243 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 351243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 351246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 351250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 351259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 351262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 351289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351292 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351307 */     // GIR_Coverage, 5748,
     /* 351307 */     GIR_EraseRootFromParent_Done,
     /* 351308 */   // Label 7089: @351308
     /* 351308 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(351396), // Rule ID 1939 //
     /* 351313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351359 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351363 */     // MIs[2] Operand 1
     /* 351363 */     // No operand predicates
     /* 351363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351371 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351375 */     // MIs[3] Operand 1
     /* 351375 */     // No operand predicates
     /* 351375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351377 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 351377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 351384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 351387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 351394 */     GIR_RootConstrainSelectedInstOperands,
     /* 351395 */     // GIR_Coverage, 1939,
     /* 351395 */     GIR_EraseRootFromParent_Done,
     /* 351396 */   // Label 7090: @351396
     /* 351396 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(351473), // Rule ID 5715 //
     /* 351401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351444 */     // MIs[2] Operand 1
     /* 351444 */     // No operand predicates
     /* 351444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351452 */     // MIs[3] Operand 1
     /* 351452 */     // No operand predicates
     /* 351452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351454 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 351454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351459 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351471 */     GIR_RootConstrainSelectedInstOperands,
     /* 351472 */     // GIR_Coverage, 5715,
     /* 351472 */     GIR_EraseRootFromParent_Done,
     /* 351473 */   // Label 7091: @351473
     /* 351473 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(351581), // Rule ID 5717 //
     /* 351478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 351504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351521 */     // MIs[2] Operand 1
     /* 351521 */     // No operand predicates
     /* 351521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351529 */     // MIs[3] Operand 1
     /* 351529 */     // No operand predicates
     /* 351529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351531 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 351531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 351546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 351553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351579 */     GIR_RootConstrainSelectedInstOperands,
     /* 351580 */     // GIR_Coverage, 5717,
     /* 351580 */     GIR_EraseRootFromParent_Done,
     /* 351581 */   // Label 7092: @351581
     /* 351581 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(351658), // Rule ID 5747 //
     /* 351586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351629 */     // MIs[2] Operand 1
     /* 351629 */     // No operand predicates
     /* 351629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351637 */     // MIs[3] Operand 1
     /* 351637 */     // No operand predicates
     /* 351637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351639 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 351639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351644 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351656 */     GIR_RootConstrainSelectedInstOperands,
     /* 351657 */     // GIR_Coverage, 5747,
     /* 351657 */     GIR_EraseRootFromParent_Done,
     /* 351658 */   // Label 7093: @351658
     /* 351658 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(351766), // Rule ID 5749 //
     /* 351663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 351689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351706 */     // MIs[2] Operand 1
     /* 351706 */     // No operand predicates
     /* 351706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351714 */     // MIs[3] Operand 1
     /* 351714 */     // No operand predicates
     /* 351714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351716 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 351716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351728 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 351731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351735 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 351738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351764 */     GIR_RootConstrainSelectedInstOperands,
     /* 351765 */     // GIR_Coverage, 5749,
     /* 351765 */     GIR_EraseRootFromParent_Done,
     /* 351766 */   // Label 7094: @351766
     /* 351766 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(351845), // Rule ID 5669 //
     /* 351771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351799 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 351799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 351802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 351815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 351834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351844 */     // GIR_Coverage, 5669,
     /* 351844 */     GIR_EraseRootFromParent_Done,
     /* 351845 */   // Label 7095: @351845
     /* 351845 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(351921), // Rule ID 5675 //
     /* 351850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351878 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 351878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351920 */     // GIR_Coverage, 5675,
     /* 351920 */     GIR_EraseRootFromParent_Done,
     /* 351921 */   // Label 7096: @351921
     /* 351921 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(351997), // Rule ID 5685 //
     /* 351926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351954 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 351954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351996 */     // GIR_Coverage, 5685,
     /* 351996 */     GIR_EraseRootFromParent_Done,
     /* 351997 */   // Label 7097: @351997
     /* 351997 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(352060), // Rule ID 5694 //
     /* 352002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 352024 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 352028 */     // MIs[1] Operand 1
     /* 352028 */     // No operand predicates
     /* 352028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 352032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352036 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352040 */     // MIs[2] Operand 1
     /* 352040 */     // No operand predicates
     /* 352040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352042 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 352042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 352045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 352052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352058 */     GIR_RootConstrainSelectedInstOperands,
     /* 352059 */     // GIR_Coverage, 5694,
     /* 352059 */     GIR_EraseRootFromParent_Done,
     /* 352060 */   // Label 7098: @352060
     /* 352060 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(352146), // Rule ID 6428 //
     /* 352065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352090 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 352094 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352101 */     // MIs[1] Rn
     /* 352101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 352105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 352110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 352114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352118 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352122 */     // MIs[2] Operand 1
     /* 352122 */     // No operand predicates
     /* 352122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352124 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 352124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 352127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 352134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352144 */     GIR_RootConstrainSelectedInstOperands,
     /* 352145 */     // GIR_Coverage, 6428,
     /* 352145 */     GIR_EraseRootFromParent_Done,
     /* 352146 */   // Label 7099: @352146
     /* 352146 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(352225), // Rule ID 6433 //
     /* 352151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352173 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 352180 */     // MIs[1] Rn
     /* 352180 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 352184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 352189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 352193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352201 */     // MIs[2] Operand 1
     /* 352201 */     // No operand predicates
     /* 352201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352203 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 352203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 352206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 352213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352223 */     GIR_RootConstrainSelectedInstOperands,
     /* 352224 */     // GIR_Coverage, 6433,
     /* 352224 */     GIR_EraseRootFromParent_Done,
     /* 352225 */   // Label 7100: @352225
     /* 352225 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(352279), // Rule ID 1935 //
     /* 352230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352263 */     // MIs[1] Operand 1
     /* 352263 */     // No operand predicates
     /* 352263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352265 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 352265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 352268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 352277 */     GIR_RootConstrainSelectedInstOperands,
     /* 352278 */     // GIR_Coverage, 1935,
     /* 352278 */     GIR_EraseRootFromParent_Done,
     /* 352279 */   // Label 7101: @352279
     /* 352279 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(352385), // Rule ID 5699 //
     /* 352284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352314 */     // MIs[1] Operand 1
     /* 352314 */     // No operand predicates
     /* 352314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352316 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 352316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 352319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 352333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 352337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 352349 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 352352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 352370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 352377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352383 */     GIR_RootConstrainSelectedInstOperands,
     /* 352384 */     // GIR_Coverage, 5699,
     /* 352384 */     GIR_EraseRootFromParent_Done,
     /* 352385 */   // Label 7102: @352385
     /* 352385 */   GIM_Reject,
     /* 352386 */ // Label 7071: @352386
     /* 352386 */ GIM_Reject,
     /* 352387 */ // Label 6912: @352387
     /* 352387 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(354089),
     /* 352392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 352395 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(352521), // Rule ID 4188 //
     /* 352400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352414 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352420 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352430 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352433 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352437 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352444 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 352461 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 352468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352488 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352520 */     // GIR_Coverage, 4188,
     /* 352520 */     GIR_EraseRootFromParent_Done,
     /* 352521 */   // Label 7104: @352521
     /* 352521 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(352647), // Rule ID 4189 //
     /* 352526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352556 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352559 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352563 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352570 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 352587 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 352594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352614 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352646 */     // GIR_Coverage, 4189,
     /* 352646 */     GIR_EraseRootFromParent_Done,
     /* 352647 */   // Label 7105: @352647
     /* 352647 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(352769), // Rule ID 4194 //
     /* 352652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352678 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352681 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352685 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352692 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 352709 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 352716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352736 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352768 */     // GIR_Coverage, 4194,
     /* 352768 */     GIR_EraseRootFromParent_Done,
     /* 352769 */   // Label 7106: @352769
     /* 352769 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(352891), // Rule ID 4196 //
     /* 352774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352800 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352803 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352807 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352814 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352824 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 352831 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 352838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352858 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352890 */     // GIR_Coverage, 4196,
     /* 352890 */     GIR_EraseRootFromParent_Done,
     /* 352891 */   // Label 7107: @352891
     /* 352891 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(353012), // Rule ID 4186 //
     /* 352896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352910 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352916 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352926 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352929 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352933 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352940 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 352957 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 352957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 352964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352979 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 353001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353011 */     // GIR_Coverage, 4186,
     /* 353011 */     GIR_EraseRootFromParent_Done,
     /* 353012 */   // Label 7108: @353012
     /* 353012 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(353133), // Rule ID 4187 //
     /* 353017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353031 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353037 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353047 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353050 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353054 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353061 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 353078 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 353078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 353081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 353085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353100 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 353122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353132 */     // GIR_Coverage, 4187,
     /* 353132 */     GIR_EraseRootFromParent_Done,
     /* 353133 */   // Label 7109: @353133
     /* 353133 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(353250), // Rule ID 4190 //
     /* 353138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353164 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353167 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353171 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353178 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 353195 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 353195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 353198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 353202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353217 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 353239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353249 */     // GIR_Coverage, 4190,
     /* 353249 */     GIR_EraseRootFromParent_Done,
     /* 353250 */   // Label 7110: @353250
     /* 353250 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(353367), // Rule ID 4192 //
     /* 353255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353281 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353284 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353288 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353295 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 353312 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 353312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 353315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 353319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353334 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 353356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353366 */     // GIR_Coverage, 4192,
     /* 353366 */     GIR_EraseRootFromParent_Done,
     /* 353367 */   // Label 7111: @353367
     /* 353367 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(353490), // Rule ID 5740 //
     /* 353372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 353402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 353406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 353415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353419 */     // MIs[3] Operand 1
     /* 353419 */     // No operand predicates
     /* 353419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353425 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 353425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 353428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 353432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353437 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 353441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 353444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 353449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 353471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 353474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353489 */     // GIR_Coverage, 5740,
     /* 353489 */     GIR_EraseRootFromParent_Done,
     /* 353490 */   // Label 7112: @353490
     /* 353490 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(353578), // Rule ID 1938 //
     /* 353495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 353524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353545 */     // MIs[2] Operand 1
     /* 353545 */     // No operand predicates
     /* 353545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353553 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353557 */     // MIs[3] Operand 1
     /* 353557 */     // No operand predicates
     /* 353557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353559 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 353559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 353569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 353576 */     GIR_RootConstrainSelectedInstOperands,
     /* 353577 */     // GIR_Coverage, 1938,
     /* 353577 */     GIR_EraseRootFromParent_Done,
     /* 353578 */   // Label 7113: @353578
     /* 353578 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(353655), // Rule ID 5739 //
     /* 353583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 353609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353626 */     // MIs[2] Operand 1
     /* 353626 */     // No operand predicates
     /* 353626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353634 */     // MIs[3] Operand 1
     /* 353634 */     // No operand predicates
     /* 353634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353636 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 353636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353653 */     GIR_RootConstrainSelectedInstOperands,
     /* 353654 */     // GIR_Coverage, 5739,
     /* 353654 */     GIR_EraseRootFromParent_Done,
     /* 353655 */   // Label 7114: @353655
     /* 353655 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(353763), // Rule ID 5741 //
     /* 353660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 353686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353703 */     // MIs[2] Operand 1
     /* 353703 */     // No operand predicates
     /* 353703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353711 */     // MIs[3] Operand 1
     /* 353711 */     // No operand predicates
     /* 353711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353713 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 353713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 353728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353732 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 353735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353750 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353761 */     GIR_RootConstrainSelectedInstOperands,
     /* 353762 */     // GIR_Coverage, 5741,
     /* 353762 */     GIR_EraseRootFromParent_Done,
     /* 353763 */   // Label 7115: @353763
     /* 353763 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353842), // Rule ID 5664 //
     /* 353768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353790 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353796 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 353796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 353812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353841 */     // GIR_Coverage, 5664,
     /* 353841 */     GIR_EraseRootFromParent_Done,
     /* 353842 */   // Label 7116: @353842
     /* 353842 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(353928), // Rule ID 6427 //
     /* 353847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353872 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 353876 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353883 */     // MIs[1] Rn
     /* 353883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 353887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 353892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 353896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353900 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353904 */     // MIs[2] Operand 1
     /* 353904 */     // No operand predicates
     /* 353904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353906 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 353906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 353909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 353916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353926 */     GIR_RootConstrainSelectedInstOperands,
     /* 353927 */     // GIR_Coverage, 6427,
     /* 353927 */     GIR_EraseRootFromParent_Done,
     /* 353928 */   // Label 7117: @353928
     /* 353928 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(353982), // Rule ID 1934 //
     /* 353933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 353958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353966 */     // MIs[1] Operand 1
     /* 353966 */     // No operand predicates
     /* 353966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353968 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 353968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 353971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 353978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 353980 */     GIR_RootConstrainSelectedInstOperands,
     /* 353981 */     // GIR_Coverage, 1934,
     /* 353981 */     GIR_EraseRootFromParent_Done,
     /* 353982 */   // Label 7118: @353982
     /* 353982 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(354088), // Rule ID 5707 //
     /* 353987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 353990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 354005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 354009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 354017 */     // MIs[1] Operand 1
     /* 354017 */     // No operand predicates
     /* 354017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354019 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 354019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 354022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 354026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 354036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 354040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354045 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 354052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 354055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 354070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 354073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 354077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 354080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354086 */     GIR_RootConstrainSelectedInstOperands,
     /* 354087 */     // GIR_Coverage, 5707,
     /* 354087 */     GIR_EraseRootFromParent_Done,
     /* 354088 */   // Label 7119: @354088
     /* 354088 */   GIM_Reject,
     /* 354089 */ // Label 7103: @354089
     /* 354089 */ GIM_Reject,
     /* 354090 */ // Label 6913: @354090
     /* 354090 */ GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(354214), // Rule ID 11168 //
     /* 354095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 354101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354115 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354119 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 354119 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 354122 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 354126 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354131 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 354135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 354137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 354140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 354144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354149 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 354152 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 354155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 354157 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354160 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 354164 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354169 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 354172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 354181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354186 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354189 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 354192 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 354195 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 354203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354205 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354210 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 354212 */   GIR_RootConstrainSelectedInstOperands,
     /* 354213 */   // GIR_Coverage, 11168,
     /* 354213 */   GIR_EraseRootFromParent_Done,
     /* 354214 */ // Label 7120: @354214
     /* 354214 */ GIM_Reject,
     /* 354215 */ // Label 6914: @354215
     /* 354215 */ GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(354339), // Rule ID 11171 //
     /* 354220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 354226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354229 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354244 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 354244 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 354247 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 354251 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354256 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 354260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 354262 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 354265 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 354269 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354274 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 354277 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 354280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 354282 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354285 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 354289 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354294 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 354297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354299 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354302 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 354306 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354311 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354314 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 354317 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 354320 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 354328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354330 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354335 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 354337 */   GIR_RootConstrainSelectedInstOperands,
     /* 354338 */   // GIR_Coverage, 11171,
     /* 354338 */   GIR_EraseRootFromParent_Done,
     /* 354339 */ // Label 7121: @354339
     /* 354339 */ GIM_Reject,
     /* 354340 */ // Label 6915: @354340
     /* 354340 */ GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(356317),
     /* 354345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 354348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354358 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(354467), // Rule ID 4320 //
     /* 354363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354367 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354373 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354383 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354386 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354390 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354394 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354400 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354407 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354434 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354456 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354461 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354466 */     // GIR_Coverage, 4320,
     /* 354466 */     GIR_EraseRootFromParent_Done,
     /* 354467 */   // Label 7123: @354467
     /* 354467 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(354576), // Rule ID 4321 //
     /* 354472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354476 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354482 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354492 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354499 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354516 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354543 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354575 */     // GIR_Coverage, 4321,
     /* 354575 */     GIR_EraseRootFromParent_Done,
     /* 354576 */   // Label 7124: @354576
     /* 354576 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(354685), // Rule ID 4428 //
     /* 354581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354585 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354591 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354601 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354608 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354625 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354652 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354684 */     // GIR_Coverage, 4428,
     /* 354684 */     GIR_EraseRootFromParent_Done,
     /* 354685 */   // Label 7125: @354685
     /* 354685 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(354794), // Rule ID 4429 //
     /* 354690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354694 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354700 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354710 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354717 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354734 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354761 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354793 */     // GIR_Coverage, 4429,
     /* 354793 */     GIR_EraseRootFromParent_Done,
     /* 354794 */   // Label 7126: @354794
     /* 354794 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(354899), // Rule ID 4326 //
     /* 354799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354815 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354818 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354822 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354839 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354866 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354898 */     // GIR_Coverage, 4326,
     /* 354898 */     GIR_EraseRootFromParent_Done,
     /* 354899 */   // Label 7127: @354899
     /* 354899 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(355004), // Rule ID 4328 //
     /* 354904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354920 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354927 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354944 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354971 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355003 */     // GIR_Coverage, 4328,
     /* 355003 */     GIR_EraseRootFromParent_Done,
     /* 355004 */   // Label 7128: @355004
     /* 355004 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(355109), // Rule ID 4434 //
     /* 355009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355025 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355028 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355032 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355042 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 355049 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 355049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 355056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355076 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355108 */     // GIR_Coverage, 4434,
     /* 355108 */     GIR_EraseRootFromParent_Done,
     /* 355109 */   // Label 7129: @355109
     /* 355109 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(355214), // Rule ID 4436 //
     /* 355114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355130 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355137 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355147 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 355154 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 355154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 355161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355181 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355213 */     // GIR_Coverage, 4436,
     /* 355213 */     GIR_EraseRootFromParent_Done,
     /* 355214 */   // Label 7130: @355214
     /* 355214 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(355318), // Rule ID 4318 //
     /* 355219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355223 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355229 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355239 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355246 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355263 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355317 */     // GIR_Coverage, 4318,
     /* 355317 */     GIR_EraseRootFromParent_Done,
     /* 355318 */   // Label 7131: @355318
     /* 355318 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(355422), // Rule ID 4319 //
     /* 355323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355327 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355333 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355343 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355350 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355367 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355389 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355421 */     // GIR_Coverage, 4319,
     /* 355421 */     GIR_EraseRootFromParent_Done,
     /* 355422 */   // Label 7132: @355422
     /* 355422 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(355526), // Rule ID 4426 //
     /* 355427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355431 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355437 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355447 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355450 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355454 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355464 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355471 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355493 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355525 */     // GIR_Coverage, 4426,
     /* 355525 */     GIR_EraseRootFromParent_Done,
     /* 355526 */   // Label 7133: @355526
     /* 355526 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(355630), // Rule ID 4427 //
     /* 355531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355535 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355541 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355551 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355558 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355575 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355597 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355629 */     // GIR_Coverage, 4427,
     /* 355629 */     GIR_EraseRootFromParent_Done,
     /* 355630 */   // Label 7134: @355630
     /* 355630 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(355730), // Rule ID 4322 //
     /* 355635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355651 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355658 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355675 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355697 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355729 */     // GIR_Coverage, 4322,
     /* 355729 */     GIR_EraseRootFromParent_Done,
     /* 355730 */   // Label 7135: @355730
     /* 355730 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(355830), // Rule ID 4324 //
     /* 355735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355751 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355758 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355775 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355797 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355829 */     // GIR_Coverage, 4324,
     /* 355829 */     GIR_EraseRootFromParent_Done,
     /* 355830 */   // Label 7136: @355830
     /* 355830 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(355930), // Rule ID 4430 //
     /* 355835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355851 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355875 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355897 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355929 */     // GIR_Coverage, 4430,
     /* 355929 */     GIR_EraseRootFromParent_Done,
     /* 355930 */   // Label 7137: @355930
     /* 355930 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(356030), // Rule ID 4432 //
     /* 355935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355951 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355958 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355975 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355997 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 356019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356029 */     // GIR_Coverage, 4432,
     /* 356029 */     GIR_EraseRootFromParent_Done,
     /* 356030 */   // Label 7138: @356030
     /* 356030 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(356094), // Rule ID 11226 //
     /* 356035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 356058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 356062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 356066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 356074 */     // MIs[3] Operand 1
     /* 356074 */     // No operand predicates
     /* 356074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356080 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 356080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 356083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 356089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 356092 */     GIR_RootConstrainSelectedInstOperands,
     /* 356093 */     // GIR_Coverage, 11226,
     /* 356093 */     GIR_EraseRootFromParent_Done,
     /* 356094 */   // Label 7139: @356094
     /* 356094 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(356205), // Rule ID 11167 //
     /* 356099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356110 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 356110 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 356113 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 356117 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356122 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 356126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356128 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 356131 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 356135 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356140 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356143 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 356146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356148 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 356151 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 356155 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356160 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 356163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 356168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 356172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356177 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356186 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 356189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 356194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356196 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 356198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 356203 */     GIR_RootConstrainSelectedInstOperands,
     /* 356204 */     // GIR_Coverage, 11167,
     /* 356204 */     GIR_EraseRootFromParent_Done,
     /* 356205 */   // Label 7140: @356205
     /* 356205 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(356316), // Rule ID 11173 //
     /* 356210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356221 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 356221 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 356224 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 356228 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356233 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 356237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356239 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 356242 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 356246 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356251 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356254 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 356257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356259 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 356262 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 356266 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356271 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 356274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 356279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 356283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356288 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356297 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 356300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 356305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356307 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 356309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356312 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 356314 */     GIR_RootConstrainSelectedInstOperands,
     /* 356315 */     // GIR_Coverage, 11173,
     /* 356315 */     GIR_EraseRootFromParent_Done,
     /* 356316 */   // Label 7141: @356316
     /* 356316 */   GIM_Reject,
     /* 356317 */ // Label 7122: @356317
     /* 356317 */ GIM_Reject,
     /* 356318 */ // Label 6916: @356318
     /* 356318 */ GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(356469), // Rule ID 11169 //
     /* 356323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 356329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 356332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356343 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356347 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 356347 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 356350 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356354 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356359 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 356365 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356370 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356375 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 356378 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 356382 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356387 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356392 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 356395 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 356399 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356404 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356407 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 356410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356412 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 356415 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 356419 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356424 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 356427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 356432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 356436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356441 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356444 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356447 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356450 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 356453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 356458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356460 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 356462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356465 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 356467 */   GIR_RootConstrainSelectedInstOperands,
     /* 356468 */   // GIR_Coverage, 11169,
     /* 356468 */   GIR_EraseRootFromParent_Done,
     /* 356469 */ // Label 7142: @356469
     /* 356469 */ GIM_Reject,
     /* 356470 */ // Label 6917: @356470
     /* 356470 */ GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(358501),
     /* 356475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 356478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356481 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356488 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(356597), // Rule ID 4284 //
     /* 356493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356497 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356503 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356513 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356520 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356530 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356537 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356564 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356596 */     // GIR_Coverage, 4284,
     /* 356596 */     GIR_EraseRootFromParent_Done,
     /* 356597 */   // Label 7144: @356597
     /* 356597 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(356706), // Rule ID 4285 //
     /* 356602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356606 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356612 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356622 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356629 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356646 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356673 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356705 */     // GIR_Coverage, 4285,
     /* 356705 */     GIR_EraseRootFromParent_Done,
     /* 356706 */   // Label 7145: @356706
     /* 356706 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(356815), // Rule ID 4392 //
     /* 356711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356731 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356738 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356755 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356782 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356814 */     // GIR_Coverage, 4392,
     /* 356814 */     GIR_EraseRootFromParent_Done,
     /* 356815 */   // Label 7146: @356815
     /* 356815 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(356924), // Rule ID 4393 //
     /* 356820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356824 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356830 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356840 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356847 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356864 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356891 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356923 */     // GIR_Coverage, 4393,
     /* 356923 */     GIR_EraseRootFromParent_Done,
     /* 356924 */   // Label 7147: @356924
     /* 356924 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(357029), // Rule ID 4290 //
     /* 356929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356945 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356952 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356962 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356969 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356996 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357028 */     // GIR_Coverage, 4290,
     /* 357028 */     GIR_EraseRootFromParent_Done,
     /* 357029 */   // Label 7148: @357029
     /* 357029 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(357134), // Rule ID 4292 //
     /* 357034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357050 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357057 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357067 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 357074 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 357074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 357081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357101 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357133 */     // GIR_Coverage, 4292,
     /* 357133 */     GIR_EraseRootFromParent_Done,
     /* 357134 */   // Label 7149: @357134
     /* 357134 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(357239), // Rule ID 4398 //
     /* 357139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357155 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357158 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357162 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357172 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 357179 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 357179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 357186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357206 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357238 */     // GIR_Coverage, 4398,
     /* 357238 */     GIR_EraseRootFromParent_Done,
     /* 357239 */   // Label 7150: @357239
     /* 357239 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(357344), // Rule ID 4400 //
     /* 357244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357260 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357267 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357271 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357277 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 357284 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 357284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 357291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357311 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357343 */     // GIR_Coverage, 4400,
     /* 357343 */     GIR_EraseRootFromParent_Done,
     /* 357344 */   // Label 7151: @357344
     /* 357344 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(357448), // Rule ID 4282 //
     /* 357349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357353 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357359 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357369 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357372 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357376 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357393 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357415 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357447 */     // GIR_Coverage, 4282,
     /* 357447 */     GIR_EraseRootFromParent_Done,
     /* 357448 */   // Label 7152: @357448
     /* 357448 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(357552), // Rule ID 4283 //
     /* 357453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357457 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357463 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357480 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357497 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357519 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357551 */     // GIR_Coverage, 4283,
     /* 357551 */     GIR_EraseRootFromParent_Done,
     /* 357552 */   // Label 7153: @357552
     /* 357552 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(357656), // Rule ID 4390 //
     /* 357557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357561 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357567 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357577 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357584 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357601 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357623 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357655 */     // GIR_Coverage, 4390,
     /* 357655 */     GIR_EraseRootFromParent_Done,
     /* 357656 */   // Label 7154: @357656
     /* 357656 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(357760), // Rule ID 4391 //
     /* 357661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357665 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357671 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357681 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357705 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357727 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357759 */     // GIR_Coverage, 4391,
     /* 357759 */     GIR_EraseRootFromParent_Done,
     /* 357760 */   // Label 7155: @357760
     /* 357760 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(357860), // Rule ID 4286 //
     /* 357765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357781 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357788 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357805 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357827 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357859 */     // GIR_Coverage, 4286,
     /* 357859 */     GIR_EraseRootFromParent_Done,
     /* 357860 */   // Label 7156: @357860
     /* 357860 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(357960), // Rule ID 4288 //
     /* 357865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357881 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357888 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357905 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357927 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357959 */     // GIR_Coverage, 4288,
     /* 357959 */     GIR_EraseRootFromParent_Done,
     /* 357960 */   // Label 7157: @357960
     /* 357960 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(358060), // Rule ID 4394 //
     /* 357965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357981 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357988 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 358005 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 358005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 358008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 358012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358027 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 358049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358059 */     // GIR_Coverage, 4394,
     /* 358059 */     GIR_EraseRootFromParent_Done,
     /* 358060 */   // Label 7158: @358060
     /* 358060 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(358160), // Rule ID 4396 //
     /* 358065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358081 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358084 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358088 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358098 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 358105 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 358105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 358108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 358112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358127 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 358149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358159 */     // GIR_Coverage, 4396,
     /* 358159 */     GIR_EraseRootFromParent_Done,
     /* 358160 */   // Label 7159: @358160
     /* 358160 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(358224), // Rule ID 11224 //
     /* 358165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 358184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 358188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 358192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 358196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358200 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 358204 */     // MIs[3] Operand 1
     /* 358204 */     // No operand predicates
     /* 358204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 358210 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 358210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 358213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 358219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 358222 */     GIR_RootConstrainSelectedInstOperands,
     /* 358223 */     // GIR_Coverage, 11224,
     /* 358223 */     GIR_EraseRootFromParent_Done,
     /* 358224 */   // Label 7160: @358224
     /* 358224 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(358362), // Rule ID 11166 //
     /* 358229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358240 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 358240 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 358243 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358247 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358252 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 358258 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358263 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358268 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 358271 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 358275 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358280 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 358288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 358292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358297 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358300 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358305 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358308 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 358312 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358317 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 358329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358334 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358337 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358340 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358343 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 358351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358353 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358360 */     GIR_RootConstrainSelectedInstOperands,
     /* 358361 */     // GIR_Coverage, 11166,
     /* 358361 */     GIR_EraseRootFromParent_Done,
     /* 358362 */   // Label 7161: @358362
     /* 358362 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(358500), // Rule ID 11172 //
     /* 358367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358378 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 358378 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 358381 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358385 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358390 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 358396 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358401 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358406 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 358409 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 358413 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358418 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358423 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 358426 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 358430 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358435 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358438 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 358450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 358467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358475 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358478 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358481 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 358489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358491 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358496 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358498 */     GIR_RootConstrainSelectedInstOperands,
     /* 358499 */     // GIR_Coverage, 11172,
     /* 358499 */     GIR_EraseRootFromParent_Done,
     /* 358500 */   // Label 7162: @358500
     /* 358500 */   GIM_Reject,
     /* 358501 */ // Label 7143: @358501
     /* 358501 */ GIM_Reject,
     /* 358502 */ // Label 6918: @358502
     /* 358502 */ GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(360769),
     /* 358507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 358510 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(358636), // Rule ID 4248 //
     /* 358515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358529 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358535 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358545 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358548 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358552 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358559 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358576 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 358583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358603 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358635 */     // GIR_Coverage, 4248,
     /* 358635 */     GIR_EraseRootFromParent_Done,
     /* 358636 */   // Label 7164: @358636
     /* 358636 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(358762), // Rule ID 4249 //
     /* 358641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358661 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358671 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358674 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358678 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358685 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358702 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358729 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358761 */     // GIR_Coverage, 4249,
     /* 358761 */     GIR_EraseRootFromParent_Done,
     /* 358762 */   // Label 7165: @358762
     /* 358762 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(358881), // Rule ID 4356 //
     /* 358767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358781 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358787 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358797 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358800 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358804 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358821 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 358828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358848 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358880 */     // GIR_Coverage, 4356,
     /* 358880 */     GIR_EraseRootFromParent_Done,
     /* 358881 */   // Label 7166: @358881
     /* 358881 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(359000), // Rule ID 4357 //
     /* 358886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358900 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358906 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358916 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358923 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358940 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358967 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358999 */     // GIR_Coverage, 4357,
     /* 358999 */     GIR_EraseRootFromParent_Done,
     /* 359000 */   // Label 7167: @359000
     /* 359000 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(359122), // Rule ID 4254 //
     /* 359005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359031 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359034 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359038 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359045 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359055 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 359062 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 359069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359089 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359121 */     // GIR_Coverage, 4254,
     /* 359121 */     GIR_EraseRootFromParent_Done,
     /* 359122 */   // Label 7168: @359122
     /* 359122 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(359244), // Rule ID 4256 //
     /* 359127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359153 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359156 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359160 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359167 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 359184 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 359191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359211 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359243 */     // GIR_Coverage, 4256,
     /* 359243 */     GIR_EraseRootFromParent_Done,
     /* 359244 */   // Label 7169: @359244
     /* 359244 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(359359), // Rule ID 4362 //
     /* 359249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359275 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359282 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 359299 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 359306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359326 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359358 */     // GIR_Coverage, 4362,
     /* 359358 */     GIR_EraseRootFromParent_Done,
     /* 359359 */   // Label 7170: @359359
     /* 359359 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(359474), // Rule ID 4364 //
     /* 359364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359390 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359393 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359397 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 359414 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 359421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359441 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359463 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359473 */     // GIR_Coverage, 4364,
     /* 359473 */     GIR_EraseRootFromParent_Done,
     /* 359474 */   // Label 7171: @359474
     /* 359474 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(359595), // Rule ID 4246 //
     /* 359479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359493 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359499 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359509 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359512 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359516 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359523 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359527 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359533 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359540 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359562 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359594 */     // GIR_Coverage, 4246,
     /* 359594 */     GIR_EraseRootFromParent_Done,
     /* 359595 */   // Label 7172: @359595
     /* 359595 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(359716), // Rule ID 4247 //
     /* 359600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359614 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359620 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359630 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359633 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359637 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359644 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359661 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359683 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359715 */     // GIR_Coverage, 4247,
     /* 359715 */     GIR_EraseRootFromParent_Done,
     /* 359716 */   // Label 7173: @359716
     /* 359716 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(359830), // Rule ID 4354 //
     /* 359721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359735 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359741 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359751 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359758 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359768 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359775 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359797 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359829 */     // GIR_Coverage, 4354,
     /* 359829 */     GIR_EraseRootFromParent_Done,
     /* 359830 */   // Label 7174: @359830
     /* 359830 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(359944), // Rule ID 4355 //
     /* 359835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359849 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359855 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359865 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359868 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359872 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359882 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359889 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359911 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359943 */     // GIR_Coverage, 4355,
     /* 359943 */     GIR_EraseRootFromParent_Done,
     /* 359944 */   // Label 7175: @359944
     /* 359944 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(360061), // Rule ID 4250 //
     /* 359949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359975 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359978 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359982 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359989 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359999 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 360006 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 360006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 360013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360028 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360060 */     // GIR_Coverage, 4250,
     /* 360060 */     GIR_EraseRootFromParent_Done,
     /* 360061 */   // Label 7176: @360061
     /* 360061 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(360178), // Rule ID 4252 //
     /* 360066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360092 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360095 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360099 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360106 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360116 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 360123 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 360123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 360130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360145 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360177 */     // GIR_Coverage, 4252,
     /* 360177 */     GIR_EraseRootFromParent_Done,
     /* 360178 */   // Label 7177: @360178
     /* 360178 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(360288), // Rule ID 4358 //
     /* 360183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360209 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360216 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 360233 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 360233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 360240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360255 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360287 */     // GIR_Coverage, 4358,
     /* 360287 */     GIR_EraseRootFromParent_Done,
     /* 360288 */   // Label 7178: @360288
     /* 360288 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(360398), // Rule ID 4360 //
     /* 360293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360319 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360326 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 360343 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 360343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 360350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360365 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360397 */     // GIR_Coverage, 4360,
     /* 360397 */     GIR_EraseRootFromParent_Done,
     /* 360398 */   // Label 7179: @360398
     /* 360398 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(360472), // Rule ID 11222 //
     /* 360403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 360436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 360440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 360444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360448 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 360452 */     // MIs[3] Operand 1
     /* 360452 */     // No operand predicates
     /* 360452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360456 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360458 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 360458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 360461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 360467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 360470 */     GIR_RootConstrainSelectedInstOperands,
     /* 360471 */     // GIR_Coverage, 11222,
     /* 360471 */     GIR_EraseRootFromParent_Done,
     /* 360472 */   // Label 7180: @360472
     /* 360472 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(360620), // Rule ID 11165 //
     /* 360477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360498 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 360498 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360501 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360505 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360510 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360516 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360521 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360526 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360529 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 360533 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360538 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360543 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360546 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 360550 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360555 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360558 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 360570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 360587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360601 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 360609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360611 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360618 */     GIR_RootConstrainSelectedInstOperands,
     /* 360619 */     // GIR_Coverage, 11165,
     /* 360619 */     GIR_EraseRootFromParent_Done,
     /* 360620 */   // Label 7181: @360620
     /* 360620 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(360768), // Rule ID 11170 //
     /* 360625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360646 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 360646 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360649 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360653 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360658 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360664 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360669 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360674 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360677 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 360681 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360686 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360691 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360694 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 360698 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360703 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360706 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 360718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360723 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 360735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360740 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360743 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360749 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 360757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360759 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360766 */     GIR_RootConstrainSelectedInstOperands,
     /* 360767 */     // GIR_Coverage, 11170,
     /* 360767 */     GIR_EraseRootFromParent_Done,
     /* 360768 */   // Label 7182: @360768
     /* 360768 */   GIM_Reject,
     /* 360769 */ // Label 7163: @360769
     /* 360769 */ GIM_Reject,
     /* 360770 */ // Label 6919: @360770
     /* 360770 */ GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(361883),
     /* 360775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 360778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360781 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360788 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(360904), // Rule ID 4212 //
     /* 360793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360797 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360803 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360813 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360816 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360820 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360827 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 360844 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 360851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360871 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360903 */     // GIR_Coverage, 4212,
     /* 360903 */     GIR_EraseRootFromParent_Done,
     /* 360904 */   // Label 7184: @360904
     /* 360904 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(361020), // Rule ID 4213 //
     /* 360909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360913 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360919 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360929 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360932 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360936 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360943 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 360960 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 360967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360987 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361019 */     // GIR_Coverage, 4213,
     /* 361019 */     GIR_EraseRootFromParent_Done,
     /* 361020 */   // Label 7185: @361020
     /* 361020 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(361132), // Rule ID 4218 //
     /* 361025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361041 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361044 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361048 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 361072 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 361072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 361079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361099 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361131 */     // GIR_Coverage, 4218,
     /* 361131 */     GIR_EraseRootFromParent_Done,
     /* 361132 */   // Label 7186: @361132
     /* 361132 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(361244), // Rule ID 4220 //
     /* 361137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361153 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361156 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361160 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361167 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 361184 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 361184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 361191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361211 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361243 */     // GIR_Coverage, 4220,
     /* 361243 */     GIR_EraseRootFromParent_Done,
     /* 361244 */   // Label 7187: @361244
     /* 361244 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(361355), // Rule ID 4210 //
     /* 361249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361253 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361259 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361269 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361272 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361276 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361283 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 361300 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 361300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 361307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361322 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361354 */     // GIR_Coverage, 4210,
     /* 361354 */     GIR_EraseRootFromParent_Done,
     /* 361355 */   // Label 7188: @361355
     /* 361355 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(361466), // Rule ID 4211 //
     /* 361360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361364 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361370 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361380 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361383 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361387 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361394 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 361411 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 361411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 361418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361433 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361465 */     // GIR_Coverage, 4211,
     /* 361465 */     GIR_EraseRootFromParent_Done,
     /* 361466 */   // Label 7189: @361466
     /* 361466 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(361573), // Rule ID 4214 //
     /* 361471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361487 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361490 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361494 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361501 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 361518 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 361518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 361525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361540 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361562 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361572 */     // GIR_Coverage, 4214,
     /* 361572 */     GIR_EraseRootFromParent_Done,
     /* 361573 */   // Label 7190: @361573
     /* 361573 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(361680), // Rule ID 4216 //
     /* 361578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361594 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361597 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361601 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361608 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361618 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 361625 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 361625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 361632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361647 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361679 */     // GIR_Coverage, 4216,
     /* 361679 */     GIR_EraseRootFromParent_Done,
     /* 361680 */   // Label 7191: @361680
     /* 361680 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(361744), // Rule ID 11220 //
     /* 361685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 361708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 361716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361720 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 361724 */     // MIs[3] Operand 1
     /* 361724 */     // No operand predicates
     /* 361724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 361730 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 361730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 361733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 361739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 361742 */     GIR_RootConstrainSelectedInstOperands,
     /* 361743 */     // GIR_Coverage, 11220,
     /* 361743 */     GIR_EraseRootFromParent_Done,
     /* 361744 */   // Label 7192: @361744
     /* 361744 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(361882), // Rule ID 11164 //
     /* 361749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361760 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 361760 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 361763 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361767 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361772 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 361778 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361783 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361788 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 361791 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 361795 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361800 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 361803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 361805 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 361808 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 361812 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361817 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 361820 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 361823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 361825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 361828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 361832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361837 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 361840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 361849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361854 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361857 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 361860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 361863 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 361871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361873 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361878 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 361880 */     GIR_RootConstrainSelectedInstOperands,
     /* 361881 */     // GIR_Coverage, 11164,
     /* 361881 */     GIR_EraseRootFromParent_Done,
     /* 361882 */   // Label 7193: @361882
     /* 361882 */   GIM_Reject,
     /* 361883 */ // Label 7183: @361883
     /* 361883 */ GIM_Reject,
     /* 361884 */ // Label 6920: @361884
     /* 361884 */ GIM_Reject,
     /* 361885 */ // Label 89: @361885
     /* 361885 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7197*/ GIMT_Encode4(364802),
     /* 361896 */ /*GILLT_s16*//*Label 7194*/ GIMT_Encode4(361908),
     /* 361900 */ /*GILLT_s32*//*Label 7195*/ GIMT_Encode4(362542),
     /* 361904 */ /*GILLT_s64*//*Label 7196*/ GIMT_Encode4(364135),
     /* 361908 */ // Label 7194: @361908
     /* 361908 */ GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(361952), // Rule ID 11213 //
     /* 361913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361926 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361930 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 361930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361935 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 361941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361946 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361951 */   // GIR_Coverage, 11213,
     /* 361951 */   GIR_EraseRootFromParent_Done,
     /* 361952 */ // Label 7198: @361952
     /* 361952 */ GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(361996), // Rule ID 11214 //
     /* 361957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 361963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361970 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361974 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 361974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361979 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 361985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361995 */   // GIR_Coverage, 11214,
     /* 361995 */   GIR_EraseRootFromParent_Done,
     /* 361996 */ // Label 7199: @361996
     /* 361996 */ GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(362040), // Rule ID 11215 //
     /* 362001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 362007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362014 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362018 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 362018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362023 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 362029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362039 */   // GIR_Coverage, 11215,
     /* 362039 */   GIR_EraseRootFromParent_Done,
     /* 362040 */ // Label 7200: @362040
     /* 362040 */ GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(362085), // Rule ID 5777 //
     /* 362045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362059 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362063 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 362063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362068 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 362074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362084 */   // GIR_Coverage, 5777,
     /* 362084 */   GIR_EraseRootFromParent_Done,
     /* 362085 */ // Label 7201: @362085
     /* 362085 */ GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(362130), // Rule ID 5780 //
     /* 362090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362104 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362108 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362112 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362116 */   // MIs[1] Operand 1
     /* 362116 */   // No operand predicates
     /* 362116 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362118 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 362118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 362121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362123 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362125 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362128 */   GIR_RootConstrainSelectedInstOperands,
     /* 362129 */   // GIR_Coverage, 5780,
     /* 362129 */   GIR_EraseRootFromParent_Done,
     /* 362130 */ // Label 7202: @362130
     /* 362130 */ GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(362206), // Rule ID 11188 //
     /* 362135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362156 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 362160 */   // MIs[1] Operand 1
     /* 362160 */   // No operand predicates
     /* 362160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362162 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 362162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 362169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362174 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362178 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362188 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 362195 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362205 */   // GIR_Coverage, 11188,
     /* 362205 */   GIR_EraseRootFromParent_Done,
     /* 362206 */ // Label 7203: @362206
     /* 362206 */ GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(362282), // Rule ID 11189 //
     /* 362211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 362217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362224 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362228 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362232 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 362236 */   // MIs[1] Operand 1
     /* 362236 */   // No operand predicates
     /* 362236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362238 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 362238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 362245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362250 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362254 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362264 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 362271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362281 */   // GIR_Coverage, 11189,
     /* 362281 */   GIR_EraseRootFromParent_Done,
     /* 362282 */ // Label 7204: @362282
     /* 362282 */ GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(362358), // Rule ID 11190 //
     /* 362287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 362293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362308 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 362312 */   // MIs[1] Operand 1
     /* 362312 */   // No operand predicates
     /* 362312 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362314 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 362314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 362321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362326 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362330 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362340 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 362347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362357 */   // GIR_Coverage, 11190,
     /* 362357 */   GIR_EraseRootFromParent_Done,
     /* 362358 */ // Label 7205: @362358
     /* 362358 */ GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(362419), // Rule ID 11178 //
     /* 362363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362380 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 362380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 362387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362392 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362398 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362402 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 362410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 362412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362415 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362417 */   GIR_RootConstrainSelectedInstOperands,
     /* 362418 */   // GIR_Coverage, 11178,
     /* 362418 */   GIR_EraseRootFromParent_Done,
     /* 362419 */ // Label 7206: @362419
     /* 362419 */ GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(362480), // Rule ID 11179 //
     /* 362424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 362430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362441 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 362441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 362448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362453 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362459 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362463 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 362471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 362473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362476 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362478 */   GIR_RootConstrainSelectedInstOperands,
     /* 362479 */   // GIR_Coverage, 11179,
     /* 362479 */   GIR_EraseRootFromParent_Done,
     /* 362480 */ // Label 7207: @362480
     /* 362480 */ GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(362541), // Rule ID 11180 //
     /* 362485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 362491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362502 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 362502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 362509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362514 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362520 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362524 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 362532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 362534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362537 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362539 */   GIR_RootConstrainSelectedInstOperands,
     /* 362540 */   // GIR_Coverage, 11180,
     /* 362540 */   GIR_EraseRootFromParent_Done,
     /* 362541 */ // Label 7208: @362541
     /* 362541 */ GIM_Reject,
     /* 362542 */ // Label 7195: @362542
     /* 362542 */ GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(362587), // Rule ID 6954 //
     /* 362547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362561 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362565 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 362565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362570 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 362576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362586 */   // GIR_Coverage, 6954,
     /* 362586 */   GIR_EraseRootFromParent_Done,
     /* 362587 */ // Label 7209: @362587
     /* 362587 */ GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(362632), // Rule ID 6955 //
     /* 362592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 362595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362606 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362610 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 362610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362615 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 362621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362626 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362631 */   // GIR_Coverage, 6955,
     /* 362631 */   GIR_EraseRootFromParent_Done,
     /* 362632 */ // Label 7210: @362632
     /* 362632 */ GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(362676), // Rule ID 11209 //
     /* 362637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 362643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362650 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362654 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 362654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362659 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362670 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362675 */   // GIR_Coverage, 11209,
     /* 362675 */   GIR_EraseRootFromParent_Done,
     /* 362676 */ // Label 7211: @362676
     /* 362676 */ GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(362720), // Rule ID 11210 //
     /* 362681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362694 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362698 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 362698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362703 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362719 */   // GIR_Coverage, 11210,
     /* 362719 */   GIR_EraseRootFromParent_Done,
     /* 362720 */ // Label 7212: @362720
     /* 362720 */ GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(362764), // Rule ID 11211 //
     /* 362725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362738 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362742 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 362742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362747 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362753 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362758 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362763 */   // GIR_Coverage, 11211,
     /* 362763 */   GIR_EraseRootFromParent_Done,
     /* 362764 */ // Label 7213: @362764
     /* 362764 */ GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(362808), // Rule ID 11216 //
     /* 362769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362782 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362786 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 362786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362791 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362807 */   // GIR_Coverage, 11216,
     /* 362807 */   GIR_EraseRootFromParent_Done,
     /* 362808 */ // Label 7214: @362808
     /* 362808 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(362852), // Rule ID 11217 //
     /* 362813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 362819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362826 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362830 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 362830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362835 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362841 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362851 */   // GIR_Coverage, 11217,
     /* 362851 */   GIR_EraseRootFromParent_Done,
     /* 362852 */ // Label 7215: @362852
     /* 362852 */ GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(362897), // Rule ID 5776 //
     /* 362857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362871 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362875 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 362875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362880 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 362886 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362891 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362896 */   // GIR_Coverage, 5776,
     /* 362896 */   GIR_EraseRootFromParent_Done,
     /* 362897 */ // Label 7216: @362897
     /* 362897 */ GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(362970), // Rule ID 11194 //
     /* 362902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 362908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362923 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 362927 */   // MIs[1] Operand 1
     /* 362927 */   // No operand predicates
     /* 362927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362929 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 362929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 362932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362941 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 362947 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362952 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 362960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362965 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 362968 */   GIR_RootConstrainSelectedInstOperands,
     /* 362969 */   // GIR_Coverage, 11194,
     /* 362969 */   GIR_EraseRootFromParent_Done,
     /* 362970 */ // Label 7217: @362970
     /* 362970 */ GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(363043), // Rule ID 11195 //
     /* 362975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362996 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363000 */   // MIs[1] Operand 1
     /* 363000 */   // No operand predicates
     /* 363000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363002 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 363002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 363005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363014 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 363020 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363025 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 363033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363038 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 363041 */   GIR_RootConstrainSelectedInstOperands,
     /* 363042 */   // GIR_Coverage, 11195,
     /* 363042 */   GIR_EraseRootFromParent_Done,
     /* 363043 */ // Label 7218: @363043
     /* 363043 */ GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(363116), // Rule ID 11196 //
     /* 363048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363069 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363073 */   // MIs[1] Operand 1
     /* 363073 */   // No operand predicates
     /* 363073 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363075 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 363075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 363078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363087 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 363093 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 363106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363111 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 363114 */   GIR_RootConstrainSelectedInstOperands,
     /* 363115 */   // GIR_Coverage, 11196,
     /* 363115 */   GIR_EraseRootFromParent_Done,
     /* 363116 */ // Label 7219: @363116
     /* 363116 */ GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(363164), // Rule ID 1926 //
     /* 363121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 363124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 363127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363138 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363142 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363146 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 363150 */   // MIs[1] Operand 1
     /* 363150 */   // No operand predicates
     /* 363150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363152 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 363155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363157 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363159 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363162 */   GIR_RootConstrainSelectedInstOperands,
     /* 363163 */   // GIR_Coverage, 1926,
     /* 363163 */   GIR_EraseRootFromParent_Done,
     /* 363164 */ // Label 7220: @363164
     /* 363164 */ GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(363212), // Rule ID 1927 //
     /* 363169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 363172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363194 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 363198 */   // MIs[1] Operand 1
     /* 363198 */   // No operand predicates
     /* 363198 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363200 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 363203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363205 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363207 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363210 */   GIR_RootConstrainSelectedInstOperands,
     /* 363211 */   // GIR_Coverage, 1927,
     /* 363211 */   GIR_EraseRootFromParent_Done,
     /* 363212 */ // Label 7221: @363212
     /* 363212 */ GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(363260), // Rule ID 1928 //
     /* 363217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 363220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363242 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 363246 */   // MIs[1] Operand 1
     /* 363246 */   // No operand predicates
     /* 363246 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363248 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 363251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363253 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363255 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363258 */   GIR_RootConstrainSelectedInstOperands,
     /* 363259 */   // GIR_Coverage, 1928,
     /* 363259 */   GIR_EraseRootFromParent_Done,
     /* 363260 */ // Label 7222: @363260
     /* 363260 */ GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(363308), // Rule ID 1930 //
     /* 363265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 363271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363290 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 363294 */   // MIs[1] Operand 1
     /* 363294 */   // No operand predicates
     /* 363294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363296 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 363299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363301 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363303 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363306 */   GIR_RootConstrainSelectedInstOperands,
     /* 363307 */   // GIR_Coverage, 1930,
     /* 363307 */   GIR_EraseRootFromParent_Done,
     /* 363308 */ // Label 7223: @363308
     /* 363308 */ GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(363356), // Rule ID 1931 //
     /* 363313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363338 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363342 */   // MIs[1] Operand 1
     /* 363342 */   // No operand predicates
     /* 363342 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363344 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 363347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363349 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363351 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363354 */   GIR_RootConstrainSelectedInstOperands,
     /* 363355 */   // GIR_Coverage, 1931,
     /* 363355 */   GIR_EraseRootFromParent_Done,
     /* 363356 */ // Label 7224: @363356
     /* 363356 */ GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(363404), // Rule ID 1932 //
     /* 363361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363386 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363390 */   // MIs[1] Operand 1
     /* 363390 */   // No operand predicates
     /* 363390 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363392 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 363395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363397 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363399 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363402 */   GIR_RootConstrainSelectedInstOperands,
     /* 363403 */   // GIR_Coverage, 1932,
     /* 363403 */   GIR_EraseRootFromParent_Done,
     /* 363404 */ // Label 7225: @363404
     /* 363404 */ GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(363449), // Rule ID 5779 //
     /* 363409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363423 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363431 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363435 */   // MIs[1] Operand 1
     /* 363435 */   // No operand predicates
     /* 363435 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363437 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 363437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 363440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363442 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363444 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363447 */   GIR_RootConstrainSelectedInstOperands,
     /* 363448 */   // GIR_Coverage, 5779,
     /* 363448 */   GIR_EraseRootFromParent_Done,
     /* 363449 */ // Label 7226: @363449
     /* 363449 */ GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(363525), // Rule ID 11184 //
     /* 363454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 363460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363475 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 363479 */   // MIs[1] Operand 1
     /* 363479 */   // No operand predicates
     /* 363479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363481 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 363481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 363488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363493 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363497 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363507 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363514 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363524 */   // GIR_Coverage, 11184,
     /* 363524 */   GIR_EraseRootFromParent_Done,
     /* 363525 */ // Label 7227: @363525
     /* 363525 */ GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(363601), // Rule ID 11185 //
     /* 363530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 363536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363551 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 363555 */   // MIs[1] Operand 1
     /* 363555 */   // No operand predicates
     /* 363555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363557 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 363557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 363564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363569 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363573 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363583 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363595 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363600 */   // GIR_Coverage, 11185,
     /* 363600 */   GIR_EraseRootFromParent_Done,
     /* 363601 */ // Label 7228: @363601
     /* 363601 */ GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(363677), // Rule ID 11186 //
     /* 363606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363627 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 363631 */   // MIs[1] Operand 1
     /* 363631 */   // No operand predicates
     /* 363631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363633 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 363633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 363640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363645 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363649 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363659 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363676 */   // GIR_Coverage, 11186,
     /* 363676 */   GIR_EraseRootFromParent_Done,
     /* 363677 */ // Label 7229: @363677
     /* 363677 */ GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(363753), // Rule ID 11191 //
     /* 363682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363695 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363703 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 363707 */   // MIs[1] Operand 1
     /* 363707 */   // No operand predicates
     /* 363707 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363709 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 363709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 363716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363721 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363725 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363735 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363752 */   // GIR_Coverage, 11191,
     /* 363752 */   GIR_EraseRootFromParent_Done,
     /* 363753 */ // Label 7230: @363753
     /* 363753 */ GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(363829), // Rule ID 11192 //
     /* 363758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 363764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363779 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 363783 */   // MIs[1] Operand 1
     /* 363783 */   // No operand predicates
     /* 363783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363785 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 363785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 363792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363797 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363801 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363811 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363823 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363828 */   // GIR_Coverage, 11192,
     /* 363828 */   GIR_EraseRootFromParent_Done,
     /* 363829 */ // Label 7231: @363829
     /* 363829 */ GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(363890), // Rule ID 11174 //
     /* 363834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 363840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363851 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 363851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 363858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363863 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363869 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363873 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 363881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363886 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363888 */   GIR_RootConstrainSelectedInstOperands,
     /* 363889 */   // GIR_Coverage, 11174,
     /* 363889 */   GIR_EraseRootFromParent_Done,
     /* 363890 */ // Label 7232: @363890
     /* 363890 */ GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(363951), // Rule ID 11175 //
     /* 363895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 363901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363912 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 363912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 363919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363924 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363930 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363934 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 363942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363947 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363949 */   GIR_RootConstrainSelectedInstOperands,
     /* 363950 */   // GIR_Coverage, 11175,
     /* 363950 */   GIR_EraseRootFromParent_Done,
     /* 363951 */ // Label 7233: @363951
     /* 363951 */ GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(364012), // Rule ID 11176 //
     /* 363956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363973 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 363973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 363980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363985 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363991 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363995 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 364003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364008 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364010 */   GIR_RootConstrainSelectedInstOperands,
     /* 364011 */   // GIR_Coverage, 11176,
     /* 364011 */   GIR_EraseRootFromParent_Done,
     /* 364012 */ // Label 7234: @364012
     /* 364012 */ GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(364073), // Rule ID 11181 //
     /* 364017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 364023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364034 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 364034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 364041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364046 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364052 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364056 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 364064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 364066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364069 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364071 */   GIR_RootConstrainSelectedInstOperands,
     /* 364072 */   // GIR_Coverage, 11181,
     /* 364072 */   GIR_EraseRootFromParent_Done,
     /* 364073 */ // Label 7235: @364073
     /* 364073 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(364134), // Rule ID 11182 //
     /* 364078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 364084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364095 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 364095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 364102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364107 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364113 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364117 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 364125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 364127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364130 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364132 */   GIR_RootConstrainSelectedInstOperands,
     /* 364133 */   // GIR_Coverage, 11182,
     /* 364133 */   GIR_EraseRootFromParent_Done,
     /* 364134 */ // Label 7236: @364134
     /* 364134 */ GIM_Reject,
     /* 364135 */ // Label 7196: @364135
     /* 364135 */ GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(364180), // Rule ID 6953 //
     /* 364140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364154 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364158 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 364158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364163 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 364169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364179 */   // GIR_Coverage, 6953,
     /* 364179 */   GIR_EraseRootFromParent_Done,
     /* 364180 */ // Label 7237: @364180
     /* 364180 */ GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(364224), // Rule ID 11212 //
     /* 364185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364198 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364202 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 364202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364207 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 364213 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364218 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364223 */   // GIR_Coverage, 11212,
     /* 364223 */   GIR_EraseRootFromParent_Done,
     /* 364224 */ // Label 7238: @364224
     /* 364224 */ GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(364268), // Rule ID 11218 //
     /* 364229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364242 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364246 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 364246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364251 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 364257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364267 */   // GIR_Coverage, 11218,
     /* 364267 */   GIR_EraseRootFromParent_Done,
     /* 364268 */ // Label 7239: @364268
     /* 364268 */ GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(364313), // Rule ID 5775 //
     /* 364273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364287 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 364291 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 364291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364296 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 364302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364312 */   // GIR_Coverage, 5775,
     /* 364312 */   GIR_EraseRootFromParent_Done,
     /* 364313 */ // Label 7240: @364313
     /* 364313 */ GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(364386), // Rule ID 11197 //
     /* 364318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364339 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364343 */   // MIs[1] Operand 1
     /* 364343 */   // No operand predicates
     /* 364343 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364345 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 364345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 364348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364357 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 364363 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364368 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 364376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364381 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 364384 */   GIR_RootConstrainSelectedInstOperands,
     /* 364385 */   // GIR_Coverage, 11197,
     /* 364385 */   GIR_EraseRootFromParent_Done,
     /* 364386 */ // Label 7241: @364386
     /* 364386 */ GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(364434), // Rule ID 1929 //
     /* 364391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 364394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364408 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364412 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364416 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 364420 */   // MIs[1] Operand 1
     /* 364420 */   // No operand predicates
     /* 364420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364422 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 364422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 364425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364427 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364429 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 364432 */   GIR_RootConstrainSelectedInstOperands,
     /* 364433 */   // GIR_Coverage, 1929,
     /* 364433 */   GIR_EraseRootFromParent_Done,
     /* 364434 */ // Label 7242: @364434
     /* 364434 */ GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(364482), // Rule ID 1933 //
     /* 364439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364464 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364468 */   // MIs[1] Operand 1
     /* 364468 */   // No operand predicates
     /* 364468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364470 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 364470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 364473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364475 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364477 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 364480 */   GIR_RootConstrainSelectedInstOperands,
     /* 364481 */   // GIR_Coverage, 1933,
     /* 364481 */   GIR_EraseRootFromParent_Done,
     /* 364482 */ // Label 7243: @364482
     /* 364482 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(364527), // Rule ID 5778 //
     /* 364487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364501 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364505 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364509 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364513 */   // MIs[1] Operand 1
     /* 364513 */   // No operand predicates
     /* 364513 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364515 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 364515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 364518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364520 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364522 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 364525 */   GIR_RootConstrainSelectedInstOperands,
     /* 364526 */   // GIR_Coverage, 5778,
     /* 364526 */   GIR_EraseRootFromParent_Done,
     /* 364527 */ // Label 7244: @364527
     /* 364527 */ GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(364603), // Rule ID 11187 //
     /* 364532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364553 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364557 */   // MIs[1] Operand 1
     /* 364557 */   // No operand predicates
     /* 364557 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364559 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 364559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364571 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 364575 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 364578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364585 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364602 */   // GIR_Coverage, 11187,
     /* 364602 */   GIR_EraseRootFromParent_Done,
     /* 364603 */ // Label 7245: @364603
     /* 364603 */ GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(364679), // Rule ID 11193 //
     /* 364608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364629 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364633 */   // MIs[1] Operand 1
     /* 364633 */   // No operand predicates
     /* 364633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364635 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 364635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364647 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 364651 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 364654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364661 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364668 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364673 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364678 */   // GIR_Coverage, 11193,
     /* 364678 */   GIR_EraseRootFromParent_Done,
     /* 364679 */ // Label 7246: @364679
     /* 364679 */ GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(364740), // Rule ID 11177 //
     /* 364684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364701 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 364701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 364708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364713 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364719 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364723 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 364731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364736 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364738 */   GIR_RootConstrainSelectedInstOperands,
     /* 364739 */   // GIR_Coverage, 11177,
     /* 364739 */   GIR_EraseRootFromParent_Done,
     /* 364740 */ // Label 7247: @364740
     /* 364740 */ GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(364801), // Rule ID 11183 //
     /* 364745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364762 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 364762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 364769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364774 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364780 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364784 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 364792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 364794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364797 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364799 */   GIR_RootConstrainSelectedInstOperands,
     /* 364800 */   // GIR_Coverage, 11183,
     /* 364800 */   GIR_EraseRootFromParent_Done,
     /* 364801 */ // Label 7248: @364801
     /* 364801 */ GIM_Reject,
     /* 364802 */ // Label 7197: @364802
     /* 364802 */ GIM_Reject,
     /* 364803 */ // Label 90: @364803
     /* 364803 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7256*/ GIMT_Encode4(367122),
     /* 364814 */ /*GILLT_nxv2s16*//*Label 7249*/ GIMT_Encode4(364854),
     /* 364818 */ /*GILLT_nxv2s32*//*Label 7250*/ GIMT_Encode4(365213),
     /* 364822 */ /*GILLT_nxv2s64*//*Label 7251*/ GIMT_Encode4(365515), GIMT_Encode4(0),
     /* 364830 */ /*GILLT_nxv4s16*//*Label 7252*/ GIMT_Encode4(365890),
     /* 364834 */ /*GILLT_nxv4s32*//*Label 7253*/ GIMT_Encode4(366192), GIMT_Encode4(0),
     /* 364842 */ /*GILLT_nxv8s16*//*Label 7254*/ GIMT_Encode4(366567), GIMT_Encode4(0),
     /* 364850 */ /*GILLT_nxv16s8*//*Label 7255*/ GIMT_Encode4(366978),
     /* 364854 */ // Label 7249: @364854
     /* 364854 */ GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(365212),
     /* 364859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364866 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(364930), // Rule ID 6009 //
     /* 364871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364882 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364886 */     // MIs[1] Operand 1
     /* 364886 */     // No operand predicates
     /* 364886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364888 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364929 */     // GIR_Coverage, 6009,
     /* 364929 */     GIR_EraseRootFromParent_Done,
     /* 364930 */   // Label 7258: @364930
     /* 364930 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(364987), // Rule ID 2675 //
     /* 364935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 364950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 364971 */     // MIs[2] Operand 1
     /* 364971 */     // No operand predicates
     /* 364971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364973 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 364973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364985 */     GIR_RootConstrainSelectedInstOperands,
     /* 364986 */     // GIR_Coverage, 2675,
     /* 364986 */     GIR_EraseRootFromParent_Done,
     /* 364987 */   // Label 7259: @364987
     /* 364987 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(365044), // Rule ID 2677 //
     /* 364992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 365007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365024 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 365028 */     // MIs[2] Operand 1
     /* 365028 */     // No operand predicates
     /* 365028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365030 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 365030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 365033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365042 */     GIR_RootConstrainSelectedInstOperands,
     /* 365043 */     // GIR_Coverage, 2677,
     /* 365043 */     GIR_EraseRootFromParent_Done,
     /* 365044 */   // Label 7260: @365044
     /* 365044 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(365101), // Rule ID 8317 //
     /* 365049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365085 */     // MIs[2] Operand 1
     /* 365085 */     // No operand predicates
     /* 365085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365087 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 365087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365099 */     GIR_RootConstrainSelectedInstOperands,
     /* 365100 */     // GIR_Coverage, 8317,
     /* 365100 */     GIR_EraseRootFromParent_Done,
     /* 365101 */   // Label 7261: @365101
     /* 365101 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(365135), // Rule ID 8360 //
     /* 365106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365117 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 365121 */     // MIs[1] Operand 1
     /* 365121 */     // No operand predicates
     /* 365121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365123 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 365123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 365126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365128 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 365133 */     GIR_RootConstrainSelectedInstOperands,
     /* 365134 */     // GIR_Coverage, 8360,
     /* 365134 */     GIR_EraseRootFromParent_Done,
     /* 365135 */   // Label 7262: @365135
     /* 365135 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(365211), // Rule ID 8338 //
     /* 365140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365147 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365173 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365180 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 365183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365209 */     GIR_RootConstrainSelectedInstOperands,
     /* 365210 */     // GIR_Coverage, 8338,
     /* 365210 */     GIR_EraseRootFromParent_Done,
     /* 365211 */   // Label 7263: @365211
     /* 365211 */   GIM_Reject,
     /* 365212 */ // Label 7257: @365212
     /* 365212 */ GIM_Reject,
     /* 365213 */ // Label 7250: @365213
     /* 365213 */ GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(365514),
     /* 365218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365225 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(365289), // Rule ID 6007 //
     /* 365230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365241 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365245 */     // MIs[1] Operand 1
     /* 365245 */     // No operand predicates
     /* 365245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365247 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365259 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365288 */     // GIR_Coverage, 6007,
     /* 365288 */     GIR_EraseRootFromParent_Done,
     /* 365289 */   // Label 7265: @365289
     /* 365289 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(365346), // Rule ID 8326 //
     /* 365294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365326 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365330 */     // MIs[2] Operand 1
     /* 365330 */     // No operand predicates
     /* 365330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365332 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365344 */     GIR_RootConstrainSelectedInstOperands,
     /* 365345 */     // GIR_Coverage, 8326,
     /* 365345 */     GIR_EraseRootFromParent_Done,
     /* 365346 */   // Label 7266: @365346
     /* 365346 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(365403), // Rule ID 8335 //
     /* 365351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 365366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365383 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 365387 */     // MIs[2] Operand 1
     /* 365387 */     // No operand predicates
     /* 365387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365389 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 365389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 365392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365401 */     GIR_RootConstrainSelectedInstOperands,
     /* 365402 */     // GIR_Coverage, 8335,
     /* 365402 */     GIR_EraseRootFromParent_Done,
     /* 365403 */   // Label 7267: @365403
     /* 365403 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(365437), // Rule ID 8362 //
     /* 365408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365419 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 365423 */     // MIs[1] Operand 1
     /* 365423 */     // No operand predicates
     /* 365423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365425 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 365425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 365428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365430 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 365435 */     GIR_RootConstrainSelectedInstOperands,
     /* 365436 */     // GIR_Coverage, 8362,
     /* 365436 */     GIR_EraseRootFromParent_Done,
     /* 365437 */   // Label 7268: @365437
     /* 365437 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(365513), // Rule ID 8340 //
     /* 365442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365449 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365449 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365452 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365456 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365475 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365478 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365482 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 365485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365511 */     GIR_RootConstrainSelectedInstOperands,
     /* 365512 */     // GIR_Coverage, 8340,
     /* 365512 */     GIR_EraseRootFromParent_Done,
     /* 365513 */   // Label 7269: @365513
     /* 365513 */   GIM_Reject,
     /* 365514 */ // Label 7264: @365514
     /* 365514 */ GIM_Reject,
     /* 365515 */ // Label 7251: @365515
     /* 365515 */ GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(365889),
     /* 365520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 365523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365527 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(365581), // Rule ID 6002 //
     /* 365532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 365539 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365580 */     // GIR_Coverage, 6002,
     /* 365580 */     GIR_EraseRootFromParent_Done,
     /* 365581 */   // Label 7271: @365581
     /* 365581 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(365645), // Rule ID 6006 //
     /* 365586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365597 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365601 */     // MIs[1] Operand 1
     /* 365601 */     // No operand predicates
     /* 365601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365603 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365615 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365644 */     // GIR_Coverage, 6006,
     /* 365644 */     GIR_EraseRootFromParent_Done,
     /* 365645 */   // Label 7272: @365645
     /* 365645 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(365702), // Rule ID 2672 //
     /* 365650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 365665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365682 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 365686 */     // MIs[2] Operand 1
     /* 365686 */     // No operand predicates
     /* 365686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365688 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 365688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 365691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365700 */     GIR_RootConstrainSelectedInstOperands,
     /* 365701 */     // GIR_Coverage, 2672,
     /* 365701 */     GIR_EraseRootFromParent_Done,
     /* 365702 */   // Label 7273: @365702
     /* 365702 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(365759), // Rule ID 8332 //
     /* 365707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 365722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 365743 */     // MIs[2] Operand 1
     /* 365743 */     // No operand predicates
     /* 365743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365745 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 365745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 365748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365757 */     GIR_RootConstrainSelectedInstOperands,
     /* 365758 */     // GIR_Coverage, 8332,
     /* 365758 */     GIR_EraseRootFromParent_Done,
     /* 365759 */   // Label 7274: @365759
     /* 365759 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(365793), // Rule ID 8363 //
     /* 365764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365775 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 365779 */     // MIs[1] Operand 1
     /* 365779 */     // No operand predicates
     /* 365779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365781 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 365781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 365784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365786 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 365791 */     GIR_RootConstrainSelectedInstOperands,
     /* 365792 */     // GIR_Coverage, 8363,
     /* 365792 */     GIR_EraseRootFromParent_Done,
     /* 365793 */   // Label 7275: @365793
     /* 365793 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(365812), // Rule ID 2391 //
     /* 365798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 365805 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 365805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 365810 */     GIR_RootConstrainSelectedInstOperands,
     /* 365811 */     // GIR_Coverage, 2391,
     /* 365811 */     GIR_Done,
     /* 365812 */   // Label 7276: @365812
     /* 365812 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(365888), // Rule ID 8341 //
     /* 365817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365824 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365824 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365827 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365831 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365857 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 365878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365886 */     GIR_RootConstrainSelectedInstOperands,
     /* 365887 */     // GIR_Coverage, 8341,
     /* 365887 */     GIR_EraseRootFromParent_Done,
     /* 365888 */   // Label 7277: @365888
     /* 365888 */   GIM_Reject,
     /* 365889 */ // Label 7270: @365889
     /* 365889 */ GIM_Reject,
     /* 365890 */ // Label 7252: @365890
     /* 365890 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(366191),
     /* 365895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365902 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(365966), // Rule ID 6010 //
     /* 365907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365918 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365922 */     // MIs[1] Operand 1
     /* 365922 */     // No operand predicates
     /* 365922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365924 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365936 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365965 */     // GIR_Coverage, 6010,
     /* 365965 */     GIR_EraseRootFromParent_Done,
     /* 365966 */   // Label 7279: @365966
     /* 365966 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(366023), // Rule ID 2676 //
     /* 365971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 365986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366003 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 366007 */     // MIs[2] Operand 1
     /* 366007 */     // No operand predicates
     /* 366007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366009 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 366009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 366012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366021 */     GIR_RootConstrainSelectedInstOperands,
     /* 366022 */     // GIR_Coverage, 2676,
     /* 366022 */     GIR_EraseRootFromParent_Done,
     /* 366023 */   // Label 7280: @366023
     /* 366023 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(366080), // Rule ID 8320 //
     /* 366028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366060 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 366064 */     // MIs[2] Operand 1
     /* 366064 */     // No operand predicates
     /* 366064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366066 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 366066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366078 */     GIR_RootConstrainSelectedInstOperands,
     /* 366079 */     // GIR_Coverage, 8320,
     /* 366079 */     GIR_EraseRootFromParent_Done,
     /* 366080 */   // Label 7281: @366080
     /* 366080 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(366114), // Rule ID 8359 //
     /* 366085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366096 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 366100 */     // MIs[1] Operand 1
     /* 366100 */     // No operand predicates
     /* 366100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366102 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 366102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 366105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366107 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 366112 */     GIR_RootConstrainSelectedInstOperands,
     /* 366113 */     // GIR_Coverage, 8359,
     /* 366113 */     GIR_EraseRootFromParent_Done,
     /* 366114 */   // Label 7282: @366114
     /* 366114 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(366190), // Rule ID 8337 //
     /* 366119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366126 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366126 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 366129 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366133 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366152 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 366159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 366162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366188 */     GIR_RootConstrainSelectedInstOperands,
     /* 366189 */     // GIR_Coverage, 8337,
     /* 366189 */     GIR_EraseRootFromParent_Done,
     /* 366190 */   // Label 7283: @366190
     /* 366190 */   GIM_Reject,
     /* 366191 */ // Label 7278: @366191
     /* 366191 */ GIM_Reject,
     /* 366192 */ // Label 7253: @366192
     /* 366192 */ GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(366566),
     /* 366197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366204 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(366258), // Rule ID 6003 //
     /* 366209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 366216 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 366216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 366223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366228 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 366247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366257 */     // GIR_Coverage, 6003,
     /* 366257 */     GIR_EraseRootFromParent_Done,
     /* 366258 */   // Label 7285: @366258
     /* 366258 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(366322), // Rule ID 6008 //
     /* 366263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366274 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 366278 */     // MIs[1] Operand 1
     /* 366278 */     // No operand predicates
     /* 366278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366280 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 366280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 366287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366292 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 366311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366321 */     // GIR_Coverage, 6008,
     /* 366321 */     GIR_EraseRootFromParent_Done,
     /* 366322 */   // Label 7286: @366322
     /* 366322 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(366379), // Rule ID 2669 //
     /* 366327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366359 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 366363 */     // MIs[2] Operand 1
     /* 366363 */     // No operand predicates
     /* 366363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366365 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 366365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 366368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366377 */     GIR_RootConstrainSelectedInstOperands,
     /* 366378 */     // GIR_Coverage, 2669,
     /* 366378 */     GIR_EraseRootFromParent_Done,
     /* 366379 */   // Label 7287: @366379
     /* 366379 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(366436), // Rule ID 8329 //
     /* 366384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 366420 */     // MIs[2] Operand 1
     /* 366420 */     // No operand predicates
     /* 366420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366422 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 366422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 366425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366434 */     GIR_RootConstrainSelectedInstOperands,
     /* 366435 */     // GIR_Coverage, 8329,
     /* 366435 */     GIR_EraseRootFromParent_Done,
     /* 366436 */   // Label 7288: @366436
     /* 366436 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(366470), // Rule ID 8361 //
     /* 366441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366452 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 366456 */     // MIs[1] Operand 1
     /* 366456 */     // No operand predicates
     /* 366456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366458 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 366458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 366461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366463 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 366468 */     GIR_RootConstrainSelectedInstOperands,
     /* 366469 */     // GIR_Coverage, 8361,
     /* 366469 */     GIR_EraseRootFromParent_Done,
     /* 366470 */   // Label 7289: @366470
     /* 366470 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(366489), // Rule ID 2390 //
     /* 366475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 366482 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 366482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 366487 */     GIR_RootConstrainSelectedInstOperands,
     /* 366488 */     // GIR_Coverage, 2390,
     /* 366488 */     GIR_Done,
     /* 366489 */   // Label 7290: @366489
     /* 366489 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(366565), // Rule ID 8339 //
     /* 366494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366501 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366501 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 366504 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366508 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 366534 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 366537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 366555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366563 */     GIR_RootConstrainSelectedInstOperands,
     /* 366564 */     // GIR_Coverage, 8339,
     /* 366564 */     GIR_EraseRootFromParent_Done,
     /* 366565 */   // Label 7291: @366565
     /* 366565 */   GIM_Reject,
     /* 366566 */ // Label 7284: @366566
     /* 366566 */ GIM_Reject,
     /* 366567 */ // Label 7254: @366567
     /* 366567 */ GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(366628), // Rule ID 6004 //
     /* 366572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366582 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 366586 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 366586 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 366593 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366598 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 366617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366627 */   // GIR_Coverage, 6004,
     /* 366627 */   GIR_EraseRootFromParent_Done,
     /* 366628 */ // Label 7292: @366628
     /* 366628 */ GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(366699), // Rule ID 6011 //
     /* 366633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366651 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 366655 */   // MIs[1] Operand 1
     /* 366655 */   // No operand predicates
     /* 366655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366657 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 366657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 366664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366669 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 366688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366698 */   // GIR_Coverage, 6011,
     /* 366698 */   GIR_EraseRootFromParent_Done,
     /* 366699 */ // Label 7293: @366699
     /* 366699 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(366763), // Rule ID 2666 //
     /* 366704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366722 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366730 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366735 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366739 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366743 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 366747 */   // MIs[2] Operand 1
     /* 366747 */   // No operand predicates
     /* 366747 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366749 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 366749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366754 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366758 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366761 */   GIR_RootConstrainSelectedInstOperands,
     /* 366762 */   // GIR_Coverage, 2666,
     /* 366762 */   GIR_EraseRootFromParent_Done,
     /* 366763 */ // Label 7294: @366763
     /* 366763 */ GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(366827), // Rule ID 8323 //
     /* 366768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366786 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366790 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366794 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366799 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366803 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366807 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 366811 */   // MIs[2] Operand 1
     /* 366811 */   // No operand predicates
     /* 366811 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366813 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 366813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366818 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366822 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366825 */   GIR_RootConstrainSelectedInstOperands,
     /* 366826 */   // GIR_Coverage, 8323,
     /* 366826 */   GIR_EraseRootFromParent_Done,
     /* 366827 */ // Label 7295: @366827
     /* 366827 */ GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(366868), // Rule ID 8358 //
     /* 366832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366850 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 366854 */   // MIs[1] Operand 1
     /* 366854 */   // No operand predicates
     /* 366854 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366856 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 366856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 366859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366861 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 366866 */   GIR_RootConstrainSelectedInstOperands,
     /* 366867 */   // GIR_Coverage, 8358,
     /* 366867 */   GIR_EraseRootFromParent_Done,
     /* 366868 */ // Label 7296: @366868
     /* 366868 */ GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(366894), // Rule ID 2389 //
     /* 366873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 366887 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 366887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 366892 */   GIR_RootConstrainSelectedInstOperands,
     /* 366893 */   // GIR_Coverage, 2389,
     /* 366893 */   GIR_Done,
     /* 366894 */ // Label 7297: @366894
     /* 366894 */ GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(366977), // Rule ID 8336 //
     /* 366899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366913 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366913 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 366916 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366920 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366939 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 366946 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 366949 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366954 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366975 */   GIR_RootConstrainSelectedInstOperands,
     /* 366976 */   // GIR_Coverage, 8336,
     /* 366976 */   GIR_EraseRootFromParent_Done,
     /* 366977 */ // Label 7298: @366977
     /* 366977 */ GIM_Reject,
     /* 366978 */ // Label 7255: @366978
     /* 366978 */ GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(367121),
     /* 366983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366990 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(367044), // Rule ID 6005 //
     /* 366995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 367002 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 367002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 367009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367014 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 367033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367043 */     // GIR_Coverage, 6005,
     /* 367043 */     GIR_EraseRootFromParent_Done,
     /* 367044 */   // Label 7300: @367044
     /* 367044 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(367101), // Rule ID 2663 //
     /* 367049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 367064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 367085 */     // MIs[2] Operand 1
     /* 367085 */     // No operand predicates
     /* 367085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367087 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 367087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 367090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 367092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 367096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 367099 */     GIR_RootConstrainSelectedInstOperands,
     /* 367100 */     // GIR_Coverage, 2663,
     /* 367100 */     GIR_EraseRootFromParent_Done,
     /* 367101 */   // Label 7301: @367101
     /* 367101 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(367120), // Rule ID 2388 //
     /* 367106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 367109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 367113 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 367113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 367118 */     GIR_RootConstrainSelectedInstOperands,
     /* 367119 */     // GIR_Coverage, 2388,
     /* 367119 */     GIR_Done,
     /* 367120 */   // Label 7302: @367120
     /* 367120 */   GIM_Reject,
     /* 367121 */ // Label 7299: @367121
     /* 367121 */ GIM_Reject,
     /* 367122 */ // Label 7256: @367122
     /* 367122 */ GIM_Reject,
     /* 367123 */ // Label 91: @367123
     /* 367123 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7305*/ GIMT_Encode4(367274),
     /* 367134 */ /*GILLT_s32*//*Label 7303*/ GIMT_Encode4(367142),
     /* 367138 */ /*GILLT_s64*//*Label 7304*/ GIMT_Encode4(367208),
     /* 367142 */ // Label 7303: @367142
     /* 367142 */ GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(367207),
     /* 367147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367158 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(367173), // Rule ID 2321 //
     /* 367163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 367166 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 367171 */     GIR_RootConstrainSelectedInstOperands,
     /* 367172 */     // GIR_Coverage, 2321,
     /* 367172 */     GIR_Done,
     /* 367173 */   // Label 7307: @367173
     /* 367173 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(367206), // Rule ID 4005 //
     /* 367178 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 367178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 367185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 367194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 367199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367204 */     GIR_RootConstrainSelectedInstOperands,
     /* 367205 */     // GIR_Coverage, 4005,
     /* 367205 */     GIR_EraseRootFromParent_Done,
     /* 367206 */   // Label 7308: @367206
     /* 367206 */   GIM_Reject,
     /* 367207 */ // Label 7306: @367207
     /* 367207 */ GIM_Reject,
     /* 367208 */ // Label 7304: @367208
     /* 367208 */ GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(367273),
     /* 367213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367224 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(367239), // Rule ID 2322 //
     /* 367229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 367232 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 367237 */     GIR_RootConstrainSelectedInstOperands,
     /* 367238 */     // GIR_Coverage, 2322,
     /* 367238 */     GIR_Done,
     /* 367239 */   // Label 7310: @367239
     /* 367239 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(367272), // Rule ID 4006 //
     /* 367244 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 367244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 367247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 367251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 367260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 367265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367270 */     GIR_RootConstrainSelectedInstOperands,
     /* 367271 */     // GIR_Coverage, 4006,
     /* 367271 */     GIR_EraseRootFromParent_Done,
     /* 367272 */   // Label 7311: @367272
     /* 367272 */   GIM_Reject,
     /* 367273 */ // Label 7309: @367273
     /* 367273 */ GIM_Reject,
     /* 367274 */ // Label 7305: @367274
     /* 367274 */ GIM_Reject,
     /* 367275 */ // Label 92: @367275
     /* 367275 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7320*/ GIMT_Encode4(367948),
     /* 367286 */ /*GILLT_s32*//*Label 7312*/ GIMT_Encode4(367326),
     /* 367290 */ /*GILLT_s64*//*Label 7313*/ GIMT_Encode4(367556), GIMT_Encode4(0),
     /* 367298 */ /*GILLT_v2s32*//*Label 7314*/ GIMT_Encode4(367786), GIMT_Encode4(0),
     /* 367306 */ /*GILLT_v4s16*//*Label 7315*/ GIMT_Encode4(367813),
     /* 367310 */ /*GILLT_v4s32*//*Label 7316*/ GIMT_Encode4(367840),
     /* 367314 */ /*GILLT_v8s8*//*Label 7317*/ GIMT_Encode4(367867),
     /* 367318 */ /*GILLT_v8s16*//*Label 7318*/ GIMT_Encode4(367894),
     /* 367322 */ /*GILLT_v16s8*//*Label 7319*/ GIMT_Encode4(367921),
     /* 367326 */ // Label 7312: @367326
     /* 367326 */ GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(367555),
     /* 367331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367338 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(367438), // Rule ID 4007 //
     /* 367343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 367351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 367367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 367383 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 367387 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 367391 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 367395 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 367399 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367403 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367408 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 367412 */     // MIs[3] Rn
     /* 367412 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 367417 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 367421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 367425 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367427 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 367430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 367436 */     GIR_RootConstrainSelectedInstOperands,
     /* 367437 */     // GIR_Coverage, 4007,
     /* 367437 */     GIR_EraseRootFromParent_Done,
     /* 367438 */   // Label 7322: @367438
     /* 367438 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(367538), // Rule ID 13775 //
     /* 367443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 367451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 367467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 367483 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 367487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 367491 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 367504 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367508 */     // MIs[4] Rn
     /* 367508 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 367513 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 367517 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 367521 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 367525 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367527 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 367530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 367536 */     GIR_RootConstrainSelectedInstOperands,
     /* 367537 */     // GIR_Coverage, 13775,
     /* 367537 */     GIR_EraseRootFromParent_Done,
     /* 367538 */   // Label 7323: @367538
     /* 367538 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(367554), // Rule ID 180 //
     /* 367543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367547 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 367552 */     GIR_RootConstrainSelectedInstOperands,
     /* 367553 */     // GIR_Coverage, 180,
     /* 367553 */     GIR_Done,
     /* 367554 */   // Label 7324: @367554
     /* 367554 */   GIM_Reject,
     /* 367555 */ // Label 7321: @367555
     /* 367555 */ GIM_Reject,
     /* 367556 */ // Label 7313: @367556
     /* 367556 */ GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(367785),
     /* 367561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367568 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(367668), // Rule ID 4008 //
     /* 367573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 367581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 367585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 367597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 367601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 367613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 367617 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 367621 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 367625 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 367629 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367633 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367638 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 367642 */     // MIs[3] Rn
     /* 367642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 367647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 367651 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 367655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367657 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 367660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 367666 */     GIR_RootConstrainSelectedInstOperands,
     /* 367667 */     // GIR_Coverage, 4008,
     /* 367667 */     GIR_EraseRootFromParent_Done,
     /* 367668 */   // Label 7326: @367668
     /* 367668 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(367768), // Rule ID 13776 //
     /* 367673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 367681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 367685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 367697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 367701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367709 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 367713 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 367717 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367721 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367726 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367730 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 367734 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367738 */     // MIs[4] Rn
     /* 367738 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 367743 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 367747 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 367751 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 367755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367757 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 367760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 367766 */     GIR_RootConstrainSelectedInstOperands,
     /* 367767 */     // GIR_Coverage, 13776,
     /* 367767 */     GIR_EraseRootFromParent_Done,
     /* 367768 */   // Label 7327: @367768
     /* 367768 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(367784), // Rule ID 181 //
     /* 367773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367777 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 367782 */     GIR_RootConstrainSelectedInstOperands,
     /* 367783 */     // GIR_Coverage, 181,
     /* 367783 */     GIR_Done,
     /* 367784 */   // Label 7328: @367784
     /* 367784 */   GIM_Reject,
     /* 367785 */ // Label 7325: @367785
     /* 367785 */ GIM_Reject,
     /* 367786 */ // Label 7314: @367786
     /* 367786 */ GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(367812), // Rule ID 720 //
     /* 367791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367805 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 367805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 367810 */   GIR_RootConstrainSelectedInstOperands,
     /* 367811 */   // GIR_Coverage, 720,
     /* 367811 */   GIR_Done,
     /* 367812 */ // Label 7329: @367812
     /* 367812 */ GIM_Reject,
     /* 367813 */ // Label 7315: @367813
     /* 367813 */ GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(367839), // Rule ID 718 //
     /* 367818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 367824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367832 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 367832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 367837 */   GIR_RootConstrainSelectedInstOperands,
     /* 367838 */   // GIR_Coverage, 718,
     /* 367838 */   GIR_Done,
     /* 367839 */ // Label 7330: @367839
     /* 367839 */ GIM_Reject,
     /* 367840 */ // Label 7316: @367840
     /* 367840 */ GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(367866), // Rule ID 721 //
     /* 367845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367859 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 367859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 367864 */   GIR_RootConstrainSelectedInstOperands,
     /* 367865 */   // GIR_Coverage, 721,
     /* 367865 */   GIR_Done,
     /* 367866 */ // Label 7331: @367866
     /* 367866 */ GIM_Reject,
     /* 367867 */ // Label 7317: @367867
     /* 367867 */ GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(367893), // Rule ID 716 //
     /* 367872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 367878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367886 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 367886 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 367891 */   GIR_RootConstrainSelectedInstOperands,
     /* 367892 */   // GIR_Coverage, 716,
     /* 367892 */   GIR_Done,
     /* 367893 */ // Label 7332: @367893
     /* 367893 */ GIM_Reject,
     /* 367894 */ // Label 7318: @367894
     /* 367894 */ GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(367920), // Rule ID 719 //
     /* 367899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367913 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 367913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 367918 */   GIR_RootConstrainSelectedInstOperands,
     /* 367919 */   // GIR_Coverage, 719,
     /* 367919 */   GIR_Done,
     /* 367920 */ // Label 7333: @367920
     /* 367920 */ GIM_Reject,
     /* 367921 */ // Label 7319: @367921
     /* 367921 */ GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(367947), // Rule ID 717 //
     /* 367926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 367932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367940 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 367940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 367945 */   GIR_RootConstrainSelectedInstOperands,
     /* 367946 */   // GIR_Coverage, 717,
     /* 367946 */   GIR_Done,
     /* 367947 */ // Label 7334: @367947
     /* 367947 */ GIM_Reject,
     /* 367948 */ // Label 7320: @367948
     /* 367948 */ GIM_Reject,
     /* 367949 */ // Label 93: @367949
     /* 367949 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7339*/ GIMT_Encode4(368108),
     /* 367960 */ /*GILLT_s32*//*Label 7335*/ GIMT_Encode4(368000),
     /* 367964 */ /*GILLT_s64*//*Label 7336*/ GIMT_Encode4(368027), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 367988 */ /*GILLT_v8s8*//*Label 7337*/ GIMT_Encode4(368054), GIMT_Encode4(0),
     /* 367996 */ /*GILLT_v16s8*//*Label 7338*/ GIMT_Encode4(368081),
     /* 368000 */ // Label 7335: @368000
     /* 368000 */ GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(368026), // Rule ID 2319 //
     /* 368005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 368008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368019 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 368019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 368024 */   GIR_RootConstrainSelectedInstOperands,
     /* 368025 */   // GIR_Coverage, 2319,
     /* 368025 */   GIR_Done,
     /* 368026 */ // Label 7340: @368026
     /* 368026 */ GIM_Reject,
     /* 368027 */ // Label 7336: @368027
     /* 368027 */ GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(368053), // Rule ID 2320 //
     /* 368032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 368035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368046 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 368046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 368051 */   GIR_RootConstrainSelectedInstOperands,
     /* 368052 */   // GIR_Coverage, 2320,
     /* 368052 */   GIR_Done,
     /* 368053 */ // Label 7341: @368053
     /* 368053 */ GIM_Reject,
     /* 368054 */ // Label 7337: @368054
     /* 368054 */ GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(368080), // Rule ID 764 //
     /* 368059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368073 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 368073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 368078 */   GIR_RootConstrainSelectedInstOperands,
     /* 368079 */   // GIR_Coverage, 764,
     /* 368079 */   GIR_Done,
     /* 368080 */ // Label 7342: @368080
     /* 368080 */ GIM_Reject,
     /* 368081 */ // Label 7338: @368081
     /* 368081 */ GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(368107), // Rule ID 765 //
     /* 368086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 368092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368100 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 368100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 368105 */   GIR_RootConstrainSelectedInstOperands,
     /* 368106 */   // GIR_Coverage, 765,
     /* 368106 */   GIR_Done,
     /* 368107 */ // Label 7343: @368107
     /* 368107 */ GIM_Reject,
     /* 368108 */ // Label 7339: @368108
     /* 368108 */ GIM_Reject,
     /* 368109 */ // Label 94: @368109
     /* 368109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7351*/ GIMT_Encode4(368422),
     /* 368120 */ /*GILLT_s32*//*Label 7344*/ GIMT_Encode4(368156),
     /* 368124 */ /*GILLT_s64*//*Label 7345*/ GIMT_Encode4(368229), GIMT_Encode4(0),
     /* 368132 */ /*GILLT_v2s32*//*Label 7346*/ GIMT_Encode4(368302),
     /* 368136 */ /*GILLT_v2s64*//*Label 7347*/ GIMT_Encode4(368326),
     /* 368140 */ /*GILLT_v4s16*//*Label 7348*/ GIMT_Encode4(368350),
     /* 368144 */ /*GILLT_v4s32*//*Label 7349*/ GIMT_Encode4(368374), GIMT_Encode4(0),
     /* 368152 */ /*GILLT_v8s16*//*Label 7350*/ GIMT_Encode4(368398),
     /* 368156 */ // Label 7344: @368156
     /* 368156 */ GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(368228),
     /* 368161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368168 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(368211), // Rule ID 4011 //
     /* 368173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 368181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 368185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368194 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 368198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368200 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 368200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 368203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368209 */     GIR_RootConstrainSelectedInstOperands,
     /* 368210 */     // GIR_Coverage, 4011,
     /* 368210 */     GIR_EraseRootFromParent_Done,
     /* 368211 */   // Label 7353: @368211
     /* 368211 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(368227), // Rule ID 185 //
     /* 368216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368220 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 368220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 368225 */     GIR_RootConstrainSelectedInstOperands,
     /* 368226 */     // GIR_Coverage, 185,
     /* 368226 */     GIR_Done,
     /* 368227 */   // Label 7354: @368227
     /* 368227 */   GIM_Reject,
     /* 368228 */ // Label 7352: @368228
     /* 368228 */ GIM_Reject,
     /* 368229 */ // Label 7345: @368229
     /* 368229 */ GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(368301),
     /* 368234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368241 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(368284), // Rule ID 4012 //
     /* 368246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 368254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 368258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368267 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 368271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368273 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 368273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 368276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 368282 */     GIR_RootConstrainSelectedInstOperands,
     /* 368283 */     // GIR_Coverage, 4012,
     /* 368283 */     GIR_EraseRootFromParent_Done,
     /* 368284 */   // Label 7356: @368284
     /* 368284 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(368300), // Rule ID 186 //
     /* 368289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368293 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 368293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 368298 */     GIR_RootConstrainSelectedInstOperands,
     /* 368299 */     // GIR_Coverage, 186,
     /* 368299 */     GIR_Done,
     /* 368300 */   // Label 7357: @368300
     /* 368300 */   GIM_Reject,
     /* 368301 */ // Label 7355: @368301
     /* 368301 */ GIM_Reject,
     /* 368302 */ // Label 7346: @368302
     /* 368302 */ GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(368325), // Rule ID 4988 //
     /* 368307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368318 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 368318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 368323 */   GIR_RootConstrainSelectedInstOperands,
     /* 368324 */   // GIR_Coverage, 4988,
     /* 368324 */   GIR_Done,
     /* 368325 */ // Label 7358: @368325
     /* 368325 */ GIM_Reject,
     /* 368326 */ // Label 7347: @368326
     /* 368326 */ GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(368349), // Rule ID 4990 //
     /* 368331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368342 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 368342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 368347 */   GIR_RootConstrainSelectedInstOperands,
     /* 368348 */   // GIR_Coverage, 4990,
     /* 368348 */   GIR_Done,
     /* 368349 */ // Label 7359: @368349
     /* 368349 */ GIM_Reject,
     /* 368350 */ // Label 7348: @368350
     /* 368350 */ GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(368373), // Rule ID 4986 //
     /* 368355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 368358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368366 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 368366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 368371 */   GIR_RootConstrainSelectedInstOperands,
     /* 368372 */   // GIR_Coverage, 4986,
     /* 368372 */   GIR_Done,
     /* 368373 */ // Label 7360: @368373
     /* 368373 */ GIM_Reject,
     /* 368374 */ // Label 7349: @368374
     /* 368374 */ GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(368397), // Rule ID 4989 //
     /* 368379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368390 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 368390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 368395 */   GIR_RootConstrainSelectedInstOperands,
     /* 368396 */   // GIR_Coverage, 4989,
     /* 368396 */   GIR_Done,
     /* 368397 */ // Label 7361: @368397
     /* 368397 */ GIM_Reject,
     /* 368398 */ // Label 7350: @368398
     /* 368398 */ GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(368421), // Rule ID 4987 //
     /* 368403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368414 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 368414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 368419 */   GIR_RootConstrainSelectedInstOperands,
     /* 368420 */   // GIR_Coverage, 4987,
     /* 368420 */   GIR_Done,
     /* 368421 */ // Label 7362: @368421
     /* 368421 */ GIM_Reject,
     /* 368422 */ // Label 7351: @368422
     /* 368422 */ GIM_Reject,
     /* 368423 */ // Label 95: @368423
     /* 368423 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7367*/ GIMT_Encode4(368576),
     /* 368434 */ /*GILLT_s32*//*Label 7363*/ GIMT_Encode4(368474),
     /* 368438 */ /*GILLT_s64*//*Label 7364*/ GIMT_Encode4(368498), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 368462 */ /*GILLT_v8s8*//*Label 7365*/ GIMT_Encode4(368522), GIMT_Encode4(0),
     /* 368470 */ /*GILLT_v16s8*//*Label 7366*/ GIMT_Encode4(368549),
     /* 368474 */ // Label 7363: @368474
     /* 368474 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(368497), // Rule ID 182 //
     /* 368479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368490 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 368490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 368495 */   GIR_RootConstrainSelectedInstOperands,
     /* 368496 */   // GIR_Coverage, 182,
     /* 368496 */   GIR_Done,
     /* 368497 */ // Label 7368: @368497
     /* 368497 */ GIM_Reject,
     /* 368498 */ // Label 7364: @368498
     /* 368498 */ GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(368521), // Rule ID 183 //
     /* 368503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368514 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 368514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 368519 */   GIR_RootConstrainSelectedInstOperands,
     /* 368520 */   // GIR_Coverage, 183,
     /* 368520 */   GIR_Done,
     /* 368521 */ // Label 7369: @368521
     /* 368521 */ GIM_Reject,
     /* 368522 */ // Label 7365: @368522
     /* 368522 */ GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(368548), // Rule ID 974 //
     /* 368527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368541 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 368541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 368546 */   GIR_RootConstrainSelectedInstOperands,
     /* 368547 */   // GIR_Coverage, 974,
     /* 368547 */   GIR_Done,
     /* 368548 */ // Label 7370: @368548
     /* 368548 */ GIM_Reject,
     /* 368549 */ // Label 7366: @368549
     /* 368549 */ GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(368575), // Rule ID 975 //
     /* 368554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 368560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368568 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 368568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 368573 */   GIR_RootConstrainSelectedInstOperands,
     /* 368574 */   // GIR_Coverage, 975,
     /* 368574 */   GIR_Done,
     /* 368575 */ // Label 7371: @368575
     /* 368575 */ GIM_Reject,
     /* 368576 */ // Label 7367: @368576
     /* 368576 */ GIM_Reject,
     /* 368577 */ // Label 96: @368577
     /* 368577 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7380*/ GIMT_Encode4(369067),
     /* 368588 */ /*GILLT_s16*//*Label 7372*/ GIMT_Encode4(368628),
     /* 368592 */ /*GILLT_s32*//*Label 7373*/ GIMT_Encode4(368659),
     /* 368596 */ /*GILLT_s64*//*Label 7374*/ GIMT_Encode4(368690), GIMT_Encode4(0),
     /* 368604 */ /*GILLT_v2s32*//*Label 7375*/ GIMT_Encode4(368721),
     /* 368608 */ /*GILLT_v2s64*//*Label 7376*/ GIMT_Encode4(368752),
     /* 368612 */ /*GILLT_v4s16*//*Label 7377*/ GIMT_Encode4(368783),
     /* 368616 */ /*GILLT_v4s32*//*Label 7378*/ GIMT_Encode4(368814), GIMT_Encode4(0),
     /* 368624 */ /*GILLT_v8s16*//*Label 7379*/ GIMT_Encode4(368845),
     /* 368628 */ // Label 7372: @368628
     /* 368628 */ GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(368658), // Rule ID 552 //
     /* 368633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368647 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 368652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368656 */   GIR_RootConstrainSelectedInstOperands,
     /* 368657 */   // GIR_Coverage, 552,
     /* 368657 */   GIR_Done,
     /* 368658 */ // Label 7381: @368658
     /* 368658 */ GIM_Reject,
     /* 368659 */ // Label 7373: @368659
     /* 368659 */ GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(368689), // Rule ID 554 //
     /* 368664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368678 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 368678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 368683 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368687 */   GIR_RootConstrainSelectedInstOperands,
     /* 368688 */   // GIR_Coverage, 554,
     /* 368688 */   GIR_Done,
     /* 368689 */ // Label 7382: @368689
     /* 368689 */ GIM_Reject,
     /* 368690 */ // Label 7374: @368690
     /* 368690 */ GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(368720), // Rule ID 556 //
     /* 368695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368709 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 368709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 368714 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368718 */   GIR_RootConstrainSelectedInstOperands,
     /* 368719 */   // GIR_Coverage, 556,
     /* 368719 */   GIR_Done,
     /* 368720 */ // Label 7383: @368720
     /* 368720 */ GIM_Reject,
     /* 368721 */ // Label 7375: @368721
     /* 368721 */ GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(368751), // Rule ID 913 //
     /* 368726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368740 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 368740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 368745 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368749 */   GIR_RootConstrainSelectedInstOperands,
     /* 368750 */   // GIR_Coverage, 913,
     /* 368750 */   GIR_Done,
     /* 368751 */ // Label 7384: @368751
     /* 368751 */ GIM_Reject,
     /* 368752 */ // Label 7376: @368752
     /* 368752 */ GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(368782), // Rule ID 917 //
     /* 368757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368771 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 368771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 368776 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368780 */   GIR_RootConstrainSelectedInstOperands,
     /* 368781 */   // GIR_Coverage, 917,
     /* 368781 */   GIR_Done,
     /* 368782 */ // Label 7385: @368782
     /* 368782 */ GIM_Reject,
     /* 368783 */ // Label 7377: @368783
     /* 368783 */ GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(368813), // Rule ID 909 //
     /* 368788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 368794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368802 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 368802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 368807 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368811 */   GIR_RootConstrainSelectedInstOperands,
     /* 368812 */   // GIR_Coverage, 909,
     /* 368812 */   GIR_Done,
     /* 368813 */ // Label 7386: @368813
     /* 368813 */ GIM_Reject,
     /* 368814 */ // Label 7378: @368814
     /* 368814 */ GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(368844), // Rule ID 915 //
     /* 368819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368833 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 368833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 368838 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368842 */   GIR_RootConstrainSelectedInstOperands,
     /* 368843 */   // GIR_Coverage, 915,
     /* 368843 */   GIR_Done,
     /* 368844 */ // Label 7387: @368844
     /* 368844 */ GIM_Reject,
     /* 368845 */ // Label 7379: @368845
     /* 368845 */ GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(369066),
     /* 368850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368861 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(368880), // Rule ID 911 //
     /* 368866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368869 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 368869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 368874 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368878 */     GIR_RootConstrainSelectedInstOperands,
     /* 368879 */     // GIR_Coverage, 911,
     /* 368879 */     GIR_Done,
     /* 368880 */   // Label 7389: @368880
     /* 368880 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(369065), // Rule ID 6986 //
     /* 368885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 368888 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 368888 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 368891 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 368895 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368900 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 368904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 368906 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 368909 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 368913 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368918 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 368921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 368923 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 368926 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368930 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368935 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368941 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368946 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368951 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 368954 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 368958 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368963 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 368966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 368968 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 368971 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 368975 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368980 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 368983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 368985 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 368988 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 368992 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368997 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 369000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369002 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369005 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369009 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369028 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369031 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369034 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 369055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 369063 */     GIR_RootConstrainSelectedInstOperands,
     /* 369064 */     // GIR_Coverage, 6986,
     /* 369064 */     GIR_EraseRootFromParent_Done,
     /* 369065 */   // Label 7390: @369065
     /* 369065 */   GIM_Reject,
     /* 369066 */ // Label 7388: @369066
     /* 369066 */ GIM_Reject,
     /* 369067 */ // Label 7380: @369067
     /* 369067 */ GIM_Reject,
     /* 369068 */ // Label 97: @369068
     /* 369068 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7399*/ GIMT_Encode4(369367),
     /* 369079 */ /*GILLT_s16*//*Label 7391*/ GIMT_Encode4(369119),
     /* 369083 */ /*GILLT_s32*//*Label 7392*/ GIMT_Encode4(369150),
     /* 369087 */ /*GILLT_s64*//*Label 7393*/ GIMT_Encode4(369181), GIMT_Encode4(0),
     /* 369095 */ /*GILLT_v2s32*//*Label 7394*/ GIMT_Encode4(369212),
     /* 369099 */ /*GILLT_v2s64*//*Label 7395*/ GIMT_Encode4(369243),
     /* 369103 */ /*GILLT_v4s16*//*Label 7396*/ GIMT_Encode4(369274),
     /* 369107 */ /*GILLT_v4s32*//*Label 7397*/ GIMT_Encode4(369305), GIMT_Encode4(0),
     /* 369115 */ /*GILLT_v8s16*//*Label 7398*/ GIMT_Encode4(369336),
     /* 369119 */ // Label 7391: @369119
     /* 369119 */ GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(369149), // Rule ID 570 //
     /* 369124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369138 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 369138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 369143 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369147 */   GIR_RootConstrainSelectedInstOperands,
     /* 369148 */   // GIR_Coverage, 570,
     /* 369148 */   GIR_Done,
     /* 369149 */ // Label 7400: @369149
     /* 369149 */ GIM_Reject,
     /* 369150 */ // Label 7392: @369150
     /* 369150 */ GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(369180), // Rule ID 572 //
     /* 369155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369169 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 369169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 369174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369178 */   GIR_RootConstrainSelectedInstOperands,
     /* 369179 */   // GIR_Coverage, 572,
     /* 369179 */   GIR_Done,
     /* 369180 */ // Label 7401: @369180
     /* 369180 */ GIM_Reject,
     /* 369181 */ // Label 7393: @369181
     /* 369181 */ GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(369211), // Rule ID 574 //
     /* 369186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369200 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 369200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 369205 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369209 */   GIR_RootConstrainSelectedInstOperands,
     /* 369210 */   // GIR_Coverage, 574,
     /* 369210 */   GIR_Done,
     /* 369211 */ // Label 7402: @369211
     /* 369211 */ GIM_Reject,
     /* 369212 */ // Label 7394: @369212
     /* 369212 */ GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(369242), // Rule ID 960 //
     /* 369217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 369223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369231 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 369231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 369236 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369240 */   GIR_RootConstrainSelectedInstOperands,
     /* 369241 */   // GIR_Coverage, 960,
     /* 369241 */   GIR_Done,
     /* 369242 */ // Label 7403: @369242
     /* 369242 */ GIM_Reject,
     /* 369243 */ // Label 7395: @369243
     /* 369243 */ GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(369273), // Rule ID 964 //
     /* 369248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369262 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 369262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 369267 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369271 */   GIR_RootConstrainSelectedInstOperands,
     /* 369272 */   // GIR_Coverage, 964,
     /* 369272 */   GIR_Done,
     /* 369273 */ // Label 7404: @369273
     /* 369273 */ GIM_Reject,
     /* 369274 */ // Label 7396: @369274
     /* 369274 */ GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(369304), // Rule ID 956 //
     /* 369279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 369285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369293 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 369293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 369298 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369302 */   GIR_RootConstrainSelectedInstOperands,
     /* 369303 */   // GIR_Coverage, 956,
     /* 369303 */   GIR_Done,
     /* 369304 */ // Label 7405: @369304
     /* 369304 */ GIM_Reject,
     /* 369305 */ // Label 7397: @369305
     /* 369305 */ GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(369335), // Rule ID 962 //
     /* 369310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369324 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 369324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 369329 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369333 */   GIR_RootConstrainSelectedInstOperands,
     /* 369334 */   // GIR_Coverage, 962,
     /* 369334 */   GIR_Done,
     /* 369335 */ // Label 7406: @369335
     /* 369335 */ GIM_Reject,
     /* 369336 */ // Label 7398: @369336
     /* 369336 */ GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(369366), // Rule ID 958 //
     /* 369341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369355 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 369355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 369360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369364 */   GIR_RootConstrainSelectedInstOperands,
     /* 369365 */   // GIR_Coverage, 958,
     /* 369365 */   GIR_Done,
     /* 369366 */ // Label 7407: @369366
     /* 369366 */ GIM_Reject,
     /* 369367 */ // Label 7399: @369367
     /* 369367 */ GIM_Reject,
     /* 369368 */ // Label 98: @369368
     /* 369368 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7416*/ GIMT_Encode4(369858),
     /* 369379 */ /*GILLT_s16*//*Label 7408*/ GIMT_Encode4(369419),
     /* 369383 */ /*GILLT_s32*//*Label 7409*/ GIMT_Encode4(369450),
     /* 369387 */ /*GILLT_s64*//*Label 7410*/ GIMT_Encode4(369481), GIMT_Encode4(0),
     /* 369395 */ /*GILLT_v2s32*//*Label 7411*/ GIMT_Encode4(369512),
     /* 369399 */ /*GILLT_v2s64*//*Label 7412*/ GIMT_Encode4(369543),
     /* 369403 */ /*GILLT_v4s16*//*Label 7413*/ GIMT_Encode4(369574),
     /* 369407 */ /*GILLT_v4s32*//*Label 7414*/ GIMT_Encode4(369605), GIMT_Encode4(0),
     /* 369415 */ /*GILLT_v8s16*//*Label 7415*/ GIMT_Encode4(369636),
     /* 369419 */ // Label 7408: @369419
     /* 369419 */ GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(369449), // Rule ID 540 //
     /* 369424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369438 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 369438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 369443 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369447 */   GIR_RootConstrainSelectedInstOperands,
     /* 369448 */   // GIR_Coverage, 540,
     /* 369448 */   GIR_Done,
     /* 369449 */ // Label 7417: @369449
     /* 369449 */ GIM_Reject,
     /* 369450 */ // Label 7409: @369450
     /* 369450 */ GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(369480), // Rule ID 542 //
     /* 369455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369469 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 369469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 369474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369478 */   GIR_RootConstrainSelectedInstOperands,
     /* 369479 */   // GIR_Coverage, 542,
     /* 369479 */   GIR_Done,
     /* 369480 */ // Label 7418: @369480
     /* 369480 */ GIM_Reject,
     /* 369481 */ // Label 7410: @369481
     /* 369481 */ GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(369511), // Rule ID 544 //
     /* 369486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369500 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 369500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 369505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369509 */   GIR_RootConstrainSelectedInstOperands,
     /* 369510 */   // GIR_Coverage, 544,
     /* 369510 */   GIR_Done,
     /* 369511 */ // Label 7419: @369511
     /* 369511 */ GIM_Reject,
     /* 369512 */ // Label 7411: @369512
     /* 369512 */ GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(369542), // Rule ID 893 //
     /* 369517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 369523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369531 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 369531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 369536 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369540 */   GIR_RootConstrainSelectedInstOperands,
     /* 369541 */   // GIR_Coverage, 893,
     /* 369541 */   GIR_Done,
     /* 369542 */ // Label 7420: @369542
     /* 369542 */ GIM_Reject,
     /* 369543 */ // Label 7412: @369543
     /* 369543 */ GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(369573), // Rule ID 897 //
     /* 369548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369562 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 369562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 369567 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369571 */   GIR_RootConstrainSelectedInstOperands,
     /* 369572 */   // GIR_Coverage, 897,
     /* 369572 */   GIR_Done,
     /* 369573 */ // Label 7421: @369573
     /* 369573 */ GIM_Reject,
     /* 369574 */ // Label 7413: @369574
     /* 369574 */ GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(369604), // Rule ID 889 //
     /* 369579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 369585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369593 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 369593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 369598 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369602 */   GIR_RootConstrainSelectedInstOperands,
     /* 369603 */   // GIR_Coverage, 889,
     /* 369603 */   GIR_Done,
     /* 369604 */ // Label 7422: @369604
     /* 369604 */ GIM_Reject,
     /* 369605 */ // Label 7414: @369605
     /* 369605 */ GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(369635), // Rule ID 895 //
     /* 369610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369624 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 369624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 369629 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369633 */   GIR_RootConstrainSelectedInstOperands,
     /* 369634 */   // GIR_Coverage, 895,
     /* 369634 */   GIR_Done,
     /* 369635 */ // Label 7423: @369635
     /* 369635 */ GIM_Reject,
     /* 369636 */ // Label 7415: @369636
     /* 369636 */ GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(369857),
     /* 369641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369652 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(369671), // Rule ID 891 //
     /* 369657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369660 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 369660 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 369665 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369669 */     GIR_RootConstrainSelectedInstOperands,
     /* 369670 */     // GIR_Coverage, 891,
     /* 369670 */     GIR_Done,
     /* 369671 */   // Label 7425: @369671
     /* 369671 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(369856), // Rule ID 6988 //
     /* 369676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 369679 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 369679 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 369682 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 369686 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369691 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 369697 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 369700 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 369704 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369709 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 369712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 369714 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 369717 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369721 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369726 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369732 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369737 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369742 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 369745 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 369749 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369754 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 369757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 369759 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 369762 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 369766 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369771 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 369774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 369776 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 369779 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 369783 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369788 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 369791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 369846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 369854 */     GIR_RootConstrainSelectedInstOperands,
     /* 369855 */     // GIR_Coverage, 6988,
     /* 369855 */     GIR_EraseRootFromParent_Done,
     /* 369856 */   // Label 7426: @369856
     /* 369856 */   GIM_Reject,
     /* 369857 */ // Label 7424: @369857
     /* 369857 */ GIM_Reject,
     /* 369858 */ // Label 7416: @369858
     /* 369858 */ GIM_Reject,
     /* 369859 */ // Label 99: @369859
     /* 369859 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7435*/ GIMT_Encode4(370349),
     /* 369870 */ /*GILLT_s16*//*Label 7427*/ GIMT_Encode4(369910),
     /* 369874 */ /*GILLT_s32*//*Label 7428*/ GIMT_Encode4(369941),
     /* 369878 */ /*GILLT_s64*//*Label 7429*/ GIMT_Encode4(369972), GIMT_Encode4(0),
     /* 369886 */ /*GILLT_v2s32*//*Label 7430*/ GIMT_Encode4(370003),
     /* 369890 */ /*GILLT_v2s64*//*Label 7431*/ GIMT_Encode4(370034),
     /* 369894 */ /*GILLT_v4s16*//*Label 7432*/ GIMT_Encode4(370065),
     /* 369898 */ /*GILLT_v4s32*//*Label 7433*/ GIMT_Encode4(370096), GIMT_Encode4(0),
     /* 369906 */ /*GILLT_v8s16*//*Label 7434*/ GIMT_Encode4(370127),
     /* 369910 */ // Label 7427: @369910
     /* 369910 */ GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(369940), // Rule ID 558 //
     /* 369915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369929 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 369929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 369934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369938 */   GIR_RootConstrainSelectedInstOperands,
     /* 369939 */   // GIR_Coverage, 558,
     /* 369939 */   GIR_Done,
     /* 369940 */ // Label 7436: @369940
     /* 369940 */ GIM_Reject,
     /* 369941 */ // Label 7428: @369941
     /* 369941 */ GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(369971), // Rule ID 560 //
     /* 369946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369960 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 369960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 369965 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369969 */   GIR_RootConstrainSelectedInstOperands,
     /* 369970 */   // GIR_Coverage, 560,
     /* 369970 */   GIR_Done,
     /* 369971 */ // Label 7437: @369971
     /* 369971 */ GIM_Reject,
     /* 369972 */ // Label 7429: @369972
     /* 369972 */ GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(370002), // Rule ID 562 //
     /* 369977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369991 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 369991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 369996 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370000 */   GIR_RootConstrainSelectedInstOperands,
     /* 370001 */   // GIR_Coverage, 562,
     /* 370001 */   GIR_Done,
     /* 370002 */ // Label 7438: @370002
     /* 370002 */ GIM_Reject,
     /* 370003 */ // Label 7430: @370003
     /* 370003 */ GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(370033), // Rule ID 923 //
     /* 370008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370022 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 370022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 370027 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370031 */   GIR_RootConstrainSelectedInstOperands,
     /* 370032 */   // GIR_Coverage, 923,
     /* 370032 */   GIR_Done,
     /* 370033 */ // Label 7439: @370033
     /* 370033 */ GIM_Reject,
     /* 370034 */ // Label 7431: @370034
     /* 370034 */ GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(370064), // Rule ID 927 //
     /* 370039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370053 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 370053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 370058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370062 */   GIR_RootConstrainSelectedInstOperands,
     /* 370063 */   // GIR_Coverage, 927,
     /* 370063 */   GIR_Done,
     /* 370064 */ // Label 7440: @370064
     /* 370064 */ GIM_Reject,
     /* 370065 */ // Label 7432: @370065
     /* 370065 */ GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(370095), // Rule ID 919 //
     /* 370070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 370076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370084 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 370084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 370089 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370093 */   GIR_RootConstrainSelectedInstOperands,
     /* 370094 */   // GIR_Coverage, 919,
     /* 370094 */   GIR_Done,
     /* 370095 */ // Label 7441: @370095
     /* 370095 */ GIM_Reject,
     /* 370096 */ // Label 7433: @370096
     /* 370096 */ GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(370126), // Rule ID 925 //
     /* 370101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370115 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 370115 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 370120 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370124 */   GIR_RootConstrainSelectedInstOperands,
     /* 370125 */   // GIR_Coverage, 925,
     /* 370125 */   GIR_Done,
     /* 370126 */ // Label 7442: @370126
     /* 370126 */ GIM_Reject,
     /* 370127 */ // Label 7434: @370127
     /* 370127 */ GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(370348),
     /* 370132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370143 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(370162), // Rule ID 921 //
     /* 370148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370151 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 370151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 370156 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370160 */     GIR_RootConstrainSelectedInstOperands,
     /* 370161 */     // GIR_Coverage, 921,
     /* 370161 */     GIR_Done,
     /* 370162 */   // Label 7444: @370162
     /* 370162 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(370347), // Rule ID 6996 //
     /* 370167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 370170 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 370170 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 370173 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370177 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370182 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 370188 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 370191 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 370195 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370200 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 370203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 370205 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 370208 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370212 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370217 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370223 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370228 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370233 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 370236 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370240 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370245 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 370248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 370250 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 370253 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 370257 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370262 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 370265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 370267 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 370270 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 370274 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370279 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 370282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 370319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 370337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 370345 */     GIR_RootConstrainSelectedInstOperands,
     /* 370346 */     // GIR_Coverage, 6996,
     /* 370346 */     GIR_EraseRootFromParent_Done,
     /* 370347 */   // Label 7445: @370347
     /* 370347 */   GIM_Reject,
     /* 370348 */ // Label 7443: @370348
     /* 370348 */ GIM_Reject,
     /* 370349 */ // Label 7435: @370349
     /* 370349 */ GIM_Reject,
     /* 370350 */ // Label 100: @370350
     /* 370350 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7454*/ GIMT_Encode4(370840),
     /* 370361 */ /*GILLT_s16*//*Label 7446*/ GIMT_Encode4(370401),
     /* 370365 */ /*GILLT_s32*//*Label 7447*/ GIMT_Encode4(370432),
     /* 370369 */ /*GILLT_s64*//*Label 7448*/ GIMT_Encode4(370463), GIMT_Encode4(0),
     /* 370377 */ /*GILLT_v2s32*//*Label 7449*/ GIMT_Encode4(370494),
     /* 370381 */ /*GILLT_v2s64*//*Label 7450*/ GIMT_Encode4(370525),
     /* 370385 */ /*GILLT_v4s16*//*Label 7451*/ GIMT_Encode4(370556),
     /* 370389 */ /*GILLT_v4s32*//*Label 7452*/ GIMT_Encode4(370587), GIMT_Encode4(0),
     /* 370397 */ /*GILLT_v8s16*//*Label 7453*/ GIMT_Encode4(370618),
     /* 370401 */ // Label 7446: @370401
     /* 370401 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(370431), // Rule ID 534 //
     /* 370406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 370409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370420 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 370420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 370425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370429 */   GIR_RootConstrainSelectedInstOperands,
     /* 370430 */   // GIR_Coverage, 534,
     /* 370430 */   GIR_Done,
     /* 370431 */ // Label 7455: @370431
     /* 370431 */ GIM_Reject,
     /* 370432 */ // Label 7447: @370432
     /* 370432 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(370462), // Rule ID 536 //
     /* 370437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370451 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 370451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 370456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370460 */   GIR_RootConstrainSelectedInstOperands,
     /* 370461 */   // GIR_Coverage, 536,
     /* 370461 */   GIR_Done,
     /* 370462 */ // Label 7456: @370462
     /* 370462 */ GIM_Reject,
     /* 370463 */ // Label 7448: @370463
     /* 370463 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(370493), // Rule ID 538 //
     /* 370468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370482 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 370482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 370487 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370491 */   GIR_RootConstrainSelectedInstOperands,
     /* 370492 */   // GIR_Coverage, 538,
     /* 370492 */   GIR_Done,
     /* 370493 */ // Label 7457: @370493
     /* 370493 */ GIM_Reject,
     /* 370494 */ // Label 7449: @370494
     /* 370494 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(370524), // Rule ID 883 //
     /* 370499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370513 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 370513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 370518 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370522 */   GIR_RootConstrainSelectedInstOperands,
     /* 370523 */   // GIR_Coverage, 883,
     /* 370523 */   GIR_Done,
     /* 370524 */ // Label 7458: @370524
     /* 370524 */ GIM_Reject,
     /* 370525 */ // Label 7450: @370525
     /* 370525 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(370555), // Rule ID 887 //
     /* 370530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370544 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 370544 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 370549 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370553 */   GIR_RootConstrainSelectedInstOperands,
     /* 370554 */   // GIR_Coverage, 887,
     /* 370554 */   GIR_Done,
     /* 370555 */ // Label 7459: @370555
     /* 370555 */ GIM_Reject,
     /* 370556 */ // Label 7451: @370556
     /* 370556 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(370586), // Rule ID 879 //
     /* 370561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 370567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370575 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 370575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 370580 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370584 */   GIR_RootConstrainSelectedInstOperands,
     /* 370585 */   // GIR_Coverage, 879,
     /* 370585 */   GIR_Done,
     /* 370586 */ // Label 7460: @370586
     /* 370586 */ GIM_Reject,
     /* 370587 */ // Label 7452: @370587
     /* 370587 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(370617), // Rule ID 885 //
     /* 370592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370606 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 370606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 370611 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370615 */   GIR_RootConstrainSelectedInstOperands,
     /* 370616 */   // GIR_Coverage, 885,
     /* 370616 */   GIR_Done,
     /* 370617 */ // Label 7461: @370617
     /* 370617 */ GIM_Reject,
     /* 370618 */ // Label 7453: @370618
     /* 370618 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(370839),
     /* 370623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370634 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(370653), // Rule ID 881 //
     /* 370639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370642 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 370642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 370647 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370651 */     GIR_RootConstrainSelectedInstOperands,
     /* 370652 */     // GIR_Coverage, 881,
     /* 370652 */     GIR_Done,
     /* 370653 */   // Label 7463: @370653
     /* 370653 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(370838), // Rule ID 6990 //
     /* 370658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 370661 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 370661 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 370664 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370668 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370673 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 370679 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 370682 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 370686 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370691 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 370694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 370696 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 370699 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370703 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370708 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370714 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370719 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370724 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 370727 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370731 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370736 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 370739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 370741 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 370744 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 370748 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370753 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 370756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 370758 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 370761 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 370765 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370770 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 370773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370775 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370778 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370782 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370801 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370804 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 370810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 370828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 370836 */     GIR_RootConstrainSelectedInstOperands,
     /* 370837 */     // GIR_Coverage, 6990,
     /* 370837 */     GIR_EraseRootFromParent_Done,
     /* 370838 */   // Label 7464: @370838
     /* 370838 */   GIM_Reject,
     /* 370839 */ // Label 7462: @370839
     /* 370839 */ GIM_Reject,
     /* 370840 */ // Label 7454: @370840
     /* 370840 */ GIM_Reject,
     /* 370841 */ // Label 101: @370841
     /* 370841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7473*/ GIMT_Encode4(371966),
     /* 370852 */ /*GILLT_s16*//*Label 7465*/ GIMT_Encode4(370892),
     /* 370856 */ /*GILLT_s32*//*Label 7466*/ GIMT_Encode4(371118),
     /* 370860 */ /*GILLT_s64*//*Label 7467*/ GIMT_Encode4(371344), GIMT_Encode4(0),
     /* 370868 */ /*GILLT_v2s32*//*Label 7468*/ GIMT_Encode4(371516),
     /* 370872 */ /*GILLT_v2s64*//*Label 7469*/ GIMT_Encode4(371554),
     /* 370876 */ /*GILLT_v4s16*//*Label 7470*/ GIMT_Encode4(371592),
     /* 370880 */ /*GILLT_v4s32*//*Label 7471*/ GIMT_Encode4(371630), GIMT_Encode4(0),
     /* 370888 */ /*GILLT_v8s16*//*Label 7472*/ GIMT_Encode4(371668),
     /* 370892 */ // Label 7465: @370892
     /* 370892 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(371117),
     /* 370897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370907 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(370998), // Rule ID 6910 //
     /* 370912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370949 */     // MIs[2] Rn
     /* 370949 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370954 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 370958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370960 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 370960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370972 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 370991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370996 */     GIR_RootConstrainSelectedInstOperands,
     /* 370997 */     // GIR_Coverage, 6910,
     /* 370997 */     GIR_EraseRootFromParent_Done,
     /* 370998 */   // Label 7475: @370998
     /* 370998 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(371089), // Rule ID 13913 //
     /* 371003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371024 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371040 */     // MIs[2] Rn
     /* 371040 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371045 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371051 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 371051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371063 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 371082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371087 */     GIR_RootConstrainSelectedInstOperands,
     /* 371088 */     // GIR_Coverage, 13913,
     /* 371088 */     GIR_EraseRootFromParent_Done,
     /* 371089 */   // Label 7476: @371089
     /* 371089 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(371116), // Rule ID 583 //
     /* 371094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371105 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 371105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 371110 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371114 */     GIR_RootConstrainSelectedInstOperands,
     /* 371115 */     // GIR_Coverage, 583,
     /* 371115 */     GIR_Done,
     /* 371116 */   // Label 7477: @371116
     /* 371116 */   GIM_Reject,
     /* 371117 */ // Label 7474: @371117
     /* 371117 */ GIM_Reject,
     /* 371118 */ // Label 7466: @371118
     /* 371118 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(371343),
     /* 371123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371133 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(371224), // Rule ID 6908 //
     /* 371138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371159 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371175 */     // MIs[2] Rn
     /* 371175 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371180 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371186 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 371186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371198 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 371217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371222 */     GIR_RootConstrainSelectedInstOperands,
     /* 371223 */     // GIR_Coverage, 6908,
     /* 371223 */     GIR_EraseRootFromParent_Done,
     /* 371224 */   // Label 7479: @371224
     /* 371224 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(371315), // Rule ID 13911 //
     /* 371229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371250 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371266 */     // MIs[2] Rn
     /* 371266 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371271 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371277 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 371277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 371280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371289 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 371308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371313 */     GIR_RootConstrainSelectedInstOperands,
     /* 371314 */     // GIR_Coverage, 13911,
     /* 371314 */     GIR_EraseRootFromParent_Done,
     /* 371315 */   // Label 7480: @371315
     /* 371315 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(371342), // Rule ID 585 //
     /* 371320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371331 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 371331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 371336 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371340 */     GIR_RootConstrainSelectedInstOperands,
     /* 371341 */     // GIR_Coverage, 585,
     /* 371341 */     GIR_Done,
     /* 371342 */   // Label 7481: @371342
     /* 371342 */   GIM_Reject,
     /* 371343 */ // Label 7478: @371343
     /* 371343 */ GIM_Reject,
     /* 371344 */ // Label 7467: @371344
     /* 371344 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(371515),
     /* 371349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 371355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371359 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(371423), // Rule ID 6906 //
     /* 371364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371385 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371401 */     // MIs[2] Rn
     /* 371401 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371406 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 371410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371412 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 371412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 371415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371421 */     GIR_RootConstrainSelectedInstOperands,
     /* 371422 */     // GIR_Coverage, 6906,
     /* 371422 */     GIR_EraseRootFromParent_Done,
     /* 371423 */   // Label 7483: @371423
     /* 371423 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(371487), // Rule ID 13909 //
     /* 371428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371449 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371465 */     // MIs[2] Rn
     /* 371465 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371470 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371476 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 371476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 371479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371485 */     GIR_RootConstrainSelectedInstOperands,
     /* 371486 */     // GIR_Coverage, 13909,
     /* 371486 */     GIR_EraseRootFromParent_Done,
     /* 371487 */   // Label 7484: @371487
     /* 371487 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(371514), // Rule ID 587 //
     /* 371492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371503 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 371503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 371508 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371512 */     GIR_RootConstrainSelectedInstOperands,
     /* 371513 */     // GIR_Coverage, 587,
     /* 371513 */     GIR_Done,
     /* 371514 */   // Label 7485: @371514
     /* 371514 */   GIM_Reject,
     /* 371515 */ // Label 7482: @371515
     /* 371515 */ GIM_Reject,
     /* 371516 */ // Label 7468: @371516
     /* 371516 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(371553), // Rule ID 1202 //
     /* 371521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 371530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371542 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 371542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 371547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371551 */   GIR_RootConstrainSelectedInstOperands,
     /* 371552 */   // GIR_Coverage, 1202,
     /* 371552 */   GIR_Done,
     /* 371553 */ // Label 7486: @371553
     /* 371553 */ GIM_Reject,
     /* 371554 */ // Label 7469: @371554
     /* 371554 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(371591), // Rule ID 1206 //
     /* 371559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 371568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371580 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 371580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 371585 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371589 */   GIR_RootConstrainSelectedInstOperands,
     /* 371590 */   // GIR_Coverage, 1206,
     /* 371590 */   GIR_Done,
     /* 371591 */ // Label 7487: @371591
     /* 371591 */ GIM_Reject,
     /* 371592 */ // Label 7470: @371592
     /* 371592 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(371629), // Rule ID 1198 //
     /* 371597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 371606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371618 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 371618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 371623 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371627 */   GIR_RootConstrainSelectedInstOperands,
     /* 371628 */   // GIR_Coverage, 1198,
     /* 371628 */   GIR_Done,
     /* 371629 */ // Label 7488: @371629
     /* 371629 */ GIM_Reject,
     /* 371630 */ // Label 7471: @371630
     /* 371630 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(371667), // Rule ID 1204 //
     /* 371635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 371644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371656 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 371656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 371661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371665 */   GIR_RootConstrainSelectedInstOperands,
     /* 371666 */   // GIR_Coverage, 1204,
     /* 371666 */   GIR_Done,
     /* 371667 */ // Label 7489: @371667
     /* 371667 */ GIM_Reject,
     /* 371668 */ // Label 7472: @371668
     /* 371668 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(371965),
     /* 371673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 371679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371691 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(371710), // Rule ID 1200 //
     /* 371696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371699 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 371699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 371704 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371708 */     GIR_RootConstrainSelectedInstOperands,
     /* 371709 */     // GIR_Coverage, 1200,
     /* 371709 */     GIR_Done,
     /* 371710 */   // Label 7491: @371710
     /* 371710 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(371964), // Rule ID 6999 //
     /* 371715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 371718 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 371718 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 371721 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371725 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371730 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 371736 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 371739 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371743 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371748 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 371754 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 371757 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 371761 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371766 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 371769 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 371772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 371774 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 371777 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371781 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371786 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371792 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371797 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371802 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 371805 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371809 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371814 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 371817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 371819 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 371822 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371826 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371831 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371837 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371842 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371847 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 371850 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371854 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371859 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 371862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 371864 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 371867 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 371871 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371876 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 371879 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 371882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 371884 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 371887 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 371891 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371896 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 371899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371901 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371904 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371908 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371927 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371933 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 371936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 371954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 371962 */     GIR_RootConstrainSelectedInstOperands,
     /* 371963 */     // GIR_Coverage, 6999,
     /* 371963 */     GIR_EraseRootFromParent_Done,
     /* 371964 */   // Label 7492: @371964
     /* 371964 */   GIM_Reject,
     /* 371965 */ // Label 7490: @371965
     /* 371965 */ GIM_Reject,
     /* 371966 */ // Label 7473: @371966
     /* 371966 */ GIM_Reject,
     /* 371967 */ // Label 102: @371967
     /* 371967 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7501*/ GIMT_Encode4(372582),
     /* 371978 */ /*GILLT_s16*//*Label 7493*/ GIMT_Encode4(372018),
     /* 371982 */ /*GILLT_s32*//*Label 7494*/ GIMT_Encode4(372056),
     /* 371986 */ /*GILLT_s64*//*Label 7495*/ GIMT_Encode4(372094), GIMT_Encode4(0),
     /* 371994 */ /*GILLT_v2s32*//*Label 7496*/ GIMT_Encode4(372132),
     /* 371998 */ /*GILLT_v2s64*//*Label 7497*/ GIMT_Encode4(372170),
     /* 372002 */ /*GILLT_v4s16*//*Label 7498*/ GIMT_Encode4(372208),
     /* 372006 */ /*GILLT_v4s32*//*Label 7499*/ GIMT_Encode4(372246), GIMT_Encode4(0),
     /* 372014 */ /*GILLT_v8s16*//*Label 7500*/ GIMT_Encode4(372284),
     /* 372018 */ // Label 7493: @372018
     /* 372018 */ GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(372055), // Rule ID 631 //
     /* 372023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372044 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 372044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 372049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372053 */   GIR_RootConstrainSelectedInstOperands,
     /* 372054 */   // GIR_Coverage, 631,
     /* 372054 */   GIR_Done,
     /* 372055 */ // Label 7502: @372055
     /* 372055 */ GIM_Reject,
     /* 372056 */ // Label 7494: @372056
     /* 372056 */ GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(372093), // Rule ID 633 //
     /* 372061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372082 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 372082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 372087 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372091 */   GIR_RootConstrainSelectedInstOperands,
     /* 372092 */   // GIR_Coverage, 633,
     /* 372092 */   GIR_Done,
     /* 372093 */ // Label 7503: @372093
     /* 372093 */ GIM_Reject,
     /* 372094 */ // Label 7495: @372094
     /* 372094 */ GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(372131), // Rule ID 635 //
     /* 372099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 372108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372120 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 372120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 372125 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372129 */   GIR_RootConstrainSelectedInstOperands,
     /* 372130 */   // GIR_Coverage, 635,
     /* 372130 */   GIR_Done,
     /* 372131 */ // Label 7504: @372131
     /* 372131 */ GIM_Reject,
     /* 372132 */ // Label 7496: @372132
     /* 372132 */ GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(372169), // Rule ID 1342 //
     /* 372137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 372143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 372146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372158 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 372158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 372163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372167 */   GIR_RootConstrainSelectedInstOperands,
     /* 372168 */   // GIR_Coverage, 1342,
     /* 372168 */   GIR_Done,
     /* 372169 */ // Label 7505: @372169
     /* 372169 */ GIM_Reject,
     /* 372170 */ // Label 7497: @372170
     /* 372170 */ GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(372207), // Rule ID 1346 //
     /* 372175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 372184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372196 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 372196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 372201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372205 */   GIR_RootConstrainSelectedInstOperands,
     /* 372206 */   // GIR_Coverage, 1346,
     /* 372206 */   GIR_Done,
     /* 372207 */ // Label 7506: @372207
     /* 372207 */ GIM_Reject,
     /* 372208 */ // Label 7498: @372208
     /* 372208 */ GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(372245), // Rule ID 1338 //
     /* 372213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 372219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 372222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372234 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 372234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 372239 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372243 */   GIR_RootConstrainSelectedInstOperands,
     /* 372244 */   // GIR_Coverage, 1338,
     /* 372244 */   GIR_Done,
     /* 372245 */ // Label 7507: @372245
     /* 372245 */ GIM_Reject,
     /* 372246 */ // Label 7499: @372246
     /* 372246 */ GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(372283), // Rule ID 1344 //
     /* 372251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 372260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372272 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 372272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 372277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372281 */   GIR_RootConstrainSelectedInstOperands,
     /* 372282 */   // GIR_Coverage, 1344,
     /* 372282 */   GIR_Done,
     /* 372283 */ // Label 7508: @372283
     /* 372283 */ GIM_Reject,
     /* 372284 */ // Label 7500: @372284
     /* 372284 */ GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(372581),
     /* 372289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 372295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372307 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(372326), // Rule ID 1340 //
     /* 372312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372315 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 372315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 372320 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372324 */     GIR_RootConstrainSelectedInstOperands,
     /* 372325 */     // GIR_Coverage, 1340,
     /* 372325 */     GIR_Done,
     /* 372326 */   // Label 7510: @372326
     /* 372326 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(372580), // Rule ID 7005 //
     /* 372331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 372334 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 372334 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 372337 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 372341 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372346 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 372350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 372352 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 372355 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 372359 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372364 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 372368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 372370 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 372373 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 372377 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372382 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 372385 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 372388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 372390 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 372393 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372397 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372402 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 372408 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372413 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372418 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 372421 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 372425 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372430 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 372433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 372435 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 372438 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372442 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372447 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372453 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372458 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372463 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 372466 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 372470 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372475 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 372478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 372480 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 372483 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 372487 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372492 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 372495 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 372498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 372500 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 372503 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 372507 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372512 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 372515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 372520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 372549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 372570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 372578 */     GIR_RootConstrainSelectedInstOperands,
     /* 372579 */     // GIR_Coverage, 7005,
     /* 372579 */     GIR_EraseRootFromParent_Done,
     /* 372580 */   // Label 7511: @372580
     /* 372580 */   GIM_Reject,
     /* 372581 */ // Label 7509: @372581
     /* 372581 */ GIM_Reject,
     /* 372582 */ // Label 7501: @372582
     /* 372582 */ GIM_Reject,
     /* 372583 */ // Label 103: @372583
     /* 372583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7520*/ GIMT_Encode4(376304),
     /* 372594 */ /*GILLT_s16*//*Label 7512*/ GIMT_Encode4(372634),
     /* 372598 */ /*GILLT_s32*//*Label 7513*/ GIMT_Encode4(373188),
     /* 372602 */ /*GILLT_s64*//*Label 7514*/ GIMT_Encode4(373736), GIMT_Encode4(0),
     /* 372610 */ /*GILLT_v2s32*//*Label 7515*/ GIMT_Encode4(374284),
     /* 372614 */ /*GILLT_v2s64*//*Label 7516*/ GIMT_Encode4(374814),
     /* 372618 */ /*GILLT_v4s16*//*Label 7517*/ GIMT_Encode4(375172),
     /* 372622 */ /*GILLT_v4s32*//*Label 7518*/ GIMT_Encode4(375514), GIMT_Encode4(0),
     /* 372630 */ /*GILLT_v8s16*//*Label 7519*/ GIMT_Encode4(375872),
     /* 372634 */ // Label 7512: @372634
     /* 372634 */ GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(373187),
     /* 372639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372649 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(372762), // Rule ID 6240 //
     /* 372654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372678 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372715 */     // MIs[3] Operand 1
     /* 372715 */     // No operand predicates
     /* 372715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372717 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372729 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 372748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372760 */     GIR_RootConstrainSelectedInstOperands,
     /* 372761 */     // GIR_Coverage, 6240,
     /* 372761 */     GIR_EraseRootFromParent_Done,
     /* 372762 */   // Label 7522: @372762
     /* 372762 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(372875), // Rule ID 13890 //
     /* 372767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372803 */     // MIs[2] Operand 1
     /* 372803 */     // No operand predicates
     /* 372803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372811 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372815 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372819 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372824 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 372828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372830 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372842 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372848 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 372861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372873 */     GIR_RootConstrainSelectedInstOperands,
     /* 372874 */     // GIR_Coverage, 13890,
     /* 372874 */     GIR_EraseRootFromParent_Done,
     /* 372875 */   // Label 7523: @372875
     /* 372875 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(372954), // Rule ID 13824 //
     /* 372880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372914 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 372914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372926 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 372932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 372945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372952 */     GIR_RootConstrainSelectedInstOperands,
     /* 372953 */     // GIR_Coverage, 13824,
     /* 372953 */     GIR_EraseRootFromParent_Done,
     /* 372954 */   // Label 7524: @372954
     /* 372954 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(373033), // Rule ID 4802 //
     /* 372959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372987 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372993 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 372993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373005 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 373011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 373024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373031 */     GIR_RootConstrainSelectedInstOperands,
     /* 373032 */     // GIR_Coverage, 4802,
     /* 373032 */     GIR_EraseRootFromParent_Done,
     /* 373033 */   // Label 7525: @373033
     /* 373033 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(373096), // Rule ID 13439 //
     /* 373038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 373062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373074 */     // MIs[2] Operand 1
     /* 373074 */     // No operand predicates
     /* 373074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373080 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 373083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373094 */     GIR_RootConstrainSelectedInstOperands,
     /* 373095 */     // GIR_Coverage, 13439,
     /* 373095 */     GIR_EraseRootFromParent_Done,
     /* 373096 */   // Label 7526: @373096
     /* 373096 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(373159), // Rule ID 2011 //
     /* 373101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 373129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373141 */     // MIs[2] Operand 1
     /* 373141 */     // No operand predicates
     /* 373141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373143 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 373146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373157 */     GIR_RootConstrainSelectedInstOperands,
     /* 373158 */     // GIR_Coverage, 2011,
     /* 373158 */     GIR_EraseRootFromParent_Done,
     /* 373159 */   // Label 7527: @373159
     /* 373159 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(373186), // Rule ID 619 //
     /* 373164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373175 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 373175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 373180 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373184 */     GIR_RootConstrainSelectedInstOperands,
     /* 373185 */     // GIR_Coverage, 619,
     /* 373185 */     GIR_Done,
     /* 373186 */   // Label 7528: @373186
     /* 373186 */   GIM_Reject,
     /* 373187 */ // Label 7521: @373187
     /* 373187 */ GIM_Reject,
     /* 373188 */ // Label 7513: @373188
     /* 373188 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(373735),
     /* 373193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 373196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373203 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(373316), // Rule ID 6242 //
     /* 373208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373232 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373265 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373269 */     // MIs[3] Operand 1
     /* 373269 */     // No operand predicates
     /* 373269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373271 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 373274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373283 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 373289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 373302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373314 */     GIR_RootConstrainSelectedInstOperands,
     /* 373315 */     // GIR_Coverage, 6242,
     /* 373315 */     GIR_EraseRootFromParent_Done,
     /* 373316 */   // Label 7530: @373316
     /* 373316 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(373429), // Rule ID 13892 //
     /* 373321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373353 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373357 */     // MIs[2] Operand 1
     /* 373357 */     // No operand predicates
     /* 373357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373365 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373369 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 373373 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373378 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 373382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373384 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 373384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 373387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373396 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 373402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 373415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373427 */     GIR_RootConstrainSelectedInstOperands,
     /* 373428 */     // GIR_Coverage, 13892,
     /* 373428 */     GIR_EraseRootFromParent_Done,
     /* 373429 */   // Label 7531: @373429
     /* 373429 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(373505), // Rule ID 13826 //
     /* 373434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373455 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373465 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 373465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 373468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373477 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 373483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 373496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373503 */     GIR_RootConstrainSelectedInstOperands,
     /* 373504 */     // GIR_Coverage, 13826,
     /* 373504 */     GIR_EraseRootFromParent_Done,
     /* 373505 */   // Label 7532: @373505
     /* 373505 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(373581), // Rule ID 4804 //
     /* 373510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373535 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373541 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 373541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 373544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373553 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 373559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 373572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373579 */     GIR_RootConstrainSelectedInstOperands,
     /* 373580 */     // GIR_Coverage, 4804,
     /* 373580 */     GIR_EraseRootFromParent_Done,
     /* 373581 */   // Label 7533: @373581
     /* 373581 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(373644), // Rule ID 13441 //
     /* 373586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373618 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373622 */     // MIs[2] Operand 1
     /* 373622 */     // No operand predicates
     /* 373622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373628 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 373631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373642 */     GIR_RootConstrainSelectedInstOperands,
     /* 373643 */     // GIR_Coverage, 13441,
     /* 373643 */     GIR_EraseRootFromParent_Done,
     /* 373644 */   // Label 7534: @373644
     /* 373644 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(373707), // Rule ID 2013 //
     /* 373649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373685 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373689 */     // MIs[2] Operand 1
     /* 373689 */     // No operand predicates
     /* 373689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373691 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 373694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373705 */     GIR_RootConstrainSelectedInstOperands,
     /* 373706 */     // GIR_Coverage, 2013,
     /* 373706 */     GIR_EraseRootFromParent_Done,
     /* 373707 */   // Label 7535: @373707
     /* 373707 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(373734), // Rule ID 621 //
     /* 373712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373723 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 373723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 373728 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373732 */     GIR_RootConstrainSelectedInstOperands,
     /* 373733 */     // GIR_Coverage, 621,
     /* 373733 */     GIR_Done,
     /* 373734 */   // Label 7536: @373734
     /* 373734 */   GIM_Reject,
     /* 373735 */ // Label 7529: @373735
     /* 373735 */ GIM_Reject,
     /* 373736 */ // Label 7514: @373736
     /* 373736 */ GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(374283),
     /* 373741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 373747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373751 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(373864), // Rule ID 6244 //
     /* 373756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373780 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373817 */     // MIs[3] Operand 1
     /* 373817 */     // No operand predicates
     /* 373817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373819 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373831 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 373850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373862 */     GIR_RootConstrainSelectedInstOperands,
     /* 373863 */     // GIR_Coverage, 6244,
     /* 373863 */     GIR_EraseRootFromParent_Done,
     /* 373864 */   // Label 7538: @373864
     /* 373864 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(373977), // Rule ID 13894 //
     /* 373869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373901 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373905 */     // MIs[2] Operand 1
     /* 373905 */     // No operand predicates
     /* 373905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373917 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 373921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373926 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 373930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373932 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373944 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 373963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373975 */     GIR_RootConstrainSelectedInstOperands,
     /* 373976 */     // GIR_Coverage, 13894,
     /* 373976 */     GIR_EraseRootFromParent_Done,
     /* 373977 */   // Label 7539: @373977
     /* 373977 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(374053), // Rule ID 13828 //
     /* 373982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374013 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 374013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374025 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 374031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 374044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374051 */     GIR_RootConstrainSelectedInstOperands,
     /* 374052 */     // GIR_Coverage, 13828,
     /* 374052 */     GIR_EraseRootFromParent_Done,
     /* 374053 */   // Label 7540: @374053
     /* 374053 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(374129), // Rule ID 4806 //
     /* 374058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374089 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 374089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 374092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374101 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 374107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 374120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374127 */     GIR_RootConstrainSelectedInstOperands,
     /* 374128 */     // GIR_Coverage, 4806,
     /* 374128 */     GIR_EraseRootFromParent_Done,
     /* 374129 */   // Label 7541: @374129
     /* 374129 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(374192), // Rule ID 13443 //
     /* 374134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374166 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374170 */     // MIs[2] Operand 1
     /* 374170 */     // No operand predicates
     /* 374170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374176 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 374179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374190 */     GIR_RootConstrainSelectedInstOperands,
     /* 374191 */     // GIR_Coverage, 13443,
     /* 374191 */     GIR_EraseRootFromParent_Done,
     /* 374192 */   // Label 7542: @374192
     /* 374192 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(374255), // Rule ID 2015 //
     /* 374197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374233 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374237 */     // MIs[2] Operand 1
     /* 374237 */     // No operand predicates
     /* 374237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374239 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 374242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374253 */     GIR_RootConstrainSelectedInstOperands,
     /* 374254 */     // GIR_Coverage, 2015,
     /* 374254 */     GIR_EraseRootFromParent_Done,
     /* 374255 */   // Label 7543: @374255
     /* 374255 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(374282), // Rule ID 623 //
     /* 374260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374271 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 374271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 374276 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374280 */     GIR_RootConstrainSelectedInstOperands,
     /* 374281 */     // GIR_Coverage, 623,
     /* 374281 */     GIR_Done,
     /* 374282 */   // Label 7544: @374282
     /* 374282 */   GIM_Reject,
     /* 374283 */ // Label 7537: @374283
     /* 374283 */ GIM_Reject,
     /* 374284 */ // Label 7515: @374284
     /* 374284 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(374813),
     /* 374289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 374292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 374295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374299 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(374385), // Rule ID 13431 //
     /* 374304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 374315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374348 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374352 */     // MIs[3] Operand 1
     /* 374352 */     // No operand predicates
     /* 374352 */     // MIs[1] Operand 2
     /* 374352 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 374363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374369 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374383 */     GIR_RootConstrainSelectedInstOperands,
     /* 374384 */     // GIR_Coverage, 13431,
     /* 374384 */     GIR_EraseRootFromParent_Done,
     /* 374385 */   // Label 7546: @374385
     /* 374385 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(374471), // Rule ID 2003 //
     /* 374390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 374405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374438 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374442 */     // MIs[3] Operand 1
     /* 374442 */     // No operand predicates
     /* 374442 */     // MIs[1] Operand 2
     /* 374442 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 374453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374455 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374469 */     GIR_RootConstrainSelectedInstOperands,
     /* 374470 */     // GIR_Coverage, 2003,
     /* 374470 */     GIR_EraseRootFromParent_Done,
     /* 374471 */   // Label 7547: @374471
     /* 374471 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(374534), // Rule ID 13432 //
     /* 374476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374508 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374512 */     // MIs[2] Operand 1
     /* 374512 */     // No operand predicates
     /* 374512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374518 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374532 */     GIR_RootConstrainSelectedInstOperands,
     /* 374533 */     // GIR_Coverage, 13432,
     /* 374533 */     GIR_EraseRootFromParent_Done,
     /* 374534 */   // Label 7548: @374534
     /* 374534 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(374597), // Rule ID 2004 //
     /* 374539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374579 */     // MIs[2] Operand 1
     /* 374579 */     // No operand predicates
     /* 374579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374581 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374595 */     GIR_RootConstrainSelectedInstOperands,
     /* 374596 */     // GIR_Coverage, 2004,
     /* 374596 */     GIR_EraseRootFromParent_Done,
     /* 374597 */   // Label 7549: @374597
     /* 374597 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(374691), // Rule ID 13896 //
     /* 374602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374625 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374625 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374628 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374632 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374658 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374689 */     GIR_RootConstrainSelectedInstOperands,
     /* 374690 */     // GIR_Coverage, 13896,
     /* 374690 */     GIR_EraseRootFromParent_Done,
     /* 374691 */   // Label 7550: @374691
     /* 374691 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(374785), // Rule ID 6246 //
     /* 374696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374719 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374719 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374722 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374726 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374752 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374783 */     GIR_RootConstrainSelectedInstOperands,
     /* 374784 */     // GIR_Coverage, 6246,
     /* 374784 */     GIR_EraseRootFromParent_Done,
     /* 374785 */   // Label 7551: @374785
     /* 374785 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(374812), // Rule ID 1322 //
     /* 374790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374801 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 374806 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374810 */     GIR_RootConstrainSelectedInstOperands,
     /* 374811 */     // GIR_Coverage, 1322,
     /* 374811 */     GIR_Done,
     /* 374812 */   // Label 7552: @374812
     /* 374812 */   GIM_Reject,
     /* 374813 */ // Label 7545: @374813
     /* 374813 */ GIM_Reject,
     /* 374814 */ // Label 7516: @374814
     /* 374814 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(375171),
     /* 374819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 374825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374829 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(374892), // Rule ID 13437 //
     /* 374834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374870 */     // MIs[2] Operand 1
     /* 374870 */     // No operand predicates
     /* 374870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374876 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 374879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374890 */     GIR_RootConstrainSelectedInstOperands,
     /* 374891 */     // GIR_Coverage, 13437,
     /* 374891 */     GIR_EraseRootFromParent_Done,
     /* 374892 */   // Label 7554: @374892
     /* 374892 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(374955), // Rule ID 2009 //
     /* 374897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374937 */     // MIs[2] Operand 1
     /* 374937 */     // No operand predicates
     /* 374937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374939 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 374942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374953 */     GIR_RootConstrainSelectedInstOperands,
     /* 374954 */     // GIR_Coverage, 2009,
     /* 374954 */     GIR_EraseRootFromParent_Done,
     /* 374955 */   // Label 7555: @374955
     /* 374955 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(375049), // Rule ID 13900 //
     /* 374960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 374972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374983 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 375000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375009 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 375037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375047 */     GIR_RootConstrainSelectedInstOperands,
     /* 375048 */     // GIR_Coverage, 13900,
     /* 375048 */     GIR_EraseRootFromParent_Done,
     /* 375049 */   // Label 7556: @375049
     /* 375049 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(375143), // Rule ID 6250 //
     /* 375054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 375070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375077 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 375080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 375094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 375131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375141 */     GIR_RootConstrainSelectedInstOperands,
     /* 375142 */     // GIR_Coverage, 6250,
     /* 375142 */     GIR_EraseRootFromParent_Done,
     /* 375143 */   // Label 7557: @375143
     /* 375143 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(375170), // Rule ID 1326 //
     /* 375148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375159 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 375164 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375168 */     GIR_RootConstrainSelectedInstOperands,
     /* 375169 */     // GIR_Coverage, 1326,
     /* 375169 */     GIR_Done,
     /* 375170 */   // Label 7558: @375170
     /* 375170 */   GIM_Reject,
     /* 375171 */ // Label 7553: @375171
     /* 375171 */ GIM_Reject,
     /* 375172 */ // Label 7517: @375172
     /* 375172 */ GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(375513),
     /* 375177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 375183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375187 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(375273), // Rule ID 13425 //
     /* 375192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 375203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375236 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375240 */     // MIs[3] Operand 1
     /* 375240 */     // No operand predicates
     /* 375240 */     // MIs[1] Operand 2
     /* 375240 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 375251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375257 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 375260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375271 */     GIR_RootConstrainSelectedInstOperands,
     /* 375272 */     // GIR_Coverage, 13425,
     /* 375272 */     GIR_EraseRootFromParent_Done,
     /* 375273 */   // Label 7560: @375273
     /* 375273 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(375359), // Rule ID 1997 //
     /* 375278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 375293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375326 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375330 */     // MIs[3] Operand 1
     /* 375330 */     // No operand predicates
     /* 375330 */     // MIs[1] Operand 2
     /* 375330 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 375341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375343 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 375346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375357 */     GIR_RootConstrainSelectedInstOperands,
     /* 375358 */     // GIR_Coverage, 1997,
     /* 375358 */     GIR_EraseRootFromParent_Done,
     /* 375359 */   // Label 7561: @375359
     /* 375359 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(375422), // Rule ID 13426 //
     /* 375364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375396 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375400 */     // MIs[2] Operand 1
     /* 375400 */     // No operand predicates
     /* 375400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375406 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 375409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375420 */     GIR_RootConstrainSelectedInstOperands,
     /* 375421 */     // GIR_Coverage, 13426,
     /* 375421 */     GIR_EraseRootFromParent_Done,
     /* 375422 */   // Label 7562: @375422
     /* 375422 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(375485), // Rule ID 1998 //
     /* 375427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375467 */     // MIs[2] Operand 1
     /* 375467 */     // No operand predicates
     /* 375467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375469 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 375472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375483 */     GIR_RootConstrainSelectedInstOperands,
     /* 375484 */     // GIR_Coverage, 1998,
     /* 375484 */     GIR_EraseRootFromParent_Done,
     /* 375485 */   // Label 7563: @375485
     /* 375485 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(375512), // Rule ID 1318 //
     /* 375490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375501 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 375501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 375506 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375510 */     GIR_RootConstrainSelectedInstOperands,
     /* 375511 */     // GIR_Coverage, 1318,
     /* 375511 */     GIR_Done,
     /* 375512 */   // Label 7564: @375512
     /* 375512 */   GIM_Reject,
     /* 375513 */ // Label 7559: @375513
     /* 375513 */ GIM_Reject,
     /* 375514 */ // Label 7518: @375514
     /* 375514 */ GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(375871),
     /* 375519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 375525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375529 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(375592), // Rule ID 13435 //
     /* 375534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 375545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375566 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375570 */     // MIs[2] Operand 1
     /* 375570 */     // No operand predicates
     /* 375570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375576 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 375579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375590 */     GIR_RootConstrainSelectedInstOperands,
     /* 375591 */     // GIR_Coverage, 13435,
     /* 375591 */     GIR_EraseRootFromParent_Done,
     /* 375592 */   // Label 7566: @375592
     /* 375592 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(375655), // Rule ID 2007 //
     /* 375597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 375612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375633 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375637 */     // MIs[2] Operand 1
     /* 375637 */     // No operand predicates
     /* 375637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375639 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 375642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375653 */     GIR_RootConstrainSelectedInstOperands,
     /* 375654 */     // GIR_Coverage, 2007,
     /* 375654 */     GIR_EraseRootFromParent_Done,
     /* 375655 */   // Label 7567: @375655
     /* 375655 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(375749), // Rule ID 13898 //
     /* 375660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375683 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 375686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 375700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 375719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 375737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375747 */     GIR_RootConstrainSelectedInstOperands,
     /* 375748 */     // GIR_Coverage, 13898,
     /* 375748 */     GIR_EraseRootFromParent_Done,
     /* 375749 */   // Label 7568: @375749
     /* 375749 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(375843), // Rule ID 6248 //
     /* 375754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375777 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375777 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 375780 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375784 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 375794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375803 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375810 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 375813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 375831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375841 */     GIR_RootConstrainSelectedInstOperands,
     /* 375842 */     // GIR_Coverage, 6248,
     /* 375842 */     GIR_EraseRootFromParent_Done,
     /* 375843 */   // Label 7569: @375843
     /* 375843 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(375870), // Rule ID 1324 //
     /* 375848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375859 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 375859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 375864 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375868 */     GIR_RootConstrainSelectedInstOperands,
     /* 375869 */     // GIR_Coverage, 1324,
     /* 375869 */     GIR_Done,
     /* 375870 */   // Label 7570: @375870
     /* 375870 */   GIM_Reject,
     /* 375871 */ // Label 7565: @375871
     /* 375871 */ GIM_Reject,
     /* 375872 */ // Label 7519: @375872
     /* 375872 */ GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(376303),
     /* 375877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 375883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375887 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(375950), // Rule ID 13429 //
     /* 375892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375924 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375928 */     // MIs[2] Operand 1
     /* 375928 */     // No operand predicates
     /* 375928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375934 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 375937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375948 */     GIR_RootConstrainSelectedInstOperands,
     /* 375949 */     // GIR_Coverage, 13429,
     /* 375949 */     GIR_EraseRootFromParent_Done,
     /* 375950 */   // Label 7572: @375950
     /* 375950 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(376013), // Rule ID 2001 //
     /* 375955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375995 */     // MIs[2] Operand 1
     /* 375995 */     // No operand predicates
     /* 375995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375997 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 376000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376011 */     GIR_RootConstrainSelectedInstOperands,
     /* 376012 */     // GIR_Coverage, 2001,
     /* 376012 */     GIR_EraseRootFromParent_Done,
     /* 376013 */   // Label 7573: @376013
     /* 376013 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(376040), // Rule ID 1320 //
     /* 376018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376029 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 376029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 376034 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376038 */     GIR_RootConstrainSelectedInstOperands,
     /* 376039 */     // GIR_Coverage, 1320,
     /* 376039 */     GIR_Done,
     /* 376040 */   // Label 7574: @376040
     /* 376040 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(376302), // Rule ID 7003 //
     /* 376045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 376048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376056 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 376056 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 376059 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376063 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376068 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 376074 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 376077 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376081 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376086 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 376090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 376092 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 376095 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 376099 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376104 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 376107 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 376110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 376112 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 376115 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376119 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376124 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 376130 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376135 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376140 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 376143 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376147 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376152 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 376155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 376157 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 376160 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376164 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376169 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 376175 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376180 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376185 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 376188 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376192 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376197 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 376200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 376202 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 376205 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 376209 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376214 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 376217 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 376220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376222 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 376225 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 376229 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376234 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 376237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 376242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376265 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 376292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 376300 */     GIR_RootConstrainSelectedInstOperands,
     /* 376301 */     // GIR_Coverage, 7003,
     /* 376301 */     GIR_EraseRootFromParent_Done,
     /* 376302 */   // Label 7575: @376302
     /* 376302 */   GIM_Reject,
     /* 376303 */ // Label 7571: @376303
     /* 376303 */ GIM_Reject,
     /* 376304 */ // Label 7520: @376304
     /* 376304 */ GIM_Reject,
     /* 376305 */ // Label 104: @376305
     /* 376305 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7584*/ GIMT_Encode4(376920),
     /* 376316 */ /*GILLT_s16*//*Label 7576*/ GIMT_Encode4(376356),
     /* 376320 */ /*GILLT_s32*//*Label 7577*/ GIMT_Encode4(376394),
     /* 376324 */ /*GILLT_s64*//*Label 7578*/ GIMT_Encode4(376432), GIMT_Encode4(0),
     /* 376332 */ /*GILLT_v2s32*//*Label 7579*/ GIMT_Encode4(376470),
     /* 376336 */ /*GILLT_v2s64*//*Label 7580*/ GIMT_Encode4(376508),
     /* 376340 */ /*GILLT_v4s16*//*Label 7581*/ GIMT_Encode4(376546),
     /* 376344 */ /*GILLT_v4s32*//*Label 7582*/ GIMT_Encode4(376584), GIMT_Encode4(0),
     /* 376352 */ /*GILLT_v8s16*//*Label 7583*/ GIMT_Encode4(376622),
     /* 376356 */ // Label 7576: @376356
     /* 376356 */ GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(376393), // Rule ID 589 //
     /* 376361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 376367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376382 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 376382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 376387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376391 */   GIR_RootConstrainSelectedInstOperands,
     /* 376392 */   // GIR_Coverage, 589,
     /* 376392 */   GIR_Done,
     /* 376393 */ // Label 7585: @376393
     /* 376393 */ GIM_Reject,
     /* 376394 */ // Label 7577: @376394
     /* 376394 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(376431), // Rule ID 591 //
     /* 376399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 376405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376420 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 376420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 376425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376429 */   GIR_RootConstrainSelectedInstOperands,
     /* 376430 */   // GIR_Coverage, 591,
     /* 376430 */   GIR_Done,
     /* 376431 */ // Label 7586: @376431
     /* 376431 */ GIM_Reject,
     /* 376432 */ // Label 7578: @376432
     /* 376432 */ GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(376469), // Rule ID 593 //
     /* 376437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 376443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 376446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376458 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 376458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 376463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376467 */   GIR_RootConstrainSelectedInstOperands,
     /* 376468 */   // GIR_Coverage, 593,
     /* 376468 */   GIR_Done,
     /* 376469 */ // Label 7587: @376469
     /* 376469 */ GIM_Reject,
     /* 376470 */ // Label 7579: @376470
     /* 376470 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(376507), // Rule ID 1227 //
     /* 376475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 376484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376496 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 376496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 376501 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376505 */   GIR_RootConstrainSelectedInstOperands,
     /* 376506 */   // GIR_Coverage, 1227,
     /* 376506 */   GIR_Done,
     /* 376507 */ // Label 7588: @376507
     /* 376507 */ GIM_Reject,
     /* 376508 */ // Label 7580: @376508
     /* 376508 */ GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(376545), // Rule ID 1231 //
     /* 376513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 376522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376534 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 376534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 376539 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376543 */   GIR_RootConstrainSelectedInstOperands,
     /* 376544 */   // GIR_Coverage, 1231,
     /* 376544 */   GIR_Done,
     /* 376545 */ // Label 7589: @376545
     /* 376545 */ GIM_Reject,
     /* 376546 */ // Label 7581: @376546
     /* 376546 */ GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(376583), // Rule ID 1223 //
     /* 376551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 376560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376572 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 376572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 376577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376581 */   GIR_RootConstrainSelectedInstOperands,
     /* 376582 */   // GIR_Coverage, 1223,
     /* 376582 */   GIR_Done,
     /* 376583 */ // Label 7590: @376583
     /* 376583 */ GIM_Reject,
     /* 376584 */ // Label 7582: @376584
     /* 376584 */ GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(376621), // Rule ID 1229 //
     /* 376589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 376598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376610 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 376610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 376615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376619 */   GIR_RootConstrainSelectedInstOperands,
     /* 376620 */   // GIR_Coverage, 1229,
     /* 376620 */   GIR_Done,
     /* 376621 */ // Label 7591: @376621
     /* 376621 */ GIM_Reject,
     /* 376622 */ // Label 7583: @376622
     /* 376622 */ GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(376919),
     /* 376627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 376633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376645 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(376664), // Rule ID 1225 //
     /* 376650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376653 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 376653 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 376658 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376662 */     GIR_RootConstrainSelectedInstOperands,
     /* 376663 */     // GIR_Coverage, 1225,
     /* 376663 */     GIR_Done,
     /* 376664 */   // Label 7593: @376664
     /* 376664 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(376918), // Rule ID 7001 //
     /* 376669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 376672 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 376672 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 376675 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376679 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376684 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 376690 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 376693 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376697 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376702 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 376706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 376708 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 376711 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 376715 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376720 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 376723 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 376726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 376728 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 376731 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376735 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376740 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 376746 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376751 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376756 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 376759 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376763 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376768 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 376771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 376773 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 376776 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376780 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376785 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 376791 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376796 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376801 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 376804 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376808 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376813 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 376816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 376818 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 376821 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 376825 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376830 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 376833 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 376836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 376841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 376845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376850 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 376853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376855 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 376858 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376862 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 376908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 376916 */     GIR_RootConstrainSelectedInstOperands,
     /* 376917 */     // GIR_Coverage, 7001,
     /* 376917 */     GIR_EraseRootFromParent_Done,
     /* 376918 */   // Label 7594: @376918
     /* 376918 */   GIM_Reject,
     /* 376919 */ // Label 7592: @376919
     /* 376919 */ GIM_Reject,
     /* 376920 */ // Label 7584: @376920
     /* 376920 */ GIM_Reject,
     /* 376921 */ // Label 105: @376921
     /* 376921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7603*/ GIMT_Encode4(392527),
     /* 376932 */ /*GILLT_s16*//*Label 7595*/ GIMT_Encode4(376972),
     /* 376936 */ /*GILLT_s32*//*Label 7596*/ GIMT_Encode4(379746),
     /* 376940 */ /*GILLT_s64*//*Label 7597*/ GIMT_Encode4(382676), GIMT_Encode4(0),
     /* 376948 */ /*GILLT_v2s32*//*Label 7598*/ GIMT_Encode4(385606),
     /* 376952 */ /*GILLT_v2s64*//*Label 7599*/ GIMT_Encode4(387127),
     /* 376956 */ /*GILLT_v4s16*//*Label 7600*/ GIMT_Encode4(388648),
     /* 376960 */ /*GILLT_v4s32*//*Label 7601*/ GIMT_Encode4(389827), GIMT_Encode4(0),
     /* 376968 */ /*GILLT_v8s16*//*Label 7602*/ GIMT_Encode4(391348),
     /* 376972 */ // Label 7595: @376972
     /* 376972 */ GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(379745),
     /* 376977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 376980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376983 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 376986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376990 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(377140), // Rule ID 4864 //
     /* 376995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377019 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377035 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377044 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 377060 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377067 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 377070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377079 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377085 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377107 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 377126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 377138 */     GIR_RootConstrainSelectedInstOperands,
     /* 377139 */     // GIR_Coverage, 4864,
     /* 377139 */     GIR_EraseRootFromParent_Done,
     /* 377140 */   // Label 7605: @377140
     /* 377140 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(377287), // Rule ID 4828 //
     /* 377145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377169 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 377189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377197 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377201 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377206 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377216 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 377219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377228 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377234 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377239 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377256 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377285 */     GIR_RootConstrainSelectedInstOperands,
     /* 377286 */     // GIR_Coverage, 4828,
     /* 377286 */     GIR_EraseRootFromParent_Done,
     /* 377287 */   // Label 7606: @377287
     /* 377287 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(377434), // Rule ID 13837 //
     /* 377292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377328 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377344 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377348 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377353 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377363 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 377366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377375 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377386 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377403 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377432 */     GIR_RootConstrainSelectedInstOperands,
     /* 377433 */     // GIR_Coverage, 13837,
     /* 377433 */     GIR_EraseRootFromParent_Done,
     /* 377434 */   // Label 7607: @377434
     /* 377434 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(377565), // Rule ID 6078 //
     /* 377439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377463 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 377483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377487 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377491 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377495 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377500 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 377504 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377508 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377512 */     // MIs[4] Operand 1
     /* 377512 */     // No operand predicates
     /* 377512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377518 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377530 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 377560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 377563 */     GIR_RootConstrainSelectedInstOperands,
     /* 377564 */     // GIR_Coverage, 6078,
     /* 377564 */     GIR_EraseRootFromParent_Done,
     /* 377565 */   // Label 7608: @377565
     /* 377565 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(377696), // Rule ID 6110 //
     /* 377570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377602 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377606 */     // MIs[2] Operand 1
     /* 377606 */     // No operand predicates
     /* 377606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 377618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 377622 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377626 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377630 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 377634 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377639 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 377643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377647 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377649 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377694 */     GIR_RootConstrainSelectedInstOperands,
     /* 377695 */     // GIR_Coverage, 6110,
     /* 377695 */     GIR_EraseRootFromParent_Done,
     /* 377696 */   // Label 7609: @377696
     /* 377696 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(377827), // Rule ID 6174 //
     /* 377701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377737 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377749 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377753 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377757 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377762 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 377766 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377770 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377774 */     // MIs[4] Operand 1
     /* 377774 */     // No operand predicates
     /* 377774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377780 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377792 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 377822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 377825 */     GIR_RootConstrainSelectedInstOperands,
     /* 377826 */     // GIR_Coverage, 6174,
     /* 377826 */     GIR_EraseRootFromParent_Done,
     /* 377827 */   // Label 7610: @377827
     /* 377827 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(377958), // Rule ID 6142 //
     /* 377832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377876 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377880 */     // MIs[3] Operand 1
     /* 377880 */     // No operand predicates
     /* 377880 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 377884 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377888 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377892 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 377896 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377901 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 377905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377909 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377911 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377923 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377956 */     GIR_RootConstrainSelectedInstOperands,
     /* 377957 */     // GIR_Coverage, 6142,
     /* 377957 */     GIR_EraseRootFromParent_Done,
     /* 377958 */   // Label 7611: @377958
     /* 377958 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(378093), // Rule ID 2455 //
     /* 377963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377987 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378012 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378022 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 378025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378034 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378040 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378045 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 378089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378091 */     GIR_RootConstrainSelectedInstOperands,
     /* 378092 */     // GIR_Coverage, 2455,
     /* 378092 */     GIR_EraseRootFromParent_Done,
     /* 378093 */   // Label 7612: @378093
     /* 378093 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(378212), // Rule ID 6046 //
     /* 378098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378122 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378138 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378155 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378159 */     // MIs[3] Operand 1
     /* 378159 */     // No operand predicates
     /* 378159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378163 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378165 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378177 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 378196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378210 */     GIR_RootConstrainSelectedInstOperands,
     /* 378211 */     // GIR_Coverage, 6046,
     /* 378211 */     GIR_EraseRootFromParent_Done,
     /* 378212 */   // Label 7613: @378212
     /* 378212 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(378331), // Rule ID 2537 //
     /* 378217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378253 */     // MIs[2] Operand 1
     /* 378253 */     // No operand predicates
     /* 378253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378265 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 378269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378274 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 378278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378284 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378296 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 378315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378329 */     GIR_RootConstrainSelectedInstOperands,
     /* 378330 */     // GIR_Coverage, 2537,
     /* 378330 */     GIR_EraseRootFromParent_Done,
     /* 378331 */   // Label 7614: @378331
     /* 378331 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(378431), // Rule ID 4826 //
     /* 378336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378360 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 378376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378387 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378399 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378429 */     GIR_RootConstrainSelectedInstOperands,
     /* 378430 */     // GIR_Coverage, 4826,
     /* 378430 */     GIR_EraseRootFromParent_Done,
     /* 378431 */   // Label 7615: @378431
     /* 378431 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(378531), // Rule ID 4862 //
     /* 378436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 378472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 378480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378487 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378499 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 378518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 378525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 378529 */     GIR_RootConstrainSelectedInstOperands,
     /* 378530 */     // GIR_Coverage, 4862,
     /* 378530 */     GIR_EraseRootFromParent_Done,
     /* 378531 */   // Label 7616: @378531
     /* 378531 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(378628), // Rule ID 13833 //
     /* 378536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378572 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378586 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378598 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378626 */     GIR_RootConstrainSelectedInstOperands,
     /* 378627 */     // GIR_Coverage, 13833,
     /* 378627 */     GIR_EraseRootFromParent_Done,
     /* 378628 */   // Label 7617: @378628
     /* 378628 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(378728), // Rule ID 13835 //
     /* 378633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378674 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378684 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378696 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378726 */     GIR_RootConstrainSelectedInstOperands,
     /* 378727 */     // GIR_Coverage, 13835,
     /* 378727 */     GIR_EraseRootFromParent_Done,
     /* 378728 */   // Label 7618: @378728
     /* 378728 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(378828), // Rule ID 4860 //
     /* 378733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378761 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 378769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 378777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378784 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378796 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 378815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 378826 */     GIR_RootConstrainSelectedInstOperands,
     /* 378827 */     // GIR_Coverage, 4860,
     /* 378827 */     GIR_EraseRootFromParent_Done,
     /* 378828 */   // Label 7619: @378828
     /* 378828 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(378925), // Rule ID 4824 //
     /* 378833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378873 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378883 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378895 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378923 */     GIR_RootConstrainSelectedInstOperands,
     /* 378924 */     // GIR_Coverage, 4824,
     /* 378924 */     GIR_EraseRootFromParent_Done,
     /* 378925 */   // Label 7620: @378925
     /* 378925 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(379009), // Rule ID 6108 //
     /* 378930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378962 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378966 */     // MIs[2] Operand 1
     /* 378966 */     // No operand predicates
     /* 378966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378974 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 378978 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378989 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 379000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379007 */     GIR_RootConstrainSelectedInstOperands,
     /* 379008 */     // GIR_Coverage, 6108,
     /* 379008 */     GIR_EraseRootFromParent_Done,
     /* 379009 */   // Label 7621: @379009
     /* 379009 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(379090), // Rule ID 6140 //
     /* 379014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379058 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379062 */     // MIs[3] Operand 1
     /* 379062 */     // No operand predicates
     /* 379062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379072 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 379075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379088 */     GIR_RootConstrainSelectedInstOperands,
     /* 379089 */     // GIR_Coverage, 6140,
     /* 379089 */     GIR_EraseRootFromParent_Done,
     /* 379090 */   // Label 7622: @379090
     /* 379090 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(379174), // Rule ID 6172 //
     /* 379095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379144 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379148 */     // MIs[3] Operand 1
     /* 379148 */     // No operand predicates
     /* 379148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379154 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 379157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379172 */     GIR_RootConstrainSelectedInstOperands,
     /* 379173 */     // GIR_Coverage, 6172,
     /* 379173 */     GIR_EraseRootFromParent_Done,
     /* 379174 */   // Label 7623: @379174
     /* 379174 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(379255), // Rule ID 6076 //
     /* 379179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379227 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379231 */     // MIs[3] Operand 1
     /* 379231 */     // No operand predicates
     /* 379231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379235 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379237 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 379240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379253 */     GIR_RootConstrainSelectedInstOperands,
     /* 379254 */     // GIR_Coverage, 6076,
     /* 379254 */     GIR_EraseRootFromParent_Done,
     /* 379255 */   // Label 7624: @379255
     /* 379255 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(379340), // Rule ID 2453 //
     /* 379260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379298 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 379301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379310 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 379316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 379329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 379336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379338 */     GIR_RootConstrainSelectedInstOperands,
     /* 379339 */     // GIR_Coverage, 2453,
     /* 379339 */     GIR_EraseRootFromParent_Done,
     /* 379340 */   // Label 7625: @379340
     /* 379340 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(379425), // Rule ID 2451 //
     /* 379345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379373 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379383 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 379383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 379386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379395 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 379401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 379414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379423 */     GIR_RootConstrainSelectedInstOperands,
     /* 379424 */     // GIR_Coverage, 2451,
     /* 379424 */     GIR_EraseRootFromParent_Done,
     /* 379425 */   // Label 7626: @379425
     /* 379425 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(379494), // Rule ID 2535 //
     /* 379430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379462 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379466 */     // MIs[2] Operand 1
     /* 379466 */     // No operand predicates
     /* 379466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379476 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 379479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379492 */     GIR_RootConstrainSelectedInstOperands,
     /* 379493 */     // GIR_Coverage, 2535,
     /* 379493 */     GIR_EraseRootFromParent_Done,
     /* 379494 */   // Label 7627: @379494
     /* 379494 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(379563), // Rule ID 6044 //
     /* 379499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379535 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379539 */     // MIs[2] Operand 1
     /* 379539 */     // No operand predicates
     /* 379539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379545 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 379548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379561 */     GIR_RootConstrainSelectedInstOperands,
     /* 379562 */     // GIR_Coverage, 6044,
     /* 379562 */     GIR_EraseRootFromParent_Done,
     /* 379563 */   // Label 7628: @379563
     /* 379563 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(379613), // Rule ID 13279 //
     /* 379568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379598 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 379601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379611 */     GIR_RootConstrainSelectedInstOperands,
     /* 379612 */     // GIR_Coverage, 13279,
     /* 379612 */     GIR_EraseRootFromParent_Done,
     /* 379613 */   // Label 7629: @379613
     /* 379613 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(379663), // Rule ID 643 //
     /* 379618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379648 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 379651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379661 */     GIR_RootConstrainSelectedInstOperands,
     /* 379662 */     // GIR_Coverage, 643,
     /* 379662 */     GIR_EraseRootFromParent_Done,
     /* 379663 */   // Label 7630: @379663
     /* 379663 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(379713), // Rule ID 655 //
     /* 379668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 379683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379698 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 379701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 379707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 379711 */     GIR_RootConstrainSelectedInstOperands,
     /* 379712 */     // GIR_Coverage, 655,
     /* 379712 */     GIR_EraseRootFromParent_Done,
     /* 379713 */   // Label 7631: @379713
     /* 379713 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(379744), // Rule ID 637 //
     /* 379718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379733 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 379738 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379742 */     GIR_RootConstrainSelectedInstOperands,
     /* 379743 */     // GIR_Coverage, 637,
     /* 379743 */     GIR_Done,
     /* 379744 */   // Label 7632: @379744
     /* 379744 */   GIM_Reject,
     /* 379745 */ // Label 7604: @379745
     /* 379745 */ GIM_Reject,
     /* 379746 */ // Label 7596: @379746
     /* 379746 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(382675),
     /* 379751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 379754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 379757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 379760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379764 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(379914), // Rule ID 4870 //
     /* 379769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379818 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 379826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379830 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 379834 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379841 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379841 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379844 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379848 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379853 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 379859 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379864 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379881 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 379900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 379912 */     GIR_RootConstrainSelectedInstOperands,
     /* 379913 */     // GIR_Coverage, 4870,
     /* 379913 */     GIR_EraseRootFromParent_Done,
     /* 379914 */   // Label 7634: @379914
     /* 379914 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(380061), // Rule ID 4834 //
     /* 379919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 379963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379967 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379971 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379975 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379980 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 379984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379990 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380002 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380008 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380013 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380030 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 380057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380059 */     GIR_RootConstrainSelectedInstOperands,
     /* 380060 */     // GIR_Coverage, 4834,
     /* 380060 */     GIR_EraseRootFromParent_Done,
     /* 380061 */   // Label 7635: @380061
     /* 380061 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(380208), // Rule ID 13843 //
     /* 380066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380118 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 380122 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380127 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 380131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380137 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 380140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380149 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380155 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380160 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380177 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 380204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380206 */     GIR_RootConstrainSelectedInstOperands,
     /* 380207 */     // GIR_Coverage, 13843,
     /* 380207 */     GIR_EraseRootFromParent_Done,
     /* 380208 */   // Label 7636: @380208
     /* 380208 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(380339), // Rule ID 6094 //
     /* 380213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380237 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 380257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380265 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 380269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380274 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 380278 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380282 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380286 */     // MIs[4] Operand 1
     /* 380286 */     // No operand predicates
     /* 380286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380290 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 380292 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 380334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 380337 */     GIR_RootConstrainSelectedInstOperands,
     /* 380338 */     // GIR_Coverage, 6094,
     /* 380338 */     GIR_EraseRootFromParent_Done,
     /* 380339 */   // Label 7637: @380339
     /* 380339 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(380470), // Rule ID 6126 //
     /* 380344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380380 */     // MIs[2] Operand 1
     /* 380380 */     // No operand predicates
     /* 380380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 380392 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 380396 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380400 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380404 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 380408 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380413 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 380417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380421 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 380423 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380435 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380468 */     GIR_RootConstrainSelectedInstOperands,
     /* 380469 */     // GIR_Coverage, 6126,
     /* 380469 */     GIR_EraseRootFromParent_Done,
     /* 380470 */   // Label 7638: @380470
     /* 380470 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(380601), // Rule ID 6190 //
     /* 380475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380511 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 380531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 380540 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380544 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380548 */     // MIs[4] Operand 1
     /* 380548 */     // No operand predicates
     /* 380548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380552 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 380554 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380566 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380572 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 380596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 380599 */     GIR_RootConstrainSelectedInstOperands,
     /* 380600 */     // GIR_Coverage, 6190,
     /* 380600 */     GIR_EraseRootFromParent_Done,
     /* 380601 */   // Label 7639: @380601
     /* 380601 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(380732), // Rule ID 6158 //
     /* 380606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380650 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380654 */     // MIs[3] Operand 1
     /* 380654 */     // No operand predicates
     /* 380654 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 380658 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380662 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380666 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 380670 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380675 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 380679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380683 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 380685 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380697 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380730 */     GIR_RootConstrainSelectedInstOperands,
     /* 380731 */     // GIR_Coverage, 6158,
     /* 380731 */     GIR_EraseRootFromParent_Done,
     /* 380732 */   // Label 7640: @380732
     /* 380732 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(380867), // Rule ID 2461 //
     /* 380737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380761 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380786 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380796 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380796 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 380799 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380803 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380808 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380836 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 380855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 380863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380865 */     GIR_RootConstrainSelectedInstOperands,
     /* 380866 */     // GIR_Coverage, 2461,
     /* 380866 */     GIR_EraseRootFromParent_Done,
     /* 380867 */   // Label 7641: @380867
     /* 380867 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(380986), // Rule ID 6062 //
     /* 380872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380929 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380933 */     // MIs[3] Operand 1
     /* 380933 */     // No operand predicates
     /* 380933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380939 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 380970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380984 */     GIR_RootConstrainSelectedInstOperands,
     /* 380985 */     // GIR_Coverage, 6062,
     /* 380985 */     GIR_EraseRootFromParent_Done,
     /* 380986 */   // Label 7642: @380986
     /* 380986 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(381105), // Rule ID 2553 //
     /* 380991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381023 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381027 */     // MIs[2] Operand 1
     /* 381027 */     // No operand predicates
     /* 381027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381035 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381039 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381043 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381048 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 381052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381058 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 381076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 381089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381103 */     GIR_RootConstrainSelectedInstOperands,
     /* 381104 */     // GIR_Coverage, 2553,
     /* 381104 */     GIR_EraseRootFromParent_Done,
     /* 381105 */   // Label 7643: @381105
     /* 381105 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(381205), // Rule ID 4832 //
     /* 381110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381134 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381161 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381173 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 381179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381203 */     GIR_RootConstrainSelectedInstOperands,
     /* 381204 */     // GIR_Coverage, 4832,
     /* 381204 */     GIR_EraseRootFromParent_Done,
     /* 381205 */   // Label 7644: @381205
     /* 381205 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(381305), // Rule ID 4868 //
     /* 381210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 381246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381261 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381273 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 381279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 381292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 381299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 381303 */     GIR_RootConstrainSelectedInstOperands,
     /* 381304 */     // GIR_Coverage, 4868,
     /* 381304 */     GIR_EraseRootFromParent_Done,
     /* 381305 */   // Label 7645: @381305
     /* 381305 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(381402), // Rule ID 13839 //
     /* 381310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381346 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381360 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 381360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381372 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 381378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381400 */     GIR_RootConstrainSelectedInstOperands,
     /* 381401 */     // GIR_Coverage, 13839,
     /* 381401 */     GIR_EraseRootFromParent_Done,
     /* 381402 */   // Label 7646: @381402
     /* 381402 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(381502), // Rule ID 13841 //
     /* 381407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381448 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381458 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381470 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 381476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381500 */     GIR_RootConstrainSelectedInstOperands,
     /* 381501 */     // GIR_Coverage, 13841,
     /* 381501 */     GIR_EraseRootFromParent_Done,
     /* 381502 */   // Label 7647: @381502
     /* 381502 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(381602), // Rule ID 4866 //
     /* 381507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381535 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 381543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381558 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 381558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381570 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 381576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 381589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 381600 */     GIR_RootConstrainSelectedInstOperands,
     /* 381601 */     // GIR_Coverage, 4866,
     /* 381601 */     GIR_EraseRootFromParent_Done,
     /* 381602 */   // Label 7648: @381602
     /* 381602 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(381699), // Rule ID 4830 //
     /* 381607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381657 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 381657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381669 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 381675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381697 */     GIR_RootConstrainSelectedInstOperands,
     /* 381698 */     // GIR_Coverage, 4830,
     /* 381698 */     GIR_EraseRootFromParent_Done,
     /* 381699 */   // Label 7649: @381699
     /* 381699 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(381777), // Rule ID 6212 //
     /* 381704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 381741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381745 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381749 */     // MIs[3] Operand 1
     /* 381749 */     // No operand predicates
     /* 381749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381757 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381759 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381775 */     GIR_RootConstrainSelectedInstOperands,
     /* 381776 */     // GIR_Coverage, 6212,
     /* 381776 */     GIR_EraseRootFromParent_Done,
     /* 381777 */   // Label 7650: @381777
     /* 381777 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(381861), // Rule ID 6124 //
     /* 381782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381814 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381818 */     // MIs[2] Operand 1
     /* 381818 */     // No operand predicates
     /* 381818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 381830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381841 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 381852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381859 */     GIR_RootConstrainSelectedInstOperands,
     /* 381860 */     // GIR_Coverage, 6124,
     /* 381860 */     GIR_EraseRootFromParent_Done,
     /* 381861 */   // Label 7651: @381861
     /* 381861 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(381942), // Rule ID 6156 //
     /* 381866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381914 */     // MIs[3] Operand 1
     /* 381914 */     // No operand predicates
     /* 381914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381922 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381924 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381940 */     GIR_RootConstrainSelectedInstOperands,
     /* 381941 */     // GIR_Coverage, 6156,
     /* 381941 */     GIR_EraseRootFromParent_Done,
     /* 381942 */   // Label 7652: @381942
     /* 381942 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(382026), // Rule ID 6188 //
     /* 381947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381996 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382000 */     // MIs[3] Operand 1
     /* 382000 */     // No operand predicates
     /* 382000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382006 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 382009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382024 */     GIR_RootConstrainSelectedInstOperands,
     /* 382025 */     // GIR_Coverage, 6188,
     /* 382025 */     GIR_EraseRootFromParent_Done,
     /* 382026 */   // Label 7653: @382026
     /* 382026 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(382104), // Rule ID 6234 //
     /* 382031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 382072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382076 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382080 */     // MIs[3] Operand 1
     /* 382080 */     // No operand predicates
     /* 382080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382086 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 382089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382102 */     GIR_RootConstrainSelectedInstOperands,
     /* 382103 */     // GIR_Coverage, 6234,
     /* 382103 */     GIR_EraseRootFromParent_Done,
     /* 382104 */   // Label 7654: @382104
     /* 382104 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(382185), // Rule ID 6092 //
     /* 382109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382157 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382161 */     // MIs[3] Operand 1
     /* 382161 */     // No operand predicates
     /* 382161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382165 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382167 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 382170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382183 */     GIR_RootConstrainSelectedInstOperands,
     /* 382184 */     // GIR_Coverage, 6092,
     /* 382184 */     GIR_EraseRootFromParent_Done,
     /* 382185 */   // Label 7655: @382185
     /* 382185 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(382270), // Rule ID 2459 //
     /* 382190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382214 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382228 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382240 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 382246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 382259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 382266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382268 */     GIR_RootConstrainSelectedInstOperands,
     /* 382269 */     // GIR_Coverage, 2459,
     /* 382269 */     GIR_EraseRootFromParent_Done,
     /* 382270 */   // Label 7656: @382270
     /* 382270 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(382355), // Rule ID 2457 //
     /* 382275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382303 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382313 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 382313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 382316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382325 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 382331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 382344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382353 */     GIR_RootConstrainSelectedInstOperands,
     /* 382354 */     // GIR_Coverage, 2457,
     /* 382354 */     GIR_EraseRootFromParent_Done,
     /* 382355 */   // Label 7657: @382355
     /* 382355 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(382424), // Rule ID 2551 //
     /* 382360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382396 */     // MIs[2] Operand 1
     /* 382396 */     // No operand predicates
     /* 382396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382406 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 382409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382422 */     GIR_RootConstrainSelectedInstOperands,
     /* 382423 */     // GIR_Coverage, 2551,
     /* 382423 */     GIR_EraseRootFromParent_Done,
     /* 382424 */   // Label 7658: @382424
     /* 382424 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(382493), // Rule ID 6060 //
     /* 382429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382465 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382469 */     // MIs[2] Operand 1
     /* 382469 */     // No operand predicates
     /* 382469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382475 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 382478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382491 */     GIR_RootConstrainSelectedInstOperands,
     /* 382492 */     // GIR_Coverage, 6060,
     /* 382492 */     GIR_EraseRootFromParent_Done,
     /* 382493 */   // Label 7659: @382493
     /* 382493 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(382543), // Rule ID 13281 //
     /* 382498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382528 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 382531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382541 */     GIR_RootConstrainSelectedInstOperands,
     /* 382542 */     // GIR_Coverage, 13281,
     /* 382542 */     GIR_EraseRootFromParent_Done,
     /* 382543 */   // Label 7660: @382543
     /* 382543 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(382593), // Rule ID 645 //
     /* 382548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382578 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 382581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382591 */     GIR_RootConstrainSelectedInstOperands,
     /* 382592 */     // GIR_Coverage, 645,
     /* 382592 */     GIR_EraseRootFromParent_Done,
     /* 382593 */   // Label 7661: @382593
     /* 382593 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(382643), // Rule ID 657 //
     /* 382598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 382613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382628 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 382631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 382637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 382641 */     GIR_RootConstrainSelectedInstOperands,
     /* 382642 */     // GIR_Coverage, 657,
     /* 382642 */     GIR_EraseRootFromParent_Done,
     /* 382643 */   // Label 7662: @382643
     /* 382643 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(382674), // Rule ID 639 //
     /* 382648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382663 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 382668 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382672 */     GIR_RootConstrainSelectedInstOperands,
     /* 382673 */     // GIR_Coverage, 639,
     /* 382673 */     GIR_Done,
     /* 382674 */   // Label 7663: @382674
     /* 382674 */   GIM_Reject,
     /* 382675 */ // Label 7633: @382675
     /* 382675 */ GIM_Reject,
     /* 382676 */ // Label 7597: @382676
     /* 382676 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(385605),
     /* 382681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 382684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 382687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382694 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(382844), // Rule ID 4876 //
     /* 382699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382723 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382748 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 382756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 382764 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382771 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382771 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 382774 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382778 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382783 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 382789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382811 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 382830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 382842 */     GIR_RootConstrainSelectedInstOperands,
     /* 382843 */     // GIR_Coverage, 4876,
     /* 382843 */     GIR_EraseRootFromParent_Done,
     /* 382844 */   // Label 7665: @382844
     /* 382844 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(382991), // Rule ID 4840 //
     /* 382849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382873 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 382893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382901 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382910 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382920 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 382923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382932 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 382938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382960 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 382979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382989 */     GIR_RootConstrainSelectedInstOperands,
     /* 382990 */     // GIR_Coverage, 4840,
     /* 382990 */     GIR_EraseRootFromParent_Done,
     /* 382991 */   // Label 7666: @382991
     /* 382991 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(383138), // Rule ID 13849 //
     /* 382996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383032 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383044 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383048 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383052 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383057 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383067 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 383070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383079 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383085 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383107 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 383134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383136 */     GIR_RootConstrainSelectedInstOperands,
     /* 383137 */     // GIR_Coverage, 13849,
     /* 383137 */     GIR_EraseRootFromParent_Done,
     /* 383138 */   // Label 7667: @383138
     /* 383138 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(383269), // Rule ID 6098 //
     /* 383143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383167 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 383183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 383187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383191 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383195 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383199 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383204 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 383208 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383212 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383216 */     // MIs[4] Operand 1
     /* 383216 */     // No operand predicates
     /* 383216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383220 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 383222 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 383264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 383267 */     GIR_RootConstrainSelectedInstOperands,
     /* 383268 */     // GIR_Coverage, 6098,
     /* 383268 */     GIR_EraseRootFromParent_Done,
     /* 383269 */   // Label 7668: @383269
     /* 383269 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(383400), // Rule ID 6130 //
     /* 383274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383310 */     // MIs[2] Operand 1
     /* 383310 */     // No operand predicates
     /* 383310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383318 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 383322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 383326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383330 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383334 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 383338 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383343 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 383347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383351 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 383353 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383365 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383398 */     GIR_RootConstrainSelectedInstOperands,
     /* 383399 */     // GIR_Coverage, 6130,
     /* 383399 */     GIR_EraseRootFromParent_Done,
     /* 383400 */   // Label 7669: @383400
     /* 383400 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(383531), // Rule ID 6194 //
     /* 383405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383441 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383457 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 383470 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383474 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383478 */     // MIs[4] Operand 1
     /* 383478 */     // No operand predicates
     /* 383478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383482 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 383484 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383496 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 383526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 383529 */     GIR_RootConstrainSelectedInstOperands,
     /* 383530 */     // GIR_Coverage, 6194,
     /* 383530 */     GIR_EraseRootFromParent_Done,
     /* 383531 */   // Label 7670: @383531
     /* 383531 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(383662), // Rule ID 6162 //
     /* 383536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383580 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383584 */     // MIs[3] Operand 1
     /* 383584 */     // No operand predicates
     /* 383584 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 383588 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383592 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383596 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 383600 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383605 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 383609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383613 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 383615 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383627 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383660 */     GIR_RootConstrainSelectedInstOperands,
     /* 383661 */     // GIR_Coverage, 6162,
     /* 383661 */     GIR_EraseRootFromParent_Done,
     /* 383662 */   // Label 7671: @383662
     /* 383662 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(383797), // Rule ID 2467 //
     /* 383667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383691 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383716 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383726 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 383729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383738 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383766 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 383785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 383793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383795 */     GIR_RootConstrainSelectedInstOperands,
     /* 383796 */     // GIR_Coverage, 2467,
     /* 383796 */     GIR_EraseRootFromParent_Done,
     /* 383797 */   // Label 7672: @383797
     /* 383797 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(383916), // Rule ID 6066 //
     /* 383802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383826 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383863 */     // MIs[3] Operand 1
     /* 383863 */     // No operand predicates
     /* 383863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383869 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383881 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 383900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383914 */     GIR_RootConstrainSelectedInstOperands,
     /* 383915 */     // GIR_Coverage, 6066,
     /* 383915 */     GIR_EraseRootFromParent_Done,
     /* 383916 */   // Label 7673: @383916
     /* 383916 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(384035), // Rule ID 2557 //
     /* 383921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383953 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383957 */     // MIs[2] Operand 1
     /* 383957 */     // No operand predicates
     /* 383957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383965 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383969 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383973 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383978 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383988 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384000 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 384006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 384019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384033 */     GIR_RootConstrainSelectedInstOperands,
     /* 384034 */     // GIR_Coverage, 2557,
     /* 384034 */     GIR_EraseRootFromParent_Done,
     /* 384035 */   // Label 7674: @384035
     /* 384035 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(384135), // Rule ID 4838 //
     /* 384040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384064 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 384080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384091 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384103 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 384109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384133 */     GIR_RootConstrainSelectedInstOperands,
     /* 384134 */     // GIR_Coverage, 4838,
     /* 384134 */     GIR_EraseRootFromParent_Done,
     /* 384135 */   // Label 7675: @384135
     /* 384135 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(384235), // Rule ID 4874 //
     /* 384140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384164 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 384176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 384184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384191 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384203 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 384209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 384222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 384229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 384233 */     GIR_RootConstrainSelectedInstOperands,
     /* 384234 */     // GIR_Coverage, 4874,
     /* 384234 */     GIR_EraseRootFromParent_Done,
     /* 384235 */   // Label 7676: @384235
     /* 384235 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(384332), // Rule ID 13845 //
     /* 384240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384276 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 384280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384290 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 384290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384302 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 384308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384330 */     GIR_RootConstrainSelectedInstOperands,
     /* 384331 */     // GIR_Coverage, 13845,
     /* 384331 */     GIR_EraseRootFromParent_Done,
     /* 384332 */   // Label 7677: @384332
     /* 384332 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(384432), // Rule ID 13847 //
     /* 384337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384378 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 384382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384388 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384400 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 384406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384430 */     GIR_RootConstrainSelectedInstOperands,
     /* 384431 */     // GIR_Coverage, 13847,
     /* 384431 */     GIR_EraseRootFromParent_Done,
     /* 384432 */   // Label 7678: @384432
     /* 384432 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(384532), // Rule ID 4872 //
     /* 384437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384465 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 384473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 384481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384488 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 384488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 384506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 384519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 384530 */     GIR_RootConstrainSelectedInstOperands,
     /* 384531 */     // GIR_Coverage, 4872,
     /* 384531 */     GIR_EraseRootFromParent_Done,
     /* 384532 */   // Label 7679: @384532
     /* 384532 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(384629), // Rule ID 4836 //
     /* 384537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384577 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 384581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384587 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 384587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384599 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 384605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384627 */     GIR_RootConstrainSelectedInstOperands,
     /* 384628 */     // GIR_Coverage, 4836,
     /* 384628 */     GIR_EraseRootFromParent_Done,
     /* 384629 */   // Label 7680: @384629
     /* 384629 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(384707), // Rule ID 6216 //
     /* 384634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384675 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384679 */     // MIs[3] Operand 1
     /* 384679 */     // No operand predicates
     /* 384679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384689 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384705 */     GIR_RootConstrainSelectedInstOperands,
     /* 384706 */     // GIR_Coverage, 6216,
     /* 384706 */     GIR_EraseRootFromParent_Done,
     /* 384707 */   // Label 7681: @384707
     /* 384707 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(384791), // Rule ID 6128 //
     /* 384712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384748 */     // MIs[2] Operand 1
     /* 384748 */     // No operand predicates
     /* 384748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 384760 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384771 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 384782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384789 */     GIR_RootConstrainSelectedInstOperands,
     /* 384790 */     // GIR_Coverage, 6128,
     /* 384790 */     GIR_EraseRootFromParent_Done,
     /* 384791 */   // Label 7682: @384791
     /* 384791 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(384872), // Rule ID 6160 //
     /* 384796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384840 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384844 */     // MIs[3] Operand 1
     /* 384844 */     // No operand predicates
     /* 384844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384854 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384870 */     GIR_RootConstrainSelectedInstOperands,
     /* 384871 */     // GIR_Coverage, 6160,
     /* 384871 */     GIR_EraseRootFromParent_Done,
     /* 384872 */   // Label 7683: @384872
     /* 384872 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(384956), // Rule ID 6192 //
     /* 384877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384926 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384930 */     // MIs[3] Operand 1
     /* 384930 */     // No operand predicates
     /* 384930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384936 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384954 */     GIR_RootConstrainSelectedInstOperands,
     /* 384955 */     // GIR_Coverage, 6192,
     /* 384955 */     GIR_EraseRootFromParent_Done,
     /* 384956 */   // Label 7684: @384956
     /* 384956 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(385034), // Rule ID 6238 //
     /* 384961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385006 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385010 */     // MIs[3] Operand 1
     /* 385010 */     // No operand predicates
     /* 385010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385016 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 385019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385032 */     GIR_RootConstrainSelectedInstOperands,
     /* 385033 */     // GIR_Coverage, 6238,
     /* 385033 */     GIR_EraseRootFromParent_Done,
     /* 385034 */   // Label 7685: @385034
     /* 385034 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(385115), // Rule ID 6096 //
     /* 385039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385087 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385091 */     // MIs[3] Operand 1
     /* 385091 */     // No operand predicates
     /* 385091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385097 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 385097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 385100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385113 */     GIR_RootConstrainSelectedInstOperands,
     /* 385114 */     // GIR_Coverage, 6096,
     /* 385114 */     GIR_EraseRootFromParent_Done,
     /* 385115 */   // Label 7686: @385115
     /* 385115 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(385200), // Rule ID 2465 //
     /* 385120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385144 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385158 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385170 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 385176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 385189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 385196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385198 */     GIR_RootConstrainSelectedInstOperands,
     /* 385199 */     // GIR_Coverage, 2465,
     /* 385199 */     GIR_EraseRootFromParent_Done,
     /* 385200 */   // Label 7687: @385200
     /* 385200 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(385285), // Rule ID 2463 //
     /* 385205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 385237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385243 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 385243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 385246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385255 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 385261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 385274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385283 */     GIR_RootConstrainSelectedInstOperands,
     /* 385284 */     // GIR_Coverage, 2463,
     /* 385284 */     GIR_EraseRootFromParent_Done,
     /* 385285 */   // Label 7688: @385285
     /* 385285 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(385354), // Rule ID 2555 //
     /* 385290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385322 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385326 */     // MIs[2] Operand 1
     /* 385326 */     // No operand predicates
     /* 385326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385336 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 385336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 385339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385352 */     GIR_RootConstrainSelectedInstOperands,
     /* 385353 */     // GIR_Coverage, 2555,
     /* 385353 */     GIR_EraseRootFromParent_Done,
     /* 385354 */   // Label 7689: @385354
     /* 385354 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(385423), // Rule ID 6064 //
     /* 385359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 385378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385395 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 385399 */     // MIs[2] Operand 1
     /* 385399 */     // No operand predicates
     /* 385399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385405 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 385405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 385408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385421 */     GIR_RootConstrainSelectedInstOperands,
     /* 385422 */     // GIR_Coverage, 6064,
     /* 385422 */     GIR_EraseRootFromParent_Done,
     /* 385423 */   // Label 7690: @385423
     /* 385423 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(385473), // Rule ID 13283 //
     /* 385428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385458 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 385461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385471 */     GIR_RootConstrainSelectedInstOperands,
     /* 385472 */     // GIR_Coverage, 13283,
     /* 385472 */     GIR_EraseRootFromParent_Done,
     /* 385473 */   // Label 7691: @385473
     /* 385473 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(385523), // Rule ID 647 //
     /* 385478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385508 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 385511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385521 */     GIR_RootConstrainSelectedInstOperands,
     /* 385522 */     // GIR_Coverage, 647,
     /* 385522 */     GIR_EraseRootFromParent_Done,
     /* 385523 */   // Label 7692: @385523
     /* 385523 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(385573), // Rule ID 659 //
     /* 385528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 385543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385558 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 385561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 385567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 385571 */     GIR_RootConstrainSelectedInstOperands,
     /* 385572 */     // GIR_Coverage, 659,
     /* 385572 */     GIR_EraseRootFromParent_Done,
     /* 385573 */   // Label 7693: @385573
     /* 385573 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(385604), // Rule ID 641 //
     /* 385578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385593 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 385598 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 385602 */     GIR_RootConstrainSelectedInstOperands,
     /* 385603 */     // GIR_Coverage, 641,
     /* 385603 */     GIR_Done,
     /* 385604 */   // Label 7694: @385604
     /* 385604 */   GIM_Reject,
     /* 385605 */ // Label 7664: @385605
     /* 385605 */ GIM_Reject,
     /* 385606 */ // Label 7598: @385606
     /* 385606 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(387126),
     /* 385611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 385617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 385620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385624 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(385702), // Rule ID 6196 //
     /* 385629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385670 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385674 */     // MIs[3] Operand 1
     /* 385674 */     // No operand predicates
     /* 385674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385684 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385700 */     GIR_RootConstrainSelectedInstOperands,
     /* 385701 */     // GIR_Coverage, 6196,
     /* 385701 */     GIR_EraseRootFromParent_Done,
     /* 385702 */   // Label 7696: @385702
     /* 385702 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(385786), // Rule ID 6112 //
     /* 385707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385739 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385743 */     // MIs[2] Operand 1
     /* 385743 */     // No operand predicates
     /* 385743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385751 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385755 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385766 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 385777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385784 */     GIR_RootConstrainSelectedInstOperands,
     /* 385785 */     // GIR_Coverage, 6112,
     /* 385785 */     GIR_EraseRootFromParent_Done,
     /* 385786 */   // Label 7697: @385786
     /* 385786 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(385867), // Rule ID 6144 //
     /* 385791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385835 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385839 */     // MIs[3] Operand 1
     /* 385839 */     // No operand predicates
     /* 385839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385849 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385865 */     GIR_RootConstrainSelectedInstOperands,
     /* 385866 */     // GIR_Coverage, 6144,
     /* 385866 */     GIR_EraseRootFromParent_Done,
     /* 385867 */   // Label 7698: @385867
     /* 385867 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(385951), // Rule ID 6176 //
     /* 385872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385921 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385925 */     // MIs[3] Operand 1
     /* 385925 */     // No operand predicates
     /* 385925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385931 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385949 */     GIR_RootConstrainSelectedInstOperands,
     /* 385950 */     // GIR_Coverage, 6176,
     /* 385950 */     GIR_EraseRootFromParent_Done,
     /* 385951 */   // Label 7699: @385951
     /* 385951 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(386029), // Rule ID 6218 //
     /* 385956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386001 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386005 */     // MIs[3] Operand 1
     /* 386005 */     // No operand predicates
     /* 386005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386011 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386027 */     GIR_RootConstrainSelectedInstOperands,
     /* 386028 */     // GIR_Coverage, 6218,
     /* 386028 */     GIR_EraseRootFromParent_Done,
     /* 386029 */   // Label 7700: @386029
     /* 386029 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(386110), // Rule ID 6080 //
     /* 386034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 386061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386082 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386086 */     // MIs[3] Operand 1
     /* 386086 */     // No operand predicates
     /* 386086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386092 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386108 */     GIR_RootConstrainSelectedInstOperands,
     /* 386109 */     // GIR_Coverage, 6080,
     /* 386109 */     GIR_EraseRootFromParent_Done,
     /* 386110 */   // Label 7701: @386110
     /* 386110 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(386179), // Rule ID 2539 //
     /* 386115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 386126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386147 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386151 */     // MIs[2] Operand 1
     /* 386151 */     // No operand predicates
     /* 386151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386161 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 386164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386177 */     GIR_RootConstrainSelectedInstOperands,
     /* 386178 */     // GIR_Coverage, 2539,
     /* 386178 */     GIR_EraseRootFromParent_Done,
     /* 386179 */   // Label 7702: @386179
     /* 386179 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(386248), // Rule ID 6048 //
     /* 386184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 386199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 386224 */     // MIs[2] Operand 1
     /* 386224 */     // No operand predicates
     /* 386224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386230 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 386233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386246 */     GIR_RootConstrainSelectedInstOperands,
     /* 386247 */     // GIR_Coverage, 6048,
     /* 386247 */     GIR_EraseRootFromParent_Done,
     /* 386248 */   // Label 7703: @386248
     /* 386248 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(386341), // Rule ID 6200 //
     /* 386253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386292 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386304 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386311 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386339 */     GIR_RootConstrainSelectedInstOperands,
     /* 386340 */     // GIR_Coverage, 6200,
     /* 386340 */     GIR_EraseRootFromParent_Done,
     /* 386341 */   // Label 7704: @386341
     /* 386341 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(386440), // Rule ID 6114 //
     /* 386346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386389 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386401 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386408 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 386432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386438 */     GIR_RootConstrainSelectedInstOperands,
     /* 386439 */     // GIR_Coverage, 6114,
     /* 386439 */     GIR_EraseRootFromParent_Done,
     /* 386440 */   // Label 7705: @386440
     /* 386440 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(386536), // Rule ID 6146 //
     /* 386445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386487 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386506 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386534 */     GIR_RootConstrainSelectedInstOperands,
     /* 386535 */     // GIR_Coverage, 6146,
     /* 386535 */     GIR_EraseRootFromParent_Done,
     /* 386536 */   // Label 7706: @386536
     /* 386536 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(386635), // Rule ID 6178 //
     /* 386541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386584 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386599 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386603 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386633 */     GIR_RootConstrainSelectedInstOperands,
     /* 386634 */     // GIR_Coverage, 6178,
     /* 386634 */     GIR_EraseRootFromParent_Done,
     /* 386635 */   // Label 7707: @386635
     /* 386635 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(386728), // Rule ID 6222 //
     /* 386640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386679 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386691 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386698 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386726 */     GIR_RootConstrainSelectedInstOperands,
     /* 386727 */     // GIR_Coverage, 6222,
     /* 386727 */     GIR_EraseRootFromParent_Done,
     /* 386728 */   // Label 7708: @386728
     /* 386728 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(386824), // Rule ID 6082 //
     /* 386733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386775 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386787 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386822 */     GIR_RootConstrainSelectedInstOperands,
     /* 386823 */     // GIR_Coverage, 6082,
     /* 386823 */     GIR_EraseRootFromParent_Done,
     /* 386824 */   // Label 7709: @386824
     /* 386824 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(386908), // Rule ID 2541 //
     /* 386829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386859 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386878 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 386894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386906 */     GIR_RootConstrainSelectedInstOperands,
     /* 386907 */     // GIR_Coverage, 2541,
     /* 386907 */     GIR_EraseRootFromParent_Done,
     /* 386908 */   // Label 7710: @386908
     /* 386908 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(386958), // Rule ID 13313 //
     /* 386913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386943 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 386943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 386946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386956 */     GIR_RootConstrainSelectedInstOperands,
     /* 386957 */     // GIR_Coverage, 13313,
     /* 386957 */     GIR_EraseRootFromParent_Done,
     /* 386958 */   // Label 7711: @386958
     /* 386958 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(387042), // Rule ID 6050 //
     /* 386963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386993 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387008 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387012 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 387015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 387028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387040 */     GIR_RootConstrainSelectedInstOperands,
     /* 387041 */     // GIR_Coverage, 6050,
     /* 387041 */     GIR_EraseRootFromParent_Done,
     /* 387042 */   // Label 7712: @387042
     /* 387042 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(387092), // Rule ID 1307 //
     /* 387047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387077 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 387077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 387080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387090 */     GIR_RootConstrainSelectedInstOperands,
     /* 387091 */     // GIR_Coverage, 1307,
     /* 387091 */     GIR_EraseRootFromParent_Done,
     /* 387092 */   // Label 7713: @387092
     /* 387092 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(387125), // Rule ID 1297 //
     /* 387097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387112 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 387112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 387115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 387123 */     GIR_RootConstrainSelectedInstOperands,
     /* 387124 */     // GIR_Coverage, 1297,
     /* 387124 */     GIR_EraseRootFromParent_Done,
     /* 387125 */   // Label 7714: @387125
     /* 387125 */   GIM_Reject,
     /* 387126 */ // Label 7695: @387126
     /* 387126 */ GIM_Reject,
     /* 387127 */ // Label 7599: @387127
     /* 387127 */ GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(388647),
     /* 387132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 387138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 387141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387145 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(387223), // Rule ID 6208 //
     /* 387150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 387187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387191 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387195 */     // MIs[3] Operand 1
     /* 387195 */     // No operand predicates
     /* 387195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387203 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387205 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387221 */     GIR_RootConstrainSelectedInstOperands,
     /* 387222 */     // GIR_Coverage, 6208,
     /* 387222 */     GIR_EraseRootFromParent_Done,
     /* 387223 */   // Label 7716: @387223
     /* 387223 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(387307), // Rule ID 6120 //
     /* 387228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387260 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387264 */     // MIs[2] Operand 1
     /* 387264 */     // No operand predicates
     /* 387264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387276 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387287 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 387298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387305 */     GIR_RootConstrainSelectedInstOperands,
     /* 387306 */     // GIR_Coverage, 6120,
     /* 387306 */     GIR_EraseRootFromParent_Done,
     /* 387307 */   // Label 7717: @387307
     /* 387307 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(387388), // Rule ID 6152 //
     /* 387312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387360 */     // MIs[3] Operand 1
     /* 387360 */     // No operand predicates
     /* 387360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387370 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387386 */     GIR_RootConstrainSelectedInstOperands,
     /* 387387 */     // GIR_Coverage, 6152,
     /* 387387 */     GIR_EraseRootFromParent_Done,
     /* 387388 */   // Label 7718: @387388
     /* 387388 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(387472), // Rule ID 6184 //
     /* 387393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387442 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387446 */     // MIs[3] Operand 1
     /* 387446 */     // No operand predicates
     /* 387446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387452 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387470 */     GIR_RootConstrainSelectedInstOperands,
     /* 387471 */     // GIR_Coverage, 6184,
     /* 387471 */     GIR_EraseRootFromParent_Done,
     /* 387472 */   // Label 7719: @387472
     /* 387472 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(387550), // Rule ID 6230 //
     /* 387477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 387518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387526 */     // MIs[3] Operand 1
     /* 387526 */     // No operand predicates
     /* 387526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387532 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387548 */     GIR_RootConstrainSelectedInstOperands,
     /* 387549 */     // GIR_Coverage, 6230,
     /* 387549 */     GIR_EraseRootFromParent_Done,
     /* 387550 */   // Label 7720: @387550
     /* 387550 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(387631), // Rule ID 6088 //
     /* 387555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387586 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387603 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387607 */     // MIs[3] Operand 1
     /* 387607 */     // No operand predicates
     /* 387607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387613 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387629 */     GIR_RootConstrainSelectedInstOperands,
     /* 387630 */     // GIR_Coverage, 6088,
     /* 387630 */     GIR_EraseRootFromParent_Done,
     /* 387631 */   // Label 7721: @387631
     /* 387631 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(387700), // Rule ID 2547 //
     /* 387636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387672 */     // MIs[2] Operand 1
     /* 387672 */     // No operand predicates
     /* 387672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387682 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387698 */     GIR_RootConstrainSelectedInstOperands,
     /* 387699 */     // GIR_Coverage, 2547,
     /* 387699 */     GIR_EraseRootFromParent_Done,
     /* 387700 */   // Label 7722: @387700
     /* 387700 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(387769), // Rule ID 6056 //
     /* 387705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387741 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387745 */     // MIs[2] Operand 1
     /* 387745 */     // No operand predicates
     /* 387745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387751 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387767 */     GIR_RootConstrainSelectedInstOperands,
     /* 387768 */     // GIR_Coverage, 6056,
     /* 387768 */     GIR_EraseRootFromParent_Done,
     /* 387769 */   // Label 7723: @387769
     /* 387769 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(387862), // Rule ID 6210 //
     /* 387774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387813 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387825 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387860 */     GIR_RootConstrainSelectedInstOperands,
     /* 387861 */     // GIR_Coverage, 6210,
     /* 387861 */     GIR_EraseRootFromParent_Done,
     /* 387862 */   // Label 7724: @387862
     /* 387862 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(387961), // Rule ID 6122 //
     /* 387867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387910 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387922 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387929 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 387953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387959 */     GIR_RootConstrainSelectedInstOperands,
     /* 387960 */     // GIR_Coverage, 6122,
     /* 387960 */     GIR_EraseRootFromParent_Done,
     /* 387961 */   // Label 7725: @387961
     /* 387961 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(388057), // Rule ID 6154 //
     /* 387966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 387989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388008 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388023 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388027 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 388030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 388043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388055 */     GIR_RootConstrainSelectedInstOperands,
     /* 388056 */     // GIR_Coverage, 6154,
     /* 388056 */     GIR_EraseRootFromParent_Done,
     /* 388057 */   // Label 7726: @388057
     /* 388057 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(388156), // Rule ID 6186 //
     /* 388062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 388094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388105 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 388127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 388140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388154 */     GIR_RootConstrainSelectedInstOperands,
     /* 388155 */     // GIR_Coverage, 6186,
     /* 388155 */     GIR_EraseRootFromParent_Done,
     /* 388156 */   // Label 7727: @388156
     /* 388156 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(388249), // Rule ID 6232 //
     /* 388161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 388189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388200 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 388222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 388235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388247 */     GIR_RootConstrainSelectedInstOperands,
     /* 388248 */     // GIR_Coverage, 6232,
     /* 388248 */     GIR_EraseRootFromParent_Done,
     /* 388249 */   // Label 7728: @388249
     /* 388249 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(388345), // Rule ID 6090 //
     /* 388254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 388285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388296 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388308 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 388318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 388331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388343 */     GIR_RootConstrainSelectedInstOperands,
     /* 388344 */     // GIR_Coverage, 6090,
     /* 388344 */     GIR_EraseRootFromParent_Done,
     /* 388345 */   // Label 7729: @388345
     /* 388345 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(388429), // Rule ID 2549 //
     /* 388350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388380 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388392 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388395 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388399 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 388402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 388415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388427 */     GIR_RootConstrainSelectedInstOperands,
     /* 388428 */     // GIR_Coverage, 2549,
     /* 388428 */     GIR_EraseRootFromParent_Done,
     /* 388429 */   // Label 7730: @388429
     /* 388429 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(388479), // Rule ID 13317 //
     /* 388434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388464 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 388467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388477 */     GIR_RootConstrainSelectedInstOperands,
     /* 388478 */     // GIR_Coverage, 13317,
     /* 388478 */     GIR_EraseRootFromParent_Done,
     /* 388479 */   // Label 7731: @388479
     /* 388479 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(388563), // Rule ID 6058 //
     /* 388484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388514 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 388536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 388549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388561 */     GIR_RootConstrainSelectedInstOperands,
     /* 388562 */     // GIR_Coverage, 6058,
     /* 388562 */     GIR_EraseRootFromParent_Done,
     /* 388563 */   // Label 7732: @388563
     /* 388563 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(388613), // Rule ID 1311 //
     /* 388568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388598 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 388601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388611 */     GIR_RootConstrainSelectedInstOperands,
     /* 388612 */     // GIR_Coverage, 1311,
     /* 388612 */     GIR_EraseRootFromParent_Done,
     /* 388613 */   // Label 7733: @388613
     /* 388613 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(388646), // Rule ID 1301 //
     /* 388618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388633 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 388636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 388644 */     GIR_RootConstrainSelectedInstOperands,
     /* 388645 */     // GIR_Coverage, 1301,
     /* 388645 */     GIR_EraseRootFromParent_Done,
     /* 388646 */   // Label 7734: @388646
     /* 388646 */   GIM_Reject,
     /* 388647 */ // Label 7715: @388647
     /* 388647 */ GIM_Reject,
     /* 388648 */ // Label 7600: @388648
     /* 388648 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(389826),
     /* 388653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 388659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 388662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388666 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(388750), // Rule ID 6104 //
     /* 388671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388703 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388707 */     // MIs[2] Operand 1
     /* 388707 */     // No operand predicates
     /* 388707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 388711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388715 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388719 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388728 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388730 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 388741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388748 */     GIR_RootConstrainSelectedInstOperands,
     /* 388749 */     // GIR_Coverage, 6104,
     /* 388749 */     GIR_EraseRootFromParent_Done,
     /* 388750 */   // Label 7736: @388750
     /* 388750 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(388831), // Rule ID 6136 //
     /* 388755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388799 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388803 */     // MIs[3] Operand 1
     /* 388803 */     // No operand predicates
     /* 388803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388813 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388829 */     GIR_RootConstrainSelectedInstOperands,
     /* 388830 */     // GIR_Coverage, 6136,
     /* 388830 */     GIR_EraseRootFromParent_Done,
     /* 388831 */   // Label 7737: @388831
     /* 388831 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(388915), // Rule ID 6168 //
     /* 388836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388885 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388889 */     // MIs[3] Operand 1
     /* 388889 */     // No operand predicates
     /* 388889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388895 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388913 */     GIR_RootConstrainSelectedInstOperands,
     /* 388914 */     // GIR_Coverage, 6168,
     /* 388914 */     GIR_EraseRootFromParent_Done,
     /* 388915 */   // Label 7738: @388915
     /* 388915 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(388996), // Rule ID 6072 //
     /* 388920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388968 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388972 */     // MIs[3] Operand 1
     /* 388972 */     // No operand predicates
     /* 388972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388976 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388978 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388994 */     GIR_RootConstrainSelectedInstOperands,
     /* 388995 */     // GIR_Coverage, 6072,
     /* 388995 */     GIR_EraseRootFromParent_Done,
     /* 388996 */   // Label 7739: @388996
     /* 388996 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(389065), // Rule ID 2531 //
     /* 389001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 389012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 389025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389033 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 389037 */     // MIs[2] Operand 1
     /* 389037 */     // No operand predicates
     /* 389037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389047 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 389047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 389050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389063 */     GIR_RootConstrainSelectedInstOperands,
     /* 389064 */     // GIR_Coverage, 2531,
     /* 389064 */     GIR_EraseRootFromParent_Done,
     /* 389065 */   // Label 7740: @389065
     /* 389065 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(389134), // Rule ID 6040 //
     /* 389070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 389085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 389098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 389110 */     // MIs[2] Operand 1
     /* 389110 */     // No operand predicates
     /* 389110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389116 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 389116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 389119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389132 */     GIR_RootConstrainSelectedInstOperands,
     /* 389133 */     // GIR_Coverage, 6040,
     /* 389133 */     GIR_EraseRootFromParent_Done,
     /* 389134 */   // Label 7741: @389134
     /* 389134 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(389233), // Rule ID 6106 //
     /* 389139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389182 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389194 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389197 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389201 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 389217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 389225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389231 */     GIR_RootConstrainSelectedInstOperands,
     /* 389232 */     // GIR_Coverage, 6106,
     /* 389232 */     GIR_EraseRootFromParent_Done,
     /* 389233 */   // Label 7742: @389233
     /* 389233 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(389329), // Rule ID 6138 //
     /* 389238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389280 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389292 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389295 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389299 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 389315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389327 */     GIR_RootConstrainSelectedInstOperands,
     /* 389328 */     // GIR_Coverage, 6138,
     /* 389328 */     GIR_EraseRootFromParent_Done,
     /* 389329 */   // Label 7743: @389329
     /* 389329 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(389428), // Rule ID 6170 //
     /* 389334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389377 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389389 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389396 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 389412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389426 */     GIR_RootConstrainSelectedInstOperands,
     /* 389427 */     // GIR_Coverage, 6170,
     /* 389427 */     GIR_EraseRootFromParent_Done,
     /* 389428 */   // Label 7744: @389428
     /* 389428 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(389524), // Rule ID 6074 //
     /* 389433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389475 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389490 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 389510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389522 */     GIR_RootConstrainSelectedInstOperands,
     /* 389523 */     // GIR_Coverage, 6074,
     /* 389523 */     GIR_EraseRootFromParent_Done,
     /* 389524 */   // Label 7745: @389524
     /* 389524 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(389608), // Rule ID 2533 //
     /* 389529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389559 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389578 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 389594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389606 */     GIR_RootConstrainSelectedInstOperands,
     /* 389607 */     // GIR_Coverage, 2533,
     /* 389607 */     GIR_EraseRootFromParent_Done,
     /* 389608 */   // Label 7746: @389608
     /* 389608 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(389658), // Rule ID 13309 //
     /* 389613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389643 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 389646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389656 */     GIR_RootConstrainSelectedInstOperands,
     /* 389657 */     // GIR_Coverage, 13309,
     /* 389657 */     GIR_EraseRootFromParent_Done,
     /* 389658 */   // Label 7747: @389658
     /* 389658 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(389742), // Rule ID 6042 //
     /* 389663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389693 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389705 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389712 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 389728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389740 */     GIR_RootConstrainSelectedInstOperands,
     /* 389741 */     // GIR_Coverage, 6042,
     /* 389741 */     GIR_EraseRootFromParent_Done,
     /* 389742 */   // Label 7748: @389742
     /* 389742 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(389792), // Rule ID 1303 //
     /* 389747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389777 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 389780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389790 */     GIR_RootConstrainSelectedInstOperands,
     /* 389791 */     // GIR_Coverage, 1303,
     /* 389791 */     GIR_EraseRootFromParent_Done,
     /* 389792 */   // Label 7749: @389792
     /* 389792 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(389825), // Rule ID 1293 //
     /* 389797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389812 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 389815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 389823 */     GIR_RootConstrainSelectedInstOperands,
     /* 389824 */     // GIR_Coverage, 1293,
     /* 389824 */     GIR_EraseRootFromParent_Done,
     /* 389825 */   // Label 7750: @389825
     /* 389825 */   GIM_Reject,
     /* 389826 */ // Label 7735: @389826
     /* 389826 */ GIM_Reject,
     /* 389827 */ // Label 7601: @389827
     /* 389827 */ GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(391347),
     /* 389832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 389838 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 389841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389845 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(389923), // Rule ID 6202 //
     /* 389850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389891 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389895 */     // MIs[3] Operand 1
     /* 389895 */     // No operand predicates
     /* 389895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389905 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389921 */     GIR_RootConstrainSelectedInstOperands,
     /* 389922 */     // GIR_Coverage, 6202,
     /* 389922 */     GIR_EraseRootFromParent_Done,
     /* 389923 */   // Label 7752: @389923
     /* 389923 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(390007), // Rule ID 6116 //
     /* 389928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389964 */     // MIs[2] Operand 1
     /* 389964 */     // No operand predicates
     /* 389964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 389968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389976 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389987 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 389998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390005 */     GIR_RootConstrainSelectedInstOperands,
     /* 390006 */     // GIR_Coverage, 6116,
     /* 390006 */     GIR_EraseRootFromParent_Done,
     /* 390007 */   // Label 7753: @390007
     /* 390007 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(390088), // Rule ID 6148 //
     /* 390012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 390035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390056 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390060 */     // MIs[3] Operand 1
     /* 390060 */     // No operand predicates
     /* 390060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390070 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390086 */     GIR_RootConstrainSelectedInstOperands,
     /* 390087 */     // GIR_Coverage, 6148,
     /* 390087 */     GIR_EraseRootFromParent_Done,
     /* 390088 */   // Label 7754: @390088
     /* 390088 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(390172), // Rule ID 6180 //
     /* 390093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 390121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390142 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390146 */     // MIs[3] Operand 1
     /* 390146 */     // No operand predicates
     /* 390146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390152 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390170 */     GIR_RootConstrainSelectedInstOperands,
     /* 390171 */     // GIR_Coverage, 6180,
     /* 390171 */     GIR_EraseRootFromParent_Done,
     /* 390172 */   // Label 7755: @390172
     /* 390172 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(390250), // Rule ID 6224 //
     /* 390177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 390189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 390218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390222 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390226 */     // MIs[3] Operand 1
     /* 390226 */     // No operand predicates
     /* 390226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390232 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390248 */     GIR_RootConstrainSelectedInstOperands,
     /* 390249 */     // GIR_Coverage, 6224,
     /* 390249 */     GIR_EraseRootFromParent_Done,
     /* 390250 */   // Label 7756: @390250
     /* 390250 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(390331), // Rule ID 6084 //
     /* 390255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 390282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390303 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390307 */     // MIs[3] Operand 1
     /* 390307 */     // No operand predicates
     /* 390307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390313 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390329 */     GIR_RootConstrainSelectedInstOperands,
     /* 390330 */     // GIR_Coverage, 6084,
     /* 390330 */     GIR_EraseRootFromParent_Done,
     /* 390331 */   // Label 7757: @390331
     /* 390331 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(390400), // Rule ID 2543 //
     /* 390336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 390347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390372 */     // MIs[2] Operand 1
     /* 390372 */     // No operand predicates
     /* 390372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390382 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 390385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390398 */     GIR_RootConstrainSelectedInstOperands,
     /* 390399 */     // GIR_Coverage, 2543,
     /* 390399 */     GIR_EraseRootFromParent_Done,
     /* 390400 */   // Label 7758: @390400
     /* 390400 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(390469), // Rule ID 6052 //
     /* 390405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 390420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390441 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390445 */     // MIs[2] Operand 1
     /* 390445 */     // No operand predicates
     /* 390445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390451 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 390454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390467 */     GIR_RootConstrainSelectedInstOperands,
     /* 390468 */     // GIR_Coverage, 6052,
     /* 390468 */     GIR_EraseRootFromParent_Done,
     /* 390469 */   // Label 7759: @390469
     /* 390469 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(390562), // Rule ID 6206 //
     /* 390474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390513 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390525 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390532 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390560 */     GIR_RootConstrainSelectedInstOperands,
     /* 390561 */     // GIR_Coverage, 6206,
     /* 390561 */     GIR_EraseRootFromParent_Done,
     /* 390562 */   // Label 7760: @390562
     /* 390562 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(390661), // Rule ID 6118 //
     /* 390567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390610 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390629 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 390653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390659 */     GIR_RootConstrainSelectedInstOperands,
     /* 390660 */     // GIR_Coverage, 6118,
     /* 390660 */     GIR_EraseRootFromParent_Done,
     /* 390661 */   // Label 7761: @390661
     /* 390661 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(390757), // Rule ID 6150 //
     /* 390666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390708 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390720 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390727 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390755 */     GIR_RootConstrainSelectedInstOperands,
     /* 390756 */     // GIR_Coverage, 6150,
     /* 390756 */     GIR_EraseRootFromParent_Done,
     /* 390757 */   // Label 7762: @390757
     /* 390757 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(390856), // Rule ID 6182 //
     /* 390762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390805 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390817 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390824 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390854 */     GIR_RootConstrainSelectedInstOperands,
     /* 390855 */     // GIR_Coverage, 6182,
     /* 390855 */     GIR_EraseRootFromParent_Done,
     /* 390856 */   // Label 7763: @390856
     /* 390856 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(390949), // Rule ID 6228 //
     /* 390861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390900 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390915 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390919 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390947 */     GIR_RootConstrainSelectedInstOperands,
     /* 390948 */     // GIR_Coverage, 6228,
     /* 390948 */     GIR_EraseRootFromParent_Done,
     /* 390949 */   // Label 7764: @390949
     /* 390949 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(391045), // Rule ID 6086 //
     /* 390954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390996 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391008 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 391018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 391031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391043 */     GIR_RootConstrainSelectedInstOperands,
     /* 391044 */     // GIR_Coverage, 6086,
     /* 391044 */     GIR_EraseRootFromParent_Done,
     /* 391045 */   // Label 7765: @391045
     /* 391045 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(391129), // Rule ID 2545 //
     /* 391050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 391065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391080 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391092 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391099 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 391102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 391115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391127 */     GIR_RootConstrainSelectedInstOperands,
     /* 391128 */     // GIR_Coverage, 2545,
     /* 391128 */     GIR_EraseRootFromParent_Done,
     /* 391129 */   // Label 7766: @391129
     /* 391129 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(391179), // Rule ID 13315 //
     /* 391134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391164 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 391164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 391167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391177 */     GIR_RootConstrainSelectedInstOperands,
     /* 391178 */     // GIR_Coverage, 13315,
     /* 391178 */     GIR_EraseRootFromParent_Done,
     /* 391179 */   // Label 7767: @391179
     /* 391179 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(391263), // Rule ID 6054 //
     /* 391184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 391203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391214 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391226 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391233 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 391236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 391249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391261 */     GIR_RootConstrainSelectedInstOperands,
     /* 391262 */     // GIR_Coverage, 6054,
     /* 391262 */     GIR_EraseRootFromParent_Done,
     /* 391263 */   // Label 7768: @391263
     /* 391263 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(391313), // Rule ID 1309 //
     /* 391268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391298 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 391298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 391301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391311 */     GIR_RootConstrainSelectedInstOperands,
     /* 391312 */     // GIR_Coverage, 1309,
     /* 391312 */     GIR_EraseRootFromParent_Done,
     /* 391313 */   // Label 7769: @391313
     /* 391313 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(391346), // Rule ID 1299 //
     /* 391318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391333 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 391333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 391336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 391344 */     GIR_RootConstrainSelectedInstOperands,
     /* 391345 */     // GIR_Coverage, 1299,
     /* 391345 */     GIR_EraseRootFromParent_Done,
     /* 391346 */   // Label 7770: @391346
     /* 391346 */   GIM_Reject,
     /* 391347 */ // Label 7751: @391347
     /* 391347 */ GIM_Reject,
     /* 391348 */ // Label 7602: @391348
     /* 391348 */ GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(392526),
     /* 391353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 391359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 391362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391366 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(391450), // Rule ID 6100 //
     /* 391371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391407 */     // MIs[2] Operand 1
     /* 391407 */     // No operand predicates
     /* 391407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 391411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391415 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391419 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391430 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391448 */     GIR_RootConstrainSelectedInstOperands,
     /* 391449 */     // GIR_Coverage, 6100,
     /* 391449 */     GIR_EraseRootFromParent_Done,
     /* 391450 */   // Label 7772: @391450
     /* 391450 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(391531), // Rule ID 6132 //
     /* 391455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391499 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391503 */     // MIs[3] Operand 1
     /* 391503 */     // No operand predicates
     /* 391503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391511 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391513 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391529 */     GIR_RootConstrainSelectedInstOperands,
     /* 391530 */     // GIR_Coverage, 6132,
     /* 391530 */     GIR_EraseRootFromParent_Done,
     /* 391531 */   // Label 7773: @391531
     /* 391531 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(391615), // Rule ID 6164 //
     /* 391536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391585 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391589 */     // MIs[3] Operand 1
     /* 391589 */     // No operand predicates
     /* 391589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391595 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391613 */     GIR_RootConstrainSelectedInstOperands,
     /* 391614 */     // GIR_Coverage, 6164,
     /* 391614 */     GIR_EraseRootFromParent_Done,
     /* 391615 */   // Label 7774: @391615
     /* 391615 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(391696), // Rule ID 6068 //
     /* 391620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391668 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391672 */     // MIs[3] Operand 1
     /* 391672 */     // No operand predicates
     /* 391672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391678 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391694 */     GIR_RootConstrainSelectedInstOperands,
     /* 391695 */     // GIR_Coverage, 6068,
     /* 391695 */     GIR_EraseRootFromParent_Done,
     /* 391696 */   // Label 7775: @391696
     /* 391696 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(391765), // Rule ID 2527 //
     /* 391701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391733 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391737 */     // MIs[2] Operand 1
     /* 391737 */     // No operand predicates
     /* 391737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391747 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391763 */     GIR_RootConstrainSelectedInstOperands,
     /* 391764 */     // GIR_Coverage, 2527,
     /* 391764 */     GIR_EraseRootFromParent_Done,
     /* 391765 */   // Label 7776: @391765
     /* 391765 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(391834), // Rule ID 6036 //
     /* 391770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391806 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391810 */     // MIs[2] Operand 1
     /* 391810 */     // No operand predicates
     /* 391810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391816 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391832 */     GIR_RootConstrainSelectedInstOperands,
     /* 391833 */     // GIR_Coverage, 6036,
     /* 391833 */     GIR_EraseRootFromParent_Done,
     /* 391834 */   // Label 7777: @391834
     /* 391834 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(391933), // Rule ID 6102 //
     /* 391839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391882 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391894 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 391925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391931 */     GIR_RootConstrainSelectedInstOperands,
     /* 391932 */     // GIR_Coverage, 6102,
     /* 391932 */     GIR_EraseRootFromParent_Done,
     /* 391933 */   // Label 7778: @391933
     /* 391933 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(392029), // Rule ID 6134 //
     /* 391938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391980 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391992 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391999 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 392015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392027 */     GIR_RootConstrainSelectedInstOperands,
     /* 392028 */     // GIR_Coverage, 6134,
     /* 392028 */     GIR_EraseRootFromParent_Done,
     /* 392029 */   // Label 7779: @392029
     /* 392029 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(392128), // Rule ID 6166 //
     /* 392034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 392058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 392062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392077 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 392080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 392112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392126 */     GIR_RootConstrainSelectedInstOperands,
     /* 392127 */     // GIR_Coverage, 6166,
     /* 392127 */     GIR_EraseRootFromParent_Done,
     /* 392128 */   // Label 7780: @392128
     /* 392128 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(392224), // Rule ID 6070 //
     /* 392133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 392160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 392164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 392175 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 392178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392187 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 392194 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 392210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392222 */     GIR_RootConstrainSelectedInstOperands,
     /* 392223 */     // GIR_Coverage, 6070,
     /* 392223 */     GIR_EraseRootFromParent_Done,
     /* 392224 */   // Label 7781: @392224
     /* 392224 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(392308), // Rule ID 2529 //
     /* 392229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392259 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 392262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 392294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392306 */     GIR_RootConstrainSelectedInstOperands,
     /* 392307 */     // GIR_Coverage, 2529,
     /* 392307 */     GIR_EraseRootFromParent_Done,
     /* 392308 */   // Label 7782: @392308
     /* 392308 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(392358), // Rule ID 13311 //
     /* 392313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392343 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 392343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 392346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392356 */     GIR_RootConstrainSelectedInstOperands,
     /* 392357 */     // GIR_Coverage, 13311,
     /* 392357 */     GIR_EraseRootFromParent_Done,
     /* 392358 */   // Label 7783: @392358
     /* 392358 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(392442), // Rule ID 6038 //
     /* 392363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 392378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 392382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392393 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 392396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 392400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 392408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392412 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 392425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 392428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392440 */     GIR_RootConstrainSelectedInstOperands,
     /* 392441 */     // GIR_Coverage, 6038,
     /* 392441 */     GIR_EraseRootFromParent_Done,
     /* 392442 */   // Label 7784: @392442
     /* 392442 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(392492), // Rule ID 1305 //
     /* 392447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392477 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 392477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 392480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392490 */     GIR_RootConstrainSelectedInstOperands,
     /* 392491 */     // GIR_Coverage, 1305,
     /* 392491 */     GIR_EraseRootFromParent_Done,
     /* 392492 */   // Label 7785: @392492
     /* 392492 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(392525), // Rule ID 1295 //
     /* 392497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392512 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 392512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 392515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 392523 */     GIR_RootConstrainSelectedInstOperands,
     /* 392524 */     // GIR_Coverage, 1295,
     /* 392524 */     GIR_EraseRootFromParent_Done,
     /* 392525 */   // Label 7786: @392525
     /* 392525 */   GIM_Reject,
     /* 392526 */ // Label 7771: @392526
     /* 392526 */ GIM_Reject,
     /* 392527 */ // Label 7603: @392527
     /* 392527 */ GIM_Reject,
     /* 392528 */ // Label 106: @392528
     /* 392528 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7795*/ GIMT_Encode4(392827),
     /* 392539 */ /*GILLT_s16*//*Label 7787*/ GIMT_Encode4(392579),
     /* 392543 */ /*GILLT_s32*//*Label 7788*/ GIMT_Encode4(392610),
     /* 392547 */ /*GILLT_s64*//*Label 7789*/ GIMT_Encode4(392641), GIMT_Encode4(0),
     /* 392555 */ /*GILLT_v2s32*//*Label 7790*/ GIMT_Encode4(392672),
     /* 392559 */ /*GILLT_v2s64*//*Label 7791*/ GIMT_Encode4(392703),
     /* 392563 */ /*GILLT_v4s16*//*Label 7792*/ GIMT_Encode4(392734),
     /* 392567 */ /*GILLT_v4s32*//*Label 7793*/ GIMT_Encode4(392765), GIMT_Encode4(0),
     /* 392575 */ /*GILLT_v8s16*//*Label 7794*/ GIMT_Encode4(392796),
     /* 392579 */ // Label 7787: @392579
     /* 392579 */ GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(392609), // Rule ID 569 //
     /* 392584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392598 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 392603 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392607 */   GIR_RootConstrainSelectedInstOperands,
     /* 392608 */   // GIR_Coverage, 569,
     /* 392608 */   GIR_Done,
     /* 392609 */ // Label 7796: @392609
     /* 392609 */ GIM_Reject,
     /* 392610 */ // Label 7788: @392610
     /* 392610 */ GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(392640), // Rule ID 571 //
     /* 392615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392629 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 392634 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392638 */   GIR_RootConstrainSelectedInstOperands,
     /* 392639 */   // GIR_Coverage, 571,
     /* 392639 */   GIR_Done,
     /* 392640 */ // Label 7797: @392640
     /* 392640 */ GIM_Reject,
     /* 392641 */ // Label 7789: @392641
     /* 392641 */ GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(392671), // Rule ID 573 //
     /* 392646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392660 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 392665 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392669 */   GIR_RootConstrainSelectedInstOperands,
     /* 392670 */   // GIR_Coverage, 573,
     /* 392670 */   GIR_Done,
     /* 392671 */ // Label 7798: @392671
     /* 392671 */ GIM_Reject,
     /* 392672 */ // Label 7790: @392672
     /* 392672 */ GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(392702), // Rule ID 959 //
     /* 392677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392691 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 392696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392700 */   GIR_RootConstrainSelectedInstOperands,
     /* 392701 */   // GIR_Coverage, 959,
     /* 392701 */   GIR_Done,
     /* 392702 */ // Label 7799: @392702
     /* 392702 */ GIM_Reject,
     /* 392703 */ // Label 7791: @392703
     /* 392703 */ GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(392733), // Rule ID 963 //
     /* 392708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392722 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 392727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392731 */   GIR_RootConstrainSelectedInstOperands,
     /* 392732 */   // GIR_Coverage, 963,
     /* 392732 */   GIR_Done,
     /* 392733 */ // Label 7800: @392733
     /* 392733 */ GIM_Reject,
     /* 392734 */ // Label 7792: @392734
     /* 392734 */ GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(392764), // Rule ID 955 //
     /* 392739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392753 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 392758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392762 */   GIR_RootConstrainSelectedInstOperands,
     /* 392763 */   // GIR_Coverage, 955,
     /* 392763 */   GIR_Done,
     /* 392764 */ // Label 7801: @392764
     /* 392764 */ GIM_Reject,
     /* 392765 */ // Label 7793: @392765
     /* 392765 */ GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(392795), // Rule ID 961 //
     /* 392770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392784 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 392789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392793 */   GIR_RootConstrainSelectedInstOperands,
     /* 392794 */   // GIR_Coverage, 961,
     /* 392794 */   GIR_Done,
     /* 392795 */ // Label 7802: @392795
     /* 392795 */ GIM_Reject,
     /* 392796 */ // Label 7794: @392796
     /* 392796 */ GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(392826), // Rule ID 957 //
     /* 392801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392815 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 392820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392824 */   GIR_RootConstrainSelectedInstOperands,
     /* 392825 */   // GIR_Coverage, 957,
     /* 392825 */   GIR_Done,
     /* 392826 */ // Label 7803: @392826
     /* 392826 */ GIM_Reject,
     /* 392827 */ // Label 7795: @392827
     /* 392827 */ GIM_Reject,
     /* 392828 */ // Label 107: @392828
     /* 392828 */ GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(392841), // Rule ID 6515 //
     /* 392833 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 392833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 392836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 392839 */   GIR_RootConstrainSelectedInstOperands,
     /* 392840 */   // GIR_Coverage, 6515,
     /* 392840 */   GIR_EraseRootFromParent_Done,
     /* 392841 */ // Label 7804: @392841
     /* 392841 */ GIM_Reject,
     /* 392842 */ // Label 108: @392842
     /* 392842 */ GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(392862), // Rule ID 6516 //
     /* 392847 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 392847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 392850 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 392860 */   GIR_RootConstrainSelectedInstOperands,
     /* 392861 */   // GIR_Coverage, 6516,
     /* 392861 */   GIR_EraseRootFromParent_Done,
     /* 392862 */ // Label 7805: @392862
     /* 392862 */ GIM_Reject,
     /* 392863 */ // Label 109: @392863
     /* 392863 */ GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(392887), // Rule ID 6517 //
     /* 392868 */   // MIs[0] kind
     /* 392868 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 392871 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 392876 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 392876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 392879 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 392885 */   GIR_RootConstrainSelectedInstOperands,
     /* 392886 */   // GIR_Coverage, 6517,
     /* 392886 */   GIR_EraseRootFromParent_Done,
     /* 392887 */ // Label 7806: @392887
     /* 392887 */ GIM_Reject,
     /* 392888 */ // Label 110: @392888
     /* 392888 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7810*/ GIMT_Encode4(393197),
     /* 392899 */ /*GILLT_s16*//*Label 7807*/ GIMT_Encode4(392911),
     /* 392903 */ /*GILLT_s32*//*Label 7808*/ GIMT_Encode4(393064),
     /* 392907 */ /*GILLT_s64*//*Label 7809*/ GIMT_Encode4(393169),
     /* 392911 */ // Label 7807: @392911
     /* 392911 */ GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(393012), // Rule ID 5606 //
     /* 392916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392930 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 392930 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 392933 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 392937 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392942 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392946 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 392952 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392955 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 392959 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392964 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 392967 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392985 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 392992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392997 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 393005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393007 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393010 */   GIR_RootConstrainSelectedInstOperands,
     /* 393011 */   // GIR_Coverage, 5606,
     /* 393011 */   GIR_EraseRootFromParent_Done,
     /* 393012 */ // Label 7811: @393012
     /* 393012 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(393063), // Rule ID 5607 //
     /* 393017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393031 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 393031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 393034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 393038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393043 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393047 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 393056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393061 */   GIR_RootConstrainSelectedInstOperands,
     /* 393062 */   // GIR_Coverage, 5607,
     /* 393062 */   GIR_EraseRootFromParent_Done,
     /* 393063 */ // Label 7812: @393063
     /* 393063 */ GIM_Reject,
     /* 393064 */ // Label 7808: @393064
     /* 393064 */ GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(393141), // Rule ID 5608 //
     /* 393069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393080 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 393080 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393083 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 393087 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393092 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393096 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 393105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393114 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 393121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 393134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393139 */   GIR_RootConstrainSelectedInstOperands,
     /* 393140 */   // GIR_Coverage, 5608,
     /* 393140 */   GIR_EraseRootFromParent_Done,
     /* 393141 */ // Label 7813: @393141
     /* 393141 */ GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(393168), // Rule ID 5609 //
     /* 393146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393157 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 393162 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393166 */   GIR_RootConstrainSelectedInstOperands,
     /* 393167 */   // GIR_Coverage, 5609,
     /* 393167 */   GIR_Done,
     /* 393168 */ // Label 7814: @393168
     /* 393168 */ GIM_Reject,
     /* 393169 */ // Label 7809: @393169
     /* 393169 */ GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(393196), // Rule ID 5610 //
     /* 393174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393185 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 393190 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393194 */   GIR_RootConstrainSelectedInstOperands,
     /* 393195 */   // GIR_Coverage, 5610,
     /* 393195 */   GIR_Done,
     /* 393196 */ // Label 7815: @393196
     /* 393196 */ GIM_Reject,
     /* 393197 */ // Label 7810: @393197
     /* 393197 */ GIM_Reject,
     /* 393198 */ // Label 111: @393198
     /* 393198 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7819*/ GIMT_Encode4(393368),
     /* 393209 */ /*GILLT_s16*//*Label 7816*/ GIMT_Encode4(393221),
     /* 393213 */ /*GILLT_s32*//*Label 7817*/ GIMT_Encode4(393282),
     /* 393217 */ /*GILLT_s64*//*Label 7818*/ GIMT_Encode4(393340),
     /* 393221 */ // Label 7816: @393221
     /* 393221 */ GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(393251), // Rule ID 1942 //
     /* 393226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393240 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 393245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393249 */   GIR_RootConstrainSelectedInstOperands,
     /* 393250 */   // GIR_Coverage, 1942,
     /* 393250 */   GIR_Done,
     /* 393251 */ // Label 7820: @393251
     /* 393251 */ GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(393281), // Rule ID 1944 //
     /* 393256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393270 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 393275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393279 */   GIR_RootConstrainSelectedInstOperands,
     /* 393280 */   // GIR_Coverage, 1944,
     /* 393280 */   GIR_Done,
     /* 393281 */ // Label 7821: @393281
     /* 393281 */ GIM_Reject,
     /* 393282 */ // Label 7817: @393282
     /* 393282 */ GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(393312), // Rule ID 1946 //
     /* 393287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393301 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 393306 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393310 */   GIR_RootConstrainSelectedInstOperands,
     /* 393311 */   // GIR_Coverage, 1946,
     /* 393311 */   GIR_Done,
     /* 393312 */ // Label 7822: @393312
     /* 393312 */ GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(393339), // Rule ID 5616 //
     /* 393317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393328 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 393333 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393337 */   GIR_RootConstrainSelectedInstOperands,
     /* 393338 */   // GIR_Coverage, 5616,
     /* 393338 */   GIR_Done,
     /* 393339 */ // Label 7823: @393339
     /* 393339 */ GIM_Reject,
     /* 393340 */ // Label 7818: @393340
     /* 393340 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(393367), // Rule ID 5618 //
     /* 393345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393356 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 393361 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393365 */   GIR_RootConstrainSelectedInstOperands,
     /* 393366 */   // GIR_Coverage, 5618,
     /* 393366 */   GIR_Done,
     /* 393367 */ // Label 7824: @393367
     /* 393367 */ GIM_Reject,
     /* 393368 */ // Label 7819: @393368
     /* 393368 */ GIM_Reject,
     /* 393369 */ // Label 112: @393369
     /* 393369 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7828*/ GIMT_Encode4(393539),
     /* 393380 */ /*GILLT_s16*//*Label 7825*/ GIMT_Encode4(393392),
     /* 393384 */ /*GILLT_s32*//*Label 7826*/ GIMT_Encode4(393453),
     /* 393388 */ /*GILLT_s64*//*Label 7827*/ GIMT_Encode4(393511),
     /* 393392 */ // Label 7825: @393392
     /* 393392 */ GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(393422), // Rule ID 1954 //
     /* 393397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393411 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 393416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393420 */   GIR_RootConstrainSelectedInstOperands,
     /* 393421 */   // GIR_Coverage, 1954,
     /* 393421 */   GIR_Done,
     /* 393422 */ // Label 7829: @393422
     /* 393422 */ GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(393452), // Rule ID 1956 //
     /* 393427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393441 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 393446 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393450 */   GIR_RootConstrainSelectedInstOperands,
     /* 393451 */   // GIR_Coverage, 1956,
     /* 393451 */   GIR_Done,
     /* 393452 */ // Label 7830: @393452
     /* 393452 */ GIM_Reject,
     /* 393453 */ // Label 7826: @393453
     /* 393453 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(393483), // Rule ID 1958 //
     /* 393458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393472 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 393477 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393481 */   GIR_RootConstrainSelectedInstOperands,
     /* 393482 */   // GIR_Coverage, 1958,
     /* 393482 */   GIR_Done,
     /* 393483 */ // Label 7831: @393483
     /* 393483 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(393510), // Rule ID 5624 //
     /* 393488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393499 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 393504 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393508 */   GIR_RootConstrainSelectedInstOperands,
     /* 393509 */   // GIR_Coverage, 5624,
     /* 393509 */   GIR_Done,
     /* 393510 */ // Label 7832: @393510
     /* 393510 */ GIM_Reject,
     /* 393511 */ // Label 7827: @393511
     /* 393511 */ GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(393538), // Rule ID 5626 //
     /* 393516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393527 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 393532 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393536 */   GIR_RootConstrainSelectedInstOperands,
     /* 393537 */   // GIR_Coverage, 5626,
     /* 393537 */   GIR_Done,
     /* 393538 */ // Label 7833: @393538
     /* 393538 */ GIM_Reject,
     /* 393539 */ // Label 7828: @393539
     /* 393539 */ GIM_Reject,
     /* 393540 */ // Label 113: @393540
     /* 393540 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7837*/ GIMT_Encode4(393710),
     /* 393551 */ /*GILLT_s16*//*Label 7834*/ GIMT_Encode4(393563),
     /* 393555 */ /*GILLT_s32*//*Label 7835*/ GIMT_Encode4(393624),
     /* 393559 */ /*GILLT_s64*//*Label 7836*/ GIMT_Encode4(393682),
     /* 393563 */ // Label 7834: @393563
     /* 393563 */ GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(393593), // Rule ID 1948 //
     /* 393568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393582 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 393587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393591 */   GIR_RootConstrainSelectedInstOperands,
     /* 393592 */   // GIR_Coverage, 1948,
     /* 393592 */   GIR_Done,
     /* 393593 */ // Label 7838: @393593
     /* 393593 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(393623), // Rule ID 1950 //
     /* 393598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393612 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 393617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393621 */   GIR_RootConstrainSelectedInstOperands,
     /* 393622 */   // GIR_Coverage, 1950,
     /* 393622 */   GIR_Done,
     /* 393623 */ // Label 7839: @393623
     /* 393623 */ GIM_Reject,
     /* 393624 */ // Label 7835: @393624
     /* 393624 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(393654), // Rule ID 1952 //
     /* 393629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393643 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 393648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393652 */   GIR_RootConstrainSelectedInstOperands,
     /* 393653 */   // GIR_Coverage, 1952,
     /* 393653 */   GIR_Done,
     /* 393654 */ // Label 7840: @393654
     /* 393654 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(393681), // Rule ID 5620 //
     /* 393659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393670 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 393675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393679 */   GIR_RootConstrainSelectedInstOperands,
     /* 393680 */   // GIR_Coverage, 5620,
     /* 393680 */   GIR_Done,
     /* 393681 */ // Label 7841: @393681
     /* 393681 */ GIM_Reject,
     /* 393682 */ // Label 7836: @393682
     /* 393682 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(393709), // Rule ID 5622 //
     /* 393687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393698 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 393703 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393707 */   GIR_RootConstrainSelectedInstOperands,
     /* 393708 */   // GIR_Coverage, 5622,
     /* 393708 */   GIR_Done,
     /* 393709 */ // Label 7842: @393709
     /* 393709 */ GIM_Reject,
     /* 393710 */ // Label 7837: @393710
     /* 393710 */ GIM_Reject,
     /* 393711 */ // Label 114: @393711
     /* 393711 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7846*/ GIMT_Encode4(393881),
     /* 393722 */ /*GILLT_s16*//*Label 7843*/ GIMT_Encode4(393734),
     /* 393726 */ /*GILLT_s32*//*Label 7844*/ GIMT_Encode4(393795),
     /* 393730 */ /*GILLT_s64*//*Label 7845*/ GIMT_Encode4(393853),
     /* 393734 */ // Label 7843: @393734
     /* 393734 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(393764), // Rule ID 1960 //
     /* 393739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393753 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 393758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393762 */   GIR_RootConstrainSelectedInstOperands,
     /* 393763 */   // GIR_Coverage, 1960,
     /* 393763 */   GIR_Done,
     /* 393764 */ // Label 7847: @393764
     /* 393764 */ GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(393794), // Rule ID 1962 //
     /* 393769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393783 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 393788 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393792 */   GIR_RootConstrainSelectedInstOperands,
     /* 393793 */   // GIR_Coverage, 1962,
     /* 393793 */   GIR_Done,
     /* 393794 */ // Label 7848: @393794
     /* 393794 */ GIM_Reject,
     /* 393795 */ // Label 7844: @393795
     /* 393795 */ GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(393825), // Rule ID 1964 //
     /* 393800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393814 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 393819 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393823 */   GIR_RootConstrainSelectedInstOperands,
     /* 393824 */   // GIR_Coverage, 1964,
     /* 393824 */   GIR_Done,
     /* 393825 */ // Label 7849: @393825
     /* 393825 */ GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(393852), // Rule ID 5628 //
     /* 393830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393841 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 393846 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393850 */   GIR_RootConstrainSelectedInstOperands,
     /* 393851 */   // GIR_Coverage, 5628,
     /* 393851 */   GIR_Done,
     /* 393852 */ // Label 7850: @393852
     /* 393852 */ GIM_Reject,
     /* 393853 */ // Label 7845: @393853
     /* 393853 */ GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(393880), // Rule ID 5630 //
     /* 393858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393869 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 393874 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393878 */   GIR_RootConstrainSelectedInstOperands,
     /* 393879 */   // GIR_Coverage, 5630,
     /* 393879 */   GIR_Done,
     /* 393880 */ // Label 7851: @393880
     /* 393880 */ GIM_Reject,
     /* 393881 */ // Label 7846: @393881
     /* 393881 */ GIM_Reject,
     /* 393882 */ // Label 115: @393882
     /* 393882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7856*/ GIMT_Encode4(395010),
     /* 393893 */ /*GILLT_s8*//*Label 7852*/ GIMT_Encode4(393909),
     /* 393897 */ /*GILLT_s16*//*Label 7853*/ GIMT_Encode4(393956),
     /* 393901 */ /*GILLT_s32*//*Label 7854*/ GIMT_Encode4(394371),
     /* 393905 */ /*GILLT_s64*//*Label 7855*/ GIMT_Encode4(394824),
     /* 393909 */ // Label 7852: @393909
     /* 393909 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(393932), // Rule ID 5889 //
     /* 393914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 393921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393925 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 393925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 393930 */   GIR_RootConstrainSelectedInstOperands,
     /* 393931 */   // GIR_Coverage, 5889,
     /* 393931 */   GIR_Done,
     /* 393932 */ // Label 7857: @393932
     /* 393932 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(393955), // Rule ID 5890 //
     /* 393937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 393944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393948 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 393948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 393953 */   GIR_RootConstrainSelectedInstOperands,
     /* 393954 */   // GIR_Coverage, 5890,
     /* 393954 */   GIR_Done,
     /* 393955 */ // Label 7858: @393955
     /* 393955 */ GIM_Reject,
     /* 393956 */ // Label 7853: @393956
     /* 393956 */ GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(394006), // Rule ID 5836 //
     /* 393961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393976 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393979 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393984 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 393988 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393993 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393995 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 393998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394000 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394004 */   GIR_RootConstrainSelectedInstOperands,
     /* 394005 */   // GIR_Coverage, 5836,
     /* 394005 */   GIR_EraseRootFromParent_Done,
     /* 394006 */ // Label 7859: @394006
     /* 394006 */ GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(394056), // Rule ID 5838 //
     /* 394011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394026 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394029 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 394034 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 394038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394043 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394045 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 394045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 394048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394054 */   GIR_RootConstrainSelectedInstOperands,
     /* 394055 */   // GIR_Coverage, 5838,
     /* 394055 */   GIR_EraseRootFromParent_Done,
     /* 394056 */ // Label 7860: @394056
     /* 394056 */ GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(394106), // Rule ID 5846 //
     /* 394061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394068 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394076 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394079 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 394084 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 394088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394095 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 394095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 394098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394100 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394104 */   GIR_RootConstrainSelectedInstOperands,
     /* 394105 */   // GIR_Coverage, 5846,
     /* 394105 */   GIR_EraseRootFromParent_Done,
     /* 394106 */ // Label 7861: @394106
     /* 394106 */ GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(394156), // Rule ID 5848 //
     /* 394111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394118 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394126 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394129 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 394134 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 394138 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394143 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394145 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 394145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 394148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394150 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394154 */   GIR_RootConstrainSelectedInstOperands,
     /* 394155 */   // GIR_Coverage, 5848,
     /* 394155 */   GIR_EraseRootFromParent_Done,
     /* 394156 */ // Label 7862: @394156
     /* 394156 */ GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(394198), // Rule ID 5845 //
     /* 394161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 394176 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394180 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394185 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394187 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 394187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 394190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394192 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394196 */   GIR_RootConstrainSelectedInstOperands,
     /* 394197 */   // GIR_Coverage, 5845,
     /* 394197 */   GIR_EraseRootFromParent_Done,
     /* 394198 */ // Label 7863: @394198
     /* 394198 */ GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(394240), // Rule ID 5847 //
     /* 394203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394210 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394214 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 394218 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394222 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394227 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394229 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 394229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 394232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394234 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394238 */   GIR_RootConstrainSelectedInstOperands,
     /* 394239 */   // GIR_Coverage, 5847,
     /* 394239 */   GIR_EraseRootFromParent_Done,
     /* 394240 */ // Label 7864: @394240
     /* 394240 */ GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(394282), // Rule ID 5835 //
     /* 394245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 394260 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394264 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394269 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394271 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 394271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 394274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394276 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394280 */   GIR_RootConstrainSelectedInstOperands,
     /* 394281 */   // GIR_Coverage, 5835,
     /* 394281 */   GIR_EraseRootFromParent_Done,
     /* 394282 */ // Label 7865: @394282
     /* 394282 */ GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(394324), // Rule ID 5837 //
     /* 394287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 394302 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394306 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394311 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394313 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 394313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 394316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394318 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394322 */   GIR_RootConstrainSelectedInstOperands,
     /* 394323 */   // GIR_Coverage, 5837,
     /* 394323 */   GIR_EraseRootFromParent_Done,
     /* 394324 */ // Label 7866: @394324
     /* 394324 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(394347), // Rule ID 5891 //
     /* 394329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394340 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 394340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 394345 */   GIR_RootConstrainSelectedInstOperands,
     /* 394346 */   // GIR_Coverage, 5891,
     /* 394346 */   GIR_Done,
     /* 394347 */ // Label 7867: @394347
     /* 394347 */ GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(394370), // Rule ID 5892 //
     /* 394352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394363 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 394363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 394368 */   GIR_RootConstrainSelectedInstOperands,
     /* 394369 */   // GIR_Coverage, 5892,
     /* 394369 */   GIR_Done,
     /* 394370 */ // Label 7868: @394370
     /* 394370 */ GIM_Reject,
     /* 394371 */ // Label 7854: @394371
     /* 394371 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(394421), // Rule ID 5840 //
     /* 394376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394383 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394391 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394394 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 394399 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 394403 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394410 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 394410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 394413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394415 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394419 */   GIR_RootConstrainSelectedInstOperands,
     /* 394420 */   // GIR_Coverage, 5840,
     /* 394420 */   GIR_EraseRootFromParent_Done,
     /* 394421 */ // Label 7869: @394421
     /* 394421 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(394471), // Rule ID 5842 //
     /* 394426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394433 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394437 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394441 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394444 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 394449 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394453 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394458 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394460 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 394463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394465 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394469 */   GIR_RootConstrainSelectedInstOperands,
     /* 394470 */   // GIR_Coverage, 5842,
     /* 394470 */   GIR_EraseRootFromParent_Done,
     /* 394471 */ // Label 7870: @394471
     /* 394471 */ GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(394521), // Rule ID 5850 //
     /* 394476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394491 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394494 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 394499 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 394503 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394508 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394510 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 394510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 394513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394515 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394519 */   GIR_RootConstrainSelectedInstOperands,
     /* 394520 */   // GIR_Coverage, 5850,
     /* 394520 */   GIR_EraseRootFromParent_Done,
     /* 394521 */ // Label 7871: @394521
     /* 394521 */ GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(394571), // Rule ID 5852 //
     /* 394526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394533 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394537 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394541 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394544 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 394549 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394553 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394558 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394560 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 394563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394565 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394569 */   GIR_RootConstrainSelectedInstOperands,
     /* 394570 */   // GIR_Coverage, 5852,
     /* 394570 */   GIR_EraseRootFromParent_Done,
     /* 394571 */ // Label 7872: @394571
     /* 394571 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(394613), // Rule ID 5849 //
     /* 394576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 394591 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394595 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394602 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 394602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 394605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394607 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394611 */   GIR_RootConstrainSelectedInstOperands,
     /* 394612 */   // GIR_Coverage, 5849,
     /* 394612 */   GIR_EraseRootFromParent_Done,
     /* 394613 */ // Label 7873: @394613
     /* 394613 */ GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(394655), // Rule ID 5851 //
     /* 394618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 394633 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394637 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394644 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 394647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394649 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394653 */   GIR_RootConstrainSelectedInstOperands,
     /* 394654 */   // GIR_Coverage, 5851,
     /* 394654 */   GIR_EraseRootFromParent_Done,
     /* 394655 */ // Label 7874: @394655
     /* 394655 */ GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(394697), // Rule ID 5839 //
     /* 394660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 394675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394679 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394686 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 394686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 394689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394691 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394695 */   GIR_RootConstrainSelectedInstOperands,
     /* 394696 */   // GIR_Coverage, 5839,
     /* 394696 */   GIR_EraseRootFromParent_Done,
     /* 394697 */ // Label 7875: @394697
     /* 394697 */ GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(394739), // Rule ID 5841 //
     /* 394702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394709 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394713 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 394717 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394721 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394728 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 394731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394733 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394737 */   GIR_RootConstrainSelectedInstOperands,
     /* 394738 */   // GIR_Coverage, 5841,
     /* 394738 */   GIR_EraseRootFromParent_Done,
     /* 394739 */ // Label 7876: @394739
     /* 394739 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(394800), // Rule ID 5893 //
     /* 394744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394755 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 394762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394767 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394771 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394782 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394799 */   // GIR_Coverage, 5893,
     /* 394799 */   GIR_EraseRootFromParent_Done,
     /* 394800 */ // Label 7877: @394800
     /* 394800 */ GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(394823), // Rule ID 5894 //
     /* 394805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394816 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 394821 */   GIR_RootConstrainSelectedInstOperands,
     /* 394822 */   // GIR_Coverage, 5894,
     /* 394822 */   GIR_Done,
     /* 394823 */ // Label 7878: @394823
     /* 394823 */ GIM_Reject,
     /* 394824 */ // Label 7855: @394824
     /* 394824 */ GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(395009),
     /* 394829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394836 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(394879), // Rule ID 5844 //
     /* 394841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 394857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394868 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 394871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394877 */     GIR_RootConstrainSelectedInstOperands,
     /* 394878 */     // GIR_Coverage, 5844,
     /* 394878 */     GIR_EraseRootFromParent_Done,
     /* 394879 */   // Label 7880: @394879
     /* 394879 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(394922), // Rule ID 5854 //
     /* 394884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394892 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394895 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 394900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394911 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 394914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394920 */     GIR_RootConstrainSelectedInstOperands,
     /* 394921 */     // GIR_Coverage, 5854,
     /* 394921 */     GIR_EraseRootFromParent_Done,
     /* 394922 */   // Label 7881: @394922
     /* 394922 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(394957), // Rule ID 5853 //
     /* 394927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 394935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394946 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 394949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394955 */     GIR_RootConstrainSelectedInstOperands,
     /* 394956 */     // GIR_Coverage, 5853,
     /* 394956 */     GIR_EraseRootFromParent_Done,
     /* 394957 */   // Label 7882: @394957
     /* 394957 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(394992), // Rule ID 5843 //
     /* 394962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 394970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394981 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 394984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394990 */     GIR_RootConstrainSelectedInstOperands,
     /* 394991 */     // GIR_Coverage, 5843,
     /* 394991 */     GIR_EraseRootFromParent_Done,
     /* 394992 */   // Label 7883: @394992
     /* 394992 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(395008), // Rule ID 5895 //
     /* 394997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395001 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 395001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 395006 */     GIR_RootConstrainSelectedInstOperands,
     /* 395007 */     // GIR_Coverage, 5895,
     /* 395007 */     GIR_Done,
     /* 395008 */   // Label 7884: @395008
     /* 395008 */   GIM_Reject,
     /* 395009 */ // Label 7879: @395009
     /* 395009 */ GIM_Reject,
     /* 395010 */ // Label 7856: @395010
     /* 395010 */ GIM_Reject,
     /* 395011 */ // Label 116: @395011
     /* 395011 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7888*/ GIMT_Encode4(395213),
     /* 395022 */ /*GILLT_s8*//*Label 7885*/ GIMT_Encode4(395034),
     /* 395026 */ /*GILLT_s16*//*Label 7886*/ GIMT_Encode4(395081),
     /* 395030 */ /*GILLT_s32*//*Label 7887*/ GIMT_Encode4(395128),
     /* 395034 */ // Label 7885: @395034
     /* 395034 */ GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(395057), // Rule ID 5986 //
     /* 395039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395050 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 395050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 395055 */   GIR_RootConstrainSelectedInstOperands,
     /* 395056 */   // GIR_Coverage, 5986,
     /* 395056 */   GIR_Done,
     /* 395057 */ // Label 7889: @395057
     /* 395057 */ GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(395080), // Rule ID 5987 //
     /* 395062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395073 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 395073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 395078 */   GIR_RootConstrainSelectedInstOperands,
     /* 395079 */   // GIR_Coverage, 5987,
     /* 395079 */   GIR_Done,
     /* 395080 */ // Label 7890: @395080
     /* 395080 */ GIM_Reject,
     /* 395081 */ // Label 7886: @395081
     /* 395081 */ GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(395104), // Rule ID 5988 //
     /* 395086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395097 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 395097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 395102 */   GIR_RootConstrainSelectedInstOperands,
     /* 395103 */   // GIR_Coverage, 5988,
     /* 395103 */   GIR_Done,
     /* 395104 */ // Label 7891: @395104
     /* 395104 */ GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(395127), // Rule ID 5989 //
     /* 395109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395120 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 395120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 395125 */   GIR_RootConstrainSelectedInstOperands,
     /* 395126 */   // GIR_Coverage, 5989,
     /* 395126 */   GIR_Done,
     /* 395127 */ // Label 7892: @395127
     /* 395127 */ GIM_Reject,
     /* 395128 */ // Label 7887: @395128
     /* 395128 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(395151), // Rule ID 5990 //
     /* 395133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395144 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 395144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 395149 */   GIR_RootConstrainSelectedInstOperands,
     /* 395150 */   // GIR_Coverage, 5990,
     /* 395150 */   GIR_Done,
     /* 395151 */ // Label 7893: @395151
     /* 395151 */ GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(395212), // Rule ID 5991 //
     /* 395156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395167 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 395167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 395174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395179 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395183 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395194 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 395201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395211 */   // GIR_Coverage, 5991,
     /* 395211 */   GIR_EraseRootFromParent_Done,
     /* 395212 */ // Label 7894: @395212
     /* 395212 */ GIM_Reject,
     /* 395213 */ // Label 7888: @395213
     /* 395213 */ GIM_Reject,
     /* 395214 */ // Label 117: @395214
     /* 395214 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7898*/ GIMT_Encode4(395416),
     /* 395225 */ /*GILLT_s8*//*Label 7895*/ GIMT_Encode4(395237),
     /* 395229 */ /*GILLT_s16*//*Label 7896*/ GIMT_Encode4(395284),
     /* 395233 */ /*GILLT_s32*//*Label 7897*/ GIMT_Encode4(395331),
     /* 395237 */ // Label 7895: @395237
     /* 395237 */ GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(395260), // Rule ID 5980 //
     /* 395242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395253 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 395253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 395258 */   GIR_RootConstrainSelectedInstOperands,
     /* 395259 */   // GIR_Coverage, 5980,
     /* 395259 */   GIR_Done,
     /* 395260 */ // Label 7899: @395260
     /* 395260 */ GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(395283), // Rule ID 5981 //
     /* 395265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395276 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 395276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 395281 */   GIR_RootConstrainSelectedInstOperands,
     /* 395282 */   // GIR_Coverage, 5981,
     /* 395282 */   GIR_Done,
     /* 395283 */ // Label 7900: @395283
     /* 395283 */ GIM_Reject,
     /* 395284 */ // Label 7896: @395284
     /* 395284 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(395307), // Rule ID 5982 //
     /* 395289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395300 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 395300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 395305 */   GIR_RootConstrainSelectedInstOperands,
     /* 395306 */   // GIR_Coverage, 5982,
     /* 395306 */   GIR_Done,
     /* 395307 */ // Label 7901: @395307
     /* 395307 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(395330), // Rule ID 5983 //
     /* 395312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395323 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 395323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 395328 */   GIR_RootConstrainSelectedInstOperands,
     /* 395329 */   // GIR_Coverage, 5983,
     /* 395329 */   GIR_Done,
     /* 395330 */ // Label 7902: @395330
     /* 395330 */ GIM_Reject,
     /* 395331 */ // Label 7897: @395331
     /* 395331 */ GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(395354), // Rule ID 5984 //
     /* 395336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395347 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 395347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 395352 */   GIR_RootConstrainSelectedInstOperands,
     /* 395353 */   // GIR_Coverage, 5984,
     /* 395353 */   GIR_Done,
     /* 395354 */ // Label 7903: @395354
     /* 395354 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(395415), // Rule ID 5985 //
     /* 395359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395370 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 395370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 395377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395382 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395386 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395397 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 395404 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395409 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395414 */   // GIR_Coverage, 5985,
     /* 395414 */   GIR_EraseRootFromParent_Done,
     /* 395415 */ // Label 7904: @395415
     /* 395415 */ GIM_Reject,
     /* 395416 */ // Label 7898: @395416
     /* 395416 */ GIM_Reject,
     /* 395417 */ // Label 118: @395417
     /* 395417 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7908*/ GIMT_Encode4(395619),
     /* 395428 */ /*GILLT_s8*//*Label 7905*/ GIMT_Encode4(395440),
     /* 395432 */ /*GILLT_s16*//*Label 7906*/ GIMT_Encode4(395487),
     /* 395436 */ /*GILLT_s32*//*Label 7907*/ GIMT_Encode4(395534),
     /* 395440 */ // Label 7905: @395440
     /* 395440 */ GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(395463), // Rule ID 5974 //
     /* 395445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395456 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 395456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 395461 */   GIR_RootConstrainSelectedInstOperands,
     /* 395462 */   // GIR_Coverage, 5974,
     /* 395462 */   GIR_Done,
     /* 395463 */ // Label 7909: @395463
     /* 395463 */ GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(395486), // Rule ID 5975 //
     /* 395468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395479 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 395479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 395484 */   GIR_RootConstrainSelectedInstOperands,
     /* 395485 */   // GIR_Coverage, 5975,
     /* 395485 */   GIR_Done,
     /* 395486 */ // Label 7910: @395486
     /* 395486 */ GIM_Reject,
     /* 395487 */ // Label 7906: @395487
     /* 395487 */ GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(395510), // Rule ID 5976 //
     /* 395492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395503 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 395503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 395508 */   GIR_RootConstrainSelectedInstOperands,
     /* 395509 */   // GIR_Coverage, 5976,
     /* 395509 */   GIR_Done,
     /* 395510 */ // Label 7911: @395510
     /* 395510 */ GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(395533), // Rule ID 5977 //
     /* 395515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395526 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 395526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 395531 */   GIR_RootConstrainSelectedInstOperands,
     /* 395532 */   // GIR_Coverage, 5977,
     /* 395532 */   GIR_Done,
     /* 395533 */ // Label 7912: @395533
     /* 395533 */ GIM_Reject,
     /* 395534 */ // Label 7907: @395534
     /* 395534 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(395557), // Rule ID 5978 //
     /* 395539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395550 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 395550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 395555 */   GIR_RootConstrainSelectedInstOperands,
     /* 395556 */   // GIR_Coverage, 5978,
     /* 395556 */   GIR_Done,
     /* 395557 */ // Label 7913: @395557
     /* 395557 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(395618), // Rule ID 5979 //
     /* 395562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395573 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 395573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 395580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395585 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395589 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395600 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 395607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395617 */   // GIR_Coverage, 5979,
     /* 395617 */   GIR_EraseRootFromParent_Done,
     /* 395618 */ // Label 7914: @395618
     /* 395618 */ GIM_Reject,
     /* 395619 */ // Label 7908: @395619
     /* 395619 */ GIM_Reject,
     /* 395620 */ // Label 119: @395620
     /* 395620 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7918*/ GIMT_Encode4(395822),
     /* 395631 */ /*GILLT_s8*//*Label 7915*/ GIMT_Encode4(395643),
     /* 395635 */ /*GILLT_s16*//*Label 7916*/ GIMT_Encode4(395690),
     /* 395639 */ /*GILLT_s32*//*Label 7917*/ GIMT_Encode4(395737),
     /* 395643 */ // Label 7915: @395643
     /* 395643 */ GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(395666), // Rule ID 5968 //
     /* 395648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395659 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 395659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 395664 */   GIR_RootConstrainSelectedInstOperands,
     /* 395665 */   // GIR_Coverage, 5968,
     /* 395665 */   GIR_Done,
     /* 395666 */ // Label 7919: @395666
     /* 395666 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(395689), // Rule ID 5969 //
     /* 395671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395682 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 395682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 395687 */   GIR_RootConstrainSelectedInstOperands,
     /* 395688 */   // GIR_Coverage, 5969,
     /* 395688 */   GIR_Done,
     /* 395689 */ // Label 7920: @395689
     /* 395689 */ GIM_Reject,
     /* 395690 */ // Label 7916: @395690
     /* 395690 */ GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(395713), // Rule ID 5970 //
     /* 395695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395706 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 395706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 395711 */   GIR_RootConstrainSelectedInstOperands,
     /* 395712 */   // GIR_Coverage, 5970,
     /* 395712 */   GIR_Done,
     /* 395713 */ // Label 7921: @395713
     /* 395713 */ GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(395736), // Rule ID 5971 //
     /* 395718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395729 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 395729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 395734 */   GIR_RootConstrainSelectedInstOperands,
     /* 395735 */   // GIR_Coverage, 5971,
     /* 395735 */   GIR_Done,
     /* 395736 */ // Label 7922: @395736
     /* 395736 */ GIM_Reject,
     /* 395737 */ // Label 7917: @395737
     /* 395737 */ GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(395760), // Rule ID 5972 //
     /* 395742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395753 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 395753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 395758 */   GIR_RootConstrainSelectedInstOperands,
     /* 395759 */   // GIR_Coverage, 5972,
     /* 395759 */   GIR_Done,
     /* 395760 */ // Label 7923: @395760
     /* 395760 */ GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(395821), // Rule ID 5973 //
     /* 395765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395776 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 395776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 395783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395788 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395792 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395803 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 395810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395820 */   // GIR_Coverage, 5973,
     /* 395820 */   GIR_EraseRootFromParent_Done,
     /* 395821 */ // Label 7924: @395821
     /* 395821 */ GIM_Reject,
     /* 395822 */ // Label 7918: @395822
     /* 395822 */ GIM_Reject,
     /* 395823 */ // Label 120: @395823
     /* 395823 */ GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(395962),
     /* 395828 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 395831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 395835 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(395869), // Rule ID 257 //
     /* 395840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 395847 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 395847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 395850 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 395852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 395862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 395867 */     GIR_RootConstrainSelectedInstOperands,
     /* 395868 */     // GIR_Coverage, 257,
     /* 395868 */     GIR_EraseRootFromParent_Done,
     /* 395869 */   // Label 7926: @395869
     /* 395869 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(395903), // Rule ID 258 //
     /* 395874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 395881 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 395881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 395884 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 395886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 395896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 395901 */     GIR_RootConstrainSelectedInstOperands,
     /* 395902 */     // GIR_Coverage, 258,
     /* 395902 */     GIR_EraseRootFromParent_Done,
     /* 395903 */   // Label 7927: @395903
     /* 395903 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(395932), // Rule ID 273 //
     /* 395908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 395915 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 395915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 395918 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 395920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 395930 */     GIR_RootConstrainSelectedInstOperands,
     /* 395931 */     // GIR_Coverage, 273,
     /* 395931 */     GIR_EraseRootFromParent_Done,
     /* 395932 */   // Label 7928: @395932
     /* 395932 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(395961), // Rule ID 294 //
     /* 395937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 395944 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 395944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 395947 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 395949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 395959 */     GIR_RootConstrainSelectedInstOperands,
     /* 395960 */     // GIR_Coverage, 294,
     /* 395960 */     GIR_EraseRootFromParent_Done,
     /* 395961 */   // Label 7929: @395961
     /* 395961 */   GIM_Reject,
     /* 395962 */ // Label 7925: @395962
     /* 395962 */ GIM_Reject,
     /* 395963 */ // Label 121: @395963
     /* 395963 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7942*/ GIMT_Encode4(396502),
     /* 395974 */ /*GILLT_s64*//*Label 7930*/ GIMT_Encode4(396058), GIMT_Encode4(0),
     /* 395982 */ /*GILLT_v2s32*//*Label 7931*/ GIMT_Encode4(396096),
     /* 395986 */ /*GILLT_v2s64*//*Label 7932*/ GIMT_Encode4(396134),
     /* 395990 */ /*GILLT_v4s16*//*Label 7933*/ GIMT_Encode4(396172),
     /* 395994 */ /*GILLT_v4s32*//*Label 7934*/ GIMT_Encode4(396210),
     /* 395998 */ /*GILLT_v8s8*//*Label 7935*/ GIMT_Encode4(396248),
     /* 396002 */ /*GILLT_v8s16*//*Label 7936*/ GIMT_Encode4(396286),
     /* 396006 */ /*GILLT_v16s8*//*Label 7937*/ GIMT_Encode4(396324), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396026 */ /*GILLT_nxv2s64*//*Label 7938*/ GIMT_Encode4(396362), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 396038 */ /*GILLT_nxv4s32*//*Label 7939*/ GIMT_Encode4(396397), GIMT_Encode4(0),
     /* 396046 */ /*GILLT_nxv8s16*//*Label 7940*/ GIMT_Encode4(396432), GIMT_Encode4(0),
     /* 396054 */ /*GILLT_nxv16s8*//*Label 7941*/ GIMT_Encode4(396467),
     /* 396058 */ // Label 7930: @396058
     /* 396058 */ GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(396095), // Rule ID 5069 //
     /* 396063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396069 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 396072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396088 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 396088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 396093 */   GIR_RootConstrainSelectedInstOperands,
     /* 396094 */   // GIR_Coverage, 5069,
     /* 396094 */   GIR_Done,
     /* 396095 */ // Label 7943: @396095
     /* 396095 */ GIM_Reject,
     /* 396096 */ // Label 7931: @396096
     /* 396096 */ GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(396133), // Rule ID 5068 //
     /* 396101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 396107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 396110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396122 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396126 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 396126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 396131 */   GIR_RootConstrainSelectedInstOperands,
     /* 396132 */   // GIR_Coverage, 5068,
     /* 396132 */   GIR_Done,
     /* 396133 */ // Label 7944: @396133
     /* 396133 */ GIM_Reject,
     /* 396134 */ // Label 7932: @396134
     /* 396134 */ GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(396171), // Rule ID 5073 //
     /* 396139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 396145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 396148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396160 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396164 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 396164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 396169 */   GIR_RootConstrainSelectedInstOperands,
     /* 396170 */   // GIR_Coverage, 5073,
     /* 396170 */   GIR_Done,
     /* 396171 */ // Label 7945: @396171
     /* 396171 */ GIM_Reject,
     /* 396172 */ // Label 7933: @396172
     /* 396172 */ GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(396209), // Rule ID 5067 //
     /* 396177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396183 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 396186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396198 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396202 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 396202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 396207 */   GIR_RootConstrainSelectedInstOperands,
     /* 396208 */   // GIR_Coverage, 5067,
     /* 396208 */   GIR_Done,
     /* 396209 */ // Label 7946: @396209
     /* 396209 */ GIM_Reject,
     /* 396210 */ // Label 7934: @396210
     /* 396210 */ GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(396247), // Rule ID 5072 //
     /* 396215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 396221 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 396224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396236 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396240 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 396240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 396245 */   GIR_RootConstrainSelectedInstOperands,
     /* 396246 */   // GIR_Coverage, 5072,
     /* 396246 */   GIR_Done,
     /* 396247 */ // Label 7947: @396247
     /* 396247 */ GIM_Reject,
     /* 396248 */ // Label 7935: @396248
     /* 396248 */ GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(396285), // Rule ID 5066 //
     /* 396253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 396256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 396259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 396262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396274 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396278 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 396278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 396283 */   GIR_RootConstrainSelectedInstOperands,
     /* 396284 */   // GIR_Coverage, 5066,
     /* 396284 */   GIR_Done,
     /* 396285 */ // Label 7948: @396285
     /* 396285 */ GIM_Reject,
     /* 396286 */ // Label 7936: @396286
     /* 396286 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(396323), // Rule ID 5071 //
     /* 396291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 396300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396312 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396316 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 396316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 396321 */   GIR_RootConstrainSelectedInstOperands,
     /* 396322 */   // GIR_Coverage, 5071,
     /* 396322 */   GIR_Done,
     /* 396323 */ // Label 7949: @396323
     /* 396323 */ GIM_Reject,
     /* 396324 */ // Label 7937: @396324
     /* 396324 */ GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(396361), // Rule ID 5070 //
     /* 396329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 396332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 396335 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 396338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396350 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396354 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 396354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 396359 */   GIR_RootConstrainSelectedInstOperands,
     /* 396360 */   // GIR_Coverage, 5070,
     /* 396360 */   GIR_Done,
     /* 396361 */ // Label 7950: @396361
     /* 396361 */ GIM_Reject,
     /* 396362 */ // Label 7938: @396362
     /* 396362 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(396396), // Rule ID 11858 //
     /* 396367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 396370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 396373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 396376 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 396379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396383 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 396383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 396386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 396388 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 396390 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 396392 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 396394 */   GIR_RootConstrainSelectedInstOperands,
     /* 396395 */   // GIR_Coverage, 11858,
     /* 396395 */   GIR_EraseRootFromParent_Done,
     /* 396396 */ // Label 7951: @396396
     /* 396396 */ GIM_Reject,
     /* 396397 */ // Label 7939: @396397
     /* 396397 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(396431), // Rule ID 11856 //
     /* 396402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 396405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 396408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 396411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 396414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396418 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 396418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 396421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 396423 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 396425 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 396427 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 396429 */   GIR_RootConstrainSelectedInstOperands,
     /* 396430 */   // GIR_Coverage, 11856,
     /* 396430 */   GIR_EraseRootFromParent_Done,
     /* 396431 */ // Label 7952: @396431
     /* 396431 */ GIM_Reject,
     /* 396432 */ // Label 7940: @396432
     /* 396432 */ GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(396466), // Rule ID 11854 //
     /* 396437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 396440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 396443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 396446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 396449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396453 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 396453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 396456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 396458 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 396460 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 396462 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 396464 */   GIR_RootConstrainSelectedInstOperands,
     /* 396465 */   // GIR_Coverage, 11854,
     /* 396465 */   GIR_EraseRootFromParent_Done,
     /* 396466 */ // Label 7953: @396466
     /* 396466 */ GIM_Reject,
     /* 396467 */ // Label 7941: @396467
     /* 396467 */ GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(396501), // Rule ID 11852 //
     /* 396472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 396475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 396478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 396481 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 396484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396488 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 396488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 396491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 396493 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 396495 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 396497 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 396499 */   GIR_RootConstrainSelectedInstOperands,
     /* 396500 */   // GIR_Coverage, 11852,
     /* 396500 */   GIR_EraseRootFromParent_Done,
     /* 396501 */ // Label 7954: @396501
     /* 396501 */ GIM_Reject,
     /* 396502 */ // Label 7942: @396502
     /* 396502 */ GIM_Reject,
     /* 396503 */ // Label 122: @396503
     /* 396503 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7963*/ GIMT_Encode4(398325),
     /* 396514 */ /*GILLT_s64*//*Label 7955*/ GIMT_Encode4(396550), GIMT_Encode4(0),
     /* 396522 */ /*GILLT_v2s32*//*Label 7956*/ GIMT_Encode4(396745),
     /* 396526 */ /*GILLT_v2s64*//*Label 7957*/ GIMT_Encode4(396992),
     /* 396530 */ /*GILLT_v4s16*//*Label 7958*/ GIMT_Encode4(397239),
     /* 396534 */ /*GILLT_v4s32*//*Label 7959*/ GIMT_Encode4(397515),
     /* 396538 */ /*GILLT_v8s8*//*Label 7960*/ GIMT_Encode4(397762),
     /* 396542 */ /*GILLT_v8s16*//*Label 7961*/ GIMT_Encode4(397907),
     /* 396546 */ /*GILLT_v16s8*//*Label 7962*/ GIMT_Encode4(398183),
     /* 396550 */ // Label 7955: @396550
     /* 396550 */ GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(396744),
     /* 396555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396562 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(396609), // Rule ID 6413 //
     /* 396567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396575 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396578 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396582 */     // MIs[1] Rn
     /* 396582 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396593 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 396596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396607 */     GIR_RootConstrainSelectedInstOperands,
     /* 396608 */     // GIR_Coverage, 6413,
     /* 396608 */     GIR_EraseRootFromParent_Done,
     /* 396609 */   // Label 7965: @396609
     /* 396609 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(396656), // Rule ID 6424 //
     /* 396614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396622 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396629 */     // MIs[1] Rn
     /* 396629 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396640 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 396643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396654 */     GIR_RootConstrainSelectedInstOperands,
     /* 396655 */     // GIR_Coverage, 6424,
     /* 396655 */     GIR_EraseRootFromParent_Done,
     /* 396656 */   // Label 7966: @396656
     /* 396656 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(396703), // Rule ID 13182 //
     /* 396661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396669 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396672 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396676 */     // MIs[1] Rn
     /* 396676 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396687 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 396690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396701 */     GIR_RootConstrainSelectedInstOperands,
     /* 396702 */     // GIR_Coverage, 13182,
     /* 396702 */     GIR_EraseRootFromParent_Done,
     /* 396703 */   // Label 7967: @396703
     /* 396703 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(396723), // Rule ID 5632 //
     /* 396708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 396712 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 396712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396722 */     // GIR_Coverage, 5632,
     /* 396722 */     GIR_Done,
     /* 396723 */   // Label 7968: @396723
     /* 396723 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(396743), // Rule ID 5633 //
     /* 396728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396732 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 396732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396742 */     // GIR_Coverage, 5633,
     /* 396742 */     GIR_Done,
     /* 396743 */   // Label 7969: @396743
     /* 396743 */   GIM_Reject,
     /* 396744 */ // Label 7964: @396744
     /* 396744 */ GIM_Reject,
     /* 396745 */ // Label 7956: @396745
     /* 396745 */ GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(396991),
     /* 396750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396757 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(396804), // Rule ID 6410 //
     /* 396762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396770 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396777 */     // MIs[1] Rn
     /* 396777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396788 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 396791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396802 */     GIR_RootConstrainSelectedInstOperands,
     /* 396803 */     // GIR_Coverage, 6410,
     /* 396803 */     GIR_EraseRootFromParent_Done,
     /* 396804 */   // Label 7971: @396804
     /* 396804 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(396851), // Rule ID 6421 //
     /* 396809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396817 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396820 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396824 */     // MIs[1] Rn
     /* 396824 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396835 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 396838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396849 */     GIR_RootConstrainSelectedInstOperands,
     /* 396850 */     // GIR_Coverage, 6421,
     /* 396850 */     GIR_EraseRootFromParent_Done,
     /* 396851 */   // Label 7972: @396851
     /* 396851 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(396898), // Rule ID 13179 //
     /* 396856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396871 */     // MIs[1] Rn
     /* 396871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396882 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 396885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396896 */     GIR_RootConstrainSelectedInstOperands,
     /* 396897 */     // GIR_Coverage, 13179,
     /* 396897 */     GIR_EraseRootFromParent_Done,
     /* 396898 */   // Label 7973: @396898
     /* 396898 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(396917), // Rule ID 1916 //
     /* 396903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396910 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 396910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 396915 */     GIR_RootConstrainSelectedInstOperands,
     /* 396916 */     // GIR_Coverage, 1916,
     /* 396916 */     GIR_Done,
     /* 396917 */   // Label 7974: @396917
     /* 396917 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(396990), // Rule ID 5634 //
     /* 396922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396926 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396926 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 396929 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396933 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 396943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 396962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 396980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396988 */     GIR_RootConstrainSelectedInstOperands,
     /* 396989 */     // GIR_Coverage, 5634,
     /* 396989 */     GIR_EraseRootFromParent_Done,
     /* 396990 */   // Label 7975: @396990
     /* 396990 */   GIM_Reject,
     /* 396991 */ // Label 7970: @396991
     /* 396991 */ GIM_Reject,
     /* 396992 */ // Label 7957: @396992
     /* 396992 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(397238),
     /* 396997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397004 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(397051), // Rule ID 6412 //
     /* 397009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397024 */     // MIs[1] Rn
     /* 397024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397035 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 397038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397049 */     GIR_RootConstrainSelectedInstOperands,
     /* 397050 */     // GIR_Coverage, 6412,
     /* 397050 */     GIR_EraseRootFromParent_Done,
     /* 397051 */   // Label 7977: @397051
     /* 397051 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(397098), // Rule ID 6423 //
     /* 397056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397064 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397071 */     // MIs[1] Rn
     /* 397071 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397082 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 397085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397096 */     GIR_RootConstrainSelectedInstOperands,
     /* 397097 */     // GIR_Coverage, 6423,
     /* 397097 */     GIR_EraseRootFromParent_Done,
     /* 397098 */   // Label 7978: @397098
     /* 397098 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(397145), // Rule ID 13181 //
     /* 397103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397118 */     // MIs[1] Rn
     /* 397118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397129 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 397132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397143 */     GIR_RootConstrainSelectedInstOperands,
     /* 397144 */     // GIR_Coverage, 13181,
     /* 397144 */     GIR_EraseRootFromParent_Done,
     /* 397145 */   // Label 7979: @397145
     /* 397145 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(397164), // Rule ID 1918 //
     /* 397150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 397157 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 397157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 397162 */     GIR_RootConstrainSelectedInstOperands,
     /* 397163 */     // GIR_Coverage, 1918,
     /* 397163 */     GIR_Done,
     /* 397164 */   // Label 7980: @397164
     /* 397164 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(397237), // Rule ID 5636 //
     /* 397169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397173 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 397176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 397190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 397209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 397227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397235 */     GIR_RootConstrainSelectedInstOperands,
     /* 397236 */     // GIR_Coverage, 5636,
     /* 397236 */     GIR_EraseRootFromParent_Done,
     /* 397237 */   // Label 7981: @397237
     /* 397237 */   GIM_Reject,
     /* 397238 */ // Label 7976: @397238
     /* 397238 */ GIM_Reject,
     /* 397239 */ // Label 7958: @397239
     /* 397239 */ GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(397300), // Rule ID 6408 //
     /* 397244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397251 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397259 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397262 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397266 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 397273 */   // MIs[1] Rn
     /* 397273 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397277 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397284 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 397287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397289 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397298 */   GIR_RootConstrainSelectedInstOperands,
     /* 397299 */   // GIR_Coverage, 6408,
     /* 397299 */   GIR_EraseRootFromParent_Done,
     /* 397300 */ // Label 7982: @397300
     /* 397300 */ GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(397354), // Rule ID 6425 //
     /* 397305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397312 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397320 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397323 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397327 */   // MIs[1] Rn
     /* 397327 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397331 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397336 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397338 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 397341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397343 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397352 */   GIR_RootConstrainSelectedInstOperands,
     /* 397353 */   // GIR_Coverage, 6425,
     /* 397353 */   GIR_EraseRootFromParent_Done,
     /* 397354 */ // Label 7983: @397354
     /* 397354 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(397408), // Rule ID 13177 //
     /* 397359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397374 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397377 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397381 */   // MIs[1] Rn
     /* 397381 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397385 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397390 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397392 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 397395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397397 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397401 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397406 */   GIR_RootConstrainSelectedInstOperands,
     /* 397407 */   // GIR_Coverage, 13177,
     /* 397407 */   GIR_EraseRootFromParent_Done,
     /* 397408 */ // Label 7984: @397408
     /* 397408 */ GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(397434), // Rule ID 1914 //
     /* 397413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397427 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 397427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 397432 */   GIR_RootConstrainSelectedInstOperands,
     /* 397433 */   // GIR_Coverage, 1914,
     /* 397433 */   GIR_Done,
     /* 397434 */ // Label 7985: @397434
     /* 397434 */ GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(397514), // Rule ID 5637 //
     /* 397439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397450 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397450 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 397453 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397457 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 397467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397476 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397479 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397483 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 397486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397491 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397496 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 397504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397506 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397512 */   GIR_RootConstrainSelectedInstOperands,
     /* 397513 */   // GIR_Coverage, 5637,
     /* 397513 */   GIR_EraseRootFromParent_Done,
     /* 397514 */ // Label 7986: @397514
     /* 397514 */ GIM_Reject,
     /* 397515 */ // Label 7959: @397515
     /* 397515 */ GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(397761),
     /* 397520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397527 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(397574), // Rule ID 6411 //
     /* 397532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397540 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397543 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397547 */     // MIs[1] Rn
     /* 397547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397558 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 397561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397572 */     GIR_RootConstrainSelectedInstOperands,
     /* 397573 */     // GIR_Coverage, 6411,
     /* 397573 */     GIR_EraseRootFromParent_Done,
     /* 397574 */   // Label 7988: @397574
     /* 397574 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(397621), // Rule ID 6422 //
     /* 397579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397587 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397590 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397594 */     // MIs[1] Rn
     /* 397594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397605 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 397608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397619 */     GIR_RootConstrainSelectedInstOperands,
     /* 397620 */     // GIR_Coverage, 6422,
     /* 397620 */     GIR_EraseRootFromParent_Done,
     /* 397621 */   // Label 7989: @397621
     /* 397621 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(397668), // Rule ID 13180 //
     /* 397626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397634 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397641 */     // MIs[1] Rn
     /* 397641 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397652 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 397655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397666 */     GIR_RootConstrainSelectedInstOperands,
     /* 397667 */     // GIR_Coverage, 13180,
     /* 397667 */     GIR_EraseRootFromParent_Done,
     /* 397668 */   // Label 7990: @397668
     /* 397668 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(397687), // Rule ID 1917 //
     /* 397673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397680 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 397680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 397685 */     GIR_RootConstrainSelectedInstOperands,
     /* 397686 */     // GIR_Coverage, 1917,
     /* 397686 */     GIR_Done,
     /* 397687 */   // Label 7991: @397687
     /* 397687 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(397760), // Rule ID 5635 //
     /* 397692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397696 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397696 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 397699 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397703 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 397713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397722 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397725 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397729 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 397732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 397750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397758 */     GIR_RootConstrainSelectedInstOperands,
     /* 397759 */     // GIR_Coverage, 5635,
     /* 397759 */     GIR_EraseRootFromParent_Done,
     /* 397760 */   // Label 7992: @397760
     /* 397760 */   GIM_Reject,
     /* 397761 */ // Label 7987: @397761
     /* 397761 */ GIM_Reject,
     /* 397762 */ // Label 7960: @397762
     /* 397762 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(397819), // Rule ID 13175 //
     /* 397767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 397770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397774 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397782 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397789 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 397793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397795 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 397802 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 397805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397812 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397817 */   GIR_RootConstrainSelectedInstOperands,
     /* 397818 */   // GIR_Coverage, 13175,
     /* 397818 */   GIR_EraseRootFromParent_Done,
     /* 397819 */ // Label 7993: @397819
     /* 397819 */ GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(397880), // Rule ID 6406 //
     /* 397824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397839 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397842 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397846 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 397853 */   // MIs[1] Rn
     /* 397853 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397857 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397864 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 397867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397869 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397878 */   GIR_RootConstrainSelectedInstOperands,
     /* 397879 */   // GIR_Coverage, 6406,
     /* 397879 */   GIR_EraseRootFromParent_Done,
     /* 397880 */ // Label 7994: @397880
     /* 397880 */ GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(397906), // Rule ID 1912 //
     /* 397885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397899 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 397899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 397904 */   GIR_RootConstrainSelectedInstOperands,
     /* 397905 */   // GIR_Coverage, 1912,
     /* 397905 */   GIR_Done,
     /* 397906 */ // Label 7995: @397906
     /* 397906 */ GIM_Reject,
     /* 397907 */ // Label 7961: @397907
     /* 397907 */ GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(397968), // Rule ID 6409 //
     /* 397912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397927 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397930 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397934 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 397941 */   // MIs[1] Rn
     /* 397941 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397945 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397950 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397952 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 397955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397957 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397966 */   GIR_RootConstrainSelectedInstOperands,
     /* 397967 */   // GIR_Coverage, 6409,
     /* 397967 */   GIR_EraseRootFromParent_Done,
     /* 397968 */ // Label 7996: @397968
     /* 397968 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(398022), // Rule ID 6426 //
     /* 397973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397988 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397995 */   // MIs[1] Rn
     /* 397995 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397999 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398006 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 398009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398011 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398020 */   GIR_RootConstrainSelectedInstOperands,
     /* 398021 */   // GIR_Coverage, 6426,
     /* 398021 */   GIR_EraseRootFromParent_Done,
     /* 398022 */ // Label 7997: @398022
     /* 398022 */ GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(398076), // Rule ID 13178 //
     /* 398027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 398030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398042 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398045 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398049 */   // MIs[1] Rn
     /* 398049 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398053 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398058 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398060 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 398063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398065 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398074 */   GIR_RootConstrainSelectedInstOperands,
     /* 398075 */   // GIR_Coverage, 13178,
     /* 398075 */   GIR_EraseRootFromParent_Done,
     /* 398076 */ // Label 7998: @398076
     /* 398076 */ GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(398102), // Rule ID 1915 //
     /* 398081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 398087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 398095 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 398095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 398100 */   GIR_RootConstrainSelectedInstOperands,
     /* 398101 */   // GIR_Coverage, 1915,
     /* 398101 */   GIR_Done,
     /* 398102 */ // Label 7999: @398102
     /* 398102 */ GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(398182), // Rule ID 5638 //
     /* 398107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 398110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398118 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398118 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 398121 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398125 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 398135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398144 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398147 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398151 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 398154 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398164 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 398169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 398172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398180 */   GIR_RootConstrainSelectedInstOperands,
     /* 398181 */   // GIR_Coverage, 5638,
     /* 398181 */   GIR_EraseRootFromParent_Done,
     /* 398182 */ // Label 8000: @398182
     /* 398182 */ GIM_Reject,
     /* 398183 */ // Label 7962: @398183
     /* 398183 */ GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(398244), // Rule ID 6407 //
     /* 398188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 398191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398203 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398206 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398210 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 398217 */   // MIs[1] Rn
     /* 398217 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398221 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398226 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398228 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 398231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398242 */   GIR_RootConstrainSelectedInstOperands,
     /* 398243 */   // GIR_Coverage, 6407,
     /* 398243 */   GIR_EraseRootFromParent_Done,
     /* 398244 */ // Label 8001: @398244
     /* 398244 */ GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(398298), // Rule ID 13176 //
     /* 398249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 398252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398256 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398264 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398267 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398271 */   // MIs[1] Rn
     /* 398271 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398275 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398280 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398282 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 398285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398287 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398296 */   GIR_RootConstrainSelectedInstOperands,
     /* 398297 */   // GIR_Coverage, 13176,
     /* 398297 */   GIR_EraseRootFromParent_Done,
     /* 398298 */ // Label 8002: @398298
     /* 398298 */ GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(398324), // Rule ID 1913 //
     /* 398303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 398309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 398317 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 398317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 398322 */   GIR_RootConstrainSelectedInstOperands,
     /* 398323 */   // GIR_Coverage, 1913,
     /* 398323 */   GIR_Done,
     /* 398324 */ // Label 8003: @398324
     /* 398324 */ GIM_Reject,
     /* 398325 */ // Label 7963: @398325
     /* 398325 */ GIM_Reject,
     /* 398326 */ // Label 123: @398326
     /* 398326 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8006*/ GIMT_Encode4(398580),
     /* 398337 */ /*GILLT_v4s16*//*Label 8004*/ GIMT_Encode4(398353), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 398349 */ /*GILLT_v8s16*//*Label 8005*/ GIMT_Encode4(398439),
     /* 398353 */ // Label 8004: @398353
     /* 398353 */ GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(398438),
     /* 398358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398372 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(398406), // Rule ID 1922 //
     /* 398377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398392 */     // MIs[1] Operand 1
     /* 398392 */     // No operand predicates
     /* 398392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398394 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 398397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398404 */     GIR_RootConstrainSelectedInstOperands,
     /* 398405 */     // GIR_Coverage, 1922,
     /* 398405 */     GIR_EraseRootFromParent_Done,
     /* 398406 */   // Label 8008: @398406
     /* 398406 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(398437), // Rule ID 5639 //
     /* 398411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398423 */     // MIs[1] Operand 1
     /* 398423 */     // No operand predicates
     /* 398423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398425 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 398425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 398428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398435 */     GIR_RootConstrainSelectedInstOperands,
     /* 398436 */     // GIR_Coverage, 5639,
     /* 398436 */     GIR_EraseRootFromParent_Done,
     /* 398437 */   // Label 8009: @398437
     /* 398437 */   GIM_Reject,
     /* 398438 */ // Label 8007: @398438
     /* 398438 */ GIM_Reject,
     /* 398439 */ // Label 8005: @398439
     /* 398439 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(398579),
     /* 398444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398454 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(398505), // Rule ID 6417 //
     /* 398459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398467 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398470 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398474 */     // MIs[1] Rn
     /* 398474 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 398487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398489 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 398492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398503 */     GIR_RootConstrainSelectedInstOperands,
     /* 398504 */     // GIR_Coverage, 6417,
     /* 398504 */     GIR_EraseRootFromParent_Done,
     /* 398505 */   // Label 8011: @398505
     /* 398505 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(398543), // Rule ID 1923 //
     /* 398510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398529 */     // MIs[1] Operand 1
     /* 398529 */     // No operand predicates
     /* 398529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398531 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 398534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398541 */     GIR_RootConstrainSelectedInstOperands,
     /* 398542 */     // GIR_Coverage, 1923,
     /* 398542 */     GIR_EraseRootFromParent_Done,
     /* 398543 */   // Label 8012: @398543
     /* 398543 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(398578), // Rule ID 5640 //
     /* 398548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398564 */     // MIs[1] Operand 1
     /* 398564 */     // No operand predicates
     /* 398564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398566 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 398566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 398569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398576 */     GIR_RootConstrainSelectedInstOperands,
     /* 398577 */     // GIR_Coverage, 5640,
     /* 398577 */     GIR_EraseRootFromParent_Done,
     /* 398578 */   // Label 8013: @398578
     /* 398578 */   GIM_Reject,
     /* 398579 */ // Label 8010: @398579
     /* 398579 */ GIM_Reject,
     /* 398580 */ // Label 8006: @398580
     /* 398580 */ GIM_Reject,
     /* 398581 */ // Label 124: @398581
     /* 398581 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8016*/ GIMT_Encode4(398835),
     /* 398592 */ /*GILLT_v2s32*//*Label 8014*/ GIMT_Encode4(398608), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 398604 */ /*GILLT_v4s32*//*Label 8015*/ GIMT_Encode4(398694),
     /* 398608 */ // Label 8014: @398608
     /* 398608 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(398693),
     /* 398613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398627 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(398661), // Rule ID 1920 //
     /* 398632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398647 */     // MIs[1] Operand 1
     /* 398647 */     // No operand predicates
     /* 398647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398649 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 398652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398659 */     GIR_RootConstrainSelectedInstOperands,
     /* 398660 */     // GIR_Coverage, 1920,
     /* 398660 */     GIR_EraseRootFromParent_Done,
     /* 398661 */   // Label 8018: @398661
     /* 398661 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(398692), // Rule ID 5641 //
     /* 398666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398678 */     // MIs[1] Operand 1
     /* 398678 */     // No operand predicates
     /* 398678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398680 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 398680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 398683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398690 */     GIR_RootConstrainSelectedInstOperands,
     /* 398691 */     // GIR_Coverage, 5641,
     /* 398691 */     GIR_EraseRootFromParent_Done,
     /* 398692 */   // Label 8019: @398692
     /* 398692 */   GIM_Reject,
     /* 398693 */ // Label 8017: @398693
     /* 398693 */ GIM_Reject,
     /* 398694 */ // Label 8015: @398694
     /* 398694 */ GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(398834),
     /* 398699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398709 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(398760), // Rule ID 6419 //
     /* 398714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398729 */     // MIs[1] Rn
     /* 398729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 398742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398744 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 398747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398758 */     GIR_RootConstrainSelectedInstOperands,
     /* 398759 */     // GIR_Coverage, 6419,
     /* 398759 */     GIR_EraseRootFromParent_Done,
     /* 398760 */   // Label 8021: @398760
     /* 398760 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(398798), // Rule ID 1921 //
     /* 398765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398784 */     // MIs[1] Operand 1
     /* 398784 */     // No operand predicates
     /* 398784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398786 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 398789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398796 */     GIR_RootConstrainSelectedInstOperands,
     /* 398797 */     // GIR_Coverage, 1921,
     /* 398797 */     GIR_EraseRootFromParent_Done,
     /* 398798 */   // Label 8022: @398798
     /* 398798 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(398833), // Rule ID 5642 //
     /* 398803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398819 */     // MIs[1] Operand 1
     /* 398819 */     // No operand predicates
     /* 398819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398821 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 398821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 398824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398831 */     GIR_RootConstrainSelectedInstOperands,
     /* 398832 */     // GIR_Coverage, 5642,
     /* 398832 */     GIR_EraseRootFromParent_Done,
     /* 398833 */   // Label 8023: @398833
     /* 398833 */   GIM_Reject,
     /* 398834 */ // Label 8020: @398834
     /* 398834 */ GIM_Reject,
     /* 398835 */ // Label 8016: @398835
     /* 398835 */ GIM_Reject,
     /* 398836 */ // Label 125: @398836
     /* 398836 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(398981),
     /* 398841 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 398844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398854 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(398905), // Rule ID 6420 //
     /* 398859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398867 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398870 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398874 */     // MIs[1] Rn
     /* 398874 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 398887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398889 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 398892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398903 */     GIR_RootConstrainSelectedInstOperands,
     /* 398904 */     // GIR_Coverage, 6420,
     /* 398904 */     GIR_EraseRootFromParent_Done,
     /* 398905 */   // Label 8025: @398905
     /* 398905 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(398980),
     /* 398910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398914 */     GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(398948), // Rule ID 1919 //
     /* 398919 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398922 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398926 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398930 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398934 */       // MIs[1] Operand 1
     /* 398934 */       // No operand predicates
     /* 398934 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398936 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398936 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 398939 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398941 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398943 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398946 */       GIR_RootConstrainSelectedInstOperands,
     /* 398947 */       // GIR_Coverage, 1919,
     /* 398947 */       GIR_EraseRootFromParent_Done,
     /* 398948 */     // Label 8027: @398948
     /* 398948 */     GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(398979), // Rule ID 5643 //
     /* 398953 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398957 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398961 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398965 */       // MIs[1] Operand 1
     /* 398965 */       // No operand predicates
     /* 398965 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398967 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 398967 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 398970 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398972 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398974 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398977 */       GIR_RootConstrainSelectedInstOperands,
     /* 398978 */       // GIR_Coverage, 5643,
     /* 398978 */       GIR_EraseRootFromParent_Done,
     /* 398979 */     // Label 8028: @398979
     /* 398979 */     GIM_Reject,
     /* 398980 */   // Label 8026: @398980
     /* 398980 */   GIM_Reject,
     /* 398981 */ // Label 8024: @398981
     /* 398981 */ GIM_Reject,
     /* 398982 */ // Label 126: @398982
     /* 398982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8031*/ GIMT_Encode4(399160),
     /* 398993 */ /*GILLT_v8s8*//*Label 8029*/ GIMT_Encode4(399005), GIMT_Encode4(0),
     /* 399001 */ /*GILLT_v16s8*//*Label 8030*/ GIMT_Encode4(399054),
     /* 399005 */ // Label 8029: @399005
     /* 399005 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(399053), // Rule ID 1924 //
     /* 399010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399027 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399035 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 399039 */   // MIs[1] Operand 1
     /* 399039 */   // No operand predicates
     /* 399039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399041 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 399041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 399044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399046 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399048 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 399051 */   GIR_RootConstrainSelectedInstOperands,
     /* 399052 */   // GIR_Coverage, 1924,
     /* 399052 */   GIR_EraseRootFromParent_Done,
     /* 399053 */ // Label 8032: @399053
     /* 399053 */ GIM_Reject,
     /* 399054 */ // Label 8030: @399054
     /* 399054 */ GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(399159),
     /* 399059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399069 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(399120), // Rule ID 6415 //
     /* 399074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 399082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 399085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 399089 */     // MIs[1] Rn
     /* 399089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 399093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 399098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 399102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399104 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 399104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 399107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 399109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 399118 */     GIR_RootConstrainSelectedInstOperands,
     /* 399119 */     // GIR_Coverage, 6415,
     /* 399119 */     GIR_EraseRootFromParent_Done,
     /* 399120 */   // Label 8034: @399120
     /* 399120 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(399158), // Rule ID 1925 //
     /* 399125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 399144 */     // MIs[1] Operand 1
     /* 399144 */     // No operand predicates
     /* 399144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399146 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 399146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 399149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 399156 */     GIR_RootConstrainSelectedInstOperands,
     /* 399157 */     // GIR_Coverage, 1925,
     /* 399157 */     GIR_EraseRootFromParent_Done,
     /* 399158 */   // Label 8035: @399158
     /* 399158 */   GIM_Reject,
     /* 399159 */ // Label 8033: @399159
     /* 399159 */ GIM_Reject,
     /* 399160 */ // Label 8031: @399160
     /* 399160 */ GIM_Reject,
     /* 399161 */ // Label 127: @399161
     /* 399161 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8045*/ GIMT_Encode4(400810),
     /* 399172 */ /*GILLT_s64*//*Label 8036*/ GIMT_Encode4(399256), GIMT_Encode4(0),
     /* 399180 */ /*GILLT_v2s32*//*Label 8037*/ GIMT_Encode4(399577),
     /* 399184 */ /*GILLT_v2s64*//*Label 8038*/ GIMT_Encode4(399898),
     /* 399188 */ /*GILLT_v4s16*//*Label 8039*/ GIMT_Encode4(399981),
     /* 399192 */ /*GILLT_v4s32*//*Label 8040*/ GIMT_Encode4(400302),
     /* 399196 */ /*GILLT_v8s8*//*Label 8041*/ GIMT_Encode4(400385),
     /* 399200 */ /*GILLT_v8s16*//*Label 8042*/ GIMT_Encode4(400594),
     /* 399204 */ /*GILLT_v16s8*//*Label 8043*/ GIMT_Encode4(400677), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399252 */ /*GILLT_nxv16s8*//*Label 8044*/ GIMT_Encode4(400763),
     /* 399256 */ // Label 8036: @399256
     /* 399256 */ GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(399576),
     /* 399261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399271 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(399386), // Rule ID 5460 //
     /* 399276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399293 */     // MIs[1] Operand 2
     /* 399293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399312 */     // MIs[2] Rn
     /* 399312 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399317 */     // MIs[2] Operand 2
     /* 399317 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 399328 */     // MIs[0] imm
     /* 399328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399336 */     // MIs[3] Operand 1
     /* 399336 */     // No operand predicates
     /* 399336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399338 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399368 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399385 */     // GIR_Coverage, 5460,
     /* 399385 */     GIR_EraseRootFromParent_Done,
     /* 399386 */   // Label 8047: @399386
     /* 399386 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(399501), // Rule ID 5465 //
     /* 399391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399408 */     // MIs[1] Operand 2
     /* 399408 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399427 */     // MIs[2] Rn
     /* 399427 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399432 */     // MIs[2] Operand 2
     /* 399432 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 399443 */     // MIs[0] imm
     /* 399443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399451 */     // MIs[3] Operand 1
     /* 399451 */     // No operand predicates
     /* 399451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399453 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399483 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399500 */     // GIR_Coverage, 5465,
     /* 399500 */     GIR_EraseRootFromParent_Done,
     /* 399501 */   // Label 8048: @399501
     /* 399501 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(399538), // Rule ID 5457 //
     /* 399506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399514 */     // MIs[0] imm
     /* 399514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399522 */     // MIs[1] Operand 1
     /* 399522 */     // No operand predicates
     /* 399522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399524 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399536 */     GIR_RootConstrainSelectedInstOperands,
     /* 399537 */     // GIR_Coverage, 5457,
     /* 399537 */     GIR_EraseRootFromParent_Done,
     /* 399538 */   // Label 8049: @399538
     /* 399538 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(399575), // Rule ID 5462 //
     /* 399543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399551 */     // MIs[0] imm
     /* 399551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399559 */     // MIs[1] Operand 1
     /* 399559 */     // No operand predicates
     /* 399559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399561 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399573 */     GIR_RootConstrainSelectedInstOperands,
     /* 399574 */     // GIR_Coverage, 5462,
     /* 399574 */     GIR_EraseRootFromParent_Done,
     /* 399575 */   // Label 8050: @399575
     /* 399575 */   GIM_Reject,
     /* 399576 */ // Label 8046: @399576
     /* 399576 */ GIM_Reject,
     /* 399577 */ // Label 8037: @399577
     /* 399577 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(399897),
     /* 399582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399592 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(399707), // Rule ID 5450 //
     /* 399597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399614 */     // MIs[1] Operand 2
     /* 399614 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399633 */     // MIs[2] Rn
     /* 399633 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399638 */     // MIs[2] Operand 2
     /* 399638 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 399649 */     // MIs[0] imm
     /* 399649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399657 */     // MIs[3] Operand 1
     /* 399657 */     // No operand predicates
     /* 399657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399659 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399706 */     // GIR_Coverage, 5450,
     /* 399706 */     GIR_EraseRootFromParent_Done,
     /* 399707 */   // Label 8052: @399707
     /* 399707 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(399822), // Rule ID 5455 //
     /* 399712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399729 */     // MIs[1] Operand 2
     /* 399729 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399748 */     // MIs[2] Rn
     /* 399748 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399753 */     // MIs[2] Operand 2
     /* 399753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 399764 */     // MIs[0] imm
     /* 399764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399772 */     // MIs[3] Operand 1
     /* 399772 */     // No operand predicates
     /* 399772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399774 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399790 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399804 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399821 */     // GIR_Coverage, 5455,
     /* 399821 */     GIR_EraseRootFromParent_Done,
     /* 399822 */   // Label 8053: @399822
     /* 399822 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(399859), // Rule ID 5447 //
     /* 399827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399835 */     // MIs[0] imm
     /* 399835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399843 */     // MIs[1] Operand 1
     /* 399843 */     // No operand predicates
     /* 399843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399845 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399857 */     GIR_RootConstrainSelectedInstOperands,
     /* 399858 */     // GIR_Coverage, 5447,
     /* 399858 */     GIR_EraseRootFromParent_Done,
     /* 399859 */   // Label 8054: @399859
     /* 399859 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(399896), // Rule ID 5452 //
     /* 399864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399872 */     // MIs[0] imm
     /* 399872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399880 */     // MIs[1] Operand 1
     /* 399880 */     // No operand predicates
     /* 399880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399882 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399894 */     GIR_RootConstrainSelectedInstOperands,
     /* 399895 */     // GIR_Coverage, 5452,
     /* 399895 */     GIR_EraseRootFromParent_Done,
     /* 399896 */   // Label 8055: @399896
     /* 399896 */   GIM_Reject,
     /* 399897 */ // Label 8051: @399897
     /* 399897 */ GIM_Reject,
     /* 399898 */ // Label 8038: @399898
     /* 399898 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(399980),
     /* 399903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399921 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(399950), // Rule ID 5458 //
     /* 399926 */     // MIs[0] imm
     /* 399926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399934 */     // MIs[1] Operand 1
     /* 399934 */     // No operand predicates
     /* 399934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399936 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399948 */     GIR_RootConstrainSelectedInstOperands,
     /* 399949 */     // GIR_Coverage, 5458,
     /* 399949 */     GIR_EraseRootFromParent_Done,
     /* 399950 */   // Label 8057: @399950
     /* 399950 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(399979), // Rule ID 5463 //
     /* 399955 */     // MIs[0] imm
     /* 399955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399963 */     // MIs[1] Operand 1
     /* 399963 */     // No operand predicates
     /* 399963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399965 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399977 */     GIR_RootConstrainSelectedInstOperands,
     /* 399978 */     // GIR_Coverage, 5463,
     /* 399978 */     GIR_EraseRootFromParent_Done,
     /* 399979 */   // Label 8058: @399979
     /* 399979 */   GIM_Reject,
     /* 399980 */ // Label 8056: @399980
     /* 399980 */ GIM_Reject,
     /* 399981 */ // Label 8039: @399981
     /* 399981 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(400301),
     /* 399986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399996 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(400111), // Rule ID 5440 //
     /* 400001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400018 */     // MIs[1] Operand 2
     /* 400018 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400037 */     // MIs[2] Rn
     /* 400037 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 400042 */     // MIs[2] Operand 2
     /* 400042 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 400053 */     // MIs[0] imm
     /* 400053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 400057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400061 */     // MIs[3] Operand 1
     /* 400061 */     // No operand predicates
     /* 400061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400063 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 400063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 400086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 400088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 400100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400110 */     // GIR_Coverage, 5440,
     /* 400110 */     GIR_EraseRootFromParent_Done,
     /* 400111 */   // Label 8060: @400111
     /* 400111 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(400226), // Rule ID 5445 //
     /* 400116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400133 */     // MIs[1] Operand 2
     /* 400133 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400152 */     // MIs[2] Rn
     /* 400152 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 400157 */     // MIs[2] Operand 2
     /* 400157 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 400168 */     // MIs[0] imm
     /* 400168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 400172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400176 */     // MIs[3] Operand 1
     /* 400176 */     // No operand predicates
     /* 400176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400178 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 400178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 400201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 400203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400208 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 400215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400225 */     // GIR_Coverage, 5445,
     /* 400225 */     GIR_EraseRootFromParent_Done,
     /* 400226 */   // Label 8061: @400226
     /* 400226 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(400263), // Rule ID 5437 //
     /* 400231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400239 */     // MIs[0] imm
     /* 400239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400247 */     // MIs[1] Operand 1
     /* 400247 */     // No operand predicates
     /* 400247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400249 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 400252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400261 */     GIR_RootConstrainSelectedInstOperands,
     /* 400262 */     // GIR_Coverage, 5437,
     /* 400262 */     GIR_EraseRootFromParent_Done,
     /* 400263 */   // Label 8062: @400263
     /* 400263 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(400300), // Rule ID 5442 //
     /* 400268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400276 */     // MIs[0] imm
     /* 400276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400284 */     // MIs[1] Operand 1
     /* 400284 */     // No operand predicates
     /* 400284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400286 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 400289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400298 */     GIR_RootConstrainSelectedInstOperands,
     /* 400299 */     // GIR_Coverage, 5442,
     /* 400299 */     GIR_EraseRootFromParent_Done,
     /* 400300 */   // Label 8063: @400300
     /* 400300 */   GIM_Reject,
     /* 400301 */ // Label 8059: @400301
     /* 400301 */ GIM_Reject,
     /* 400302 */ // Label 8040: @400302
     /* 400302 */ GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(400384),
     /* 400307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400325 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(400354), // Rule ID 5448 //
     /* 400330 */     // MIs[0] imm
     /* 400330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400338 */     // MIs[1] Operand 1
     /* 400338 */     // No operand predicates
     /* 400338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400340 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400352 */     GIR_RootConstrainSelectedInstOperands,
     /* 400353 */     // GIR_Coverage, 5448,
     /* 400353 */     GIR_EraseRootFromParent_Done,
     /* 400354 */   // Label 8065: @400354
     /* 400354 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(400383), // Rule ID 5453 //
     /* 400359 */     // MIs[0] imm
     /* 400359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400367 */     // MIs[1] Operand 1
     /* 400367 */     // No operand predicates
     /* 400367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400369 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400381 */     GIR_RootConstrainSelectedInstOperands,
     /* 400382 */     // GIR_Coverage, 5453,
     /* 400382 */     GIR_EraseRootFromParent_Done,
     /* 400383 */   // Label 8066: @400383
     /* 400383 */   GIM_Reject,
     /* 400384 */ // Label 8064: @400384
     /* 400384 */ GIM_Reject,
     /* 400385 */ // Label 8041: @400385
     /* 400385 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(400593),
     /* 400390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 400396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400400 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(400515), // Rule ID 5435 //
     /* 400405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400422 */     // MIs[1] Operand 2
     /* 400422 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400441 */     // MIs[2] Rn
     /* 400441 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 400446 */     // MIs[2] Operand 2
     /* 400446 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 400457 */     // MIs[0] imm
     /* 400457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 400461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400465 */     // MIs[3] Operand 1
     /* 400465 */     // No operand predicates
     /* 400465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400467 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 400467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400483 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 400490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 400492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400497 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 400504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400514 */     // GIR_Coverage, 5435,
     /* 400514 */     GIR_EraseRootFromParent_Done,
     /* 400515 */   // Label 8068: @400515
     /* 400515 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(400555), // Rule ID 1868 //
     /* 400520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400531 */     // MIs[0] imm
     /* 400531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400539 */     // MIs[1] Operand 1
     /* 400539 */     // No operand predicates
     /* 400539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400541 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 400544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400553 */     GIR_RootConstrainSelectedInstOperands,
     /* 400554 */     // GIR_Coverage, 1868,
     /* 400554 */     GIR_EraseRootFromParent_Done,
     /* 400555 */   // Label 8069: @400555
     /* 400555 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(400592), // Rule ID 5432 //
     /* 400560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400568 */     // MIs[0] imm
     /* 400568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400576 */     // MIs[1] Operand 1
     /* 400576 */     // No operand predicates
     /* 400576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400578 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 400581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400590 */     GIR_RootConstrainSelectedInstOperands,
     /* 400591 */     // GIR_Coverage, 5432,
     /* 400591 */     GIR_EraseRootFromParent_Done,
     /* 400592 */   // Label 8070: @400592
     /* 400592 */   GIM_Reject,
     /* 400593 */ // Label 8067: @400593
     /* 400593 */ GIM_Reject,
     /* 400594 */ // Label 8042: @400594
     /* 400594 */ GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(400676),
     /* 400599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400617 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(400646), // Rule ID 5438 //
     /* 400622 */     // MIs[0] imm
     /* 400622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400630 */     // MIs[1] Operand 1
     /* 400630 */     // No operand predicates
     /* 400630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400632 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400644 */     GIR_RootConstrainSelectedInstOperands,
     /* 400645 */     // GIR_Coverage, 5438,
     /* 400645 */     GIR_EraseRootFromParent_Done,
     /* 400646 */   // Label 8072: @400646
     /* 400646 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(400675), // Rule ID 5443 //
     /* 400651 */     // MIs[0] imm
     /* 400651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400659 */     // MIs[1] Operand 1
     /* 400659 */     // No operand predicates
     /* 400659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400661 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400673 */     GIR_RootConstrainSelectedInstOperands,
     /* 400674 */     // GIR_Coverage, 5443,
     /* 400674 */     GIR_EraseRootFromParent_Done,
     /* 400675 */   // Label 8073: @400675
     /* 400675 */   GIM_Reject,
     /* 400676 */ // Label 8071: @400676
     /* 400676 */ GIM_Reject,
     /* 400677 */ // Label 8043: @400677
     /* 400677 */ GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(400762),
     /* 400682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 400688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400700 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(400732), // Rule ID 1869 //
     /* 400705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400708 */     // MIs[0] imm
     /* 400708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400716 */     // MIs[1] Operand 1
     /* 400716 */     // No operand predicates
     /* 400716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400718 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400730 */     GIR_RootConstrainSelectedInstOperands,
     /* 400731 */     // GIR_Coverage, 1869,
     /* 400731 */     GIR_EraseRootFromParent_Done,
     /* 400732 */   // Label 8075: @400732
     /* 400732 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(400761), // Rule ID 5433 //
     /* 400737 */     // MIs[0] imm
     /* 400737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400745 */     // MIs[1] Operand 1
     /* 400745 */     // No operand predicates
     /* 400745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400747 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400759 */     GIR_RootConstrainSelectedInstOperands,
     /* 400760 */     // GIR_Coverage, 5433,
     /* 400760 */     GIR_EraseRootFromParent_Done,
     /* 400761 */   // Label 8076: @400761
     /* 400761 */   GIM_Reject,
     /* 400762 */ // Label 8074: @400762
     /* 400762 */ GIM_Reject,
     /* 400763 */ // Label 8044: @400763
     /* 400763 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(400809), // Rule ID 2733 //
     /* 400768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 400774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 400777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400781 */   // MIs[0] Op3
     /* 400781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400789 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 400793 */   // MIs[1] Operand 1
     /* 400793 */   // No operand predicates
     /* 400793 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400795 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 400795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 400798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400800 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 400802 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 400804 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 400807 */   GIR_RootConstrainSelectedInstOperands,
     /* 400808 */   // GIR_Coverage, 2733,
     /* 400808 */   GIR_EraseRootFromParent_Done,
     /* 400809 */ // Label 8077: @400809
     /* 400809 */ GIM_Reject,
     /* 400810 */ // Label 8045: @400810
     /* 400810 */ GIM_Reject,
     /* 400811 */ // Label 128: @400811
     /* 400811 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8085*/ GIMT_Encode4(401369),
     /* 400822 */ /*GILLT_s32*//*Label 8078*/ GIMT_Encode4(400858),
     /* 400826 */ /*GILLT_s64*//*Label 8079*/ GIMT_Encode4(400896), GIMT_Encode4(0),
     /* 400834 */ /*GILLT_v2s32*//*Label 8080*/ GIMT_Encode4(400994),
     /* 400838 */ /*GILLT_v2s64*//*Label 8081*/ GIMT_Encode4(401069),
     /* 400842 */ /*GILLT_v4s16*//*Label 8082*/ GIMT_Encode4(401144),
     /* 400846 */ /*GILLT_v4s32*//*Label 8083*/ GIMT_Encode4(401219), GIMT_Encode4(0),
     /* 400854 */ /*GILLT_v8s16*//*Label 8084*/ GIMT_Encode4(401294),
     /* 400858 */ // Label 8078: @400858
     /* 400858 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(400895), // Rule ID 1622 //
     /* 400863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 400872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400884 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 400884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 400889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400893 */   GIR_RootConstrainSelectedInstOperands,
     /* 400894 */   // GIR_Coverage, 1622,
     /* 400894 */   GIR_Done,
     /* 400895 */ // Label 8086: @400895
     /* 400895 */ GIM_Reject,
     /* 400896 */ // Label 8079: @400896
     /* 400896 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(400993),
     /* 400901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400915 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(400946), // Rule ID 2513 //
     /* 400920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400927 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 400933 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 400935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400937 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 400937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 400940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400944 */     GIR_RootConstrainSelectedInstOperands,
     /* 400945 */     // GIR_Coverage, 2513,
     /* 400945 */     GIR_EraseRootFromParent_Done,
     /* 400946 */   // Label 8088: @400946
     /* 400946 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(400969), // Rule ID 1621 //
     /* 400951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400958 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 400958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 400963 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400967 */     GIR_RootConstrainSelectedInstOperands,
     /* 400968 */     // GIR_Coverage, 1621,
     /* 400968 */     GIR_Done,
     /* 400969 */   // Label 8089: @400969
     /* 400969 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(400992), // Rule ID 5212 //
     /* 400974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400981 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 400981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 400986 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400990 */     GIR_RootConstrainSelectedInstOperands,
     /* 400991 */     // GIR_Coverage, 5212,
     /* 400991 */     GIR_Done,
     /* 400992 */   // Label 8090: @400992
     /* 400992 */   GIM_Reject,
     /* 400993 */ // Label 8087: @400993
     /* 400993 */ GIM_Reject,
     /* 400994 */ // Label 8080: @400994
     /* 400994 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(401068),
     /* 400999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401013 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(401044), // Rule ID 773 //
     /* 401018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401035 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 401035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 401038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401042 */     GIR_RootConstrainSelectedInstOperands,
     /* 401043 */     // GIR_Coverage, 773,
     /* 401043 */     GIR_EraseRootFromParent_Done,
     /* 401044 */   // Label 8092: @401044
     /* 401044 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(401067), // Rule ID 1210 //
     /* 401049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401056 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 401061 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401065 */     GIR_RootConstrainSelectedInstOperands,
     /* 401066 */     // GIR_Coverage, 1210,
     /* 401066 */     GIR_Done,
     /* 401067 */   // Label 8093: @401067
     /* 401067 */   GIM_Reject,
     /* 401068 */ // Label 8091: @401068
     /* 401068 */ GIM_Reject,
     /* 401069 */ // Label 8081: @401069
     /* 401069 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(401143),
     /* 401074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401088 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(401119), // Rule ID 775 //
     /* 401093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401100 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401106 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401110 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 401110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 401113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401117 */     GIR_RootConstrainSelectedInstOperands,
     /* 401118 */     // GIR_Coverage, 775,
     /* 401118 */     GIR_EraseRootFromParent_Done,
     /* 401119 */   // Label 8095: @401119
     /* 401119 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(401142), // Rule ID 1212 //
     /* 401124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401131 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 401136 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401140 */     GIR_RootConstrainSelectedInstOperands,
     /* 401141 */     // GIR_Coverage, 1212,
     /* 401141 */     GIR_Done,
     /* 401142 */   // Label 8096: @401142
     /* 401142 */   GIM_Reject,
     /* 401143 */ // Label 8094: @401143
     /* 401143 */ GIM_Reject,
     /* 401144 */ // Label 8082: @401144
     /* 401144 */ GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(401218),
     /* 401149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401163 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(401194), // Rule ID 771 //
     /* 401168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401175 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401181 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401185 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 401185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 401188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401192 */     GIR_RootConstrainSelectedInstOperands,
     /* 401193 */     // GIR_Coverage, 771,
     /* 401193 */     GIR_EraseRootFromParent_Done,
     /* 401194 */   // Label 8098: @401194
     /* 401194 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(401217), // Rule ID 1208 //
     /* 401199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401206 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 401211 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401215 */     GIR_RootConstrainSelectedInstOperands,
     /* 401216 */     // GIR_Coverage, 1208,
     /* 401216 */     GIR_Done,
     /* 401217 */   // Label 8099: @401217
     /* 401217 */   GIM_Reject,
     /* 401218 */ // Label 8097: @401218
     /* 401218 */ GIM_Reject,
     /* 401219 */ // Label 8083: @401219
     /* 401219 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(401293),
     /* 401224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401238 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(401269), // Rule ID 774 //
     /* 401243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401250 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401256 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401260 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 401260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 401263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401267 */     GIR_RootConstrainSelectedInstOperands,
     /* 401268 */     // GIR_Coverage, 774,
     /* 401268 */     GIR_EraseRootFromParent_Done,
     /* 401269 */   // Label 8101: @401269
     /* 401269 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(401292), // Rule ID 1211 //
     /* 401274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401281 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 401286 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401290 */     GIR_RootConstrainSelectedInstOperands,
     /* 401291 */     // GIR_Coverage, 1211,
     /* 401291 */     GIR_Done,
     /* 401292 */   // Label 8102: @401292
     /* 401292 */   GIM_Reject,
     /* 401293 */ // Label 8100: @401293
     /* 401293 */ GIM_Reject,
     /* 401294 */ // Label 8084: @401294
     /* 401294 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(401368),
     /* 401299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401313 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(401344), // Rule ID 772 //
     /* 401318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401325 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401331 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401335 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 401335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 401338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401342 */     GIR_RootConstrainSelectedInstOperands,
     /* 401343 */     // GIR_Coverage, 772,
     /* 401343 */     GIR_EraseRootFromParent_Done,
     /* 401344 */   // Label 8104: @401344
     /* 401344 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(401367), // Rule ID 1209 //
     /* 401349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401356 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 401361 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401365 */     GIR_RootConstrainSelectedInstOperands,
     /* 401366 */     // GIR_Coverage, 1209,
     /* 401366 */     GIR_Done,
     /* 401367 */   // Label 8105: @401367
     /* 401367 */   GIM_Reject,
     /* 401368 */ // Label 8103: @401368
     /* 401368 */ GIM_Reject,
     /* 401369 */ // Label 8085: @401369
     /* 401369 */ GIM_Reject,
     /* 401370 */ // Label 129: @401370
     /* 401370 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8113*/ GIMT_Encode4(402461),
     /* 401381 */ /*GILLT_s32*//*Label 8106*/ GIMT_Encode4(401417),
     /* 401385 */ /*GILLT_s64*//*Label 8107*/ GIMT_Encode4(401455), GIMT_Encode4(0),
     /* 401393 */ /*GILLT_v2s32*//*Label 8108*/ GIMT_Encode4(401596),
     /* 401397 */ /*GILLT_v2s64*//*Label 8109*/ GIMT_Encode4(401769),
     /* 401401 */ /*GILLT_v4s16*//*Label 8110*/ GIMT_Encode4(401942),
     /* 401405 */ /*GILLT_v4s32*//*Label 8111*/ GIMT_Encode4(402115), GIMT_Encode4(0),
     /* 401413 */ /*GILLT_v8s16*//*Label 8112*/ GIMT_Encode4(402288),
     /* 401417 */ // Label 8106: @401417
     /* 401417 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(401454), // Rule ID 1624 //
     /* 401422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 401431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401443 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 401443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 401448 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401452 */   GIR_RootConstrainSelectedInstOperands,
     /* 401453 */   // GIR_Coverage, 1624,
     /* 401453 */   GIR_Done,
     /* 401454 */ // Label 8114: @401454
     /* 401454 */ GIM_Reject,
     /* 401455 */ // Label 8107: @401455
     /* 401455 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(401595),
     /* 401460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401470 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(401505), // Rule ID 5246 //
     /* 401475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401482 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401488 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401496 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 401496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 401499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401503 */     GIR_RootConstrainSelectedInstOperands,
     /* 401504 */     // GIR_Coverage, 5246,
     /* 401504 */     GIR_EraseRootFromParent_Done,
     /* 401505 */   // Label 8116: @401505
     /* 401505 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(401540), // Rule ID 5244 //
     /* 401510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401521 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401527 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401531 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 401531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 401534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401538 */     GIR_RootConstrainSelectedInstOperands,
     /* 401539 */     // GIR_Coverage, 5244,
     /* 401539 */     GIR_EraseRootFromParent_Done,
     /* 401540 */   // Label 8117: @401540
     /* 401540 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(401567), // Rule ID 1623 //
     /* 401545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401556 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 401556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 401561 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401565 */     GIR_RootConstrainSelectedInstOperands,
     /* 401566 */     // GIR_Coverage, 1623,
     /* 401566 */     GIR_Done,
     /* 401567 */   // Label 8118: @401567
     /* 401567 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(401594), // Rule ID 5213 //
     /* 401572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401583 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 401583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 401588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401592 */     GIR_RootConstrainSelectedInstOperands,
     /* 401593 */     // GIR_Coverage, 5213,
     /* 401593 */     GIR_Done,
     /* 401594 */   // Label 8119: @401594
     /* 401594 */   GIM_Reject,
     /* 401595 */ // Label 8115: @401595
     /* 401595 */ GIM_Reject,
     /* 401596 */ // Label 8108: @401596
     /* 401596 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(401768),
     /* 401601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401611 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(401670), // Rule ID 1172 //
     /* 401616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401655 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 401658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401668 */     GIR_RootConstrainSelectedInstOperands,
     /* 401669 */     // GIR_Coverage, 1172,
     /* 401669 */     GIR_EraseRootFromParent_Done,
     /* 401670 */   // Label 8121: @401670
     /* 401670 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(401705), // Rule ID 788 //
     /* 401675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401682 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401688 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401696 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 401696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 401699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401703 */     GIR_RootConstrainSelectedInstOperands,
     /* 401704 */     // GIR_Coverage, 788,
     /* 401704 */     GIR_EraseRootFromParent_Done,
     /* 401705 */   // Label 8122: @401705
     /* 401705 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(401740), // Rule ID 778 //
     /* 401710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401731 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 401731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 401734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401738 */     GIR_RootConstrainSelectedInstOperands,
     /* 401739 */     // GIR_Coverage, 778,
     /* 401739 */     GIR_EraseRootFromParent_Done,
     /* 401740 */   // Label 8123: @401740
     /* 401740 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(401767), // Rule ID 1215 //
     /* 401745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401756 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 401761 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401765 */     GIR_RootConstrainSelectedInstOperands,
     /* 401766 */     // GIR_Coverage, 1215,
     /* 401766 */     GIR_Done,
     /* 401767 */   // Label 8124: @401767
     /* 401767 */   GIM_Reject,
     /* 401768 */ // Label 8120: @401768
     /* 401768 */ GIM_Reject,
     /* 401769 */ // Label 8109: @401769
     /* 401769 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(401941),
     /* 401774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401784 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(401843), // Rule ID 1176 //
     /* 401789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401828 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 401831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401841 */     GIR_RootConstrainSelectedInstOperands,
     /* 401842 */     // GIR_Coverage, 1176,
     /* 401842 */     GIR_EraseRootFromParent_Done,
     /* 401843 */   // Label 8126: @401843
     /* 401843 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(401878), // Rule ID 790 //
     /* 401848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401869 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 401869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 401872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 401876 */     GIR_RootConstrainSelectedInstOperands,
     /* 401877 */     // GIR_Coverage, 790,
     /* 401877 */     GIR_EraseRootFromParent_Done,
     /* 401878 */   // Label 8127: @401878
     /* 401878 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(401913), // Rule ID 780 //
     /* 401883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 401894 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 401900 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 401902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 401904 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 401904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 401907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 401911 */     GIR_RootConstrainSelectedInstOperands,
     /* 401912 */     // GIR_Coverage, 780,
     /* 401912 */     GIR_EraseRootFromParent_Done,
     /* 401913 */   // Label 8128: @401913
     /* 401913 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(401940), // Rule ID 1217 //
     /* 401918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401929 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 401934 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401938 */     GIR_RootConstrainSelectedInstOperands,
     /* 401939 */     // GIR_Coverage, 1217,
     /* 401939 */     GIR_Done,
     /* 401940 */   // Label 8129: @401940
     /* 401940 */   GIM_Reject,
     /* 401941 */ // Label 8125: @401941
     /* 401941 */ GIM_Reject,
     /* 401942 */ // Label 8110: @401942
     /* 401942 */ GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(402114),
     /* 401947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401957 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(402016), // Rule ID 1168 //
     /* 401962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402001 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 402004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402014 */     GIR_RootConstrainSelectedInstOperands,
     /* 402015 */     // GIR_Coverage, 1168,
     /* 402015 */     GIR_EraseRootFromParent_Done,
     /* 402016 */   // Label 8131: @402016
     /* 402016 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(402051), // Rule ID 786 //
     /* 402021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402028 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402042 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 402045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402049 */     GIR_RootConstrainSelectedInstOperands,
     /* 402050 */     // GIR_Coverage, 786,
     /* 402050 */     GIR_EraseRootFromParent_Done,
     /* 402051 */   // Label 8132: @402051
     /* 402051 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(402086), // Rule ID 776 //
     /* 402056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402077 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 402080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402084 */     GIR_RootConstrainSelectedInstOperands,
     /* 402085 */     // GIR_Coverage, 776,
     /* 402085 */     GIR_EraseRootFromParent_Done,
     /* 402086 */   // Label 8133: @402086
     /* 402086 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(402113), // Rule ID 1213 //
     /* 402091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402102 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 402107 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402111 */     GIR_RootConstrainSelectedInstOperands,
     /* 402112 */     // GIR_Coverage, 1213,
     /* 402112 */     GIR_Done,
     /* 402113 */   // Label 8134: @402113
     /* 402113 */   GIM_Reject,
     /* 402114 */ // Label 8130: @402114
     /* 402114 */ GIM_Reject,
     /* 402115 */ // Label 8111: @402115
     /* 402115 */ GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(402287),
     /* 402120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402130 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(402189), // Rule ID 1174 //
     /* 402135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402174 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 402177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402187 */     GIR_RootConstrainSelectedInstOperands,
     /* 402188 */     // GIR_Coverage, 1174,
     /* 402188 */     GIR_EraseRootFromParent_Done,
     /* 402189 */   // Label 8136: @402189
     /* 402189 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(402224), // Rule ID 789 //
     /* 402194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402201 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402207 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402215 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 402218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402222 */     GIR_RootConstrainSelectedInstOperands,
     /* 402223 */     // GIR_Coverage, 789,
     /* 402223 */     GIR_EraseRootFromParent_Done,
     /* 402224 */   // Label 8137: @402224
     /* 402224 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(402259), // Rule ID 779 //
     /* 402229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402240 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402246 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402250 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 402253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402257 */     GIR_RootConstrainSelectedInstOperands,
     /* 402258 */     // GIR_Coverage, 779,
     /* 402258 */     GIR_EraseRootFromParent_Done,
     /* 402259 */   // Label 8138: @402259
     /* 402259 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(402286), // Rule ID 1216 //
     /* 402264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402275 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 402280 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402284 */     GIR_RootConstrainSelectedInstOperands,
     /* 402285 */     // GIR_Coverage, 1216,
     /* 402285 */     GIR_Done,
     /* 402286 */   // Label 8139: @402286
     /* 402286 */   GIM_Reject,
     /* 402287 */ // Label 8135: @402287
     /* 402287 */ GIM_Reject,
     /* 402288 */ // Label 8112: @402288
     /* 402288 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(402460),
     /* 402293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402303 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(402362), // Rule ID 1170 //
     /* 402308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402347 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 402350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402360 */     GIR_RootConstrainSelectedInstOperands,
     /* 402361 */     // GIR_Coverage, 1170,
     /* 402361 */     GIR_EraseRootFromParent_Done,
     /* 402362 */   // Label 8141: @402362
     /* 402362 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(402397), // Rule ID 787 //
     /* 402367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402374 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402380 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402388 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 402391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402395 */     GIR_RootConstrainSelectedInstOperands,
     /* 402396 */     // GIR_Coverage, 787,
     /* 402396 */     GIR_EraseRootFromParent_Done,
     /* 402397 */   // Label 8142: @402397
     /* 402397 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(402432), // Rule ID 777 //
     /* 402402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402413 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402419 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402423 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 402426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402430 */     GIR_RootConstrainSelectedInstOperands,
     /* 402431 */     // GIR_Coverage, 777,
     /* 402431 */     GIR_EraseRootFromParent_Done,
     /* 402432 */   // Label 8143: @402432
     /* 402432 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(402459), // Rule ID 1214 //
     /* 402437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402448 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 402453 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402457 */     GIR_RootConstrainSelectedInstOperands,
     /* 402458 */     // GIR_Coverage, 1214,
     /* 402458 */     GIR_Done,
     /* 402459 */   // Label 8144: @402459
     /* 402459 */   GIM_Reject,
     /* 402460 */ // Label 8140: @402460
     /* 402460 */ GIM_Reject,
     /* 402461 */ // Label 8113: @402461
     /* 402461 */ GIM_Reject,
     /* 402462 */ // Label 130: @402462
     /* 402462 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8152*/ GIMT_Encode4(403553),
     /* 402473 */ /*GILLT_s32*//*Label 8145*/ GIMT_Encode4(402509),
     /* 402477 */ /*GILLT_s64*//*Label 8146*/ GIMT_Encode4(402547), GIMT_Encode4(0),
     /* 402485 */ /*GILLT_v2s32*//*Label 8147*/ GIMT_Encode4(402688),
     /* 402489 */ /*GILLT_v2s64*//*Label 8148*/ GIMT_Encode4(402861),
     /* 402493 */ /*GILLT_v4s16*//*Label 8149*/ GIMT_Encode4(403034),
     /* 402497 */ /*GILLT_v4s32*//*Label 8150*/ GIMT_Encode4(403207), GIMT_Encode4(0),
     /* 402505 */ /*GILLT_v8s16*//*Label 8151*/ GIMT_Encode4(403380),
     /* 402509 */ // Label 8145: @402509
     /* 402509 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(402546), // Rule ID 1626 //
     /* 402514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 402523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402535 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 402535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 402540 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402544 */   GIR_RootConstrainSelectedInstOperands,
     /* 402545 */   // GIR_Coverage, 1626,
     /* 402545 */   GIR_Done,
     /* 402546 */ // Label 8153: @402546
     /* 402546 */ GIM_Reject,
     /* 402547 */ // Label 8146: @402547
     /* 402547 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(402687),
     /* 402552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 402558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402562 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(402597), // Rule ID 5247 //
     /* 402567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402574 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402580 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402588 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 402588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 402591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402595 */     GIR_RootConstrainSelectedInstOperands,
     /* 402596 */     // GIR_Coverage, 5247,
     /* 402596 */     GIR_EraseRootFromParent_Done,
     /* 402597 */   // Label 8155: @402597
     /* 402597 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(402632), // Rule ID 5245 //
     /* 402602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402613 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402619 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402623 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 402623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 402626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402630 */     GIR_RootConstrainSelectedInstOperands,
     /* 402631 */     // GIR_Coverage, 5245,
     /* 402631 */     GIR_EraseRootFromParent_Done,
     /* 402632 */   // Label 8156: @402632
     /* 402632 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(402659), // Rule ID 1625 //
     /* 402637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402648 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 402648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 402653 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402657 */     GIR_RootConstrainSelectedInstOperands,
     /* 402658 */     // GIR_Coverage, 1625,
     /* 402658 */     GIR_Done,
     /* 402659 */   // Label 8157: @402659
     /* 402659 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(402686), // Rule ID 5214 //
     /* 402664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402675 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 402675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 402680 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402684 */     GIR_RootConstrainSelectedInstOperands,
     /* 402685 */     // GIR_Coverage, 5214,
     /* 402685 */     GIR_Done,
     /* 402686 */   // Label 8158: @402686
     /* 402686 */   GIM_Reject,
     /* 402687 */ // Label 8154: @402687
     /* 402687 */ GIM_Reject,
     /* 402688 */ // Label 8147: @402688
     /* 402688 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(402860),
     /* 402693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 402699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402703 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(402762), // Rule ID 1182 //
     /* 402708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402747 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 402747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 402750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402760 */     GIR_RootConstrainSelectedInstOperands,
     /* 402761 */     // GIR_Coverage, 1182,
     /* 402761 */     GIR_EraseRootFromParent_Done,
     /* 402762 */   // Label 8160: @402762
     /* 402762 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(402797), // Rule ID 793 //
     /* 402767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402788 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 402788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 402791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402795 */     GIR_RootConstrainSelectedInstOperands,
     /* 402796 */     // GIR_Coverage, 793,
     /* 402796 */     GIR_EraseRootFromParent_Done,
     /* 402797 */   // Label 8161: @402797
     /* 402797 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(402832), // Rule ID 783 //
     /* 402802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402813 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402819 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402823 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 402823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 402826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402830 */     GIR_RootConstrainSelectedInstOperands,
     /* 402831 */     // GIR_Coverage, 783,
     /* 402831 */     GIR_EraseRootFromParent_Done,
     /* 402832 */   // Label 8162: @402832
     /* 402832 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(402859), // Rule ID 1220 //
     /* 402837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402848 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 402848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 402853 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402857 */     GIR_RootConstrainSelectedInstOperands,
     /* 402858 */     // GIR_Coverage, 1220,
     /* 402858 */     GIR_Done,
     /* 402859 */   // Label 8163: @402859
     /* 402859 */   GIM_Reject,
     /* 402860 */ // Label 8159: @402860
     /* 402860 */ GIM_Reject,
     /* 402861 */ // Label 8148: @402861
     /* 402861 */ GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(403033),
     /* 402866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 402872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402876 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(402935), // Rule ID 1186 //
     /* 402881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402920 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 402920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 402923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402933 */     GIR_RootConstrainSelectedInstOperands,
     /* 402934 */     // GIR_Coverage, 1186,
     /* 402934 */     GIR_EraseRootFromParent_Done,
     /* 402935 */   // Label 8165: @402935
     /* 402935 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(402970), // Rule ID 795 //
     /* 402940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402947 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402953 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402961 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 402961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 402964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402968 */     GIR_RootConstrainSelectedInstOperands,
     /* 402969 */     // GIR_Coverage, 795,
     /* 402969 */     GIR_EraseRootFromParent_Done,
     /* 402970 */   // Label 8166: @402970
     /* 402970 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(403005), // Rule ID 785 //
     /* 402975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402986 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 402992 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 402994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402996 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 402996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 402999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403003 */     GIR_RootConstrainSelectedInstOperands,
     /* 403004 */     // GIR_Coverage, 785,
     /* 403004 */     GIR_EraseRootFromParent_Done,
     /* 403005 */   // Label 8167: @403005
     /* 403005 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(403032), // Rule ID 1222 //
     /* 403010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403021 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 403021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 403026 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403030 */     GIR_RootConstrainSelectedInstOperands,
     /* 403031 */     // GIR_Coverage, 1222,
     /* 403031 */     GIR_Done,
     /* 403032 */   // Label 8168: @403032
     /* 403032 */   GIM_Reject,
     /* 403033 */ // Label 8164: @403033
     /* 403033 */ GIM_Reject,
     /* 403034 */ // Label 8149: @403034
     /* 403034 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(403206),
     /* 403039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 403045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403049 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(403108), // Rule ID 1178 //
     /* 403054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 403065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 403082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403093 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 403093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 403096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403106 */     GIR_RootConstrainSelectedInstOperands,
     /* 403107 */     // GIR_Coverage, 1178,
     /* 403107 */     GIR_EraseRootFromParent_Done,
     /* 403108 */   // Label 8170: @403108
     /* 403108 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(403143), // Rule ID 791 //
     /* 403113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403120 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403126 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403134 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 403134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 403137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403141 */     GIR_RootConstrainSelectedInstOperands,
     /* 403142 */     // GIR_Coverage, 791,
     /* 403142 */     GIR_EraseRootFromParent_Done,
     /* 403143 */   // Label 8171: @403143
     /* 403143 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(403178), // Rule ID 781 //
     /* 403148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403169 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 403169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 403172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403176 */     GIR_RootConstrainSelectedInstOperands,
     /* 403177 */     // GIR_Coverage, 781,
     /* 403177 */     GIR_EraseRootFromParent_Done,
     /* 403178 */   // Label 8172: @403178
     /* 403178 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(403205), // Rule ID 1218 //
     /* 403183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403194 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 403194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 403199 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403203 */     GIR_RootConstrainSelectedInstOperands,
     /* 403204 */     // GIR_Coverage, 1218,
     /* 403204 */     GIR_Done,
     /* 403205 */   // Label 8173: @403205
     /* 403205 */   GIM_Reject,
     /* 403206 */ // Label 8169: @403206
     /* 403206 */ GIM_Reject,
     /* 403207 */ // Label 8150: @403207
     /* 403207 */ GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(403379),
     /* 403212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 403218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403222 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(403281), // Rule ID 1184 //
     /* 403227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 403238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 403255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403266 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 403266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 403269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403279 */     GIR_RootConstrainSelectedInstOperands,
     /* 403280 */     // GIR_Coverage, 1184,
     /* 403280 */     GIR_EraseRootFromParent_Done,
     /* 403281 */   // Label 8175: @403281
     /* 403281 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(403316), // Rule ID 794 //
     /* 403286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403293 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403299 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403307 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 403307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 403310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403314 */     GIR_RootConstrainSelectedInstOperands,
     /* 403315 */     // GIR_Coverage, 794,
     /* 403315 */     GIR_EraseRootFromParent_Done,
     /* 403316 */   // Label 8176: @403316
     /* 403316 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(403351), // Rule ID 784 //
     /* 403321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403332 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403338 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403342 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 403342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 403345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403349 */     GIR_RootConstrainSelectedInstOperands,
     /* 403350 */     // GIR_Coverage, 784,
     /* 403350 */     GIR_EraseRootFromParent_Done,
     /* 403351 */   // Label 8177: @403351
     /* 403351 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(403378), // Rule ID 1221 //
     /* 403356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403367 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 403367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 403372 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403376 */     GIR_RootConstrainSelectedInstOperands,
     /* 403377 */     // GIR_Coverage, 1221,
     /* 403377 */     GIR_Done,
     /* 403378 */   // Label 8178: @403378
     /* 403378 */   GIM_Reject,
     /* 403379 */ // Label 8174: @403379
     /* 403379 */ GIM_Reject,
     /* 403380 */ // Label 8151: @403380
     /* 403380 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(403552),
     /* 403385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 403391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403395 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(403454), // Rule ID 1180 //
     /* 403400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 403411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 403428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403439 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 403439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 403442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403452 */     GIR_RootConstrainSelectedInstOperands,
     /* 403453 */     // GIR_Coverage, 1180,
     /* 403453 */     GIR_EraseRootFromParent_Done,
     /* 403454 */   // Label 8180: @403454
     /* 403454 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(403489), // Rule ID 792 //
     /* 403459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403466 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403472 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403480 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 403480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 403483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403487 */     GIR_RootConstrainSelectedInstOperands,
     /* 403488 */     // GIR_Coverage, 792,
     /* 403488 */     GIR_EraseRootFromParent_Done,
     /* 403489 */   // Label 8181: @403489
     /* 403489 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(403524), // Rule ID 782 //
     /* 403494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403505 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 403511 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 403513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403515 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 403515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 403518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403522 */     GIR_RootConstrainSelectedInstOperands,
     /* 403523 */     // GIR_Coverage, 782,
     /* 403523 */     GIR_EraseRootFromParent_Done,
     /* 403524 */   // Label 8182: @403524
     /* 403524 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(403551), // Rule ID 1219 //
     /* 403529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403540 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 403540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 403545 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403549 */     GIR_RootConstrainSelectedInstOperands,
     /* 403550 */     // GIR_Coverage, 1219,
     /* 403550 */     GIR_Done,
     /* 403551 */   // Label 8183: @403551
     /* 403551 */   GIM_Reject,
     /* 403552 */ // Label 8179: @403552
     /* 403552 */ GIM_Reject,
     /* 403553 */ // Label 8152: @403553
     /* 403553 */ GIM_Reject,
     /* 403554 */ // Label 131: @403554
     /* 403554 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8188*/ GIMT_Encode4(403707),
     /* 403565 */ /*GILLT_s32*//*Label 8184*/ GIMT_Encode4(403605),
     /* 403569 */ /*GILLT_s64*//*Label 8185*/ GIMT_Encode4(403629), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403593 */ /*GILLT_v8s8*//*Label 8186*/ GIMT_Encode4(403653), GIMT_Encode4(0),
     /* 403601 */ /*GILLT_v16s8*//*Label 8187*/ GIMT_Encode4(403680),
     /* 403605 */ // Label 8184: @403605
     /* 403605 */ GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(403628), // Rule ID 4015 //
     /* 403610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 403613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 403617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 403621 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 403621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 403626 */   GIR_RootConstrainSelectedInstOperands,
     /* 403627 */   // GIR_Coverage, 4015,
     /* 403627 */   GIR_Done,
     /* 403628 */ // Label 8189: @403628
     /* 403628 */ GIM_Reject,
     /* 403629 */ // Label 8185: @403629
     /* 403629 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(403652), // Rule ID 4016 //
     /* 403634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 403637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 403641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 403645 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 403645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 403650 */   GIR_RootConstrainSelectedInstOperands,
     /* 403651 */   // GIR_Coverage, 4016,
     /* 403651 */   GIR_Done,
     /* 403652 */ // Label 8190: @403652
     /* 403652 */ GIM_Reject,
     /* 403653 */ // Label 8186: @403653
     /* 403653 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(403679), // Rule ID 976 //
     /* 403658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403672 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 403672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 403677 */   GIR_RootConstrainSelectedInstOperands,
     /* 403678 */   // GIR_Coverage, 976,
     /* 403678 */   GIR_Done,
     /* 403679 */ // Label 8191: @403679
     /* 403679 */ GIM_Reject,
     /* 403680 */ // Label 8187: @403680
     /* 403680 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(403706), // Rule ID 977 //
     /* 403685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403699 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 403699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 403704 */   GIR_RootConstrainSelectedInstOperands,
     /* 403705 */   // GIR_Coverage, 977,
     /* 403705 */   GIR_Done,
     /* 403706 */ // Label 8192: @403706
     /* 403706 */ GIM_Reject,
     /* 403707 */ // Label 8188: @403707
     /* 403707 */ GIM_Reject,
     /* 403708 */ // Label 132: @403708
     /* 403708 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8197*/ GIMT_Encode4(403883),
     /* 403719 */ /*GILLT_v4s16*//*Label 8193*/ GIMT_Encode4(403739), GIMT_Encode4(0),
     /* 403727 */ /*GILLT_v8s8*//*Label 8194*/ GIMT_Encode4(403784),
     /* 403731 */ /*GILLT_v8s16*//*Label 8195*/ GIMT_Encode4(403811),
     /* 403735 */ /*GILLT_v16s8*//*Label 8196*/ GIMT_Encode4(403856),
     /* 403739 */ // Label 8193: @403739
     /* 403739 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(403783),
     /* 403744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403755 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(403770), // Rule ID 980 //
     /* 403760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403763 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 403763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 403768 */     GIR_RootConstrainSelectedInstOperands,
     /* 403769 */     // GIR_Coverage, 980,
     /* 403769 */     GIR_Done,
     /* 403770 */   // Label 8199: @403770
     /* 403770 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(403782), // Rule ID 4962 //
     /* 403775 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 403775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 403780 */     GIR_RootConstrainSelectedInstOperands,
     /* 403781 */     // GIR_Coverage, 4962,
     /* 403781 */     GIR_Done,
     /* 403782 */   // Label 8200: @403782
     /* 403782 */   GIM_Reject,
     /* 403783 */ // Label 8198: @403783
     /* 403783 */ GIM_Reject,
     /* 403784 */ // Label 8194: @403784
     /* 403784 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(403810), // Rule ID 978 //
     /* 403789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403803 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 403803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 403808 */   GIR_RootConstrainSelectedInstOperands,
     /* 403809 */   // GIR_Coverage, 978,
     /* 403809 */   GIR_Done,
     /* 403810 */ // Label 8201: @403810
     /* 403810 */ GIM_Reject,
     /* 403811 */ // Label 8195: @403811
     /* 403811 */ GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(403855),
     /* 403816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403827 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(403842), // Rule ID 981 //
     /* 403832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403835 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 403835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 403840 */     GIR_RootConstrainSelectedInstOperands,
     /* 403841 */     // GIR_Coverage, 981,
     /* 403841 */     GIR_Done,
     /* 403842 */   // Label 8203: @403842
     /* 403842 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(403854), // Rule ID 4964 //
     /* 403847 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 403847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 403852 */     GIR_RootConstrainSelectedInstOperands,
     /* 403853 */     // GIR_Coverage, 4964,
     /* 403853 */     GIR_Done,
     /* 403854 */   // Label 8204: @403854
     /* 403854 */   GIM_Reject,
     /* 403855 */ // Label 8202: @403855
     /* 403855 */ GIM_Reject,
     /* 403856 */ // Label 8196: @403856
     /* 403856 */ GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(403882), // Rule ID 979 //
     /* 403861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403875 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 403875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 403880 */   GIR_RootConstrainSelectedInstOperands,
     /* 403881 */   // GIR_Coverage, 979,
     /* 403881 */   GIR_Done,
     /* 403882 */ // Label 8205: @403882
     /* 403882 */ GIM_Reject,
     /* 403883 */ // Label 8197: @403883
     /* 403883 */ GIM_Reject,
     /* 403884 */ // Label 133: @403884
     /* 403884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8212*/ GIMT_Encode4(404157),
     /* 403895 */ /*GILLT_v2s32*//*Label 8206*/ GIMT_Encode4(403923), GIMT_Encode4(0),
     /* 403903 */ /*GILLT_v4s16*//*Label 8207*/ GIMT_Encode4(403968),
     /* 403907 */ /*GILLT_v4s32*//*Label 8208*/ GIMT_Encode4(404013),
     /* 403911 */ /*GILLT_v8s8*//*Label 8209*/ GIMT_Encode4(404058),
     /* 403915 */ /*GILLT_v8s16*//*Label 8210*/ GIMT_Encode4(404085),
     /* 403919 */ /*GILLT_v16s8*//*Label 8211*/ GIMT_Encode4(404130),
     /* 403923 */ // Label 8206: @403923
     /* 403923 */ GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(403967),
     /* 403928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403939 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(403954), // Rule ID 986 //
     /* 403944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403947 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 403947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 403952 */     GIR_RootConstrainSelectedInstOperands,
     /* 403953 */     // GIR_Coverage, 986,
     /* 403953 */     GIR_Done,
     /* 403954 */   // Label 8214: @403954
     /* 403954 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(403966), // Rule ID 4966 //
     /* 403959 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 403959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 403964 */     GIR_RootConstrainSelectedInstOperands,
     /* 403965 */     // GIR_Coverage, 4966,
     /* 403965 */     GIR_Done,
     /* 403966 */   // Label 8215: @403966
     /* 403966 */   GIM_Reject,
     /* 403967 */ // Label 8213: @403967
     /* 403967 */ GIM_Reject,
     /* 403968 */ // Label 8207: @403968
     /* 403968 */ GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(404012),
     /* 403973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403984 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(403999), // Rule ID 984 //
     /* 403989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403992 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 403992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 403997 */     GIR_RootConstrainSelectedInstOperands,
     /* 403998 */     // GIR_Coverage, 984,
     /* 403998 */     GIR_Done,
     /* 403999 */   // Label 8217: @403999
     /* 403999 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(404011), // Rule ID 4963 //
     /* 404004 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 404004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 404009 */     GIR_RootConstrainSelectedInstOperands,
     /* 404010 */     // GIR_Coverage, 4963,
     /* 404010 */     GIR_Done,
     /* 404011 */   // Label 8218: @404011
     /* 404011 */   GIM_Reject,
     /* 404012 */ // Label 8216: @404012
     /* 404012 */ GIM_Reject,
     /* 404013 */ // Label 8208: @404013
     /* 404013 */ GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(404057),
     /* 404018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404029 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(404044), // Rule ID 987 //
     /* 404034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404037 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 404037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 404042 */     GIR_RootConstrainSelectedInstOperands,
     /* 404043 */     // GIR_Coverage, 987,
     /* 404043 */     GIR_Done,
     /* 404044 */   // Label 8220: @404044
     /* 404044 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(404056), // Rule ID 4967 //
     /* 404049 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 404049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 404054 */     GIR_RootConstrainSelectedInstOperands,
     /* 404055 */     // GIR_Coverage, 4967,
     /* 404055 */     GIR_Done,
     /* 404056 */   // Label 8221: @404056
     /* 404056 */   GIM_Reject,
     /* 404057 */ // Label 8219: @404057
     /* 404057 */ GIM_Reject,
     /* 404058 */ // Label 8209: @404058
     /* 404058 */ GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(404084), // Rule ID 982 //
     /* 404063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 404069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404077 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 404077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 404082 */   GIR_RootConstrainSelectedInstOperands,
     /* 404083 */   // GIR_Coverage, 982,
     /* 404083 */   GIR_Done,
     /* 404084 */ // Label 8222: @404084
     /* 404084 */ GIM_Reject,
     /* 404085 */ // Label 8210: @404085
     /* 404085 */ GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(404129),
     /* 404090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404101 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(404116), // Rule ID 985 //
     /* 404106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404109 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 404109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 404114 */     GIR_RootConstrainSelectedInstOperands,
     /* 404115 */     // GIR_Coverage, 985,
     /* 404115 */     GIR_Done,
     /* 404116 */   // Label 8224: @404116
     /* 404116 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(404128), // Rule ID 4965 //
     /* 404121 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 404121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 404126 */     GIR_RootConstrainSelectedInstOperands,
     /* 404127 */     // GIR_Coverage, 4965,
     /* 404127 */     GIR_Done,
     /* 404128 */   // Label 8225: @404128
     /* 404128 */   GIM_Reject,
     /* 404129 */ // Label 8223: @404129
     /* 404129 */ GIM_Reject,
     /* 404130 */ // Label 8211: @404130
     /* 404130 */ GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(404156), // Rule ID 983 //
     /* 404135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404149 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 404149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 404154 */   GIR_RootConstrainSelectedInstOperands,
     /* 404155 */   // GIR_Coverage, 983,
     /* 404155 */   GIR_Done,
     /* 404156 */ // Label 8226: @404156
     /* 404156 */ GIM_Reject,
     /* 404157 */ // Label 8212: @404157
     /* 404157 */ GIM_Reject,
     /* 404158 */ // Label 134: @404158
     /* 404158 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8233*/ GIMT_Encode4(404363),
     /* 404169 */ /*GILLT_s64*//*Label 8227*/ GIMT_Encode4(404201), GIMT_Encode4(0),
     /* 404177 */ /*GILLT_v2s32*//*Label 8228*/ GIMT_Encode4(404228),
     /* 404181 */ /*GILLT_v2s64*//*Label 8229*/ GIMT_Encode4(404255),
     /* 404185 */ /*GILLT_v4s16*//*Label 8230*/ GIMT_Encode4(404282),
     /* 404189 */ /*GILLT_v4s32*//*Label 8231*/ GIMT_Encode4(404309), GIMT_Encode4(0),
     /* 404197 */ /*GILLT_v8s16*//*Label 8232*/ GIMT_Encode4(404336),
     /* 404201 */ // Label 8227: @404201
     /* 404201 */ GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(404227), // Rule ID 1008 //
     /* 404206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404220 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 404220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 404225 */   GIR_RootConstrainSelectedInstOperands,
     /* 404226 */   // GIR_Coverage, 1008,
     /* 404226 */   GIR_Done,
     /* 404227 */ // Label 8234: @404227
     /* 404227 */ GIM_Reject,
     /* 404228 */ // Label 8228: @404228
     /* 404228 */ GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(404254), // Rule ID 1004 //
     /* 404233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404247 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 404247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 404252 */   GIR_RootConstrainSelectedInstOperands,
     /* 404253 */   // GIR_Coverage, 1004,
     /* 404253 */   GIR_Done,
     /* 404254 */ // Label 8235: @404254
     /* 404254 */ GIM_Reject,
     /* 404255 */ // Label 8229: @404255
     /* 404255 */ GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(404281), // Rule ID 1010 //
     /* 404260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404274 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 404274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 404279 */   GIR_RootConstrainSelectedInstOperands,
     /* 404280 */   // GIR_Coverage, 1010,
     /* 404280 */   GIR_Done,
     /* 404281 */ // Label 8236: @404281
     /* 404281 */ GIM_Reject,
     /* 404282 */ // Label 8230: @404282
     /* 404282 */ GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(404308), // Rule ID 1000 //
     /* 404287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 404293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404301 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 404301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 404306 */   GIR_RootConstrainSelectedInstOperands,
     /* 404307 */   // GIR_Coverage, 1000,
     /* 404307 */   GIR_Done,
     /* 404308 */ // Label 8237: @404308
     /* 404308 */ GIM_Reject,
     /* 404309 */ // Label 8231: @404309
     /* 404309 */ GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(404335), // Rule ID 1006 //
     /* 404314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404328 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 404328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 404333 */   GIR_RootConstrainSelectedInstOperands,
     /* 404334 */   // GIR_Coverage, 1006,
     /* 404334 */   GIR_Done,
     /* 404335 */ // Label 8238: @404335
     /* 404335 */ GIM_Reject,
     /* 404336 */ // Label 8232: @404336
     /* 404336 */ GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(404362), // Rule ID 1002 //
     /* 404341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404355 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 404355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 404360 */   GIR_RootConstrainSelectedInstOperands,
     /* 404361 */   // GIR_Coverage, 1002,
     /* 404361 */   GIR_Done,
     /* 404362 */ // Label 8239: @404362
     /* 404362 */ GIM_Reject,
     /* 404363 */ // Label 8233: @404363
     /* 404363 */ GIM_Reject,
     /* 404364 */ // Label 135: @404364
     /* 404364 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8242*/ GIMT_Encode4(404762),
     /* 404375 */ /*GILLT_v2s64*//*Label 8240*/ GIMT_Encode4(404387), GIMT_Encode4(0),
     /* 404383 */ /*GILLT_v4s32*//*Label 8241*/ GIMT_Encode4(404525),
     /* 404387 */ // Label 8240: @404387
     /* 404387 */ GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(404446), // Rule ID 5870 //
     /* 404392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404403 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 404403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 404406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 404410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 404435 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404445 */   // GIR_Coverage, 5870,
     /* 404445 */   GIR_EraseRootFromParent_Done,
     /* 404446 */ // Label 8243: @404446
     /* 404446 */ GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(404524), // Rule ID 5992 //
     /* 404451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404462 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 404462 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 404465 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 404469 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404474 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 404480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 404483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 404487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 404497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 404508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404518 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404523 */   // GIR_Coverage, 5992,
     /* 404523 */   GIR_EraseRootFromParent_Done,
     /* 404524 */ // Label 8244: @404524
     /* 404524 */ GIM_Reject,
     /* 404525 */ // Label 8241: @404525
     /* 404525 */ GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(404584), // Rule ID 5866 //
     /* 404530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 404533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404541 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 404541 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404544 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 404548 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404553 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 404573 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404583 */   // GIR_Coverage, 5866,
     /* 404583 */   GIR_EraseRootFromParent_Done,
     /* 404584 */ // Label 8245: @404584
     /* 404584 */ GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(404643), // Rule ID 5867 //
     /* 404589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404600 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 404600 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404603 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 404607 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404612 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 404632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404642 */   // GIR_Coverage, 5867,
     /* 404642 */   GIR_EraseRootFromParent_Done,
     /* 404643 */ // Label 8246: @404643
     /* 404643 */ GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(404702), // Rule ID 5868 //
     /* 404648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404659 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 404659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 404666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404671 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 404691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404701 */   // GIR_Coverage, 5868,
     /* 404701 */   GIR_EraseRootFromParent_Done,
     /* 404702 */ // Label 8247: @404702
     /* 404702 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(404761), // Rule ID 5869 //
     /* 404707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404718 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 404718 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404721 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 404725 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404730 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 404750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404760 */   // GIR_Coverage, 5869,
     /* 404760 */   GIR_EraseRootFromParent_Done,
     /* 404761 */ // Label 8248: @404761
     /* 404761 */ GIM_Reject,
     /* 404762 */ // Label 8242: @404762
     /* 404762 */ GIM_Reject,
     /* 404763 */ // Label 136: @404763
     /* 404763 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8253*/ GIMT_Encode4(405132),
     /* 404774 */ /*GILLT_v2s32*//*Label 8249*/ GIMT_Encode4(404834), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 404786 */ /*GILLT_v4s32*//*Label 8250*/ GIMT_Encode4(404954), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 404818 */ /*GILLT_nxv2s64*//*Label 8251*/ GIMT_Encode4(405074), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 404830 */ /*GILLT_nxv4s32*//*Label 8252*/ GIMT_Encode4(405103),
     /* 404834 */ // Label 8249: @404834
     /* 404834 */ GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(404953),
     /* 404839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 404845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 404848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404860 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(404933), // Rule ID 26 //
     /* 404865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 404876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404909 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404913 */     // MIs[3] Operand 1
     /* 404913 */     // No operand predicates
     /* 404913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404915 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 404918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 404922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404931 */     GIR_RootConstrainSelectedInstOperands,
     /* 404932 */     // GIR_Coverage, 26,
     /* 404932 */     GIR_EraseRootFromParent_Done,
     /* 404933 */   // Label 8255: @404933
     /* 404933 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(404952), // Rule ID 22 //
     /* 404938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404945 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 404945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 404950 */     GIR_RootConstrainSelectedInstOperands,
     /* 404951 */     // GIR_Coverage, 22,
     /* 404951 */     GIR_Done,
     /* 404952 */   // Label 8256: @404952
     /* 404952 */   GIM_Reject,
     /* 404953 */ // Label 8254: @404953
     /* 404953 */ GIM_Reject,
     /* 404954 */ // Label 8250: @404954
     /* 404954 */ GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(405073),
     /* 404959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 404965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 404968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404980 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(405053), // Rule ID 27 //
     /* 404985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 404996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405029 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405033 */     // MIs[3] Operand 1
     /* 405033 */     // No operand predicates
     /* 405033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405035 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 405038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 405042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405051 */     GIR_RootConstrainSelectedInstOperands,
     /* 405052 */     // GIR_Coverage, 27,
     /* 405052 */     GIR_EraseRootFromParent_Done,
     /* 405053 */   // Label 8258: @405053
     /* 405053 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(405072), // Rule ID 23 //
     /* 405058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 405061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405065 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 405065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 405070 */     GIR_RootConstrainSelectedInstOperands,
     /* 405071 */     // GIR_Coverage, 23,
     /* 405071 */     GIR_Done,
     /* 405072 */   // Label 8259: @405072
     /* 405072 */   GIM_Reject,
     /* 405073 */ // Label 8257: @405073
     /* 405073 */ GIM_Reject,
     /* 405074 */ // Label 8251: @405074
     /* 405074 */ GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(405102), // Rule ID 2986 //
     /* 405079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 405085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 405088 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 405091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405095 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 405095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 405100 */   GIR_RootConstrainSelectedInstOperands,
     /* 405101 */   // GIR_Coverage, 2986,
     /* 405101 */   GIR_Done,
     /* 405102 */ // Label 8260: @405102
     /* 405102 */ GIM_Reject,
     /* 405103 */ // Label 8252: @405103
     /* 405103 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(405131), // Rule ID 2985 //
     /* 405108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 405114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 405117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 405120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405124 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 405124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 405129 */   GIR_RootConstrainSelectedInstOperands,
     /* 405130 */   // GIR_Coverage, 2985,
     /* 405130 */   GIR_Done,
     /* 405131 */ // Label 8261: @405131
     /* 405131 */ GIM_Reject,
     /* 405132 */ // Label 8253: @405132
     /* 405132 */ GIM_Reject,
     /* 405133 */ // Label 137: @405133
     /* 405133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8265*/ GIMT_Encode4(405249),
     /* 405144 */ /*GILLT_s16*//*Label 8262*/ GIMT_Encode4(405156),
     /* 405148 */ /*GILLT_s32*//*Label 8263*/ GIMT_Encode4(405187),
     /* 405152 */ /*GILLT_s64*//*Label 8264*/ GIMT_Encode4(405218),
     /* 405156 */ // Label 8262: @405156
     /* 405156 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(405186), // Rule ID 1658 //
     /* 405161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 405164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 405167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 405175 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 405175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 405180 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405184 */   GIR_RootConstrainSelectedInstOperands,
     /* 405185 */   // GIR_Coverage, 1658,
     /* 405185 */   GIR_Done,
     /* 405186 */ // Label 8266: @405186
     /* 405186 */ GIM_Reject,
     /* 405187 */ // Label 8263: @405187
     /* 405187 */ GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(405217), // Rule ID 1657 //
     /* 405192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 405195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 405198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405206 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 405206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 405211 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405215 */   GIR_RootConstrainSelectedInstOperands,
     /* 405216 */   // GIR_Coverage, 1657,
     /* 405216 */   GIR_Done,
     /* 405217 */ // Label 8267: @405217
     /* 405217 */ GIM_Reject,
     /* 405218 */ // Label 8264: @405218
     /* 405218 */ GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(405248), // Rule ID 1656 //
     /* 405223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 405226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 405229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405237 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 405237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 405242 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 405246 */   GIR_RootConstrainSelectedInstOperands,
     /* 405247 */   // GIR_Coverage, 1656,
     /* 405247 */   GIR_Done,
     /* 405248 */ // Label 8268: @405248
     /* 405248 */ GIM_Reject,
     /* 405249 */ // Label 8265: @405249
     /* 405249 */ GIM_Reject,
     /* 405250 */ // Label 138: @405250
     /* 405250 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8272*/ GIMT_Encode4(406482),
     /* 405261 */ /*GILLT_v2s64*//*Label 8269*/ GIMT_Encode4(405281), GIMT_Encode4(0),
     /* 405269 */ /*GILLT_v4s32*//*Label 8270*/ GIMT_Encode4(405842), GIMT_Encode4(0),
     /* 405277 */ /*GILLT_v8s16*//*Label 8271*/ GIMT_Encode4(406403),
     /* 405281 */ // Label 8269: @405281
     /* 405281 */ GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(405841),
     /* 405286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 405292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405296 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(405388), // Rule ID 2054 //
     /* 405301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405345 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405349 */     // MIs[3] Operand 1
     /* 405349 */     // No operand predicates
     /* 405349 */     // MIs[1] Operand 2
     /* 405349 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 405360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 405369 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 405372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405386 */     GIR_RootConstrainSelectedInstOperands,
     /* 405387 */     // GIR_Coverage, 2054,
     /* 405387 */     GIR_EraseRootFromParent_Done,
     /* 405388 */   // Label 8274: @405388
     /* 405388 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(405480), // Rule ID 13480 //
     /* 405393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405437 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405441 */     // MIs[3] Operand 1
     /* 405441 */     // No operand predicates
     /* 405441 */     // MIs[1] Operand 2
     /* 405441 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 405452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 405461 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 405464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405478 */     GIR_RootConstrainSelectedInstOperands,
     /* 405479 */     // GIR_Coverage, 13480,
     /* 405479 */     GIR_EraseRootFromParent_Done,
     /* 405480 */   // Label 8275: @405480
     /* 405480 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(405566), // Rule ID 13478 //
     /* 405485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405529 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405533 */     // MIs[3] Operand 1
     /* 405533 */     // No operand predicates
     /* 405533 */     // MIs[1] Operand 2
     /* 405533 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405550 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 405553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405564 */     GIR_RootConstrainSelectedInstOperands,
     /* 405565 */     // GIR_Coverage, 13478,
     /* 405565 */     GIR_EraseRootFromParent_Done,
     /* 405566 */   // Label 8276: @405566
     /* 405566 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(405652), // Rule ID 2052 //
     /* 405571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405619 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405623 */     // MIs[3] Operand 1
     /* 405623 */     // No operand predicates
     /* 405623 */     // MIs[1] Operand 2
     /* 405623 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405636 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 405639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405650 */     GIR_RootConstrainSelectedInstOperands,
     /* 405651 */     // GIR_Coverage, 2052,
     /* 405651 */     GIR_EraseRootFromParent_Done,
     /* 405652 */   // Label 8277: @405652
     /* 405652 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(405691), // Rule ID 1741 //
     /* 405657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 405667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 405674 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 405674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 405677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405689 */     GIR_RootConstrainSelectedInstOperands,
     /* 405690 */     // GIR_Coverage, 1741,
     /* 405690 */     GIR_EraseRootFromParent_Done,
     /* 405691 */   // Label 8278: @405691
     /* 405691 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(405754), // Rule ID 13479 //
     /* 405696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405732 */     // MIs[2] Operand 1
     /* 405732 */     // No operand predicates
     /* 405732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405738 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 405741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405752 */     GIR_RootConstrainSelectedInstOperands,
     /* 405753 */     // GIR_Coverage, 13479,
     /* 405753 */     GIR_EraseRootFromParent_Done,
     /* 405754 */   // Label 8279: @405754
     /* 405754 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(405817), // Rule ID 2053 //
     /* 405759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405795 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405799 */     // MIs[2] Operand 1
     /* 405799 */     // No operand predicates
     /* 405799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405801 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 405804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405815 */     GIR_RootConstrainSelectedInstOperands,
     /* 405816 */     // GIR_Coverage, 2053,
     /* 405816 */     GIR_EraseRootFromParent_Done,
     /* 405817 */   // Label 8280: @405817
     /* 405817 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(405840), // Rule ID 1740 //
     /* 405822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405833 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 405833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 405838 */     GIR_RootConstrainSelectedInstOperands,
     /* 405839 */     // GIR_Coverage, 1740,
     /* 405839 */     GIR_Done,
     /* 405840 */   // Label 8281: @405840
     /* 405840 */   GIM_Reject,
     /* 405841 */ // Label 8273: @405841
     /* 405841 */ GIM_Reject,
     /* 405842 */ // Label 8270: @405842
     /* 405842 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(406402),
     /* 405847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405857 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(405949), // Rule ID 2051 //
     /* 405862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405910 */     // MIs[3] Operand 1
     /* 405910 */     // No operand predicates
     /* 405910 */     // MIs[1] Operand 2
     /* 405910 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 405921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405930 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 405933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405947 */     GIR_RootConstrainSelectedInstOperands,
     /* 405948 */     // GIR_Coverage, 2051,
     /* 405948 */     GIR_EraseRootFromParent_Done,
     /* 405949 */   // Label 8283: @405949
     /* 405949 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(406041), // Rule ID 13477 //
     /* 405954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405998 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 406002 */     // MIs[3] Operand 1
     /* 406002 */     // No operand predicates
     /* 406002 */     // MIs[1] Operand 2
     /* 406002 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 406013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 406022 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 406022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 406025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 406032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406039 */     GIR_RootConstrainSelectedInstOperands,
     /* 406040 */     // GIR_Coverage, 13477,
     /* 406040 */     GIR_EraseRootFromParent_Done,
     /* 406041 */   // Label 8284: @406041
     /* 406041 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(406127), // Rule ID 13475 //
     /* 406046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 406057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 406069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 406082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406090 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 406094 */     // MIs[3] Operand 1
     /* 406094 */     // No operand predicates
     /* 406094 */     // MIs[1] Operand 2
     /* 406094 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 406105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406109 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406111 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 406111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 406114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406125 */     GIR_RootConstrainSelectedInstOperands,
     /* 406126 */     // GIR_Coverage, 13475,
     /* 406126 */     GIR_EraseRootFromParent_Done,
     /* 406127 */   // Label 8285: @406127
     /* 406127 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(406213), // Rule ID 2049 //
     /* 406132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 406147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 406159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 406172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 406184 */     // MIs[3] Operand 1
     /* 406184 */     // No operand predicates
     /* 406184 */     // MIs[1] Operand 2
     /* 406184 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 406195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406197 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 406197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 406200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406211 */     GIR_RootConstrainSelectedInstOperands,
     /* 406212 */     // GIR_Coverage, 2049,
     /* 406212 */     GIR_EraseRootFromParent_Done,
     /* 406213 */   // Label 8286: @406213
     /* 406213 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(406252), // Rule ID 1739 //
     /* 406218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 406228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 406235 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 406235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 406238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 406245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 406250 */     GIR_RootConstrainSelectedInstOperands,
     /* 406251 */     // GIR_Coverage, 1739,
     /* 406251 */     GIR_EraseRootFromParent_Done,
     /* 406252 */   // Label 8287: @406252
     /* 406252 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(406315), // Rule ID 13476 //
     /* 406257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 406268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 406281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 406293 */     // MIs[2] Operand 1
     /* 406293 */     // No operand predicates
     /* 406293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406299 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 406299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 406302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406313 */     GIR_RootConstrainSelectedInstOperands,
     /* 406314 */     // GIR_Coverage, 13476,
     /* 406314 */     GIR_EraseRootFromParent_Done,
     /* 406315 */   // Label 8288: @406315
     /* 406315 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(406378), // Rule ID 2050 //
     /* 406320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 406335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 406348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 406360 */     // MIs[2] Operand 1
     /* 406360 */     // No operand predicates
     /* 406360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406362 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 406362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 406365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406376 */     GIR_RootConstrainSelectedInstOperands,
     /* 406377 */     // GIR_Coverage, 2050,
     /* 406377 */     GIR_EraseRootFromParent_Done,
     /* 406378 */   // Label 8289: @406378
     /* 406378 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(406401), // Rule ID 1738 //
     /* 406383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406394 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 406394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 406399 */     GIR_RootConstrainSelectedInstOperands,
     /* 406400 */     // GIR_Coverage, 1738,
     /* 406400 */     GIR_Done,
     /* 406401 */   // Label 8290: @406401
     /* 406401 */   GIM_Reject,
     /* 406402 */ // Label 8282: @406402
     /* 406402 */ GIM_Reject,
     /* 406403 */ // Label 8271: @406403
     /* 406403 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(406481),
     /* 406408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 406414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406418 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(406457), // Rule ID 1737 //
     /* 406423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 406433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 406440 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 406440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 406443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 406450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 406455 */     GIR_RootConstrainSelectedInstOperands,
     /* 406456 */     // GIR_Coverage, 1737,
     /* 406456 */     GIR_EraseRootFromParent_Done,
     /* 406457 */   // Label 8292: @406457
     /* 406457 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(406480), // Rule ID 1736 //
     /* 406462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406473 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 406473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 406478 */     GIR_RootConstrainSelectedInstOperands,
     /* 406479 */     // GIR_Coverage, 1736,
     /* 406479 */     GIR_Done,
     /* 406480 */   // Label 8293: @406480
     /* 406480 */   GIM_Reject,
     /* 406481 */ // Label 8291: @406481
     /* 406481 */ GIM_Reject,
     /* 406482 */ // Label 8272: @406482
     /* 406482 */ GIM_Reject,
     /* 406483 */ // Label 139: @406483
     /* 406483 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8312*/ GIMT_Encode4(407262),
     /* 406494 */ /*GILLT_v2s32*//*Label 8294*/ GIMT_Encode4(406570),
     /* 406498 */ /*GILLT_v2s64*//*Label 8295*/ GIMT_Encode4(406625),
     /* 406502 */ /*GILLT_v4s16*//*Label 8296*/ GIMT_Encode4(406680),
     /* 406506 */ /*GILLT_v4s32*//*Label 8297*/ GIMT_Encode4(406735),
     /* 406510 */ /*GILLT_v8s8*//*Label 8298*/ GIMT_Encode4(406790),
     /* 406514 */ /*GILLT_v8s16*//*Label 8299*/ GIMT_Encode4(406824),
     /* 406518 */ /*GILLT_v16s8*//*Label 8300*/ GIMT_Encode4(406879), GIMT_Encode4(0),
     /* 406526 */ /*GILLT_nxv2s1*//*Label 8301*/ GIMT_Encode4(406913),
     /* 406530 */ /*GILLT_nxv2s16*//*Label 8302*/ GIMT_Encode4(406939),
     /* 406534 */ /*GILLT_nxv2s32*//*Label 8303*/ GIMT_Encode4(406965),
     /* 406538 */ /*GILLT_nxv2s64*//*Label 8304*/ GIMT_Encode4(406991),
     /* 406542 */ /*GILLT_nxv4s1*//*Label 8305*/ GIMT_Encode4(407038),
     /* 406546 */ /*GILLT_nxv4s16*//*Label 8306*/ GIMT_Encode4(407064),
     /* 406550 */ /*GILLT_nxv4s32*//*Label 8307*/ GIMT_Encode4(407090),
     /* 406554 */ /*GILLT_nxv8s1*//*Label 8308*/ GIMT_Encode4(407137),
     /* 406558 */ /*GILLT_nxv8s16*//*Label 8309*/ GIMT_Encode4(407163),
     /* 406562 */ /*GILLT_nxv16s1*//*Label 8310*/ GIMT_Encode4(407210),
     /* 406566 */ /*GILLT_nxv16s8*//*Label 8311*/ GIMT_Encode4(407236),
     /* 406570 */ // Label 8294: @406570
     /* 406570 */ GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(406624),
     /* 406575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 406581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406593 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(406608), // Rule ID 1874 //
     /* 406598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406601 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 406601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 406606 */     GIR_RootConstrainSelectedInstOperands,
     /* 406607 */     // GIR_Coverage, 1874,
     /* 406607 */     GIR_Done,
     /* 406608 */   // Label 8314: @406608
     /* 406608 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(406623), // Rule ID 2505 //
     /* 406613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406616 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 406621 */     GIR_RootConstrainSelectedInstOperands,
     /* 406622 */     // GIR_Coverage, 2505,
     /* 406622 */     GIR_Done,
     /* 406623 */   // Label 8315: @406623
     /* 406623 */   GIM_Reject,
     /* 406624 */ // Label 8313: @406624
     /* 406624 */ GIM_Reject,
     /* 406625 */ // Label 8295: @406625
     /* 406625 */ GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(406679),
     /* 406630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 406636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406648 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(406663), // Rule ID 1876 //
     /* 406653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406656 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 406656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 406661 */     GIR_RootConstrainSelectedInstOperands,
     /* 406662 */     // GIR_Coverage, 1876,
     /* 406662 */     GIR_Done,
     /* 406663 */   // Label 8317: @406663
     /* 406663 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(406678), // Rule ID 2507 //
     /* 406668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406671 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 406676 */     GIR_RootConstrainSelectedInstOperands,
     /* 406677 */     // GIR_Coverage, 2507,
     /* 406677 */     GIR_Done,
     /* 406678 */   // Label 8318: @406678
     /* 406678 */   GIM_Reject,
     /* 406679 */ // Label 8316: @406679
     /* 406679 */ GIM_Reject,
     /* 406680 */ // Label 8296: @406680
     /* 406680 */ GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(406734),
     /* 406685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 406691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406703 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(406718), // Rule ID 1872 //
     /* 406708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406711 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 406711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 406716 */     GIR_RootConstrainSelectedInstOperands,
     /* 406717 */     // GIR_Coverage, 1872,
     /* 406717 */     GIR_Done,
     /* 406718 */   // Label 8320: @406718
     /* 406718 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(406733), // Rule ID 2503 //
     /* 406723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406726 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 406726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 406731 */     GIR_RootConstrainSelectedInstOperands,
     /* 406732 */     // GIR_Coverage, 2503,
     /* 406732 */     GIR_Done,
     /* 406733 */   // Label 8321: @406733
     /* 406733 */   GIM_Reject,
     /* 406734 */ // Label 8319: @406734
     /* 406734 */ GIM_Reject,
     /* 406735 */ // Label 8297: @406735
     /* 406735 */ GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(406789),
     /* 406740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 406746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406758 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(406773), // Rule ID 1875 //
     /* 406763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406766 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 406766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 406771 */     GIR_RootConstrainSelectedInstOperands,
     /* 406772 */     // GIR_Coverage, 1875,
     /* 406772 */     GIR_Done,
     /* 406773 */   // Label 8323: @406773
     /* 406773 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(406788), // Rule ID 2506 //
     /* 406778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406781 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 406786 */     GIR_RootConstrainSelectedInstOperands,
     /* 406787 */     // GIR_Coverage, 2506,
     /* 406787 */     GIR_Done,
     /* 406788 */   // Label 8324: @406788
     /* 406788 */   GIM_Reject,
     /* 406789 */ // Label 8322: @406789
     /* 406789 */ GIM_Reject,
     /* 406790 */ // Label 8298: @406790
     /* 406790 */ GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(406823), // Rule ID 1870 //
     /* 406795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 406804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406816 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 406816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 406821 */   GIR_RootConstrainSelectedInstOperands,
     /* 406822 */   // GIR_Coverage, 1870,
     /* 406822 */   GIR_Done,
     /* 406823 */ // Label 8325: @406823
     /* 406823 */ GIM_Reject,
     /* 406824 */ // Label 8299: @406824
     /* 406824 */ GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(406878),
     /* 406829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 406835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406847 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(406862), // Rule ID 1873 //
     /* 406852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406855 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 406855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 406860 */     GIR_RootConstrainSelectedInstOperands,
     /* 406861 */     // GIR_Coverage, 1873,
     /* 406861 */     GIR_Done,
     /* 406862 */   // Label 8327: @406862
     /* 406862 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(406877), // Rule ID 2504 //
     /* 406867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406870 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 406875 */     GIR_RootConstrainSelectedInstOperands,
     /* 406876 */     // GIR_Coverage, 2504,
     /* 406876 */     GIR_Done,
     /* 406877 */   // Label 8328: @406877
     /* 406877 */   GIM_Reject,
     /* 406878 */ // Label 8326: @406878
     /* 406878 */ GIM_Reject,
     /* 406879 */ // Label 8300: @406879
     /* 406879 */ GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(406912), // Rule ID 1871 //
     /* 406884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 406893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406905 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 406905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 406910 */   GIR_RootConstrainSelectedInstOperands,
     /* 406911 */   // GIR_Coverage, 1871,
     /* 406911 */   GIR_Done,
     /* 406912 */ // Label 8329: @406912
     /* 406912 */ GIM_Reject,
     /* 406913 */ // Label 8301: @406913
     /* 406913 */ GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(406938), // Rule ID 8943 //
     /* 406918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 406924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 406927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406931 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 406931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 406936 */   GIR_RootConstrainSelectedInstOperands,
     /* 406937 */   // GIR_Coverage, 8943,
     /* 406937 */   GIR_Done,
     /* 406938 */ // Label 8330: @406938
     /* 406938 */ GIM_Reject,
     /* 406939 */ // Label 8302: @406939
     /* 406939 */ GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(406964), // Rule ID 8919 //
     /* 406944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 406950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 406953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406957 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 406957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406962 */   GIR_RootConstrainSelectedInstOperands,
     /* 406963 */   // GIR_Coverage, 8919,
     /* 406963 */   GIR_Done,
     /* 406964 */ // Label 8331: @406964
     /* 406964 */ GIM_Reject,
     /* 406965 */ // Label 8303: @406965
     /* 406965 */ GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(406990), // Rule ID 8920 //
     /* 406970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 406976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 406979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406983 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 406983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406988 */   GIR_RootConstrainSelectedInstOperands,
     /* 406989 */   // GIR_Coverage, 8920,
     /* 406989 */   GIR_Done,
     /* 406990 */ // Label 8332: @406990
     /* 406990 */ GIM_Reject,
     /* 406991 */ // Label 8304: @406991
     /* 406991 */ GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(407037),
     /* 406996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 406999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 407002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407006 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(407021), // Rule ID 8915 //
     /* 407011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407014 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 407014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 407019 */     GIR_RootConstrainSelectedInstOperands,
     /* 407020 */     // GIR_Coverage, 8915,
     /* 407020 */     GIR_Done,
     /* 407021 */   // Label 8334: @407021
     /* 407021 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(407036), // Rule ID 8921 //
     /* 407026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407029 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 407029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 407034 */     GIR_RootConstrainSelectedInstOperands,
     /* 407035 */     // GIR_Coverage, 8921,
     /* 407035 */     GIR_Done,
     /* 407036 */   // Label 8335: @407036
     /* 407036 */   GIM_Reject,
     /* 407037 */ // Label 8333: @407037
     /* 407037 */ GIM_Reject,
     /* 407038 */ // Label 8305: @407038
     /* 407038 */ GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(407063), // Rule ID 8942 //
     /* 407043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 407049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 407052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407056 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 407056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 407061 */   GIR_RootConstrainSelectedInstOperands,
     /* 407062 */   // GIR_Coverage, 8942,
     /* 407062 */   GIR_Done,
     /* 407063 */ // Label 8336: @407063
     /* 407063 */ GIM_Reject,
     /* 407064 */ // Label 8306: @407064
     /* 407064 */ GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(407089), // Rule ID 8917 //
     /* 407069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 407075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 407078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407082 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 407082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 407087 */   GIR_RootConstrainSelectedInstOperands,
     /* 407088 */   // GIR_Coverage, 8917,
     /* 407088 */   GIR_Done,
     /* 407089 */ // Label 8337: @407089
     /* 407089 */ GIM_Reject,
     /* 407090 */ // Label 8307: @407090
     /* 407090 */ GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(407136),
     /* 407095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 407098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 407101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407105 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(407120), // Rule ID 8914 //
     /* 407110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407113 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 407113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 407118 */     GIR_RootConstrainSelectedInstOperands,
     /* 407119 */     // GIR_Coverage, 8914,
     /* 407119 */     GIR_Done,
     /* 407120 */   // Label 8339: @407120
     /* 407120 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(407135), // Rule ID 8918 //
     /* 407125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407128 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 407128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 407133 */     GIR_RootConstrainSelectedInstOperands,
     /* 407134 */     // GIR_Coverage, 8918,
     /* 407134 */     GIR_Done,
     /* 407135 */   // Label 8340: @407135
     /* 407135 */   GIM_Reject,
     /* 407136 */ // Label 8338: @407136
     /* 407136 */ GIM_Reject,
     /* 407137 */ // Label 8308: @407137
     /* 407137 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(407162), // Rule ID 8941 //
     /* 407142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 407148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 407151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407155 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 407155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 407160 */   GIR_RootConstrainSelectedInstOperands,
     /* 407161 */   // GIR_Coverage, 8941,
     /* 407161 */   GIR_Done,
     /* 407162 */ // Label 8341: @407162
     /* 407162 */ GIM_Reject,
     /* 407163 */ // Label 8309: @407163
     /* 407163 */ GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(407209),
     /* 407168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 407171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 407174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407178 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(407193), // Rule ID 8913 //
     /* 407183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407186 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 407186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 407191 */     GIR_RootConstrainSelectedInstOperands,
     /* 407192 */     // GIR_Coverage, 8913,
     /* 407192 */     GIR_Done,
     /* 407193 */   // Label 8343: @407193
     /* 407193 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(407208), // Rule ID 8916 //
     /* 407198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407201 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 407201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 407206 */     GIR_RootConstrainSelectedInstOperands,
     /* 407207 */     // GIR_Coverage, 8916,
     /* 407207 */     GIR_Done,
     /* 407208 */   // Label 8344: @407208
     /* 407208 */   GIM_Reject,
     /* 407209 */ // Label 8342: @407209
     /* 407209 */ GIM_Reject,
     /* 407210 */ // Label 8310: @407210
     /* 407210 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(407235), // Rule ID 2414 //
     /* 407215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 407221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 407224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407228 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 407228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 407233 */   GIR_RootConstrainSelectedInstOperands,
     /* 407234 */   // GIR_Coverage, 2414,
     /* 407234 */   GIR_Done,
     /* 407235 */ // Label 8345: @407235
     /* 407235 */ GIM_Reject,
     /* 407236 */ // Label 8311: @407236
     /* 407236 */ GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(407261), // Rule ID 8912 //
     /* 407241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 407247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 407250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407254 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 407254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 407259 */   GIR_RootConstrainSelectedInstOperands,
     /* 407260 */   // GIR_Coverage, 8912,
     /* 407260 */   GIR_Done,
     /* 407261 */ // Label 8346: @407261
     /* 407261 */ GIM_Reject,
     /* 407262 */ // Label 8312: @407262
     /* 407262 */ GIM_Reject,
     /* 407263 */ // Label 140: @407263
     /* 407263 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8365*/ GIMT_Encode4(408042),
     /* 407274 */ /*GILLT_v2s32*//*Label 8347*/ GIMT_Encode4(407350),
     /* 407278 */ /*GILLT_v2s64*//*Label 8348*/ GIMT_Encode4(407405),
     /* 407282 */ /*GILLT_v4s16*//*Label 8349*/ GIMT_Encode4(407460),
     /* 407286 */ /*GILLT_v4s32*//*Label 8350*/ GIMT_Encode4(407515),
     /* 407290 */ /*GILLT_v8s8*//*Label 8351*/ GIMT_Encode4(407570),
     /* 407294 */ /*GILLT_v8s16*//*Label 8352*/ GIMT_Encode4(407604),
     /* 407298 */ /*GILLT_v16s8*//*Label 8353*/ GIMT_Encode4(407659), GIMT_Encode4(0),
     /* 407306 */ /*GILLT_nxv2s1*//*Label 8354*/ GIMT_Encode4(407693),
     /* 407310 */ /*GILLT_nxv2s16*//*Label 8355*/ GIMT_Encode4(407719),
     /* 407314 */ /*GILLT_nxv2s32*//*Label 8356*/ GIMT_Encode4(407745),
     /* 407318 */ /*GILLT_nxv2s64*//*Label 8357*/ GIMT_Encode4(407771),
     /* 407322 */ /*GILLT_nxv4s1*//*Label 8358*/ GIMT_Encode4(407818),
     /* 407326 */ /*GILLT_nxv4s16*//*Label 8359*/ GIMT_Encode4(407844),
     /* 407330 */ /*GILLT_nxv4s32*//*Label 8360*/ GIMT_Encode4(407870),
     /* 407334 */ /*GILLT_nxv8s1*//*Label 8361*/ GIMT_Encode4(407917),
     /* 407338 */ /*GILLT_nxv8s16*//*Label 8362*/ GIMT_Encode4(407943),
     /* 407342 */ /*GILLT_nxv16s1*//*Label 8363*/ GIMT_Encode4(407990),
     /* 407346 */ /*GILLT_nxv16s8*//*Label 8364*/ GIMT_Encode4(408016),
     /* 407350 */ // Label 8347: @407350
     /* 407350 */ GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(407404),
     /* 407355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 407361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407373 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(407388), // Rule ID 1881 //
     /* 407378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407381 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 407381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 407386 */     GIR_RootConstrainSelectedInstOperands,
     /* 407387 */     // GIR_Coverage, 1881,
     /* 407387 */     GIR_Done,
     /* 407388 */   // Label 8367: @407388
     /* 407388 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(407403), // Rule ID 5469 //
     /* 407393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407396 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 407396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 407401 */     GIR_RootConstrainSelectedInstOperands,
     /* 407402 */     // GIR_Coverage, 5469,
     /* 407402 */     GIR_Done,
     /* 407403 */   // Label 8368: @407403
     /* 407403 */   GIM_Reject,
     /* 407404 */ // Label 8366: @407404
     /* 407404 */ GIM_Reject,
     /* 407405 */ // Label 8348: @407405
     /* 407405 */ GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(407459),
     /* 407410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 407416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407428 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(407443), // Rule ID 1883 //
     /* 407433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407436 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 407436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 407441 */     GIR_RootConstrainSelectedInstOperands,
     /* 407442 */     // GIR_Coverage, 1883,
     /* 407442 */     GIR_Done,
     /* 407443 */   // Label 8370: @407443
     /* 407443 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(407458), // Rule ID 5471 //
     /* 407448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407451 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 407451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 407456 */     GIR_RootConstrainSelectedInstOperands,
     /* 407457 */     // GIR_Coverage, 5471,
     /* 407457 */     GIR_Done,
     /* 407458 */   // Label 8371: @407458
     /* 407458 */   GIM_Reject,
     /* 407459 */ // Label 8369: @407459
     /* 407459 */ GIM_Reject,
     /* 407460 */ // Label 8349: @407460
     /* 407460 */ GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(407514),
     /* 407465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 407471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407483 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(407498), // Rule ID 1879 //
     /* 407488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407491 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 407491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 407496 */     GIR_RootConstrainSelectedInstOperands,
     /* 407497 */     // GIR_Coverage, 1879,
     /* 407497 */     GIR_Done,
     /* 407498 */   // Label 8373: @407498
     /* 407498 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(407513), // Rule ID 5467 //
     /* 407503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407506 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 407506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 407511 */     GIR_RootConstrainSelectedInstOperands,
     /* 407512 */     // GIR_Coverage, 5467,
     /* 407512 */     GIR_Done,
     /* 407513 */   // Label 8374: @407513
     /* 407513 */   GIM_Reject,
     /* 407514 */ // Label 8372: @407514
     /* 407514 */ GIM_Reject,
     /* 407515 */ // Label 8350: @407515
     /* 407515 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(407569),
     /* 407520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 407526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407538 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(407553), // Rule ID 1882 //
     /* 407543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407546 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 407546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 407551 */     GIR_RootConstrainSelectedInstOperands,
     /* 407552 */     // GIR_Coverage, 1882,
     /* 407552 */     GIR_Done,
     /* 407553 */   // Label 8376: @407553
     /* 407553 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(407568), // Rule ID 5470 //
     /* 407558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407561 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 407561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 407566 */     GIR_RootConstrainSelectedInstOperands,
     /* 407567 */     // GIR_Coverage, 5470,
     /* 407567 */     GIR_Done,
     /* 407568 */   // Label 8377: @407568
     /* 407568 */   GIM_Reject,
     /* 407569 */ // Label 8375: @407569
     /* 407569 */ GIM_Reject,
     /* 407570 */ // Label 8351: @407570
     /* 407570 */ GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(407603), // Rule ID 1877 //
     /* 407575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 407584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407596 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 407596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 407601 */   GIR_RootConstrainSelectedInstOperands,
     /* 407602 */   // GIR_Coverage, 1877,
     /* 407602 */   GIR_Done,
     /* 407603 */ // Label 8378: @407603
     /* 407603 */ GIM_Reject,
     /* 407604 */ // Label 8352: @407604
     /* 407604 */ GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(407658),
     /* 407609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 407615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407627 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(407642), // Rule ID 1880 //
     /* 407632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407635 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 407635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 407640 */     GIR_RootConstrainSelectedInstOperands,
     /* 407641 */     // GIR_Coverage, 1880,
     /* 407641 */     GIR_Done,
     /* 407642 */   // Label 8380: @407642
     /* 407642 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(407657), // Rule ID 5468 //
     /* 407647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407650 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 407650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 407655 */     GIR_RootConstrainSelectedInstOperands,
     /* 407656 */     // GIR_Coverage, 5468,
     /* 407656 */     GIR_Done,
     /* 407657 */   // Label 8381: @407657
     /* 407657 */   GIM_Reject,
     /* 407658 */ // Label 8379: @407658
     /* 407658 */ GIM_Reject,
     /* 407659 */ // Label 8353: @407659
     /* 407659 */ GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(407692), // Rule ID 1878 //
     /* 407664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 407673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407685 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 407685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 407690 */   GIR_RootConstrainSelectedInstOperands,
     /* 407691 */   // GIR_Coverage, 1878,
     /* 407691 */   GIR_Done,
     /* 407692 */ // Label 8382: @407692
     /* 407692 */ GIM_Reject,
     /* 407693 */ // Label 8354: @407693
     /* 407693 */ GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(407718), // Rule ID 8946 //
     /* 407698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 407704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 407707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407711 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 407711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 407716 */   GIR_RootConstrainSelectedInstOperands,
     /* 407717 */   // GIR_Coverage, 8946,
     /* 407717 */   GIR_Done,
     /* 407718 */ // Label 8383: @407718
     /* 407718 */ GIM_Reject,
     /* 407719 */ // Label 8355: @407719
     /* 407719 */ GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(407744), // Rule ID 8929 //
     /* 407724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 407730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 407733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407737 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 407737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 407742 */   GIR_RootConstrainSelectedInstOperands,
     /* 407743 */   // GIR_Coverage, 8929,
     /* 407743 */   GIR_Done,
     /* 407744 */ // Label 8384: @407744
     /* 407744 */ GIM_Reject,
     /* 407745 */ // Label 8356: @407745
     /* 407745 */ GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(407770), // Rule ID 8930 //
     /* 407750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 407756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 407759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407763 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 407763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 407768 */   GIR_RootConstrainSelectedInstOperands,
     /* 407769 */   // GIR_Coverage, 8930,
     /* 407769 */   GIR_Done,
     /* 407770 */ // Label 8385: @407770
     /* 407770 */ GIM_Reject,
     /* 407771 */ // Label 8357: @407771
     /* 407771 */ GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(407817),
     /* 407776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 407779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 407782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407786 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(407801), // Rule ID 8925 //
     /* 407791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407794 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 407794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 407799 */     GIR_RootConstrainSelectedInstOperands,
     /* 407800 */     // GIR_Coverage, 8925,
     /* 407800 */     GIR_Done,
     /* 407801 */   // Label 8387: @407801
     /* 407801 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(407816), // Rule ID 8931 //
     /* 407806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407809 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 407809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 407814 */     GIR_RootConstrainSelectedInstOperands,
     /* 407815 */     // GIR_Coverage, 8931,
     /* 407815 */     GIR_Done,
     /* 407816 */   // Label 8388: @407816
     /* 407816 */   GIM_Reject,
     /* 407817 */ // Label 8386: @407817
     /* 407817 */ GIM_Reject,
     /* 407818 */ // Label 8358: @407818
     /* 407818 */ GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(407843), // Rule ID 8945 //
     /* 407823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 407829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 407832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407836 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 407836 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 407841 */   GIR_RootConstrainSelectedInstOperands,
     /* 407842 */   // GIR_Coverage, 8945,
     /* 407842 */   GIR_Done,
     /* 407843 */ // Label 8389: @407843
     /* 407843 */ GIM_Reject,
     /* 407844 */ // Label 8359: @407844
     /* 407844 */ GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(407869), // Rule ID 8927 //
     /* 407849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 407855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 407858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407862 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 407862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 407867 */   GIR_RootConstrainSelectedInstOperands,
     /* 407868 */   // GIR_Coverage, 8927,
     /* 407868 */   GIR_Done,
     /* 407869 */ // Label 8390: @407869
     /* 407869 */ GIM_Reject,
     /* 407870 */ // Label 8360: @407870
     /* 407870 */ GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(407916),
     /* 407875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 407878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 407881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407885 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(407900), // Rule ID 8924 //
     /* 407890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407893 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 407893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 407898 */     GIR_RootConstrainSelectedInstOperands,
     /* 407899 */     // GIR_Coverage, 8924,
     /* 407899 */     GIR_Done,
     /* 407900 */   // Label 8392: @407900
     /* 407900 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(407915), // Rule ID 8928 //
     /* 407905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407908 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 407908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 407913 */     GIR_RootConstrainSelectedInstOperands,
     /* 407914 */     // GIR_Coverage, 8928,
     /* 407914 */     GIR_Done,
     /* 407915 */   // Label 8393: @407915
     /* 407915 */   GIM_Reject,
     /* 407916 */ // Label 8391: @407916
     /* 407916 */ GIM_Reject,
     /* 407917 */ // Label 8361: @407917
     /* 407917 */ GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(407942), // Rule ID 8944 //
     /* 407922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 407928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 407931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407935 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 407935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 407940 */   GIR_RootConstrainSelectedInstOperands,
     /* 407941 */   // GIR_Coverage, 8944,
     /* 407941 */   GIR_Done,
     /* 407942 */ // Label 8394: @407942
     /* 407942 */ GIM_Reject,
     /* 407943 */ // Label 8362: @407943
     /* 407943 */ GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(407989),
     /* 407948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 407951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 407954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407958 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(407973), // Rule ID 8923 //
     /* 407963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407966 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 407966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 407971 */     GIR_RootConstrainSelectedInstOperands,
     /* 407972 */     // GIR_Coverage, 8923,
     /* 407972 */     GIR_Done,
     /* 407973 */   // Label 8396: @407973
     /* 407973 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(407988), // Rule ID 8926 //
     /* 407978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407981 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 407981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 407986 */     GIR_RootConstrainSelectedInstOperands,
     /* 407987 */     // GIR_Coverage, 8926,
     /* 407987 */     GIR_Done,
     /* 407988 */   // Label 8397: @407988
     /* 407988 */   GIM_Reject,
     /* 407989 */ // Label 8395: @407989
     /* 407989 */ GIM_Reject,
     /* 407990 */ // Label 8363: @407990
     /* 407990 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(408015), // Rule ID 2418 //
     /* 407995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 408001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 408004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 408008 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 408008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 408013 */   GIR_RootConstrainSelectedInstOperands,
     /* 408014 */   // GIR_Coverage, 2418,
     /* 408014 */   GIR_Done,
     /* 408015 */ // Label 8398: @408015
     /* 408015 */ GIM_Reject,
     /* 408016 */ // Label 8364: @408016
     /* 408016 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(408041), // Rule ID 8922 //
     /* 408021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 408027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 408030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408034 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 408034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 408039 */   GIR_RootConstrainSelectedInstOperands,
     /* 408040 */   // GIR_Coverage, 8922,
     /* 408040 */   GIR_Done,
     /* 408041 */ // Label 8399: @408041
     /* 408041 */ GIM_Reject,
     /* 408042 */ // Label 8365: @408042
     /* 408042 */ GIM_Reject,
     /* 408043 */ // Label 141: @408043
     /* 408043 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8406*/ GIMT_Encode4(408248),
     /* 408054 */ /*GILLT_s64*//*Label 8400*/ GIMT_Encode4(408086), GIMT_Encode4(0),
     /* 408062 */ /*GILLT_v2s32*//*Label 8401*/ GIMT_Encode4(408113),
     /* 408066 */ /*GILLT_v2s64*//*Label 8402*/ GIMT_Encode4(408140),
     /* 408070 */ /*GILLT_v4s16*//*Label 8403*/ GIMT_Encode4(408167),
     /* 408074 */ /*GILLT_v4s32*//*Label 8404*/ GIMT_Encode4(408194), GIMT_Encode4(0),
     /* 408082 */ /*GILLT_v8s16*//*Label 8405*/ GIMT_Encode4(408221),
     /* 408086 */ // Label 8400: @408086
     /* 408086 */ GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(408112), // Rule ID 1069 //
     /* 408091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408105 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 408105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 408110 */   GIR_RootConstrainSelectedInstOperands,
     /* 408111 */   // GIR_Coverage, 1069,
     /* 408111 */   GIR_Done,
     /* 408112 */ // Label 8407: @408112
     /* 408112 */ GIM_Reject,
     /* 408113 */ // Label 8401: @408113
     /* 408113 */ GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(408139), // Rule ID 1065 //
     /* 408118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408132 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 408132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 408137 */   GIR_RootConstrainSelectedInstOperands,
     /* 408138 */   // GIR_Coverage, 1065,
     /* 408138 */   GIR_Done,
     /* 408139 */ // Label 8408: @408139
     /* 408139 */ GIM_Reject,
     /* 408140 */ // Label 8402: @408140
     /* 408140 */ GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(408166), // Rule ID 1071 //
     /* 408145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408159 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 408159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 408164 */   GIR_RootConstrainSelectedInstOperands,
     /* 408165 */   // GIR_Coverage, 1071,
     /* 408165 */   GIR_Done,
     /* 408166 */ // Label 8409: @408166
     /* 408166 */ GIM_Reject,
     /* 408167 */ // Label 8403: @408167
     /* 408167 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(408193), // Rule ID 1061 //
     /* 408172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408186 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 408186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 408191 */   GIR_RootConstrainSelectedInstOperands,
     /* 408192 */   // GIR_Coverage, 1061,
     /* 408192 */   GIR_Done,
     /* 408193 */ // Label 8410: @408193
     /* 408193 */ GIM_Reject,
     /* 408194 */ // Label 8404: @408194
     /* 408194 */ GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(408220), // Rule ID 1067 //
     /* 408199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408213 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 408213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 408218 */   GIR_RootConstrainSelectedInstOperands,
     /* 408219 */   // GIR_Coverage, 1067,
     /* 408219 */   GIR_Done,
     /* 408220 */ // Label 8411: @408220
     /* 408220 */ GIM_Reject,
     /* 408221 */ // Label 8405: @408221
     /* 408221 */ GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(408247), // Rule ID 1063 //
     /* 408226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408240 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 408240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 408245 */   GIR_RootConstrainSelectedInstOperands,
     /* 408246 */   // GIR_Coverage, 1063,
     /* 408246 */   GIR_Done,
     /* 408247 */ // Label 8412: @408247
     /* 408247 */ GIM_Reject,
     /* 408248 */ // Label 8406: @408248
     /* 408248 */ GIM_Reject,
     /* 408249 */ // Label 142: @408249
     /* 408249 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8415*/ GIMT_Encode4(409115),
     /* 408260 */ /*GILLT_v2s64*//*Label 8413*/ GIMT_Encode4(408272), GIMT_Encode4(0),
     /* 408268 */ /*GILLT_v4s32*//*Label 8414*/ GIMT_Encode4(408566),
     /* 408272 */ // Label 8413: @408272
     /* 408272 */ GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(408354), // Rule ID 5856 //
     /* 408277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408284 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 408292 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 408295 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 408300 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 408304 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408309 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408311 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 408311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 408318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408323 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 408327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408353 */   // GIR_Coverage, 5856,
     /* 408353 */   GIR_EraseRootFromParent_Done,
     /* 408354 */ // Label 8416: @408354
     /* 408354 */ GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(408428), // Rule ID 5855 //
     /* 408359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 408374 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408378 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408385 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 408385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 408392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408397 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 408401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408427 */   // GIR_Coverage, 5855,
     /* 408427 */   GIR_EraseRootFromParent_Done,
     /* 408428 */ // Label 8417: @408428
     /* 408428 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(408487), // Rule ID 5865 //
     /* 408433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408444 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 408444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 408451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408456 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 408476 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408486 */   // GIR_Coverage, 5865,
     /* 408486 */   GIR_EraseRootFromParent_Done,
     /* 408487 */ // Label 8418: @408487
     /* 408487 */ GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(408565), // Rule ID 5993 //
     /* 408492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408503 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 408503 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408506 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 408510 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408515 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 408521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 408524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 408528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 408538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 408549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408564 */   // GIR_Coverage, 5993,
     /* 408564 */   GIR_EraseRootFromParent_Done,
     /* 408565 */ // Label 8419: @408565
     /* 408565 */ GIM_Reject,
     /* 408566 */ // Label 8414: @408566
     /* 408566 */ GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(408648), // Rule ID 5858 //
     /* 408571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 408586 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 408589 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 408594 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 408598 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408605 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 408605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 408612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408617 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 408621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408647 */   // GIR_Coverage, 5858,
     /* 408647 */   GIR_EraseRootFromParent_Done,
     /* 408648 */ // Label 8420: @408648
     /* 408648 */ GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(408730), // Rule ID 5860 //
     /* 408653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408660 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 408668 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 408671 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 408676 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 408680 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408687 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 408687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 408694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408699 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 408703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408719 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408724 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408729 */   // GIR_Coverage, 5860,
     /* 408729 */   GIR_EraseRootFromParent_Done,
     /* 408730 */ // Label 8421: @408730
     /* 408730 */ GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(408804), // Rule ID 5857 //
     /* 408735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 408750 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408761 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 408761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 408768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408773 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 408777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408803 */   // GIR_Coverage, 5857,
     /* 408803 */   GIR_EraseRootFromParent_Done,
     /* 408804 */ // Label 8422: @408804
     /* 408804 */ GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(408878), // Rule ID 5859 //
     /* 408809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 408824 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408828 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408833 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408835 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 408835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 408842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408847 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 408851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408877 */   // GIR_Coverage, 5859,
     /* 408877 */   GIR_EraseRootFromParent_Done,
     /* 408878 */ // Label 8423: @408878
     /* 408878 */ GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(408937), // Rule ID 5861 //
     /* 408883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408894 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 408894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 408901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408936 */   // GIR_Coverage, 5861,
     /* 408936 */   GIR_EraseRootFromParent_Done,
     /* 408937 */ // Label 8424: @408937
     /* 408937 */ GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(408996), // Rule ID 5862 //
     /* 408942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408953 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 408953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 408960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408965 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408995 */   // GIR_Coverage, 5862,
     /* 408995 */   GIR_EraseRootFromParent_Done,
     /* 408996 */ // Label 8425: @408996
     /* 408996 */ GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(409055), // Rule ID 5863 //
     /* 409001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 409004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409012 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 409012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 409015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 409019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409024 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 409028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 409030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 409044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409054 */   // GIR_Coverage, 5863,
     /* 409054 */   GIR_EraseRootFromParent_Done,
     /* 409055 */ // Label 8426: @409055
     /* 409055 */ GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(409114), // Rule ID 5864 //
     /* 409060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409071 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 409071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 409074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 409078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409083 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 409087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 409089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 409092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 409097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 409103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409108 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409113 */   // GIR_Coverage, 5864,
     /* 409113 */   GIR_EraseRootFromParent_Done,
     /* 409114 */ // Label 8427: @409114
     /* 409114 */ GIM_Reject,
     /* 409115 */ // Label 8415: @409115
     /* 409115 */ GIM_Reject,
     /* 409116 */ // Label 143: @409116
     /* 409116 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8432*/ GIMT_Encode4(409485),
     /* 409127 */ /*GILLT_v2s32*//*Label 8428*/ GIMT_Encode4(409187), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 409139 */ /*GILLT_v4s32*//*Label 8429*/ GIMT_Encode4(409307), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 409171 */ /*GILLT_nxv2s64*//*Label 8430*/ GIMT_Encode4(409427), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 409183 */ /*GILLT_nxv4s32*//*Label 8431*/ GIMT_Encode4(409456),
     /* 409187 */ // Label 8428: @409187
     /* 409187 */ GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(409306),
     /* 409192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 409198 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 409201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409213 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(409286), // Rule ID 28 //
     /* 409218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 409221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 409225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 409229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409262 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409266 */     // MIs[3] Operand 1
     /* 409266 */     // No operand predicates
     /* 409266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409268 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 409271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 409275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409284 */     GIR_RootConstrainSelectedInstOperands,
     /* 409285 */     // GIR_Coverage, 28,
     /* 409285 */     GIR_EraseRootFromParent_Done,
     /* 409286 */   // Label 8434: @409286
     /* 409286 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(409305), // Rule ID 24 //
     /* 409291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 409294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409298 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 409298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 409303 */     GIR_RootConstrainSelectedInstOperands,
     /* 409304 */     // GIR_Coverage, 24,
     /* 409304 */     GIR_Done,
     /* 409305 */   // Label 8435: @409305
     /* 409305 */   GIM_Reject,
     /* 409306 */ // Label 8433: @409306
     /* 409306 */ GIM_Reject,
     /* 409307 */ // Label 8429: @409307
     /* 409307 */ GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(409426),
     /* 409312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 409318 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 409321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409333 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(409406), // Rule ID 29 //
     /* 409338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 409341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 409345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 409349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409382 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409386 */     // MIs[3] Operand 1
     /* 409386 */     // No operand predicates
     /* 409386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409388 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 409391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 409395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409404 */     GIR_RootConstrainSelectedInstOperands,
     /* 409405 */     // GIR_Coverage, 29,
     /* 409405 */     GIR_EraseRootFromParent_Done,
     /* 409406 */   // Label 8437: @409406
     /* 409406 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(409425), // Rule ID 25 //
     /* 409411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 409414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409418 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 409418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 409423 */     GIR_RootConstrainSelectedInstOperands,
     /* 409424 */     // GIR_Coverage, 25,
     /* 409424 */     GIR_Done,
     /* 409425 */   // Label 8438: @409425
     /* 409425 */   GIM_Reject,
     /* 409426 */ // Label 8436: @409426
     /* 409426 */ GIM_Reject,
     /* 409427 */ // Label 8430: @409427
     /* 409427 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(409455), // Rule ID 7629 //
     /* 409432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 409438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 409441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 409444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409448 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 409448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 409453 */   GIR_RootConstrainSelectedInstOperands,
     /* 409454 */   // GIR_Coverage, 7629,
     /* 409454 */   GIR_Done,
     /* 409455 */ // Label 8439: @409455
     /* 409455 */ GIM_Reject,
     /* 409456 */ // Label 8431: @409456
     /* 409456 */ GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(409484), // Rule ID 7628 //
     /* 409461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 409467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 409470 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 409473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409477 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 409477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 409482 */   GIR_RootConstrainSelectedInstOperands,
     /* 409483 */   // GIR_Coverage, 7628,
     /* 409483 */   GIR_Done,
     /* 409484 */ // Label 8440: @409484
     /* 409484 */ GIM_Reject,
     /* 409485 */ // Label 8432: @409485
     /* 409485 */ GIM_Reject,
     /* 409486 */ // Label 144: @409486
     /* 409486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8444*/ GIMT_Encode4(409602),
     /* 409497 */ /*GILLT_s16*//*Label 8441*/ GIMT_Encode4(409509),
     /* 409501 */ /*GILLT_s32*//*Label 8442*/ GIMT_Encode4(409540),
     /* 409505 */ /*GILLT_s64*//*Label 8443*/ GIMT_Encode4(409571),
     /* 409509 */ // Label 8441: @409509
     /* 409509 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(409539), // Rule ID 1669 //
     /* 409514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 409517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 409520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409528 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 409528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 409533 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409537 */   GIR_RootConstrainSelectedInstOperands,
     /* 409538 */   // GIR_Coverage, 1669,
     /* 409538 */   GIR_Done,
     /* 409539 */ // Label 8445: @409539
     /* 409539 */ GIM_Reject,
     /* 409540 */ // Label 8442: @409540
     /* 409540 */ GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(409570), // Rule ID 1668 //
     /* 409545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 409548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 409551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409559 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 409559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 409564 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409568 */   GIR_RootConstrainSelectedInstOperands,
     /* 409569 */   // GIR_Coverage, 1668,
     /* 409569 */   GIR_Done,
     /* 409570 */ // Label 8446: @409570
     /* 409570 */ GIM_Reject,
     /* 409571 */ // Label 8443: @409571
     /* 409571 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(409601), // Rule ID 1667 //
     /* 409576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 409579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 409582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409590 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 409590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 409595 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409599 */   GIR_RootConstrainSelectedInstOperands,
     /* 409600 */   // GIR_Coverage, 1667,
     /* 409600 */   GIR_Done,
     /* 409601 */ // Label 8447: @409601
     /* 409601 */ GIM_Reject,
     /* 409602 */ // Label 8444: @409602
     /* 409602 */ GIM_Reject,
     /* 409603 */ // Label 145: @409603
     /* 409603 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8451*/ GIMT_Encode4(410835),
     /* 409614 */ /*GILLT_v2s64*//*Label 8448*/ GIMT_Encode4(409634), GIMT_Encode4(0),
     /* 409622 */ /*GILLT_v4s32*//*Label 8449*/ GIMT_Encode4(410195), GIMT_Encode4(0),
     /* 409630 */ /*GILLT_v8s16*//*Label 8450*/ GIMT_Encode4(410756),
     /* 409634 */ // Label 8448: @409634
     /* 409634 */ GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(410194),
     /* 409639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 409645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409649 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(409741), // Rule ID 2106 //
     /* 409654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409698 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409702 */     // MIs[3] Operand 1
     /* 409702 */     // No operand predicates
     /* 409702 */     // MIs[1] Operand 2
     /* 409702 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 409713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409722 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 409725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409739 */     GIR_RootConstrainSelectedInstOperands,
     /* 409740 */     // GIR_Coverage, 2106,
     /* 409740 */     GIR_EraseRootFromParent_Done,
     /* 409741 */   // Label 8453: @409741
     /* 409741 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(409833), // Rule ID 13510 //
     /* 409746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409790 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409794 */     // MIs[3] Operand 1
     /* 409794 */     // No operand predicates
     /* 409794 */     // MIs[1] Operand 2
     /* 409794 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 409805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409814 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 409817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409831 */     GIR_RootConstrainSelectedInstOperands,
     /* 409832 */     // GIR_Coverage, 13510,
     /* 409832 */     GIR_EraseRootFromParent_Done,
     /* 409833 */   // Label 8454: @409833
     /* 409833 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(409919), // Rule ID 13508 //
     /* 409838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409882 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409886 */     // MIs[3] Operand 1
     /* 409886 */     // No operand predicates
     /* 409886 */     // MIs[1] Operand 2
     /* 409886 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409903 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409917 */     GIR_RootConstrainSelectedInstOperands,
     /* 409918 */     // GIR_Coverage, 13508,
     /* 409918 */     GIR_EraseRootFromParent_Done,
     /* 409919 */   // Label 8455: @409919
     /* 409919 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(410005), // Rule ID 2104 //
     /* 409924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409972 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409976 */     // MIs[3] Operand 1
     /* 409976 */     // No operand predicates
     /* 409976 */     // MIs[1] Operand 2
     /* 409976 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409989 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410003 */     GIR_RootConstrainSelectedInstOperands,
     /* 410004 */     // GIR_Coverage, 2104,
     /* 410004 */     GIR_EraseRootFromParent_Done,
     /* 410005 */   // Label 8456: @410005
     /* 410005 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(410044), // Rule ID 1831 //
     /* 410010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 410020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 410027 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 410027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 410030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410042 */     GIR_RootConstrainSelectedInstOperands,
     /* 410043 */     // GIR_Coverage, 1831,
     /* 410043 */     GIR_EraseRootFromParent_Done,
     /* 410044 */   // Label 8457: @410044
     /* 410044 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(410107), // Rule ID 13509 //
     /* 410049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410081 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410085 */     // MIs[2] Operand 1
     /* 410085 */     // No operand predicates
     /* 410085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410091 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 410094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410105 */     GIR_RootConstrainSelectedInstOperands,
     /* 410106 */     // GIR_Coverage, 13509,
     /* 410106 */     GIR_EraseRootFromParent_Done,
     /* 410107 */   // Label 8458: @410107
     /* 410107 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(410170), // Rule ID 2105 //
     /* 410112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410148 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410152 */     // MIs[2] Operand 1
     /* 410152 */     // No operand predicates
     /* 410152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410154 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 410157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410168 */     GIR_RootConstrainSelectedInstOperands,
     /* 410169 */     // GIR_Coverage, 2105,
     /* 410169 */     GIR_EraseRootFromParent_Done,
     /* 410170 */   // Label 8459: @410170
     /* 410170 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(410193), // Rule ID 1830 //
     /* 410175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410186 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 410186 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 410191 */     GIR_RootConstrainSelectedInstOperands,
     /* 410192 */     // GIR_Coverage, 1830,
     /* 410192 */     GIR_Done,
     /* 410193 */   // Label 8460: @410193
     /* 410193 */   GIM_Reject,
     /* 410194 */ // Label 8452: @410194
     /* 410194 */ GIM_Reject,
     /* 410195 */ // Label 8449: @410195
     /* 410195 */ GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(410755),
     /* 410200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 410206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410210 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(410302), // Rule ID 2103 //
     /* 410215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 410226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410259 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410263 */     // MIs[3] Operand 1
     /* 410263 */     // No operand predicates
     /* 410263 */     // MIs[1] Operand 2
     /* 410263 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 410274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410283 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 410286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410300 */     GIR_RootConstrainSelectedInstOperands,
     /* 410301 */     // GIR_Coverage, 2103,
     /* 410301 */     GIR_EraseRootFromParent_Done,
     /* 410302 */   // Label 8462: @410302
     /* 410302 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(410394), // Rule ID 13507 //
     /* 410307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 410318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410351 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410355 */     // MIs[3] Operand 1
     /* 410355 */     // No operand predicates
     /* 410355 */     // MIs[1] Operand 2
     /* 410355 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 410366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410375 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 410378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410392 */     GIR_RootConstrainSelectedInstOperands,
     /* 410393 */     // GIR_Coverage, 13507,
     /* 410393 */     GIR_EraseRootFromParent_Done,
     /* 410394 */   // Label 8463: @410394
     /* 410394 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(410480), // Rule ID 13505 //
     /* 410399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 410410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410443 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410447 */     // MIs[3] Operand 1
     /* 410447 */     // No operand predicates
     /* 410447 */     // MIs[1] Operand 2
     /* 410447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 410458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410464 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 410467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410478 */     GIR_RootConstrainSelectedInstOperands,
     /* 410479 */     // GIR_Coverage, 13505,
     /* 410479 */     GIR_EraseRootFromParent_Done,
     /* 410480 */   // Label 8464: @410480
     /* 410480 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(410566), // Rule ID 2101 //
     /* 410485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 410500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410516 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410533 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410537 */     // MIs[3] Operand 1
     /* 410537 */     // No operand predicates
     /* 410537 */     // MIs[1] Operand 2
     /* 410537 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 410548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410550 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 410553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410564 */     GIR_RootConstrainSelectedInstOperands,
     /* 410565 */     // GIR_Coverage, 2101,
     /* 410565 */     GIR_EraseRootFromParent_Done,
     /* 410566 */   // Label 8465: @410566
     /* 410566 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(410605), // Rule ID 1829 //
     /* 410571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410588 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 410591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410603 */     GIR_RootConstrainSelectedInstOperands,
     /* 410604 */     // GIR_Coverage, 1829,
     /* 410604 */     GIR_EraseRootFromParent_Done,
     /* 410605 */   // Label 8466: @410605
     /* 410605 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(410668), // Rule ID 13506 //
     /* 410610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410646 */     // MIs[2] Operand 1
     /* 410646 */     // No operand predicates
     /* 410646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410652 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 410655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410666 */     GIR_RootConstrainSelectedInstOperands,
     /* 410667 */     // GIR_Coverage, 13506,
     /* 410667 */     GIR_EraseRootFromParent_Done,
     /* 410668 */   // Label 8467: @410668
     /* 410668 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(410731), // Rule ID 2102 //
     /* 410673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410709 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410713 */     // MIs[2] Operand 1
     /* 410713 */     // No operand predicates
     /* 410713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410715 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 410718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410729 */     GIR_RootConstrainSelectedInstOperands,
     /* 410730 */     // GIR_Coverage, 2102,
     /* 410730 */     GIR_EraseRootFromParent_Done,
     /* 410731 */   // Label 8468: @410731
     /* 410731 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(410754), // Rule ID 1828 //
     /* 410736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410747 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 410752 */     GIR_RootConstrainSelectedInstOperands,
     /* 410753 */     // GIR_Coverage, 1828,
     /* 410753 */     GIR_Done,
     /* 410754 */   // Label 8469: @410754
     /* 410754 */   GIM_Reject,
     /* 410755 */ // Label 8461: @410755
     /* 410755 */ GIM_Reject,
     /* 410756 */ // Label 8450: @410756
     /* 410756 */ GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(410834),
     /* 410761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410771 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(410810), // Rule ID 1827 //
     /* 410776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 410786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 410793 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 410796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410808 */     GIR_RootConstrainSelectedInstOperands,
     /* 410809 */     // GIR_Coverage, 1827,
     /* 410809 */     GIR_EraseRootFromParent_Done,
     /* 410810 */   // Label 8471: @410810
     /* 410810 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(410833), // Rule ID 1826 //
     /* 410815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410826 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 410831 */     GIR_RootConstrainSelectedInstOperands,
     /* 410832 */     // GIR_Coverage, 1826,
     /* 410832 */     GIR_Done,
     /* 410833 */   // Label 8472: @410833
     /* 410833 */   GIM_Reject,
     /* 410834 */ // Label 8470: @410834
     /* 410834 */ GIM_Reject,
     /* 410835 */ // Label 8451: @410835
     /* 410835 */ GIM_Reject,
     /* 410836 */ // Label 146: @410836
     /* 410836 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8491*/ GIMT_Encode4(411615),
     /* 410847 */ /*GILLT_v2s32*//*Label 8473*/ GIMT_Encode4(410923),
     /* 410851 */ /*GILLT_v2s64*//*Label 8474*/ GIMT_Encode4(410978),
     /* 410855 */ /*GILLT_v4s16*//*Label 8475*/ GIMT_Encode4(411033),
     /* 410859 */ /*GILLT_v4s32*//*Label 8476*/ GIMT_Encode4(411088),
     /* 410863 */ /*GILLT_v8s8*//*Label 8477*/ GIMT_Encode4(411143),
     /* 410867 */ /*GILLT_v8s16*//*Label 8478*/ GIMT_Encode4(411177),
     /* 410871 */ /*GILLT_v16s8*//*Label 8479*/ GIMT_Encode4(411232), GIMT_Encode4(0),
     /* 410879 */ /*GILLT_nxv2s1*//*Label 8480*/ GIMT_Encode4(411266),
     /* 410883 */ /*GILLT_nxv2s16*//*Label 8481*/ GIMT_Encode4(411292),
     /* 410887 */ /*GILLT_nxv2s32*//*Label 8482*/ GIMT_Encode4(411318),
     /* 410891 */ /*GILLT_nxv2s64*//*Label 8483*/ GIMT_Encode4(411344),
     /* 410895 */ /*GILLT_nxv4s1*//*Label 8484*/ GIMT_Encode4(411391),
     /* 410899 */ /*GILLT_nxv4s16*//*Label 8485*/ GIMT_Encode4(411417),
     /* 410903 */ /*GILLT_nxv4s32*//*Label 8486*/ GIMT_Encode4(411443),
     /* 410907 */ /*GILLT_nxv8s1*//*Label 8487*/ GIMT_Encode4(411490),
     /* 410911 */ /*GILLT_nxv8s16*//*Label 8488*/ GIMT_Encode4(411516),
     /* 410915 */ /*GILLT_nxv16s1*//*Label 8489*/ GIMT_Encode4(411563),
     /* 410919 */ /*GILLT_nxv16s8*//*Label 8490*/ GIMT_Encode4(411589),
     /* 410923 */ // Label 8473: @410923
     /* 410923 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(410977),
     /* 410928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410946 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(410961), // Rule ID 1888 //
     /* 410951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410954 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 410954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 410959 */     GIR_RootConstrainSelectedInstOperands,
     /* 410960 */     // GIR_Coverage, 1888,
     /* 410960 */     GIR_Done,
     /* 410961 */   // Label 8493: @410961
     /* 410961 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(410976), // Rule ID 5474 //
     /* 410966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410969 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 410974 */     GIR_RootConstrainSelectedInstOperands,
     /* 410975 */     // GIR_Coverage, 5474,
     /* 410975 */     GIR_Done,
     /* 410976 */   // Label 8494: @410976
     /* 410976 */   GIM_Reject,
     /* 410977 */ // Label 8492: @410977
     /* 410977 */ GIM_Reject,
     /* 410978 */ // Label 8474: @410978
     /* 410978 */ GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(411032),
     /* 410983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411001 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(411016), // Rule ID 1890 //
     /* 411006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411009 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 411009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 411014 */     GIR_RootConstrainSelectedInstOperands,
     /* 411015 */     // GIR_Coverage, 1890,
     /* 411015 */     GIR_Done,
     /* 411016 */   // Label 8496: @411016
     /* 411016 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(411031), // Rule ID 5476 //
     /* 411021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411024 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 411029 */     GIR_RootConstrainSelectedInstOperands,
     /* 411030 */     // GIR_Coverage, 5476,
     /* 411030 */     GIR_Done,
     /* 411031 */   // Label 8497: @411031
     /* 411031 */   GIM_Reject,
     /* 411032 */ // Label 8495: @411032
     /* 411032 */ GIM_Reject,
     /* 411033 */ // Label 8475: @411033
     /* 411033 */ GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(411087),
     /* 411038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 411044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411056 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(411071), // Rule ID 1886 //
     /* 411061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411064 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 411064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 411069 */     GIR_RootConstrainSelectedInstOperands,
     /* 411070 */     // GIR_Coverage, 1886,
     /* 411070 */     GIR_Done,
     /* 411071 */   // Label 8499: @411071
     /* 411071 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(411086), // Rule ID 5472 //
     /* 411076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411079 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 411079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 411084 */     GIR_RootConstrainSelectedInstOperands,
     /* 411085 */     // GIR_Coverage, 5472,
     /* 411085 */     GIR_Done,
     /* 411086 */   // Label 8500: @411086
     /* 411086 */   GIM_Reject,
     /* 411087 */ // Label 8498: @411087
     /* 411087 */ GIM_Reject,
     /* 411088 */ // Label 8476: @411088
     /* 411088 */ GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(411142),
     /* 411093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 411099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411111 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(411126), // Rule ID 1889 //
     /* 411116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411119 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 411119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 411124 */     GIR_RootConstrainSelectedInstOperands,
     /* 411125 */     // GIR_Coverage, 1889,
     /* 411125 */     GIR_Done,
     /* 411126 */   // Label 8502: @411126
     /* 411126 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(411141), // Rule ID 5475 //
     /* 411131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411134 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 411134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 411139 */     GIR_RootConstrainSelectedInstOperands,
     /* 411140 */     // GIR_Coverage, 5475,
     /* 411140 */     GIR_Done,
     /* 411141 */   // Label 8503: @411141
     /* 411141 */   GIM_Reject,
     /* 411142 */ // Label 8501: @411142
     /* 411142 */ GIM_Reject,
     /* 411143 */ // Label 8477: @411143
     /* 411143 */ GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(411176), // Rule ID 1884 //
     /* 411148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 411157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411169 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 411169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 411174 */   GIR_RootConstrainSelectedInstOperands,
     /* 411175 */   // GIR_Coverage, 1884,
     /* 411175 */   GIR_Done,
     /* 411176 */ // Label 8504: @411176
     /* 411176 */ GIM_Reject,
     /* 411177 */ // Label 8478: @411177
     /* 411177 */ GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(411231),
     /* 411182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 411188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411200 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(411215), // Rule ID 1887 //
     /* 411205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411208 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 411208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 411213 */     GIR_RootConstrainSelectedInstOperands,
     /* 411214 */     // GIR_Coverage, 1887,
     /* 411214 */     GIR_Done,
     /* 411215 */   // Label 8506: @411215
     /* 411215 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(411230), // Rule ID 5473 //
     /* 411220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411223 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 411223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 411228 */     GIR_RootConstrainSelectedInstOperands,
     /* 411229 */     // GIR_Coverage, 5473,
     /* 411229 */     GIR_Done,
     /* 411230 */   // Label 8507: @411230
     /* 411230 */   GIM_Reject,
     /* 411231 */ // Label 8505: @411231
     /* 411231 */ GIM_Reject,
     /* 411232 */ // Label 8479: @411232
     /* 411232 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(411265), // Rule ID 1885 //
     /* 411237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 411243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 411246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411258 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 411258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 411263 */   GIR_RootConstrainSelectedInstOperands,
     /* 411264 */   // GIR_Coverage, 1885,
     /* 411264 */   GIR_Done,
     /* 411265 */ // Label 8508: @411265
     /* 411265 */ GIM_Reject,
     /* 411266 */ // Label 8480: @411266
     /* 411266 */ GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(411291), // Rule ID 8937 //
     /* 411271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 411277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 411280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411284 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 411284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 411289 */   GIR_RootConstrainSelectedInstOperands,
     /* 411290 */   // GIR_Coverage, 8937,
     /* 411290 */   GIR_Done,
     /* 411291 */ // Label 8509: @411291
     /* 411291 */ GIM_Reject,
     /* 411292 */ // Label 8481: @411292
     /* 411292 */ GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(411317), // Rule ID 8899 //
     /* 411297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 411303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 411306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411310 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 411310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 411315 */   GIR_RootConstrainSelectedInstOperands,
     /* 411316 */   // GIR_Coverage, 8899,
     /* 411316 */   GIR_Done,
     /* 411317 */ // Label 8510: @411317
     /* 411317 */ GIM_Reject,
     /* 411318 */ // Label 8482: @411318
     /* 411318 */ GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(411343), // Rule ID 8900 //
     /* 411323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 411329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 411332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411336 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 411336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 411341 */   GIR_RootConstrainSelectedInstOperands,
     /* 411342 */   // GIR_Coverage, 8900,
     /* 411342 */   GIR_Done,
     /* 411343 */ // Label 8511: @411343
     /* 411343 */ GIM_Reject,
     /* 411344 */ // Label 8483: @411344
     /* 411344 */ GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(411390),
     /* 411349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 411352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 411355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411359 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(411374), // Rule ID 8895 //
     /* 411364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411367 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 411367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 411372 */     GIR_RootConstrainSelectedInstOperands,
     /* 411373 */     // GIR_Coverage, 8895,
     /* 411373 */     GIR_Done,
     /* 411374 */   // Label 8513: @411374
     /* 411374 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(411389), // Rule ID 8901 //
     /* 411379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411382 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 411382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 411387 */     GIR_RootConstrainSelectedInstOperands,
     /* 411388 */     // GIR_Coverage, 8901,
     /* 411388 */     GIR_Done,
     /* 411389 */   // Label 8514: @411389
     /* 411389 */   GIM_Reject,
     /* 411390 */ // Label 8512: @411390
     /* 411390 */ GIM_Reject,
     /* 411391 */ // Label 8484: @411391
     /* 411391 */ GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(411416), // Rule ID 8936 //
     /* 411396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 411402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 411405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411409 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 411409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 411414 */   GIR_RootConstrainSelectedInstOperands,
     /* 411415 */   // GIR_Coverage, 8936,
     /* 411415 */   GIR_Done,
     /* 411416 */ // Label 8515: @411416
     /* 411416 */ GIM_Reject,
     /* 411417 */ // Label 8485: @411417
     /* 411417 */ GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(411442), // Rule ID 8897 //
     /* 411422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 411428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 411431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411435 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 411435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 411440 */   GIR_RootConstrainSelectedInstOperands,
     /* 411441 */   // GIR_Coverage, 8897,
     /* 411441 */   GIR_Done,
     /* 411442 */ // Label 8516: @411442
     /* 411442 */ GIM_Reject,
     /* 411443 */ // Label 8486: @411443
     /* 411443 */ GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(411489),
     /* 411448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 411451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 411454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411458 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(411473), // Rule ID 8894 //
     /* 411463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411466 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 411466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 411471 */     GIR_RootConstrainSelectedInstOperands,
     /* 411472 */     // GIR_Coverage, 8894,
     /* 411472 */     GIR_Done,
     /* 411473 */   // Label 8518: @411473
     /* 411473 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(411488), // Rule ID 8898 //
     /* 411478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411481 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 411481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 411486 */     GIR_RootConstrainSelectedInstOperands,
     /* 411487 */     // GIR_Coverage, 8898,
     /* 411487 */     GIR_Done,
     /* 411488 */   // Label 8519: @411488
     /* 411488 */   GIM_Reject,
     /* 411489 */ // Label 8517: @411489
     /* 411489 */ GIM_Reject,
     /* 411490 */ // Label 8487: @411490
     /* 411490 */ GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(411515), // Rule ID 8935 //
     /* 411495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 411501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 411504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411508 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 411508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 411513 */   GIR_RootConstrainSelectedInstOperands,
     /* 411514 */   // GIR_Coverage, 8935,
     /* 411514 */   GIR_Done,
     /* 411515 */ // Label 8520: @411515
     /* 411515 */ GIM_Reject,
     /* 411516 */ // Label 8488: @411516
     /* 411516 */ GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(411562),
     /* 411521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411531 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(411546), // Rule ID 8893 //
     /* 411536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411539 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 411544 */     GIR_RootConstrainSelectedInstOperands,
     /* 411545 */     // GIR_Coverage, 8893,
     /* 411545 */     GIR_Done,
     /* 411546 */   // Label 8522: @411546
     /* 411546 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(411561), // Rule ID 8896 //
     /* 411551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411554 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 411559 */     GIR_RootConstrainSelectedInstOperands,
     /* 411560 */     // GIR_Coverage, 8896,
     /* 411560 */     GIR_Done,
     /* 411561 */   // Label 8523: @411561
     /* 411561 */   GIM_Reject,
     /* 411562 */ // Label 8521: @411562
     /* 411562 */ GIM_Reject,
     /* 411563 */ // Label 8489: @411563
     /* 411563 */ GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(411588), // Rule ID 2406 //
     /* 411568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411581 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 411586 */   GIR_RootConstrainSelectedInstOperands,
     /* 411587 */   // GIR_Coverage, 2406,
     /* 411587 */   GIR_Done,
     /* 411588 */ // Label 8524: @411588
     /* 411588 */ GIM_Reject,
     /* 411589 */ // Label 8490: @411589
     /* 411589 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(411614), // Rule ID 8892 //
     /* 411594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 411600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411607 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 411607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 411612 */   GIR_RootConstrainSelectedInstOperands,
     /* 411613 */   // GIR_Coverage, 8892,
     /* 411613 */   GIR_Done,
     /* 411614 */ // Label 8525: @411614
     /* 411614 */ GIM_Reject,
     /* 411615 */ // Label 8491: @411615
     /* 411615 */ GIM_Reject,
     /* 411616 */ // Label 147: @411616
     /* 411616 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8544*/ GIMT_Encode4(412395),
     /* 411627 */ /*GILLT_v2s32*//*Label 8526*/ GIMT_Encode4(411703),
     /* 411631 */ /*GILLT_v2s64*//*Label 8527*/ GIMT_Encode4(411758),
     /* 411635 */ /*GILLT_v4s16*//*Label 8528*/ GIMT_Encode4(411813),
     /* 411639 */ /*GILLT_v4s32*//*Label 8529*/ GIMT_Encode4(411868),
     /* 411643 */ /*GILLT_v8s8*//*Label 8530*/ GIMT_Encode4(411923),
     /* 411647 */ /*GILLT_v8s16*//*Label 8531*/ GIMT_Encode4(411957),
     /* 411651 */ /*GILLT_v16s8*//*Label 8532*/ GIMT_Encode4(412012), GIMT_Encode4(0),
     /* 411659 */ /*GILLT_nxv2s1*//*Label 8533*/ GIMT_Encode4(412046),
     /* 411663 */ /*GILLT_nxv2s16*//*Label 8534*/ GIMT_Encode4(412072),
     /* 411667 */ /*GILLT_nxv2s32*//*Label 8535*/ GIMT_Encode4(412098),
     /* 411671 */ /*GILLT_nxv2s64*//*Label 8536*/ GIMT_Encode4(412124),
     /* 411675 */ /*GILLT_nxv4s1*//*Label 8537*/ GIMT_Encode4(412171),
     /* 411679 */ /*GILLT_nxv4s16*//*Label 8538*/ GIMT_Encode4(412197),
     /* 411683 */ /*GILLT_nxv4s32*//*Label 8539*/ GIMT_Encode4(412223),
     /* 411687 */ /*GILLT_nxv8s1*//*Label 8540*/ GIMT_Encode4(412270),
     /* 411691 */ /*GILLT_nxv8s16*//*Label 8541*/ GIMT_Encode4(412296),
     /* 411695 */ /*GILLT_nxv16s1*//*Label 8542*/ GIMT_Encode4(412343),
     /* 411699 */ /*GILLT_nxv16s8*//*Label 8543*/ GIMT_Encode4(412369),
     /* 411703 */ // Label 8526: @411703
     /* 411703 */ GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(411757),
     /* 411708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 411714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411726 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(411741), // Rule ID 1895 //
     /* 411731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411734 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 411734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 411739 */     GIR_RootConstrainSelectedInstOperands,
     /* 411740 */     // GIR_Coverage, 1895,
     /* 411740 */     GIR_Done,
     /* 411741 */   // Label 8546: @411741
     /* 411741 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(411756), // Rule ID 5479 //
     /* 411746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411749 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 411754 */     GIR_RootConstrainSelectedInstOperands,
     /* 411755 */     // GIR_Coverage, 5479,
     /* 411755 */     GIR_Done,
     /* 411756 */   // Label 8547: @411756
     /* 411756 */   GIM_Reject,
     /* 411757 */ // Label 8545: @411757
     /* 411757 */ GIM_Reject,
     /* 411758 */ // Label 8527: @411758
     /* 411758 */ GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(411812),
     /* 411763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 411769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411781 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(411796), // Rule ID 1897 //
     /* 411786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411789 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 411789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 411794 */     GIR_RootConstrainSelectedInstOperands,
     /* 411795 */     // GIR_Coverage, 1897,
     /* 411795 */     GIR_Done,
     /* 411796 */   // Label 8549: @411796
     /* 411796 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(411811), // Rule ID 5481 //
     /* 411801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411804 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 411809 */     GIR_RootConstrainSelectedInstOperands,
     /* 411810 */     // GIR_Coverage, 5481,
     /* 411810 */     GIR_Done,
     /* 411811 */   // Label 8550: @411811
     /* 411811 */   GIM_Reject,
     /* 411812 */ // Label 8548: @411812
     /* 411812 */ GIM_Reject,
     /* 411813 */ // Label 8528: @411813
     /* 411813 */ GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(411867),
     /* 411818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 411824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411836 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(411851), // Rule ID 1893 //
     /* 411841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411844 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 411844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 411849 */     GIR_RootConstrainSelectedInstOperands,
     /* 411850 */     // GIR_Coverage, 1893,
     /* 411850 */     GIR_Done,
     /* 411851 */   // Label 8552: @411851
     /* 411851 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(411866), // Rule ID 5477 //
     /* 411856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411859 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 411859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 411864 */     GIR_RootConstrainSelectedInstOperands,
     /* 411865 */     // GIR_Coverage, 5477,
     /* 411865 */     GIR_Done,
     /* 411866 */   // Label 8553: @411866
     /* 411866 */   GIM_Reject,
     /* 411867 */ // Label 8551: @411867
     /* 411867 */ GIM_Reject,
     /* 411868 */ // Label 8529: @411868
     /* 411868 */ GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(411922),
     /* 411873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 411879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411891 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(411906), // Rule ID 1896 //
     /* 411896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411899 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 411899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 411904 */     GIR_RootConstrainSelectedInstOperands,
     /* 411905 */     // GIR_Coverage, 1896,
     /* 411905 */     GIR_Done,
     /* 411906 */   // Label 8555: @411906
     /* 411906 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(411921), // Rule ID 5480 //
     /* 411911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411914 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 411914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 411919 */     GIR_RootConstrainSelectedInstOperands,
     /* 411920 */     // GIR_Coverage, 5480,
     /* 411920 */     GIR_Done,
     /* 411921 */   // Label 8556: @411921
     /* 411921 */   GIM_Reject,
     /* 411922 */ // Label 8554: @411922
     /* 411922 */ GIM_Reject,
     /* 411923 */ // Label 8530: @411923
     /* 411923 */ GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(411956), // Rule ID 1891 //
     /* 411928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 411937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411949 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 411949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 411954 */   GIR_RootConstrainSelectedInstOperands,
     /* 411955 */   // GIR_Coverage, 1891,
     /* 411955 */   GIR_Done,
     /* 411956 */ // Label 8557: @411956
     /* 411956 */ GIM_Reject,
     /* 411957 */ // Label 8531: @411957
     /* 411957 */ GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(412011),
     /* 411962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 411968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411980 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(411995), // Rule ID 1894 //
     /* 411985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411988 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 411988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 411993 */     GIR_RootConstrainSelectedInstOperands,
     /* 411994 */     // GIR_Coverage, 1894,
     /* 411994 */     GIR_Done,
     /* 411995 */   // Label 8559: @411995
     /* 411995 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(412010), // Rule ID 5478 //
     /* 412000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412003 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 412003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 412008 */     GIR_RootConstrainSelectedInstOperands,
     /* 412009 */     // GIR_Coverage, 5478,
     /* 412009 */     GIR_Done,
     /* 412010 */   // Label 8560: @412010
     /* 412010 */   GIM_Reject,
     /* 412011 */ // Label 8558: @412011
     /* 412011 */ GIM_Reject,
     /* 412012 */ // Label 8532: @412012
     /* 412012 */ GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(412045), // Rule ID 1892 //
     /* 412017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 412026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412038 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 412038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 412043 */   GIR_RootConstrainSelectedInstOperands,
     /* 412044 */   // GIR_Coverage, 1892,
     /* 412044 */   GIR_Done,
     /* 412045 */ // Label 8561: @412045
     /* 412045 */ GIM_Reject,
     /* 412046 */ // Label 8533: @412046
     /* 412046 */ GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(412071), // Rule ID 8940 //
     /* 412051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 412057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 412060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 412064 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 412064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 412069 */   GIR_RootConstrainSelectedInstOperands,
     /* 412070 */   // GIR_Coverage, 8940,
     /* 412070 */   GIR_Done,
     /* 412071 */ // Label 8562: @412071
     /* 412071 */ GIM_Reject,
     /* 412072 */ // Label 8534: @412072
     /* 412072 */ GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(412097), // Rule ID 8909 //
     /* 412077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 412083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 412086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412090 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 412090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 412095 */   GIR_RootConstrainSelectedInstOperands,
     /* 412096 */   // GIR_Coverage, 8909,
     /* 412096 */   GIR_Done,
     /* 412097 */ // Label 8563: @412097
     /* 412097 */ GIM_Reject,
     /* 412098 */ // Label 8535: @412098
     /* 412098 */ GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(412123), // Rule ID 8910 //
     /* 412103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 412109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 412112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412116 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 412116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 412121 */   GIR_RootConstrainSelectedInstOperands,
     /* 412122 */   // GIR_Coverage, 8910,
     /* 412122 */   GIR_Done,
     /* 412123 */ // Label 8564: @412123
     /* 412123 */ GIM_Reject,
     /* 412124 */ // Label 8536: @412124
     /* 412124 */ GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(412170),
     /* 412129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 412132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 412135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412139 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(412154), // Rule ID 8905 //
     /* 412144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412147 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 412147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 412152 */     GIR_RootConstrainSelectedInstOperands,
     /* 412153 */     // GIR_Coverage, 8905,
     /* 412153 */     GIR_Done,
     /* 412154 */   // Label 8566: @412154
     /* 412154 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(412169), // Rule ID 8911 //
     /* 412159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412162 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 412162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 412167 */     GIR_RootConstrainSelectedInstOperands,
     /* 412168 */     // GIR_Coverage, 8911,
     /* 412168 */     GIR_Done,
     /* 412169 */   // Label 8567: @412169
     /* 412169 */   GIM_Reject,
     /* 412170 */ // Label 8565: @412170
     /* 412170 */ GIM_Reject,
     /* 412171 */ // Label 8537: @412171
     /* 412171 */ GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(412196), // Rule ID 8939 //
     /* 412176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 412182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 412185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 412189 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 412189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 412194 */   GIR_RootConstrainSelectedInstOperands,
     /* 412195 */   // GIR_Coverage, 8939,
     /* 412195 */   GIR_Done,
     /* 412196 */ // Label 8568: @412196
     /* 412196 */ GIM_Reject,
     /* 412197 */ // Label 8538: @412197
     /* 412197 */ GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(412222), // Rule ID 8907 //
     /* 412202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 412208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 412211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412215 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 412215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 412220 */   GIR_RootConstrainSelectedInstOperands,
     /* 412221 */   // GIR_Coverage, 8907,
     /* 412221 */   GIR_Done,
     /* 412222 */ // Label 8569: @412222
     /* 412222 */ GIM_Reject,
     /* 412223 */ // Label 8539: @412223
     /* 412223 */ GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(412269),
     /* 412228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 412231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 412234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412238 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(412253), // Rule ID 8904 //
     /* 412243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412246 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 412246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 412251 */     GIR_RootConstrainSelectedInstOperands,
     /* 412252 */     // GIR_Coverage, 8904,
     /* 412252 */     GIR_Done,
     /* 412253 */   // Label 8571: @412253
     /* 412253 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(412268), // Rule ID 8908 //
     /* 412258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412261 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 412261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 412266 */     GIR_RootConstrainSelectedInstOperands,
     /* 412267 */     // GIR_Coverage, 8908,
     /* 412267 */     GIR_Done,
     /* 412268 */   // Label 8572: @412268
     /* 412268 */   GIM_Reject,
     /* 412269 */ // Label 8570: @412269
     /* 412269 */ GIM_Reject,
     /* 412270 */ // Label 8540: @412270
     /* 412270 */ GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(412295), // Rule ID 8938 //
     /* 412275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 412281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 412284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 412288 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 412288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 412293 */   GIR_RootConstrainSelectedInstOperands,
     /* 412294 */   // GIR_Coverage, 8938,
     /* 412294 */   GIR_Done,
     /* 412295 */ // Label 8573: @412295
     /* 412295 */ GIM_Reject,
     /* 412296 */ // Label 8541: @412296
     /* 412296 */ GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(412342),
     /* 412301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 412304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 412307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412311 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(412326), // Rule ID 8903 //
     /* 412316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412319 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 412319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 412324 */     GIR_RootConstrainSelectedInstOperands,
     /* 412325 */     // GIR_Coverage, 8903,
     /* 412325 */     GIR_Done,
     /* 412326 */   // Label 8575: @412326
     /* 412326 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(412341), // Rule ID 8906 //
     /* 412331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412334 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 412334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 412339 */     GIR_RootConstrainSelectedInstOperands,
     /* 412340 */     // GIR_Coverage, 8906,
     /* 412340 */     GIR_Done,
     /* 412341 */   // Label 8576: @412341
     /* 412341 */   GIM_Reject,
     /* 412342 */ // Label 8574: @412342
     /* 412342 */ GIM_Reject,
     /* 412343 */ // Label 8542: @412343
     /* 412343 */ GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(412368), // Rule ID 2410 //
     /* 412348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 412354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 412357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 412361 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 412361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 412366 */   GIR_RootConstrainSelectedInstOperands,
     /* 412367 */   // GIR_Coverage, 2410,
     /* 412367 */   GIR_Done,
     /* 412368 */ // Label 8577: @412368
     /* 412368 */ GIM_Reject,
     /* 412369 */ // Label 8543: @412369
     /* 412369 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(412394), // Rule ID 8902 //
     /* 412374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 412380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 412383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412387 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 412387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 412392 */   GIR_RootConstrainSelectedInstOperands,
     /* 412393 */   // GIR_Coverage, 8902,
     /* 412393 */   GIR_Done,
     /* 412394 */ // Label 8578: @412394
     /* 412394 */ GIM_Reject,
     /* 412395 */ // Label 8544: @412395
     /* 412395 */ GIM_Reject,
     /* 412396 */ // Label 148: @412396
     /* 412396 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8587*/ GIMT_Encode4(413093),
     /* 412407 */ /*GILLT_s64*//*Label 8579*/ GIMT_Encode4(412443), GIMT_Encode4(0),
     /* 412415 */ /*GILLT_v2s32*//*Label 8580*/ GIMT_Encode4(412554),
     /* 412419 */ /*GILLT_v2s64*//*Label 8581*/ GIMT_Encode4(412631),
     /* 412423 */ /*GILLT_v4s16*//*Label 8582*/ GIMT_Encode4(412708),
     /* 412427 */ /*GILLT_v4s32*//*Label 8583*/ GIMT_Encode4(412785),
     /* 412431 */ /*GILLT_v8s8*//*Label 8584*/ GIMT_Encode4(412862),
     /* 412435 */ /*GILLT_v8s16*//*Label 8585*/ GIMT_Encode4(412939),
     /* 412439 */ /*GILLT_v16s8*//*Label 8586*/ GIMT_Encode4(413016),
     /* 412443 */ // Label 8579: @412443
     /* 412443 */ GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(412553),
     /* 412448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 412451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412459 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(412484), // Rule ID 5251 //
     /* 412464 */     // MIs[0] Operand 2
     /* 412464 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 412475 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 412475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 412478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412482 */     GIR_RootConstrainSelectedInstOperands,
     /* 412483 */     // GIR_Coverage, 5251,
     /* 412483 */     GIR_EraseRootFromParent_Done,
     /* 412484 */   // Label 8589: @412484
     /* 412484 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(412518), // Rule ID 2120 //
     /* 412489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412492 */     // MIs[0] imm
     /* 412492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412504 */     // MIs[1] Operand 1
     /* 412504 */     // No operand predicates
     /* 412504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412506 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 412509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412516 */     GIR_RootConstrainSelectedInstOperands,
     /* 412517 */     // GIR_Coverage, 2120,
     /* 412517 */     GIR_EraseRootFromParent_Done,
     /* 412518 */   // Label 8590: @412518
     /* 412518 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(412552), // Rule ID 6289 //
     /* 412523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412526 */     // MIs[0] imm
     /* 412526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412538 */     // MIs[1] Operand 1
     /* 412538 */     // No operand predicates
     /* 412538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412540 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 412540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 412543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412550 */     GIR_RootConstrainSelectedInstOperands,
     /* 412551 */     // GIR_Coverage, 6289,
     /* 412551 */     GIR_EraseRootFromParent_Done,
     /* 412552 */   // Label 8591: @412552
     /* 412552 */   GIM_Reject,
     /* 412553 */ // Label 8588: @412553
     /* 412553 */ GIM_Reject,
     /* 412554 */ // Label 8580: @412554
     /* 412554 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(412630),
     /* 412559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412570 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(412595), // Rule ID 4892 //
     /* 412575 */     // MIs[0] Operand 2
     /* 412575 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 412586 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 412586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 412589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412593 */     GIR_RootConstrainSelectedInstOperands,
     /* 412594 */     // GIR_Coverage, 4892,
     /* 412594 */     GIR_EraseRootFromParent_Done,
     /* 412595 */   // Label 8593: @412595
     /* 412595 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(412629), // Rule ID 2227 //
     /* 412600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412603 */     // MIs[0] imm
     /* 412603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412615 */     // MIs[1] Operand 1
     /* 412615 */     // No operand predicates
     /* 412615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412617 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 412620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412627 */     GIR_RootConstrainSelectedInstOperands,
     /* 412628 */     // GIR_Coverage, 2227,
     /* 412628 */     GIR_EraseRootFromParent_Done,
     /* 412629 */   // Label 8594: @412629
     /* 412629 */   GIM_Reject,
     /* 412630 */ // Label 8592: @412630
     /* 412630 */ GIM_Reject,
     /* 412631 */ // Label 8581: @412631
     /* 412631 */ GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(412707),
     /* 412636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412647 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(412672), // Rule ID 4896 //
     /* 412652 */     // MIs[0] Operand 2
     /* 412652 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 412663 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 412663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 412666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412670 */     GIR_RootConstrainSelectedInstOperands,
     /* 412671 */     // GIR_Coverage, 4896,
     /* 412671 */     GIR_EraseRootFromParent_Done,
     /* 412672 */   // Label 8596: @412672
     /* 412672 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(412706), // Rule ID 2229 //
     /* 412677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412680 */     // MIs[0] imm
     /* 412680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412692 */     // MIs[1] Operand 1
     /* 412692 */     // No operand predicates
     /* 412692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412694 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 412697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412704 */     GIR_RootConstrainSelectedInstOperands,
     /* 412705 */     // GIR_Coverage, 2229,
     /* 412705 */     GIR_EraseRootFromParent_Done,
     /* 412706 */   // Label 8597: @412706
     /* 412706 */   GIM_Reject,
     /* 412707 */ // Label 8595: @412707
     /* 412707 */ GIM_Reject,
     /* 412708 */ // Label 8582: @412708
     /* 412708 */ GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(412784),
     /* 412713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412724 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(412749), // Rule ID 4891 //
     /* 412729 */     // MIs[0] Operand 2
     /* 412729 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 412740 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 412740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 412743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412747 */     GIR_RootConstrainSelectedInstOperands,
     /* 412748 */     // GIR_Coverage, 4891,
     /* 412748 */     GIR_EraseRootFromParent_Done,
     /* 412749 */   // Label 8599: @412749
     /* 412749 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(412783), // Rule ID 2225 //
     /* 412754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412757 */     // MIs[0] imm
     /* 412757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412769 */     // MIs[1] Operand 1
     /* 412769 */     // No operand predicates
     /* 412769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412771 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 412774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412781 */     GIR_RootConstrainSelectedInstOperands,
     /* 412782 */     // GIR_Coverage, 2225,
     /* 412782 */     GIR_EraseRootFromParent_Done,
     /* 412783 */   // Label 8600: @412783
     /* 412783 */   GIM_Reject,
     /* 412784 */ // Label 8598: @412784
     /* 412784 */ GIM_Reject,
     /* 412785 */ // Label 8583: @412785
     /* 412785 */ GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(412861),
     /* 412790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412801 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(412826), // Rule ID 4895 //
     /* 412806 */     // MIs[0] Operand 2
     /* 412806 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 412817 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 412817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 412820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412824 */     GIR_RootConstrainSelectedInstOperands,
     /* 412825 */     // GIR_Coverage, 4895,
     /* 412825 */     GIR_EraseRootFromParent_Done,
     /* 412826 */   // Label 8602: @412826
     /* 412826 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(412860), // Rule ID 2228 //
     /* 412831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412834 */     // MIs[0] imm
     /* 412834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412846 */     // MIs[1] Operand 1
     /* 412846 */     // No operand predicates
     /* 412846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412848 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 412851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412858 */     GIR_RootConstrainSelectedInstOperands,
     /* 412859 */     // GIR_Coverage, 2228,
     /* 412859 */     GIR_EraseRootFromParent_Done,
     /* 412860 */   // Label 8603: @412860
     /* 412860 */   GIM_Reject,
     /* 412861 */ // Label 8601: @412861
     /* 412861 */ GIM_Reject,
     /* 412862 */ // Label 8584: @412862
     /* 412862 */ GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(412938),
     /* 412867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412878 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(412903), // Rule ID 4890 //
     /* 412883 */     // MIs[0] Operand 2
     /* 412883 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 412894 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 412894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 412897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412901 */     GIR_RootConstrainSelectedInstOperands,
     /* 412902 */     // GIR_Coverage, 4890,
     /* 412902 */     GIR_EraseRootFromParent_Done,
     /* 412903 */   // Label 8605: @412903
     /* 412903 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(412937), // Rule ID 2223 //
     /* 412908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412911 */     // MIs[0] imm
     /* 412911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412923 */     // MIs[1] Operand 1
     /* 412923 */     // No operand predicates
     /* 412923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412925 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 412928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412935 */     GIR_RootConstrainSelectedInstOperands,
     /* 412936 */     // GIR_Coverage, 2223,
     /* 412936 */     GIR_EraseRootFromParent_Done,
     /* 412937 */   // Label 8606: @412937
     /* 412937 */   GIM_Reject,
     /* 412938 */ // Label 8604: @412938
     /* 412938 */ GIM_Reject,
     /* 412939 */ // Label 8585: @412939
     /* 412939 */ GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(413015),
     /* 412944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412955 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(412980), // Rule ID 4894 //
     /* 412960 */     // MIs[0] Operand 2
     /* 412960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 412971 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 412971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 412974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412978 */     GIR_RootConstrainSelectedInstOperands,
     /* 412979 */     // GIR_Coverage, 4894,
     /* 412979 */     GIR_EraseRootFromParent_Done,
     /* 412980 */   // Label 8608: @412980
     /* 412980 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(413014), // Rule ID 2226 //
     /* 412985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412988 */     // MIs[0] imm
     /* 412988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 413000 */     // MIs[1] Operand 1
     /* 413000 */     // No operand predicates
     /* 413000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413002 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 413005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413012 */     GIR_RootConstrainSelectedInstOperands,
     /* 413013 */     // GIR_Coverage, 2226,
     /* 413013 */     GIR_EraseRootFromParent_Done,
     /* 413014 */   // Label 8609: @413014
     /* 413014 */   GIM_Reject,
     /* 413015 */ // Label 8607: @413015
     /* 413015 */ GIM_Reject,
     /* 413016 */ // Label 8586: @413016
     /* 413016 */ GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(413092),
     /* 413021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413032 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(413057), // Rule ID 4893 //
     /* 413037 */     // MIs[0] Operand 2
     /* 413037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 413048 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 413048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 413051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413055 */     GIR_RootConstrainSelectedInstOperands,
     /* 413056 */     // GIR_Coverage, 4893,
     /* 413056 */     GIR_EraseRootFromParent_Done,
     /* 413057 */   // Label 8611: @413057
     /* 413057 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(413091), // Rule ID 2224 //
     /* 413062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413065 */     // MIs[0] imm
     /* 413065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 413077 */     // MIs[1] Operand 1
     /* 413077 */     // No operand predicates
     /* 413077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413079 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 413082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413089 */     GIR_RootConstrainSelectedInstOperands,
     /* 413090 */     // GIR_Coverage, 2224,
     /* 413090 */     GIR_EraseRootFromParent_Done,
     /* 413091 */   // Label 8612: @413091
     /* 413091 */   GIM_Reject,
     /* 413092 */ // Label 8610: @413092
     /* 413092 */ GIM_Reject,
     /* 413093 */ // Label 8587: @413093
     /* 413093 */ GIM_Reject,
     /* 413094 */ // Label 149: @413094
     /* 413094 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8621*/ GIMT_Encode4(413549),
     /* 413105 */ /*GILLT_s64*//*Label 8613*/ GIMT_Encode4(413141), GIMT_Encode4(0),
     /* 413113 */ /*GILLT_v2s32*//*Label 8614*/ GIMT_Encode4(413227),
     /* 413117 */ /*GILLT_v2s64*//*Label 8615*/ GIMT_Encode4(413273),
     /* 413121 */ /*GILLT_v4s16*//*Label 8616*/ GIMT_Encode4(413319),
     /* 413125 */ /*GILLT_v4s32*//*Label 8617*/ GIMT_Encode4(413365),
     /* 413129 */ /*GILLT_v8s8*//*Label 8618*/ GIMT_Encode4(413411),
     /* 413133 */ /*GILLT_v8s16*//*Label 8619*/ GIMT_Encode4(413457),
     /* 413137 */ /*GILLT_v16s8*//*Label 8620*/ GIMT_Encode4(413503),
     /* 413141 */ // Label 8613: @413141
     /* 413141 */ GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(413226),
     /* 413146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 413149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413157 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(413191), // Rule ID 2129 //
     /* 413162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413165 */     // MIs[0] imm
     /* 413165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 413177 */     // MIs[1] Operand 1
     /* 413177 */     // No operand predicates
     /* 413177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413179 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 413182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413189 */     GIR_RootConstrainSelectedInstOperands,
     /* 413190 */     // GIR_Coverage, 2129,
     /* 413190 */     GIR_EraseRootFromParent_Done,
     /* 413191 */   // Label 8623: @413191
     /* 413191 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(413225), // Rule ID 6292 //
     /* 413196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413199 */     // MIs[0] imm
     /* 413199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 413211 */     // MIs[1] Operand 1
     /* 413211 */     // No operand predicates
     /* 413211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413213 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 413213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 413216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413223 */     GIR_RootConstrainSelectedInstOperands,
     /* 413224 */     // GIR_Coverage, 6292,
     /* 413224 */     GIR_EraseRootFromParent_Done,
     /* 413225 */   // Label 8624: @413225
     /* 413225 */   GIM_Reject,
     /* 413226 */ // Label 8622: @413226
     /* 413226 */ GIM_Reject,
     /* 413227 */ // Label 8614: @413227
     /* 413227 */ GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(413272), // Rule ID 2286 //
     /* 413232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413246 */   // MIs[0] imm
     /* 413246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413254 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 413258 */   // MIs[1] Operand 1
     /* 413258 */   // No operand predicates
     /* 413258 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413260 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 413263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413265 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413267 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413270 */   GIR_RootConstrainSelectedInstOperands,
     /* 413271 */   // GIR_Coverage, 2286,
     /* 413271 */   GIR_EraseRootFromParent_Done,
     /* 413272 */ // Label 8625: @413272
     /* 413272 */ GIM_Reject,
     /* 413273 */ // Label 8615: @413273
     /* 413273 */ GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(413318), // Rule ID 2288 //
     /* 413278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413292 */   // MIs[0] imm
     /* 413292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413300 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 413304 */   // MIs[1] Operand 1
     /* 413304 */   // No operand predicates
     /* 413304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413306 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 413309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413311 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413313 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413316 */   GIR_RootConstrainSelectedInstOperands,
     /* 413317 */   // GIR_Coverage, 2288,
     /* 413317 */   GIR_EraseRootFromParent_Done,
     /* 413318 */ // Label 8626: @413318
     /* 413318 */ GIM_Reject,
     /* 413319 */ // Label 8616: @413319
     /* 413319 */ GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(413364), // Rule ID 2284 //
     /* 413324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413338 */   // MIs[0] imm
     /* 413338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413346 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 413350 */   // MIs[1] Operand 1
     /* 413350 */   // No operand predicates
     /* 413350 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413352 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 413355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413357 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413359 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413362 */   GIR_RootConstrainSelectedInstOperands,
     /* 413363 */   // GIR_Coverage, 2284,
     /* 413363 */   GIR_EraseRootFromParent_Done,
     /* 413364 */ // Label 8627: @413364
     /* 413364 */ GIM_Reject,
     /* 413365 */ // Label 8617: @413365
     /* 413365 */ GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(413410), // Rule ID 2287 //
     /* 413370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413384 */   // MIs[0] imm
     /* 413384 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413388 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413392 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 413396 */   // MIs[1] Operand 1
     /* 413396 */   // No operand predicates
     /* 413396 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413398 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 413401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413403 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413405 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413408 */   GIR_RootConstrainSelectedInstOperands,
     /* 413409 */   // GIR_Coverage, 2287,
     /* 413409 */   GIR_EraseRootFromParent_Done,
     /* 413410 */ // Label 8628: @413410
     /* 413410 */ GIM_Reject,
     /* 413411 */ // Label 8618: @413411
     /* 413411 */ GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(413456), // Rule ID 2282 //
     /* 413416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 413422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413430 */   // MIs[0] imm
     /* 413430 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413434 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413438 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 413442 */   // MIs[1] Operand 1
     /* 413442 */   // No operand predicates
     /* 413442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413444 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 413447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413449 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413451 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413454 */   GIR_RootConstrainSelectedInstOperands,
     /* 413455 */   // GIR_Coverage, 2282,
     /* 413455 */   GIR_EraseRootFromParent_Done,
     /* 413456 */ // Label 8629: @413456
     /* 413456 */ GIM_Reject,
     /* 413457 */ // Label 8619: @413457
     /* 413457 */ GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(413502), // Rule ID 2285 //
     /* 413462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413476 */   // MIs[0] imm
     /* 413476 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413484 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 413488 */   // MIs[1] Operand 1
     /* 413488 */   // No operand predicates
     /* 413488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413490 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 413493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413495 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413497 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413500 */   GIR_RootConstrainSelectedInstOperands,
     /* 413501 */   // GIR_Coverage, 2285,
     /* 413501 */   GIR_EraseRootFromParent_Done,
     /* 413502 */ // Label 8630: @413502
     /* 413502 */ GIM_Reject,
     /* 413503 */ // Label 8620: @413503
     /* 413503 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(413548), // Rule ID 2283 //
     /* 413508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413522 */   // MIs[0] imm
     /* 413522 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413526 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413530 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 413534 */   // MIs[1] Operand 1
     /* 413534 */   // No operand predicates
     /* 413534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413536 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 413539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413541 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413543 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413546 */   GIR_RootConstrainSelectedInstOperands,
     /* 413547 */   // GIR_Coverage, 2283,
     /* 413547 */   GIR_EraseRootFromParent_Done,
     /* 413548 */ // Label 8631: @413548
     /* 413548 */ GIM_Reject,
     /* 413549 */ // Label 8621: @413549
     /* 413549 */ GIM_Reject,
     /* 413550 */ // Label 150: @413550
     /* 413550 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8650*/ GIMT_Encode4(414329),
     /* 413561 */ /*GILLT_v2s32*//*Label 8632*/ GIMT_Encode4(413637),
     /* 413565 */ /*GILLT_v2s64*//*Label 8633*/ GIMT_Encode4(413692),
     /* 413569 */ /*GILLT_v4s16*//*Label 8634*/ GIMT_Encode4(413747),
     /* 413573 */ /*GILLT_v4s32*//*Label 8635*/ GIMT_Encode4(413802),
     /* 413577 */ /*GILLT_v8s8*//*Label 8636*/ GIMT_Encode4(413857),
     /* 413581 */ /*GILLT_v8s16*//*Label 8637*/ GIMT_Encode4(413891),
     /* 413585 */ /*GILLT_v16s8*//*Label 8638*/ GIMT_Encode4(413946), GIMT_Encode4(0),
     /* 413593 */ /*GILLT_nxv2s1*//*Label 8639*/ GIMT_Encode4(413980),
     /* 413597 */ /*GILLT_nxv2s16*//*Label 8640*/ GIMT_Encode4(414006),
     /* 413601 */ /*GILLT_nxv2s32*//*Label 8641*/ GIMT_Encode4(414032),
     /* 413605 */ /*GILLT_nxv2s64*//*Label 8642*/ GIMT_Encode4(414058),
     /* 413609 */ /*GILLT_nxv4s1*//*Label 8643*/ GIMT_Encode4(414105),
     /* 413613 */ /*GILLT_nxv4s16*//*Label 8644*/ GIMT_Encode4(414131),
     /* 413617 */ /*GILLT_nxv4s32*//*Label 8645*/ GIMT_Encode4(414157),
     /* 413621 */ /*GILLT_nxv8s1*//*Label 8646*/ GIMT_Encode4(414204),
     /* 413625 */ /*GILLT_nxv8s16*//*Label 8647*/ GIMT_Encode4(414230),
     /* 413629 */ /*GILLT_nxv16s1*//*Label 8648*/ GIMT_Encode4(414277),
     /* 413633 */ /*GILLT_nxv16s8*//*Label 8649*/ GIMT_Encode4(414303),
     /* 413637 */ // Label 8632: @413637
     /* 413637 */ GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(413691),
     /* 413642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 413648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413660 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(413675), // Rule ID 1902 //
     /* 413665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413668 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 413668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 413673 */     GIR_RootConstrainSelectedInstOperands,
     /* 413674 */     // GIR_Coverage, 1902,
     /* 413674 */     GIR_Done,
     /* 413675 */   // Label 8652: @413675
     /* 413675 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(413690), // Rule ID 5484 //
     /* 413680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413683 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 413688 */     GIR_RootConstrainSelectedInstOperands,
     /* 413689 */     // GIR_Coverage, 5484,
     /* 413689 */     GIR_Done,
     /* 413690 */   // Label 8653: @413690
     /* 413690 */   GIM_Reject,
     /* 413691 */ // Label 8651: @413691
     /* 413691 */ GIM_Reject,
     /* 413692 */ // Label 8633: @413692
     /* 413692 */ GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(413746),
     /* 413697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 413703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413715 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(413730), // Rule ID 1904 //
     /* 413720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413723 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 413723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 413728 */     GIR_RootConstrainSelectedInstOperands,
     /* 413729 */     // GIR_Coverage, 1904,
     /* 413729 */     GIR_Done,
     /* 413730 */   // Label 8655: @413730
     /* 413730 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(413745), // Rule ID 5486 //
     /* 413735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413738 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 413743 */     GIR_RootConstrainSelectedInstOperands,
     /* 413744 */     // GIR_Coverage, 5486,
     /* 413744 */     GIR_Done,
     /* 413745 */   // Label 8656: @413745
     /* 413745 */   GIM_Reject,
     /* 413746 */ // Label 8654: @413746
     /* 413746 */ GIM_Reject,
     /* 413747 */ // Label 8634: @413747
     /* 413747 */ GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(413801),
     /* 413752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 413758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413770 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(413785), // Rule ID 1900 //
     /* 413775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413778 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 413778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 413783 */     GIR_RootConstrainSelectedInstOperands,
     /* 413784 */     // GIR_Coverage, 1900,
     /* 413784 */     GIR_Done,
     /* 413785 */   // Label 8658: @413785
     /* 413785 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(413800), // Rule ID 5482 //
     /* 413790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413793 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 413798 */     GIR_RootConstrainSelectedInstOperands,
     /* 413799 */     // GIR_Coverage, 5482,
     /* 413799 */     GIR_Done,
     /* 413800 */   // Label 8659: @413800
     /* 413800 */   GIM_Reject,
     /* 413801 */ // Label 8657: @413801
     /* 413801 */ GIM_Reject,
     /* 413802 */ // Label 8635: @413802
     /* 413802 */ GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(413856),
     /* 413807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 413813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413825 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(413840), // Rule ID 1903 //
     /* 413830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413833 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 413833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 413838 */     GIR_RootConstrainSelectedInstOperands,
     /* 413839 */     // GIR_Coverage, 1903,
     /* 413839 */     GIR_Done,
     /* 413840 */   // Label 8661: @413840
     /* 413840 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(413855), // Rule ID 5485 //
     /* 413845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413848 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 413848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 413853 */     GIR_RootConstrainSelectedInstOperands,
     /* 413854 */     // GIR_Coverage, 5485,
     /* 413854 */     GIR_Done,
     /* 413855 */   // Label 8662: @413855
     /* 413855 */   GIM_Reject,
     /* 413856 */ // Label 8660: @413856
     /* 413856 */ GIM_Reject,
     /* 413857 */ // Label 8636: @413857
     /* 413857 */ GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(413890), // Rule ID 1898 //
     /* 413862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 413868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 413871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413883 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 413883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 413888 */   GIR_RootConstrainSelectedInstOperands,
     /* 413889 */   // GIR_Coverage, 1898,
     /* 413889 */   GIR_Done,
     /* 413890 */ // Label 8663: @413890
     /* 413890 */ GIM_Reject,
     /* 413891 */ // Label 8637: @413891
     /* 413891 */ GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(413945),
     /* 413896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 413902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413914 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(413929), // Rule ID 1901 //
     /* 413919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413922 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 413922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 413927 */     GIR_RootConstrainSelectedInstOperands,
     /* 413928 */     // GIR_Coverage, 1901,
     /* 413928 */     GIR_Done,
     /* 413929 */   // Label 8665: @413929
     /* 413929 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(413944), // Rule ID 5483 //
     /* 413934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413937 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 413937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 413942 */     GIR_RootConstrainSelectedInstOperands,
     /* 413943 */     // GIR_Coverage, 5483,
     /* 413943 */     GIR_Done,
     /* 413944 */   // Label 8666: @413944
     /* 413944 */   GIM_Reject,
     /* 413945 */ // Label 8664: @413945
     /* 413945 */ GIM_Reject,
     /* 413946 */ // Label 8638: @413946
     /* 413946 */ GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(413979), // Rule ID 1899 //
     /* 413951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 413960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413972 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 413977 */   GIR_RootConstrainSelectedInstOperands,
     /* 413978 */   // GIR_Coverage, 1899,
     /* 413978 */   GIR_Done,
     /* 413979 */ // Label 8667: @413979
     /* 413979 */ GIM_Reject,
     /* 413980 */ // Label 8639: @413980
     /* 413980 */ GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(414005), // Rule ID 3348 //
     /* 413985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 413991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 413994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413998 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 413998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 414003 */   GIR_RootConstrainSelectedInstOperands,
     /* 414004 */   // GIR_Coverage, 3348,
     /* 414004 */   GIR_Done,
     /* 414005 */ // Label 8668: @414005
     /* 414005 */ GIM_Reject,
     /* 414006 */ // Label 8640: @414006
     /* 414006 */ GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(414031), // Rule ID 2879 //
     /* 414011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 414017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 414020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414024 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 414024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 414029 */   GIR_RootConstrainSelectedInstOperands,
     /* 414030 */   // GIR_Coverage, 2879,
     /* 414030 */   GIR_Done,
     /* 414031 */ // Label 8669: @414031
     /* 414031 */ GIM_Reject,
     /* 414032 */ // Label 8641: @414032
     /* 414032 */ GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(414057), // Rule ID 2880 //
     /* 414037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 414043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 414046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414050 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 414050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 414055 */   GIR_RootConstrainSelectedInstOperands,
     /* 414056 */   // GIR_Coverage, 2880,
     /* 414056 */   GIR_Done,
     /* 414057 */ // Label 8670: @414057
     /* 414057 */ GIM_Reject,
     /* 414058 */ // Label 8642: @414058
     /* 414058 */ GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(414104),
     /* 414063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 414066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 414069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414073 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(414088), // Rule ID 2875 //
     /* 414078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414081 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 414081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 414086 */     GIR_RootConstrainSelectedInstOperands,
     /* 414087 */     // GIR_Coverage, 2875,
     /* 414087 */     GIR_Done,
     /* 414088 */   // Label 8672: @414088
     /* 414088 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(414103), // Rule ID 2881 //
     /* 414093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414096 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 414096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 414101 */     GIR_RootConstrainSelectedInstOperands,
     /* 414102 */     // GIR_Coverage, 2881,
     /* 414102 */     GIR_Done,
     /* 414103 */   // Label 8673: @414103
     /* 414103 */   GIM_Reject,
     /* 414104 */ // Label 8671: @414104
     /* 414104 */ GIM_Reject,
     /* 414105 */ // Label 8643: @414105
     /* 414105 */ GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(414130), // Rule ID 3347 //
     /* 414110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 414116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 414119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414123 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 414123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 414128 */   GIR_RootConstrainSelectedInstOperands,
     /* 414129 */   // GIR_Coverage, 3347,
     /* 414129 */   GIR_Done,
     /* 414130 */ // Label 8674: @414130
     /* 414130 */ GIM_Reject,
     /* 414131 */ // Label 8644: @414131
     /* 414131 */ GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(414156), // Rule ID 2877 //
     /* 414136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 414142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 414145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414149 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 414149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 414154 */   GIR_RootConstrainSelectedInstOperands,
     /* 414155 */   // GIR_Coverage, 2877,
     /* 414155 */   GIR_Done,
     /* 414156 */ // Label 8675: @414156
     /* 414156 */ GIM_Reject,
     /* 414157 */ // Label 8645: @414157
     /* 414157 */ GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(414203),
     /* 414162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 414165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 414168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414172 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(414187), // Rule ID 2874 //
     /* 414177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414180 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 414180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 414185 */     GIR_RootConstrainSelectedInstOperands,
     /* 414186 */     // GIR_Coverage, 2874,
     /* 414186 */     GIR_Done,
     /* 414187 */   // Label 8677: @414187
     /* 414187 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(414202), // Rule ID 2878 //
     /* 414192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414195 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 414195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 414200 */     GIR_RootConstrainSelectedInstOperands,
     /* 414201 */     // GIR_Coverage, 2878,
     /* 414201 */     GIR_Done,
     /* 414202 */   // Label 8678: @414202
     /* 414202 */   GIM_Reject,
     /* 414203 */ // Label 8676: @414203
     /* 414203 */ GIM_Reject,
     /* 414204 */ // Label 8646: @414204
     /* 414204 */ GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(414229), // Rule ID 3346 //
     /* 414209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 414215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 414218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414222 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 414222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 414227 */   GIR_RootConstrainSelectedInstOperands,
     /* 414228 */   // GIR_Coverage, 3346,
     /* 414228 */   GIR_Done,
     /* 414229 */ // Label 8679: @414229
     /* 414229 */ GIM_Reject,
     /* 414230 */ // Label 8647: @414230
     /* 414230 */ GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(414276),
     /* 414235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 414238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 414241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414245 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(414260), // Rule ID 2873 //
     /* 414250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414253 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 414253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 414258 */     GIR_RootConstrainSelectedInstOperands,
     /* 414259 */     // GIR_Coverage, 2873,
     /* 414259 */     GIR_Done,
     /* 414260 */   // Label 8681: @414260
     /* 414260 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(414275), // Rule ID 2876 //
     /* 414265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414268 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 414268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 414273 */     GIR_RootConstrainSelectedInstOperands,
     /* 414274 */     // GIR_Coverage, 2876,
     /* 414274 */     GIR_Done,
     /* 414275 */   // Label 8682: @414275
     /* 414275 */   GIM_Reject,
     /* 414276 */ // Label 8680: @414276
     /* 414276 */ GIM_Reject,
     /* 414277 */ // Label 8648: @414277
     /* 414277 */ GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(414302), // Rule ID 2398 //
     /* 414282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 414288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 414291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414295 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 414295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 414300 */   GIR_RootConstrainSelectedInstOperands,
     /* 414301 */   // GIR_Coverage, 2398,
     /* 414301 */   GIR_Done,
     /* 414302 */ // Label 8683: @414302
     /* 414302 */ GIM_Reject,
     /* 414303 */ // Label 8649: @414303
     /* 414303 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(414328), // Rule ID 2872 //
     /* 414308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 414314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 414317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414321 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 414321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 414326 */   GIR_RootConstrainSelectedInstOperands,
     /* 414327 */   // GIR_Coverage, 2872,
     /* 414327 */   GIR_Done,
     /* 414328 */ // Label 8684: @414328
     /* 414328 */ GIM_Reject,
     /* 414329 */ // Label 8650: @414329
     /* 414329 */ GIM_Reject,
     /* 414330 */ // Label 151: @414330
     /* 414330 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8703*/ GIMT_Encode4(415109),
     /* 414341 */ /*GILLT_v2s32*//*Label 8685*/ GIMT_Encode4(414417),
     /* 414345 */ /*GILLT_v2s64*//*Label 8686*/ GIMT_Encode4(414472),
     /* 414349 */ /*GILLT_v4s16*//*Label 8687*/ GIMT_Encode4(414527),
     /* 414353 */ /*GILLT_v4s32*//*Label 8688*/ GIMT_Encode4(414582),
     /* 414357 */ /*GILLT_v8s8*//*Label 8689*/ GIMT_Encode4(414637),
     /* 414361 */ /*GILLT_v8s16*//*Label 8690*/ GIMT_Encode4(414671),
     /* 414365 */ /*GILLT_v16s8*//*Label 8691*/ GIMT_Encode4(414726), GIMT_Encode4(0),
     /* 414373 */ /*GILLT_nxv2s1*//*Label 8692*/ GIMT_Encode4(414760),
     /* 414377 */ /*GILLT_nxv2s16*//*Label 8693*/ GIMT_Encode4(414786),
     /* 414381 */ /*GILLT_nxv2s32*//*Label 8694*/ GIMT_Encode4(414812),
     /* 414385 */ /*GILLT_nxv2s64*//*Label 8695*/ GIMT_Encode4(414838),
     /* 414389 */ /*GILLT_nxv4s1*//*Label 8696*/ GIMT_Encode4(414885),
     /* 414393 */ /*GILLT_nxv4s16*//*Label 8697*/ GIMT_Encode4(414911),
     /* 414397 */ /*GILLT_nxv4s32*//*Label 8698*/ GIMT_Encode4(414937),
     /* 414401 */ /*GILLT_nxv8s1*//*Label 8699*/ GIMT_Encode4(414984),
     /* 414405 */ /*GILLT_nxv8s16*//*Label 8700*/ GIMT_Encode4(415010),
     /* 414409 */ /*GILLT_nxv16s1*//*Label 8701*/ GIMT_Encode4(415057),
     /* 414413 */ /*GILLT_nxv16s8*//*Label 8702*/ GIMT_Encode4(415083),
     /* 414417 */ // Label 8685: @414417
     /* 414417 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(414471),
     /* 414422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 414425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 414428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414440 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(414455), // Rule ID 1909 //
     /* 414445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414448 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 414448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 414453 */     GIR_RootConstrainSelectedInstOperands,
     /* 414454 */     // GIR_Coverage, 1909,
     /* 414454 */     GIR_Done,
     /* 414455 */   // Label 8705: @414455
     /* 414455 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(414470), // Rule ID 5489 //
     /* 414460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414463 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 414463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 414468 */     GIR_RootConstrainSelectedInstOperands,
     /* 414469 */     // GIR_Coverage, 5489,
     /* 414469 */     GIR_Done,
     /* 414470 */   // Label 8706: @414470
     /* 414470 */   GIM_Reject,
     /* 414471 */ // Label 8704: @414471
     /* 414471 */ GIM_Reject,
     /* 414472 */ // Label 8686: @414472
     /* 414472 */ GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(414526),
     /* 414477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 414483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414495 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(414510), // Rule ID 1911 //
     /* 414500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414503 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 414503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 414508 */     GIR_RootConstrainSelectedInstOperands,
     /* 414509 */     // GIR_Coverage, 1911,
     /* 414509 */     GIR_Done,
     /* 414510 */   // Label 8708: @414510
     /* 414510 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(414525), // Rule ID 5491 //
     /* 414515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414518 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414518 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 414523 */     GIR_RootConstrainSelectedInstOperands,
     /* 414524 */     // GIR_Coverage, 5491,
     /* 414524 */     GIR_Done,
     /* 414525 */   // Label 8709: @414525
     /* 414525 */   GIM_Reject,
     /* 414526 */ // Label 8707: @414526
     /* 414526 */ GIM_Reject,
     /* 414527 */ // Label 8687: @414527
     /* 414527 */ GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(414581),
     /* 414532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414550 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(414565), // Rule ID 1907 //
     /* 414555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414558 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 414558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 414563 */     GIR_RootConstrainSelectedInstOperands,
     /* 414564 */     // GIR_Coverage, 1907,
     /* 414564 */     GIR_Done,
     /* 414565 */   // Label 8711: @414565
     /* 414565 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(414580), // Rule ID 5487 //
     /* 414570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414573 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 414578 */     GIR_RootConstrainSelectedInstOperands,
     /* 414579 */     // GIR_Coverage, 5487,
     /* 414579 */     GIR_Done,
     /* 414580 */   // Label 8712: @414580
     /* 414580 */   GIM_Reject,
     /* 414581 */ // Label 8710: @414581
     /* 414581 */ GIM_Reject,
     /* 414582 */ // Label 8688: @414582
     /* 414582 */ GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(414636),
     /* 414587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 414593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414605 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(414620), // Rule ID 1910 //
     /* 414610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414613 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 414613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 414618 */     GIR_RootConstrainSelectedInstOperands,
     /* 414619 */     // GIR_Coverage, 1910,
     /* 414619 */     GIR_Done,
     /* 414620 */   // Label 8714: @414620
     /* 414620 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(414635), // Rule ID 5490 //
     /* 414625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414628 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 414633 */     GIR_RootConstrainSelectedInstOperands,
     /* 414634 */     // GIR_Coverage, 5490,
     /* 414634 */     GIR_Done,
     /* 414635 */   // Label 8715: @414635
     /* 414635 */   GIM_Reject,
     /* 414636 */ // Label 8713: @414636
     /* 414636 */ GIM_Reject,
     /* 414637 */ // Label 8689: @414637
     /* 414637 */ GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(414670), // Rule ID 1905 //
     /* 414642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 414648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 414651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414663 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 414663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 414668 */   GIR_RootConstrainSelectedInstOperands,
     /* 414669 */   // GIR_Coverage, 1905,
     /* 414669 */   GIR_Done,
     /* 414670 */ // Label 8716: @414670
     /* 414670 */ GIM_Reject,
     /* 414671 */ // Label 8690: @414671
     /* 414671 */ GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(414725),
     /* 414676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 414682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414694 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(414709), // Rule ID 1908 //
     /* 414699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414702 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 414702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 414707 */     GIR_RootConstrainSelectedInstOperands,
     /* 414708 */     // GIR_Coverage, 1908,
     /* 414708 */     GIR_Done,
     /* 414709 */   // Label 8718: @414709
     /* 414709 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(414724), // Rule ID 5488 //
     /* 414714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414717 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 414717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 414722 */     GIR_RootConstrainSelectedInstOperands,
     /* 414723 */     // GIR_Coverage, 5488,
     /* 414723 */     GIR_Done,
     /* 414724 */   // Label 8719: @414724
     /* 414724 */   GIM_Reject,
     /* 414725 */ // Label 8717: @414725
     /* 414725 */ GIM_Reject,
     /* 414726 */ // Label 8691: @414726
     /* 414726 */ GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(414759), // Rule ID 1906 //
     /* 414731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 414737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 414740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414752 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 414752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 414757 */   GIR_RootConstrainSelectedInstOperands,
     /* 414758 */   // GIR_Coverage, 1906,
     /* 414758 */   GIR_Done,
     /* 414759 */ // Label 8720: @414759
     /* 414759 */ GIM_Reject,
     /* 414760 */ // Label 8692: @414760
     /* 414760 */ GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(414785), // Rule ID 8934 //
     /* 414765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 414771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 414774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414778 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 414778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 414783 */   GIR_RootConstrainSelectedInstOperands,
     /* 414784 */   // GIR_Coverage, 8934,
     /* 414784 */   GIR_Done,
     /* 414785 */ // Label 8721: @414785
     /* 414785 */ GIM_Reject,
     /* 414786 */ // Label 8693: @414786
     /* 414786 */ GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(414811), // Rule ID 8889 //
     /* 414791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 414797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 414800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414804 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 414804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 414809 */   GIR_RootConstrainSelectedInstOperands,
     /* 414810 */   // GIR_Coverage, 8889,
     /* 414810 */   GIR_Done,
     /* 414811 */ // Label 8722: @414811
     /* 414811 */ GIM_Reject,
     /* 414812 */ // Label 8694: @414812
     /* 414812 */ GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(414837), // Rule ID 8890 //
     /* 414817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 414823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 414826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414830 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 414830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 414835 */   GIR_RootConstrainSelectedInstOperands,
     /* 414836 */   // GIR_Coverage, 8890,
     /* 414836 */   GIR_Done,
     /* 414837 */ // Label 8723: @414837
     /* 414837 */ GIM_Reject,
     /* 414838 */ // Label 8695: @414838
     /* 414838 */ GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(414884),
     /* 414843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 414846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 414849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414853 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(414868), // Rule ID 8885 //
     /* 414858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414861 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 414861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 414866 */     GIR_RootConstrainSelectedInstOperands,
     /* 414867 */     // GIR_Coverage, 8885,
     /* 414867 */     GIR_Done,
     /* 414868 */   // Label 8725: @414868
     /* 414868 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(414883), // Rule ID 8891 //
     /* 414873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414876 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 414876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 414881 */     GIR_RootConstrainSelectedInstOperands,
     /* 414882 */     // GIR_Coverage, 8891,
     /* 414882 */     GIR_Done,
     /* 414883 */   // Label 8726: @414883
     /* 414883 */   GIM_Reject,
     /* 414884 */ // Label 8724: @414884
     /* 414884 */ GIM_Reject,
     /* 414885 */ // Label 8696: @414885
     /* 414885 */ GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(414910), // Rule ID 8933 //
     /* 414890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 414896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 414899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414903 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 414903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 414908 */   GIR_RootConstrainSelectedInstOperands,
     /* 414909 */   // GIR_Coverage, 8933,
     /* 414909 */   GIR_Done,
     /* 414910 */ // Label 8727: @414910
     /* 414910 */ GIM_Reject,
     /* 414911 */ // Label 8697: @414911
     /* 414911 */ GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(414936), // Rule ID 8887 //
     /* 414916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 414922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 414925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414929 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 414929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414934 */   GIR_RootConstrainSelectedInstOperands,
     /* 414935 */   // GIR_Coverage, 8887,
     /* 414935 */   GIR_Done,
     /* 414936 */ // Label 8728: @414936
     /* 414936 */ GIM_Reject,
     /* 414937 */ // Label 8698: @414937
     /* 414937 */ GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(414983),
     /* 414942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 414945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 414948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414952 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(414967), // Rule ID 8884 //
     /* 414957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414960 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 414960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414965 */     GIR_RootConstrainSelectedInstOperands,
     /* 414966 */     // GIR_Coverage, 8884,
     /* 414966 */     GIR_Done,
     /* 414967 */   // Label 8730: @414967
     /* 414967 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(414982), // Rule ID 8888 //
     /* 414972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414975 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 414975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414980 */     GIR_RootConstrainSelectedInstOperands,
     /* 414981 */     // GIR_Coverage, 8888,
     /* 414981 */     GIR_Done,
     /* 414982 */   // Label 8731: @414982
     /* 414982 */   GIM_Reject,
     /* 414983 */ // Label 8729: @414983
     /* 414983 */ GIM_Reject,
     /* 414984 */ // Label 8699: @414984
     /* 414984 */ GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(415009), // Rule ID 8932 //
     /* 414989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 414995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 414998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415002 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 415002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 415007 */   GIR_RootConstrainSelectedInstOperands,
     /* 415008 */   // GIR_Coverage, 8932,
     /* 415008 */   GIR_Done,
     /* 415009 */ // Label 8732: @415009
     /* 415009 */ GIM_Reject,
     /* 415010 */ // Label 8700: @415010
     /* 415010 */ GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(415056),
     /* 415015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 415018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 415021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415025 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(415040), // Rule ID 8883 //
     /* 415030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415033 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 415033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 415038 */     GIR_RootConstrainSelectedInstOperands,
     /* 415039 */     // GIR_Coverage, 8883,
     /* 415039 */     GIR_Done,
     /* 415040 */   // Label 8734: @415040
     /* 415040 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(415055), // Rule ID 8886 //
     /* 415045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415048 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 415048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 415053 */     GIR_RootConstrainSelectedInstOperands,
     /* 415054 */     // GIR_Coverage, 8886,
     /* 415054 */     GIR_Done,
     /* 415055 */   // Label 8735: @415055
     /* 415055 */   GIM_Reject,
     /* 415056 */ // Label 8733: @415056
     /* 415056 */ GIM_Reject,
     /* 415057 */ // Label 8701: @415057
     /* 415057 */ GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(415082), // Rule ID 2402 //
     /* 415062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 415068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 415071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 415075 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 415075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 415080 */   GIR_RootConstrainSelectedInstOperands,
     /* 415081 */   // GIR_Coverage, 2402,
     /* 415081 */   GIR_Done,
     /* 415082 */ // Label 8736: @415082
     /* 415082 */ GIM_Reject,
     /* 415083 */ // Label 8702: @415083
     /* 415083 */ GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(415108), // Rule ID 8882 //
     /* 415088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 415091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 415094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 415097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 415101 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 415101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 415106 */   GIR_RootConstrainSelectedInstOperands,
     /* 415107 */   // GIR_Coverage, 8882,
     /* 415107 */   GIR_Done,
     /* 415108 */ // Label 8737: @415108
     /* 415108 */ GIM_Reject,
     /* 415109 */ // Label 8703: @415109
     /* 415109 */ GIM_Reject,
     /* 415110 */ // Label 152: @415110
     /* 415110 */ GIM_Reject,
     /* 415111 */ }; // Size: 415111 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
